//@ui5-bundle sap/m/library-preload.js
/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/ColumnHeaderPopover',['sap/ui/core/Control','sap/m/Toolbar','sap/m/Button','sap/m/ResponsivePopover','sap/m/ToolbarSpacer','sap/ui/dom/containsOrEquals'],function(C,T,B,R,a,c){"use strict";
var b=C.extend("sap.m.ColumnHeaderPopover",{
library:"sap.m",
metadata:{properties:{},aggregations:{items:{type:"sap.m.ColumnPopoverItem",multiple:true,singularName:"item",bindable:true},_popover:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},defaultAggregation:"items",associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}},
renderer:null
});
b.prototype.init=function(){this._bPopoverCreated=false;this._oShownCustomContent=null;var t=this;this._minWidthDelegate=function(){this.$().css("min-width",t.minWidth);};};
b.prototype.exit=function(){if(this._oToolbar){this._oToolbar.destroy();this._oToolbar=null;}this._closeBtn=null;this._spacer=null;this._aButtons=null;this._oShownCustomContent=null;};
b.prototype._createPopover=function(){var t=this;this._oShownCustomContent=null;var o=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=o.getText("COLUMNHEADERPOPOVER_CLOSE_BUTTON");var p=new R(this.getId()+"-popover",{showArrow:false,showHeader:false,placement:"Bottom",verticalScrolling:true,horizontalScrolling:false,ariaLabelledBy:this.getAriaLabelledBy(),beforeClose:function(e){if(t._oShownCustomContent){t._oShownCustomContent.setVisible(false);t._oShownCustomContent=null;}t._cleanSelection();}});p._oControl.addDelegate({"onAfterRendering":this._minWidthDelegate},p._oControl);this.setAggregation("_popover",p);var d=new T(this.getId()+"-tb");this._spacer=new a();this._closeBtn=new B(d.getId()+"-closeBtn",{type:"Transparent",icon:"sap-icon://decline",tooltip:s,press:[p.close,p]});d.addContent(this._spacer);d.addContent(this._closeBtn);p.addContent(d);this._oToolbar=d;};
b.prototype._cleanSelection=function(o){var d=this._aButtons;if(d){d.forEach(function(e){if((!o||e!==o)&&e.getPressed&&e.getPressed()){e.setPressed(false);}});}};
b.prototype.openBy=function(o){if(!this._bPopoverCreated){this._createPopover();this._bPopoverCreated=true;}else{this._oToolbar.removeContent(this._spacer);this._oToolbar.removeContent(this._closeBtn);this._oToolbar.destroyContent();}var p=this.getAggregation("_popover");var d=[];var I=this.getItems();var m=5;for(var i=0;(i<I.length)&&(d.length<m);i++){var e=I[i];if(e.getVisible()){var f=e._createButton(this._oToolbar.getId()+"-btn_"+i,this);f._sContentId=e._sContentId;d.push(f);this._oToolbar.insertContent(f,i);}}if(d.length===0){return;}this._aButtons=d;this._oToolbar.addContent(this._spacer);this._oToolbar.addContent(this._closeBtn);if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}var O=o.getFocusDomRef();if(O){p.setOffsetY(-O.clientHeight);this.minWidth=O.clientWidth;}p.openBy(o);};
b.prototype.invalidate=function(o){var p=this.getAggregation("_popover");if(o===p){C.prototype.invalidate.apply(this,arguments);}return this;};
b.prototype.addAriaLabelledBy=function(i){var r=this.getAggregation("_popover");if(r){r.addAriaLabelledBy(i);}return this.addAssociation("ariaLabelledBy",i);};
b.prototype.removeAriaLabelledBy=function(o){var r=this.getAggregation("_popover");if(r){r.removeAriaLabelledBy(o);}return this.removeAssociation("ariaLabelledBy",o);};
b.prototype.removeAllAssociation=function(A,s){if(A==="ariaLabelledBy"){var r=this.getAggregation("_popover");if(r){r.removeAllAssociation(A,s);}}return C.prototype.removeAllAssociation.apply(this,arguments);};
return b;});
sap.ui.predefine('sap/m/ColumnPopoverActionItem',['./ColumnPopoverItem','sap/m/Button'],function(C,B){"use strict";
var a=C.extend("sap.m.ColumnPopoverActionItem",{
library:"sap.m",
metadata:{properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null}},events:{press:{}}}
});
a.prototype._createButton=function(i,c){return new B(i,{icon:this.getIcon(),type:"Transparent",tooltip:this.getText(),visible:this.getVisible(),press:[function(e){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);c._oShownCustomContent=null;c._cleanSelection(this);}var p=c.getAggregation("_popover");p.close();this.firePress();},this]});};
return a;});
sap.ui.predefine('sap/m/ColumnPopoverCustomItem',['./ColumnPopoverItem','sap/m/ToggleButton'],function(C,T){"use strict";
var a=C.extend("sap.m.ColumnPopoverCustomItem",{
library:"sap.m",
metadata:{properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:false,singularName:"content"}},events:{beforeShowContent:{}}}
});
a.prototype._createButton=function(i,c){var p=c.getAggregation("_popover");var o=this.getContent();if(o){o.setVisible(false);this._sContentId=o.sId;}p.addContent(o);var t=this;return new T(i,{icon:this.getIcon(),type:"Transparent",tooltip:this.getText(),visible:this.getVisible(),press:function(){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);}if(this.getPressed()){c._cleanSelection(this);t.fireBeforeShowContent();if(o){o.setVisible(true);c._oShownCustomContent=o;}}else if(o){o.setVisible(false);c._oShownCustomContent=null;}}});};
return a;});
sap.ui.predefine('sap/m/ColumnPopoverItem',['sap/ui/core/Element'],function(E){"use strict";
var C=E.extend("sap.m.ColumnPopoverItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Misc",defaultValue:true}}}});
C.prototype._createButton=function(){throw new Error('Abstract function _create Button must be implemented in your Item (that extends this abstract object).');};
return C;});
sap.ui.predefine('sap/m/ColumnPopoverSortItem',['sap/ui/core/Core','./ColumnPopoverItem','sap/m/ToggleButton','sap/m/Button','sap/m/StandardListItem','sap/m/List'],function(C,a,T,B,S,L){"use strict";
var b=a.extend("sap.m.ColumnPopoverSortItem",{
library:"sap.m",
metadata:{properties:{label:{type:"string",group:"Misc",defaultValue:null}},events:{sort:{parameters:{property:{type:"string"}}}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:true}}}
});
b.prototype._createButton=function(I,c){var o=C.getLibraryResourceBundle("sap.m"),s=o.getText("COLUMNHEADERPOPOVER_SORT_BUTTON"),d=this.getItems(),t=this;if(d.length>1){var p=c.getAggregation("_popover");var l=new L();for(var i=0;i<d.length;i++){var e=new S({title:d[i].getText(),type:"Active"});l.addItem(e);e.data("key",d[i].getKey());}l.attachEvent("itemPress",function(E){p.close();var e=E.getParameter("listItem");t.fireSort({property:e.data("key")});});l.setVisible(false);p.addContent(l);return new T(I,{icon:"sap-icon://sort",type:"Transparent",tooltip:s,visible:this.getVisible(),press:function(){if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);}if(this.getPressed()){c._cleanSelection(this);if(l){l.setVisible(true);c._oShownCustomContent=l;}}else if(l){l.setVisible(false);c._oShownCustomContent=null;}}});}else{return new B(I,{icon:"sap-icon://sort",type:"Transparent",tooltip:s,visible:this.getVisible(),press:function(){var p=c.getAggregation("_popover");if(c._oShownCustomContent){c._oShownCustomContent.setVisible(false);c._oShownCustomContent=null;c._cleanSelection(this);}p.close();t.fireSort({property:d[0]?d[0].getKey():null});}});}};
return b;});
sap.ui.predefine('sap/m/CustomTreeItem',['./TreeItemBase','./ListItemBase','./library',"./CustomTreeItemRenderer"],function(T,L,l,C){"use strict";
var a=T.extend("sap.m.CustomTreeItem",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}}}});
a.prototype.getContentAnnouncement=function(){return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return a;});
sap.ui.predefine('sap/m/CustomTreeItemRenderer',['./TreeItemBaseRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var C=R.extend(T);C.apiVersion=2;
C.renderLIAttributes=function(r,l){r.class("sapMCTI");T.renderLIAttributes.apply(this,arguments);};
C.renderLIContent=function(r,l){l.getContent().forEach(function(c){r.renderControl(c);});};
return C;},true);
sap.ui.predefine('sap/m/P13nAnyFilterItem',['./library','sap/m/P13nFilterItem'],function(l,P){"use strict";
var a=P.extend("sap.m.P13nAnyFilterItem",{metadata:{library:"sap.m",properties:{value1:{type:"any",group:"Misc",defaultValue:null},value2:{type:"any",group:"Misc",defaultValue:null}}}});
return a;});
sap.ui.predefine('sap/m/P13nColumnsItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nColumnsItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Misc"},index:{type:"int",group:"Appearance"},visible:{type:"boolean",group:"Appearance"},width:{type:"string",group:"Misc"},total:{type:"boolean"}}}});
return P;});
sap.ui.predefine('sap/m/P13nColumnsPanel',['sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler','sap/ui/core/IconPool','./library','./Table','./Column','./ColumnListItem','./P13nPanel','./P13nColumnsItem','./SearchField','./ScrollContainer','./Text','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./OverflowToolbarButton','./ToolbarSpacer',"sap/ui/thirdparty/jquery"],function(C,c,J,B,R,I,l,T,d,e,P,f,S,g,h,i,O,j,k,m,q){"use strict";var n=l.OverflowToolbarPriority;var o=l.ButtonType;var p=l.ToolbarDesign;var L=l.ListType;var r=l.ListMode;var s=l.P13nPanelType;
var t=P.extend("sap.m.P13nColumnsPanel",{
metadata:{library:"sap.m",properties:{visibleItemsThreshold:{type:"int",group:"Behavior",defaultValue:-1}},aggregations:{columnsItems:{type:"sap.m.P13nColumnsItem",multiple:true,singularName:"columnsItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{addColumnsItem:{parameters:{newItem:{type:"sap.m.P13nColumnsItem"}}},changeColumnsItems:{parameters:{newItems:{type:"sap.m.P13nColumnsItem[]"},existingItems:{type:"sap.m.P13nColumnsItem[]"},items:{type:"object[]"}}},setData:{}}},
renderer:{apiVersion:2,render:function(a,b){a.openStart("div",b);a.class("sapMP13nColumnsPanel");a.openEnd();b.getAggregation("content").forEach(function(u){a.renderControl(u);});a.close("div");}}
});
t.prototype.init=function(){this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bTableItemsChanged=false;this._bOnAfterRenderingFirstTimeExecuted=false;var M=new J({items:[],columnKeyOfMarkedItem:undefined,isMoveDownButtonEnabled:undefined,isMoveUpButtonEnabled:undefined,showOnlySelectedItems:undefined,countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(B.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nColumnsPanel");this.setType(s.columns);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("COLUMSPANEL_TITLE"));this._createTable();this._createToolbar();this.setVerticalScrolling(false);var a=new g({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",a);var b=this;this._fnHandleResize=function(){var u=false,v,w;if(b.getParent){var $=null,x,H;var y=b.getParent();var z=b._getToolbar();if(y&&y.$){$=y.$("cont");if($.children().length>0&&z.$().length>0){v=a.$()[0].clientHeight;x=$.children()[0].clientHeight;H=z?z.$()[0].clientHeight:0;w=x-H;if(v!==w){a.setHeight(w+'px');u=true;}}}}return u;};this._sContainerResizeListener=R.register(a,this._fnHandleResize);};
t.prototype.reInitialize=function(){};
t.prototype.onBeforeRendering=function(){this._updateInternalModel();if(!this._getInternalModel().getProperty("/columnKeyOfMarkedItem")){this._setColumnKeyOfMarkedItem(this._getColumnKeyByTableItem(this._getVisibleTableItems()[0]));}this._switchMarkedTableItemTo(this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem")));this._updateControlLogic();};
t.prototype.onAfterRendering=function(){if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);var a=this;this._iLiveChangeTimer=window.setTimeout(function(){a._fnHandleResize();},0);}};
t.prototype.getOkPayload=function(){this._updateInternalModel();var M=this._getInternalModel().getProperty("/items");return{tableItems:M.map(function(a){return{columnKey:a.columnKey,index:a.persistentIndex===-1?undefined:a.persistentIndex,visible:a.persistentSelected,width:a.width};}),tableItemsChanged:this._bTableItemsChanged,selectedItems:M.filter(function(a){return a.persistentSelected;}).map(function(a){return{columnKey:a.columnKey};})};};
t.prototype.getResetPayload=function(){return{oPanel:this};};
t.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
t.prototype.addItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",a);return this;};
t.prototype.insertItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",a,b);return this;};
t.prototype.removeItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}a=this.removeAggregation("items",a);return a;};
t.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
t.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
t.prototype.addColumnsItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("columnsItems",a);return this;};
t.prototype.insertColumnsItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("columnsItems",a,b);return this;};
t.prototype.updateColumnsItems=function(a){this.updateAggregation("columnsItems");if(a===c.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
t.prototype.removeColumnsItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("columnsItems",a);};
t.prototype.removeAllColumnsItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("columnsItems");};
t.prototype.destroyColumnsItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("columnsItems");return this;};
t.prototype.onBeforeNavigationFrom=function(){var M=this._getSelectedModelItems();var v=this.getVisibleItemsThreshold();return!(M&&v!==-1&&M.length>v);};
t.prototype._notifyChange=function(){this._bTableItemsChanged=true;var a=this.getChangeNotifier();if(a){a(this);}};
t.prototype._scrollToSelectedItem=function(a){if(!a){return;}sap.ui.getCore().applyChanges();};
t.prototype._getInternalModel=function(){return this.getModel("$sapmP13nColumnsPanel");};
t.prototype._createTable=function(){this._oTable=new T({mode:r.MultiSelect,rememberSelections:false,itemPress:q.proxy(this._onItemPressed,this),selectionChange:q.proxy(this._onSelectionChange,this),columns:[new d({vAlign:C.VerticalAlign.Middle,header:new h({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(a,b){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[a,b]);}}})})],items:{path:"/items",templateShareable:false,template:new e({cells:[new h({text:"{text}"})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:L.Active})}});this._oTable.setModel(this._getInternalModel());};
t.prototype._createToolbar=function(){var a=this;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var u=new O(this.getId()+"-toolbar",{design:p.Auto,content:[new m(),new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(a._iSearchTimer);if(D){a._iSearchTimer=window.setTimeout(function(){a._onExecuteSearch();},D);}else{a._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new j({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})}),new i({text:{path:'/showOnlySelectedItems',formatter:function(v){return v?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},tooltip:{path:'/showOnlySelectedItems',formatter:function(v){return v?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},type:o.Transparent,press:q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new j({moveToOverflow:true,priority:n.High})}),new k({icon:I.getIconURI("collapse-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),type:o.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:q.proxy(this.onPressButtonMoveToTop,this),layoutData:new j({moveToOverflow:true,priority:n.Low,group:2})}),new k({icon:I.getIconURI("slim-arrow-up"),text:b.getText('COLUMNSPANEL_MOVE_UP'),tooltip:b.getText('COLUMNSPANEL_MOVE_UP'),type:o.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:q.proxy(this.onPressButtonMoveUp,this),layoutData:new j({moveToOverflow:true,priority:n.High,group:1})}),new k({icon:I.getIconURI("slim-arrow-down"),text:b.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:b.getText('COLUMNSPANEL_MOVE_DOWN'),type:o.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:q.proxy(this.onPressButtonMoveDown,this),layoutData:new j({moveToOverflow:true,priority:n.High,group:1})}),new k({icon:I.getIconURI("expand-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),type:o.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:q.proxy(this.onPressButtonMoveToBottom,this),layoutData:new j({moveToOverflow:true,priority:n.Low,group:2})})]});u.setModel(this._getInternalModel());this.addAggregation("content",u);};
t.prototype.onPressButtonMoveToTop=function(){this._moveMarkedTableItem(this._getMarkedTableItem(),this._getVisibleTableItems()[0]);};
t.prototype.onPressButtonMoveUp=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.indexOf(this._getMarkedTableItem())-1]);};
t.prototype.onPressButtonMoveDown=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.indexOf(this._getMarkedTableItem())+1]);};
t.prototype.onPressButtonMoveToBottom=function(){var v=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),v[v.length-1]);};
t.prototype._onSwitchButtonShowSelected=function(){this._getInternalModel().setProperty("/showOnlySelectedItems",!this._getInternalModel().getProperty("/showOnlySelectedItems"));this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fnHandleResize();};
t.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
t.prototype._switchVisibilityOfUnselectedModelItems=function(){var b=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(a){if(a.persistentSelected){a.visible=true;return;}a.visible=!b;});this._getInternalModel().setProperty("/items",M);};
t.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
t.prototype._moveMarkedTableItem=function(a,b){var M=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(a));var u=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(b));var v=this._getModelItemIndexByColumnKey(M.columnKey);var w=this._getModelItemIndexByColumnKey(u.columnKey);this._moveModelItems(v,w);this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fireChangeColumnsItems();this._fireSetData();this._notifyChange();};
t.prototype._moveModelItems=function(a,b){var M=this._getInternalModel().getProperty("/items");if(a<0||b<0||a>M.length-1||b>M.length-1){return false;}this._removeStyleOfMarkedTableItem();var u=M.splice(a,1);M.splice(b,0,u[0]);this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());return true;};
t.prototype._getModelItemByColumnKey=function(a){var M=this._getInternalModel().getProperty("/items").filter(function(b){return b.columnKey===a;});return M[0];};
t.prototype._updateCounts=function(M){var a=0;var b=0;M.forEach(function(u){a++;if(u.persistentSelected){b++;}});this._getInternalModel().setProperty("/countOfItems",a);this._getInternalModel().setProperty("/countOfSelectedItems",b);};
t.prototype._sortModelItemsByPersistentIndex=function(M){var u;var v;try{v=sap.ui.getCore().getConfiguration().getLocale().toString();if(typeof window.Intl!=='undefined'){u=window.Intl.Collator(v,{numeric:true});}}catch(E){}M.forEach(function(a,b){a.localIndex=b;});M.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex>-1&&a.persistentIndex<b.persistentIndex){return-1;}else if(b.persistentIndex>-1&&a.persistentIndex>b.persistentIndex){return 1;}else{return a.localIndex-b.localIndex;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){return u?u.compare(a.text,b.text):a.text.localeCompare(b.text,v,{numeric:true});}});M.forEach(function(a){delete a.localIndex;});};
t.prototype._getColumnKeyByTableItem=function(a){var b=this._oTable.indexOfItem(a);if(b<0){return null;}return this._oTable.getBinding("items").getContexts()[b].getObject().columnKey;};
t.prototype._getModelItemIndexByColumnKey=function(a){var b=-1;this._getInternalModel().getProperty("/items").some(function(M,u){if(M.columnKey===a){b=u;return true;}});return b;};
t.prototype._getSelectedModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return M.persistentSelected;});};
t.prototype._getVisibleTableItems=function(){return this._oTable.getItems().filter(function(a){return a.getVisible();});};
t.prototype._getTableItemByColumnKey=function(a){var b=this._oTable.getBinding("items").getContexts();var u=this._oTable.getItems().filter(function(v,w){return b[w].getObject().columnKey===a;});return u[0];};
t.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
t.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
t.prototype._getSearchText=function(){var a=this._getSearchField();return a?a.getValue():"";};
t.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
t.prototype._isFilteredByShowSelected=function(){return this._getInternalModel().getData().showOnlySelectedItems;};
t.prototype._updateControlLogic=function(){var b=this._isFilteredBySearchText();var a=this._isFilteredByShowSelected();var v=this._getVisibleTableItems();this._getInternalModel().setProperty("/isMoveUpButtonEnabled",v.indexOf(this._getMarkedTableItem())>0);this._getInternalModel().setProperty("/isMoveDownButtonEnabled",v.indexOf(this._getMarkedTableItem())>-1&&v.indexOf(this._getMarkedTableItem())<v.length-1);var u=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(u){u.setEnabled(!b&&!a);}};
t.prototype._updateModelItemsPersistentIndex=function(M){var a=-1;M.forEach(function(b){b.persistentIndex=-1;if(b.persistentSelected){a++;b.persistentIndex=a;}});};
t.prototype._fireSetData=function(){this._bIgnoreUpdateInternalModel=true;this.fireSetData();this._bIgnoreUpdateInternalModel=false;};
t.prototype._fireChangeColumnsItems=function(){this._bIgnoreUpdateInternalModel=true;var M=this._getInternalModel().getProperty("/items");var E={newItems:[],existingItems:[],items:M.map(function(a){return{columnKey:a.columnKey,visible:a.persistentSelected,index:a.persistentIndex===-1?undefined:a.persistentIndex,width:a.width,total:a.total};})};M.forEach(function(a){var b=this._getColumnsItemByColumnKey(a.columnKey);if(b){b.setVisible(a.persistentSelected);b.setIndex(a.persistentIndex===-1?undefined:a.persistentIndex);if(a.width!==undefined){b.setWidth(a.width);}if(a.total!==undefined){b.setTotal(a.total);}E.existingItems.push(b);}else{E.newItems.push(new f({columnKey:a.columnKey,visible:a.persistentSelected,index:a.persistentIndex===-1?undefined:a.persistentIndex,width:a.width,total:a.total}));}},this);this.fireChangeColumnsItems(E);this._bIgnoreUpdateInternalModel=false;};
t.prototype._getColumnsItemByColumnKey=function(a){var b=this.getColumnsItems().filter(function(u){return u.getColumnKey()===a;});return b[0];};
t.prototype._getMarkedTableItem=function(){return this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem"));};
t.prototype._setColumnKeyOfMarkedItem=function(a){this._getInternalModel().setProperty("/columnKeyOfMarkedItem",a);};
t.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));this._updateControlLogic();};
t.prototype._onSelectionChange=function(E){if(!E.getParameter("selectAll")&&E.getParameter("listItems").length===1){this._switchMarkedTableItemTo(E.getParameter("listItem"));}this._selectTableItem();};
t.prototype._selectTableItem=function(){this._updateControlLogic();var M=this._getInternalModel().getProperty("/items");this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeColumnsItems();this._fireSetData();this._notifyChange();var v=this.getValidationExecutor();if(v){v();}};
t.prototype._switchMarkedTableItemTo=function(a){this._removeStyleOfMarkedTableItem();var b=this._getColumnKeyByTableItem(a);if(b){this._setColumnKeyOfMarkedItem(b);a.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
t.prototype._removeStyleOfMarkedTableItem=function(){if(this._getMarkedTableItem()){this._getMarkedTableItem().removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
t.prototype._filterModelItemsBySearchText=function(){var a=this._getSearchText();a=a.replace(/(^\s+)|(\s+$)/g,'');a=a.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var b=new RegExp(a,'igm');if(!b){return;}this._getVisibleModelItems().forEach(function(M){M.visible=false;if(typeof M.text==="string"&&M.text.match(b)){M.visible=true;}if(typeof M.tooltip==="string"&&M.tooltip.match(b)){M.visible=true;}});this._getInternalModel().refresh();};
t.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._removeStyleOfMarkedTableItem();var M=this._getInternalModel().getProperty("/items");this._getInternalModel().setProperty("/items",this.getItems().map(function(b){return{columnKey:b.getColumnKey(),visible:true,text:b.getText(),tooltip:b.getTooltip(),persistentIndex:-1,persistentSelected:b.getVisible(),width:undefined,total:undefined};},this));this.getColumnsItems().forEach(function(b){var u=this._getModelItemByColumnKey(b.getColumnKey());if(!u){return;}if(b.getIndex()!==undefined){u.persistentIndex=b.getIndex();}if(b.getVisible()!==undefined){u.persistentSelected=b.getVisible();}if(b.getWidth()!==undefined){u.width=b.getWidth();}if(b.getTotal()!==undefined){u.total=b.getTotal();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var a=this._getInternalModel().getProperty("/items");this._sortModelItemsByPersistentIndex(a);this._updateCounts(a);this._getInternalModel().setProperty("/items",a);this._switchMarkedTableItemTo(this._getMarkedTableItem());if(q(a).not(M).length!==0||q(M).not(a).length!==0){this._bTableItemsChanged=true;}};
return t;});
sap.ui.predefine('sap/m/P13nConditionPanel',['./library','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/Item','sap/ui/core/ListItem','sap/ui/model/odata/type/Boolean','sap/ui/model/type/String','sap/ui/model/odata/type/String','sap/ui/model/type/Date','sap/ui/model/type/Time','sap/ui/model/odata/type/DateTime','sap/ui/model/type/Float','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./ToolbarSpacer','./Text','./SearchField','./CheckBox','./ComboBox','./Select','./Label','./Input','./DatePicker','./TimePicker','./DateTimePicker','sap/base/Log','sap/ui/thirdparty/jquery'],function(a,c,C,I,D,b,R,d,L,B,S,e,f,T,g,F,h,O,k,m,o,q,r,s,t,u,v,x,y,z,A,Q){"use strict";var V=c.ValueState;var E=a.ButtonType;var G=a.ToolbarDesign;var H=c.TextAlign;var J=a.OverflowToolbarPriority;var P=a.P13nConditionOperation;var K;var M;var N;var U;
var W=C.extend("sap.m.P13nConditionPanel",{
metadata:{library:"sap.m",properties:{maxConditions:{type:"string",group:"Misc",defaultValue:'-1'},exclude:{type:"boolean",group:"Misc",defaultValue:false},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},autoAddNewRow:{type:"boolean",group:"Misc",defaultValue:false},disableFirstRemoveIcon:{type:"boolean",group:"Misc",defaultValue:false},alwaysShowAddIcon:{type:"boolean",group:"Misc",defaultValue:true},usePrevConditionSetting:{type:"boolean",group:"Misc",defaultValue:true},autoReduceKeyFieldItems:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},showLabel:{type:"boolean",group:"Misc",defaultValue:false},displayFormat:{type:"string",group:"Misc",defaultValue:null},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{dataChange:{}}},
renderer:{apiVersion:2,render:function(i,j){i.openStart("section",j);i.class("sapMConditionPanel");i.openEnd();i.openStart("div");i.class("sapMConditionPanelContent");i.class("sapMConditionPanelBG");i.openEnd();j.getAggregation("content").forEach(function(l){i.renderControl(l);});i.close("div");i.close("section");}}
});
W.prototype.setConditions=function(j){if(!j){A.error("sap.m.P13nConditionPanel : aCondition is not defined");}if(this._bIgnoreSetConditions){return;}this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;for(var i=0;i<j.length;i++){this._addCondition2Map(j[i]);}this._clearConditions();this._fillConditions();};
W.prototype.removeAllConditions=function(){this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._clearConditions();this._fillConditions();};
W.prototype.addCondition=function(i){if(this._bIgnoreSetConditions){return;}i.index=this._iConditions;this._addCondition2Map(i);this._addCondition(i);};
W.prototype.insertCondition=function(i,j){if(this._bIgnoreSetConditions){return;}if(j!==undefined){i.index=j;}this._addCondition2Map(i);this._addCondition(i);};
W.prototype.removeCondition=function(i){this._clearConditions();if(typeof i=="string"){this._removeConditionFromMap(i);}if(typeof i=="object"){this._removeConditionFromMap(i.key);}this._fillConditions();};
W.prototype._addCondition2Map=function(i){if(!i.key){i.key="condition_"+this._iConditions;if(this.getExclude()){i.key="x"+i.key;}}this._iConditions++;this._oConditionsMap[i.key]=i;this._aConditionKeys.push(i.key);};
W.prototype._removeConditionFromMap=function(j){this._iConditions--;delete this._oConditionsMap[j];var i=this._aConditionKeys.indexOf(j);if(i>=0){this._aConditionKeys.splice(i,1);}};
W.prototype.getConditions=function(){var i;var j=[];if(this._oConditionsMap){for(var l in this._oConditionsMap){i=this._oConditionsMap[l];var n=i.value;if(!n){n=this._getFormatedConditionText(i.operation,i.value1,i.value2,i.exclude,i.keyField,i.showIfGrouped);}if(!i._oGrid||i._oGrid.select.getSelected()){j.push({"key":l,"text":n,"exclude":i.exclude,"operation":i.operation,"keyField":i.keyField,"value1":i.value1,"value2":i.operation===P.BT?i.value2:null,"showIfGrouped":i.showIfGrouped});}}}return j;};
W.prototype.setOperations=function(i,j){j=j||"default";this._oTypeOperations[j]=i;this._updateAllOperations();};
W.prototype.setValues=function(i,j){j=j||"default";this._oTypeValues[j]=i;};
W.prototype.addOperation=function(i,j){j=j||"default";this._oTypeOperations[j].push(i);this._updateAllOperations();};
W.prototype.removeAllOperations=function(i){i=i||"default";this._oTypeOperations[i]=[];this._updateAllOperations();};
W.prototype.getOperations=function(i){i=i||"default";return this._oTypeOperations[i];};
W.prototype.setKeyFields=function(i){this._aKeyFields=i;this._aKeyFields.forEach(function(j){W._createKeyFieldTypeInstance(j);},this);this._updateKeyFieldItems(this._oConditionsGrid,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
W.prototype.addKeyField=function(i){this._aKeyFields.push(i);W._createKeyFieldTypeInstance(i);this._updateKeyFieldItems(this._oConditionsGrid,true,true);this._updateAllConditionsEnableStates();this._createAndUpdateAllKeyFields();this._updateAllOperations();};
W._createKeyFieldTypeInstance=function(i){var j;if(!i.typeInstance){switch(i.type){case"boolean":i.typeInstance=new B();break;case"numc":if(!(i.formatSettings&&i.formatSettings.isDigitSequence)){A.error("sap.m.P13nConditionPanel","NUMC type support requires isDigitSequence==true!");i.formatSettings=Object.assign({},i.formatSettings,{isDigitSequence:true});}j=i.formatSettings;if(i.maxLength){j=Object.assign({},j,{maxLength:i.maxLength});}if(!j.maxLength){A.error("sap.m.P13nConditionPanel","NUMC type suppport requires maxLength!");}i.typeInstance=new e({},j);break;case"date":i.typeInstance=new f(Object.assign({},i.formatSettings,{strictParsing:true}),{});break;case"time":i.typeInstance=new T(Object.assign({},i.formatSettings,{strictParsing:true}),{});break;case"datetime":i.typeInstance=new g(Object.assign({},i.formatSettings,{strictParsing:true}),{displayFormat:"Date"});var n=i.typeInstance;if(!n.oFormat){n.formatValue(new Date(),"string");}if(n.oFormat){n.oFormat.oFormatOptions.UTC=false;}break;case"stringdate":sap.ui.getCore().loadLibrary("sap.ui.comp");U=U||sap.ui.requireSync("sap/ui/comp/odata/type/StringDate");i.typeInstance=new U(Object.assign({},i.formatSettings,{strictParsing:true}));break;case"numeric":if(i.precision||i.scale){j={};if(i.precision){j["maxIntegerDigits"]=parseInt(i.precision);}if(i.scale){j["maxFractionDigits"]=parseInt(i.scale);}}i.typeInstance=new F(j);break;default:var l=i.formatSettings;if(i.maxLength){l=Object.assign({},l,{maxLength:i.maxLength});}i.typeInstance=new S({},l);break;}}};
W.prototype.removeAllKeyFields=function(){this._aKeyFields=[];this._updateKeyFieldItems(this._oConditionsGrid,true);};
W.prototype.getKeyFields=function(){return this._aKeyFields;};
W.prototype.setAlwaysShowAddIcon=function(i){this.setProperty("alwaysShowAddIcon",i);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");}return this;};
W.prototype.setLayoutMode=function(l){this.setProperty("layoutMode",l);if(this._oConditionsGrid){this._oConditionsGrid.toggleStyleClass("conditionRootGrid",l!=="Desktop");}this._updateConditionFieldSpans(l);this._clearConditions();this._fillConditions();return this;};
W.prototype.setContainerQuery=function(i){this._unregisterResizeHandler();this.setProperty("containerQuery",i);this._registerResizeHandler();this._clearConditions();this._fillConditions();return this;};
W.prototype._updateConditionFieldSpans=function(i){if(this._aConditionsFields){var j=i==="Desktop";if(j){this._aConditionsFields[2].SpanFilter="L3 M3 S3";this._aConditionsFields[4].SpanFilter="L2 M2 S2";this._aConditionsFields[5].SpanFilter="L3 M3 S3";this._aConditionsFields[6].SpanFilter="L2 M2 S2";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}var l=i==="Tablet";if(l){this._aConditionsFields[2].SpanFilter="L5 M5 S5";this._aConditionsFields[4].SpanFilter="L5 M5 S5";this._aConditionsFields[5].SpanFilter="L10 M10 S10";this._aConditionsFields[6].SpanFilter="L10 M10 S10";this._aConditionsFields[7].SpanFilter="L1 M1 S1";}}};
W.prototype.init=function(){sap.ui.getCore().loadLibrary("sap.ui.layout");K=K||sap.ui.requireSync("sap/ui/layout/Grid");M=M||sap.ui.requireSync("sap/ui/layout/GridData");N=N||sap.ui.requireSync("sap/ui/layout/HorizontalLayout");this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sFromLabelText=this._oRb.getText("CONDITIONPANEL_LABELFROM");this._sToLabelText=this._oRb.getText("CONDITIONPANEL_LABELTO");this._sValueLabelText=this._oRb.getText("CONDITIONPANEL_LABELVALUE");this._sShowIfGroupedLabelText=this._oRb.getText("CONDITIONPANEL_LABELGROUPING");this._sValidationDialogFieldMessage=this._oRb.getText("CONDITIONPANEL_FIELDMESSAGE");this._oTypeOperations={"default":[]};this._oTypeValues={"default":[]};this._aKeyFields=[];this._oConditionsMap={};this._aConditionKeys=[];this._iConditions=0;this._sLayoutMode="Desktop";this._sConditionType="Filter";this._sAddRemoveIconTooltip="FILTER";this._iBreakPointTablet=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD].points[0];this._iBreakPointDesktop=D.media._predefinedRangeSets[D.media.RANGESETS.SAP_STANDARD].points[1];this._oConditionsGrid=new K({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:0,vSpacing:0}).toggleStyleClass("conditionRootGrid",this.getLayoutMode()!=="Desktop");this._oConditionsGrid.addStyleClass("sapUiRespGridOverflowHidden");this._iFirstConditionIndex=0;this._iConditionPageSize=10;this._oInvisibleTextField=new b({text:this._oRb.getText("CONDITIONPANEL_FIELD_LABEL")});this._oInvisibleTextOperator=new b({text:this._oRb.getText("CONDITIONPANEL_OPERATOR_LABEL")});this.addAggregation("content",this._oInvisibleTextField);this.addAggregation("content",this._oInvisibleTextOperator);this.addAggregation("content",this._oConditionsGrid);this._registerResizeHandler();this._aConditionsFields=[{"ID":"select","Label":"","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"CheckBox","Value":""},{"ID":"keyFieldLabel","Text":"Sort By","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"keyField","Label":"","SpanFilter":"L3 M5 S10","SpanSort":"L5 M5 S12","SpanGroup":"L4 M4 S12","Control":"ComboBox"},{"ID":"operationLabel","Text":"Sort Order","SpanFilter":"L1 M1 S1","SpanSort":"L1 M1 S1","SpanGroup":"L1 M1 S1","Control":"Label"},{"ID":"operation","Label":"","SpanFilter":"L2 M5 S10","SpanSort":D.system.phone?"L5 M5 S8":"L5 M5 S9","SpanGroup":"L2 M5 S10","Control":"ComboBox"},{"ID":"value1","Label":this._sFromLabelText,"SpanFilter":"L3 M10 S10","SpanSort":"L3 M10 S10","SpanGroup":"L3 M10 S10","Control":"TextField","Value":""},{"ID":"value2","Label":this._sToLabelText,"SpanFilter":"L2 M10 S10","SpanSort":"L2 M10 S10","SpanGroup":"L2 M10 S10","Control":"TextField","Value":""},{"ID":"showIfGrouped","Label":this._sShowIfGroupedLabelText,"SpanFilter":"L1 M10 S10","SpanSort":"L1 M10 S10","SpanGroup":"L3 M4 S9","Control":"CheckBox","Value":"false"}];this._oButtonGroupSpan={"SpanFilter":"L2 M2 S2","SpanSort":D.system.phone?"L2 M2 S4":"L2 M2 S3","SpanGroup":"L2 M2 S3"};this._updateConditionFieldSpans(this.getLayoutMode());this._fillConditions();};
W.prototype._createPaginatorToolbar=function(){this._bPaginatorButtonsVisible=false;var i=this;this._oPrevButton=new h({icon:I.getIconURI("navigation-left-arrow"),tooltip:this._oRb.getText("WIZARD_FINISH"),visible:true,press:function(j){i._iFirstConditionIndex=Math.max(0,i._iFirstConditionIndex-i._iConditionPageSize);i._clearConditions();i._fillConditions();},layoutData:new k({priority:J.NeverOverflow})});this._oNextButton=new h({icon:I.getIconURI("navigation-right-arrow"),tooltip:this._oRb.getText("WIZARD_NEXT"),visible:true,press:function(j){i._iFirstConditionIndex+=i._iConditionPageSize;i._clearConditions();i._fillConditions();},layoutData:new k({priority:J.NeverOverflow})});this._oRemoveAllButton=new h({text:this._oRb.getText("CONDITIONPANEL_REMOVE_ALL"),visible:true,press:function(j){i._aConditionKeys.forEach(function(l,n){if(n>=0){this.fireDataChange({key:l,index:n,operation:"remove",newData:null});}},i);this._iFirstConditionIndex=0;i.removeAllConditions();},layoutData:new k({priority:J.Low})});this._oAddButton=new h({icon:I.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),visible:true,press:function(j){var l=i._createConditionRow(i._oConditionsGrid,undefined,null,0);i._changeField(l);setTimeout(function(){l.keyField.focus();});i._updatePaginatorToolbar();},layoutData:new k({priority:J.Low})});this._oHeaderText=new o({wrapping:false,layoutData:new k({priority:J.NeverOverflow})});this._oPageText=new o({wrapping:false,textAlign:H.Center,layoutData:new k({priority:J.NeverOverflow})});this._oFilterField=new q({width:"12rem",layoutData:new k({priority:J.High})});this._oPaginatorToolbar=new O({height:"3rem",design:G.Transparent,content:[this._oHeaderText,new m(),this._oFilterField,this._oPrevButton,this._oPageText,this._oNextButton,this._oRemoveAllButton,this._oAddButton]});};
W.prototype._updatePaginatorToolbar=function(){if(this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"){return;}var i=this._aConditionKeys.length;var p=1+Math.floor(Math.max(0,i-1)/this._iConditionPageSize);var j=1+Math.floor(this._iFirstConditionIndex/this._iConditionPageSize);var l=this.getParent();if(!this._oPaginatorToolbar){if(i>this._iConditionPageSize){this._createPaginatorToolbar();this.insertAggregation("content",this._oPaginatorToolbar,0);this._onGridResize();}else{if(l&&l.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=l.getHeaderText();}l.setHeaderText(this._sOrgHeaderText+(i>0?" ("+i+")":""));}return;}}this._oPrevButton.setEnabled(this._iFirstConditionIndex>0);this._oNextButton.setEnabled(this._iFirstConditionIndex+this._iConditionPageSize<i);if(l&&l.setHeaderToolbar){if(!l.getHeaderToolbar()){this.removeAggregation("content",this._oPaginatorToolbar);l.setHeaderToolbar(this._oPaginatorToolbar);l.attachExpand(function(X){this._setToolbarElementVisibility(X.getSource().getExpanded()&&this._bPaginatorButtonsVisible);}.bind(this));}}if(l&&l.setHeaderText){if(this._sOrgHeaderText==undefined){this._sOrgHeaderText=l.getHeaderText();}var n=this._sOrgHeaderText+(i>0?" ("+i+")":"");l.setHeaderText(n);this._oHeaderText.setText(n);}else{this._oHeaderText.setText(i+" Conditions");}this._oPageText.setText(j+"/"+p);this._bPaginatorButtonsVisible=this._bPaginatorButtonsVisible||p>1;this._setToolbarElementVisibility(this._bPaginatorButtonsVisible);if(j>p){this._iFirstConditionIndex-=Math.max(0,this._iConditionPageSize);this._clearConditions();this._fillConditions();}var w=0;this._oConditionsGrid.getContent().forEach(function(X){if(X.select.getSelected()){w++;}},this);if(p==j&&(i-this._iFirstConditionIndex)>w){this._clearConditions();this._fillConditions();}};
W.prototype._setToolbarElementVisibility=function(i){this._oPrevButton.setVisible(i);this._oNextButton.setVisible(i);this._oPageText.setVisible(i);this._oFilterField.setVisible(false);this._oAddButton.setVisible(i);this._oRemoveAllButton.setVisible(i);};
W.prototype.exit=function(){this._clearConditions();this._unregisterResizeHandler();this._aConditionsFields=null;this._aKeys=null;this._aKeyFields=null;this._oTypeOperations=null;this._oRb=null;this._sFromLabelText=null;this._sToLabelText=null;this._sValueLabelText=null;this._sValidationDialogFieldMessage=null;this._oConditionsMap=null;this._aConditionKeys=[];};
W.prototype._clearConditions=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){for(var l in this._aConditionsFields){var n=this._aConditionsFields[l];if(j[n["ID"]]&&j.getContent().indexOf(j[n["ID"]])===-1){j[n["ID"]].destroy();}}},this);this._oConditionsGrid.destroyContent();};
W.prototype._fillConditions=function(){var j,l;var i=0,p=this._getMaxConditionsAsNumber(),n=this._aConditionKeys.length;if(this._oConditionsMap){var w=this._sConditionType!=="Filter"||this.getMaxConditions()!=="-1"?9999:this._iConditionPageSize;n=Math.min(n,Math.min(p,this._iFirstConditionIndex+w));for(i=this._iFirstConditionIndex;i<n;i++){l=this._aConditionKeys[i];j=this._oConditionsMap[l];this._createConditionRow(this._oConditionsGrid,j,l);}}this._updatePaginatorToolbar();if((this.getAutoAddNewRow()||this._oConditionsGrid.getContent().length===0)&&this._oConditionsGrid.getContent().length<p){this._createConditionRow(this._oConditionsGrid);}};
W.prototype._addCondition=function(j){var i=0;var l=this._getMaxConditionsAsNumber();if(this._oConditionsMap){for(var n in this._oConditionsMap){if(i<l&&j===this._oConditionsMap[n]){this._createConditionRow(this._oConditionsGrid,j,n,i);}i++;}}this._updatePaginatorToolbar();};
W.prototype._getMaxConditionsAsNumber=function(){return this.getMaxConditions()==="-1"?9999:parseInt(this.getMaxConditions());};
W.prototype.onAfterRendering=function(){if(this.getLayoutMode()){this._sLayoutMode=this.getLayoutMode();return;}};
W.prototype._handleMediaChange=function(p){this._sLayoutMode=p.name;this._updateLayout(p);};
W.prototype._unregisterResizeHandler=function(){if(this._sContainerResizeListener){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;}D.media.detachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);};
W.prototype._registerResizeHandler=function(){if(this.getContainerQuery()){this._sContainerResizeListener=R.register(this._oConditionsGrid,this._onGridResize.bind(this));this._onGridResize();}else{D.media.attachHandler(this._handleMediaChange,this,D.media.RANGESETS.SAP_STANDARD);}};
W.prototype._getKeyFromConditionGrid=function(i){var j=i.data("_key");if(!j){j=this._createConditionKey();}return j;};
W.prototype._createConditionKey=function(){var i=0;var j;do{j="condition_"+i;if(this.getExclude()){j="x"+j;}i++;}while(this._oConditionsMap[j]);return j;};
W.prototype._createConditionRow=function(i,j,l,p,n){var w=null;var X;var Y=this;if(p===undefined){p=i.getContent().length;}var Z=new K({width:"100%",defaultSpan:"L12 M12 S12",hSpacing:1,vSpacing:0,containerQuery:this.getContainerQuery()}).data("_key",l);Z.addStyleClass("sapUiRespGridOverflowHidden");for(var $ in this._aConditionsFields){var _;var a1=this._aConditionsFields[$];switch(a1["Control"]){case"CheckBox":_=new r({enabled:false,visible:false,layoutData:new M({span:a1["Span"+this._sConditionType]})});if(a1["ID"]==="showIfGrouped"){_.setEnabled(true);_.setText(a1["Label"]);_.attachSelect(function(){Y._changeField(Z);});_.setSelected(j?j.showIfGrouped:true);}else{if(j){_.setSelected(true);_.setEnabled(true);}}break;case"ComboBox":if(a1["ID"]==="keyField"){_=new s({width:"100%",ariaLabelledBy:this._oInvisibleTextField});var b1=_.setSelectedKey.bind(_);_.setSelectedKey=function(l){b1(l);var o1=Y.getValidationExecutor();if(o1){o1();}};var c1=_.setSelectedItem.bind(_);_.setSelectedItem=function(o1){c1(o1);var p1=Y.getValidationExecutor();if(p1){p1();}};_.setLayoutData(new M({span:a1["Span"+this._sConditionType]}));this._fillKeyFieldListItems(_,this._aKeyFields);if(_.attachSelectionChange){_.attachSelectionChange(function(o1){var p1=Y.getValidationExecutor();if(p1){p1();}Y._handleSelectionChangeOnKeyField(i,Z);});}if(_.attachChange){_.attachChange(function(o1){Z.keyField.close();Y._handleChangeOnKeyField(i,Z);});}if(_.setSelectedItem){if(j){_.setSelectedKey(j.keyField);this._aKeyFields.forEach(function(d1,o1){var p1=d1.key;if(p1===undefined){p1=d1;}if(j.keyField===p1){_.setSelectedItem(_.getItems()[o1]);}},this);}else{if(this.getUsePrevConditionSetting()&&!this.getAutoReduceKeyFieldItems()){if(p>0&&!l&&n){X=i.getContent()[p-1];if(X.keyField.getSelectedKey()){_.setSelectedKey(X.keyField.getSelectedKey());}else{if(!_.getSelectedItem()&&_.getItems().length>0){_.setSelectedItem(_.getItems()[0]);}}}else{this._aKeyFields.some(function(d1,o1){if(d1.isDefault){_.setSelectedItem(_.getItems()[o1]);return true;}if(!_.getSelectedItem()&&d1.type!=="boolean"){_.setSelectedItem(_.getItems()[o1]);}},this);if(!_.getSelectedItem()&&_.getItems().length>0){_.setSelectedItem(_.getItems()[0]);}}}else{this._aKeyFields.forEach(function(d1,o1){if(d1.isDefault){_.setSelectedItem(_.getItems()[o1]);}},this);}}}}if(a1["ID"]==="operation"){_=new t({width:"100%",ariaLabelledBy:this._oInvisibleTextOperator,layoutData:new M({span:a1["Span"+this._sConditionType]})});_.attachChange(function(){Y._handleChangeOnOperationField(i,Z);});Z[a1["ID"]]=_;this._updateOperationItems(i,Z);if(j){var d1=this._getCurrentKeyFieldItem(Z.keyField);var e1=this._oTypeOperations["default"];if(d1){if(d1.type&&this._oTypeOperations[d1.type]){e1=this._oTypeOperations[d1.type];}if(d1.operations){e1=d1.operations;}}e1.some(function(o1,p1){if(j.operation===o1){_.setSelectedKey(o1);return true;}},this);}else{if(this.getUsePrevConditionSetting()){if(p>0&&l===null){var X=i.getContent()[p-1];_.setSelectedKey(X.operation.getSelectedKey());}}}}if(_.getSelectedItem&&_.getSelectedItem()){_.setTooltip(_.getSelectedItem().getTooltip()||_.getSelectedItem().getText());}break;case"TextField":var f1=this._getCurrentKeyFieldItem(Z.keyField);_=this._createValueField(f1,a1,Z);_.oTargetGrid=i;if(j&&j[a1["ID"]]!==undefined){var g1=j[a1["ID"]];if(_ instanceof t){if(typeof g1==="boolean"){_.setSelectedIndex(g1?2:1);}}else if(g1!==null&&Z.oType){if(typeof g1==="string"&&Z.oType.getName()==="sap.ui.comp.odata.type.StringDate"){_.setValue(g1);}else{if(typeof g1==="string"&&["String","sap.ui.model.odata.type.String","sap.ui.model.odata.type.Decimal"].indexOf(Z.oType.getName())==-1){try{g1=Z.oType.parseValue(g1,"string");_.setValue(Z.oType.formatValue(g1,"string"));}catch(h1){A.error("sap.m.P13nConditionPanel","Value '"+g1+"' does not have the expected type format for "+Z.oType.getName()+".parseValue()");}}else{_.setValue(Z.oType.formatValue(g1,"string"));}}}else{_.setValue(g1);}}break;case"Label":_=new u({text:a1["Text"]+":",visible:this.getShowLabel(),layoutData:new M({span:a1["Span"+this._sConditionType]})}).addStyleClass("conditionLabel");_.oTargetGrid=i;break;}Z[a1["ID"]]=_;Z.addContent(_);}w=new N({layoutData:new M({span:this.getLayoutMode()==="Desktop"?"L2 M2 S2":this._oButtonGroupSpan["Span"+this._sConditionType]})}).addStyleClass("floatRight");Z.addContent(w);Z["ButtonContainer"]=w;var i1=new h({type:E.Transparent,icon:I.getIconURI("sys-cancel"),tooltip:this._oRb.getText("CONDITIONPANEL_REMOVE"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){Y._handleRemoveCondition(this.oTargetGrid,Z);},layoutData:new M({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M2 S2"})});i1.oTargetGrid=i;w.addContent(i1);Z["remove"]=i1;var j1=new h({type:E.Transparent,icon:I.getIconURI("add"),tooltip:this._oRb.getText("CONDITIONPANEL_ADD"+(this._sAddRemoveIconTooltipKey?"_"+this._sAddRemoveIconTooltipKey:"")+"_TOOLTIP"),press:function(){Y._handleAddCondition(this.oTargetGrid,Z,true);},layoutData:new M({span:this.getLayoutMode()==="Desktop"?"L1 M1 S1":"L1 M10 S10"})});j1.oTargetGrid=i;j1.addStyleClass("conditionAddBtnFloatRight");w.addContent(j1);Z["add"]=j1;i.insertContent(Z,p);this._updateOperationItems(i,Z);this._changeOperationValueFields(i,Z);this._updateAllConditionsEnableStates();this._updateConditionButtons(i);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false);}if(this._sLayoutMode){this._updateLayout({name:this._sLayoutMode});}if(j){var k1=this._getFormatedConditionText(j.operation,j.value1,j.value2,j.exclude,j.keyField,j.showIfGrouped);j._oGrid=Z;j.value=k1;this._oConditionsMap[l]=j;}var l1=Z.operation.getSelectedKey();if(l1==="BT"&&Z.value1.setMinDate&&Z.value2.setMaxDate){var m1=Z.value1.getDateValue();var n1=Z.value2.getDateValue();this._updateMinMaxDate(Z,m1,n1);}else{this._updateMinMaxDate(Z,null,null);}return Z;};
W.prototype._handleRemoveCondition=function(i,j){var l=i.getContent().indexOf(j);this._removeCondition(i,j);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false);}if(l>=0){l=Math.min(l,i.getContent().length-1);var j=i.getContent()[l];setTimeout(function(){j.remove.focus();});}this._updatePaginatorToolbar();};
W.prototype._handleAddCondition=function(i,j,l){var p=i.getContent().indexOf(j);var n=this._createConditionRow(i,undefined,null,p+1,l);this._changeField(n);setTimeout(function(){n.keyField.focus();});this._updatePaginatorToolbar();};
W.prototype._getCurrentKeyFieldItem=function(i){if(i.getSelectedKey&&i.getSelectedKey()){var j=i.getSelectedKey();var l=this._aKeyFields;for(var n in l){var p=l[n];if(p.key===j){return p;}}}return null;};
W.prototype._createValueField=function(j,n,p){var w;var X;var Y=this;var Z={value:n["Value"],width:"100%",placeholder:n["Label"],change:function(i){Y._validateAndFormatFieldValue(i);Y._changeField(p,i);},layoutData:new M({span:n["Span"+this._sConditionType]})};if(j&&j.typeInstance){var $=j.typeInstance;X=this._findConfig($,"ctrl");if(X==="DateTimePicker"&&$.getMetadata().getName()==="sap.ui.model.odata.type.DateTime"){if(!($.oConstraints&&$.oConstraints.isDateOnly)){A.error("sap.m.P13nConditionPanel","sap.ui.model.odata.type.DateTime without displayFormat = Date is not supported!");$.oConstraints=Object.assign({},$.oConstraints,{isDateOnly:true});}X="DatePicker";}p.oType=$;if(X=="select"){var _=[];var a1=j.values||this._oTypeValues[X]||["",$.formatValue(false,"string"),$.formatValue(true,"string")];a1.forEach(function(i,c1){_.push(new d({key:c1.toString(),text:i.toString()}));});Z={width:"100%",items:_,change:function(){Y._changeField(p);Y._makeFieldValid(w,true);},layoutData:new M({span:n["Span"+this._sConditionType]})};w=new t(Z);}else if(X=="TimePicker"){if($.oFormatOptions&&$.oFormatOptions.style){Z.displayFormat=$.oFormatOptions.style;}w=new y(Z);}else if(X=="DateTimePicker"){if($.oFormatOptions&&$.oFormatOptions.style){Z.displayFormat=$.oFormatOptions.style;}w=new z(Z);}else if(X==="DatePicker"){if($.oFormatOptions){Z.displayFormat=$.oFormatOptions.style||$.oFormatOptions.pattern;if($.isA("sap.ui.comp.odata.type.StringDate")){Z.valueFormat="yyyyMMdd";}}w=new x(Z);}else{w=new v(Z);if(this._fSuggestCallback){j=this._getCurrentKeyFieldItem(p.keyField);if(j&&j.key){var b1=this._fSuggestCallback(w,j.key);if(b1){w._oSuggestProvider=b1;}}}}}else{p.oType=null;w=new v(Z);}if(X!=="boolean"&&X!=="enum"&&w){w.onpaste=function(c1){var d1;if(window.clipboardData){d1=window.clipboardData.getData("Text");}else{d1=c1.originalEvent.clipboardData.getData('text/plain');}var p=c1.srcControl.getParent();var e1=d1.split(/\r\n|\r|\n/g);if(e1&&e1[e1.length-1].trim()===""){e1.pop();}var f1=p.operation;var op=f1.getSelectedKey();if(e1&&e1.length>1&&op!=="BT"){setTimeout(function(){var g1=e1?e1.length:0;var h1=Y._getCurrentKeyFieldItem(p.keyField);var f1=p.operation;for(var i=0;i<g1;i++){if(Y._aConditionKeys.length>=Y._getMaxConditionsAsNumber()){break;}var i1=e1[i].trim();if(i1){var j1;if(h1.typeInstance){try{j1=h1.typeInstance.parseValue(i1,"string");h1.typeInstance.validateValue(j1);}catch(k1){A.error("sap.m.P13nConditionPanel.onPaste","not able to parse value "+i1+" with type "+h1.typeInstance.getName());i1="";j1=null;}if(!j1){continue;}}var l1={"index":Y._iConditions,"key":Y._createConditionKey(),"exclude":Y.getExclude(),"operation":f1.getSelectedKey(),"keyField":h1.key,"value1":j1,"value2":null};Y._addCondition2Map(l1);Y.fireDataChange({key:l1.key,index:l1.index,operation:"add",newData:l1});}}Y._clearConditions();Y._fillConditions();},0);}};}if(j&&j.maxLength&&w.setMaxLength){var l=-1;if(typeof j.maxLength==="string"){l=parseInt(j.maxLength);}if(typeof j.maxLength==="number"){l=j.maxLength;}if(l>0&&(!w.getShowSuggestion||!w.getShowSuggestion())){w.setMaxLength(l);}}return w;};
W.prototype._fillOperationListItems=function(i,j,l){if(l==="_STRING_"){l="";}if(l==="_TIME_"||l==="_DATETIME_"){l="_DATE_";}if(l==="_BOOLEAN_"||l==="_NUMC_"){l="";}i.destroyItems();j.forEach(function(n){var p=this._oRb.getText("CONDITIONPANEL_OPTION"+l+n);if(p.startsWith("CONDITIONPANEL_OPTION")){p=this._oRb.getText("CONDITIONPANEL_OPTION"+n);}i.addItem(new L({key:n,text:p,tooltip:p}));}.bind(this));};
W.prototype._fillKeyFieldListItems=function(i,j){i.destroyItems();for(var l in j){var n=j[l];i.addItem(new L({key:n.key,text:n.text,tooltip:n.tooltip?n.tooltip:n.text}));}i.setEditable(i.getItems().length>1);};
W.prototype._handleChangeOnOperationField=function(i,j){this._changeOperationValueFields(i,j);this._changeField(j);};
W.prototype._handleSelectionChangeOnKeyField=function(i,j){if(this._sConditionType==="Filter"){this._updateOperationItems(i,j);this._createAndUpdateValueFields(i,j);this._changeOperationValueFields(i,j);}this._changeField(j);};
W.prototype._handleChangeOnKeyField=function(i,j){if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(i,false,false,j.keyField);}};
W.prototype._createAndUpdateAllKeyFields=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){this._createAndUpdateValueFields(this._oConditionsGrid,j);this._changeOperationValueFields(this._oConditionsGrid,j);},this);};
W.prototype._createAndUpdateValueFields=function(i,j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=function(j,p,w){var X=p.getValue?p.getValue():"";var Y=j.indexOfContent(p);j.removeContent(p);if(p._oSuggestProvider){p._oSuggestProvider.destroy();p._oSuggestProvider=null;}p.destroy();var Z=this._aConditionsFields[w];p=this._createValueField(l,Z,j);j[Z["ID"]]=p;j.insertContent(p,Y===-1?j.indexOfContent(j.operation)+1:Y);var $,_;if(j.oType&&X){try{$=j.oType.parseValue(X,"string");j.oType.validateValue($);_=j.oType.formatValue($,"string");p.setValue(_);}catch(a1){var b1=a1.message;this._makeFieldValid(p,false,b1);p.setValue(X);}}};n.bind(this)(j,j.value1,5);n.bind(this)(j,j.value2,6);};
W.prototype._updateAllOperations=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){this._updateOperationItems(this._oConditionsGrid,j);this._changeOperationValueFields(this._oConditionsGrid,j);},this);};
W.prototype._updateOperationItems=function(i,j){var l="";var n=this._getCurrentKeyFieldItem(j.keyField);var p=j.operation;var w=this._oTypeOperations["default"];var X=p.getSelectedItem();if(n){if(n.type&&n.type!==""&&this._oTypeOperations[n.type]){l=n.type;w=this._oTypeOperations[l];}if(n.operations){w=n.operations;}}this._fillOperationListItems(p,w,l?"_"+l.toUpperCase()+"_":"");if(X&&p.getItemByKey(X.getKey())){p.setSelectedKey(X.getKey());}else{p.setSelectedItem(p.getItems()[0]);}this._sConditionType="Filter";if(w[0]===P.Ascending||w[0]===P.Descending){this._sConditionType="Sort";}if(w[0]===P.GroupAscending||w[0]===P.GroupDescending){this._sConditionType="Group";}this._adjustValue1Span(j);};
W.prototype._updateKeyFieldItems=function(l,p,w,X){var n=l.getContent().length;var i;var Y={};if(!p){for(i=0;i<n;i++){var Z=l.getContent()[i].keyField;var $=Z.getSelectedKey();if($!=null&&$!==""){Y[$]=true;}}}for(i=0;i<n;i++){var Z=l.getContent()[i].keyField;var _=l.getContent()[i].select;var a1=Z.getSelectedKey();var j=0;var b1=this._aKeyFields;if(Z!==X){if(w){j=b1.length-1;}else{Z.destroyItems();}for(j;j<b1.length;j++){var c1=b1[j];if(c1.key==null||c1.key===""||!Y[c1.key]||c1.key===a1){Z.addItem(new L({key:c1.key,text:c1.text,tooltip:c1.tooltip?c1.tooltip:c1.text}));}}Z.setEditable(Z.getItems().length>1);}if(a1){Z.setSelectedKey(a1);}else if(Z.getItems().length>0){Z.setSelectedItem(Z.getItems()[0]);}if(!_.getSelected()){this._aKeyFields.some(function(d1,e1){if(d1.isDefault){Z.setSelectedItem(Z.getItems()[e1]);return true;}if(!Z.getSelectedItem()){if(d1.type!=="boolean"){Z.setSelectedItem(Z.getItems()[e1]);}}},this);}if(Z.getSelectedItem()){Z.setTooltip(Z.getSelectedItem().getTooltip()||Z.getSelectedItem().getText());}}};
W.prototype._changeOperationValueFields=function(i,j){var l=j.operation;var n=l.getSelectedKey();var p=j.value1;var w=j.value2;var X=j.showIfGrouped;if(!n){return;}if(n===P.BT){if(p.setPlaceholder&&p.getPlaceholder()!==this._sFromLabelText){p.setPlaceholder(this._sFromLabelText);}if(!p.getVisible()){p.setVisible(true);j.insertContent(p,j.getContent().length-1);}if(w.setPlaceholder&&w.getPlaceholder()!==this._sToLabelText){w.setPlaceholder(this._sToLabelText);}if(!w.getVisible()){w.setVisible(true);j.insertContent(w,j.getContent().length-1);}}else{if(n===P.GroupAscending||n===P.GroupDescending){if(p.getVisible()){p.setVisible(false);j.removeContent(p);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}if(l.getVisible()){l.setVisible(false);j.removeContent(l);}X.setVisible(this._getMaxConditionsAsNumber()!=1);}else{if(n===P.NotEmpty||n===P.Empty||n===P.Initial||n===P.Ascending||n===P.Descending||n===P.Total||n===P.Average||n===P.Minimum||n===P.Maximum){if(p.getVisible()){p.setVisible(false);j.removeContent(p);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}j.removeContent(X);}else{if(p.setPlaceholder&&p.getPlaceholder()!==this._sValueLabelText){p.setPlaceholder(this._sValueLabelText);}if(!p.getVisible()){p.setVisible(true);j.insertContent(p,j.getContent().length-1);}if(w.getVisible()){w.setVisible(false);j.removeContent(w);}}}}this._adjustValue1Span(j);};
W.prototype._adjustValue1Span=function(i){if(this._sConditionType==="Filter"&&i.value1&&i.operation){var j=i.operation;var n=this._aConditionsFields[5]["Span"+this._sConditionType];if(j.getSelectedKey()!=="BT"){n="L5 M10 S10";}var l=i.value1.getLayoutData();if(l.getSpan()!==n){l.setSpan(n);}}};
W.prototype._getIndexOfCondition=function(i){var j=-1;i.getParent().getContent().some(function(l){if(l.select.getSelected()){j++;}return(l===i);},this);return j+this._iFirstConditionIndex;};
W.prototype._makeFieldValid=function(i,j,l){if(j){i.setValueState(V.None);i.setValueStateText("");}else{i.setValueState(V.Warning);i.setValueStateText(l?l:this._sValidationDialogFieldMessage);}};
W.prototype._validateAndFormatFieldValue=function(i){var j=i.oSource;var l=j.getParent();var n;if(j.getDateValue&&i){n=i.getParameter("value");var p=i.getParameter("valid");this._makeFieldValid(j,p);return;}else{n=j.getValue&&j.getValue();}if(!l){return;}if(this.getDisplayFormat()==="UpperCase"&&n){n=n.toUpperCase();j.setValue(n);}if(l.oType&&n){try{var w=l.oType.parseValue(n,"string");l.oType.validateValue(w);this._makeFieldValid(j,true);n=l.oType.formatValue(w,"string");j.setValue(n);}catch(X){var Y=X.message;this._makeFieldValid(j,false,Y);}}else{this._makeFieldValid(j,true);}};
W.prototype._updateMinMaxDate=function(i,j,l){if(i.value1.setMinDate&&i.value2.setMaxDate){if(i.value1&&i.value1.setMaxDate){i.value1.setMaxDate(l instanceof Date?l:null);}if(i.value2&&i.value2.setMinDate){i.value2.setMinDate(j instanceof Date?j:null);}}};
W.prototype._changeField=function(i,j){var l=i.keyField.getSelectedKey();if(i.keyField.getSelectedItem()){i.keyField.setTooltip(i.keyField.getSelectedItem().getTooltip()||i.keyField.getSelectedItem().getText());}else{i.keyField.setTooltip(null);}var n=i.operation.getSelectedKey();if(i.operation.getSelectedItem()){i.operation.setTooltip(i.operation.getSelectedItem().getTooltip()||i.operation.getSelectedItem().getText());}else{i.operation.setTooltip(null);}var p=function(h1,i1){var d1;var j1;if(h1.getDateValue&&!(h1.isA("sap.m.TimePicker"))&&i1.getName()!=="sap.ui.comp.odata.type.StringDate"){j1=h1.getDateValue();if(i1&&j1){if((j&&j.getParameter("valid"))||h1.isValidValue()){d1=i1.formatValue(j1,"string");}else{d1="";}}}else{d1=this._getValueTextFromField(h1);j1=d1;if(i1&&i1.getName()==="sap.ui.comp.odata.type.StringDate"){d1=i1.formatValue(j1,"string");}else if(i1&&d1){try{j1=i1.parseValue(d1,"string");i1.validateValue(j1);}catch(k1){A.error("sap.m.P13nConditionPanel","not able to parse value "+d1+" with type "+i1.getName());d1="";}}}return[j1,d1];}.bind(this);var w=p(i.value1,i.oType);var X=w[0],Y=w[1];w=p(i.value2,i.oType);var Z=w[0],$=w[1];if(n==="BT"){this._updateMinMaxDate(i,X,Z);}else{this._updateMinMaxDate(i,null,null);}var _=this._getCurrentKeyFieldItem(i.keyField);if(_&&_.type==="numc"){if([P.Contains,P.EndsWith].indexOf(n)!=-1){X=i.oType.formatValue(X,"string");}}var a1=i.showIfGrouped.getSelected();var b1=this.getExclude();var c1=i.select;var d1="";var e1;if(l===""||l==null){l=null;e1=this._getKeyFromConditionGrid(i);this._removeConditionFromMap(e1);this._enableCondition(i,false);var f1=this._getIndexOfCondition(i);if(c1.getSelected()){c1.setSelected(false);c1.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:e1,index:f1,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}return;}this._enableCondition(i,true);d1=this._getFormatedConditionText(n,Y,$,b1,l,a1);var g1={"value":d1,"exclude":b1,"operation":n,"keyField":l,"value1":X,"value2":n===P.BT?Z:null,"showIfGrouped":a1};e1=this._getKeyFromConditionGrid(i);if(d1!==""){c1.setSelected(true);c1.setEnabled(true);var n="update";if(!this._oConditionsMap[e1]){n="add";}this._oConditionsMap[e1]=g1;if(n==="add"){this._aConditionKeys.splice(this._getIndexOfCondition(i),0,e1);}i.data("_key",e1);this.fireDataChange({key:e1,index:this._getIndexOfCondition(i),operation:n,newData:g1});}else if(this._oConditionsMap[e1]!==undefined){this._removeConditionFromMap(e1);i.data("_key",null);var f1=this._getIndexOfCondition(i);if(c1.getSelected()){c1.setSelected(false);c1.setEnabled(false);this._bIgnoreSetConditions=true;this.fireDataChange({key:e1,index:f1,operation:"remove",newData:null});this._bIgnoreSetConditions=false;}}this._updatePaginatorToolbar();};
W.prototype._getValueTextFromField=function(i){if(i instanceof t){return i.getSelectedItem()?i.getSelectedItem().getText():"";}return i.getValue();};
W.prototype._updateAllConditionsEnableStates=function(){var i=this._oConditionsGrid.getContent();i.forEach(function(j){var l=this._getCurrentKeyFieldItem(j.keyField);var n=l&&l.key!==undefined?l.key:l;var p=n!==""&&n!==null;this._enableCondition(j,p);},this);};
W.prototype._enableCondition=function(i,j){i.operation.setEnabled(j);i.value1.setEnabled(j);i.value2.setEnabled(j);i.showIfGrouped.setEnabled(j);};
W.prototype._removeCondition=function(i,j){var l=this._getKeyFromConditionGrid(j);var n=-1;if(j.select.getSelected()){n=this._getIndexOfCondition(j);}this._removeConditionFromMap(l);j.destroy();if(i.getContent().length<1){this._createConditionRow(i);}else{this._updateConditionButtons(i);}if(n>=0){this.fireDataChange({key:l,index:n,operation:"remove",newData:null});}};
W.prototype._updateConditionButtons=function(j){var l=this._getMaxConditionsAsNumber();var n=j.getContent().length;for(var i=0;i<n;i++){var p=j.getContent()[i].add;if((this.getAlwaysShowAddIcon()&&(n<l))||(i===n-1&&i<l-1)){p.removeStyleClass("displayNone");}else{p.addStyleClass("displayNone");}var w=j.getContent()[i].remove;if(l===1||(i===0&&n===1&&this.getDisableFirstRemoveIcon())){w.addStyleClass("displayNone");}else{w.removeStyleClass("displayNone");}}};
W.prototype.validateConditions=function(){var j=this;var l=function(n){var p=true;for(var i=0;i<n.length;i++){var w=n[i];var X=j._checkCondition(w,i===n.length-1);p=p&&X;}return p;};return l(this._oConditionsGrid.getContent());};
W.prototype.removeValidationErrors=function(){this._oConditionsGrid.getContent().forEach(function(i){var j=i.value1;var l=i.value2;j.setValueState(V.None);j.setValueStateText("");l.setValueState(V.None);l.setValueStateText("");},this);};
W.prototype.removeInvalidConditions=function(){var i=[];this._oConditionsGrid.getContent().forEach(function(j){if(j.value1.getValueState()!==V.None||j.value2.getValueState()!==V.None){i.push(j);}},this);i.forEach(function(j){this._removeCondition(this._oConditionsGrid,j);if(this.getAutoReduceKeyFieldItems()){this._updateKeyFieldItems(this._oConditionsGrid,false);}},this);};
W.prototype._checkCondition=function(i,j){var l=true;var n=i.value1;var p=i.value2;var w=n&&(n.getVisible()&&!this._getValueTextFromField(n));var X=n&&n.getVisible()&&n.getValueState?n.getValueState():V.None;var Y=p&&(p.getVisible()&&!this._getValueTextFromField(p));var Z=p&&p.getVisible()&&p.getValueState?p.getValueState():V.None;var $=i.operation.getSelectedKey();if($===P.BT){if(!w?Y:!Y){if(w){n.setValueState(V.Warning);n.setValueStateText(this._sValidationDialogFieldMessage);}if(Y){p.setValueState(V.Warning);p.setValueStateText(this._sValidationDialogFieldMessage);}l=false;}else if(X!==V.None||Z!==V.None){l=false;}else{n.setValueState(V.None);n.setValueStateText("");p.setValueState(V.None);p.setValueStateText("");}}if((n.getVisible()&&n.getValueState&&n.getValueState()!==V.None)||(p.getVisible()&&p.getValueState&&p.getValueState()!==V.None)){l=false;}return l;};
W.prototype._getFormatedConditionText=function(j,l,n,p,w,X){var Y=W.getFormatedConditionText(j,l,n,p);if(!Y){switch(j){case P.Initial:Y="=''";break;case P.NotEmpty:Y="!''";break;case P.Ascending:Y="ascending";break;case P.GroupAscending:Y="ascending";Y+=" showIfGrouped:"+X;break;case P.Descending:Y="descending";break;case P.GroupDescending:Y="descending";Y+=" showIfGrouped:"+X;break;case P.Total:Y="total";break;case P.Average:Y="average";break;case P.Minimum:Y="minimum";break;case P.Maximum:Y="maximum";break;}if(p&&Y!==""){Y="!("+Y+")";}}if(this._aKeyFields&&this._aKeyFields.length>1){var Z=null;for(var i=0;i<this._aKeyFields.length;i++){var $=this._aKeyFields[i];if(typeof $!=="string"){if($.key===w&&$.text){Z=$.text;}}}if(Z&&Y!==""){Y=Z+": "+Y;}}return Y;};
W._oConditionMap={"EQ":"=$0","GT":">$0","GE":">=$0","LT":"<$0","LE":"<=$0","Contains":"*$0*","StartsWith":"$0*","EndsWith":"*$0","BT":"$0...$1","Empty":"<$r>"};(function(){var _=sap.ui.getCore().getLibraryResourceBundle("sap.m");W._oConditionMap[P.Empty]=W._oConditionMap[P.Empty].replace("$r",_.getText("CONDITIONPANEL_OPTIONEmpty"));})();
W._templateReplace=function(i,j){return i.replace(/\$\d/g,function(l){return j[parseInt(l.substr(1))];});};
W.getFormatedConditionText=function(i,j,l,n){var p="";switch(i){case P.Empty:p=W._templateReplace(W._oConditionMap[i],[]);break;case P.EQ:case P.GT:case P.GE:case P.LT:case P.LE:case P.Contains:case P.StartsWith:case P.EndsWith:if(j!==""&&j!==undefined&&j!==null){p=W._templateReplace(W._oConditionMap[i],[j]);}break;case P.BT:if(j!==""&&j!==undefined&&j!==null){if(l!==""&&l!==undefined&&l!==null){p=W._templateReplace(W._oConditionMap[i],[j,l]);}}break;default:break;}if(n&&p!==""){p="!("+p+")";}return p;};
W.prototype._updateLayout=function(j){if(!this._oConditionsGrid){return;}var l=this._oConditionsGrid.getContent();var n=this._aConditionsFields.length;var p=n;if(j.name==="Tablet"){p=5;}if(j.name==="Phone"){p=3;}if(this._sConditionType==="Filter"){for(var i=0;i<l.length;i++){var w=l[i];w.ButtonContainer.removeStyleClass("floatRight");w.removeContent(w.ButtonContainer);w.insertContent(w.ButtonContainer,p);if(!this.getAlwaysShowAddIcon()){if(p!==n){w.ButtonContainer.removeContent(w.add);w.addContent(w.add);}else{w.removeContent(w.add);w.ButtonContainer.addContent(w.add);}}}}};
W.prototype._onGridResize=function(){var w;if(this._oPaginatorToolbar&&this._oConditionsGrid&&this._oConditionsGrid.getContent().length>0){var i=this._oConditionsGrid.getContent()[0];if(i.remove&&i.remove.$().position()){w=0;if(this._oPaginatorToolbar.getParent()&&this._oPaginatorToolbar.getParent().getExpandable&&this._oPaginatorToolbar.getParent().getExpandable()){w=48-4;}var j=i.remove.$().position().left-w+i.remove.$().width();this._oPaginatorToolbar.setWidth(j+"px");}}var l=this._oConditionsGrid.getDomRef();if(!l){return;}if(!Q(l).is(":visible")){return;}w=l.clientWidth;var n={};if(w<=this._iBreakPointTablet){n.name="Phone";}else if((w>this._iBreakPointTablet)&&(w<=this._iBreakPointDesktop)){n.name="Tablet";}else{n.name="Desktop";}if(n.name==="Phone"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}if(n.name==="Tablet"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}if(n.name==="Desktop"&&this._sLayoutMode!==n.name){this._updateLayout(n);this._sLayoutMode=n.name;}};
W.prototype._findConfig=function(i,j){if(typeof i==="object"){i=i.getMetadata().getName();}var l;while(i&&!(l=this._getConfig(i,j))){i=this._getParentType(i);}return l;};
W.prototype._getConfig=function(i,j){var l=this._mOpsForType[i];if(l){return l[j];}};
W.prototype._getParentType=function(i){return this._mTypes[i];};
W.prototype._mTypes={"base":undefined,"string":"base","numeric":"base","date":"base","time":"base","boolean":"base","int":"numeric","float":"numeric","sap.ui.model.type.Boolean":"boolean","sap.ui.model.type.Date":"date","sap.ui.model.type.FileSize":"string","sap.ui.model.type.Float":"float","sap.ui.model.type.Integer":"int","sap.ui.model.type.String":"string","sap.ui.model.type.Time":"time","sap.ui.comp.odata.type.StringDate":"date","sap.ui.model.odata.type.Boolean":"boolean","sap.ui.model.odata.type.Byte":"int","sap.ui.model.odata.type.Date":"date","sap.ui.model.odata.type.DateTime":"datetime","sap.ui.model.odata.type.DateTimeOffset":"datetime","sap.ui.model.odata.type.Decimal":"float","sap.ui.model.odata.type.Double":"float","sap.ui.model.odata.type.Single":"float","sap.ui.model.odata.type.Guid":"string","sap.ui.model.odata.type.Int16":"int","sap.ui.model.odata.type.Int32":"int","sap.ui.model.odata.type.Int64":"int","sap.ui.model.odata.type.Raw":"string","sap.ui.model.odata.type.SByte":"int","sap.ui.model.odata.type.String":"string","sap.ui.model.odata.type.Time":"time","sap.ui.model.odata.type.TimeOfDay":"time","Edm.Boolean":"sap.ui.model.odata.type.Boolean","Edm.Byte":"sap.ui.model.odata.type.Byte","Edm.Date":"sap.ui.model.odata.type.Date","Edm.DateTime":"sap.ui.model.odata.type.DateTime","Edm.DateTimeOffset":"sap.ui.model.odata.type.DateTimeOffset","Edm.Decimal":"sap.ui.model.odata.type.Decimal","Edm.Double":"sap.ui.model.odata.type.Double","Edm.Single":"sap.ui.model.odata.type.Single","Edm.Guid":"sap.ui.model.odata.type.Guid","Edm.Int16":"sap.ui.model.odata.type.Int16","Edm.Int32":"sap.ui.model.odata.type.Int32","Edm.Int64":"sap.ui.model.odata.type.Int64","Edm.SByte":"sap.ui.model.odata.type.SByte","Edm.String":"sap.ui.model.odata.type.String","Edm.Time":"sap.ui.model.odata.type.Time","Edm.TimeOfDay":"sap.ui.model.odata.type.TimeOfDay"};W.prototype._mOpsForType={"base":{ctrl:"input"},"string":{ctrl:"input"},"date":{ctrl:"DatePicker"},"datetime":{ctrl:"DateTimePicker"},"numeric":{ctrl:"input"},"time":{ctrl:"TimePicker"},"boolean":{ctrl:"select"}};return W;});
sap.ui.predefine('sap/m/P13nDialog',['./Dialog','./library','sap/ui/core/EnabledPropagator','./DialogRenderer','sap/ui/core/library','sap/ui/Device','./Bar','./Button','./Title','sap/m/OverflowToolbarLayoutData','sap/ui/base/ManagedObjectObserver',"sap/ui/thirdparty/jquery","sap/base/Log","sap/base/util/isEmptyObject"],function(D,l,E,a,c,b,B,d,T,O,M,q,L,e){"use strict";var f=l.OverflowToolbarPriority;var g=l.ListType;var P=l.P13nPanelType;var h=l.ListMode;var j=c.MessageType;var k=l.ButtonType;var N;var m;var p={apiVersion:2,render:function(r,C){a.render.apply(this,arguments);var i=C._getVisiblePanelID();var o=C.getVisiblePanel();if(i&&o){r.openStart("div",i);r.openEnd();r.renderControl(o);r.close("div");}}};
var n=D.extend("sap.m.P13nDialog",{
metadata:{library:"sap.m",properties:{initialVisiblePanelType:{type:"string",group:"Misc",defaultValue:null},showReset:{type:"boolean",group:"Appearance",defaultValue:false},showResetEnabled:{type:"boolean",group:"Appearance",defaultValue:false},validationExecutor:{type:"object",group:"Misc",defaultValue:null}},aggregations:{panels:{type:"sap.m.P13nPanel",multiple:true,singularName:"panel",bindable:"bindable"}},events:{ok:{},cancel:{},reset:{}}},
renderer:p
});
E.apply(n.prototype,[true]);
n.prototype.init=function(o){this.addStyleClass("sapMP13nDialog");D.prototype.init.apply(this,arguments);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._mValidationListener={};this._createDialog();this._mVisibleNavigationItems={};this._bNavigationControlsPromiseResolved=false;this._oNavigationControlsPromise=this._requestRequiredNavigationControls();this._oObserver=new M(_.bind(this));this._oObserver.observe(this,{properties:["showReset","showResetEnabled"],aggregations:["panels"]});};
n.prototype.setShowResetEnabled=function(i){return this.setProperty("showResetEnabled",i,true);};
n.prototype._createDialog=function(){if(b.system.phone){var t=this;this.setStretch(true);this.setVerticalScrolling(false);this.setHorizontalScrolling(false);this.setCustomHeader(new B(this.getId()+"-phoneHeader",{contentLeft:new d(this.getId()+"-backToList",{visible:false,type:k.Back,press:function(){t._backToList();}}),contentMiddle:new T(this.getId()+"-phoneTitle",{text:this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"),level:"H2"})}));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}else{this.setHorizontalScrolling(false);this.setContentWidth("65rem");this.setContentHeight("40rem");this.setDraggable(true);this.setResizable(true);this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"));this.addButton(this._createOKButton());this.addButton(this._createCancelButton());this.addButton(this._createResetButton());}};
n.prototype._showValidationDialog=function(C,F,v){var w=[];var i=[];this._prepareMessages(F,v,w,i);var t=this;return new Promise(function(r){sap.ui.require(["sap/m/MessageBox"],function(o){var s="";if(i.length){i.forEach(function(u,I,x){s=(x.length>1?"• ":"")+u.messageText+"\n"+s;});o.show(s,{icon:o.Icon.ERROR,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE_ERROR"),actions:[o.Action.CLOSE],styleClass:t.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}else if(w.length){w.forEach(function(u,I,x){s=(x.length>1?"• ":"")+u.messageText+"\n"+s;});s=s+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE_QUESTION");o.show(s,{icon:o.Icon.WARNING,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE"),actions:[sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_FIX"),o.Action.IGNORE],onClose:function(A){if(A===o.Action.IGNORE){C();}},styleClass:t.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""});}r();});});};
n.prototype._prepareMessages=function(F,v,w,o){if(!F.length&&!v.length){return;}F.forEach(function(s){switch(s){case P.filter:v.push({messageType:j.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE")});break;case P.columns:v.push({messageType:j.Warning,messageText:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VISIBLE_ITEMS_THRESHOLD_MESSAGE")});break;default:L.error("Panel type '"+s+"' is not supported jet.");}});var u=v.filter(function(r,I,s){for(var i=++I;i<s.length;i++){if(r.messageText===s[i].messageText){return false;}}return true;});u.forEach(function(i){if(i.messageType===j.Warning){w.push(i);}else if(i.messageType===j.Error){o.push(i);}});};
n.prototype._mapPanelToNavigationItem=function(o){if(!o){return null;}return b.system.phone?new m(o.getId()+"-navItem",{type:g.Navigation,title:o.getTitle()}):new m(o.getId()+"-navItem",{text:o.getTitle()});};
n.prototype._switchPanel=function(o){var i=this._getPanelByNavigationItem(o);this.setVerticalScrolling(i.getVerticalScrolling());if(b.system.phone){var r=this._getNavigationControl();if(r){r.setVisible(false);i.beforeNavigationTo();i.setVisible(true);this.getCustomHeader().getContentMiddle()[0].setText(i.getTitle());this.getCustomHeader().getContentLeft()[0].setVisible(true);}}else{this.getPanels().forEach(function(s){if(s===i){s.beforeNavigationTo();s.setVisible(true);}else{s.setVisible(false);}},this);}this.invalidate();this.rerender();};
n.prototype._backToList=function(){var o=this._getNavigationControl();if(o){o.setVisible(true);var i=this.getVisiblePanel();i.setVisible(false);this._updateDialogTitle();this.getCustomHeader().getContentLeft()[0].setVisible(false);}};
n.prototype.getVisiblePanel=function(){var o=null;this.getPanels().some(function(i){if(i.getVisible()){o=i;return true;}});return o;};
n.prototype._getVisiblePanelID=function(){var o=this.getVisiblePanel();if(o){return this.getId()+"-panel_"+o.getId();}return null;};
n.prototype._getPanelByNavigationItem=function(o){for(var i=0,r=this.getPanels(),s=r.length;i<s;i++){if(this._getNavigationItemByPanel(r[i])===o){return r[i];}}return null;};
n.prototype._getNavigationItemByPanel=function(o){return o?o.data("sapMP13nDialogNavigationItem"):null;};
n.prototype.onAfterRendering=function(){D.prototype.onAfterRendering.apply(this,arguments);var C=q(this.getFocusDomRef()).find(".sapMDialogScrollCont");var i=this._getVisiblePanelID();if(i&&C){var $=q(document.getElementById(i));$.appendTo(q(C));}};
n.prototype._updateDialogTitle=function(){var o=this.getVisiblePanel();var t=this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");if(!this._isNavigationControlExpected()&&o){switch(o.getType()){case P.filter:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_FILTER");break;case P.sort:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_SORT");break;case P.group:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_GROUP");break;case P.columns:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_COLUMNS");break;case P.dimeasure:t=this._oResourceBundle.getText("P13NDIALOG_TITLE_DIMEASURE");break;default:t=o.getTitleLarge()||this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS");}}if(b.system.phone){this.getCustomHeader().getContentMiddle()[0].setText(t);}else{this.setTitle(t);}};
n.prototype._registerValidationListener=function(o,C){if(this.getPanels().indexOf(o)&&C&&this._mValidationListener[o.getType()]===undefined){this._mValidationListener[o.getType()]=C;}};
n.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v&&!e(this._mValidationListener)){var t=this;v(this._getPayloadOfPanels()).then(function(V){var r=t._distributeValidationResult(V);for(var s in t._mValidationListener){var C=t._mValidationListener[s];C(r[s]||[]);}});}};
n.prototype._distributeValidationResult=function(r){var o={};r.forEach(function(R){R.panelTypes.forEach(function(t){if(o[t]===undefined){o[t]=[];}o[t].push({columnKey:R.columnKey,messageType:R.messageType,messageText:R.messageText});});});return o;};
n.prototype._createOKButton=function(){var t=this;return new d(this.getId()+"-ok",{type:k.Emphasized,text:this._oResourceBundle.getText("P13NDIALOG_OK"),layoutData:new O({priority:f.NeverOverflow}),press:function(){t.setBusy(true);var o=t._getPayloadOfPanels();var F=function(){t.setBusy(false);t.fireOk({payload:o});};var i=[];var C=function(){t.getPanels().forEach(function(r){if(i.indexOf(r.getType())>-1){r.onAfterNavigationFrom();}});F();};t.getPanels().forEach(function(r){if(!r.onBeforeNavigationFrom()){i.push(r.getType());}});var v=[];var V=t.getValidationExecutor();if(V){V(o).then(function(v){if(i.length||v.length){t.setBusy(false);t._showValidationDialog(C,i,v);}else{F();}});}else{if(i.length||v.length){t.setBusy(false);t._showValidationDialog(C,i,v);}else{F();}}}});};
n.prototype._createCancelButton=function(){var t=this;return new d(this.getId()+"-cancel",{text:this._oResourceBundle.getText("P13NDIALOG_CANCEL"),layoutData:new O({priority:f.NeverOverflow}),press:function(){t.fireCancel();}});};
n.prototype._createResetButton=function(){var t=this;return new d(this.getId()+"-reset",{text:this._oResourceBundle.getText("P13NDIALOG_RESET"),layoutData:new O({priority:f.NeverOverflow}),visible:this.getShowReset(),enabled:this.getShowResetEnabled(),press:function(){sap.ui.getCore().byId(t.getId()+"-ok").focus();t.setShowResetEnabled(false);var o={};t.getPanels().forEach(function(i){o[i.getType()]=i.getResetPayload();});t.fireReset({payload:o});}});};
n.prototype._getPayloadOfPanels=function(){var o={};this.getPanels().forEach(function(i){o[i.getType()]=i.getOkPayload();});return o;};
n.prototype.exit=function(){D.prototype.exit.apply(this,arguments);this._oObserver.disconnect();this._oObserver=undefined;this._mValidationListener={};this._mVisibleNavigationItems={};this._oNavigationControlsPromise=null;};
n.prototype._isInstanceOf=function(o,s){var C=sap.ui.require(s);return o&&typeof C==='function'&&(o instanceof C);};
function _(C){if(this._isInstanceOf(C.object,"sap/m/P13nDialog")){var i;switch(C.name){case"panels":var o=C.child?[C.child]:C.children;o.forEach(function(r){switch(C.mutation){case"insert":this._mVisibleNavigationItems[r.sId]=r.getVisible();r.setVisible(false);r.beforeNavigationTo();this._oObserver.observe(r,{properties:["title"]});r.setValidationExecutor(q.proxy(this._callValidationExecutor,this));r.setValidationListener(q.proxy(this._registerValidationListener,this));break;case"remove":delete this._mVisibleNavigationItems[r.sId];this._oObserver.unobserve(r);r.setValidationExecutor();r.setValidationListener();break;default:L.error("Mutation '"+C.mutation+"' is not supported jet.");}},this);if(this._bNavigationControlsPromiseResolved){this._updateDialog();}else{this._oNavigationControlsPromise.then(function(){this._updateDialog();}.bind(this));}break;case"showReset":i=this.getButtons();if(i.length>1){i[2].setVisible(C.current);}break;case"showResetEnabled":i=this.getButtons();if(i.length>1){i[2].setEnabled(C.current);i[2].invalidate();}break;default:L.error("The property or aggregation '"+C.name+"' has not been registered.");}}else if(this._isInstanceOf(C.object,"sap/m/P13nPanel")){if(C.name==="title"){var I=this._getNavigationItemByPanel(C.object);if(I){if(b.system.phone){I.setTitle(C.current);}else{I.setText(C.current);}}}}}
n.prototype._isNavigationControlExpected=function(){return this._getCountOfVisibleNavigationItems()>1;};
n.prototype._getCountOfVisibleNavigationItems=function(){var C=0;for(var i in this._mVisibleNavigationItems){C=this._mVisibleNavigationItems[i]?C+1:C;}return C;};
n.prototype._isNavigationControlExists=function(){return b.system.phone?this.getContent().length>0:(!!this.getSubHeader()&&this.getSubHeader().getContentLeft().length>0);};
n.prototype._getNavigationControl=function(){if(!this._isNavigationControlExists()){this._createNavigationControl();}return b.system.phone?this.getContent()[0]:this.getSubHeader().getContentLeft()[0];};
n.prototype._setVisibleOfNavigationControl=function(v){if(!this._isNavigationControlExists()){return;}return b.system.phone?this.getContent()[0].setVisible(v):this.getSubHeader().setVisible(v);};
n.prototype._createNavigationControl=function(){if(b.system.phone){this.addContent(new N(this.getId()+"-navigationItems",{mode:h.None,itemPress:function(o){this._switchPanel(o.getParameter("listItem"));}.bind(this)}));}else{this.setSubHeader(new B(this.getId()+"-navigationBar",{contentLeft:new N(this.getId()+"-navigationItems",{width:'100%',selectionChange:function(o){this._switchPanel(o.getParameter("item"));}.bind(this)})}));}return this._getNavigationControl();};
n.prototype._updateDialog=function(){var o=this._getNavigationControl();o.destroyItems();var i=this._determineInitialVisiblePanel();this.getPanels().forEach(function(r){var s=this._mapPanelToNavigationItem(r);r.data("sapMP13nDialogNavigationItem",s);o.addItem(s);var v=b.system.phone?this._mVisibleNavigationItems[r.sId]&&this._getCountOfVisibleNavigationItems()===1:this._mVisibleNavigationItems[r.sId]&&i===r.sId;r.setVisible(v);if(v){if(!b.system.phone){this.setVerticalScrolling(r.getVerticalScrolling());}}s.setVisible(this._mVisibleNavigationItems[r.sId]);if(v&&o.setSelectedItem){o.setSelectedItem(s);}}.bind(this));this._updateDialogTitle();this._setVisibleOfNavigationControl(this._isNavigationControlExpected());};
n.prototype._determineInitialVisiblePanel=function(){if(this.getInitialVisiblePanelType()){for(var i=0;i<this.getPanels().length;i++){if(this.getPanels()[i].getType()==this.getInitialVisiblePanelType()){return this.getPanels()[i].sId;}}}var I;this.getPanels().some(function(o){if(this._mVisibleNavigationItems[o.sId]){I=o.sId;return true;}}.bind(this));return I;};
n.prototype._requestRequiredNavigationControls=function(){var s=b.system.phone?"sap/m/List":"sap/m/SegmentedButton";var i=b.system.phone?"sap/m/StandardListItem":"sap/m/SegmentedButtonItem";N=sap.ui.require(s);m=sap.ui.require(i);if(N&&m){this._bNavigationControlsPromiseResolved=true;return Promise.resolve();}if(!this._oNavigationControlsPromise){this._oNavigationControlsPromise=new Promise(function(r){sap.ui.require([s,i],function(o,t){N=o;m=t;this._bNavigationControlsPromiseResolved=true;return r();}.bind(this));}.bind(this));}return this._oNavigationControlsPromise;};
return n;});
sap.ui.predefine('sap/m/P13nDimMeasureItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nDimMeasureItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string"},index:{type:"int",defaultValue:-1},visible:{type:"boolean"},role:{type:"string"}}}});
return P;});
sap.ui.predefine('sap/m/P13nDimMeasurePanel',['./library','./P13nPanel','./P13nDimMeasureItem','./SearchField','./Table','./Column','./ColumnListItem','./ScrollContainer','./Text','./Select','./ComboBox','./Button','./OverflowToolbar','./OverflowToolbarLayoutData','./OverflowToolbarButton','./ToolbarSpacer','sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler','sap/ui/core/Item','sap/ui/core/InvisibleText','sap/ui/core/IconPool',"sap/ui/thirdparty/jquery"],function(l,P,c,S,T,C,d,e,f,g,h,B,O,i,j,k,m,n,J,o,R,I,p,q,Q){"use strict";var r=l.OverflowToolbarPriority;var s=l.ButtonType;var t=l.ToolbarDesign;var L=l.ListType;var u=l.ListMode;var v=l.P13nPanelType;
var w=P.extend("sap.m.P13nDimMeasurePanel",{
metadata:{library:"sap.m",properties:{chartTypeKey:{type:"string",defaultValue:""}},aggregations:{dimMeasureItems:{type:"sap.m.P13nDimMeasureItem",multiple:true,singularName:"dimMeasureItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},availableChartTypes:{type:"sap.ui.core.Item",multiple:true,singularName:"availableChartType"}},events:{changeDimMeasureItems:{},changeChartType:{}}},
renderer:{apiVersion:2,render:function(a,b){a.openStart("div",b);a.class("sapMP13nColumnsPanel");a.openEnd();b.getAggregation("content").forEach(function(x){a.renderControl(x);});a.close("div");}}
});
w.prototype.init=function(){var a=this;this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bOnAfterRenderingFirstTimeExecuted=false;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.oAvailableRoleTypes={Dimension:[{key:"category",text:b.getText('COLUMNSPANEL_CHARTROLE_CATEGORY')},{key:"category2",text:b.getText('COLUMNSPANEL_CHARTROLE_CATEGORY2')},{key:"series",text:b.getText('COLUMNSPANEL_CHARTROLE_SERIES')}],Measure:[{key:"axis1",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS1')},{key:"axis2",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS2')},{key:"axis3",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS3')},{key:"axis4",text:b.getText('COLUMNSPANEL_CHARTROLE_AXIS4')}]};var M=new J({availableChartTypes:[],selectedChartTypeKey:null,items:[],columnKeyOfMarkedItem:undefined,isMoveDownButtonEnabled:undefined,isMoveUpButtonEnabled:undefined,showOnlySelectedItems:undefined,countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(o.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nDimMeasurePanel");this.setType(v.dimeasure);this.setTitle(b.getText("CHARTPANEL_TITLE"));this._createTable();this._createToolbar();this.setVerticalScrolling(false);var x=new e({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",x);this._fnHandleResize=function(){var y=false,z,A;if(a.getParent){var $=null,D,H;var E=a.getParent();var F=a._getToolbar();if(E&&E.$){$=E.$("cont");if($.children().length>0&&F.$().length>0){z=x.$()[0].clientHeight;D=$.children()[0].clientHeight;H=F?F.$()[0].clientHeight:0;A=D-H;if(z!==A){x.setHeight(A+'px');y=true;}}}}return y;};this._sContainerResizeListener=R.register(x,this._fnHandleResize);};
w.prototype.onBeforeRendering=function(){this._updateInternalModel();if(!this._getInternalModel().getProperty("/columnKeyOfMarkedItem")){this._setColumnKeyOfMarkedItem(this._getColumnKeyByTableItem(this._getVisibleTableItems()[0]));}this._switchMarkedTableItemTo(this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem")));this._updateControlLogic();};
w.prototype.onAfterRendering=function(){var a=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){a._fnHandleResize();a._getToolbar()._resetAndInvalidateToolbar();},0);}};
w.prototype.getOkPayload=function(){this._updateInternalModel();this._getInternalModel().getProperty("/items").forEach(function(M){if(this._getDimMeasureItemByColumnKey(M.columnKey)){return;}if(!M.persistentSelected){return;}this.addAggregation("dimMeasureItems",new c({columnKey:M.columnKey,visible:M.persistentSelected,index:M.persistentIndex===-1?undefined:M.persistentIndex,role:M.role}));},this);return{dimMeasureItems:this.getDimMeasureItems(),chartTypeKey:this.getChartTypeKey()};};
w.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}if(this.oInvisibleChartTypeText){this.oInvisibleChartTypeText.destroy();this.oInvisibleChartTypeText=null;}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
w.prototype.addItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",a);return this;};
w.prototype.insertItem=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",a,b);return this;};
w.prototype.removeItem=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}a=this.removeAggregation("items",a);return a;};
w.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
w.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
w.prototype.addDimMeasureItem=function(D){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("dimMeasureItems",D);return this;};
w.prototype.insertDimMeasureItem=function(D,a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("dimMeasureItems",D,a);return this;};
w.prototype.updateDimMeasureItems=function(a){this.updateAggregation("dimMeasureItems");if(a===n.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
w.prototype.removeDimMeasureItem=function(D){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("dimMeasureItems",D);};
w.prototype.removeAllDimMeasureItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("dimMeasureItems");};
w.prototype.destroyDimMeasureItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("dimMeasureItems");return this;};
w.prototype.setChartTypeKey=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.setProperty("chartTypeKey",a);return this;};
w.prototype.addAvailableChartType=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("availableChartTypes",a);return this;};
w.prototype.insertAvailableChartType=function(a,b){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("availableChartTypes",a,b);return this;};
w.prototype.removeAvailableChartType=function(a){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("availableChartTypes",a);};
w.prototype.removeAllAvailableChartType=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("availableChartTypes");};
w.prototype.destroyAvailableChartType=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("availableChartTypes");return this;};
w.prototype._notifyChange=function(){var a=this.getChangeNotifier();if(a){a(this);}};
w.prototype._scrollToSelectedItem=function(a){if(!a){return;}sap.ui.getCore().applyChanges();if(!!a.getDomRef()){a.focus();}};
w.prototype._getInternalModel=function(){return this.getModel("$sapmP13nDimMeasurePanel");};
w.prototype._createTable=function(){var a=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T({mode:u.MultiSelect,rememberSelections:false,itemPress:Q.proxy(this._onItemPressed,this),selectionChange:Q.proxy(this._onSelectionChange,this),columns:[new C({vAlign:m.VerticalAlign.Middle,header:new f({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(b,x){return a.getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[b,x]);}}})}),new C({vAlign:m.VerticalAlign.Middle,header:new f({text:a.getText('COLUMNSPANEL_COLUMN_TYPE')})}),new C({vAlign:m.VerticalAlign.Middle,header:new f({text:a.getText('COLUMNSPANEL_COLUMN_ROLE')})})],items:{path:"/items",templateShareable:false,template:new d({cells:[new f({text:"{text}"}),new f({text:{path:'',formatter:function(M){if(M.aggregationRole==="Dimension"){return a.getText('COLUMNSPANEL_TYPE_DIMENSION');}if(M.aggregationRole==="Measure"){return a.getText('COLUMNSPANEL_TYPE_MEASURE');}}}}),new g({selectedKey:"{role}",items:{path:'availableRoleTypes',factory:function(b,x){var A=x.getObject();return new I({key:A.key,text:A.text});}},change:Q.proxy(this._onRoleChange,this)})],visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:L.Active})}});this._oTable.setModel(this._getInternalModel());};
w.prototype._createToolbar=function(){var a=this;var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var x=new p({text:b.getText('COLUMNSPANEL_CHARTTYPE')});this.oInvisibleChartTypeText=x;var y=new h({placeholder:x.getText(),selectedKey:{path:'/selectedChartTypeKey'},ariaLabelledBy:x,items:{path:'/availableChartTypes',templateShareable:false,template:new I({key:"{key}",text:"{text}"})},selectionChange:Q.proxy(this._onChartTypeChange,this),layoutData:new i({moveToOverflow:false,stayInOverflow:false})});var z=new O(this.getId()+"-toolbar",{design:t.Auto,content:[x,y,new k(),new S(this.getId()+"-searchField",{liveChange:function(E){var V=E.getSource().getValue(),D=(V?300:0);window.clearTimeout(a._iSearchTimer);if(D){a._iSearchTimer=window.setTimeout(function(){a._onExecuteSearch();},D);}else{a._onExecuteSearch();}},search:Q.proxy(this._onExecuteSearch,this),layoutData:new i({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})}),new B({text:{path:'/showOnlySelectedItems',formatter:function(A){return A?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},tooltip:{path:'/showOnlySelectedItems',formatter:function(A){return A?b.getText('COLUMNSPANEL_SHOW_ALL'):b.getText('COLUMNSPANEL_SHOW_SELECTED');}},type:s.Transparent,press:Q.proxy(this._onSwitchButtonShowSelected,this),layoutData:new i({moveToOverflow:true,priority:r.High})}),new j({icon:q.getIconURI("collapse-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_TOP'),type:s.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:Q.proxy(this.onPressButtonMoveToTop,this),layoutData:new i({moveToOverflow:true,priority:r.Low,group:2})}),new j({icon:q.getIconURI("slim-arrow-up"),text:b.getText('COLUMNSPANEL_MOVE_UP'),tooltip:b.getText('COLUMNSPANEL_MOVE_UP'),type:s.Transparent,enabled:{path:'/isMoveUpButtonEnabled'},press:Q.proxy(this.onPressButtonMoveUp,this),layoutData:new i({moveToOverflow:true,priority:r.High,group:1})}),new j({icon:q.getIconURI("slim-arrow-down"),text:b.getText('COLUMNSPANEL_MOVE_DOWN'),tooltip:b.getText('COLUMNSPANEL_MOVE_DOWN'),type:s.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:Q.proxy(this.onPressButtonMoveDown,this),layoutData:new i({moveToOverflow:true,priority:r.High,group:1})}),new j({icon:q.getIconURI("expand-group"),text:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),tooltip:b.getText('COLUMNSPANEL_MOVE_TO_BOTTOM'),type:s.Transparent,enabled:{path:'/isMoveDownButtonEnabled'},press:Q.proxy(this.onPressButtonMoveToBottom,this),layoutData:new i({moveToOverflow:true,priority:r.Low,group:2})})]});z.setModel(this._getInternalModel());this.addAggregation("content",z);};
w.prototype.onPressButtonMoveToTop=function(){this._moveMarkedTableItem(this._getMarkedTableItem(),this._getVisibleTableItems()[0]);};
w.prototype.onPressButtonMoveUp=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.indexOf(this._getMarkedTableItem())-1]);};
w.prototype.onPressButtonMoveDown=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.indexOf(this._getMarkedTableItem())+1]);};
w.prototype.onPressButtonMoveToBottom=function(){var V=this._getVisibleTableItems();this._moveMarkedTableItem(this._getMarkedTableItem(),V[V.length-1]);};
w.prototype._onSwitchButtonShowSelected=function(){this._getInternalModel().setProperty("/showOnlySelectedItems",!this._getInternalModel().getProperty("/showOnlySelectedItems"));this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fnHandleResize();};
w.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
w.prototype._switchVisibilityOfUnselectedModelItems=function(){var b=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(a){if(a.persistentSelected){a.visible=true;return;}a.visible=!b;});this._getInternalModel().setProperty("/items",M);};
w.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
w.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
w.prototype._moveMarkedTableItem=function(a,b){var M=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(a));var x=this._getModelItemByColumnKey(this._getColumnKeyByTableItem(b));var y=this._getModelItemIndexByColumnKey(M.columnKey);var z=this._getModelItemIndexByColumnKey(x.columnKey);this._moveModelItems(y,z);this._scrollToSelectedItem(this._getMarkedTableItem());this._updateControlLogic();this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._moveModelItems=function(a,b){var M=this._getInternalModel().getProperty("/items");if(a<0||b<0||a>M.length-1||b>M.length-1){return false;}this._removeStyleOfMarkedTableItem();var x=M.splice(a,1);M.splice(b,0,x[0]);this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());return true;};
w.prototype._getModelItemByColumnKey=function(a){var M=this._getInternalModel().getProperty("/items").filter(function(b){return b.columnKey===a;});return M[0];};
w.prototype._updateCounts=function(M){var a=0;var b=0;M.forEach(function(x){a++;if(x.persistentSelected){b++;}});this._getInternalModel().setProperty("/countOfItems",a);this._getInternalModel().setProperty("/countOfSelectedItems",b);};
w.prototype._sortModelItemsByPersistentIndex=function(M){var x;var y=sap.ui.getCore().getConfiguration().getLocale().toString();try{if(typeof window.Intl!=='undefined'){x=window.Intl.Collator(y,{numeric:true});}}catch(E){}M.forEach(function(a,b){a.localIndex=b;});M.sort(function(a,b){if(a.persistentSelected===true&&(b.persistentSelected===false||b.persistentSelected===undefined)){return-1;}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&b.persistentSelected===true){return 1;}else if(a.persistentSelected===true&&b.persistentSelected===true){if(a.persistentIndex>-1&&a.persistentIndex<b.persistentIndex){return-1;}else if(b.persistentIndex>-1&&a.persistentIndex>b.persistentIndex){return 1;}else{return a.localIndex-b.localIndex;}}else if((a.persistentSelected===false||a.persistentSelected===undefined)&&(b.persistentSelected===false||b.persistentSelected===undefined)){return x?x.compare(a.text,b.text):a.text.localeCompare(b.text,y,{numeric:true});}});M.forEach(function(a){delete a.localIndex;});};
w.prototype._getColumnKeyByTableItem=function(a){var b=this._oTable.indexOfItem(a);if(b<0){return null;}return this._oTable.getBinding("items").getContexts()[b].getObject().columnKey;};
w.prototype._getModelItemIndexByColumnKey=function(a){var b=-1;this._getInternalModel().getData().items.some(function(M,x){if(M.columnKey===a){b=x;return true;}});return b;};
w.prototype._getSelectedModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return M.persistentSelected;});};
w.prototype._getVisibleTableItems=function(){return this._oTable.getItems().filter(function(a){return a.getVisible();});};
w.prototype._getTableItemByColumnKey=function(a){var b=this._oTable.getBinding("items").getContexts();var x=this._oTable.getItems().filter(function(y,z){return b[z].getObject().columnKey===a;});return x[0];};
w.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
w.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
w.prototype._getSearchText=function(){var a=this._getSearchField();return a?a.getValue():"";};
w.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
w.prototype._isFilteredByShowSelected=function(){return this._getInternalModel().getData().showOnlySelectedItems;};
w.prototype._updateControlLogic=function(){var b=this._isFilteredBySearchText();var a=this._isFilteredByShowSelected();var V=this._getVisibleTableItems();this._getInternalModel().setProperty("/isMoveUpButtonEnabled",V.indexOf(this._getMarkedTableItem())>0);this._getInternalModel().setProperty("/isMoveDownButtonEnabled",V.indexOf(this._getMarkedTableItem())>-1&&V.indexOf(this._getMarkedTableItem())<V.length-1);var x=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(x){x.setEnabled(!b&&!a);}};
w.prototype._updateModelItemsPersistentIndex=function(M){var a=-1;M.forEach(function(b){b.persistentIndex=-1;if(b.persistentSelected){a++;b.persistentIndex=a;}});};
w.prototype._fireChangeDimMeasureItems=function(){this._bIgnoreUpdateInternalModel=true;this.fireChangeDimMeasureItems({items:this._getInternalModel().getProperty("/items").map(function(M){return{columnKey:M.columnKey,visible:M.persistentSelected,index:M.persistentIndex===-1?undefined:M.persistentIndex,role:M.role};})});this._bIgnoreUpdateInternalModel=false;};
w.prototype._fireChangeChartType=function(){this._bIgnoreUpdateInternalModel=true;this.fireChangeChartType({chartTypeKey:this._getInternalModel().getProperty("/selectedChartTypeKey")});this._bIgnoreUpdateInternalModel=false;};
w.prototype._getDimMeasureItemByColumnKey=function(a){var D=this.getDimMeasureItems().filter(function(b){return b.getColumnKey()===a;});return D[0];};
w.prototype._getMarkedTableItem=function(){return this._getTableItemByColumnKey(this._getInternalModel().getProperty("/columnKeyOfMarkedItem"));};
w.prototype._setColumnKeyOfMarkedItem=function(a){this._getInternalModel().setProperty("/columnKeyOfMarkedItem",a);};
w.prototype._onItemPressed=function(E){this._switchMarkedTableItemTo(E.getParameter('listItem'));this._updateControlLogic();};
w.prototype._onChartTypeChange=function(E){this._fireChangeChartType();this._notifyChange();};
w.prototype._onRoleChange=function(E){this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._onSelectionChange=function(E){if(!E.getParameter("selectAll")&&E.getParameter("listItems").length===1){this._switchMarkedTableItemTo(E.getParameter("listItem"));}this._selectTableItem();};
w.prototype._selectTableItem=function(){this._updateControlLogic();var M=this._getInternalModel().getProperty("/items");this._updateModelItemsPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeDimMeasureItems();this._notifyChange();};
w.prototype._switchMarkedTableItemTo=function(a){this._removeStyleOfMarkedTableItem();var b=this._getColumnKeyByTableItem(a);if(b){this._setColumnKeyOfMarkedItem(b);a.addStyleClass("sapMP13nColumnsPanelItemSelected");}};
w.prototype._removeStyleOfMarkedTableItem=function(){if(this._getMarkedTableItem()){this._getMarkedTableItem().removeStyleClass("sapMP13nColumnsPanelItemSelected");}};
w.prototype._filterModelItemsBySearchText=function(){var a=this._getSearchText();a=a.replace(/(^\s+)|(\s+$)/g,'');a=a.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var b=new RegExp(a,'igm');if(!b){return;}this._getVisibleModelItems().forEach(function(M){var x=this._getTableItemByColumnKey(M.columnKey);var y=x.getCells();M.visible=false;if(y[0]&&y[0].getText().match(b)){M.visible=true;}if(y[1]&&y[1].getText().match(b)){M.visible=true;}if(y[2]&&y[2].getSelectedItem()&&y[2].getSelectedItem().getText().match(b)){M.visible=true;}if(M.tooltip&&M.tooltip.match(b)){M.visible=true;}},this);this._getInternalModel().refresh();};
w.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._removeStyleOfMarkedTableItem();this._getInternalModel().setProperty("/items",this.getItems().map(function(a){return{columnKey:a.getColumnKey(),visible:true,text:a.getText(),tooltip:a.getTooltip(),aggregationRole:a.getAggregationRole(),availableRoleTypes:this.oAvailableRoleTypes[a.getAggregationRole()],role:a.getRole(),persistentIndex:-1,persistentSelected:undefined};},this));this._getInternalModel().setProperty("/selectedChartTypeKey",this.getChartTypeKey());this._getInternalModel().setProperty("/availableChartTypes",this.getAvailableChartTypes().map(function(a){return{key:a.getKey(),text:a.getText()};},this));this.getDimMeasureItems().forEach(function(D){var a=this._getModelItemByColumnKey(D.getColumnKey());if(!a){return;}if(D.getIndex()!==undefined){a.persistentIndex=D.getIndex();}if(D.getVisible()!==undefined){a.persistentSelected=D.getVisible();}if(D.getRole()!==undefined){a.role=D.getRole();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var M=this._getInternalModel().getProperty("/items");this._sortModelItemsByPersistentIndex(M);this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._switchMarkedTableItemTo(this._getMarkedTableItem());};
return w;});
sap.ui.predefine('sap/m/P13nFilterItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nFilterItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},value1:{type:"string",group:"Misc",defaultValue:null},value2:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},exclude:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setOperation=function(o){return this.setProperty("operation",o,true);};
P.prototype.setColumnKey=function(k){return this.setProperty("columnKey",k,true);};
P.prototype.setValue1=function(v){return this.setProperty("value1",v,true);};
P.prototype.setValue2=function(v){return this.setProperty("value2",v,true);};
P.prototype.setExclude=function(e){return this.setProperty("exclude",e,true);};
return P;});
sap.ui.predefine('sap/m/P13nFilterPanel',['./P13nConditionPanel','./P13nPanel','./library','sap/m/Panel','./P13nFilterItem','./P13nOperationsHelper'],function(P,a,l,b,c,d){"use strict";var e=l.P13nPanelType;var f=l.P13nConditionOperation;
var g=a.extend("sap.m.P13nFilterPanel",{
metadata:{library:"sap.m",properties:{maxIncludes:{type:"string",group:"Misc",defaultValue:'-1'},maxExcludes:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null},enableEmptyOperations:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},filterItems:{type:"sap.m.P13nFilterItem",multiple:true,singularName:"filterItem",bindable:"bindable"},messageStrip:{type:"sap.m.MessageStrip",multiple:false}},events:{addFilterItem:{},removeFilterItem:{},updateFilterItem:{},filterItemChanged:{parameters:{reason:{type:"string"},key:{type:"string"},index:{type:"int"},itemData:{type:"object"}}}}},
renderer:{apiVersion:2,render:function(r,C){r.openStart("section",C);r.class("sapMFilterPanel");r.openEnd();r.openStart("div");r.class("sapMFilterPanelContent");r.class("sapMFilterPanelBG");r.openEnd();C.getAggregation("content").forEach(function(o){r.renderControl(o);});r.close("div");r.close("section");}}
});
g.prototype.setConditions=function(C){var I=[];var E=[];if(C.length){for(var i=0;i<C.length;i++){var o=C[i];if(!o.exclude){I.push(o);}else{E.push(o);}}}this._oIncludeFilterPanel.setConditions(I);this._oExcludeFilterPanel.setConditions(E);if(E.length>0){this._oExcludePanel.setExpanded(true);}return this;};
g.prototype.getConditions=function(){var i=this._oIncludeFilterPanel.getConditions();var E=this._oExcludeFilterPanel.getConditions();return i.concat(E);};
g.prototype.setContainerQuery=function(C){this.setProperty("containerQuery",C);this._oIncludeFilterPanel.setContainerQuery(C);this._oExcludeFilterPanel.setContainerQuery(C);return this;};
g.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oIncludeFilterPanel.setLayoutMode(m);this._oExcludeFilterPanel.setLayoutMode(m);return this;};
g.prototype.validateConditions=function(){return this._oIncludeFilterPanel.validateConditions()&&this._oExcludeFilterPanel.validateConditions();};
g.prototype.removeInvalidConditions=function(){this._oIncludeFilterPanel.removeInvalidConditions();this._oExcludeFilterPanel.removeInvalidConditions();};
g.prototype.removeValidationErrors=function(){this._oIncludeFilterPanel.removeValidationErrors();this._oExcludeFilterPanel.removeValidationErrors();};
g.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
g.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
g.prototype.setIncludeOperations=function(o,t){t=t||"default";this._aIncludeOperations[t]=o;if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}};
g.prototype.getIncludeOperations=function(t){if(this._oIncludeFilterPanel){return this._oIncludeFilterPanel.getOperations(t);}};
g.prototype.setExcludeOperations=function(o,t){t=t||"default";this._aExcludeOperations[t]=o;if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}};
g.prototype.getExcludeOperations=function(t){if(this._oExcludeFilterPanel){return this._oExcludeFilterPanel.getOperations(t);}};
g.prototype.setKeyFields=function(k,K){this._aKeyFields=k;if(this._oIncludeFilterPanel){k.some(function(o){if(o.isDefault){this._oIncludeFilterPanel.setAutoAddNewRow(true);}}.bind(this));this._oIncludeFilterPanel.setKeyFields(k);}if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setKeyFields((Array.isArray(K)&&K.length>0)?K:k);}};
g.prototype.getKeyFields=function(){return this._aKeyFields;};
g.prototype.setMaxIncludes=function(m){this.setProperty("maxIncludes",m);if(this._oIncludeFilterPanel){this._oIncludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
g.prototype.setMaxExcludes=function(m){this.setProperty("maxExcludes",m);if(this._oExcludeFilterPanel){this._oExcludeFilterPanel.setMaxConditions(m);}this._updatePanel();return this;};
g.prototype._updatePanel=function(){var m=this.getMaxIncludes()==="-1"?1000:parseInt(this.getMaxIncludes());var M=this.getMaxExcludes()==="-1"?1000:parseInt(this.getMaxExcludes());if(m>0){if(M<=0){this._oIncludePanel.setHeaderText(null);this._oIncludePanel.setExpandable(false);this._oIncludePanel.addStyleClass("panelTopMargin");this._oIncludePanel.addStyleClass("panelNoHeader");}}if(M===0){this._oExcludePanel.setHeaderText(null);this._oExcludePanel.setExpandable(false);this._oExcludePanel.addStyleClass("panelNoHeader");}};
g.prototype.init=function(){this.setType(e.filter);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("FILTERPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");this._aKeyFields=[];this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aIncludeOperations={};this._aExcludeOperations={};this._oIncludePanel=new b({expanded:true,expandable:true,headerText:this._oRb.getText("FILTERPANEL_INCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oIncludeFilterPanel=new P({maxConditions:this.getMaxIncludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oIncludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";this._oIncludePanel.addContent(this._oIncludeFilterPanel);this.addAggregation("content",this._oIncludePanel);this._oExcludePanel=new b({expanded:false,expandable:true,headerText:this._oRb.getText("FILTERPANEL_EXCLUDES"),width:"auto"}).addStyleClass("sapMFilterPadding");this._oExcludeFilterPanel=new P({exclude:true,maxConditions:this.getMaxExcludes(),alwaysShowAddIcon:false,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oExcludeFilterPanel._sAddRemoveIconTooltipKey="FILTER";if(!this._oOperationsHelper){this._oOperationsHelper=new d();}this._updateOperations();var t;for(t in this._aExcludeOperations){this._oExcludeFilterPanel.setOperations(this._aExcludeOperations[t],t);}for(t in this._aIncludeOperations){this._oIncludeFilterPanel.setOperations(this._aIncludeOperations[t],t);}this._oExcludePanel.addContent(this._oExcludeFilterPanel);this.addAggregation("content",this._oExcludePanel);this._updatePanel();};
g.prototype.exit=function(){var h=function(o){if(o&&o.destroy){o.destroy();}return null;};this._oOperationsHelper=h(this._oOperationsHelper);this._aKeyFields=h(this._aKeyFields);this._aIncludeOperations=h(this._aIncludeOperations);this._aExcludeOperations=h(this._aExcludeOperations);this._oRb=h(this._oRb);};
g.prototype.onBeforeRendering=function(){var k=[],K,m,E=this.getEnableEmptyOperations();if(this._bUpdateRequired){this._bUpdateRequired=false;var M=this.getMessageStrip();if(M){M.addStyleClass("sapUiResponsiveMargin");this.insertAggregation("content",M,0);}K=[];m=(this.getBindingInfo("items")||{}).model;var G=function(n,o,i){var B=i.getBinding(n),h;if(B&&o){return o.getObject()[B.getPath()];}h=i.getMetadata();return h.hasProperty(n)?h.getProperty(n).get(i):h.getAggregation(n).get(i);};this.getItems().forEach(function(i){var o=i.getBindingContext(m),F,n,h;if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}K.push(F={key:i.getColumnKey(),text:G("text",o,i),tooltip:G("tooltip",o,i),maxLength:G("maxLength",o,i),type:G("type",o,i),typeInstance:G("typeInstance",o,i),formatSettings:G("formatSettings",o,i),precision:G("precision",o,i),scale:G("scale",o,i),isDefault:G("isDefault",o,i),values:G("values",o,i)});if(E){n=i.getNullable();h={};Object.keys(F).forEach(function(s){h[s]=F[s];});k.push(h);this._enhanceFieldOperationsWithEmpty(h,n,true);this._enhanceFieldOperationsWithEmpty(F,n);this._modifyFieldOperationsBasedOnMaxLength(h);}this._modifyFieldOperationsBasedOnMaxLength(F);},this);this.setKeyFields(K,k);var C=[];m=(this.getBindingInfo("filterItems")||{}).model;this.getFilterItems().forEach(function(F){var o=F.getBindingContext(m);if(F.getBinding("key")&&o){o.getObject()[F.getBinding("key").getPath()]=F.getKey();}C.push({key:F.getKey(),keyField:G("columnKey",o,F),operation:G("operation",o,F),value1:G("value1",o,F),value2:G("value2",o,F),exclude:G("exclude",o,F)});});this.setConditions(C);}};
g.prototype._updateOperations=function(){this._oOperationsHelper.getIncludeTypes().forEach(function(t){this.setIncludeOperations(this._oOperationsHelper.getIncludeOperationsByType(t),t);}.bind(this));this._oOperationsHelper.getExcludeTypes().forEach(function(t){this.setExcludeOperations(this._oOperationsHelper.getExcludeOperationsByType(t),t);}.bind(this));};
g.prototype._enableEnhancedExcludeOperations=function(){if(this._oOperationsHelper){this._oOperationsHelper.setUseExcludeOperationsExtended();}this._updateOperations();};
g.prototype._modifyFieldOperationsBasedOnMaxLength=function(F){var o;if(F.maxLength===1||F.maxLength==="1"){o=F.operations?F.operations:this._oIncludeFilterPanel.getOperations(F.type);F.operations=[];o.forEach(function(O){if([f.Contains,f.StartsWith,f.EndsWith].indexOf(O)===-1){F.operations.push(O);}},this);}};
g.prototype._enhanceFieldOperationsWithEmpty=function(F,n,E){var o,O;if(["string","stringdate"].indexOf(F.type)>-1||(["date","datetime"].indexOf(F.type)>-1&&n)){o=this[E?"_oExcludeFilterPanel":"_oIncludeFilterPanel"];O=o.getOperations(F.type);if(!O){O=o.getOperations();}if(!Array.isArray(F.operations)){F.operations=[];}O.forEach(function(s){F.operations.push(s);});if(F.operations.indexOf(f.Empty)===-1){F.operations.push(f.Empty);}}};
g.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
g.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);this._bUpdateRequired=true;return r;};
g.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
g.prototype.addFilterItem=function(F){this.addAggregation("filterItems",F,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
g.prototype.insertFilterItem=function(F,i){this.insertAggregation("filterItems",F,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
g.prototype.updateFilterItems=function(r){this.updateAggregation("filterItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
g.prototype.setMessageStrip=function(m){this.setAggregation("messageStrip",m,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
g.prototype.updateMessageStrip=function(r){this.updateAggregation("messageStrip");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;}};
g.prototype.removeFilterItem=function(F){F=this.removeAggregation("filterItems",F,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return F;};
g.prototype.removeAllFilterItems=function(){var F=this.removeAllAggregation("filterItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return F;};
g.prototype.destroyFilterItems=function(){this.destroyAggregation("filterItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
g.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var C=E.getParameter("index");var F;var I=-1;var h=E.getSource()===t._oExcludeFilterPanel;t.getFilterItems().some(function(j,i){if((!j.getExclude()&&!h)||(j.getExclude()&&h)){C--;}I=i;return C<0;},this);switch(o){case"update":F=t.getFilterItems()[I];if(F){F.setExclude(n.exclude);F.setColumnKey(n.keyField);F.setOperation(n.operation);F.setValue1(n.value1);F.setValue2(n.value2);}t.fireUpdateFilterItem({key:k,index:I,filterItemData:F});t.fireFilterItemChanged({reason:"updated",key:k,index:I,itemData:{columnKey:n.keyField,operation:n.operation,exclude:n.exclude,value1:n.value1,value2:n.value2}});break;case"add":if(C>=0){I++;}F=new c({columnKey:n.keyField,exclude:n.exclude,operation:n.operation});F.setValue1(n.value1);F.setValue2(n.value2);t._bIgnoreBindCalls=true;t.fireAddFilterItem({key:k,index:I,filterItemData:F});t.fireFilterItemChanged({reason:"added",key:k,index:I,itemData:{columnKey:n.keyField,operation:n.operation,exclude:n.exclude,value1:n.value1,value2:n.value2}});t._bIgnoreBindCalls=false;break;case"remove":t._bIgnoreBindCalls=true;t.fireRemoveFilterItem({key:k,index:I});t.fireFilterItemChanged({reason:"removed",key:k,index:I});t._bIgnoreBindCalls=false;break;default:throw"Operation'"+o+"' is not supported yet";}t._notifyChange();};};
g.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return g;});
sap.ui.predefine('sap/m/P13nGroupItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nGroupItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null},showIfGrouped:{type:"boolean",group:"Misc",defaultValue:false}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
P.prototype.setShowIfGrouped=function(v){return this.setProperty("showIfGrouped",v,true);};
return P;});
sap.ui.predefine('sap/m/P13nGroupPanel',['./library','./P13nConditionPanel','./P13nPanel','./P13nGroupItem',"sap/ui/thirdparty/jquery"],function(l,P,a,c,q){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nGroupPanel",{
metadata:{library:"sap.m",properties:{maxGroups:{type:"string",group:"Misc",defaultValue:'-1'},containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},groupItems:{type:"sap.m.P13nGroupItem",multiple:true,singularName:"groupItem",bindable:"bindable"}},events:{addGroupItem:{parameters:{}},removeGroupItem:{},updateGroupItem:{}}},
renderer:{apiVersion:2,render:function(r,C){r.openStart("section",C);r.class("sapMGroupPanel");r.openEnd();r.openStart("div");r.class("sapMGroupPanelContent");r.class("sapMGroupPanelBG");r.openEnd();C.getAggregation("content").forEach(function(o){r.renderControl(o);});r.close("div");r.close("section");}}
});
f.prototype.setMaxGroups=function(m){this.setProperty("maxGroups",m);if(this._oGroupPanel){this._oGroupPanel.setMaxConditions(m);}return this;};
f.prototype._getConditions=function(){return this._oGroupPanel.getConditions();};
f.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oGroupPanel.setContainerQuery(b);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oGroupPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oGroupPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oGroupPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oGroupPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setOperations=function(o){this._aOperations=o;if(this._oGroupPanel){this._oGroupPanel.setOperations(this._aOperations);}};
f.prototype.init=function(){this.setType(d.group);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("GROUPPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");this._aKeyFields=[];if(!this._aOperations){this.setOperations([e.GroupAscending,e.GroupDescending]);}this._oGroupPanel=new P({maxConditions:this.getMaxGroups(),autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange(),validationExecutor:q.proxy(this._callValidationExecutor,this)});this._oGroupPanel.setOperations(this._aOperations);this._oGroupPanel._sAddRemoveIconTooltipKey="GROUP";this.addAggregation("content",this._oGroupPanel);};
f.prototype.exit=function(){var b=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=b(this._aKeyFields);this._aOperations=b(this._aOperations);};
f.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var b=i.getBinding(n);if(b&&o){return o.getObject()[b.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i)});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oGroupPanel.setKeyFields(k);var C=[];m=(this.getBindingInfo("groupItems")||{}).model;this.getGroupItems().forEach(function(G){var o=G.getBindingContext(m);if(G.getBinding("key")){o.getObject()[G.getBinding("key").getPath()]=G.getKey();}C.push({key:G.getKey(),keyField:g("columnKey",o,G),operation:g("operation",o,G),showIfGrouped:g("showIfGrouped",o,G)});});this._oGroupPanel.setConditions(C);}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addGroupItem=function(g){this.addAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertGroupItem=function(g,i){this.insertAggregation("groupItems",g,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateGroupItems=function(r){this.updateAggregation("groupItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeGroupItem=function(g){g=this.removeAggregation("groupItems",g,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
f.prototype.removeAllGroupItems=function(){var g=this.removeAllAggregation("groupItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return g;};
f.prototype.destroyGroupItems=function(){this.destroyAggregation("groupItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var i=E.getParameter("index");var g;if(o==="update"){g=t.getGroupItems()[i];if(g){g.setColumnKey(n.keyField);g.setOperation(n.operation);g.setShowIfGrouped(n.showIfGrouped);}t.fireUpdateGroupItem({key:k,index:i,groupItemData:g});t._notifyChange();}if(o==="add"){g=new c({key:k,columnKey:n.keyField,operation:n.operation,showIfGrouped:n.showIfGrouped});t._bIgnoreBindCalls=true;t.fireAddGroupItem({key:k,index:i,groupItemData:g});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveGroupItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
f.prototype.getOkPayload=function(){if(!this.getModel()){return null;}var s=[];this._oGroupPanel._oConditionsGrid.getContent().forEach(function(C){var o=C.keyField;s.push(o.getSelectedKey());});return{selectedColumnKeys:s};};
f.prototype._callValidationExecutor=function(){var v=this.getValidationExecutor();if(v){v();}};
f.prototype._updateValidationResult=function(v){this._oGroupPanel._oConditionsGrid.getContent().forEach(function(C){var o=C.keyField;o.setValueStateText("");o.setValueState("None");var s=o.getSelectedKey();v.forEach(function(r){if(r.columnKey===s){o.setValueStateText(r.messageText);o.setValueState(r.messageType);}});});};
f.prototype.setValidationListener=function(L){this.setProperty("validationListener",L);if(L){L(this,q.proxy(this._updateValidationResult,this));}return this;};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/P13nItem',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var P=E.extend("sap.m.P13nItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},visible:{type:"boolean",group:"Misc",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:"text"},typeInstance:{type:"object",group:"Misc",defaultValue:null,since:"1.56"},precision:{type:"string",group:"Misc",defaultValue:null},formatSettings:{type:"object",group:"Misc",defaultValue:null,since:"1.52"},scale:{type:"string",group:"Misc",defaultValue:null},maxLength:{type:"string",group:"Misc",defaultValue:null},width:{type:"string",group:"Misc",defaultValue:null},isDefault:{type:"boolean",group:"Misc",defaultValue:false},values:{type:"string[]",group:"Misc",defaultValue:null},role:{type:"string",defaultValue:null},aggregationRole:{type:"string",defaultValue:null},href:{type:"string",defaultValue:null},target:{type:"string",defaultValue:null},press:{type:"object",defaultValue:null},description:{type:"string",defaultValue:null},nullable:{type:"boolean",group:"Misc",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/P13nOperationsHelper',["./library"],function(l){"use strict";var P=function(){this.init();};var O=l.P13nConditionOperation;P.prototype.oIncludeOperations={"default":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"string":[O.Contains,O.EQ,O.BT,O.StartsWith,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"date":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"time":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"datetime":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numeric":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numc":[O.Contains,O.EQ,O.BT,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"boolean":[O.EQ]};P.prototype.oExcludeOperationsDefault={"default":[O.EQ]};P.prototype.oExcludeOperationsExtended={"default":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"string":[O.Contains,O.EQ,O.BT,O.StartsWith,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"date":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"time":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"datetime":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numeric":[O.EQ,O.BT,O.LT,O.LE,O.GT,O.GE],"numc":[O.Contains,O.EQ,O.BT,O.EndsWith,O.LT,O.LE,O.GT,O.GE],"boolean":[O.EQ]};
P.prototype.init=function(){this.oExcludeOperations=this.oExcludeOperationsDefault;};
P.prototype.setUseExcludeOperationsExtended=function(){this.oExcludeOperations=this.oExcludeOperationsExtended;};
P.prototype.getIncludeOperationsByType=function(t){if(!t){t="default";}return this.oIncludeOperations[t].map(function(o){return o;});};
P.prototype.getExcludeOperationsByType=function(t){if(!t){t="default";}return this.oExcludeOperations[t].map(function(o){return o;});};
P.prototype.getIncludeTypes=function(){return Object.keys(this.oIncludeOperations);};
P.prototype.getExcludeTypes=function(){return Object.keys(this.oExcludeOperations);};
return P;},true);
sap.ui.predefine('sap/m/P13nPanel',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var P=C.extend("sap.m.P13nPanel",{
metadata:{"abstract":true,library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},titleLarge:{type:"string",group:"Appearance",defaultValue:null},type:{type:"string",group:"Misc",defaultValue:null},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},validationExecutor:{type:"object",group:"Misc",defaultValue:null},validationListener:{type:"object",group:"Misc",defaultValue:null},changeNotifier:{type:"object",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.P13nItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{beforeNavigationTo:{}}},
renderer:{apiVersion:2,render:function(r,c){r.openStart("span",c);r.class("sapMP13nPanel");r.openEnd();r.close("span");}}
});
P.prototype.getOkPayload=function(){return{};};
P.prototype.getResetPayload=function(){return{};};
P.prototype.beforeNavigationTo=function(){this.fireBeforeNavigationTo();};
P.prototype.onBeforeNavigationFrom=function(){return true;};
P.prototype.onAfterNavigationFrom=function(){};
return P;});
sap.ui.predefine('sap/m/P13nSelectionItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nSelectionItem",{metadata:{library:"sap.m",properties:{columnKey:{type:"string",defaultValue:undefined},selected:{type:"boolean",defaultValue:false}}}});
return P;});
sap.ui.predefine('sap/m/P13nSelectionPanel',['./library','./ColumnListItem','./P13nPanel','./SearchField','./Text','./Table','./Column','./ScrollContainer','./P13nSelectionItem','./VBox','./Link','./OverflowToolbar','./OverflowToolbarLayoutData','./ToolbarSpacer','sap/ui/core/library','sap/ui/model/ChangeReason','sap/ui/model/json/JSONModel','sap/ui/model/BindingMode','sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery"],function(l,C,P,S,T,a,b,c,d,V,L,O,e,f,g,h,J,B,R,q){"use strict";var i=l.ToolbarDesign;var j=l.ListType;var k=l.ListMode;var m=l.P13nPanelType;
var n=P.extend("sap.m.P13nSelectionPanel",{
metadata:{library:"sap.m",aggregations:{selectionItems:{type:"sap.m.P13nSelectionItem",multiple:true,singularName:"selectionItem",bindable:"bindable"},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"}},events:{changeSelectionItems:{parameters:{items:{type:"object[]"}}}}},
renderer:{apiVersion:2,render:function(r,o){r.openStart("div",o);r.class("sapMP13nColumnsPanel");r.openEnd();o.getAggregation("content").forEach(function(p){r.renderControl(p);});r.close("div");}}
});
n.prototype.init=function(){this._iLiveChangeTimer=0;this._iSearchTimer=0;this._bIgnoreUpdateInternalModel=false;this._bUpdateInternalModel=true;this._bOnAfterRenderingFirstTimeExecuted=false;var M=new J({items:[],countOfSelectedItems:0,countOfItems:0});M.setDefaultBindingMode(B.TwoWay);M.setSizeLimit(1000);this.setModel(M,"$sapmP13nSelectionPanel");this.setType(m.selection);this._createTable();this._createToolbar();this.setVerticalScrolling(false);var s=new c({horizontal:false,vertical:true,content:[this._oTable],width:'100%',height:'100%'});this.addAggregation("content",s);var t=this;this._fnHandleResize=function(){var o=false,p,r;if(t.getParent){var $=null,u,H;var v=t.getParent();var w=t._getToolbar();if(v&&v.$){$=v.$("cont");if($.children().length>0&&w.$().length>0){p=s.$()[0].clientHeight;u=$.children()[0].clientHeight;H=w?w.$()[0].clientHeight:0;r=u-H;if(p!==r){s.setHeight(r+'px');o=true;}}}}return o;};this._sContainerResizeListener=R.register(s,this._fnHandleResize);};
n.prototype.onBeforeRendering=function(){this._updateInternalModel();};
n.prototype.onAfterRendering=function(){var t=this;if(!this._bOnAfterRenderingFirstTimeExecuted){this._bOnAfterRenderingFirstTimeExecuted=true;window.clearTimeout(this._iLiveChangeTimer);this._iLiveChangeTimer=window.setTimeout(function(){t._fnHandleResize();},0);}};
n.prototype.getOkPayload=function(){this._updateInternalModel();var M=this._getInternalModel().getProperty("/items");return{selectionItems:M.map(function(o){return{columnKey:o.columnKey,selected:o.persistentSelected};})};};
n.prototype.exit=function(){R.deregister(this._sContainerResizeListener);this._sContainerResizeListener=null;this._getToolbar().destroy();this._oTable.destroy();this._oTable=null;if(this._getInternalModel()){this._getInternalModel().destroy();}window.clearTimeout(this._iLiveChangeTimer);window.clearTimeout(this._iSearchTimer);};
n.prototype.addItem=function(I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("items",I);return this;};
n.prototype.insertItem=function(I,o){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("items",I,o);return this;};
n.prototype.removeItem=function(I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}I=this.removeAggregation("items",I);return I;};
n.prototype.removeAllItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("items");};
n.prototype.destroyItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("items");return this;};
n.prototype.addSelectionItem=function(s){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.addAggregation("selectionItems",s);return this;};
n.prototype.insertSelectionItem=function(s,I){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.insertAggregation("selectionItems",s,I);return this;};
n.prototype.updateSelectionItems=function(r){this.updateAggregation("selectionItems");if(r===h.Change&&!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}};
n.prototype.removeSelectionItem=function(s){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAggregation("selectionItems",s);};
n.prototype.removeAllSelectionItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}return this.removeAllAggregation("selectionItems");};
n.prototype.destroySelectionItems=function(){if(!this._bIgnoreUpdateInternalModel){this._bUpdateInternalModel=true;}this.destroyAggregation("selectionItems");return this;};
n.prototype.onBeforeNavigationFrom=function(){return true;};
n.prototype._notifyChange=function(){var o=this.getChangeNotifier();if(o){o(this);}};
n.prototype._getInternalModel=function(){return this.getModel("$sapmP13nSelectionPanel");};
n.prototype._createTable=function(){var t=this;this._oTable=new a({mode:k.MultiSelect,rememberSelections:false,selectionChange:q.proxy(this._onSelectionChange,this),columns:[new b({vAlign:g.VerticalAlign.Middle,header:new T({text:{parts:[{path:'/countOfSelectedItems'},{path:'/countOfItems'}],formatter:function(o,p){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText('COLUMNSPANEL_SELECT_ALL_WITH_COUNTER',[o,p]);}}})})],items:{path:"/items",templateShareable:false,template:new C({cells:new V({items:[new L({href:"{href}",text:"{text}",target:"{target}",enabled:{path:'href',formatter:function(v){if(!v){this.addStyleClass("sapUiCompSmartLink");}return!!v;}},press:function(E){var H=E.getSource().getHref();var I=t.getItems().filter(function(o){return o.getHref()===H&&!!o.getPress();});if(!I.length){return;}var p=I[0].getPress();p(E);}}),new T({visible:{path:'description',formatter:function(D){return!!D;}},text:"{description}"})]}),visible:"{visible}",selected:"{persistentSelected}",tooltip:"{tooltip}",type:j.Active})}});this._oTable.setModel(this._getInternalModel());};
n.prototype._createToolbar=function(){var t=this;var o=new O(this.getId()+"-toolbar",{design:i.Auto,content:[new f(),new S(this.getId()+"-searchField",{liveChange:function(E){var v=E.getSource().getValue(),D=(v?300:0);window.clearTimeout(t._iSearchTimer);if(D){t._iSearchTimer=window.setTimeout(function(){t._onExecuteSearch();},D);}else{t._onExecuteSearch();}},search:q.proxy(this._onExecuteSearch,this),layoutData:new e({minWidth:"12.5rem",maxWidth:"23.077rem",shrinkable:true,moveToOverflow:false,stayInOverflow:false})})]});o.setModel(this._getInternalModel());this.addAggregation("content",o);};
n.prototype._onExecuteSearch=function(){this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();this._updateControlLogic();};
n.prototype._switchVisibilityOfUnselectedModelItems=function(){var s=this._isFilteredByShowSelected();var M=this._getInternalModel().getProperty("/items");M.forEach(function(o){if(o.persistentSelected){o.visible=true;return;}o.visible=!s;});this._getInternalModel().setProperty("/items",M);};
n.prototype._getVisibleModelItems=function(){return this._getInternalModel().getProperty("/items").filter(function(M){return!!M.visible;});};
n.prototype._getModelItemByColumnKey=function(s){var M=this._getInternalModel().getProperty("/items").filter(function(o){return o.columnKey===s;});return M[0];};
n.prototype._updateCounts=function(M){var o=0;var p=0;M.forEach(function(r){o++;if(r.persistentSelected){p++;}});this._getInternalModel().setProperty("/countOfItems",o);this._getInternalModel().setProperty("/countOfSelectedItems",p);};
n.prototype._getToolbar=function(){return sap.ui.getCore().byId(this.getId()+"-toolbar")||null;};
n.prototype._getSearchField=function(){return sap.ui.getCore().byId(this.getId()+"-searchField")||null;};
n.prototype._getSearchText=function(){var s=this._getSearchField();return s?s.getValue():"";};
n.prototype._isFilteredBySearchText=function(){return!!this._getSearchText().length;};
n.prototype._isFilteredByShowSelected=function(){return false;};
n.prototype._updateControlLogic=function(){var I=this._isFilteredBySearchText();var s=this._isFilteredByShowSelected();var t=sap.ui.getCore().byId(this._oTable.getId()+'-sa');if(t){t.setEnabled(!I&&!s);}};
n.prototype._fireChangeSelectionItems=function(){this._bIgnoreUpdateInternalModel=true;var M=this._getInternalModel().getProperty("/items");this.fireChangeSelectionItems({items:M.map(function(o){return{columnKey:o.columnKey,selected:o.persistentSelected};})});this._bIgnoreUpdateInternalModel=false;};
n.prototype._onSelectionChange=function(){this._selectTableItem();};
n.prototype._selectTableItem=function(){var M=this._getInternalModel().getProperty("/items");this._updateCounts(M);this._getInternalModel().setProperty("/items",M);this._fireChangeSelectionItems();this._notifyChange();};
n.prototype._filterModelItemsBySearchText=function(){var s=this._getSearchText();s=s.replace(/(^\s+)|(\s+$)/g,'');s=s.replace(/[-\/\\^$*+?.()|[\]{}]/g,'\\$&');var r=new RegExp(s,'igm');this._getVisibleModelItems().forEach(function(M){M.visible=false;if(M.text&&M.text.match(r)){M.visible=true;}if(M.tooltip&&M.tooltip.match(r)){M.visible=true;}});this._getInternalModel().refresh();};
n.prototype._updateInternalModel=function(){if(!this._bUpdateInternalModel){return;}this._bUpdateInternalModel=false;this._getInternalModel().setProperty("/items",this.getItems().map(function(I){return{columnKey:I.getColumnKey(),visible:true,text:I.getText(),tooltip:I.getTooltip(),href:I.getHref(),target:I.getTarget(),persistentSelected:I.getVisible(),description:I.getDescription()};},this));this.getSelectionItems().forEach(function(s){var o=this._getModelItemByColumnKey(s.getColumnKey());if(!o){return;}if(s.getSelected()!==undefined){o.persistentSelected=s.getSelected();}},this);this._switchVisibilityOfUnselectedModelItems();this._filterModelItemsBySearchText();var M=this._getInternalModel().getProperty("/items");this._updateCounts(M);this._getInternalModel().setProperty("/items",M);};
return n;});
sap.ui.predefine('sap/m/P13nSortItem',['./library','sap/ui/core/Item'],function(l,I){"use strict";
var P=I.extend("sap.m.P13nSortItem",{metadata:{library:"sap.m",properties:{operation:{type:"string",group:"Misc",defaultValue:null},columnKey:{type:"string",group:"Misc",defaultValue:null}}}});
P.prototype.setColumnKey=function(v){return this.setProperty("columnKey",v,true);};
P.prototype.setOperation=function(v){return this.setProperty("operation",v,true);};
return P;});
sap.ui.predefine('sap/m/P13nSortPanel',['./library','./P13nConditionPanel','./P13nPanel','./P13nSortItem'],function(l,P,a,c){"use strict";var d=l.P13nPanelType;var e=l.P13nConditionOperation;
var f=a.extend("sap.m.P13nSortPanel",{
metadata:{library:"sap.m",properties:{containerQuery:{type:"boolean",group:"Misc",defaultValue:false},layoutMode:{type:"string",group:"Misc",defaultValue:null}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",visibility:"hidden"},sortItems:{type:"sap.m.P13nSortItem",multiple:true,singularName:"sortItem",bindable:"bindable"}},events:{addSortItem:{},removeSortItem:{},updateSortItem:{}}},
renderer:{apiVersion:2,render:function(r,C){r.openStart("section",C);r.class("sapMSortPanel");r.openEnd();r.openStart("div");r.class("sapMSortPanelContent");r.class("sapMSortPanelBG");r.openEnd();C.getAggregation("content").forEach(function(o){r.renderControl(o);});r.close("div");r.close("section");}}
});
f.prototype._getConditions=function(){return this._oSortPanel.getConditions();};
f.prototype.setContainerQuery=function(b){this.setProperty("containerQuery",b);this._oSortPanel.setContainerQuery(b);return this;};
f.prototype.setLayoutMode=function(m){this.setProperty("layoutMode",m);this._oSortPanel.setLayoutMode(m);return this;};
f.prototype.validateConditions=function(){return this._oSortPanel.validateConditions();};
f.prototype.removeInvalidConditions=function(){this._oSortPanel.removeInvalidConditions();};
f.prototype.removeValidationErrors=function(){this._oSortPanel.removeValidationErrors();};
f.prototype.onBeforeNavigationFrom=function(){return this.validateConditions();};
f.prototype.onAfterNavigationFrom=function(){return this.removeInvalidConditions();};
f.prototype.setOperations=function(o){this._aOperations=o;if(this._oSortPanel){this._oSortPanel.setOperations(this._aOperations);}return this;};
f.prototype.init=function(){this.setType(d.sort);this.setTitle(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SORTPANEL_TITLE"));sap.ui.getCore().loadLibrary("sap.ui.layout");this._aKeyFields=[];if(!this._aOperations){this.setOperations([e.Ascending,e.Descending]);}this._oSortPanel=new P({autoReduceKeyFieldItems:true,layoutMode:this.getLayoutMode(),dataChange:this._handleDataChange()});this._oSortPanel.setOperations(this._aOperations);this._oSortPanel._sAddRemoveIconTooltipKey="SORT";this.addAggregation("content",this._oSortPanel);};
f.prototype.exit=function(){var b=function(o){if(o&&o.destroy){o.destroy();}return null;};this._aKeyFields=b(this._aKeyFields);this._aOperations=b(this._aOperations);};
f.prototype.onBeforeRendering=function(){if(this._bUpdateRequired){this._bUpdateRequired=false;var k=[];var m=(this.getBindingInfo("items")||{}).model;var g=function(n,o,i){var b=i.getBinding(n);if(b&&o){return o.getObject()[b.getPath()];}return i.getMetadata().getProperty(n)?i.getProperty(n):i.getAggregation(n);};this.getItems().forEach(function(i){var o=i.getBindingContext(m);if(i.getBinding("key")){o.getObject()[i.getBinding("key").getPath()]=i.getKey();}k.push({key:i.getColumnKey(),text:g("text",o,i),tooltip:g("tooltip",o,i)});});k.splice(0,0,{key:null,text:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_SELECTION_NONE")});this._oSortPanel.setKeyFields(k);var C=[];m=(this.getBindingInfo("sortItems")||{}).model;this.getSortItems().forEach(function(s){var o=s.getBindingContext(m);if(s.getBinding("key")){o.getObject()[s.getBinding("key").getPath()]=s.getKey();}C.push({key:s.getKey(),keyField:g("columnKey",o,s),operation:g("operation",o,s)});});this._oSortPanel.setConditions(C);}};
f.prototype.addItem=function(i){a.prototype.addItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.removeItem=function(i){var r=a.prototype.removeItem.apply(this,arguments);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return r;};
f.prototype.destroyItems=function(){this.destroyAggregation("items");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.addSortItem=function(s){this.addAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.insertSortItem=function(s,i){this.insertAggregation("sortItems",s,i,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype.updateSortItems=function(r){this.updateAggregation("sortItems");if(r==="change"&&!this._bIgnoreBindCalls){this._bUpdateRequired=true;this.invalidate();}};
f.prototype.removeSortItem=function(s){s=this.removeAggregation("sortItems",s,true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
f.prototype.removeAllSortItems=function(){var s=this.removeAllAggregation("sortItems",true);if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return s;};
f.prototype.destroySortItems=function(){this.destroyAggregation("sortItems");if(!this._bIgnoreBindCalls){this._bUpdateRequired=true;}return this;};
f.prototype._handleDataChange=function(){var t=this;return function(E){var n=E.getParameter("newData");var o=E.getParameter("operation");var k=E.getParameter("key");var i=E.getParameter("index");var s;if(o==="update"){s=t.getSortItems()[i];if(s){s.setColumnKey(n.keyField);s.setOperation(n.operation);}t.fireUpdateSortItem({key:k,index:i,sortItemData:s});t._notifyChange();}if(o==="add"){s=new c({key:k,columnKey:n.keyField,operation:n.operation});t._bIgnoreBindCalls=true;t.fireAddSortItem({key:k,index:i,sortItemData:s});t._bIgnoreBindCalls=false;t._notifyChange();}if(o==="remove"){t._bIgnoreBindCalls=true;t.fireRemoveSortItem({key:k,index:i});t._bIgnoreBindCalls=false;t._notifyChange();}};};
f.prototype._notifyChange=function(){var L=this.getChangeNotifier();if(L){L(this);}};
return f;});
sap.ui.predefine('sap/m/QuickView',["./library","sap/ui/Device","sap/ui/core/IconPool","./QuickViewBase","./ResponsivePopover","./NavContainer","./Page","./Bar","./Button"],function(l,D,I,Q,R,N,P,B,a){"use strict";var b=l.PlacementType;
var c=Q.extend("sap.m.QuickView",{
metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:b.Right},width:{type:'sap.ui.core.CSSSize',group:'Dimension',defaultValue:'320px'}},aggregations:{},designtime:"sap/m/designtime/QuickView.designtime",events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}},
renderer:{apiVersion:2,render:function(){}}
});
c.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);var t=this;this._oPopover=new R(this.getId()+'-quickView',{placement:this.getPlacement(),content:[this._oNavContainer],contentWidth:this.getWidth(),showHeader:false,showCloseButton:false,afterOpen:function(e){t._afterOpen(e);t.fireAfterOpen({openBy:e.getParameter("openBy")});},afterClose:function(e){t.fireAfterClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});},beforeOpen:function(e){t.fireBeforeOpen({openBy:e.getParameter("openBy")});},beforeClose:function(e){t.fireBeforeClose({openBy:e.getParameter("openBy"),origin:t.getCloseButton()});t._bRendered=false;}});this._oPopover.addStyleClass("sapMQuickView");var p=this._oPopover.getAggregation("_popup");p.addEventDelegate({onBeforeRendering:this._initializeQuickView,onAfterRendering:this._setLinkWidth,onkeydown:this._onPopupKeyDown},this);var t=this;var s=p._fnAdjustPositionAndArrow;if(s){p._fnAdjustPositionAndArrow=function(){s.apply(p,arguments);t._adjustContainerHeight();};}this._bItemsChanged=true;};
c.prototype._initializeQuickView=function(){this._bRendered=true;if(this._bItemsChanged){this._clearContainerHeight();this._initPages();var p=this._oNavContainer.getCurrentPage();if(p){var h=p.getCustomHeader();if(h){this._oPopover.addAriaDescribedBy(h.getId());}}var d=this.getAggregation("pages");if(!d&&D.system.phone){this._addEmptyPage();}this._bItemsChanged=false;}};
c.prototype.exit=function(){this._bRendered=false;this._bItemsChanged=true;if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
c.prototype.invalidate=function(){};
c.prototype._createPage=function(q){return q._createPage();};
c.prototype._onPopupKeyDown=function(e){this._processKeyboard(e);};
c.prototype._afterOpen=function(e){if(D.system.phone){this._restoreFocus();}};
c.prototype._addEmptyPage=function(){var p=new P({customHeader:new B().addStyleClass("sapMQuickViewHeader")});var t=this;var C=p.getCustomHeader();C.addContentRight(new a({icon:I.getIconURI("decline"),press:function(){t._oPopover.close();}}));p.addStyleClass('sapMQuickViewPage');this._oNavContainer.addPage(p);};
c.prototype._clearContainerHeight=function(){var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&$[0].style.height){$[0].style.height='';}};
c.prototype._adjustContainerHeight=function(){if(this.getPages().length<=1){return;}var p=this._oPopover.getAggregation("_popup");var $=p.$().find('.sapMPopoverCont');if($[0]&&!$[0].style.height){$[0].style.height=$.height()+'px';}};
c.prototype._setLinkWidth=function(){this._oPopover.$().find(".sapMLnk").css("width","auto");};
c.prototype.getCloseButton=function(){if(!D.system.phone){return undefined;}var p=this._oNavContainer.getCurrentPage();var o=p.getCustomHeader().getContentRight()[0];return o;};
c.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._oPopover.setPlacement(p);return this;};
c.prototype.setWidth=function(w){if(this._oPopover){this._oPopover.setContentWidth(w);this.setProperty('width',w,true);}return this;};
c.prototype.openBy=function(C){this._bItemsChanged=true;this._oPopover.openBy(C);return this;};
c.prototype.close=function(){this._oPopover.close();return this;};
c.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getFieldGroupIds","setFieldGroupIds","getBusy","setBusy","setTooltip","getTooltip"].forEach(function(n){c.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var r=this._oPopover.getAggregation("_popup")[n].apply(this._oPopover.getAggregation("_popup"),arguments);return r===this._oPopover.getAggregation("_popup")?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){c.prototype["_"+f+"Old"]=c.prototype[f];c.prototype[f]=function(){var n=[],r,i;for(i=0;i<arguments.length;i++){n.push(arguments[i]);}if(["setModel","bindAggregation"].indexOf(f)===-1){n.push(true);}r=c.prototype["_"+f+"Old"].apply(this,n);this._bItemsChanged=true;if(this._oPopover){if(arguments[0]!=="pages"){this._oPopover[f].apply(this._oPopover,arguments);}if(this._bRendered){this._initializeQuickView();}}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});return c;});
sap.ui.predefine('sap/m/QuickViewBase',["./library","sap/ui/core/Control","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,K,q){"use strict";
var Q=C.extend("sap.m.QuickViewBase",{
metadata:{library:"sap.m",properties:{},defaultAggregation:"pages",aggregations:{pages:{type:"sap.m.QuickViewPage",multiple:true,singularName:"page",bindable:"bindable"}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},navOrigin:{type:"sap.ui.core.Control"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"},isTopPage:{type:"boolean"},navOrigin:{type:"sap.ui.core.Control"}}}}},
renderer:{apiVersion:2,render:function(){}}
});
Q.prototype.navigateBack=function(){if(!this._oNavContainer.currentPageIsTopPage()){this._setNavOrigin(null);this._oNavContainer.back();}};
Q.prototype.getNavContainer=function(){return this._oNavContainer;};
Q.prototype._initPages=function(){var n=this._oNavContainer;n.destroyPages();n.init();var p=this.getAggregation("pages");if(!p){return;}var I=this.getId();for(var i=0;i<p.length;i++){var o=p[i];o._oPage=null;var N={hasBackButton:i>0,popover:this._oPopover,navContainer:n,quickViewId:I,quickView:this};o.setNavContext(N);var P=this._createPage(o);this._oNavContainer.addPage(P);}};
Q.prototype._processKeyboard=function(e){if(e.shiftKey&&e.which===K.ENTER){this.navigateBack();e.preventDefault();}};
Q.prototype._createPage=function(o){return o;};
Q.prototype._navigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q(document.getElementById(F)).index();var a=q(document.getElementById(T)).index();if(a==-1||a>i){t.addStyleClass('sapMNavItemOffset');}else{f.addStyleClass('sapMNavItemOffset');}f.$().parents('.sapMPanelContent').scrollTop(0);var p=e.getParameters();if(this._navOrigin){p.navOrigin=this._navOrigin;}this.fireNavigate(p);};
Q.prototype._afterNavigate=function(e){var t=e.getParameter('to');var f=e.getParameter('from');var T=e.getParameter('toId');var F=e.getParameter('fromId');var i=q(document.getElementById(F)).index();var a=q(document.getElementById(T)).index();if(a>i){t.removeStyleClass('sapMNavItemOffset');}else{f.removeStyleClass('sapMNavItemOffset');}var p=e.getParameters();p.isTopPage=this._oNavContainer.currentPageIsTopPage();if(this._navOrigin){p.navOrigin=this._navOrigin;}this.fireAfterNavigate(p);this._setLinkWidth();setTimeout(this._restoreFocus.bind(this),0);};
Q.prototype._restoreFocus=function(){var p=this._oNavContainer.getCurrentPage();var f=this._oNavContainer._mFocusObject[p.getId()];if(!f){var c=p.getContent();if(c&&c.length>1){f=c[1].$().firstFocusableDomRef();}}if(f){f.focus();}};
Q.prototype._setLinkWidth=function(){};
Q.prototype._setNavOrigin=function(c){this._navOrigin=c;};
return Q;});
sap.ui.predefine('sap/m/QuickViewCard',["./library","./QuickViewBase","./NavContainer","./Page","./ScrollContainer","./QuickViewCardRenderer"],function(l,Q,N,P,S,a){"use strict";
var b=Q.extend("sap.m.QuickViewCard",{metadata:{library:"sap.m",properties:{showVerticalScrollBar:{type:"boolean",group:"Behavior",defaultValue:true}},designtime:"sap/m/designtime/QuickViewCard.designtime"}});
b.prototype.init=function(){var n={pages:[new P()],navigate:this._navigate.bind(this),afterNavigate:this._afterNavigate.bind(this)};this._oNavContainer=new N(n);};
b.prototype.onBeforeRendering=function(){this._initPages();};
b.prototype.onAfterRendering=function(){this._setLinkWidth();};
b.prototype.exit=function(){if(this._oNavContainer){this._oNavContainer.destroy();}};
b.prototype.onkeydown=function(e){this._processKeyboard(e);};
b.prototype._createPage=function(q){var c=q._createPageContent();q._mPageContent=null;var C=new S(this.getId()+'-'+q.getPageId(),{horizontal:false,vertical:false});if(c.header){C.addContent(c.header);}C.addContent(c.form);C.addStyleClass('sapMQuickViewPage');return C;};
b.prototype._setLinkWidth=function(){this.$().find(".sapMLnk").css("width","auto");};
return b;});
sap.ui.predefine('sap/m/QuickViewGroupElement',["./library","sap/ui/core/Element","./Link","./Text","sap/ui/core/CustomData"],function(l,E,L,T,C){"use strict";var G=l.QuickViewGroupElementType;
var a=E.extend("sap.m.QuickViewGroupElement",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},label:{type:"string",group:"Misc",defaultValue:""},value:{type:"string",group:"Misc",defaultValue:""},url:{type:"string",group:"Misc",defaultValue:""},target:{type:"string",group:"Misc",defaultValue:"_blank"},type:{type:"sap.m.QuickViewGroupElementType",group:"Misc",defaultValue:G.text},pageLinkId:{type:"string",group:"Misc",defaultValue:""},emailSubject:{type:"string",group:"Misc",defaultValue:""}}}});
a.prototype._getGroupElementValue=function(q){if(!this.getValue()){return null;}switch(this.getType()){case G.email:var h="mailto:"+this.getValue();var s=this.getEmailSubject();if(s){h+='?subject='+s;}return new L({href:h,text:this.getValue(),wrapping:true});case G.phone:case G.mobile:return new L({href:"tel:"+this.getValue(),text:this.getValue()});case G.link:return new L({href:this.getUrl(),text:this.getValue(),target:this.getTarget()});case G.pageLink:var b=this.getPageLinkId();if(q){b=q+'-'+b;}return new L({text:this.getValue(),customData:[new C({key:"pageNumber",value:b})]});default:return new T({text:this.getValue()});}};
a.prototype.setProperty=function(){E.prototype.setProperty.apply(this,arguments);var g=this.getParent();if(!g){return this;}var p=g.getParent();if(p){p._updatePage();}return this;};
a.prototype.getQuickViewBase=function(){var p=this.getParent();if(p&&p.getQuickViewBase){return p.getQuickViewBase();}return null;};
return a;});
sap.ui.predefine('sap/m/QuickViewPage',["./library","sap/ui/core/Core","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/layout/form/SimpleForm","sap/ui/layout/VerticalLayout","sap/ui/layout/HorizontalLayout","sap/m/Page","sap/m/Button","sap/m/Bar","sap/m/Title","sap/m/Image","sap/m/Link","sap/m/Text","sap/m/Label","sap/m/HBox","sap/ui/core/Icon","sap/ui/core/Title","sap/ui/core/CustomData","sap/ui/core/library","sap/ui/layout/library","sap/ui/Device","sap/ui/layout/form/ResponsiveGridLayout","./QuickViewPageRenderer","sap/base/security/encodeURL","sap/ui/dom/jquery/Focusable"],function(l,C,a,I,S,V,H,P,B,b,T,c,L,d,e,f,g,h,i,m,n,D,R,Q,o){"use strict";var U=l.URLHelper;var p=n.form.SimpleFormLayout;var q=m.TitleLevel;var r=l.QuickViewGroupElementType;var s=l.ButtonType;var t=C.getLibraryResourceBundle('sap.m');
var u=a.extend("sap.m.QuickViewPage",{metadata:{library:"sap.m",properties:{pageId:{type:"string",group:"Misc",defaultValue:""},header:{type:"string",group:"Misc",defaultValue:""},title:{type:"string",group:"Misc",defaultValue:""},titleUrl:{type:"string",group:"Misc",defaultValue:""},crossAppNavCallback:{type:"object",group:"Misc"},description:{type:"string",group:"Misc",defaultValue:""},icon:{type:"string",group:"Misc",defaultValue:""},fallbackIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null}},defaultAggregation:"groups",aggregations:{groups:{type:"sap.m.QuickViewGroup",multiple:true,singularName:"group",bindable:"bindable"}}}});
u.prototype.init=function(){var G=sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getService;if(G){this.oCrossAppNavigator=G("CrossApplicationNavigation");}};
u.prototype.onBeforeRendering=function(){this._destroyPageContent();this._createPageContent();};
u.prototype.getPageContent=function(){return this._mPageContent;};
u.prototype.setNavContext=function(j){this._mNavContext=j;};
u.prototype.getNavContext=function(){return this._mNavContext;};
u.prototype.setPageTitleControl=function(j){this._oPageTitle=j;};
u.prototype.getPageTitleControl=function(){return this._oPageTitle;};
u.prototype._createPage=function(){var j=this._createPageContent();var N=this.getNavContext();var k;if(this._oPage){k=this._oPage;k.destroyContent();k.setCustomHeader(new b());}else{k=this._oPage=new P(N.quickViewId+'-'+this.getPageId(),{customHeader:new b()});k.addEventDelegate({onAfterRendering:this.onAfterRenderingPage},this);}if(this.getHeader()===""&&N.quickView.getPages().length===1&&!D.system.phone){k.setShowHeader(false);k.addStyleClass('sapMQuickViewPageWithoutHeader');}if(j.header){k.addContent(j.header);}k.addContent(j.form);var v=k.getCustomHeader();v.addContentMiddle(new T({text:this.getHeader()}).addStyleClass("sapMQuickViewTitle"));if(N.hasBackButton){v.addContentLeft(new B({type:s.Back,tooltip:t.getText("PAGE_NAVBUTTON_TEXT"),press:function(){if(N.navContainer){N.quickView._setNavOrigin(null);N.navContainer.back();}}}));}if(N.popover&&D.system.phone){v.addContentRight(new B({icon:I.getIconURI("decline"),press:function(){N.popover.close();}}));}k.addStyleClass('sapMQuickViewPage');return k;};
u.prototype.onAfterRenderingPage=function(){var j=this.getParent(),k=j instanceof a&&j.isA('sap.m.QuickView');if(k&&!this._oPage.$().firstFocusableDomRef()){this._oPage.$('cont').attr('tabindex',0);}if(this._bItemsChanged){var N=this.getNavContext();if(N){N.quickView._restoreFocus();}this._bItemsChanged=false;}};
u.prototype._createPageContent=function(){var F=this._createForm();var j=this._getPageHeaderContent();var k=this.getPageTitleControl();if(j&&k){F.addAriaLabelledBy(k);}this._mPageContent={form:F,header:j};return this._mPageContent;};
u.prototype._createForm=function(){var G=this.getAggregation("groups"),F=new S({maxContainerCols:1,editable:false,layout:p.ResponsiveGridLayout});if(G){for(var j=0;j<G.length;j++){if(G[j].getVisible()){this._renderGroup(G[j],F);}}}return F;};
u.prototype._getPageHeaderContent=function(){var j,F,k=this.getFallbackIcon(),v=new V(),w=new H(),x=this.getIcon(),y=this.getTitle(),z=this.getDescription(),A=this.getTitleUrl();if(!x&&!y&&!z){return null;}if(x){if(this.getIcon().indexOf("sap-icon")==0){j=this._createIcon(x,!A,y);}else{j=new c({src:x,decorative:false,tooltip:y}).addStyleClass("sapUiIcon sapMQuickViewPageImage");if(I.isIconURI(k)){F=this._createIcon(k,!A,y);F.addStyleClass("sapMQuickViewThumbnail sapMQuickViewPageFallbackIconHidden");j.attachError(this._onImageLoadError.bind(this));w.addContent(F);}}j.addStyleClass("sapMQuickViewThumbnail");if(A){j.attachPress(this._crossApplicationNavigation(this));if(F){F.attachPress(this._crossApplicationNavigation(this));}}w.addContent(j);}var E;if(A){E=new L({text:y,href:A,target:"_blank"});}else if(this.getCrossAppNavCallback()){E=new L({text:y});E.attachPress(this._crossApplicationNavigation(this));}else{E=new T({text:y,level:q.H1});}this.setPageTitleControl(E);var G=new d({text:z});v.addContent(E);v.addContent(G);w.addContent(v);return w;};
u.prototype._createIcon=function(j,k,v){return new g({src:j,decorative:k,useIconTooltip:false,tooltip:v});};
u.prototype._renderGroup=function(G,F){var E=G.getAggregation("elements");var j,v,w;if(G.getHeading()){F.addContent(new h({text:G.getHeading(),level:q.H2}));}if(!E){return;}var N=this.getNavContext();for(var k=0;k<E.length;k++){j=E[k];if(!j.getVisible()){continue;}w=new e({text:j.getLabel()});var x;if(N){x=N.quickViewId;}v=j._getGroupElementValue(x);F.addContent(w);if(!v){F.addContent(new d({text:""}));continue;}w.setLabelFor(v.getId());if(j.getType()==r.pageLink){v.attachPress(this._attachPressLink(this));}if(j.getType()==r.mobile&&!D.system.desktop){var y=new g({src:I.getIconURI("post"),tooltip:t.getText("QUICKVIEW_SEND_SMS"),decorative:false,customData:[new i({key:"phoneNumber",value:j.getValue()})],press:this._mobilePress});var z=new f({items:[v,y]});F.addContent(z);}else{F.addContent(v);}}};
u.prototype._crossApplicationNavigation=function(j){return function(){if(j.getCrossAppNavCallback()&&j.oCrossAppNavigator){var k=j.getCrossAppNavCallback();if(typeof k=="function"){var v=k();var w=j.oCrossAppNavigator.hrefForExternal({target:{semanticObject:v.target.semanticObject,action:v.target.action},params:v.params});U.redirect(w);}}else if(j.getTitleUrl()){window.open(j.getTitleUrl(),"_blank");}};};
u.prototype._destroyPageContent=function(){if(!this._mPageContent){return;}if(this._mPageContent.form){this._mPageContent.form.destroy();}if(this._mPageContent.header){this._mPageContent.header.destroy();}this._mPageContent=null;};
u.prototype.exit=function(){if(this._oPage){this._oPage.destroy();this._oPage=null;}else{this._destroyPageContent();}this._mNavContext=null;};
u.prototype._attachPressLink=function(j){var N=j.getNavContext();return function(E){E.preventDefault();var k=this.getCustomData()[0].getValue();if(N.navContainer&&k){N.quickView._setNavOrigin(this);N.navContainer.to(k);}};};
u.prototype._mobilePress=function(){var j="sms://"+o(this.getCustomData()[0].getValue());window.location.replace(j);};
u.prototype._updatePage=function(){var N=this.getNavContext();if(N&&N.quickView._bRendered){this._bItemsChanged=true;N.popover.focus();if(N.quickView.indexOfPage(this)==0){N.quickView._clearContainerHeight();}this._createPage();N.popover.$().css('display','block');N.quickView._adjustContainerHeight();N.quickView._restoreFocus();}};
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){u.prototype["_"+F+"Old"]=u.prototype[F];u.prototype[F]=function(){var j=u.prototype["_"+F+"Old"].apply(this,arguments);this._updatePage();if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return j;}return this;};});
u.prototype.setProperty=function(){a.prototype.setProperty.apply(this,arguments);this._updatePage();return this;};
u.prototype.getQuickViewBase=function(){var j=this.getParent();if(j&&j.isA("sap.m.QuickViewBase")){return j;}return null;};
u.prototype._onImageLoadError=function(E){var F=0,j=this._mPageContent.header.getContent()[F],k=E.getSource(),v=document.activeElement===k.getDomRef();j.removeStyleClass("sapMQuickViewPageFallbackIconHidden");k.addStyleClass("sapMQuickViewPageFailedImage");if(v){j.focus();}};
return u;});
/*!
 * @copyright@
 */
sap.ui.predefine('sap/m/NumericContentRenderer',["sap/m/library"],function(l){"use strict";var N={};
N.render=function(r,c){var s=c.getState();var w=c.getWithMargin();var W=w?"":"WithoutMargin";r.write("<div");r.writeControlData(c);var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.writeAttributeEscaped("aria-label",t);r.writeAttribute("role","img");if(s===l.LoadState.Failed||s===l.LoadState.Loading){r.writeAttribute("aria-disabled","true");}if(c.getAnimateTextChange()){r.addClass("sapMNCAnimation");}if(c.getWidth()){r.addStyle("width",c.getWidth());}r.writeStyles();r.addClass("sapMNC");r.addClass(W);if(c.hasListeners("press")){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMNCInner");r.addClass(W);r.writeClasses();r.write(">");this._renderValue(r,c,W);r.write("</div>");r.write("</div>");};
N._prepareAndRenderIcon=function(r,c,i,n){if(i){var s,L=l.LoadState,C=c.getState();for(s in L){if(L.hasOwnProperty(s)&&s!==C){i.removeStyleClass(s);}else if(L.hasOwnProperty(s)&&s===C){i.addStyleClass(s);}}i.addStyleClass("sapMNCIconImage");var S={sapMNCLargeFontSize:false,sapMNCMediumFontSize:false,sapMNCSmallFontSize:false};S[n]=true;Object.keys(S).forEach(function(k){i.toggleStyleClass(k,S[k]);});r.renderControl(i);}};
N._renderScaleAndIndicator=function(r,c,w,v,s,n){var i=l.DeviationIndicator.None!==c.getIndicator()&&v!=="";var S=s&&v;if(i||S){var a=c.getState();var C=c.getValueColor();r.write("<div");r.writeAttribute("id",c.getId()+"-indicator");r.addClass("sapMNCIndScale");r.addClass(w);r.addClass(C);r.addClass(a);if(n){r.addClass(n);}r.writeClasses();r.write(">");r.renderControl(c._oIndicatorIcon);if(S){r.write("<div");r.writeAttribute("id",c.getId()+"-scale");r.addClass("sapMNCScale");r.addClass(a);r.addClass(C);r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");}r.write("</div>");}};
N._renderValue=function(r,c,w){var v=c.getValue();var s=c.getScale();if(c.getFormatterValue()){var f=c._parseFormattedValue(v);s=f.scale;v=f.value;}var e=c.getNullifyValue()?"0":"";r.write("<div");r.writeAttribute("id",c.getId()+"-value");r.addClass("sapMNCValue");r.addClass(w);r.addClass(c.getValueColor());r.addClass(c.getState());r.writeClasses();r.write(">");var m=c._getMaxDigitsData();this._prepareAndRenderIcon(r,c,c._oIcon,m.fontClass);var C=c.getTruncateValueTo()||m.maxLength;r.write("<span id=\""+c.getId()+"-value-inner\"");if(m.fontClass){r.addClass(m.fontClass);}r.writeClasses();r.write(">");if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.writeEscaped(v.substring(0,C-1));}else{r.writeEscaped(v?v.substring(0,C):e);}r.write("</span>");this._renderScaleAndIndicator(r,c,w,v,s,m.fontClass);r.write("</div>");};
return N;},true);
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/m/AccButton',['./Button','./AccButtonRenderer'],function(B,A){"use strict";
var a=B.extend("sap.m.AccButton",{metadata:{library:"sap.m",properties:{"tabIndex":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHidden":{type:"string",defaultValue:null,bindable:"bindable"},"ariaHaspopup":{type:"string",defaultValue:null,bindable:"bindable"}}}});
return a;});
sap.ui.predefine('sap/m/AccButtonRenderer',['./ButtonRenderer','sap/ui/core/Renderer'],function(B,R){"use strict";var A=R.extend(B);
A.renderAccessibilityAttributes=function(r,c){if(c.getTabIndex()){r.writeAttribute("tabindex",c.getTabIndex());}if(c.getAriaHidden()){r.writeAttribute("aria-hidden",c.getAriaHidden());}if(c.getAriaHaspopup()){r.writeAttribute("aria-haspopup",c.getAriaHaspopup());}};
return A;},true);
sap.ui.predefine('sap/m/ActionListItem',['./ListItemBase','./library','./ActionListItemRenderer'],function(L,l,A){"use strict";var a=l.ListMode;var b=l.ListType;
var c=L.extend("sap.m.ActionListItem",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
c.prototype.init=function(){this.setType(b.Active);L.prototype.init.apply(this,arguments);};
c.prototype.getMode=function(){return a.None;};
c.prototype.onsapspace=c.prototype.onsapenter;
c.prototype.getContentAnnouncement=function(){return this.getText();};
return c;});
sap.ui.predefine('sap/m/ActionListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var A=R.extend(L);A.apiVersion=2;
A.renderLIAttributes=function(r,l){r.class("sapMALI");};
A.renderLIContent=function(r,l){var t=l.getText();if(t){r.openStart("div").class("sapMALIText").openEnd();r.text(t);r.close("div");}};
return A;},true);
sap.ui.predefine('sap/m/ActionSelect',['./Select','sap/ui/core/InvisibleText','sap/ui/core/Core','./ActionSelectRenderer'],function(S,I,C,A){"use strict";
var a=S.extend("sap.m.ActionSelect",{metadata:{library:"sap.m",associations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"}}}});
a.prototype.init=function(){S.prototype.init.call(this);this.getList().addEventDelegate({onfocusin:this.onfocusinList},this);};
a.prototype.hasContent=function(){return S.prototype.hasContent.call(this)||!!this.getButtons().length;};
a.prototype.addContentToFlex=function(){var s=this.getSimpleFixFlex();this.getButtons().forEach(function(b){s.addFlexContent(C.byId(b));});};
a.prototype._onBeforeRenderingPopover=function(){S.prototype._onBeforeRenderingPopover.call(this);var p=this.getPicker();p&&p._setAriaRoleApplication(true);this._updateTutorMessage();};
a.prototype.onAfterRenderingPicker=function(){S.prototype.onAfterRenderingPicker.call(this);var p=this.getPicker(),r=this.getRenderer();p.addStyleClass(r.CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker");p.addStyleClass(r.ACTION_SELECT_CSS_CLASS+"Picker-CTX");};
a.prototype.createPickerCloseButton=function(){};
a.prototype.removeButton=function(b){var s=this.getSimpleFixFlex();if(s){if(typeof b==="number"){b=this.getButtons()[b];}s.removeFlexContent(b);}return this.removeAssociation("buttons",b);};
a.prototype.removeAllButtons=function(){var s=this.getSimpleFixFlex();if(s){this.getButtons().forEach(function(b){s.removeFlexContent(C.byId(b));});}return this.removeAllAssociation("buttons");};
a.prototype.onsaptabprevious=function(e){var b=this.getButtons(),p=this.getPicker(),i;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=b.length-1;i>=0;i--){if(C.byId(b[i]).getEnabled()){C.byId(b[i]).focus();e.preventDefault();break;}}}};
a.prototype.onsaptabnext=function(e){var b=this.getButtons(),p=this.getPicker(),i;this._bProcessChange=false;if(e.isMarked()||!this.getEnabled()){return;}e.setMarked();if(p&&p.isOpen()&&b.length>0){for(i=0;i<b.length;i++){if(C.byId(b[i]).getEnabled()){C.byId(b[i]).focus();e.preventDefault();break;}}}};
a.prototype.onsapfocusleave=function(e){var b=this.getButtons();var k=(b.indexOf(e.relatedControlId)===-1);if(k){S.prototype.onsapfocusleave.apply(this,arguments);}this._toggleListFocusIndication(true);};
a.prototype.onfocusinList=function(e){if(document.activeElement!==this.getList().getDomRef()){this.focus();}};
a.prototype.onfocusin=function(){S.prototype.onfocusin.apply(this,arguments);this._toggleListFocusIndication(false);};
a.prototype._toggleListFocusIndication=function(r){var s=this.getSelectedItem();if(this.isOpen()&&s){s.$().toggleClass("sapMActionSelectItemWithoutFocus",r);}};
a.prototype._updateTutorMessage=function(){var p=this.getPicker(),b=p.getAriaLabelledBy(),h=!!this.getButtons().length,t;if(!this._sTutorMessageId){this._sTutorMessageId=this._getTutorMessageId();this._oTutorMessageText=new I(this._sTutorMessageId,{text:C.getLibraryResourceBundle("sap.m").getText("ACTION_SELECT_TUTOR_MESSAGE")}).toStatic();}t=(b.indexOf(this._sTutorMessageId)===-1);if(t&&h){p.addAriaLabelledBy(this._sTutorMessageId);}else{if(!h){p.removeAriaLabelledBy(this._sTutorMessageId);}}};
a.prototype._getTutorMessageId=function(){return this.getId()+"-tutorMessage";};
a.prototype.exit=function(){if(this._oTutorMessageText){this._oTutorMessageText.destroy();this._oTutorMessageText=null;}};
return a;});
sap.ui.predefine('sap/m/ActionSelectRenderer',['sap/ui/core/Renderer','./SelectRenderer'],function(R,S){"use strict";var A=R.extend(S);A.ACTION_SELECT_CSS_CLASS="sapMActionSelect";A.apiVersion=2;
A.addClass=function(r,a){r.class(A.ACTION_SELECT_CSS_CLASS);};
return A;},true);
sap.ui.predefine('sap/m/ActionSheet',['./Dialog','./Popover','./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText','sap/ui/base/ManagedObject','sap/ui/Device','./ActionSheetRenderer','./Button',"sap/ui/thirdparty/jquery"],function(D,P,l,C,I,a,M,b,A,B,q){"use strict";var c=l.ButtonType;var d=l.DialogType;var e=l.PlacementType;
var f=C.extend("sap.m.ActionSheet",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:e.Bottom},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:true},cancelButtonText:{type:"string",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null}},aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_cancelButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_invisibleAriaTexts:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},defaultAggregation:"buttons",events:{cancelButtonTap:{deprecated:true},beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}},cancelButtonPress:{}},designtime:"sap/m/designtime/ActionSheet.designtime"}});
f.prototype.init=function(){this._fnOrientationChange=this._orientationChange.bind(this);this._actionSelected=null;};
f.prototype.exit=function(){b.resize.detachHandler(this._fnOrientationChange);if(this._parent){this._parent.destroy();this._parent=null;}if(this._oCancelButton){this._oCancelButton.destroy();this._oCancelButton=null;}this._clearItemNavigation();};
f.prototype._clearItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
f.prototype._setItemNavigation=function(){var g=this._getAllButtons(),h=[],o=this.getDomRef();if(o){this._oItemNavigation.setRootDomRef(o);for(var i=0;i<g.length;i++){if(g[i].getEnabled()&&g[i].getVisible()){h.push(g[i].getFocusDomRef());}}if(this._oCancelButton){h.push(this._oCancelButton.getFocusDomRef());}this._oItemNavigation.setItemDomRefs(h);this._oItemNavigation.setSelectedIndex(0);this._oItemNavigation.setPageSize(5);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});}};
f.prototype.onmousedown=function(E){if(E.srcControl.isA("sap.m.Button")&&this.getButtons().indexOf(E.srcControl)!==-1){this._actionSelected=E.srcControl;}};
f.prototype.onBeforeRendering=function(){var t,p;this._clearItemNavigation();t=this.getTitle();if(this._parent&&!this.isPropertyInitial("title")&&this._parent.getTitle()!==t){if(b.system.phone){this._parent.setTitle(t);this._parent.setShowHeader(!!t);}if(t){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.removeStyleClass("sapMActionSheetDialogWithTitle");}}p=this.getPlacement();if(this._parent&&!b.system.phone&&!this.isPropertyInitial("placement")&&this._parent.setPlacement()!==p){this._parent.setPlacement(p);}};
f.prototype.onAfterRendering=function(){this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigation();};
f.prototype.sapfocusleave=function(){this.close();};
f.prototype.openBy=function(o){var t=this;if(!this._parent){var O=this.getParent();if(O){this.setParent(null);}if(!b.system.phone){this._parent=new P({placement:this.getPlacement(),showHeader:false,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(){t.fireBeforeClose();},afterClose:function(){if(t.getShowCancelButton()){t.fireCancelButtonTap();t.fireCancelButtonPress();}t._onAfterClose(t._actionSelected);t._actionSelected=null;},ariaLabelledBy:this.getPopupHiddenLabelId()||undefined}).addStyleClass("sapMActionSheetPopover");this._parent._setAriaRoleApplication(true);if(b.browser.internet_explorer){this._parent._fnAdjustPositionAndArrow=q.proxy(function(){P.prototype._adjustPositionAndArrow.apply(this);var $=this.$(),g=$.children(".sapMPopoverCont")[0].getBoundingClientRect().width;q.each($.find(".sapMActionSheet > .sapMBtn"),function(i,h){var j=q(h),k;j.css("width","");k=h.getBoundingClientRect().width;if(k<=g){j.css("width","100%");}});},this._parent);}}else{this._parent=new D({title:this.getTitle(),type:d.Standard,content:[this],beforeOpen:function(){t.fireBeforeOpen();},afterOpen:function(){t.focus();t.fireAfterOpen();},beforeClose:function(E){t.fireBeforeClose({origin:E.getParameter("origin")});},afterClose:function(E){t._actionSelected=E.getParameter("origin");t._onAfterClose(t._actionSelected);t._actionSelected=null;b.resize.detachHandler(t._fnOrientationChange);}}).addStyleClass("sapMActionSheetDialog");if(this.getTitle()){this._parent.addStyleClass("sapMActionSheetDialogWithTitle");}else{this._parent.addAriaLabelledBy(this.getPopupHiddenLabelId()||undefined);}if(!b.system.phone){this._parent.setBeginButton(this._getCancelButton());}if(b.system.phone){this._parent.oPopup.setModal(true);this._parent._setDimensions=function(){D.prototype._setDimensions.apply(this);this.$("cont").css("max-height","");};this._parent._adjustScrollingPane=function(){var h=this.$().height();this.$("cont").css("max-height",h);if(this._oScroller){this._oScroller.refresh();}};}}if(O){O.addDependent(this._parent);}}if(!b.system.phone){this._parent.openBy(o);}else{this._parent.open();b.resize.attachHandler(this._fnOrientationChange);}};
f.prototype.close=function(){if(this._parent){this._parent.close();}};
f.prototype.isOpen=function(){return!!this._parent&&this._parent.isOpen();};
f.prototype._createCancelButton=function(){if(!this._oCancelButton){var s=(this.getCancelButtonText())?this.getCancelButtonText():sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACTIONSHEET_CANCELBUTTON_TEXT"),t=this;this._oCancelButton=new B(this.getId()+'-cancelBtn',{text:s,type:c.Reject,press:function(){if(b.system.phone&&t._parent){t._parent._oCloseTrigger=this;}t.close();t.fireCancelButtonTap();t.fireCancelButtonPress();}}).addStyleClass("sapMActionSheetButton sapMActionSheetCancelButton sapMBtnTransparent sapMBtnInverted");if(b.system.phone){this.setAggregation("_cancelButton",this._oCancelButton,true);}}return this;};
f.prototype._getCancelButton=function(){if(b.system.phone&&this.getShowCancelButton()){this._createCancelButton();return this._oCancelButton;}return null;};
f.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,true);if(this._oCancelButton){this._oCancelButton.setText(t);}return this;};
f.prototype._preProcessActionButton=function(o){var t=o.getType();if(t!==c.Accept&&t!==c.Reject){o.setType(c.Transparent);}o.addStyleClass("sapMBtnInverted");if(!o.getIcon()){o.addStyleClass("sapMActionSheetButtonNoIcon");}o.addStyleClass("sapMActionSheetButton");this._parent&&this._parent.invalidate();return this;};
f.prototype._buttonSelected=function(){if(b.system.phone&&this._parent){this._parent._oCloseTrigger=this;}this.close();};
f.prototype._orientationChange=function(){this._parent._adjustScrollingPane();};
f.prototype._addAriaHiddenTexts=function(o){var s=o.getId(),i;if(sap.ui.getCore().getConfiguration().getAccessibility()){i=new a(s+"-actionSheetHiddenText");this.addAggregation("_invisibleAriaTexts",i,false);o.addAriaLabelledBy(i.getId());}};
f.prototype._removeAriaHiddenTexts=function(o){o.getAriaLabelledBy().forEach(function(i){var g=sap.ui.getCore().byId(i);if(g instanceof a&&i.indexOf("actionSheetHiddenText")>-1){this.removeAggregation("_invisibleAriaTexts",g,false);o.removeAriaLabelledBy(g);g.destroy();}},this);};
f.prototype.addButton=function(o){this.addAggregation("buttons",o,false);this._addAriaHiddenTexts(o);this._preProcessActionButton(o);o.attachPress(this._buttonSelected,this);return this;};
f.prototype.insertButton=function(o,i){this.insertAggregation("buttons",o,i,false);this._addAriaHiddenTexts(o);this._preProcessActionButton(o);o.attachPress(this._buttonSelected,this);return this;};
f.prototype.removeButton=function(o){var r=this.removeAggregation("buttons",o,false);if(r){r.detachPress(this._buttonSelected,this);this._removeAriaHiddenTexts(r);}return r;};
f.prototype.removeAllButtons=function(){var r=this.removeAllAggregation("buttons",false),t=this;q.each(r,function(i,o){o.detachPress(t._buttonSelected,t);t._removeAriaHiddenTexts(o);});return r;};
f.prototype.clone=function(){var g=this.getButtons();for(var i=0;i<g.length;i++){g[i].detachPress(this._buttonSelected,this);}var o=C.prototype.clone.apply(this,arguments);for(var j=0;j<g.length;j++){g[j].attachPress(this._buttonSelected,this);}return o;};
f.prototype._getAllButtons=function(){return this.getButtons();};
f.prototype.getPopupHiddenLabelId=function(){return a.getStaticId("sap.m","ACTIONSHEET_AVAILABLE_ACTIONS");};
f.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
f.prototype._onAfterClose=function(o){this.fireAfterClose({origin:o});};
return f;});
sap.ui.predefine('sap/m/ActionSheetRenderer',["sap/ui/Device"],function(D){"use strict";var A={apiVersion:2};
A.render=function(r,c){var a=c._getAllButtons(),I=c.getAggregation("_invisibleAriaTexts"),R=sap.ui.getCore().getLibraryResourceBundle('sap.m'),b=a.length,d=sap.ui.getCore().getConfiguration().getAccessibility(),v=a.filter(function(B){return B.getVisible();}).length,C,i,m,B,V=1,g=function(o){return I.filter(function(e){return e.getId().indexOf(o.getId())>-1;})[0];};for(i=0;i<b;i++){B=a[i];if(B.getIcon()&&B.getVisible()){m=true;}}r.openStart("div",c);r.class("sapMActionSheet");if(m){r.class("sapMActionSheetMixedButtons");}var t=c.getTooltip_AsString();if(t){r.attr("title",t);}d&&r.attr("role","presentation");r.openEnd();for(i=0;i<b;i++){B=a[i];r.renderControl(a[i]);if(d&&B.getVisible()){C=g(B);if(C){C.setText(R.getText('ACTIONSHEET_BUTTON_INDEX',[V,v]));r.renderControl(C);}V++;}}if(D.system.phone&&c.getShowCancelButton()){r.renderControl(c._getCancelButton());}r.close("div");};
return A;},true);
sap.ui.predefine('sap/m/App',['./NavContainer','./library','./AppRenderer','sap/ui/base/DataType',"sap/ui/util/Mobile","sap/base/Log","sap/ui/thirdparty/jquery"],function(N,l,A,D,M,L,q){"use strict";
var a=N.extend("sap.m.App",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},mobileWebAppCapable:{type:"boolean",group:"Appearance",defaultValue:true}},events:{orientationChange:{deprecated:true,parameters:{landscape:{type:"boolean"}}}}}});
a.prototype.init=function(){N.prototype.init.apply(this,arguments);this.addStyleClass("sapMApp");M.init({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});q(window).on("resize",q.proxy(this._handleOrientationChange,this));};
a.prototype.onBeforeRendering=function(){if(N.prototype.onBeforeRendering){N.prototype.onBeforeRendering.apply(this,arguments);}M.init({homeIcon:this.getHomeIcon(),mobileWebAppCapable:this.getMobileWebAppCapable()});};
a.prototype.onAfterRendering=function(){if(N.prototype.onAfterRendering){N.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}};
a.prototype.exit=function(){q(window).off("resize",this._handleOrientationChange);if(this._sInitTimer){clearTimeout(this._sInitTimer);}};
a.prototype._handleOrientationChange=function(){var $=q(window);var i=$.width()>$.height();if(this._oldIsLandscape!==i){this.fireOrientationChange({landscape:i});this._oldIsLandscape=i;}};
a.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for App.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
return a;});
sap.ui.predefine('sap/m/AppRenderer',['./NavContainerRenderer','sap/ui/core/Renderer','sap/m/library'],function(N,R,l){"use strict";var B=l.BackgroundHelper;var A=R.extend(N);A.apiVersion=2;
A.renderAttributes=function(r,c){B.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
A.renderBeforeContent=function(r,c){B.renderBackgroundImageTag(r,c,"sapMAppBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return A;},true);
sap.ui.predefine('sap/m/AssociativeOverflowToolbar',['sap/base/Log','./OverflowToolbar','./OverflowToolbarRenderer','./Toolbar','sap/ui/Device'],function(L,O,a,T,D){"use strict";
var A=O.extend("sap.m.AssociativeOverflowToolbar",{
metadata:{associations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}},
renderer:a
});
A.prototype.getContent=function(){var b=this.getAssociation("content")||[];var c=[];b.forEach(function(d){var C=sap.ui.getCore().byId(d);if(C){c.push(C);}});return c;};
A.prototype.insertContent=function(c,I){var s=c.getId(),b=this.getAssociation("content").filter(function(d){return d!==s;});var i;if(I<0){i=0;}else if(I>b.length){i=b.length;}else{i=I;}if(i!==I){L.warning("AssociativeOverflowToolbar.insertContent: index '"+I+"' out of range [0,"+b.length+"], forced to "+i);}b.splice(i,0,s);this.removeAllAssociation("content");b.forEach(function(d){this.addAssociation("content",d);},this);return this;};
A.prototype.exit=function(){O.prototype.exit.apply(this,arguments);return this._callToolbarMethod('destroyContent',[true]);};
A.prototype.indexOfContent=function(c){var b=this.getAssociation("content")||[];return b.indexOf(c.getId());};
A.prototype._handleResize=function(){if(D.system.phone){this._resetAndInvalidateToolbar();}else{this._bControlsInfoCached=false;O.prototype._handleResize.apply(this,arguments);}};
A.prototype._callToolbarMethod=function(f,b){switch(f){case'addContent':return this.addAssociation("content",b[0]);case'getContent':return this.getContent();case'insertContent':return this.insertContent(b[0],b[1]);case'removeContent':return sap.ui.getCore().byId(this.removeAssociation("content",b[0],b[1],b[2]))||null;case'destroyContent':this.removeAllAssociation("content",b[0]);return this;case'removeAllContent':return this.removeAllAssociation("content",b[0]).map(function(c){return sap.ui.getCore().byId(c);});default:return T.prototype[f].apply(this,b);}};
return A;});
sap.ui.predefine('sap/m/Avatar',["sap/ui/core/Control","sap/ui/core/IconPool","./AvatarRenderer","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/Icon","./library"],function(C,I,A,K,L,a,l){"use strict";var b=l.AvatarType;var c=l.AvatarImageFitType;var d=l.AvatarColor;var e=l.AvatarSize;var f=l.AvatarShape;var g=Object.keys(d).filter(function(s){return s.indexOf("Accent")!==-1;});
var h=C.extend("sap.m.Avatar",{metadata:{library:"sap.m",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},initials:{type:"string",group:"Data",defaultValue:null},displayShape:{type:"sap.m.AvatarShape",group:"Appearance",defaultValue:f.Circle},displaySize:{type:"sap.m.AvatarSize",group:"Appearance",defaultValue:e.S},customDisplaySize:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"3rem"},customFontSize:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"1.125rem"},imageFitType:{type:"sap.m.AvatarImageFitType",group:"Appearance",defaultValue:c.Cover},fallbackIcon:{type:"string",group:"Data",defaultValue:null},backgroundColor:{type:"sap.m.AvatarColor",group:"Appearance",defaultValue:d.Accent6},showBorder:{type:"boolean",group:"Appearance",defaultValue:false},badgeIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},badgeTooltip:{type:"string",group:"Data",defaultValue:null}},aggregations:{detailBox:{type:'sap.m.LightBox',multiple:false,bindable:"bindable"},_badge:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/Avatar.designtime"}});
h.DEFAULT_CIRCLE_PLACEHOLDER="sap-icon://person-placeholder";h.DEFAULT_SQUARE_PLACEHOLDER="sap-icon://product";h.AVATAR_BADGE_TOOLTIP={"sap-icon://zoom-in":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP_ZOOMIN"),"sap-icon://camera":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP_CAMERA"),"sap-icon://edit":sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP_EDIT")};
h.prototype.init=function(){this._sActualType=null;this._bIsDefaultIcon=true;this._sImageFallbackType=null;this._sPickedRandomColor=null;this._badgeRef=null;};
h.prototype.exit=function(){if(this._icon){this._icon.destroy();}if(this._fnLightBoxOpen){this._fnLightBoxOpen=null;}if(this._badgeRef){this._badgeRef.destroy();}this._sPickedRandomColor=null;};
h.prototype.setDetailBox=function(o){var i=this.getDetailBox();if(o){if(o===i){return this;}if(i){this.detachPress(this._fnLightBoxOpen,i);}this._fnLightBoxOpen=o.open;this.attachPress(this._fnLightBoxOpen,o);}else if(this._fnLightBoxOpen){this.detachPress(this._fnLightBoxOpen,i);this._fnLightBoxOpen=null;}return this.setAggregation("detailBox",o);};
h.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments),i=o.getDetailBox();if(i){o.detachPress(this._fnLightBoxOpen,this.getDetailBox());o._fnLightBoxOpen=i.open;o.attachPress(o._fnLightBoxOpen,i);}return o;};
h.prototype.attachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")){this.$().attr("tabindex","0");this.$().attr("role","button");}return this;};
h.prototype.detachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")){this.$().removeAttr("tabindex");this.$().attr("role","img");}return this;};
h.prototype.ontap=function(){this.firePress({});};
h.prototype.onkeydown=function(E){if(E.which===K.SHIFT||E.which===K.ESCAPE){this._bShouldInterupt=this._bSpacePressed;}if(E.which===K.SPACE){this._bSpacePressed=true;E.preventDefault();}if(E.which===K.ENTER){this.firePress({});}};
h.prototype.onkeyup=function(E){if(E.which===K.SPACE){if(!this._bShouldInterupt){this.firePress({});}this._bShouldInterupt=false;this._bSpacePressed=false;E.stopPropagation();}};
h.prototype._areInitialsValid=function(i){var v=/^[a-zA-Z]{1,2}$/;if(!v.test(i)){L.warning("Initials should consist of only 1 or 2 latin letters",this);this._sActualType=b.Icon;this._bIsDefaultIcon=true;return false;}return true;};
h.prototype._validateSrc=function(s){if(I.isIconURI(s)){this._sActualType=b.Icon;this._bIsDefaultIcon=I.getIconInfo(s)?false:true;}else{this._bIsDefaultIcon=true;this._sActualType=b.Image;this.preloadedImage=new window.Image();this.preloadedImage.src=s;this.preloadedImage.onload=this._onImageLoad.bind(this);this.preloadedImage.onerror=this._onImageError.bind(this);}return this;};
h.prototype._getDisplayIcon=function(s){return I.isIconURI(s)&&I.getIconInfo(s)?I.createControlByURI({src:s}):null;};
h.prototype._getActualDisplayType=function(){var s=this.getSrc(),i=this.getInitials();if(s){this._validateSrc(s);}else if(i&&this._areInitialsValid(i)){this._sActualType=b.Initials;}else{L.warning("No src and initials were provided",this);this._sActualType=b.Icon;this._bIsDefaultIcon=true;}return this._sActualType;};
h.prototype._getImageFallbackType=function(){var i=this.getInitials();this._sImageFallbackType=i&&this._areInitialsValid(i)?b.Initials:b.Icon;return this._sImageFallbackType;};
h.prototype._getDefaultIconPath=function(D){var s=null,F=this.getFallbackIcon();if(F&&I.isIconURI(F)){s=F;}else if(D===f.Circle){s=h.DEFAULT_CIRCLE_PLACEHOLDER;}else if(D===f.Square){s=h.DEFAULT_SQUARE_PLACEHOLDER;}return s;};
h.prototype._getIcon=function(){var s=this.getSrc(),D=this.getDisplayShape();if(this._bIsDefaultIcon){s=this._getDefaultIconPath(D);}if(!this._icon){this._icon=I.createControlByURI({alt:"Image placeholder",src:s});}else if(this._icon.getSrc()!==s){this._icon.setSrc(s);}return this._icon;};
h.prototype._getDefaultTooltip=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_TOOLTIP");};
h.prototype._getBadgeIconSource=function(){var B;if(this.getDetailBox()){B="sap-icon://zoom-in";}else if(this.getBadgeIcon()!==""){if(this._getDisplayIcon(this.getBadgeIcon())){B=this.getBadgeIcon();}else{L.warning("No valid Icon URI source for badge affordance was provided");}}return B;};
h.prototype._getBadgeTooltip=function(){var B=this._getDefaultTooltip(),s=this.getBadgeIcon();if(this.getBadgeTooltip()){B=this.getBadgeTooltip();}else if(s&&h.AVATAR_BADGE_TOOLTIP[this.getBadgeIcon()]){B=h.AVATAR_BADGE_TOOLTIP[s];}return B;};
h.prototype._getBadge=function(){var B=this._getBadgeIconSource(),s=this._getBadgeTooltip();if(!B){return;}if(!this._badgeRef){this.setAggregation("_badge",new a({src:B,tooltip:s}));}this._badgeRef=this.getAggregation("_badge");return this._badgeRef;};
h.prototype._onImageLoad=function(){delete this.preloadedImage;};
h.prototype._onImageError=function(){var F=this._getImageFallbackType();this.$().removeClass("sapFAvatarImage").addClass("sapFAvatar"+F);delete this.preloadedImage;};
h.prototype._getActualBackgroundColor=function(){var B=this.getBackgroundColor();if(B===d.Random){if(this._sPickedRandomColor){return this._sPickedRandomColor;}B=this._sPickedRandomColor=d[g[g.length*Math.random()<<0]];}else{this._sPickedRandomColor=null;}return B;};
return h;});
sap.ui.predefine('sap/m/AvatarColor',[],function(){"use strict";var A={Accent1:"Accent1",Accent2:"Accent2",Accent3:"Accent3",Accent4:"Accent4",Accent5:"Accent5",Accent6:"Accent6",Accent7:"Accent7",Accent8:"Accent8",Accent9:"Accent9",Accent10:"Accent10",Random:"Random",Transparent:"Transparent",TileIcon:"TileIcon",Placeholder:"Placeholder"};return A;});
sap.ui.predefine('sap/m/AvatarImageFitType',[],function(){"use strict";var A={Cover:"Cover",Contain:"Contain"};return A;});
sap.ui.predefine('sap/m/AvatarRenderer',["sap/m/library","sap/base/security/encodeCSS"],function(l,e){"use strict";var A=l.AvatarSize;var a=l.AvatarType;var b={apiVersion:2};
b.render=function(r,o){var i=o.getInitials(),s=o._getActualDisplayType(),I=o._getImageFallbackType(),d=o.getDisplaySize(),D=o.getDisplayShape(),c=o.getImageFitType(),C=o.getCustomDisplaySize(),f=o.getCustomFontSize(),S=o.getSrc(),g="sapFAvatar",t=o.getTooltip_AsString(),L=o.getAriaLabelledBy(),h=o.getAriaDescribedBy(),B=o.hasListeners("press")?o._getBadge():null,j=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("AVATAR_ROLE_DESCRIPTION");r.openStart("span",o);r.class(g);r.class("sapFAvatarColor"+o._getActualBackgroundColor());r.class(g+d);r.class(g+s);r.class(g+D);if(o.hasListeners("press")){r.class("sapMPointer");r.class(g+"Focusable");r.attr("role","button");r.attr("tabindex",0);}else{r.attr("role","img");}r.attr("aria-roledescription",j);if(o.getShowBorder()){r.class("sapFAvatarBorder");}if(d===A.Custom){r.style("width",C);r.style("height",C);r.style("font-size",f);}if(t){r.attr("title",t);r.attr("aria-label",t);}else if(i){r.attr("aria-label",i);}if(L&&L.length>0){r.attr("aria-labelledby",L.join(" "));}if(h&&h.length>0){r.attr("aria-describedby",h.join(" "));}r.openEnd();if(s===a.Icon||I===a.Icon){r.renderControl(o._getIcon().addStyleClass(g+"TypeIcon"));}else if(s===a.Initials||I===a.Initials){r.openStart("span");r.class(g+"InitialsHolder");r.openEnd();r.text(i);r.close("span");}if(s===a.Image){r.openStart("span");r.class(g+"ImageHolder");r.class(g+s+c);r.style("background-image","url('"+e(S)+"')");r.openEnd();r.close("span");}if(B){r.openStart("div");r.class(g+"BadgeIconActiveArea");if(C){r.style("font-size",C);}r.openEnd();r.openStart("span");r.class(g+"BadgeIcon");r.openEnd();r.renderControl(B);r.close("span");r.close("div");}r.close("span");};
return b;},true);
sap.ui.predefine('sap/m/AvatarShape',[],function(){"use strict";var A={Circle:"Circle",Square:"Square"};return A;});
sap.ui.predefine('sap/m/AvatarSize',[],function(){"use strict";var A={XS:"XS",S:"S",M:"M",L:"L",XL:"XL",Custom:"Custom"};return A;});
sap.ui.predefine('sap/m/AvatarType',[],function(){"use strict";var A={Icon:"Icon",Image:"Image",Initials:"Initials"};return A;});
sap.ui.predefine('sap/m/BadgeCustomData',['sap/ui/core/CustomData','sap/base/Log'],function(C,L){"use strict";
var B=C.extend("sap.m.BadgeCustomData",{metadata:{properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true}}}});
B.prototype.init=function(){var p=this.getParent();if(p&&!p.isA("sap.m.IBadge")){L.warning("BadgeCustomData must be attached only to controls, which implement sap.m.IBadge");}};
B.prototype.setValue=function(v){if(this.getValue()===v){return this;}var p=this.getParent();C.prototype.setValue.call(this,v);if(p&&typeof v==="string"){p.updateBadgeValue(v);}return this;};
B.prototype.setVisible=function(v){if(this.getVisible()===v){return this;}var p=this.getParent();if(p){p.updateBadgeVisibility(v);}this.setProperty("visible",v,true);return this;};
B.prototype.setKey=function(){return this;};
return B;});
sap.ui.predefine('sap/m/BadgeEnabler',['sap/m/BadgeCustomData','sap/base/Log','sap/m/library'],function(B,L,l){"use strict";var I="sapMBadge";var a={topLeft:"sapMBadgeTopLeft",topRight:"sapMBadgeTopRight",inline:"sapMBadgeInline"};var b=l.BadgeState;var c=l.BadgeStyle;var d=["","undefined","null"];var e=function(){this.initBadgeEnablement=function(C,o){var D=o?o:this;this._oBadgeConfig=C||{};D.addEventDelegate({onAfterRendering:f},this);};function _(C,o){if(C.suffix){return o.$(C.suffix);}if(C.selector){return o.$().find(C.selector).first();}}function f(){this._isBadgeAttached=false;if(!this.getBadgeCustomData()||!this.getBadgeCustomData().getVisible()){return false;}j.call(this);if(!Object.keys(this._oBadgeConfig).length){return this;}return this;}function g(){var o=h.call(this);o.removeClass("sapMBadgeAnimationUpdate");o.removeClass("sapMBadgeAnimationAdd");o.width();o.addClass("sapMBadgeAnimationRemove");o.removeAttr("aria-label");this._isBadgeAttached=false;m.call(this,"",b["Disappear"]);return this;}function h(){return this.$(I);}function i(){return this.getId()+"-"+I;}function j(){var o,s=i.call(this),p=h.call(this),v=this._oBadgeCustomData.getValue(),S=this._oBadgeConfig.style?this._oBadgeConfig.style:c.Default;this._oBadgeContainer=this._oBadgeConfig&&this._oBadgeConfig.selector?_(this._oBadgeConfig.selector,this):this.$();if(p.length){p.remove();}o=jQuery('<div></div>').addClass(I+"Indicator");o.addClass(I+S);o.attr("id",s);o.attr("data-badge",v);o.attr("aria-label",k.call(this));o.appendTo(this._oBadgeContainer);o.addClass("sapMBadgeAnimationAdd");this._isBadgeAttached=true;this._oBadgeContainer.addClass(I);if(this._oBadgeConfig.position){this._oBadgeContainer.addClass(a[this._oBadgeConfig.position]);}if(this._oBadgeConfig.accentColor){this._oBadgeContainer.addClass(I+this._oBadgeConfig.accentColor);}m.call(this,v,b["Appear"]);}this.updateBadgeValue=function(v){if(!this._oBadgeCustomData.getVisible()){return false;}var o=h.call(this),v=n(v||this.getBadgeCustomData().getValue())||"";o.removeClass("sapMBadgeAnimationUpdate");o.attr("data-badge",v);o.attr("aria-label",k.call(this));o.width();o.addClass("sapMBadgeAnimationUpdate");m.call(this,v,b["Updated"]);};function k(){var A=this.getAriaLabelBadgeText;return A&&typeof A==="function"&&A.call(this);}function m(v,s){if(this.onBadgeUpdate&&typeof this.onBadgeUpdate==="function"){var o=i.call(this);return this.onBadgeUpdate(v,s,o);}}function n(v){return d.indexOf(v)===-1&&v;}this.addCustomData=function(C){if(C.isA("sap.m.BadgeCustomData")){this.removeAggregation("customData",this._oBadgeCustomData,true);this._oBadgeCustomData=C;this.addAggregation("customData",C,true);return this.updateBadgeVisibility(C.getVisible());}return this.addAggregation("customData",C);};this.insertCustomData=function(C){if(C.isA("sap.m.BadgeCustomData")){this.removeAggregation("customData",this._oBadgeCustomData,true);this._oBadgeCustomData=C;this.addAggregation("customData",C,true);return this.updateBadgeVisibility(C.getVisible());}return this.insertAggregation("customData",C);};this.getBadgeCustomData=function(){var o=this.getCustomData().filter(function(p){return p instanceof B;});return o.length?o[0]:undefined;};this.removeBadgeCustomData=function(){var o;o=this._oBadgeCustomData;this._oBadgeCustomData=null;return this.removeAggregation("customData",o,true);};this.setBadgeAccentColor=function(v){if(!this._oBadgeContainer){return false;}this._oBadgeContainer.removeClass(I+this._oBadgeConfig.accentColor);this._oBadgeContainer.addClass(I+v);this._oBadgeConfig.accentColor=v;};this.setBadgePosition=function(v){if(!this._oBadgeContainer){return false;}this._oBadgeContainer.removeClass(I+this._oBadgeConfig.position);this._oBadgeContainer.addClass(a[v]);this._oBadgeConfig.position=v;};this.updateBadgeVisibility=function(v){return v?j.call(this):g.call(this);};this._renderBadge=function(){f.call(this);};};return e;});
sap.ui.predefine('sap/m/Bar',['./BarInPageEnabler','./library','sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/ui/Device','./BarRenderer',"sap/ui/thirdparty/jquery"],function(B,l,C,R,D,a,q){"use strict";var b=l.BarDesign;
var c=C.extend("sap.m.Bar",{metadata:{interfaces:["sap.m.IBar"],library:"sap.m",properties:{enableFlexBox:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},translucent:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},design:{type:"sap.m.BarDesign",group:"Appearance",defaultValue:b.Auto}},aggregations:{contentLeft:{type:"sap.ui.core.Control",multiple:true,singularName:"contentLeft"},contentMiddle:{type:"sap.ui.core.Control",multiple:true,singularName:"contentMiddle"},contentRight:{type:"sap.ui.core.Control",multiple:true,singularName:"contentRight"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/m/designtime/Bar.designtime",dnd:{draggable:false,droppable:true}}});
c.prototype.onBeforeRendering=function(){this._removeAllListeners();};
c.prototype.onAfterRendering=function(){this._handleResize();};
c.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);};
c.prototype.exit=function(){this._removeAllListeners();if(this._oflexBox){this._oflexBox.destroy();this._oflexBox=null;}this._$MidBarPlaceHolder=null;this._$RightBar=null;this._$LeftBar=null;};
c._aResizeHandlers=["_sResizeListenerId","_sResizeListenerIdMid","_sResizeListenerIdRight","_sResizeListenerIdLeft"];
c.prototype._removeAllListeners=function(){var t=this;c._aResizeHandlers.forEach(function(i){t._removeListenerFailsave(i);});};
c.prototype._removeListenerFailsave=function(L){if(this[L]){R.deregister(this[L]);this[L]=null;}};
c.prototype._handleResize=function(){this._removeAllListeners();var e=!!this.getContentLeft().length,f=!!this.getContentMiddle().length,g=!!this.getContentRight().length;if(!this.getVisible()){return;}if(!e&&!f&&!g){return;}this._$LeftBar=this.$("BarLeft");this._$RightBar=this.$("BarRight");this._$MidBarPlaceHolder=this.$("BarPH");this._updatePosition(e,f,g);this._sResizeListenerId=R.register(this.getDomRef(),q.proxy(this._handleResize,this));if(this.getEnableFlexBox()){return;}if(e){this._sResizeListenerIdLeft=R.register(this._$LeftBar[0],q.proxy(this._handleResize,this));}if(f){this._sResizeListenerIdMid=R.register(this._$MidBarPlaceHolder[0],q.proxy(this._handleResize,this));}if(g){this._sResizeListenerIdRight=R.register(this._$RightBar[0],q.proxy(this._handleResize,this));}};
c.prototype._updatePosition=function(e,f,g){if(!e&&!g&&f){return;}if(e&&!f&&!g){return;}if(!e&&!f&&g){return;}var i=this.$().outerWidth(true);this._$RightBar.css({width:""});this._$LeftBar.css({width:""});if(D.browser.msie){this._$MidBarPlaceHolder.css({position:"",width:""});}else{this._$MidBarPlaceHolder.css({position:"",width:"",visibility:"hidden"});}var r=this._$RightBar.outerWidth(true);if(r>i){if(e){this._$LeftBar.css({width:"0px"});}if(f){this._$MidBarPlaceHolder.css({width:"0px"});}this._$RightBar.css({width:i+"px"});return;}var L=this._getBarContainerWidth(this._$LeftBar);if(i<(L+r)){L=i-r;this._$LeftBar.css({width:L+"px"});this._$MidBarPlaceHolder.css({width:"0px"});return;}this._$MidBarPlaceHolder.css(this._getMidBarCss(r,i,L));};
c.prototype._getMidBarCss=function(r,i,L){var m=this._$MidBarPlaceHolder.outerWidth(true),e=sap.ui.getCore().getConfiguration().getRTL(),s=e?"right":"left",M={visibility:""};if(this.getEnableFlexBox()){m=i-L-r-parseInt(this._$MidBarPlaceHolder.css('margin-left'))-parseInt(this._$MidBarPlaceHolder.css('margin-right'));M.position="absolute";M.width=m+"px";M[s]=L;return M;}var S=i-L-r,f=(i/2)-(m/2),g=L>f,h=(i/2)+(m/2),j=(i-r)<h;if(this._$MidBarPlaceHolder.closest(".sapMBarTitleStart").length>0||(S>0&&(g||j))){M.position="absolute";M.width=S+"px";M.left=e?r:L;}return M;};
c.prototype._getBarContainerWidth=function($){var i,e=0,f=$.children(),g=0;if(D.browser.webkit||D.browser.firefox||D.browser.edge){for(i=0;i<f.length;i++){g+=q(f[i]).outerWidth(true);}e=$.outerWidth(true);}else{var o;for(i=0;i<f.length;i++){o=window.getComputedStyle(f[i]);if(o.width=="auto"){g+=q(f[i]).width()+1;}else{g+=parseFloat(o.width);}g+=parseFloat(o.marginLeft);g+=parseFloat(o.marginRight);g+=parseFloat(o.paddingLeft);g+=parseFloat(o.paddingRight);}var h=window.getComputedStyle($[0]);e+=parseFloat(h.width);e+=parseFloat(h.marginLeft);e+=parseFloat(h.marginRight);e+=parseFloat(h.paddingLeft);e+=parseFloat(h.paddingRight);}if(e<g){e=g;}return e;};
var d=B.extend("sap.m.BarInAnyContentEnabler",{});
d.mContexts={dialogFooter:{contextClass:"sapMFooter-CTX",tag:"Footer"}};
d.prototype.getContext=function(){var p=B.prototype.getContext.call();for(var k in d.mContexts){p[k]=d.mContexts[k];}return p;};
c.prototype.getContext=d.prototype.getContext;c.prototype.isContextSensitive=d.prototype.isContextSensitive;c.prototype.setHTMLTag=d.prototype.setHTMLTag;c.prototype.getHTMLTag=d.prototype.getHTMLTag;c.prototype.applyTagAndContextClassFor=d.prototype.applyTagAndContextClassFor;c.prototype._applyContextClassFor=d.prototype._applyContextClassFor;c.prototype._applyTag=d.prototype._applyTag;c.prototype._getContextOptions=d.prototype._getContextOptions;c.prototype._setRootAccessibilityRole=d.prototype._setRootAccessibilityRole;c.prototype._getRootAccessibilityRole=d.prototype._getRootAccessibilityRole;c.prototype._setRootAriaLevel=d.prototype._setRootAriaLevel;c.prototype._getRootAriaLevel=d.prototype._getRootAriaLevel;return c;});
sap.ui.predefine('sap/m/BarInPageEnabler',['sap/ui/base/Object','sap/m/library',"sap/base/Log"],function(O,l,L){"use strict";var I=l.IBarHTMLTag;var c={footer:{contextClass:"sapMFooter-CTX sapContrast sapContrastPlus",tag:"Footer",internalAriaLabel:"BAR_ARIA_DESCRIPTION_FOOTER"},header:{contextClass:"sapMHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_HEADER"},subheader:{contextClass:"sapMSubHeader-CTX",tag:"Header",internalAriaLabel:"BAR_ARIA_DESCRIPTION_SUBHEADER"}};var a="sapMIBar";
var B=O.extend("sap.m.BarInPageEnabler",{
isContextSensitive:function(){return this.getDesign&&this.getDesign()==="Auto";},
setHTMLTag:function(n){if(n===this.sTag){return this;}this.sTag=n;return this;},
getHTMLTag:function(){if(!this.hasOwnProperty("sTag")){this.sTag=I.Div;}return this.sTag;},
getContext:function(){return c;},
_getRootAccessibilityRole:function(){var r=this._sRootAccessibilityRole||"toolbar";return r;},
_setRootAccessibilityRole:function(r){this._sRootAccessibilityRole=r;return this;},
_getRootAriaLevel:function(){var A=this.sAriaLevel;return A;},
_setRootAriaLevel:function(s){this.sAriaLevel=s;return this;},
applyTagAndContextClassFor:function(C){this._applyTag(C);return this._applyContextClassFor(C);},
_applyContextClassFor:function(C){var o=this._getContextOptions(C);if(!o){return this;}if(!this.isContextSensitive){L.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}if(!this.getRenderer().shouldAddIBarContext()){this.addStyleClass(a+"-CTX");}if(this.isContextSensitive()){this.addStyleClass(o.contextClass);}return this;},
_applyTag:function(C){var o=this._getContextOptions(C);if(!o){return this;}if(!this.setHTMLTag){L.error("The bar control you are using does not implement all the members of the IBar interface",this);return this;}this.setHTMLTag(o.tag);return this;},
_getContextOptions:function(C){var o;if(this.getContext){o=this.getContext();}else{o=c;}var b=o[C];if(!b){L.error("The context "+C+" is not known",this);return null;}return b;},
render:function(r,C){var t=C.getHTMLTag().toLowerCase();r.openStart(t,C);r.class(a);if(this.shouldAddIBarContext(C)){r.class(a+"-CTX");}B.renderTooltip(r,C);this.decorateRootElement(r,C);r.openEnd();this.renderBarContent(r,C);r.close(t);}
});
B.renderTooltip=function(r,C){var t=C.getTooltip_AsString();if(t){r.attr("title",t);}};
B.addChildClassTo=function(C){C.addStyleClass("sapMBarChild");};
return B;});
sap.ui.predefine('sap/m/BarRenderer',['./BarInPageEnabler','sap/ui/Device',"sap/base/Log",'sap/m/HBox'],function(B,D,L,H){"use strict";var a={apiVersion:2};a.render=B.prototype.render;
a.decorateRootElement=function(r,c){r.class("sapMBar");r.class(this.getContext(c));r.accessibilityState(c,{"role":c._getRootAccessibilityRole(),"level":c._getRootAriaLevel()});if(c.getTranslucent()&&D.support.touch){r.class("sapMBarTranslucent");}r.class("sapMBar-CTX");};
a.shouldAddIBarContext=function(){return true;};
a.renderBarContent=function(r,c){r.openStart("div",c.getId()+"-BarLeft");r.class("sapMBarLeft");r.class("sapMBarContainer");w("left",r,c);r.openEnd();this.renderAllControls(c.getContentLeft(),r,c);r.close("div");r.openStart("div",c.getId()+"-BarMiddle");r.class("sapMBarMiddle");r.openEnd();if(c.getEnableFlexBox()){c._oflexBox=c._oflexBox||new H(c.getId()+"-BarPH",{alignItems:"Center"}).addStyleClass("sapMBarPH").setParent(c,null,true);var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;if(b&&!C&&!d){c._oflexBox.addStyleClass("sapMBarFlexBoxWidth100");}c.getContentMiddle().forEach(function(m){c._oflexBox.addItem(m);});r.renderControl(c._oflexBox);}else{r.openStart("div",c.getId()+"-BarPH");r.class("sapMBarPH");r.class("sapMBarContainer");w("middle",r,c);r.openEnd();this.renderAllControls(c.getContentMiddle(),r,c);r.close("div");}r.close("div");r.openStart("div",c.getId()+"-BarRight");r.class("sapMBarRight");r.class("sapMBarContainer");if(sap.ui.getCore().getConfiguration().getRTL()){r.class("sapMRTL");}w("right",r,c);r.openEnd();this.renderAllControls(c.getContentRight(),r,c);r.close("div");};
a.renderAllControls=function(c,r,b){c.forEach(function(C){B.addChildClassTo(C,b);r.renderControl(C);});};
a._mContexts={Header:"sapMHeader-CTX",SubHeader:"sapMSubHeader-CTX",Footer:"sapMFooter-CTX",Default:"sapMContent-CTX"};
a.getContext=function(c){var d=c.getDesign(),C=a._mContexts;return C[d]||C.Default;};
function w(A,r,c){var C=!!c.getContentLeft().length,b=!!c.getContentMiddle().length,d=!!c.getContentRight().length;switch(A.toLowerCase()){case"left":if(C&&!b&&!d){r.style("width","100%");}break;case"middle":if(b&&!C&&!d){r.style("width","100%");}break;case"right":if(d&&!C&&!b){r.style("width","100%");}break;default:L.error("Cannot determine which of the three content aggregations is alone");}}
return a;},true);
sap.ui.predefine('sap/m/Breadcrumbs',["sap/ui/core/Control","sap/m/Text","sap/m/Link","sap/m/Select","sap/ui/core/Item","sap/ui/core/delegate/ItemNavigation","sap/ui/core/ResizeHandler","sap/ui/core/IconPool","sap/ui/Device","sap/m/library","./BreadcrumbsRenderer"],function(C,T,L,S,I,a,R,b,D,l,B){"use strict";var c=l.SelectType,d=l.BreadcrumbsSeparatorStyle;
var e=C.extend("sap.m.Breadcrumbs",{metadata:{library:"sap.m",interfaces:["sap.m.IBreadcrumbs"],designtime:"sap/m/designtime/Breadcrumbs.designtime",properties:{currentLocationText:{type:"string",group:"Behavior",defaultValue:null},separatorStyle:{type:"sap.m.BreadcrumbsSeparatorStyle",group:"Appearance",defaultValue:d.Slash}},aggregations:{links:{type:"sap.m.Link",multiple:true,singularName:"link"},_currentLocation:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},defaultAggregation:"links"}});
e.STYLE_MAPPER={Slash:"/",BackSlash:"\\",DoubleSlash:"//",DoubleBackSlash:"\\\\",GreaterThan:">",DoubleGreaterThan:">>"};
e.prototype.init=function(){this._sSeparatorSymbol=e.STYLE_MAPPER[this.getSeparatorStyle()];};
e.prototype.onBeforeRendering=function(){this.bRenderingPhase=true;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._bControlsInfoCached){this._updateSelect(true);}};
e.prototype.onAfterRendering=function(){if(!this._sResizeListenerId){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}if(!this._bControlsInfoCached){this._updateSelect(true);return;}this._configureKeyboardHandling();this.bRenderingPhase=false;};
e.prototype.onThemeChanged=function(){this._resetControl();};
e.prototype.exit=function(){this._resetControl();this._destroyItemNavigation();};
e.PAGEUP_AND_PAGEDOWN_JUMP_SIZE=5;
e.prototype._getAugmentedId=function(s){return this.getId()+"-"+s;};
e.prototype._getSelect=function(){if(!this.getAggregation("_select")){this.setAggregation("_select",this._decorateSelect(new S({id:this._getAugmentedId("select"),change:this._selectChangeHandler.bind(this),forceSelection:false,autoAdjustWidth:true,icon:b.getIconURI("slim-arrow-down"),type:c.IconOnly,tooltip:B._getResourceBundleText("BREADCRUMB_SELECT_TOOLTIP")})),true);}return this.getAggregation("_select");};
e.prototype._getCurrentLocation=function(){if(!this.getAggregation("_currentLocation")){var o=new T({id:this._getAugmentedId("currentText"),text:this.getCurrentLocationText(),wrapping:false}).addStyleClass("sapMBreadcrumbsCurrentLocation");o.addEventDelegate({onAfterRendering:function(){o.$().attr("aria-current","page");}});this.setAggregation("_currentLocation",o).addStyleClass("sapMBreadcrumbsCurrentLocation");}return this.getAggregation("_currentLocation");};
function f(A,g){var h=Array.prototype.slice.apply(g);h.unshift(A);return h;}
e.prototype.insertLink=function(o,i){var r=this.insertAggregation.apply(this,f("links",arguments));this._registerControlListener(o);this._resetControl();return r;};
e.prototype.addLink=function(o){var r=this.addAggregation.apply(this,f("links",arguments));this._registerControlListener(o);this._resetControl();return r;};
e.prototype.removeLink=function(o){var r=this.removeAggregation.apply(this,f("links",arguments));this._deregisterControlListener(r);this._resetControl();return r;};
e.prototype.removeAllLinks=function(){var g=this.getAggregation("links",[]);var r=this.removeAllAggregation.apply(this,f("links",arguments));g.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
e.prototype.destroyLinks=function(){var g=this.getAggregation("links",[]);var r=this.destroyAggregation.apply(this,f("links",arguments));g.forEach(this._deregisterControlListener,this);this._resetControl();return r;};
e.prototype._decorateSelect=function(s){s.getPicker().attachAfterOpen(this._removeItemNavigation,this).attachBeforeClose(this._restoreItemNavigation,this);s._onBeforeOpenDialog=this._onSelectBeforeOpenDialog.bind(this);s._onBeforeOpenPopover=this._onSelectBeforeOpenPopover.bind(this);s.onsapescape=this._onSelectEscPress.bind(this);return s;};
e.prototype._removeItemNavigation=function(){this.removeDelegate(this._getItemNavigation());};
e.prototype._onSelectBeforeOpenDialog=function(){var s=this._getSelect();if(this.getCurrentLocationText()&&D.system.phone){s.setSelectedIndex(0);}else{s.setSelectedItem(null);}S.prototype._onBeforeOpenDialog.call(s);this._removeItemNavigation();};
e.prototype._onSelectBeforeOpenPopover=function(){this._getSelect().setSelectedItem(null);this._removeItemNavigation();};
e.prototype._restoreItemNavigation=function(){this.addDelegate(this._getItemNavigation());};
e.prototype._onSelectEscPress=function(){this._getSelect().close();};
e.prototype._createSelectItem=function(i){return new I({key:i.getId(),text:i.getText()});};
e.prototype._selectChangeHandler=function(E){var o,s,g,h=E.getParameter("selectedItem");if(!h){return;}if(!this._getSelect().isOpen()){return;}o=sap.ui.getCore().byId(h.getKey());if(!(o instanceof L)){return;}s=o.getHref();g=o.getTarget();o.firePress();if(s){if(g){window.open(s,g);}else{window.location.href=s;}}};
e.prototype._getItemsForMobile=function(){var i=this.getLinks();if(this.getCurrentLocationText()){i.push(this._getCurrentLocation());}return i;};
e.prototype._updateSelect=function(i){var s=this._getSelect(),g,o=this._getControlDistribution();if(!this._bControlDistributionCached||i){s.destroyItems();g=D.system.phone?this._getItemsForMobile():o.aControlsForSelect;g.map(this._createSelectItem).reverse().forEach(s.insertItem,s);this._bControlDistributionCached=true;this.invalidate(this);}s.setVisible(!!o.aControlsForSelect.length);if(!this._sResizeListenerId&&!this.bRenderingPhase){this._sResizeListenerId=R.register(this,this._handleScreenResize.bind(this));}};
e.prototype._getControlsForBreadcrumbTrail=function(){var v;if(this._bControlDistributionCached&&this._oDistributedControls){return this._oDistributedControls.aControlsForBreadcrumbTrail;}v=this.getLinks().filter(function(o){return o.getVisible();});if(this.getCurrentLocationText()){return v.concat([this._getCurrentLocation()]);}return v;};
e.prototype._getControlInfo=function(o){return{id:o.getId(),control:o,width:o.$().parent().outerWidth(true),bCanOverflow:o instanceof L};};
e.prototype._getControlDistribution=function(m){m=m||this._iContainerSize;this._iContainerSize=m;this._oDistributedControls=this._determineControlDistribution(m);return this._oDistributedControls;};
e.prototype._getSelectWidth=function(){return this._getSelect().getVisible()&&this._iSelectWidth||0;};
e.prototype._determineControlDistribution=function(m){var i,o,g=this._getControlsInfo().aControlInfo,s=this._getSelectWidth(),h=[],j=[],u=s;for(i=g.length-1;i>=0;i--){o=g[i];u+=o.width;if(g.length-1===i){j.push(o.control);continue;}if(i===0){u-=s;}if(u>m&&o.bCanOverflow){h.unshift(o.control);}else{j.unshift(o.control);}}return{aControlsForBreadcrumbTrail:j,aControlsForSelect:h};};
e.prototype._getControlsInfo=function(){if(!this._bControlsInfoCached){this._iSelectWidth=this._getSelect().$().parent().outerWidth(true)||0;this._aControlInfo=this._getControlsForBreadcrumbTrail().map(this._getControlInfo);this._iContainerSize=this.$().outerWidth(true);this._bControlsInfoCached=true;}return{aControlInfo:this._aControlInfo,iSelectWidth:this._iSelectWidth,iContentSize:this._iContainerSize};};
e.prototype._handleScreenResize=function(E){var i=this._oDistributedControls.aControlsForBreadcrumbTrail.length,o=this._getControlDistribution(E.size.width),g=o.aControlsForBreadcrumbTrail.length;if(i!==g){this._updateSelect(true);}return this;};
e.prototype._getItemsToNavigate=function(){var i=this._getControlsForBreadcrumbTrail().slice(),s=this._getSelect();if(s.getVisible()){i.unshift(s);}return i;};
e.prototype._getItemNavigation=function(){if(!this._itemNavigation){this._itemNavigation=new a();}return this._itemNavigation;};
e.prototype._destroyItemNavigation=function(){if(this._itemNavigation){this.removeEventDelegate(this._itemNavigation);this._itemNavigation.destroy();this._itemNavigation=null;}};
e.prototype._configureKeyboardHandling=function(){var i=this._getItemNavigation(),s=-1,g=this._getItemsToNavigate(),n=[];if(g.length===0){return;}g.forEach(function(o,h){if(h===0){o.$().attr("tabindex","0");}o.$().attr("tabindex","-1");n.push(o.getDomRef());});this.addDelegate(i);i.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"],saphome:["alt"],sapend:["alt"]});i.setCycling(false);i.setPageSize(e.PAGEUP_AND_PAGEDOWN_JUMP_SIZE);i.setRootDomRef(this.getDomRef());i.setItemDomRefs(n);i.setSelectedIndex(s);return this;};
e.prototype._registerControlListener=function(o){if(o){o.attachEvent("_change",this._resetControl,this);}};
e.prototype._deregisterControlListener=function(o){if(o){o.detachEvent("_change",this._resetControl,this);}};
e.prototype.setCurrentLocationText=function(t){var o=this._getCurrentLocation(),r=this.setProperty("currentLocationText",t,true);if(o.getText()!==t){o.setText(t);this._resetControl();}return r;};
e.prototype.setSeparatorStyle=function(s){this.setProperty("separatorStyle",s);var g=e.STYLE_MAPPER[this.getSeparatorStyle()];if(g){this._sSeparatorSymbol=g;}return this;};
e.prototype._resetControl=function(){this._aControlInfo=null;this._iContainerSize=null;this._bControlsInfoCached=null;this._bControlDistributionCached=null;this._oDistributedControls=null;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.removeDelegate(this._getItemNavigation());this.invalidate(this);return this;};
return e;});
sap.ui.predefine('sap/m/BreadcrumbsRenderer',["sap/m/Text"],function(T){"use strict";var B={apiVersion:2};var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
B.render=function(R,c){var C=c._getControlsForBreadcrumbTrail(),s=c._getSelect(),S=c._sSeparatorSymbol;R.openStart("nav",c);R.class("sapMBreadcrumbs");R.attr("aria-label",B._getResourceBundleText("BREADCRUMB_LABEL"));R.openEnd();R.openStart("ol");R.openEnd();if(s.getVisible()){this._renderControlInListItem(R,s,S,false,"sapMBreadcrumbsSelectItem");}C.forEach(function(o){this._renderControlInListItem(R,o,S,o instanceof T);},this);R.close("ol");R.close("nav");};
B._renderControlInListItem=function(R,c,s,S,a){R.openStart("li");R.class("sapMBreadcrumbsItem");R.class(a);R.openEnd();R.renderControl(c);if(!S){R.openStart("span").class("sapMBreadcrumbsSeparator").openEnd().text(s).close("span");}R.close("li");};
B._getResourceBundleText=function(t){return r.getText(t);};
return B;},true);
sap.ui.predefine('sap/m/BusyDialog',['./library','sap/ui/core/Control','sap/m/Dialog','sap/m/BusyIndicator','sap/m/Label','sap/m/Button',"sap/base/Log",'sap/ui/core/Core'],function(l,C,D,B,L,a,b,c){"use strict";
var d=C.extend("sap.m.BusyDialog",{
metadata:{library:"sap.m",properties:{text:{type:"string",group:"Appearance",defaultValue:''},title:{type:"string",group:"Appearance",defaultValue:''},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:''},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},cancelButtonText:{type:"string",group:"Misc",defaultValue:''},showCancelButton:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{close:{parameters:{cancelPressed:{type:"boolean"}}}},designtime:"sap/m/designtime/BusyDialog.designtime"},
renderer:{apiVersion:2,render:function(r,o){}}
});
d.prototype.init=function(){this._busyIndicator=new B(this.getId()+'-busyInd',{visible:true});this._oDialog=new D(this.getId()+'-Dialog',{content:this._busyIndicator,showHeader:false,afterClose:this._fnCloseHandler.bind(this),initialFocus:this._busyIndicator.getId()+'-busyIndicator'}).addStyleClass('sapMBusyDialog');this._oDialog.close=function(){};this._oDialog.addEventDelegate({onBeforeRendering:function(){var t=this.getText(),e=this.getTitle(),s=this.getShowCancelButton()||this.getCancelButtonText();if(!t&&!e&&!s){this._oDialog.addStyleClass('sapMBusyDialog-Light');}else{this._oDialog.removeStyleClass('sapMBusyDialog-Light');}}},this);this._oDialog.oPopup.onsapescape=function(e){this.close(true);}.bind(this);};
d.prototype.exit=function(){this._busyIndicator.destroy();this._busyIndicator=null;if(this._cancelButton){this._cancelButton.destroy();this._cancelButton=null;}if(this._oLabel){this._oLabel.destroy();this._oLabel=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}};
d.prototype.open=function(){b.debug("sap.m.BusyDialog.open called at "+new Date().getTime());if(this.getAriaLabelledBy()&&!this._oDialog._$dialog){var t=this;this.getAriaLabelledBy().forEach(function(i){t._oDialog.addAriaLabelledBy(i);});}if(!document.body||!c.isInitialized()){setTimeout(function(){this.open();}.bind(this),50);}else{this._oDialog.open();}return this;};
d.prototype.close=function(i){this._isClosedFromUserInteraction=i;D.prototype.close.call(this._oDialog);return this;};
d.prototype._fnCloseHandler=function(){this.fireClose({cancelPressed:this._isClosedFromUserInteraction||false});};
d.prototype.setTitle=function(t){this.setProperty('title',t,true);this._oDialog.setTitle(t).setShowHeader(!!t);return this;};
d.prototype.setTooltip=function(t){this._oDialog.setTooltip(t);return this;};
d.prototype.getTooltip=function(){return this._oDialog.getTooltip();};
d.prototype.setText=function(t){this.setProperty('text',t,true);if(!this._oLabel){if(t){this._oLabel=new L(this.getId()+'-TextLabel',{text:t}).addStyleClass('sapMBusyDialogLabel');this._oDialog.insertAggregation('content',this._oLabel,0);this._oDialog.addAriaLabelledBy(this._oLabel.getId());}}else{if(t){this._oLabel.setText(t).setVisible(true);}else{this._oLabel.setVisible(false);}}return this;};
d.prototype.setCustomIcon=function(i){this.setProperty("customIcon",i,true);this._busyIndicator.setCustomIcon(i);return this;};
d.prototype.setCustomIconRotationSpeed=function(s){this.setProperty("customIconRotationSpeed",s,true);this._busyIndicator.setCustomIconRotationSpeed(s);return this;};
d.prototype.setCustomIconDensityAware=function(i){this.setProperty("customIconDensityAware",i,true);this._busyIndicator.setCustomIconDensityAware(i);return this;};
d.prototype.setCustomIconWidth=function(w){this.setProperty("customIconWidth",w,true);this._busyIndicator.setCustomIconWidth(w);return this;};
d.prototype.setCustomIconHeight=function(h){this.setProperty("customIconHeight",h,true);this._busyIndicator.setCustomIconHeight(h);return this;};
d.prototype.setShowCancelButton=function(i){this.setProperty("showCancelButton",i,false);if(i){this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
d.prototype.setCancelButtonText=function(t){this.setProperty("cancelButtonText",t,false);if(t){this._getCancelButton().setText(t);this._oDialog.setEndButton(this._getCancelButton());}else{this._destroyTheCancelButton();}return this;};
d.prototype.getDomRef=function(){return this._oDialog&&this._oDialog.getDomRef();};
["addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass"].forEach(function(A){d.prototype[A]=function(){if(this._oDialog&&this._oDialog[A]){this._oDialog[A].apply(this._oDialog,arguments);return this;}};});
d.prototype._destroyTheCancelButton=function(){this._oDialog.destroyEndButton();this._cancelButton=null;};
d.prototype._getCancelButton=function(){var e=this.getCancelButtonText();e=e?e:c.getLibraryResourceBundle("sap.m").getText("BUSYDIALOG_CANCELBUTTON_TEXT");return this._cancelButton?this._cancelButton:this._cancelButton=new a(this.getId()+'busyCancelBtn',{text:e,press:function(){this.close(true);}.bind(this)});};
return d;});
sap.ui.predefine('sap/m/BusyIndicator',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Image','sap/m/Label',"./BusyIndicatorRenderer"],function(l,C,c,I,L,B){"use strict";var T=c.TextDirection;
var a=C.extend("sap.m.BusyIndicator",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Data",defaultValue:""},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},customIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:""},customIconRotationSpeed:{type:"int",group:"Appearance",defaultValue:1000},customIconDensityAware:{type:"boolean",defaultValue:true},customIconWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},customIconHeight:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"44px"},size:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"1rem"},design:{type:"string",group:"Appearance",defaultValue:"auto"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
a.prototype.init=function(){this.setBusyIndicatorDelay(0);};
a.prototype.onBeforeRendering=function(){if(this.getCustomIcon()){this.setBusy(false);}else{this.setBusy(true,"busy-area");}if(this._busyLabel){this._busyLabel.setTextDirection(this.getTextDirection());}if(this._iconImage){this._iconImage.setDensityAware(this.getCustomIconDensityAware());this._iconImage.setSrc(this.getCustomIcon());this._iconImage.setWidth(this.getCustomIconWidth());this._iconImage.setHeight(this.getCustomIconHeight());}else if(!this._iconImage&&this.getCustomIcon()){this._createCustomIcon(this.getCustomIcon()).addStyleClass("sapMBsyIndIcon");}if(this._busyLabel){this._busyLabel.setText(this.getText());this._busyLabel.setTextDirection(this.getTextDirection());}else if(!this._busyLabel&&this.getText()){this._createLabel(this.getText());}var r=this.getCustomIconRotationSpeed();if(r<0){this.setCustomIconRotationSpeed(0);}};
a.prototype.onAfterRendering=function(){this._setRotationSpeed();};
a.prototype.exit=function(){if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._busyLabel){this._busyLabel.destroy();this._busyLabel=null;}};
a.prototype._createCustomIcon=function(i){this._iconImage=new I(this.getId()+"-icon",{src:i,width:this.getCustomIconWidth(),height:this.getCustomIconHeight(),densityAware:this.getCustomIconDensityAware()});return this._iconImage;};
a.prototype._createLabel=function(t){this._busyLabel=new L(this.getId()+"-label",{labelFor:this.getId(),text:t,textAlign:"Center",textDirection:this.getTextDirection()});return this._busyLabel;};
a.prototype._setRotationSpeed=function(){if(!this._iconImage){return;}var $=this._iconImage.$();var r=this.getCustomIconRotationSpeed()+"ms";$.css("-webkit-animation-duration",r).css("animation-duration",r);$.css("display","none");setTimeout(function(){$.css("display","inline");},0);};
return a;});
sap.ui.predefine('sap/m/BusyIndicatorRenderer',[],function(){"use strict";var B={apiVersion:2};
B.render=function(r,b){var t=b.getTooltip_AsString();r.openStart("div",b).class("sapMBusyIndicator");r.style("font-size",b.getSize());r.accessibilityState(b);if(t){r.attr("title",t);}r.openEnd();if(b.getCustomIcon()){r.renderControl(b._iconImage);}else{r.openStart("div",b.getId()+"-busy-area");r.class("sapMBusyIndicatorBusyArea").openEnd().close("div");}if(b._busyLabel){r.renderControl(b._busyLabel);}r.close("div");};
return B;},true);
sap.ui.predefine('sap/m/Button',["./library","sap/ui/core/Control","sap/ui/core/ShortcutHintsMixin","sap/ui/core/EnabledPropagator","sap/ui/core/IconPool","sap/ui/Device","sap/ui/core/ContextMenuSupport","sap/ui/core/library","./ButtonRenderer","sap/ui/events/KeyCodes","sap/ui/core/LabelEnablement","sap/m/BadgeEnabler","sap/ui/core/InvisibleText"],function(l,C,S,E,I,D,a,c,B,K,L,b,d){"use strict";var T=c.TextDirection;var e=l.ButtonType;var f=l.ButtonAccessibilityType;var g=l.BadgeState;
var h=C.extend("sap.m.Button",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:e.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},iconFirst:{type:"boolean",group:"Appearance",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},press:{}},designtime:"sap/m/designtime/Button.designtime",dnd:{draggable:true,droppable:false}}});
E.call(h.prototype);a.apply(h.prototype);b.call(h.prototype);
h.prototype.init=function(){this._onmouseenter=this._onmouseenter.bind(this);this._buttonPressed=false;S.addConfig(this,{event:"press",position:"0 0",addAccessibilityLabel:true},this);this.initBadgeEnablement({position:"topRight",selector:{suffix:"inner"}});this._oBadgeData={value:"",state:""};};
h.prototype.onBadgeUpdate=function(v,s){var V=parseInt(v);if(!this.getDomRef()){return;}if(V<1&&s!==g.Disappear){this.updateBadgeVisibility(false);return;}else if(V>9999&&v.indexOf("+")===-1){v="999+";this.updateBadgeValue(v);return;}if(this._oBadgeData.value!==v||this._oBadgeData.state!==s){this._updateBadgeInvisibleText(v);this._oBadgeData={value:v,state:s};this.invalidate();}};
h.prototype._updateBadgeInvisibleText=function(v){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),i,p;v=v.toString().trim();p=v.indexOf("+");if(p!==-1){i=r.getText("BUTTON_BADGE_MORE_THAN_ITEMS",v.substr(0,p));}else{switch(v){case"":i="";break;case"1":i=r.getText("BUTTON_BADGE_ONE_ITEM",v);break;default:i=r.getText("BUTTON_BADGE_MANY_ITEMS",v);}}this._getBadgeInvisibleText().setText(i);};
h.prototype._getBadgeInvisibleText=function(){return this._oBadgeInvisibleText||(this._oBadgeInvisibleText=new d(this.getId()+"-badge").toStatic());};
h.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._iconBtn){this._iconBtn.destroy();}if(this._oBadgeInvisibleText){this._oBadgeInvisibleText.destroy();this._oBadgeData=null;}this.$().off("mouseenter",this._onmouseenter);};
h.prototype.setType=function(s){this.setProperty("type",s,false);if(s===e.Critical){this._sTypeIconURI="sap-icon://message-warning";}else if(s===e.Negative){this._sTypeIconURI="sap-icon://message-error";}else if(s===e.Success){this._sTypeIconURI="sap-icon://message-success";}else if(s===e.Neutral){this._sTypeIconURI="sap-icon://message-information";}else{this._sTypeIconURI=null;}return this;};
h.prototype.onBeforeRendering=function(){this._bRenderActive=this._bActive;this.$().off("mouseenter",this._onmouseenter);};
h.prototype.onAfterRendering=function(){if(this._bRenderActive){this._activeButton();this._bRenderActive=this._bActive;}this.$().on("mouseenter",this._onmouseenter);};
h.prototype.ontouchstart=function(o){o.setMarked();if(this._bRenderActive){delete this._bRenderActive;}if(o.targetTouches.length===1){this._buttonPressed=true;this._activeButton();}if(this.getEnabled()&&this.getVisible()){if((D.browser.safari||D.browser.firefox)&&(o.originalEvent&&o.originalEvent.type==="mousedown")){this._setButtonFocus();}if(!sap.ui.Device.browser.msie){this._sTouchStartTargetId=o.target.id.replace(this.getId(),'');}}else{if(!sap.ui.Device.browser.msie){this._sTouchStartTargetId='';}}};
h.prototype.ontouchend=function(o){var s;this._buttonPressed=o.originalEvent&&o.originalEvent.buttons&1;this._inactiveButton();if(this._bRenderActive){delete this._bRenderActive;this.ontap(o,true);}if(!sap.ui.Device.browser.msie){s=o.target.id.replace(this.getId(),'');if(this._buttonPressed===0&&((this._sTouchStartTargetId==="-BDI-content"&&(s==='-content'||s==='-inner'||s==='-img'))||(this._sTouchStartTargetId==="-content"&&(s==='-inner'||s==='-img'))||(this._sTouchStartTargetId==='-img'&&s!=='-img'))){this.ontap(o,true);}}this._sTouchStartTargetId='';};
h.prototype.ontouchcancel=function(){this._buttonPressed=false;this._sTouchStartTargetId='';this._inactiveButton();};
h.prototype.ontap=function(o,F){o.setMarked();delete this._bRenderActive;if(this.bFromTouchEnd){return;}if(this.getEnabled()&&this.getVisible()){if((o.originalEvent&&o.originalEvent.type==="touchend")){this.focus();}this.fireTap({});this.firePress({});}this.bFromTouchEnd=F;if(this.bFromTouchEnd){setTimeout(function(){delete this.bFromTouchEnd;}.bind(this),0);}};
h.prototype.onkeydown=function(o){if(o.which===K.SPACE||o.which===K.ENTER||o.which===K.ESCAPE||o.which===K.SHIFT){if(o.which===K.SPACE||o.which===K.ENTER){o.setMarked();this._activeButton();}if(o.which===K.ENTER){this.firePress({});}if(o.which===K.SPACE){this._bPressedSpace=true;}if(this._bPressedSpace){if(o.which===K.SHIFT||o.which===K.ESCAPE){this._bPressedEscapeOrShift=true;this._inactiveButton();}}}else{if(this._bPressedSpace){o.preventDefault();}}};
h.prototype.onkeyup=function(o){if(o.which===K.ENTER){o.setMarked();this._inactiveButton();}if(o.which===K.SPACE){if(!this._bPressedEscapeOrShift){o.setMarked();this._inactiveButton();this.firePress({});}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}if(o.which===K.ESCAPE){this._bPressedSpace=false;}};
h.prototype._onmouseenter=function(o){if(this._buttonPressed&&o.originalEvent&&o.originalEvent.buttons&1){this._activeButton();}};
h.prototype.onfocusout=function(){this._buttonPressed=false;this._sTouchStartTargetId='';this._inactiveButton();};
h.prototype._activeButton=function(){if(!this._isUnstyled()){this.$("inner").addClass("sapMBtnActive");}this._bActive=this.getEnabled();if(this._bActive){if(this._getAppliedIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this.getActiveIcon());}}};
h.prototype._inactiveButton=function(){if(!this._isUnstyled()){this.$("inner").removeClass("sapMBtnActive");}this._bActive=false;if(this.getEnabled()){if(this._getAppliedIcon()&&this.getActiveIcon()&&this._image){this._image.setSrc(this._getAppliedIcon());}}};
h.prototype._isHoverable=function(){return this.getEnabled()&&D.system.desktop;};
h.prototype._getImage=function(i,s,A,j){var k=I.isIconURI(s),m;if(this._image instanceof sap.m.Image&&k||this._image instanceof sap.ui.core.Icon&&!k){this._image.destroy();this._image=undefined;}m=this.getIconFirst();if(this._image){this._image.setSrc(s);if(this._image instanceof sap.m.Image){this._image.setActiveSrc(A);this._image.setDensityAware(j);}}else{this._image=I.createControlByURI({id:i,src:s,activeSrc:A,densityAware:j,useIconTooltip:false},sap.m.Image).addStyleClass("sapMBtnCustomIcon").setParent(this,null,true);}this._image.addStyleClass("sapMBtnIcon");this._image.toggleStyleClass("sapMBtnIconLeft",m);this._image.toggleStyleClass("sapMBtnIconRight",!m);return this._image;};
h.prototype._getInternalIconBtn=function(i,s){var o=this._iconBtn;if(o){o.setSrc(s);}else{o=I.createControlByURI({id:i,src:s,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}o.addStyleClass("sapMBtnIcon");o.addStyleClass("sapMBtnIconLeft");this._iconBtn=o;return this._iconBtn;};
h.prototype._isUnstyled=function(){var u=false;if(this.getType()===e.Unstyled){u=true;}return u;};
h.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("inner");};
h.prototype._getText=function(){return this.getText();};
h.prototype._getTooltip=function(){var t,i;t=this.getTooltip_AsString();if(!t&&!this.getText()){i=I.getIconInfo(this._getAppliedIcon());if(i){t=i.text?i.text:i.name;}}return t;};
h.prototype._getAppliedIcon=function(){return this.getIcon()||this._sTypeIconURI;};
h.prototype.getAccessibilityInfo=function(){var s=this.getText()||this.getTooltip_AsString();if(!s&&this._getAppliedIcon()){var i=I.getIconInfo(this._getAppliedIcon());if(i){s=i.text||i.name;}}return{role:"button",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON"),description:s,focusable:this.getEnabled(),enabled:this.getEnabled()};};
h.prototype._setButtonFocus=function(){setTimeout(function(){this.focus();}.bind(this),0);};
h.prototype._determineSelfReferencePresence=function(){var A=this.getAriaLabelledBy(),i=A.indexOf(this.getId())!==-1,H=L.getReferencingLabels(this).length>0,p=this.getParent(),j=!!(p&&p.enhanceAccessibilityState);return!i&&this._getText()&&(A.length>0||H||j);};
h.prototype._determineAccessibilityType=function(){var H=this.getAriaLabelledBy().length>0,i=this.getAriaDescribedBy().length>0,j=L.getReferencingLabels(this).length>0,k=this.getType()!==e.Default,m=H||j,n=i||k||(this._oBadgeData&&this._oBadgeData.value!==""&&this._oBadgeData.State!==g.Disappear),A;if(!m&&!n){A=f.Default;}else if(m&&!n){A=f.Labelled;}else if(!m&&n){A=f.Described;}else if(m&&n){A=f.Combined;}return A;};
h.prototype._getTitleAttribute=function(s){return this.getTooltip();};
return h;});
sap.ui.predefine('sap/m/ButtonRenderer',['sap/ui/Device','sap/ui/core/library','sap/ui/core/IconPool','sap/ui/core/ShortcutHintsMixin','sap/m/library','sap/ui/core/InvisibleText'],function(D,c,I,S,l,a){"use strict";var B=l.ButtonType;var b=l.ButtonAccessibilityType;var T=c.TextDirection;var d=l.BadgeState;var e={apiVersion:2};
e.render=function(R,o){var s=o.getId();var t=o.getType();var E=o.getEnabled();var w=o.getWidth();var f=o._getTooltip();var g=o._getText();var h=o.getTextDirection();var i=D.browser.internet_explorer||D.browser.edge;var j=(h===T.Inherit)&&!i;var k=I.getIconURI("nav-back");var m;R.openStart("button",o);R.class("sapMBtnBase");if(!o._isUnstyled()){R.class("sapMBtn");if((t===B.Back||t===B.Up)&&o._getAppliedIcon()&&!g){R.class("sapMBtnBack");}}var n=e.generateAccProps(o);if(this.renderAccessibilityAttributes){this.renderAccessibilityAttributes(R,o,n);}R.accessibilityState(o,n);if(!E){R.attr("disabled","disabled");if(!o._isUnstyled()){R.class("sapMBtnDisabled");}}else{switch(t){case B.Accept:case B.Reject:case B.Emphasized:case B.Attention:R.class("sapMBtnInverted");break;default:break;}}if(f&&!S.isDOMIDRegistered(s)){R.attr("title",f);}if(w!=""||w.toLowerCase()==="auto"){R.style("width",w);if(o._getAppliedIcon()&&g){m="4rem";}else{m="2.25rem";}R.style("min-width",m);}r(o,R);R.openEnd();R.openStart("span",s+"-inner");if(!o._isUnstyled()){R.class("sapMBtnInner");}if(o._isHoverable()){R.class("sapMBtnHoverable");}if(E){R.class("sapMFocusable");if(i){R.class("sapMIE");}}if(!o._isUnstyled()){if(g){R.class("sapMBtnText");}if(t===B.Back||t===B.Up){R.class("sapMBtnBack");}if(o._getAppliedIcon()){if(o.getIconFirst()){R.class("sapMBtnIconFirst");}else{R.class("sapMBtnIconLast");}}}if(this.renderButtonAttributes){this.renderButtonAttributes(R,o);}if(!o._isUnstyled()&&t!==""){R.class("sapMBtn"+t);}r(o,R);R.openEnd();if(t===B.Back||t===B.Up){this.writeInternalIconPoolHtml(R,o,k);}if(o.getIconFirst()&&o._getAppliedIcon()){this.writeImgHtml(R,o);}if(g){R.openStart("span",s+"-content");R.class("sapMBtnContent");if(h!==T.Inherit){R.attr("dir",h.toLowerCase());}R.openEnd();if(j){R.openStart("bdi",s+"-BDI-content");R.openEnd();}R.text(g);if(j){R.close("bdi");}R.close("span");}if(!o.getIconFirst()&&o._getAppliedIcon()){this.writeImgHtml(R,o);}if(i&&E){R.openStart("span");R.class("sapMBtnFocusDiv");R.openEnd();R.close("span");}R.close("span");if(f){R.openStart("span",s+"-tooltip");R.class("sapUiInvisibleText");R.openEnd();R.text(f);R.close("span");}R.close("button");};
e.writeImgHtml=function(R,o){R.renderControl(o._getImage(o.getId()+"-img",o._getAppliedIcon(),o.getActiveIcon(),o.getIconDensityAware()));};
e.writeInternalIconPoolHtml=function(R,o,u){R.renderControl(o._getInternalIconBtn((o.getId()+"-iconBtn"),u));};
function r(o,R){if(o._bExcludeFromTabChain){R.attr("tabindex",-1);}}
var A={Accept:"BUTTON_ARIA_TYPE_ACCEPT",Reject:"BUTTON_ARIA_TYPE_REJECT",Attention:"BUTTON_ARIA_TYPE_ATTENTION",Emphasized:"BUTTON_ARIA_TYPE_EMPHASIZED",Critical:"BUTTON_ARIA_TYPE_CRITICAL",Negative:"BUTTON_ARIA_TYPE_NEGATIVE",Success:"BUTTON_ARIA_TYPE_SUCCESS"};
e.getButtonTypeAriaLabelId=function(t){return a.getStaticId("sap.m",A[t]);};
e.getBadgeTextId=function(o){return o._oBadgeData&&o._oBadgeData.value!==""&&o._oBadgeData.state!==d.Disappear?o._getBadgeInvisibleText().getId():"";};
e.generateAccProps=function(o){var t=o._getText(),m;if(t){m=e.generateTextButtonAccProps(o);}else{m=e.generateIconOnlyButtonAccProps(o);}m["disabled"]=null;return m;};
e.generateIconOnlyButtonAccProps=function(o){var t=e.getButtonTypeAriaLabelId(o.getType()),s=this.getBadgeTextId(o),f=o._getTooltip(),g=o.getId()+"-tooltip",h=o._determineAccessibilityType(),m={};switch(h){case b.Default:m["label"]={value:f,append:true};break;case b.Described:m["label"]={value:f,append:true};m["describedby"]={value:(g+" "+t+" "+s).trim(),append:true};break;case b.Labelled:m["describedby"]={value:g,append:true};break;case b.Combined:m["describedby"]={value:(g+" "+t+" "+s).trim(),append:true};break;default:break;}return m;};
e.generateTextButtonAccProps=function(o){var s=o.getId(),t=e.getButtonTypeAriaLabelId(o.getType()),f=this.getBadgeTextId(o),g=o._getTooltip()?s+"-tooltip":"",i=s+"-content",h=o._determineAccessibilityType(),p=o._determineSelfReferencePresence(),m={},j;switch(h){case b.Default:g&&(m["describedby"]={value:g,append:true});break;case b.Described:j=(g+" "+t+" "+f).trim();j&&(m["describedby"]={value:j,append:true});break;case b.Labelled:p&&(m["labelledby"]={value:i,append:true});g&&(m["describedby"]={value:g,append:true});break;case b.Combined:j=(g+" "+t+" "+f).trim();j&&(m["describedby"]={value:j,append:true});p&&(m["labelledby"]={value:i,append:true});break;default:break;}return m;};
return e;},true);
sap.ui.predefine('sap/m/Carousel',["./library","sap/ui/core/Core","sap/ui/core/Control","sap/ui/Device","sap/ui/core/ResizeHandler","sap/ui/core/library","sap/m/MessagePage","sap/ui/core/theming/Parameters","sap/ui/dom/units/Rem","./CarouselRenderer","./CarouselLayout","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/events/F6Navigation","sap/ui/thirdparty/jquery","sap/ui/thirdparty/mobify-carousel","sap/ui/core/IconPool"],function(l,C,a,D,R,c,M,P,b,d,f,K,L,F,q){"use strict";var B=c.BusyIndicatorSize;var I=l.ImageHelper;var g=l.CarouselArrowsPlacement;var h=l.PlacementType;
var j=a.extend("sap.m.Carousel",{metadata:{library:"sap.m",designtime:"sap/m/designtime/Carousel.designtime",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},loop:{type:"boolean",group:"Misc",defaultValue:false},showPageIndicator:{type:"boolean",group:"Appearance",defaultValue:true},pageIndicatorPlacement:{type:"sap.m.PlacementType",group:"Appearance",defaultValue:h.Bottom},showBusyIndicator:{type:"boolean",group:"Appearance",defaultValue:true,deprecated:true},arrowsPlacement:{type:"sap.m.CarouselArrowsPlacement",group:"Appearance",defaultValue:g.Content}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"},customLayout:{type:"sap.m.CarouselLayout",multiple:false}},associations:{activePage:{type:"sap.ui.core.Control",multiple:false}},events:{loadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},unloadPage:{deprecated:true,parameters:{pageId:{type:"string"}}},pageChanged:{parameters:{oldActivePageId:{type:"string"},newActivePageId:{type:"string"},activePages:{type:"array"}}},beforePageChanged:{parameters:{activePages:{type:"array"}}}}}});
j._INNER_SELECTOR=".sapMCrslInner";j._PAGE_INDICATOR_SELECTOR=".sapMCrslBulleted";j._PAGE_INDICATOR_ARROWS_SELECTOR=".sapMCrslIndicatorArrow";j._CONTROLS=".sapMCrslControls";j._ITEM_SELECTOR=".sapMCrslItem";j._LEFTMOST_CLASS="sapMCrslLeftmost";j._RIGHTMOST_CLASS="sapMCrslRightmost";j._LATERAL_CLASSES="sapMCrslLeftmost sapMCrslRightmost";j._MODIFIERNUMBERFORKEYBOARDHANDLING=10;j._BULLETS_TO_NUMBERS_THRESHOLD=9;j._PREVIOUS_CLASS_ARROW="sapMCrslPrev";j._NEXT_CLASS_ARROW="sapMCrslNext";
j.prototype.init=function(){this._fnAdjustAfterResize=function(){var $=this.$().find(j._INNER_SELECTOR);this._oMobifyCarousel.resize($);this._setWidthOfPages(this._getNumberOfItemsToShow());}.bind(this);this._aOrderOfFocusedElements=[];this._aAllActivePages=[];this._aAllActivePagesIndexes=[];this._onBeforePageChangedRef=this._onBeforePageChanged.bind(this);this._onAfterPageChangedRef=this._onAfterPageChanged.bind(this);this.data("sap-ui-fastnavgroup","true",true);this._oRb=C.getLibraryResourceBundle("sap.m");};
j.prototype.exit=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.destroy();delete this._oMobifyCarousel;}if(this._oArrowLeft){this._oArrowLeft.destroy();delete this._oArrowLeft;}if(this._oArrowRight){this._oArrowRight.destroy();delete this._oArrowRight;}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this.oMessagePage){this.oMessagePage.destroy();this.oMessagePage=null;}this.$().off('afterSlide');this._fnAdjustAfterResize=null;this._$InnerDiv=null;this._aOrderOfFocusedElements=null;this._aAllActivePages=null;this._aAllActivePagesIndexes=null;};
j.prototype.ontouchstart=function(e){if(this._oMobifyCarousel){if(e.target instanceof HTMLImageElement){e.preventDefault();}this._oMobifyCarousel.touchstart(e);}};
j.prototype.ontouchmove=function(e){if(this._oMobifyCarousel){this._oMobifyCarousel.touchmove(e);}};
j.prototype.ontouchend=function(e){if(this._oMobifyCarousel){if(this._oMobifyCarousel.hasActiveTransition()){this._oMobifyCarousel.onTransitionComplete();}this._oMobifyCarousel.touchend(e);}};
j.prototype.onBeforeRendering=function(){var A=this.getActivePage();if(!A&&this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.$().off('beforeSlide',this._onBeforePageChangedRef);this.$().off('afterSlide',this._onAfterPageChangedRef);this.$().find(".sapMCrslItemTableCell").off("focus");return this;};
j.prototype._getNumberOfItemsToShow=function(){var p=this.getPages().length,o=this.getCustomLayout(),n=1;if(o&&o.isA("sap.m.CarouselLayout")){n=Math.max(o.getVisiblePagesCount(),1);}if(n>1&&p<n){return p;}return n;};
j.prototype.onAfterRendering=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.unbind();setTimeout(function(){if(this._oMobifyCarousel){this._oMobifyCarousel.onTransitionComplete();}}.bind(this),0);}var n=this._getNumberOfItemsToShow();this.$().carousel(undefined,{numberOfItemsToShow:n});this._oMobifyCarousel=this.getDomRef()._carousel;this._oMobifyCarousel.setLoop(this.getLoop());this._oMobifyCarousel.setRTL(C.getConfiguration().getRTL());if(n>1){this._setWidthOfPages(n);}var A=this.getActivePage();if(A){this._updateActivePages(A);var i=this._getPageNumber(A);if(isNaN(i)||i==0){if(this.getPages().length>0){this.setAssociation("activePage",this.getPages()[0].getId(),true);this._adjustHUDVisibility(1);}}else{if(C.isThemeApplied()){this._moveToPage(i+1);}else{C.attachThemeChanged(this._handleThemeLoad,this);}if(this.getParent()&&this.getParent().isA("sap.zen.commons.layout.PositionContainer")){if(this._isCarouselUsedWithCommonsLayout===undefined){setTimeout(this["invalidate"].bind(this),0);this._isCarouselUsedWithCommonsLayout=true;}}}}this.$().on('beforeSlide',this._onBeforePageChangedRef);this.$().on('afterSlide',this._onAfterPageChangedRef);this._$InnerDiv=this.$().find(j._INNER_SELECTOR)[0];this._sResizeListenerId=R.register(this._$InnerDiv,this._fnAdjustAfterResize);this.$().find(".sapMCrslItemTableCell").on("focus",function(e){e.preventDefault();q(e.target).parents('.sapMCrsl').trigger("focus");return false;});var p=this.getParent();while(p){if(p.isA("sap.m.IconTabBar")){var t=this;p.attachExpand(function(e){var E=e.getParameter('expand');if(E&&i>0){t._moveToPage(i+1);}});break;}p=p.getParent();}};
j.prototype._onBeforePageChanged=function(e,p,n){if(e.target!==this.getDomRef()){return;}var N=this.getPages()[n-1].getId();this._updateActivePages(N);this.fireBeforePageChanged({activePages:this._aAllActivePagesIndexes});};
j.prototype._onAfterPageChanged=function(e,p,n){var H=this.getPages().length>0;if(e.target!==this.getDomRef()){return;}if(H&&n>0){this._changePage(p,n);}};
j.prototype._setWidthOfPages=function(n){var i=this._calculatePagesWidth(n);this.$().find(".sapMCrslItem").each(function(e,p){p.style.width=i+"%";});};
j.prototype._calculatePagesWidth=function(n){var w=this.$().width(),m=b.toPx(P.get("_sap_m_Carousel_PagesMarginRight")),i=(w-(m*(n-1)))/n,e=(i/w)*100;return e;};
j.prototype._handleThemeLoad=function(){var A=this.getActivePage();if(A){var i=this._getPageNumber(A);if(i>0){this._moveToPage(i+1);}}C.detachThemeChanged(this._handleThemeLoad,this);};
j.prototype._moveToPage=function(i){this._oMobifyCarousel.changeAnimation('sapMCrslNoTransition');this._oMobifyCarousel.move(i);this._changePage(undefined,i);};
j.prototype._changePage=function(o,n){this._adjustHUDVisibility(n);var O=this.getActivePage();if(o){O=this.getPages()[o-1].getId();}var N=this.getPages()[n-1].getId();this.setAssociation("activePage",N,true);var t=this._getPageIndicatorText(n);L.debug("sap.m.Carousel: firing pageChanged event: old page: "+O+", new page: "+N);if(!D.system.desktop){q(document.activeElement).trigger("blur");}this.firePageChanged({oldActivePageId:O,newActivePageId:N,activePages:this._aAllActivePagesIndexes});this.$('slide-number').text(t);};
j.prototype._getPageIndicatorText=function(n){return this._oRb.getText("CAROUSEL_PAGE_INDICATOR_TEXT",[n,this.getPages().length-this._getNumberOfItemsToShow()+1]);};
j.prototype._adjustHUDVisibility=function(n){var N=this._getNumberOfItemsToShow();if(D.system.desktop&&!this.getLoop()&&this.getPages().length>1){var H=this.$('hud');H.removeClass(j._LATERAL_CLASSES);if(n===1){H.addClass(j._LEFTMOST_CLASS);this._focusCarouselContainer(H,j._PREVIOUS_CLASS_ARROW);}if((n+N-1)===this.getPages().length){H.addClass(j._RIGHTMOST_CLASS);this._focusCarouselContainer(H,j._NEXT_CLASS_ARROW);}}};
j.prototype._focusCarouselContainer=function(H,A){if(H.find('.'+A)[0]===document.activeElement){this.focus();}};
j.prototype.setActivePage=function(p){var s=null;if(typeof(p)=='string'){s=p;}else if(p instanceof a){s=p.getId();}if(s){if(s===this.getActivePage()){return this;}var i=this._getPageNumber(s);if(!isNaN(i)){if(this._oMobifyCarousel){this._oMobifyCarousel.move(i+1);}}}this.setAssociation("activePage",s,true);return this;};
j.prototype._getNavigationArrow=function(s){if(!this["_oArrow"+s]){this["_oArrow"+s]=I.getImageControl(this.getId()+"-arrowScroll"+s,this["_oArrow"+s],this,{src:"sap-icon://slim-arrow-"+s.toLowerCase(),useIconTooltip:false});}return this["_oArrow"+s];};
j.prototype._getErrorPage=function(){if(!this.oMessagePage){this.oMessagePage=new M({text:this._oRb.getText("CAROUSEL_ERROR_MESSAGE"),description:"",icon:"sap-icon://document",showHeader:false});}return this.oMessagePage;};
j.prototype.previous=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.prev();}else{L.warning("Unable to execute sap.m.Carousel.previous: carousel must be rendered first.");}return this;};
j.prototype.next=function(){if(this._oMobifyCarousel){this._oMobifyCarousel.next();}else{L.warning("Unable to execute sap.m.Carousel.next: carousel must be rendered first.");}return this;};
j.prototype._getPageNumber=function(p){var i,r;for(i=0;i<this.getPages().length;i++){if(this.getPages()[i].getId()==p){r=i;break;}}return r;};
j.prototype.onsaptabprevious=function(e){this._bDirection=false;this._fnOnTabPress(e);};
j.prototype.onsaptabnext=function(e){this._bDirection=true;this._fnOnTabPress(e);};
j.prototype.onfocusin=function(e){this.saveLastFocusReference(e);this._bDirection=undefined;};
j.prototype.onsapskipforward=function(e){e.preventDefault();this._handleGroupNavigation(e,false);};
j.prototype.onsapskipback=function(e){e.preventDefault();this._handleGroupNavigation(e,true);};
j.prototype.onkeydown=function(e){if(e.keyCode==K.F7){this._handleF7Key(e);return;}if(e.target!=this.getDomRef()){return;}switch(e.keyCode){case 189:case K.NUMPAD_MINUS:this._fnSkipToIndex(e,-1);break;case K.PLUS:case K.NUMPAD_PLUS:this._fnSkipToIndex(e,1);break;}};
j.prototype.onsapescape=function(e){var i;if(e.target===this.$()[0]&&this._lastActivePageNumber){i=this._lastActivePageNumber+1;this._oMobifyCarousel.move(i);this._changePage(undefined,i);}};
j.prototype.onsapright=function(e){this._fnSkipToIndex(e,1);};
j.prototype.onsapup=function(e){this._fnSkipToIndex(e,-1);};
j.prototype.onsapleft=function(e){this._fnSkipToIndex(e,-1);};
j.prototype.onsapdown=function(e){this._fnSkipToIndex(e,1);};
j.prototype.onsaphome=function(e){this._fnSkipToIndex(e,0);};
j.prototype.onsapend=function(e){this._fnSkipToIndex(e,this.getPages().length);};
j.prototype.onsaprightmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsapupmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsappageup=function(e){this._fnSkipToIndex(e,j._MODIFIERNUMBERFORKEYBOARDHANDLING);};
j.prototype.onsapleftmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,-j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsapdownmodifiers=function(e){if(e.ctrlKey){this._fnSkipToIndex(e,-j._MODIFIERNUMBERFORKEYBOARDHANDLING);}};
j.prototype.onsappagedown=function(e){this._fnSkipToIndex(e,-j._MODIFIERNUMBERFORKEYBOARDHANDLING);};
j.prototype._fnOnTabPress=function(e){if(e.target===this.$()[0]){this._lastActivePageNumber=this._getPageNumber(this.getActivePage());}};
j.prototype._handleGroupNavigation=function(e,s){var E=q.Event("keydown");e.preventDefault();this.$().trigger("focus");E.target=e.target;E.key='F6';E.shiftKey=s;F.handleF6GroupNavigation(E);};
j.prototype.saveLastFocusReference=function(e){var o=q(e.target).closest(".sapMCrsPage").control(0),s;if(this._bDirection===undefined){return;}if(this._lastFocusablePageElement===undefined){this._lastFocusablePageElement={};}if(o){s=o.getId();this._lastFocusablePageElement[s]=e.target;this._updateFocusedPagesOrder(s);}};
j.prototype._getActivePageLastFocusedElement=function(){if(this._lastFocusablePageElement){return this._lastFocusablePageElement[this._getLastFocusedActivePage()];}};
j.prototype._updateFocusedPagesOrder=function(s){var i=this._aOrderOfFocusedElements.indexOf(s);if(i>-1){this._aOrderOfFocusedElements.splice(0,0,this._aOrderOfFocusedElements.splice(i,1)[0]);}else{this._aOrderOfFocusedElements.unshift(s);}};
j.prototype._updateActivePages=function(n){var N=this._getPageNumber(n),e=this._getNumberOfItemsToShow(),k=N+e,A=this.getPages();if(k>A.length){k=A.length-e;}this._aAllActivePages=[];this._aAllActivePagesIndexes=[];for(var i=N;i<k;i++){this._aAllActivePages.push(A[i].getId());this._aAllActivePagesIndexes.push(i);}};
j.prototype._getLastFocusedActivePage=function(){for(var i=0;i<this._aOrderOfFocusedElements.length;i++){var p=this._aOrderOfFocusedElements[i];if(this._aAllActivePages.indexOf(p)>-1){return p;}}return this.getActivePage();};
j.prototype._fnSkipToIndex=function(e,n){var i=n;if(e.target!==this.getDomRef()){return;}e.preventDefault();if(this._oMobifyCarousel.hasActiveTransition()){this._oMobifyCarousel.onTransitionComplete();}if(n!==0){i=this._getPageNumber(this.getActivePage())+1+n;}this._oMobifyCarousel.move(i);};
j.prototype._handleF7Key=function(e){var A;e.preventDefault();A=this._getActivePageLastFocusedElement();if(e.target===this.$()[0]&&A){A.focus();}else{this.$().trigger("focus");}};
j.prototype.setShowBusyIndicator=function(){L.warning("sap.m.Carousel: Deprecated function 'setShowBusyIndicator' called. Does nothing.");return this;};
j.prototype.getShowBusyIndicator=function(){L.warning("sap.m.Carousel: Deprecated function 'getShowBusyIndicator' called. Does nothing.");return false;};
j.prototype.setBusyIndicatorSize=function(s){if(!(s in B)){s=B.Medium;}return a.prototype.setBusyIndicatorSize.call(this,s);};
return j;});
sap.ui.predefine('sap/m/CarouselLayout',["sap/ui/base/ManagedObject"],function(M){"use strict";
var C=M.extend("sap.m.CarouselLayout",{metadata:{library:"sap.m",properties:{visiblePagesCount:{type:"int",group:"Misc",defaultValue:1}}}});
return C;});
sap.ui.predefine('sap/m/CarouselRenderer',["sap/m/library","sap/base/strings/capitalize","sap/ui/core/Core","sap/ui/Device"],function(l,c,C,D){"use strict";var a=l.CarouselArrowsPlacement;var P=l.PlacementType;var r=C.getLibraryResourceBundle("sap.m");var b={apiVersion:2};b._BULLETS_TO_NUMBERS_THRESHOLD=9;
b.render=function(R,o){var p=o.getPages(),i=p.length,s=o.getPageIndicatorPlacement(),A=o.getArrowsPlacement(),I=o._getPageNumber(o.getActivePage());this._renderOpeningDiv(R,o);if(s===P.Top){this._renderPageIndicatorAndArrows(R,o,{iPageCount:i,iIndex:I,sArrowsPlacement:A,bBottom:false,bShowPageIndicator:o.getShowPageIndicator()});}this._renderInnerDiv(R,o,p,s);if(D.system.desktop&&i>o._getNumberOfItemsToShow()&&A===a.Content){this._renderHudArrows(R,o);}if(s===P.Bottom){this._renderPageIndicatorAndArrows(R,o,{iPageCount:i,iIndex:I,sArrowsPlacement:A,bBottom:true,bShowPageIndicator:o.getShowPageIndicator()});}R.close("div");};
b._renderOpeningDiv=function(R,o){var t=o.getTooltip_AsString();R.openStart("div",o).class("sapMCrsl").class("sapMCrslFluid").style("width",o.getWidth()).style("height",o.getHeight()).attr("data-sap-ui-customfastnavgroup",true).attr("tabindex",0).accessibilityState(o,{role:"listbox"});if(t){R.attr("title",t);}R.openEnd();};
b._renderInnerDiv=function(R,o,p,s){R.openStart("div").class("sapMCrslInner");if(p.length>1&&(o.getShowPageIndicator()||o.getArrowsPlacement()===a.PageIndicator)){if(s===P.Bottom){R.class("sapMCrslBottomOffset");if(o.getArrowsPlacement()===a.PageIndicator){R.class("sapMCrslBottomArrowsOffset");}}else{R.class("sapMCrslTopOffset");if(o.getArrowsPlacement()===a.PageIndicator){R.class("sapMCrslTopArrowsOffset");}}}R.openEnd();var f=function(d,i,A){R.openStart("div",o.getId()+"-"+d.getId()+"-slide").class("sapMCrslItem").accessibilityState(d,{role:"option",posinset:i+1,setsize:A.length}).openEnd();b._renderPageInScrollContainer(R,o,d);R.close("div");};if(p.length){p.forEach(f);}else{R.renderControl(o._getErrorPage());}R.close("div");};
b._renderPageIndicatorAndArrows=function(R,o,s){var p=s.iPageCount,S=D.system.desktop&&s.sArrowsPlacement===a.PageIndicator,I=o.getId(),O=[],n=o._getNumberOfItemsToShow(),d=1;if(p<=o._getNumberOfItemsToShow()){return;}if(!s.bShowPageIndicator&&!S){return;}if(s.bBottom){O.push("sapMCrslControlsBottom");}else{O.push("sapMCrslControlsTop");}if(S){R.openStart("div").class("sapMCrslControls");O.forEach(function(e){R.class(e);});R.openEnd();R.openStart("div").class("sapMCrslControlsContainer");O.forEach(function(e){R.class(e);});R.openEnd();}else{R.openStart("div").class("sapMCrslControlsNoArrows");O.forEach(function(e){R.class(e);});R.openEnd();}if(S){this._renderArrow(R,o,"previous");}R.openStart("div",I+"-pageIndicator");if(!s.bShowPageIndicator){R.style("opacity","0");}if(p<b._BULLETS_TO_NUMBERS_THRESHOLD){R.class("sapMCrslBulleted").openEnd();for(var i=1;i<=p-n+1;i++){R.openStart("span").attr("data-slide",d).accessibilityState({role:"img",label:r.getText("CAROUSEL_POSITION",[i,p])}).openEnd().text(i).close("span");d++;}}else{R.class("sapMCrslNumeric").openEnd();var t=r.getText("CAROUSEL_PAGE_INDICATOR_TEXT",[s.iIndex+1,p-n+1]);R.openStart("span",I+"-"+"slide-number").openEnd().text(t).close("span");}R.close("div");if(S){this._renderArrow(R,o,"next");}if(!S){R.close("div");}if(S){R.close("div").close("div");}};
b._renderHudArrows=function(R,o){var A;if(o.getShowPageIndicator()){if(o.getPageIndicatorPlacement()===P.Top){A="sapMCrslHudTop";}else if(o.getPageIndicatorPlacement()===P.Bottom){A="sapMCrslHudBottom";}}else{A="sapMCrslHudMiddle";}R.openStart("div",o.getId()+"-hud").class("sapMCrslHud").class(A).openEnd();this._renderArrow(R,o,"previous");this._renderArrow(R,o,"next");R.close("div");};
b._renderArrow=function(R,o,d){var s=d.slice(0,4);R.openStart("a").class("sapMCrsl"+c(s)).attr("tabindex","-1").attr("data-slide",s).attr("title",r.getText("PAGINGBUTTON_"+d.toUpperCase())).openEnd();R.openStart("div").class("sapMCrslArrowInner").openEnd();R.renderControl(o._getNavigationArrow(d==="previous"?"Left":"Right"));R.close("div").close("a");};
b._renderPageInScrollContainer=function(R,o,p){R.openStart("div").class("sapMScrollCont").class("sapMScrollContH").style("width","100%").style("height","100%").openEnd();R.openStart("div").class("sapMScrollContScroll").openEnd();R.openStart("div").class("sapMCrslItemTable").openEnd();R.openStart("div").class("sapMCrslItemTableCell");if(p.isA("sap.m.Image")){var i="sapMCrslImgNoArrows",s=D.system.desktop&&o.getArrowsPlacement()===a.PageIndicator;if(s){i="sapMCrslImg";}R.class(i);}R.openEnd();R.renderControl(p.addStyleClass("sapMCrsPage"));R.close("div");R.close("div");R.close("div");R.close("div");};
return b;},true);
sap.ui.predefine('sap/m/CheckBox',['./Label','./library','sap/ui/Device','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/EnabledPropagator','sap/ui/core/library','./CheckBoxRenderer',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes",'sap/ui/core/LabelEnablement','sap/ui/core/message/MessageMixin'],function(L,l,D,C,I,E,c,a,q,K,b,M){"use strict";var V=c.ValueState;var T=c.TextAlign;var d=c.TextDirection;
var e=C.extend("sap.m.CheckBox",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{selected:{type:"boolean",group:"Data",defaultValue:false},partiallySelected:{type:"boolean",group:"Data",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Misc",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},valueStateText:{type:"string",group:"Misc",defaultValue:null,visibility:"hidden"},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{_label:{type:"sap.m.Label",group:"Behavior",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selected:{type:"boolean"}}}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/CheckBox.designtime"}});
E.call(e.prototype);M.call(e.prototype);
e.prototype.init=function(){this.addActiveState(this);I.insertFontFaceStyle();this._handleReferencingLabels();};
e.prototype.exit=function(){this._oLabel=null;delete this._iTabIndex;};
e.prototype.setText=function(t){var o=this._getLabel();this.setProperty("text",t);o.setText(t);return this;};
e.prototype.setWidth=function(w){this.setProperty("width",w,true);this._setWidth();return this;};
e.prototype.setUseEntireWidth=function(u){this.setProperty("useEntireWidth",u,true);this._setWidth();return this;};
e.prototype.setTextDirection=function(s){var o=this._getLabel();this.setProperty("textDirection",s);o.setTextDirection(s);return this;};
e.prototype.setTextAlign=function(A){var o=this._getLabel();this.setProperty("textAlign",A);o.setTextAlign(A);return this;};
e.prototype.setValueStateText=function(t){return this.setProperty("valueStateText",t);};
e.prototype.setWrapping=function(w){var o=this._getLabel();this.setProperty("wrapping",w);o.setWrapping(w);return this;};
e.prototype.addActiveState=function(o){if(D.os.blackberry){o.addDelegate({ontouchstart:function(f){q(o.getDomRef()).addClass("sapMActive");},ontouchend:function(f){q(o.getDomRef()).removeClass("sapMActive");}});}};
e.prototype.ontouchstart=function(o){o.originalEvent._sapui_handledByControl=true;};
e.prototype.ontap=function(o){var s;if(this.getEnabled()&&this.getEditable()&&!this.getDisplayOnly()){this.$().trigger("focus");s=this._getSelectedState();this.setSelected(s);this.setPartiallySelected(false);this.fireSelect({selected:s});o&&o.setMarked();}};
e.prototype.onkeyup=function(o){if(o&&o.which===K.SPACE&&!o.shiftKey){this.ontap(o);o.preventDefault();o.stopPropagation();}};
e.prototype.onsapspace=function(o){o.preventDefault();};
e.prototype.onsapenter=function(o){this.ontap(o);};
e.prototype.setTabIndex=function(t){this._iTabIndex=t;this.$("CbBg").attr("tabindex",t);return this;};
e.prototype.getTabIndex=function(){if(this.hasOwnProperty("_iTabIndex")){return this._iTabIndex;}return(this.getEnabled()&&!this.getDisplayOnly())?0:-1;};
e.prototype._getLabel=function(){if(!this._oLabel){this._oLabel=new L(this.getId()+"-label",{labelFor:this.getId()}).addStyleClass("sapMCbLabel");this.setAggregation("_label",this._oLabel,true);}return this.getAggregation("_label");};
e.prototype._setWidth=function(){var o=this._getLabel(),$=this.$(),w=this.getWidth();if(this.getUseEntireWidth()){o.setWidth("");$.outerWidth(w);}else{$.outerWidth("");o.setWidth(w);}};
e.prototype._getSelectedState=function(){var s=this.getSelected(),p=this.getPartiallySelected();return(s===p)||(!s&&p);};
e.prototype._getAriaChecked=function(){var s=this.getSelected();if(this.getPartiallySelected()&&s){return"mixed";}return s;};
e.prototype._fnLabelTapHandler=function(){this.$().trigger("focus");};
e.prototype._handleReferencingLabels=function(){var f=b.getReferencingLabels(this),t=this;if(f.length>0){f.forEach(function(s){sap.ui.getCore().byId(s).addEventDelegate({ontap:function(){t._fnLabelTapHandler();}});});}};
e.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"checkbox",type:B.getText("ACC_CTR_TYPE_CHECKBOX"),description:(this.getText()||"")+(this.getSelected()?(" "+B.getText("ACC_CTR_STATE_CHECKED")):""),focusable:this.getEnabled()&&!this.getDisplayOnly(),enabled:this.getEnabled(),editable:this.getEditable()};};
e.prototype.getFormDoNotAdjustWidth=function(){return this.getText()?false:true;};
return e;});
sap.ui.predefine('sap/m/CheckBoxRenderer',['sap/ui/core/library','sap/ui/core/ValueStateSupport','sap/ui/Device'],function(c,V,D){"use strict";var a=c.ValueState;var C={apiVersion:2};
C.render=function(r,o){var i=o.getId(),e=o.getEnabled(),d=o.getDisplayOnly(),E=o.getEditable(),I=e&&!d,b=e&&d,f=o.getAggregation("_label"),v=o.getValueState(),g=a.Error===v,h=a.Warning===v,j=a.Success===v,k=a.Information===v,u=o.getUseEntireWidth();r.openStart("div",o);r.class("sapMCb");if(!E){r.class("sapMCbRo");}if(b){r.class("sapMCbDisplayOnly");}if(!e){r.class("sapMCbBgDis");}if(o.getText()){r.class("sapMCbHasLabel");}if(o.getWrapping()){r.class("sapMCbWrapped");}if(g){r.class("sapMCbErr");}else if(h){r.class("sapMCbWarn");}else if(j){r.class("sapMCbSucc");}else if(k){r.class("sapMCbInfo");}if(u){r.style("width",o.getWidth());}var t=this.getTooltipText(o);if(t){r.attr("title",t);}if(I){r.attr("tabindex",o.getTabIndex());}r.accessibilityState(o,{role:"checkbox",selected:null,checked:o._getAriaChecked(),describedby:t?i+"-Descr":undefined});if(b){r.attr("aria-readonly",true);}r.openEnd();r.openStart("div",o.getId()+"-CbBg");r.class("sapMCbBg");if(I&&E&&D.system.desktop){r.class("sapMCbHoverable");}if(!o.getActiveHandling()){r.class("sapMCbActiveStateOff");}r.class("sapMCbMark");if(o.getSelected()){r.class("sapMCbMarkChecked");}if(o.getPartiallySelected()){r.class("sapMCbMarkPartiallyChecked");}r.openEnd();r.voidStart("input",o.getId()+"-CB");r.attr("type","CheckBox");if(o.getSelected()){r.attr("checked","checked");}if(o.getName()){r.attr("name",o.getName());}if(!e){r.attr("disabled","disabled");}if(!E){r.attr("readonly","readonly");}r.voidEnd();r.close("div");r.renderControl(f);if(t&&sap.ui.getCore().getConfiguration().getAccessibility()){r.openStart("span",i+"-Descr");r.class("sapUiHidden");r.openEnd();r.text(t);r.close("span");}r.close("div");};
C.getTooltipText=function(o){var v=o.getProperty("valueStateText"),t=o.getTooltip_AsString();if(v){return(t?t+" - ":"")+v;}else{return V.enrichTooltip(o,t);}};
return C;},true);
sap.ui.predefine('sap/m/ColorPaletteRenderer',['sap/ui/Device'],function(D){"use strict";var C={apiVersion:2};var l=sap.ui.getCore().getLibraryResourceBundle("sap.m");
C.render=function(r,c){r.openStart("div",c);r.class("sapMColorPalette");r.openEnd();if(c._getShowDefaultColorButton()){this.renderDefaultColorButton(r,c);this.renderSeparator(r);}this.renderSwatches(r,c);if(c._getShowMoreColorsButton()){this.renderSeparator(r);this.renderMoreColorsButton(r,c);if(D.system.phone){this.renderSeparator(r);}}if(c._getShowRecentColorsSection()){if(!c._getShowMoreColorsButton()||!D.system.phone){this.renderSeparator(r);}this.renderRecentColorsSection(r,c);if(D.system.phone){this.renderSeparator(r);}}r.close("div");};
C.renderSwatches=function(r,c){var s=c.getColors();r.openStart("div",c.getId()+"-swatchCont-paletteColor");r.class("sapMColorPaletteContent");r.accessibilityState(c,{"role":"region","label":l.getText("COLOR_PALETTE_SWATCH_CONTAINER_TITLE")});r.openEnd();s.forEach(function(a,i){this.renderSquare(r,c,a,i,false);},this);r.close("div");};
C.renderSquare=function(r,c,s,i,I){var n=c._ColorsHelper.getNamedColor(s),a=(n===undefined)?l.getText("COLOR_PALETTE_PREDEFINED_COLOR_CUSTOM"):l.getText("COLOR_PALETTE_PREDEFINED_COLOR_"+n.toUpperCase()),b=I?l.getText("COLOR_PALETTE_RECENT_COLOR",[i+1,a]):l.getText("COLOR_PALETTE_PREDEFINED_COLOR",[i+1,a]);r.openStart("div");r.class("sapMColorPaletteSquare");if(I&&s===""){r.class("sapMRecentColorSquareDisabled");}r.attr("data-sap-ui-color",s);r.attr("tabindex","-1");r.attr("title",b);r.accessibilityState(c,{"role":"button","label":b});r.openEnd();r.openStart("div");r.style("background-color",s);r.openEnd();r.close("div");r.close("div");};
C.renderSeparator=function(r){r.openStart("div");r.class("sapMColorPaletteSeparator");r.openEnd();r.voidStart("hr");r.voidEnd();r.close("div");};
C.renderDefaultColorButton=function(r,c){r.renderControl(c._getDefaultColorButton());};
C.renderMoreColorsButton=function(r,c){r.renderControl(c._getMoreColorsButton());};
C.renderRecentColorsSection=function(r,c){var s,R=c._getRecentColors(),a=5,b=l.getText("COLOR_PALETTE_SWATCH_RECENT_COLOR_CONTAINER_TITLE");r.openStart("div",c.getId()+"-swatchCont-recentColors");r.class("sapMColorPaletteContent");r.attr("role","region");r.attr("aria-label",b);r.openEnd();for(var i=0;i<a;i++){if(R[i]){s=R[i];}else{s="";}this.renderSquare(r,c,s,i,true);}r.close("div");};
return C;},true);
sap.ui.predefine('sap/m/Column',['./library','sap/ui/core/Element','sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device',"sap/ui/thirdparty/jquery"],function(l,E,R,c,D,q){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var T=c.TextAlign;var S=c.SortOrder;
var C=E.extend("sap.m.Column",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},hAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit},styleClass:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},minScreenWidth:{type:"string",group:"Behavior",defaultValue:null},demandPopin:{type:"boolean",group:"Behavior",defaultValue:false},popinHAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin,deprecated:true},popinDisplay:{type:"sap.m.PopinDisplay",group:"Appearance",defaultValue:P.Block},mergeDuplicates:{type:"boolean",group:"Behavior",defaultValue:false},mergeFunctionName:{type:"string",group:"Misc",defaultValue:'getText'},sortIndicator:{type:"sap.ui.core.SortOrder",group:"Appearance",defaultValue:S.None},importance:{type:"sap.ui.core.Priority",group:"Behavior",defaultValue:"None"},autoPopinWidth:{type:"float",group:"Behavior",defaultValue:8}},defaultAggregation:"header",aggregations:{header:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/m/designtime/Column.designtime"}});
C.prototype._index=-1;C.prototype._screen="";C.prototype._media=null;C.prototype._bForcedColumn=false;
C.prototype.exit=function(){this._clearMedia();};
C.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
C.prototype.informTable=function(e,p,v){var t=this.getTable();if(t){var m="onColumn"+e;if(t[m]){t[m](this,p,v);}}};
C.prototype.ontouchstart=function(e){this._bTouchStartMarked=e.isMarked();};
C.prototype.ontap=function(e){if(!this._bTouchStartMarked&&!e.isMarked()){this.informTable("Press");}};
C.prototype.onsapspace=function(e){if(e.srcControl===this){this.informTable("Press");e.preventDefault();}};
C.prototype.onsapenter=C.prototype.onsapspace;
C.prototype.invalidate=function(){var p=this.getParent();if(!p||!p.bOutput){return;}E.prototype.invalidate.apply(this,arguments);};
C.prototype._clearMedia=function(){if(this._media&&this._minWidth){this._detachMediaContainerWidthChange(this._notifyResize,this,this.getId());D.media.removeRangeSet(this.getId());this._media=null;}};
C.prototype._addMedia=function(){delete this._bShouldAddMedia;if(this._minWidth){D.media.initRangeSet(this.getId(),[parseFloat(this._minWidth)]);this._attachMediaContainerWidthChange(this._notifyResize,this,this.getId());this._media=this._getCurrentMediaContainerRange(this.getId());if(this._media){this._media.matches=!!this._media.from;}}};
C.prototype._notifyResize=function(m){if(this._media.from===m.from){return;}this._media=m;this._media.matches=!!m.from;setTimeout(function(){this.fireEvent("media",this);this.informTable("Resize");}.bind(this),0);};
C.prototype._validateMinWidth=function(w){if(!w){return;}if(Object.prototype.toString.call(w)!="[object String]"){throw new Error('expected string for property "minScreenWidth" of '+this);}if(Object.keys(l.ScreenSizes).indexOf(w.toLowerCase())!=-1){return;}if(!/^\d+(\.\d+)?(px|em|rem)$/i.test(w)){throw new Error('invalid CSS size("px", "em", "rem" required) or sap.m.ScreenSize enumeration for property "minScreenWidth" of '+this);}};
C.prototype._isWidthPredefined=function(w){var t=this,u=w.replace(/[^a-z]/ig,""),b=parseFloat(l.BaseFontSize)||16;q.each(l.ScreenSizes,function(s,a){if(u!="px"){a/=b;}if(a+u==w){t._minWidth=this+"px";t._screen=s;return false;}});if(this._minWidth){return true;}if(u=="px"){this._minWidth=w;}else{this._minWidth=parseFloat(w)*b+"px";}};
C.prototype.getCssAlign=function(a){a=a||this.getHAlign();if(a===T.Begin||a===T.End||a===T.Initial){a=R.getTextAlign(a);}return a.toLowerCase();};
C.prototype.getStyleClass=function(r){var a=this.getProperty("styleClass");if(!r){return a;}if(this._screen&&(!this.getDemandPopin()||!window.matchMedia)){a+=" sapMSize-"+this._screen;}else if(this._media&&!this._media.matches){a+=" sapMListTblNone";}return a.trim();};
C.prototype.setIndex=function(n){this._index=+n;};
C.prototype.setOrder=function(n){this._order=+n;};
C.prototype.getOrder=function(){return this.hasOwnProperty("_order")?this._order:this.getInitialOrder();};
C.prototype.setInitialOrder=function(n){this._initialOrder=+n;};
C.prototype.getInitialOrder=function(){if(this.hasOwnProperty("_initialOrder")){return this._initialOrder;}var t=this.getTable();if(!t){return-1;}return t.indexOfColumn(this);};
C.prototype.setDisplay=function(t,d){if(!t||this._index<0){return;}var i=this._index+1,p=this.getParent(),a=d?"table-cell":"none",h=t.querySelector("tr > th:nth-child("+i+")"),b=t.querySelectorAll("tr > td:nth-child("+i+")"),e=b.length;h.style.display=a;h.setAttribute("aria-hidden",!d);for(i=0;i<e;i++){b[i].style.display=a;b[i].setAttribute("aria-hidden",!d);}if(p&&p.setTableHeaderVisibility){setTimeout(function(){p.setTableHeaderVisibility(d);},0);}};
C.prototype.setWidth=function(w){var t=this.getTable();if(!t){return this.setProperty("width",w);}if(this.getWidth()===w){return this;}var o=t.shouldRenderDummyColumn();this.informTable("WidthChanged",w);if(o!==t.shouldRenderDummyColumn()){return this.setProperty("width",w);}var a=t.getAutoPopinMode();this.setProperty("width",w,a);if(a){var $=this.$();$.css("width",w);$.attr("data-sap-width",w);}this.informTable("RecalculateAutoPopin",true);return this;};
C.prototype.setImportance=function(i){if(this.getImportance()===i){return this;}this.setProperty("importance",i,true);this.informTable("RecalculateAutoPopin",true);return this;};
C.prototype.setAutoPopinWidth=function(w){if(this.getAutoPopinWidth()===w){return this;}this.setProperty("autoPopinWidth",w,true);this.informTable("RecalculateAutoPopin",true);return this;};
C.prototype.setVisible=function(v){if(v==this.getVisible()){return this;}var p=this.getParent(),t=p&&p.getTableDomRef&&p.getTableDomRef(),s=t&&this._index>=0;this.setProperty("visible",v,s);if(s){this.informTable("RecalculateAutoPopin",true);this.setDisplay(t,v);}return this;};
C.prototype._setMinScreenWidth=function(w){this._clearMedia();this._minWidth=0;this._screen="";if(w){w=w.toLowerCase();var a=l.ScreenSizes[w];if(a){this._screen=w;this._minWidth=a+"px";}else{this._isWidthPredefined(w);}var p=this.getTable();if(p&&p.isActive()){this._addMedia();}else{this._bShouldAddMedia=true;}}};
C.prototype.setMinScreenWidth=function(w){if(w==this.getMinScreenWidth()){return this;}this._validateMinWidth(w);this._setMinScreenWidth(w);var t=this.getTable();if(!t){return this.setProperty("minScreenWidth",w);}return this.setProperty("minScreenWidth",w,t.getAutoPopinMode());};
C.prototype.setDemandPopin=function(v){if(v==this.getDemandPopin()){return this;}if(!this.getMinScreenWidth()){return this.setProperty("demandPopin",v,true);}return this.setProperty("demandPopin",v);};
C.prototype.setSortIndicator=function(s){this.setProperty("sortIndicator",s,true);this.$().attr("aria-sort",this.getSortIndicator().toLowerCase());return this;};
C.prototype.isPopin=function(){if(!this.getDemandPopin()){return false;}var t=this.getTable();if(t){var h=t.getHiddenInPopin()||[];var H=h.some(function(i){return this.getImportance()===i;},this);if(H){return false;}}if(this._media){return!this._media.matches;}return false;};
C.prototype.isHidden=function(){if(this._media){return!this._media.matches;}if(this._screen&&this._minWidth){return parseFloat(this._minWidth)>window.innerWidth;}return false;};
C.prototype.setLastValue=function(v){if(this.getMergeDuplicates()){this._lastValue=v;}return this;};
C.prototype.clearLastValue=function(){return this.setLastValue(NaN);};
C.prototype.getLastValue=function(){return this._lastValue;};
C.prototype.onItemsRemoved=function(){this.clearLastValue();};
C.prototype.getFocusDomRef=function(){var p=this.getParent();if(p&&p.bActiveHeaders){var o=this.getDomRef();if(o){return o.firstChild;}}return E.prototype.getFocusDomRef.apply(this,arguments);};
C.prototype.getCalculatedMinScreenWidth=function(){return parseInt(this._minWidth)||0;};
C.prototype.setForcedColumn=function(f){if(this._bForcedColumn==f){return;}this._bForcedColumn=f;this._setMinScreenWidth(f?"":this.getMinScreenWidth());};
return C;});
sap.ui.predefine('sap/m/ColumnListItem',["sap/ui/core/Element","sap/ui/core/library","./library","./ListItemBase","./ColumnListItemRenderer","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(E,c,l,L,C,q){"use strict";var a=l.ListType;var V=c.VerticalAlign;
var b=L.extend("sap.m.ColumnListItem",{metadata:{library:"sap.m",properties:{vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit}},defaultAggregation:"cells",aggregations:{cells:{type:"sap.ui.core.Control",multiple:true,singularName:"cell",bindable:"bindable"}}}});
var T=E.extend("sap.m.TablePopin",{
ontap:function(e){if(e.isMarked()||L.detectTextSelection(this.getDomRef())){return e.stopImmediatePropagation(true);}if(e.srcControl===this||!q(e.target).is(":sapFocusable")){this.getParent().focus();}},
_onMouseEnter:function(){var $=q(this),d=$.prev();if(!d.length||!d.hasClass("sapMLIBHoverable")||d.hasClass("sapMPopinHovered")){return;}d.addClass("sapMPopinHovered");},
_onMouseLeave:function(){var $=q(this),d=$.prev();if(!d.length||!d.hasClass("sapMLIBHoverable")||!d.hasClass("sapMPopinHovered")){return;}d.removeClass("sapMPopinHovered");}
});
b.prototype.TagName="tr";
b.prototype.init=function(){L.prototype.init.call(this);this._bNeedsTypeColumn=false;this._aClonedHeaders=[];};
b.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this._checkTypeColumn();var p=this.hasPopin();if(p){this.$Popin().hover(p._onMouseEnter,p._onMouseLeave);}};
b.prototype.exit=function(){L.prototype.exit.call(this);this._checkTypeColumn(false);this._destroyClonedHeaders();if(this._oPopin){this._oPopin.destroy(true);this._oPopin=null;}};
b.prototype.setVisible=function(v){L.prototype.setVisible.call(this,v);if(!v&&this.hasPopin()){this.removePopin();}return this;};
b.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
b.prototype.getPopin=function(){if(!this._oPopin){this._oPopin=new T({id:this.getId()+"-sub"}).addDelegate({ontouchstart:this.ontouchstart,ontouchmove:this.ontouchmove,ontap:this.ontap,ontouchend:this.ontouchend,ontouchcancel:this.ontouchcancel,onsaptabnext:this.onsaptabnext,onsaptabprevious:this.onsaptabprevious,onsapup:this.onsapup,onsapdown:this.onsapdown,oncontextmenu:this.oncontextmenu},this).setParent(this,null,true);}return this._oPopin;};
b.prototype.$Popin=function(){return this.$("sub");};
b.prototype.hasPopin=function(){return this._oPopin;};
b.prototype.removePopin=function(){this._oPopin&&this.$Popin().remove();};
b.prototype.getTabbables=function(){return this.$().add(this.$Popin()).find(":sapTabbable");};
b.prototype.getAccessibilityType=function(B){return B.getText("ACC_CTR_TYPE_ROW");};
b.prototype.getContentAnnouncement=function(B){var t=this.getTable();if(!t){return;}var A="",d=this.getCells(),e=t.getColumns(true);e.forEach(function(o){var f=d[o.getInitialOrder()];if(!f||!o.getVisible()||(o.isHidden()&&!o.isPopin())){return;}var h=o.getHeader();if(h&&h.getVisible()){A+=L.getAccessibilityText(h)+" ";}A+=L.getAccessibilityText(f,true)+" ";});return A;};
b.prototype.updateSelectedDOM=function(s,t){L.prototype.updateSelectedDOM.apply(this,arguments);if(this.hasPopin()){this.$Popin().attr("aria-selected",s);}};
b.prototype.onfocusin=function(e){if(e.isMarked()){return;}if(e.srcControl===this){this.$().children(".sapMListTblCellDup").find(":sapTabbable").attr("tabindex",-1);}L.prototype.onfocusin.apply(this,arguments);};
b.prototype._checkTypeColumn=function(n){if(n==undefined){n=this._needsTypeColumn();}if(this._bNeedsTypeColumn!=n){this._bNeedsTypeColumn=n;this.informList("TypeColumnChange",n);}};
b.prototype._needsTypeColumn=function(){var t=this.getType();return this.getVisible()&&(t==a.Detail||t==a.Navigation||t==a.DetailAndActive);};
b.prototype._addClonedHeader=function(h){return this._aClonedHeaders.push(h);};
b.prototype._destroyClonedHeaders=function(){if(this._aClonedHeaders.length){this._aClonedHeaders.forEach(function(o){o.destroy("KeepDom");});this._aClonedHeaders=[];}};
b.prototype._activeHandlingInheritor=function(){this._toggleActiveClass(true);};
b.prototype._inactiveHandlingInheritor=function(){this._toggleActiveClass(false);};
b.prototype._toggleActiveClass=function(s){if(this.hasPopin()){this.$Popin().toggleClass("sapMLIBActive",s);}};
return b;});
sap.ui.predefine('sap/m/ColumnListItemRenderer',["sap/ui/core/Renderer","sap/ui/core/library","sap/ui/core/Core","sap/ui/Device","sap/base/Log","./library","./ListItemBaseRenderer"],function(R,c,C,D,L,l,a){"use strict";var P=l.PopinDisplay;var V=c.VerticalAlign;var b=l.PopinLayout;var d=R.extend(a);d.apiVersion=2;
d.render=function(r,o){var t=o.getTable();if(!t){return;}a.render.apply(this,arguments);if(o.getVisible()&&t.hasPopin()){this.renderPopin(r,o,t);}};
d.renderHighlight=function(r,o){r.openStart("td");r.class("sapMListTblHighlightCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderHighlight.apply(this,arguments);r.close("td");};
d.renderNavigated=function(r,o){r.openStart("td");r.class("sapMListTblNavigatedCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderNavigated.apply(this,arguments);r.close("td");};
d.renderType=function(r,o){r.openStart("td");r.class("sapMListTblNavCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderType.apply(this,arguments);r.close("td");};
d.renderModeContent=function(r,o){r.openStart("td");r.class("sapMListTblSelCol");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();a.renderModeContent.apply(this,arguments);r.close("td");};
d.renderCounter=function(r,o){};
d.getAriaRole=function(o){return"";};
d.renderLIAttributes=function(r,o){r.class("sapMListTblRow");var A=o.getVAlign();if(A!=V.Inherit){r.class("sapMListTblRow"+A);}var t=o.getTable();if(t&&t.getAlternateRowColors()){var p=t.indexOfItem(o);if(p%2==0){r.class("sapMListTblRowAlternate");}}if(t&&t.shouldRenderDummyColumn()){r.class("sapMListTblRowHasDummyCell");}};
d.renderLIContentWrapper=function(r,o){var t=o.getTable();if(!t){return;}var e=t.getColumns(true),f=o.getCells();o._destroyClonedHeaders();e.forEach(function(g,i){var h,j=true,k=f[g.getInitialOrder()];if(!k||!g.getVisible()||g.isPopin()){g.setIndex(-1);return;}r.openStart("td",o.getId()+"_cell"+i);r.class("sapMListTblCell");r.attr("data-sap-ui-column",g.getId());if(g){r.class(g.getStyleClass(true));h=g.getHeader();if(h){r.attr("headers",g.getId());}if(!t.hasPopin()&&g.getMergeDuplicates()){var F=g.getMergeFunctionName(),m=F.split("#"),s=m[1],n=m[0];if(typeof k[n]!="function"){L.warning("mergeFunctionName property is defined on "+g+" but this is not function of "+k);}else if(t._bRendering||!k.bOutput){var p=g.getLastValue(),q=k[n](s);if(p===q){j=C.getConfiguration().getAccessibility();k.addStyleClass("sapMListTblCellDupCnt");r.class("sapMListTblCellDup");}else{g.setLastValue(q);}}else if(k.hasStyleClass("sapMListTblCellDupCnt")){r.class("sapMListTblCellDup");}}g.getVAlign()!="Inherit"&&r.style("vertical-align",g.getVAlign().toLowerCase());r.style("text-align",g.getCssAlign());if(g.isHidden()){r.style("display","none");r.attr("aria-hidden","true");}}r.openEnd();if(j){this.applyAriaLabelledBy(h,k);r.renderControl(k);}r.close("td");},this);};
d.renderDummyCell=function(r,o){r.openStart("td");r.class("sapMListTblDummyCell");r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();r.close("td");};
d.applyAriaLabelledBy=function(h,o){if(h&&h.getText&&h.getVisible()&&o.getAriaLabelledBy&&(o.getAriaLabelledBy()||[]).indexOf(h.getId())==-1){o.addAriaLabelledBy(h);}};
d.renderPopin=function(r,o,t){o.removePopin();r.openStart("tr",o.getPopin());r.class("sapMListTblSubRow");r.attr("tabindex","-1");if(o.isSelectable()){r.attr("aria-selected",o.getSelected());}r.openEnd();this.renderHighlight(r,o);r.openStart("td",o.getId()+"-subcell");r.attr("colspan",t.shouldRenderDummyColumn()?t.getColSpan()+1:t.getColSpan());var p=t.getPopinLayout();if(D.browser.msie||(D.browser.edge&&D.browser.version<16)){p=b.Block;}r.attr("aria-labelledby",this.getAriaAnnouncement(null,"TABLE_POPIN_ROLE_DESCRIPTION"));r.openEnd();r.openStart("div");r.class("sapMListTblSubCnt");r.class("sapMListTblSubCnt"+p);r.openEnd();var e=o.getCells(),f=t.getColumns(true);f.forEach(function(g){if(!g.getVisible()||!g.isPopin()){return;}var h=e[g.getInitialOrder()],H=g.getHeader();if(!H&&!h){return;}var s=g.getStyleClass(),i=g.getPopinDisplay();r.openStart("div");r.class("sapMListTblSubCntRow");s&&r.class(s);r.openEnd();if(H&&i!=P.WithoutHeader){r.openStart("div").class("sapMListTblSubCntHdr").openEnd();H=H.clone();g.addDependent(H);o._addClonedHeader(H);r.renderControl(H);r.close("div");r.openStart("div").class("sapMListTblSubCntSpr").openEnd();r.text(C.getLibraryResourceBundle("sap.m").getText("TABLE_POPIN_LABEL_COLON"));r.close("div");}if(h){r.openStart("div");r.class("sapMListTblSubCntVal");r.class("sapMListTblSubCntVal"+i);r.openEnd();this.applyAriaLabelledBy(H,h);r.renderControl(h);r.close("div");}r.close("div");},this);r.close("div");r.close("td");this.renderNavigated(r,o);r.close("tr");};
d.addLegacyOutlineClass=function(r,o){};
d.renderContentLatter=function(r,o){var t=o.getTable();if(t&&t.shouldRenderDummyColumn()){if(!t.hasPopin()){a.renderContentLatter.apply(this,arguments);this.renderDummyCell(r,o);}else{this.renderDummyCell(r,o);a.renderContentLatter.apply(this,arguments);}}else{a.renderContentLatter.apply(this,arguments);}};
return d;},true);
sap.ui.predefine('sap/m/ComboBox',['./ComboBoxTextField','./ComboBoxBase','./List','./library','sap/ui/Device','sap/ui/core/Item','./StandardListItem','./ComboBoxRenderer','sap/ui/base/ManagedObjectObserver',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","./Toolbar","sap/base/assert","sap/base/security/encodeXML","sap/ui/core/Core","sap/base/Log","sap/ui/dom/jquery/control"],function(C,a,L,l,D,I,S,b,M,c,K,T,d,f,g,h,q){"use strict";var j=l.ListType;var k=l.ListMode;
var m=a.extend("sap.m.ComboBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ComboBox.designtime",properties:{selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},filterSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{value:{type:"string"},itemPressed:{type:"boolean"}}},selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}},dnd:{draggable:false,droppable:true}}});
function H(o,i){if(!i){return;}var e=o.getFocusDomRef(),p=o._getSelectionRange().start,t=e.value.substring(0,e.selectionStart),r=o._shouldResetSelectionStart(i),u=o.getSelectedItem(),G=i.isA("sap.ui.core.SeparatorItem"),v=this.getListItem(i);o.handleListItemsVisualFocus(v);o.setSelection(i);if(i!==u&&!G){o.updateDomValue(i.getText());o.fireSelectionChange({selectedItem:i});i=o.getSelectedItem();if(r){p=0;}o.selectText(p,e.value.length);o._bIsLastFocusedItemHeader=false;}if(G){o.setSelectedItem(null);o.fireSelectionChange({selectedItem:null});o.updateDomValue(t);o._bIsLastFocusedItemHeader=true;o._getGroupHeaderInvisibleText().setText(o._oRb.getText("LIST_ITEM_GROUP_HEADER")+" "+i.getText());}if(o.isOpen()){o.removeStyleClass("sapMFocus");o._getList().addStyleClass("sapMListFocus");}else{o.addStyleClass("sapMFocus");}o.scrollToItem(i);}
m.prototype.scrollToItem=function(i){var p=this.getPicker(),P=p.getDomRef("cont"),o=this.getListItem(i),e=i&&o&&o.getDomRef();if(!p||!P||!e){return;}var r=P.scrollTop,t=e.offsetTop,u=P.clientHeight,v=e.offsetHeight;if(r>t){P.scrollTop=t;}else if((t+v)>(r+u)){P.scrollTop=Math.ceil(t+v-u);}};
function s(i,e){if(document.activeElement===this.getFocusDomRef()){this.selectText(i,e);}}
function n(i){var o=this.getSelectedItem(),e=this.getListItem(o),p=o&&e&&e.getDomRef(),r=p&&p.offsetTop,t=p&&p.offsetHeight,P=this.getPicker(),u=P.getDomRef("cont"),v=u.clientHeight;if(o&&((r+t)>(v))){if(!i){this._getList().$().css("visibility","hidden");}else{u.scrollTop=r-t/2;this._getList().$().css("visibility","visible");}}}
m.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
m.prototype._setItemVisibility=function(i,v){var o=i&&this.getListItem(i).$(),e="sapMSelectListItemBaseInvisible";if(v){i.bVisible=true;o.length&&o.removeClass(e);}else{i.bVisible=false;o.length&&o.addClass(e);}};
m.prototype.setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
m.prototype.revertSelection=function(){var p,P=this.getPickerTextField();this.setSelectedItem(this._oSelectedItemBeforeOpen);this.setValue(this._sValueBeforeOpen);if(this.getSelectedItem()===null){p=this._sValueBeforeOpen;}else{p=this._oSelectedItemBeforeOpen.getText();}P&&P.setValue(p);};
m.prototype.filterItems=function(o){var i=this.getItems(),F=[],e=[],p=o.properties.indexOf("additionalText")>-1,r=this.fnFilter||a.DEFAULT_TEXT_FILTER,G=[],t=false;this._oFirstItemTextMatched=null;i.forEach(function(u){if(u.isA("sap.ui.core.SeparatorItem")){if(!u.getText()){this.getListItem(u).setVisible(false);return;}G.push({separator:u,show:false});t=true;this.getListItem(u).setVisible(false);return;}var v=r.call(this,o.value,u,"getText");var w=r.call(this,o.value,u,"getAdditionalText");if((v||w)&&t){G[G.length-1].show=true;t=false;}if(v){e.push(u);F.push(u);}else if(w&&p){F.push(u);}}.bind(this));i.forEach(function(u){if(u.isA("sap.ui.core.SeparatorItem")){return;}var v=F.indexOf(u)>-1;var w=e.indexOf(u)>-1;if(!this._oFirstItemTextMatched&&w){this._oFirstItemTextMatched=u;}this.getListItem(u).setVisible(v);},this);G.forEach(function(u){if(u.show){this.getListItem(u.separator).setVisible(true);}}.bind(this));return F;};
m.prototype._filterStartsWithItems=function(i,e){var o=i.toLowerCase();var p=this.getItems(),F=p.filter(function(r){return r[e]&&r[e]().toLowerCase().startsWith(o);});return F;};
m.prototype._getFilters=function(){return this.getFilterSecondaryValues()?["text","additionalText"]:["text"];};
m.prototype.getNextFocusableItem=function(e){var A=this.getSelectableItems(),i=this.getNonSeparatorSelectableItems(A),F=this.hasStyleClass("sapMFocus"),o=this.getSelectedItem()||this._getItemByListItem(this._oLastFocusedListItem),p=this.getFormattedTextFocused(),N;if((F&&this.isOpen())||p){N=A[0];}else if(F&&!this.getValueStateLinks().length){N=i[i.indexOf(o)+(e?1:-1)];}else{N=A[A.indexOf(o)+(e?1:-1)];}if(p||(!p&&o===A[0]&&!e&&this.getValueStateLinks().length)){this.setProperty("formattedTextFocused",!p);}return N;};
m.prototype.getNonSeparatorSelectableItems=function(i){return i.filter(function(o){return!o.isA("sap.ui.core.SeparatorItem");});};
m.prototype._itemsTextStartsWithTypedValue=function(i,t){if(!i||typeof t!="string"||t==""){return false;}return i.getText().toLowerCase().startsWith(t.toLowerCase());};
m.prototype._shouldResetSelectionStart=function(i){var o=this.getFocusDomRef(),e=this._getSelectionRange(),p=e.start!==e.end,t=o.value.substring(0,e.start),r=this._itemsTextStartsWithTypedValue(i,t);return!(r&&(p||this._bIsLastFocusedItemHeader));};
m.prototype._getSelectionRange=function(){var o=this.getFocusDomRef(),v=this.getValue(),i=o.selectionStart,e=o.selectionEnd,r={start:i,end:e};if(!(D.browser.msie||D.browser.edge)){return r;}if(this._bIsLastFocusedItemHeader){r.start=v.length;r.end=v.length;}return r;};
m.prototype.handleListItemsVisualFocus=function(o){if(this._oLastFocusedListItem){this._oLastFocusedListItem.removeStyleClass("sapMLIBFocused");this._oLastFocusedListItem=null;}else if(this.isOpen()&&this.getFocusDomRef()){this.getFocusDomRef().setAttribute("aria-activedescendant",o.getId());}if(o){this._oLastFocusedListItem=o;o.addStyleClass("sapMLIBFocused");}};
m.prototype.setSelection=function(i){var o=this._getList(),e=this._getSuggestionsPopover(),p,r;this.setAssociation("selectedItem",i);this._setPropertyProtected("selectedItemId",(i instanceof I)?i.getId():i,true);if(typeof i==="string"){i=g.byId(i);}if(o){p=this.getListItem(i);if(p){o.setSelectedItem(p,true);}else{o.removeSelections(true);}}r=i?i.getKey():"";this._setPropertyProtected("selectedKey",r);if(e){e._iPopupListSelectedIndex=this.getItems().indexOf(i);}};
m.prototype.isSelectionSynchronized=function(){var i=this.getSelectedItem();return this.getSelectedKey()===(i&&i.getKey());};
m.prototype.isFiltered=function(){var o=this._getList();return o&&(o.getVisibleItems().length!==this.getItems().length);};
m.prototype.isItemVisible=function(i){return i&&(i.bVisible===undefined||i.bVisible);};
m.prototype._mapItemToListItem=function(i){var o,e,p,A;var r=this.getRenderer();if(!i){return null;}A=(i.getAdditionalText&&this.getShowSecondaryValues())?i.getAdditionalText():"";e=r.CSS_CLASS_COMBOBOXBASE+"Item";p=(this.isItemSelected(i))?e+"Selected":"";if(i.isA("sap.ui.core.SeparatorItem")){o=this._mapSeparatorItemToGroupHeader(i,r);}else{o=new S({type:j.Active,info:A,visible:i.getEnabled()}).addStyleClass(e+" "+p);}o.setTitle(i.getText());this.setSelectable(i,i.getEnabled());o.setTooltip(i.getTooltip());i.data(r.CSS_CLASS_COMBOBOXBASE+"ListItem",o);i.getCustomData().forEach(function(t){o.addCustomData(t.clone());});this._oItemObserver.observe(i,{properties:["text","additionalText","enabled","tooltip"]});return o;};
m.prototype._forwardItemProperties=function(p){var i=p.object,o=i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"ListItem"),e={text:"title",enabled:"visible",tooltip:"tooltip"},A,P,r;if(Object.keys(e).indexOf(p.name)>-1){P=e[p.name];r="set"+P.charAt(0).toUpperCase()+P.slice(1);o[r](p.current);}if(p.name==="additionalText"){A=this.getShowSecondaryValues()?p.current:"";o.setInfo(A);}};
m.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
m.prototype.setAssociation=function(A,i,e){var o=this._getList();if(o&&(A==="selectedItem")){if(!(i instanceof I)){i=this.findItem("id",i);}o.setSelectedItem(this.getListItem(i),true);}return a.prototype.setAssociation.apply(this,arguments);};
m.prototype.removeAllAssociation=function(A,e){var o=this._getList();if(o&&(A==="selectedItem")){L.prototype.removeAllAssociation.apply(o,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
m.prototype.init=function(){this._oRb=g.getLibraryResourceBundle("sap.m");a.prototype.init.apply(this,arguments);this.bOpenValueStateMessage=true;this._sValueBeforeOpen="";this._sInputValueBeforeOpen="";this._oSelectedItemBeforeOpen=null;this._oFirstItemTextMatched=null;this.bIsFocused=false;if(D.system.phone){this.attachEvent("_change",this.onPropertyChange,this);}this._oLastFocusedListItem=null;this._bIsLastFocusedItemHeader=null;this._oItemObserver=new M(this._forwardItemProperties.bind(this));};
m.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);var o=this.getSelectedItem(),e=this._getList(),i=o&&this.getListItem(o),F=this.getProperty("formattedTextFocused"),p=this.getPicker()&&this.getPicker().getCustomHeader(),P=(D.browser.msie&&p&&p.getFormattedText)?p.getFormattedText():p;this.synchronizeSelection();if(!this.getOpen()&&document.activeElement===this.getFocusDomRef()){this.addStyleClass("sapMFocus");}if(F){P.addStyleClass("sapMPseudoFocus");e.removeStyleClass("sapMListFocus");i.removeStyleClass("sapMLIBFocused");this.removeStyleClass("sapMFocus");}else if(P){P.removeStyleClass("sapMPseudoFocus");}};
m.prototype._fillList=function(){var o=this._getList(),e,p,r,i,t;if(!o){return;}if(this._oLastFocusedListItem){t=this._getItemByListItem(this._oLastFocusedListItem);}o.destroyItems();e=this.getItems();if(this._sInputValueBeforeOpen){e=this.filterItems({properties:this._getFilters(),value:this._sInputValueBeforeOpen});}for(i=0,r=e.length;i<r;i++){p=this._mapItemToListItem(e[i]);o.addAggregation("items",p,true);}if(t){this._oLastFocusedListItem=this.getListItem(t);}};
m.prototype.exit=function(){a.prototype.exit.apply(this,arguments);this._oRb=null;this._oSelectedItemBeforeOpen=null;this._oFirstItemTextMatched=null;this._oLastFocusedListItem=null;if(this._oSuggestionPopover){if(this._oPickerCustomHeader){this._oPickerCustomHeader.destroy();this._oPickerCustomHeader=null;}this._oSuggestionPopover.destroy();this._oSuggestionPopover=null;}if(this._oItemObserver){this._oItemObserver.disconnect();this._oItemObserver=null;}};
m.prototype.onBeforeRenderingPicker=function(){var o=this["onBeforeRendering"+this.getPickerType()];o&&o.call(this);};
m.prototype.onBeforeRenderingDropdown=function(){var p=this.getPicker(),w=(this.$().outerWidth()/parseFloat(l.BaseFontSize))+"rem";if(p){p.setContentMinWidth(w);}};
m.prototype.onBeforeRenderingList=function(){if(this.bProcessingLoadItemsEvent){var o=this._getList(),F=this.getFocusDomRef();if(o){o.setBusy(true);}if(F){F.setAttribute("aria-busy","true");}}};
m.prototype.onAfterRenderingPicker=function(){var o=this["onAfterRendering"+this.getPickerType()];o&&o.call(this);n.call(this,false);};
m.prototype.onAfterRenderingList=function(){var o=this.getSelectedItem(),e=this.getListItem(o);if(this.bProcessingLoadItemsEvent&&(this.getItems().length===0)){return;}var i=this._getList(),F=this.getFocusDomRef();this._highlightList(this._sInputValueBeforeOpen);if(o){i.setSelectedItem(e);this.handleListItemsVisualFocus(e);}if(i){i.setBusy(false);}if(F){F.removeAttribute("aria-busy");}};
m.prototype.oninput=function(e){a.prototype.oninput.apply(this,arguments);this.syncPickerContent();if(e.isMarked("invalid")){return;}this.loadItems(function(){this.handleInputValidation(e,this.isComposingCharacter());},{name:"input",busyIndicator:false});if(this.bProcessingLoadItemsEvent&&(this.getPickerType()==="Dropdown")){this.open();}if(this._oLastFocusedListItem){this._oLastFocusedListItem.removeStyleClass("sapMLIBFocused");this._oLastFocusedListItem=null;}this.setFormattedTextFocused(false);this.addStyleClass("sapMFocus");this._getList().removeStyleClass("sapMListFocus");if(this._getItemsShownWithFilter()){this.toggleIconPressedStyle(true);}};
m.prototype.handleInputValidation=function(e,i){var v,o,F,p,r,t=this.getSelectedItem(),V=e.target.value,E=V==="",u=e.srcControl,w=(this.getPickerType()==="Dropdown");if(E&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){v=this.getItems();}else{v=this.filterItems({properties:this._getFilters(),value:V});}F=v[0];p=v.some(function(x){return x.getKey()===this.getSelectedKey();},this);o=this.intersectItems(this._filterStartsWithItems(V,'getText'),v);r=!E&&F&&F.getEnabled();if(F&&this.getSelectedKey()&&!p){this.setSelection(null);}if(r&&u&&u._bDoTypeAhead){this.handleTypeAhead(u,v,V,i);}else if(r&&V===o[0].getText()){this.setSelection(o[0]);}else{this.setSelection(null);}if(t!==this.getSelectedItem()){this.fireSelectionChange({selectedItem:this.getSelectedItem()});}this._sInputValueBeforeOpen=V;if(this.isOpen()){setTimeout(function(){this._highlightList(V);}.bind(this));}if(F){if(E&&!this.bOpenedByKeyboardOrButton){this.close();}else if(w){this.open();this.scrollToItem(this.getSelectedItem());}}else if(this.isOpen()){if(w&&!this.bOpenedByKeyboardOrButton){this.close();}}else{this.clearFilter();}};
m.prototype.handleTypeAhead=function(i,e,v,o){var p=this.intersectItems(this._filterStartsWithItems(v,'getText'),e);var r=this.getFilterSecondaryValues();var t=D.system.desktop;var u=this.intersectItems(this._filterStartsWithItems(v,'getAdditionalText'),e);if(r&&!p[0]&&u[0]){!o&&i.updateDomValue(u[0].getAdditionalText());this.setSelection(u[0]);}else if(p[0]){!o&&i.updateDomValue(p[0].getText());this.setSelection(p[0]);}if(t){s.call(i,v.length,i.getValue().length);}else{setTimeout(s.bind(i,v.length,i.getValue().length),0);}this.addStyleClass("sapMFocus");this._getList().removeStyleClass("sapMListFocus");};
m.prototype.onSelectionChange=function(o){var i=this._getItemByListItem(o.getParameter("listItem")),p=this.getChangeEventParams(),e=(i!==this.getSelectedItem());this.updateDomValue(i.getText());this.setSelection(i);this.fireSelectionChange({selectedItem:this.getSelectedItem()});if(e){p.itemPressed=true;this.onChange(null,p);}};
m.prototype.onItemPress=function(o){var e=o.getParameter("listItem"),t=e.getTitle(),p=this.getChangeEventParams(),i=(e!==this.getListItem(this.getSelectedItem()));if(e.isA("sap.m.GroupHeaderListItem")){return;}this.handleListItemsVisualFocus(e);this.updateDomValue(t);if(!i){p.itemPressed=true;this.onChange(null,p);}this._setPropertyProtected("value",t,true);if(this.getPickerType()==="Dropdown"&&!this.isPlatformTablet()){this.selectText.bind(this,this.getValue().length,this.getValue().length);}this.close();};
m.prototype.onBeforeOpen=function(){a.prototype.onBeforeOpen.apply(this,arguments);var p=this["onBeforeOpen"+this.getPickerType()],o=this.getFocusDomRef();this.setProperty("open",true);if(this.hasLoadItemsEventListeners()&&!this.bProcessingLoadItemsEvent){this.loadItems();}if(o){o.setAttribute("aria-controls",this.getPicker().getId());}this.addContent();p&&p.call(this);};
m.prototype.onBeforeOpenDialog=function(){var p=this.getPickerTextField();this._oSelectedItemBeforeOpen=this.getSelectedItem();this._sValueBeforeOpen=this.getValue();if(this.getSelectedItem()){this.filterItems({properties:this._getFilters(),value:""});}p.setValue(this._sValueBeforeOpen);};
m.prototype.onAfterOpen=function(){var i=this.getSelectedItem(),o=this._getSelectionRange(),t=this.isPlatformTablet();this.closeValueStateMessage();n.call(this,true);if(!t&&i&&o.start===o.end&&o.start>1){setTimeout(function(){this.selectText(0,o.end);}.bind(this),0);}};
m.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);var o=this.getFocusDomRef();this.setProperty("open",false);this.setProperty("formattedTextFocused",false);if(o){o.removeAttribute("aria-controls");}this.toggleIconPressedStyle(false);};
m.prototype.onAfterClose=function(){this.clearFilter();this._sInputValueBeforeOpen="";if(this.isPickerDialog()){a.prototype.closeValueStateMessage.apply(this,arguments);}};
m.prototype.onItemChange=function(o){var e=this.getAssociation("selectedItem"),N=o.getParameter("newValue"),p=o.getParameter("name");if(e===o.getParameter("id")){switch(p){case"text":if(!this.isBound("value")){this.setValue(N);}break;case"key":if(!this.isBound("selectedKey")){this.setSelectedKey(N);}break;}}};
m.prototype.onkeydown=function(e){var o=e.srcControl;a.prototype.onkeydown.apply(o,arguments);if(!o.getEnabled()||!o.getEditable()){return;}var i=K;o._bDoTypeAhead=!D.os.android&&(e.which!==i.BACKSPACE)&&(e.which!==i.DELETE);};
m.prototype.oncut=function(e){var o=e.srcControl;a.prototype.oncut.apply(o,arguments);o._bDoTypeAhead=false;};
m.prototype.onsapenter=function(e){var o=e.srcControl,i=o.getSelectedItem();if(i&&this.getFilterSecondaryValues()){o.updateDomValue(i.getText());}a.prototype.onsapenter.apply(o,arguments);if(!o.getEnabled()||!o.getEditable()){return;}if(o.isOpen()&&!this.isComposingCharacter()){o.close();}};
m.prototype.onsapdown=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();e.setMarked();e.preventDefault();this.loadItems(function navigateToNextSelectableItem(){H.call(this,o,this.getNextFocusableItem(true));});};
m.prototype.onsapup=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();e.setMarked();e.preventDefault();this.loadItems(function navigateToPrevSelectableItem(){H.call(this,o,this.getNextFocusableItem(false));});};
m.prototype.onsaphome=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();e.setMarked();if(this.getValueStateLinks().length){this.setProperty("formattedTextFocused",true);}e.preventDefault();this.loadItems(function navigateToFirstSelectableItem(){var F=this.getSelectableItems()[0];H.call(this,o,F);});};
m.prototype.onsapend=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();e.setMarked();e.preventDefault();if(this.getValueStateLinks().length&&this.getFormattedTextFocused()){this.setProperty("formattedTextFocused",false);}this.loadItems(function navigateToLastSelectableItem(){var i=this.findLastEnabledItem(this.getSelectableItems());H.call(this,o,i);});};
m.prototype.onsappagedown=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();e.setMarked();e.preventDefault();if(this.getValueStateLinks().length&&this.getFormattedTextFocused()){this.setProperty("formattedTextFocused",false);}this.loadItems(function(){var i=this.getNonSeparatorSelectableItems(this.getSelectableItems()),p=i.indexOf(this.getSelectedItem())+10,r;p=(p>i.length-1)?i.length-1:Math.max(0,p);r=i[p];H.call(this,o,r);});};
m.prototype.onsappageup=function(e){var o=e.srcControl;if(!o.getEnabled()||!o.getEditable()){return;}this.syncPickerContent();e.setMarked();e.preventDefault();this.loadItems(function(){var i=this.getNonSeparatorSelectableItems(this.getSelectableItems()),p=i.indexOf(this.getSelectedItem())-10,r;p=(p>i.length-1)?i.length-1:Math.max(0,p);r=i[p];H.call(this,o,r);});};
m.prototype.onsapshow=function(e){var i,o,E=this.getEditable(),p;a.prototype.onsapshow.apply(this,arguments);this.syncPickerContent();if(!this.getValue()&&E){i=this.getSelectableItems();o=this.getNonSeparatorSelectableItems(i)[0];if(o){p=this.getListItem(o);if(this.isOpen()){this.removeStyleClass("sapMFocus");this._getList().addStyleClass("sapMListFocus");this.handleListItemsVisualFocus(p);}else{this.addStyleClass("sapMFocus");}this.setSelection(o);this.updateDomValue(o.getText());this.fireSelectionChange({selectedItem:o});setTimeout(function(){this.selectText(0,o.getText().length);}.bind(this),0);}}};
m.prototype.onsaphide=m.prototype.onsapshow;
m.prototype.ontap=function(e){var o=this.getFocusDomRef(),A="aria-activedescendant";this.addStyleClass("sapMFocus");if(this.getFormattedTextFocused()){this.setFormattedTextFocused(false);}else if((this.getOpen()&&this._getList().hasStyleClass("sapMListFocus"))||this._oLastFocusedListItem){this._getList().removeStyleClass("sapMListFocus");this._oLastFocusedListItem.removeStyleClass("sapMLIBFocused");this._oLastFocusedListItem=null;o.removeAttribute(A);}};
m.prototype.onfocusin=function(e){var i=this.getPickerType()==="Dropdown";if(this._bIsBeingDestroyed){return;}if(e.target===this.getOpenArea()){this.bOpenValueStateMessage=false;if(i&&!this.isPlatformTablet()){this.focus();}}else{if(i){setTimeout(function(){if(document.activeElement===this.getFocusDomRef()&&!this.bIsFocused&&!this.bFocusoutDueRendering&&!this.getSelectedText()){this.selectText(0,this.getValue().length);}this.bIsFocused=true;}.bind(this),0);}if(!this.isOpen()&&this.bOpenValueStateMessage&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}this.bOpenValueStateMessage=true;}if(this.getEnabled()&&(!this.isOpen()||!this.getSelectedItem()||!this._getList().hasStyleClass("sapMListFocus"))){this.addStyleClass("sapMFocus");}};
m.prototype.onsapfocusleave=function(e){this.bIsFocused=false;var t,p,r,F,i=this.getSelectedItem();if(i&&this.getFilterSecondaryValues()){this.updateDomValue(i.getText());}a.prototype.onsapfocusleave.apply(this,arguments);if(this.isPickerDialog()){return;}p=this.getPicker();if(!e.relatedControlId||!p){return;}t=this.isPlatformTablet();r=g.byId(e.relatedControlId);F=r&&r.getFocusDomRef();if(c(p.getFocusDomRef(),F)&&!t&&!this.getFormattedTextFocused()){this.focus();}};
m.prototype.synchronizeSelection=function(){if(this.isSelectionSynchronized()){return;}var e=this.getSelectedKey(),i=this.getItemByKey(""+e);if(i&&(e!=="")){this.setAssociation("selectedItem",i,true);this._setPropertyProtected("selectedItemId",i.getId(),true);if(this._sValue===this.getValue()){this.setValue(i.getText());this._sValue=this.getValue();}}};
m.prototype.configPicker=function(p){var r=this.getRenderer(),e=r.CSS_CLASS_COMBOBOXBASE;p.setHorizontalScrolling(false).addStyleClass(e+"Picker").addStyleClass(e+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this);};
m.prototype._configureList=function(o){var r=this.getRenderer();if(!o){return;}o.setMode(k.SingleSelectMaster).addStyleClass(r.CSS_CLASS_COMBOBOXBASE+"List").addStyleClass(r.CSS_CLASS_COMBOBOX+"List");o.attachSelectionChange(this.onSelectionChange,this).attachItemPress(this.onItemPress,this);o.addEventDelegate({onBeforeRendering:this.onBeforeRenderingList,onAfterRendering:this.onAfterRenderingList},this);};
m.prototype.destroyItems=function(){this.destroyAggregation("items");if(this._getList()){this._getList().destroyItems();}return this;};
m.prototype.getDefaultSelectedItem=function(){return null;};
m.prototype.getChangeEventParams=function(){return{itemPressed:false};};
m.prototype.clearSelection=function(){this.setSelection(null);};
m.prototype.selectText=function(i,e){a.prototype.selectText.apply(this,arguments);this.textSelectionStart=i;this.textSelectionEnd=e;return this;};
m.prototype.removeAllItems=function(){var i=a.prototype.removeAllItems.apply(this,arguments);this._fillList();return i;};
m.prototype.clone=function(i){var o=a.prototype.clone.apply(this,arguments),e=this._getList();if(!this.isBound("items")&&e){o.syncPickerContent();o.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));}return o;};
m.prototype.open=function(){this.syncPickerContent();var o=this._getList();a.prototype.open.call(this);if(this.getSelectedItem()){o.addStyleClass("sapMListFocus");this.removeStyleClass("sapMFocus");}return this;};
m.prototype.syncPickerContent=function(){var p,P=this.getPicker(),e=this.getInputForwardableProperties();if(!P){var i,G;P=this.createPicker(this.getPickerType());p=this.getPickerTextField();this._fillList();if(p){e.forEach(function(o){o=o.charAt(0).toUpperCase()+o.slice(1);i="set"+o;G="get"+o;if(p[i]){p[i](this[G]());}},this);}this._getSuggestionsPopover().updateValueState(this.getValueState(),this.getValueStateText(),this.getShowValueStateMessage());}this.synchronizeSelection();return P;};
m.prototype.findAggregatedObjects=function(){var o=this._getList();if(o){return L.prototype.findAggregatedObjects.apply(o,arguments);}return[];};
m.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=g.byId(i);}if(!(i instanceof I)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));return this;};
m.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);i=this.getSelectedItem();this.setValue(this._getSelectedItemText(i));return this;};
m.prototype.setSelectedKey=function(e){e=this.validateProperty("selectedKey",e);var i=(e===""),o=this.isBound("selectedKey")&&this.isBound("value")&&this.getBindingInfo("selectedKey").skipModelUpdate;if(i){this.setSelection(null);if(!o){this.setValue("");}return this;}var p=this.getItemByKey(e);if(p){this.setSelection(p);if(!o){this.setValue(this._getSelectedItemText(p));}return this;}this._sValue=this.getValue();return this._setPropertyProtected("selectedKey",e);};
m.prototype._setPropertyProtected=function(p,v,i){try{return this.setProperty(p,v,i);}catch(e){h.warning("setSelectedKey update failed due to exception. Loggable in support mode log",null,null,function(){return{exception:e};});}};
m.prototype.getSelectedItem=function(){var v=this.getAssociation("selectedItem");return(v===null)?null:g.byId(v)||null;};
m.prototype.removeItem=function(i){i=a.prototype.removeItem.apply(this,arguments);var o;if(this._getList()){this._getList().removeItem(i&&this.getListItem(i));}if(this.isBound("items")&&!this.bItemsUpdated){return i;}var v=this.getValue();if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){o=this.getDefaultSelectedItem();this.setSelection(o);this.setValue(v);}return i;};
m.prototype._modifyPopupInput=function(i){a.prototype._modifyPopupInput.apply(this,arguments);i.addEventDelegate({onsapenter:function(){var t=i.getValue();this.updateDomValue(t);this.onChange();if(t){this.updateDomValue(t);this.onChange();this.close();}}},this);return i;};
m.prototype.applyShowItemsFilters=function(){var p,P;this.syncPickerContent();p=this.getPicker();P=function(){p.detachBeforeOpen(P,this);p=null;this.filterItems({value:this.getValue()||"_",properties:this._getFilters()});};p.attachBeforeOpen(P,this);};
m.prototype._getFormattedValueStateText=function(){if(this.isOpen()){return this._getSuggestionsPopover()._getValueStateHeader().getFormattedText();}else{return C.prototype.getFormattedValueStateText.call(this);}};
return m;});
sap.ui.predefine('sap/m/ComboBoxBase',['./Dialog','./ComboBoxTextField','./Input','./GroupHeaderListItem','./SuggestionsPopover','sap/ui/core/SeparatorItem','sap/ui/core/InvisibleText','sap/base/Log','./library','sap/ui/Device','sap/ui/core/library','./ComboBoxBaseRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/security/encodeXML","sap/base/strings/escapeRegExp"],function(D,C,I,G,S,a,b,L,l,c,d,e,f,K,q,g,h){"use strict";var P=l.PlacementType;var j=["value","enabled","name","placeholder","editable","textAlign","textDirection","valueState","valueStateText"];
var k=C.extend("sap.m.ComboBoxBase",{metadata:{library:"sap.m","abstract":true,defaultAggregation:"items",properties:{showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},formattedTextFocused:{type:"boolean",defaultValue:false,hidden:true},open:{type:"boolean",defaultValue:false,hidden:true}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"}},events:{loadItems:{}},dnd:{draggable:false,droppable:true}}});
k.DEFAULT_TEXT_FILTER=function(i,o,p){var s,m,M;if(!o[p]){return false;}s=o[p]().toLowerCase();m=i.toLowerCase();M=new RegExp('(^|\\s)'+h(m)+".*",'g');return M.test(s);};
k.prototype.oncompositionstart=function(){this._bIsComposingCharacter=true;};
k.prototype.oncompositionend=function(E){this._bIsComposingCharacter=false;this._sComposition=E.target.value;if(!c.browser.edge&&!c.browser.firefox){C.prototype.handleInput.apply(this,arguments);this.handleInputValidation(E,this.isComposingCharacter());}};
k.prototype.isComposingCharacter=function(){return this._bIsComposingCharacter;};
k.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;if(this.hasLoadItemsEventListeners()){this.onItemsLoaded();}};
k.prototype.setFilterFunction=function(F){if(F===null||F===undefined){this.fnFilter=null;return this;}if(typeof(F)!=="function"){L.warning("Passed filter is not a function and the default implementation will be used");}else{this.fnFilter=F;}return this;};
k.prototype.highLightList=function(v,i,B){if(B&&typeof B==="function"){B(i,v);}else{this._getSuggestionsPopover().highlightSuggestionItems(i,v,true);}};
k.prototype._highlightList=function(v){var i=[],m=[],o,n,p;this._getList().getItems().forEach(function(r){n=r.getDomRef();p=n&&n.getElementsByClassName("sapMSLITitleOnly")[0];if(p){i.push(p);o=n.querySelector(".sapMSLIInfo");if(o&&r.getInfo){m.push(o);}}});this.highLightList(v,i);this.highLightList(v,m);};
k.prototype._modifyPopupInput=function(i){this.setTextFieldHandler(i);return i;};
k.prototype.setTextFieldHandler=function(t){var i=this,T=t._handleEvent;t._handleEvent=function(E){T.apply(this,arguments);if(/keydown|sapdown|sapup|saphome|sapend|sappagedown|sappageup|input/.test(E.type)){i._handleEvent(E);}};};
k.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
k.prototype.loadItems=function(i,o){var m=typeof i==="function";if(this.hasLoadItemsEventListeners()&&(this.getItems().length===0)){this._bOnItemsLoadedScheduled=false;if(m){o=q.extend({action:i,busyIndicator:true,busyIndicatorDelay:300},o);this.aMessageQueue.push(o);if((this.iLoadItemsEventInitialProcessingTimeoutID===-1)&&(o.busyIndicator)){this.iLoadItemsEventInitialProcessingTimeoutID=setTimeout(function onItemsNotLoadedAfterDelay(){this.setInternalBusyIndicatorDelay(0);this.setInternalBusyIndicator(true);}.bind(this),o.busyIndicatorDelay);}}if(!this.bProcessingLoadItemsEvent){this.bProcessingLoadItemsEvent=true;this.fireLoadItems();}}else if(m){i.call(this);}};
k.prototype.onItemsLoaded=function(){this.bProcessingLoadItemsEvent=false;clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);if(this.bInitialBusyIndicatorState!==this.getBusy()){this.setInternalBusyIndicator(this.bInitialBusyIndicatorState);}if(this.iInitialBusyIndicatorDelay!==this.getBusyIndicatorDelay()){this.setInternalBusyIndicatorDelay(this.iInitialBusyIndicatorDelay);}for(var i=0,m,n,o;i<this.aMessageQueue.length;i++){m=this.aMessageQueue.shift();i--;o=(i+1)===this.aMessageQueue.length;n=o?null:this.aMessageQueue[i+1];if(typeof m.action==="function"){if((m.name==="input")&&!o&&(n.name==="input")){continue;}m.action.call(this);}}};
k.prototype.hasLoadItemsEventListeners=function(){return this.hasListeners("loadItems");};
k.prototype._scheduleOnItemsLoadedOnce=function(){if(!this._bOnItemsLoadedScheduled&&!this.isBound("items")&&this.hasLoadItemsEventListeners()&&this.bProcessingLoadItemsEvent){this._bOnItemsLoadedScheduled=true;setTimeout(this.onItemsLoaded.bind(this),0);}};
k.prototype.getPickerInvisibleTextId=function(){return b.getStaticId("sap.m","COMBOBOX_AVAILABLE_OPTIONS");};
k.prototype._getGroupHeaderInvisibleText=function(){if(!this._oGroupHeaderInvisibleText){this._oGroupHeaderInvisibleText=new b();this._oGroupHeaderInvisibleText.toStatic();}return this._oGroupHeaderInvisibleText;};
k.prototype._getItemByListItem=function(o){return this._getItemBy(o,"ListItem");};
k.prototype._getItemBy=function(o,s){s=this.getRenderer().CSS_CLASS_COMBOBOXBASE+s;for(var i=0,m=this.getItems(),n=m.length;i<n;i++){if(m[i].data(s)===o){return m[i];}}return null;};
k.prototype._isListInSuggestMode=function(){return this._getList().getItems().some(function(o){return!o.getVisible()&&this._getItemByListItem(o).getEnabled();},this);};
k.prototype.getListItem=function(i){return i?i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"ListItem"):null;};
k.prototype.getSelectable=function(i){return i._bSelectable;};
k.prototype._setItemsShownWithFilter=function(v){this._bItemsShownWithFilter=v;};
k.prototype._getItemsShownWithFilter=function(){return this._bItemsShownWithFilter;};
k.prototype.init=function(){C.prototype.init.apply(this,arguments);this.setPickerType(c.system.phone?"Dialog":"Dropdown");this._setItemsShownWithFilter(false);this.bItemsUpdated=false;this.bOpenedByKeyboardOrButton=false;this._bShouldClosePicker=false;this._oPickerValueStateText=null;this.bProcessingLoadItemsEvent=false;this.iLoadItemsEventInitialProcessingTimeoutID=-1;this.aMessageQueue=[];this.bInitialBusyIndicatorState=this.getBusy();this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();this._bOnItemsLoadedScheduled=false;this._bDoTypeAhead=true;this.getIcon().addEventDelegate({onmousedown:function(E){this._bShouldClosePicker=this.isOpen();}},this);this.getIcon().attachPress(this._handlePopupOpenAndItemsLoad.bind(this,true));this._sComposition="";this.fnFilter=null;};
k.prototype.onBeforeRendering=function(){var s=this.getOpen(),v=s?this._getSuggestionsPopover()._getValueStateHeader().getText():null,V=s?this._getSuggestionsPopover()._getValueStateHeader().getValueState():null;C.prototype.onBeforeRendering.apply(this,arguments);if(s&&((this.getValueStateText()&&v!==this.getValueStateText())||(this.getValueState()!==V)||this.getFormattedValueStateText())){this._updateSuggestionsPopoverValueState();}};
k.prototype._handlePopupOpenAndItemsLoad=function(o){var p;if(!this.getEnabled()||!this.getEditable()){return;}if(o&&this._getItemsShownWithFilter()){this._bShouldClosePicker=false;this.toggleIconPressedStyle(true);this.bOpenedByKeyboardOrButton=false;this.clearFilter();this._setItemsShownWithFilter(false);return;}if(this._bShouldClosePicker){this._bShouldClosePicker=false;this.close();return;}this.loadItems();this.bOpenedByKeyboardOrButton=o;if(this.isPlatformTablet()){this.syncPickerContent();p=this.getPicker();p.setInitialFocus(p);}this.open();};
k.prototype.exit=function(){C.prototype.exit.apply(this,arguments);if(this._getList()){this._getList().destroy();this._oList=null;}if(this._getGroupHeaderInvisibleText()){this._getGroupHeaderInvisibleText().destroy();this._oGroupHeaderInvisibleText=null;}clearTimeout(this.iLoadItemsEventInitialProcessingTimeoutID);this.aMessageQueue=null;this.fnFilter=null;};
k.prototype.onsapshow=function(E){if(!this.getEnabled()||!this.getEditable()){return;}E.setMarked();if(E.keyCode===K.F4){this.onF4(E);}if(this._getItemsShownWithFilter()){this.loadItems(this._handlePopupOpenAndItemsLoad.bind(this,true));return;}if(this.isOpen()){this.close();return;}this.selectText(0,this.getValue().length);this.loadItems();this.bOpenedByKeyboardOrButton=true;this.open();};
k.prototype.onF4=function(E){E.preventDefault();};
k.prototype.onsapescape=function(E){if(this.getEnabled()&&this.getEditable()&&this.isOpen()){E.setMarked();E.preventDefault();this.close();}else{C.prototype.onsapescape.apply(this,arguments);}};
k.prototype.onsaphide=k.prototype.onsapshow;
k.prototype.onsapfocusleave=function(E){if(!E.relatedControlId){C.prototype.onsapfocusleave.apply(this,arguments);return;}var r=sap.ui.getCore().byId(E.relatedControlId);if(r===this){return;}var p=this.getPicker(),F=r&&r.getFocusDomRef();if(p&&f(p.getFocusDomRef(),F)){return;}C.prototype.onsapfocusleave.apply(this,arguments);};
k.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
k.prototype.addContent=function(p){};
k.prototype.getList=function(){L.warning("[Warning]:","You are attempting to use deprecated method 'getList()', please refer to SAP note 2746748.",this);return this._getList();};
k.prototype._getList=function(){if(this.bIsDestroyed){return null;}return this._oList;};
k.prototype.setPickerType=function(p){this._sPickerType=p;};
k.prototype.getPickerType=function(){return this._sPickerType;};
k.prototype._updateSuggestionsPopoverValueState=function(){var s=this._getSuggestionsPopover();if(!s){return;}var v=this.getValueState(),n=this.getValueState()!==s._getValueStateHeader().getValueState(),N=this.getFormattedValueStateText(),V=this.getValueStateText(),i=N||n;if(s.isOpen()&&!i){this.setFormattedValueStateText(s._getValueStateHeader().getFormattedText());}s.updateValueState(v,(N||V),this.getShowValueStateMessage());};
k.prototype.shouldValueStateMessageBeOpened=function(){var s=C.prototype.shouldValueStateMessageBeOpened.apply(this,arguments);return(s&&!this.isOpen());};
k.prototype.onPropertyChange=function(o,i){var n=o.getParameter("newValue"),p=o.getParameter("name"),m="set"+p.charAt(0).toUpperCase()+p.slice(1),r=(i&&i.srcControl)||this.getPickerTextField();if(this.getInputForwardableProperties().indexOf(p)>-1&&r&&(typeof r[m]==="function")){r[m](n);}};
k.prototype.getInputForwardableProperties=function(){return j;};
k.prototype.isPickerDialog=function(){return this.getPickerType()==="Dialog";};
k.prototype.isPlatformTablet=function(){var n=!c.system.combi,t=c.system.tablet&&n;return t;};
k.prototype.createPickerTextField=function(){var i=new I({width:"100%",showValueStateMessage:false});return i;};
k.prototype.getDropdownSettings=function(){return{showArrow:false,placement:P.VerticalPreferredBottom,offsetX:0,offsetY:0,bounce:false,ariaLabelledBy:this.getPickerInvisibleTextId()||undefined};};
k.prototype._configureList=function(){};
k.prototype.createPicker=function(p){var o=this.getAggregation("picker");if(o){return o;}this._oSuggestionPopover=this._createSuggestionsPopover();o=this._oSuggestionPopover._oPopover;this.setAggregation("picker",o,true);this.configPicker(o);return o;};
k.prototype.configPicker=function(p){};
k.prototype._hasShowSelectedButton=function(){return false;};
k.prototype._createSuggestionsPopover=function(){var u=this.isPickerDialog(),s;s=new S(this);if(u){var i=this.createPickerTextField();s._oPopupInput=this._modifyPopupInput(i);}s._createSuggestionPopup({showSelectedButton:this._hasShowSelectedButton()});s._createSuggestionPopupContent(false);this.forwardEventHandlersToSuggPopover(s);this._oList=s._oList;this._configureList(this._oList);return s;};
k.prototype.forwardEventHandlersToSuggPopover=function(s){s.setOkPressHandler(this._handleOkPress.bind(this));s.setCancelPressHandler(this._handleCancelPress.bind(this));s.setInputLabels(this.getLabels.bind(this));};
k.prototype._handleOkPress=function(){var t=this,T=t.getPickerTextField();t.updateDomValue(T.getValue());t.onChange();t.close();};
k.prototype._handleCancelPress=function(){this.close();this.revertSelection();};
k.prototype.setSelectable=function(i,s){if(this.indexOfItem(i)<0){return;}i._bSelectable=s;var o=this.getListItem(i);if(o){o.setVisible(s);}};
k.prototype.onBeforeOpen=function(){this._updateSuggestionsPopoverValueState();if(!this._getItemsShownWithFilter()){this.toggleIconPressedStyle(true);}};
k.prototype.onBeforeClose=function(){this.bOpenedByKeyboardOrButton=false;this._setItemsShownWithFilter(false);this._updateSuggestionsPopoverValueState();};
k.prototype.getPicker=function(){var p=this.getAggregation("picker");if(p&&!p.bIsDestroyed&&!this.bIsDestroyed){return p;}return null;};
k.prototype._getSuggestionsPopover=function(){return this._oSuggestionPopover;};
k.prototype.getValueStateLinks=function(){var H=this.getPicker()&&this.getPicker().getCustomHeader()&&typeof this.getPicker().getCustomHeader().getFormattedText==="function",F=H&&this.getPicker().getCustomHeader().getFormattedText(),v=F&&F.getControls();return v||[];};
k.prototype.getPickerTextField=function(){var p=this.getPicker(),s=p&&p.getSubHeader();return s&&s.getContent()[0]||null;};
k.prototype.getPickerTitle=function(){var p=this.getPicker(),H=p&&p.getCustomHeader();if(this.isPickerDialog()&&H){return H.getContentMiddle()[0];}return null;};
k.prototype.revertSelection=function(){};
k.prototype.hasContent=function(){return this.getItems().length>0;};
k.prototype.syncPickerContent=function(){};
k.prototype.findFirstEnabledItem=function(m){m=m||this.getItems();for(var i=0;i<m.length;i++){if(m[i].getEnabled()){return m[i];}}return null;};
k.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
k.prototype.open=function(){var p=this.getPicker();if(p){p.open();}return this;};
k.prototype.getVisibleItems=function(){for(var i=0,o,m=this.getItems(),v=[];i<m.length;i++){o=this.getListItem(m[i]);if(o&&o.getVisible()){v.push(m[i]);}}return v;};
k.prototype.isItemSelected=function(){};
k.prototype.getKeys=function(m){m=m||this.getItems();for(var i=0,n=[];i<m.length;i++){n[i]=m[i].getKey();}return n;};
k.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems());};
k.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,n=this.getItems();i<n.length;i++){if(n[i][m]()===v){return n[i];}}return null;};
k.prototype.getItemByText=function(t){return this.findItem("text",t);};
k.prototype.clearFilter=function(){this.getItems().forEach(function(i){var o=this.getListItem(i);if(o){o.setVisible(i.getEnabled()&&this.getSelectable(i));}},this);};
k.prototype.onItemChange=function(o){};
k.prototype.clearSelection=function(){};
k.prototype.setInternalBusyIndicator=function(B){this.bInitialBusyIndicatorState=this.getBusy();return this.setBusy.apply(this,arguments);};
k.prototype.setInternalBusyIndicatorDelay=function(i){this.iInitialBusyIndicatorDelay=this.getBusyIndicatorDelay();return this.setBusyIndicatorDelay.apply(this,arguments);};
k.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this._getList()){this._getList().addItem(this._mapItemToListItem(i));}return this;};
k.prototype.insertItem=function(i,m){this.insertAggregation("items",i,m,true);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this._getList()){this._getList().insertItem(this._mapItemToListItem(i),m);}this._scheduleOnItemsLoadedOnce();return this;};
k.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
k.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
k.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
k.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
k.prototype.getItemByKey=function(s){return this.findItem("key",s);};
k.prototype.addItemGroup=function(o,H,s){H=H||new a({text:o.text||o.key});this.addAggregation("items",H,s);if(this._getList()&&H.isA("sap.ui.core.SeparatorItem")){this._getList().addItem(this._mapItemToListItem(H));}return H;};
k.prototype._mapSeparatorItemToGroupHeader=function(s,o){var i=new G({title:s.getText(),ariaLabelledBy:this._getGroupHeaderInvisibleText().getId()});i.addStyleClass(o.CSS_CLASS_COMBOBOXBASE+"NonInteractiveItem");if(s.getText&&!s.getText()){i.addStyleClass(o.CSS_CLASS_COMBOBOXBASE+"SeparatorItemNoText");}return i;};
k.prototype.isOpen=function(){var p=this.getPicker();return!!(p&&p.isOpen());};
k.prototype.close=function(){var p=this.getPicker();if(p){p.close();}return this;};
k.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
k.prototype.removeAllItems=function(){var m=this.removeAllAggregation("items");this.clearSelection();for(var i=0;i<m.length;i++){m[i].detachEvent("_change",this.onItemChange,this);}return m;};
k.prototype.intersectItems=function(i,o){return i.filter(function(m){return o.map(function(O){return O.getId();}).indexOf(m.getId())!==-1;});};
k.prototype.showItems=function(F){var i=this.fnFilter,m=function(){if(!this.getItems().length){return;}this.detachLoadItems(m);this.setFilterFunction(F||function(){return true;});this.applyShowItemsFilters();this._handlePopupOpenAndItemsLoad(false);this.setFilterFunction(i);}.bind(this);if(!this.getEnabled()||!this.getEditable()){return;}this._setItemsShownWithFilter(true);this.attachLoadItems(m);this.loadItems(m);};
k.prototype.applyShowItemsFilters=function(){};
return k;});
sap.ui.predefine('sap/m/ComboBoxBaseRenderer',['./ComboBoxTextFieldRenderer','sap/ui/core/Renderer','sap/ui/core/Core'],function(C,R,a){"use strict";var b=R.extend(C);b.apiVersion=2;b.CSS_CLASS_COMBOBOXBASE="sapMComboBoxBase";
b.getAccessibilityState=function(c){var A=C.getAccessibilityState.call(this,c),l=c._getList();if(l){A.controls=l.getId();}return A;};
b.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);var d=b.CSS_CLASS_COMBOBOXBASE;r.class(d);if(!c.getEnabled()){r.class(d+"Disabled");}if(!c.getEditable()){r.class(d+"Readonly");}};
b.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.class(b.CSS_CLASS_COMBOBOXBASE+"Arrow");};
return b;},true);
sap.ui.predefine('sap/m/ComboBoxRenderer',['./ComboBoxBaseRenderer','sap/ui/core/Renderer','sap/ui/Device'],function(C,R){"use strict";var a=R.extend(C);a.apiVersion=2;a.CSS_CLASS_COMBOBOX="sapMComboBox";
a.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX);};
a.addInnerClasses=function(r,c){C.addInnerClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX+"Inner");};
a.addButtonClasses=function(r,c){C.addButtonClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX+"Arrow");};
a.addPlaceholderClasses=function(r,c){C.addPlaceholderClasses.apply(this,arguments);r.class(a.CSS_CLASS_COMBOBOX+"Placeholder");};
a.writeInnerAttributes=function(r,c){var s=c.getSelectedItem(),S=s&&c.getListItem(s),o=c.isOpen(),f=c.getProperty("formattedTextFocused");C.writeInnerAttributes.apply(this,arguments);r.attr("aria-expanded",o);if(f){r.attr("aria-activedescendant",c._getFormattedValueStateText().getId());}else if(o&&S&&S.hasStyleClass("sapMLIBFocused")&&c.getFocusDomRef()===document.activeElement){r.attr("aria-activedescendant",S.getId());}};
return a;},true);
sap.ui.predefine('sap/m/ComboBoxTextField',['./InputBase','./library','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/Device','sap/ui/core/LabelEnablement',"./ComboBoxTextFieldRenderer"],function(I,l,a,c,D,L,C){"use strict";
var b=I.extend("sap.m.ComboBoxTextField",{metadata:{library:"sap.m",properties:{maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},showButton:{type:"boolean",group:"Appearance",defaultValue:true}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
b.prototype.init=function(){I.prototype.init.apply(this,arguments);this.addEndIcon({id:this.getId()+"-arrow",src:"sap-icon://slim-arrow-down",noTabStop:true,alt:r.getText("COMBOBOX_BUTTON"),decorative:false});};
b.prototype.getIcon=function(){return this.getAggregation("_endIcon")[0];};
b.prototype.toggleIconPressedStyle=function(s){this.toggleStyleClass(I.ICON_PRESSED_CSS_CLASS,s);};
b.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.apply(this,arguments);var R=L.getReferencingLabels(this)||[],i=this.getIcon();i.setVisible(this.getShowButton());R.forEach(function(s){if(i.getAriaLabelledBy().indexOf(s)===-1){i.addAssociation("ariaLabelledBy",s,true);}},this);if(!this.oInvisibleText&&D.browser.msie){this.oInvisibleText=new a(this.getId()+'-describedby',{text:r.getText("ACC_CTR_TYPE_COMBO")}).toStatic();}};
b.prototype.getOpenArea=function(){var d=this.getIcon().getDomRef();return d?d.parentNode:d;};
b.prototype.onsapenter=function(e){I.prototype.onsapenter.apply(this,arguments);if(!this.getEnabled()||!this.getEditable()){return;}this._bCheckDomValue&&e.setMarked();var v=this.getValue(),V=v.length;this.setValue(v);this.selectText(V,V);};
b.prototype.getValue=function(){var d=this.getFocusDomRef();if(d){return d.value;}return this.getProperty("value");};
b.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
b.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=r.getText("ACC_CTR_TYPE_COMBO");return i;};
b.prototype.exit=function(){I.prototype.exit.apply(this,arguments);if(this.oInvisibleText){this.oInvisibleText.destroy();this.oInvisibleText=null;}};
return b;});
sap.ui.predefine('sap/m/ComboBoxTextFieldRenderer',['./InputBaseRenderer','sap/ui/core/Renderer','sap/ui/core/LabelEnablement','sap/ui/Device'],function(I,R,L,D){"use strict";var C=R.extend(I);C.apiVersion=2;C.CSS_CLASS_COMBOBOXTEXTFIELD="sapMComboBoxTextField";
C.writeInnerAttributes=function(r,c){r.attr("role","combobox");r.attr("aria-haspopup","listbox");r.attr("aria-autocomplete","both");r.attr("aria-expanded","false");r.attr("autocomplete","off");r.attr("autocorrect","off");r.attr("autocapitalize","off");r.attr("type","text");};
C.getAriaRole=function(){};
C.getAriaDescribedBy=function(c){var a=I.getAriaDescribedBy.apply(this,arguments);if(D.browser.msie){return(a||"")+" "+c.oInvisibleText.getId();}return a;};
C.addOuterStyles=function(r,c){r.style("max-width",c.getMaxWidth());};
return C;},true);
sap.ui.predefine('sap/m/CustomListItem',['./ListItemBase','./library','./CustomListItemRenderer'],function(L,l,C){"use strict";
var a=L.extend("sap.m.CustomListItem",{metadata:{library:"sap.m",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designtime:"sap/m/designtime/CustomListItem.designtime"}});
a.prototype.getContentAnnouncement=function(){return this.getContent().map(function(c){return L.getAccessibilityText(c);}).join(" ").trim();};
return a;});
sap.ui.predefine('sap/m/CustomListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var C=R.extend(L);C.apiVersion=2;
C.renderLIAttributes=function(r,l){r.class("sapMCLI");};
C.renderLIContent=function(r,l){l.getContent().forEach(r.renderControl,r);};
return C;},true);
sap.ui.predefine('sap/m/CustomTile',['./Tile','./library','./CustomTileRenderer'],function(T,l,C){"use strict";
var a=T.extend("sap.m.CustomTile",{metadata:{library:"sap.m",designtime:"sap/m/designtime/CustomTile.designtime",defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:false}}}});
return a;});
sap.ui.predefine('sap/m/CustomTileRenderer',['./TileRenderer','sap/ui/core/Renderer'],function(T,R){"use strict";var C=R.extend(T);
C.render=function(r,c){var t,v;r.write("<div tabindex=\"0\"");r.writeControlData(c);r.addClass("sapMCustomTile");r.writeClasses();if(c._invisible){r.addStyle("visibility","hidden");r.writeStyles();}if(c.getParent()instanceof sap.m.TileContainer){t=c.getParent();v=t._getVisibleTiles();r.writeAccessibilityState(c,{role:"option",posinset:t._indexOfVisibleTile(c,v)+1,setsize:v.length});}r.write(">");r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCRemove\"></div>");r.write("<div class=\"sapMCustomTileContent\">");this._renderContent(r,c);r.write("</div></div>");};
C._renderContent=function(r,t){r.renderControl(t.getContent());};
return C;},true);
sap.ui.predefine('sap/m/DatePickerRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var D=R.extend(I);D.apiVersion=2;
D.writeInnerValue=function(r,d){if(d._bValid){r.attr("value",d._formatValue(d.getDateValue()));}else{r.attr("value",d.getValue());}};
D.writeInnerAttributes=function(r,d){r.attr("type","text");if(d._bMobile){r.attr("readonly","readonly");}};
D.getAriaRole=function(d){return"combobox";};
D.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATEPICKER_DATE_TYPE")+" "+b;};
D.getAccessibilityState=function(d){var a=I.getAccessibilityState.apply(this,arguments);a["autocomplete"]="none";a["haspopup"]=true;a["expanded"]=false;a["disabled"]=null;if(d._bMobile&&d.getEnabled()&&d.getEditable()){a["readonly"]=false;}return a;};
return D;},true);
sap.ui.predefine('sap/m/DateRangeSelectionRenderer',['sap/ui/core/Renderer','./DatePickerRenderer'],function(R,D){"use strict";var a=R.extend(D);a.apiVersion=2;
a.writeInnerValue=function(r,c){if(c._bValid){r.attr("value",c._formatValue(c.getDateValue(),c.getSecondDateValue()));}else{r.attr("value",c.getValue());}};
return a;},true);
sap.ui.predefine('sap/m/DateTimeField',['sap/ui/model/type/Date','sap/ui/model/odata/type/ODataType','sap/ui/model/odata/type/DateTimeBase','./InputBase','sap/ui/core/LocaleData','sap/ui/core/library','sap/ui/core/format/DateFormat','./DateTimeFieldRenderer',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos"],function(S,O,D,I,L,c,a,b,d,f,q){"use strict";var C=c.CalendarType;
var g=I.extend("sap.m.DateTimeField",{metadata:{"abstract":true,library:"sap.m",properties:{displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null},initialFocusedDateValue:{type:"object",group:"Data",defaultValue:null}}}});
g.prototype.setValue=function(v){v=this.validateProperty("value",v);var o=this.getValue();if(v===o){return this;}else{this.setLastValue(v);}this.setProperty("value",v);this._bValid=true;var e;if(v){e=this._parseValue(v);if(!e||e.getTime()<this._oMinDate.getTime()||e.getTime()>this._oMaxDate.getTime()){this._bValid=false;f.warning("Value can not be converted to a valid date",this);}}this.setProperty("dateValue",e);if(this.getDomRef()){var s;if(e){s=this._formatValue(e);}else{s=v;}if(this._$input.val()!==s){this._$input.val(s);this._curpos=this._$input.cursorPos();}}return this;};
g.prototype.setDateValue=function(o){if(!this._isValidDate(o)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getDateValue(),o)){return this;}o=this._dateValidation(o);var v=this._formatValue(o,true);if(v!==this.getValue()){this.setLastValue(v);}this.setProperty("value",v);if(this.getDomRef()){var s=this._formatValue(o);if(this._$input.val()!==s){this._$input.val(s);this._curpos=this._$input.cursorPos();}}return this;};
g.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var V=this.getValue();if(V){this._handleDateValidation(this._parseValue(V));}return this;};
g.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);this.updateDomValue(this._formatValue(this.getDateValue()));this._updateDomPlaceholder(this._getPlaceholder());return this;};
g.prototype.getDisplayFormatType=function(){return null;};
g.prototype._dateValidation=function(o){this._bValid=true;this.setProperty("dateValue",o);return o;};
g.prototype._handleDateValidation=function(o){this._bValid=true;this.setProperty("dateValue",o);};
g.prototype._getPlaceholder=function(){var p=this.getPlaceholder();if(!p){p=this._getDisplayFormatPattern();if(!p){p=this._getDefaultDisplayStyle();}if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}}return p;};
g.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getDatePattern(p);};
g.prototype._parseValue=function(v,h){var B=this.getBinding("value"),o=B&&B.getType&&B.getType(),F,i,j;if(o&&this._isSupportedBindingType(o)){try{j=o.parseValue(v,"string");if(typeof(j)==="string"&&o instanceof D){j=D.prototype.parseValue.call(o,v,"string");}F=o.oFormatOptions;if(F&&F.source&&F.source.pattern=="timestamp"){j=new Date(j);}else if(F&&F.source&&typeof F.source.pattern==="string"){j=o.oInputFormat.parse(v);}}catch(e){}if(j&&((o.oFormatOptions&&this._isFormatOptionsUTC(o.oFormatOptions))||(o.oConstraints&&o.oConstraints.isDateOnly))){i=new Date(j.getUTCFullYear(),j.getUTCMonth(),j.getUTCDate(),j.getUTCHours(),j.getUTCMinutes(),j.getUTCSeconds(),j.getUTCMilliseconds());i.setFullYear(j.getUTCFullYear());j=i;}return j;}return this._getFormatter(h).parse(v);};
g.prototype._formatValue=function(o,v){if(!o){return"";}var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),F,h;if(e&&this._isSupportedBindingType(e)){if((e.oFormatOptions&&e.oFormatOptions.UTC)||(e.oConstraints&&e.oConstraints.isDateOnly)){h=new Date(Date.UTC(o.getFullYear(),o.getMonth(),o.getDate(),o.getHours(),o.getMinutes(),o.getSeconds(),o.getMilliseconds()));h.setUTCFullYear(o.getFullYear());o=h;}F=e.oFormatOptions;if(F&&F.source&&F.source.pattern=="timestamp"){o=o.getTime();}else if(e.oOutputFormat){return e.oOutputFormat.format(o);}return e.formatValue(o,"string");}return this._getFormatter(!v).format(o);};
g.prototype._isSupportedBindingType=function(B){return B.isA(["sap.ui.model.type.Date","sap.ui.model.odata.type.DateTime","sap.ui.model.odata.type.DateTimeOffset"]);};
g.prototype._isFormatOptionsUTC=function(B){return(B.UTC||(B.source&&B.source.UTC));};
g.prototype._getDefaultDisplayStyle=function(){return"medium";};
g.prototype._getDefaultValueStyle=function(){return"short";};
g.prototype._getFormatter=function(e){var p=this._getBoundValueTypePattern(),r=false,F,B=this.getBinding("value"),s;if(B&&B.oType&&B.oType.oOutputFormat){r=!!B.oType.oOutputFormat.oFormatOptions.relative;s=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){if(e){p=(this.getDisplayFormat()||this._getDefaultDisplayStyle());s=this.getDisplayFormatType();}else{p=(this.getValueFormat()||this._getDefaultValueStyle());s=C.Gregorian;}}if(!s){s=sap.ui.getCore().getConfiguration().getCalendarType();}if(e){if(p===this._sUsedDisplayPattern&&s===this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}}else{if(p===this._sUsedValuePattern&&s===this._sUsedValueCalendarType){F=this._oValueFormat;}}if(F){return F;}return this._getFormatterInstance(F,p,r,s,e);};
g.prototype._getFormatterInstance=function(F,p,r,s,e){if(this._checkStyle(p)){F=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:s},e);}else{F=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:s},e);}if(e){this._sUsedDisplayPattern=p;this._sUsedDisplayCalendarType=s;this._oDisplayFormat=F;}else{this._sUsedValuePattern=p;this._sUsedValueCalendarType=s;this._oValueFormat=F;}return F;};
g.prototype._getFormatInstance=function(A,e){return a.getInstance(A);};
g.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
g.prototype._getDisplayFormatPattern=function(){var p=this._getBoundValueTypePattern();if(p){return p;}p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
g.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),o=B&&B.getType&&B.getType();if(o instanceof S){return o.getOutputPattern();}if(o instanceof O&&o.oFormat){return o.oFormat.oFormatOptions.pattern;}return undefined;};
g.prototype._isValidDate=function(o){return!o||Object.prototype.toString.call(o)==="[object Date]";};
g.prototype._updateDomPlaceholder=function(v){if(this.getDomRef()){this._$input.attr("placeholder",v);}};
return g;});
sap.ui.predefine('sap/m/DateTimeFieldRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var D=R.extend(I);D.apiVersion=2;return D;},true);
sap.ui.predefine('sap/m/DateTimeInput',["sap/ui/thirdparty/jquery",'sap/ui/core/Control','./library','./DatePicker','./DateTimePicker','./TimePicker','sap/ui/model/type/Date','sap/ui/model/type/Time','sap/ui/model/type/DateTime','sap/ui/model/odata/type/ODataType','sap/ui/core/library','sap/ui/Device',"./DateTimeInputRenderer"],function(q,C,l,D,a,T,b,c,d,O,e,f,g){"use strict";var h=l.DateTimeInputType;var j=e.TextDirection;var k=e.TextAlign;var V=e.ValueState;
var m=C.extend("sap.m.DateTimeInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/DateTimeInput.designtime",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:k.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:j.Inherit},type:{type:"sap.m.DateTimeInputType",group:"Data",defaultValue:h.Date},displayFormat:{type:"string",group:"Appearance",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},dateValue:{type:"object",group:"Data",defaultValue:null}},aggregations:{_picker:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"},dateValue:{type:"object"},valid:{type:"boolean"}}}}}});
!(function(P,$,i){var r=l.getLocaleData();q.extend(P,{_types:{Date:{valueFormat:r.getDatePattern("short"),displayFormat:r.getDatePattern("medium")},Time:{valueFormat:r.getTimePattern("short"),displayFormat:r.getTimePattern("short")},DateTime:{valueFormat:r.getDateTimePattern("short"),displayFormat:r.getDateTimePattern("short")}}});["Time","Date"].forEach(function(t,s){["valueFormat","displayFormat"].forEach(function(F){var u=P._types;u.DateTime[F]=u.DateTime[F].replace("{"+s+"}",u[t][F]);});});}(m.prototype,q,f));
m.prototype.init=function(){this.setType(h.Date);};
m.prototype.onBeforeRendering=function(){o.call(this);};
m.prototype.getFocusDomRef=function(){var P=_.call(this);return P.getFocusDomRef();};
m.prototype.getIdForLabel=function(){var P=_.call(this);return P.getIdForLabel();};
function n(t){var P;switch(t){case h.DateTime:P=new a(this.getId()+"-Picker");break;case h.Time:P=new T(this.getId()+"-Picker",{localeId:sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString()});break;default:P=new D(this.getId()+"-Picker");break;}P.setDisplayFormat(this.getDisplayFormat()||this._types[t].displayFormat);P.setValueFormat(this.getValueFormat()||this._types[t].valueFormat);if(this.getDateValue()){P.setDateValue(this.getDateValue());}P.setEnabled(this.getEnabled());P.setEditable(this.getEditable());P.setValueState(this.getValueState());P.setValueStateText(this.getValueStateText());P.setShowValueStateMessage(this.getShowValueStateMessage());P.setName(this.getName());P.setPlaceholder(this.getPlaceholder());P.setTextAlign(this.getTextAlign());P.setTextDirection(this.getTextDirection());P.setWidth("100%");P.attachChange(p,this);var A=this.getAriaLabelledBy();for(var i=0;i<A.length;i++){P.addAriaLabelledBy(A[i]);}return P;}
m.prototype.setType=function(t){if(t==this.getType()&&_.call(this)){return this;}this.destroyAggregation("_picker");var P=n.call(this,t);this.setAggregation("_picker",P);this.setProperty("type",t);return this;};
m.prototype.setWidth=function(w){this.setProperty("width",w);if(this.getDomRef()){w=this.getWidth();this.$().css("width",w);}return this;};
m.prototype.setValue=function(v){o.call(this);v=this.validateProperty("value",v);if(v.toLowerCase()=="now"){return this.setDateValue(new Date());}if(v===this.getValue()){return this;}this.setProperty("value",v,true);var P=_.call(this);P.setValue(v);var i=P.getDateValue();this.setProperty("dateValue",i,true);return this;};
m.prototype.setDateValue=function(i){if(!this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}o.call(this);this.setProperty("dateValue",i,true);var P=_.call(this);P.setDateValue(i);var v=P.getValue();this.setProperty("value",v,true);return this;};
m.prototype.setDisplayFormat=function(s){this.setProperty("displayFormat",s,true);var P=_.call(this);P.setDisplayFormat(s||this._types[this.getType()].displayFormat);return this;};
m.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);var P=_.call(this);P.setValueFormat(v||this._types[this.getType()].ValueFormat);return this;};
m.prototype.setEnabled=function(E){this.setProperty("enabled",E,true);var P=_.call(this);P.setEnabled(E);return this;};
m.prototype.setEditable=function(E){this.setProperty("editable",E,true);var P=_.call(this);P.setEditable(E);return this;};
m.prototype.setValueState=function(v){this.setProperty("valueState",v,true);var P=_.call(this);P.setValueState(v);return this;};
m.prototype.setValueStateText=function(v){this.setProperty("valueStateText",v,true);var P=_.call(this);P.setValueStateText(v);return this;};
m.prototype.setShowValueStateMessage=function(s){this.setProperty("showValueStateMessage",s,true);var P=_.call(this);P.setShowValueStateMessage(s);return this;};
m.prototype.setName=function(N){this.setProperty("name",N,true);var P=_.call(this);P.setName(N);return this;};
m.prototype.setPlaceholder=function(P){this.setProperty("placeholder",P,true);var i=_.call(this);i.setPlaceholder(P);return this;};
m.prototype.setTextAlign=function(t){this.setProperty("textAlign",t,true);var P=_.call(this);P.setTextAlign(t);return this;};
m.prototype.setTextDirection=function(t){this.setProperty("textDirection",t,true);var P=_.call(this);P.setTextDirection(t);return this;};
m.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var P=_.call(this);P.addAriaLabelledBy(i);return this;};
m.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var P=_.call(this);P.removeAriaLabelledBy(i);return this;};
m.prototype.removeAllAriaLabelledBy=function(){this.removeAssociation("ariaLabelledBy",true);var P=_.call(this);P.removeAllAriaLabelledBy();return this;};
m.prototype.getAccessibilityInfo=function(){var P=_.call(this);return P&&P.getAccessibilityInfo?P.getAccessibilityInfo():null;};
m.prototype._getPickerByTypeAndPattern=function(t,i,r){var R=/[DdYyMLWwGQUur]/,s=/[HhKkmsa]/,u=s.test(r),v=R.test(r),w=u&&!v,x=v&&!u,y=v&&u,N,z;switch(t){case h.Time:case h.Date:case h.DateTime:if(w&&i.getMetadata().getName()!=="sap.m.TimePicker"){N=h.Time;}else if(x&&i.getMetadata().getName()!=="sap.m.DatePicker"){N=h.Date;}else if(y&&i.getMetadata().getName()!=="sap.m.DateTimePicker"){N=h.DateTime;}break;default:{throw"Invalid type: "+t+". Expected is one of the sap.m.DateTimeInputType";}}if(N){this.destroyAggregation("_picker");z=n.call(this,N);this.setAggregation("_picker",z);}return z||i;};
m.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),i=B&&B.getType()&&B.getType();if(i instanceof b||i instanceof c||i instanceof d){return i.getOutputPattern();}if(i instanceof O&&i.oFormat){return i.oFormat.oFormatOptions.pattern;}return undefined;};
function _(){return this.getAggregation("_picker");}
m.prototype._isValidDate=function(i){return!i||Object.prototype.toString.call(i)==="[object Date]";};
function o(){if(this._getBoundValueTypePattern()){var P=this._getBoundValueTypePattern();var i=_.call(this);i=this._getPickerByTypeAndPattern(this.getType(),i,P);if(i.getValueFormat()!=P){i.setValueFormat(P);}if(i.getDisplayFormat()!=P){i.setDisplayFormat(P);}}}
function p(E){var v=E.getParameter("value");var i;var r=E.getParameter("valid");this.setProperty("value",v,true);if(r){i=E.oSource.getDateValue();this.setProperty("dateValue",i,true);}this.fireChange({value:v,newValue:v,valid:r,dateValue:i,newDateValue:i});}
return m;});
sap.ui.predefine('sap/m/DateTimeInputRenderer',[],function(){"use strict";var D={};
D.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMDTI");var w=c.getWidth();if(w){r.addStyle("width",w);}r.writeStyles();r.writeClasses();r.write(">");var p=c.getAggregation("_picker");if(p){r.renderControl(p);}r.write("</div>");};
return D;},true);
sap.ui.predefine('sap/m/DateTimePickerRenderer',['sap/ui/core/Renderer','./DatePickerRenderer','./InputBaseRenderer'],function(R,D,I){"use strict";var a=R.extend(D);a.apiVersion=2;
a.getDescribedByAnnouncement=function(d){var b=I.getDescribedByAnnouncement.apply(this,arguments);return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("DATETIMEPICKER_TYPE")+" "+b;};
return a;},true);
sap.ui.predefine('sap/m/Dialog',["./Bar","./InstanceManager","./AssociativeOverflowToolbar","./ToolbarSpacer","./Title","./library","./TitleAlignmentMixin","sap/m/Image","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/Popup","sap/ui/core/delegate/ScrollEnablement","sap/ui/core/RenderManager","sap/ui/core/InvisibleText","sap/ui/core/ResizeHandler","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/Device","sap/ui/base/ManagedObject","sap/ui/core/library","sap/ui/events/KeyCodes","./TitlePropagationSupport","./DialogRenderer","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/core/Core","sap/ui/core/Configuration","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Focusable"],function(B,I,A,T,a,l,b,c,C,d,P,S,R,f,g,h,D,M,j,K,k,m,L,q,n,o){"use strict";var O=j.OpenState;var p=l.DialogType;var r=l.DialogRoleType;var V=j.ValueState;var s=l.TitleAlignment;var t=n.getConfiguration().getAnimationMode();var u=t!==o.AnimationMode.none&&t!==o.AnimationMode.minimal;var v=u?300:10;var w=17;
var x=C.extend("sap.m.Dialog",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},title:{type:"string",group:"Appearance",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},type:{type:"sap.m.DialogType",group:"Appearance",defaultValue:p.Standard},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:V.None},stretchOnPhone:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},stretch:{type:"boolean",group:"Appearance",defaultValue:false},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},verticalScrolling:{type:"boolean",group:"Behavior",defaultValue:true},resizable:{type:"boolean",group:"Behavior",defaultValue:false},draggable:{type:"boolean",group:"Behavior",defaultValue:false},escapeHandler:{type:"any",group:"Behavior",defaultValue:null},role:{type:"sap.m.DialogRoleType",group:"Data",defaultValue:r.Dialog,visibility:"hidden"},closeOnNavigation:{type:"boolean",group:"Behavior",defaultValue:true},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:s.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},subHeader:{type:"sap.m.IBar",multiple:false},customHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},_header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_icon:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_toolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_valueState:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{beforeOpen:{},afterOpen:{},beforeClose:{parameters:{origin:{type:"sap.m.Button"}}},afterClose:{parameters:{origin:{type:"sap.m.Button"}}}},designtime:"sap/m/designtime/Dialog.designtime"}});
h.call(x.prototype,{header:{suffix:"header"},subHeader:{selector:".sapMDialogSubHeader .sapMIBar"},content:{selector:".sapMDialogScrollCont"},footer:{suffix:"footer"}});k.call(x.prototype,"content",function(){return this._headerTitle?this._headerTitle.getId():false;});x._bPaddingByDefault=(n.getConfiguration().getCompatibilityVersion("sapMDialogWithPadding").compareTo("1.16")<0);x._mIcons={};x._mIcons[V.Success]=d.getIconURI("message-success");x._mIcons[V.Warning]=d.getIconURI("message-warning");x._mIcons[V.Error]=d.getIconURI("message-error");x._mIcons[V.Information]=d.getIconURI("hint");
x.prototype.init=function(){var e=this;this._oManuallySetSize=null;this._oManuallySetPosition=null;this._bRTL=n.getConfiguration().getRTL();this._scrollContentList=["sap.m.NavContainer","sap.m.Page","sap.m.ScrollContainer","sap.m.SplitContainer","sap.m.MultiInput","sap.m.SimpleFixFlex"];this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setNavigationMode("SCOPE");this.oPopup.setModal(true);this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this.oPopup._applyPosition=function(i,F){e._setDimensions();e._adjustScrollingPane();if(e._oManuallySetPosition){i.at={left:e._oManuallySetPosition.x,top:e._oManuallySetPosition.y};}else{i.at=e._calcCenter();}e._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,i);e._registerContentResizeHandler();};if(x._bPaddingByDefault){this.addStyleClass("sapUiPopupWithPadding");}this._initTitlePropagationSupport();this._initResponsivePaddingsEnablement();this._sAriaRoleDescription=n.getLibraryResourceBundle("sap.m").getText("DIALOG_ROLE_DESCRIPTION");};
x.prototype.onBeforeRendering=function(){if(this._hasSingleScrollableContent()){this.setVerticalScrolling(false);this.setHorizontalScrolling(false);L.info("VerticalScrolling and horizontalScrolling in sap.m.Dialog with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:this.getHorizontalScrolling(),vertical:this.getVerticalScrolling()});}if(this._oScroller){this._oScroller.setVertical(this.getVerticalScrolling());this._oScroller.setHorizontal(this.getHorizontalScrolling());}this._createToolbarButtons();if(n.getConfiguration().getAccessibility()&&this.getState()!=V.None){var e=new f({text:this.getValueStateString(this.getState())});this.setAggregation("_valueState",e);this.addAriaLabelledBy(e.getId());}};
x.prototype.onAfterRendering=function(){this._$scrollPane=this.$("scroll");this._$content=this.$("cont");this._$dialog=this.$();if(this.isOpen()){this._setInitialFocus();}};
x.prototype.exit=function(){I.removeDialogInstance(this);this._deregisterContentResizeHandler();this._deregisterResizeHandler();if(this.oPopup){this.oPopup.detachOpened(this._handleOpened,this);this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._header){this._header.destroy();this._header=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}if(this._toolbarSpacer){this._toolbarSpacer.destroy();this._toolbarSpacer=null;}};
x.prototype.open=function(){var e=this.oPopup;e.setInitialFocusId(this.getId());var i=e.getOpenState();switch(i){case O.OPEN:case O.OPENING:return this;case O.CLOSING:this._bOpenAfterClose=true;break;default:}this._oCloseTrigger=null;this.fireBeforeOpen();e.attachOpened(this._handleOpened,this);this._iLastWidthAndHeightWithScroll=null;e.setContent(this);e.open();this._registerResizeHandler();I.addDialogInstance(this);return this;};
x.prototype.close=function(){this._bOpenAfterClose=false;this.$().removeClass('sapDialogDisableTransition');this._deregisterResizeHandler();var e=this.oPopup;var i=this.oPopup.getOpenState();if(!(i===O.CLOSED||i===O.CLOSING)){l.closeKeyboard();this.fireBeforeClose({origin:this._oCloseTrigger});e.attachClosed(this._handleClosed,this);this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;e.close();this._deregisterContentResizeHandler();}return this;};
x.prototype.isOpen=function(){return!!this.oPopup&&this.oPopup.isOpen();};
x.prototype.setIcon=function(i){this._bHasCustomIcon=true;return this.setProperty("icon",i);};
x.prototype.setState=function(e){var i;this.setProperty("state",e);if(this._bHasCustomIcon){return this;}if(e===V.None){i="";}else{i=x._mIcons[e];}this.setProperty("icon",i);return this;};
x.prototype._handleOpened=function(){this.oPopup.detachOpened(this._handleOpened,this);this._setInitialFocus();this.fireAfterOpen();};
x.prototype._handleClosed=function(){if(!this.oPopup){return;}this.oPopup.detachClosed(this._handleClosed,this);if(this.getDomRef()){R.preserveContent(this.getDomRef());this.$().remove();}I.removeDialogInstance(this);this.fireAfterClose({origin:this._oCloseTrigger});if(this._bOpenAfterClose){this._bOpenAfterClose=false;this.open();}};
x.prototype.onfocusin=function(e){var i=e.target;if(i.id===this.getId()+"-firstfe"){var z=this.$("footer").lastFocusableDomRef()||this.$("cont").lastFocusableDomRef()||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||(this._getAnyHeader()&&this._getAnyHeader().$().lastFocusableDomRef());if(z){z.focus();}}else if(i.id===this.getId()+"-lastfe"){var F=(this._getAnyHeader()&&this._getAnyHeader().$().firstFocusableDomRef())||(this.getSubHeader()&&this.getSubHeader().$().firstFocusableDomRef())||this.$("cont").firstFocusableDomRef()||this.$("footer").firstFocusableDomRef();if(F){F.focus();}}};
x.prototype._getPromiseWrapper=function(){var e=this;return{reject:function(){e.currentPromise.reject();},resolve:function(){e.currentPromise.resolve();}};};
x.prototype.onsapescape=function(e){var E=this.getEscapeHandler(),i={},z=this;if(this._isSpaceOrEnterPressed){return;}if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this._oCloseTrigger=null;if(typeof E==='function'){new window.Promise(function(F,G){i.resolve=F;i.reject=G;z.currentPromise=i;E(z._getPromiseWrapper());}).then(function(F){z.close();}).catch(function(){L.info("Disallow dialog closing");});}else{this.close();}e.stopPropagation();};
x.prototype.onkeyup=function(e){if(this._isSpaceOrEnter(e)){this._isSpaceOrEnterPressed=false;}};
x.prototype.onkeydown=function(e){if(this._isSpaceOrEnter(e)){this._isSpaceOrEnterPressed=true;}};
x.prototype._isSpaceOrEnter=function(e){var i=e.which||e.keyCode;return i==K.SPACE||i==K.ENTER;};
x.prototype._openAnimation=function($,i,e){$.addClass("sapMDialogOpen");$.css("display","block");setTimeout(e,v);};
x.prototype._closeAnimation=function($,i,e){$.removeClass("sapMDialogOpen");setTimeout(e,v);};
x.prototype._setDimensions=function(){var $=this.$(),e=this.getStretch(),i=this.getStretchOnPhone()&&D.system.phone,z=this.getType()===p.Message,E={};if(!e){if(!this._oManuallySetSize){E.width=this.getContentWidth()||undefined;E.height=this.getContentHeight()||undefined;}else{E.width=this._oManuallySetSize.width;E.height=this._oManuallySetSize.height;}}if(E.width=='auto'){E.width=undefined;}if(E.height=='auto'){E.height=undefined;}if((e&&!z)||(i)){this.$().addClass('sapMDialogStretched');}$.css(E);if(!e&&!this._oManuallySetSize&&!this._bDisableRepositioning){this._centerDialog();}if(window.navigator.userAgent.toLowerCase().indexOf("chrome")!==-1&&this.getStretch()){$.find('> footer').css({bottom:'0.001px'});}};
x.prototype._adjustScrollingPane=function(){if(this._oScroller){this._oScroller.refresh();}};
x.prototype._reposition=function(){};
x.prototype._repositionAfterOpen=function(){};
x.prototype._reapplyPosition=function(){this._adjustScrollingPane();};
x.prototype._onResize=function(){var $=this.$(),e=this.$('cont'),i,z=this.getContentHeight(),E=this.getContentWidth(),F,G=Math.floor(window.innerWidth*0.9),H=2,J=D.browser,N=0;if(this._oManuallySetSize){e.css({width:'auto'});return;}if(!z||z=='auto'){i=e.scrollTop();e.css({height:'auto'});$.children().each(function(){N+=q(this).outerHeight(true);});if(this.getStretch()||N>$.innerHeight()){F=parseFloat($.height())+H;e.height(Math.round(F));}e.scrollTop(i);}if(D.system.desktop&&!J.chrome){var Q=e.width()+"x"+e.height(),U=$.css("min-width")!==$.css("width");if(Q!==this._iLastWidthAndHeightWithScroll&&U){if(this._hasVerticalScrollbar()&&(!E||E=='auto')&&!this.getStretch()&&e.width()<G){$.addClass("sapMDialogVerticalScrollIncluded");e.css({"padding-right":w});this._iLastWidthAndHeightWithScroll=Q;}else{$.removeClass("sapMDialogVerticalScrollIncluded");e.css({"padding-right":""});this._iLastWidthAndHeightWithScroll=null;}}}if(!this.getStretch()&&!this._oManuallySetSize&&!this._bDisableRepositioning){this._centerDialog();}};
x.prototype._hasVerticalScrollbar=function(){var $=this.$('cont');if(D.browser.msie){return $[0].clientWidth<$.outerWidth();}return $[0].clientHeight<$[0].scrollHeight;};
x.prototype._centerDialog=function(){this.$().css(this._calcCenter());};
x.prototype._calcCenter=function(){var e=window.innerWidth,i=window.innerHeight,$=this.$(),z=$.outerWidth(),E=$.outerHeight();return{left:Math.round((e-z)/2),top:Math.round((i-E)/2)};};
x.prototype._createHeader=function(){if(!this._header){this._header=new B(this.getId()+"-header");this._header._setRootAccessibilityRole("heading");this._header._setRootAriaLevel("2");this._setupBarTitleAlignment(this._header,this.getId()+"_header");this.setAggregation("_header",this._header);}};
x.prototype._applyTitleToHeader=function(){var e=this.getProperty("title");if(this._headerTitle){this._headerTitle.setText(e);}else{this._headerTitle=new a(this.getId()+"-title",{text:e,level:"H2"}).addStyleClass("sapMDialogTitle");this._header.addContentMiddle(this._headerTitle);}};
x.prototype._hasSingleScrollableContent=function(){var e=this.getContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA(this._scrollContentList)){return true;}return false;};
x.prototype._getFocusDomRef=function(){var i=this.getInitialFocus();if(i){return document.getElementById(i);}return this._getFirstFocusableContentSubHeader()||this._getFirstFocusableContentElement()||this._getFirstVisibleButtonDomRef()||this.getDomRef();};
x.prototype._getFirstVisibleButtonDomRef=function(){var e=this.getBeginButton(),E=this.getEndButton(),z=this.getButtons(),F;if(e&&e.getVisible()){F=e.getDomRef();}else if(E&&E.getVisible()){F=E.getDomRef();}else if(z&&z.length>0){for(var i=0;i<z.length;i++){if(z[i].getVisible()){F=z[i].getDomRef();break;}}}return F;};
x.prototype._getFirstFocusableContentSubHeader=function(){var $=this.$().find('.sapMDialogSubHeader');return $.firstFocusableDomRef();};
x.prototype._getFirstFocusableContentElement=function(){var $=this.$("cont");return $.firstFocusableDomRef();};
x.prototype._setInitialFocus=function(){var F=this._getFocusDomRef(),e;if(F&&F.id){e=n.byId(F.id);}if(e){if(e.getVisible&&!e.getVisible()){this.focus();return;}F=e.getFocusDomRef();}if(!F){this.setInitialFocus("");F=this._getFocusDomRef();}if(!this.getInitialFocus()){this.setAssociation('initialFocus',F?F.id:this.getId(),true);}if(D.system.desktop||(F&&!/input|textarea|select/i.test(F.tagName))){if(F){F.focus();}}else{this.focus();}};
x.prototype.getScrollDelegate=function(){return this._oScroller;};
x.prototype._composeAggreNameInHeader=function(e){var H;if(e==="Begin"){H="contentLeft";}else if(e==="End"){H="contentRight";}else{H="content"+e;}return H;};
x.prototype._isToolbarEmpty=function(){var e=this._oToolbar.getContent().filter(function(i){return i.getMetadata().getName()!=='sap.m.ToolbarSpacer';});return e.length===0;};
x.prototype._setButton=function(e,i,z){return this;};
x.prototype._getButton=function(e){var i=e.toLowerCase()+"Button",z="_o"+this._firstLetterUpperCase(e)+"Button";if(D.system.phone){return this.getAggregation(i,null,true);}else{return this[z];}};
x.prototype._getButtonFromHeader=function(e){if(this._header){var H=this._composeAggreNameInHeader(this._firstLetterUpperCase(e)),i=this._header.getAggregation(H);return i&&i[0];}else{return null;}};
x.prototype._firstLetterUpperCase=function(e){return e.charAt(0).toUpperCase()+e.slice(1);};
x.prototype._getAnyHeader=function(){var e=this.getCustomHeader();if(e){e._setRootAriaLevel("2");return e._setRootAccessibilityRole("heading");}else{var i=this.getShowHeader();if(!i){return null;}this._createHeader();this._applyTitleToHeader();this._applyIconToHeader();return this._header;}};
x.prototype._deregisterResizeHandler=function(){if(this._resizeListenerId){g.deregister(this._resizeListenerId);this._resizeListenerId=null;}D.resize.detachHandler(this._onResize,this);};
x.prototype._registerResizeHandler=function(){var _=this.$("scroll");this._resizeListenerId=g.register(_.get(0),q.proxy(this._onResize,this));D.resize.attachHandler(this._onResize,this);this._onResize();};
x.prototype._deregisterContentResizeHandler=function(){if(this._sContentResizeListenerId){g.deregister(this._sContentResizeListenerId);this._sContentResizeListenerId=null;}};
x.prototype._registerContentResizeHandler=function(){if(!this._sContentResizeListenerId){this._sContentResizeListenerId=g.register(this.getDomRef("scrollCont"),q.proxy(this._onResize,this));}this._onResize();};
x.prototype._attachHandler=function(e){var i=this;if(!this._oButtonDelegate){this._oButtonDelegate={ontap:function(){i._oCloseTrigger=this;},onkeyup:function(){i._oCloseTrigger=this;},onkeydown:function(){i._oCloseTrigger=this;}};}if(e){e.addDelegate(this._oButtonDelegate,true,e);}};
x.prototype._createToolbarButtons=function(){var e=this._getToolbar();var i=this.getButtons();var z=this.getBeginButton();var E=this.getEndButton(),F=this,G=[z,E];G.forEach(function(H){if(H&&F._oButtonDelegate){H.removeDelegate(F._oButtonDelegate);}});e.removeAllContent();if(!("_toolbarSpacer"in this)){this._toolbarSpacer=new T();}e.addContent(this._toolbarSpacer);G.forEach(function(H){F._attachHandler(H);});if(i&&i.length){i.forEach(function(H){e.addContent(H);});}else{if(z){e.addContent(z);}if(E){e.addContent(E);}}};
x.prototype._getToolbar=function(){if(!this._oToolbar){this._oToolbar=new A(this.getId()+"-footer").addStyleClass("sapMTBNoBorders");this._oToolbar.addDelegate({onAfterRendering:function(){if(this.getType()===p.Message){this.$("footer").removeClass("sapContrast sapContrastPlus");}}},false,this);this.setAggregation("_toolbar",this._oToolbar);}return this._oToolbar;};
x.prototype.getValueStateString=function(e){var i=n.getLibraryResourceBundle("sap.m");switch(e){case(V.Success):return i.getText("LIST_ITEM_STATE_SUCCESS");case(V.Warning):return i.getText("LIST_ITEM_STATE_WARNING");case(V.Error):return i.getText("LIST_ITEM_STATE_ERROR");case(V.Information):return i.getText("LIST_ITEM_STATE_INFORMATION");default:return"";}};
x.prototype.setSubHeader=function(e){this.setAggregation("subHeader",e);if(e){e.setVisible=function(i){e.setProperty("visible",i);this.invalidate();}.bind(this);}return this;};
x.prototype.setLeftButton=function(e){if(typeof e==="string"){e=n.byId(e);}this.setBeginButton(e);return this.setAssociation("leftButton",e);};
x.prototype.setRightButton=function(e){if(typeof e==="string"){e=n.byId(e);}this.setEndButton(e);return this.setAssociation("rightButton",e);};
x.prototype.getLeftButton=function(){var e=this.getBeginButton();return e?e.getId():null;};
x.prototype.getRightButton=function(){var e=this.getEndButton();return e?e.getId():null;};
x.prototype.setBeginButton=function(e){if(e&&e.isA("sap.m.Button")){e.addStyleClass("sapMDialogBeginButton");}return this.setAggregation("beginButton",e);};
x.prototype.setEndButton=function(e){if(e&&e.isA("sap.m.Button")){e.addStyleClass("sapMDialogEndButton");}return this.setAggregation("endButton",e);};
x.prototype.getAggregation=function(e,i,z){var E=C.prototype.getAggregation.apply(this,Array.prototype.slice.call(arguments,0,2));if(e==='buttons'&&E&&E.length===0){this.getBeginButton()&&E.push(this.getBeginButton());this.getEndButton()&&E.push(this.getEndButton());}return E;};
x.prototype.getAriaLabelledBy=function(){var H=this._getAnyHeader(),e=this.getAssociation("ariaLabelledBy",[]).slice();var i=this.getSubHeader();if(i){e.unshift(i.getId());}if(H){var z=H.findAggregatedObjects(true,function(E){return E.isA("sap.m.Title");});if(z.length){e=z.map(function(E){return E.getId();}).concat(e);}else{e.unshift(H.getId());}}return e;};
x.prototype._applyIconToHeader=function(){var i=this.getIcon();if(!i){if(this._iconImage){this._iconImage.destroy();this._iconImage=null;}return;}if(!this._iconImage){this._iconImage=d.createControlByURI({id:this.getId()+"-icon",src:i,useIconTooltip:false},c).addStyleClass("sapMDialogIcon");this._header.insertAggregation("contentMiddle",this._iconImage,0);}this._iconImage.setSrc(i);};
x.prototype.setInitialFocus=function(i){return this.setAssociation("initialFocus",i,true);};
x.prototype.forceInvalidate=C.prototype.invalidate;
x.prototype.invalidate=function(e){if(this.isOpen()){this.forceInvalidate(e);}};
function y(e){var $=q(e);var i=$.control(0);if($.parents('.sapMDialogSection').length){return false;}if(!i||i.getMetadata().getInterfaces().indexOf("sap.m.IBar")>-1){return true;}return $.hasClass('sapMDialogTitle');}
if(D.system.desktop){x.prototype.ondblclick=function(e){if(y(e.target)){var $=this.$('cont');this._bDisableRepositioning=false;this._oManuallySetPosition=null;this._oManuallySetSize=null;this.oPopup&&this.oPopup._applyPosition(this.oPopup._oLastPosition,true);$.css({height:'100%'});}};x.prototype.onmousedown=function(e){if(e.which===3){return;}if(this.getStretch()||(!this.getDraggable()&&!this.getResizable())){return;}var i;var z=this;var $=q(document);var E=q(e.target);var F=E.hasClass('sapMDialogResizeHandler')&&this.getResizable();var G=function(a1){i=i?clearTimeout(i):setTimeout(function(){a1();},0);};var H=window.innerWidth;var J=window.innerHeight;var N={x:e.pageX,y:e.pageY,width:z._$dialog.width(),height:z._$dialog.height(),outerHeight:z._$dialog.outerHeight(),offset:{x:e.offsetX?e.offsetX:e.originalEvent.layerX,y:e.offsetY?e.offsetY:e.originalEvent.layerY},position:{x:z._$dialog.offset().left,y:z._$dialog.offset().top}};var Q;function U(){var a1=z.$(),b1=z.$('cont'),c1,d1;$.off("mouseup",U);$.off("mousemove",Q);if(F){z._$dialog.removeClass('sapMDialogResizing');c1=parseInt(a1.height());d1=parseInt(a1.css("border-top-width"))+parseInt(a1.css("border-bottom-width"));b1.height(c1+d1);}}if((y(e.target)&&this.getDraggable())||F){z._bDisableRepositioning=true;z._$dialog.addClass('sapDialogDisableTransition');z._oManuallySetPosition={x:N.position.x,y:N.position.y};z._$dialog.css({left:Math.min(Math.max(0,z._oManuallySetPosition.x),H-N.width),top:Math.min(Math.max(0,z._oManuallySetPosition.y),J-N.height),width:N.width});}if(y(e.target)&&this.getDraggable()){Q=function(a1){if(a1.buttons===0){U();return;}G(function(){z._bDisableRepositioning=true;z._oManuallySetPosition={x:a1.pageX-e.pageX+N.position.x,y:a1.pageY-e.pageY+N.position.y};z._$dialog.css({left:Math.min(Math.max(0,z._oManuallySetPosition.x),H-N.width),top:Math.min(Math.max(0,z._oManuallySetPosition.y),J-N.outerHeight)});});};$.on("mousemove",Q);}else if(F){z._$dialog.addClass('sapMDialogResizing');var W={};var X=parseInt(z._$dialog.css('min-width'));var Y=N.x+N.width-X;var Z=E.width()-e.offsetX;var _=E.height()-e.offsetY;Q=function(a1){G(function(){z._bDisableRepositioning=true;z.$('cont').height('').width('');if(a1.pageY+_>J){a1.pageY=J-_;}if(a1.pageX+Z>H){a1.pageX=H-Z;}z._oManuallySetSize={width:N.width+a1.pageX-N.x,height:N.height+a1.pageY-N.y};if(z._bRTL){W.left=Math.min(Math.max(a1.pageX,0),Y);z._oManuallySetSize.width=N.width+N.x-Math.max(a1.pageX,0);}W.width=z._oManuallySetSize.width;W.height=z._oManuallySetSize.height;z._$dialog.css(W);});};$.on("mousemove",Q);}else{return;}$.on("mouseup",U);e.preventDefault();e.stopPropagation();};}
x.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
b.mixInto(x.prototype);return x;});
sap.ui.predefine('sap/m/DialogRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/library"],function(l,D,c){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var V=c.ValueState;var d={apiVersion:2};d._mStateClasses={};d._mStateClasses[V.None]="";d._mStateClasses[V.Success]="sapMDialogSuccess";d._mStateClasses[V.Warning]="sapMDialogWarning";d._mStateClasses[V.Error]="sapMDialogError";d._mStateClasses[V.Information]="sapMDialogInformation";
d.render=function(r,o){var i=o.getId(),h=o._getAnyHeader(),s=o.getSubHeader(),B=o.getBeginButton(),e=o.getEndButton(),S=o.getState(),f=o.getStretch(),g=o.getStretchOnPhone()&&D.system.phone,v=o.getAggregation("_valueState");r.openStart("div",o).style("width",o.getContentWidth()).style("height",o.getContentHeight()).class("sapMDialog").class("sapMDialog-CTX").class("sapMPopup-CTX");if(o.isOpen()){r.class("sapMDialogOpen");}if(window.devicePixelRatio>1){r.class("sapMDialogHighPixelDensity");}if(o._bDisableRepositioning){r.class("sapMDialogTouched");}if(f||g){r.class("sapMDialogStretched");}r.class(d._mStateClasses[S]);var n=!o._oToolbar&&!B&&!e;var E=o._oToolbar&&o._isToolbarEmpty()&&!B&&!e;if(n||E){r.class("sapMDialog-NoFooter");}if(!h){r.class("sapMDialog-NoHeader");}var R=o.getProperty("role");var j=o._sAriaRoleDescription;if(S===V.Error||S===V.Warning){R=b.AlertDialog;}r.accessibilityState(o,{role:R,roledescription:j,modal:true});if(o._forceDisableScrolling){r.class("sapMDialogWithScrollCont");}if(s&&s.getVisible()){r.class("sapMDialogWithSubHeader");if(s.getDesign()==l.ToolbarDesign.Info){r.class("sapMDialogSubHeaderInfoBar");}}if(o.getType()===a.Message){r.class("sapMMessageDialog");}if(!o.getVerticalScrolling()){r.class("sapMDialogVerScrollDisabled");}if(!o.getHorizontalScrolling()){r.class("sapMDialogHorScrollDisabled");}if(D.system.phone){r.class("sapMDialogPhone");}if(o.getDraggable()&&!f){r.class("sapMDialogDraggable");}if(l._bSizeCompact){r.class("sapUiSizeCompact");}var t=o.getTooltip_AsString();if(t){r.attr("title",t);}r.attr("tabindex","-1");r.openEnd();if(D.system.desktop){if(o.getResizable()&&!f){r.icon("sap-icon://resize-corner",["sapMDialogResizeHandler"],{"title":""});}r.openStart("span",i+"-firstfe").class("sapMDialogFirstFE").attr("tabindex","0").openEnd().close("span");}if(h){h._applyContextClassFor("header");r.openStart("header").class("sapMDialogTitle").openEnd().renderControl(h).close("header");}if(s){s._applyContextClassFor("subheader");r.openStart("header").class("sapMDialogSubHeader").openEnd().renderControl(s).close("header");}if(v){r.renderControl(v);}r.openStart("section",i+"-cont").class("sapMDialogSection").openEnd();r.openStart("div",i+"-scroll").class("sapMDialogScroll").openEnd();r.openStart("div",i+"-scrollCont").class("sapMDialogScrollCont");if(o.getStretch()||o.getContentHeight()){r.class("sapMDialogStretchContent");}r.openEnd();o.getContent().forEach(r.renderControl,r);r.close("div").close("div").close("section");if(!(n||E)){o._oToolbar._applyContextClassFor("footer");r.openStart("footer").class("sapMDialogFooter").openEnd().renderControl(o._oToolbar).close("footer");}if(D.system.desktop){r.openStart("span",i+"-lastfe").class("sapMDialogLastFE").attr("tabindex","0").openEnd().close("span");}r.close("div");};
return d;},true);
sap.ui.predefine('sap/m/DisplayListItem',["sap/ui/core/library","./library","./ListItemBase","./DisplayListItemRenderer"],function(c,l,L,D){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.DisplayListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null},valueTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}}}});
a.prototype.getContentAnnouncement=function(){return this.getLabel()+" "+this.getValue();};
return a;});
sap.ui.predefine('sap/m/DisplayListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var D=R.extend(L);D.apiVersion=2;
D.renderLIAttributes=function(r,l){r.class("sapMDLI");};
D.renderLIContent=function(r,l){var s=l.getLabel();if(s){r.openStart("label");r.attr("for",l.getId()+"-value");r.class("sapMDLILabel");r.openEnd();r.text(s);r.close("label");}var v=l.getValue();if(v){r.openStart("div",l.getId()+"-value");r.class("sapMDLIValue");var V=l.getValueTextDirection();if(V!=T.Inherit){r.attr("dir",V.toLowerCase());}r.openEnd();r.text(v);r.close("div");}};
return D;},true);
sap.ui.predefine('sap/m/DraftIndicator',["sap/ui/core/Control","sap/m/Label","sap/m/library","./DraftIndicatorRenderer"],function(C,L,l,D){"use strict";var a=l.DraftIndicatorState;
var b=C.extend("sap.m.DraftIndicator",{metadata:{library:"sap.m",designtime:"sap/m/designtime/DraftIndicator.designtime",properties:{state:{type:"sap.m.DraftIndicatorState",group:"Behavior",defaultValue:a.Clear},minDisplayTime:{type:"int",group:"Behavior",defaultValue:1500}},aggregations:{_label:{type:"sap.m.Label",multiple:false,visibility:"hidden"}}}});
var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");b._oTEXTS={};b._oTEXTS[a.Saving]=B.getText("DRAFT_INDICATOR_SAVING_DRAFT");b._oTEXTS[a.Saved]=B.getText("DRAFT_INDICATOR_DRAFT_SAVED");b._oTEXTS[a.Clear]="";
b.prototype.init=function(){this.aQueue=[];this.iDelayedCallId=null;};
b.prototype.exit=function(){this._resetDraftTimer();};
b.prototype.setState=function(s){this.setProperty("state",s);this._addToQueue(s);if(s===a.Saving){this._addToQueue(a.Clear);}return this;};
b.prototype._getLabel=function(){var c=this.getAggregation('_label');if(!c){var c=new L({id:this.getId()+"-label"});this.setAggregation('_label',c,true);c=this.getAggregation('_label');}return c;};
b.prototype.showDraftSaving=function(){this._addToQueue(a.Saving);this._addToQueue(a.Clear);};
b.prototype.showDraftSaved=function(){this._addToQueue(a.Saved);};
b.prototype.clearDraftState=function(){this._addToQueue(a.Clear);};
b.prototype._addToQueue=function(s){this.aQueue.push(s);this._processQueue();};
b.prototype._processQueue=function(){if(this.iDelayedCallId){return;}var n=this.aQueue.shift();var t=this.getMinDisplayTime();if(!n){return;}this._applyState(n);if(n===a.Clear){this._proceed();return;}this.iDelayedCallId=setTimeout(this._proceed.bind(this),t);};
b.prototype._proceed=function(){this._resetDraftTimer();this._processQueue();};
b.prototype._applyState=function(s){this._getLabel().setText(b._oTEXTS[s]);};
b.prototype._resetDraftTimer=function(){clearTimeout(this.iDelayedCallId);this.iDelayedCallId=null;};
return b;});
sap.ui.predefine('sap/m/DraftIndicatorRenderer',[],function(){"use strict";var D={apiVersion:2};
D.render=function(r,c){r.openStart("div",c);r.class("sapMDraftIndicator");r.openEnd();var l=c._getLabel();r.renderControl(l);r.close("div");};
return D;},true);
sap.ui.predefine('sap/m/FacetFilter',['./NavContainer','./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/core/InvisibleText','sap/ui/core/IntervalTrigger','sap/ui/Device','sap/ui/base/ManagedObject','sap/ui/core/Icon','sap/ui/model/Filter','./FacetFilterRenderer',"sap/ui/events/KeyCodes","sap/base/assert","sap/base/Log","sap/ui/events/jquery/EventSimulation","sap/ui/thirdparty/jquery","sap/m/Button","sap/m/ToolbarSpacer","sap/m/OverflowToolbar","sap/m/Text","sap/m/Toolbar","sap/m/Popover","sap/m/SearchField","sap/m/Bar","sap/m/Dialog","sap/m/List","sap/m/StandardListItem","sap/m/CheckBox","sap/m/Page","sap/ui/dom/jquery/scrollRightRTL","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/Selectors"],function(N,l,C,I,a,b,c,D,M,d,F,e,K,f,L,E,q,B,T,O,g,h,P,S,m,n,o,p,r,s){"use strict";var t=l.ToolbarDesign;var u=l.ListType;var v=l.ListMode;var w=l.FacetFilterListDataType;var x=l.ButtonType;var y=l.PlacementType;var z=l.FacetFilterType;
var A=C.extend("sap.m.FacetFilter",{metadata:{interfaces:["sap.ui.core.IShrinkable"],library:"sap.m",properties:{showPersonalization:{type:"boolean",group:"Appearance",defaultValue:false},type:{type:"sap.m.FacetFilterType",group:"Appearance",defaultValue:z.Simple},liveSearch:{type:"boolean",group:"Behavior",defaultValue:true},showSummaryBar:{type:"boolean",group:"Behavior",defaultValue:false},showReset:{type:"boolean",group:"Behavior",defaultValue:true},showPopoverOKButton:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"lists",aggregations:{lists:{type:"sap.m.FacetFilterList",multiple:true,singularName:"list"},buttons:{type:"sap.m.Button",multiple:true,singularName:"button",visibility:"hidden"},removeFacetIcons:{type:"sap.ui.core.Icon",multiple:true,singularName:"removeFacetIcon",visibility:"hidden"},popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"},addFacetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},summaryBar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},resetButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},arrowLeft:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},arrowRight:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{reset:{},confirm:{}}}});
A.SCROLL_STEP=264;
A.prototype.setType=function(i){var j,k;if(D.system.phone){this.setProperty("type",z.Light);k=true;}else{this.setProperty("type",i);k=(i===z.Light);}j=this._getSummaryBar();j.setActive(k);if(i===z.Light){if(this.getShowReset()){this._addResetToSummary(j);}else{this._removeResetFromSummary(j);}}return this;};
A.prototype.setShowReset=function(V){this.setProperty("showReset",V);var i=this._getSummaryBar();if(V){if(this.getShowSummaryBar()||this.getType()===z.Light){this._addResetToSummary(i);}}else{if(this.getShowSummaryBar()||this.getType()===z.Light){this._removeResetFromSummary(i);}}return this;};
A.prototype.setShowSummaryBar=function(V){this.setProperty("showSummaryBar",V);if(V){var i=this._getSummaryBar();if(this.getShowReset()){this._addResetToSummary(i);}else{this._removeResetFromSummary(i);}i.setActive(this.getType()===z.Light);}return this;};
A.prototype.setLiveSearch=function(V){this.setProperty("liveSearch",V);if(this._displayedList){var i=this._displayedList;var j=sap.ui.getCore().byId(i.getAssociation("search"));j.detachLiveChange(i._handleSearchEvent,i);if(V){j.attachLiveChange(i._handleSearchEvent,i);}}return this;};
A.prototype.getLists=function(){var i=this.getAggregation("lists");if(!i){i=[];}if(this._displayedList){i.splice(this._listAggrIndex,0,this._displayedList);}i.forEach(function(j){if(!j.hasListeners("listItemsChange")){j.attachEvent("listItemsChange",_.bind(this));}}.bind(this));return i;};
function _(i){var j=i.getSource();if(this._oAllCheckBoxBar){this._oAllCheckBoxBar.setVisible(Boolean(j.getItems(true).length));}}
A.prototype.removeList=function(i){var j=M.prototype.removeAggregation.call(this,"lists",i);this._removeList(j);return j;};
A.prototype.removeAggregation=function(){var i=M.prototype.removeAggregation.apply(this,arguments);if(arguments[0]==="lists"){this._removeList(i);}return i;};
A.prototype.openFilterDialog=function(){var i=this._getFacetDialog();var j=this._getFacetDialogNavContainer();i.addContent(j);this.getLists().forEach(function(k){if(k.getMode()===v.MultiSelect){k._preserveOriginalActiveState();}});i.setInitialFocus(j.getPages()[0].getContent()[0].getItems()[0]);i.open();return this;};
A.prototype.init=function(){this._pageSize=5;this._addDelegateFlag=false;this._invalidateFlag=false;this._lastCategoryFocusIndex=0;this._aDomRefs=null;this._previousTarget=null;this._addTarget=null;this._aRows=null;this._bundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.data("sap-ui-fastnavgroup","true",true);this._buttons={};this._aOwnedLabels=[];this._removeFacetIcons={};this._listAggrIndex=-1;this._displayedList=null;this._lastScrolling=false;this._bPreviousScrollForward=false;this._bPreviousScrollBack=false;this._getAddFacetButton();this.setAggregation("resetButton",this._createResetButton());if(E.touchEventMode==="ON"&&!D.system.phone){this._enableTouchSupport();}if(D.system.phone){this.setType(z.Light);}};
A.prototype.exit=function(){var i;c.removeListener(this._checkOverflow,this);if(this.oItemNavigation){this.removeDelegate(this.oItemNavigation);this.oItemNavigation.destroy();}if(this._aOwnedLabels){this._aOwnedLabels.forEach(function(j){i=sap.ui.getCore().byId(j);if(i){i.destroy();}});this._aOwnedLabels=null;}if(this._oAllCheckBoxBar){this._oAllCheckBoxBar=undefined;}};
A.prototype.onBeforeRendering=function(){if(this.getShowSummaryBar()||this.getType()===z.Light){var i=this._getSummaryBar();var j=i.getContent()[0];j.setText(this._getSummaryText());}c.removeListener(this._checkOverflow,this);};
A.prototype.onAfterRendering=function(){var i=this.getShowSummaryBar(),j=this.getType(),k=this._getSummaryBar().$();if(j!==z.Light&&!D.system.phone){c.addListener(this._checkOverflow,this);}if(j!==z.Light){this._startItemNavigation();}if(j===z.Light){k.attr("aria-roledescription",this._bundle.getText("FACETFILTER_ACTIVE_TITLE"));k.attr("role","group");}else if(i){k.attr("aria-roledescription",this._bundle.getText("FACETFILTER_TITLE"));}};
A.prototype._startItemNavigation=function(){var j=this.getDomRef(),R=j.getElementsByClassName("sapMFFHead"),k=[];if(R.length>0){for(var i=0;i<R[0].childNodes.length;i++){if(R[0].childNodes[i].id.indexOf("ff")<0&&R[0].childNodes[i].id.indexOf("icon")<0&&R[0].childNodes[i].id.indexOf("add")<0){k.push(R[0].childNodes[i]);}if(R[0].childNodes[i].id.indexOf("add")>=0){k.push(R[0].childNodes[i]);}}}if(k!=""){this._aDomRefs=k;}if((!this.oItemNavigation)||this._addDelegateFlag==true){this.oItemNavigation=new a();this.addDelegate(this.oItemNavigation);this._addDelegateFlag=false;}this._aRows=R;for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].id.indexOf("add")>=0){this._addTarget=this.$().find(":sapTabbable")[i];break;}}this.oItemNavigation.setRootDomRef(j);this.oItemNavigation.setItemDomRefs(k);this.oItemNavigation.setCycling(false);this.oItemNavigation.setPageSize(this._pageSize);};
A.prototype.onsapdelete=function(i){var j,G;if(this.getType()===z.Light){return;}if(!this.getShowPersonalization()){return;}j=sap.ui.getCore().byId(i.target.id);if(!j){return;}G=sap.ui.getCore().byId(j.getAssociation("list"));if(!G){return;}if(!G.getShowRemoveFacetIcon()){return;}G.removeSelections(true);G.setSelectedKeys();G.setProperty("active",false,true);this.invalidate();var $=this.$().find(":sapTabbable");q($[$.length-1]).trigger("focus");var H=this.oItemNavigation.getFocusedIndex();q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(H+1);this.focus();if(this.oItemNavigation.getFocusedIndex()==0){for(var k=0;k<this.$().find(":sapTabbable").length-1;k++){if($[k].id.indexOf("add")>=0){q($[k]).trigger("focus");}}}};
A.prototype.onsaptabnext=function(j){if(this.getType()===z.Light){return;}this._previousTarget=j.target;if(j.target.parentNode.className=="sapMFFHead"){for(var i=0;i<this.$().find(":sapTabbable").length;i++){if(this.$().find(":sapTabbable")[i].parentNode.className=="sapMFFResetDiv"){q(this.$().find(":sapTabbable")[i]).trigger("focus");this._invalidateFlag=false;j.preventDefault();j.setMarked();return;}}}this._lastCategoryFocusIndex=this.oItemNavigation.getFocusedIndex();if(this._invalidateFlag==true){this.oItemNavigation.setFocusedIndex(-1);this.focus();this._invalidateFlag=false;}};
A.prototype.onsaptabprevious=function(i){if(this.getType()===z.Light){return;}if(i.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget==null){q(this.$().find(":sapTabbable")[0]).trigger("focus");i.preventDefault();i.setMarked();return;}if(i.target.parentNode.className=="sapMFFResetDiv"&&this._previousTarget!=null&&this._previousTarget.id!=i.target.id){q(this._previousTarget).trigger("focus");i.preventDefault();i.setMarked();return;}if(i.target.id.indexOf("add")>=0||i.target.parentNode.className=="sapMFFHead"){this._previousTarget=i.target;q(this.$().find(":sapTabbable")[0]).trigger("focus");}};
A.prototype.onsapend=function(i){if(this.getType()===z.Light){return;}if(this._addTarget!=null){q(this._addTarget).trigger("focus");i.preventDefault();i.setMarked();}else{q(this._aRows[this._aRows.length-1]).trigger("focus");i.preventDefault();i.setMarked();}this._previousTarget=i.target;};
A.prototype.onsaphome=function(i){if(this.getType()===z.Light){return;}q(this._aRows[0]).trigger("focus");i.preventDefault();i.setMarked();this._previousTarget=i.target;};
A.prototype.onsappageup=function(i){this._previousTarget=i.target;};
A.prototype.onsappagedown=function(i){this._previousTarget=i.target;};
A.prototype.onsapincreasemodifiers=function(i){if(this.getType()===z.Light){return;}if(i.which==K.ARROW_RIGHT){this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()-1;var k=j+this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();}};
A.prototype.onsapdecreasemodifiers=function(i){if(this.getType()===z.Light){return;}var j=0;if(i.which==K.ARROW_LEFT){this._previousTarget=i.target;j=this.oItemNavigation.getFocusedIndex()+1;var k=j-this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();}};
A.prototype.onsapdownmodifiers=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;var j=0;j=this.oItemNavigation.getFocusedIndex()-1;var k=j+this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();};
A.prototype.onsapupmodifiers=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;var j=0;j=this.oItemNavigation.getFocusedIndex();if(j!=0){j=j+1;}var k=j-this._pageSize;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(k);this.focus();};
A.prototype.onsapexpand=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()+1;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(j);this.focus();};
A.prototype.onsapcollapse=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;var j=this.oItemNavigation.getFocusedIndex()-1;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(j);this.focus();};
A.prototype.onsapdown=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();return;}};
A.prototype.onsapup=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();}};
A.prototype.onsapleft=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();}};
A.prototype.onsapright=function(i){if(this.getType()===z.Light){return;}this._previousTarget=i.target;if(i.target.parentNode.className=="sapMFFResetDiv"){q(i.target).trigger("focus");i.preventDefault();i.setMarked();}};
A.prototype.onsapescape=function(i){if(this.getType()===z.Light){return;}if(i.target.parentNode.className=="sapMFFResetDiv"){return;}var j=this._lastCategoryFocusIndex;q(i.target).trigger("blur");this.oItemNavigation.setFocusedIndex(j);this.focus();};
A.prototype._getPopover=function(){var i=this.getAggregation("popover");if(!i){var j=this;i=new P({placement:y.Bottom,beforeOpen:function(G){if(j._displayedList){j._displayedList._bSearchEventDefaultBehavior&&j._displayedList._setSearchValue("");}this.setCustomHeader(j._createFilterItemsSearchFieldBar(j._displayedList));var H=this.getSubHeader();if(!H){this.setSubHeader(j._createSelectAllCheckboxBar(j._displayedList));}k(j._displayedList);},afterClose:function(G){j._addDelegateFlag=true;j._handlePopoverAfterClose();},horizontalScrolling:false});this.setAggregation("popover",i,true);i.setContentWidth("30%");i.addStyleClass("sapMFFPop");var k=function(G){if(!G){return;}var H=j._getFacetRemoveIcon(G);if(H){H._bTouchStarted=false;}};}if(this.getShowPopoverOKButton()){this._addOKButtonToPopover(i);}else{i.destroyAggregation("footer");}return i;};
A.prototype._handlePopoverAfterClose=function(){var i=this.getAggregation("popover"),j=this._displayedList;if(!i){return;}var k=this._getFacetRemoveIcon(j);if(k&&k._bTouchStarted){return;}this._restoreListFromDisplayContainer(i);this._displayRemoveIcon(false,j);j._fireListCloseEvent();this._fireConfirmEvent();this.destroyAggregation("popover");if(this._oOpenPopoverDeferred){setTimeout(function(){this._oOpenPopoverDeferred.resolve();this._oOpenPopoverDeferred=undefined;}.bind(this),0);}};
A.prototype._fireConfirmEvent=function(){this.fireEvent('confirm');};
A.prototype._openPopover=function(i,j){var k;if(!i.isOpen()){var G=sap.ui.getCore().byId(j.getAssociation("list"));f(G,"The facet filter button should be associated with a list.");k=!G.fireListOpen({});this._moveListToDisplayContainer(G,i);i.openBy(j);if(G.getShowRemoveFacetIcon()){this._displayRemoveIcon(true,G);}if(G.getWordWrap()){i.setContentWidth("30%");}if(!k){G._applySearch();}}return this;};
A.prototype._getAddFacetButton=function(){var i=this.getAggregation("addFacetButton");if(!i){i=new B(this.getId()+"-add",{icon:I.getIconURI("add-filter"),type:x.Transparent,tooltip:this._bundle.getText("FACETFILTER_ADDFACET"),press:function(j){this.openFilterDialog();}.bind(this)});this.setAggregation("addFacetButton",i,true);}return i;};
A.prototype._getButtonForList=function(i){if(this._buttons[i.getId()]){this._setButtonText(i);return this._buttons[i.getId()];}var j=this;var k=new B({type:x.Transparent,press:function(G){var H=this;var J=function(){var Q=j._getPopover();j._openPopover(Q,H);};if(i.getMode()===v.MultiSelect){i._preserveOriginalActiveState();}var Q=j._getPopover();if(Q.isOpen()){setTimeout(function(){if(Q.isOpen()){return;}j._oOpenPopoverDeferred=q.Deferred();j._oOpenPopoverDeferred.promise().done(J);},100);}else{setTimeout(J.bind(this),100);}}});this._buttons[i.getId()]=k;this.addAggregation("buttons",k);k.setAssociation("list",i.getId(),true);this._setButtonText(i);return k;};
A.prototype._setButtonText=function(i){var j=this._buttons[i.getId()];if(i._iAllItemsCount===undefined&&i.getMaxItemsCount()||!i._bSearchEventDefaultBehavior){i._iAllItemsCount=i.getMaxItemsCount();}if(j){var k="";var G=Object.getOwnPropertyNames(i._oSelectedKeys);var H=G.length;if(H===1){var J=i._oSelectedKeys[G[0]];k=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[i.getTitle(),J]);}else if(H>0&&H===(i._iAllItemsCount?i._iAllItemsCount:0)){k=this._bundle.getText("FACETFILTER_ALL_SELECTED",[i.getTitle()]);}else if(H>0){k=this._bundle.getText("FACETFILTER_ITEM_SELECTION",[i.getTitle(),H]);}else{k=i.getTitle();}j.setText(k);}};
A.prototype._getFacetRemoveIcon=function(i){var j=this,k=this._removeFacetIcons[i.getId()];if(!k){k=new d({src:I.getIconURI("decline"),tooltip:this._bundle.getText("FACETFILTER_REMOVE"),press:function(){k._bPressed=true;}});k.addDelegate({ontouchstart:function(){k._bTouchStarted=true;k._bPressed=false;},ontouchend:function(){j._displayRemoveIcon(false,i);k._bTouchStarted=false;setTimeout(G.bind(this),100);}},true);var G=function(){if(k._bPressed){i.removeSelections(true);i.setSelectedKeys();i.setProperty("active",false,true);}j._handlePopoverAfterClose();};k.setAssociation("list",i.getId(),true);k.addStyleClass("sapMFFLRemoveIcon");this._removeFacetIcons[i.getId()]=k;this.addAggregation("removeFacetIcons",k);this._displayRemoveIcon(false,i);}return k;};
A.prototype._displayRemoveIcon=function(i,j){if(this.getShowPersonalization()){var k=this._removeFacetIcons[j.getId()];if(i){k.removeStyleClass("sapMFFLHiddenRemoveIcon");k.addStyleClass("sapMFFLVisibleRemoveIcon");}else{k.removeStyleClass("sapMFFLVisibleRemoveIcon");k.addStyleClass("sapMFFLHiddenRemoveIcon");}}};
A.prototype._getFacetDialogNavContainer=function(){var i=new N({autoFocus:false});var j=this._createFacetPage();i.addPage(j);i.setInitialPage(j);i.attachAfterNavigate(function(k){var G=k.getParameters()["to"];var H=k.getParameters()['from'];if(H===j){var J=(this._displayedList.getMode()===v.MultiSelect)?G.getContent(0)[1].getItems()[0]:G.getContent(0)[0].getItems()[0];if(J){J.focus();}}if(G===j){H.destroySubHeader();f(this._displayedList===null,"Filter items list should have been placed back in the FacetFilter aggregation before page content is destroyed.");H.destroyContent();this._selectedFacetItem.invalidate();G.invalidate();this._selectedFacetItem.focus();this._selectedFacetItem=null;}}.bind(this));return i;};
A.prototype._createFacetPage=function(){var i=this._createFacetList();var j=new S({width:"100%",tooltip:this._bundle.getText("FACETFILTER_SEARCH"),liveChange:function(G){var H=i.getBinding("items");if(H){var J=new F("text",sap.ui.model.FilterOperator.Contains,G.getParameters()["newValue"]);H.filter([J]);}}});var k=new s({enableScrolling:true,title:this._bundle.getText("FACETFILTER_TITLE"),subHeader:new m({contentMiddle:j}),content:[i]});return k;};
A.prototype._createFilterItemsPage=function(){var i=new s({showNavButton:true,enableScrolling:true,navButtonPress:function(j){var k=j.getSource().getParent();this._navFromFilterItemsPage(k);}.bind(this)});return i;};
A.prototype._getFilterItemsPage=function(i){var j=i.getPages()[1];if(j){i.removePage(j);j.destroy();}var k=this._createFilterItemsPage();i.addPage(k);return k;};
A.prototype._createFilterItemsSearchFieldBar=function(i){var j=true;if(i.getDataType()!=w.String){j=false;}var k=new S({value:i._getSearchValue(),width:"100%",enabled:j,tooltip:this._bundle.getText("FACETFILTER_SEARCH"),search:function(H){this._displayedList._handleSearchEvent(H);}.bind(this)});if(this.getLiveSearch()){k.attachLiveChange(i._handleSearchEvent,i);}var G=new m({contentMiddle:k});i.setAssociation("search",k);return G;};
A.prototype._getFacetDialog=function(){var i=this.getAggregation("dialog");if(!i){var j=this;i=new n({showHeader:false,stretch:D.system.phone?true:false,afterClose:function(){j._addDelegateFlag=true;j._invalidateFlag=true;var k=this.getContent()[0];var G=k.getPages()[1];if(k.getCurrentPage()===G){var H=j._restoreListFromDisplayContainer(G);if(H.getMode()===v.MultiSelect){H._updateActiveState();j._bCheckForAddListBtn=true;}H._fireListCloseEvent();H._bSearchEventDefaultBehavior&&H._search("");}this.destroyAggregation("content",true);j.invalidate();},beginButton:new B({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),press:function(){j._closeDialog();}}),contentHeight:"500px",ariaLabelledBy:[b.getStaticId("sap.m","FACETFILTER_AVAILABLE_FILTER_NAMES")]});i.addStyleClass("sapMFFDialog");i.onsapentermodifiers=function(k){if(k.shiftKey&&!k.ctrlKey&&!k.altKey){var G=this.getContent()[0];j._navFromFilterItemsPage(G);}};this.setAggregation("dialog",i,true);}return i;};
A.prototype._closeDialog=function(){var i=this.getAggregation("dialog");if(i&&i.isOpen()){i.close();this._fireConfirmEvent();}};
A.prototype._closePopover=function(){var i=this.getAggregation("popover");if(i&&i.isOpen()){i.close();}};
A.prototype._createFacetList=function(){var j=this._oFacetList=new o({mode:v.None,items:{path:"/items",template:new p({title:"{text}",counter:"{count}",type:u.Navigation,customData:[new sap.ui.core.CustomData({key:"index",value:"{index}"})]})}});var k=this._getMapFacetLists();var G=new sap.ui.model.json.JSONModel({items:k});if(k.length>100){G.setSizeLimit(k.length);}var H=this;j.attachUpdateFinished(function(){for(var i=0;i<j.getItems().length;i++){var J=this.getItems()[i];J.detachPress(H._handleFacetListItemPress,H);J.attachPress(H._handleFacetListItemPress,H);}});j.setModel(G);return j;};
A.prototype.refreshFacetList=function(){this._oFacetList.getModel().setData({items:this._getMapFacetLists()});return this;};
A.prototype._getMapFacetLists=function(){return this.getLists().map(function(i,j){return{text:i.getTitle(),count:i.getAllCount(),index:j};});};
A.prototype._createSelectAllCheckboxBar=function(i){if(!i.getMultiSelect()){return null;}var j=i.getActive()&&i.getItems().length>0&&Object.getOwnPropertyNames(i._oSelectedKeys).length===i.getItems().length;var k=new r(i.getId()+"-selectAll",{text:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),tooltip:this._bundle.getText("FACETFILTER_CHECKBOX_ALL"),selected:j,select:function(H){k.setSelected(H.getParameter("selected"));i._handleSelectAllClick(H.getParameter("selected"));}});i.setAssociation("allcheckbox",k);var G=new m({visible:Boolean(i.getItems(true).length)});G.addEventDelegate({ontap:function(H){if(H.srcControl===this){i._handleSelectAllClick(k.getSelected());}}},G);G.addContentLeft(k);G.addStyleClass("sapMFFCheckbar");this._oAllCheckBoxBar=G;return G;};
A.prototype._handleFacetListItemPress=function(i){this._navToFilterItemsPage(i.getSource());};
A.prototype._navToFilterItemsPage=function(i){this._selectedFacetItem=i;var j=this.getAggregation("dialog").getContent()[0];var k=i.getCustomData();f(k.length===1,"There should be exactly one custom data for the original facet list item index");var G=k[0].getValue();var H=this.getLists()[G];this._listIndexAgg=this.indexOfAggregation("lists",H);if(this._listIndexAgg==G){var J=this._getFilterItemsPage(j);H.fireListOpen({});this._moveListToDisplayContainer(H,J);J.setSubHeader(this._createFilterItemsSearchFieldBar(H));var Q=this._createSelectAllCheckboxBar(H);if(Q){J.insertContent(Q,0);}J.setTitle(H.getTitle());j.to(J);}};
A.prototype._navFromFilterItemsPage=function(i){var j=i.getPages()[1];var k=this._restoreListFromDisplayContainer(j);if(k.getMode()===v.MultiSelect){k._updateActiveState();}k._fireListCloseEvent();k._bSearchEventDefaultBehavior&&k._search("");this._selectedFacetItem.setCounter(k.getAllCount());i.backToTop();};
A.prototype._moveListToDisplayContainer=function(i,j){this._listAggrIndex=this.indexOfAggregation("lists",i);f(this._listAggrIndex>-1,"The lists index should be valid.");M.prototype.removeAggregation.call(this,"lists",i,true);j.addAggregation("content",i,false);i.setAssociation("facetFilter",this,true);this._displayedList=i;};
A.prototype._restoreListFromDisplayContainer=function(i){var j=i.removeAggregation("content",this._displayedList,true);this.insertAggregation("lists",j,this._listAggrIndex,j.getActive());this._listAggrIndex=-1;this._displayedList=null;return j;};
A.prototype._getSequencedLists=function(){var k=-1;var G=[];var H=this.getLists();if(H.length>0){for(var i=0;i<H.length;i++){if(H[i].getActive()){if(H[i].getSequence()<-1){H[i].setSequence(-1);}else if(H[i].getSequence()>k){k=H[i].getSequence();}G.push(H[i]);}else if(!H[i].getRetainListSequence()){H[i].setSequence(-1);}}for(var j=0;j<G.length;j++){if(G[j].getSequence()<=-1){k+=1;G[j].setSequence(k);}}if(G.length>1){G.sort(function(J,Q){return J.getSequence()-Q.getSequence();});}}return G;};
A.prototype._getSummaryBar=function(){var i=this.getAggregation("summaryBar"),j=this.getType();if(!i){var k=new g({maxLines:1});i=new h({content:[k],active:j===z.Light?true:false,design:t.Info,ariaLabelledBy:k,press:function(G){this.openFilterDialog();}.bind(this)});i._setRootAccessibilityRole("group");this.setAggregation("summaryBar",i);}return i;};
A.prototype._createResetButton=function(){var j=new B({type:x.Transparent,icon:I.getIconURI("undo"),tooltip:this._bundle.getText("FACETFILTER_RESET"),press:function(k){this._addDelegateFlag=true;this._invalidateFlag=true;this.fireReset();var G=this.getLists();for(var i=0;i<G.length;i++){G[i]._setSearchValue("");G[i]._applySearch();var H=G[i].getItems()[0];if(H){H.focus();}}this.invalidate();}.bind(this)});return j;};
A.prototype._addOKButtonToPopover=function(i){var j=i.getFooter(),k;if(!j){k=new B({text:this._bundle.getText("FACETFILTER_ACCEPT"),tooltip:this._bundle.getText("FACETFILTER_ACCEPT"),press:function(){this._closePopover();}.bind(this)});j=new O({content:[new T(),k]});i.setFooter(j);}};
A.prototype._getSummaryText=function(){var k=", ";var G=" ";var H="";var J=true;var Q=this.getLists();if(Q.length>0){for(var i=0;i<Q.length;i++){var R=Q[i];if(R.getActive()){var U=this._getSelectedItemsText(R);var V="";for(var j=0;j<U.length;j++){V=V+U[j]+k;}if(V){V=V.substring(0,V.lastIndexOf(k)).trim();if(J){H=this._bundle.getText("FACETFILTER_INFOBAR_FILTERED_BY",[R.getTitle(),V]);J=false;}else{H=H+G+this._bundle.getText("FACETFILTER_INFOBAR_AND")+G+this._bundle.getText("FACETFILTER_INFOBAR_AFTER_AND",[R.getTitle(),V]);}}}}}if(!H){H=this._bundle.getText("FACETFILTER_INFOBAR_NO_FILTERS");}return H;};
A.prototype._getSelectedItemsText=function(i){var j=i.getSelectedItems().map(function(k){return k.getText();});i._oSelectedKeys&&Object.getOwnPropertyNames(i._oSelectedKeys).forEach(function(k){j.indexOf(i._oSelectedKeys[k])===-1&&j.push(i._oSelectedKeys[k]);});return j;};
A.prototype._addResetToSummary=function(i){if(i.getContent().length===1){i.addContent(new T({width:""}));var j=this._createResetButton();i.addContent(j);j.addStyleClass("sapUiSizeCompact");j.addStyleClass("sapMFFRefresh");j.addStyleClass("sapMFFBtnHoverable");}};
A.prototype._removeResetFromSummary=function(i){if(i.getContent().length===3){var j=i.removeAggregation("content",1);j.destroy();var k=i.removeAggregation("content",1);k.destroy();}};
A.prototype._removeList=function(i){if(i){var j=this._buttons[i.getId()];if(j){this.removeAggregation("buttons",j);j.destroy();}var R=this._removeFacetIcons[i.getId()];if(R){this.removeAggregation("removeIcons",R);R.destroy();}delete this._buttons[i.getId()];delete this._removeFacetIcons[i.getId()];}};
A.prototype._getScrollingArrow=function(j){var k=null;var G={src:"sap-icon://navigation-"+j+"-arrow"};if(j==="left"){k=this.getAggregation("arrowLeft");if(!k){G.id=this.getId()+"-arrowScrollLeft";k=I.createControlByURI(G);var H=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollLeft"];for(var i=0;i<H.length;i++){k.addStyleClass(H[i]);k.setTooltip(this._bundle.getText("FACETFILTER_PREVIOUS"));}this.setAggregation("arrowLeft",k);}}else if(j==="right"){k=this.getAggregation("arrowRight");if(!k){G.id=this.getId()+"-arrowScrollRight";k=I.createControlByURI(G);var J=["sapMPointer","sapMFFArrowScroll","sapMFFArrowScrollRight"];for(var i=0;i<J.length;i++){k.addStyleClass(J[i]);k.setTooltip(this._bundle.getText("FACETFILTER_NEXT"));}this.setAggregation("arrowRight",k);}}else{L.error("Scrolling arrow name "+j+" is not valid");}return k;};
A.prototype._checkOverflow=function(){var i=this.getDomRef("head"),$=q(i),j=this.$(),k=false,G=false,H=false,J=null,Q=null,R=null;if(i){J=i.scrollLeft;Q=i.scrollWidth;R=i.clientWidth;if(Q>R){if(Q-R==1){Q=R;}else{H=true;}}j.toggleClass("sapMFFScrolling",H);j.toggleClass("sapMFFNoScrolling",!H);this._lastScrolling=H;if(!this._bRtl){k=J>0;G=(Q>R)&&(Q>J+R);}else{G=$.scrollLeftRTL()>0;k=$.scrollRightRTL()>0;}if((G!=this._bPreviousScrollForward)||(k!=this._bPreviousScrollBack)){j.toggleClass("sapMFFNoScrollBack",!k);j.toggleClass("sapMFFNoScrollForward",!G);}}};
A.prototype.onclick=function(i){var j=i.target.id;if(j){var k=this.getId(),G=i.target;i.preventDefault();if(j==k+"-arrowScrollLeft"){G.tabIndex=-1;G.focus();this._scroll(-A.SCROLL_STEP,500);}else if(j==k+"-arrowScrollRight"){G.tabIndex=-1;G.focus();this._scroll(A.SCROLL_STEP,500);}}};
A.prototype._scroll=function(i,j){var k=this.getDomRef("head");var G=k.scrollLeft;if(!D.browser.internet_explorer&&this._bRtl){i=-i;}var H=G+i;q(k).stop(true,true).animate({scrollLeft:H},j);};
A.prototype._enableTouchSupport=function(){var i=function(G){var H=this.getType();if(H===z.Light){return;}G.preventDefault();if(this._iInertiaIntervalId){window.clearInterval(this._iInertiaIntervalId);}this.startScrollX=this.getDomRef("head").scrollLeft;this.startTouchX=G.touches[0].pageX;this._bTouchNotMoved=true;this._lastMoveTime=new Date().getTime();}.bind(this);var j=function(G){var H=this.getType();if(H===z.Light){return;}var J=G.touches[0].pageX-this.startTouchX;var Q=this.getDomRef("head");var R=Q.scrollLeft;var U=this.startScrollX-J;Q.scrollLeft=U;this._bTouchNotMoved=false;var V=new Date().getTime()-this._lastMoveTime;this._lastMoveTime=new Date().getTime();if(V>0){this._velocity=(U-R)/V;}G.preventDefault();}.bind(this);var k=function(G){var H=this.getType();if(H===z.Light){return;}if(this._bTouchNotMoved===false){G.preventDefault();var J=this.getDomRef("head");var Q=50;var R=Math.abs(this._velocity/10);this._iInertiaIntervalId=window.setInterval(function(){this._velocity=this._velocity*0.80;var U=this._velocity*Q;J.scrollLeft=J.scrollLeft+U;if(Math.abs(this._velocity)<R){window.clearInterval(this._iInertiaIntervalId);this._iInertiaIntervalId=undefined;}},Q);}else if(this._bTouchNotMoved===true){this.onclick(G);G.preventDefault();}this._bTouchNotMoved=undefined;this._lastMoveTime=undefined;}.bind(this);this.addEventDelegate({ontouchstart:i},this);this.addEventDelegate({ontouchend:k},this);this.addEventDelegate({ontouchmove:j},this);};
return A;});
sap.ui.predefine('sap/m/FacetFilterItem',['./ListItemBase','./library','./FacetFilterItemRenderer'],function(L,l,F){"use strict";
var a=L.extend("sap.m.FacetFilterItem",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},count:{type:"int",group:"Misc",defaultValue:null,deprecated:true}}}});
a.prototype.setCount=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
a.prototype.setCounter=function(c){this.setProperty("count",c);this.setProperty("counter",c);return this;};
a.prototype.init=function(){this.attachEvent("_change",this._itemTextChange);L.prototype.init.apply(this);this.addStyleClass("sapMFFLI");};
a.prototype.exit=function(){L.prototype.exit.apply(this);this.detachEvent("_change",this._itemTextChange);};
a.prototype._itemTextChange=function(e){if(e.getParameter("name")==="text"){this.informList("TextChange",e.getParameter("newValue"));}};
return a;});
sap.ui.predefine('sap/m/FacetFilterItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer'],function(L,R){"use strict";var F=R.extend(L);F.apiVersion=2;
F.renderLIContent=function(r,c){r.openStart("div",c);if(c.getParent()&&c.getParent().getWordWrap()){r.class("sapMFFLITitleWrap");}else{r.class("sapMFFLITitle");}r.openEnd();r.text(c.getText());r.close("div");};
return F;},true);
sap.ui.predefine('sap/m/FacetFilterList',['./List','./library','sap/ui/model/ChangeReason','sap/ui/model/Filter','./FacetFilterListRenderer','./FacetFilterItem',"sap/base/Log","sap/ui/model/FilterOperator","sap/ui/model/FilterType"],function(L,l,C,F,a,b,c,d,e){"use strict";var f=l.ListMode;var g=l.FacetFilterListDataType;
var h=L.extend("sap.m.FacetFilterList",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},wordWrap:{type:"boolean",group:"Appearance",defaultValue:false},multiSelect:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},active:{type:"boolean",group:"Behavior",defaultValue:true},enableCaseInsensitiveSearch:{type:"boolean",group:"Behavior",defaultValue:false,deprecated:false},allCount:{type:"int",group:"Appearance",defaultValue:null},sequence:{type:"int",group:"Behavior",defaultValue:-1},key:{type:"string",group:"Identification",defaultValue:null},showRemoveFacetIcon:{type:"boolean",group:"Misc",defaultValue:true},retainListSequence:{type:"boolean",group:"Misc",defaultValue:false},dataType:{type:"sap.m.FacetFilterListDataType",group:"Misc",defaultValue:g.String}},events:{listOpen:{allowPreventDefault:true},listClose:{parameters:{selectedItems:{type:"sap.m.FacetFilterItem[]"},allSelected:{type:"boolean"},selectedKeys:{type:"object"}}},search:{allowPreventDefault:true,parameters:{term:{type:"string"}}}}}});
h.prototype.setTitle=function(t){this.setProperty("title",t,true);this._updateFacetFilterButtonText();return this;};
h.prototype.setMultiSelect=function(v){this.setProperty("multiSelect",v,true);var m=v?f.MultiSelect:f.SingleSelectMaster;this.setMode(m);return this;};
h.prototype.setMode=function(m){if(m===f.MultiSelect||m===f.SingleSelectMaster){L.prototype.setMode.call(this,m);this.setProperty("multiSelect",m===f.MultiSelect?true:false,true);}return this;};
h.prototype._applySearch=function(){var s=this._getSearchValue();if(s===null){return;}this._bSearchEventDefaultBehavior&&this._search(s,true);this._updateSelectAllCheckBox();};
h.prototype.getSelectedItems=function(){var s=[];var o={};var i=L.prototype.getSelectedItems.apply(this,arguments);i.forEach(function(I){s.push(new b({text:I.getText(),key:I.getKey(),selected:true}));o[I.getKey()]=true;});var S=this.getSelectedKeys();var j=Object.getOwnPropertyNames(S);if(i.length<j.length){j.forEach(function(k){if(!o[k]){s.push(new b({text:S[k],key:k,selected:true}));}});}return s;};
h.prototype.getSelectedItem=function(){var i=L.prototype.getSelectedItem.apply(this,arguments);var s=Object.getOwnPropertyNames(this.getSelectedKeys());if(!i&&s.length>0){i=new b({text:this.getSelectedKeys()[s[0]],key:s[0],selected:true});}return i;};
h.prototype.removeSelections=function(A){if(this._allowRemoveSelections){A?this.setSelectedKeys():L.prototype.removeSelections.call(this,A);}return this;};
h.prototype.getSelectedKeys=function(){var r={};var k=this._oSelectedKeys;Object.getOwnPropertyNames(k).forEach(function(i){r[i]=k[i];});return r;};
h.prototype.setSelectedKeys=function(k){this._oSelectedKeys={};var K=false;k&&Object.getOwnPropertyNames(k).forEach(function(i){this._addSelectedKey(i,k[i]);K=true;},this);if(K){if(this.getMode()===f.MultiSelect){this.setActive(true);}this._selectItemsByKeys();}else{L.prototype.removeSelections.call(this);}};
h.prototype._getNonGroupItems=function(){var i=[];this.getItems().forEach(function(I){if(I.getMode()!==f.None){i.push(I);}});return i;};
h.prototype.removeSelectedKey=function(k,t){if(this._removeSelectedKey(k,t)){this._getNonGroupItems().forEach(function(i){var I=i.getKey()||i.getText();k===I&&i.setSelected(false);});}};
h.prototype.removeSelectedKeys=function(){this._oSelectedKeys={};L.prototype.removeSelections.call(this,true);};
h.prototype.removeItem=function(i){var I=L.prototype.removeItem.apply(this,arguments);if(!this._filtering){I&&I.getSelected()&&this.removeSelectedKey(I.getKey(),I.getText());return I;}};
h.prototype.init=function(){this._firstTime=true;this._bSearchEventDefaultBehavior=true;this._saveBindInfo;this._oSelectedKeys={};L.prototype.init.call(this);this.setMode(f.MultiSelect);this.setIncludeItemInSelection(true);this.setGrowing(true);this.setRememberSelections(false);this._searchValue="";this.attachUpdateFinished(function(E){var u=E.getParameter("reason");u=u?u.toLowerCase():u;if(u==="change"){var B=this.getBinding("items"),m=B?B.getModel():null;if(m&&m.getProperty(B.getPath())){this._iAllItemsCount=m.getProperty(B.getPath()).length||0;}this._oSelectedKeys={};this._getNonGroupItems().forEach(function(i){if(i.getSelected()){this._addSelectedKey(i.getKey(),i.getText());}},this);}if(u!==C.Filter.toLowerCase()){this._selectItemsByKeys();}this._updateFacetFilterButtonText();this._updateSelectAllCheckBox();});this._allowRemoveSelections=true;this._bOriginalActiveState;this._iAllItemsCount;};
h.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._setSearchValue("");this._allowRemoveSelections=false;L.prototype._resetItemsBinding.apply(this,arguments);this._allowRemoveSelections=true;}};
h.prototype._fireListCloseEvent=function(){var s=this.getSelectedItems();var S=this.getSelectedKeys();var A=s.length===0;this._firstTime=true;this.fireListClose({selectedItems:s,selectedKeys:S,allSelected:A});};
h.prototype._updateActiveState=function(){var o=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));if(Object.getOwnPropertyNames(this._oSelectedKeys).length>0||(o&&o.getSelected())){this.setActive(true);}};
h.prototype._handleSearchEvent=function(E){var s=E.getParameters()["query"];if(s===undefined){s=E.getParameters()["newValue"];}this._bSearchEventDefaultBehavior=this.fireSearch({term:s,clearButtonPressed:E.getParameters()["clearButtonPressed"]});this._bSearchEventDefaultBehavior?this._search(s):this._setSearchValue(s);this._updateSelectAllCheckBox();};
h.prototype._search=function(s,i){var j,B,u,U,p,o,P,k,n=0,m=this.getBinding("items"),q=this.getBindingInfo("items");function r(M){return M instanceof sap.ui.model.odata.ODataModel||M instanceof sap.ui.model.odata.v2.ODataModel||M instanceof sap.ui.model.odata.v4.ODataModel;}if(i||(s!==this._searchValue)){this._searchValue=s;if(q&&q.binding){j=q.binding.aFilters;if(j.length>0){n=j[0].aFilters.length;if(this._firstTime){this._saveBindInfo=j[0].aFilters[0][0];this._firstTime=false;}}}if(m){if(s||n>0){k=q.template?q.template:q.factory();B=k.getBindingInfo("text").parts;p=B[0].path;if(p||p===""){u=[];B.forEach(function(t){u.push(new F(t.path,d.Contains,s));});if(this.getEnableCaseInsensitiveSearch()&&r(m.getModel())){u.forEach(function(t){t.bCaseSensitive=false;});}P=new F(u,false);if(n>1){o=new F([P,this._saveBindInfo],true);}else{if(this._saveBindInfo>""&&U.sPath!=this._saveBindInfo.sPath){o=new F([P,this._saveBindInfo],true);}else{if(s==""){o=[];}else{o=new F([P],true);}}}m.filter(o,e.Control);}}else{m.filter([],e.Control);}}else{c.warning("No filtering performed","The list must be defined with a binding for search to work",this);}}};
h.prototype._getSearchValue=function(){return this._searchValue;};
h.prototype._updateSelectAllCheckBox=function(){var i=this._getNonGroupItems(),I=i.length,o,A,s;function j(k){return k.getSelected();}if(this.getMultiSelect()){o=sap.ui.getCore().byId(this.getAssociation("allcheckbox"));A=I>0&&I===i.filter(j).length;s=this.getActive()&&A;o&&o.setSelected(s);}};
h.prototype._addSelectedKey=function(k,t){if(!k&&!t){c.error("Both sKey and sText are not defined. At least one must be defined.");return;}if(this.getMode()===f.SingleSelectMaster){this.removeSelectedKeys();}if(!k){k=t;}this._oSelectedKeys[k]=t||k;};
h.prototype._removeSelectedKey=function(k,t){if(!k&&!t){c.error("Both sKey and sText are not defined. At least one must be defined.");return false;}if(!k){k=t;}delete this._oSelectedKeys[k];return true;};
h.prototype._setSearchValue=function(v){this._searchValue=v;};
h.prototype._isItemSelected=function(i){return!!(this._oSelectedKeys[i&&(i.getKey()||i.getText())]);};
h.prototype._updateFacetFilterButtonText=function(){if(this.getParent()&&this.getParent()._setButtonText){this.getParent()._setButtonText(this);}};
h.prototype._selectItemsByKeys=function(){this._getNonGroupItems().forEach(function(i){i.setSelected(this._isItemSelected(i));},this);this._updateFacetFilterButtonText();};
h.prototype._handleSelectAllClick=function(s){var A,i,I=this._getNonGroupItems(),j=I.length;I.forEach(function(o){if(s){this._addSelectedKey(o.getKey(),o.getText());}else{this._removeSelectedKey(o.getKey(),o.getText());}o.setSelected(s,true);},this);function k(o){return o.getSelected();}if(this.getMode()===f.MultiSelect){i=j>0&&j===I.filter(k).length;A=this._getOriginalActiveState()||(s&&i);this.setActive(A);}setTimeout(this._updateSelectAllCheckBox.bind(this),0);};
h.prototype.onItemTextChange=function(i,n){var k=i.getKey();if(this._oSelectedKeys[k]&&n&&!this._filtering){this._oSelectedKeys[k]=n;}};
h.prototype.onItemSelectedChange=function(i,s){var A;if(s){this._addSelectedKey(i.getKey(),i.getText());}else{this._removeSelectedKey(i.getKey(),i.getText());}L.prototype.onItemSelectedChange.apply(this,arguments);if(this.getMode()===f.MultiSelect){A=this._getOriginalActiveState()||s||this.getSelectedItems().length>1;this.setActive(A);}!this.getDomRef()&&this.getParent()&&this.getParent().getDomRef()&&this.getParent().invalidate();setTimeout(this._updateSelectAllCheckBox.bind(this),0);};
h.prototype.updateItems=function(r){var p=document.activeElement;this._filtering=r===C.Filter;L.prototype.updateItems.apply(this,arguments);this._filtering=false;if(p&&p.getAttribute("id")!==document.activeElement.getAttribute("id")){this.focus();}if(!this.getGrowing()||r===C.Filter){this._selectItemsByKeys();}};
h.prototype._getOriginalActiveState=function(){return this._bOriginalActiveState;};
h.prototype._preserveOriginalActiveState=function(){this._bOriginalActiveState=this.getActive();};
h.prototype._showBusyIndicator=function(){L.prototype._showBusyIndicator.apply(this,arguments);this.fireEvent("listItemsChange");};
h.prototype._hideBusyIndicator=function(){L.prototype._hideBusyIndicator.apply(this,arguments);this.fireEvent("listItemsChange");};
return h;});
sap.ui.predefine('sap/m/FacetFilterListRenderer',['./ListRenderer','sap/ui/core/Renderer'],function(L,R){"use strict";var F=R.extend(L);F.apiVersion=2;return F;},true);
sap.ui.predefine('sap/m/FacetFilterRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/InvisibleText"],function(l,D,I){"use strict";var F=l.FacetFilterType;var a={apiVersion:2};
a.render=function(r,c){if(c.getType()===F.Light||c.getShowSummaryBar()){a.renderSummaryBar(r,c);}else{a.renderSimpleFlow(r,c);}};
a.renderSimpleFlow=function(r,c){r.openStart("div",c);r.class("sapMFF");r.accessibilityState({role:"toolbar",roledescription:c._bundle.getText("FACETFILTER_TITLE")});if(c._lastScrolling){r.class("sapMFFScrolling");}else{r.class("sapMFFNoScrolling");}if(c.getShowReset()){r.class("sapMFFResetSpacer");}r.openEnd();if(D.system.desktop){r.renderControl(c._getScrollingArrow("left"));}r.openStart("div",c.getId()+"-head");r.class("sapMFFHead");r.openEnd();a.renderFacetFilterListButtons(c,r);if(c.getShowPersonalization()){a.renderAddFilterButton(c,r);}r.close("div");if(D.system.desktop){r.renderControl(c._getScrollingArrow("right"));}if(c.getShowReset()){r.openStart("div");r.class("sapMFFResetDiv");r.openEnd();r.renderControl(c.getAggregation("resetButton"));r.close("div");}r.close("div");};
a.renderSummaryBar=function(r,c){r.openStart("div",c);r.class("sapMFF");r.openEnd();r.renderControl(c.getAggregation("summaryBar"));r.close("div");};
a.getAriaAnnouncement=function(k,b){return I.getStaticId("sap.m",b||"FACETFILTER_"+k.toUpperCase());};
a.renderFacetFilterListButtons=function(c,r){var L=c._getSequencedLists(),b=L.length,s=c.getShowPersonalization(),B,i;for(i=0;i<b;i++){var d=L[i].getItems().length>0,e=L[i].getActive(),A=c._bCheckForAddListBtn&&(d||e);if(!c._bCheckForAddListBtn||A){B=c._getButtonForList(L[i]);a.addPositionInfoForButton(c,B,i+1,b+1);if(s){B.addAriaDescribedBy(a.getAriaAnnouncement("ARIA_REMOVE"));}r.renderControl(B);if(s){r.renderControl(c._getFacetRemoveIcon(L[i]));}}}return this;};
a.renderAddFilterButton=function(c,r){var A=c.getAggregation("addFacetButton"),b=c._getSequencedLists().length+1;a.addPositionInfoForButton(c,A,b,b);r.renderControl(A);return this;};
a.addPositionInfoForButton=function(c,b,p,s){var S=a.createStaticPositioningLabel(c,p,s);a.clearOldPositioningLabels(c,b);b.addAriaDescribedBy(S);return this;};
a.clearOldPositioningLabels=function(c,b){var o=b.removeAllAriaDescribedBy(),r=this.getAriaAnnouncement("ARIA_REMOVE"),i;o.forEach(function(s){if(r===s){return;}i=sap.ui.getCore().byId(s);i&&i.destroy();});return this;};
a.createStaticPositioningLabel=function(c,p,s){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),f=r.getText("FACETFILTER_ARIA_FACET_FILTER"),P=r.getText("FACETFILTERLIST_ARIA_POSITION",[p,s]),S=new I({text:f+" "+P}).toStatic();c._aOwnedLabels.push(S.getId());return S;};
return a;},true);
sap.ui.predefine('sap/m/FeedContent',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/Device','./FeedContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,T,D,F,K){"use strict";var S=l.Size;
var a=C.extend("sap.m.FeedContent",{metadata:{library:"sap.m",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:S.Auto},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null},"value":{type:"string",group:"Misc",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Misc",defaultValue:null},"truncateValueTo":{type:"int",group:"Misc",defaultValue:4}},defaultAggregation:"_contentTextAgr",aggregations:{"_contentTextAgr":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
a.prototype.init=function(){this._oContentText=new T(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("_contentTextAgr",this._oContentText,true);this.setTooltip("{AltText}");};
a.prototype.onBeforeRendering=function(){this.$().off("mouseenter");this.$().off("mouseleave");};
a.prototype.onAfterRendering=function(){this.$().on("mouseenter",this._addTooltip.bind(this));this.$().on("mouseleave",this._removeTooltip.bind(this));};
a.prototype.exit=function(){this._oContentText=null;};
a.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
a.prototype._removeTooltip=function(){this.$().attr("title",null);};
a.prototype.getAltText=function(){var A="";var i=true;if(this.getAggregation("_contentTextAgr").getText()){A+=this.getAggregation("_contentTextAgr").getText();i=false;}if(this.getSubheader()){if(i){A+=""+this.getSubheader();}else{A+="\n"+this.getSubheader();}i=false;}if(this.getValue()){if(i){A+=""+this.getValue();}else{A+="\n"+this.getValue();}}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
a.prototype.setContentText=function(t){this._oContentText.setText(t);return this;};
a.prototype.ontap=function(e){if(D.browser.msie){this.$().trigger("focus");}this.firePress();};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
a.prototype.attachEvent=function(e,d,f,b){C.prototype.attachEvent.call(this,e,d,f,b);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");}return this;};
a.prototype.detachEvent=function(e,f,b){C.prototype.detachEvent.call(this,e,f,b);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");}return this;};
return a;});
sap.ui.predefine('sap/m/FeedContentRenderer',[],function(){"use strict";var F={};
F.render=function(r,c){var s=c.getSubheader();var v=c.getValue();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.write("<div");r.writeControlData(c);r.writeAttribute("role","presentation");r.writeAttributeEscaped("aria-label",t);r.addClass("sapMFC");if(c.hasListeners("press")){r.writeAttribute("tabindex","0");r.addClass("sapMPointer");}r.writeClasses();r.write(">");if(v){r.write("<div");r.writeAttribute("id",c.getId()+"-value");r.addClass("sapMFCValue");r.addClass(c.getValueColor());r.writeClasses();r.write(">");var C=c.getTruncateValueTo();if(v.length>=C&&(v[C-1]==="."||v[C-1]===",")){r.writeEscaped(v.substring(0,C-1));}else if(v){r.writeEscaped(v.substring(0,C));}else{r.writeEscaped("");}r.write("</div>");}r.write("<div");r.addClass("sapMFCCTxt");r.writeClasses();r.write(">");r.renderControl(c._oContentText);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-subheader");r.addClass("sapMFCSbh");r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");r.write("</div>");};
return F;},true);
sap.ui.predefine('sap/m/FeedInput',["./library","sap/ui/core/Control","sap/ui/core/IconPool","sap/m/TextArea","sap/m/Button","./FeedInputRenderer","sap/ui/thirdparty/jquery","sap/base/security/URLWhitelist","sap/base/security/sanitizeHTML"],function(l,C,I,T,B,F,q,U,s){"use strict";var a=l.ButtonType;var M=15,b=2,c=0;
var d=C.extend("sap.m.FeedInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/FeedInput.designtime",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},rows:{type:"int",group:"Appearance",defaultValue:2},showExceededText:{type:"boolean",group:"Behavior",defaultValue:false},maxLength:{type:"int",group:"Behavior",defaultValue:0},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Appearance",defaultValue:"Post something here"},value:{type:"string",group:"Data",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},buttonTooltip:{type:"sap.ui.core.TooltipBase",group:"Accessibility",defaultValue:"Submit"},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null}},events:{post:{parameters:{value:{type:"string"}}}}}});
var _={ATTRIBS:{'style':1,'class':1,'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'abbr':1,'blockquote':1,'br':1,'cite':1,'code':1,'em':1,'h1':{cssClass:'sapMTitle sapMTitleStyleH1'},'h2':{cssClass:'sapMTitle sapMTitleStyleH2'},'h3':{cssClass:'sapMTitle sapMTitleStyleH3'},'h4':{cssClass:'sapMTitle sapMTitleStyleH4'},'h5':{cssClass:'sapMTitle sapMTitleStyleH5'},'h6':{cssClass:'sapMTitle sapMTitleStyleH6'},'p':1,'pre':1,'strong':1,'span':1,'u':1,'dl':1,'dt':1,'dd':1,'ol':1,'ul':1,'li':1}};d.prototype._renderingRules=_;
function S(t,e){var f,v,g=t==="a";var h=this._renderingRules.ELEMENTS[t].cssClass||"";for(var i=0;i<e.length;i+=2){f=e[i];v=e[i+1];if(!this._renderingRules.ATTRIBS[f]&&!this._renderingRules.ATTRIBS[t+"::"+f]){e[i+1]=null;continue;}if(f=="href"){if(!U.validate(v)){e[i+1]="#";g=false;}}if(f=="target"){g=false;}if(h&&f.toLowerCase()=="class"){e[i+1]=h+" "+v;h="";}}if(g){e.push("target");e.push("_blank");}if(h){e.push("class");e.push(h);}return e;}
function p(t,e){return S.call(this,t,e);}
d.prototype._sanitizeHTML=function(t){return s(t,{tagPolicy:p.bind(this),uriRewriter:function(u){if(U.validate(u)){return u;}}});};
d.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setProperty("placeholder",o.getText("FEEDINPUT_PLACEHOLDER"),true);this.setProperty("buttonTooltip",o.getText("FEEDINPUT_SUBMIT"),true);};
d.prototype.exit=function(){if(this._oTextArea){this._oTextArea.destroy();}if(this._oButton){this._oButton.destroy();}if(this._oImageControl){this._oImageControl.destroy();}};
d.prototype.setIconDensityAware=function(i){this.setProperty("iconDensityAware",i,true);var f=sap.ui.require("sap/m/Image");if(this._getImageControl()instanceof f){this._getImageControl().setDensityAware(i);}return this;};
d.prototype.setRows=function(r){var m=this.getProperty("growingMaxLines");if(r>M){r=M;}else if(r<b){r=b;}if(r>m&&m!==0){this.setProperty("growingMaxLines",r,true);this._getTextArea().setGrowingMaxLines(r);}this.setProperty("rows",r,true);this._getTextArea().setRows(r);return this;};
d.prototype.setShowExceededText=function(v){this.setProperty("showExceededText",v,true);this._getTextArea().setShowExceededText(v);return this;};
d.prototype.setMaxLength=function(m){this.setProperty("maxLength",m,true);this._getTextArea().setMaxLength(m);return this;};
d.prototype.setGrowing=function(g){this.setProperty("growing",g,true);this._getTextArea().setGrowing(g);return this;};
d.prototype.setGrowingMaxLines=function(m){var r=this.getProperty("rows");if(m!==c){if(m<r){m=r;}else if(m>M){m=M;}}this.setProperty("growingMaxLines",m,true);this._getTextArea().setGrowingMaxLines(m);return this;};
d.prototype.setValue=function(v){this.setProperty("value",v,true);this._getTextArea().setValue(v);this._enablePostButton();return this;};
d.prototype.setPlaceholder=function(v){this.setProperty("placeholder",v,true);this._getTextArea().setPlaceholder(v);return this;};
d.prototype.setEnabled=function(e){this.setProperty("enabled",e,true);if(this.getDomRef("outerContainer")){if(e){this.getDomRef("outerContainer").classList.remove("sapMFeedInDisabled");}else{this.getDomRef("outerContainer").classList.add("sapMFeedInDisabled");}}this._getTextArea().setEnabled(e);this._enablePostButton();return this;};
d.prototype.setButtonTooltip=function(v){this.setProperty("buttonTooltip",v,true);this._getPostButton().setTooltip(v);return this;};
d.prototype._getTextArea=function(){var t=this;if(!this._oTextArea){this._oTextArea=new T(this.getId()+"-textArea",{value:this.getValue(),maxLength:this.getMaxLength(),placeholder:this.getPlaceholder(),growing:this.getGrowing(),growingMaxLines:this.getGrowingMaxLines(),showExceededText:this.getShowExceededText(),rows:this.getRows(),liveChange:q.proxy(function(e){var v=e.getParameter("value");this.setProperty("value",v,true);this._enablePostButton();},this)});this._oTextArea.setParent(this);this._oTextArea.addEventDelegate({onAfterRendering:function(){t.$("counterContainer").empty();t.$("counterContainer").html(t._oTextArea.getAggregation("_counter").$());}});}return this._oTextArea;};
d.prototype._getPostButton=function(){if(!this._oButton){this._oButton=new B(this.getId()+"-button",{enabled:false,type:a.Default,icon:"sap-icon://feeder-arrow",tooltip:this.getButtonTooltip(),press:q.proxy(function(){this._oTextArea.focus();this.firePost({value:this._sanitizeHTML(this.getValue())});this.setValue(null);},this)});this._oButton.setParent(this);}return this._oButton;};
d.prototype._enablePostButton=function(){var P=this._isControlEnabled();var o=this._getPostButton();o.setEnabled(P);};
d.prototype._isControlEnabled=function(){var v=this.getValue();return this.getEnabled()&&(typeof v==="string"||v instanceof String)&&v.trim().length>0;};
d.prototype._getImageControl=function(){var i=this.getIcon()||I.getIconURI("person-placeholder"),e=this.getId()+'-icon',P={src:i,alt:this.getAriaLabelForPicture(),densityAware:this.getIconDensityAware(),decorative:false,useIconTooltip:false},f=['sapMFeedInImage'];this._oImageControl=l.ImageHelper.getImageControl(e,this._oImageControl,this,P,f);return this._oImageControl;};
return d;});
sap.ui.predefine('sap/m/FeedInputRenderer',[],function(){"use strict";var F={};
F.render=function(r,c){var m=c.getId();r.write("<div");r.writeControlData(c);r.addClass("sapMFeedInBase");r.writeClasses();r.write(">");r.write('<div id="'+m+'-outerContainer"');r.addClass("sapMFeedIn");if(!c.getShowIcon()){r.addClass("sapMFeedInNoIcon");}if(!c.getEnabled()){r.addClass("sapMFeedInDisabled");}r.writeClasses();r.write(">");if(!!c.getShowIcon()){this._addImage(r,c,m);}r.write('<div id="'+m+'-container"');r.addClass("sapMFeedInContainer");r.writeClasses();r.write(">");var t=c._getTextArea();r.renderControl(t);r.renderControl(c._getPostButton());r.write("</div>");r.write("</div>");r.write('<div id="'+m+'-counterContainer"');r.addClass("sapMFeedInCounter");r.writeClasses();r.write(">");r.write("</div>");r.write("</div>");};
F._addImage=function(r,c,m){r.write('<figure id="'+m+'-figure" class ="sapMFeedInFigure');if(!!c.getIcon()){r.write('">');}else{r.write(' sapMFeedListItemIsDefaultIcon">');}r.renderControl(c._getImageControl());r.write('</figure>');};
return F;},true);
sap.ui.predefine('sap/m/FeedListItem',["./ListItemBase","./Link","./library","./FormattedText","sap/ui/core/Control","sap/ui/core/IconPool","sap/m/Button","sap/ui/Device","./FeedListItemRenderer"],function(L,a,l,F,C,I,B,D,b){"use strict";var c=l.ListType;var d=l.ImageHelper;var e=l.LinkConversion;var f=l.ButtonType;
var g=L.extend("sap.m.FeedListItem",{metadata:{library:"sap.m",designtime:"sap/m/designtime/FeedListItem.designtime",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},sender:{type:"string",group:"Data",defaultValue:null},text:{type:"string",group:"Data",defaultValue:null},moreLabel:{type:"string",group:"Data",defaultValue:null},lessLabel:{type:"string",group:"Data",defaultValue:null},info:{type:"string",group:"Data",defaultValue:null},timestamp:{type:"string",group:"Data",defaultValue:null},senderActive:{type:"boolean",group:"Behavior",defaultValue:true},iconActive:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",defaultValue:true},showIcon:{type:"boolean",group:"Behavior",defaultValue:true},convertLinksToAnchorTags:{type:"sap.m.LinkConversion",group:"Behavior",defaultValue:e.None},convertedLinksDefaultTarget:{type:"string",group:"Behavior",defaultValue:"_blank"},maxCharacters:{type:"int",group:"Behavior",defaultValue:null}},defaultAggregation:"actions",aggregations:{actions:{type:"sap.m.FeedListItemAction",multiple:true},_text:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"},_actionButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{senderPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}},iconPress:{parameters:{domRef:{type:"string"},getDomRef:{type:"function"}}}}}});
g._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");g._nMaxCharactersMobile=300;g._nMaxCharactersDesktop=500;g._sTextShowMore=g._oRb.getText("TEXT_SHOW_MORE");g._sTextShowLess=g._oRb.getText("TEXT_SHOW_LESS");
g.prototype.init=function(){L.prototype.init.apply(this);this.setAggregation("_text",new F(this.getId()+"-formattedText"),true);this.setAggregation("_actionButton",new B({id:this.getId()+"-actionButton",type:f.Transparent,icon:"sap-icon://overflow",press:[this._onActionButtonPress,this]}),true);};
g.prototype._onActionButtonPress=function(){sap.ui.require(["sap/m/ActionSheet"],this._openActionSheet.bind(this));};
g.prototype._openActionSheet=function(A){var o=this.getAggregation("_actionSheet");var h=this.getActions();var j;if(!(o&&o instanceof A)){o=new A({id:this.getId()+"-actionSheet",beforeOpen:[this._onBeforeOpenActionSheet,this]});this.setAggregation("_actionSheet",o,true);}o.destroyAggregation("buttons",true);for(var i=0;i<h.length;i++){j=h[i];o.addButton(new B({icon:j.getIcon(),text:j.getText(),press:j.firePress.bind(j,{"item":this})}));}o.openBy(this.getAggregation("_actionButton"));};
g.prototype._onBeforeOpenActionSheet=function(h){var A,t;if(D.system.phone){return;}t=sap.ui.getCore().getConfiguration().getTheme();A=h.getSource().getParent();A.removeStyleClass("sapContrast sapContrastPlus");if(t==="sap_belize"){A.addStyleClass("sapContrast");}else if(t==="sap_belize_plus"){A.addStyleClass("sapContrastPlus");}};
g.prototype.invalidate=function(){C.prototype.invalidate.apply(this,arguments);var m=g._sTextShowMore;if(this.getMoreLabel()){m=this.getMoreLabel();}delete this._bTextExpanded;if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.setProperty("text",m,true);}};
g.prototype.onBeforeRendering=function(){this.$("realtext").find('a[target="_blank"]').off("click");var o=this.getAggregation("_text");o.setProperty("convertLinksToAnchorTags",this.getConvertLinksToAnchorTags(),true);o.setProperty("convertedLinksDefaultTarget",this.getConvertedLinksDefaultTarget(),true);if(this.getConvertLinksToAnchorTags()===l.LinkConversion.None){o.setHtmlText(this.getText());}else{o.setProperty("htmlText",this.getText(),true);}this._sFullText=o._getDisplayHtml().replace(/\n/g,"<br>");this._sShortText=this._getCollapsedText();if(this._sShortText){this._sShortText=this._sShortText.replace(/<br>/g," ");}this._bEmptyTagsInShortTextCleared=false;};
g.prototype.onAfterRendering=function(){if(this._checkTextIsExpandable()&&!this._bTextExpanded){this._clearEmptyTagsInCollapsedText();}var r=this.$("realtext");F.prototype.onAfterRendering.apply({$:function(){return r;}});};
g.prototype.exit=function(){this.$("realtext").find('a[target="_blank"]').off("click");if(this._oLinkControl){this._oLinkControl.destroy();}if(this._oImageControl){this._oImageControl.destroy();}if(this._oLinkExpandCollapse){this._oLinkExpandCollapse.destroy();}L.prototype.exit.apply(this);};
g.prototype.ontap=function(E){if(E.srcControl){if((!this.getIconActive()&&this._oImageControl&&E.srcControl.getId()===this._oImageControl.getId())||(!this.getSenderActive()&&this._oLinkControl&&E.srcControl.getId()===this._oLinkControl.getId())||(!this._oImageControl||(E.srcControl.getId()!==this._oImageControl.getId())&&(!this._oLinkControl||(E.srcControl.getId()!==this._oLinkControl.getId()))&&(!this._oLinkExpandCollapse||(E.srcControl.getId()!==this._oLinkExpandCollapse.getId())))){L.prototype.ontap.apply(this,[E]);}}};
g.prototype.onfocusin=function(E){if(this._oImageControl){var $=this.$("icon");if(E.target.id===this.getId()){$.removeAttr("alt");}else{$.attr("alt"," ");}}var i=E.srcControl,o=i.getDomRef(),p=this.getParent().getAccessbilityPosition(i);if(i instanceof sap.m.FeedListItem){o.setAttribute("aria-posinset",p.posInset);o.setAttribute("aria-setsize",p.setSize);}};
g.prototype._getImageControl=function(){var i=this.getIcon();var s=i?i:I.getIconURI("person-placeholder");var h=this.getId()+'-icon';var p={src:s,alt:this.getSender(),densityAware:this.getIconDensityAware(),decorative:false,useIconTooltip:false};var j;if(this.getIconActive()){j=['sapMFeedListItemImage'];}else{j=['sapMFeedListItemImageInactive'];}var t=this;this._oImageControl=d.getImageControl(h,this._oImageControl,this,p,j);if(this.getIconActive()){if(!this._oImageControl.hasListeners("press")){this._oImageControl.attachPress(function(){t.fireIconPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});});}}return this._oImageControl;};
g.prototype._getLinkSender=function(w){if(!this._oLinkControl){var t=this;this._oLinkControl=new a({press:function(){t.fireSenderPress({domRef:this.getDomRef(),getDomRef:this.getDomRef.bind(this)});}});this._oLinkControl.setParent(this,null,true);}if(w){this._oLinkControl.setProperty("text",this.getSender()+g._oRb.getText("COLON"),true);}else{this._oLinkControl.setProperty("text",this.getSender(),true);}this._oLinkControl.setProperty("enabled",this.getSenderActive(),true);return this._oLinkControl;};
g.prototype._activeHandlingInheritor=function(){var A=this.getActiveIcon();if(this._oImageControl&&A){this._oImageControl.setSrc(A);}};
g.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon()?this.getIcon():I.getIconURI("person-placeholder");if(this._oImageControl){this._oImageControl.setSrc(s);}};
g.prototype._getCollapsedText=function(){this._nMaxCollapsedLength=this.getMaxCharacters();if(this._nMaxCollapsedLength===0){if(D.system.phone){this._nMaxCollapsedLength=g._nMaxCharactersMobile;}else{this._nMaxCollapsedLength=g._nMaxCharactersDesktop;}}var p=this._convertHtmlToPlainText(this._sFullText);var t=null;if(p&&p.length>this._nMaxCollapsedLength){var s=p.substring(0,this._nMaxCollapsedLength);var n=s.lastIndexOf(" ");if(n>0){s=s.substr(0,n);}if(p.length===this._sFullText.length){t=s;}else{t=this._convertPlainToHtmlText(s);}}return t;};
g.prototype._clearEmptyTagsInCollapsedText=function(){var r;if(this._bEmptyTagsInShortTextCleared){return;}this._bEmptyTagsInShortTextCleared=true;do{r=this.$("realtext").find(":empty").remove();}while(r.length>0);this._sShortText=this.$("realtext").html();};
g.prototype._toggleTextExpanded=function(){var $=this.$("realtext");var h=this.$("threeDots");var m=g._sTextShowMore;var s=g._sTextShowLess;if(this.getMoreLabel()){m=this.getMoreLabel();}if(this.getLessLabel()){s=this.getLessLabel();}if(this._bTextExpanded){$.html(this._sShortText.replace(/&#xa;/g,"<br>"));h.text(" ... ");this._oLinkExpandCollapse.setText(m);this._bTextExpanded=false;this._clearEmptyTagsInCollapsedText();}else{$.html(this._sFullText.replace(/&#xa;/g,"<br>"));h.text("  ");this._oLinkExpandCollapse.setText(s);this._bTextExpanded=true;}};
g.prototype._getLinkExpandCollapse=function(){var m=g._sTextShowMore;if(this.getMoreLabel()){m=this.getMoreLabel();}if(!this._oLinkExpandCollapse){this._oLinkExpandCollapse=new a({text:m,press:[this._toggleTextExpanded,this]});this._bTextExpanded=false;this._oLinkExpandCollapse.setParent(this,null,true);}return this._oLinkExpandCollapse;};
g.prototype._convertHtmlToPlainText=function(h){var r=/(<([^>]+)>)/ig;return h.replace(r,"");};
g.prototype._convertPlainToHtmlText=function(h){var s=this._sFullText;var r=/(<([^>]+)>)/ig;var E=s.split(r);var t="";for(var i=0;i<E.length;i++){if(E[i].length===0){continue;}if(h.length>0&&E[i].indexOf(h.trim())!==-1){E[i]=h;}if(/^<.+>$/.test(E[i])){t=t+E[i];E[i+1]="";continue;}if(h.indexOf(E[i].trim())===-1){continue;}else{h=h.replace(E[i],"");}t=t+E[i];}return t;};
g.prototype._checkTextIsExpandable=function(){return this._sShortText!==null;};
g.prototype.setType=function(t){if(this.getType()!==t){if(t===c.Navigation){this.setProperty("type",c.Active);}else{this.setProperty("type",t);}}return this;};
return g;});
sap.ui.predefine('sap/m/FeedListItemAction',["sap/ui/core/Element"],function(E){"use strict";
var F=E.extend("sap.m.FeedListItemAction",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:""},key:{type:"string",group:"Misc",defaultValue:""}},events:{press:{}}}});
return F;});
sap.ui.predefine('sap/m/FeedListItemRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer","sap/ui/Device"],function(L,R,D){"use strict";var F=R.extend(L);
F.renderLIAttributes=function(r,c){r.addClass("sapMFeedListItemTitleDiv");r.addClass("sapMFeedListShowSeparatorsAll");};
F.renderLIContent=function(r,c){var m=c.getId(),i=D.system.phone;r.write('<div');r.addClass('sapMFeedListItem');r.writeClasses();r.write('>');if(c.getShowIcon()){this._writeImageControl(r,c,m);}if(c.getActions().length>0){r.write("<div");r.writeAttributeEscaped("id",m+"-action-button");r.addClass('sapMFeedListItemActionButton');r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_actionButton"));r.write("</div>");}if(i){r.write('<div class= "sapMFeedListItemHeader sapUiSelectable ');if(c.getShowIcon()){r.write('sapMFeedListItemHasFigure ');}if(c.getSender()&&c.getTimestamp()){r.write('sapMFeedListItemFullHeight');}r.write('" >');if(c.getSender()){r.write('<p id="'+m+'-name" class="sapMFeedListItemTextName sapUiSelectable">');r.renderControl(c._getLinkSender(false));r.write('</p>');}if(c.getTimestamp()){r.write('<p id="'+m+'-timestamp" class="sapMFeedListItemTimestamp sapUiSelectable">');r.writeEscaped(c.getTimestamp());r.write('</p>');}r.write('</div>');r.write('<div class="sapMFeedListItemText sapUiSelectable">');this._writeText(r,c,m,i);if(c._checkTextIsExpandable()){this._writeCollapsedText(r,c,m);}else{r.write(c._sFullText);r.write('</span>');}r.write('</div>');if(c.getInfo()){r.write('<p class="sapMFeedListItemFooter sapUiSelectable">');if(c.getInfo()){r.write('<span id="'+m+'-info" class="sapMFeedListItemInfo sapUiSelectable">');r.writeEscaped(c.getInfo());r.write('</span>');}r.write('</p>');}}else{r.write('<div class= "sapMFeedListItemText ');if(c.getShowIcon()){r.write('sapMFeedListItemHasFigure');}r.write('" >');r.write('<div id="'+m+'-text" class="sapMFeedListItemTextText sapUiSelectable">');if(c.getSender()){r.write('<span id="'+m+'-name" class="sapMFeedListItemTextName sapUiSelectable">');r.renderControl(c._getLinkSender(true));r.write('</span>');}this._writeText(r,c,m,i);if(c._checkTextIsExpandable()){this._writeCollapsedText(r,c,m);}else{r.write(c._sFullText);r.write('</span>');}r.write('</div>');if(c.getInfo()||c.getTimestamp()){r.write('<p class="sapMFeedListItemFooter sapUiSelectable">');if(!sap.ui.getCore().getConfiguration().getRTL()){if(c.getInfo()){this._writeInfo(r,c,m);if(c.getTimestamp()){r.write("<span>&#160&#160&#x00B7&#160&#160</span>");}}if(c.getTimestamp()){this._writeTimestamp(r,c,m);}}else{if(c.getTimestamp()){this._writeTimestamp(r,c,m);}if(c.getInfo()){if(c.getTimestamp()){r.write("<span>&#160&#160&#x00B7&#160&#160</span>");}this._writeInfo(r,c,m);}}r.write('</p>');}r.write('</div>');}r.write('</div>');};
F._writeImageControl=function(r,c,i){r.write('<figure id="'+i+'-figure"');r.addClass('sapMFeedListItemFigure');if(!c.getIcon()){r.addClass('sapMFeedListItemIsDefaultIcon');}r.writeClasses();r.write('>');r.renderControl(c._getImageControl());r.write('</figure>');};
F._writeCollapsedText=function(r,c,i){if(c._bTextExpanded){r.write(c._sFullText);r.write('</span>');r.write('<span id="'+i+'-threeDots" class ="sapMFeedListItemTextString">');r.write("&#32");r.write('</span>');}else{r.write(c._sShortText);r.write('</span>');r.write('<span id="'+i+'-threeDots" class ="sapMFeedListItemTextString">');r.write("&#32&#46&#46&#46&#32");r.write('</span>');}var l=c._getLinkExpandCollapse();l.addStyleClass("sapMFeedListItemLinkExpandCollapse");r.renderControl(l);};
F._writeTimestamp=function(r,c,i){r.write('<span id="'+i+'-timestamp"');r.addClass('sapMFeedListItemTimestampText');r.addClass('sapUiSelectable');if(c.getUnread()){r.addClass('sapMFeedListItem-Unread');}r.writeClasses();r.write(">");r.writeEscaped(c.getTimestamp());r.write('</span>');};
F._writeInfo=function(r,c,i){r.write('<span id="'+i+'-info"');r.addClass('sapMFeedListItemInfoText');r.addClass('sapUiSelectable');if(c.getUnread()){r.addClass('sapMFeedListItem-Unread');}r.writeClasses();r.write(">");r.writeEscaped(c.getInfo());r.write('</span>');};
F._writeText=function(r,c,i,I){r.write('<span id="'+i+'-realtext"');I?r.addClass('sapMFeedListItemText'):r.addClass('sapMFeedListItemTextString');r.addClass('sapMFeedListItemText');r.addClass('sapUiSelectable');if(c.getUnread()){r.addClass('sapMFeedListItem-Unread');}r.writeClasses();r.write(">");};
return F;},true);
sap.ui.predefine('sap/m/Fiori20Adapter',['sap/ui/base/Object','sap/ui/base/EventProvider','sap/ui/base/ManagedObjectObserver','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(B,E,M,D,L,q){"use strict";var e=new E(),i,c,C;
var H=B.extend("HeaderAdapter",{constructor:function(o,A){if(!o||!A){L.error("Cannot initialize: Invalid arguments.");return;}this._oHeader=o;this._oStyledPage=null;this._oTitleInfo=null;this._oSubTitleInfo=null;this._oBackButtonInfo=null;this._oAdaptOptions=A;}});
H.prototype.adapt=function(){var s=this._oAdaptOptions.bStylePage,k=this._oAdaptOptions.bCollapseHeader;if(s){this._toggleStyle("sapF2Adapted",true,true);}this._adaptTitle();this._adaptBackButton();if(k){this._collapseHeader();}return this.getAdaptedContent();};
H.prototype.getAdaptedContent=function(){return{oTitleInfo:this._oTitleInfo,oSubTitleInfo:this._oSubTitleInfo,oBackButtonInfo:this._oBackButtonInfo,oStyledPage:this._oStyledPage};};
H.prototype._adaptTitle=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bMoveTitle!==true){return false;}this._oTitleInfo=this._detectTitle();this._oSubTitleInfo=this._detectSubTitle();var s=!!this._oTitleInfo||!!this._oSubTitleInfo;if(this._oTitleInfo){this._oTitleInfo.oControl.toggleStyleClass("sapF2AdaptedTitle",true);}return s;};
H.prototype._adaptBackButton=function(){if(!H._isAdaptableHeader(this._oHeader)||this._oAdaptOptions.bHideBackButton!==true){return false;}var k,l=false;this._oBackButtonInfo=this._detectBackButton();if(this._oBackButtonInfo){k=this._oBackButtonInfo.oControl.getVisible();this._oBackButtonInfo.oControl.toggleStyleClass("sapF2AdaptedNavigation",k);l=true;}return l;};
H.prototype._toggleStyle=function(s,A,S){var p=this._oHeader.getParent();if(!p){return;}this._oStyledPage=p;if(A===true){p.addStyleClass(s,S);}else if(A===false){p.removeStyleClass(s,S);}else if(A===undefined){p.hasStyleClass(s)?p.removeStyleClass(s,S):p.addStyleClass(s,S);}};
H._isAdaptableHeader=function(o){if(!o||!f(o,"sap/m/Bar")){return false;}var p=o.getParent();return p&&(f(p,"sap/m/Page")||f(p,"sap/m/MessagePage")||f(p,"sap/uxap/ObjectPageHeader"));};
H.prototype._detectTitle=function(){var t;if(H._isAdaptableHeader(this._oHeader)){var m=this._oHeader.getContentMiddle();if(m.length===1&&a(m[0])){var T=m[0];t={id:T.getId(),text:T.getText(),oControl:T,sChangeEventId:"_change",sPropertyName:"text"};}}return t;};
H.prototype._detectSubTitle=function(p){if(f(p,"sap/uxap/ObjectPageHeader")){var o=p.getHeaderTitle();if(o){return{id:o.getId(),text:o.getObjectTitle(),oControl:o,sChangeEventId:"_titleChange",sPropertyName:"objectTitle"};}}};
H.prototype._detectBackButton=function(){var k,o;if(H._isAdaptableHeader(this._oHeader)){k=this._oHeader.getContentLeft();if(k.length>0&&f(k[0],"sap/m/Button")&&(k[0].getType()==="Back"||k[0].getType()==="Up"||k[0].getIcon()==="sap-icon://nav-back")){o=k[0];return{id:o.getId(),oControl:o,sChangeEventId:"_change",sPropertyName:"visible"};}}};
H.prototype._collapseHeader=function(){var t=this._oTitleInfo,k=this._oBackButtonInfo,l,m,n,o,p,r,A;if(H._isAdaptableHeader(this._oHeader)){l=this._oHeader.getContentLeft();m=this._oHeader.getContentMiddle();n=this._oHeader.getContentRight();o=(l.length===1)&&(h(l[0])||k);p=(m.length===1)&&(h(m[0])||t);r=(n.length===1)&&h(n[0]);A=(l.length===0||o)&&(m.length===0||p)&&((n.length===0)||r);this._toggleStyle("sapF2CollapsedHeader",A,true);}};
var F=B.extend("sap.m.Fiori20Adapter",{});
F.attachViewChange=function(l,o){e.attachEvent("adaptedViewChange",l,o);};
F.detachViewChange=function(l,o){e.detachEvent("adaptedViewChange",l,o);};
F.traverse=function(o,A){i={aViewTitles:{},aViewSubTitles:{},aViewBackButtons:{}};c={};C=null;this._doBFS([{oNode:o,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}};
F._doBFS=function(Q){var n=Q.shift();if(!n){return;}var N=n.oNode,A=n.oAdaptOptions,s=A.iSearchDepth;A=this._applyRules(A,N);if(!this._isAdaptationRequired(N,A)||(s<=0)){return;}var I=this._isTopNavigableView(N);if(I){this._setAsCurrentlyAdaptedTopViewId(N.getId());}var o=this._processNode(N,A);var k=this._getNodeChildren(N),l=q.extend({},A,{iSearchDepth:this._updateSearchDepth(s,N)});if(o){var t=!!o.oTitleInfo,m=!!o.oBackButton,p=!!o.oStyledPage;l=q.extend(l,{bMoveTitle:A.bMoveTitle&&!t,bHideBackButton:A.bHideBackButton&&!m,bStylePage:A.bStylePage&&!p});}k.forEach(function(r){if(r){Q.push({oNode:r,oAdaptOptions:l});}});this._doBFS(Q);};
F._processNode=function(o,A){this._attachDefferedAdaptationListeners(o,A);if(H._isAdaptableHeader(o)){return this._adaptHeader(o,A);}if(o.getParent()&&f(o.getParent(),"sap/m/NavContainer")){return this._getCachedViewInfoToMerge(o.getId());}};
F._attachDefferedAdaptationListeners=function(o,A){this._attachAdaptableContentChange(o,A);this._attachNavigablePageChange(o,A);if(f(o,"sap/m/Page")||f(o,"sap/ui/core/mvc/XMLView")){this._observeAddAggregation(o,"content",A);}if(f(o,"sap/m/NavContainer")){this._observeRemoveAggregation(o,"pages",A);}if((A.bLateAdaptation===true)&&f(o,"sap/m/Bar")){this._observeAddAggregation(o,"contentLeft",A,o);this._observeAddAggregation(o,"contentMiddle",A,o);this._observeAddAggregation(o,"contentRight",A,o);}if(f(o,"sap/ui/core/ComponentContainer")){var k=o.getComponentInstance();if(!k&&o.getName()&&!o.getDomRef()){var t=this;var l={onBeforeRendering:function(){o.removeEventDelegate(l);t._doBFS([{oNode:o.getComponentInstance(),oAdaptOptions:A}]);if(t._getCurrentlyAdaptedTopViewId()){t._fireViewChange(t._getCurrentlyAdaptedTopViewId(),A);}}};o.addEventDelegate(l,this);}}};
F._checkHasListener=function(o,s){var k=c[o.getId()];return k&&k[s];};
F._setHasListener=function(o,s,l){var k=c[o.getId()];if(!k){k={};c[o.getId()]=k;}k[s]=l;};
F._attachAdaptableContentChange=function(o,A){if(!o._getAdaptableContent||!q.isFunction(o._getAdaptableContent)){return;}if(this._checkHasListener(o,"_adaptableContentChange")){return;}var O=this._getCurrentlyAdaptedTopViewId();var k=function(l){var m=l.getParameter("adaptableContent");this._setAsCurrentlyAdaptedTopViewId(O);this._doBFS([{oNode:m,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);o.attachEvent("_adaptableContentChange",k);this._setHasListener(o,"_adaptableContentChange",k);};
F._attachNavigablePageChange=function(o,A){if(!f(o,"sap/m/NavContainer")){return;}if(this._checkHasListener(o,"navigate")){return;}var O=function(k){var n=k.getParameter("to");A=this._applyRules(A,n);this._doBFS([{oNode:n,oAdaptOptions:A}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),A);}}.bind(this);o.attachNavigate(O);this._setHasListener(o,"navigate",O);};
F._observeAddAggregation=function(o,A,k,l){if(this._checkHasListener(o,A)){return;}var O=this._getCurrentlyAdaptedTopViewId(),m=function(p){var s=p.mutation,r=p.object;if((s==="add")||(s==="insert")){this._setAsCurrentlyAdaptedTopViewId(O);this._doBFS([{oNode:l?l:r,oAdaptOptions:k}]);if(this._getCurrentlyAdaptedTopViewId()){this._fireViewChange(this._getCurrentlyAdaptedTopViewId(),k);}}}.bind(this),n=new M(m);n.observe(o,{aggregations:[A]});this._setHasListener(o,A,n);};
F._observeRemoveAggregation=function(o,A,k){if(this._checkHasListener(o,A)){return;}var O=new M(this._onRemoveAggregation.bind(this));O.observe(o,{aggregations:[A]});this._setHasListener(o,A,O);};
F._removeFromMergeInfo=function(m,o){Object.keys(m).forEach(function(k){var l=m[k];if((l.oControl===o)||j(l.oControl,o)){this._detachAllListeners(l.oControl);delete m[k];}},this);};
F._detachAllListeners=function(o){var k=c[o.getId()];if(!k){return;}Object.keys(k).forEach(function(s){var l=k[s];if(l instanceof M){l.disconnect();}else{o.detachEvent(s,l);}delete k[s];});};
F._onRemoveAggregation=function(o){var m=o.mutation,r;if(m==="remove"){r=o.child;this._detachAllListeners(r);this._removeFromMergeInfo(i.aViewTitles,r);this._removeFromMergeInfo(i.aViewSubTitles,r);this._removeFromMergeInfo(i.aViewBackButtons,r);}};
F._getNodeChildren=function(o){if(o._getAdaptableContent&&q.isFunction(o._getAdaptableContent)){var k=[o._getAdaptableContent()];if(f(o,"sap/m/Page")){k=k.concat(o.getContent());}return k;}if(f(o,"sap/m/SplitContainer")){return[].concat(o.getAggregation("_navMaster"),o.getAggregation("_navDetail"));}if(f(o,"sap/uxap/ObjectPageLayout")){return[o.getHeaderTitle()];}if(f(o,"sap/ui/core/ComponentContainer")){return[o.getComponentInstance()];}if(f(o,"sap/ui/core/UIComponent")){return[o.getAggregation("rootControl")];}return o.findAggregatedObjects(false,g);};
F._updateSearchDepth=function(s,o){if(f(o,"sap/ui/core/mvc/View")||f(o,"sap/ui/core/Component")||f(o,"sap/ui/core/ComponentContainer")){return s;}return s-1;};
F._getTotalCachedInfoToMerge=function(v){var V=sap.ui.getCore().byId(v),o=this._getCachedViewInfoToMerge(v),k,l,s,S,m,p,n;if(!D.system.phone&&this._isTopSplitContainerSubView(V)){p=V.getParent();m=p&&p.getParent();if(m){k=m._oMasterNav&&(m._oMasterNav.getId()===p.getId());l=m._oDetailNav&&(m._oDetailNav.getId()===p.getId());}}if(k){s=m.getCurrentDetailPage();S=s&&s.getId();n=this._getCachedViewInfoToMerge(S);o=this._mergeSplitViewInfos(o,n);}if(l){s=m.getCurrentMasterPage();S=s&&s.getId();n=this._getCachedViewInfoToMerge(S);o=this._mergeSplitViewInfos(n,o);}o.sViewId=(k||l)?m.getId():v;return o;};
F._isTopSplitContainerSubView=function(o){var p=o&&o.getParent();return this._isTopmostNavContainer(p)&&f(p.getParent(),"sap/m/SplitContainer");};
F._mergeSplitViewInfos=function(m,o){q.each(m,function(k,v){m[k]=v||o[k];});return m;};
F._getCachedViewInfoToMerge=function(v){var o=(i.aViewBackButtons[v])?i.aViewBackButtons[v].oControl:undefined;return{oTitleInfo:i.aViewTitles[v],oSubTitleInfo:i.aViewSubTitles[v],oBackButton:o};};
F._applyRules=function(A,o){var p=o.getParent();if(f(p,"sap/m/SplitContainer")){var I=D.system.phone,m=A.bMoveTitle,k=A.bHideBackButton;if(m){m=I;}if(k&&!D.system.phone){k='initialPage';}return q.extend({},A,{bMoveTitle:m,bHideBackButton:k});}if(f(p,"sap/m/NavContainer")){if(A.bHideBackButton==='initialPage'){var l=p._getActualInitialPage()&&(p._getActualInitialPage().getId()===o.getId());return q.extend({},A,{bHideBackButton:l});}}if((A.bMoveTitle===false)||(A.bHideBackButton===false)){return q.extend({},A,{bCollapseHeader:false});}return A;};
F._getCurrentlyAdaptedTopViewId=function(){return C;};
F._setAsCurrentlyAdaptedTopViewId=function(v){C=v;};
F._isTopNavigableView=function(n){var p=n.getParent();return p&&this._isTopmostNavContainer(p);};
F._isTopmostNavContainer=function(o){var k,n=o;while(n){if(f(n,"sap/m/NavContainer")){k=n;}n=n.getParent();}return k&&(k.getId()===o.getId());};
F._adaptHeader=function(o,A){if(!o||!A){return;}var k=new H(o,A),l=k.adapt();var t=this._getCurrentlyAdaptedTopViewId();if(l.oTitleInfo){i.aViewTitles[t]=l.oTitleInfo;this._registerTextChangeListener(i.aViewTitles,t,A);}if(l.oSubTitleInfo){i.aViewSubTitles[t]=l.oSubTitleInfo;this._registerTextChangeListener(i.aViewSubTitles,t,A);}if(l.oBackButtonInfo){if(l.oBackButtonInfo.oControl.getVisible()){i.aViewBackButtons[t]=l.oBackButtonInfo;}this._registerVisibilityChangeListener(l.oBackButtonInfo,i.aViewBackButtons,t,A);}return l;};
F._registerTextChangeListener=function(t,v,A){var T=t[v];if(T&&T.oControl&&T.sChangeEventId){if(this._checkHasListener(T.oControl,T.sChangeEventId)){return;}var k=function(o){var T=t[v];if(o.getParameter("name")!==T.sPropertyName){return;}T.text=o.getParameter("newValue");this._fireViewChange(v,A);}.bind(this);T.oControl.attachEvent(T.sChangeEventId,k);this._setHasListener(T.oControl,T.sChangeEventId,k);}};
F._registerVisibilityChangeListener=function(o,k,v,A){var V;if(o&&o.oControl&&o.sChangeEventId){if(this._checkHasListener(o.oControl,o.sChangeEventId)){return;}var l=function(m){if(m.getParameter("name")!==o.sPropertyName){return;}V=m.getParameter("newValue");if(!V){q.each(k,function(I,n){if(n.oControl.getId()===o.oControl.getId()){delete k[I];}});}var p=o.oControl.getParent();if(H._isAdaptableHeader(p)){F._adaptHeader(p,A);this._fireViewChange(v,A);}}.bind(this);o.oControl.attachEvent(o.sChangeEventId,l);this._setHasListener(o.oControl,o.sChangeEventId,l);}};
F._fireViewChange=function(v,A){var t=this._getTotalCachedInfoToMerge(v);t.oAdaptOptions=A;e.fireEvent("adaptedViewChange",t);};
F._isAdaptationRequired=function(n,A){if(!n||this._isNonAdaptableControl(n)){return false;}for(var o in A){if(A.hasOwnProperty(o)&&((A[o]===true)||(A[o]==="initialPage"))){return true;}}return false;};
F._isNonAdaptableControl=function(o){return b(o);};
function a(o){return d(o,["sap/m/Label","sap/m/Text","sap/m/Title"]);}
function b(o){return d(o,["sap/m/List","sap/m/Table","sap/ui/table/Table","sap/ui/table/TreeTable"]);}
function d(o,t){if(!o||!t){return;}return t.some(function(T){return f(o,T);});}
function f(o,t){var T=sap.ui.require(t);return T&&(o instanceof T);}
function g(o){return o&&(o.sParentAggregationName!=="dependents");}
function h(o){return o&&(typeof o.getVisible==="function")&&(o.getVisible()===false);}
function j(o,r){var p=o&&o.getParent();while(p){if(p===r){return true;}p=p.getParent();}return false;}
return F;});
sap.ui.predefine('sap/m/FlexBox',['./FlexBoxStylingHelper','./FlexItemData','./library','sap/ui/core/Control','sap/ui/core/InvisibleRenderer','./FlexBoxRenderer','sap/ui/thirdparty/jquery'],function(F,a,l,C,I,b,q){"use strict";var B=l.BackgroundDesign;var c=l.FlexAlignContent;var d=l.FlexWrap;var e=l.FlexAlignItems;var f=l.FlexJustifyContent;var g=l.FlexRendertype;var h=l.FlexDirection;
var j=C.extend("sap.m.FlexBox",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},displayInline:{type:"boolean",group:"Appearance",defaultValue:false},direction:{type:"sap.m.FlexDirection",group:"Appearance",defaultValue:h.Row},fitContainer:{type:"boolean",group:"Appearance",defaultValue:false},renderType:{type:"sap.m.FlexRendertype",group:"Misc",defaultValue:g.Div},justifyContent:{type:"sap.m.FlexJustifyContent",group:"Appearance",defaultValue:f.Start},alignItems:{type:"sap.m.FlexAlignItems",group:"Appearance",defaultValue:e.Stretch},wrap:{type:"sap.m.FlexWrap",group:"Appearance",defaultValue:d.NoWrap},alignContent:{type:"sap.m.FlexAlignContent",group:"Appearance",defaultValue:c.Stretch},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Transparent}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Control",multiple:true,singularName:"item"}},designtime:"sap/m/designtime/FlexBox.designtime",dnd:{draggable:false,droppable:true}}});
j.prototype.init=function(){this._oItemDelegate={onAfterRendering:this._onAfterItemRendering};};
j.prototype.addItem=function(i){this.addAggregation("items",i);this._onItemInserted(i);return this;};
j.prototype.insertItem=function(i,k){this.insertAggregation("items",i,k);this._onItemInserted(i);return this;};
j.prototype.removeItem=function(i){var o=this.removeAggregation("items",i);this._onItemRemoved(o);return o;};
j.prototype.removeAllItems=function(){var k=this.getItems();for(var i=0;i<k.length;i++){this._onItemRemoved(k[i]);}return this.removeAllAggregation("items");};
j.prototype._onItemInserted=function(i){if(i&&!(i instanceof j)){i.attachEvent("_change",this._onItemChange,this);if(this.getRenderType()===g.Bare){i.addEventDelegate(this._oItemDelegate,i);}}};
j.prototype._onItemRemoved=function(i){if(i&&!(i instanceof j)){i.detachEvent("_change",this._onItemChange,this);if(this.getRenderType()===g.Bare){i.removeEventDelegate(this._oItemDelegate,i);}}};
j.prototype._onItemChange=function(o){if(o.getParameter("name")!=="visible"||(this.getRenderType()!==g.List&&this.getRenderType()!==g.Div)){return;}var i=sap.ui.getCore().byId(o.getParameter("id")),$=null;if(i.getLayoutData()){$=q(document.getElementById(i.getLayoutData().getId()));}else{$=q(document.getElementById(I.createInvisiblePlaceholderId(i))).parent();}if(o.getParameter("newValue")){$.removeClass("sapUiHiddenPlaceholder").removeAttr("aria-hidden");}else{$.addClass("sapUiHiddenPlaceholder").attr("aria-hidden","true");}};
j.prototype._onAfterItemRendering=function(){var L=this.getLayoutData();if(L instanceof a){F.setFlexItemStyles(null,L);}};
j.prototype.setRenderType=function(v){var o=this.getRenderType(),i=this.getItems();if(v===o){return this;}this.setProperty("renderType",v);if(o==="Bare"){i.forEach(this._onItemRemoved,this);}if(v==="Bare"){i.forEach(this._onItemInserted,this);}return this;};
j.prototype.getAccessibilityInfo=function(){return{children:this.getItems()};};
return j;});
sap.ui.predefine('sap/m/FlexBoxCssPropertyMap',[],function(){"use strict";var F={'specie10':{'order':{'<number>':{'flex-order':'<number>'}},'flex-grow':{'<number>':{'flex-positive':'<number>','flex-preferred-size':'auto'}},'flex-shrink':{'<number>':{'flex-negative':'<number>'}},'flex-basis':{'<number>':{'flex-preferred-size':'<number>'}}}};return F;},true);
sap.ui.predefine('sap/m/FlexBoxRenderer',['./FlexBoxStylingHelper','sap/m/library',"sap/base/Log","sap/m/FlexItemData"],function(F,l,L,a){"use strict";var b=l.FlexDirection;var c=l.FlexRendertype;var d={apiVersion:2};
d.render=function(r,f){r.openStart(f.getRenderType()===c.List?"ul":"div",f);var p=f.getParent();if(p&&p.isA("sap.m.FlexBox")){if(!f.hasStyleClass("sapMFlexItem")){r.class("sapMFlexItem");}var o=f.getLayoutData();if(o instanceof a){F.setFlexItemStyles(r,o);}}else if(f.getFitContainer()){r.class("sapMFlexBoxFit");}r.class("sapMFlexBox");if(f.getDisplayInline()){r.class("sapMFlexBoxInline");}if(f.getDirection()===b.Column||f.getDirection()===b.ColumnReverse){r.class("sapMVBox");}else{r.class("sapMHBox");}if(f.getDirection()===b.RowReverse||f.getDirection()===b.ColumnReverse){r.class("sapMFlexBoxReverse");}r.class("sapMFlexBoxJustify"+f.getJustifyContent());r.class("sapMFlexBoxAlignItems"+f.getAlignItems());r.class("sapMFlexBoxWrap"+f.getWrap());r.class("sapMFlexBoxAlignContent"+f.getAlignContent());var B="sapMFlexBoxBG"+f.getBackgroundDesign();if(!f.hasStyleClass(B)){r.class(B);}r.style("height",f.getHeight());r.style("width",f.getWidth());var t=f.getTooltip_AsString();if(t){r.attr("title",t);}r.openEnd();d.renderItems(f,r);if(f.getRenderType()===c.List){r.close("ul");}else{r.close("div");}};
d.renderItems=function(f,r){var C=f.getItems(),w='';for(var i=0;i<C.length;i++){if(C[i].isA('sap.m.FlexBox')||f.getRenderType()===c.Bare){w="";}else if(f.getRenderType()===c.List){w="li";}else{w="div";}d.renderItem(C[i],w,r);}};
d.renderItem=function(i,w,r){var o=i.getLayoutData();if(w&&!o){i.setAggregation("layoutData",new a(),true);o=i.getLayoutData();}if(!(o instanceof a)){if(o){L.warning(o+" set on "+i+" is not of type sap.m.FlexItemData");}if(w){r.openStart(w);}}else{if(w){r.openStart(w,o.getId());}if(o.getStyleClass()){d.addItemClass(o.getStyleClass(),i,w,r);}d.addItemClass("sapMFlexItemAlign"+o.getAlignSelf(),i,w,r);d.addItemClass("sapMFlexBoxBG"+o.getBackgroundDesign(),i,w,r);if(w){F.setFlexItemStyles(r,o);}}d.addItemClass("sapMFlexItem",i,w,r);if(w){if(i.isA("sap.m.ScrollContainer")){r.class("sapMFlexBoxScroll");}if(!i.getVisible()){r.class("sapUiHiddenPlaceholder");}r.openEnd();}r.renderControl(i);if(w){r.close(w);}};
d.addItemClass=function(C,i,w,r){if(w){r.class(C);}else{i.addStyleClass(C);}};
return d;},true);
sap.ui.predefine('sap/m/FlexBoxStylingHelper',['./FlexBoxCssPropertyMap','sap/ui/Device'],function(F,D){"use strict";var a={};
a.setFlexItemStyles=function(r,l){r=r||null;var o=''+l.getOrder(),g=''+l.getGrowFactor(),s=''+l.getShrinkFactor(),b=l.getBaseSize().toLowerCase(),m=l.getMinHeight(),M=l.getMaxHeight(),c=l.getMinWidth(),d=l.getMaxWidth();if(typeof o!=='undefined'){a.setStyle(r,l,"order",o);}if(typeof g!=='undefined'){a.setStyle(r,l,"flex-grow",g);}if(typeof s!=='undefined'){a.setStyle(r,l,"flex-shrink",s);}if(typeof b!=='undefined'){a.setStyle(r,l,"flex-basis",b);}if(typeof m!=='undefined'){a.setStyle(r,l,"min-height",m);}if(typeof M!=='undefined'){a.setStyle(r,l,"max-height",M);}if(typeof c!=='undefined'){a.setStyle(r,l,"min-width",c);}if(typeof d!=='undefined'){a.setStyle(r,l,"max-width",d);}};
a.setStyle=function(r,l,p,v){if(typeof(v)==="string"){v=v.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase();}else if(typeof(v)==="number"){v=v.toString();}a.writeStyle(r,l,p,v);};
a.writeStyle=function(r,l,p,v){if(D.browser.internet_explorer&&(p==="flex-basis"||p==="flex-preferred-size")){if(l.getParent()){if(l.getParent().getParent().getDirection().indexOf("Row")>-1){p="width";}else{p="height";}}}if(r){if(v==="0"||v){r.style(p,v);}}else{if(l.$().length){if(v!=="0"&&!v){l.$().css(p,null);}else{l.$().css(p,v);}}else{if(l.getParent()){if(v!=="0"&&!v){l.getParent().$().css(p,null);}else{l.getParent().$().css(p,v);}}}}};
return a;},true);
sap.ui.predefine('sap/m/FlexItemData',['./FlexBoxStylingHelper','./library','sap/ui/core/LayoutData'],function(F,l,L){"use strict";var B=l.BackgroundDesign;var a=l.FlexAlignSelf;
var b=L.extend("sap.m.FlexItemData",{metadata:{library:"sap.m",properties:{alignSelf:{type:"sap.m.FlexAlignSelf",group:"Misc",defaultValue:a.Auto},order:{type:"int",group:"Misc",defaultValue:0},growFactor:{type:"float",group:"Misc",defaultValue:0},shrinkFactor:{type:"float",group:"Misc",defaultValue:1},baseSize:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:"auto"},minHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},maxHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},styleClass:{type:"string",group:"Misc",defaultValue:''},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Transparent}}}});
b.prototype.setAlignSelf=function(v){var o=this.getAlignSelf();this.setProperty("alignSelf",v,true);this.$().removeClass("sapMFlexItemAlign"+o).addClass("sapMFlexItemAlign"+this.getAlignSelf());return this;};
b.prototype.setOrder=function(v){this.setProperty("order",v,true);F.setStyle(null,this,"order",this.getOrder());return this;};
b.prototype.setGrowFactor=function(v){this.setProperty("growFactor",v,true);F.setStyle(null,this,"flex-grow",this.getGrowFactor());return this;};
b.prototype.setShrinkFactor=function(v){this.setProperty("shrinkFactor",v,true);F.setStyle(null,this,"flex-shrink",this.getShrinkFactor());return this;};
b.prototype.setBaseSize=function(v){this.setProperty("baseSize",v,true);F.setStyle(null,this,"flex-basis",this.getBaseSize());return this;};
b.prototype.setMinHeight=function(v){this.setProperty("minHeight",v,true);this.$().css("min-height",this.getMinHeight());return this;};
b.prototype.setMaxHeight=function(v){this.setProperty("maxHeight",v,true);this.$().css("max-height",this.getMaxHeight());return this;};
b.prototype.setMinWidth=function(v){this.setProperty("minWidth",v,true);this.$().css("min-width",this.getMinWidth());return this;};
b.prototype.setMaxWidth=function(v){this.setProperty("maxWidth",v,true);this.$().css("max-width",this.getMaxWidth());return this;};
b.prototype.setBackgroundDesign=function(v){var o=this.getBackgroundDesign();this.setProperty("backgroundDesign",v,true);this.$().removeClass("sapMFlexBoxBG"+o).addClass("sapMFlexBoxBG"+this.getBackgroundDesign());return this;};
b.prototype.setStyleClass=function(v){var o=this.getStyleClass();this.setProperty("styleClass",v,true);this.$().removeClass(o).addClass(this.getStyleClass());return this;};
b.prototype.getDomRef=function(s){var p,i=L.prototype.getDomRef.call(this,s);if(i){return i;}p=this.getParent();if(!p){return null;}return p.getDomRef(s);};
return b;});
sap.ui.predefine('sap/m/FormattedText',['./library','sap/ui/core/Control','./FormattedTextAnchorGenerator','./FormattedTextRenderer',"sap/base/Log","sap/base/security/URLWhitelist","sap/base/security/sanitizeHTML"],function(l,C,F,a,L,U,s){"use strict";var b=l.LinkConversion;
var c=C.extend("sap.m.FormattedText",{metadata:{library:"sap.m",properties:{htmlText:{type:"string",group:"Misc",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},convertLinksToAnchorTags:{type:"sap.m.LinkConversion",group:"Behavior",defaultValue:b.None},convertedLinksDefaultTarget:{type:"string",group:"Behavior",defaultValue:"_blank"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}},aggregations:{controls:{type:"sap.m.Link",multiple:true,singularName:"control"}}}});
var _={ATTRIBS:{'style':1,'class':1,'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'abbr':1,'blockquote':1,'br':1,'cite':1,'code':1,'em':1,'h1':{cssClass:'sapMTitle sapMTitleStyleH1'},'h2':{cssClass:'sapMTitle sapMTitleStyleH2'},'h3':{cssClass:'sapMTitle sapMTitleStyleH3'},'h4':{cssClass:'sapMTitle sapMTitleStyleH4'},'h5':{cssClass:'sapMTitle sapMTitleStyleH5'},'h6':{cssClass:'sapMTitle sapMTitleStyleH6'},'p':1,'pre':1,'strong':1,'span':1,'u':1,'dl':1,'dt':1,'dd':1,'ol':1,'ul':1,'li':1}},d={ATTRIBS:{'a::href':1,'a::target':1},ELEMENTS:{'a':{cssClass:'sapMLnk'},'em':1,'strong':1,'u':1}};c.prototype._renderingRules=_;
c.prototype.init=function(){};
function S(t,f){var w;var g,v,h=t==="a";var j=this._renderingRules.ELEMENTS[t].cssClass||"";for(var i=0;i<f.length;i+=2){g=f[i];v=f[i+1];if(!this._renderingRules.ATTRIBS[g]&&!this._renderingRules.ATTRIBS[t+"::"+g]){w='FormattedText: <'+t+'> with attribute ['+g+'="'+v+'"] is not allowed';L.warning(w,this);f[i+1]=null;continue;}if(g=="href"){if(!U.validate(v)){L.warning("FormattedText: incorrect href attribute:"+v,this);f[i+1]="#";h=false;}}if(g=="target"){h=false;}if(j&&g.toLowerCase()=="class"){f[i+1]=j+" "+v;j="";}}if(h){f.push("target");f.push("_blank");}if(j){f.push("class");f.push(j);}return f;}
function p(t,f){if(this._renderingRules.ELEMENTS[t]){return S.call(this,t,f);}else{var w='<'+t+'> is not allowed';L.warning(w,this);}}
function e(t){return s(t,{tagPolicy:p.bind(this),uriRewriter:function(u){if(U.validate(u)){return u;}}});}
function o(E){var n=window.open();n.opener=null;n.location=E.currentTarget.href;E.preventDefault();}
c.prototype.onAfterRendering=function(){this.$().find('a[target="_blank"]').on("click",o);};
c.prototype.onBeforeRendering=function(){this.$().find('a[target="_blank"]').off("click",o);};
c.prototype._getDisplayHtml=function(){var t=this.getHtmlText(),A=this.getConvertLinksToAnchorTags();if(A===l.LinkConversion.None){return t;}t=F.generateAnchors(t,A,this.getConvertedLinksDefaultTarget());return e.call(this,t);};
c.prototype.setHtmlText=function(t){return this.setProperty("htmlText",e.call(this,t));};
c.prototype._setUseLimitedRenderingRules=function(f){this._renderingRules=f?d:_;};
return c;});
sap.ui.predefine('sap/m/FormattedTextAnchorGenerator',["sap/ui/base/Object","sap/m/library","sap/base/security/URLWhitelist"],function(B,l,U){"use strict";var L=l.LinkConversion;
var A=B.extend("sap.m.FormattedTextAnchorGenerator",{getInterface:function(){return this;}});
var c=/(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;()$]*[-A-Z0-9+&@#\/%=~_|])/gim;var W=/(www\.[^\s><]+(\b|$))/gim;var d="//";var D=/<(?:"[^"]*"['"]*|'[^']*'['"]*|[^'">])+(?!\/\s\*)>/gim;var E=/<a[^>]*>([^<]+)<\/a>/gim;var e=[D,E];
A.generateAnchors=function(t,s,T){if(s===L.ProtocolOnly){t=A._createAnchors(t,c,T);}if(s===L.All){t=A._createAnchors(t,c,T);t=A._createAnchors(t,W,T,d);}return t;};
A._createPositionObject=function(i,a){return{iStartPos:i,iEndPos:i+a};};
A._isNested=function(f,s){return f.iStartPos<s.iStartPos&&f.iEndPos>s.iEndPos;};
A._isAllowed=function(b,C){return b.some(function(o){return A._isNested(o,C);});};
A._shouldBeProcessed=function(u,C,b){return U.validate(u)&&!A._isAllowed(b,C);};
A._scanForEntitiesToSkip=function(r,t){var a=[],C;while((C=r.exec(t))!==null){a.push(A._createPositionObject(C.index,C[0].length));}return a;};
A._getEntitiesToSkipWhileSearchingForLinks=function(t){return e.map(function(s){return A._scanForEntitiesToSkip(s,t);}).reduce(function(a,b){return a.concat(b);});};
A._createAnchors=function(t,r,T,p){var a=A._getEntitiesToSkipWhileSearchingForLinks(t),C;p=p||'';C=function(P){var o=A._createPositionObject(arguments[3],P.length);if(!A._shouldBeProcessed(P,o,a)){return P;}return"<a href=\""+p+P+"\" target=\""+T+"\">"+P+"</a>";};return t.replace(r,C);};
return A;});
sap.ui.predefine('sap/m/FormattedTextRenderer',["sap/base/Log"],function(L){"use strict";var F={apiVersion:2};
F.render=function(r,c){var w=c.getWidth(),h=c.getHeight(),C=c.getAggregation("controls"),t=c._getDisplayHtml(),R=[],n='',s=0;r.openStart("div",c);r.class("sapMFT");if(w){r.class("sapMFTOverflowWidth");}if(h){r.class("sapMFTOverflowHeight");}if(c.getTooltip_AsString()){r.attr("title",c.getTooltip_AsString());}r.style("width",w||null);r.style("height",h||null);r.openEnd();while(t!==''&&t!==n){n=t.replace(/(?:\%\%(\d+))/,_);}if(t!==''){try{r.unsafeHtml(t);}catch(e){r.text(t);}}r.close("div");function _(m,i,p){var M=m.length;try{r.unsafeHtml(t.substr(0,p));}catch(e){r.text(t.substr(0,p));}s+=p;if(C&&C[i]!==undefined){if(R[i]===undefined){r.renderControl(C[i]);R[i]=s;}else{L.error("Control with index '"+i+"' ("+m+", htmlText@"+s+") is already rendered (htmlText@"+R[i]+")!",'sap.m.FormattedText:',c.getId());}}else{r.text(m);L.error("Missing control for placeholder '"+m+"' (htmlText@"+s+")!",'sap.m.FormattedText:',c.getId());}t=t.substr(p+M);s+=M;}};
return F;},true);
sap.ui.predefine('sap/m/GenericTag',["sap/ui/core/Control","sap/ui/events/KeyCodes",'./library',"sap/ui/core/library","sap/ui/core/Icon","./GenericTagRenderer"],function(C,K,l,c,I){"use strict";var G=l.GenericTagDesign,a=l.GenericTagValueState,V=c.ValueState,b={Error:"sap-icon://message-error",Warning:"sap-icon://message-warning",Success:"sap-icon://message-success",Information:"sap-icon://hint"};
var d=C.extend("sap.m.GenericTag",{metadata:{library:"sap.m",interfaces:["sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent"],properties:{text:{type:"string",defaultValue:""},status:{type:"sap.ui.core.ValueState",defaultValue:V.None},design:{type:"sap.m.GenericTagDesign",defaultValue:G.Full},valueState:{type:"sap.m.GenericTagValueState",defaultValue:a.None}},defaultAggregation:"value",aggregations:{value:{type:"sap.m.ObjectNumber",multiple:false},_statusIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_errorIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{press:{}}}});
d.CLASSNAME_OVERFLOW_TOOLBAR="sapMGenericTagOverflowToolbar";
d.prototype.setStatus=function(s){this.setProperty("status",s,false);this._getStatusIcon().setSrc(s!==V.None?b[s]:null);return this;};
d.prototype.setValue=function(v){this.setAggregation("value",v);this.fireEvent("_valueChanged");return this;};
d.prototype._getStatusIcon=function(){var s=this.getAggregation("_statusIcon");if(!s){s=new I(this.getId()+"-statusIcon").addStyleClass("sapMGenericTagIcon");this.setAggregation("_statusIcon",s);}return s;};
d.prototype._getErrorIcon=function(){var e=this.getAggregation("_errorIcon");if(!e){e=new I(this.getId()+"-errorIcon",{src:b[V.Error]}).addStyleClass("sapMGenericTagErrorIcon");this.setAggregation("_errorIcon",e);}return e;};
d.prototype.ontouchstart=function(){this._toggleActiveGenericTag(true);};
d.prototype.ontouchend=function(){this._toggleActiveGenericTag(false);};
d.prototype.ontouchcancel=function(){this._toggleActiveGenericTag(false);};
d.prototype.onkeydown=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._toggleActiveGenericTag(true);}if(e.which===K.SHIFT||e.which===K.ESCAPE){this._bShouldInterupt=this._bSpacePressed;}if(e.which===K.SPACE){this._bSpacePressed=true;e.preventDefault();}if(e.which===K.ENTER){this.firePress();}};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE||e.which===K.ENTER){this._toggleActiveGenericTag(false);}if(e.which===K.SPACE){if(!this._bShouldInterupt){this.firePress();}this._bShouldInterupt=false;this._bSpacePressed=false;}};
d.prototype.onclick=function(){this.firePress();};
d.prototype.onfocusout=function(){this._toggleActiveGenericTag(false);};
d.prototype._toggleActiveGenericTag=function(t){this.toggleStyleClass("sapMGenericTagActive",t);};
d.prototype._onBeforeEnterOverflow=function(o){o.addStyleClass(d.CLASSNAME_OVERFLOW_TOOLBAR);};
d.prototype._onAfterExitOverflow=function(o){o.removeStyleClass(d.CLASSNAME_OVERFLOW_TOOLBAR);};
d.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,invalidationEvents:["_valueChanged"]};o.onBeforeEnterOverflow=this._onBeforeEnterOverflow;o.onAfterExitOverflow=this._onAfterExitOverflow;return o;};
return d;});
sap.ui.predefine('sap/m/GenericTagRenderer',["./library","sap/ui/core/library"],function(l,c){"use strict";var G=l.GenericTagDesign,a=l.GenericTagValueState,V=c.ValueState,C=sap.ui.getCore(),b={apiVersion:2};
b.render=function(r,o){var L=this._getAriaLabelledBy(o),R=C.getLibraryResourceBundle("sap.m"),t=o.getTooltip_AsString();r.openStart("div",o);r.class("sapMGenericTag");r.attr("tabindex",0);r.class("sapMGenericTag"+o.getStatus());r.accessibilityState(o,{role:"button",roledescription:R.getText("GENERICTAG_ROLEDESCRIPTION"),labelledby:L.join(" ")});if(t){r.attr("title",t);}r.openEnd();r.openStart("div");r.class("sapMGenericTagWrap");r.openEnd();this.renderElements(r,o);r.close("div");r.close("div");};
b.renderElements=function(r,o){var s=o.getDesign()===G.StatusIconHidden,S=o.getValueState()===a.Error,v=o.getValue();if(!s&&o.getStatus()!==V.None){r.renderControl(o._getStatusIcon());}this.renderText(r,o);if(S){r.renderControl(o._getErrorIcon());}else if(v){r.renderControl(v.addStyleClass("sapMGenericTagValue"));}this.renderHiddenARIAElement(r,o);};
b.renderText=function(r,o){r.openStart("span",o.getId()+"-text");r.class("sapMGenericTagText");r.openEnd();r.text(o.getText());r.close("span");};
b.renderHiddenARIAElement=function(r,o){if(o.getStatus()===V.None){return;}r.openStart("span",o.getId()+"-status");r.class("sapUiInvisibleText");r.attr("aria-hidden","true");r.openEnd();r.text(this._getGenericTagStatusText(o));r.close("span");};
b._getAriaLabelledBy=function(o){var L=[],i=o.getId(),t=this._getTagValueId(o),T=this._getTagValueState(o);if(o.getStatus()!==V.None){L.push(i+"-status");}L.push(i+"-text");L.push(o.getValueState()===a.Error?i+"-errorIcon":t);if(T&&T!==V.None){L.push(t+'-state');}return L;};
b._getGenericTagStatusText=function(o){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),A;switch(o.getStatus()){case V.Error:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_ERROR");break;case V.Warning:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_WARNING");break;case V.Success:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_SUCCESS");break;case V.Information:A=r.getText("GENERICTAG_ARIA_VALUE_STATE_INFORMATION");break;default:}return A;};
b._getTagValueId=function(o){var v=o.getValue();return v?v.getId():"";};
b._getTagValueState=function(o){var v=o.getValue();return v?v.getState():"";};
return b;},true);
sap.ui.predefine('sap/m/GenericTile',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/core/HTML','sap/ui/core/Icon','sap/ui/core/IconPool','sap/m/Button','sap/m/GenericTileRenderer','sap/m/GenericTileLineModeRenderer','sap/ui/Device','sap/ui/core/ResizeHandler',"sap/base/strings/camelize","sap/base/util/deepEqual","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery"],function(l,C,T,H,I,a,B,G,L,D,R,c,d,P,q){"use strict";var b=l.GenericTileScope,e=l.LoadState,F=l.FrameType,S=l.Size,f=l.GenericTileMode,g=l.TileSizeBehavior,W=l.WrappingType;var h="GenericTileDeviceSet";var j={};
var m=C.extend("sap.m.GenericTile",{
metadata:{library:"sap.m",properties:{mode:{type:"sap.m.GenericTileMode",group:"Appearance",defaultValue:f.ContentMode},header:{type:"string",group:"Appearance",defaultValue:null},subheader:{type:"string",group:"Appearance",defaultValue:null},failedText:{type:"string",group:"Appearance",defaultValue:null},size:{type:"sap.m.Size",group:"Misc",defaultValue:S.Auto},frameType:{type:"sap.m.FrameType",group:"Misc",defaultValue:F.OneByOne},backgroundImage:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},headerImage:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},state:{type:"sap.m.LoadState",group:"Misc",defaultValue:e.Loaded},imageDescription:{type:"string",group:"Accessibility",defaultValue:null},scope:{type:"sap.m.GenericTileScope",group:"Misc",defaultValue:b.Display},sizeBehavior:{type:"sap.m.TileSizeBehavior",defaultValue:g.Responsive},ariaLabel:{type:"string",group:"Accessibility",defaultValue:null},url:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},additionalTooltip:{type:"string",group:"Accessibility",defaultValue:null}},defaultAggregation:"tileContent",aggregations:{tileContent:{type:"sap.m.TileContent",multiple:true,bindable:"bindable"},icon:{type:"sap.ui.core.Control",multiple:false},_titleText:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_failedMessageText:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{press:{parameters:{scope:{type:"sap.m.GenericTileScope"},action:{type:"string"},domRef:{type:"any"}}}}},
renderer:function(r,o){if(o.getMode()===l.GenericTileMode.LineMode){L.render(r,o);}else{G.render(r,o);}}
});
m._Action={Press:"Press",Remove:"Remove"};m.LINEMODE_SIBLING_PROPERTIES=["state","subheader","header","scope"];
m.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!D.media.hasRangeSet(h)){D.media.initRangeSet(h,[450],"px",["small","large"]);}this._oTitle=new T(this.getId()+"-title");this._oTitle.addStyleClass("sapMGTTitle");this._oTitle.cacheLineHeight=false;this.setAggregation("_titleText",this._oTitle,true);this._oSubTitle=new T(this.getId()+"-subTitle");this._oSubTitle.cacheLineHeight=false;this.addDependent(this._oSubTitle);this._sFailedToLoad=this._oRb.getText("INFOTILE_CANNOT_LOAD_TILE");this._sLoading=this._oRb.getText("INFOTILE_LOADING");this._oFailedText=new T(this.getId()+"-failed-txt",{maxLines:2});this._oFailedText.cacheLineHeight=false;this._oFailedText.addStyleClass("sapMGTFailed");this.setAggregation("_failedMessageText",this._oFailedText,true);this._oWarningIcon=new I(this.getId()+"-warn-icon",{src:"sap-icon://notification",size:"1.375rem"});this._oWarningIcon.addStyleClass("sapMGTFtrFldIcnMrk");this._oBusy=new H(this.getId()+"-overlay");this._oBusy.setBusyIndicatorDelay(0);this._bTilePress=true;this._bThemeApplied=true;if(!sap.ui.getCore().isInitialized()){this._bThemeApplied=false;sap.ui.getCore().attachInit(this._handleCoreInitialized.bind(this));}else{this._handleCoreInitialized();}};
m.prototype.setWrappingType=function(w){this.setProperty("wrappingType",w,true);this._oTitle.setWrappingType(w);this._oFailedText.setWrappingType(w);this._oSubTitle.setWrappingType(w);return this;};
m.prototype.setSubheader=function(s){this.setProperty("subheader",s);this._oSubTitle.setText(s);return this;};
m.prototype._handleCoreInitialized=function(){this._bThemeApplied=sap.ui.getCore().isThemeApplied();if(!this._bThemeApplied){sap.ui.getCore().attachThemeChanged(this._handleThemeApplied,this);}};
m.prototype._handleThemeApplied=function(){this._bThemeApplied=true;this._oTitle.clampHeight();sap.ui.getCore().detachThemeChanged(this._handleThemeApplied,this);};
m.prototype._initScopeContent=function(t){if(!this.getState||this.getState()!==l.LoadState.Disabled){this._oMoreIcon=this._oMoreIcon||a.createControlByURI({id:this.getId()+"-action-more",size:"1rem",useIconTooltip:false,src:"sap-icon://overflow"}).addStyleClass("sapMPointer").addStyleClass(t+"MoreIcon");this._oRemoveButton=this._oRemoveButton||new B({id:this.getId()+"-action-remove",icon:"sap-icon://decline",tooltip:this._oRb.getText("GENERICTILE_REMOVEBUTTON_TEXT")}).addStyleClass("sapUiSizeCompact").addStyleClass(t+"RemoveButton");this._oRemoveButton._bExcludeFromTabChain=true;switch(this.getScope()){case l.GenericTileScope.Actions:this._oMoreIcon.setVisible(true);this._oRemoveButton.setVisible(true);break;case l.GenericTileScope.ActionMore:this._oMoreIcon.setVisible(true);this._oRemoveButton.setVisible(false);break;case l.GenericTileScope.ActionRemove:this._oRemoveButton.setVisible(true);this._oMoreIcon.setVisible(false);break;default:}}};
m.prototype._isSmall=function(){return this.getSizeBehavior()===g.Small||window.matchMedia("(max-width: 374px)").matches;};
m.prototype.exit=function(){if(this._sParentResizeListenerId){R.deregister(this._sResizeListenerId);this._sParentResizeListenerId=null;}D.media.detachHandler(this._handleMediaChange,this,h);if(this._$RootNode){this._$RootNode.off(this._getAnimationEvents());this._$RootNode=null;}this._clearAnimationUpdateQueue();this._oWarningIcon.destroy();if(this._oImage){this._oImage.destroy();}this._oBusy.destroy();if(this._oMoreIcon){this._oMoreIcon.destroy();}if(this._oRemoveButton){this._oRemoveButton.destroy();}};
m.prototype.onBeforeRendering=function(){var s=!!this.getSubheader();if(this.getMode()===l.GenericTileMode.HeaderMode){this._applyHeaderMode(s);}else{this._applyContentMode(s);}var t=this.getTileContent().length;for(var i=0;i<t;i++){this.getTileContent()[i].setProperty("disabled",this.getState()===l.LoadState.Disabled,true);}this._initScopeContent("sapMGT");this._generateFailedText();this.$().off("mouseenter");this.$().off("mouseleave");if(this._sParentResizeListenerId){R.deregister(this._sResizeListenerId);this._sParentResizeListenerId=null;}D.media.detachHandler(this._handleMediaChange,this,h);if(this._$RootNode){this._$RootNode.off(this._getAnimationEvents());}if(this.getFrameType()===l.FrameType.Auto){this.setProperty("frameType",l.FrameType.OneByOne,true);}};
m.prototype.onAfterRendering=function(){this._setupResizeClassHandler();this.$().on("mouseenter",this._updateAriaAndTitle.bind(this));this.$().on("mouseleave",this._removeTooltipFromControl.bind(this));var M=this.getMode();var s=this._isScreenLarge();if(M===l.GenericTileMode.LineMode){var p=this.$().parent();if(s){p.addClass("sapMGTLineModeContainer");p.removeClass("sapMGTLineModeListContainer");p.addClass("sapMGTLineModeFloatingContainer");this._updateHoverStyle(true);if(this.getParent()instanceof C){this._sParentResizeListenerId=R.register(this.getParent(),this._handleResize.bind(this));}else{this._sParentResizeListenerId=R.register(p,this._handleResize.bind(this));}}else{p.removeClass("sapMGTLineModeFloatingContainer");p.addClass("sapMGTLineModeListContainer");}}if(M===l.GenericTileMode.LineMode&&this._bUpdateLineTileSiblings){this._updateLineTileSiblings();this._bUpdateLineTileSiblings=false;}if(M===l.GenericTileMode.LineMode){D.media.attachHandler(this._handleMediaChange,this,h);}this.onDragComplete();};
m.prototype.onDragComplete=function(){if(this.hasStyleClass("sapMGTPressActive")){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}if(this.getMode()===l.GenericTileMode.LineMode){this.removeStyleClass("sapMGTLineModePress");}}};
m.prototype._handleResize=function(){if(this.getMode()===l.GenericTileMode.LineMode&&this._isScreenLarge()&&this.getParent()){this._queueAnimationEnd();}};
m.prototype._setupResizeClassHandler=function(){var i=function(){if(this.getSizeBehavior()===g.Small||window.matchMedia("(max-width: 374px)").matches){this.$().addClass("sapMTileSmallPhone");}else{this.$().removeClass("sapMTileSmallPhone");}}.bind(this);q(window).on("resize",i);i();};
m.prototype._isCompact=function(){return q("body").hasClass("sapUiSizeCompact")||this.$().is(".sapUiSizeCompact")||this.$().closest(".sapUiSizeCompact").length>0;};
m.prototype._calculateStyleData=function(){this.$("lineBreak").remove();if(!this._isScreenLarge()||!this.getDomRef()||this.$().is(":hidden")){return null;}var $=this.$(),E=this.$("endMarker"),s=this.$("startMarker");if(E.length===0||s.length===0){return null;}var k=this._getLineCount(),n,o,p=Math.ceil(L._getCSSPixelValue(this,"margin-top")),r,A=this.$().parent().innerWidth(),t=Math.ceil(L._getCSSPixelValue(this,"min-height")),u=L._getCSSPixelValue(this,"line-height"),v=this.$().is(":not(:first-child)")&&k>1,w=q("<span><br></span>"),i=0,x=sap.ui.getCore().getConfiguration().getRTL(),y=E.position();if(v){w.attr("id",this.getId()+"-lineBreak");$.prepend(w);k=this._getLineCount();y=E.position();}var z={rtl:x,lineBreak:v,startOffset:s.offset(),endOffset:E.offset(),availableWidth:A,lines:[]};var J;if(D.browser.msie||D.browser.edge){J=w.find("br").position();}else{J=w.position();}var K=J;if(!(D.browser.mozilla||D.browser.msie||D.browser.edge)&&J.left<y.left){K=y;}z.positionLeft=v?J.left:$.position().left;z.positionRight=v?$.width()-K.left:z.availableWidth-$.position().left;if(!v&&k>1){z.positionRight=s.parent().innerWidth()-(s.position().left+s.width());}for(i;i<k;i++){if(v&&i===0){continue;}if(k===1){n=x?z.availableWidth-z.positionLeft:z.positionLeft;r=$.width();}else if(i===k-1){n=0;r=x?$.width()-y.left:y.left;}else if(v&&i===1){n=0;r=A;}else{n=0;r=A;}o=i*u+p;z.lines.push({offset:{x:n,y:o},width:r,height:t});}return z;};
m.prototype._getStyleData=function(){var s=this._calculateStyleData();if(!d(this._oStyleData,s)){delete this._oStyleData;this._oStyleData=s;return true;}return false;};
m.prototype._getAnimationEvents=function(){return"transitionend.sapMGT$id animationend.sapMGT$id".replace(/\$id/g,c(this.getId()));};
m.prototype._updateHoverStyle=function(i){if(!this._getStyleData()&&!i){return;}this._clearAnimationUpdateQueue();this._cHoverStyleUpdates=-1;this._oAnimationEndCallIds={};if(this._oStyleData&&this._oStyleData.lineBreak&&this.getUIArea()){this._$RootNode=q(this.getUIArea().getRootNode());this._$RootNode.on(this._getAnimationEvents(),this._queueAnimationEnd.bind(this));}this._queueAnimationEnd();};
m.prototype._queueAnimationEnd=function(E){if(E){var t=q(E.target);if(t.is(".sapMGT, .sapMGT *")){return false;}}if(typeof this._cHoverStyleUpdates!=="number"){this._cHoverStyleUpdates=-1;}if(!this._oAnimationEndCallIds){this._oAnimationEndCallIds={};}this._cHoverStyleUpdates++;this._oAnimationEndCallIds[this._cHoverStyleUpdates]=setTimeout(this._handleAnimationEnd.bind(this,this._cHoverStyleUpdates),10);};
m.prototype._handleAnimationEnd=function(i){delete this._oAnimationEndCallIds[i];if(this._cHoverStyleUpdates===i){this._getStyleData();L._updateHoverStyle.call(this);}};
m.prototype._clearAnimationUpdateQueue=function(){for(var k in this._oAnimationEndCallIds){clearTimeout(this._oAnimationEndCallIds[k]);delete this._oAnimationEndCallIds[k];}};
m.prototype._getLineCount=function(){var o=this.getDomRef().getBoundingClientRect(),i=L._getCSSPixelValue(this,"line-height");return Math.round(o.height/i);};
m.prototype.getBoundingRects=function(){var p=this.$().offset();if(this.getMode()===l.GenericTileMode.LineMode&&this._isScreenLarge()){this._getStyleData();var r=[],s,o;this.$().find(".sapMGTLineStyleHelper").each(function(){s=q(this);o=s.offset();r.push({offset:{x:o.left,y:o.top},width:s.width(),height:s.height()});});return r;}else{return[{offset:{x:p.left,y:p.top},width:this.$().width(),height:this.$().height()}];}};
m.prototype._updateLineTileSiblings=function(){var p=this.getParent();if(this.getMode()===l.GenericTileMode.LineMode&&this._isScreenLarge()&&p){var i=p.indexOfAggregation(this.sParentAggregationName,this);var s=p.getAggregation(this.sParentAggregationName).splice(i+1);for(i=0;i<s.length;i++){var o=s[i];if(o instanceof l.GenericTile&&o.getMode()===l.GenericTileMode.LineMode){o._updateHoverStyle();}}}};
m.prototype.ontouchstart=function(){this.addStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}if(this.getMode()===l.GenericTileMode.LineMode){this.addStyleClass("sapMGTLineModePress");}};
m.prototype.ontouchcancel=function(){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}};
m.prototype.ontouchend=function(){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}if(this.getMode()===l.GenericTileMode.LineMode){this.removeStyleClass("sapMGTLineModePress");}};
m.prototype.ontap=function(i){var p;if(this._bTilePress&&this.getState()!==l.LoadState.Disabled){this.$().trigger("focus");p=this._getEventParams(i);if(!(this.isInActionRemoveScope()&&p.action===m._Action.Press)){this.firePress(p);}i.preventDefault();}};
m.prototype.onkeydown=function(i){var k=j[i.keyCode];if(!k){j[i.keyCode]=true;if(j[32]||j[13]){i.preventDefault();}}if(P.events.sapselect.fnCheck(i)&&this.getState()!==l.LoadState.Disabled){this.addStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").addClass("sapMGTPressActive");}i.preventDefault();}};
m.prototype._updateAriaLabel=function(){var A=this._getAriaText(),t=this.$(),i=false;if(t.attr("aria-label")!==A){t.attr("aria-label",A);i=true;}return i;};
m.prototype.onkeyup=function(i){var k=j[i.keyCode];if(k){delete j[i.keyCode];}var p,n=false,s=this.getScope(),A=s===l.GenericTileScope.Actions||s===l.GenericTileScope.ActionRemove;if(A&&(P.events.sapdelete.fnCheck(i)||P.events.sapbackspace.fnCheck(i))){p={scope:s,action:m._Action.Remove,domRef:this._oRemoveButton.getPopupAnchorDomRef()};n=true;}if(P.events.sapselect.fnCheck(i)&&this.getState()!==l.LoadState.Disabled){this.removeStyleClass("sapMGTPressActive");if(this.$("hover-overlay").length>0){this.$("hover-overlay").removeClass("sapMGTPressActive");}p=this._getEventParams(i);n=true;}if(n){this.firePress(p);i.preventDefault();}this._updateAriaLabel();};
m.prototype.setProperty=function(p){C.prototype.setProperty.apply(this,arguments);if(this.getMode()===l.GenericTileMode.LineMode&&m.LINEMODE_SIBLING_PROPERTIES.indexOf(p)!==-1){this._bUpdateLineTileSiblings=true;}return this;};
m.prototype.getHeader=function(){return this._oTitle.getText();};
m.prototype.setHeader=function(t){this.setProperty("header",t);this._oTitle.setText(t);return this;};
m.prototype.setHeaderImage=function(u){var v=!d(this.getHeaderImage(),u);if(v){if(this._oImage){this._oImage.destroy();this._oImage=undefined;}if(u){this._oImage=a.createControlByURI({id:this.getId()+"-icon-image",src:u},l.Image);this._oImage.addStyleClass("sapMGTHdrIconImage");}}return this.setProperty("headerImage",u);};
m.prototype._applyHeaderMode=function(s){if(s){this._oTitle.setProperty("maxLines",4,true);}else{this._oTitle.setProperty("maxLines",5,true);}this._changeTileContentContentVisibility(false);};
m.prototype._applyContentMode=function(s){if(s){this._oTitle.setProperty("maxLines",2,true);}else{this._oTitle.setProperty("maxLines",3,true);}this._changeTileContentContentVisibility(true);};
m.prototype._changeTileContentContentVisibility=function(v){var t;t=this.getTileContent();for(var i=0;i<t.length;i++){t[i].setRenderContent(v);}};
m.prototype._getHeaderAriaAndTooltipText=function(){var t="";var i=true;if(this.getHeader()){t+=this.getHeader();i=false;}if(this.getSubheader()){t+=(i?"":"\n")+this.getSubheader();i=false;}if(this.getImageDescription()){t+=(i?"":"\n")+this.getImageDescription();}return t;};
m.prototype._getContentAriaAndTooltipText=function(){var t="";var k=true;var n=this.getTileContent();var A=this.getAdditionalTooltip();if(!this._isInActionScope()&&this.getMode()===l.GenericTileMode.ContentMode){for(var i=0;i<n.length;i++){if(q.isFunction(n[i]._getAriaAndTooltipText)){t+=(k?"":"\n")+n[i]._getAriaAndTooltipText();}else if(n[i].getTooltip_AsString()){t+=(k?"":"\n")+n[i].getTooltip_AsString();}k=false;}}if(A){t+=(k?"":"\n")+A;}return t;};
m.prototype._getAriaAndTooltipText=function(){var A=(this.getTooltip_AsString()&&!this._isTooltipSuppressed())?this.getTooltip_AsString():(this._getHeaderAriaAndTooltipText()+"\n"+this._getContentAriaAndTooltipText());switch(this.getState()){case l.LoadState.Disabled:return"";case l.LoadState.Loading:return A+"\n"+this._sLoading;case l.LoadState.Failed:return A+"\n"+this._oFailedText.getText();default:if(A.trim().length===0){return"";}else{return A;}}};
m.prototype._getAriaText=function(){var A=this.getTooltip_Text();var s=this.getAriaLabel();if(!A||this._isTooltipSuppressed()){A=this._getAriaAndTooltipText();}if(this._isInActionScope()){A=this._oRb.getText("GENERICTILE_ACTIONS_ARIA_TEXT")+" "+A;}if(s){A=s+" "+A;}return A;};
m.prototype._getTooltipText=function(){var t=this.getTooltip_Text();if(this._isTooltipSuppressed()===true){t=null;}return t;};
m.prototype._checkFooter=function(t,i){var s=i.getState();var A=this._isInActionScope()||this._bShowActionsView===true;if(s===l.LoadState.Failed||A&&s!==l.LoadState.Disabled){t.setRenderFooter(false);}else{t.setRenderFooter(true);}};
m.prototype._isInActionScope=function(){return this.getScope()===l.GenericTileScope.Actions||this.getScope()===l.GenericTileScope.ActionMore||this.getScope()===l.GenericTileScope.ActionRemove;};
m.prototype.isInActionRemoveScope=function(){return this.getScope()===l.GenericTileScope.ActionRemove;};
m.prototype._generateFailedText=function(){var s=this.getFailedText();var i=s?s:this._sFailedToLoad;this._oFailedText.setProperty("text",i,true);this._oFailedText.setAggregation("tooltip",i,true);};
m.prototype._isTooltipSuppressed=function(){var t=this.getTooltip_Text();if(t&&t.length>0&&t.trim().length===0){return true;}else{return false;}};
m.prototype._isHeaderTextTruncated=function(){var o,M,$,w;if(this.getMode()===l.GenericTileMode.LineMode){$=this.$("hdr-text");if($.length>0){w=Math.ceil($[0].getBoundingClientRect().width);return($[0]&&w<$[0].scrollWidth);}else{return false;}}else{o=this.getAggregation("_titleText").getDomRef("inner");M=this.getAggregation("_titleText").getClampHeight(o);return(M<o.scrollHeight);}};
m.prototype._isSubheaderTextTruncated=function(){var s;if(this.getMode()===l.GenericTileMode.LineMode){s=this.$("subHdr-text");}else{s=this.$("subTitle");}if(s.length>0){var w=Math.ceil(s[0].getBoundingClientRect().width);return(s[0]&&w<s[0].scrollWidth);}else{return false;}};
m.prototype._setTooltipFromControl=function(){var t=this._getAriaAndTooltipText();if(t&&!this._getTooltipText()&&!this._isTooltipSuppressed()){this.$().attr("title",t.trim());this._bTooltipFromControl=true;}};
m.prototype._updateAriaAndTitle=function(){var A=this._getAriaAndTooltipText();var s=this._getAriaText();var t=this.$();if(t.attr("title")!==A){t.attr("aria-label",s);}if(this._isInActionScope()){t.find('*:not(.sapMGTRemoveButton)').removeAttr("aria-label").removeAttr("title").off("mouseenter");}else{t.find('*').removeAttr("aria-label").removeAttr("title").off("mouseenter");}this._setTooltipFromControl();};
m.prototype._removeTooltipFromControl=function(){if(this._bTooltipFromControl){this.$().removeAttr("title");this._bTooltipFromControl=false;}};
m.prototype._isScreenLarge=function(){return this._getCurrentMediaContainerRange(h).name==="large";};
m.prototype._getEventParams=function(E){var p,A=m._Action.Press,s=this.getScope(),o=this.getDomRef();if((s===l.GenericTileScope.Actions||l.GenericTileScope.ActionRemove)&&E.target.id.indexOf("-action-remove")>-1){A=m._Action.Remove;o=this._oRemoveButton.getPopupAnchorDomRef();}else if(s===l.GenericTileScope.Actions||s===l.GenericTileScope.ActionMore){o=this._oMoreIcon.getDomRef();}p={scope:s,action:A,domRef:o};return p;};
m.prototype._handleMediaChange=function(){this._bUpdateLineTileSiblings=true;this.invalidate();};
m.prototype.setPressEnabled=function(v){this._bTilePress=v;};
m.prototype.showActionsView=function(v){if(this._bShowActionsView!==v){this._bShowActionsView=v;this.invalidate();}};
return m;});
sap.ui.predefine('sap/m/GenericTileLineModeRenderer',["sap/m/library","sap/base/security/encodeCSS","sap/ui/thirdparty/jquery"],function(l,e,q){"use strict";var G=l.GenericTileScope;var L=l.LoadState;var a={};
a.render=function(r,c){var t=c._getTooltipText(),i=c._isScreenLarge(),A=c._getAriaText(),s=c.getScope(),S,I=false,h=c.hasListeners("press"),b=c.getState();var R=c.getUrl()&&!c._isInActionScope()&&b!==L.Disabled;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();if(s===G.Actions){S=e("sapMGTScopeActions");}else if(s===G.ActionMore||s===G.ActionRemove){I=true;S=e("sapMGTScopeSingleAction");}else{S=e("sapMGTScopeDisplay");}if(R){r.write("<a");r.writeAttributeEscaped("href",c.getUrl());r.writeAttribute("draggable","false");}else{r.write("<span");}r.writeControlData(c);r.writeAttributeEscaped("aria-label",A);if(!R){r.writeAttribute("role",h?"button":"presentation");}r.addClass("sapMGT");r.addClass(S);r.addClass("sapMGTLineMode");this._writeDirection(r);if(t){r.writeAttributeEscaped("title",t);}if(b!==L.Disabled){if(!c.isInActionRemoveScope()){r.addClass("sapMPointer");}r.writeAttribute("tabindex","0");}else{r.addClass("sapMGTDisabled");}if(b===L.Failed){r.addClass("sapMGTFailed");}r.writeClasses();r.write(">");if(i){r.write("<div");r.writeAttribute("id",c.getId()+"-startMarker");r.addClass("sapMGTStartMarker");r.writeClasses();r.write("></div>");this._renderFailedIcon(r,c);this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("<div");r.writeAttribute("id",c.getId()+"-endMarker");r.addClass("sapMGTEndMarker");r.writeClasses();r.write(">");if(c._isInActionScope()){this._renderActionsScope(r,c,I);}r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-styleHelper");r.addClass("sapMGTStyleHelper");r.writeClasses();r.write("></div>");}else{if(c.getState()!==L.Disabled){this._renderFocusDiv(r,c);}r.write("<div");r.writeAttribute("id",c.getId()+"-touchArea");r.addClass("sapMGTTouchArea");r.writeClasses();r.write(">");this._renderFailedIcon(r,c);r.write("<span");r.writeAttribute("id",c.getId()+"-lineModeHelpContainer");r.addClass("sapMGTLineModeHelpContainer");r.writeClasses();r.write(">");this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("</span>");if(c._isInActionScope()){this._renderActionsScope(r,c,I);}r.write("</div>");}if(R){r.write("</a>");}else{r.write("</span>");}};
a._writeDirection=function(r){if(this._bRTL){r.writeAttribute("dir","rtl");}};
a._renderFailedIcon=function(r,c){if(c.getState()===L.Failed){if(c._isCompact()){c._oWarningIcon.setSize("1.25rem");}else{c._oWarningIcon.setSize("1.375rem");}r.renderControl(c._oWarningIcon.addStyleClass("sapMGTLineModeFailedIcon"));}};
a._renderHeader=function(r,c){r.write("<span");this._writeDirection(r);r.addClass("sapMGTHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-hdr-text");r.write(">");r.writeEscaped(c._oTitle.getText());r.write("</span>");};
a._renderSubheader=function(r,c){r.write("<span");this._writeDirection(r);r.addClass("sapMGTSubHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-subHdr-text");r.write(">");r.writeEscaped(c._oSubTitle.getText());r.write("</span>");};
a._renderActionsScope=function(r,c,i){if(c.getState()!==L.Disabled){r.write("<span");r.writeAttribute("id",c.getId()+"-actions");r.addClass("sapMGTActionsContainer");if(i){r.addClass("sapMGTScopeSingleActionContainer");}r.writeClasses();r.write(">");r.renderControl(c._oMoreIcon);r.renderControl(c._oRemoveButton);r.write("</span>");}};
a._updateHoverStyle=function(){var s=this.$("styleHelper"),o,i=0,h="";s.empty();if(!this._oStyleData||this.$().is(":hidden")){return;}if(this._oStyleData.rtl){s.css("right",-this._oStyleData.positionRight);}else{s.css("left",-this._oStyleData.positionLeft);}for(i;i<this._oStyleData.lines.length;i++){o=this._oStyleData.lines[i];var r=q("<div class='sapMGTLineStyleHelper'><div class='sapMGTLineStyleHelperInner'></div></div>");if(this._oStyleData.rtl){r.css("right",o.offset.x+"px");}else{r.css("left",o.offset.x+"px");}r.css({top:o.offset.y+"px",width:o.width+"px",height:o.height});h+=r.get(0).outerHTML.trim();}s.html(h);};
a._renderFocusDiv=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-focus");r.addClass("sapMGTFocusDiv");r.writeClasses();r.write(">");r.write("</div>");};
a._getCSSPixelValue=function(o,p){var O=o instanceof q?o:o.$(),m=(O.css(p)||"").match(/([^a-zA-Z\%]*)(.*)/),v=parseFloat(m[1]),u=m[2];return(u==="px")?v:v*16;};
return a;},true);
sap.ui.predefine('sap/m/GenericTileRenderer',["sap/m/library","sap/base/security/encodeCSS"],function(l,e){"use strict";var G=l.GenericTileMode;var L=l.LoadState;var a={};
a.render=function(r,c){var t=c._getTooltipText();var A=c._getAriaText();var h=c.getHeaderImage();var H=c.hasListeners("press");var s=c.getState();var S=e("sapMGTState"+s);var b;var R=c.getUrl()&&!c._isInActionScope()&&s!==L.Disabled;if(c._isInActionScope()){b=e("sapMGTScopeActions");}else{b=e("sapMGTScopeDisplay");}if(R){r.write("<a");r.writeAttributeEscaped("href",c.getUrl());r.writeAttribute("draggable","false");}else{r.write("<div");}r.writeControlData(c);if(t){r.writeAttributeEscaped("title",t);}r.addClass("sapMGT");r.addClass(S);r.addClass(b);if(!c._isInActionScope()&&c._bShowActionsView){r.addClass("sapMGTScopeActions");}r.addClass(c.getFrameType());if(!R){r.writeAttribute("role",H?"button":"presentation");}r.writeAttributeEscaped("aria-label",A);if(s!==L.Disabled){if(!c.isInActionRemoveScope()){r.addClass("sapMPointer");}r.writeAttribute("tabindex","0");}if(c.getWidth()){r.write(" style='width: "+c.getWidth()+";");}if(c.getBackgroundImage()){r.write(c.getWidth()?" background-image:url(\"":"style='background-image:url(\"");r.writeEscaped(c.getBackgroundImage());r.write("\");'");r.addClass("sapMGTBackgroundImage");}else{r.write("'");}if(c.getMode()===G.HeaderMode){r.addClass("sapMGTHeaderMode");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMGTHdrContent");r.addClass(c.getFrameType());if(t){r.writeAttributeEscaped("title",t);}r.writeClasses();r.write(">");if(h){r.renderControl(c._oImage);}this._renderHeader(r,c);if(c.getSubheader()){this._renderSubheader(r,c);}r.write("</div>");r.write("<div");r.addClass("sapMGTContent");r.writeClasses();r.writeAttribute("id",c.getId()+"-content");r.write(">");var T=c.getTileContent();var d=T.length;for(var i=0;i<d;i++){c._checkFooter(T[i],c);r.renderControl(T[i]);}r.write("</div>");if(s!==L.Loaded){this._renderStateOverlay(r,c,t);}if(s!==L.Disabled){this._renderHoverOverlay(r,c);this._renderFocusDiv(r,c);}if(c._isInActionScope()){this._renderActionsScope(r,c);}if(R){r.write("</a>");}else{r.write("</div>");}};
a._renderFocusDiv=function(r,c){r.write("<div");r.addClass("sapMGTFocusDiv");r.writeClasses();r.writeAttribute("id",c.getId()+"-focus");r.write(">");r.write("</div>");};
a._renderStateOverlay=function(r,c,t){var s=c.getState();r.write("<div");r.addClass("sapMGTOverlay");r.writeClasses();r.writeAttribute("id",c.getId()+"-overlay");if(t){r.writeAttributeEscaped("title",t);}r.write(">");switch(s){case L.Loading:c._oBusy.setBusy(s==L.Loading);r.renderControl(c._oBusy);break;case L.Failed:r.write("<div");r.writeAttribute("id",c.getId()+"-failed-ftr");r.addClass("sapMGenericTileFtrFld");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",c.getId()+"-failed-icon");r.addClass("sapMGenericTileFtrFldIcn");r.writeClasses();r.write(">");r.renderControl(c._oWarningIcon);r.write("</div>");if(!c._isInActionScope()&&!c._bShowActionsView){r.write("<div");r.writeAttribute("id",c.getId()+"-failed-text");r.addClass("sapMGenericTileFtrFldTxt");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_failedMessageText"));r.write("</div>");}r.write("</div>");break;default:}r.write("</div>");};
a._renderActionsScope=function(r,c){if(c.getState()!==L.Disabled){r.renderControl(c._oRemoveButton);r.renderControl(c._oMoreIcon);}};
a._renderHoverOverlay=function(r,c){r.write("<div");if(c.getBackgroundImage()){r.addClass("sapMGTWithImageHoverOverlay");}else{r.addClass("sapMGTWithoutImageHoverOverlay");}r.writeClasses();r.writeAttribute("id",c.getId()+"-hover-overlay");r.write(">");r.write("</div>");};
a._renderHeader=function(r,c){r.write("<div");r.addClass("sapMGTHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-hdr-text");r.write(">");r.renderControl(c._oTitle);r.write("</div>");};
a._renderSubheader=function(r,c){r.write("<div");r.addClass("sapMGTSubHdrTxt");r.writeClasses();r.writeAttribute("id",c.getId()+"-subHdr-text");r.write(">");r.renderControl(c._oSubTitle);r.write("</div>");};
return a;},true);
sap.ui.predefine('sap/m/GroupHeaderListItem',["sap/ui/core/library","./library","./ListItemBase","./GroupHeaderListItemRenderer"],function(c,l,L,G){"use strict";var a=l.ListMode;var T=c.TextDirection;
var b=L.extend("sap.m.GroupHeaderListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},count:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}}}});
b.prototype.getMode=function(){return a.None;};
b.prototype.shouldClearLastValue=function(){return true;};
b.prototype.getTable=function(){var p=this.getParent();if(p&&p.isA("sap.m.Table")){return p;}};
b.prototype.onBeforeRendering=function(){var t=this.getTable();if(t){t.getColumns().forEach(function(C){C.clearLastValue();});this.TagName="tr";}};
b.prototype.getAccessibilityType=function(B){var t=this.getTable()?"ROW":"OPTION";return B.getText("LIST_ITEM_GROUP_HEADER")+" "+B.getText("ACC_CTR_TYPE_"+t);};
b.prototype.getContentAnnouncement=function(){return this.getTitle();};
b.prototype.getGroupAnnouncement=function(){};
return b;});
sap.ui.predefine('sap/m/GroupHeaderListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var G=R.extend(L);G.apiVersion=2;
G.renderType=function(r,l){var t=l.getTable();if(t){if(t.hasPopin()){this.renderDummyCell(r,t);}this.renderCell(r,"sapMListTblNavCol");}L.renderType.apply(this,arguments);if(t){r.close("td");}};
G.renderNavigated=function(r,l){var t=l.getTable();if(t){this.renderCell(r,"sapMListTblNavigatedCol");}L.renderNavigated.apply(this,arguments);if(t){r.close("td");}};
G.renderDummyCell=function(r,t){if(t.shouldRenderDummyColumn()){this.renderCell(r,"sapMListTblDummyCell");r.close("td");}};
G.renderCell=function(r,C){r.openStart("td");r.class(C);r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();};
G.renderCounter=function(r,l){};
G.renderLIAttributes=function(r,l){r.class("sapMGHLI");if(l.getUpperCase()){r.class("sapMGHLIUpperCase");}var t=l.getTable();if(t&&t.shouldRenderDummyColumn()){r.class("sapMListTblRowHasDummyCell");}};
G.renderLIContentWrapper=function(r,l){var t=l.getTable();if(t){r.openStart("td");r.class("sapMGHLICell");r.attr("colspan",t.getColSpan());r.openEnd();}L.renderLIContentWrapper.apply(this,arguments);if(t){r.close("td");}};
G.renderLIContent=function(r,l){var t=l.getTitleTextDirection();r.openStart("span");r.class("sapMGHLITitle");if(t!=T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(l.getTitle());r.close("span");var C=l.getCount()||l.getCounter();if(C){r.openStart("span");r.class("sapMGHLICounter");r.openEnd();r.text(" ("+C+")");r.close("span");}};
G.addLegacyOutlineClass=function(r,l){if(!l.getTable()){L.addLegacyOutlineClass.apply(this,arguments);}};
G.getAriaRole=function(l){if(l.getTable()){return"row";}return L.getAriaRole.apply(this,arguments);};
return G;},true);
sap.ui.predefine('sap/m/GrowingEnablement',['sap/ui/base/Object','sap/ui/core/format/NumberFormat','sap/m/library','sap/ui/model/ChangeReason','sap/ui/base/ManagedObjectMetadata','sap/ui/core/HTML','sap/m/CustomListItem',"sap/base/security/encodeXML"],function(B,N,l,C,M,H,a,e){"use strict";var L=l.ListType;var b=l.ListGrowingDirection;
var G=B.extend("sap.m.GrowingEnablement",{
constructor:function(c){B.apply(this);this._oControl=c;this._oControl.bUseExtendedChangeDetection=true;this._oControl.addDelegate(this);var r=this._oControl.getItems(true).length;this._iRenderedDataItems=r;this._iLimit=r;this._bLoading=false;this._sGroupingPath="";this._bDataRequested=false;this._oContainerDomRef=null;this._iLastItemsCount=0;this._iTriggerTimer=0;this._aChunk=[];this._oRM=null;},
destroy:function(){if(this._oTrigger){this._oTrigger.destroy();this._oTrigger=null;}if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(this._oRM){this._oRM.destroy();this._oRM=null;}this._oControl.$("triggerList").remove();this._oControl.bUseExtendedChangeDetection=false;this._oControl.removeDelegate(this);this._oContainerDomRef=null;this._oControl=null;},
render:function(r){r.openStart("div",this._oControl.getId()+"-triggerList");r.class("sapMListUl").class("sapMGrowingList");r.style("display","none");r.openEnd();r.renderControl(this._getTrigger());r.close("div");},
onAfterRendering:function(){var c=this._oControl;if(c.getGrowingScrollToLoad()){var s=l.getScrollDelegate(c);if(s){this._oScrollDelegate=s;s.setGrowingList(this.onScrollToLoad.bind(this),c.getGrowingDirection(),this._updateTrigger.bind(this,false));}}else if(this._oScrollDelegate){this._oScrollDelegate.setGrowingList(null);this._oScrollDelegate=null;}if(!this._bLoading){this._updateTriggerDelayed(false);}},
setTriggerText:function(t){this._oControl.$("triggerText").text(t);},
reset:function(){this._iLimit=0;var o=this._oControl.getBindingInfo("items");this._oControl.oExtendedChangeDetectionConfig=(!o||!o.template)?null:{replace:true};},
shouldReset:function(c){var m=C;return c==m.Sort||c==m.Filter||c==m.Context;},
getInfo:function(){return{total:this._oControl.getMaxItemsCount(),actual:this._iRenderedDataItems};},
onScrollToLoad:function(){var t=this._oControl.getDomRef("triggerList");if(this._bLoading||!t||t.style.display!="none"){return;}if(this._oControl.getGrowingDirection()==b.Upwards){var s=this._oScrollDelegate;this._oScrollPosition={left:s.getScrollLeft(),top:s.getScrollHeight()};}this.requestNewPage();},
requestNewPage:function(){if(!this._oControl||this._bLoading){return;}var o=this._oControl.getBinding("items");if(o&&!o.isLengthFinal()||this._iLimit<this._oControl.getMaxItemsCount()){if(this._oControl.getMetadata().hasProperty("enableBusyIndicator")){this._bParentEnableBusyIndicator=this._oControl.getEnableBusyIndicator();this._oControl.setEnableBusyIndicator(false);}this._iLimit+=this._oControl.getGrowingThreshold();this._updateTriggerDelayed(true);this.updateItems("Growing");}},
_onBeforePageLoaded:function(c){this._bLoading=true;this._oControl.onBeforePageLoaded(this.getInfo(),c);},
_onAfterPageLoaded:function(c){this._bLoading=false;this._updateTriggerDelayed(false);this._oControl.onAfterPageLoaded(this.getInfo(),c);if(this._oControl.setEnableBusyIndicator){this._oControl.setEnableBusyIndicator(this._bParentEnableBusyIndicator);}},
_getTrigger:function(){var t=this._oControl.getId()+"-trigger",T=this._oControl.getGrowingTriggerText();T=T||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LOAD_MORE_DATA");this._oControl.addNavSection(t);if(this._oTrigger){this.setTriggerText(T);return this._oTrigger;}this._oTrigger=new a({id:t,busyIndicatorDelay:0,type:L.Active,content:new H({content:'<div class="sapMGrowingListTrigger">'+'<div class="sapMSLIDiv sapMGrowingListTriggerText">'+'<span class="sapMSLITitle" id="'+t+'Text">'+e(T)+'</span>'+'</div>'+'<div class="sapMGrowingListDescription sapMSLIDescription" id="'+t+'Info"></div>'+'</div>'})}).setParent(this._oControl,null,true).attachPress(this.requestNewPage,this).addDelegate({onsapenter:function(E){this.requestNewPage();E.preventDefault();},onsapspace:function(E){this.requestNewPage();E.preventDefault();},onAfterRendering:function(E){var $=this._oTrigger.$();$.removeAttr("aria-selected");$.attr({"tabindex":0,"role":"button","aria-labelledby":t+"Text"+" "+t+"Info"});}},this);this._oTrigger.getList=function(){};this._oTrigger.TagName="div";return this._oTrigger;},
_getListItemInfo:function(){return("[ "+this._iRenderedDataItems+" / "+N.getFloatInstance().format(this._oControl.getMaxItemsCount())+" ]");},
_getGroupingPath:function(o){var s=o.aSorters||[];var S=s[0]||{};return(S.fnGroup)?S.sPath||"":"";},
_getDomIndex:function(i){if(typeof i!="number"){return i;}if(this._oControl.hasPopin&&this._oControl.hasPopin()){return(i*2);}return i;},
_getHasScrollbars:function(){if(!this._oScrollDelegate){return false;}if(this._iRenderedDataItems>=40){return true;}return this._oScrollDelegate.getMaxScrollTop()>this._oControl.getDomRef("triggerList").clientHeight;},
destroyListItems:function(s){this._oControl.destroyItems(s);this._iRenderedDataItems=0;this._aChunk=[];},
addListItem:function(c,o,s){var d=this._oControl,f=o.binding,i=this.createListItem(c,o);if(f.isGrouped()){var I=d.getItems(true),g=I[I.length-1],m=o.model,h=f.getGroup(i.getBindingContext(m));if(g&&g.isGroupHeader()){d.removeAggregation("items",g,true);this._fnAppendGroupItem=this.appendGroupItem.bind(this,h,g,s);g=I[I.length-1];}if(!g||h.key!==f.getGroup(g.getBindingContext(m)).key){var j=(o.groupHeaderFactory)?o.groupHeaderFactory(h):null;if(d.getGrowingDirection()==b.Upwards){this.applyPendingGroupItem();this._fnAppendGroupItem=this.appendGroupItem.bind(this,h,j,s);}else{this.appendGroupItem(h,j,s);}}}d.addAggregation("items",i,s);if(s){this._aChunk.push(i);}},
applyPendingGroupItem:function(){if(this._fnAppendGroupItem){this._fnAppendGroupItem();this._fnAppendGroupItem=undefined;}},
appendGroupItem:function(g,o,s){o=this._oControl.addItemGroup(g,o,s);if(s){this._aChunk.push(o);}},
createListItem:function(c,o){this._iRenderedDataItems++;return G.createItem(c,o);},
updateItemsBindingContext:function(d,m){if(!d.length){return;}var I=this._oControl.getItems(true);for(var i=0,c=0,o;i<I.length;i++){o=I[i];if(!o.isGroupHeader()){o.setBindingContext(d[c++],m);}}},
applyChunk:function(I,d){this.applyPendingGroupItem();var c=this._aChunk.length;if(!c){return;}if(this._oControl.isA("sap.m.Table")){var h=this._oControl.getColumns().some(function(o){return o.getVisible();});if(!h){return;}}if(this._oControl.getGrowingDirection()==b.Upwards){this._aChunk.reverse();if(I===true){I=0;}else if(typeof I=="number"){I=this._iRenderedDataItems-c-I;}}d=d||this._oContainerDomRef;this._oRM=this._oRM||sap.ui.getCore().createRenderManager();for(var i=0;i<c;i++){this._oRM.renderControl(this._aChunk[i]);}this._oRM.flush(d,false,this._getDomIndex(I));this._aChunk=[];},
addListItems:function(c,o,s){for(var i=0;i<c.length;i++){this.addListItem(c[i],o,s);}},
rebuildListItems:function(c,o,s){this.destroyListItems(s);this.addListItems(c,o,s);if(s){var h=this._oContainerDomRef.contains(document.activeElement);this.applyChunk(false);h&&this._oControl.focus();}else{this.applyPendingGroupItem();}},
insertListItem:function(c,o,i){var I=this.createListItem(c,o);this._oControl.insertAggregation("items",I,i,true);this._aChunk.push(I);},
deleteListItem:function(i){this._oControl.getItems(true)[i].destroy(true);this._iRenderedDataItems--;},
refreshItems:function(c){if(!this._bDataRequested){this._bDataRequested=true;this._onBeforePageLoaded(c);}if(!this._iLimit||this.shouldReset(c)||!this._oControl.getItems(true).length){this._iLimit=this._oControl.getGrowingThreshold();}this._oControl.getBinding("items").getContexts(0,this._iLimit);},
updateItems:function(c){var o=this._oControl,d=o.getBinding("items"),f=o.getBindingInfo("items"),I=o.getItems(true);if(!this._iLimit||this.shouldReset(c)||!I.length){this._iLimit=o.getGrowingThreshold();}if(this._bDataRequested){this._bDataRequested=false;}else{this._onBeforePageLoaded(c);}var g=d.getContexts(0,this._iLimit)||[];if(g.dataRequested){this._bDataRequested=true;if(g.diff&&!g.diff.length){return;}}this._oContainerDomRef=o.getItemsContainerDomRef();var D=g.diff,F=false,v;if(!g.length){this.destroyListItems();}else if(!this._oContainerDomRef){this.rebuildListItems(g,f);}else if(!D||!I.length&&D.length){if(o.shouldRenderItems()){this.rebuildListItems(g,f,true);}}else if(d.isGrouped()||o.checkGrowingFromScratch()){if(this._sGroupingPath!=this._getGroupingPath(d)){F=true;}else{for(var i=0;i<D.length;i++){var h=D[i],j=g[h.index];if(h.type=="delete"||h.type=="replace"){F=true;break;}else if(h.index!=this._iRenderedDataItems){F=true;break;}else{this.addListItem(j,f,true);v=true;}}}}else{if(this._sGroupingPath){o.removeGroupHeaders(true);}v=-1;var k=-1;for(var i=0;i<D.length;i++){var h=D[i],m=h.index,j=g[m];if(h.type=="delete"){if(v!=-1){this.applyChunk(v);k=-1;v=-1;}this.deleteListItem(m);}else if(h.type=="insert"){if(v==-1){v=m;}else if(k>-1&&m!=k+1){this.applyChunk(v);v=m;}this.insertListItem(j,f,m);k=m;}}}if(F){this.rebuildListItems(g,f,true);}else if(this._oContainerDomRef&&D){this.updateItemsBindingContext(g,f.model);this.applyChunk(v);}this._oContainerDomRef=null;this._sGroupingPath=this._getGroupingPath(d);if(!this._bDataRequested){this._onAfterPageLoaded(c);}},
_updateTriggerDelayed:function(c){if(this._oControl.getGrowingScrollToLoad()){this._iTriggerTimer&&window.cancelAnimationFrame(this._iTriggerTimer);this._iTriggerTimer=window.requestAnimationFrame(this._updateTrigger.bind(this,c));}else{this._updateTrigger(c);}},
_updateTrigger:function(c){var t=this._oTrigger,o=this._oControl,v=o&&o.getVisibleItems().length>0;if(!t||!o||!v||!o.shouldRenderItems()||!o.getDomRef()){return;}var d=o.getBinding("items");if(!d){return;}t.setBusy(c);t.$().toggleClass("sapMGrowingListBusyIndicatorVisible",c);if(c){t.setActive(false);o.$("triggerList").css("display","");}else{var i=o.getItems(true),I=i.length,f=d.getLength()||0,g=d.isLengthFinal(),h=o.getGrowingScrollToLoad(),T=t.getDomRef();if(T&&T.contains(document.activeElement)){(i[this._iLastItemsCount]||o).focus();}if(!I||!this._iLimit||(g&&this._iLimit>=f)||(h&&this._getHasScrollbars())){o.$("triggerList").css("display","none");}else{if(g){o.$("triggerInfo").css("display","block").text(this._getListItemInfo());}t.$().removeClass("sapMGrowingListBusyIndicatorVisible");o.$("triggerList").css("display","");if(o.isA("sap.m.Table")&&!o.hasPopin()&&o.shouldRenderDummyColumn()){var D=o.getDomRef("tblHeadDummyCol");var w=o.getDomRef().clientWidth-D.clientWidth;T.style.width=w+"px";}}this._iLastItemsCount=this._oControl.getItems(true).length;if(h&&this._oScrollPosition===undefined&&o.getGrowingDirection()==b.Upwards){this._oScrollPosition={left:0,top:0};}if(I>0&&this._oScrollPosition){var s=this._oScrollDelegate,S=this._oScrollPosition;s.scrollTo(S.left,s.getScrollHeight()-S.top);this._oScrollPosition=null;}}}
});
G.createItem=function(c,o,i){var I=o.factory(M.uid(i?i:"clone"),c);return I.setBindingContext(c,o.model);};
return G;});
sap.ui.predefine('sap/m/GrowingList',['./List','./library','./GrowingListRenderer'],function(L,l,G){"use strict";
var a=L.extend("sap.m.GrowingList",{metadata:{deprecated:true,library:"sap.m",properties:{threshold:{type:"int",group:"Misc",defaultValue:20},triggerText:{type:"string",group:"Appearance",defaultValue:null},scrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false}}}});
a.prototype._isIncompatible=function(){return sap.ui.getCore().getConfiguration().getCompatibilityVersion("sapMGrowingList").compareTo("1.16")>=0;};
a.prototype.init=function(){L.prototype.init.call(this);if(!this._isIncompatible()){this.setGrowing();}};
a.prototype.setGrowing=function(){return L.prototype.setGrowing.call(this,true);};
!(function(g,o){["Threshold","TriggerText","ScrollToLoad"].forEach(function(p){g["set"+p]=o["setGrowing"+p];g["get"+p]=o["getGrowing"+p];});}(a.prototype,L.prototype));return a;});
sap.ui.predefine('sap/m/GrowingListRenderer',['./ListRenderer','sap/ui/core/Renderer',"sap/base/Log"],function(L,R,a){"use strict";var G=R.extend(L);G.apiVersion=2;
G.render=function(r,c){if(c._isIncompatible()){a.warning("Does not render sap.m.GrowingList#"+c.getId()+" when compatibility version is 1.16 or higher. Instead use sap.m.List/Table control with growing feature!");}else{L.render.call(this,r,c);}};
return G;},true);
sap.ui.predefine('sap/m/HBox',['./FlexBox','./library','./HBoxRenderer'],function(F,l,H){"use strict";
var a=F.extend("sap.m.HBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/HBox.designtime"}});
return a;});
sap.ui.predefine('sap/m/HBoxRenderer',['./FlexBoxRenderer'],function(F){"use strict";var H={apiVersion:2};
H.render=function(r,c){F.render.apply(this,[r,c]);};
return H;},true);
sap.ui.predefine('sap/m/HeaderContainer',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/Device','sap/m/HeaderContainerItemNavigator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/library','sap/ui/core/IntervalTrigger','sap/ui/base/ManagedObject','sap/ui/core/Icon','./HeaderContainerRenderer',"sap/base/Log","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/scrollRightRTL","sap/ui/dom/jquery/Selectors"],function(l,C,a,D,H,I,c,b,M,d,e,L,P,q){"use strict";var O=c.Orientation;
var f=a.extend("sap.m.HeaderContainerItemContainer",{
metadata:{defaultAggregation:"item",properties:{position:{type:"int",defaultValue:null},setSize:{type:"int",defaultValue:null},ariaLabelledBy:{type:"string",defaultValue:null}},aggregations:{item:{type:"sap.ui.core.Control",multiple:false}}},
renderer:function(r,o){var i=o.getAggregation("item");if(!i||!i.getVisible()){return;}r.write("<div");r.writeControlData(o);r.addClass("sapMHdrCntrItemCntr");r.addClass("sapMHrdrCntrInner");r.writeAttribute("aria-setsize",o.getSetSize());r.writeAttribute("aria-posinset",o.getPosition());r.writeAttribute("role","listitem");if(o.getAriaLabelledBy()){r.writeAttributeEscaped("aria-labelledby",o.getAriaLabelledBy());}r.writeClasses();r.write(">");r.renderControl(i);r.write("</div>");}
});
var g=a.extend("sap.m.HeaderContainer",{metadata:{interfaces:["sap.m.ObjectHeaderContainer"],library:"sap.m",properties:{scrollStep:{type:"int",defaultValue:300,group:"Behavior"},scrollStepByItem:{type:"int",defaultValue:1,group:"Behavior"},scrollTime:{type:"int",defaultValue:500,group:"Behavior"},showOverflowItem:{type:"boolean",defaultValue:true,group:"Behavior"},showDividers:{type:"boolean",defaultValue:true,group:"Appearance"},orientation:{type:"sap.ui.core.Orientation",defaultValue:O.Horizontal,group:"Appearance"},backgroundDesign:{type:"sap.m.BackgroundDesign",defaultValue:l.BackgroundDesign.Transparent,group:"Appearance"},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true},_scrollContainer:{type:"sap.m.ScrollContainer",multiple:false,visibility:"hidden"},_prevButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}}});
g.prototype.init=function(){this._aItemEnd=[];this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oScrollCntr=new l.ScrollContainer(this.getId()+"-scrl-cntnr",{width:"100%",height:"100%",horizontal:!D.system.desktop});this.setAggregation("_scrollContainer",this._oScrollCntr,true);if(D.system.desktop){this._oArrowPrev=new l.Button({id:this.getId()+"-scrl-prev-button",type:l.ButtonType.Transparent,tooltip:this._oRb.getText("HEADERCONTAINER_BUTTON_PREV_SECTION"),press:function(E){E.cancelBubble();this._scroll(this._getScrollValue(false),this.getScrollTime());}.bind(this)}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrLeft");this._oArrowPrev._bExcludeFromTabChain=true;this.setAggregation("_prevButton",this._oArrowPrev,true);this._oArrowNext=new l.Button({id:this.getId()+"-scrl-next-button",type:l.ButtonType.Transparent,tooltip:this._oRb.getText("HEADERCONTAINER_BUTTON_NEXT_SECTION"),press:function(E){E.cancelBubble();this._scroll(this._getScrollValue(true),this.getScrollTime());}.bind(this)}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrRight");this._oArrowNext._bExcludeFromTabChain=true;this.setAggregation("_nextButton",this._oArrowNext,true);}else if(D.system.phone||D.system.tablet){this._oArrowPrev=new d({id:this.getId()+"-scrl-prev-button"}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrLeft");this.setAggregation("_prevButton",this._oArrowPrev,true);this._oArrowNext=new d({id:this.getId()+"-scrl-next-button"}).addStyleClass("sapMHdrCntrBtn").addStyleClass("sapMHdrCntrRight");this.setAggregation("_nextButton",this._oArrowNext,true);}this._oScrollCntr.addDelegate({onAfterRendering:function(){if(D.system.desktop){var F=this._oScrollCntr.getDomRef("scroll");var o=this._oScrollCntr.$("scroll");var h=o.find(".sapMHrdrCntrInner").attr("tabindex","0");if(!this._oItemNavigation){this._oItemNavigation=new H();this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._handleBorderReached,this);this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleAfterFocus,this);this._oItemNavigation.attachEvent(I.Events.BeforeFocus,this._handleBeforeFocus,this);if(D.browser.msie||D.browser.edge){this._oItemNavigation.attachEvent(I.Events.FocusAgain,this._handleFocusAgain,this);}}this._oItemNavigation.setRootDomRef(F);this._oItemNavigation.setItemDomRefs(h);this._oItemNavigation.setTabIndex0();this._oItemNavigation.setCycling(false);this._handleMobileScrolling();}}.bind(this)});b.addListener(this._checkOverflow,this);};
g.prototype.onBeforeRendering=function(){if(!this.getHeight()){L.warning("No height provided",this);}if(!this.getWidth()){L.warning("No width provided",this);}if(D.system.desktop){this._oArrowPrev.setIcon(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-left":"sap-icon://slim-arrow-up");this._oArrowNext.setIcon(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-right":"sap-icon://slim-arrow-down");}else if(D.system.phone||D.system.tablet){this._oArrowPrev.setSrc(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-left":"sap-icon://slim-arrow-up");this._oArrowNext.setSrc(this.getOrientation()===O.Horizontal?"sap-icon://slim-arrow-right":"sap-icon://slim-arrow-down");}};
g.prototype.onAfterRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._checkOverflow();};
g.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}b.removeListener(this._checkOverflow,this);};
g.prototype.onsaptabnext=function(E){var F=this.$().find(":focusable");var t=F.index(E.target);var n=F.eq(t+1).get(0);var o=this._getParentCell(E.target);var T;if(n){T=this._getParentCell(n);}if((o&&T&&o.id!==T.id)||(n&&n.id===this.getId()+"-after")||(n&&n.id===this.getId()+"-scrl-prev-button")||(n&&n.id===this.getId()+"-scrl-next-button")){var h=F.last().get(0);if(h){this._bIgnoreFocusIn=true;h.focus();}}};
g.prototype.onsaptabprevious=function(E){this.$().find(".sapMHdrCntrItemCntr").css("border-color","");var F=this.$().find(":focusable");var t=F.index(E.target);var p=F.eq(t-1).get(0);var o=this._getParentCell(E.target);var T;if(p){T=this._getParentCell(p);}if(!T||o&&o.id!==T.id){var s=this.$().attr("tabindex");this.$().attr("tabindex","0");this.$().trigger("focus");if(!s){this.$().removeAttr("tabindex");}else{this.$().attr("tabindex",s);}}};
g.prototype.setOrientation=function(v){this.setProperty("orientation",v);if(v===O.Horizontal&&!D.system.desktop){this._oScrollCntr.setHorizontal(true);this._oScrollCntr.setVertical(false);}else if(!D.system.desktop){this._oScrollCntr.setHorizontal(false);this._oScrollCntr.setVertical(true);}return this;};
g.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
g.prototype.getAggregation=function(A,o,s){return this._callMethodInManagedObject("getAggregation",A,o,s);};
g.prototype.setAggregation=function(A,o,s){return this._callMethodInManagedObject("setAggregation",A,o,s);};
g.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
g.prototype.insertAggregation=function(A,o,i,s){return this._callMethodInManagedObject("insertAggregation",A,o,i,s);};
g.prototype.addAggregation=function(A,o,s){return this._callMethodInManagedObject("addAggregation",A,o,s);};
g.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
g.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
g.prototype.destroyAggregation=function(A,s){return this._callMethodInManagedObject("destroyAggregation",A,s);};
g.prototype._setScrollInProcess=function(v){this.bScrollInProcess=v;};
g.prototype._scroll=function(i,h){this._setScrollInProcess(true);setTimeout(this._setScrollInProcess.bind(this,false),h+300);if(this.getOrientation()===O.Horizontal){this._hScroll(i,h);}else{this._vScroll(i,h);}};
g.prototype._vScroll=function(h,i){var o=this._oScrollCntr.getDomRef(),s=o.scrollTop,S=o.scrollHeight,j=s+h,k=o.clientHeight,p=parseFloat(this.$("scroll-area").css("padding-top")),r;if(j<=0){r=this._calculateRemainingScrolling(h,i,s);this.$("scroll-area").css("transition","padding "+r+"s");this.$().removeClass("sapMHrdrTopPadding");}else if(j+k+p>=S){r=this._calculateRemainingScrolling(h,i,S-k-s);this.$("scroll-area").css("transition","padding "+r+"s");if(k+h>S&&k!==S){this.$().removeClass("sapMHrdrBottomPadding");this.$().addClass("sapMHrdrTopPadding");}else{this.$().removeClass("sapMHrdrBottomPadding");}}else{this.$("scroll-area").css("transition","padding "+i/1000+"s");}this._oScrollCntr.scrollTo(0,j,i);};
g.prototype._hScroll=function(h,i){var o=this._oScrollCntr.getDomRef();var s,S,j,k,p,r;if(!this._bRtl){S=o.scrollLeft;k=o.scrollWidth;j=o.clientWidth+(D.browser.msie?1:0);s=S+h;p=parseFloat(this.$("scroll-area").css("padding-left"));if(s<=0){r=this._calculateRemainingScrolling(h,i,S);this.$("scroll-area").css("transition","padding "+r+"s");this.$().removeClass("sapMHrdrLeftPadding");}else if(s+o.clientWidth+p>=k){r=this._calculateRemainingScrolling(h,i,k-j-S);this.$("scroll-area").css("transition","padding "+r+"s");if(j+h>k&&j!==k){this.$().removeClass("sapMHrdrRightPadding");this.$().addClass("sapMHrdrLeftPadding");}else{this.$().removeClass("sapMHrdrRightPadding");}}else{this.$("scroll-area").css("transition","padding "+i/1000+"s");}this._oScrollCntr.scrollTo(s,0,i);}else{s=q(o).scrollRightRTL()+h;this._oScrollCntr.scrollTo((s>0)?s:0,0,i);}};
g.prototype._collectItemSize=function(){var s=0,h=this._filterVisibleItems(),F=this.getOrientation()===O.Horizontal?"outerWidth":"outerHeight";this._aItemEnd=[];h.forEach(function(o,i){s+=o.$().parent()[F](true);this._aItemEnd[i]=s;},this);};
g.prototype._getScrollValue=function(F){if(!this._oScrollCntr){return 0;}var h=this.getOrientation()===O.Horizontal,$=this._oScrollCntr.$(),j=this.$("prev-button-container"),m=this.$("next-button-container"),s=h?$[0].scrollLeft:$[0].scrollTop,t=0,S=0,n,o=this._filterVisibleItems();var G=function(k){var S=0,B=0;var r=10;if(this._bRtl&&h){if(!j.is(":visible")){B=j.width();}if(!m.is(":visible")){B=m.width();}}for(var i=0;i<o.length&&i<k;i++){S+=p(o[i]);}return S!==0?S+r-B:0;}.bind(this);var p=function(k){return h?k.$().parent().outerWidth(true):k.$().parent().outerHeight(true);};var E=function(){var S=this._getSize(true),r,A=0;for(var i=t;i<o.length;i++){if(!o[i].$().is(":visible")){r=p(o[i])+G(i)-S-s;for(var k=t;k<o.length&&k<i;k++){if(n+A>r){break;}t++;A+=p(o[k]);}n+=A;break;}}}.bind(this);if(this.getScrollStepByItem()>0){s=h&&this._bRtl?$.scrollRightRTL():s;for(var i=0;i<o.length;i++){S+=p(o[i]);if(S>=s){t=i;break;}}t=(F?1:-1)*this.getScrollStepByItem()+t;if(t<0){t=0;}if(t>=o.length){t=o.length-1;}n=G(t)-s;if(F&&!this.getShowOverflowItem()){E();}return n;}return F?this.getScrollStep():-this.getScrollStep();};
g.prototype._calculateRemainingScrolling=function(h,i,j){return Math.abs(j*i/(1000*h));};
g.prototype._checkOverflow=function(){if(this.getOrientation()===O.Horizontal){this._checkHOverflow();}else{this._checkVOverflow();}};
g.prototype._filterVisibleItems=function(){return this.getContent().filter(function(i){return i.getVisible();});};
g.prototype._getFirstItemOffset=function(t){var F=this._filterVisibleItems()[0],$=F&&F.$(),h=$&&$.parent(),i=h&&h[0]&&h[0][t];return i||0;};
g.prototype._checkVOverflow=function(){var B=this._oScrollCntr.getDomRef(),o,$;if(B){var F=this._getFirstItemOffset("offsetTop");var s=Math.ceil(B.scrollTop);var S=false;var h=false;var r=B.scrollHeight;var i=B.offsetHeight;if(Math.abs(r-i)===1){r=i;}if(s>F){S=true;}if((r>i)&&(s+i<r)){h=true;}h=this._checkForOverflowItem(h);$=this.$("prev-button-container");o=$.is(":visible");if(o&&!S){$.hide();this.$().removeClass("sapMHrdrTopPadding");}if(!o&&S){$.show();this.$().addClass("sapMHrdrTopPadding");}$=this.$("next-button-container");var j=$.is(":visible");if(j&&!h){$.hide();this.$().removeClass("sapMHrdrBottomPadding");}if(!j&&h){$.show();this.$().addClass("sapMHrdrBottomPadding");}}};
g.prototype._handleMobileScrolling=function(){if(C.isMobile()){var $=this.$("scrl-cntnr-scroll"),i=this.getOrientation()===O.Horizontal,p=i?"clientX":"clientY",h=0,t=this,s=false;$.on("touchstart",function(E){s=true;h=E.targetTouches[0][p];});$.on("touchmove",function(E){if(s){var j=E.targetTouches[0][p],k=h-j,S=t._oScrollCntr.getDomRef();i?S.scrollLeft+=k:S.scrollTop+=k;h=j;E.preventDefault();}});$.on("touchend",function(){s=false;});}};
g.prototype._checkHOverflow=function(){var B=this._oScrollCntr.getDomRef(),$;if(B){var F=this._getFirstItemOffset("offsetLeft");var s=Math.ceil(B.scrollLeft);var S=false;var h=false;var r=B.scrollWidth;var i=B.offsetWidth;if(Math.abs(r-i)===1){r=i;}if(this._bRtl){var j=q(B).scrollLeftRTL();if(j>((D.browser.msie||D.browser.edge)?1:0)){h=true;}}else if(s>F){S=true;}if(r-5>i){if(this._bRtl){if(q(B).scrollRightRTL()>1){S=true;}}else if(s+i<r){h=true;}}$=this.$("prev-button-container");h=this._checkForOverflowItem(h);var o=$.is(":visible");if(o&&!S){$.hide();this.$().removeClass("sapMHrdrLeftPadding");}if(!o&&S){$.show();this.$().addClass("sapMHrdrLeftPadding");}$=this.$("next-button-container");var k=$.is(":visible");if(k&&!h){$.hide();this.$().removeClass("sapMHrdrRightPadding");}if(!k&&h){$.show();this.$().addClass("sapMHrdrRightPadding");}}};
g.prototype._getSize=function(A){var $=this._oScrollCntr.$(),h=this.getOrientation()===O.Horizontal,i=this.$("next-button-container"),j=!i.is(":visible")&&A,F=h?"width":"height";return $[F]()-(j?i[F]():0);};
g.prototype._checkForOverflowItem=function(s){if(this._oScrollCntr&&!this.getShowOverflowItem()){var $=this._oScrollCntr.$(),h=this.getOrientation()===O.Horizontal,S=!h?$[0].scrollTop:(this._bRtl?$.scrollRightRTL():$[0].scrollLeft),F=h?"width":"height",j=this._getSize(s),k=this._filterVisibleItems();this._collectItemSize();this._aItemEnd.forEach(function(E,i){var m=k[i].$(),n=m.parent(),v=m.is(":visible");if(s&&E>S+j){if(i===0||this._aItemEnd[i-1]<=S){n.css(F,"auto");m.show();}else if(v){n[F](n[F]());m.hide();s=true;}}else{if(!v){n.css(F,"auto");m.show();}}},this);}return s;};
g.prototype._handleBorderReached=function(E){if(D.browser.msie&&this.bScrollInProcess){return;}var i=E.getParameter("index");if(i===0){this._scroll(this._getScrollValue(false),this.getScrollTime());}else if(i===this._filterVisibleItems().length-1){this._scroll(this._getScrollValue(true),this.getScrollTime());}};
g.prototype._handleAfterFocus=function(E){var s=E.getParameter("event");if((D.browser.msie||D.browser.edge)&&s.type==="mousedown"&&s.srcControl instanceof sap.m.Input){s.srcControl.focus();}if(D.browser.msie&&this.bScrollInProcess){return;}var i=E.getParameter("index");if(i===0){this._scroll(this._getScrollValue(false),this.getScrollTime());}else if(i===this._filterVisibleItems().length-1){this._scroll(this._getScrollValue(true),this.getScrollTime());}};
g.prototype._handleFocusAgain=function(E){var s=E.getParameter("event");if((D.browser.msie||D.browser.edge)&&s.type==="mousedown"&&s.srcControl instanceof sap.m.Input){s.srcControl.focus();}E.getParameter("event").preventDefault();};
g.prototype._handleBeforeFocus=function(E){var o=E.getParameter("event");if(q(o.target).hasClass("sapMHdrCntrItemCntr")||q(o.target).hasClass("sapMScrollContScroll")||P.events.sapprevious.fnCheck(o)||P.events.sapnext.fnCheck(o)){this.$().find(".sapMHdrCntrItemCntr").css("border-color","");}else{this.$().find(".sapMHdrCntrItemCntr").css("border-color","transparent");}};
g.prototype._unWrapHeaderContainerItemContainer=function(w){if(w instanceof f){w=w.getItem();}else if(Array.isArray(w)){for(var i=0;i<w.length;i++){if(w[i]instanceof f){w[i]=w[i].getItem();}}}return w;};
g._AGGREGATION_FUNCTIONS=["validateAggregation","validateAggregation","getAggregation","setAggregation","indexOfAggregation","removeAggregation"];g._AGGREGATION_FUNCTIONS_FOR_INSERT=["insertAggregation","addAggregation"];
g.prototype._callMethodInManagedObject=function(F,A){var h=Array.prototype.slice.call(arguments);if(A==="content"){var o=h[2];h[1]="content";if(o instanceof a){if(((g._AGGREGATION_FUNCTIONS?Array.prototype.indexOf.call(g._AGGREGATION_FUNCTIONS,F):-1))>-1&&o.getParent()instanceof f){h[2]=o.getParent();}else if(((g._AGGREGATION_FUNCTIONS_FOR_INSERT?Array.prototype.indexOf.call(g._AGGREGATION_FUNCTIONS_FOR_INSERT,F):-1))>-1){h[2]=new f({item:o});}}var r=this._oScrollCntr[F].apply(this._oScrollCntr,h.slice(1));if(F!=="removeAllAggregation"){var j=this._oScrollCntr.getContent();var k=this.getAriaLabelledBy();for(var i=0;i<j.length;i++){var m=j[i];m.setPosition(i+1);m.setSetSize(j.length);m.setAriaLabelledBy(k[i]);}}return this._unWrapHeaderContainerItemContainer(r);}else{return M.prototype[F].apply(this,h.slice(1));}};
g.prototype._getParentCell=function(o){return q(o).parents(".sapMHrdrCntrInner").andSelf(".sapMHrdrCntrInner").get(0);};
g.prototype.onfocusin=function(E){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;return;}if(E.target.id===this.getId()+"-after"){this._restoreLastFocused();}};
g.prototype._restoreLastFocused=function(){if(!this._oItemNavigation){return;}var n=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(n[i]);var r=$.control(0)||{};var t=r.getTabbables?r.getTabbables():$.find(":sapTabbable");t.eq(-1).add($).eq(-1).trigger("focus");};
return g;});
sap.ui.predefine('sap/m/HeaderContainerItemNavigator',["sap/ui/core/delegate/ItemNavigation","sap/base/assert","sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes"],function(I,a,c,K){"use strict";
var H=I.extend("sap.m.HeaderContainerItemNavigator");
H.prototype.focusItem=function(i,e){if(e.type==="mousedown"){var f=this.aItemDomRefs[i].focus;this.aItemDomRefs[i].focus=function(){};this._callParent("focusItem",arguments);this.aItemDomRefs[i].focus=f;return;}this._callParent("focusItem",arguments);};
H.prototype._callParent=function(f,A){if(typeof I.prototype[f]==="function"){I.prototype[f].apply(this,A);}};
H.prototype.onsaphome=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsaphome",arguments);};
H.prototype.onsapend=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsapend",arguments);};
H.prototype.onsapnext=function(e){if(this._skipNavigation(e)){return;}this._callParent("onsapnext",arguments);};
H.prototype.onsapprevious=function(e){if(this._skipNavigation(e,true,false)){return;}this._callParent("onsapprevious",arguments);};
H.prototype._skipNavigation=function(e){return Array.prototype.indexOf.call(this.aItemDomRefs,e.target)===-1;};
return H;});
sap.ui.predefine('sap/m/HeaderContainerRenderer',['sap/ui/core/library',"sap/base/security/encodeCSS"],function(c,e){"use strict";var O=c.Orientation;var H={};
H.render=function(r,C){var t=C.getTooltip_AsString();var o=C.getOrientation();if(o){o=e(o);}var b=e("sapMHdrCntrBG"+C.getBackgroundDesign());r.write("<div");r.writeControlData(C);if(t&&(typeof t==="string")){r.writeAttributeEscaped("title",t);}r.addClass("sapMHdrCntr");r.addClass(o);if(C.getShowDividers()){r.addClass("sapMHrdrCntrDvdrs");}r.writeClasses();if(C.getHeight()){r.addStyle("height",C.getHeight());}else{r.addStyle("height",(C.getOrientation()===O.Horizontal)?"auto":"100%");}if(C.getWidth()){r.addStyle("width",C.getWidth());}else{r.addStyle("width",(C.getOrientation()===O.Horizontal)?"100%":"auto");}r.writeStyles();var d="";var a=C.getContent();for(var i=0;a&&i<a.length;i++){d+=a[i].getId()+" ";}r.writeAttribute("role","list");r.write(">");r.write("<div");r.writeAttributeEscaped("id",C.getId()+"-scroll-area");r.addClass("sapMHdrCntrCntr");r.addClass(o);r.addClass(b);r.writeClasses();r.write(">");r.renderControl(C.getAggregation("_scrollContainer"));r.write("</div>");var B=C.getAggregation("_prevButton");if(B){r.write("<div");r.writeAttributeEscaped("id",C.getId()+"-prev-button-container");r.addClass("sapMHdrCntrBtnCntr");r.addClass("sapMHdrCntrLeft");r.addClass(o);r.writeClasses();r.write(">");r.renderControl(B);r.write("</div>");}B=C.getAggregation("_nextButton");if(B){r.write("<div");r.writeAttributeEscaped("id",C.getId()+"-next-button-container");r.addClass("sapMHdrCntrBtnCntr");r.addClass("sapMHdrCntrRight");r.addClass(o);r.writeClasses();r.write(">");r.renderControl(B);r.write("</div>");}r.write("<div");r.writeAttribute("id",C.getId()+"-after");r.writeAttribute("tabindex","0");r.write("></div>");r.write("</div>");};
return H;},true);
sap.ui.predefine('sap/m/HyphenationSupport',["sap/ui/core/Core","./library","sap/ui/core/hyphenation/Hyphenation","sap/base/Log"],function(C,l,H,L){"use strict";var W=l.WrappingType;
function i(o){if(!o.isA("sap.m.IHyphenation")){L.error("[UI5 Hyphenation] The given control does not implement interface sap.m.IHyphenation and can not use HyphenationSupport mixin.");return false;}return true;}
function a(o,k){var t=o.getTextsToBeHyphenated();if(typeof t!=="object"){L.error("[UI5 Hyphenation] The result of getTextsToBeHyphenated method is not a map object.",o.getId());return false;}if(Object.keys(t).indexOf(k)<0){L.error("[UI5 Hyphenation] The key "+k+" is not found in the result of getTextsToBeHyphenated method.",o.getId());return false;}return true;}
function s(D,n){n=n||"";var f=D.childNodes;if(f.length===1&&f[0].nodeType===window.Node.TEXT_NODE){f[0].nodeValue=n;}else{D.textContent=n;}}
function d(t,T){var D=[];Object.keys(t).forEach(function(k){if(!(k in T&&t[k]===T[k])){D.push(k);}});return D;}
function b(){var f=C.getConfiguration().getHyphenation(),o=H.getInstance();if(f==="native"||f==="disable"){return false;}if(f==="thirdparty"){return true;}return o.isLanguageSupported()&&!o.canUseNativeHyphenation()&&o.canUseThirdPartyHyphenation();}
function c(o){var f=C.getConfiguration().getHyphenation();if(f==='disable'){return false;}if(o.getWrappingType()===W.Hyphenated&&!o.getWrapping()){L.warning("[UI5 Hyphenation] The property wrappingType=Hyphenated will not take effect unless wrapping=true.",o.getId());}return o.getWrapping()&&o.getWrappingType()===W.Hyphenated;}
function h(o){if(!c(o)||!b()){o._mHyphenatedTexts={};o._mUnhyphenatedTexts={};return;}var t=o.getTextsToBeHyphenated(),f=d(t,o._mUnhyphenatedTexts);if(f.length>0){o._mUnhyphenatedTexts=t;f.forEach(function(k){delete o._mHyphenatedTexts[k];});var g=H.getInstance();if(!g.isLanguageInitialized()){g.initialize().then(function(){var D=o.isActive()?o.getDomRefsForHyphenatedTexts():null,n=false;f.forEach(function(k){o._mHyphenatedTexts[k]=g.hyphenate(t[k]);if(D&&k in D){s(D[k],o._mHyphenatedTexts[k]);}else{n=true;}});if(n){o.invalidate();}});}else{f.forEach(function(k){o._mHyphenatedTexts[k]=g.hyphenate(t[k]);});}}}
var e={};
e.mixInto=function(o){if(!i(o)){return;}var I=o.init;o.init=function(f){var r=I.apply(this,arguments);this._mHyphenatedTexts={};this._mUnhyphenatedTexts={};return r;};var O=o.onBeforeRendering;o.onBeforeRendering=function(){var r=O.apply(this,arguments);h(this);return r;};};
e.writeHyphenationClass=function(r,o){if(!i(o)){return;}if(c(o)&&!b()){r.class("sapUiHyphenation");}};
e.getTextForRender=function(o,k){if(!i(o)){return null;}if(!a(o,k)){return null;}var t=o.getTextsToBeHyphenated();if(c(o)&&b()){if(t[k]!==o._mUnhyphenatedTexts[k]){h(o);}if(k in o._mHyphenatedTexts){return o._mHyphenatedTexts[k];}}return t[k];};
return e;});
sap.ui.predefine('sap/m/IconTabBar',['./library',"sap/ui/core/Core",'sap/ui/core/Control','./IconTabBarRenderer','./IconTabHeader',"sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/thirdparty/jquery"],function(l,C,a,I,b,R,q){"use strict";var c=l.IconTabHeaderMode;var B=l.BackgroundDesign;var d=l.IconTabDensityMode;
var e=a.extend("sap.m.IconTabBar",{metadata:{interfaces:["sap.m.ObjectHeaderContainer","sap.f.IDynamicPageStickyContent"],library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},expandable:{type:"boolean",group:"Misc",defaultValue:true},expanded:{type:"boolean",group:"Misc",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:null},upperCase:{type:"boolean",group:"Appearance",defaultValue:false},stretchContentHeight:{type:"boolean",group:"Appearance",defaultValue:false},applyContentPadding:{type:"boolean",group:"Appearance",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid},headerMode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:c.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},headerBackgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid},enableTabReordering:{type:"boolean",group:"Behavior",defaultValue:false},maxNestingLevel:{type:"int",group:"Behavior",defaultValue:0},tabDensityMode:{type:"sap.m.IconTabDensityMode",group:"Appearance",defaultValue:d.Cozy},ariaTexts:{type:"object",group:"Accessibility",defaultValue:null}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",forwarding:{getter:"_getIconTabHeader",aggregation:"items",forwardBinding:true}},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_header:{type:"sap.m.IconTabHeader",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"},selectedItem:{type:"sap.m.IconTabFilter"},selectedKey:{type:"string"}}},expand:{parameters:{expand:{type:"boolean"},collapse:{type:"boolean"}}}},designtime:"sap/m/designtime/IconTabBar.designtime"}});
R.call(e.prototype,{header:{selector:".sapMITH"},content:{suffix:"content"}});
e.prototype.init=function(){this._initResponsivePaddingsEnablement();};
e.prototype.setExpanded=function(E){this.setProperty("expanded",E,true);if(this.$().length){this._toggleExpandCollapse(E);}return this;};
e.prototype.setHeaderMode=function(m){this.setProperty("headerMode",m,true);this._getIconTabHeader().setMode(m);return this;};
e.prototype.setTabDensityMode=function(m){this.setProperty("tabDensityMode",m);this._getIconTabHeader().setTabDensityMode(m);return this;};
e.prototype.setHeaderBackgroundDesign=function(h){this.setProperty("headerBackgroundDesign",h,true);this._getIconTabHeader().setBackgroundDesign(h);return this;};
e.prototype.setEnableTabReordering=function(v){this.setProperty("enableTabReordering",v,true);this._getIconTabHeader().setEnableTabReordering(v);return this;};
e.prototype.setAriaTexts=function(A){this.setProperty("ariaTexts",A,true);this._getIconTabHeader().setAriaTexts(A);return this;};
e.prototype._rerenderContent=function(o){var $=this.$("content");if(o&&($.length>0)){var r=C.createRenderManager();for(var i=0;i<o.length;i++){r.renderControl(o[i]);}r.flush($[0]);r.destroy();}};
e.prototype._toggleExpandCollapse=function(E){var $=this.$("content");var s=this._getIconTabHeader().oSelectedItem;if(E===undefined){E=!this.getExpanded();}if(s){s.$().toggleClass("sapMITBSelected",E);s.$().attr({'aria-expanded':E});if(E){s.$().attr({'aria-selected':E});}else{s.$().removeAttr('aria-selected');}}this._iAnimationCounter=(this._iAnimationCounter===undefined?1:++this._iAnimationCounter);if(E){if(s){if(this.$("content").children().length===0){var S=s.getContent();if(S.length>0){this._rerenderContent(S);}else{this._rerenderContent(this.getContent());}}$.stop(true,true).slideDown('400',q.proxy(this.onTransitionEnded,this,E));this.$("containerContent").toggleClass("sapMITBContentClosed",!E);}}else{this.$("contentArrow").hide();$.stop(true,true).slideUp('400',q.proxy(this.onTransitionEnded,this,E));}if(!E||s){this.setProperty("expanded",E,true);}this.fireExpand({expand:E,collapse:!E});return this;};
e.prototype.onTransitionEnded=function(E){var $=this.$("content"),f=this.$("containerContent"),g=this.$("contentArrow");if(this._iAnimationCounter===1){f.toggleClass("sapMITBContentClosed",!E);if(E){g.show();$.css("display","block");}else{g.hide();$.css("display","none");}}this._iAnimationCounter=(this._iAnimationCounter>0?--this._iAnimationCounter:0);return this;};
e.prototype._getIconTabHeader=function(){var o=this.getAggregation("_header");if(!o){o=new b(this.getId()+"--header",{});this.setAggregation("_header",o,true);}return o;};
e.prototype._getStickyContent=function(){var i=this._getIconTabHeader();e._CLASSES_TO_COPY.forEach(function(s){if(this.hasStyleClass(s)){i.addStyleClass(s);}}.bind(this));return i;};
e.prototype._returnStickyContent=function(){if(this.bIsDestroyed){return;}this._getStickyContent().$().prependTo(this.$());};
e.prototype._setStickySubheaderSticked=function(i){this._bStickyContentSticked=i;};
e.prototype._getStickySubheaderSticked=function(){return this._bStickyContentSticked;};
e.prototype.onBeforeRendering=function(){var i=this._getIconTabHeader(),$=i.$();i.setMaxNestingLevel(this.getMaxNestingLevel());if(this._bStickyContentSticked&&$){delete this._bStickyContentSticked;this._getIconTabHeader().$().remove();}};
e.prototype.setShowSelection=function(v){this._getIconTabHeader().setShowSelection(v);return this;};
e.prototype.getShowSelection=function(){return this._getIconTabHeader().getShowSelection();};
e.prototype.setSelectedKey=function(v){this._getIconTabHeader().setSelectedKey(v);return this;};
e.prototype.getSelectedKey=function(){return this._getIconTabHeader().getSelectedKey();};
e.prototype.setSelectedItem=function(i,A){return this._getIconTabHeader().setSelectedItem(i,A);};
e._CLASSES_TO_COPY=["sapUiResponsiveContentPadding","sapUiNoContentPadding","sapUiContentPadding"];return e;});
sap.ui.predefine('sap/m/IconTabBarDragAndDropUtil',['sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo',"sap/ui/events/KeyCodes",'sap/ui/core/dnd/DropPosition'],function(D,a,K,b){"use strict";var I="Before",c="insertBefore",d="insertAfter",i,e="IconTabReorder",f="Forward",g="Backward";var h={_insertControl:function(i,o,j,k){var $=o.$(),l=j.$(),m=[],n=[];if(o._getNestedLevel()>1&&j._getNestedLevel()>1){m=o._getRootTab()._getSelectList().getItems().filter(function(p){return o._getRealTab()._isParentOf(p._getRealTab());});n=j._getRootTab()._getSelectList().getItems().filter(function(p){return j._getRealTab()._isParentOf(p._getRealTab());});}if(k){var O=o._getRootTab().getParent()._getOverflow()._getSelectList().getItems();m=O.filter(function(p){return o._getRealTab()._isParentOf(p._getRealTab());});n=O.filter(function(p){return j._getRealTab()._isParentOf(p._getRealTab());});}if(i===d){$.insertAfter(l);}else{$.insertBefore(l);}m.reverse().forEach(function(C){C.$().insertAfter($);});n.reverse().forEach(function(C){C.$().insertAfter(l);});},handleDrop:function(C,s,o,j,k,l){var B=C.indexOfItem(o),m=C.indexOfItem(j),A=0,r=sap.ui.getCore().getConfiguration().getRTL(),n=s===I,p=j._getNestedLevel()-1;if(o._isParentOf(j)){return;}if(p===l&&s===b.On){return;}if(r&&!k){if(n){A=B<m?m:m+1;i=d;}else{A=B<m?m-1:m;i=c;}}else{if(n){A=B<m?m-1:m;i=c;}else{A=B<m?m:m+1;i=d;}}if(C.isA("sap.m.IconTabFilter")||!o.getParent().isA("sap.m.IconTabHeader")){if(n){A=m;}else{A=m+1;}}h._insertControl(i,o,j);if(s===b.On){if(j===o){return;}A=C.getAggregation("items").length;}h._handleConfigurationAfterDragAndDrop.call(C,o,A);},_updateAccessibilityInfo:function(){var o=this.getItems(),A=1,j;o.forEach(function(k){j=k.getDomRef();if(j&&j.getAttribute("aria-posinset")!==null){j.setAttribute("aria-posinset",A++);}});},_handleConfigurationAfterDragAndDrop:function(o,j){var k=[];if(this.isA("sap.m.IconTabBarSelectList")){k=this.getItems().filter(function(l){return o._getRealTab()._isParentOf(l._getRealTab());});}this.removeAggregation('items',o,true);this.insertAggregation('items',o,j,true);k.forEach(function(l){this.removeAggregation('items',l,true);}.bind(this));var n=1+this.indexOfAggregation('items',o);k.reverse().forEach(function(l){this.insertAggregation('items',l,n,true);}.bind(this));h._updateAccessibilityInfo.call(this);},_decreaseDropIndex:function(B,j){var p=B-1;while(p>=0&&(j[B]._getRealTab()._getNestedLevel()!==j[p]._getRealTab()._getNestedLevel()||!j[p].getVisible()||(!j[B].$().hasClass("sapMITBFilterHidden")&&j[p].$().hasClass("sapMITBFilterHidden")))){p--;}if(p<0){i=d;return B;}i=c;return p;},_increaseDropIndex:function(B,j,m){var n=B+1;while(n<j.length&&(j[B]._getRealTab()._getNestedLevel()!==j[n]._getRealTab()._getNestedLevel()||!j[n].getVisible())){n++;}if(n>m){i=c;return B;}i=d;return n;},moveItem:function(o,k,m){var j=this.getItems(),B=this.indexOfItem(o),r=sap.ui.getCore().getConfiguration().getRTL(),n,p;if(this.isA("sap.m.IconTabFilter")){j=this._getRealTab().getItems();}switch(k){case K.HOME:n=0;i=c;break;case K.END:n=j.length-1;i=d;break;case K.ARROW_LEFT:if(r){p=h.preventDragBetweenSubItems(o,f,this);n=h._increaseDropIndex(B,j,m);}else{p=h.preventDragBetweenSubItems(o,g,this);n=h._decreaseDropIndex(B,j);}break;case K.ARROW_RIGHT:if(r){p=h.preventDragBetweenSubItems(o,g,this);n=h._decreaseDropIndex(B,j);}else{p=h.preventDragBetweenSubItems(o,f,this);n=h._increaseDropIndex(B,j,m);}break;case K.ARROW_DOWN:p=h.preventDragBetweenSubItems(o,f,this);n=h._increaseDropIndex(B,j,m);break;case K.ARROW_UP:p=h.preventDragBetweenSubItems(o,g,this);n=h._decreaseDropIndex(B,j);break;default:return false;}if(p){return false;}if(!this.isA("sap.m.IconTabFilter")){var l=j[n];h._insertControl(i,o,l,this._oTabFilter&&this._oTabFilter._bIsOverflow);}h._handleConfigurationAfterDragAndDrop.call(this,o,n);return true;},setDragDropAggregations:function(j,s,o){var k=j._oIconTabHeader?j._oIconTabHeader:j;var l=k.getId();j.addDragDropConfig(new D({sourceAggregation:"items",groupName:e+l}));j.addDragDropConfig(new a({targetAggregation:"items",dropPosition:o,dropLayout:s,drop:j._handleDragAndDrop.bind(j),groupName:e+l}));},preventDragBetweenSubItems:function(o,s,C){var p=false;if(C.isA("sap.m.IconTabBarSelectList")){var r=o._getRealTab(),P=r.getParent(),j=P.getItems();if((j.indexOf(r)===0&&s===g)||(j.indexOf(r)+1===j.length&&s===f)||j.length===1){p=true;}}return p;}};return h;});
sap.ui.predefine('sap/m/IconTabBarRenderer',[],function(){"use strict";var I={apiVersion:2};I._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault'];
I.render=function(r,i){var c=i.getContent(),h=i._getIconTabHeader();r.openStart("div",i).class("sapMITB");if(i.getStretchContentHeight()){r.class("sapMITBStretch");}if(!i.getApplyContentPadding()){r.class("sapMITBNoContentPadding");}r.class("sapMITBBackgroundDesign"+i.getBackgroundDesign()).openEnd();if(!i._bHideHeader){r.renderControl(h);}r.openStart("div",i.getId()+"-containerContent").class("sapMITBContainerContent");if(!i.getExpanded()){r.class("sapMITBContentClosed");}r.openEnd();r.openStart("div",i.getId()+"-content").class("sapMITBContent").attr("role","tabpanel");if(!i.getExpanded()){r.style("display","none");}if(h.oSelectedItem){r.accessibilityState({labelledby:h.oSelectedItem.getId()});}r.openEnd();if(i.getExpanded()){if(h.oSelectedItem&&h.oSelectedItem.getContent()){var C=h.oSelectedItem.getContent();if(C.length>0){c=C;}}c.forEach(function(o){r.renderControl(o);});}r.close("div").close("div").close("div");};
return I;},true);
sap.ui.predefine('sap/m/IconTabBarSelectList',['./library','sap/ui/core/Control',"sap/ui/core/Core",'sap/ui/core/delegate/ItemNavigation','./IconTabBarDragAndDropUtil','sap/ui/core/dnd/DropPosition','./IconTabBarSelectListRenderer',"sap/ui/thirdparty/jquery"],function(l,C,a,I,b,D,c,q){"use strict";
var d=C.extend("sap.m.IconTabBarSelectList",{metadata:{library:"sap.m",aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",dnd:true}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.m.IconTabFilter"}}}}}});
d.prototype.init=function(){this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this.addEventDelegate(this._oItemNavigation);this._oItemNavigation.setPageSize(10);this._oIconTabHeader=null;this._oTabFilter=null;};
d.prototype.exit=function(){this._oItemNavigation.destroy();this._oItemNavigation=null;this._oIconTabHeader=null;this._oTabFilter=null;};
d.prototype.onBeforeRendering=function(){if(!this._oIconTabHeader){return;}this.destroyDragDropConfig();this._setsDragAndConfiguration();};
d.prototype.onAfterRendering=function(){this._initItemNavigation();this.getItems().forEach(function(i){if(i._onAfterParentRendering){i._onAfterParentRendering();}});};
d.prototype._setsDragAndConfiguration=function(){if(this._oIconTabHeader.getEnableTabReordering()&&!this.getDragDropConfig().length){b.setDragDropAggregations(this,"Vertical",this._oIconTabHeader._getDropPosition());}};
d.prototype._initItemNavigation=function(){var e=this.getItems(),f=[],p=this._oIconTabHeader.oSelectedItem,s=-1,o,i;for(i=0;i<e.length;i++){o=e[i];if(o.isA("sap.m.IconTabFilter")){var g=o._getAllSubFiltersDomRefs();f=f.concat(o.getDomRef(),g);}if(p&&this.getSelectedItem()&&this.getSelectedItem()._getRealTab()===p){s=i;}}if(p&&f.indexOf(p.getDomRef())!==-1){s=f.indexOf(p.getDomRef());}this._oItemNavigation.setRootDomRef(this.getDomRef()).setItemDomRefs(f).setSelectedIndex(s);};
d.prototype.getVisibleItems=function(){return this.getItems().filter(function(i){return i.getVisible();});};
d.prototype.getVisibleTabFilters=function(){return this.getVisibleItems().filter(function(i){return i.isA("sap.m.IconTabFilter");});};
d.prototype.setSelectedItem=function(i){this._selectedItem=i;};
d.prototype.getSelectedItem=function(){return this._selectedItem;};
d.prototype.ontap=function(e){var t=e.srcControl;if(!t){return;}if(!t.isA("sap.m.IconTabFilter")){return;}if(this._oIconTabHeader._isUnselectable(t)){return;}e.preventDefault();if(t!=this.getSelectedItem()){this.fireSelectionChange({selectedItem:t});}};
d.prototype.onsapenter=d.prototype.ontap;d.prototype.onsapspace=d.prototype.ontap;
d.prototype.checkIconOnly=function(){this._bIconOnly=this.getVisibleTabFilters().every(function(i){return!i.getText()&&!i.getCount();});return this._bIconOnly;};
d.prototype._handleDragAndDrop=function(e){var s=e.getParameter("dropPosition"),o=e.getParameter("draggedControl"),f=e.getParameter("droppedControl"),g=f._getRealTab().getParent(),h=this._oIconTabHeader.getMaxNestingLevel();if(this._oTabFilter._bIsOverflow){g=this._oIconTabHeader;}if(s===D.On){g=f._getRealTab();}b.handleDrop(g,s,o._getRealTab(),f._getRealTab(),true,h);this._oIconTabHeader._setItemsForStrip();this._oIconTabHeader._initItemNavigation();this._oTabFilter._setSelectListItems();this._initItemNavigation();f._getRealTab().getParent().$().trigger("focus");};
d.prototype.ondragrearranging=function(e){if(!this._oIconTabHeader.getEnableTabReordering()){return;}var t=e.srcControl,k=e.keyCode,i=this.indexOfItem(t),o=this;b.moveItem.call(o,t,k,o.getItems().length-1);this._initItemNavigation();t.$().trigger("focus");if(i===this.indexOfItem(t)){return;}o=t._getRealTab().getParent();if(this._oTabFilter._bIsOverflow&&t._getRealTab()._getNestedLevel()===1){this._oIconTabHeader._moveTab(t._getRealTab(),k,this._oIconTabHeader.getItems().length-1);}else{b.moveItem.call(o,t._getRealTab(),k,o.getItems().length-1);}};
d.prototype.onsaphomemodifiers=d.prototype.ondragrearranging;d.prototype.onsapendmodifiers=d.prototype.ondragrearranging;d.prototype.onsapincreasemodifiers=d.prototype.ondragrearranging;d.prototype.onsapdecreasemodifiers=d.prototype.ondragrearranging;return d;});
sap.ui.predefine('sap/m/IconTabBarSelectListRenderer',["sap/ui/core/theming/Parameters","sap/ui/core/library"],function(P,c){"use strict";var I=c.IconColor;var a={apiVersion:2};a.fNestedItemPaddingLeft=Number.parseFloat(P.get("_sap_m_IconTabBar_SelectListItem_PaddingLeft"));
a.render=function(r,s){var i=s.getVisibleItems(),o=s._oIconTabHeader,t=o._checkTextOnly(),T=o.getVisibleTabFilters().length,n=this.fNestedItemPaddingLeft,e=false;var h=i.filter(function(b){return b.isA("sap.m.IconTabFilter");}).some(function(b){return b.getIconColor()!==I.Default;});s.checkIconOnly();var A=Number.parseFloat(P.get("_sap_m_IconTabBar_SelectListItem_PaddingLeftAdditional"));if(h&&A){n+=A;e=true;}this.renderList(r,i,s,o,t,n,e,T);};
a.renderList=function(r,b,s,o,t,p,e,S){if(!b.length){return;}r.openStart("ul",s).attr("role","menu").class("sapMITBSelectList");if(t){r.class("sapMITBSelectListTextOnly");}r.openEnd();for(var i=0;i<b.length;i++){var d=b[i],f;if(o&&d.isA("sap.m.IconTabFilter")){f=o.getVisibleTabFilters().indexOf(d._getRealTab());}if(d.isA("sap.m.IconTabFilter")&&d._getRootTab()._getSelectList()===s){f=i;S=b.length;}var l=d._getNestedLevel()-2;if(e){l++;}if(s._bIsOverflow){l++;}d.renderInSelectList(r,s,f,S,p*l);}r.close("ul");};
return a;},true);
sap.ui.predefine('sap/m/IconTabFilter',["./library","sap/ui/core/library","sap/ui/core/Core","sap/ui/core/Item","sap/ui/core/Renderer","sap/ui/core/IconPool","sap/ui/core/InvisibleText","sap/ui/core/Control",'sap/ui/Device',"./AccButton","sap/m/BadgeCustomData","sap/m/Button","sap/m/ResponsivePopover","sap/m/IconTabBarSelectList","sap/m/BadgeEnabler"],function(l,c,C,I,R,a,b,d,D,A,B,e,f,g,h){"use strict";var T=c.TextAlign;var j=c.TextDirection;var k=l.ButtonType;var P=l.PlacementType;var m=l.ImageHelper;var n=l.IconTabFilterDesign;var o=l.BadgeStyle;var p=c.IconColor;var q=3000;
var r=I.extend("sap.m.IconTabFilter",{metadata:{interfaces:["sap.m.IconTab","sap.ui.core.PopupInterface","sap.m.IBadge"],library:"sap.m",designtime:"sap/m/designtime/IconTabFilter.designtime",properties:{count:{type:"string",group:"Data",defaultValue:''},showAll:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},iconColor:{type:"sap.ui.core.IconColor",group:"Appearance",defaultValue:p.Default},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},visible:{type:"boolean",group:"Behavior",defaultValue:true},design:{type:"sap.m.IconTabFilterDesign",group:"Appearance",defaultValue:n.Vertical}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},items:{type:"sap.m.IconTab",multiple:true,singularName:"item"},_expandButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}}}});
h.call(r.prototype);var s=C.getLibraryResourceBundle("sap.m");r._aAllIconColors=['sapMITBFilterCritical','sapMITBFilterPositive','sapMITBFilterNegative','sapMITBFilterDefault','sapMITBFilterNeutral'];
r.prototype._getImageControl=function(i,t,u){var v={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(v.src){this._oImageControl=m.getImageControl(this.getId()+"-icon",this._oImageControl,t,v,i,u);}else if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}return this._oImageControl;};
r.prototype.init=function(){this._oDragEventDelegate={onlongdragover:this._handleOnLongDragOver,ondragover:this._handleOnDragOver,ondragleave:this._handleOnDragLeave,ondrop:this._handleOnDrop};this.initBadgeEnablement({style:o.Attention,selector:{selector:".sapMITBBadgeHolder"}});this._oCloneInList=null;};
r.prototype.exit=function(E){if(this._oImageControl){this._oImageControl.destroy();}if(I.prototype.exit){I.prototype.exit.call(this,E);}if(this._invisibleText){this._invisibleText.destroy();this._invisibleText=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}if(this._oExpandButton){this._oExpandButton.removeEventDelegate(this._oDragEventDelegate);this._oExpandButton.destroy();this._oExpandButton=null;}this.removeEventDelegate(this._oDragEventDelegate);this._oDragEventDelegate=null;if(this._iHideBadgeTimeout){clearTimeout(this._iHideBadgeTimeout);}};
r.prototype.invalidate=function(){var i=this.getParent(),t,O;if(!i){return;}t=i.getParent();if(!(t instanceof sap.m.IconTabBar)){i.invalidate();return;}O=t.getParent();if(O instanceof sap.m.ObjectHeader){O.invalidate();}else{t.invalidate();}};
r.prototype.setProperty=function(i,v,S){switch(i){case'enabled':case'textDirection':case'text':case'count':case'showAll':case'icon':case'iconColor':case'iconDensityAware':case'design':if(this.getProperty(i)===v){return this;}d.prototype.setProperty.call(this,i,v,true);if(!S){var t=this.getParent();if(t instanceof sap.m.IconTabHeader){t.invalidate();}}break;default:d.prototype.setProperty.apply(this,arguments);break;}return this;};
r.prototype._getNonEmptyKey=function(){var K=this.getKey();if(K){return K;}return this.getId();};
r.prototype._getRealTab=function(){return this._oRealItem||this;};
r.prototype._getRootTab=function(){var t=this._getRealTab(),i=t.getParent();while(i&&i.isA("sap.m.IconTabFilter")){t=i;i=i.getParent();}return t;};
r.prototype._getNestedLevel=function(){var i=this._getRealTab().getParent(),L;for(L=1;i&&i.isA("sap.m.IconTabFilter");L++){i=i.getParent();}return L;};
r.prototype.render=function(i,v,V){if(!this.getVisible()){return;}this._prepareDragEventDelegate();var t=this.getParent(),u=t.getParent(),H=t._isInsideIconTabBar(),w={role:"tab"},x=this.getId(),y=this.getCount(),z=this.getText(),E=this.getIcon(),F=this.getIconColor(),S=F==='Positive'||F==='Critical'||F==='Negative'||F==='Neutral',G=this.getDesign()===n.Horizontal,J=t._bTextOnly,K=t._bInLine||t.isInlineMode(),L=this.getShowAll();if(H){w.controls=u.getId()+"-content";}if(this.getItems().length){w.roledescription=s.getText("ICONTABFILTER_SPLIT_TAB");}if(z.length||y!==""||E){var M=[];if(y!==""){M.push(x+"-count");}if(z.length){M.push(x+"-text");}if(E){M.push(x+"-icon");}if(S){M.push(x+"-iconColor");}w.labelledby=M.join(" ");}if(v!==undefined&&V!==undefined){Object.assign(w,{posinset:v+1,setsize:V});}i.openStart("div",this).accessibilityState(w).class("sapMITBItem");if(!y){i.class("sapMITBItemNoCount");}if(G){i.class("sapMITBHorizontal");}else{i.class("sapMITBVertical");}if(L){i.class("sapMITBAll");}else{i.class("sapMITBFilter").class("sapMITBFilter"+F);}if(t._isUnselectable(this)){i.class("sapMITHUnselectable");}if(this.getItems().length>0){i.class("sapMITBFilterWithItems");}if(!this.getEnabled()){i.class("sapMITBDisabled").attr("aria-disabled",true);}i.attr("aria-selected",false);var N=this.getTooltip_AsString();if(N){i.attr("title",N);}if(this._bIsOverflow||this.getItems().length){i.attr("aria-haspopup","menu");}i.openEnd();i.openStart("div").class("sapMITBFilterWrapper").openEnd();if(!K){i.openStart("div",x+"-tab").class("sapMITBTab").openEnd();if(!L||!E){if(S){i.openStart("div",x+"-iconColor").style("display","none").openEnd().text(s.getText('ICONTABBAR_ICONCOLOR_'+F.toUpperCase())).close("div");}i.renderControl(this._getImageControl(['sapMITBFilterIcon',"sapMITBBadgeHolder",'sapMITBFilter'+F],t,r._aAllIconColors));}if(!L&&!E&&!J){i.openStart("span").class("sapMITBFilterNoIcon").openEnd().close("span");}if(G&&!L){i.close("div");i.openStart("div").class("sapMITBHorizontalWrapper").openEnd();}i.openStart("span",x+"-count").class("sapMITBCount");if(L||(!E&&!z.length)){i.class("sapMITBBadgeHolder");}i.openEnd();if(y===""&&G){i.unsafeHtml("&nbsp;");}else{i.text(y);}i.close("span");if(!G){i.close("div");}}if(z.length){i.openStart("div",x+"-text").class("sapMITBText");if(H&&u.getUpperCase()){i.class("sapMITBTextUpperCase");}if(K){i.attr("dir","ltr");}i.openEnd();i.openStart("span").class("sapMITHTextContent");if(!E&&!L){i.class("sapMITBBadgeHolder");}i.openEnd();i.text(t._getDisplayText(this));i.close("span");if(this._bIsOverflow||this.getItems().length&&t._isUnselectable(this)){i.openStart("span",this.getId()+"-expandButton").class("sapMITHShowSubItemsIcon").openEnd();i.icon(a.getIconURI("slim-arrow-down"),null,{"title":null,"aria-hidden":true});i.close("span");}i.close("div");}if(!K&&G){i.close("div");}i.openStart("div").class("sapMITBContentArrow").openEnd().close("div");i.close("div");if(this.getItems().length&&!t._isUnselectable(this)){i.openStart("span").accessibilityState({role:"separator"}).openEnd().close("span");i.renderControl(this._getExpandButton());}if(this.getItems().length){this._updateExpandButtonBadge();}i.close("div");};
r.prototype.renderInSelectList=function(i,S,t,u,v){if(this._invisibleText){this._invisibleText.destroy();this._invisibleText=null;}if(!this.getVisible()){return;}var w=true,x=S._bIconOnly,y=S._oIconTabHeader;if(y){w=y._bTextOnly;}i.openStart("li",this).class("sapMITBSelectItem").attr("tabindex","-1").attr("role","menuitem");if(v){i.style("padding-left",v+"rem");}if(t!==undefined&&u!==undefined){i.attr("aria-posinset",t+1);i.attr("aria-setsize",u);i.attr("aria-level",this._getNestedLevel());}var z=this.getTooltip_AsString();if(z){i.attr("title",z);}if(y._isUnselectable(this)){i.class("sapMITHUnselectable");}if(!this.getEnabled()){i.class("sapMITBDisabled").attr("aria-disabled",true);}if(S.getSelectedItem()==this){i.class("sapMITBSelectItemSelected");i.attr("aria-selected",true);}var E=this.getIconColor();i.class("sapMITBFilter"+E);var F=this.getId(),G=E=='Positive'||E=='Critical'||E=='Negative'||E=='Neutral',L=[];if(!x){L.push(F+"-text");}if(!w&&this.getIcon()){L.push(F+"-icon");}if(G){this._invisibleText=new b({text:s.getText('ICONTABBAR_ICONCOLOR_'+E.toUpperCase())});L.push(this._invisibleText.getId());}i.accessibilityState({labelledby:L.join(" ")}).openEnd();if(this._invisibleText){i.renderControl(this._invisibleText);}if(!w){this._renderIcon(i,x);}if(!x){this._renderText(i);}i.close("li");};
r.prototype._onAfterParentRendering=function(){this._renderBadge();};
r.prototype._renderIcon=function(i,t){var u=this.getIcon();if(u){var v=a.getIconInfo(u),w=["sapMITBSelectItemIcon"];if(v&&!v.suppressMirroring){w.push("sapUiIconMirrorInRTL");}if(t){w.push("sapMITBBadgeHolder");}i.icon(u,w,{id:this.getId()+"-icon","aria-hidden":true});}else{i.openStart("span").class("sapUiIcon").openEnd().close("span");}};
r.prototype._renderText=function(i){var t=this.getText(),u=this.getCount(),v=C.getConfiguration().getRTL(),w=this.getTextDirection();i.openStart("span",this.getId()+"-text").attr("dir","ltr").class("sapMText").class("sapMTextNoWrap").class("sapMITBText").class("sapMITBBadgeHolder");if(w!==j.Inherit){i.attr('dir',w.toLowerCase());}var x=R.getTextAlign(T.Begin,w);if(x){i.style("text-align",x);}if(u){if(v){t='('+u+') '+t;}else{t+=' ('+u+')';}}i.openEnd().text(t).close("span");};
r.prototype._getSelectList=function(){if(!this._oSelectList){this._oSelectList=new g({selectionChange:function(E){var t=E.getParameter("selectedItem");this._oIconTabHeader.setSelectedItem(t._getRealTab());this._oTabFilter._closePopover();}});this._oSelectList._oIconTabHeader=this.getParent();this._oSelectList._oTabFilter=this;this._oSelectList._bIsOverflow=this._bIsOverflow;}return this._oSelectList;};
r.prototype._prepareDragEventDelegate=function(){if(this.getEnabled()){this.addEventDelegate(this._oDragEventDelegate,this);}else{this.removeEventDelegate(this._oDragEventDelegate);}};
r.prototype._getExpandButton=function(){this._oExpandButton=this.getAggregation("_expandButton");if(!this._oExpandButton){this._oExpandButton=new A(this.getId()+"-expandButton",{type:k.Transparent,icon:a.getIconURI("slim-arrow-down"),tooltip:s.getText("ICONTABHEADER_OVERFLOW_MORE"),tabIndex:"-1",press:this._expandButtonPress.bind(this)}).addStyleClass("sapMITBFilterExpandBtn");this.setAggregation("_expandButton",this._oExpandButton);}return this._oExpandButton;};
r.prototype._updateExpandButtonBadge=function(){var H=this.getBadgeCustomData()&&this.getBadgeCustomData().getVisible(),i=this._hasChildWithBadge();if(i&&!H){this.addCustomData(new B({visible:true}));}else if(!i&&H){this.getBadgeCustomData().setVisible(false);}};
r.prototype._hasChildWithBadge=function(){var i=this._bIsOverflow?this._getIconTabHeader()._getItemsForOverflow():this._getAllSubItems();return i.some(function(t){return t.isA("sap.m.IBadge")&&t.getBadgeCustomData()&&t.getBadgeCustomData().getVisible();});};
r.prototype._expandButtonPress=function(){if(!this.getEnabled()){return;}this.$().trigger("focus");if(!this._oPopover){this._oPopover=new f({showArrow:false,showHeader:false,offsetY:0,offsetX:0,placement:P.VerticalPreferredBottom}).addStyleClass("sapMITBFilterPopover");this._oPopover.attachBeforeClose(function(){this._getSelectList().destroyItems();},this);if(D.system.phone){this._oPopover._oControl.addButton(this._createPopoverCloseButton());}this.addDependent(this._oPopover);this._oPopover._oControl._adaptPositionParams=function(){var i=this.$().parents().hasClass("sapUiSizeCompact");this._arrowOffset=0;if(i){this._offsets=["0 0","0 0","0 4","0 0"];}else{this._offsets=["0 0","0 0","0 5","0 0"];}this._atPositions=["end top","end top","end bottom","begin top"];this._myPositions=["end bottom","begin top","end top","end top"];};}var H=this._setSelectListItems();var S=this._getSelectList();this._oPopover.removeAllContent();if(this.getItems().length||this._bIsOverflow){this._oPopover.addContent(S);this._oPopover.setInitialFocus(H?S.getSelectedItem():S.getVisibleTabFilters()[0]);this._oPopover.openBy(this);}};
r.prototype._getAllSubItems=function(){var i=[];this._getRealTab().getItems().forEach(function(t){if(t.isA("sap.m.IconTabFilter")){i=i.concat(t,t._getAllSubItems());}else{i=i.concat(t);}});return i;};
r.prototype._getAllSubFilters=function(){return this._getAllSubItems().filter(function(i){return i.isA("sap.m.IconTabFilter");});};
r.prototype._getAllSubFiltersDomRefs=function(){return this._getAllSubFilters().filter(function(S){return Boolean(S._getRealTab().getDomRef());}).map(function(S){return S._getRealTab().getDomRef();});};
r.prototype._getFirstAvailableSubFilter=function(){var t=this._getAllSubFilters();for(var i=0;i<t.length;i++){var u=t[i];if(u.getContent().length&&u.getVisible()){return u;}}return this;};
r.prototype._isParentOf=function(t){var u=this._getAllSubFilters();for(var i=0;i<u.length;i++){if(u[i]._getRealTab()===t){return true;}}return false;};
r.prototype._createPopoverCloseButton=function(){return new e({text:s.getText("SELECT_CANCEL_BUTTON"),press:this._closePopover.bind(this)});};
r.prototype._closePopover=function(){if(this._oPopover){this._oPopover.close();this._oPopover.removeAllContent();}if(this._bIsOverflow&&this.getParent().oSelectedItem){(this.getParent()._oSelectedRootItem||this.getParent().oSelectedItem).$().focus();}};
r.prototype._handleOnDragOver=function(E){if(!this._bIsOverflow&&!this._getIconTabHeader().getMaxNestingLevel()){return;}this.getDomRef().classList.add("sapMITHDragOver");E.preventDefault();};
r.prototype._handleOnLongDragOver=function(){if(!this._bIsOverflow&&!this._getIconTabHeader().getMaxNestingLevel()){return;}if(this._oPopover&&this._oPopover.isOpen()){return;}this._expandButtonPress();};
r.prototype._handleOnDrop=function(){this.getDomRef().classList.remove("sapMITHDragOver");};
r.prototype._handleOnDragLeave=function(){this.getDomRef().classList.remove("sapMITHDragOver");};
r.prototype._setSelectListItems=function(){var t=this.getParent(),S=this._getSelectList(),u=this._getAllSubItems(),v=t.oSelectedItem,H=false,w;if(this._bIsOverflow){u=t._getItemsForOverflow();}S.destroyItems();S.setSelectedItem(null);for(var i=0;i<u.length;i++){w=u[i];var L=w.clone(undefined,undefined,{cloneChildren:false,cloneBindings:true});if(w instanceof r&&w.getBadgeCustomData()){L.addCustomData(w.getBadgeCustomData().clone());w._oCloneInList=L;}L._oRealItem=w;S.addItem(L);if(w.isA("sap.m.IconTabSeparator")){continue;}if(L._getRealTab()===v){S.setSelectedItem(L);H=true;continue;}if(L._getRealTab()._isParentOf(v)){S.setSelectedItem(v._getRealTab());H=true;}}return H;};
r.prototype._getIconTabHeader=function(){return this._getRootTab().getParent();};
r.prototype.onsapdown=function(E){if(!this.getEnabled()){return;}if(this._bIsOverflow||((this._getNestedLevel()===1&&this._getRealTab()===this)&&this._getRealTab().getItems().length!==0)){E.stopImmediatePropagation();this._expandButtonPress();}};
r.prototype._startBadgeHiding=function(){if(this._iHideBadgeTimeout){return;}this._iHideBadgeTimeout=setTimeout(this._hideBadge.bind(this),q);};
r.prototype._hideBadge=function(){var i=this.getBadgeCustomData();if(!i){return;}i.setVisible(false);this._getRootTab()._updateExpandButtonBadge();if(this._oCloneInList&&!this._oCloneInList.bIsDestroyed&&this._oCloneInList.getBadgeCustomData()){this._oCloneInList.getBadgeCustomData().setVisible(false);this._oCloneInList=null;}if(this._isInOverflow()){this._getIconTabHeader()._getOverflow()._updateExpandButtonBadge();}this._iHideBadgeTimeout=null;};
r.prototype._isInOverflow=function(){var i=this.getDomRef();return i&&i.classList.contains("sapMITBFilterHidden");};
return r;});
sap.ui.predefine('sap/m/IconTabHeader',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation',"sap/ui/core/InvisibleText",'sap/ui/core/ResizeHandler','sap/ui/Device','sap/m/Button','sap/m/IconTabFilter','sap/m/IconTabSeparator','sap/m/IconTabBarDragAndDropUtil','sap/ui/core/dnd/DropPosition','sap/m/IconTabHeaderRenderer',"sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/events/KeyCodes"],function(l,C,a,E,I,b,R,D,B,c,d,e,f,g,q,L,K){"use strict";var h=l.BackgroundDesign;var k=l.IconTabHeaderMode;var m=l.IconTabDensityMode;
var n=a.extend("sap.m.IconTabHeader",{metadata:{library:"sap.m",properties:{showSelection:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},selectedKey:{type:"string",group:"Data",defaultValue:null},visible:{type:"boolean",group:"Behavior",defaultValue:true},mode:{type:"sap.m.IconTabHeaderMode",group:"Appearance",defaultValue:k.Standard},showOverflowSelectList:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:h.Solid},enableTabReordering:{type:"boolean",group:"Behavior",defaultValue:false},maxNestingLevel:{type:"int",group:"Behavior",defaultValue:0},tabDensityMode:{type:"sap.m.IconTabDensityMode",group:"Appearance",defaultValue:m.Cozy},ariaTexts:{type:"object",group:"Accessibility",defaultValue:null}},aggregations:{items:{type:"sap.m.IconTab",multiple:true,singularName:"item",dnd:{draggable:true,droppable:true,layout:"Horizontal"}},_overflow:{type:"sap.m.IconTabFilter",multiple:false,visibility:"hidden"}},events:{select:{parameters:{item:{type:"sap.m.IconTabFilter"},key:{type:"string"}}}}}});
var r=C.getLibraryResourceBundle("sap.m");E.apply(n.prototype,[true]);
n.prototype.init=function(){this._aTabKeys=[];this._oAriaHeadText=null;};
n.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._aTabKeys){this._aTabKeys=null;}if(this._oOverflow){this._oOverflow.removeEventDelegate(this._oOverflowEventDelegate);this._oOverflowEventDelegate=null;this._oOverflow=null;}if(this._oAriaHeadText){this._oAriaHeadText.destroy();this._oAriaHeadText=null;}this._bRtl=null;};
n.prototype.onBeforeRendering=function(){this._bRtl=C.getConfiguration().getRTL();if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._updateSelection();this.destroyDragDropConfig();this._setsDragAndDropConfigurations();};
n.prototype.onAfterRendering=function(){this._applyTabDensityMode();if(this.oSelectedItem){this._applySelectionToFilters();}if(C.isThemeApplied()){this._setItemsForStrip();}else{C.attachThemeChanged(this._handleThemeLoad,this);}this._initItemNavigation();this._sResizeListenerId=R.register(this.getDomRef(),q.proxy(this._fnResize,this));this.getItems().forEach(function(i){if(i._onAfterParentRendering){i._onAfterParentRendering();}});};
n.prototype._getSelectList=function(){return this._getOverflow()._getSelectList();};
n.prototype._getOverflow=function(){var o=this.getAggregation("_overflow");if(!o){o=new c({id:this.getId()+'-overflow',text:r.getText("ICONTABHEADER_OVERFLOW_MORE")});o._bIsOverflow=true;this._oOverflowEventDelegate={onsapnext:o.onsapdown};o.addEventDelegate(this._oOverflowEventDelegate,o);this.setAggregation("_overflow",o);this._oOverflow=o;}return o;};
n.prototype._getInvisibleHeadText=function(){var A=this.getAriaTexts()||{};if(!this._oAriaHeadText){this._oAriaHeadText=new b({id:this.getId()+"-ariaHeadText"});}this._oAriaHeadText.setText(A.headerDescription);return this._oAriaHeadText;};
n.prototype._onItemNavigationFocusLeave=function(){if(!this.oSelectedItem){return;}var j=this.getItems();var o=-1;var p;for(var i=0;i<j.length;i++){p=j[i];if(p instanceof c==false){continue;}o++;if((this.oSelectedItem._getRootTab()||this.oSelectedItem)===p){break;}}this._oItemNavigation.setFocusedIndex(o);};
n.prototype.getTabFilters=function(){var t=[];this.getItems().forEach(function(i){if(i instanceof c){t.push(i);}});return t;};
n.prototype._setsDragAndDropConfigurations=function(){if(this.getEnableTabReordering()&&!this.getDragDropConfig().length){e.setDragDropAggregations(this,"Horizontal",this._getDropPosition());}};
n.prototype._getDropPosition=function(){return this.getMaxNestingLevel()===0?f.Between:f.OnOrBetween;};
n.prototype.setSelectedKey=function(s){var j=this.getTabFilters(),o=this._isInsideIconTabBar(),S;if(j.length>0){s=s||j[0]._getNonEmptyKey();}if(this.$().length){for(var i=0;i<j.length;i++){if(j[i]._getNonEmptyKey()===s){this.setSelectedItem(j[i],true);S=true;break;}}if(!S&&!o&&s){this.setSelectedItem(null);}}this.setProperty("selectedKey",s,true);return this;};
n.prototype.setSelectedItem=function(i,A){if(!i){if(this.oSelectedItem){this._removeSelectionFromFilters();this.oSelectedItem=null;}return this;}if(this._isUnselectable(i)){return this;}var p=this.getParent();var j=this._isInsideIconTabBar();var o=false;if(i.getContent().length===0&&this.oSelectedItem&&this.oSelectedItem.getContent().length===0){o=true;}if(this.oSelectedItem&&this.oSelectedItem.getVisible()&&(!A&&j&&p.getExpandable()||this.oSelectedItem!==i)){this._removeSelectionFromFilters();}if(i.getVisible()){if(this.oSelectedItem===i){if(!A&&j&&p.getExpandable()){p._toggleExpandCollapse();}}else{if(j){p.$("content").attr('aria-labelledby',i.sId);}this.oSelectedItem=i;this._applySelectionToFilters();this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);if(j&&(p.getExpandable()||p.getExpanded())){var s=this.oSelectedItem.getContent();if(s.length>0){p._rerenderContent(s);}else{if(!o){p._rerenderContent(p.getContent());}}if(!A&&p.getExpandable()&&!p.getExpanded()){p._toggleExpandCollapse(true);}}}}this.oSelectedItem=i;var S=this.oSelectedItem._getNonEmptyKey();this.setProperty("selectedKey",S,true);if(j){p.setProperty("selectedKey",S,true);}if(!A){if(j){p.fireSelect({selectedItem:this.oSelectedItem,selectedKey:S,item:this.oSelectedItem,key:S});}else{this.fireSelect({selectedItem:this.oSelectedItem,selectedKey:S,item:this.oSelectedItem,key:S});}}this.oSelectedItem._startBadgeHiding();this._setItemsForStrip();return this;};
n.prototype.getVisibleTabFilters=function(){return this.getTabFilters().filter(function(F){return F.getVisible();});};
n.prototype._initItemNavigation=function(){var t=[],s=-1,S=this.oSelectedItem&&this.oSelectedItem._getRootTab();this.getTabFilters().forEach(function(i){var j=this.getFocusDomRef(i);if(!j){return;}j.setAttribute("tabindex","-1");t.push(j);if(i===S||i===this.oSelectedItem){s=t.indexOf(j);}}.bind(this));if(this.$().hasClass("sapMITHOverflowList")){var o=this._getOverflow().getFocusDomRef();o.setAttribute("tabindex","-1");t.push(o);}if(!this._oItemNavigation){this._oItemNavigation=new I().setCycling(false).attachEvent(I.Events.FocusLeave,this._onItemNavigationFocusLeave,this).setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(this.getDomRef()).setItemDomRefs(t).setPageSize(t.length).setSelectedIndex(s);};
n.prototype.onThemeChanged=function(){this._applyTabDensityMode();};
n.prototype._applyTabDensityMode=function(){var t=this.getTabDensityMode();this.$().removeClass("sapUiSizeCompact");switch(t){case m.Compact:this.$().addClass("sapUiSizeCompact");break;case m.Inherit:if(this.$().closest(".sapUiSizeCompact").length){this.$().addClass("sapUiSizeCompact");}break;}};
n.prototype._handleThemeLoad=function(){setTimeout(this._setItemsForStrip.bind(this),350);C.detachThemeChanged(this._handleThemeLoad,this);};
n.prototype.destroyItems=function(){this.oSelectedItem=null;this._aTabKeys=[];this.destroyAggregation("items");return this;};
n.prototype.addItem=function(i){if(!(i instanceof d)){var s=i.getKey();if(this._aTabKeys.indexOf(s)!==-1){L.warning("sap.m.IconTabHeader: duplicate key '"+s+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(s);}this.addAggregation("items",i);this._invalidateParentIconTabBar();};
n.prototype.insertItem=function(i,j){if(!(i instanceof d)){var s=i.getKey();if(this._aTabKeys.indexOf(s)!==-1){L.warning("sap.m.IconTabHeader: duplicate key '"+s+"' inside the IconTabFilter. Please use unique keys.");}this._aTabKeys.push(s);}this.insertAggregation("items",i,j);this._invalidateParentIconTabBar();};
n.prototype.removeAllItems=function(){var o=this.removeAllAggregation("items");this._aTabKeys=[];this.oSelectedItem=null;this._invalidateParentIconTabBar();return o;};
n.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(i&&!(i instanceof d)){var s=i.getKey();this._aTabKeys.splice(this._aTabKeys.indexOf(s),1);}if(this.oSelectedItem===i){this.oSelectedItem=null;}this._invalidateParentIconTabBar();return i;};
n.prototype.updateAggregation=function(){this.oSelectedItem=null;a.prototype.updateAggregation.apply(this,arguments);this.invalidate();};
n.prototype.removeAggregation=function(A,o,s){var i=this.getTabFilters();var j=a.prototype.removeAggregation.apply(this,arguments);if(s){return j;}if(j&&j==this.oSelectedItem&&A=='items'){var p=(i?Array.prototype.indexOf.call(i,j):-1);i=this.getTabFilters();p=Math.max(0,Math.min(p,i.length-1));var S=i[p];if(S){this.setSelectedItem(S,true);}else{var t=this.getParent();if(this._isInsideIconTabBar()&&t.getExpanded()){t.$("content").children().remove();}}}return j;};
n.prototype.removeAllAggregation=function(A,s){if(A=='items'){var i=this.getParent();if(this._isInsideIconTabBar()&&i.getExpanded()){i.$("content").children().remove();}}return a.prototype.removeAllAggregation.apply(this,arguments);};
n.prototype._getDisplayText=function(i){var t=i.getText();if(this.isInlineMode()){var s=i.getCount();if(s){if(this._bRtl){t='('+s+') '+t;}else{t+=' ('+s+')';}}}return t;};
n.prototype.isInlineMode=function(){return this._bTextOnly&&this.getMode()==k.Inline;};
n.prototype._checkTextOnly=function(){this._bTextOnly=this.getItems().every(function(i){return i instanceof d||!i.getIcon();});return this._bTextOnly;};
n.prototype._checkNoText=function(j){if(j.length>0){for(var i=0;i<j.length;i++){if(!(j[i]instanceof d)){if(j[i].getText().length>0){return false;}}}}return true;};
n.prototype._checkInLine=function(j){var o;if(j.length>0){for(var i=0;i<j.length;i++){o=j[i];if(!(o instanceof d)){if(o.getIcon()||o.getCount()){this._bInLine=false;return false;}}}}this._bInLine=true;return true;};
n.prototype._getItemsInStrip=function(){return this.getItems().filter(function(i){var o=i.getDomRef();return o&&!o.classList.contains("sapMITBFilterHidden");});};
n.prototype._setItemsForStrip=function(){var t=this.getVisibleTabFilters();if(!C.isThemeApplied()||!t.length){return;}var T=this.getDomRef("head"),s=(this.oSelectedItem&&this.oSelectedItem.getVisible())?this.oSelectedItem:t[0];if(!T){return;}var j=T.offsetWidth,i,S=(s._getRootTab()||s).getDomRef(),o=this.getItems().filter(function(z){return z.getDomRef();}).map(function(z){return z.getDomRef();});if(!o.length||!S){return;}o.forEach(function(z){z.style.width="";z.classList.remove("sapMITBFilterHidden");z.classList.remove("sapMITBFilterTruncated");});var p=o.indexOf(S),u=this._getItemSize(S),v,w=0,x;if(o[p-1]&&o[p-1].classList.contains("sapMITBSep")){v=o[p-1];w=this._getItemSize(v);}x=u+w;if(j<x){S.style.width=(j-20-w)+"px";S.classList.add("sapMITBFilterTruncated");}o.splice(p,1);if(v){o.splice(p-1,1);}var y=this._findLastVisibleItem(o,j,x);for(i=y+1;i<o.length;i++){o[i].classList.add("sapMITBFilterHidden");}this._getOverflow()._updateExpandButtonBadge();this._getOverflow().$().toggleClass("sapMITHOverflowVisible",y+1!==o.length);this.$().toggleClass("sapMITHOverflowList",y+1!==o.length);};
n.prototype._findLastVisibleItem=function(i,t,s){var j=-1,o,p,u,P;for(o=0;o<i.length;o++){p=i[o];u=this._getItemSize(p);if(t>(s+u)){s+=u;j=o;}else{P=i[o-1];if(P&&P.classList.contains("sapMITBSep")){j-=1;}break;}}return j;};
n.prototype._getItemSize=function(i){var s=window.getComputedStyle(i),w=i.offsetWidth,M=Number.parseInt(s.marginLeft)+Number.parseInt(s.marginRight);return w+M;};
n.prototype._handleActivation=function(o){var t=o.target.id,i=o.srcControl,s,$=q(o.target);if(i instanceof B){return;}var j=q(document.getElementById(t));if(j.parents()&&Array.prototype.indexOf.call(j.parents(),this.$("content")[0])>-1){}else{if(t){o.preventDefault();if($.hasClass('sapMITBFilterIcon')||$.hasClass('sapMITBCount')||$.hasClass('sapMITBText')||$.hasClass('sapMITBTab')||$.hasClass('sapMITBContentArrow')||$.hasClass('sapMITBSep')||$.hasClass('sapMITBSepIcon')){s=o.srcControl.getId().replace(/-icon$/,"");i=C.byId(s);if(i.getMetadata().isInstanceOf("sap.m.IconTab")&&!(i instanceof d)){if(this._isUnselectable(i)){if(i.getItems().length||i._bIsOverflow){i._expandButtonPress();}return;}if(i===this._getOverflow()){i._expandButtonPress();return;}this.setSelectedItem(i);}}else if(i.getMetadata().isInstanceOf("sap.m.IconTab")&&!(i instanceof d)){if(this._isUnselectable(i)){if(i.getItems().length||i._bIsOverflow){i._expandButtonPress();}return;}if(i===this._getOverflow()){i._expandButtonPress();return;}this.setSelectedItem(i);}}else{if(i.getMetadata().isInstanceOf("sap.m.IconTab")&&!(i instanceof d)){if(this._isUnselectable(i)){if(i.getItems().length||i._bIsOverflow){i._expandButtonPress();}return;}if(i===this._getOverflow()){i._expandButtonPress();return;}this.setSelectedItem(i);}}}};
n.prototype._fnResize=function(){if(this._getOverflow()._oPopover){this._getOverflow()._oPopover.close();}this._setItemsForStrip();this._initItemNavigation();};
n.prototype._isUnselectable=function(i){var F=i._getRealTab();return!F.getEnabled()||(this._isInsideIconTabBar()&&!this.getParent().getContent().length&&F._getNestedLevel()===1&&F.getItems().length&&!F.getContent().length)||F._bIsOverflow;};
n.prototype._isInsideIconTabBar=function(){var p=this.getParent();return p instanceof a&&p.isA('sap.m.IconTabBar');};
n.prototype._invalidateParentIconTabBar=function(){if(this._isInsideIconTabBar()){this.getParent().invalidate();}};
n.prototype.getFocusDomRef=function(F){var t=F||this.oSelectedItem;if(!t){return null;}return t.getDomRef();};
n.prototype.applyFocusInfo=function(F){if(F.focusDomRef){q(F.focusDomRef).trigger("focus");}};
n.prototype._updateSelection=function(){var j=this.getItems(),s=this.getSelectedKey(),i=0,p=this.getParent(),o=this._isInsideIconTabBar(),t=p&&p.isA("sap.tnt.ToolHeader");if(!j.length){return;}if(!this.oSelectedItem||s&&s!==this.oSelectedItem._getNonEmptyKey()){if(s){this.oSelectedItem=this._findItemByKey(s);}if(!this.oSelectedItem&&(o||!s)){for(i=0;i<j.length;i++){if(!(j[i]instanceof d)&&j[i].getVisible()){this.oSelectedItem=j[i];break;}}}}if(!t&&this.oSelectedItem&&!this.oSelectedItem.getVisible()){for(i=0;i<j.length;i++){if(!(j[i]instanceof d)&&j[i].getVisible()){this.oSelectedItem=j[i];break;}}}if(!this.oSelectedItem){return;}if(this._isUnselectable(this.oSelectedItem)){this.setSelectedItem(this.oSelectedItem._getFirstAvailableSubFilter(),true);return;}this.setProperty("selectedKey",this.oSelectedItem._getNonEmptyKey(),true);};
n.prototype._findItemByKey=function(s){var t=this.getTabFilters(),S;for(var i=0;i<t.length;i++){if(t[i]._getNonEmptyKey()===s){return t[i];}S=t[i]._getAllSubFilters();for(var j=0;j<S.length;j++){if(S[j]._getNonEmptyKey()===s){return S[j];}}}};
n.prototype._applySelectionToFilters=function(){if(this._isInsideIconTabBar()&&!this.getParent().getExpanded()){return;}this.oSelectedItem.$().addClass("sapMITBSelected").attr({'aria-selected':true});if(this.oSelectedItem._getNestedLevel()!==1){var s=this.oSelectedItem._getRootTab();s.$().addClass("sapMITBSelected").attr({"aria-selected":true});}};
n.prototype._removeSelectionFromFilters=function(){this.oSelectedItem.$().removeClass("sapMITBSelected").attr({'aria-selected':false});if(this.oSelectedItem._getNestedLevel()!==1){var s=this.oSelectedItem._getRootTab();s.$().removeClass("sapMITBSelected").attr({"aria-selected":false});}};
n.prototype._getItemsForOverflow=function(){var i=this._getItemsInStrip(),j=[];this.getItems().forEach(function(o){if(!D.system.phone&&i.indexOf(o)>-1){return;}j.push(o);if(o.isA("sap.m.IconTabFilter")){o._getAllSubItems().forEach(function(s){j.push(s);});}});return j;};
n.prototype.ontouchstart=function(o){var t=o.targetTouches[0];this._iActiveTouch=t.identifier;};
n.prototype.ontouchend=function(o){if(this._iActiveTouch===undefined){return;}var M=0;var i=1;var j;if(o.which===j||o.which===M||o.which===i){this._handleActivation(o);}this._iActiveTouch=undefined;};
n.prototype.ontouchcancel=n.prototype.ontouchend;
n.prototype.onkeydown=function(o){switch(o.which){case K.ENTER:this._handleActivation(o);o.preventDefault();break;case K.SPACE:this._handleActivation(o);o.preventDefault();break;}};
n.prototype._handleDragAndDrop=function(o){var i=o.getParameter("dropPosition"),j=o.getParameter("draggedControl"),p=o.getParameter("droppedControl"),s=this,t=this.getMaxNestingLevel();if(i===f.On){s=p._getRealTab();}e.handleDrop(s,i,j._getRealTab(),p,false,t);if(j._getNestedLevel()>1){j._getRootTab()._closePopover();}this._setItemsForStrip();this._initItemNavigation();this._getOverflow()._setSelectListItems();this._getSelectList()._initItemNavigation();j._getRealTab().$().trigger("focus");if(i===f.On){p._getRealTab().$().trigger("focus");}};
n.prototype._moveTab=function(t,i,M){e.moveItem.call(this,t,i,M);this._setItemsForStrip();this._initItemNavigation();};
n.prototype.ondragrearranging=function(o){if(!this.getEnableTabReordering()){return;}var t=o.srcControl,T=this.indexOfItem(this._getItemsInStrip().pop());this._moveTab(t,o.keyCode,T);t.$().trigger("focus");};
n.prototype.onsaphomemodifiers=n.prototype.ondragrearranging;n.prototype.onsapendmodifiers=n.prototype.ondragrearranging;n.prototype.onsapincreasemodifiers=n.prototype.ondragrearranging;n.prototype.onsapdecreasemodifiers=n.prototype.ondragrearranging;return n;});
sap.ui.predefine('sap/m/IconTabHeaderRenderer',[],function(){"use strict";var I={apiVersion:2};
I.render=function(r,c){if(!c.getVisible()){return;}var s=c.getId(),a=c.getItems(),v=c.getVisibleTabFilters().length,V=0,t=c._checkTextOnly(),n=c._checkNoText(a),b=c._checkInLine(a)||c.isInlineMode();var o=c.getParent(),u=o&&o.isA('sap.m.IconTabBar')&&o.getUpperCase(),A=c.getAriaTexts()||{};r.openStart("div",c).class("sapMITH").class("sapContrastPlus").class("sapMITHBackgroundDesign"+c.getBackgroundDesign());if(a.length){r.class("sapMITHOverflowList");}if(u){r.class("sapMITBTextUpperCase");}if(t){r.class("sapMITBTextOnly");}if(n){r.class("sapMITBNoText");}if(b){r.class("sapMITBInLine");}r.accessibilityState(c,{role:"navigation"});if(A.headerLabel){r.accessibilityState(c,{label:A.headerLabel});}r.openEnd();if(A.headerDescription){r.renderControl(c._getInvisibleHeadText());}r.openStart("div",s+"-head").class("sapMITBHead");r.accessibilityState({role:"tablist",orientation:"horizontal"});if(A.headerDescription){r.accessibilityState({describedby:c._getInvisibleHeadText().getId()});}r.openEnd();for(var i=0;i<a.length;i++){var d=a[i];d.render(r,V,v);if(d.isA("sap.m.IconTabFilter")){if(d.getVisible()){V++;}}}r.close("div");if(a.length){r.openStart("div").class("sapMITHOverflow").openEnd();c._getOverflow().render(r);r.close("div");}r.close("div");};
return I;},true);
sap.ui.predefine('sap/m/IconTabSeparator',["./library","sap/ui/core/Core","sap/ui/core/Element","sap/ui/core/Item","sap/m/IconTabFilter"],function(l,C,E,I,a){"use strict";var b=l.ImageHelper;
var c=E.extend("sap.m.IconTabSeparator",{metadata:{interfaces:["sap.m.IconTab"],library:"sap.m",designtime:"sap/m/designtime/IconTabSeparator.designtime",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:''},visible:{type:"boolean",group:"Behavior",defaultValue:true},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}}}});
c.prototype._getImageControl=function(d,p){var P={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=b.getImageControl(this.getId()+"-icon",this._oImageControl,p,P,d);return this._oImageControl;};
c.prototype.exit=function(e){if(this._oImageControl){this._oImageControl.destroy();}if(I.prototype.exit){I.prototype.exit.call(this,e);}};
c.prototype._getRealTab=function(){return a.prototype._getRealTab.call(this);};
c.prototype._getNestedLevel=function(){return a.prototype._getNestedLevel.call(this);};
c.prototype.render=function(r){if(!this.getVisible()){return;}var i=this.getIcon(),o=this.getParent(),R=C.getLibraryResourceBundle('sap.m'),A={};if(i){A.role="img";A.label=R.getText("ICONTABBAR_NEXTSTEP");}else{A.role="separator";}r.openStart("div",this).accessibilityState(A).class("sapMITBItem").class("sapMITBSep");if(!i){r.class("sapMITBSepLine");}r.openEnd();if(i){r.renderControl(this._getImageControl(["sapMITBSepIcon"],o));}r.close("div");};
c.prototype.renderInSelectList=function(r,s,i,S,p){if(!this.getVisible()){return;}var d=this.getIcon(),o=s._oIconTabHeader,R=C.getLibraryResourceBundle('sap.m'),A={};if(d){A.role="img";A.label=R.getText("ICONTABBAR_NEXTSTEP");}else{A.role="separator";}r.openStart("li",this).class("sapMITBSelectItem").class("sapMITBSep").accessibilityState(A);if(p&&!d){r.style("padding-left",p+"rem");}if(!d){r.class("sapMITBSepLine");}r.openEnd();if(d){r.renderControl(this._getImageControl(["sapMITBSepIcon"],o));}r.close("li");};
return c;});
sap.ui.predefine('sap/m/Image',['./library','sap/ui/core/Control','sap/ui/base/DataType','./ImageRenderer',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/security/encodeCSS"],function(l,C,D,I,K,q,e){"use strict";var a=l.ImageMode;
var b=C.extend("sap.m.Image",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/Image.designtime",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},useMap:{type:"string",group:"Misc",defaultValue:null},densityAware:{type:"boolean",group:"Misc",defaultValue:false},activeSrc:{type:"sap.ui.core.URI",group:"Data",defaultValue:""},mode:{type:"sap.m.ImageMode",group:"Misc",defaultValue:"Image"},backgroundSize:{type:"string",group:"Appearance",defaultValue:"cover"},backgroundPosition:{type:"string",group:"Appearance",defaultValue:"initial"},backgroundRepeat:{type:"string",group:"Appearance",defaultValue:"no-repeat"}},aggregations:{detailBox:{type:'sap.m.LightBox',multiple:false,bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDetails:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDetails"}},events:{tap:{},press:{},load:{},error:{}},dnd:{draggable:true,droppable:false}}});
b._currentDevicePixelRatio=(function(){var r=(window.devicePixelRatio===undefined?1:window.devicePixelRatio);if(r<=1){r=1;}else{r*=2;r=Math.round(r);r/=2;}if(r>2){r=2;}return r;}());
b.prototype.onload=function(E){var w,h;if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}this._bVersion2Tried=false;var d=this.$(),o=d[0];if(this.getMode()===a.Background){d.css("background-image","url(\""+e(this._oImage.src)+"\")");}if(!this._isWidthOrHeightSet()){if(this._iLoadImageDensity>1){w=Math.round(o.getBoundingClientRect().width);h=Math.round(o.getBoundingClientRect().height);if((w===o.naturalWidth)&&(h===o.naturalHeight)){d.width(w/this._iLoadImageDensity);}}}d.removeClass("sapMNoImg");this.fireLoad();};
b.prototype.onerror=function(E){if(!this._defaultEventTriggered){this._defaultEventTriggered=true;}var $=this.$(),m=this.getMode(),s=(m===a.Image)?this._getDomImg().attr("src"):this._oImage.src,d=b._currentDevicePixelRatio,c=this._isActiveState?this.getActiveSrc():this.getSrc();$.addClass("sapMNoImg");if(!s||this._iLoadImageDensity===1){if(this.getAlt()&&!this.getDecorative()){$.removeClass("sapMNoImg");}this.fireError();return;}if(d===2||d<1){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(c,1));}else if(d===1.5){if(this._bVersion2Tried){setTimeout(q.proxy(function(){this._iLoadImageDensity=1;this._updateDomSrc(this._generateSrcByDensity(c,1));},this),0);}else{setTimeout(q.proxy(function(){this._iLoadImageDensity=2;this._updateDomSrc(this._generateSrcByDensity(c,2));this._bVersion2Tried=true;},this),0);}}};
b.prototype.setDetailBox=function(L){var c=this.getDetailBox();if(L){if(L===c){return this;}if(c){this.detachPress(this._fnLightBoxOpen,c);}this._fnLightBoxOpen=L.open;this.attachPress(this._fnLightBoxOpen,L);}else if(this._fnLightBoxOpen){this.detachPress(this._fnLightBoxOpen,c);this._fnLightBoxOpen=null;}return this.setAggregation("detailBox",L);};
b.prototype.clone=function(){var c=C.prototype.clone.apply(this,arguments),o=c.getDetailBox();if(o){c.detachPress(this._fnLightBoxOpen,this.getDetailBox());c._fnLightBoxOpen=o.open;c.attachPress(c._fnLightBoxOpen,o);}return c;};
b.prototype.onBeforeRendering=function(){this._defaultEventTriggered=false;if(this.getMode()==a.Image){var d=this.getDetailBox()?this.$().find(".sapMImg"):this.$();d.off("load").off("error");}};
b.prototype.onAfterRendering=function(){var d=this.getDetailBox()?this.$().find(".sapMImg"):this.$(),m=this.getMode(),o;if(m===a.Image){d.on("load",q.proxy(this.onload,this));d.on("error",q.proxy(this.onerror,this));o=d[0];}if(m===a.Background){o=this._oImage;}if(o&&o.complete&&!this._defaultEventTriggered){if(o.naturalWidth>0){this.onload({});}else{this.onerror({});}}};
b.prototype.exit=function(){if(this._oImage){q(this._oImage).off("load",this.onload).off("error",this.onerror);this._oImage=null;}else{this.$().off("load",this.onload).off("error",this.onerror);}if(this._fnLightBoxOpen){this._fnLightBoxOpen=null;}};
b.prototype.ontouchstart=function(E){if(E.srcControl.mEventRegistry["press"]||E.srcControl.mEventRegistry["tap"]){E.setMarked();}if(E.targetTouches.length===1&&this.getActiveSrc()){this._updateDomSrc(this._getDensityAwareActiveSrc());this._isActiveState=true;}};
b.prototype.ontouchend=function(E){if(E.targetTouches.length===0&&this.getActiveSrc()){this._isActiveState=false;this._updateDomSrc(this._getDensityAwareSrc());this.$().removeClass("sapMNoImg");}};
b.prototype.attachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")){this.$().attr("tabindex","0");this.$().attr("role","button");}return this;};
b.prototype.detachPress=function(){Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")){this.$().removeAttr("tabindex");if(this.getDecorative()){this.$().attr("role","presentation");}else{this.$().removeAttr("role");}}return this;};
b.prototype.ontap=function(E){this.fireTap({});this.firePress({});};
b.prototype.onkeyup=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this.firePress({});E.stopPropagation();}};
b.prototype.onsapspace=function(E){E.preventDefault();};
b.prototype._updateDomSrc=function(s){var d=this.$(),m=this.getMode();if(d.length){if(m===a.Image){this._getDomImg().attr("src",s);}else{d.addClass("sapMNoImg");q(this._oImage).attr("src",s);}}};
b.prototype._getDomImg=function(){var d=this.$();return this.getDetailBox()?d.children("img"):d;};
b.prototype._preLoadImage=function(s){if(this.getMode()!==a.Background){return;}var $=q(this._oImage);if(!this._oImage){this._oImage=new window.Image();$=q(this._oImage);$.on("load",q.proxy(this.onload,this)).on("error",q.proxy(this.onerror,this));}this._oImage.src=s;};
b.prototype._isWidthOrHeightSet=function(){return(this.getWidth()&&this.getWidth()!=='')||(this.getHeight()&&this.getHeight()!=='');};
b.prototype._getDensityAwareSrc=function(){var s=this.getSrc(),c=this.getDensityAware(),d=c?b._currentDevicePixelRatio:1;this._iLoadImageDensity=d;return this._generateSrcByDensity(s,d);};
b.prototype._getDensityAwareActiveSrc=function(){var A=this.getActiveSrc(),c=this.getDensityAware(),d=c?b._currentDevicePixelRatio:1;this._iLoadImageDensity=d;return this._generateSrcByDensity(A,d);};
b.prototype._generateSrcByDensity=function(s,d){if(!s){return"";}if(this._isDataUri(s)){this._iLoadImageDensity=1;return s;}if(d===1){return s;}var L=s.lastIndexOf("."),c=s.lastIndexOf("/"),n=s.substring(0,L),E=s.substring(L);if(L===-1||(c>L)){return s+"@"+d;}n=n+"@"+d;return n+E;};
b.prototype._isDataUri=function(s){return s?s.indexOf("data:")===0:false;};
b.prototype._isValidBackgroundSizeValue=function(v){var w=/\s+/g;v=q.trim(v).replace(w," ");return i(v.split(" "),["auto","cover","contain","initial"])||D.getType("sap.ui.core.CSSSizeShortHand").isValid(v);};
b.prototype._isValidBackgroundPositionValue=function(v){var w=/\s+/g;v=q.trim(v).replace(w," ");return i(v.split(" "),["left","right","top","center","bottom","initial"])||D.getType("sap.ui.core.CSSSizeShortHand").isValid(v);};
b.prototype.getAccessibilityInfo=function(){var h=this.hasListeners("press");if(this.getDecorative()&&!this.getUseMap()&&!h){return null;}return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||"",focusable:h};};
b.prototype.getFocusDomRef=function(){return this.getDomRef("inner")||this.getDomRef();};
b.prototype.getFormDoNotAdjustWidth=function(){return true;};
function i(t,r){function c(T){return r.indexOf(T)<0;}return t&&r&&!t.some(c);}
return b;});
sap.ui.predefine('sap/m/ImageContent',['./library','sap/ui/core/Control','sap/m/Image','sap/ui/core/IconPool','sap/ui/Device','./ImageContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,I,a,D,b,K){"use strict";
var c=C.extend("sap.m.ImageContent",{metadata:{library:"sap.m",properties:{src:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},description:{type:"string",group:"Accessibility",defaultValue:null}},defaultAggregation:"_content",aggregations:{_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{}}}});
c.prototype.onBeforeRendering=function(){var i,u,d;i=this.getAggregation("_content");u=this.getSrc();d=this.getDescription();if(!i||u!==i.getSrc()||d!==i.getAlt()){if(i){i.destroy();i=null;}i=a.createControlByURI({id:this.getId()+"-icon-image",src:u,alt:d,decorative:true},I);this.setAggregation("_content",i,true);this._setPointerOnImage();}if(d){this.setTooltip(d.trim());}};
c.prototype._setPointerOnImage=function(){var i=this.getAggregation("_content");if(i&&this.hasListeners("press")){i.addStyleClass("sapMPointer");}else if(i&&i.hasStyleClass("sapMPointer")){i.removeStyleClass("sapMPointer");}};
c.prototype.ontap=function(e){if(D.browser.msie){this.$().trigger("focus");}this.firePress();};
c.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
c.prototype.attachEvent=function(e,d,f,g){C.prototype.attachEvent.call(this,e,d,f,g);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnImage();}return this;};
c.prototype.detachEvent=function(e,f,d){C.prototype.detachEvent.call(this,e,f,d);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnImage();}return this;};
c.prototype.getAltText=function(){var o=this.getAggregation("_content");if(o&&o.getAlt()!==""){return o.getAlt();}else if(o&&o.getAccessibilityInfo()){return o.getAccessibilityInfo().description;}else{return"";}};
return c;});
sap.ui.predefine('sap/m/ImageContentRenderer',[],function(){"use strict";var I={};
I.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMImageContent");var t=c.getTooltip_AsString();if(t){r.writeAttributeEscaped("title",t);}if(c.hasListeners("press")){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}r.writeClasses();r.write(">");var C=c.getAggregation("_content");if(C){C.addStyleClass("sapMImageContentImageIcon");r.renderControl(C);}r.write("</div>");};
return I;},true);
sap.ui.predefine('sap/m/ImageRenderer',['sap/m/library',"sap/base/security/encodeCSS"],function(l,e){"use strict";var I=l.ImageMode;var a={apiVersion:2};
a.render=function(r,i){var m=i.getMode(),b=i.getAlt(),t=i.getTooltip_AsString(),h=i.hasListeners("press"),L=i.getDetailBox(),u=i.getUseMap(),c=i.getAriaLabelledBy(),d=i.getAriaDescribedBy(),D=i.getAriaDetails(),f=m===I.Image;if(L){r.openStart("span",i);r.class("sapMLightBoxImage");r.openEnd();r.openStart("span").class("sapMLightBoxMagnifyingGlass").openEnd().close("span");}if(f){r.voidStart("img",!L?i:i.getId()+"-inner");}else{r.openStart("span",!L?i:i.getId()+"-inner");}if(!i.getDecorative()){if(c&&c.length>0){r.attr("aria-labelledby",c.join(" "));}if(d&&d.length>0){r.attr("aria-describedby",d.join(" "));}if(D&&D.length>0){r.attr("aria-details",D.join(" "));}}if(f){r.attr("src",i._getDensityAwareSrc());}else{i._preLoadImage(i._getDensityAwareSrc());if(i._isValidBackgroundSizeValue(i.getBackgroundSize())){r.style("background-size",i.getBackgroundSize());}if(i._isValidBackgroundPositionValue(i.getBackgroundPosition())){r.style("background-position",i.getBackgroundPosition());}r.style("background-repeat",e(i.getBackgroundRepeat()));}r.class("sapMImg");if(i.hasListeners("press")||i.hasListeners("tap")){r.class("sapMPointer");}if(u||!i.getDecorative()||h){r.class("sapMImgFocusable");}if(u){if(!(u.startsWith("#"))){u="#"+u;}r.attr("usemap",u);}if(i.getDecorative()&&!u&&!h){r.attr("role","presentation");r.attr("aria-hidden","true");r.attr("alt","");}else if(b||t){r.attr("alt",b||t);}if(b||t){r.attr("aria-label",b||t);}if(t){r.attr("title",t);}if(h){r.attr("role","button");r.attr("tabindex",0);}r.style("width",i.getWidth());r.style("height",i.getHeight());f?r.voidEnd():r.openEnd().close("span");if(L){r.close("span");}};
return a;},true);
sap.ui.predefine('sap/m/Input',['./InputBase','./Popover','sap/ui/core/Item','./ColumnListItem','./GroupHeaderListItem','./DisplayListItem','./StandardListItem','sap/ui/core/SeparatorItem','./List','./Table','./library','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/Control','./SuggestionsPopover','./Toolbar','./ToolbarSpacer','./Button',"sap/ui/dom/containsOrEquals","sap/base/assert","sap/base/util/deepEqual","./InputRenderer","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/selectText"],function(I,P,a,C,G,D,S,b,L,T,l,c,d,e,f,g,h,B,j,k,m,n,q){"use strict";var o=l.ListType;var p=l.InputTextFormatMode;var r=l.InputType;var s=l.ListMode;var t=l.ListSeparators;
var u=I.extend("sap.m.Input",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.InputType",group:"Data",defaultValue:r.Text},maxLength:{type:"int",group:"Behavior",defaultValue:0},dateFormat:{type:"string",group:"Misc",defaultValue:'YYYY-MM-dd',deprecated:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:false},showSuggestion:{type:"boolean",group:"Behavior",defaultValue:false},valueHelpOnly:{type:"boolean",group:"Behavior",defaultValue:false},filterSuggests:{type:"boolean",group:"Behavior",defaultValue:true},maxSuggestionWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},startSuggestion:{type:"int",group:"Behavior",defaultValue:1},showTableSuggestionValueHelp:{type:"boolean",group:"Behavior",defaultValue:true},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},selectedKey:{type:"string",group:"Data",defaultValue:""},textFormatMode:{type:"sap.m.InputTextFormatMode",group:"Misc",defaultValue:p.Value},textFormatter:{type:"any",group:"Misc",defaultValue:""},suggestionRowValidator:{type:"any",group:"Misc",defaultValue:""},enableSuggestionsHighlighting:{type:"boolean",group:"Behavior",defaultValue:true},autocomplete:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"suggestionItems",aggregations:{suggestionItems:{type:"sap.ui.core.Item",multiple:true,singularName:"suggestionItem"},suggestionColumns:{type:"sap.m.Column",multiple:true,singularName:"suggestionColumn",bindable:"bindable",forwarding:{getter:"_getSuggestionsTable",aggregation:"columns"}},suggestionRows:{type:"sap.m.ColumnListItem",altTypes:["sap.m.GroupHeaderListItem"],multiple:true,singularName:"suggestionRow",bindable:"bindable",forwarding:{getter:"_getSuggestionsTable",aggregation:"items"}},_suggestionPopup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_valueHelpIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},selectedRow:{type:"sap.m.ColumnListItem",multiple:false}},events:{liveChange:{parameters:{value:{type:"string"},escPressed:{type:"boolean"},previousValue:{type:"string"}}},valueHelpRequest:{parameters:{fromSuggestions:{type:"boolean"}}},suggest:{parameters:{suggestValue:{type:"string"},suggestionColumns:{type:"sap.m.ListBase"}}},suggestionItemSelected:{parameters:{selectedItem:{type:"sap.ui.core.Item"},selectedRow:{type:"sap.m.ColumnListItem"}}},submit:{parameters:{value:{type:"string"}}}},designtime:"sap/m/designtime/Input.designtime"}});
c.insertFontFaceStyle();
u._DEFAULTFILTER_TABULAR=function(v,w){var x=w.getCells(),i=0;for(;i<x.length;i++){if(x[i].getText){if(f._wordStartsWithValue(x[i].getText(),v)){return true;}}}return false;};
u._DEFAULTRESULT_TABULAR=function(v){var w=v.getCells(),i=0;for(;i<w.length;i++){if(w[i].getText){return w[i].getText();}}return"";};
u.prototype.init=function(){I.prototype.init.call(this);this._fnFilter=f._DEFAULTFILTER;this._bFullScreen=d.system.phone;this._iSetCount=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");};
u.prototype.exit=function(){I.prototype.exit.call(this);this._deregisterEvents();this.cancelPendingSuggest();if(this._iRefreshListTimeout){clearTimeout(this._iRefreshListTimeout);this._iRefreshListTimeout=null;}if(this._oSuggestionTable){this._oSuggestionTable.destroy();this._oSuggestionTable=null;}if(this._oSuggPopover){this._oSuggPopover.destroy();this._oSuggPopover=null;}if(this._oShowMoreButton){this._oShowMoreButton.destroy();this._oShowMoreButton=null;}if(this._oButtonToolbar){this._oButtonToolbar.destroy();this._oButtonToolbar=null;}this.$().off("click");};
u.prototype.onBeforeRendering=function(){var i=this.getSelectedKey(),v=this.getShowValueHelp()&&this.getEnabled()&&this.getEditable(),E=this.getAggregation("_endIcon")||[],w=E[0],x,y=this._isSuggestionsPopoverOpen(),V=y?this._oSuggPopover._getValueStateHeader().getText():null,z=y?this._oSuggPopover._getValueStateHeader().getValueState():"";I.prototype.onBeforeRendering.call(this);this._deregisterEvents();if(i){this.setSelectedKey(i);}if(this.getShowSuggestion()){this._oSuggPopover._bAutocompleteEnabled=this.getAutocomplete();if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}else{this._removeShowMoreButton();}x=this._oSuggPopover._oPopupInput;if(x){x.setType(this.getType());}}if(v){w=this._getValueHelpIcon();w.setProperty("visible",true,true);}else if(w){w.setProperty("visible",false,true);}if(!this.getWidth()){this.setProperty("width","100%",true);}if(this._oSuggPopover){this._oSuggPopover._resetTypeAhead();}if(y&&((this.getValueStateText()&&V!==this.getValueStateText())||(this.getValueState()!==z)||(this.getFormattedValueStateText()))){this._updateSuggestionsPopoverValueState();}};
u.prototype._getDisplayText=function(i){var v=this.getTextFormatter();if(v){return v(i);}var w=i.getText(),K=i.getKey(),x=this.getTextFormatMode();switch(x){case p.Key:return K;case p.ValueKey:return w+' ('+K+')';case p.KeyValue:return'('+K+') '+w;default:return w;}};
u.prototype._onValueUpdated=function(i){if(this._bSelectingItem||i===this._sSelectedValue){return;}var K=this.getSelectedKey(),H;if(K===''){return;}if(this._hasTabularSuggestions()){H=this._oSuggestionTable&&!!this._oSuggestionTable.getSelectedItem();}else{H=this._oSuggPopover._oList&&!!this._oSuggPopover._oList.getSelectedItem();}if(H){return;}this.setProperty("selectedKey",'',true);this.setAssociation("selectedRow",null,true);this.setAssociation("selectedItem",null,true);this.fireSuggestionItemSelected({selectedItem:null,selectedRow:null});};
u.prototype._updateSelectionFromList=function(){if(this._oSuggPopover._iPopupListSelectedIndex<0){return false;}var i=this._oSuggPopover._oList.getSelectedItem();if(i){if(this._hasTabularSuggestions()){this.setSelectionRow(i,true);}else{this.setSelectionItem(i._oItem,true);}}return true;};
u.prototype.setSelectionItem=function(i,v){this._bSelectingItem=true;if(!i){this.setAssociation("selectedItem",null,true);this.setValue('');return;}this._oSuggPopover._iPopupListSelectedIndex=-1;var w=this._iSetCount,N;this.setAssociation("selectedItem",i,true);this.setProperty("selectedKey",i.getKey(),true);if(v){this.fireSuggestionItemSelected({selectedItem:i});}if(w!==this._iSetCount){N=this.getValue();}else{N=this._getDisplayText(i);}this._sSelectedValue=N;this.updateInputField(N);if(this.bIsDestroyed){return;}if(!(this.isMobileDevice()&&this instanceof sap.m.MultiInput)){this._closeSuggestionPopup();}this._bSelectingItem=false;};
u.prototype.addSuggestionRowGroup=function(i,H,v){H=H||new G({title:i.text||i.key});this.addAggregation("suggestionRows",H,v);return H;};
u.prototype.addSuggestionItemGroup=function(i,H,v){H=H||new b({text:i.text||i.key});this.addAggregation("suggestionItems",H,v);return H;};
u.prototype.setSelectedItem=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(i!==null&&!(i instanceof a)){return this;}this.setSelectionItem(i);return this;};
u.prototype.setSelectedKey=function(K){K=this.validateProperty("selectedKey",K);this.setProperty("selectedKey",K,true);if(this._hasTabularSuggestions()){return this;}if(!K){this.setSelectionItem();return this;}var i=this.getSuggestionItemByKey(K);this.setSelectionItem(i);return this;};
u.prototype.getSuggestionItemByKey=function(K){var v=this.getSuggestionItems()||[],w,i;for(i=0;i<v.length;i++){w=v[i];if(w.getKey()===K){return w;}}};
u.prototype._getFormattedValueStateText=function(){var i=this._isSuggestionsPopoverOpen(),v=i?this._oSuggPopover._getValueStateHeader().getFormattedText():null;if(i&&v){return v;}else{return I.prototype.getFormattedValueStateText.call(this);}};
u.prototype.setSelectionRow=function(i,v){if(!i){this.setAssociation("selectedRow",null,true);return;}this._oSuggPopover._iPopupListSelectedIndex=-1;this._bSelectingItem=true;var w,x=this.getSuggestionRowValidator();if(x){w=x(i);if(!(w instanceof a)){w=null;}}var y=this._iSetCount,K="",N;this.setAssociation("selectedRow",i,true);if(w){K=w.getKey();}this.setProperty("selectedKey",K,true);if(v){this.fireSuggestionItemSelected({selectedRow:i});}if(y!==this._iSetCount){N=this.getValue();}else{if(w){N=this._getDisplayText(w);}else{N=this._fnRowResultFilter?this._fnRowResultFilter(i):f._DEFAULTRESULT_TABULAR(i);}}this._sSelectedValue=N;this.updateInputField(N);if(this.bIsDestroyed){return;}if(!(this.isMobileDevice()&&this instanceof sap.m.MultiInput&&this._isMultiLineMode)){this._closeSuggestionPopup();}this._bSelectingItem=false;};
u.prototype.setSelectedRow=function(i){if(typeof i==="string"){i=sap.ui.getCore().byId(i);}if(i!==null&&!(i instanceof C)){return this;}this.setSelectionRow(i);return this;};
u.prototype._getValueHelpIcon=function(){var i=this,E=this.getAggregation("_endIcon")||[],v=E[0];if(!v){v=this.addEndIcon({id:this.getId()+"-vhi",src:c.getIconURI("value-help"),useIconTooltip:false,alt:this._oRb.getText("INPUT_VALUEHELP_BUTTON"),decorative:false,noTabStop:true,press:function(w){if(!i.getValueHelpOnly()){var x=this.getParent(),$;if(d.support.touch){$=x.$('inner');$.attr('readonly','readonly');x.focus();$.removeAttr('readonly');}else{x.focus();}i.bValueHelpRequested=true;i._fireValueHelpRequest(false);}}});}return v;};
u.prototype._fireValueHelpRequest=function(F){var i="";if(this.getShowSuggestion()&&this._oSuggPopover){i=this._oSuggPopover._sTypedInValue||"";}else{i=this.getDOMValue();}this.fireValueHelpRequest({fromSuggestions:F,_userInputValue:i});};
u.prototype._fireValueHelpRequestForValueHelpOnly=function(){if(this.getEnabled()&&this.getEditable()&&this.getShowValueHelp()&&this.getValueHelpOnly()){if(d.system.phone){this.focus();}this._fireValueHelpRequest(false);}};
u.prototype.ontap=function(E){I.prototype.ontap.call(this,E);if(this.isValueHelpOnlyOpener(E.target)){this._fireValueHelpRequestForValueHelpOnly();}if(this.isMobileDevice()&&this.getEditable()&&this.getEnabled()&&this.getShowSuggestion()&&this._oSuggPopover&&E.target.id!=this.getId()+"-vhi"){this._openSuggestionsPopover();}};
u.prototype.setFilterFunction=function(F){if(F===null||F===undefined){this._fnFilter=f._DEFAULTFILTER;return this;}k(typeof(F)==="function","Input.setFilterFunction: first argument fnFilter must be a function on "+this);this._fnFilter=F;return this;};
u.prototype.setRowResultFunction=function(F){var i;if(F===null||F===undefined){this._fnRowResultFilter=f._DEFAULTRESULT_TABULAR;return this;}k(typeof(F)==="function","Input.setRowResultFunction: first argument fnFilter must be a function on "+this);this._fnRowResultFilter=F;i=this.getSelectedRow();if(i){this.setSelectedRow(i);}return this;};
u.prototype.closeSuggestions=function(){this._closeSuggestionPopup();};
u.prototype._doSelect=function(i,E){if(d.support.touch){return;}var v=this._$input[0];if(v){var R=this._$input;v.focus();R.selectText(i?i:0,E?E:R.val().length);}return this;};
u.prototype._isIncrementalType=function(){var i=this.getType();if(i==="Number"||i==="Date"||i==="Datetime"||i==="Month"||i==="Time"||i==="Week"){return true;}return false;};
u.prototype.onsapescape=function(E){var i;if(this._isSuggestionsPopoverOpen()){E.originalEvent._sapui_handledByControl=true;this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();if(this._sBeforeSuggest!==undefined){if(this._sBeforeSuggest!==this.getValue()){i=this.getLastValue();this.setValue(this._sBeforeSuggest);this.setLastValue(i);}this._sBeforeSuggest=undefined;}return;}if(this.getValueLiveUpdate()){this.setProperty("value",this.getLastValue(),true);}if(I.prototype.onsapescape){I.prototype.onsapescape.apply(this,arguments);}};
u.prototype.onsapenter=function(E){this.cancelPendingSuggest();if(this._isSuggestionsPopoverOpen()){if(!this._updateSelectionFromList()&&!this.isComposingCharacter()){this._closeSuggestionPopup();}}if(I.prototype.onsapenter){I.prototype.onsapenter.apply(this,arguments);}if(this.getEnabled()&&this.getEditable()&&!(this.getValueHelpOnly()&&this.getShowValueHelp())){this.fireSubmit({value:this.getValue()});}};
u.prototype.onsapfocusleave=function(E){var i=this._oSuggPopover,v=i&&i._oPopover,F=E.relatedControlId&&sap.ui.getCore().byId(E.relatedControlId),w=F&&F.getFocusDomRef(),H=i&&i._sProposedItemText&&this.getAutocomplete(),x=v&&w&&j(v.getDomRef(),w);if(v instanceof P){if(x&&!i.bMessageValueStateActive){this._bPopupHasFocus=true;if(d.system.desktop&&m(v.getFocusDomRef(),w)||F.isA("sap.m.GroupHeaderListItem")){this.focus();}}else{if(this.getDOMValue()===this._sSelectedSuggViaKeyboard){this._sSelectedSuggViaKeyboard=null;}}}if(!x&&!H){I.prototype.onsapfocusleave.apply(this,arguments);}this.bValueHelpRequested=false;};
u.prototype.onmousedown=function(E){if(this._isSuggestionsPopoverOpen()){E.stopPropagation();}};
u.prototype._deregisterEvents=function(){if(this._oSuggPopover){this._oSuggPopover._deregisterResize();}if(this.isMobileDevice()&&this._oSuggPopover&&this._oSuggPopover._oPopover){this.$().off("click");}};
u.prototype.updateSuggestionItems=function(){this._bSuspendInvalidate=true;this.updateAggregation("suggestionItems");this._synchronizeSuggestions();this._bSuspendInvalidate=false;return this;};
u.prototype.invalidate=function(){if(!this._bSuspendInvalidate){e.prototype.invalidate.apply(this,arguments);}};
u.prototype.cancelPendingSuggest=function(){if(this._iSuggestDelay){clearTimeout(this._iSuggestDelay);this._iSuggestDelay=null;}};
u.prototype._triggerSuggest=function(v){this.cancelPendingSuggest();this._bShouldRefreshListItems=true;if(!v){v="";}if(v.length>=this.getStartSuggestion()){this._iSuggestDelay=setTimeout(function(){if(this._sPrevSuggValue!==v){this._bBindingUpdated=false;this.fireSuggest({suggestValue:v});if(!this._bBindingUpdated){this._refreshItemsDelayed();}this._sPrevSuggValue=v;}}.bind(this),300);}else if(this.isMobileDevice()){if(this._oSuggPopover._oList instanceof T){this._oSuggPopover._oList.addStyleClass("sapMInputSuggestionTableHidden");}else if(this._oSuggPopover._oList&&this._oSuggPopover._oList.destroyItems){this._oSuggPopover._oList.destroyItems();}}else if(this._isSuggestionsPopoverOpen()){setTimeout(function(){var N=this.getDOMValue()||'';if(N<this.getStartSuggestion()){this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}}.bind(this),0);}};
(function(){
u.prototype.setShowSuggestion=function(v){this.setProperty("showSuggestion",v,true);if(v){this._oSuggPopover=this._getSuggestionsPopover();this._oSuggPopover._iPopupListSelectedIndex=-1;if(!this._oSuggPopover._oPopover){this._createSuggestionsPopoverPopup();this._synchronizeSuggestions();this._createSuggestionPopupContent();}}else{if(this._oSuggPopover){this._oSuggPopover._destroySuggestionPopup();this._oSuggPopover._iPopupListSelectedIndex=-1;this._oButtonToolbar=null;this._oShowMoreButton=null;}}return this;};
u.prototype._shouldTriggerSuggest=function(){return!this._bPopupHasFocus&&!this.getStartSuggestion()&&!this.getValue()&&this.getShowSuggestion();};
u.prototype.setShowTableSuggestionValueHelp=function(v){this.setProperty("showTableSuggestionValueHelp",v,true);if(!(this._oSuggPopover&&this._oSuggPopover._oPopover)){return this;}if(v){this._addShowMoreButton();}else{this._removeShowMoreButton();}return this;};
u.prototype.onchange=function(E){if(this.getShowValueHelp()||this.getShowSuggestion()){return;}this.onChange(E);};
u.prototype.oninput=function(E){I.prototype.oninput.call(this,E);if(E.isMarked("invalid")){return;}var v=this.getDOMValue(),i,w,x;if(this.getValueLiveUpdate()){this.setProperty("value",v,true);this._onValueUpdated(v);}this.fireLiveChange({value:v,newValue:v});this.addStyleClass("sapMFocus");if(this.getShowSuggestion()&&!this.isMobileDevice()){i=this._getSuggestionsPopover();w=i._oList;this._triggerSuggest(v);if(w&&!i.bMessageValueStateActive){x=w.getSelectedItem();w.removeStyleClass("sapMListFocus");x&&x.removeStyleClass("sapMLIBFocused");}else if(i.bMessageValueStateActive&&document.activeElement.tagName!=="A"){i._getValueStateHeader().removeStyleClass("sapMPseudoFocus");}}};
u.prototype.getValue=function(){return this.getDomRef("inner")&&this._$input?this.getDOMValue():this.getProperty("value");};
u.prototype._refreshItemsDelayed=function(){clearTimeout(this._iRefreshListTimeout);this._iRefreshListTimeout=setTimeout(function(){if(this._oSuggPopover){this._refreshListItems();}}.bind(this),0);};
u.prototype._filterListItems=function(v,w){var i,x,y,z=[],H=[],F=this.getFilterSuggests(),A=false;for(i=0;i<v.length;i++){y=v[i];if(v[i].isA("sap.ui.core.SeparatorItem")){x=new G({id:y.getId()+"-ghli",title:v[i].getText()});z.push({header:x,visible:false});this._configureListItem(y,x);H.push(x);}else if(!F||this._fnFilter(w,y)){if(v[i].isA("sap.ui.core.ListItem")){x=new D(y.getId()+"-dli");x.setLabel(y.getText());x.setValue(y.getAdditionalText());}else{x=new S(y.getId()+"-sli");x.setTitle(y.getText());}if(!A&&(this._oSuggPopover._sProposedItemText===v[i].getText())){x.setSelected(true);A=true;}if(z.length){z[z.length-1].visible=true;}this._configureListItem(y,x);H.push(x);}}z.forEach(function(E){E.header.setVisible(E.visible);});return{hitItems:H,groups:z};};
u.prototype._filterTabularItems=function(v,w){var i,x,F=this.getFilterSuggests(),H=[],y=[],z=false;for(i=0;i<v.length;i++){if(v[i].isA("sap.m.GroupHeaderListItem")){y.push({header:v[i],visible:false});}else{x=!F||this._fnFilter(w,v[i]);v[i].setVisible(x);x&&H.push(v[i]);if(!z&&x&&this._oSuggPopover._sProposedItemText===this._fnRowResultFilter(v[i])){v[i].setSelected(true);z=true;}if(y.length&&x){y[y.length-1].visible=true;}}}y.forEach(function(A){A.header.setVisible(A.visible);});this._getSuggestionsTable().invalidate();return{hitItems:H,groups:y};};
u.prototype._clearSuggestionPopupItems=function(){if(!this._oSuggPopover._oList){return;}if(this._oSuggPopover._oList instanceof T){this._oSuggPopover._oList.removeSelections(true);}else{this._oSuggPopover._oList.destroyItems();}};
u.prototype._hideSuggestionPopup=function(){var i=this._oSuggPopover._oPopover;function v(){if(d.browser.internet_explorer){var F=this.getFocusInfo();this.setDOMValue(this._oSuggPopover._sTypedInValue);this.applyFocusInfo(F);}else{this.setDOMValue(this._oSuggPopover._sTypedInValue);}}if(!this.isMobileDevice()){if(this._isSuggestionsPopoverOpen()){this._sCloseTimer=setTimeout(function(){if(this._oSuggPopover){this._oSuggPopover._iPopupListSelectedIndex=-1;}this.cancelPendingSuggest();if(this._oSuggPopover._sTypedInValue){v.call(this);}this._oSuggPopover._oProposedItem=null;i.close();}.bind(this),0);}}else if(this._hasTabularSuggestions()&&this._oSuggPopover._oList){this._oSuggPopover._oList.addStyleClass("sapMInputSuggestionTableHidden");}this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-activedescendant");};
u.prototype._openSuggestionPopup=function(O){if(!this.isMobileDevice()){if(this._sCloseTimer){clearTimeout(this._sCloseTimer);this._sCloseTimer=null;}if(!this._isSuggestionsPopoverOpen()&&!this._sOpenTimer&&O!==false){this._sOpenTimer=setTimeout(function(){this._sOpenTimer=null;this._oSuggPopover&&this._openSuggestionsPopover();}.bind(this),0);}}};
u.prototype._getFilteredSuggestionItems=function(i){var F,v=this.getSuggestionItems(),w=this.getSuggestionRows();if(this._hasTabularSuggestions()){if(this.isMobileDevice()&&this._oSuggPopover._oList){this._oSuggPopover._oList.removeStyleClass("sapMInputSuggestionTableHidden");}F=this._filterTabularItems(w,i);}else{F=this._filterListItems(v,i);}return F;};
u.prototype._fillSimpleSuggestionPopupItems=function(F){var i,H=F.hitItems,v=F.groups,w=H.length,x=w;if(!this._hasTabularSuggestions()){for(i=0;i<w;i++){this._oSuggPopover._oList.addItem(H[i]);}x-=v.length;}return x;};
u.prototype._applySuggestionAcc=function(N){var A="",R=this._oRb;if(N===1){A=R.getText("INPUT_SUGGESTIONS_ONE_HIT");}else if(N>1){A=R.getText("INPUT_SUGGESTIONS_MORE_HITS",N);}else{A=R.getText("INPUT_SUGGESTIONS_NO_HIT");}this.$("SuggDescr").text(A);};
u.prototype._refreshListItems=function(){var i=this.getShowSuggestion(),v=this._oSuggPopover._sTypedInValue||this.getDOMValue()||"",F,w;this._oSuggPopover._iPopupListSelectedIndex=-1;if(!i||!this._bShouldRefreshListItems||!this.getDomRef()||(!this.isMobileDevice()&&!this.$().hasClass("sapMInputFocused"))){return null;}this._clearSuggestionPopupItems();if(v.length<this.getStartSuggestion()){this._hideSuggestionPopup();return false;}F=this._getFilteredSuggestionItems(v);w=this._fillSimpleSuggestionPopupItems(F);if(w>0){this._openSuggestionPopup(this.getValue().length>=this.getStartSuggestion());}else{this._hideSuggestionPopup();}this._applySuggestionAcc(w);};
u.prototype._configureListItem=function(i,v){var w=o.Active;if(!i.getEnabled()||v.isA("sap.m.GroupHeaderListItem")){w=o.Inactive;}v.setType(w);v._oItem=i;v.addEventDelegate({ontouchstart:function(E){(E.originalEvent||E)._sapui_cancelAutoClose=true;}});return v;};
u.prototype.addSuggestionItem=function(i){this.addAggregation("suggestionItems",i,true);if(!this._oSuggPopover){this._getSuggestionsPopover();}this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
u.prototype.insertSuggestionItem=function(i,v){this.insertAggregation("suggestionItems",v,i,true);if(!this._oSuggPopover){this._getSuggestionsPopover();}this._synchronizeSuggestions();this._createSuggestionPopupContent();return this;};
u.prototype.removeSuggestionItem=function(i){var v=this.removeAggregation("suggestionItems",i,true);this._synchronizeSuggestions();return v;};
u.prototype.removeAllSuggestionItems=function(){var i=this.removeAllAggregation("suggestionItems",true);this._synchronizeSuggestions();return i;};
u.prototype.destroySuggestionItems=function(){this.destroyAggregation("suggestionItems",true);this._synchronizeSuggestions();return this;};
u.prototype.addSuggestionRow=function(i){i.setType(o.Active);this.addAggregation("suggestionRows",i);this._synchronizeSuggestions();this._createSuggestionPopupContent(true);return this;};
u.prototype.insertSuggestionRow=function(i,v){i.setType(o.Active);this.insertAggregation("suggestionRows",i,v);this._synchronizeSuggestions();this._createSuggestionPopupContent(true);return this;};
u.prototype.removeSuggestionRow=function(i){var v=this.removeAggregation("suggestionRows",i);this._synchronizeSuggestions();return v;};
u.prototype.removeAllSuggestionRows=function(){var i=this.removeAllAggregation("suggestionRows");this._synchronizeSuggestions();return i;};
u.prototype.destroySuggestionRows=function(){this.destroyAggregation("suggestionRows");this._synchronizeSuggestions();return this;};
u.prototype.bindAggregation=function(){if(arguments[0]==="suggestionRows"||arguments[0]==="suggestionColumns"||arguments[0]==="suggestionItems"){this._createSuggestionPopupContent(arguments[0]==="suggestionRows"||arguments[0]==="suggestionColumns");this._bBindingUpdated=true;}return I.prototype.bindAggregation.apply(this,arguments);};
u.prototype._closeSuggestionPopup=function(){if(this._isSuggestionsPopoverOpen()){this.cancelPendingSuggest();this._oSuggPopover._oPopover.close();if(!this.isMobileDevice()&&this.$().hasClass("sapMInputFocused")){this.openValueStateMessage();}this.$("SuggDescr").text("");this.$("inner").removeAttr("aria-activedescendant");this._sPrevSuggValue=null;}};
u.prototype._synchronizeSuggestions=function(){if(document.activeElement===this.getFocusDomRef()){this._bShouldRefreshListItems=true;this._refreshItemsDelayed();}if(!this.getDomRef()||this._isSuggestionsPopoverOpen()){return;}this._synchronizeSelection();};
u.prototype._synchronizeSelection=function(){var i=this.getSelectedKey();if(!i){return;}if(this.getValue()&&!this.getSelectedItem()&&!this.getSelectedRow()){return;}this.setSelectedKey(i);};
})();
u.prototype.onfocusin=function(E){I.prototype.onfocusin.apply(this,arguments);this.addStyleClass("sapMInputFocused");if(!this.isMobileDevice()&&this._isSuggestionsPopoverOpen()){this.closeValueStateMessage();}if(this._shouldTriggerSuggest()){this._triggerSuggest(this.getValue());}this._bPopupHasFocus=undefined;this._sPrevSuggValue=null;};
u.prototype.oncompositionend=function(E){I.prototype.oncompositionend.apply(this,arguments);if(this._oSuggPopover&&!d.browser.edge&&!d.browser.firefox){this._oSuggPopover._handleTypeAhead();}};
u.prototype.onsapshow=function(E){if(!this.getEnabled()||!this.getEditable()||!this.getShowValueHelp()){return;}this.bValueHelpRequested=true;this._fireValueHelpRequest(false);E.preventDefault();E.stopPropagation();};
u.prototype.onsaphide=u.prototype.onsapshow;
u.prototype.onsapselect=function(E){this._fireValueHelpRequestForValueHelpOnly();};
u.prototype.onfocusout=function(E){I.prototype.onfocusout.apply(this,arguments);this.removeStyleClass("sapMInputFocused");this.$("SuggDescr").text("");};
u.prototype._hasTabularSuggestions=function(){return!!(this.getAggregation("suggestionColumns")&&this.getAggregation("suggestionColumns").length);};
u.prototype._getSuggestionsTable=function(){if(this._bIsBeingDestroyed){return this._oSuggestionTable;}if(!this._oSuggestionTable){this._oSuggestionTable=new T(this.getId()+"-popup-table",{mode:s.SingleSelectMaster,showNoData:false,showSeparators:t.None,width:"100%",enableBusyIndicator:false,rememberSelections:false,itemPress:function(E){if(d.system.desktop){this.focus();}this._oSuggPopover._bSuggestionItemTapped=true;var i=E.getParameter("listItem");this.setSelectionRow(i,true);}.bind(this),sticky:[l.Sticky.ColumnHeaders]});this._oSuggestionTable.addEventDelegate({onAfterRendering:function(){var i,v;if(!this.getEnableSuggestionsHighlighting()){return;}i=this._oSuggestionTable.$().find('tbody .sapMLabel');v=(this._sTypedInValue||this.getValue()).toLowerCase();this._oSuggPopover.highlightSuggestionItems(i,v);}.bind(this)});if(this.isMobileDevice()){this._oSuggestionTable.addStyleClass("sapMInputSuggestionTableHidden");}this._oSuggestionTable.updateItems=function(){T.prototype.updateItems.apply(this,arguments);this._refreshItemsDelayed();return this;};}return this._oSuggestionTable;};
u.prototype.clone=function(){var i=e.prototype.clone.apply(this,arguments);i.setRowResultFunction(this._fnRowResultFilter);i.setValue(this.getValue());return i;};
u.prototype.setValue=function(v){this._iSetCount++;I.prototype.setValue.call(this,v);this._onValueUpdated(v);return this;};
u.prototype.setDOMValue=function(v){this._$input.val(v);};
u.prototype.getDOMValue=function(){return this._$input.val();};
u.prototype.updateInputField=function(N){if(this._isSuggestionsPopoverOpen()&&this.isMobileDevice()){this._oSuggPopover._oPopupInput.setValue(N);this._oSuggPopover._oPopupInput._doSelect();}else{N=this._getInputValue(N);this.setDOMValue(N);this.onChange(null,null,N);}};
u.prototype.getAccessibilityInfo=function(){var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.description=((i.description||"")+" "+this.getDescription()).trim();return i;};
u.prototype.preventChangeOnFocusLeave=function(E){return this.bFocusoutDueRendering||this.bValueHelpRequested;};
u.prototype._getShowMoreButton=function(){return this._oShowMoreButton||(this._oShowMoreButton=new B({text:this._oRb.getText("INPUT_SUGGESTIONS_SHOW_ALL"),press:this._getShowMoreButtonPress.bind(this)}));};
u.prototype._getShowMoreButtonPress=function(){var i;if(this.getShowTableSuggestionValueHelp()){if(this._oSuggPopover._sTypedInValue){i=this._oSuggPopover._sTypedInValue;this.updateDomValue(i);this._oSuggPopover._resetTypeAhead();this._oSuggPopover._sTypedInValue=i;}this._fireValueHelpRequest(true);this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}};
u.prototype._addShowMoreButton=function(i){var v=this._oSuggPopover&&this._oSuggPopover._oPopover;if(!v||!i&&!this._hasTabularSuggestions()){return;}if(v.isA("sap.m.Dialog")){var w=this._getShowMoreButton();v.setEndButton(w);}else{var x=this._getButtonToolbar();v.setFooter(x);}};
u.prototype._removeShowMoreButton=function(){var i=this._oSuggPopover&&this._oSuggPopover._oPopover;if(!i||!this._hasTabularSuggestions()){return;}if(i.isA("sap.m.Dialog")){i.setEndButton(null);}else{i.setFooter(null);}};
u.prototype._getButtonToolbar=function(){var i=this._getShowMoreButton();return this._oButtonToolbar||(this._oButtonToolbar=new g({content:[new h(),i]}));};
u.prototype._hasShowSelectedButton=function(){return false;};
u.prototype._createSuggestionPopupContent=function(i){if(this._bIsBeingDestroyed||this._getSuggestionsPopover()._oList){return;}this._oSuggPopover._createSuggestionPopupContent(i);if(!this._hasTabularSuggestions()&&!i){this._oSuggPopover._oList.attachItemPress(function(E){if(d.system.desktop){this.focus();}var v=E.getParameter("listItem");if(!v.isA("sap.m.GroupHeaderListItem")){this._oSuggPopover._bSuggestionItemTapped=true;this.setSelectionItem(v._oItem,true);}},this);}else{if(this._fnFilter===f._DEFAULTFILTER){this._fnFilter=u._DEFAULTFILTER_TABULAR;}if(!this._fnRowResultFilter){this._fnRowResultFilter=u._DEFAULTRESULT_TABULAR;}if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton(i);}}};
u.prototype._createPopupInput=function(){var i=new u(this.getId()+"-popup-input",{width:"100%",valueLiveUpdate:true,showValueStateMessage:false,valueState:this.getValueState(),showValueHelp:this.getShowValueHelp(),valueHelpRequest:function(E){this.fireValueHelpRequest({fromSuggestions:true});this._oSuggPopover._iPopupListSelectedIndex=-1;this._closeSuggestionPopup();}.bind(this),liveChange:function(E){var v=E.getParameter("newValue");this.setDOMValue(this._getInputValue(this._oSuggPopover._oPopupInput.getValue()));this._triggerSuggest(v);this.fireLiveChange({value:v,newValue:v});}.bind(this)});return i;};
u.prototype._modifyPopupInput=function(i){i.addEventDelegate({onsapenter:function(){if(this.getAutocomplete()){this._oSuggPopover._finalizeAutocomplete();}this._closeSuggestionPopup();}},this);return i;};
u.prototype.forwardEventHandlersToSuggPopover=function(i){i.setOkPressHandler(this._closeSuggestionPopup.bind(this));i.setCancelPressHandler(this._closeSuggestionPopup.bind(this));};
u.prototype._getSuggestionsPopover=function(){if(!this._oSuggPopover){var i=this._oSuggPopover=new f(this);if(this.isMobileDevice()){var v=this._createPopupInput();i._oPopupInput=this._modifyPopupInput(v);}this._oSuggPopover.setInputLabels(this.getLabels.bind(this));this._createSuggestionsPopoverPopup();this.forwardEventHandlersToSuggPopover(i);i._bAutocompleteEnabled=this.getAutocomplete();i.attachEvent(f.M_EVENTS.SELECTION_CHANGE,function(E){var N=E.getParameter("newValue");this.setDOMValue(N);this._sSelectedSuggViaKeyboard=N;this._doSelect();},this);if(this.getShowTableSuggestionValueHelp()){this._addShowMoreButton();}}return this._oSuggPopover;};
u.prototype._createSuggestionsPopoverPopup=function(){if(!this._oSuggPopover){return;}var i=this._oSuggPopover;var v;i._createSuggestionPopup({showSelectedButton:this._hasShowSelectedButton()});v=i._oPopover;v.attachBeforeOpen(function(){this._updateSuggestionsPopoverValueState();},this);v.attachBeforeClose(function(){this._updateSuggestionsPopoverValueState();},this);if(this.isMobileDevice()){v.attachBeforeClose(function(){this.setDOMValue(this._getInputValue(i._oPopupInput.getValue()));this.onChange();},this).attachAfterClose(function(){var w=i._oList;if(!w){return;}if(T&&!(w instanceof T)){w.destroyItems();}else{w.removeSelections(true);}}).attachAfterOpen(function(){this._triggerSuggest(this.getValue());this._refreshListItems();},this).attachBeforeOpen(function(){i._oPopupInput.setPlaceholder(this.getPlaceholder());i._oPopupInput.setMaxLength(this.getMaxLength());i._oPopupInput.setValue(this.getValue());},this);}else{v.attachAfterClose(function(){this._updateSelectionFromList();var w=i._oList,x=w.getSelectedItem();if(!w){return;}if(w instanceof T){x&&x.removeStyleClass("sapMLIBFocused");w.removeSelections(true);}else{w.destroyItems();}i._deregisterResize();},this).attachBeforeOpen(function(){i._sPopoverContentWidth=this.getMaxSuggestionWidth();i._bEnableHighlighting=this.getEnableSuggestionsHighlighting();i._bAutocompleteEnabled=this.getAutocomplete();i._bIsInputIncrementalType=this._isIncrementalType();this._sBeforeSuggest=this.getValue();i._resizePopup();i._registerResize();},this);}this.setAggregation("_suggestionPopup",v);this._oSuggestionPopup=v;};
u.prototype.showItems=function(F){var i,v,w=this._fnFilter;if(!this.getEnabled()||!this.getEditable()){return;}this.setFilterFunction(F||function(){return true;});this._clearSuggestionPopupItems();i=this._getFilteredSuggestionItems(this.getDOMValue());v=this._fillSimpleSuggestionPopupItems(i);if(v>0){this._openSuggestionPopup();}else{this._hideSuggestionPopup();}this._applySuggestionAcc(v);this.setFilterFunction(w);};
u.prototype.shouldValueStateMessageBeOpened=function(){var i=I.prototype.shouldValueStateMessageBeOpened.apply(this,arguments);if(!i||this._isSuggestionsPopoverOpen()){return false;}return true;};
u.prototype._isSuggestionsPopoverOpen=function(){return this._oSuggPopover&&this._oSuggPopover.isOpen();};
u.prototype.isMobileDevice=function(){return d.system.phone;};
u.prototype._openSuggestionsPopover=function(){this.closeValueStateMessage();this._updateSuggestionsPopoverValueState();this._oSuggPopover._oPopover.open();};
u.prototype._updateSuggestionsPopoverValueState=function(){var i=this._oSuggPopover,v=this.getValueState(),N=this.getValueState()!==i._getValueStateHeader().getValueState(),w=this.getFormattedValueStateText(),V=this.getValueStateText();if(!i){return;}if(this._isSuggestionsPopoverOpen()&&!w&&!N){this.setFormattedValueStateText(this._oSuggPopover._getValueStateHeader().getFormattedText());}i.updateValueState(v,(w||V),this.getShowValueStateMessage());if(this.isMobileDevice()){i._oPopupInput.setValueState(v);}};
u.prototype.setShowValueHelp=function(i){this.setProperty("showValueHelp",i);if(this._oSuggPopover&&this._oSuggPopover._oPopupInput){this._oSuggPopover._oPopupInput.setShowValueHelp(i);}return this;};
u.prototype.isValueHelpOnlyOpener=function(i){return true;};
return u;});
sap.ui.predefine('sap/m/InputBase',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./delegate/ValueStateMessage','sap/ui/core/message/MessageMixin','sap/ui/core/library','sap/ui/Device','./InputBaseRenderer','sap/base/Log',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/getSelectedText","sap/ui/dom/jquery/selectText"],function(l,C,E,I,V,M,c,D,a,b,K,q){"use strict";var T=c.TextDirection;var d=c.TextAlign;var f=c.ValueState;
var g=C.extend("sap.m.InputBase",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:f.None},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueStateText:{type:"string",group:"Misc",defaultValue:null},showValueStateMessage:{type:"boolean",group:"Misc",defaultValue:true},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:d.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},required:{type:"boolean",group:"Misc",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"string"}}}},aggregations:{formattedValueStateText:{type:"sap.m.FormattedText",multiple:false,defaultValue:null},_endIcon:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"},_beginIcon:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"}},designtime:"sap/m/designtime/InputBase.designtime"}});
E.call(g.prototype);I.insertFontFaceStyle();M.call(g.prototype);g.ICON_PRESSED_CSS_CLASS="sapMInputBaseIconPressed";g.ICON_CSS_CLASS="sapMInputBaseIcon";g.prototype.bShowLabelAsPlaceholder=!D.support.input.placeholder;
g.prototype.handleInput=function(e){if(this._bIgnoreNextInput||this._bIgnoreNextInputNonASCII){this._bIgnoreNextInput=false;this._bIgnoreNextInputNonASCII=false;e.setMarked("invalid");return;}this._bIgnoreNextInput=false;this._bIgnoreNextInputNonASCII=false;if(!this.getEditable()){e.setMarked("invalid");return;}if(document.activeElement!==e.target&&D.browser.msie&&this.getValue()===this.getLastValue()){e.setMarked("invalid");return;}this._bCheckDomValue=true;};
g.prototype._getPlaceholder=function(){return this.getPlaceholder()||"";};
g.prototype._getInputValue=function(v){v=(v===undefined)?this.$("inner").val()||"":v.toString();if(this.getMaxLength&&this.getMaxLength()>0){v=v.substring(0,this.getMaxLength());}return v;};
g.prototype._getInputElementTagName=function(){if(!this._sInputTagElementName){this._sInputTagElementName=this._$input&&this._$input.get(0)&&this._$input.get(0).tagName;}return this._sInputTagElementName;};
g.prototype.init=function(){this.setLastValue("");this.bRenderingPhase=false;this._oValueStateMessage=new V(this);this._bIsComposingCharacter=false;this.fnCloseValueStateOnClick=function(){this.closeValueStateMessage();};};
g.prototype.oncompositionstart=function(){this._bIsComposingCharacter=true;};
g.prototype.oncompositionend=function(e){this._bIsComposingCharacter=false;if(!D.browser.edge&&!D.browser.firefox){this.handleInput(e);}};
g.prototype.isComposingCharacter=function(){return this._bIsComposingCharacter;};
g.prototype.onBeforeRendering=function(){if(D.browser.msie&&D.browser.version>9&&!/^[\x00-\x7F]*$/.test(this.getValue())){this._bIgnoreNextInputNonASCII=true;this._oDomRefBeforeRendering=this.getDomRef();}if(this._bCheckDomValue&&!this.bRenderingPhase){this._sDomValue=this._getInputValue();}this.bRenderingPhase=true;};
g.prototype.onAfterRendering=function(){var v=this.getValueState();var i=this.getFocusDomRef()===document.activeElement;var e=v===f.None;if(this._bCheckDomValue&&this._sDomValue!==this._getInputValue()){this.$("inner").val(this._sDomValue);}this.$("message").text(this.getValueStateText());this._bIgnoreNextInputNonASCII=this._bIgnoreNextInputNonASCII&&this._oDomRefBeforeRendering!==this.getDomRef();this._bCheckDomValue=false;this.bRenderingPhase=false;if(i){this[e?"closeValueStateMessage":"openValueStateMessage"]();}};
g.prototype.exit=function(){if(this._oValueStateMessage){this._oValueStateMessage.destroy();}this._oValueStateMessage=null;this._oDomRefBeforeRendering=null;};
g.prototype.ontouchstart=function(e){e.setMarked();};
g.prototype.onfocusin=function(e){this._bIgnoreNextInput=!this.bShowLabelAsPlaceholder&&D.browser.msie&&D.browser.version>9&&!!this.getPlaceholder()&&!this._getInputValue()&&this._getInputElementTagName()==="INPUT";this.addStyleClass("sapMFocus");this.openValueStateMessage();};
g.prototype.onfocusout=function(e){this.removeStyleClass("sapMFocus");if(!this._bClickOnValueStateLink(e)){this.closeValueStateMessage();}};
g.prototype.onsapfocusleave=function(e){if(!this.preventChangeOnFocusLeave(e)){this.onChange(e);}};
g.prototype.preventChangeOnFocusLeave=function(e){return this.bFocusoutDueRendering;};
g.prototype.getChangeEventParams=function(){return{};};
g.prototype.ontap=function(e){return;};
g.prototype.onChange=function(e,p,n){p=p||this.getChangeEventParams();if(!this.getEditable()||!this.getEnabled()){return;}var v=this._getInputValue(n);if(v!==this.getLastValue()){this.setValue(v);v=this.getValue();this.setLastValue(v);this.fireChangeEvent(v,p);return true;}else{this._bCheckDomValue=false;}};
g.prototype.fireChangeEvent=function(v,p){var o=q.extend({value:v,newValue:v},p);this.fireChange(o);};
g.prototype.onValueRevertedByEscape=function(v,p){this.fireEvent("liveChange",{value:v,escPressed:true,previousValue:p,newValue:v});};
g.prototype.onsapenter=function(e){if((D.browser.safari||D.browser.msie)&&this.isComposingCharacter()){e.setMarked("invalid");return;}this.onChange(e);};
g.prototype.onsapescape=function(e){var v=this._getInputValue();if(v!==this.getLastValue()){e.setMarked();e.preventDefault();this.updateDomValue(this.getLastValue());this.onValueRevertedByEscape(this.getLastValue(),v);}};
g.prototype.oninput=function(e){this.handleInput(e);};
g.prototype.onkeydown=function(e){if(this.getDomRef("inner").getAttribute("readonly")&&e.keyCode==K.BACKSPACE){e.preventDefault();}};
g.prototype.oncut=function(e){};
g.prototype.selectText=function(s,S){this.$("inner").selectText(s,S);return this;};
g.prototype.getSelectedText=function(){return this.$("inner").getSelectedText();};
g.prototype.setProperty=function(p,v,s){if(p=="value"){this._bCheckDomValue=false;}return C.prototype.setProperty.apply(this,arguments);};
g.prototype.getFocusInfo=function(){var F=C.prototype.getFocusInfo.call(this),o=this.getFocusDomRef();q.extend(F,{cursorPos:0,selectionStart:0,selectionEnd:0});if(o){F.cursorPos=q(o).cursorPos();try{F.selectionStart=o.selectionStart;F.selectionEnd=o.selectionEnd;}catch(e){}}return F;};
g.prototype.applyFocusInfo=function(F){C.prototype.applyFocusInfo.call(this,F);this.$("inner").cursorPos(F.cursorPos);this.selectText(F.selectionStart,F.selectionEnd);return this;};
g.prototype.updateDomValue=function(v){var i=this.getFocusDomRef();if(!this.isActive()){return this;}v=this._getInputValue(v);if(this._getInputValue()===v){return this;}this._bCheckDomValue=true;if(this._bPreferUserInteraction){this.handleInputValueConcurrency(v);}else{i.value=v;}return this;};
g.prototype._aValueStateLinks=function(){if(this.getFormattedValueStateText()&&this.getFormattedValueStateText().getHtmlText()&&this.getFormattedValueStateText().getControls().length){return this.getFormattedValueStateText().getControls();}else{return[];}};
g.prototype._bClickOnValueStateLink=function(e){var v=this._aValueStateLinks();return v.some(function(L){return e.relatedTarget===L.getDomRef();});};
g.prototype._attachValueStateLinkPress=function(){this._aValueStateLinks().forEach(function(L){L.attachPress(this.fnCloseValueStateOnClick,this);},this);};
g.prototype._detachValueStateLinkPress=function(){this._aValueStateLinks().forEach(function(L){L.detachPress(this.fnCloseValueStateOnClick,this);},this);};
g.prototype.handleInputValueConcurrency=function(v){var i=this.getFocusDomRef(),s=i&&this._getInputValue(),e=this.getProperty("value"),h=document.activeElement===i,B=this.isBound("value")&&this.getBindingInfo("value").skipModelUpdate;if(h&&B&&s&&(e!==s)){return this;}i.value=v;if(h&&B&&!s){i.select();}};
g.prototype._setPreferUserInteraction=function(p){this._bPreferUserInteraction=p;};
g.prototype.closeValueStateMessage=function(){setTimeout(function(){if(this._oValueStateMessage){this._detachValueStateLinkPress();this._oValueStateMessage.close();}}.bind(this),0);};
g.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef("content");};
g.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
g.prototype.iOpenMessagePopupDuration=0;
g.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
g.prototype.getLabels=function(){var L=this.getAriaLabelledBy().map(function(s){return sap.ui.getCore().byId(s);});var o=sap.ui.require("sap/ui/core/LabelEnablement");if(o){L=L.concat(o.getReferencingLabels(this).map(function(s){return sap.ui.getCore().byId(s);}));}return L;};
g.prototype.openValueStateMessage=function(){if(this._oValueStateMessage&&this.shouldValueStateMessageBeOpened()){setTimeout(function(){if(!this.bIsDestroyed){this._detachValueStateLinkPress();this._attachValueStateLinkPress();this._oValueStateMessage.open();}}.bind(this),0);}};
g.prototype.shouldValueStateMessageBeOpened=function(){return(this.getValueState()!==f.None)&&this.getEditable()&&this.getEnabled()&&this.getShowValueStateMessage();};
g.prototype._calculateIconsSpace=function(){var e=this.getAggregation("_endIcon")||[],B=this.getAggregation("_beginIcon")||[],i=e.concat(B),h;return i.reduce(function(A,o){h=o&&o.getDomRef()?o.getDomRef().offsetWidth:0;return A+h;},0);};
g.prototype.setValue=function(v){v=this.validateProperty("value",v);v=this._getInputValue(v);this.updateDomValue(v);if(v!==this.getProperty("value")){this.setLastValue(v);}this.setProperty("value",v,true);return this;};
g.prototype.getFocusDomRef=function(){return this.getDomRef("inner");};
g.prototype.getIdForLabel=function(){return this.getId()+"-inner";};
g.prototype.getAccessibilityInfo=function(){var r=this.getRequired()?'Required':'',R=this.getRenderer();return{role:R.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_INPUT"),description:[this.getValue()||"",R.getLabelledByAnnouncement(this),R.getDescribedByAnnouncement(this),r].join(" ").trim(),focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEnabled()&&this.getEditable()};};
g.prototype._addIcon=function(i,o){if(["begin","end"].indexOf(i)===-1){b.error('icon position is not "begin", neither "end", please check again the passed setting');return null;}var e=I.createControlByURI(o).addStyleClass(g.ICON_CSS_CLASS);this.addAggregation("_"+i+"Icon",e);return e;};
g.prototype.addBeginIcon=function(i){return this._addIcon("begin",i);};
g.prototype.addEndIcon=function(i){return this._addIcon("end",i);};
Object.defineProperty(g.prototype,"_$input",{get:function(){return this.$("inner");}});
g.prototype.setLastValue=function(v){this._lastValue=v;return this;};
g.prototype.getLastValue=function(){return this._lastValue;};
return g;});
sap.ui.predefine('sap/m/InputBaseRenderer',['sap/ui/core/Renderer','sap/ui/core/library','sap/ui/core/LabelEnablement','sap/ui/Device'],function(R,c,L,D){"use strict";var T=c.TextDirection;var V=c.ValueState;var I={apiVersion:2};
I.render=function(r,C){var v=C.getValueState(),t=C.getTextDirection(),s=R.getTextAlign(C.getTextAlign(),t),a=sap.ui.getCore().getConfiguration().getAccessibility(),b=C.getAggregation("_beginIcon")||[],e=C.getAggregation("_endIcon")||[],d,f;r.openStart("div",C);this.addOuterStyles(r,C);this.addControlWidth(r,C);r.class("sapMInputBase");this.addPaddingClass(r,C);this.addCursorClass(r,C);this.addOuterClasses(r,C);if(!C.getEnabled()){r.class("sapMInputBaseDisabled");}if(!C.getEditable()){r.class("sapMInputBaseReadonly");}if(v!==V.None){r.class("sapMInputBaseState");}if(b.length){d=b.filter(function(i){return i.getVisible();});d.length&&r.class("sapMInputBaseHasBeginIcons");}if(e.length){f=e.filter(function(i){return i.getVisible();});f.length&&r.class("sapMInputBaseHasEndIcons");}this.writeOuterAttributes(r,C);var g=C.getTooltip_AsString();if(g){r.attr("title",g);}r.openEnd();r.openStart("div",C.getId()+"-content");r.class("sapMInputBaseContentWrapper");if(!C.getEnabled()){r.class("sapMInputBaseDisabledWrapper");}else if(!C.getEditable()){r.class("sapMInputBaseReadonlyWrapper");}if(v!==V.None){this.addValueStateClasses(r,C);}this.addWrapperStyles(r,C);r.openEnd();if(b.length){this.writeIcons(r,b);}this.prependInnerContent(r,C);this.openInputTag(r,C);if(C.getName()){r.attr("name",C.getName());}if(!C.bShowLabelAsPlaceholder&&C._getPlaceholder()){r.attr("placeholder",C._getPlaceholder());}if(C.getMaxLength&&C.getMaxLength()>0){r.attr("maxlength",C.getMaxLength());}if(!C.getEnabled()){r.attr("disabled","disabled");}else if(!C.getEditable()){r.attr("readonly","readonly");}if(t!=T.Inherit){r.attr("dir",t.toLowerCase());}this.writeInnerValue(r,C);if(a){this.writeAccessibilityState(r,C);}if(D.browser.mozilla){if(g){r.attr("x-moz-errormessage",g);}else{r.attr("x-moz-errormessage"," ");}}this.writeInnerAttributes(r,C);r.class("sapMInputBaseInner");this.addInnerClasses(r,C);r.style("text-align",s);this.addInnerStyles(r,C);this.endInputTag(r,C);this.writeInnerContent(r,C);this.closeInputTag(r,C);if(e.length){this.writeIcons(r,e);}r.close("div");this.writeDecorations(r,C);if(a){this.renderAriaLabelledBy(r,C);this.renderAriaDescribedBy(r,C);}r.close("div");};
I.getAriaRole=function(C){return"textbox";};
I.getAriaLabelledBy=function(C){if(this.getLabelledByAnnouncement(C)){return C.getId()+"-labelledby";}};
I.getLabelledByAnnouncement=function(C){return"";};
I.renderAriaLabelledBy=function(r,C){var a=this.getLabelledByAnnouncement(C);if(a){r.openStart("span",C.getId()+"-labelledby").attr("aria-hidden","true").class("sapUiInvisibleText").openEnd().text(a.trim()).close("span");}};
I.getAriaDescribedBy=function(C){if(this.getDescribedByAnnouncement(C)){return C.getId()+"-describedby";}};
I.getDescribedByAnnouncement=function(C){return"";};
I.renderAriaDescribedBy=function(r,C){var a=this.getDescribedByAnnouncement(C);if(a){r.openStart("span",C.getId()+"-describedby").attr("aria-hidden","true").class("sapUiInvisibleText").openEnd().text(a.trim()).close("span");}};
I.getAccessibilityState=function(C){var a=this.getAriaLabelledBy(C),A=this.getAriaDescribedBy(C),r=this.getAriaRole(C),m={};if(r){m.role=r;}if(C.getValueState()===V.Error){m.invalid=true;}if(a){m.labelledby={value:a.trim(),append:true};}if(A){m.describedby={value:A.trim(),append:true};}m.disabled=null;m.readonly=null;return m;};
I.writeAccessibilityState=function(r,C){r.accessibilityState(C,this.getAccessibilityState(C));};
I.openInputTag=function(r,C){r.voidStart("input",C.getId()+"-"+this.getInnerSuffix());};
I.endInputTag=function(r,C){r.voidEnd();};
I.writeInnerValue=function(r,C){r.attr("value",C.getValue());};
I.addCursorClass=function(r,C){};
I.addPaddingClass=function(r,C){r.class("sapMInputBaseHeightMargin");};
I.addOuterStyles=function(r,C){};
I.addControlWidth=function(r,C){if(!C.getProperty('width')){r.class("sapMInputBaseNoWidth");}r.style("width",C.getWidth());};
I.addOuterClasses=function(r,C){};
I.writeOuterAttributes=function(r,C){};
I.addInnerStyles=function(r,C){};
I.addWrapperStyles=function(r,C){r.style("width","100%");};
I.addInnerClasses=function(r,C){};
I.writeInnerAttributes=function(r,C){};
I.prependInnerContent=function(r,C){};
I.writeInnerContent=function(r,C){};
I.writeIcons=function(r,i){r.openStart("div").attr("tabindex","-1").class("sapMInputBaseIconContainer").openEnd();i.forEach(r.renderControl,r);r.close("div");};
I.writeDecorations=function(r,C){};
I.closeInputTag=function(r,C){};
I.addPlaceholderStyles=function(r,C){};
I.addPlaceholderClasses=function(r,C){};
I.addValueStateClasses=function(r,C){r.class("sapMInputBaseContentWrapperState");r.class("sapMInputBaseContentWrapper"+C.getValueState());};
I.getInnerSuffix=function(){return"inner";};
return I;},true);
sap.ui.predefine('sap/m/InputListItem',["sap/ui/core/library","./library","./ListItemBase","./InputListItemRenderer"],function(c,l,L,I){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.InputListItem",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Misc",defaultValue:null},labelTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",bindable:"bindable"}},designtime:"sap/m/designtime/InputListItem.designtime"}});
a.prototype.getContentAnnouncement=function(){var A=this.getLabel();this.getContent().forEach(function(C){A+=L.getAccessibilityText(C)+" ";});return A;};
return a;});
sap.ui.predefine('sap/m/InputListItemRenderer',["sap/ui/core/library","sap/ui/core/Renderer","./ListItemBaseRenderer"],function(c,R,L){"use strict";var T=c.TextDirection;var I=R.extend(L);I.apiVersion=2;
I.renderLIAttributes=function(r,l){r.class("sapMILI");};
I.renderLIContent=function(r,l){var s=l.getLabel();if(s){r.openStart("span",l.getId()+"-label");r.class("sapMILILabel");var a=l.getLabelTextDirection();if(a!==T.Inherit){r.attr("dir",a.toLowerCase());}r.openEnd();r.text(s);r.close("span");}r.openStart("div").class("sapMILIDiv").class("sapMILI-CTX").openEnd();l.getContent().forEach(r.renderControl,r);r.close("div");};
return I;},true);
sap.ui.predefine('sap/m/InputRenderer',['sap/ui/core/InvisibleText','sap/ui/core/Renderer','./InputBaseRenderer','sap/m/library'],function(I,R,a,l){"use strict";var b=l.InputType;var c=R.extend(a);c.apiVersion=2;
c.addOuterClasses=function(r,C){r.class("sapMInput");if(C.getDescription()){r.class("sapMInputWithDescription");}};
c.writeInnerAttributes=function(r,C){var s=C.getShowSuggestion();r.attr("type",C.getType().toLowerCase());if(C.getType()==b.Number){r.attr("step","any");}if(C.getType()==b.Number&&sap.ui.getCore().getConfiguration().getRTL()){r.attr("dir","ltr").style("text-align","right");}if(s){r.attr("aria-haspopup","listbox");}if(s||C.getShowValueStateMessage()){r.attr("autocomplete","off");}if((!C.getEnabled()&&C.getType()=="Password")||(C.getShowSuggestion()&&C.isMobileDevice())||(C.getValueHelpOnly()&&C.getEnabled()&&C.getEditable()&&C.getShowValueHelp())){r.attr("readonly","readonly");}};
c.addInnerClasses=function(r,C){};
c.writeDescription=function(r,C){r.openStart("div").class("sapMInputDescriptionWrapper").style("width","calc(100% - "+C.getFieldWidth()+")").openEnd();r.openStart("span",C.getId()+"-descr").class("sapMInputDescriptionText").openEnd().text(C.getDescription()).close("span");r.close("div");};
c.writeDecorations=function(r,C){if(C.getDescription()){this.writeDescription(r,C);}if(sap.ui.getCore().getConfiguration().getAccessibility()){if(C.getShowSuggestion()&&C.getEnabled()&&C.getEditable()){r.openStart("span",C.getId()+"-SuggDescr").class("sapUiPseudoInvisibleText").attr("role","status").attr("aria-live","polite").openEnd().close("span");}}};
c.addWrapperStyles=function(r,C){r.style("width",C.getDescription()?C.getFieldWidth():"100%");};
c.getAriaLabelledBy=function(C){var d=a.getAriaLabelledBy.call(this,C)||"";if(C.getDescription()){d=d+" "+C.getId()+"-descr";}return d;};
c.getAriaDescribedBy=function(C){var A=a.getAriaDescribedBy.apply(this,arguments);function d(s){A=A?A+" "+s:s;}if(C.getShowValueHelp()&&C.getEnabled()&&C.getEditable()){d(I.getStaticId("sap.m","INPUT_VALUEHELP"));if(C.getValueHelpOnly()){d(I.getStaticId("sap.m","INPUT_DISABLED"));}}if(C.getShowSuggestion()&&C.getEnabled()&&C.getEditable()){d(C.getId()+"-SuggDescr");}return A;};
c.getAriaRole=function(C){return"";};
c.getAccessibilityState=function(C){var A=a.getAccessibilityState.apply(this,arguments);return A;};
return c;},true);
sap.ui.predefine('sap/m/InstanceManager',["sap/base/assert","sap/base/Log","sap/ui/thirdparty/jquery"],function(a,L,q){"use strict";var I={};var r={},e=[];var p="_POPOVER_",d="_DIALOG_",l="_LIGHTBOX_";
I.addInstance=function(c,i){a(c,"In sap.m.InstanceManager.addInstance method, the parameter sCategoryId can't be null or empty string");a(i instanceof Object,"In sap.m.InstanceManager.addInstance method, the parameter oInstance should be an object");if(!r[c]){r[c]=[];}if(r[c].indexOf(i)===-1){r[c].push(i);}return this;};
I.removeInstance=function(c,o){var C=r[c],i;a(c,"In sap.m.InstanceManager.removeInstance method, the parameter sCategoryId can't be null or empty string");a(o instanceof Object,"In sap.m.InstanceManager.removeInstance method, the parameter oInstance should be an object");if(!C){return null;}i=C.indexOf(o);return(i===-1)?null:C.splice(i,1);};
I.getInstancesByCategoryId=function(c){a(c,"In sap.m.InstanceManager.getInstancesByCategoryId method, the parameter sCategoryId can't be null or empty string");return r[c]||e;};
I.isInstanceManaged=function(c,i){a(c,"In sap.m.InstanceManager.isInstanceManaged method, the parameter sCategoryId can't be null or empty string");a(i instanceof Object,"In sap.m.InstanceManager.isInstanceManaged method, the parameter oInstance should be an object");var C=r[c];if(!C||!i){return false;}return C.indexOf(i)!==-1;};
I.isCategoryEmpty=function(c){a(c,"In sap.m.InstanceManager.isCategoryEmpty method, the parameter sCategoryId can't be null or empty string");var C=r[c];return!C||C.length===0;};
I.addPopoverInstance=function(P){if(typeof P.close==="function"){I.addInstance(p,P);}else{L.warning("In method addPopoverInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addDialogInstance=function(D){if(typeof D.close==="function"){I.addInstance(d,D);}else{L.warning("In method addDialogInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.addLightBoxInstance=function(o){if(typeof o.close==="function"){I.addInstance(l,o);}else{L.warning("In method addLightBoxInstance: the parameter doesn't have a close method and can't be managed.");}return this;};
I.removePopoverInstance=function(P){return I.removeInstance(p,P);};
I.removeDialogInstance=function(D){return I.removeInstance(d,D);};
I.removeLightBoxInstance=function(o){return I.removeInstance(l,o);};
I.hasOpenPopover=function(){return!I.isCategoryEmpty(p);};
I.hasOpenDialog=function(){return!I.isCategoryEmpty(d);};
I.hasOpenLightBox=function(){return!I.isCategoryEmpty(l);};
I.isDialogOpen=function(D){return I.isInstanceManaged(d,D);};
I.isPopoverOpen=function(P){return I.isInstanceManaged(p,P);};
I.isLightBoxOpen=function(o){return I.isInstanceManaged(l,o);};
I.getOpenPopovers=function(){return I.getInstancesByCategoryId(p);};
I.getOpenDialogs=function(){return I.getInstancesByCategoryId(d);};
I.getOpenLightBoxes=function(){return I.getInstancesByCategoryId(l);};
I.closeAllPopovers=function(){var b=I.getOpenPopovers(),i;for(i=0;i<b.length;i++){b[i].close();}return this;};
I.closeAllDialogs=function(c){var D,b=[],f=I.getOpenDialogs(),g,i;for(i=0;i<f.length;i++){g=f[i];if(!g.getCloseOnNavigation()){continue;}if(c){D=new q.Deferred().done();b.push(D);g.attachEvent("afterClose",(function(h){return function(){h.resolve();};}(D)));}g.close();}if(c){q.when.apply(this,b).then(c);}return this;};
I.closeAllLightBoxes=function(){var i=I.getOpenLightBoxes(),b=i.length,c;for(c=0;c<b;c+=1){i[c].close();}return this;};
return I;},true);
sap.ui.predefine('sap/m/Label',['./library','sap/ui/core/Control','sap/ui/core/LabelEnablement','sap/m/HyphenationSupport','sap/ui/core/library','./LabelRenderer'],function(l,C,L,H,c,a){"use strict";var T=c.TextDirection;var b=c.TextAlign;var d=l.LabelDesign;var V=c.VerticalAlign;var W=l.WrappingType;
var e=C.extend("sap.m.Label",{metadata:{interfaces:["sap.ui.core.Label","sap.ui.core.IShrinkable","sap.m.IOverflowToolbarContent","sap.m.IHyphenation"],library:"sap.m",properties:{design:{type:"sap.m.LabelDesign",group:"Appearance",defaultValue:d.Standard},text:{type:"string",group:"Misc",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Begin},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},required:{type:"boolean",group:"Misc",defaultValue:false},displayOnly:{type:"boolean",group:"Appearance",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},vAlign:{type:"sap.ui.core.VerticalAlign",group:"Appearance",defaultValue:V.Inherit}},associations:{labelFor:{type:"sap.ui.core.Control",multiple:false}},designtime:"sap/m/designtime/Label.designtime"}});
e.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,propsUnrelatedToSize:["design","required","displayOnly"]};function g(f){var h=f&&f.getLayoutData();if(i(h,"sap/m/OverflowToolbarLayoutData")){return h.getGroup();}}o.onBeforeEnterOverflow=function(f){var I=false,t,s,h,j,k;t=f.getParent();if(!i(t,"sap/m/OverflowToolbar")){return;}s=f.getLabelFor();h=s&&sap.ui.getCore().byId(s);if(!h||(t.indexOfContent(h)<0)){return;}j=g(f);k=g(h);I=j&&(j===k);f.toggleStyleClass("sapMLabelMediumMarginTop",I,true);};o.onAfterExitOverflow=function(f){f.toggleStyleClass("sapMLabelMediumMarginTop",false,true);};return o;};
e.prototype.getTextsToBeHyphenated=function(){return{"main":this.getText()};};
e.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.$("bdi")[0]};};
L.enrich(e.prototype);H.mixInto(e.prototype);
function i(o,m){if(o&&m){var f=sap.ui.require(m);return(typeof f==='function')&&(o instanceof f);}}
return e;});
sap.ui.predefine('sap/m/LabelRenderer',['sap/ui/core/Renderer','sap/m/library','sap/ui/core/library','sap/m/HyphenationSupport',"sap/ui/core/LabelEnablement"],function(R,l,c,H,L){"use strict";var T=c.TextDirection;var V=c.VerticalAlign;var a=l.LabelDesign;var b={apiVersion:2};
b.render=function(d,o){var r=b,t=o.getTextDirection(),s=o.getTextAlign(),w=o.getWidth(),e=o.getText(),f=o.getTooltip_AsString(),g=o.getLabelForRendering(),h=g?"label":"span",D=o.isDisplayOnly(),v=o.getVAlign();d.openStart(h,o);d.class("sapMLabel");d.class("sapUiSelectable");if(o.isWrapping()){d.class("sapMLabelWrapped");}if(o.getDesign()==a.Bold){d.style("font-weight","bold");}if(o.isRequired()){d.class("sapMLabelRequired");}if(g){L.writeLabelForAttribute(d,o);}else if(o.getParent()instanceof sap.m.Toolbar){d.class("sapMLabelTBHeader");}d.accessibilityState({label:o.getText()});if(t!==T.Inherit){d.attr("dir",t.toLowerCase());}if(w){d.style("width",w);}else{d.class("sapMLabelMaxWidth");}if(s){s=r.getTextAlign(s,t);if(s){d.style("text-align",s);}}if(e==""){d.class("sapMLabelNoText");}if(D){d.class("sapMLabelDisplayOnly");}if(v!=V.Inherit){d.style("vertical-align",v.toLowerCase());}H.writeHyphenationClass(d,o);if(f){d.attr("title",f);}d.openEnd();d.openStart("span",o.getId()+"-text");d.class("sapMLabelTextWrapper");d.openEnd();d.openStart("bdi",o.getId()+"-bdi");d.openEnd();if(e){e=H.getTextForRender(o,"main");d.text(e);}d.close("bdi");d.close("span");d.openStart("span");d.class("sapMLabelColonAndRequired");d.openEnd();d.close("span");d.close(h);};
b.getTextAlign=R.getTextAlign;return b;},true);
sap.ui.predefine('sap/m/LightBox',['./library','sap/ui/core/Control','sap/ui/core/Popup','sap/m/Text','sap/m/Button','sap/ui/core/ResizeHandler','sap/ui/Device','sap/ui/core/Icon','sap/ui/layout/VerticalLayout','./InstanceManager','sap/ui/core/InvisibleText','sap/ui/core/library','./LightBoxRenderer','sap/m/BusyIndicator',"sap/ui/thirdparty/jquery",'sap/ui/core/Core','sap/ui/dom/units/Rem'],function(l,C,P,T,B,R,D,I,V,a,b,c,L,d,q,e,f){'use strict';var O=c.OpenState;var g=c.TextAlign;var h=l.ButtonType;var i=l.LightBoxLoadingStates;
var j=C.extend('sap.m.LightBox',{metadata:{interfaces:['sap.ui.core.PopupInterface'],library:'sap.m',aggregations:{imageContent:{type:'sap.m.LightBoxItem',multiple:true,bindable:"bindable"},_closeButton:{type:'sap.m.Button',multiple:false,visibility:'hidden'},_errorIcon:{type:'sap.ui.core.Icon',multiple:false,visibility:'hidden'},_errorTitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_errorSubtitle:{type:'sap.m.Text',multiple:false,visibility:'hidden'},_verticalLayout:{type:'sap.ui.layout.VerticalLayout',multiple:false,visibility:'hidden'},_invisiblePopupText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"},_busy:{type:"sap.m.BusyIndicator",multiple:false,visibility:"hidden"}},events:{},defaultAggregation:'imageContent',designtime:"sap/m/designtime/LightBox.designtime"}});
j.prototype.init=function(){this._createPopup();this._width=0;this._height=0;this._isRendering=true;this._resizeListenerId=null;this._$lightBox=null;this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._closeButtonText=this._rb.getText("LIGHTBOX_CLOSE_BUTTON");if(sap.ui.getCore().getConfiguration().getAccessibility()){this.setAggregation("_invisiblePopupText",new b());}};
j.prototype.onBeforeRendering=function(){var o=this._getImageContent(),n=o._getNativeImage(),s=o.getImageSrc(),S=o._getImageState(),m=this.getAggregation('_invisiblePopupText'),p=this._rb.getText("LIGHTBOX_ARIA_ENLARGED",[o.getTitle(),o.getSubtitle()]),r=this._rb.getText('LIGHTBOX_IMAGE_ERROR'),t=this._rb.getText('LIGHTBOX_IMAGE_ERROR_DETAILS');this._createErrorControls();if(n.getAttribute('src')!==s){n.src=s;}if(this._resizeListenerId){D.resize.detachHandler(this._onResizeHandler);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}switch(S){case i.Loading:this._timeoutId=setTimeout(function(){o._setImageState(i.TimeOutError);},10000);break;case i.Loaded:clearTimeout(this._timeoutId);this._calculateSizes(n);break;case i.Error:clearTimeout(this._timeoutId);p+=" "+r+" "+t;break;default:break;}if(o&&m){m.setText(p);}this._isRendering=true;};
j.prototype.onAfterRendering=function(){this._isRendering=false;this._$lightBox=this.$();if(!this._resizeListenerId){this._onResizeHandler=this._onResize.bind(this);D.resize.attachHandler(this._onResizeHandler);this._resizeListenerId=R.register(this,this._onResizeHandler);}};
j.prototype.forceInvalidate=C.prototype.invalidate;
j.prototype.invalidate=function(o){var m=this._getImageContent();if(this.isOpen()){if(m&&m.getImageSrc()){this.forceInvalidate(o);}else{this.close();}}return this;};
j.prototype.exit=function(){if(this._oPopup){this._oPopup.detachOpened(this._fnOpened,this);this._oPopup.detachClosed(this._fnClosed,this);this._oPopup.destroy();this._oPopup=null;}if(this._resizeListenerId){D.resize.detachHandler(this._onResizeHandler);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}a.removeLightBoxInstance(this);};
j.prototype.open=function(){var m=this._getImageContent();this._oPopup.setContent(this);if(m&&m.getImageSrc()){this._oPopup.open(300,'center center','center center',document.body,null);a.addLightBoxInstance(this);}return this;};
j.prototype.isOpen=function(){if(this._oPopup&&this._oPopup.isOpen()){return true;}return false;};
j.prototype.close=function(){if(this._resizeListenerId){D.resize.detachHandler(this._onResizeHandler);R.deregister(this._resizeListenerId);this._resizeListenerId=null;}this._oPopup.close();a.removeLightBoxInstance(this);return this;};
j.prototype._getCloseButton=function(){var m=this.getAggregation('_closeButton');if(!m){m=new B({id:this.getId()+'-closeButton',text:this._closeButtonText,type:h.Transparent,press:function(){this.close();}.bind(this)});this.setAggregation('_closeButton',m,true);}return m;};
j.prototype._getBusyIndicator=function(){var m=this.getAggregation("_busy");if(!m){m=new d();this.setAggregation("_busy",m,true);}return m;};
j.prototype._imageStateChanged=function(n){var s=n===i.Loaded||n===i.Error;if(s&&!this._isRendering){this.rerender();}};
j.prototype._createPopup=function(){this._oPopup=new P(this,true,true);this._oPopup.attachOpened(this._fnOpened,this);this._oPopup.attachClosed(this._fnClosed,this);};
j.prototype._fnOpened=function(){var t=this;t._onResize();q('#sap-ui-blocklayer-popup').on("click",function(){t.close();});};
j.prototype._fnClosed=function(){q('#sap-ui-blocklayer-popup').off("click");};
j.prototype._createErrorControls=function(){var r=this._rb;var m;var n;if(this._getImageContent()._getImageState()===i.TimeOutError){m=r.getText('LIGHTBOX_IMAGE_TIMED_OUT');n=r.getText('LIGHTBOX_IMAGE_TIMED_OUT_DETAILS');}else{m=r.getText('LIGHTBOX_IMAGE_ERROR');n=r.getText('LIGHTBOX_IMAGE_ERROR_DETAILS');}if(!this.getAggregation('_verticalLayout')){var o=new T({text:m,textAlign:g.Center}).addStyleClass("sapMLightBoxErrorTitle"),p=new T({text:n,textAlign:g.Center}).addStyleClass("sapMLightBoxErrorSubtitle"),s=new I({src:"sap-icon://picture"}).addStyleClass("sapMLightBoxErrorIcon");this.setAggregation('_verticalLayout',new V({content:[s,o,p]}).addStyleClass('sapMLightBoxVerticalLayout'));}};
j.prototype._onResize=function(){var m=k()/2+'px',t=m,n=m,o='',p='',r=this._getImageContent(),s=this.getDomRef(),u,v,w=k();if(r._getImageState()===i.Loaded){this._calculateSizes(r._getNativeImage());u=this._width;v=this._height;this._$lightBox.width(u);this._$lightBox.height(v);}else{u=s.clientWidth;v=s.clientHeight;}if(window.innerWidth>u+w){n='50%';p=Math.round(-u/2);}if(window.innerHeight>v+w){t='50%';o=Math.round(-v/2);}this._$lightBox.css({'top':t,'margin-top':o,'left':n,'margin-left':p});};
j.prototype._calculateSizes=function(m){var F=this._calculateFooterHeightInPx(),n=288-F,o=this._getImageContent().getAggregation("_image"),p;this._setImageSize(o,m.naturalWidth,m.naturalHeight);this._calculateAndSetLightBoxSize(o);p=this._pxToNumber(o.getHeight());this.toggleStyleClass('sapMLightBoxMinSize',(p<n));this._isBusy=false;};
j.prototype._calculateFooterHeightInPx=function(){var m=this.$().parents().hasClass('sapUiSizeCompact');var s=this._getImageContent().getSubtitle();var F=3;if(m&&!s){F-=0.5;}if(s){F+=0.5;}return f.toPx(F);};
j.prototype._calculateAndSetLightBoxSize=function(m){var n,o,p=(20*16),r=(18*16),F=this._calculateFooterHeightInPx();n=this._pxToNumber(m.getHeight());o=this._pxToNumber(m.getWidth());this._width=Math.max(p,o);this._height=Math.max(r,n+F);this._isLightBoxBiggerThanMinDimensions=(o>=p)&&(n>=(r-F));};
j.prototype._setImageSize=function(m,n,o){var p=this._calculateFooterHeightInPx(),r=this._getDimensions(n,o,p),w=r.width+'px',s=r.height+'px',t=m.getDomRef();m.setProperty('width',w,true);m.setProperty('height',s,true);if(t){t.style.width=w;t.style.height=s;}};
j.prototype._getDimensions=function(m,n,o){var p=20*16,r=18*16,$=q(window),w=$.height(),s=$.width(),t=k(),u=Math.max(s-t,p),v=Math.max(w-t,r),x;v-=o;if(n<=v){if(m<=u){}else{n*=u/m;m=u;}}else{if(m<=u){m*=v/n;n=v;}else{x=Math.max(m/u,n/v);m/=x;n/=x;}}return{width:Math.round(m),height:Math.round(n)};};
j.prototype._pxToNumber=function(s){return(s.substring(0,(s.length-2)))*1;};
j.prototype._getImageContent=function(){var r=this.getAggregation('imageContent');return r&&r[0];};
function k(){var s=D.system;if(s.desktop){return 4*16;}if(s.tablet){return 2*16;}if(s.phone&&D.resize.width>320){return 1*16;}return 0;}
j.prototype.onsapescape=function(E){var m=this._oPopup.getOpenState();if(m!==O.CLOSED&&m!==O.CLOSING){this.close();E.stopPropagation();}};
return j;});
sap.ui.predefine('sap/m/LightBoxItem',['./library','sap/ui/core/library','sap/ui/core/Element','sap/m/Image','sap/m/Title','sap/m/Label'],function(l,c,E,I,T,L){"use strict";var O=c.OpenState;var a=l.LightBoxLoadingStates;
var b=E.extend("sap.m.LightBoxItem",{metadata:{library:"sap.m",properties:{imageSrc:{type:'sap.ui.core.URI',group:'Appearance',multiple:false,defaultValue:''},alt:{type:'string',group:'Appearance',multiple:false,defaultValue:''},title:{type:'string',group:'Appearance',multiple:false,defaultValue:''},subtitle:{type:'string',group:'Appearance',multiple:false,defaultValue:''}},aggregations:{_image:{type:'sap.m.Image',multiple:false,visibility:'hidden'},_title:{type:'sap.m.Title',multiple:false,visibility:'hidden'},_subtitle:{type:'sap.m.Label',multiple:false,visibility:'hidden'}}}});
b.prototype.init=function(){this._createNativeImage();this.setAggregation('_image',new I({decorative:false,densityAware:false}),true);this.setAggregation('_title',new T({level:c.TitleLevel.H5,wrapping:false}),true);this.setAggregation('_subtitle',new L({wrapping:false}),true);};
b.prototype._createNativeImage=function(){var t=this;this._imageState=a.Loading;this._oImage=new window.Image();this._oImage.onload=function(){if(this.complete&&t._imageState===a.Loading){t._setImageState(a.Loaded);}};this._oImage.onerror=function(){t._setImageState(a.Error);};};
b.prototype.exit=function(){this._oImage=null;};
b.prototype._setImageState=function(i){if(i!==this._imageState){this._imageState=i;if(this.getParent()){this.getParent()._imageStateChanged(i);}}};
b.prototype._getImageState=function(){return this._imageState;};
b.prototype._getNativeImage=function(){return this._oImage;};
b.prototype.setImageSrc=function(i){var o=this.getAggregation("_image"),d=this.getParent();if(this.getImageSrc()===i){return this;}this._imageState=a.Loading;if(d&&d._oPopup.getOpenState()===O.OPEN){this._oImage.src=i;}this.setProperty("imageSrc",i,false);o.setSrc(i);return this;};
b.prototype.setAlt=function(d){var i=this.getAggregation("_image");this.setProperty("alt",d,false);i.setAlt(d);return this;};
b.prototype.setTitle=function(t){var o=this.getAggregation("_title");this.setProperty("title",t,false);o.setText(t);return this;};
b.prototype.setSubtitle=function(s){var d=this.getAggregation("_subtitle");this.setProperty("subtitle",s,false);d.setText(s);return this;};
return b;});
sap.ui.predefine('sap/m/LightBoxRenderer',["sap/m/library"],function(l){'use strict';var L=l.LightBoxLoadingStates;var a={};var c='sapMLightBox';var b='sapMLightBoxTwoLines';var d='sapMLightBoxImageContainer';var e='sapMLightBoxImageContainerTwoHeaders';var f='sapMLightBoxError';var g='sapMLightBoxErrorContainer';var h='sapMLightBoxErrorContainerTwoHeaders';var i='sapMLightBoxFooter';var j='sapContrast';var k='sapContrastPlus';var m='sapMLightBoxTitleSection';var n='sapMLightBoxTitle';var o='sapMLightBoxSubtitle';var p='sapMLightBoxFooterTwoLines';var q='sapMLightBoxTopCornersRadius';
a.render=function(r,C){var s=C._getImageContent();var t=s._getImageState();var u=C.getAggregation('_invisiblePopupText');r.write('<div');r.writeControlData(C);r.writeAttribute("tabindex","-1");r.addClass(c);if(s.getSubtitle()){r.addClass(b);}if(C._isLightBoxBiggerThanMinDimensions){r.addClass(q);}if(t!==L.Error){r.addStyle('width',C._width+'px');r.addStyle('height',C._height+'px');}else{r.addClass(f);}r.writeAccessibilityState({role:'dialog',modal:true,labelledby:u&&u.getId()});r.writeClasses();r.writeStyles();r.write('>');r.renderControl(u);if(t===L.Loading){this.renderBusyState(r,C);}else if(t===L.TimeOutError||t===L.Error){this.renderError(r,C);}else{this.renderImage(r,C);}this.renderFooter(r,C,s);r.write('</div>');C._isRendering=false;};
a.renderImage=function(r,C){var s=C._getImageContent();if(s.getSubtitle()){r.write('<div class="'+e+'">');}else{r.write('<div class="'+d+'">');}r.renderControl(s.getAggregation('_image'));r.write('</div>');};
a.renderError=function(r,C){var s=C._getImageContent(),v=C.getAggregation('_verticalLayout');if(s.getSubtitle()){r.write('<div class="'+h+'">');}else{r.write('<div class="'+g+'">');}r.renderControl(v);r.write('</div>');};
a.renderBusyState=function(r,C){r.renderControl(C._getBusyIndicator());};
a.renderFooter=function(r,C,I){var t=I.getAggregation("_title"),s=I.getAggregation("_subtitle");r.write('<div');r.addClass(i);r.addClass(j);r.addClass(k);if(I.getSubtitle()){r.addClass(p);}r.writeClasses();r.write('>');r.write('<div class="'+m+'">');if(t){r.renderControl(t.addStyleClass(n));}if(s&&s.getText()){r.renderControl(s.addStyleClass(o));}r.write('</div>');r.renderControl(C._getCloseButton());r.write('</div>');};
return a;},true);
sap.ui.predefine('sap/m/Link',['./library','sap/ui/core/Control','sap/ui/core/InvisibleText','sap/ui/core/EnabledPropagator','sap/ui/core/LabelEnablement','sap/ui/core/library','sap/ui/Device','./LinkRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/base/security/URLWhitelist"],function(l,C,I,E,L,c,D,a,K,b,U){"use strict";var T=c.TextDirection;var d=c.TextAlign;
var e=C.extend("sap.m.Link",{metadata:{interfaces:["sap.ui.core.IShrinkable","sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/Link.designtime",properties:{text:{type:"string",group:"Data",defaultValue:''},enabled:{type:"boolean",group:"Behavior",defaultValue:true},target:{type:"string",group:"Behavior",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},href:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},validateUrl:{type:"boolean",group:"Data",defaultValue:false},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:d.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},subtle:{type:"boolean",group:"Behavior",defaultValue:false},emphasized:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{allowPreventDefault:true,parameters:{ctrlKey:{type:"boolean"},metaKey:{type:"boolean"}}}},dnd:{draggable:true,droppable:false}}});
E.call(e.prototype);
e.prototype.onBeforeRendering=function(){};
e.prototype.onkeydown=function(o){if(o.which===K.SPACE||o.which===K.SHIFT||o.which===K.ESCAPE){if(o.which===K.SPACE){if(this.getEnabled()||this.getHref()){o.setMarked();o.preventDefault();this._bPressedSpace=true;}}if(this._bPressedSpace&&(o.which===K.ESCAPE||o.which===K.SHIFT)){this._bPressedEscapeOrShift=true;}}else{if(this._bPressedSpace){o.preventDefault();}}};
e.prototype.onkeyup=function(o){if(o.which===K.SPACE){if(!this._bPressedEscapeOrShift){this._handlePress(o);if(this.getHref()&&!o.isDefaultPrevented()){o.preventDefault();o.setMarked();var f=document.createEvent('MouseEvents');f.initEvent('click',false,true);this.getDomRef().dispatchEvent(f);}}else{this._bPressedEscapeOrShift=false;}this._bPressedSpace=false;}};
e.prototype._handlePress=function(o){if(this.getEnabled()){o.setMarked();if(!this.firePress({ctrlKey:!!o.ctrlKey,metaKey:!!o.metaKey})||!this.getHref()){o.preventDefault();}}else{o.preventDefault();}};
e.prototype.onsapenter=e.prototype._handlePress;if(D.support.touch){e.prototype.ontap=e.prototype._handlePress;}else{e.prototype.onclick=e.prototype._handlePress;}
e.prototype.ontouchstart=function(o){if(this.getEnabled()){o.setMarked();}};
e.prototype.setSubtle=function(s){this.setProperty("subtle",s);if(s&&!e.prototype._sAriaLinkSubtleId){e.prototype._sAriaLinkSubtleId=I.getStaticId("sap.m","LINK_SUBTLE");}return this;};
e.prototype.setEmphasized=function(f){this.setProperty("emphasized",f);if(f&&!e.prototype._sAriaLinkEmphasizedId){e.prototype._sAriaLinkEmphasizedId=I.getStaticId("sap.m","LINK_EMPHASIZED");}return this;};
e.prototype._isHrefValid=function(u){return this.getValidateUrl()?U.validate(u):true;};
e.prototype.getAccessibilityInfo=function(){return{role:"link",type:this.getText()?sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_LINK"):undefined,description:this.getText()||this.getHref()||"",focusable:this.getEnabled(),enabled:this.getEnabled()};};
e.prototype.getFormDoNotAdjustWidth=function(){return true;};
e.prototype._getTabindex=function(){return(this.getText()&&this.getEnabled())?"0":"-1";};
e.prototype._determineSelfReferencePresence=function(){var A=this.getAriaLabelledBy(),f=A.indexOf(this.getId())!==-1,h=L.getReferencingLabels(this).length>0,p=this.getParent(),g=!!(p&&p.enhanceAccessibilityState);return!f&&(A.length>0||h||g);};
return e;});
sap.ui.predefine('sap/m/LinkRenderer',['sap/ui/core/Renderer','sap/ui/core/library'],function(R,c){"use strict";var T=c.TextDirection;var L={apiVersion:2};
L.render=function(r,C){var t=C.getTextDirection(),s=R.getTextAlign(C.getTextAlign(),t),S=C._determineSelfReferencePresence(),h=C.getHref(),a={labelledby:S?{value:C.getId(),append:true}:undefined},i=h&&C._isHrefValid(h),e=C.getEnabled(),b="";r.openStart("a",C);r.class("sapMLnk");if(C.getSubtle()){r.class("sapMLnkSubtle");b+=C._sAriaLinkSubtleId;}if(C.getEmphasized()){r.class("sapMLnkEmphasized");b+=" "+C._sAriaLinkEmphasizedId;}a.describedby=b?{value:b.trim(),append:true}:undefined;if(!e){r.class("sapMLnkDsbl");r.attr("aria-disabled","true");}r.attr("tabindex",C._getTabindex());if(C.getWrapping()){r.class("sapMLnkWrapping");}if(C.getTooltip_AsString()){r.attr("title",C.getTooltip_AsString());}if(i&&e){r.attr("href",h);}else if(C.getText()){r.attr("href","");}if(C.getTarget()){r.attr("target",C.getTarget());}if(C.getWidth()){r.style("width",C.getWidth());}else{r.class("sapMLnkMaxWidth");}if(s){r.style("text-align",s);}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}C.getDragDropConfig().forEach(function(d){if(!d.getEnabled()){r.attr("draggable",false);}});r.accessibilityState(C,a);r.openEnd();if(this.writeText){this.writeText(r,C);}else{this.renderText(r,C);}r.close("a");};
L.renderText=function(r,C){r.text(C.getText());};
return L;},true);
sap.ui.predefine('sap/m/List',["./library","./ListBase","./ListRenderer"],function(l,L,a){"use strict";var B=l.BackgroundDesign;
var b=L.extend("sap.m.List",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Solid}}}});
return b;});
sap.ui.predefine('sap/m/ListBase',["sap/ui/events/KeyCodes","sap/ui/Device","sap/ui/core/Core","sap/ui/core/Control","sap/ui/core/InvisibleText","sap/ui/core/LabelEnablement","sap/ui/core/delegate/ItemNavigation","./library","./InstanceManager","./GrowingEnablement","./GroupHeaderListItem","./ListItemBase","./ListBaseRenderer","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Selectors","sap/ui/dom/jquery/Aria"],function(K,D,C,a,I,L,b,l,c,G,d,f,g,h,q,j){"use strict";var k=l.ListType;var m=l.ListKeyboardMode;var n=l.ListGrowingDirection;var S=l.SwipeDirection;var o=l.ListSeparators;var p=l.ListMode;var r=l.ListHeaderDesign;var s=l.Sticky;
var t=a.extend("sap.m.ListBase",{metadata:{library:"sap.m",dnd:true,properties:{inset:{type:"boolean",group:"Appearance",defaultValue:false},headerText:{type:"string",group:"Misc",defaultValue:null},headerDesign:{type:"sap.m.ListHeaderDesign",group:"Appearance",defaultValue:r.Standard,deprecated:true},footerText:{type:"string",group:"Misc",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:p.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},includeItemInSelection:{type:"boolean",group:"Behavior",defaultValue:false},showUnread:{type:"boolean",group:"Misc",defaultValue:false},noDataText:{type:"string",group:"Misc",defaultValue:null},showNoData:{type:"boolean",group:"Misc",defaultValue:true},enableBusyIndicator:{type:"boolean",group:"Behavior",defaultValue:true},modeAnimationOn:{type:"boolean",group:"Misc",defaultValue:true},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:o.All},swipeDirection:{type:"sap.m.SwipeDirection",group:"Misc",defaultValue:S.Both},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:20},growingTriggerText:{type:"string",group:"Appearance",defaultValue:null},growingScrollToLoad:{type:"boolean",group:"Behavior",defaultValue:false},growingDirection:{type:"sap.m.ListGrowingDirection",group:"Behavior",defaultValue:n.Downwards},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:true},keyboardMode:{type:"sap.m.ListKeyboardMode",group:"Behavior",defaultValue:m.Navigation},sticky:{type:"sap.m.Sticky[]",group:"Appearance"}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",bindable:"bindable",selector:"#{id} .sapMListItems",dnd:true},swipeContent:{type:"sap.ui.core.Control",multiple:false},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false},contextMenu:{type:"sap.ui.core.IContextMenu",multiple:false},_messageStrip:{type:"sap.m.MessageStrip",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}},selectionChange:{parameters:{listItem:{type:"sap.m.ListItemBase"},listItems:{type:"sap.m.ListItemBase[]"},selected:{type:"boolean"},selectAll:{type:"boolean"}}},"delete":{parameters:{listItem:{type:"sap.m.ListItemBase"}}},swipe:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"},swipeContent:{type:"sap.ui.core.Control"},srcControl:{type:"sap.ui.core.Control"},swipeDirection:{type:"sap.m.SwipeDirection"}}},growingStarted:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},growingFinished:{deprecated:true,parameters:{actual:{type:"int"},total:{type:"int"}}},updateStarted:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},updateFinished:{parameters:{reason:{type:"string"},actual:{type:"int"},total:{type:"int"}}},itemPress:{parameters:{listItem:{type:"sap.m.ListItemBase"},srcControl:{type:"sap.ui.core.Control"}}},beforeOpenContextMenu:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ListItemBase"}}}},designtime:"sap/m/designtime/ListBase.designtime"}});
t.prototype.bAnnounceDetails=true;t.prototype.bPreventMassSelection=false;
t.getInvisibleText=function(){return this.oInvisibleText||(this.oInvisibleText=new I().toStatic());};
t.prototype.sNavItemClass="sapMLIB";
t.prototype.init=function(){this._aNavSections=[];this._aSelectedPaths=[];this._iItemNeedsHighlight=0;this._iItemNeedsNavigated=0;this._bItemsBeingBound=false;this.data("sap-ui-fastnavgroup","true",true);};
t.prototype.onBeforeRendering=function(){this._bRendering=true;this._bActiveItem=false;this._aNavSections=[];this._removeSwipeContent();};
t.prototype.onAfterRendering=function(){this._bRendering=false;this._sLastMode=this.getMode();if(D.system.desktop){this._startItemNavigation(true);}};
t.prototype.exit=function(){this._oSelectedItem=null;this._aNavSections=[];this._aSelectedPaths=[];this._destroyGrowingDelegate();this._destroyItemNavigation();};
t.prototype.refreshItems=function(R){if(this._oGrowingDelegate){this._oGrowingDelegate.refreshItems(R);}else{if(!this._bReceivingData){this._updateStarted(R);this._bReceivingData=true;}this.refreshAggregation("items");}};
t.prototype.updateItems=function(R,e){if(e&&e.detailedReason==="AddVirtualContext"){u(this);return;}else if(e&&e.detailedReason==="RemoveVirtualContext"){v(this);return;}if(this._bItemsBeingBound){this._bItemsBeingBound=false;this.invalidate();}if(this._oGrowingDelegate){this._oGrowingDelegate.updateItems(R);}else{if(this._bReceivingData){this._bReceivingData=false;}else{this._updateStarted(R);}this.updateAggregation("items");this._updateFinished();}};
function u(e){var B=e.getBinding("items");var i=e.getBindingInfo("items");var V=B.getContexts(0,e.getGrowing()?e.getGrowingThreshold():i.length)[0];v(e);e._oVirtualItem=G.createItem(V,i,"virtual");e.addAggregation("dependents",e._oVirtualItem,true);}
function v(e){if(e._oVirtualItem){e._oVirtualItem.destroy();delete e._oVirtualItem;}}
t.prototype.setBindingContext=function(e,M){var i=(this.getBindingInfo("items")||{}).model;if(i===M){this._resetItemsBinding();}return a.prototype.setBindingContext.apply(this,arguments);};
t.prototype.bindAggregation=function(N){this._bItemsBeingBound=N==="items";v(this);a.prototype.bindAggregation.apply(this,arguments);return this;};
t.prototype._bindAggregation=function(N,B){function e(B,E,H){B.events=B.events||{};if(!B.events[E]){B.events[E]=H;}else{var O=B.events[E];B.events[E]=function(){H.apply(this,arguments);O.apply(this,arguments);};}}if(N==="items"){this._resetItemsBinding();e(B,"dataRequested",this._onBindingDataRequestedListener.bind(this));e(B,"dataReceived",this._onBindingDataReceivedListener.bind(this));}a.prototype._bindAggregation.call(this,N,B);};
t.prototype._onBindingDataRequestedListener=function(e){this._showBusyIndicator();if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}};
t.prototype._onBindingDataReceivedListener=function(e){if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}this._dataReceivedHandlerId=setTimeout(function(){this._hideBusyIndicator();delete this._dataReceivedHandlerId;}.bind(this),0);};
t.prototype.destroyItems=function(e){if(!this.getItems(true).length){return this;}this._oSelectedItem=null;this.destroyAggregation("items","KeepDom");if(!e&&!this._bItemsBeingBound){this.invalidate();}return this;};
t.prototype.removeAllItems=function(A){this._oSelectedItem=null;return this.removeAllAggregation("items");};
t.prototype.removeItem=function(i){var e=this.removeAggregation("items",i);if(e&&e===this._oSelectedItem){this._oSelectedItem=null;}return e;};
t.prototype.getItems=function(R){if(R){return this.mAggregations["items"]||[];}return this.getAggregation("items",[]);};
t.prototype.getId=function(e){var i=this.sId;return e?i+"-"+e:i;};
t.prototype.setGrowing=function(e){e=!!e;if(this.getGrowing()!=e){this.setProperty("growing",e,!e);if(e){this._oGrowingDelegate=new G(this);}else if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}}return this;};
t.prototype.setGrowingThreshold=function(T){return this.setProperty("growingThreshold",T,true);};
t.prototype.setEnableBusyIndicator=function(e){this.setProperty("enableBusyIndicator",e,true);if(!this.getEnableBusyIndicator()){this._hideBusyIndicator();}return this;};
t.prototype.setNoDataText=function(N){this.setProperty("noDataText",N,true);this.$("nodata-text").text(this.getNoDataText());return this;};
t.prototype.getNoDataText=function(e){if(e&&this._bBusy){return"";}var N=this.getProperty("noDataText");N=N||C.getLibraryResourceBundle("sap.m").getText("LIST_NO_DATA");return N;};
t.prototype.getSelectedItem=function(){var e=this.getItems(true);for(var i=0;i<e.length;i++){if(e[i].getSelected()){return e[i];}}return null;};
t.prototype.setSelectedItem=function(e,i,F){if(this.indexOfItem(e)<0){j.warning("setSelectedItem is called without valid ListItem parameter on "+this);return;}if(this._bSelectionMode){e.setSelected((i===undefined)?true:!!i);F&&this._fireSelectionChangeEvent([e]);}};
t.prototype.getSelectedItems=function(){return this.getItems(true).filter(function(i){return i.getSelected();});};
t.prototype.setSelectedItemById=function(i,e){var w=C.byId(i);return this.setSelectedItem(w,e);};
t.prototype.getSelectedContexts=function(A){var B=this.getBindingInfo("items"),M=(B||{}).model,e=this.getModel(M);if(!B||!e){return[];}if(A&&this.getRememberSelections()){return this._aSelectedPaths.map(function(P){return e.getContext(P);});}return this.getSelectedItems().map(function(i){return i.getBindingContext(M);});};
t.prototype.removeSelections=function(A,F,e){var i=[];this._oSelectedItem=null;A&&(this._aSelectedPaths=[]);this.getItems(true).forEach(function(w){if(!w.getSelected()){return;}if(e&&w.isSelectedBoundTwoWay()){return;}w.setSelected(false,true);i.push(w);!A&&this._updateSelectedPaths(w);},this);if(F&&i.length){this._fireSelectionChangeEvent(i);}return this;};
t.prototype.selectAll=function(F){if(this.getMode()!="MultiSelect"){return this;}var e=[];this.getItems(true).forEach(function(i){if(!i.getSelected()){i.setSelected(true,true);e.push(i);this._updateSelectedPaths(i);}},this);if(F&&e.length){this._fireSelectionChangeEvent(e,F);}return this;};
t.prototype.getLastMode=function(M){return this._sLastMode;};
t.prototype.setMode=function(M){M=this.validateProperty("mode",M);var O=this.getMode();if(O==M){return this;}this._bSelectionMode=M.indexOf("Select")>-1;if(!this._bSelectionMode){this.removeSelections(true);}else{var e=this.getSelectedItems();if(e.length>1){this.removeSelections(true);}else if(O===p.MultiSelect){this._oSelectedItem=e[0];}}return this.setProperty("mode",M);};
t.prototype.getGrowingInfo=function(){return this._oGrowingDelegate?this._oGrowingDelegate.getInfo():null;};
t.prototype.setRememberSelections=function(R){this.setProperty("rememberSelections",R,true);!this.getRememberSelections()&&(this._aSelectedPaths=[]);return this;};
t.prototype.setSelectedContextPaths=function(e){this._aSelectedPaths=e||[];};
t.prototype.getSelectedContextPaths=function(A){if(!A||(A&&this.getRememberSelections())){return this._aSelectedPaths.slice(0);}return this.getSelectedItems().map(function(i){return i.getBindingContextPath();});};
t.prototype.isAllSelectableSelected=function(){if(this.getMode()!=p.MultiSelect){return false;}var i=this.getItems(true),e=this.getSelectedItems().length,w=i.filter(function(x){return x.isSelectable();}).length;return(i.length>0)&&(e==w);};
t.prototype.getVisibleItems=function(){return this.getItems(true).filter(function(i){return i.getVisible();});};
t.prototype.getActiveItem=function(){return this._bActiveItem;};
t.prototype.onItemDOMUpdate=function(e){if(!this._bRendering&&this.bOutput){this._startItemNavigation(true);}var V=this.getVisibleItems().length>0;if(!V&&!this._bInvalidatedForNoData){this.invalidate();this._bInvalidatedForNoData=true;}else if(V&&this._bInvalidatedForNoData){this.invalidate();this._bInvalidatedForNoData=false;}};
t.prototype.onItemActiveChange=function(e,A){this._bActiveItem=A;};
t.prototype.onItemHighlightChange=function(i,N){this._iItemNeedsHighlight+=(N?1:-1);if(this._iItemNeedsHighlight==1&&N){this.$("listUl").addClass("sapMListHighlight");}else if(this._iItemNeedsHighlight==0){this.$("listUl").removeClass("sapMListHighlight");}};
t.prototype.onItemNavigatedChange=function(i,N){this._iItemNeedsNavigated+=(N?1:-1);if(this._iItemNeedsNavigated==1&&N){this.$("listUl").addClass("sapMListNavigated");}else if(this._iItemNeedsNavigated==0){this.$("listUl").removeClass("sapMListNavigated");}};
t.prototype.onItemSelectedChange=function(e,i){if(this.getMode()==p.MultiSelect){this._updateSelectedPaths(e,i);return;}if(i){this._aSelectedPaths=[];this._oSelectedItem&&this._oSelectedItem.setSelected(false,true);this._oSelectedItem=e;}else if(this._oSelectedItem===e){this._oSelectedItem=null;}this._updateSelectedPaths(e,i);};
t.prototype.getItemsContainerDomRef=function(){return this.getDomRef("listUl");};
t.prototype.checkGrowingFromScratch=function(){};
t.prototype.onBeforePageLoaded=function(e,i){this._fireUpdateStarted(i,e);this.fireGrowingStarted(e);};
t.prototype.onAfterPageLoaded=function(e,i){this._fireUpdateFinished(e);this.fireGrowingFinished(e);};
t.prototype.addNavSection=function(i){this._aNavSections.push(i);return i;};
t.prototype.getMaxItemsCount=function(){var B=this.getBinding("items");if(B&&B.getLength){return B.getLength()||0;}return this.getItems(true).length;};
t.prototype.shouldRenderItems=function(){return true;};
t.prototype._resetItemsBinding=function(){if(this.isBound("items")){this._bUpdating=false;this._bReceivingData=false;this.removeSelections(true,false,true);this._oGrowingDelegate&&this._oGrowingDelegate.reset();this._hideBusyIndicator();if(this._oItemNavigation){this._oItemNavigation.iFocusedIndex=-1;}}};
t.prototype._updateStarted=function(R){if(!this._bReceivingData&&!this._bUpdating){this._bUpdating=true;this._fireUpdateStarted(R);}};
t.prototype._fireUpdateStarted=function(R,i){this._sUpdateReason=h(R||"Refresh");this.fireUpdateStarted({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});};
t.prototype.onThemeChanged=function(){if(this._oGrowingDelegate){this._oGrowingDelegate._updateTrigger();}};
t.prototype._updateFinished=function(){if(!this._bReceivingData&&this._bUpdating){this._fireUpdateFinished();this._bUpdating=false;}};
t.prototype._fireUpdateFinished=function(i){this._hideBusyIndicator();setTimeout(function(){this._bItemNavigationInvalidated=true;this.fireUpdateFinished({reason:this._sUpdateReason,actual:i?i.actual:this.getItems(true).length,total:i?i.total:this.getMaxItemsCount()});}.bind(this),0);};
t.prototype._showBusyIndicator=function(){if(this.getEnableBusyIndicator()&&!this.getBusy()&&!this._bBusy){this._bBusy=true;this._sBusyTimer=setTimeout(function(){this.$("nodata-text").text("");}.bind(this),this.getBusyIndicatorDelay());this.setBusy(true,"listUl");}};
t.prototype._hideBusyIndicator=function(){if(this._bBusy){this._bBusy=false;this.setBusy(false,"listUl");clearTimeout(this._sBusyTimer);if(!this.getItems(true).length){this.$("nodata-text").text(this.getNoDataText());}}};
t.prototype.setBusy=function(B,e){if(this.getBusy()==B){return this;}a.prototype.setBusy.apply(this,arguments);if(!B||!window.IntersectionObserver){clearTimeout(this._iBusyTimer);return this;}this._iBusyTimer=setTimeout(function(){var i=this.getDomRef(e);var A=this.getDomRef("busyIndicator");var w=l.getScrollDelegate(this,true);if(!i||!A||!w){return;}var x=new window.IntersectionObserver(function(E){x.disconnect();var y=E.pop();var R=y.intersectionRatio;if(R<=0||R>=1){return;}var z=A.firstChild.style;if(y.intersectionRect.height>=y.rootBounds.height){z.position="sticky";}else{z.top=((y.boundingClientRect.top<0?1-R:0)+(R/2))*100+"%";}},{root:w.getContainerDomRef()});x.observe(i);}.bind(this),this.getBusyIndicatorDelay());return this;};
t.prototype.onItemBindingContextSet=function(i){if(!this._bSelectionMode||!this.getRememberSelections()||!this.isBound("items")){return;}if(i.isSelectedBoundTwoWay()){return;}var P=i.getBindingContextPath();if(P){var e=(this._aSelectedPaths.indexOf(P)>-1);i.setSelected(e);}};
t.prototype.onItemInserted=function(i,e){if(e){this.onItemSelectedChange(i,true);}if(!this._bSelectionMode||!this._aSelectedPaths.length||!this.getRememberSelections()||!this.isBound("items")||i.isSelectedBoundTwoWay()||i.getSelected()){return;}var P=i.getBindingContextPath();if(P&&this._aSelectedPaths.indexOf(P)>-1){i.setSelected(true);}};
t.prototype.onItemSelect=function(e,w){var M=this.getMode();if(this._mRangeSelection&&!this.bPreventMassSelection){if(!this._mRangeSelection.selected){this._fireSelectionChangeEvent([e]);this._mRangeSelection.index=this.getVisibleItems().indexOf(e);this._mRangeSelection.selected=w;return;}if(!w){e.setSelected(true);return;}var x=this.indexOfItem(e),y=this.getItems(),z,A,B=[],E;if(x<this._mRangeSelection.index){z=this._mRangeSelection.index-x;E=-1;}else{z=x-this._mRangeSelection.index;E=1;}for(var i=1;i<=z;i++){A=y[this._mRangeSelection.index+(i*E)];if(A.isSelectable()&&A.getVisible()&&!A.getSelected()){A.setSelected(true);B.push(A);}else if(A===e){B.push(A);}}this._fireSelectionChangeEvent(B);return;}if(M===p.MultiSelect){this._fireSelectionChangeEvent([e]);}else if(this._bSelectionMode&&w){this._fireSelectionChangeEvent([e]);}};
t.prototype._fireSelectionChangeEvent=function(e,i){var w=e&&e[0];if(!w){return;}this.fireSelectionChange({listItem:w,listItems:e,selected:w.getSelected(),selectAll:!!i});if(this.getGrowing()){this._bSelectAll=i;}this.fireSelect({listItem:w});};
t.prototype.onItemDelete=function(e){this.fireDelete({listItem:e});};
t.prototype.onItemPress=function(e,i){if(e.getType()==k.Inactive){return;}setTimeout(function(){this.fireItemPress({listItem:e,srcControl:i});}.bind(this),0);};
t.prototype.onItemKeyDown=function(i,e){if(!e.shiftKey||e.ctrlKey||e.altKey||e.metaKey||this.getMode()!==p.MultiSelect||!i.isSelectable()||this.bPreventMassSelection||e.which===K.F6){if(this._mRangeSelection){this._mRangeSelection=null;}return;}var V=this.getVisibleItems(),H=V.some(function(w){return!!w.getSelected();});if(!H){return;}if(!this._mRangeSelection){this._mRangeSelection={index:V.indexOf(i),selected:i.getSelected()};}};
t.prototype.onItemKeyUp=function(i,e){if(e.which===K.SHIFT){this._mRangeSelection=null;}};
t.prototype._updateSelectedPaths=function(i,e){if(!this.getRememberSelections()||!this.isBound("items")){return;}var P=i.getBindingContextPath();if(!P){return;}e=(e===undefined)?i.getSelected():e;var w=this._aSelectedPaths.indexOf(P);if(e){w<0&&this._aSelectedPaths.push(P);}else{w>-1&&this._aSelectedPaths.splice(w,1);}};
t.prototype._destroyGrowingDelegate=function(){if(this._oGrowingDelegate){this._oGrowingDelegate.destroy();this._oGrowingDelegate=null;}};
t.prototype._destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
t.prototype._getTouchBlocker=function(){return this.$().children();};
t.prototype._getSwipeContainer=function(){return this._$swipeContainer||(this._$swipeContainer=q("<div>",{"id":this.getId("swp"),"class":"sapMListSwp"}));};
t.prototype._setSwipePosition=function(){if(this._isSwipeActive){return this._getSwipeContainer().css("top",this._swipedItem.$().position().top);}};
t.prototype._renderSwipeContent=function(){var $=this._swipedItem.$(),e=this._getSwipeContainer();this.$().prepend(e.css({top:$.position().top,height:$.outerHeight(true)}));if(this._bRerenderSwipeContent){this._bRerenderSwipeContent=false;var i=C.createRenderManager();i.render(this.getSwipeContent(),e.empty()[0]);i.destroy();}return this;};
t.prototype._swipeIn=function(){var i=this,$=i._getTouchBlocker(),w=i._getSwipeContainer();i._isSwipeActive=true;i._renderSwipeContent();c.addDialogInstance(i);window.document.activeElement.blur();q(window).on("resize.swp",function(){i._setSwipePosition();});$.css("pointer-events","none").on("touchstart.swp mousedown.swp",function(e){if(!w[0].firstChild.contains(e.target)){e.preventDefault();e.stopPropagation();}});w.on("webkitAnimationEnd animationend",function(){q(this).off("webkitAnimationEnd animationend");w.css("opacity",1).trigger("focus");$.parent().on("touchend.swp touchcancel.swp mouseup.swp",function(e){if(!w[0].firstChild.contains(e.target)){i.swipeOut();}});}).removeClass("sapMListSwpOutAnim").addClass("sapMListSwpInAnim");};
t.prototype._onSwipeOut=function(e){this._getSwipeContainer().css("opacity",0).remove();q(window).off("resize.swp");this._getTouchBlocker().css("pointer-events","auto").off("touchstart.swp mousedown.swp");if(typeof e=="function"){e.call(this,this._swipedItem,this.getSwipeContent());}this._isSwipeActive=false;c.removeDialogInstance(this);};
t.prototype.swipeOut=function(e){if(!this._isSwipeActive){return this;}var i=this,$=this._getSwipeContainer();this._getTouchBlocker().parent().off("touchend.swp touchend.swp touchcancel.swp mouseup.swp");$.on("webkitAnimationEnd animationend",function(){q(this).off("webkitAnimationEnd animationend");i._onSwipeOut(e);}).removeClass("sapMListSwpInAnim").addClass("sapMListSwpOutAnim");return this;};
t.prototype._removeSwipeContent=function(){if(this._isSwipeActive){this.swipeOut()._onSwipeOut();}};
t.prototype.close=t.prototype._removeSwipeContent;
t.prototype._onSwipe=function(e,i){var w=this.getSwipeContent(),x=e.srcControl;if(w&&x&&!this._isSwipeActive&&this!==x&&!this._eventHandledByControl&&D.support.touch){for(var y=x;y&&!(y instanceof f);y=y.oParent);if(y instanceof f){this._swipedItem=y;this.fireSwipe({listItem:this._swipedItem,swipeContent:w,srcControl:x,swipeDirection:i},true)&&this._swipeIn();}}};
t.prototype.ontouchstart=function(e){this._eventHandledByControl=e.isMarked();};
t.prototype.onswipeleft=function(e){var R=C.getConfiguration().getRTL();var i=R?S.EndToBegin:S.BeginToEnd;var w=this.getSwipeDirection();if(w===S.LeftToRight){w=S.BeginToEnd;}else if(w===S.RightToLeft){w=S.EndToBegin;}if(w!=i){if(w==S.Both){w=R?S.BeginToEnd:S.EndToBegin;}this._onSwipe(e,w);}};
t.prototype.onswiperight=function(e){var R=C.getConfiguration().getRTL();var i=R?S.BeginToEnd:S.EndToBegin;var w=this.getSwipeDirection();if(w===S.LeftToRight){w=S.BeginToEnd;}else if(w===S.RightToLeft){w=S.EndToBegin;}if(w!=i){if(w==S.Both){w=R?S.EndToBegin:S.BeginToEnd;}this._onSwipe(e,w);}};
t.prototype.setSwipeDirection=function(e){return this.setProperty("swipeDirection",e,true);};
t.prototype.getSwipedItem=function(){return(this._isSwipeActive?this._swipedItem:null);};
t.prototype.setSwipeContent=function(e){this._bRerenderSwipeContent=true;this.toggleStyleClass("sapMListSwipable",!!e);return this.setAggregation("swipeContent",e,!this._isSwipeActive);};
t.prototype.invalidate=function(O){if(O&&O===this.getSwipeContent()){this._bRerenderSwipeContent=true;this._isSwipeActive&&this._renderSwipeContent();return;}return a.prototype.invalidate.apply(this,arguments);};
t.prototype.addItemGroup=function(e,H,i){if(!H){H=new d();H.setTitle(e.text||e.key);}H._bGroupHeader=true;this.addAggregation("items",H,i);return H;};
t.prototype.removeGroupHeaders=function(e){this.getItems(true).forEach(function(i){if(i.isGroupHeader()){i.destroy(e);}});};
t.prototype.getAccessibilityType=function(){return C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_LIST");};
t.prototype.getAccessibilityStates=function(){if(!this.getItems(true).length){return"";}var e="",M=p,i=this.getMode(),B=C.getLibraryResourceBundle("sap.m");if(L.isRequired(this)){e+=B.getText("LIST_REQUIRED")+" ";}if(i==M.MultiSelect){e+=B.getText("LIST_MULTISELECTABLE")+" ";}else if(i==M.Delete){e+=B.getText("LIST_DELETABLE")+" ";}else if(i!=M.None){e+=B.getText("LIST_SELECTABLE")+" ";}if(this.isGrouped()){e+=B.getText("LIST_GROUPED")+" ";}return e;};
t.prototype.getAccessibilityInfo=function(){return{description:this.getAccessibilityStates().trim(),focusable:true};};
t.prototype.getAccessbilityPosition=function(i){var e=0,w=this.getVisibleItems(),P=w.indexOf(i)+1,B=this.getBinding("items");if(this.getGrowing()&&this.getGrowingScrollToLoad()&&B&&B.isLengthFinal()){e=B.getLength();if(B.isGrouped()){e+=w.filter(function(i){return i.isGroupHeader()&&i.getVisible();}).length;}}else{e=w.length;}return{setSize:e,posInset:P};};
t.prototype.onItemFocusIn=function(i,F){this._handleStickyItemFocus(i.getDomRef());if(i!==F||!C.getConfiguration().getAccessibility()){return;}var e=i.getDomRef(),P=this.getAccessbilityPosition(i);if(D.browser.msie&&this._oItemNavigation&&this._oItemNavigation.getFocusedDomRef()===e){e.classList.remove("sapMLIBFocusable");setTimeout(function(){e.classList.add("sapMLIBFocusable");},0);}if(!i.getContentAnnouncement){this.getNavigationRoot().setAttribute("aria-activedescendant",e.id);e.setAttribute("aria-posinset",P.posInset);e.setAttribute("aria-setsize",P.setSize);}else{var A=i.getAccessibilityInfo(),B=C.getLibraryResourceBundle("sap.m"),w=A.type+" ";if(!D.browser.chrome||this.isA("sap.m.Table")){w+=B.getText("LIST_ITEM_POSITION",[P.posInset,P.setSize])+" ";}else{e.setAttribute("aria-posinset",P.posInset);e.setAttribute("aria-setsize",P.setSize);}w+=A.description;this.updateInvisibleText(w,e);return w;}};
t.prototype.updateInvisibleText=function(T,i,P){var e=t.getInvisibleText(),F=q(i||document.activeElement);if(this.bAnnounceDetails){this.bAnnounceDetails=false;T=this.getAccessibilityInfo().description+" "+T;}e.setText(T.trim());F.addAriaLabelledBy(e.getId(),P);};
t.prototype.getNavigationRoot=function(){return this.getDomRef("listUl");};
t.prototype.getFocusDomRef=function(){return this.getNavigationRoot();};
t.prototype._startItemNavigation=function(i){if(!D.system.desktop){return;}var e=this.getKeyboardMode(),w=m;if(e==w.Edit&&!this.getItems(true).length){return;}var N=this.getNavigationRoot();var T=(e==w.Edit)?-1:0;if(i&&N&&!N.contains(document.activeElement)){this._bItemNavigationInvalidated=true;if(!N.getAttribute("tabindex")){N.tabIndex=T;}return;}if(!this._oItemNavigation){this._oItemNavigation=new b();this._oItemNavigation.setCycling(false);this.addDelegate(this._oItemNavigation);this._setItemNavigationTabIndex(T);this._oItemNavigation.setTableMode(true,true).setColumns(1);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});}this._oItemNavigation.setPageSize(this.getGrowingThreshold());this._oItemNavigation.setRootDomRef(N);this.setNavigationItems(this._oItemNavigation,N);this._bItemNavigationInvalidated=false;};
t.prototype.setNavigationItems=function(i,N){var e=q(N).children(".sapMLIB").get();i.setItemDomRefs(e);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==n.Upwards){i.setFocusedIndex(e.length-1);}else{i.setFocusedIndex(0);}}};
t.prototype.getItemNavigation=function(){return this._oItemNavigation;};
t.prototype._setItemNavigationTabIndex=function(T){if(this._oItemNavigation){this._oItemNavigation.iActiveTabIndex=T;this._oItemNavigation.iTabIndex=T;}};
t.prototype.setKeyboardMode=function(e){this.setProperty("keyboardMode",e,true);if(this.isActive()){var T=(e==m.Edit)?-1:0;this.$("nodata").prop("tabIndex",~T);this.$("listUl").prop("tabIndex",T);this.$("after").prop("tabIndex",T);this._setItemNavigationTabIndex(T);}return this;};
t.prototype.setItemFocusable=function(e){if(!this._oItemNavigation){return;}var i=this._oItemNavigation.getItemDomRefs();var w=i.indexOf(e.getDomRef());if(w>=0){this._oItemNavigation.setFocusedIndex(w);}};
t.prototype.forwardTab=function(F){this._bIgnoreFocusIn=true;this.$(F?"after":"before").trigger("focus");};
t.prototype.onsaptabnext=function(e){if(e.isMarked()||this.getKeyboardMode()==m.Edit){return;}if(e.target.id==this.getId("nodata")){this.forwardTab(true);e.setMarked();}};
t.prototype.onsaptabprevious=function(e){if(e.isMarked()||this.getKeyboardMode()==m.Edit){return;}var T=e.target.id;if(T==this.getId("nodata")){this.forwardTab(false);}else if(T==this.getId("trigger")){this.focusPrevious();e.preventDefault();}};
t.prototype._navToSection=function(F){var T;var i=0;var e=F?1:-1;var w=this._aNavSections.length;this._aNavSections.some(function(y,z){var A=(y?window.document.getElementById(y):null);if(A&&A.contains(document.activeElement)){i=z;return true;}});var x=this.getItemsContainerDomRef();var $=q(document.getElementById(this._aNavSections[i]));if($[0]===x&&this._oItemNavigation){$.data("redirect",this._oItemNavigation.getFocusedIndex());}this._aNavSections.some(function(){i=(i+e+w)%w;T=q(document.getElementById(this._aNavSections[i]));if(T[0]===x&&this._oItemNavigation){var R=T.data("redirect");var y=this._oItemNavigation.getItemDomRefs();var z=y[R]||x.children[0];T=q(z);}if(T.is(":focusable")){T.trigger("focus");return true;}},this);return T;};
t.prototype.onsapshow=function(e){if(e.isMarked()||e.which==K.F4||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(true)){e.preventDefault();e.setMarked();}};
t.prototype.onsaphide=function(e){if(e.isMarked()||e.target.id!=this.getId("trigger")&&!q(e.target).hasClass(this.sNavItemClass)){return;}if(this._navToSection(false)){e.preventDefault();e.setMarked();}};
t.prototype.onkeydown=function(e){var i=(e.which==K.A)&&(e.metaKey||e.ctrlKey);if(e.isMarked()||!i||!q(e.target).hasClass(this.sNavItemClass)||this.bPreventMassSelection){return;}e.preventDefault();if(this.getMode()!==p.MultiSelect){return;}if(this.isAllSelectableSelected()){this.removeSelections(false,true);}else{this.selectAll(true);}e.setMarked();};
t.prototype.onmousedown=function(e){if(this._bItemNavigationInvalidated){this._startItemNavigation();}if(e.shiftKey&&this._mRangeSelection&&e.srcControl.getId().includes("-selectMulti")){e.preventDefault();}};
t.prototype.focusPrevious=function(){if(!this._oItemNavigation){return;}var N=this._oItemNavigation.getItemDomRefs();var i=this._oItemNavigation.getFocusedIndex();var $=q(N[i]);var R=$.control(0)||{};var T=R.getTabbables?R.getTabbables():$.find(":sapTabbable");var F=T.eq(-1).add($).eq(-1);this.bAnnounceDetails=true;F.trigger("focus");};
t.prototype.onfocusin=function(e){if(this._bIgnoreFocusIn){this._bIgnoreFocusIn=false;e.stopImmediatePropagation(true);return;}if(this._bItemNavigationInvalidated){this._startItemNavigation();}var T=e.target;if(T.id==this.getId("nodata")){this.updateInvisibleText(this.getNoDataText(),T);}if(e.isMarked()||!this._oItemNavigation||this.getKeyboardMode()==m.Edit||T.id!=this.getId("after")){return;}this.focusPrevious();e.setMarked();};
t.prototype.onsapfocusleave=function(e){if(this._oItemNavigation&&!this.bAnnounceDetails&&!this.getNavigationRoot().contains(document.activeElement)){this.bAnnounceDetails=true;}};
t.prototype.onItemArrowUpDown=function(e,E){var i=this.getItems(true),w=i.indexOf(e)+(E.type=="sapup"?-1:1),x=i[w];if(x&&x.isGroupHeader()){x=i[w+(E.type=="sapup"?-1:1)];}if(!x){return;}var T=x.getTabbables(),F=e.getTabbables().index(E.target),$=T.eq(T[F]?F:-1);$[0]?$.trigger("focus"):x.focus();E.preventDefault();E.setMarked();};
t.prototype.onItemContextMenu=function(e,E){var i=this.getContextMenu();if(!i){return;}var w=this.fireBeforeOpenContextMenu({listItem:e,column:C.byId(q(E.target).closest(".sapMListTblCell",this.getNavigationRoot()).attr("data-sap-ui-column"))});if(w){E.setMarked();E.preventDefault();var B,x=this.getBindingInfo("items");if(x){B=e.getBindingContext(x.model);i.setBindingContext(B,x.model);}i.openAsContextMenu(E,e);}};
t.prototype.onItemUpDownModifiers=function(i,e,w){if(!this._mRangeSelection||this.bPreventMassSelection){return;}var V=this.getVisibleItems(),x=V.indexOf(i),y=V[x+w];if(!y){if(this._mRangeSelection){this._mRangeSelection=null;}e.setMarked();return;}var z=y.getSelected();if(this._mRangeSelection.direction===undefined){this._mRangeSelection.direction=w;}else if(this._mRangeSelection.direction!==w){if(this._mRangeSelection.index!==V.indexOf(i)){y=i;z=y.getSelected();if(this._mRangeSelection.selected&&z){this.setSelectedItem(y,false,true);return;}}else{this._mRangeSelection.direction=w;}}if(this._mRangeSelection.selected!==z&&y.isSelectable()){this.setSelectedItem(y,this._mRangeSelection.selected,true);}};
t.prototype.isGrouped=function(){var B=this.getBinding("items");return B&&B.isGrouped();};
t.prototype.setContextMenu=function(e){this.setAggregation("contextMenu",e,true);return this;};
t.prototype.destroyContextMenu=function(){this.destroyAggregation("contextMenu",true);return this;};
t.getStickyBrowserSupport=function(){var B=D.browser;return(B.safari||B.chrome||(B.firefox&&B.version>=59)||(B.edge&&B.version>=16));};
t.prototype.getStickyStyleValue=function(){var e=this.getSticky();if(!e||!e.length||!t.getStickyBrowserSupport()){return(this._iStickyValue=0);}var i=0,H=this.getHeaderText(),w=this.getHeaderToolbar(),x=H||(w&&w.getVisible()),y=this.getInfoToolbar(),z=y&&y.getVisible(),A=false;if(this.isA("sap.m.Table")){A=this.getColumns().some(function(B){return B.getVisible()&&B.getHeader();});}e.forEach(function(B){if(B===s.HeaderToolbar&&x){i+=1;}else if(B===s.InfoToolbar&&z){i+=2;}else if(B===s.ColumnHeaders&&A){i+=4;}});return(this._iStickyValue=i);};
t.prototype._handleStickyItemFocus=function(i){if(!this._iStickyValue){return;}var e=l.getScrollDelegate(this,true);if(!e){return;}var T=0,w=0,x=0,y=0,H=0,z=0;if(this._iStickyValue&4){var A=this.getDomRef("tblHeader").firstChild;var B=A.getBoundingClientRect();w=parseInt(B.bottom);T=parseInt(B.height);}if(this._iStickyValue&2){var E=this.getDomRef().querySelector(".sapMListInfoTBarContainer");if(E){var F=E.getBoundingClientRect();y=parseInt(F.bottom);x=parseInt(F.height);}}if(this._iStickyValue&1){var J=this.getDomRef().querySelector(".sapMListHdr");if(J){var M=J.getBoundingClientRect();z=parseInt(M.bottom);H=parseInt(M.height);}}var N=Math.round(i.getBoundingClientRect().top);if(w>N||y>N||z>N){window.requestAnimationFrame(function(){e.scrollToElement(i,0,[0,-T-x-H]);});}};
t.prototype.setHeaderToolbar=function(H){return this._setToolbar("headerToolbar",H);};
t.prototype.setInfoToolbar=function(i){return this._setToolbar("infoToolbar",i);};
t.prototype.scrollToIndex=function(i){var e,R,w,x;x=l.getScrollDelegate(this,true);if(!x){return;}e=this.getVisibleItems();R=e.length;if(typeof i!=='number'||i<-1){i=0;}if(i>=R||i===-1){i=R-1;}w=e[i];if(!w){return;}setTimeout(function(){x.scrollToElement(w.getDomRef(),null,[0,this._getStickyAreaHeight()*-1]);}.bind(this),0);};
t.prototype._getStickyAreaHeight=function(){var e=this.getSticky();if(!(e&&e.length)){return 0;}return e.reduce(function(i,w){var x,y;switch(w){case s.HeaderToolbar:x=this.getHeaderToolbar();y=x&&x.getDomRef()||this.getDomRef("header");break;case s.InfoToolbar:x=this.getInfoToolbar();y=x&&x.getDomRef();break;case s.ColumnHeaders:y=this.getDomRef("tblHeader");break;default:}return i+(y?y.offsetHeight:0);}.bind(this),0);};
t.prototype._setToolbar=function(A,T){var O=this.getAggregation(A);if(O){O.detachEvent("_change",this._onToolbarPropertyChanged,this);}this.setAggregation(A,T);if(T){T.attachEvent("_change",this._onToolbarPropertyChanged,this);}return this;};
t.prototype._onToolbarPropertyChanged=function(e){if(e.getParameter("name")!=="visible"){return;}var O=this._iStickyValue,N=this.getStickyStyleValue();if(O!==N){var i=this.getDomRef();if(i){var w=i.classList;w.toggle("sapMSticky",!!N);w.remove("sapMSticky"+O);w.toggle("sapMSticky"+N,!!N);}}};
return t;});
sap.ui.predefine('sap/m/ListBaseRenderer',["sap/m/library","sap/ui/Device","sap/ui/core/InvisibleText","./ListItemBaseRenderer"],function(l,D,I,L){"use strict";var a=l.ListGrowingDirection;var b=l.ListKeyboardMode;var T=l.ToolbarDesign;var c={apiVersion:2};c.ModeOrder={None:0,Delete:1,MultiSelect:-1,SingleSelect:1,SingleSelectLeft:-1,SingleSelectMaster:0};
c.render=function(r,C){r.openStart("div",C);r.class("sapMList");if(C.getInset()){r.class("sapMListInsetBG");}r.style("width",C.getWidth());if(C.getBackgroundDesign){r.class("sapMListBG"+C.getBackgroundDesign());}var t=C.getTooltip_AsString();if(t){r.attr("title",t);}var s=C.getStickyStyleValue();if(s){r.class("sapMSticky");r.class("sapMSticky"+s);}this.renderContainerAttributes(r,C);r.openEnd();r.renderControl(C.getAggregation("_messageStrip"));var h=C.getHeaderText();var H=C.getHeaderToolbar();if(H){H.setDesign(T.Transparent,true);H.addStyleClass("sapMListHdr");H.addStyleClass("sapMListHdrTBar");H.addStyleClass("sapMTBHeader-CTX");r.renderControl(H);}else if(h){r.openStart("header",C.getId("header"));r.class("sapMListHdr").class("sapMListHdrText").openEnd();r.text(h);r.close("header");}var o=C.getInfoToolbar();if(o){o.setDesign(T.Info,true);o.addStyleClass("sapMListInfoTBar");r.openStart("div").class("sapMListInfoTBarContainer").openEnd();r.renderControl(o);r.close("div");}var d=C.getItems(),S=C.getShowNoData(),R=C.shouldRenderItems()&&d.length,e=C.getKeyboardMode()==b.Edit?-1:0,u=C.getGrowingDirection()==a.Upwards&&C.getGrowing();if(u){this.renderGrowing(r,C);}this.renderDummyArea(r,C,"before",-1);this.renderListStartAttributes(r,C);r.class("sapMListUl");if(C._iItemNeedsHighlight){r.class("sapMListHighlight");}if(R||S){r.attr("tabindex",e);}r.class("sapMListShowSeparators"+C.getShowSeparators());r.class("sapMListMode"+C.getMode());if(C._iItemNeedsNavigated){r.class("sapMListNavigated");}r.openEnd();this.renderListHeadAttributes(r,C);if(R){if(u){d.reverse();}for(var i=0;i<d.length;i++){r.renderControl(d[i]);}}var v=C.getVisibleItems().length>0;if(S&&(!R||!v)){this.renderNoData(r,C);}this.renderListEndAttributes(r,C);this.renderDummyArea(r,C,"after",e);if(!u){this.renderGrowing(r,C);}if(C.getFooterText()){r.openStart("footer",C.getId("footer")).class("sapMListFtr").openEnd();r.text(C.getFooterText());r.close("footer");}r.close("div");};
c.renderContainerAttributes=function(r,C){};
c.renderListHeadAttributes=function(r,C){};
c.renderListStartAttributes=function(r,C){r.openStart("ul",C.getId("listUl"));r.class("sapMListItems");C.addNavSection(C.getId("listUl"));r.accessibilityState(C,this.getAccessibilityState(C));};
c.getAriaRole=function(C){return"listbox";};
c.getNoDataAriaRole=function(){return null;};
c.getAriaLabelledBy=function(C){var h=C.getHeaderToolbar();if(h){var t=h.getTitleControl();if(t){var s=t.getId();if(C.getAriaLabelledBy().indexOf(s)===-1){return s;}}}else if(C.getHeaderText()){return C.getId("header");}};
c.getAriaDescribedBy=function(C){if(C.getFooterText()){return C.getId("footer");}};
c.getAccessibilityState=function(C){var r=this.getAriaRole(C);return{role:r,multiselectable:(r&&C._bSelectionMode)?C.getMode()=="MultiSelect":undefined,labelledby:{value:this.getAriaLabelledBy(C),append:true},describedby:{value:this.getAriaDescribedBy(C),append:true}};};
c.renderListEndAttributes=function(r,C){r.close("ul");};
c.renderNoData=function(r,C){r.openStart("li",C.getId("nodata"));r.attr("tabindex",C.getKeyboardMode()==b.Navigation?-1:0);var A=this.getNoDataAriaRole();if(A){r.attr("role",A);}r.class("sapMLIB").class("sapMListNoData").class("sapMLIBTypeInactive");L.addFocusableClasses.call(L,r);r.openEnd();r.openStart("div",C.getId("nodata-text")).class("sapMListNoDataText").openEnd();r.text(C.getNoDataText(true));r.close("div");r.close("li");};
c.renderDummyArea=function(r,C,A,t){r.openStart("div",C.getId(A)).attr("tabindex",t);if(D.system.desktop){r.class("sapMListDummyArea");}r.openEnd().close("div");};
c.renderGrowing=function(r,C){var g=C._oGrowingDelegate;if(g){g.render(r);}};
c.getAriaAnnouncement=function(B){return I.getStaticId("sap.m",B);};
return c;},true);
sap.ui.predefine('sap/m/ListItemBase',["sap/ui/base/DataType","sap/ui/events/KeyCodes","sap/ui/model/BindingMode","sap/ui/Device","sap/ui/core/library","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/Icon","sap/ui/core/theming/Parameters","./library","./Button","./CheckBox","./RadioButton","./ListItemBaseRenderer","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(D,K,B,a,c,C,I,b,T,l,d,e,R,L,f,q){"use strict";var g=l.ListKeyboardMode;var h=l.ListMode;var i=l.ListType;var j=l.ButtonType;var M=c.MessageType;
var k=C.extend("sap.m.ListItemBase",{metadata:{library:"sap.m",properties:{type:{type:"sap.m.ListType",group:"Misc",defaultValue:i.Inactive},visible:{type:"boolean",group:"Appearance",defaultValue:true},unread:{type:"boolean",group:"Misc",defaultValue:false},selected:{type:"boolean",defaultValue:false},counter:{type:"int",group:"Misc",defaultValue:null},highlight:{type:"string",group:"Appearance",defaultValue:"None"},highlightText:{type:"string",group:"Misc",defaultValue:""},navigated:{type:"boolean",group:"Appearance",defaultValue:false}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tap:{deprecated:true},detailTap:{deprecated:true},press:{},detailPress:{}},designtime:"sap/m/designtime/ListItemBase.designtime"}});
k.getAccessibilityText=function(o,m){if(!o||!o.getVisible||!o.getVisible()){return"";}var A;if(o.getAccessibilityInfo){A=o.getAccessibilityInfo();}if(!A||!o.getAccessibilityInfo){A=this.getDefaultAccessibilityInfo(o.getDomRef());}A=q.extend({type:"",description:"",children:[]},A);var n=sap.ui.getCore().getLibraryResourceBundle("sap.m"),t=A.type+" "+A.description+" ",s=o.getTooltip_AsString();if(A.enabled===false){t+=n.getText("CONTROL_DISABLED")+" ";}if(A.editable===false){t+=n.getText("CONTROL_READONLY")+" ";}if(!A.type&&s&&t.indexOf(s)==-1){t=s+" "+t;}A.children.forEach(function(p){t+=k.getAccessibilityText(p)+" ";});t=t.trim();if(m&&!t){t=n.getText("CONTROL_EMPTY");}return t;};
k.getDefaultAccessibilityInfo=function(o){if(!o){return null;}var N=window.Node,m=window.NodeFilter,t=document.createTreeWalker(o,m.SHOW_TEXT+m.SHOW_ELEMENT,function(p){if(p.type===N.ELEMENT_NODE){if(p.classList.contains("sapUiInvisibleText")){return m.FILTER_SKIP;}if(p.getAttribute("aria-hidden")=="true"||p.style.visibility=="hidden"||p.style.display=="none"){return m.FILTER_REJECT;}return m.FILTER_SKIP;}return m.FILTER_ACCEPT;},false);var n=[];while(t.nextNode()){var p=t.currentNode;if(p.nodeType===N.TEXT_NODE){var s=(p.nodeValue||"").trim();if(s){n.push(s);}}}return{description:n.join(" ")};};
k.prototype.DetailIconURI=I.getIconURI("edit");k.prototype.NavigationIconURI=I.getIconURI("slim-arrow-right");k.prototype.TagName="li";
k.prototype.init=function(){this._active=false;this._bGroupHeader=false;this._bNeedsHighlight=false;this._bNeedsNavigated=false;};
k.prototype.onAfterRendering=function(){this.informList("DOMUpdate",true);this._checkHighlight();this._checkNavigated();};
k.prototype.invalidate=function(){if(!this.bOutput){return;}C.prototype.invalidate.apply(this,arguments);};
k.prototype.getBindingContextPath=function(m){var o=this.getList();if(o&&!m){m=(o.getBindingInfo("items")||{}).model;}var n=this.getBindingContext(m);if(n){return n.getPath();}};
k.prototype.isSelectedBoundTwoWay=function(){var o=this.getBinding("selected");if(o&&o.getBindingMode()==B.TwoWay){return true;}};
k.prototype.getList=function(){var p=this.getParent();if(p&&p.isA("sap.m.ListBase")){return p;}};
k.prototype.getListProperty=function(p,F){var o=this.getList();if(o){p=f(p);return o["get"+p]();}return F;};
k.prototype.informList=function(E,p,P){var o=this.getList();if(o){var m="onItem"+E;if(o[m]){o[m](this,p,P);}}};
k.prototype.informSelectedChange=function(s){var o=this.getList();if(o){o.onItemSelectedChange(this,s);this.bSelectedDelayed=undefined;}else{this.bSelectedDelayed=s;}};
k.prototype.getAccessibilityType=function(o){return o.getText("ACC_CTR_TYPE_OPTION");};
k.prototype.getGroupAnnouncement=function(){return this.$().prevAll(".sapMGHLI:first").text();};
k.prototype.getAccessibilityDescription=function(o){var O=[],t=this.getType(),H=this.getHighlight(),s=this.getTooltip_AsString();if(this.getSelected()){O.push(o.getText("LIST_ITEM_SELECTED"));}if(H!==M.None){var m=this.getHighlightText();if(H in M&&!m){m=o.getText("LIST_ITEM_STATE_"+H.toUpperCase());}O.push(m);}if(this.getUnread()&&this.getListProperty("showUnread")){O.push(o.getText("LIST_ITEM_UNREAD"));}if(this.getCounter()){O.push(o.getText("LIST_ITEM_COUNTER",this.getCounter()));}if(t==i.Navigation){O.push(o.getText("LIST_ITEM_NAVIGATION"));}else{if(t==i.Detail||t==i.DetailAndActive){O.push(o.getText("LIST_ITEM_DETAIL"));}if(t==i.Active||t==i.DetailAndActive){O.push(o.getText("LIST_ITEM_ACTIVE"));}}O.push(this.getGroupAnnouncement()||"");if(this.getContentAnnouncement){O.push((this.getContentAnnouncement(o)||"").trim());}if(s){O.push(s);}if(this.getNavigated()){O.push(o.getText("LIST_ITEM_NAVIGATED"));}return O.join(" ");};
k.prototype.getAccessibilityInfo=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{type:this.getAccessibilityType(o),description:this.getAccessibilityDescription(o),focusable:true};};
k.prototype.getMode=function(){return this.getListProperty("mode","");};
k.prototype.updateAccessibilityState=function(A){var t=this.$();if(!t.length){return;}var $=t.parent().children(".sapMLIB");t.attr(q.extend({"aria-setsize":$.length,"aria-posinset":$.index(t)+1},A));};
k.prototype.getDeleteControl=function(m){if(!m||this._oDeleteControl){return this._oDeleteControl;}if(!this.DeleteIconURI){k.prototype.DeleteIconURI=I.getIconURI(T.get("_sap_m_ListItemBase_DeleteIcon"));}this._oDeleteControl=new d({id:this.getId()+"-imgDel",icon:this.DeleteIconURI,type:j.Transparent,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_DELETE")}).addStyleClass("sapMLIBIconDel sapMLIBSelectD").setParent(this,null,true).attachPress(function(E){this.informList("Delete");},this);this._oDeleteControl._bExcludeFromTabChain=true;this._oDeleteControl.getEnabled=function(){return true;};return this._oDeleteControl;};
k.prototype.onThemeChanged=function(){k.prototype.DeleteIconURI=I.getIconURI(T.get("_sap_m_ListItemBase_DeleteIcon"));if(this._oDeleteControl){this._oDeleteControl.setIcon(this.DeleteIconURI);}};
k.prototype.getDetailControl=function(m){if(!m||this._oDetailControl){return this._oDetailControl;}this._oDetailControl=new d({id:this.getId()+"-imgDet",icon:this.DetailIconURI,type:j.Transparent,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("LIST_ITEM_EDIT")}).addStyleClass("sapMLIBType sapMLIBIconDet").setParent(this,null,true).attachPress(function(){this.fireDetailTap();this.fireDetailPress();},this);this._oDetailControl._bExcludeFromTabChain=true;this._oDetailControl.getEnabled=function(){return true;};return this._oDetailControl;};
k.prototype.getNavigationControl=function(m){if(!m||this._oNavigationControl){return this._oNavigationControl;}this._oNavigationControl=new b({id:this.getId()+"-imgNav",src:this.NavigationIconURI,useIconTooltip:false,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMLIBType sapMLIBImgNav");return this._oNavigationControl;};
k.prototype.getSingleSelectControl=function(m){if(!m||this._oSingleSelectControl){m&&this._oSingleSelectControl.setSelected(this.getSelected());return this._oSingleSelectControl;}this._oSingleSelectControl=new R({id:this.getId()+"-selectSingle",groupName:this.getListProperty("id")+"_selectGroup",activeHandling:false,selected:this.getSelected()}).addStyleClass("sapMLIBSelectS").setParent(this,null,true).setTabIndex(-1).attachSelect(function(E){var s=E.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);this._oSingleSelectControl.getEnabled=function(){return true;};return this._oSingleSelectControl;};
k.prototype.getMultiSelectControl=function(m){if(!m||this._oMultiSelectControl){m&&this._oMultiSelectControl.setSelected(this.getSelected());return this._oMultiSelectControl;}this._oMultiSelectControl=new e({id:this.getId()+"-selectMulti",activeHandling:false,selected:this.getSelected()}).addStyleClass("sapMLIBSelectM").setParent(this,null,true).setTabIndex(-1).addEventDelegate({onkeydown:function(E){this.informList("KeyDown",E);},onkeyup:function(E){this.informList("KeyUp",E);}},this).attachSelect(function(E){var s=E.getParameter("selected");this.setSelected(s);this.informList("Select",s);},this);this._oMultiSelectControl.getEnabled=function(){return true;};return this._oMultiSelectControl;};
k.prototype.getModeControl=function(m){var s=this.getMode();if(!s||s==h.None){return;}if(s==h.Delete){return this.getDeleteControl(m);}if(s==h.MultiSelect){return this.getMultiSelectControl(m);}return this.getSingleSelectControl(m);};
k.prototype.getTypeControl=function(m){var t=this.getType();if(t==i.Detail||t==i.DetailAndActive){return this.getDetailControl(m);}if(t==i.Navigation){return this.getNavigationControl(m);}};
k.prototype.destroyControls=function(m){m.forEach(function(s){s="_o"+s+"Control";if(this[s]){this[s].destroy("KeepDom");this[s]=null;}},this);};
k.prototype.isActionable=function(){return this.isIncludedIntoSelection()||(this.getType()!=i.Inactive&&this.getType()!=i.Detail);};
k.prototype.exit=function(){this._oLastFocused=null;this._checkHighlight(false);this._checkNavigated(false);this.setActive(false);this.destroyControls(["Delete","SingleSelect","MultiSelect","Detail","Navigation"]);};
k.prototype.setHighlight=function(v){if(v==null){v=M.None;}else if(!D.getType("sap.ui.core.MessageType").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error('"'+v+'" is not a value of the enums sap.ui.core.MessageType or sap.ui.core.IndicationColor for property "highlight" of '+this);}return this.setProperty("highlight",v);};
k.prototype.isSelectable=function(){var m=this.getMode();return!(m==h.None||m==h.Delete);};
k.prototype.getSelected=function(){if(this.isSelectable()){return this.getProperty("selected");}return false;};
k.prototype.isSelected=k.prototype.getSelected;
k.prototype.setSelected=function(s,m){s=this.validateProperty("selected",s);if(!this.isSelectable()||s==this.getSelected()){return this;}if(!m){this.informSelectedChange(s);}var S=this.getModeControl();if(S){S.setSelected(s);}this.updateSelectedDOM(s,this.$());this.setProperty("selected",s,true);return this;};
k.prototype.updateSelectedDOM=function(s,t){t.toggleClass("sapMLIBSelected",s);t.attr("aria-selected",s);};
k.prototype.setParent=function(p){C.prototype.setParent.apply(this,arguments);if(!p){this._bGroupHeader=false;return;}this.informList("Inserted",this.bSelectedDelayed);return this;};
k.prototype.setBindingContext=function(){C.prototype.setBindingContext.apply(this,arguments);this.informList("BindingContextSet");return this;};
k.prototype.isGroupHeader=function(){return this._bGroupHeader;};
k.prototype.isIncludedIntoSelection=function(){if(!this.isSelectable()){return false;}var m=this.getMode();return m==h.SingleSelectMaster||(this.getListProperty("includeItemInSelection")&&(m==h.SingleSelectLeft||m==h.SingleSelect||m==h.MultiSelect));};
k.prototype._checkHighlight=function(n){if(n==undefined){n=(this.getVisible()&&this.getHighlight()!=M.None);}if(this._bNeedsHighlight!=n){this._bNeedsHighlight=n;this.informList("HighlightChange",n);}};
k.prototype._checkNavigated=function(n){if(n==undefined){n=(this.getVisible()&&this.getNavigated());}if(this._bNeedsNavigated!=n){this._bNeedsNavigated=n;this.informList("NavigatedChange",n);}};
k.prototype.hasActiveType=function(){var t=this.getType();return(t==i.Active||t==i.Navigation||t==i.DetailAndActive);};
k.prototype.setActive=function(A){if(A==this._active){return this;}if(A&&this.getListProperty("activeItem")){return this;}var t=this.$();this._active=A;this._activeHandling(t);if(this.getType()==i.Navigation){this._activeHandlingNav(t);}if(A){this._activeHandlingInheritor(t);}else{this._inactiveHandlingInheritor(t);}this.informList("ActiveChange",A);};
k.detectTextSelection=function(o){var s=window.getSelection(),t=s.toString().replace("\n","");return t&&q.contains(o,s.focusNode);};
k.prototype.ontap=function(E){if(this._eventHandledByControl){return E.setMarked();}if(k.detectTextSelection(this.getDomRef())){return;}if(this.isIncludedIntoSelection()){if(this.getMode()==h.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}}else if(this.hasActiveType()){window.clearTimeout(this._timeoutIdStart);window.clearTimeout(this._timeoutIdEnd);this.setActive(true);if(a.os.ios){this.focus();}setTimeout(function(){this.setActive(false);}.bind(this),180);setTimeout(function(){this.fireTap();this.firePress();}.bind(this),0);}this.informList("Press",E.srcControl);};
k.prototype.ontouchstart=function(E){this._eventHandledByControl=E.isMarked();var t=E.targetTouches[0];this._touchedY=t.clientY;this._touchedX=t.clientX;if(this._eventHandledByControl||E.touches.length!=1||!this.hasActiveType()){return;}this._timeoutIdStart=setTimeout(function(){this.setActive(true);}.bind(this),100);};
k.prototype.ontouchmove=function(E){if((this._active||this._timeoutIdStart)&&(Math.abs(this._touchedY-E.targetTouches[0].clientY)>10||Math.abs(this._touchedX-E.targetTouches[0].clientX)>10)){clearTimeout(this._timeoutIdStart);this._timeoutIdStart=null;this._timeoutIdEnd=null;this.setActive(false);}};
k.prototype.ontouchend=function(E){if(this.hasActiveType()){this._timeoutIdEnd=setTimeout(function(){this.setActive(false);}.bind(this),100);}};
k.prototype.ontouchcancel=k.prototype.ontouchend;k.prototype.ondragend=k.prototype.ontouchend;
k.prototype._activeHandlingNav=function(){};
k.prototype._activeHandlingInheritor=function(){};
k.prototype._inactiveHandlingInheritor=function(){};
k.prototype._activeHandling=function(t){t.toggleClass("sapMLIBActive",this._active);if(a.system.desktop&&this.isActionable()){t.toggleClass("sapMLIBHoverable",!this._active);}};
k.prototype.onsapspace=function(E){if(E.srcControl!==this){return;}E.preventDefault();if(E.isMarked()||!this.isSelectable()){return;}if(this.getMode()==h.MultiSelect){this.setSelected(!this.getSelected());this.informList("Select",this.getSelected());}else if(!this.getSelected()){this.setSelected(true);this.informList("Select",true);}E.setMarked();};
k.prototype.onsapenter=function(E){var o=this.getList();if(E.isMarked()||!o){return;}if(E.srcControl!==this&&o.getKeyboardMode()==g.Edit){o.setKeyboardMode(g.Navigation);this._switchFocus(E);return;}if(E.srcControl!==this){return;}if(this.isIncludedIntoSelection()){this.onsapspace(E);}else if(this.hasActiveType()){E.setMarked();this.setActive(true);setTimeout(function(){this.setActive(false);}.bind(this),180);setTimeout(function(){this.fireTap();this.firePress();}.bind(this),0);}o.onItemPress(this,E.srcControl);};
k.prototype.onsapdelete=function(E){if(E.isMarked()||E.srcControl!==this||this.getMode()!=h.Delete){return;}this.informList("Delete");E.preventDefault();E.setMarked();};
k.prototype._switchFocus=function(E){var o=this.getList();if(!o){return;}var t=this.getTabbables();if(E.srcControl!==this){o._iLastFocusPosOfItem=t.index(E.target);this.focus();}else if(t.length){var F=o._iLastFocusPosOfItem||0;F=t[F]?F:-1;t.eq(F).trigger("focus");}E.preventDefault();E.setMarked();};
k.prototype.onkeydown=function(E){if(E.isMarked()){return;}if(E.which==K.F7){this._switchFocus(E);return;}if(E.which==K.F2){if(E.srcControl===this&&this.getType().indexOf("Detail")==0&&this.hasListeners("detailPress")||this.hasListeners("detailTap")){this.fireDetailTap();this.fireDetailPress();E.preventDefault();E.setMarked();}else{var o=this.getList();if(o){this.$().prop("tabIndex",-1);o.setKeyboardMode(o.getKeyboardMode()==g.Edit?g.Navigation:g.Edit);this._switchFocus(E);}}}if(E.srcControl!==this){return;}this.informList("KeyDown",E);};
k.prototype.onkeyup=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("KeyUp",E);};
k.prototype.onsapupmodifiers=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("UpDownModifiers",E,-1);};
k.prototype.onsapdownmodifiers=function(E){if(E.isMarked()||E.srcControl!==this){return;}this.informList("UpDownModifiers",E,1);};
k.prototype.getTabbables=function(){return this.$().find(":sapTabbable");};
k.prototype.onsaptabnext=function(E){var o=this.getList();if(!o||E.isMarked()||o.getKeyboardMode()==g.Edit){return;}var m=this.getTabbables().get(-1)||this.getDomRef();if(E.target===m){o.forwardTab(true);E.setMarked();}};
k.prototype.onsaptabprevious=function(E){var o=this.getList();if(!o||E.isMarked()||o.getKeyboardMode()==g.Edit){return;}if(E.target===this.getDomRef()){o.forwardTab(false);E.setMarked();}};
k.prototype.onfocusin=function(E){var o=this.getList();if(!o||E.isMarked()){return;}this.informList("FocusIn",E.srcControl);if(E.srcControl===this){return;}if(o.getKeyboardMode()==g.Edit||!q(E.target).is(":sapFocusable")){return;}setTimeout(o["setItemFocusable"].bind(o,this),0);E.setMarked();};
k.prototype.onsapup=function(E){if(E.isMarked()||E.srcControl===this||this.getListProperty("keyboardMode")===g.Navigation){return;}this.informList("ArrowUpDown",E);};
k.prototype.oncontextmenu=function(E){if(this._bGroupHeader){return;}if(q(document.activeElement).is(":focusable")&&document.activeElement!==this.getDomRef()&&E.srcControl!==this.getModeControl()){return;}this.informList("ContextMenu",E);};
k.prototype.onsapdown=k.prototype.onsapup;return k;});
sap.ui.predefine('sap/m/ListItemBaseRenderer',["./library","sap/ui/core/Core","sap/ui/Device","sap/ui/core/InvisibleText","sap/ui/core/InvisibleRenderer"],function(l,C,D,I,a){"use strict";var L=l.ListType;var b=l.ListMode;var c={apiVersion:2};
c.renderInvisible=function(r,o){a.render(r,o,o.TagName);};
c.renderHighlight=function(r,o){var h=o.getHighlight();if(h=="None"){return;}r.openStart("div");r.class("sapMLIBHighlight");r.class("sapMLIBHighlight"+h);r.openEnd();r.close("div");};
c.isModeMatched=function(m,o){var O=(sap.ui.require("sap/m/ListBaseRenderer")||{}).ModeOrder||{};return O[m]==o;};
c.renderMode=function(r,o,O){var m=o.getMode();if(!this.isModeMatched(m,O)){return;}var M=o.getModeControl(true);if(M){this.renderModeContent(r,o,M);}};
c.renderModeContent=function(r,o,m){this.decorateMode(m,o);r.renderControl(m);};
c.decorateMode=function(m,o){m.removeStyleClass("sapMLIBSelectAnimation sapMLIBUnselectAnimation");if(!C.getConfiguration().getAnimation()||!o.getListProperty("modeAnimationOn")){return;}var M=o.getMode(),s=o.getListProperty("lastMode");if(!s||s==M){return;}if(M==b.None){m.addStyleClass("sapMLIBUnselectAnimation");}else{m.addStyleClass("sapMLIBSelectAnimation");}};
c.renderCounter=function(r,o){var i=o.getCounter();if(i){this.renderCounterContent(r,o,i);}};
c.renderCounterContent=function(r,o,i){r.openStart("div",o.getId()+"-counter");r.attr("aria-label",C.getLibraryResourceBundle("sap.m").getText("LIST_ITEM_COUNTER",i));r.class("sapMLIBCounter");r.openEnd();r.text(i);r.close("div");};
c.renderType=function(r,o){var t=o.getTypeControl(true);if(t){r.renderControl(t);}};
c.openItemTag=function(r,o){r.openStart(o.TagName,o);};
c.closeItemTag=function(r,o){r.close(o.TagName);};
c.renderTabIndex=function(r,o){r.attr("tabindex","-1");};
c.renderTooltip=function(r,o){var t=o.getTooltip_AsString();if(t){r.attr("title",t);}};
c.addFocusableClasses=function(r,o){if(D.system.desktop){r.class("sapMLIBFocusable");this.addLegacyOutlineClass(r,o);}};
c.addLegacyOutlineClass=function(r,o){if(D.browser.msie||D.browser.edge){r.class("sapMLIBLegacyOutline");}};
c.getAriaAnnouncement=function(k,B){return I.getStaticId("sap.m",B||"LIST_ITEM_"+k.toUpperCase());};
c.getAriaRole=function(o){return"option";};
c.getAriaLabelledBy=function(o){if(!o.getContentAnnouncement&&o.getAriaLabelledBy().length){return o.getId();}};
c.getAriaDescribedBy=function(o){if(o.getContentAnnouncement){return"";}var d=[],t=o.getType();if(o.getListProperty("showUnread")&&o.getUnread()){d.push(this.getAriaAnnouncement("unread"));}if(o.getMode()==b.Delete){d.push(this.getAriaAnnouncement("delete"));}if(t==L.Navigation){d.push(this.getAriaAnnouncement("navigation"));}else{if(t==L.Detail||t==L.DetailAndActive){d.push(this.getAriaAnnouncement("detail"));}if(t==L.Active||t==L.DetailAndActive){d.push(this.getAriaAnnouncement("active"));}}return d.join(" ");};
c.getAccessibilityState=function(o){var A=this.getAriaLabelledBy(o),s=this.getAriaDescribedBy(o),m={role:this.getAriaRole(o)};if(o.isSelectable()){m.selected=o.getProperty("selected");}if(A){m.labelledby={value:A.trim(),append:true};}if(s){m.describedby={value:s.trim(),append:true};}return m;};
c.renderLIContent=function(r,o){};
c.renderLIAttributes=function(r,o){};
c.renderContentFormer=function(r,o){this.renderHighlight(r,o);this.renderMode(r,o,-1);};
c.renderContentLatter=function(r,o){this.renderCounter(r,o);this.renderType(r,o);this.renderMode(r,o,1);this.renderNavigated(r,o);};
c.renderLIContentWrapper=function(r,o){r.openStart("div",o.getId()+"-content").class("sapMLIBContent").openEnd();this.renderLIContent(r,o);r.close("div");};
c.renderNavigated=function(r,o){if(!o.getNavigated()){return;}r.openStart("div");r.class("sapMLIBNavigated");r.openEnd();r.close("div");};
c.render=function(r,o){if(!o.getVisible()){this.renderInvisible(r,o);return false;}this.openItemTag(r,o);r.class("sapMLIB");r.class("sapMLIB-CTX");r.class("sapMLIBShowSeparator");r.class("sapMLIBType"+o.getType());if(D.system.desktop&&o.isActionable()){r.class("sapMLIBActionable");r.class("sapMLIBHoverable");}if(o.getSelected()){r.class("sapMLIBSelected");}if(o.getListProperty("showUnread")&&o.getUnread()){r.class("sapMLIBUnread");}this.addFocusableClasses(r,o);this.renderTooltip(r,o);this.renderTabIndex(r,o);if(C.getConfiguration().getAccessibility()){r.accessibilityState(o,this.getAccessibilityState(o));}this.renderLIAttributes(r,o);r.openEnd();this.renderContentFormer(r,o);this.renderLIContentWrapper(r,o);this.renderContentLatter(r,o);this.closeItemTag(r,o);};
return c;},true);
sap.ui.predefine('sap/m/ListRenderer',["sap/ui/core/Renderer","./ListBaseRenderer"],function(R,L){"use strict";var a=R.extend(L);a.apiVersion=2;
a.getNoDataAriaRole=function(){return"option";};
return a;},true);
sap.ui.predefine('sap/m/MaskEnabler',['sap/ui/core/Control','./InputBase','sap/ui/Device','sap/ui/core/library',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/thirdparty/jquery","sap/m/MaskInputRule","sap/ui/dom/jquery/cursorPos"],function(C,I,D,c,K,L,q,M){"use strict";var T=c.TextDirection;var a=function(){var E='^';this.init=a.init=function(){I.prototype.init.call(this);this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;this._setDefaultRules();this._setupMaskVariables();};this.exit=a.exit=function(){this._iCaretTimeoutId=null;this._iUserInputStartPosition=null;this._iMaskLength=null;this._sOldInputValue=null;this._oRules=null;this._oTempValue=null;this._bSkipSetupMaskVariables=null;};this.onBeforeRendering=function(){if(this._isMaskEnabled()){var v=this._validateDependencies();if(v){L.warning("Invalid mask input: "+v);}}I.prototype.onBeforeRendering.apply(this,arguments);};this.onAfterRendering=function(){I.prototype.onAfterRendering.apply(this,arguments);};this.onfocusin=a.onfocusin=function(e){this._sOldInputValue=this._getInputValue();I.prototype.onfocusin.apply(this,arguments);if(this._isMaskEnabled()){if(!this._oTempValue.differsFromOriginal()||!this._isValidInput(this._sOldInputValue)){this._applyMask();}this._positionCaret(true);}};this.onfocusout=function(e){if(this._isMaskEnabled()){this.bFocusoutDueRendering=this.bRenderingPhase;this.removeStyleClass("sapMFocus");q(document).off('.sapMIBtouchstart');if(this.bRenderingPhase){return;}this.closeValueStateMessage();this._inputCompletedHandler();}else{this._inputCompletedHandlerNoMask();I.prototype.onfocusout.apply(this,arguments);}};this.oninput=function(e){if(this._isChromeOnAndroid()){this._onInputForAndroidHandler(e);return;}I.prototype.oninput.apply(this,arguments);if(this._isMaskEnabled()){this._applyMask();this._positionCaret(false);}};this.onkeypress=function(e){if(this._isMaskEnabled()){this._keyPressHandler(e);}};this.onkeydown=a.onkeydown=function(e){if(this._isMaskEnabled()){var k=this._parseKeyBoardEvent(e);I.prototype.onkeydown.apply(this,arguments);this._keyDownHandler(e,k);}else{var k=this._parseKeyBoardEvent(e);if(k.bEnter){this._inputCompletedHandlerNoMask();}I.prototype.onkeydown.apply(this,arguments);}};this.onsapenter=function(e){};this.onsapfocusleave=function(e){};this.setValue=a.setValue=function(v){v=this.validateProperty('value',v);I.prototype.setValue.call(this,v);this._sOldInputValue=v;if(this._isMaskEnabled()){if(!this._oTempValue){this._setupMaskVariables();}if(this._oTempValue._aInitial.join('')!==v){this._applyRules(v);}}return this;};this.addAggregation=function(A,o,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.addAggregation.apply(this,arguments);if(!this._bSkipSetupMaskVariables){this._setupMaskVariables();}return this;}return C.prototype.addAggregation.apply(this,arguments);};this.insertAggregation=function(A,o,i,s){if(A==="rules"){if(!this._validateRegexAgainstPlaceHolderSymbol(o)){return this;}this._removeRuleWithSymbol(o.getMaskFormatSymbol());C.prototype.insertAggregation.apply(this,arguments);this._setupMaskVariables();return this;}return C.prototype.insertAggregation.apply(this,arguments);};this._validateRegexAgainstPlaceHolderSymbol=function(r){if(new RegExp(r.getRegex()).test(this.getPlaceholderSymbol())){L.error("Rejecting input mask rule because it includes the currently set placeholder symbol.");return false;}return true;};this.setPlaceholderSymbol=function(s){var S;if(!/^.$/i.test(s)){L.error("Invalid placeholder symbol string given");return this;}S=this.getRules().some(function(r){return new RegExp(r.getRegex()).test(s);});if(S){L.error("Rejecting placeholder symbol because it is included as a regex in an existing mask input rule.");}else{this.setProperty("placeholderSymbol",s);this._setupMaskVariables();}return this;};this.setMask=function(m){if(!m){var e="Setting an empty mask is pointless. Make sure you set it with a non-empty value.";L.warning(e);return this;}this.setProperty("mask",m,true);this._setupMaskVariables();return this;};this._isCharAllowed=function(s,i){return this._oRules.applyCharAt(s,i);};this._feedReplaceChar=function(s,p,e){return s;};this._inputCompletedHandlerNoMask=function(){var v=this._getInputValue();if(this._sOldInputValue!==v){I.prototype.setValue.call(this,this._getAlteredUserInputValue?this._getAlteredUserInputValue(v):v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};var b=function(e){this._aInitial=e.slice(0);this._aContent=e;};b.prototype.setCharAt=function(s,p){this._aContent[p]=s;};b.prototype.charAt=function(p){return this._aContent[p];};b.prototype.toString=function(){return this._aContent.join('');};b.prototype.differsFromOriginal=function(){return this.differsFrom(this._aInitial);};b.prototype.differsFrom=function(v){var i=0;if(v.length!==this._aContent.length){return true;}for(;i<v.length;i++){if(v[i]!==this._aContent[i]){return true;}}return false;};b.prototype.getSize=function(){return this._aContent.length;};var d=function(r){this._aRules=r;};d.prototype.nextTo=function(i){if(typeof i==="undefined"){i=-1;}do{i++;}while(i<this._aRules.length&&!this._aRules[i]);return i;};d.prototype.previousTo=function(i){do{i--;}while(!this._aRules[i]&&i>0);return i;};d.prototype.hasRuleAt=function(i){return!!this._aRules[i];};d.prototype.applyCharAt=function(s,i){return this._aRules[i].test(s);};this._setDefaultRules=function(){this._bSkipSetupMaskVariables=true;this.addRule(new M({maskFormatSymbol:"a",regex:"[A-Za-z]"}),true);this.addRule(new M({maskFormatSymbol:"9",regex:"[0-9]"}),true);this._bSkipSetupMaskVariables=false;};this._validateDependencies=function(){var p=this.getPlaceholderSymbol(),r=this.getRules(),m=[],e=[];if(!this.getMask()){e.push("Empty mask");}if(r.length){m=[];r.every(function(R){var s=R.getMaskFormatSymbol(),f=s!==p,g;g=!m.some(function(S){return s===S;});m.push(s);if(!f){e.push("Placeholder symbol is the  same as the existing rule's mask format symbol");}if(!g){e.push("Duplicated rule's maskFormatSymbol ["+s+"]");}return f&&g;});}return e.length?e.join(". "):null;};this._removeRuleWithSymbol=function(s){var S=this._findRuleBySymbol(s,this.getRules());if(S){this.removeAggregation('rules',S.oRule);S.oRule.destroy();}};this._findRuleBySymbol=function(m,r){var R=null;if(typeof m!=="string"||m.length!==1){L.error(m+" is not a valid mask rule symbol");return null;}q.each(r,function(i,o){if(o.getMaskFormatSymbol()===m){R={oRule:o,iIndex:i};return false;}});return R;};this._getTextSelection=function(){var _=q(this.getFocusDomRef());if(!_&&(_.length===0||_.is(":hidden"))){return{};}return{iFrom:_[0].selectionStart,iTo:_[0].selectionEnd,bHasSelection:(_[0].selectionEnd-_[0].selectionStart!==0)};};this._setCursorPosition=function(p){if(p<0){p=0;}q(this.getFocusDomRef()).cursorPos(p);return this;};this._getCursorPosition=function(){return q(this.getFocusDomRef()).cursorPos();};this._setupMaskVariables=function(){var r=this.getRules(),m=this.getMask(),s=this._getSkipIndexes(m),e=this._getMaskArray(m,s),p=this.getPlaceholderSymbol(),i=this._buildMaskValueArray(e,p,r,s),t=this._buildRules(e,r,s);this._oTempValue=new b(i);this._iMaskLength=t.length;this._oRules=new d(t);this._iUserInputStartPosition=this._oRules.nextTo();};this._getMaskArray=function(m,s){var l=Array.isArray(s)?s.length:0,e=(m)?m.split(""):[],i;for(i=0;i<l;i++){e.splice(s[i],1);}return e;};this._getSkipIndexes=function(m){var l=(m)?m.length:0,i,s=[],p=0,e=false;for(i=0;i<l;i++){if(m[i]===E&&!e){s.push(i-p);e=true;p++;}else{e=false;}}return s;};this._applyMask=function(){var m=this._getInputValue();if(!this.getEditable()){return;}this._applyAndUpdate(m);};this._resetTempValue=function(f,t){var i,p=this.getPlaceholderSymbol();if(typeof f==="undefined"||f===null){f=0;t=this._oTempValue.getSize()-1;}for(i=f;i<=t;i++){if(this._oRules.hasRuleAt(i)){this._oTempValue.setCharAt(p,i);}}};this._applyAndUpdate=function(m){this._applyRules(m);this.updateDomValue(this._oTempValue.toString());};this._findFirstPlaceholderPosition=function(){return this._oTempValue.toString().indexOf(this.getPlaceholderSymbol());};this._applyRules=function(i){var s,e=0,m,p=this.getPlaceholderSymbol(),f;if(this._oTempValue.toString()===i){return;}for(m=0;m<this._iMaskLength;m++){if(this._oRules.hasRuleAt(m)){this._oTempValue.setCharAt(p,m);f=false;if(i.length){do{s=i.charAt(e);e++;if(this._oRules.applyCharAt(s,m)){this._oTempValue.setCharAt(s,m);f=true;}}while(!f&&(e<i.length));}if(!f){this._resetTempValue(m+1,this._iMaskLength-1);break;}}else{if(this._oTempValue.charAt(m)===i.charAt(e)){e++;}}}};this._keyPressHandler=function(e,k){var s,p,f;if(!this.getEditable()){return;}k=k||this._parseKeyBoardEvent(e);if(k.bCtrlKey||k.bAltKey||k.bMetaKey||k.bBeforeSpace){return;}s=this._getTextSelection();if(!k.bEnter&&!k.bShiftLeftOrRightArrow&&!k.bHome&&!k.bEnd&&!(k.bShift&&k.bDelete)&&!(k.bCtrlKey&&k.bInsert)&&!(k.bShift&&k.bInsert)){if(s.bHasSelection){this._resetTempValue(s.iFrom,s.iTo-1);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,s.iFrom));}p=this._oRules.nextTo(s.iFrom-1);if(p<this._iMaskLength){f=this._feedReplaceChar(k.sChar,p,this._getInputValue());this._feedNextString(f,p);}e.preventDefault();}};this.oncut=function(e){var s=this._getTextSelection(),m=this._getMinBrowserDelay(),B=s.iFrom,i=s.iTo;I.prototype.oncut(e);if(!s.bHasSelection||!this._isMaskEnabled()){return;}i=i-1;this._resetTempValue(B,i);setTimeout(function updateDomAndCursor(v,p,o){this._oTempValue._aContent=o;this.updateDomValue(v);setTimeout(this._setCursorPosition.bind(this,p),m);}.bind(this,this._oTempValue.toString(),Math.max(this._iUserInputStartPosition,B),this._oTempValue._aContent.slice(0)),m);};this._keyDownHandler=function(e,k){var s,S,i,n,k=k||this._parseKeyBoardEvent(e);if(!this.getEditable()){return;}if(!k.bShift&&(k.bArrowRight||k.bArrowLeft)){i=this._getCursorPosition();S=this._getTextSelection();s=this._determineArrowKeyDirection(k,S);if(this._isRtlMode()&&S.bHasSelection){n=this._determineRtlCaretPositionFromSelection(s);}else{n=this._oRules[s](i);}if(this._isWebkitProblematicCase()){n=this._fixWebkitBorderPositions(n,s);}this._setCursorPosition(n);e.preventDefault();}else if(k.bEscape){this._applyAndUpdate(this._sOldInputValue);this._positionCaret(true);e.preventDefault();}else if(k.bEnter){this._inputCompletedHandler(e);}else if((k.bCtrlKey&&k.bInsert)||(k.bShift&&k.bInsert)){I.prototype.onkeydown.apply(this,arguments);}else if((!k.bShift&&k.bDelete)||k.bBackspace){this._revertKey(k);e.preventDefault();}else if(this._isChromeOnAndroid()){this._oKeyDownStateAndroid={sValue:this._oTempValue.toString(),iCursorPosition:this._getCursorPosition(),oSelection:this._getTextSelection()};}};this._revertKey=function(k,s){s=s||this._getTextSelection();var B=s.iFrom,e=s.iTo;if(!s.bHasSelection){if(k.bBackspace){B=this._oRules.previousTo(B);}}if(k.bBackspace||(k.bDelete&&s.bHasSelection)){e=e-1;}this._resetTempValue(B,e);this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(Math.max(this._iUserInputStartPosition,B));};this._feedNextString=function(n,p){var N,A=false,e=n.split(""),s;while(e.length){s=e.splice(0,1)[0];if(this._oRules.applyCharAt(s,p)){A=true;this._oTempValue.setCharAt(s,p);p=this._oRules.nextTo(p);}}if(A){N=p;this.updateDomValue(this._oTempValue.toString());this._setCursorPosition(N);}};this._inputCompletedHandler=function(){var n=this._getInputValue(),t,v,e,f;if(this._oTempValue.differsFrom(n)){this._applyAndUpdate(n);}t=this._oTempValue.differsFromOriginal();v=t?this._oTempValue.toString():"";e=!this._sOldInputValue||!this.getValue();f=!n;if(e&&(f||!t)){this.updateDomValue("");return;}if(this._sOldInputValue!==this._oTempValue.toString()){I.prototype.setValue.call(this,this._getAlteredUserInputValue?this._getAlteredUserInputValue(v):v);this._sOldInputValue=v;if(this.onChange&&!this.onChange({value:v})){this.fireChangeEvent(v);}}};this._buildMaskValueArray=function(m,p,r,s){return m.map(function(e,i){var n=s.indexOf(i)===-1,R=this._findRuleBySymbol(e,r);return(n&&R)?p:e;},this);};this._buildRules=function(m,r,s){var t=[],S,l=m.length,i=0;for(;i<l;i++){if(s.indexOf(i)===-1){S=this._findRuleBySymbol(m[i],r);t.push(S?new RegExp(S.oRule.getRegex()):null);}else{t.push(null);}}return t;};this._parseKeyBoardEvent=function(e){var p=e.which||e.keyCode,k=K,A=p===k.ARROW_RIGHT,f=p===k.ARROW_LEFT,s=e.shiftKey;return{iCode:p,sChar:String.fromCharCode(p),bCtrlKey:e.ctrlKey,bAltKey:e.altKey,bMetaKey:e.metaKey,bShift:s,bInsert:p===K.INSERT,bBackspace:p===k.BACKSPACE,bDelete:p===k.DELETE,bEscape:p===k.ESCAPE,bEnter:p===k.ENTER,bIphoneEscape:(D.system.phone&&D.os.ios&&p===127),bArrowRight:A,bArrowLeft:f,bHome:p===K.HOME,bEnd:p===K.END,bShiftLeftOrRightArrow:s&&(f||A),bBeforeSpace:p<k.SPACE};};this._positionCaret=function(s){var m=this.getMask(),i=this._getMinBrowserDelay(),e;clearTimeout(this._iCaretTimeoutId);e=this._findFirstPlaceholderPosition();if(e<0){e=m.length;}this._iCaretTimeoutId=setTimeout(function(){if(this.getFocusDomRef()!==document.activeElement){return;}if(s&&(e===(m.length))){this.selectText(0,e);}else{this._setCursorPosition(e);}}.bind(this),i);};this._getMinBrowserDelay=function(){return!D.browser.msie?4:50;};this._isValidInput=function(s){var l=s.length,i=0,e;for(;i<l;i++){e=s[i];if(this._oRules.hasRuleAt(i)&&(!this._oRules.applyCharAt(e,i)&&e!==this.getPlaceholderSymbol())){return false;}if(!this._oRules.hasRuleAt(i)&&e!==this._oTempValue.charAt(i)){return false;}}return true;};this._isRtlChar=function(s){var l='A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02B8\u0300-\u0590\u0800-\u1FFF'+'\u2C00-\uFB1C\uFDFE-\uFE6F\uFEFD-\uFFFF',r='\u0591-\u07FF\uFB1D-\uFDFD\uFE70-\uFEFC',e=new RegExp('^[^'+l+']*['+r+']');return e.test(s);};this._fixWebkitBorderPositions=function(i,s){var t=this._oTempValue.toString().length;if(s==='nextTo'){if(i===0||i===t||i===1){i=0;}else if(i===t+1){i=1;}}else{if(i===0||i===t-1){i=t;}else if(i===-1||i===t){i=t-1;}}return i;};this._containsRtlChars=function(){var t=this._oTempValue.toString(),e=false;for(var i=0;i<t.length;i++){e=this._isRtlChar(t[i]);}return e;};this._isRtlMode=function(){return sap.ui.getCore().getConfiguration().getRTL()||(this.getTextDirection()===T.RTL);};this._isWebkitProblematicCase=function(){return D.browser.webkit&&this._isRtlMode()&&!this._containsRtlChars();};this._determineArrowKeyDirection=function(k,s){var e;if(!this._isRtlMode()||!this._containsRtlChars()||s.bHasSelection){if(k.bArrowRight){e='nextTo';}else{e='previousTo';}}else{if(k.bArrowRight){e='previousTo';}else{e='nextTo';}}return e;};this._determineRtlCaretPositionFromSelection=function(s,w){var n,S=this._getTextSelection();if(w){if(s==='nextTo'){if(!this._containsRtlChars()){n=S.iFrom;}else{n=S.iTo;}}else{if(!this._containsRtlChars()){n=S.iTo;}else{n=S.iFrom;}}}else{if(s==='nextTo'){if(!this._containsRtlChars()){n=S.iTo;}else{n=S.iFrom;}}else{if(!this._containsRtlChars()){n=S.iFrom;}else{n=S.iTo;}}}return n;};this._onInputForAndroidHandler=function(e){var k;if(!this._oKeyDownStateAndroid){return;}k=this._buildKeyboardEventInfo(this._oKeyDownStateAndroid.sValue,this._getInputValue(),this._oKeyDownStateAndroid.oSelection);this.updateDomValue(this._oKeyDownStateAndroid.sValue);setTimeout(function(i,o,f){this._setCursorPosition(o.iCursorPosition);if(f.bBackspace){this._revertKey(f,o.oSelection);if(o.oSelection.bHasSelection&&f.sChar){this._keyPressHandler(i,f);}}else{this._keyPressHandler(i,f);}}.bind(this,e,this._oKeyDownStateAndroid,k),0);delete this._oKeyDownStateAndroid;e.preventDefault();};this._buildKeyboardEventInfo=function(o,n,O){var N="",i,r={},e;if(!o&&!n){return{};}if(o&&n&&n.length<o.length){r.bBackspace=true;}for(i=0;i<n.length;i++){e=O.bHasSelection&&O.iFrom===i;if(e||o[i]!==n[i]){N=n[i];break;}}r.sChar=N;return r;};this._isChromeOnAndroid=function(){return D.browser.chrome&&D.os.android;};};return a;},true);
sap.ui.predefine('sap/m/MaskInput',['./InputBase','./MaskEnabler','./MaskInputRenderer'],function(I,M,a){"use strict";
var b=I.extend("sap.m.MaskInput",{metadata:{library:"sap.m",properties:{placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"}},dnd:{draggable:false,droppable:true}}});
M.call(b.prototype);
b.prototype._isMaskEnabled=function(){return true;};
return b;});
sap.ui.predefine('sap/m/MaskInputRenderer',['sap/ui/core/Renderer','./InputBaseRenderer'],function(R,I){"use strict";var M=R.extend(I);M.apiVersion=2;
M.getLabelledByAnnouncement=function(c){var m=c.getMask(),p=c.getPlaceholder()||"",r,s,a="";if(m&&m.length){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");s=r.getText("MASKINPUT_SCREENREADER_TAG");if(p){p=" "+p+" ";}a=s+p;return a;}return I.getLabelledByAnnouncement.apply(this,arguments);};
M.getDescribedByAnnouncement=function(c){var m=c.getMask(),s=c.getPlaceholderSymbol(),r,a="";if(m.length&&s){r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a=r.getText("MASKINPUT_SCREENREADER_DESCRIPTION",[s,m]);return a.trim();}return I.getDescribedByAnnouncement.apply(this,arguments);};
return M;},true);
sap.ui.predefine('sap/m/MaskInputRule',['sap/ui/core/Element',"sap/base/Log"],function(E,L){"use strict";
var M=E.extend("sap.m.MaskInputRule",{metadata:{library:"sap.m",properties:{maskFormatSymbol:{type:"string",group:"Misc",defaultValue:"*"},regex:{type:"string",group:"Misc",defaultValue:"[a-zA-Z0-9]"}}}});
M.prototype.setMaskFormatSymbol=function(n){var i=v.call(this,n);if(i){this.setProperty("maskFormatSymbol",n);}return this;};
M.prototype.setRegex=function(n){var i=a.call(this,n);if(i){this.setProperty("regex",n);}return this;};
M.prototype.toString=function(){return this.getMaskFormatSymbol()+":"+this.getRegex();};
function v(n){if(/^.$/i.test(n)){return true;}L.error("The mask format symbol '"+n+"' is not valid");return false;}
function a(r){if(/.+/i.test(r)){return true;}L.error("The regex value '"+r+"' is not valid");return false;}
return M;});
sap.ui.predefine('sap/m/MenuButton',['./library','sap/ui/core/Control','./Button','./SplitButton','sap/ui/Device','sap/ui/core/EnabledPropagator','sap/ui/core/library','sap/ui/core/Popup','sap/ui/core/LabelEnablement',"./MenuButtonRenderer","sap/ui/events/KeyCodes"],function(l,C,B,S,D,E,c,P,L,M,K){"use strict";var a=l.MenuButtonMode;var T=c.TextDirection;var b=l.ButtonType;var d=P.Dock;var n=["buttonMode","useDefaultActionOnly","width","menuPosition"];
var e=C.extend("sap.m.MenuButton",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:b.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},buttonMode:{type:"sap.m.MenuButtonMode",group:"Misc",defaultValue:a.Regular},menuPosition:{type:"sap.ui.core.Popup.Dock",group:"Misc",defaultValue:d.BeginBottom},useDefaultActionOnly:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{menu:{type:"sap.m.Menu",multiple:false,singularName:"menu"},_button:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{defaultAction:{}},defaultAggregation:"menu",designtime:"sap/m/designtime/MenuButton.designtime",dnd:{draggable:true,droppable:false}}});
E.call(e.prototype);
e.prototype.init=function(){this._initButtonControl();};
e.prototype.exit=function(){if(this._sDefaultText){this._sDefaultText=null;}if(this._sDefaultIcon){this._sDefaultIcon=null;}if(this._iInitialTextBtnContentWidth){this._iInitialTextBtnContentWidth=null;}if(this._lastActionItemId){this._lastActionItemId=null;}if(this.getMenu()){this.getMenu().detachClosed(this._menuClosed,this);}};
e.prototype.onBeforeRendering=function(){if(!this._sDefaultText){this._sDefaultText=this.getText();}if(!this._sDefaultIcon){this._sDefaultIcon=this.getIcon();}this._updateButtonControl();this._attachMenuEvents();};
e.prototype._needsWidth=function(){return this._isSplitButton()&&this.getWidth()==="";};
e.prototype._getTextBtnContentDomRef=function(){return this._getButtonControl()._getTextButton().getDomRef("content");};
e.prototype.onAfterRendering=function(){if(this._needsWidth()&&sap.ui.getCore().isThemeApplied()&&this._getTextBtnContentDomRef()&&this._getInitialTextBtnWidth()>0){this._getTextBtnContentDomRef().style.width=this._getInitialTextBtnWidth()+'px';}this._setAriaHasPopup();};
e.prototype.onThemeChanged=function(o){if(this._needsWidth()&&this.getDomRef()&&!this._iInitialTextBtnContentWidth&&this._getTextBtnContentDomRef()&&this._getInitialTextBtnWidth()>0){this._getTextBtnContentDomRef().style.width=this._getInitialTextBtnWidth()+'px';}};
e.prototype._getInitialTextBtnWidth=function(){if(!this._iInitialTextBtnContentWidth){this._iInitialTextBtnContentWidth=Math.ceil(this._getTextBtnContentDomRef().getBoundingClientRect().width);}return this._iInitialTextBtnContentWidth;};
e.prototype._setAriaHasPopup=function(){var o=this._getButtonControl(),O=this._isSplitButton()?o._getArrowButton():o;O.$().attr("aria-haspopup","menu");};
e.prototype.setButtonMode=function(m){var t=this.getTooltip();C.prototype.setProperty.call(this,"buttonMode",m,true);this._getButtonControl().destroy();this._initButtonControl();for(var k in this.mProperties){if(this.mProperties.hasOwnProperty(k)&&n.indexOf(k)<0){this._getButtonControl().setProperty(k,this.mProperties[k],true);}}if(t){this._getButtonControl().setTooltip(t);}if(!this._isSplitButton()&&this._sDefaultText){this.setText(this._sDefaultText);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setText(sap.ui.getCore().byId(this._getLastSelectedItem()).getText());}if(!this._isSplitButton()&&this._sDefaultIcon){this.setIcon(this._sDefaultIcon);}else if(!this.getUseDefaultActionOnly()&&this._getLastSelectedItem()){this.setIcon(sap.ui.getCore().byId(this._getLastSelectedItem()).getIcon());}this.invalidate();return this;};
e.prototype._initButton=function(){var o=new B(this.getId()+"-internalBtn",{width:"100%"});o.attachPress(this._handleButtonPress,this);return o;};
e.prototype._initSplitButton=function(){var o=new S(this.getId()+"-internalSplitBtn",{width:"100%"});o.attachPress(this._handleActionPress,this);o.attachArrowPress(this._handleButtonPress,this);return o;};
e.prototype._initButtonControl=function(){var o;if(this._isSplitButton()){o=this._initSplitButton();}else{o=this._initButton();}this.setAggregation("_button",o,true);};
e.prototype._updateButtonControl=function(){this._getButtonControl().setText(this.getText());};
e.prototype._getButtonControl=function(){return this.getAggregation("_button");};
e.prototype._handleButtonPress=function(w){var m=this.getMenu(),o={zero:"0 0",plus2_right:"0 +2",minus2_right:"0 -2",plus2_left:"+2 0",minus2_left:"-2 0"};if(!m){return;}if(this._bPopupOpen){this.getMenu().close();this._bPopupOpen=false;return;}if(!m.getTitle()){m.setTitle(this.getText());}var p=[this,w];switch(this.getMenuPosition()){case d.BeginTop:p.push(d.BeginBottom,d.BeginTop,o.plus2_right);break;case d.BeginCenter:p.push(d.BeginCenter,d.BeginCenter,o.zero);break;case d.LeftTop:p.push(d.RightBottom,d.LeftBottom,o.plus2_left);break;case d.LeftCenter:p.push(d.RightCenter,d.LeftCenter,o.plus2_left);break;case d.LeftBottom:p.push(d.RightTop,d.LeftTop,o.plus2_left);break;case d.CenterTop:p.push(d.CenterBottom,d.CenterTop,o.plus2_left);break;case d.CenterCenter:p.push(d.CenterCenter,d.CenterCenter,o.zero);break;case d.CenterBottom:p.push(d.CenterTop,d.CenterBottom,o.minus2_right);break;case d.RightTop:p.push(d.LeftBottom,d.RightBottom,o.minus2_left);break;case d.RightCenter:p.push(d.LeftCenter,d.RightCenter,o.minus2_left);break;case d.RightBottom:p.push(d.LeftTop,d.RightTop,o.minus2_left);break;case d.EndTop:p.push(d.EndBottom,d.EndTop,o.plus2_right);break;case d.EndCenter:p.push(d.EndCenter,d.EndCenter,o.zero);break;case d.EndBottom:p.push(d.EndTop,d.EndBottom,o.minus2_right);break;default:case d.BeginBottom:p.push(d.BeginTop,d.BeginBottom,o.minus2_right);break;}m.openBy.apply(m,p);if(this.getMenu()){this._bPopupOpen=true;}this._writeAriaAttributes();if(this._isSplitButton()&&!D.system.phone){this._getButtonControl().setArrowState(true);}};
e.prototype._handleActionPress=function(){var s=this._getLastSelectedItem(),o;if(!this.getUseDefaultActionOnly()&&s){o=sap.ui.getCore().byId(s);this.getMenu().fireItemSelected({item:o});}else{this.fireDefaultAction();}};
e.prototype._menuClosed=function(){var o=this._getButtonControl(),O=o;this._bPopupOpen=false;if(this._isSplitButton()){o.setArrowState(false);O=o._getArrowButton();}O.$().removeAttr("aria-controls");};
e.prototype._menuItemSelected=function(o){var m=o.getParameter("item");this.fireEvent("_menuItemSelected",{item:m});this._bPopupOpen=false;if(!this._isSplitButton()||this.getUseDefaultActionOnly()||!m){return;}this._lastActionItemId=m.getId();!!this._sDefaultText&&this.setText(m.getText());!!this._sDefaultIcon&&this.setIcon(m.getIcon());};
e.prototype._getLastSelectedItem=function(){return this._lastActionItemId;};
e.prototype._attachMenuEvents=function(){if(this.getMenu()){this.getMenu().attachClosed(this._menuClosed,this);this.getMenu().attachItemSelected(this._menuItemSelected,this);}};
e.prototype._isSplitButton=function(){return this.getButtonMode()===a.Split;};
e.prototype.setProperty=function(p,v,s){function i(t){var f=[b.Up,b.Back,b.Unstyled];return f.indexOf(t)!==-1;}if(p==="type"&&i(v)){return this;}if(p==='text'){this._sDefaultText=v;}switch(p){case'activeIcon':case'iconDensityAware':case'textDirection':case'visible':case'enabled':this._getButtonControl().setProperty(p,v);break;}return C.prototype.setProperty.apply(this,arguments);};
e.prototype.setTooltip=function(t){this._getButtonControl().setTooltip(t);return C.prototype.setTooltip.apply(this,arguments);};
e.prototype.setText=function(v){B.prototype.setProperty.call(this,'text',v);this._getButtonControl().setText(v);return this;};
e.prototype.setType=function(v){B.prototype.setProperty.call(this,'type',v);this._getButtonControl().setType(v);return this;};
e.prototype.setIcon=function(v){B.prototype.setProperty.call(this,'icon',v);this._getButtonControl().setIcon(v);return this;};
e.prototype.addAriaLabelledBy=function(A){this.getAggregation("_button").addAssociation("ariaLabelledBy",A);return C.prototype.addAssociation.call(this,"ariaLabelledBy",A);};
e.prototype.addAriaDescribedBy=function(A){this.getAggregation("_button").addAssociation("ariaDescribedBy",A);return C.prototype.addAssociation.call(this,"ariaDescribedBy",A);};
e.prototype.removeAriaLabelledBy=function(A){this.getAggregation("_button").removeAssociation("ariaLabelledBy",A);return C.prototype.removeAssociation.call(this,"ariaLabelledBy",A);};
e.prototype.removeAriaDescribedBy=function(A){this.getAggregation("_button").removeAssociation("ariaDescribedBy",A);return C.prototype.removeAssociation.call(this,"ariaDescribedBy",A);};
e.prototype.removeAllAriaLabelledBy=function(A){this.getAggregation("_button").removeAllAssociation("ariaLabelledBy");return C.prototype.removeAllAssociation.call(this,"ariaLabelledBy");};
e.prototype.removeAllAriaDescribedBy=function(){this.getAggregation("_button").removeAllAssociation("ariaDescribedBy");return C.prototype.removeAllAssociation.call(this,"ariaDescribedBy");};
e.prototype.getFocusDomRef=function(){return this._getButtonControl().getDomRef();};
e.prototype.onsapup=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapdown=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapupmodifiers=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapdownmodifiers=function(o){this.openMenuByKeyboard();o.stopPropagation();};
e.prototype.onsapshow=function(o){this.openMenuByKeyboard();!!o&&o.preventDefault();};
e.prototype.ontouchstart=function(){this._bPopupOpen=this.getMenu()&&this.getMenu()._getMenu()&&this.getMenu()._getMenu().getPopup().isOpen();};
e.prototype.onkeydown=function(o){if((o.keyCode===K.ENTER||o.keyCode===K.TAB)&&this._bPopupOpen){this.getMenu().close();this._bPopupOpen=false;}};
e.prototype.openMenuByKeyboard=function(){if(!this._isSplitButton()){this._handleButtonPress(true);}};
e.prototype._writeAriaAttributes=function(){var o=this._getButtonControl(),O=this._isSplitButton()?o._getArrowButton():o,m=this.getMenu();if(m){O.$().attr("aria-controls",m.getDomRefId());}};
e.prototype.getIdForLabel=function(){return this.getId()+"-internalBtn";};
e.prototype._ensureBackwardsReference=function(){var i=this._getButtonControl(),I=i.getAriaLabelledBy(),r=L.getReferencingLabels(this);r.forEach(function(s){if(I&&I.indexOf(s)===-1){i.addAriaLabelledBy(s);}});return this;};
return e;});
sap.ui.predefine('sap/m/MenuButtonRenderer',[],function(){"use strict";var M={apiVersion:2};M.CSS_CLASS="sapMMenuBtn";
M.render=function(r,m){var w=m.getWidth();r.openStart("div",m);r.class(M.CSS_CLASS).class(M.CSS_CLASS+m.getButtonMode());if(w!=""){r.style("width",w);}r.openEnd();m._ensureBackwardsReference();r.renderControl(m._getButtonControl());r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MenuItem',['./library','sap/ui/core/Item','sap/ui/base/ManagedObjectObserver'],function(l,I,M){"use strict";
var a=I.extend("sap.m.MenuItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{press:{},propertyChanged:{parameters:{propertyKey:{type:"string"},propertyValue:{type:"any"}}},aggregationChanged:{parameters:{aggregationName:{type:"String"},methodName:{type:"String"},methodParams:{type:"Object"}}}}}});
a.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';
a.prototype.exit=function(){if(this._sVisualChild){this._sVisualChild=null;}if(this._sVisualParent){this._sVisualParent=null;}if(this._sVisualControl){this._sVisualControl=null;}};
a.prototype.setProperty=function(p,P){I.prototype.setProperty.apply(this,arguments);this.fireEvent("propertyChanged",{propertyKey:p,propertyValue:P});};
a.prototype.setAggregation=function(A,o,s){I.prototype.setAggregation.apply(this,arguments);this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"set",methodParams:{item:o}});return this;};
a.prototype.addAggregation=function(A,o,s){var v=this._getVisualControl(),V;I.prototype.addAggregation.apply(this,arguments);if(A==='customData'&&v){V=sap.ui.getCore().byId(v);this._addCustomData(V,o);}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"add",methodParams:{item:o}});return this;};
a.prototype.insertAggregation=function(A,o,i,s){var v=this._getVisualControl(),V;I.prototype.insertAggregation.apply(this,arguments);if(A==='customData'&&v){V=sap.ui.getCore().byId(v);V.insertCustomData(o.clone(a.UNIFIED_MENU_ITEMS_ID_SUFFIX),i);this._observeCustomDataChanges(o);}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"insert",methodParams:{item:o,index:i}});return this;};
a.prototype.removeAggregation=function(A,o,s){var O=I.prototype.removeAggregation.apply(this,arguments);if(A==="customData"){if(this.getCustomData().length===1){this._disconnectAndDestroyCustomDataObserver();}else if(o&&this._oCustomDataObserver){this._oCustomDataObserver.unobserve(o,{properties:["value"]});}}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"remove",methodParams:{item:O}});return O;};
a.prototype.removeAllAggregation=function(A,s){var o=I.prototype.removeAllAggregation.apply(this,arguments);if(A==='customData'){this._disconnectAndDestroyCustomDataObserver();}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"removeall",methodParams:{items:o}});return o;};
a.prototype.destroyAggregation=function(A,s){if(A==='customData'){this._disconnectAndDestroyCustomDataObserver();}this.fireEvent("aggregationChanged",{aggregationName:A,methodName:"destroy"});return I.prototype.destroyAggregation.apply(this,arguments);};
a.prototype.destroy=function(){var v=sap.ui.getCore().byId(this._getVisualControl());if(v){v.destroy();}return I.prototype.destroy.apply(this,arguments);};
a.prototype._addCustomData=function(v,c){v.addCustomData(c.clone(a.UNIFIED_MENU_ITEMS_ID_SUFFIX,undefined,{bCloneChildren:false,bCloneBindings:true}));this._observeCustomDataChanges(c);};
a.prototype._observeCustomDataChanges=function(c){this._getCustomDataObserver().observe(c,{properties:["value"]});};
a.prototype._customDataObserverCallbackFunction=function(c){sap.ui.getCore().byId(c.object.getId()+"-"+a.UNIFIED_MENU_ITEMS_ID_SUFFIX).setValue(c.current);};
a.prototype._getCustomDataObserver=function(){if(!this._oCustomDataObserver){this._oCustomDataObserver=new M(this._customDataObserverCallbackFunction);}return this._oCustomDataObserver;};
a.prototype._disconnectAndDestroyCustomDataObserver=function(){if(this._oCustomDataObserver){this._oCustomDataObserver.disconnect();this._oCustomDataObserver.destroy();this._oCustomDataObserver=null;}};
a.prototype._setVisualChild=function(c){this._setInternalRef(c,"_sVisualChild");};
a.prototype._setVisualParent=function(c){this._setInternalRef(c,"_sVisualParent");};
a.prototype._setVisualControl=function(c){this._setInternalRef(c,"_sVisualControl");};
a.prototype._setInternalRef=function(c,i){if(!c||typeof c==="string"){this[i]=c;}else if(c.getId){this[i]=c.getId();}};
a.prototype._getVisualChild=function(){return this._sVisualChild;};
a.prototype._getVisualParent=function(){return this._sVisualParent;};
a.prototype._getVisualControl=function(){return this._sVisualControl;};
return a;});
sap.ui.predefine('sap/m/MenuListItem',['./ListItemBase','./library','sap/ui/core/IconPool','sap/ui/core/library','./MenuListItemRenderer'],function(L,l,I,c,M){"use strict";var T=c.TextDirection;
var a=L.extend("sap.m.MenuListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},startsSection:{type:"boolean",group:"Behavior",defaultValue:false}},associations:{menuItem:{type:"sap.m.MenuItem",multiple:false}}}});
a.prototype.exit=function(){if(this._image){this._image.destroy();}if(this._imageRightArrow){this._imageRightArrow.destroy();}L.prototype.exit.apply(this,arguments);};
a.prototype._getImage=function(i,s,S,b){var o=this._image;if(o){o.setSrc(S);if(o instanceof sap.m.Image){o.setDensityAware(b);}}else{o=I.createControlByURI({id:i,src:S,densityAware:b,useIconTooltip:false},sap.m.Image).setParent(this,null,true);}if(o instanceof sap.m.Image){o.addStyleClass(s,true);}else{o.addStyleClass(s+"Icon",true);}this._image=o;return this._image;};
a.prototype._getIconArrowRight=function(){if(!this._imageRightArrow){this._imageRightArrow=I.createControlByURI({id:this.getId()+"-arrowRight",src:"sap-icon://slim-arrow-right",useIconTooltip:false},sap.m.Image).setParent(this,null,true);this._imageRightArrow.addStyleClass("sapMMenuLIArrowRightIcon",true);}return this._imageRightArrow;};
a.prototype._hasSubItems=function(){return!!(this.getMenuItem()&&sap.ui.getCore().byId(this.getMenuItem()).getItems().length);};
return a;});
sap.ui.predefine('sap/m/MenuListItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library'],function(L,R,l,c){"use strict";var T=c.TextDirection;var a=l.ListType;var M=R.extend(L);M.apiVersion=2;
M.openItemTag=function(r,o){if(o.getStartsSection()){r.openStart("li");r.attr("role","separator");r.class("sapUiMnuDiv");r.openEnd();r.openStart("div");r.class("sapUiMnuDivL");r.openEnd();r.close("div");r.voidStart("hr").voidEnd();r.openStart("div");r.class("sapUiMnuDivR");r.openEnd();r.close("div");r.close("li");}L.openItemTag(r,o);};
M.renderLIAttributes=function(r,o){r.class("sapMSLI");if(o.getIcon()){r.class("sapMSLIIcon");}if(o.getType()==a.Detail||o.getType()==a.DetailAndActive){r.class("sapMSLIDetail");}if(o._hasSubItems()){r.class("sapMMenuLIHasChildren");}};
M.renderLIContent=function(r,o){var t=o.getTitleTextDirection();if(o.getIcon()){r.renderControl(o._getImage((o.getId()+"-img"),"sapMMenuLIImgThumb",o.getIcon(),o.getIconDensityAware()));}r.openStart("div");r.class("sapMSLIDiv");r.class("sapMSLITitleDiv");r.openEnd();if(o._bNoFlex){r.openStart("div");r.class("sapMLIBNoFlex");r.openEnd();}r.openStart("div");r.class("sapMSLITitleOnly");if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(o.getTitle());r.close("div");if(o._bNoFlex){r.close('div');}r.close("div");if(o._hasSubItems()){r.renderControl(o._getIconArrowRight());}};
return M;},true);
sap.ui.predefine('sap/m/MessageBox',['./Button','./Dialog','./Text','./FormattedText','./Link','./VBox','sap/ui/core/IconPool','sap/ui/core/ElementMetadata','sap/ui/core/library','sap/ui/core/Control','sap/m/library',"sap/ui/thirdparty/jquery",'sap/ui/core/theming/Parameters'],function(B,D,T,F,L,V,I,E,c,C,l,q,P){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var d=c.TextDirection;var e=l.ButtonType;var M={};M.Action={OK:"OK",CANCEL:"CANCEL",YES:"YES",NO:"NO",ABORT:"ABORT",RETRY:"RETRY",IGNORE:"IGNORE",CLOSE:"CLOSE",DELETE:"DELETE"};M.Icon={NONE:undefined,INFORMATION:"INFORMATION",WARNING:"WARNING",ERROR:"ERROR",SUCCESS:"SUCCESS",QUESTION:"QUESTION"};(function(){var A=M.Action,f=M.Icon;var _=function(){if(M._rb!==sap.ui.getCore().getLibraryResourceBundle("sap.m")){M._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}};
M.show=function(m,o){var g,h,v,r=null,j=[],i,s,t,k,n,p,u,w={id:E.uid("mbox"),initialFocus:null,textDirection:d.Inherit,verticalScrolling:true,horizontalScrolling:true,details:"",contentWidth:null},x=P.get("_sap_m_Message_Box_Information_Icon")==="true",S=x?"message-information":"hint",y={"INFORMATION":"sapMMessageBoxInfo","WARNING":"sapMMessageBoxWarning","ERROR":"sapMMessageBoxError","SUCCESS":"sapMMessageBoxSuccess","QUESTION":"sapMMessageBoxQuestion","STANDARD":"sapMMessageBoxStandard"},z={"INFORMATION":I.getIconURI(S),"WARNING":I.getIconURI("message-warning"),"ERROR":I.getIconURI("message-error"),"SUCCESS":I.getIconURI("message-success"),"QUESTION":I.getIconURI("question-mark")};_();if(typeof o==="string"||arguments.length>2){s=arguments[1];t=arguments[2];k=arguments[3];n=arguments[4];p=arguments[5];u=arguments[6];o={icon:s,title:t,actions:k,onClose:n,id:p,styleClass:u};}if(o&&o.hasOwnProperty("details")){w.icon=f.INFORMATION;w.emphasizedAction=A.OK;w.actions=[A.OK,A.CANCEL];o=q.extend({},w,o);}o=q.extend({},w,o);if(typeof o.actions!=="undefined"&&!Array.isArray(o.actions)){if(o.emphasizedAction!==null){o.emphasizedAction=o.actions;}o.actions=[o.actions];}if(!o.actions||o.actions.length===0){o.emphasizedAction=A.OK;o.actions=[A.OK];}function G(O,H){var Q;if(M.Action.hasOwnProperty(O)){Q=M._rb.getText("MSGBOX_"+O);}var R=new B({id:E.uid("mbox-btn-"),text:Q||O,type:H,press:function(){r=O;g.close();}});return R;}var H;for(i=0;i<o.actions.length;i++){H=o.emphasizedAction===o.actions[i]?e.Emphasized:e.Default;j.push(G(o.actions[i],H));}function J(o,h){var O,Q,R=new V({items:[h]});if(!o.details){return R;}if(typeof o.details=='object'){o.details="<pre>"+JSON.stringify(o.details,null,'\t').replace(/{/gi,"\\{")+"</pre>";}O=new F().setVisible(false).setHtmlText(o.details);Q=new L({text:M._rb.getText("MSGBOX_LINK_TITLE"),press:function(){var U=g.getInitialFocus();g.addAriaLabelledBy(O);O.setVisible(true);Q.setVisible(false);g._setInitialFocus();if(!U||U===Q.getId()){j[0].focus();}}});Q.addStyleClass("sapMMessageBoxLinkText");O.addStyleClass("sapMMessageBoxDetails");R.addItem(Q);R.addItem(O);return R;}function K(){if(typeof o.onClose==="function"){o.onClose(r);}g.detachAfterClose(K);g.destroy();}function N(){var i=0;var O=null;if(o.initialFocus){if(o.initialFocus instanceof C){O=o.initialFocus;}if(typeof o.initialFocus==="string"){for(i=0;i<j.length;i++){if(M.Action.hasOwnProperty(o.initialFocus)){if(M._rb.getText("MSGBOX_"+o.initialFocus).toLowerCase()===j[i].getText().toLowerCase()){O=j[i];break;}}else{if(o.initialFocus.toLowerCase()===j[i].getText().toLowerCase()){O=j[i];break;}}}}}return O;}if(typeof(m)==="string"){v=new T({textDirection:o.textDirection}).setText(m).addStyleClass("sapMMsgBoxText");h=v;}else if(m instanceof C){v=m.addStyleClass("sapMMsgBoxText");}if(o&&o.hasOwnProperty("details")&&o.details!==""){v=J(o,v);}g=new D({id:o.id,type:a.Message,title:o.title,content:v,icon:z[o.icon],initialFocus:N(),verticalScrolling:o.verticalScrolling,horizontalScrolling:o.horizontalScrolling,afterClose:K,buttons:j,ariaLabelledBy:h?h.getId():undefined,contentWidth:o.contentWidth,closeOnNavigation:o.closeOnNavigation}).addStyleClass("sapMMessageBox");g.setProperty("role",b.AlertDialog);if(y[o.icon]){g.addStyleClass(y[o.icon]);}else{g.addStyleClass(y.STANDARD);}if(o.styleClass){g.addStyleClass(o.styleClass);}g.open();};
M.alert=function(m,o){_();var g={icon:f.NONE,title:M._rb.getText("MSGBOX_TITLE_ALERT"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("alert"),initialFocus:null},h,t,s,S;if(typeof o==="function"||arguments.length>2){h=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:h,title:t,id:s,styleClass:S};}o=q.extend({},g,o);return M.show(m,o);};
M.confirm=function(m,o){_();var g={icon:f.QUESTION,title:M._rb.getText("MSGBOX_TITLE_CONFIRM"),emphasizedAction:o&&o.actions?null:A.OK,actions:[A.OK,A.CANCEL],id:E.uid("confirm"),initialFocus:null},h,t,s,S;if(typeof o==="function"||arguments.length>2){h=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:h,title:t,id:s,styleClass:S};}o=q.extend({},g,o);return M.show(m,o);};
M.error=function(m,o){_();var g={icon:f.ERROR,title:M._rb.getText("MSGBOX_TITLE_ERROR"),emphasizedAction:null,actions:A.CLOSE,id:E.uid("error"),initialFocus:null};o=q.extend({},g,o);return M.show(m,o);};
M.information=function(m,o){_();var g={icon:f.INFORMATION,title:M._rb.getText("MSGBOX_TITLE_INFO"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("info"),initialFocus:null};o=q.extend({},g,o);return M.show(m,o);};
M.warning=function(m,o){_();var g={icon:f.WARNING,title:M._rb.getText("MSGBOX_TITLE_WARNING"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("warning"),initialFocus:null};o=q.extend({},g,o);return M.show(m,o);};
M.success=function(m,o){_();var g={icon:f.SUCCESS,title:M._rb.getText("MSGBOX_TITLE_SUCCESS"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("success"),initialFocus:null};o=q.extend({},g,o);return M.show(m,o);};
}());return M;},true);
sap.ui.predefine('sap/m/MessageItem',["./library","sap/ui/core/Item","sap/ui/core/library","sap/base/Log","sap/base/security/sanitizeHTML"],function(l,I,c,L,s){"use strict";var M=c.MessageType;
var a=I.extend("sap.m.MessageItem",{metadata:{library:"sap.m",properties:{type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:M.Error},title:{type:"string",group:"Appearance",defaultValue:""},subtitle:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Appearance",defaultValue:""},markupDescription:{type:"boolean",group:"Appearance",defaultValue:false},longtextUrl:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},counter:{type:"int",group:"Misc",defaultValue:null},groupName:{type:"string",group:"Misc",defaultValue:""},activeTitle:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"}}}});
a.prototype.setProperty=function(p,v,S){var P=this.getParent(),t=this.getType().toLowerCase(),b=["description","type","groupName"],u=function(n,i){if(i._oMessagePopoverItem.getId()===this.getId()&&i.getMetadata().getProperty(n)){i.setProperty(n,v);}};if(b.indexOf(p)===-1&&P&&("_bItemsChanged"in P)&&!P._bItemsChanged){P._oLists&&P._oLists.all&&P._oLists.all.getItems&&P._oLists.all.getItems().forEach(u.bind(this,p));P._oLists&&P._oLists[t]&&P._oLists[t].getItems&&P._oLists[t].getItems().forEach(u.bind(this,p));}if(typeof this._updatePropertiesFn==="function"){this._updatePropertiesFn();}return I.prototype.setProperty.apply(this,arguments);};
a.prototype._updateProperties=function(b){this._updatePropertiesFn=b;};
a.prototype.setDescription=function(d){if(typeof d==='undefined'){d='';}if(this.getMarkupDescription()){d=s(d);}this.setProperty("description",d,true);return this;};
a.prototype.setType=function(t){if(t===M.None){t=M.Information;L.warning("The provided None type is handled and rendered as Information type");}return this.setProperty("type",t,true);};
return a;});
sap.ui.predefine('sap/m/MessageListItem',["sap/ui/core/library","sap/ui/core/InvisibleText","./library",'./StandardListItem','./Link',"./MessageListItemRenderer"],function(c,I,l,S,L,M){"use strict";var a=c.MessageType;
var b=S.extend("sap.m.MessageListItem",{metadata:{library:"sap.m",properties:{activeTitle:{type:"boolean",group:"Misc",defaultValue:false},messageType:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:a.Error}},aggregations:{link:{type:"sap.m.Link",group:"Misc",multiple:false},linkAriaDescribedBy:{type:"sap.ui.core.Control",group:"Misc",multiple:false}},events:{activeTitlePress:{}}}});
b.prototype.onBeforeRendering=function(){S.prototype.onBeforeRendering.apply(this,arguments);var o=this.getLink(),d;if(!o&&this.getActiveTitle()){o=new L({press:[this.fireActiveTitlePress,this]});this.setLink(o);}if(o&&!o.getAriaDescribedBy().length){d=this._getLinkAriaDescribedBy();o.setProperty("text",this.getTitle(),true);o.addAssociation('ariaDescribedBy',d.getId(),true);this.setAggregation("linkAriaDescribedBy",d,true);}};
b.prototype._getLinkAriaDescribedBy=function(){var A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("MESSAGE_VIEW_LINK_FOCUS_TEXT",[this.getMessageType()]);return new I(this.getId()+"-link",{text:A});};
b.prototype.onkeydown=function(e){if(this.getActiveTitle()&&e.altKey&&e.key==='Enter'){this.fireActiveTitlePress(this);}};
b.prototype.getContentAnnouncement=function(B){var A=S.prototype.getContentAnnouncement.apply(this,arguments),s,m;if(this.getActiveTitle()){m=B.getText("MESSAGEVIEW_BUTTON_TOOLTIP_"+this.getMessageType().toUpperCase());s=B.getText("MESSAGE_LIST_ITEM_FOCUS_TEXT",[m]);A+=" ".concat(s);}return A;};
return b;});
sap.ui.predefine('sap/m/MessageListItemRenderer',["./StandardListItemRenderer","sap/ui/core/Renderer"],function(S,R){"use strict";var M=R.extend(S);M.apiVersion=2;
M.renderTitle=function(r,c){if(c.getActiveTitle()){r.renderControl(c.getLink());r.renderControl(c.getLinkAriaDescribedBy());}else{S.renderTitle.apply(this,arguments);}};
return M;},true);
sap.ui.predefine('sap/m/MessagePage',['./library','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/base/ManagedObject','sap/m/Text','sap/m/Image','sap/m/Button','sap/m/Title','sap/m/Bar','sap/m/FormattedText','./MessagePageRenderer',"sap/ui/thirdparty/jquery"],function(l,c,C,I,M,T,a,B,b,d,F,e,q){"use strict";var f=c.TextAlign;var g=c.TextDirection;var h=l.ButtonType;var i=l.BarDesign;
var j=C.extend("sap.m.MessagePage",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:"No matching items found."},description:{type:"string",group:"Misc",defaultValue:"Check the filter settings."},title:{type:"string",group:"Misc",defaultValue:null},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://documents"},iconAlt:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{customText:{type:"sap.m.Link",multiple:false},customDescription:{type:"sap.m.Link",multiple:false},buttons:{type:"sap.m.Button",multiple:true},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_description:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{navButtonPress:{}},designtime:"sap/m/designtime/MessagePage.designtime"}});
j.ARIA_ROLE_DESCRIPTION="MESSAGE_PAGE_ROLE_DESCRIPTION";
j.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTitle=null;this._oNavButton=new B(this.getId()+"-navButton",{type:h.Back,press:q.proxy(function(){this.fireNavButtonPress();},this)});this.setAggregation("_internalHeader",new d(this.getId()+"-intHeader",{design:i.Header}));this.setProperty("text",o.getText("MESSAGE_PAGE_TEXT"),true);this.setProperty("description",o.getText("MESSAGE_PAGE_DESCRIPTION"),true);this._sAriaRoleDescription=o.getText(j.ARIA_ROLE_DESCRIPTION);};
j.prototype.exit=function(){if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}if(this._oIconControl){this._oIconControl.destroy();this._oIconControl=null;}};
j.prototype.setTitle=function(t){this.setProperty("title",t,true);if(!this._oTitle){this._oTitle=new b(this.getId()+"-title");this._getInternalHeader().addContentMiddle(this._oTitle);}this._oTitle.setText(t);return this;};
j.prototype.setText=function(t){this.setProperty("text",t,true);var o=this.getAggregation("_text");o&&o.setText(t);return this;};
j.prototype.setDescription=function(D){this.setProperty("description",D,true);var o=this.getAggregation("_formattedText"),k=this.getAggregation("_description");o&&o.setHtmlText(D);k&&k.setText(D);return this;};
j.prototype.setShowNavButton=function(s){this.setProperty("showNavButton",s,true);var H=this._getInternalHeader();if(s){H.addContentLeft(this._oNavButton);}else{H.removeAllContentLeft();}return this;};
j.prototype.setIcon=function(s){var v=this.getIcon()||"";s=s||"";if(v!==s){var S=!!v&&!!s&&I.isIconURI(s)===I.isIconURI(v);this.setProperty("icon",s,S);if(S&&this._oIconControl){this._oIconControl.setSrc(s);}}return this;};
j.prototype.setEnableFormattedText=function(E){var o;if(E){o=this._getFormattedText();o.setHtmlText(this.getDescription());}return this.setProperty("enableFormattedText",E);};
j.prototype._getIconControl=function(){if(this._oIconControl){this._oIconControl.destroy();this._oIconControl=null;}this._oIconControl=I.createControlByURI({id:this.getId()+"-pageIcon",src:this.getIcon(),height:"8rem",width:"8rem",useIconTooltip:true,decorative:false,alt:this.getIconAlt()},a).addStyleClass("sapMMessagePageIcon");return this._oIconControl;};
j.prototype._getText=function(){if(this.getAggregation("customText")){return this.getAggregation("customText");}if(!this.getAggregation("_text")){var t=new T(this.getId()+"-text",{id:this.getId()+"-customText",text:M.escapeSettingsValue(this.getText()),textAlign:f.Center,textDirection:this.getTextDirection()});this.setAggregation("_text",t);}return this.getAggregation("_text");};
j.prototype._getDescription=function(){if(this.getAggregation("customDescription")){return this.getAggregation("customDescription");}if(this.getEnableFormattedText()){return this._getFormattedText();}if(!this.getAggregation("_description")){var D=new T(this.getId()+"-description",{id:this.getId()+"-customDescription",text:M.escapeSettingsValue(this.getDescription()),textAlign:f.Center,textDirection:this.getTextDirection()});this.setAggregation("_description",D);}return this.getAggregation("_description");};
j.prototype._getAnyHeader=function(){return this._getInternalHeader();};
j.prototype._getInternalHeader=function(){return this.getAggregation("_internalHeader");};
j.prototype._getFormattedText=function(){var o=this.getAggregation("_formattedText");if(!o){o=new F(this.getId()+"-formattedText");this.setAggregation("_formattedText",o);}return o;};
return j;});
sap.ui.predefine('sap/m/MessagePageRenderer',['sap/ui/core/library'],function(c){"use strict";var T=c.TextDirection;var M={apiVersion:2};
M.render=function(r,m){this.startOpeningDiv(r,m);this.renderHeader(r,m);this.startInnerDivs(r);this.renderContent(r,m);this.endInnerDivs(r);this.endOpeningDiv(r);};
M.startOpeningDiv=function(r,m){r.openStart("div",m);r.attr("aria-roledescription",m._sAriaRoleDescription);r.class("sapMMessagePage");if(m.getTextDirection()!==T.Inherit){r.attr("dir",m.getTextDirection().toLowerCase());}r.openEnd();};
M.renderHeader=function(r,m){if(m.getShowHeader()){r.renderControl(m.getAggregation("_internalHeader"));}};
M.startInnerDivs=function(r){r.openStart("div");r.class("sapMMessagePageInner");r.openEnd();r.openStart("div");r.class("sapMMessagePageContentWrapper");r.openEnd();};
M.renderContent=function(r,m){if(m.getIcon()){r.renderControl(m._getIconControl());}r.renderControl(m._getText().addStyleClass("sapMMessagePageMainText"));r.renderControl(m._getDescription().addStyleClass("sapMMessagePageDescription"));this.renderButtons(r,m);};
M.renderButtons=function(r,m){var b=m.getButtons();if(b.length>0){r.openStart("div");r.class("sapMMessagePageButtonsWrapper");r.openEnd();for(var i=0;i<b.length;i++){r.renderControl(b[i]);}r.close("div");}};
M.endInnerDivs=function(r){r.close("div");r.close("div");};
M.endOpeningDiv=function(r){r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MessagePopover',["./ResponsivePopover","./Button","./Toolbar","./Bar","sap/ui/core/Control","sap/ui/core/IconPool","./semantic/SemanticPage","./Popover","./MessageView","sap/ui/Device","./MessagePopoverRenderer","sap/base/Log","sap/ui/thirdparty/jquery"],function(R,B,T,a,C,I,S,P,M,D,b,L,q){"use strict";
var c=C.extend("sap.m.MessagePopover",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},placement:{type:"sap.m.VerticalPlacementType",group:"Behavior",defaultValue:"Vertical"},initiallyExpanded:{type:"boolean",group:"Behavior",defaultValue:true},groupItems:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessageItem",altTypes:["sap.m.MessagePopoverItem"],multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false,forwarding:{idSuffix:"-messageView",aggregation:"headerButton"}}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},itemSelect:{parameters:{item:{type:"sap.m.MessagePopoverItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{},activeTitlePress:{parameters:{item:{type:"sap.m.MessageItem"}}}}}});
function d(n){return n.charAt(0).toUpperCase()+n.slice(1);}
var e="sapMMsgPopover",f="320px",g="440px",h={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("message-information"),warning:I.getIconURI("message-warning"),error:I.getIconURI("message-error"),success:I.getIconURI("message-success")},A=["asyncDescriptionHandler","asyncURLHandler"],i={asyncDescriptionHandler:function(j){var l=j.item.getLongtextUrl();if(l){q.ajax({type:"GET",url:l,success:function(k){j.item.setDescription(k);j.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+l;L.error(E);j.promise.reject(E);}});}}};
c.setDefaultHandlers=function(m){A.forEach(function(F){if(m.hasOwnProperty(F)){i[F]=m[F];}});};
c.prototype.init=function(){var t=this;var p;this._oOpenByControl=null;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oMessageView=this._initMessageView();this._oMessageView.addEventDelegate({onBeforeRendering:function(){var s=t._oMessageView._oSegmentedButton.getVisible(),j=!t.getInitiallyExpanded()||s;t._oMessageView._oSegmentedButton.setVisible(j);t._oMessageView._listPage.setShowHeader(true);}});this._insertCloseBtn(this._oMessageView._oListHeader);this._insertCloseBtn(this._oMessageView._oDetailsHeader);this._oMessageView._oSegmentedButton.attachEvent("select",this._onSegButtonSelect,this);this._oPopover=new R(this.getId()+"-messagePopover",{showHeader:false,contentWidth:g,contentHeight:f,placement:this.getPlacement(),showCloseButton:false,verticalScrolling:false,horizontalScrolling:false,modal:false,afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter("openBy")});},afterClose:function(E){t._oMessageView._navContainer.backToTop();t.fireAfterClose({openBy:E.getParameter("openBy")});},beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter("openBy")});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter("openBy")});}}).addStyleClass(e);this._oPopover._setAriaModal(false);this._oPopover.addContent(this._oMessageView);this._oPopover.addAssociation("ariaLabelledBy",this.getId()+"-messageView-HeadingDescr",true);p=this._oPopover.getAggregation("_popup");p.oPopup.setAutoClose(false);p.addEventDelegate({onBeforeRendering:this.onBeforeRenderingPopover,onAfterRendering:this.onAfterRenderingPopover},this);if(D.system.phone){this._oPopover.setBeginButton(new B({text:this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),press:this.close.bind(this)}));}A.forEach(function(F){if(i.hasOwnProperty(F)){this['set'+d(F)](i[F]);}},this);};
c.prototype.onBeforeRendering=function(){if(this.getDependents().indexOf(this._oPopover)===-1){this.addDependent(this._oPopover);}this._oPopover.setPlacement(this.getPlacement());};
c.prototype.onBeforeRenderingPopover=function(){if(this._oMessageView&&this._bItemsChanged){var j=this.getItems();var t=this;this._oMessageView.destroyItems();j.forEach(function(k){k._updateProperties(function(){t._bItemsChanged=true;});this._oMessageView.addItem(k.clone("","",{cloneChildren:true,cloneBinding:true}));},this);this._bItemsChanged=false;}this._setInitialFocus();if(this._oOpenByControl&&!this._oOpenByControl.getVisible()){this._oPopover.close();}this._syncMessageView();};
c.prototype.onAfterRenderingPopover=function(){if(this._oPopover._oControl._sFocusControlId){this._oPopover._oControl._sFocusControlId=null;}};
c.prototype.exit=function(){this._oResourceBundle=null;this._oOpenByControl=null;if(this._oMessageView){this._oMessageView.destroy();this._oMessageView=null;}if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}};
c.prototype.openBy=function(o){var r=this._oPopover.getAggregation("_popup"),p=o.getParent();this._oOpenByControl=o;if(r instanceof P){if((p instanceof T||p instanceof a||p instanceof S)){r._minDimensions={width:400,height:128};r.setShowArrow(false);r.setResizable(true);}else{r.setShowArrow(true);}}if(this._oPopover){this._restoreExpansionDefaults();this._oPopover.openBy(o);}return this;};
c.prototype.close=function(){if(this._oPopover){this._oPopover.close();}return this;};
c.prototype.isOpen=function(){return this._oPopover.isOpen();};
c.prototype.toggle=function(o){if(this.isOpen()){this.close();}else{this.openBy(o);}return this;};
c.prototype.getDomRef=function(s){return this._oPopover&&this._oPopover.getAggregation("_popup").getDomRef(s);};
c.prototype._initMessageView=function(){var t=this,m;m=new M(this.getId()+"-messageView",{activeTitlePress:function(E){if(D.system.phone){t.close();}t.fireActiveTitlePress({item:E.getParameter("item")});},listSelect:function(E){t.fireListSelect({messageTypeFilter:E.getParameter('messageTypeFilter')});},itemSelect:function(E){t.fireItemSelect({messageTypeFilter:E.getParameter('messageTypeFilter'),item:E.getParameter('item')});},longtextLoaded:function(){t.fireLongtextLoaded();},urlValidated:function(){t.fireUrlValidated();}});m._makeAutomaticBinding=function(){var j=t.getItems();if(!t.getBindingInfo("items")&&!j.length){this._bindToMessageModel();}};return m;};
c.prototype._onSegButtonSelect=function(){if(this.isOpen()&&!this.getInitiallyExpanded()&&this._oPopover.hasStyleClass(e+"-init")){this._expandMsgPopover();}};
c.prototype._restoreExpansionDefaults=function(){if(this._oMessageView&&!this.getInitiallyExpanded()&&this.getItems().length!=1){this._collapseMsgPopover();this._oMessageView._oSegmentedButton.setSelectedButton("none");}else{this._expandMsgPopover();}};
c.prototype._expandMsgPopover=function(){var s,H=f,s=this._oPopover.$("cont").css("height");if(this.getInitiallyExpanded()&&s!=="0px"){H=parseFloat(s)?s:H;}this._oPopover.setContentHeight(H).removeStyleClass(e+"-init");};
c.prototype._collapseMsgPopover=function(){this._oPopover.addStyleClass(e+"-init").setContentHeight("auto");};
c.prototype._insertCloseBtn=function(o){var s=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE"),j=new B({icon:h["close"],visible:!D.system.phone,tooltip:s,press:this.close.bind(this)}).addStyleClass(e+"CloseBtn");o.insertContent(j,3,true);};
c.prototype._setInitialFocus=function(){if(this._oMessageView&&this._oMessageView._isListPage()&&this.getInitiallyExpanded()){this._oPopover.setInitialFocus(this._oMessageView._oLists[this._sCurrentList||'all']);}};
c.prototype._syncMessageView=function(){if(this._oMessageView){this._oMessageView.setProperty('asyncDescriptionHandler',this.getAsyncDescriptionHandler(),true);this._oMessageView.setProperty('asyncURLHandler',this.getAsyncURLHandler(),true);this._oMessageView.setProperty("groupItems",this.getGroupItems(),false);}};
c.prototype.setModel=function(m,n){if(this._oMessageView){this._oMessageView.setModel(m,n);}return C.prototype.setModel.apply(this,arguments);};
c.prototype.navigateBack=function(){if(this._oMessageView){this._oMessageView.navigateBack();}};
["invalidate","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getBusyIndicatorDelay","setBusyIndicatorDelay","getVisible","setVisible","getBusy","setBusy"].forEach(function(n){c.prototype[n]=function(){if(this._oPopover&&this._oPopover[n]){var p=this._oPopover;var r=p[n].apply(p,arguments);return r===p?this:r;}};});["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){c.prototype["_"+F+"Old"]=c.prototype[F];c.prototype[F]=function(){var r=c.prototype["_"+F+"Old"].apply(this,arguments);this._bItemsChanged=true;if(this._oPopover){this._oPopover.invalidate();}if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return r;}return this;};});return c;});
sap.ui.predefine('sap/m/MessagePopoverItem',["./library","./MessageItem"],function(l,M){"use strict";
var a=M.extend("sap.m.MessagePopoverItem",{});
return a;});
sap.ui.predefine('sap/m/MessagePopoverRenderer',[],function(){"use strict";var M={apiVersion:2};
M.render=function(r,c){};
return M;},true);
sap.ui.predefine('sap/m/MessageStrip',["./library","sap/ui/core/Control","./MessageStripUtilities","./Text","./Link","./FormattedText","sap/ui/core/library","./MessageStripRenderer","sap/base/Log","sap/m/Button","sap/ui/core/Core","sap/ui/core/InvisibleText"],function(l,C,M,T,L,F,c,a,b,B,d,I){"use strict";var e=c.MessageType;var f=l.ButtonType;
var g=C.extend("sap.m.MessageStrip",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MessageStrip.designtime",properties:{text:{type:"string",group:"Appearance",defaultValue:""},type:{type:"sap.ui.core.MessageType",group:"Appearance",defaultValue:e.Information},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},showCloseButton:{type:"boolean",group:"Appearance",defaultValue:false},enableFormattedText:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"link",aggregations:{link:{type:"sap.m.Link",multiple:false,singularName:"link"},_formattedText:{type:"sap.m.FormattedText",multiple:false,visibility:"hidden"},_text:{type:"sap.m.Text",multiple:false,visibility:"hidden"},_closeButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{close:{}},dnd:{draggable:true,droppable:false}}});
g.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this.setAggregation("_text",new T());this._initCloseButton();};
g.prototype.setText=function(t){var o=this.getAggregation("_formattedText");if(o){o.setHtmlText(t);}this.getAggregation("_text").setText(t);return this.setProperty("text",t);};
g.prototype.setType=function(t){if(!t||t===e.None){b.warning(M.MESSAGES.TYPE_NOT_SUPPORTED);t=e.Information;}this.getType()!==t&&this._setButtonAriaLabelledBy(t);return this.setProperty("type",t);};
g.prototype.close=function(){var h=function(){this.setVisible(false);this.fireClose();}.bind(this);if(!d.getConfiguration().getAnimation()){h();return;}M.closeTransitionWithCSS.call(this,h);};
g.prototype.setEnableFormattedText=function(E){var o=this.getAggregation("_formattedText");if(E){if(!o){o=new F();o._setUseLimitedRenderingRules(true);this.setAggregation("_formattedText",o);}o.setHtmlText(this.getText());}return this.setProperty("enableFormattedText",E);};
g.prototype.setAggregation=function(n,o,s){if(n==="link"&&o instanceof L){o.addAriaDescribedBy(this.getId());}C.prototype.setAggregation.call(this,n,o,s);return this;};
a.getAccessibilityState=function(){var A=M.getAccessibilityState.call(this),o=this.getLink(),r=d.getLibraryResourceBundle("sap.m");if(!o){A.labelledby=this.getId();}A.roledescription=r.getText("MESSAGE_STRIP_ARIA_ROLE_DESCRIPTION");return A;};
g.prototype.ontouchmove=function(E){E.setMarked();};
g.prototype._initCloseButton=function(){var r=d.getLibraryResourceBundle("sap.m"),o=this.getAggregation("_closeButton");if(!o){var h=new B({type:f.Transparent,tooltip:r.getText("MESSAGE_STRIP_TITLE"),icon:"sap-icon://decline",press:this.close.bind(this)}).addStyleClass(M.CLASSES.CLOSE_BUTTON).addStyleClass("sapUiSizeCompact");this.setAggregation("_closeButton",h);this._setButtonAriaLabelledBy(this.getType());}};
g.prototype._setButtonAriaLabelledBy=function(t){var o=this.getAggregation("_closeButton"),r=d.getLibraryResourceBundle("sap.m"),s=r.getText("MESSAGE_STRIP_"+t.toUpperCase()+"_CLOSE_BUTTON");if(!this._oInvisibleText){this._oInvisibleText=new I({text:s}).toStatic();}else{this._oInvisibleText.setText(s);}if(o){o.removeAllAriaLabelledBy();o.addAriaLabelledBy(this._oInvisibleText.getId());}};
g.prototype.exit=function(){if(this._oInvisibleText){this._oInvisibleText.destroy();this._oInvisibleText=null;}};
return g;});
sap.ui.predefine('sap/m/MessageStripRenderer',["./MessageStripUtilities"],function(M){"use strict";var a={apiVersion:2};
a.render=function(r,c){this.startMessageStrip(r,c);this.renderAriaTypeText(r,c);if(c.getShowIcon()){this.renderIcon(r,c);}this.renderTextAndLink(r,c);if(c.getShowCloseButton()){this.renderCloseButton(r,c);}this.endMessageStrip(r);};
a.startMessageStrip=function(r,c){r.openStart("div",c);r.class(M.CLASSES.ROOT);r.class(M.CLASSES.ROOT+c.getType());r.attr(M.ATTRIBUTES.CLOSABLE,c.getShowCloseButton());r.accessibilityState(c,this.getAccessibilityState.call(c));r.openEnd();};
a.renderAriaTypeText=function(r,c){r.openStart("span");r.class("sapUiPseudoInvisibleText");r.openEnd();r.text(M.getAriaTypeText.call(c));r.close("span");};
a.renderIcon=function(r,c){r.openStart("div");r.class(M.CLASSES.ICON);r.openEnd();r.icon(M.getIconURI.call(c),null,{"title":null,"aria-hidden":true});r.close("div");};
a.renderTextAndLink=function(r,c){var f=c.getAggregation("_formattedText");r.openStart("div");r.class(M.CLASSES.MESSAGE);r.openEnd();if(c.getEnableFormattedText()&&f){r.renderControl(f);}else{r.renderControl(c.getAggregation("_text"));}r.renderControl(c.getLink());r.close("div");};
a.renderCloseButton=function(r,c){r.renderControl(c.getAggregation("_closeButton"));};
a.endMessageStrip=function(r){r.close("div");};
return a;},true);
sap.ui.predefine('sap/m/MessageStripUtilities',function(){"use strict";var M={};M.MESSAGES={TYPE_NOT_SUPPORTED:"Value 'sap.ui.core.MessageType.None' for property 'type' is not supported."+"Defaulting to 'sap.ui.core.MessageType.Information'"};M.CLASSES={ROOT:"sapMMsgStrip",ICON:"sapMMsgStripIcon",MESSAGE:"sapMMsgStripMessage",CLOSE_BUTTON:"sapMMsgStripCloseButton",CLOSING_TRANSITION:"sapMMsgStripClosing"};M.ATTRIBUTES={CLOSABLE:"data-sap-ui-ms-closable"};M.RESOURCE_BUNDLE=sap.ui.getCore().getLibraryResourceBundle("sap.m");
M.getIconURI=function(){var t=this.getType(),c=this.getCustomIcon(),i="sap-icon://message-"+t.toLowerCase();return c||i;};
M.getAriaTypeText=function(){var b="MESSAGE_STRIP_"+this.getType().toUpperCase(),a=M.RESOURCE_BUNDLE.getText(b);if(this.getShowCloseButton()){a+=" "+M.RESOURCE_BUNDLE.getText("MESSAGE_STRIP_CLOSABLE");}return a;};
M.isMSCloseButtonPressed=function(t){return t.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1||t.parentNode.className.indexOf(M.CLASSES.CLOSE_BUTTON)!==-1;};
M.closeTransitionWithCSS=function(c){this.$().addClass(M.CLASSES.CLOSING_TRANSITION).one("webkitTransitionEnd transitionend",c);};
M.getAccessibilityState=function(){return{role:"note",live:"assertive"};};
return M;});
sap.ui.predefine('sap/m/MessageToast',['./InstanceManager','sap/ui/core/Popup','sap/ui/core/library','sap/ui/core/Control','sap/ui/Device',"sap/base/Log","sap/ui/thirdparty/jquery"],function(I,P,c,C,D,L,q){"use strict";var a=c.Dock;var d=c.CSSSize;var M={};var O="0 -64",e="sapMMessageToast",E="sapUiSelectable",B="sapContrast",f="sapContrastPlus";M._mSettings={duration:3000,width:"15em",my:"center bottom",at:"center bottom",of:document.defaultView,offset:"0 0",collision:"fit fit",onClose:null,animationTimingFunction:"ease",animationDuration:1000,autoClose:true,closeOnBrowserNavigation:true};M._aPopups=[];M._iOpenedPopups=0;M._bBoundedEvents=false;
M._validateSettings=function(s){M._isFiniteInteger(s.duration);M._validateWidth(s.width);M._validateDockPosition(s.my);M._validateDockPosition(s.at);M._validateOf(s.of);M._validateOffset(s.offset);M._validateCollision(s.collision);M._validateOnClose(s.onClose);M._validateAutoClose(s.autoClose);M._validateAnimationTimingFunction(s.animationTimingFunction);M._isFiniteInteger(s.animationDuration);};
M._isFiniteInteger=function(N){if(typeof N!=="number"||!isFinite(N)||!(Math.floor(N)===N)||N<=0){L.error('"iNumber" needs to be a finite positive nonzero integer on '+M+"._isFiniteInteger");}};
M._validateWidth=function(w){if(!d.isValid(w)){L.error(w+' is not of type '+'"sap.ui.core.CSSSize" for property "width" on '+M+"._validateWidth");}};
M._validateDockPosition=function(s){if(!a.isValid(s)){L.error('"'+s+'"'+' is not of type '+'"sap.ui.core.Popup.Dock" on '+M+"._validateDockPosition");}};
M._validateOf=function(v){if(!(v instanceof q)&&!(v&&v.nodeType===1)&&!(v instanceof C)&&v!==window){L.error('"of" needs to be an instance of sap.ui.core.Control or an Element or a jQuery object or the window on '+M+"._validateOf");}};
M._validateOffset=function(o){if(typeof o!=="string"){L.error(o+' is of type '+typeof o+', expected "string" for property "offset" on '+M+"._validateOffset");}};
M._validateCollision=function(s){var r=/^(fit|flip|none|flipfit|flipflip|flip flip|flip fit|fitflip|fitfit|fit fit|fit flip)$/i;if(!r.test(s)){L.error('"collision" needs to be a single value “fit”, “flip”, or “none”, or a pair for horizontal and vertical e.g. "fit flip”, "fit none", "flipfit" on '+M+"._validateOffset");}};
M._validateOnClose=function(b){if(typeof b!=="function"&&b!==null){L.error('"onClose" should be a function or null on '+M+"._validateOnClose");}};
M._validateAutoClose=function(b){if(typeof b!=="boolean"){L.error('"autoClose" should be a boolean on '+M+"._validateAutoClose");}};
M._validateAnimationTimingFunction=function(t){var r=/^(ease|linear|ease-in|ease-out|ease-in-out)$/i;if(!r.test(t)){L.error('"animationTimingFunction" should be a string, expected values: '+"ease, linear, ease-in, ease-out, ease-in-out on "+M+"._validateAnimationTimingFunction");}};
function h(o){for(var p=["my","at","of","offset"],i=0;i<p.length;i++){if(o[p[i]]!==undefined){return false;}}return true;}
function g(s){var m=document.createElement("div");m.className=e+" "+E+" "+B+" "+f;if(sap.ui.getCore().getConfiguration().getAccessibility()){m.setAttribute("role","alert");m.setAttribute("aria-label"," ");}m.style.width=s.width;m.appendChild(document.createTextNode(s.message));return m;}
function n(o){if(o){if(h(o)){o.offset=O;}if(o.of&&o.of.nodeType===9){o.of=document.defaultView;}}else{o={offset:O};}return o;}
M._handleResizeEvent=function(){if(D.system.phone||D.system.tablet){M._resetPosition(M._aPopups);}setTimeout(M["_applyPositions"].bind(M,M._aPopups),0);};
M._handleMouseDownEvent=function(o){var i=o.target.hasAttribute("class")&&o.target.getAttribute("class").indexOf(e)!==-1;if(i||o.isMarked("delayedMouseEvent")){return;}M._aPopups.forEach(function(p){p&&p.__bAutoClose&&p.close();});};
M._resetPosition=function(p){for(var i=0,m;i<p.length;i++){m=p[i]&&p[i].getContent();if(m){m.style.visibility="hidden";m.style.left=0;}}};
M._applyPositions=function(p){for(var i=0,o,m;i<p.length;i++){o=p[i];if(o){m=o._oPosition;if(D.system.phone||D.system.tablet){setTimeout(M["_applyPosition"].bind(M,o,m),0);}else{o.setPosition(m.my,m.at,m.of,m.offset);}}}};
M._applyPosition=function(p,m){m=m||p._oPosition;var o=p.getContent();p.setPosition(m.my,m.at,m.of,m.offset);o.style.visibility="visible";};
M._setCloseAnimation=function(m,i,b,s){var j="opacity "+s.animationTimingFunction+" "+s.animationDuration+"ms",t="webkitTransitionEnd."+e+" transitionend."+e;if(sap.ui.getCore().getConfiguration().getAnimation()&&s.animationDuration>0){m[0].style.webkitTransition=j;m[0].style.transition=j;m[0].style.opacity=0;m.on(t,function handleMTTransitionEnd(){m.off(t);b();});}else{b();}};
M.show=function(m,o){var t=M,s=q.extend({},M._mSettings,{message:m}),p=new P(),i,b,j="mousedown."+e+" touchstart."+e,k,l;o=n(o);q.extend(s,o);M._validateSettings(s);b=g(s);i=M._aPopups.push(p)-1;p.setContent(b);p.setPosition(s.my,s.at,s.of,s.offset,s.collision);p.setAnimations(function fnMessageToastOpen($,v,w){w();},function fnMessageToastClose($,v,w){t._setCloseAnimation($,v,w,s);});p.setShadow(false);p.__bAutoClose=s.autoClose;if(s.closeOnBrowserNavigation){I.addPopoverInstance(p);}if(!M._bBoundedEvents){q(window).on("resize."+e,M._handleResizeEvent.bind(M));q(document).on(j,M._handleMouseDownEvent.bind(M));M._bBoundedEvents=true;}p.open();M._iOpenedPopups++;function r(){I.removePopoverInstance(t._aPopups[i]);q(t._aPopups[i].getContent()).remove();t._aPopups[i].detachClosed(r);t._aPopups[i].destroy();t._aPopups[i]=null;t._iOpenedPopups--;if(t._iOpenedPopups===0){t._aPopups=[];q(window).off("resize."+e);q(document).off(j);t._bBoundedEvents=false;}if(typeof s.onClose==="function"){s.onClose.call(t);}}p.attachClosed(r);k=setTimeout(p["close"].bind(p),s.duration);function u(){clearTimeout(k);k=null;function v(){l=setTimeout(p["close"].bind(p),s.duration);p.getContent().removeEventListener("mouseleave",v);}p.getContent().addEventListener("mouseleave",v);clearTimeout(l);l=null;}p.getContent().addEventListener("touchstart",u);p.getContent().addEventListener("mouseover",u);if(D.system.desktop){p.getContent().addEventListener("mouseleave",function(){k=setTimeout(p["close"].bind(p),s.duration);});}};
M.toString=function(){return"sap.m.MessageToast";};
return M;},true);
sap.ui.predefine('sap/m/MessageView',["sap/ui/thirdparty/jquery","sap/ui/core/Control","sap/ui/core/CustomData","sap/ui/core/IconPool","sap/ui/core/HTML","sap/ui/core/Icon","./Button","./Toolbar","./ToolbarSpacer","./List","./MessageListItem","./library","./Text","./SegmentedButton","./Page","./NavContainer","./Link","./MessageItem","./GroupHeaderListItem","sap/ui/core/library","sap/ui/base/ManagedObject","./MessageViewRenderer","sap/ui/events/KeyCodes","sap/base/Log","sap/base/security/URLWhitelist","sap/ui/thirdparty/caja-html-sanitizer"],function(q,C,a,I,H,b,B,T,c,L,M,l,d,S,P,N,e,f,G,g,h,j,K,k,U){"use strict";var V=g.ValueState;var m=g.MessageType;var n=l.ListType;
var o=C.extend("sap.m.MessageView",{metadata:{library:"sap.m",properties:{asyncDescriptionHandler:{type:"any",group:"Behavior",defaultValue:null},asyncURLHandler:{type:"any",group:"Behavior",defaultValue:null},groupItems:{type:"boolean",group:"Behavior",defaultValue:false},showDetailsPageHeader:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MessageItem",multiple:true,singularName:"item"},headerButton:{type:"sap.m.Button",multiple:false},_navContainer:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},itemSelect:{parameters:{item:{type:"sap.m.MessageItem"},messageTypeFilter:{type:"sap.ui.core.MessageType"}}},listSelect:{parameters:{messageTypeFilter:{type:"sap.ui.core.MessageType"}}},longtextLoaded:{},urlValidated:{},activeTitlePress:{parameters:{item:{type:"sap.m.MessageItem"}}}}}});
var p="sapMMsgView";var r={back:I.getIconURI("nav-back"),close:I.getIconURI("decline"),information:I.getIconURI("message-information"),warning:I.getIconURI("message-warning"),error:I.getIconURI("message-error"),success:I.getIconURI("message-success")};var s=["all","error","warning","success","information"];var A=["asyncDescriptionHandler","asyncURLHandler"];var D={asyncDescriptionHandler:function(i){var t=i.item.getLongtextUrl();if(t){q.ajax({type:"GET",url:t,success:function(u){i.item.setDescription(u);i.promise.resolve();},error:function(){var E="A request has failed for long text data. URL: "+t;k.error(E);i.promise.reject(E);}});}}};
o.setDefaultHandlers=function(i){A.forEach(function(F){if(i.hasOwnProperty(F)){D[F]=i[F];}});};
o.prototype.init=function(){var t=this;this._bHasHeaderButton=false;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._createNavigationPages();this._createLists();A.forEach(function(F){if(D.hasOwnProperty(F)){t.setProperty(F,D[F]);}});};
o.prototype._afterNavigate=function(){setTimeout(this["_restoreFocus"].bind(this),0);setTimeout(this["_restoreItemsType"].bind(this),0);};
o.prototype._restoreFocus=function(){if(this._isListPage()&&this.getItems().length){this._oLists[this._sCurrentList||'all'].focus();}else if(this._oBackButton){this._oBackButton.focus();}};
o.prototype._restoreItemsType=function(){if(this._isListPage()&&this.getItems().length>1){var t=this;this._oLists[this._sCurrentList||'all'].getItems().forEach(function(i){if(i.isA("sap.m.MessageListItem")){t._setItemType(i);}});}};
o.prototype._setItemType=function(i){var t,u=i.getActiveTitle();if(!i.getTitle()||!i.getDescription()){if(u){t=".sapMSLITitleOnly a";}else{t=".sapMSLITitleOnly";}}else if(u){t=".sapMSLITitle a";}else{t=".sapMSLITitle";}var v=i.getDomRef().querySelector(t);if(v.offsetWidth<v.scrollWidth){i.setType(n.Navigation);if(this.getItems().length===1){this._fnHandleForwardNavigation(i,"show");}}};
o.prototype.onBeforeRendering=function(){var i,t=this.getItems();this._clearLists();this._detailsPage.setShowHeader(this.getShowDetailsPageHeader());if(this.getGroupItems()){i=this._groupItems(t);this._fillGroupedLists(i);}else{this._fillLists(t);}var u=this.getHeaderButton();if(u){this._bHasHeaderButton=true;this._oListHeader.insertContent(u,2);}this._clearSegmentedButton();this._fillSegmentedButton();this._fnFilterList(this._getCurrentMessageTypeFilter()||"all");if(t.length===1&&this._oLists.all.getItems()[0].getType()===n.Navigation){this._fnHandleForwardNavigation(this._oLists.all.getItems()[0],"show");this._navContainer._pageStack[this._navContainer._pageStack.length-1].transition="slide";}this._makeAutomaticBinding();};
o.prototype._fillGroupedLists=function(i){var t=Object.keys(i),u=t.indexOf(""),v;if(u!==-1){v=i[""];this._fillLists(v);delete i[""];t.splice(u,1);}t.forEach(function(w){this._fillListsWithGroups(w,i[w]);},this);};
o.prototype._fillListsWithGroups=function(i,t){var u=new G({title:i});this._oLists["all"].addAggregation("items",u,true);this._fillLists(t);};
o.prototype.exit=function(){if(this._oLists){this._destroyLists();}if(this._oMessageItemTemplate){this._oMessageItemTemplate.destroy();}this._oResourceBundle=null;this._oListHeader=null;this._oDetailsHeader=null;this._oSegmentedButton=null;this._oBackButton=null;this._navContainer=null;this._listPage=null;this._detailsPage=null;this._sCurrentList=null;};
o.prototype._makeAutomaticBinding=function(){var i=this.getItems();if(!this.getBindingInfo("items")&&!i.length){this._bindToMessageModel();}};
o.prototype._bindToMessageModel=function(){var t=this;this.setModel(sap.ui.getCore().getMessageManager().getMessageModel(),"message");this._oMessageItemTemplate=new f({type:"{message>type}",title:"{message>message}",description:"{message>description}",longtextUrl:"{message>longtextUrl}"});this.bindAggregation("items",{path:"message>/",template:t._oMessageItemTemplate});};
o.prototype._groupItems=function(i){var t={},u;i.forEach(function(v){u=v.getGroupName();t[u]=t[u]||[];t[u].push(v);});return t;};
o.prototype._onkeypress=function(E){if(E.shiftKey&&E.keyCode==K.ENTER){this.navigateBack();}};
o.prototype._getListHeader=function(){return this._oListHeader||this._createListHeader();};
o.prototype._getDetailsHeader=function(){return this._oDetailsHeader||this._createDetailsHeader();};
o.prototype._createListHeader=function(){var i=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var t=this.getId()+"-CloseBtnDescr";var u=new H(t,{content:"<span id=\""+t+"\" style=\"display: none;\">"+i+"</span>"});var v=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_HEADING");var w=this.getId()+"-HeadingDescr";var x=new H(w,{content:"<span id=\""+w+"\" style=\"display: none;\" role=\"heading\">"+v+"</span>"});this._oSegmentedButton=new S(this.getId()+"-segmented",{}).addStyleClass("sapMSegmentedButtonNoAutoWidth");this._oListHeader=new T({content:[this._oSegmentedButton,new c(),u,x]});return this._oListHeader;};
o.prototype._createDetailsHeader=function(){var i=this._oResourceBundle.getText("MESSAGEPOPOVER_CLOSE");var t=this.getId()+"-CloseBtnDetDescr";var u=new H(t,{content:"<span id=\""+t+"\" style=\"display: none;\">"+i+"</span>"});var v=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON_TOOLTIP");var w=this._oResourceBundle.getText("MESSAGEPOPOVER_ARIA_BACK_BUTTON");var x=this.getId()+"-BackBtnDetDescr";var y=new H(x,{content:"<span id=\""+x+"\" style=\"display: none;\">"+w+"</span>"});this._oBackButton=new B({icon:r["back"],press:this.navigateBack.bind(this),ariaLabelledBy:y,tooltip:v}).addStyleClass(p+"BackBtn");this._oDetailsHeader=new T({content:[this._oBackButton,new c(),u,y]});return this._oDetailsHeader;};
o.prototype._createNavigationPages=function(){this._listPage=new P(this.getId()+"listPage",{customHeader:this._getListHeader()});this._detailsPage=new P(this.getId()+"-detailsPage",{customHeader:this._getDetailsHeader()});this._detailsPage.addEventDelegate({onclick:function(E){var t=E.target;if(t.nodeName.toUpperCase()==="A"&&(t.className.indexOf("sapMMsgViewItemDisabledLink")!==-1||t.className.indexOf("sapMMsgViewItemPendingLink")!==-1)){E.preventDefault();}}});this._navContainer=new N(this.getId()+"-navContainer",{initialPage:this.getId()+"listPage",pages:[this._listPage,this._detailsPage],afterNavigate:this._afterNavigate.bind(this)});this.setAggregation("_navContainer",this._navContainer);return this;};
o.prototype._createLists=function(){this._oLists={};s.forEach(function(i){this._oLists[i]=new L({itemPress:this._fnHandleItemPress.bind(this),visible:false});this._listPage.addAggregation("content",this._oLists[i],true);},this);return this;};
o.prototype._clearLists=function(){s.forEach(function(i){if(this._oLists[i]){this._oLists[i].destroyAggregation("items",true);}},this);return this;};
o.prototype._destroyLists=function(){s.forEach(function(i){this._oLists[i]=null;},this);this._oLists=null;};
o.prototype._fillLists=function(i){i.forEach(function(t){var u=this._mapItemToListItem(t),v=this._mapItemToListItem(t);this._oLists["all"].addAggregation("items",u,true);this._oLists[t.getType().toLowerCase()].addAggregation("items",v,true);},this);};
o.prototype._mapItemToListItem=function(i){if(!i){return null;}var t=i.getType(),u=this,v=this._getItemType(i),w=new M({title:h.escapeSettingsValue(i.getTitle()),description:h.escapeSettingsValue(i.getSubtitle()),counter:i.getCounter(),icon:this._mapIcon(t),infoState:this._mapInfoState(t),info:"\r",type:v,messageType:i.getType(),activeTitle:i.getActiveTitle(),activeTitlePress:function(){u.fireActiveTitlePress({item:i});}}).addStyleClass(p+"Item").addStyleClass(p+"Item"+t).toggleStyleClass(p+"ItemActive",i.getActiveTitle());if(v!==n.Navigation){w.addEventDelegate({onAfterRendering:function(){u._setItemType(w);}},this);}w._oMessageItem=i;return w;};
o.prototype._mapInfoState=function(t){if(!t){return null;}switch(t){case m.Warning:return V.Warning;case m.Error:return V.Error;case m.Success:return V.Success;case m.Information:case m.None:return V.None;default:k.warning("The provided MessageType is not mapped to a specific ValueState",t);return null;}};
o.prototype._mapIcon=function(i){if(!i){return null;}return r[i.toLowerCase()];};
o.prototype._getItemType=function(i){return(i.getDescription()||i.getMarkupDescription()||i.getLongtextUrl())?n.Navigation:n.Inactive;};
o.prototype._clearSegmentedButton=function(){if(this._oSegmentedButton){this._oSegmentedButton.destroyAggregation("buttons",true);}return this;};
o.prototype._fillSegmentedButton=function(){var t=this;var i=function(w){return function(){t._fnFilterList(w);};};s.forEach(function(w){var x=this._oLists[w],y=w=="all"?"MESSAGEPOPOVER_ALL":"MESSAGEVIEW_BUTTON_TOOLTIP_"+w.toUpperCase(),z=x.getItems().filter(function(F){return(F instanceof M);}).length,E;if(z>0){E=new B(this.getId()+"-"+w,{text:w=="all"?this._oResourceBundle.getText(y):z,tooltip:this._oResourceBundle.getText(y),icon:r[w],press:i(w)}).addStyleClass(p+"Btn"+w.charAt(0).toUpperCase()+w.slice(1));this._oSegmentedButton.addButton(E,true);}},this);var u=this._oSegmentedButton.getButtons().length>2;this._oSegmentedButton.setVisible(u);if(!u){this._oSegmentedButton.setSelectedButton(this._oSegmentedButton.getButtons()[0]);this._fnFilterList('all');}var v=u||this._bHasHeaderButton;this._listPage.setShowHeader(v);return this;};
o.prototype._setIcon=function(i,t){this._previousIconTypeClass=p+"DescIcon"+i.getType();this._oMessageIcon=new b({src:t.getIcon()}).addStyleClass(p+"DescIcon").addStyleClass(this._previousIconTypeClass);this._detailsPage.addContent(this._oMessageIcon);};
o.prototype._setTitle=function(i,t){var u=i.getActiveTitle(),v,w=this,x=h.escapeSettingsValue(i.getTitle()),y=this.getId()+"MessageTitleText";if(u){v=new e(y,{text:x,ariaDescribedBy:t.getId()+"-link",press:function(){w.fireActiveTitlePress({item:i});}});}else{v=new d(y,{text:x});}v.addStyleClass("sapMMsgViewTitleText");this._detailsPage.addAggregation("content",v);};
o.prototype._setDescription=function(i){var t=i.getLink();this._oLastSelectedItem=i;if(i.getMarkupDescription()){this._oMessageDescriptionText=new H(this.getId()+"MarkupDescription",{content:"<div class='sapMMsgViewDescriptionText'>"+h.escapeSettingsValue(i.getDescription())+"</div>"});}else{this._oMessageDescriptionText=new d(this.getId()+"MessageDescriptionText",{text:h.escapeSettingsValue(i.getDescription())}).addStyleClass("sapMMsgViewDescriptionText");}this._detailsPage.addContent(this._oMessageDescriptionText);if(t){var u=this._createLinkCopy(t);this._detailsPage.addContent(u);u.addStyleClass("sapMMsgViewDescriptionLink");}};
o.prototype._createLinkCopy=function(i){var t,u=i.clone("","",{cloneChildren:false,cloneBindings:false}),v=i.getCustomData()||[];t=Object.keys(i.getMetadata().getProperties());t.forEach(function(w){u.setProperty(w,i.getProperty(w));});u.destroyCustomData();v.forEach(function(w){var x=new a({key:w.getKey(),value:w.getValue()});u.addCustomData(x);});return u;};
o.prototype._iNextValidationTaskId=0;
o.prototype._validateURL=function(u){if(U.validate(u)){return u;}k.warning("You have entered invalid URL");return"";};
o.prototype._queueValidation=function(i){var t=this.getAsyncURLHandler();var v=++this._iNextValidationTaskId;var u={};var w=new window.Promise(function(x,y){u.resolve=x;u.reject=y;var z={url:i,id:v,promise:u};t(z);});w.id=v;return w;};
o.prototype._getTagPolicy=function(){var t=this,i;var u=html.makeTagPolicy(this._validateURL());return function customTagPolicy(v,w){var x,y=false;if(v.toUpperCase()==="A"){for(i=0;i<w.length;){if(w[i]==="href"){y=true;x=w[i+1];w.splice(0,2);continue;}i+=2;}}w=u(v,w);if(y&&typeof t.getAsyncURLHandler()==="function"){w=w||[];var z="sapMMsgViewItemDisabledLink sapMMsgViewItemPendingLink";var E=w.indexOf("class");if(E>-1){w[E+1]+=z;}else{w.unshift(z);w.unshift("class");}var F=w.indexOf("id");if(F>-1){w.splice(F+1,1);w.splice(F,1);}var J=t._queueValidation(x);w.push("href");w.push(x);w.push("target");w.push("_blank");w.push("id");w.push("sap-ui-"+t.getId()+"-link-under-validation-"+J.id);J.then(function(O){var $=q(document.getElementById("sap-ui-"+t.getId()+"-link-under-validation-"+O.id));if(O.allowed){k.info("Allow link "+x);}else{k.info("Disallow link "+x);}$.removeClass("sapMMsgViewItemPendingLink");$.toggleClass("sapMMsgViewItemDisabledLink",!O.allowed);t.fireUrlValidated();}).catch(function(){k.warning("Async URL validation could not be performed.");});}return w;};};
o.prototype._sanitizeDescription=function(i){var t=i.getDescription();if(i.getMarkupDescription()){var u=this._getTagPolicy();t=html.sanitizeWithPolicy(t,u);}i.setDescription(t);this._setDescription(i);};
o.prototype._fnHandleForwardNavigation=function(i,t){var u=i._oMessageItem,v=this._detailsPage.getContent()||[],w=this.getAsyncDescriptionHandler();this._previousIconTypeClass=this._previousIconTypeClass||"";this.fireItemSelect({item:u,messageTypeFilter:this._getCurrentMessageTypeFilter()});this._clearDetailsPage.call(this,v);if(typeof w==="function"&&!!u.getLongtextUrl()){u.setMarkupDescription(true);var x={};var y=new window.Promise(function(E,F){x.resolve=E;x.reject=F;});var z=function(){this._detailsPage.setBusy(false);this._navigateToDetails.call(this,u,i,t,true);}.bind(this);y.then(z).catch(function(){k.warning("Async description loading could not be performed.");z();});this._navContainer.to(this._detailsPage);this._detailsPage.setBusy(true);w({promise:x,item:u});}else{this._navigateToDetails.call(this,u,i,t,false);}this._listPage.$().attr("aria-hidden","true");};
o.prototype._fnHandleItemPress=function(E){this._fnHandleForwardNavigation(E.getParameter("listItem"),"slide");};
o.prototype._navigateToDetails=function(i,t,u,v){this._setTitle(i,t);this._sanitizeDescription(i);this._setIcon(i,t);this._detailsPage.rerender();this.fireLongtextLoaded();if(!v){this._navContainer.to(this._detailsPage,u);}};
o.prototype._clearDetailsPage=function(i){i.forEach(function(t){t.destroy();},this);};
o.prototype.navigateBack=function(){this._listPage.$().removeAttr("aria-hidden");this._navContainer.back();};
o.prototype._fnFilterList=function(i){s.forEach(function(t){if(t!=i&&this._oLists[t].getVisible()){this._oLists[t].setVisible(false);}},this);this._sCurrentList=i;this._oLists[i].setVisible(true);this.fireListSelect({messageTypeFilter:this._getCurrentMessageTypeFilter()});};
o.prototype._getCurrentMessageTypeFilter=function(){return this._sCurrentList=="all"?"":this._sCurrentList;};
o.prototype._isListPage=function(){return this._navContainer.getCurrentPage()==this._listPage;};
return o;});
sap.ui.predefine('sap/m/MessageViewRenderer',["sap/ui/core/Core"],function(C){"use strict";var M={apiVersion:2};var a="sapMMsgView";
M.render=function(r,c){var R=C.getLibraryResourceBundle("sap.m");r.openStart("div",c);r.class(a);r.accessibilityState(c,{role:"region",label:R.getText("MESSAGE_VIEW_ARIA_LABEL")});r.openEnd();r.renderControl(c._navContainer);r.close("div");};
return M;},true);
sap.ui.predefine('sap/m/MultiComboBox',['./InputBase','./ComboBoxTextField','./ComboBoxBase','./Tokenizer','./Token','./List','./StandardListItem','./Popover','./GroupHeaderListItem','./library','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/ui/core/Item','sap/ui/core/SeparatorItem','sap/ui/core/ResizeHandler','./MultiComboBoxRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/base/util/deepEqual","sap/base/assert","sap/base/Log","sap/ui/core/Core",'sap/ui/core/InvisibleText',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/control"],function(I,C,a,T,b,L,S,P,G,l,E,c,d,D,e,f,R,M,g,K,h,j,k,m,n,q){"use strict";var o=l.ListType;var p=l.ListMode;var V=d.ValueState;var O=d.OpenState;var r=l.PlacementType;var s=l.TokenizerRenderMode;
var t=a.extend("sap.m.MultiComboBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MultiComboBox.designtime",properties:{selectedKeys:{type:"string[]",group:"Data",defaultValue:[]}},associations:{selectedItems:{type:"sap.ui.core.Item",multiple:true,singularName:"selectedItem"}},aggregations:{tokenizer:{type:"sap.m.Tokenizer",multiple:false,visibility:"hidden"}},events:{selectionChange:{parameters:{changedItem:{type:"sap.ui.core.Item"},selected:{type:"boolean"}}},selectionFinish:{parameters:{selectedItems:{type:"sap.ui.core.Item[]"}}}},dnd:{draggable:false,droppable:true}}});
c.insertFontFaceStyle();E.apply(t.prototype,[true]);
t.prototype.clone=function(i){var u=a.prototype.clone.apply(this,arguments),v=this._getList();if(v){u.syncPickerContent();}return u;};
t.prototype.open=function(){if(!this.isOpen()){this._bPickerIsOpening=true;}this.syncPickerContent();return a.prototype.open.apply(this,arguments);};
t.prototype.onsapend=function(i){if(i.isMarked("forwardFocusToParent")){this.focus();}};
t.prototype.onsaphome=function(i){if(!this.getFocusDomRef().selectionStart){T.prototype.onsaphome.apply(this.getAggregation("tokenizer"),arguments);}i.setMarked();};
t.prototype.onsapdown=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();this.syncPickerContent();var u=this.getSelectableItems();var v=u[0];var w=this;if(v&&this.isOpen()&&this.getValueStateLinks().length){this._handleFormattedTextNav();return;}else if(v&&this.isOpen()){setTimeout(function(){w.getListItem(v).focus();},0);return;}if(this.isFocusInTokenizer()){return;}this._oTraversalItem=this._getNextTraversalItem();if(this._oTraversalItem&&!this.isComposingCharacter()){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}};
t.prototype.onsapup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();i.preventDefault();this.syncPickerContent();if(this.isFocusInTokenizer()){return;}this._oTraversalItem=this._getPreviousTraversalItem();if(this._oTraversalItem){this.updateDomValue(this._oTraversalItem.getText());this.selectText(0,this.getValue().length);}};
t.prototype.isFocusInTokenizer=function(){return q.contains(this.getAggregation("tokenizer").getFocusDomRef(),document.activeElement);};
t.prototype.onsapshow=function(i){this._handleItemToFocus();a.prototype.onsapshow.apply(this,arguments);};
t.prototype._handlePopupOpenAndItemsLoad=function(){this._handleItemToFocus();a.prototype._handlePopupOpenAndItemsLoad.apply(this,arguments);};
t.prototype._valueStateNavDelegate=function(v,F,i){var u=this;this.oValueStateNavDelegate={};this.oValueStateNavDelegate.onsapdown=function(){u.getListItem(u.getSelectableItems()[0]).focus();};this.oValueStateNavDelegate.onsapup=function(){u.getFocusDomRef().focus();};this.oValueStateNavDelegate.onsapend=function(w){w.preventDefault();var x=u.getSelectableItems();u.getListItem(u.getSelectableItems()[x.length-1]).focus();};this.oValueStateNavDelegate.onfocusout=function(w){v.removeStyleClass("sapMFocusable");if(!v.getDomRef().contains(w.relatedTarget)){i.forEach(function(x){x.getDomRef().setAttribute("tabindex","-1");});}if(D.browser.msie){F.removeStyleClass("sapMPseudoFocus");}};return this.oValueStateNavDelegate;};
t.prototype._closePickerDelegate={onsaptabnext:function(){if(D.browser.msie){this.getPicker().getCustomHeader().getFormattedText().removeStyleClass("sapMPseudoFocus");}this.close();setTimeout(function(){this.closeValueStateMessage();}.bind(this),0);}};t.prototype._formattedTextLinksNav={onsapup:function(){this.focus();},onsapdown:function(){this.getSelectableItems()[0].focus();}};
t.prototype._handleFormattedTextNav=function(){var i=this.getPicker().getCustomHeader(),v=this.getValueStateLinks(),F=i.getFormattedText(),u=this.oValueStateNavDelegate||this._valueStateNavDelegate(i,F,v),w=v?v[v.length-1]:null,x=v?v[0]:null;if(!v.length||i.getDomRef()===document.activeElement){return;}i.getDomRef().setAttribute("tabindex","-1");i.addDelegate(u);i.addStyleClass("sapMFocusable");i.focus();if(D.browser.msie){F.addStyleClass("sapMPseudoFocus");}v.forEach(function(y){y.getDomRef().setAttribute("tabindex","0");y.addDelegate(this._formattedTextLinksNav,this);},this);this.oMoveFocusBackToVSHeader=!this.oMoveFocusBackToVSHeader?{onsaptabprevious:function(y){y.preventDefault();i.focus();i.addStyleClass("sapMFocusable");}}:this.oMoveFocusBackToVSHeader;w.addDelegate(this._closePickerDelegate,this);x.addDelegate(this.oMoveFocusBackToVSHeader,this);};
t.prototype.onsaphide=t.prototype.onsapshow;
t.prototype._selectItemByKey=function(u){var v,w,x,i,y,z,A=this.isOpen();if(!this.getEnabled()||!this.getEditable()){return;}if(u){u.setMarked();}v=this._getUnselectedItems(A?"":this.getValue());for(i=0;i<v.length;i++){z=!(v[i].getKey()===undefined||v[i].getKey()===null)&&!v[i].isA("sap.ui.core.SeparatorItem");if(v[i].getText().toUpperCase()===this.getValue().toUpperCase()&&z){x=v[i];y=true;break;}}if(y){w={item:x,id:x.getId(),key:x.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false};this._bPreventValueRemove=false;if(this.getValue()===""||(typeof this.getValue()==="string"&&x.getText().toLowerCase().startsWith(this.getValue().toLowerCase()))){if(this.getListItem(x).isSelected()){this.setValue('');}else{this.setSelection(w);}}}else{this._bPreventValueRemove=true;}if(u){this.close();}};
t.prototype.onsapenter=function(i){var u=this.getAggregation("tokenizer");I.prototype.onsapenter.apply(this,arguments);this._showAlreadySelectedVisualEffect();if(this.getValue()){this._selectItemByKey(i);}if(!this.getEditable()&&u.getHiddenTokensCount()&&i.target===this.getFocusDomRef()){u._togglePopup(u.getTokensPopup());}};
t.prototype.onsaptabnext=function(i){var u=this.getValue();if(u){var v=this._getUnselectedItemsStartingText(u);if(v.length===1){this._selectItemByKey(i);}else{this._showWrongValueVisualEffect();}}};
t.prototype.onsaptabprevious=t.prototype.onsaptabnext;
t.prototype.onsapfocusleave=function(i){var u=this.isPlatformTablet(),v=m.byId(i.relatedControlId),F=v&&v.getFocusDomRef(),w=this.getValue(),x=this.getPicker(),y=this.getAggregation("tokenizer");if(!this._bPickerIsOpening&&(!x||!x.getFocusDomRef()||!F||!q.contains(x.getFocusDomRef(),F))){this.setValue(null);if(w){this.fireChangeEvent("",{value:w});}if(!q.contains(this.getDomRef(),document.activeElement)){y.setRenderMode(s.Narrow);}}if(x&&F){if(h(x.getFocusDomRef(),F)&&!u&&!this.isPickerDialog()){this.focus();}}};
t.prototype.onfocusin=function(i){var u=this.getPicker();var v=false;var w=u&&u.getFocusDomRef();var x=(u&&u.oPopup.getOpenState())||O.CLOSED;var y=x===O.CLOSING||x===O.CLOSED;var z=this.getPickerType()==="Dropdown";var A=this.getAggregation("tokenizer");if(z){v=w&&q.contains(w,i.relatedTarget);}if(this.getEditable()&&i.target===this.getDomRef("inner")){A.setRenderMode(s.Loose);}if(i.target===this.getFocusDomRef()){A.hasOneTruncatedToken()&&A.setFirstTokenTruncated(false);this.getEnabled()&&this.addStyleClass("sapMFocus");!y&&v&&this.handleInputValidation(i,false);}if(i.target===this.getOpenArea()&&z&&!this.isPlatformTablet()){this.focus();}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()){this.openValueStateMessage();}};
t.prototype._handleItemTap=function(i){var u=q(i.target).control(0);if(!u.isA("sap.m.CheckBox")&&!u.isA("sap.m.GroupHeaderListItem")){this._bCheckBoxClicked=false;}};
t.prototype._handleItemPress=function(i){if(this.isOpen()&&this._isListInSuggestMode()&&this.getPicker().oPopup.getOpenState()!==O.CLOSING){this.clearFilter();var u=this._getLastSelectedItem();if(u){this.getListItem(u).focus();}}};
t.prototype._handleSelectionLiveChange=function(i){var u=i.getParameter("listItem");var v=i.getParameter("selected");var N=this._getItemByListItem(u);var w=this.isPickerDialog()?this.getPickerTextField():this;if(u.getType()==="Inactive"){return;}j(N,"The corresponding mapped item was not found on "+this);if(!N){return;}var x={item:N,id:N.getId(),key:N.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:true};if(v){this.fireChangeEvent(N.getText());this.setSelection(x);}else{this.fireChangeEvent(N.getText());this.removeSelection(x);}if(this._bCheckBoxClicked){w.setValue(this._sOldInput);if(this.isOpen()&&this.getPicker().oPopup.getOpenState()!==O.CLOSING){u.focus();}}else{this._bCheckBoxClicked=true;this.setValue("");this.close();}};
t.prototype.onkeydown=function(i){var u=this.getEditable(),v=this.getAggregation("tokenizer"),w=v.getTokens().length;a.prototype.onkeydown.apply(this,arguments);if(!this.getEnabled()){return;}if((i.ctrlKey||i.metaKey)&&i.which===K.I&&w){i.preventDefault();if(u){this._togglePopover();}else{this._handleIndicatorPress();}return;}this._bIsPasteEvent=(i.ctrlKey||i.metaKey)&&(i.which===K.V);if(this.getValue().length===0&&(i.ctrlKey||i.metaKey)&&(i.which===K.A)&&this._hasTokens()){v.focus();v.selectAllTokens(true);i.preventDefault();}if(this.isPickerDialog()){this._sOldValue=this.getPickerTextField().getValue();this._iOldCursorPos=q(this.getFocusDomRef()).cursorPos();}this._bDoTypeAhead=!D.os.android&&(i.which!==K.BACKSPACE)&&(i.which!==K.DELETE);};
t.prototype.oninput=function(i){a.prototype.oninput.apply(this,arguments);var u=i.srcControl,v=this.isPickerDialog(),w=v?this.getPickerTextField():this,x=w.getValueState();if(x===V.Error&&this._bAlreadySelected){w.setValueState(this._sInitialValueState);w.setValueStateText(this._sInitialValueStateText);this._bAlreadySelected=false;}if(!this.getEnabled()||!this.getEditable()){return;}this.syncPickerContent();this.handleInputValidation(i,this.isComposingCharacter());if(this._bIsPasteEvent){u.updateDomValue(this._sOldValue||i.target.value||"");return;}if(this.isOpen()){setTimeout(this._highlightList.bind(this,this._sOldInput));}if(this._getItemsShownWithFilter()){this.toggleIconPressedStyle(true);}};
t.prototype.filterItems=function(i){var F=this.fnFilter?this.fnFilter:a.DEFAULT_TEXT_FILTER;var u=[];var v=false;var w=[];i.items.forEach(function(x){if(x.isA("sap.ui.core.SeparatorItem")){w.push({separator:x});this.getListItem(x).setVisible(false);v=true;return;}var y=!!F(i.value,x,"getText");if(i.value===""){y=true;if(!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){return;}}if(v&&y){this.getListItem(w[w.length-1].separator).setVisible(true);}var z=this.getListItem(x);if(z){z.setVisible(y);y&&u.push(x);}},this);return u;};
t.prototype.onkeyup=function(i){if(!this.getEnabled()||!this.getEditable()){return;}this._sOldValue=this.getValue();this._iOldCursorPos=q(this.getFocusDomRef()).cursorPos();};
t.prototype._showWrongValueVisualEffect=function(){var i=this._getSuggestionsPopover();var u=this._sInitialValueStateText;var v=this._sInitialValueState;var w=u||this._oRbC.getText("VALUE_STATE_ERROR");var x=this;if(v===V.Error){return;}if(i){i.updateValueState(V.Error,w,true);setTimeout(i.updateValueState.bind(i,x.getValueState(),w,true),1000);}if(!this.isPickerDialog()){this.setValueState(V.Error);this.setValueStateText(this.getValueStateText()||w);setTimeout(this["setValueState"].bind(this,v||V.Error),1000);}this._syncInputWidth(this.getAggregation("tokenizer"));};
t.prototype._showAlreadySelectedVisualEffect=function(){var A=this._oRbM.getText("VALUE_STATE_ERROR_ALREADY_SELECTED");if(!this.getValue()){return;}var i=!!this.getSelectedItems().filter(function(u){return u.getText().toLowerCase()===this.getValue().toLowerCase();},this).length;var N=this.getItems().filter(function(u){return u.getText().toLowerCase()===this.getValue().toLowerCase();},this).length;if(i){this._sInitialValueState=this.getValueState();this._sInitialValueStateText=this.getValueStateText();this.setValueStateText(A);this._bAlreadySelected=true;this.setValueState("Error");return;}else if(N){return;}else{this._showWrongValueVisualEffect();}};
t.prototype._hasShowSelectedButton=function(){return true;};
t.prototype.forwardEventHandlersToSuggPopover=function(i){a.prototype.forwardEventHandlersToSuggPopover.apply(this,arguments);i.setShowSelectedPressHandler(this._filterSelectedItems.bind(this));};
t.prototype._createReadOnlyPopover=function(){return new P({showArrow:true,placement:r.Auto,showHeader:false,contentMinWidth:"auto"}).addStyleClass("sapMMultiComboBoxReadOnlyPopover");};
t.prototype.configPicker=function(i){var u=this.getRenderer(),v=u.CSS_CLASS_MULTICOMBOBOX;i.setHorizontalScrolling(false).addStyleClass(u.CSS_CLASS_COMBOBOXBASE+"Picker").addStyleClass(v+"Picker").addStyleClass(v+"Picker-CTX").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this);};
t.prototype._configureList=function(i){if(!i){return;}i.setMode(p.MultiSelect);i.setIncludeItemInSelection(true);i.attachBrowserEvent("tap",this._handleItemTap,this).attachSelectionChange(this._handleSelectionLiveChange,this).attachItemPress(this._handleItemPress,this);i.addEventDelegate({onAfterRendering:this.onAfterRenderingList,onfocusin:this.onFocusinList},this);};
t.prototype._modifyPopupInput=function(i){a.prototype._modifyPopupInput.apply(this,arguments);i.attachSubmit(function(u){var v=i.getValue();if(v){this.setValue(v);this._selectItemByKey();this.setValue(this._sOldInput);this.close();}}.bind(this));i.addEventDelegate({onfocusout:this._handleInputFocusOut},this);return i;};
t.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this._bInitialSelectedKeysSettersCompleted=true;this.getAggregation("tokenizer").setEnabled(this.getEnabled());if(this._getList()){this.syncPickerContent(true);}this._deregisterResizeHandler();this._synchronizeSelectedItemAndKey();if(!this._bAlreadySelected){this._sInitialValueStateText=this.getValueStateText();}if(this.getValueState()!==V.Error){this._sInitialValueState=this.getValueState();}};
t.prototype.syncPickerContent=function(F){var i,u,v=this.getPicker();if(!v){v=this.createPicker(this.getPickerType());this._updateSuggestionsPopoverValueState();F=true;}if(F){u=this._getList();i=this.getEditable()?this.getItems():this.getSelectedItems();this._synchronizeSelectedItemAndKey();u.destroyItems();this._clearTokenizer();this._fillList(i);if(u.getItemNavigation()){this._iFocusedIndex=u.getItemNavigation().getFocusedIndex();}}return v;};
t.prototype._registerResizeHandler=function(){j(!this._iResizeHandlerId,"Resize handler already registered");this._iResizeHandlerId=R.register(this,this._onResize.bind(this));};
t.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
t.prototype._onResize=function(){var i=this.getAggregation("tokenizer");i.setMaxWidth(this._calculateSpaceForTokenizer());this._syncInputWidth(i);this._handleNMoreAccessibility();};
t.prototype.onBeforeRenderingPicker=function(){var i=this["_onBeforeRendering"+this.getPickerType()];if(i){i.call(this);}};
t.prototype.onAfterRenderingPicker=function(){var i=this["_onAfterRendering"+this.getPickerType()];if(i){i.call(this);}};
t.prototype.onBeforeOpen=function(){a.prototype.onBeforeOpen.apply(this,arguments);var i=this["_onBeforeOpen"+this.getPickerType()];this._resetCurrentItem();this.addContent();this._aInitiallySelectedItems=this.getSelectedItems();this._synchronizeSelectedItemAndKey();if(i){i.call(this);}};
t.prototype.onAfterOpen=function(){var i=this.getFocusDomRef(),v=this.getValueStateLinks();i&&this.getFocusDomRef().setAttribute("aria-expanded","true");this._bPickerIsOpening=false;if(!this.isPlatformTablet()){this.getPicker().setInitialFocus(this);}v.forEach(function(u){u.addDelegate({onAfterRendering:function(){if(this.getFocusDomRef()){this.getFocusDomRef().setAttribute("tabindex","-1");}}},u);});this.closeValueStateMessage();};
t.prototype.onBeforeClose=function(){a.prototype.onBeforeClose.apply(this,arguments);};
t.prototype.onAfterClose=function(){var u=!q.contains(this.getDomRef(),document.activeElement)||this.isPickerDialog(),i=this.getFocusDomRef();i&&this.getFocusDomRef().setAttribute("aria-expanded","false");this.toggleIconPressedStyle(false);this.clearFilter();!this.isComposingCharacter()&&!this._bPreventValueRemove&&this.setValue("");this._sOldValue="";this._sOldInput="";this._getSuggestionsPopover()._sTypedInValue="";if(this.isPickerDialog()){this.getPickerTextField().setValue("");this.getFilterSelectedButton()&&this.getFilterSelectedButton().setPressed(false);}this.fireSelectionFinish({selectedItems:this.getSelectedItems()});this.getAggregation("tokenizer").setRenderMode(u?s.Narrow:s.Loose);if(this.getValueState()==V.Error&&document.activeElement===this.getFocusDomRef()){this.selectText(0,this.getValue().length);}};
t.prototype._onBeforeOpenDialog=function(){};
t.prototype._onBeforeOpenDropdown=function(){var i=this.getPicker(),u=this.getDomRef(),w;if(u&&i){w=(u.offsetWidth/parseFloat(l.BaseFontSize))+"rem";i.setContentMinWidth(w);}};
t.prototype.getFilterSelectedButton=function(){return this._getSuggestionsPopover().getFilterSelectedButton();};
t.prototype._filterSelectedItems=function(i,F){var u=i.oSource,v,w,x=this.getPickerTextField()?this.getPickerTextField().getValue():"",y=(u&&u.getPressed&&u.getPressed())||F,z=this.getVisibleItems(),A=this.getItems(),B=this.getSelectedItems(),H=null;if(y){z.forEach(function(J){w=B.indexOf(J)>-1?true:false;v=this.getListItem(J);if(!v){return;}if(v.isA("sap.m.GroupHeaderListItem")){v.setVisible(false);H=v;}else{v.setVisible(w);if(w&&H){H.setVisible(true);}}},this);}else{this.filterItems({value:x,items:A});}};
t.prototype.revertSelection=function(){this.setSelectedItems(this._aInitiallySelectedItems);};
t.prototype.setSelection=function(i){var u=this._getList();if(i.item&&this.isItemSelected(i.item)){return;}if(!i.item){return;}if(!i.listItemUpdated&&this.getListItem(i.item)&&u){u.setSelectedItem(this.getListItem(i.item),true);}var v=new b({key:i.key});v.setText(i.item.getText());i.item.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",v);this.getAggregation("tokenizer").addToken(v);this.$().toggleClass("sapMMultiComboBoxHasToken",this._hasTokens());this.setValue('');this.addAssociation("selectedItems",i.item,i.suppressInvalidate);var w=this.getSelectedKeys();var x=this.getKeys([i.item])[0];if(x===""||w.indexOf(x)===-1){w.push(x);this.setProperty("selectedKeys",w,i.suppressInvalidate);}if(i.fireChangeEvent){this.fireSelectionChange({changedItem:i.item,selected:true});}if(i.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
t.prototype.removeSelection=function(i){if(i.item&&!this.isItemSelected(i.item)){return;}if(!i.item){return;}this.removeAssociation("selectedItems",i.item,i.suppressInvalidate);var u=this.getSelectedKeys();var v=u.indexOf(i.item.getKey());u.splice(v,1);this.setProperty("selectedKeys",u,i.suppressInvalidate);if(!i.listItemUpdated&&this.getListItem(i.item)){var w=this.getListItem(i.item);this._getList().setSelectedItem(w,false);}if(!i.tokenUpdated){var x=this._getTokenByItem(i.item);i.item.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token",null);this.getAggregation("tokenizer").removeToken(x);}this.$().toggleClass("sapMMultiComboBoxHasToken",this._hasTokens());if(i.fireChangeEvent){this.fireSelectionChange({changedItem:i.item,selected:false});}if(i.fireFinishEvent){if(!this.isOpen()){this.fireSelectionFinish({selectedItems:this.getSelectedItems()});}}};
t.prototype._synchronizeSelectedItemAndKey=function(){var u=this.getSelectedKeys();var v=this.getKeys(this.getSelectedItems());if(!u.length){k.info("Info: _synchronizeSelectedItemAndKey() the MultiComboBox control does not contain any item on ",this);return;}for(var i=0,w=null,x=null,y=u.length;i<y;i++){w=u[i];if(v.indexOf(w)>-1){continue;}x=this.getItemByKey(""+w);if(x){this.setSelection({item:x,id:x.getId(),key:x.getKey(),fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:false});}}};
t.prototype._getTokenByItem=function(i){return i?i.data(this.getRenderer().CSS_CLASS_COMBOBOXBASE+"Token"):null;};
t.prototype.updateItems=function(i){var u=function(y){return y&&y.getKey&&y.getKey();},v,w=this.getSelectedItems().map(u),x=this.getSelectedKeys();var U=a.prototype.updateItems.apply(this,arguments);w=this.getSelectedItems().map(u).filter(function(y){return w.indexOf(y)>-1;});v=x.concat(w);this.setSelectedKeys(v);return U;};
t.prototype._getSelectedItemsOf=function(u){for(var i=0,v=u.length,w=[];i<v;i++){if(this.getListItem(u[i]).isSelected()){w.push(u[i]);}}return w;};
t.prototype._getLastSelectedItem=function(){var i=this.getAggregation("tokenizer").getTokens();var u=i.length?i[i.length-1]:null;if(!u){return null;}return this._getItemByToken(u);};
t.prototype._getOrderedSelectedItems=function(){var u=[];for(var i=0,v=this.getAggregation("tokenizer").getTokens(),w=v.length;i<w;i++){u[i]=this._getItemByToken(v[i]);}return u;};
t.prototype._getFocusedListItem=function(){if(!document.activeElement){return null;}var F=m.byId(document.activeElement.id);if(this._getList()&&g(this._getList().getFocusDomRef(),F.getFocusDomRef())){return F;}return null;};
t.prototype._getFocusedItem=function(){var i=this._getFocusedListItem();return this._getItemByListItem(i);};
t.prototype._isRangeSelectionSet=function(i){var $=i.getDomRef();return $.indexOf(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"ItemRangeSelection")>-1?true:false;};
t.prototype._hasTokens=function(){return this.getAggregation("tokenizer").getTokens().length>0;};
t.prototype._getCurrentItem=function(){if(!this._oCurrentItem){return this._getFocusedItem();}return this._oCurrentItem;};
t.prototype._setCurrentItem=function(i){this._oCurrentItem=i;};
t.prototype._resetCurrentItem=function(){this._oCurrentItem=null;};
t.prototype._decorateListItem=function(i){i.addDelegate({onkeyup:function(u){var v=null;if(u.which==K.SPACE&&this.isOpen()&&this._isListInSuggestMode()){this.open();v=this._getLastSelectedItem();if(v){this.getListItem(v).focus();}return;}},onkeydown:function(u){var v=null,w=null;if(u.shiftKey&&u.which==K.ARROW_DOWN){w=this._getCurrentItem();v=this._getNextVisibleItemOf(w);}if(u.shiftKey&&u.which==K.ARROW_UP){w=this._getCurrentItem();v=this._getPreviousVisibleItemOf(w);}if(u.shiftKey&&u.which===K.SPACE){w=this._getCurrentItem();this._selectPreviousItemsOf(w);}if(v&&v!==w){if(this.getListItem(w).isSelected()){this.setSelection({item:v,id:v.getId(),key:v.getKey(),fireChangeEvent:true,suppressInvalidate:true});this._setCurrentItem(v);}else{this.removeSelection({item:v,id:v.getId(),key:v.getKey(),fireChangeEvent:true,suppressInvalidate:true});this._setCurrentItem(v);}return;}this._resetCurrentItem();if((u.ctrlKey||u.metaKey)&&u.which==K.A){u.setMarked();u.preventDefault();var x=this.getSelectableItems();var y=this._getSelectedItemsOf(x);if(y.length!==x.length){x.forEach(function(v){this.setSelection({item:v,id:v.getId(),key:v.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}else{x.forEach(function(v){this.removeSelection({item:v,id:v.getId(),key:v.getKey(),fireChangeEvent:true,suppressInvalidate:true,listItemUpdated:false});},this);}}}},true,this);i.addEventDelegate({onsapbackspace:function(u){u.preventDefault();},onsapshow:function(u){u.setMarked();if(this.isOpen()){this.close();return;}if(this.hasContent()){this.open();}},onsaphide:function(u){this.onsapshow(u);},onsapenter:function(u){u.setMarked();this.close();},onsaphome:function(u){u.setMarked();u.preventDefault();if(this.getValueStateLinks().length){this._handleFormattedTextNav();u.stopPropagation(true);return;}var v=this.getSelectableItems();var w=v[0];this.getListItem(w).focus();},onsapend:function(u){u.setMarked();u.preventDefault();var v=this.getSelectableItems();var w=v[v.length-1];this.getListItem(w).focus();},onsapup:function(u){u.setMarked();u.preventDefault();var v=this.getSelectableItems();var w=v[0];var x=q(document.activeElement).control()[0];if(x===this.getListItem(w)&&this.getValueStateLinks().length){this._handleFormattedTextNav();u.stopPropagation(true);return;}else if(x===this.getListItem(w)){this.focus();u.stopPropagation(true);}},onfocusin:function(u){this.addStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onfocusout:function(u){this.removeStyleClass(this.getRenderer().CSS_CLASS_MULTICOMBOBOX+"Focused");},onsapfocusleave:function(u){var v=this.getAggregation("picker");var w=m.byId(u.relatedControlId);if(v&&w&&h(v.getFocusDomRef(),w.getFocusDomRef())){if(u.srcControl){u.srcControl.focus();}}}},this);if(D.support.touch){i.addEventDelegate({ontouchstart:function(u){u.setMark("cancelAutoClose");}});}};
t.prototype._handleInputFocusOut=function(){var i=this.isPickerDialog()?this.getPickerTextField():this,u=this._sOldInput||this._sOldValue||"";i.updateDomValue(u);this._bIsPasteEvent=null;};
t.prototype.onItemChange=function(i){var v=a.prototype.onItemChange.apply(this,arguments);this._forwardItemInfoToToken(i);return v;};
t.prototype._forwardItemInfoToToken=function(i){var u=i.getSource(),v=i.getParameters(),w=this._getTokenByItem(u);if(!w){return;}if(v.name==="enabled"){w.setVisible(v.newValue);}else if(w.getMetadata().hasProperty(v.name)){w.setProperty(v.name,v.newValue,false);}};
t.prototype._handleIndicatorPress=function(){var i,u=this.getAggregation("tokenizer");if(this.getEditable()){this.syncPickerContent();this._filterSelectedItems({},true);this.focus();i=this.getPicker();i.open();}else{u._togglePopup(u.getTokensPopup());}if(this.isPickerDialog()){this.getFilterSelectedButton().setPressed(true);this.bOpenedByKeyboardOrButton=true;}};
t.prototype._togglePopover=function(){var i=this.getPicker();if(!i){i=this.syncPickerContent(true);}if(i.isOpen()){i.close();}else{i.open();}};
t.prototype._createTokenizer=function(){var i=new T({renderMode:s.Narrow}).attachTokenChange(this._handleTokenChange,this);i.getTokensPopup().attachAfterOpen(function(){if(i.hasOneTruncatedToken()){i.setFirstTokenTruncated(false);}}).attachAfterClose(function(){var u=i.getTokens();if(u.length===1&&!u[0].getTruncated()){i.setFirstTokenTruncated(true);}});i.addEventDelegate({onAfterRendering:this._onAfterRenderingTokenizer},this);return i;};
t.prototype._onAfterRenderingTokenizer=function(){var i=this.getAggregation("tokenizer");if(this.getEditable()){i.addStyleClass("sapMTokenizerIndicatorDisabled");}else{i.removeStyleClass("sapMTokenizerIndicatorDisabled");}setTimeout(this._syncInputWidth.bind(this,i),0);setTimeout(this._handleNMoreAccessibility.bind(this),0);setTimeout(i["scrollToEnd"].bind(i),0);};
t.prototype._handleTokenChange=function(i){var u=i.getParameter("type");var v=i.getParameter("token");var w=null;if(u!==T.TokenChangeType.Removed&&u!==T.TokenChangeType.Added){return;}if(u===T.TokenChangeType.Removed){w=(v&&this._getItemByToken(v));if(w&&this.isItemSelected(w)){this.removeSelection({item:w,id:w.getId(),key:w.getKey(),tokenUpdated:true,fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true});!this.isPickerDialog()&&!this.isFocusInTokenizer()&&this.focus();this.fireChangeEvent("");}}};
t.prototype.onAfterRenderingList=function(){var i=this._getList();var u=document.activeElement===this.getFocusDomRef();if(this.getEditable()&&!u&&(this._iFocusedIndex!=null)&&(i.getItems().length>this._iFocusedIndex)){i.getItems()[this._iFocusedIndex].focus();this._iFocusedIndex=null;}};
t.prototype.onFocusinList=function(){if(this._bListItemNavigationInvalidated&&this._getList().getItemNavigation()){this._getList().getItemNavigation().setSelectedIndex(this._iInitialItemFocus);this._bListItemNavigationInvalidated=false;}};
t.prototype.onAfterRendering=function(){a.prototype.onAfterRendering.apply(this,arguments);this.getAggregation("tokenizer").setMaxWidth(this._calculateSpaceForTokenizer());this._registerResizeHandler();};
t.prototype.onfocusout=function(i){this.isOpen()&&this._handleInputFocusOut();this.removeStyleClass("sapMFocus");if(this.getValueState()===V.Error&&this.getValueStateText()===this._oRbM.getText("VALUE_STATE_ERROR_ALREADY_SELECTED")){this.setValueState(this._sInitialValueState);this.setValueStateText(this._sInitialValueStateText);}a.prototype.onfocusout.apply(this,arguments);};
t.prototype.onpaste=function(i){var u;if(window.clipboardData){u=window.clipboardData.getData("Text");}else{u=i.originalEvent.clipboardData.getData('text/plain');}var v=u.split(/\r\n|\r|\n/g);if(v&&v.length>0){this.getSelectableItems().forEach(function(w){if(v.indexOf(w.getText())>-1){this.setSelection({item:w,id:w.getId(),key:w.getKey(),fireChangeEvent:true,fireFinishEvent:true,suppressInvalidate:true,listItemUpdated:false});}},this);}};
t.prototype.onsapbackspace=function(i){if(!this.getEnabled()||!this.getEditable()){i.preventDefault();return;}if(this.getCursorPosition()>0||this.getValue().length>0){return;}if(!i.isMarked()){T.prototype.onsapbackspace.apply(this.getAggregation("tokenizer"),arguments);}if(i.isMarked("forwardFocusToParent")){this.focus();}i.preventDefault();};
t.prototype.onsapdelete=function(i){if(!this.getEnabled()||!this.getEditable()){return;}if(this.getValue()&&!this._isCompleteTextSelected()){return;}if(!i.isMarked()){T.prototype.onsapbackspace.apply(this.getAggregation("tokenizer"),arguments);}if(i.isMarked("forwardFocusToParent")){this.focus();}};
t.prototype.onsapnext=function(i){var u=this.getAggregation("tokenizer");if(i.isMarked()){return;}var F=q(document.activeElement).control()[0];if(!F){return;}if(F===u||u.$().find(F.$()).length>0&&this.getEditable()){this.focus();}};
t.prototype.onsapprevious=function(i){if(this.getCursorPosition()===0&&!this._isCompleteTextSelected()){if(i.srcControl===this){T.prototype.onsapprevious.apply(this.getAggregation("tokenizer"),arguments);}}};
t.prototype.onclick=function(i){var u=this.getEditable(),v=this.getEnabled(),N=i.target.className.indexOf("sapMTokenizerIndicator")>-1,w=i.target.className.indexOf("sapMToken")>-1&&this.getAggregation("tokenizer").hasOneTruncatedToken();if(u&&v&&(N||w)){i.preventDefault();this._handleIndicatorPress();}};
t.prototype.ontap=function(i){a.prototype.ontap.apply(this,arguments);var u=this.getOpenArea();if(!this.getEnabled()||!this.getEditable()){return;}i.setMarked();if(this.isPickerDialog()&&u.contains(i.target)){this.open();}};
t.prototype.getOpenArea=function(){if(this.isPickerDialog()){return this.getDomRef();}else{return a.prototype.getOpenArea.apply(this,arguments);}};
t.prototype._getItemsStartingWithPerTerm=function(i,u){var v=[],w=u?this.getEnabledItems():this.getSelectableItems(),F=this.fnFilter?this.fnFilter:a.DEFAULT_TEXT_FILTER;w.forEach(function(x){if(F(i,x,"getText")){v.push(x);}},this);return v;};
t.prototype._getItemsStartingWith=function(i,u){var v=[],w=u?this.getEnabledItems():this.getSelectableItems();w.forEach(function(x){if(typeof i==="string"&&i!==""&&x.getText().toLowerCase().startsWith(i.toLowerCase())){v.push(x);}},this);return v;};
t.prototype._getUnselectedItemsStartingText=function(i){var u=[];this._getUnselectedItems().forEach(function(v){if(typeof i==="string"&&i!==""&&v.getText().toLowerCase().startsWith(i.toLowerCase())){u.push(v);}},this);return u;};
t.prototype.getCursorPosition=function(){return this._$input.cursorPos();};
t.prototype._isCompleteTextSelected=function(){if(!this.getValue().length){return false;}var i=this._$input[0];if(i.selectionStart!==0||i.selectionEnd!==this.getValue().length){return false;}return true;};
t.prototype._selectPreviousItemsOf=function(i){var u;do{u=true;var v=this._getPreviousVisibleItemOf(i);if(v){var w=this.getListItem(v);if(w){u=this.getListItem(v).getSelected();}}this.setSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:true,suppressInvalidate:true});i=v;}while(!u);};
t.prototype._getNextVisibleItemOf=function(i){var u=this.getSelectableItems();var v=u.indexOf(i)+1;if(v<=0||v>u.length-1){return null;}return u[v];};
t.prototype._getPreviousVisibleItemOf=function(i){var u=this.getSelectableItems();var v=u.indexOf(i)-1;if(v<0){return null;}return u[v];};
t.prototype._getNextUnselectedItemOf=function(i){var u=this._getUnselectedItems();var v=u.indexOf(i)+1;if(v<=0||v>u.length-1){return null;}return u[v];};
t.prototype._getPreviousUnselectedItemOf=function(i){var u=this._getUnselectedItems();var v=u.indexOf(i)-1;if(v<0){return null;}return u[v];};
t.prototype._getNextTraversalItem=function(){var v=this.getValue();var i=v?this._getItemsStartingWithPerTerm(v):[];var u=this._getUnselectedItems();if(i.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getNextUnselectedItemOf(this._oTraversalItem);}if(i.length&&i[0].getText()===this.getValue()){return this._getNextUnselectedItemOf(i[0]);}return i.length?i[0]:u[0];};
t.prototype._getPreviousTraversalItem=function(){var v=this.getValue();var i=v?this._getItemsStartingWithPerTerm(v):[];if(i.indexOf(this._oTraversalItem)>-1&&this._oTraversalItem.getText()===this.getValue()){return this._getPreviousUnselectedItemOf(this._oTraversalItem);}if(i.length&&i[i.length-1].getText()===this.getValue()){return this._getPreviousUnselectedItemOf(i[i.length-1]);}if(i.length){return i[i.length-1];}else{var u=this._getUnselectedItems();if(u.length>0){return u[u.length-1];}else{return null;}}};
t.prototype.setSelectedItems=function(i){this.removeAllSelectedItems();if(!i||!i.length){return this;}if(!Array.isArray(i)){k.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return this;}i.forEach(function(u){if(!(u instanceof e)&&(typeof u!=="string")){k.warning("Warning: setSelectedItems() has to be an array of sap.ui.core.Item instances or of valid sap.ui.core.Item IDs",this);return;}if(typeof u==="string"){u=m.byId(u);}this.setSelection({item:u?u:null,id:u?u.getId():"",key:u?u.getKey():"",suppressInvalidate:true});},this);return this;};
t.prototype.addSelectedItem=function(i){if(!i){return this;}if(typeof i==="string"){i=m.byId(i);}this.setSelection({item:i?i:null,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true});return this;};
t.prototype.removeSelectedItem=function(i){if(!i){return null;}if(typeof i==="string"){i=m.byId(i);}if(!this.isItemSelected(i)){return null;}this.removeSelection({item:i,id:i.getId(),key:i.getKey(),fireChangeEvent:false,suppressInvalidate:true});return i;};
t.prototype.removeAllSelectedItems=function(){var i=[];var u=this.getAssociation("selectedItems",[]);u.forEach(function(v){var w=this.removeSelectedItem(v);if(w){i.push(w.getId());}},this);return i;};
t.prototype.removeSelectedKeys=function(i){var u,v=[];if(!i||!i.length||!Array.isArray(i)){return v;}i.forEach(function(w){u=this.getItemByKey(w);if(u){this.removeSelection({item:u?u:null,id:u?u.getId():"",key:u?u.getKey():"",fireChangeEvent:false,suppressInvalidate:true});v.push(u);}},this);return v;};
t.prototype.setSelectedKeys=function(i){if(this._bInitialSelectedKeysSettersCompleted){this.setProperty("selectedKeys",[],true);this.removeAllSelectedItems();}this.addSelectedKeys(i);this._bInitialSelectedKeysSettersCompleted=true;return this;};
t.prototype.addSelectedKeys=function(i){var u,v=[];i=this.validateProperty("selectedKeys",i);i.forEach(function(w){var x=this.getItemByKey(w);if(x){this.addSelectedItem(x);}else if(w!=null){v.push(w);}},this);if(v.length>0){u=this.getProperty("selectedKeys").filter(function(w){return v.indexOf(w)===-1;});v=u.concat(v);this.setProperty("selectedKeys",v,true);}return this;};
t.prototype._getUnselectedItems=function(){var i=q(this.getSelectableItems()).not(this.getSelectedItems()).get();if(!this.isOpen()){return i.filter(function(u){return!u.isA("sap.ui.core.SeparatorItem");});}return i;};
t.prototype.getSelectedItems=function(){var i=[],u=this.getAssociation("selectedItems")||[];u.forEach(function(v){var w=m.byId(v);if(w){i.push(w);}},this);return i;};
t.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
t.prototype.setEditable=function(i){var u=this._getList(),v=this.getAggregation("tokenizer");a.prototype.setEditable.apply(this,arguments);v.setEditable(i);if(u){this.syncPickerContent(true);this._updatePopoverBasedOnEditMode(i);}return this;};
t.prototype._updatePopoverBasedOnEditMode=function(i){var u=this._getList(),v=this._getSuggestionsPopover();if(!u){return;}if(i){v.addContent(u);}};
t.prototype._mapItemToListItem=function(i){var u,v,w,A;var x=this.getRenderer();if(!i){return null;}A=(i.getAdditionalText&&this.getShowSecondaryValues())?i.getAdditionalText():"";if(i.isA("sap.ui.core.SeparatorItem")){u=this._mapSeparatorItemToGroupHeader(i,x);i.data(x.CSS_CLASS_COMBOBOXBASE+"ListItem",u);this._decorateListItem(u);return u;}v=x.CSS_CLASS_MULTICOMBOBOX+"Item";w=(this.isItemSelected(i))?v+"Selected":"";u=new S({type:o.Active,visible:i.getEnabled()}).addStyleClass(v+" "+w);u.setTooltip(i.getTooltip());i.data(x.CSS_CLASS_COMBOBOXBASE+"ListItem",u);u.setTitle(i.getText());u.setInfo(A);if(w){var y=new b({key:i.getKey()});y.setText(i.getText());i.data(x.CSS_CLASS_COMBOBOXBASE+"Token",y);this.getAggregation("tokenizer").addToken(y,true);}this.setSelectable(i,i.getEnabled());this._decorateListItem(u);return u;};
t.prototype.setSelectable=function(i,u){a.prototype.setSelectable.call(this,i,u);var v=this._getTokenByItem(i);if(v){v.setVisible(u);}};
t.prototype._fillList=function(u){if(!u){return null;}if(!this._oListItemEnterEventDelegate){this._oListItemEnterEventDelegate={onsapenter:function(x){if(x.srcControl.isSelected()){x.setMarked();}}};}for(var i=0,v,w=u.length;i<w;i++){v=this._mapItemToListItem(u[i]);v.removeEventDelegate(this._oListItemEnterEventDelegate);v.addDelegate(this._oListItemEnterEventDelegate,true,this,true);this._getList().addAggregation("items",v,true);if(this.isItemSelected(u[i])){this._getList().setSelectedItem(v,true);}}};
t.prototype.handleInputValidation=function(i,u){var v=i.target.value,w=this._sOldInput&&this._sOldInput.length>v.length,x=this.isValueValid(v),y,z,A;var B=i.srcControl;if(!x&&v!==""&&!u){this._handleFieldValidationState(B);return;}A=this._getItemsStartingWith(v,true);if(!u||this._bIsPasteEvent){this._handleTypeAhead(v,A,B);}y=this.getEnabledItems();if(this.isPickerDialog()){z=this.getFilterSelectedButton();if(z!=null&&z.getPressed()){z.setPressed(false);}}if(w){y=this.getItems();}this.filterItems({value:v,items:y});this._sOldInput=v;if((!this.getValue()||!x)&&!this.bOpenedByKeyboardOrButton&&!this.isPickerDialog()){this.close();}else{this.open();}};
t.prototype.isValueValid=function(v){var i=this._getItemsStartingWith(v,true);var u=this._getItemsStartingWithPerTerm(v,true);return i.length||u.length;};
t.prototype._handleTypeAhead=function(v,i,u){var w=this.getSelectedItems();var x=i.filter(function(y){if(y.isA("sap.ui.core.SeparatorItem")){return false;}return w.indexOf(y)===-1;});if(this._bDoTypeAhead&&x.length){u.updateDomValue(x[0].getText());if(document.activeElement===u.getFocusDomRef()){u.selectText(v.length,u.getValue().length);}}};
t.prototype._handleFieldValidationState=function(i){if(this._sOldInput&&this.isValueValid(this._sOldInput)){i.updateDomValue(this._sOldInput);}else if(this._sOldValue&&this.isValueValid(this._sOldValue)){i.updateDomValue(this._sOldValue);}else{i.updateDomValue("");}if(this._iOldCursorPos){q(i.getFocusDomRef()).cursorPos(this._iOldCursorPos);}this._showWrongValueVisualEffect();};
t.prototype.init=function(){this._oRb=m.getLibraryResourceBundle("sap.m");a.prototype.init.apply(this,arguments);this._bInitialSelectedKeysSettersCompleted=false;this._bListItemNavigationInvalidated=false;this._iInitialItemFocus=-1;this._bCheckBoxClicked=true;this._bPreventValueRemove=false;this._oTokenizer=this._createTokenizer();this.setAggregation("tokenizer",this._oTokenizer);this._aInitiallySelectedItems=[];this._oRbM=m.getLibraryResourceBundle("sap.m");this._oRbC=m.getLibraryResourceBundle("sap.ui.core");this._fillList();};
t.prototype.clearSelection=function(){this.removeAllSelectedItems();};
t.prototype.insertItem=function(i,u){this.insertAggregation("items",i,u,true);if(i){i.attachEvent("_change",this.onItemChange,this);}if(this._getList()){this._getList().insertItem(this._mapItemToListItem(i),u);}return this;};
t.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this._getList()){this._getList().removeItem(i&&this.getListItem(i));}this.removeSelection({item:i,id:i?i.getId():"",key:i?i.getKey():"",fireChangeEvent:false,suppressInvalidate:true,listItemUpdated:true});return i;};
t.prototype.isItemSelected=function(i){return this.getSelectedItems().indexOf(i)>-1;};
t.prototype._clearTokenizer=function(){this.getAggregation("tokenizer").destroyTokens();};
t.prototype.exit=function(){var i=["_oSuggestionPopover","_oToggleButton","_oPickerCustomHeader","_oCustomHeaderToolbar","_oPickerCloseButton"],u=this;a.prototype.exit.apply(this,arguments);this._deregisterResizeHandler();i.forEach(function(v){if(u[v]){u[v].destroy();u[v]=null;}});this._sInitialValueState=null;};
t.prototype.destroyItems=function(){this.destroyAggregation("items");this.setProperty("selectedKeys",[],true);if(this._getList()){this._getList().destroyItems();}this.getAggregation("tokenizer").destroyTokens();return this;};
t.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items");this.removeAllSelectedItems();if(this._getList()){this._getList().removeAllItems();}return i;};
t.prototype._getItemByToken=function(i){return this._getItemBy(i,"Token");};
t.prototype._getItemByValue=function(v){return this.getSelectableItems().find(function(i){return i.getText().toLowerCase()===v.toLowerCase();});};
t.prototype._handleItemToFocus=function(){if(this.isOpen()){return;}this.syncPickerContent();var i,u,v=m.byId(document.activeElement.id),w=this.getSelectedItems(),x=this.getSelectableItems(),y=this._getList(),z=y&&y.getItemNavigation(),A=this.getValue(),B=this.getPicker();if(v&&v.isA("sap.m.Token")){u=this._getItemByToken(v);}else if(A){u=this._getItemByValue(A);}if(!u){u=w.length?this._getItemByListItem(this._getList().getSelectedItems()[0]):x[0];}i=x.indexOf(u);if(z){z.setSelectedIndex(i);}else{this._bListItemNavigationInvalidated=true;this._iInitialItemFocus=i;}B.setInitialFocus(y);};
t.prototype.getAccessibilityInfo=function(){var i=this.getSelectedItems().map(function(v){return v.getText();}).join(" ");var u=a.prototype.getAccessibilityInfo.apply(this,arguments);u.type=m.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_MULTICOMBO");u.description=((u.description||"")+" "+i).trim();return u;};
t.prototype._calculateSpaceForTokenizer=function(){if(this.getDomRef()){var i,u=this.getDomRef().offsetWidth,v=this._calculateIconsSpace(),w=this.$().find(".sapMInputBaseInner"),x=["min-width","padding-right","padding-left"],y=x.reduce(function(A,z){return A+(parseInt(w.css(z))||0);},0);i=u-(v+y);i=i<0?0:i;return i+"px";}else{return null;}};
t.prototype._syncInputWidth=function(i){var F=this.getDomRef('inner'),u,v;if(!F||(i&&!i.getDomRef())){return;}v=parseFloat(i.getDomRef().getBoundingClientRect().width.toFixed(2));u=this._calculateIconsSpace();F.style.width='calc(100% - '+parseFloat(u+v)+"px)";};
t.prototype._handleNMoreAccessibility=function(){var i=n.getStaticId("sap.m","MULTICOMBOBOX_OPEN_NMORE_POPOVER"),u=this.getAggregation("tokenizer"),F=this.getFocusDomRef(),A=(F&&F.getAttribute("aria-labelledby")),v=A?A.split(" "):[],N=v.indexOf(i),w=this.getEnabled(),x=!this.getEditable()&&u&&u.getHiddenTokensCount();if(x&&N===-1){v.push(i);w&&this.getFocusDomRef().setAttribute("aria-keyshortcuts","Enter");}else if(N!==-1&&!x){v.splice(N,1);this.getFocusDomRef().removeAttribute("aria-keyshortcuts");}if(F&&v.length){F.setAttribute("aria-labelledby",v.join(" ").trim());}};
t.prototype.applyShowItemsFilters=function(){this.syncPickerContent();this.filterItems({value:this.getValue()||"_",items:this.getItems()});};
return t;});
sap.ui.predefine('sap/m/MultiComboBoxRenderer',['./ComboBoxBaseRenderer','./ComboBoxTextFieldRenderer','sap/ui/core/Renderer','sap/ui/core/Core'],function(C,a,R,b){"use strict";var M=R.extend(C);M.apiVersion=2;M.CSS_CLASS_MULTICOMBOBOX="sapMMultiComboBox";
M.addOuterClasses=function(r,c){C.addOuterClasses.apply(this,arguments);r.class(M.CSS_CLASS_MULTICOMBOBOX);if(c._hasTokens()){r.class("sapMMultiComboBoxHasToken");}};
M.getAriaDescribedBy=function(c){var A=a.getAriaDescribedBy.apply(this,arguments),t=c.getAggregation("tokenizer"),i=t&&t.getTokensInfoId();return(A||"")+" "+i;};
M.getAccessibilityState=function(c){var A=C.getAccessibilityState.apply(this,arguments),r=b.getLibraryResourceBundle("sap.m");A.roledescription=r.getText("MULTICOMBOBOX_ARIA_ROLE_DESCRIPTION");return A;};
M.prependInnerContent=function(r,c){r.renderControl(c.getAggregation("tokenizer"));};
return M;},true);
sap.ui.predefine('sap/m/MultiEditField',["sap/ui/core/XMLComposite","./library","sap/ui/core/Item"],function(X,l,I){"use strict";
var M=X.extend("sap.m.MultiEditField",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{selectedItem:{type:"sap.ui.core.Item",group:"Data",defaultValue:null,invalidate:true},showValueHelp:{type:"boolean",group:"Behavior",defaultValue:true,invalidate:true},nullable:{type:"boolean",group:"Behavior",defaultValue:true,invalidate:true},required:{type:"boolean",group:"Behavior",defaultValue:false,invalidate:true}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,bindable:"bindable"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
M.prototype.init=function(){if(!M.prototype._oRb){M.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}var k=new I({key:"keep",text:"< "+this._oRb.getText("MULTI_EDIT_KEEP_TEXT")+" >"}),b=new I({key:"blank",text:"< "+this._oRb.getText("MULTI_EDIT_BLANK_TEXT")+" >"}),n=new I({key:"new",text:"< "+this._oRb.getText("MULTI_EDIT_NEW_TEXT")+" >"});this._getKeepAll=function(){return k;};this._getBlank=function(){return b;};this._getValueHelp=function(){return n;};this.byId("select").getParent=this.getParent.bind(this);this._oLastSelectedItem=this._getKeepAll();};
M.prototype.onBeforeRendering=function(){this.insertAggregation("items",this._getKeepAll(),0,true);if(this.getNullable()){this.insertAggregation("items",this._getBlank(),1,true);}else{this.removeAggregation("items",this._getBlank(),true);}if(this.getShowValueHelp()){this.insertAggregation("items",this._getValueHelp(),this.getNullable()?2:1,true);}else{this.removeAggregation("items",this._getValueHelp(),true);}var s=this.getSelectedItem();if(s){s=this._getInternalItem(s);this.byId("select").setSelectedItem(s);}};
M.prototype.setSelectedItem=function(s){var i=this._getExternalItem(s)||s;var o;if(i&&this.indexOfItem(i)>=0&&!this._isSpecialValueItem(i)){o=this._getInternalItem(s);if(o){this.byId("select").setSelectedItem(o);}this._oLastSelectedItem=i;return this.setProperty("selectedItem",i);}return this;};
M.prototype.exit=function(){this._getKeepAll().destroy();this._getBlank().destroy();this._getValueHelp().destroy();var i=this.byId("itemTemplate");if(i){i.destroy();}};
M.prototype.getFormDoNotAdjustWidth=function(){return true;};
M.prototype.isBlankSelected=function(){return this._getExternalItem(this.byId("select").getSelectedItem())===this._getBlank();};
M.prototype.isKeepExistingSelected=function(){return this._getExternalItem(this.byId("select").getSelectedItem())===this._getKeepAll();};
M.prototype._isSpecialValueItem=function(i){return i===this._getKeepAll()||i===this._getBlank()||i===this._getValueHelp();};
M.prototype._handleSelectionChange=function(e){var i=this._getExternalItem(e.getParameter("selectedItem"));if(i&&!this._isSpecialValueItem(i)){this.fireChange({selectedItem:i});}else if(i===this._getValueHelp()){this.fireEvent("_valueHelpRequest");}if(i!==this._getValueHelp()){this._oLastSelectedItem=i;this.setProperty("selectedItem",i,true);}};
M.prototype.resetSelection=function(){this.byId("select").setSelectedItem(this._getInternalItem(this._oLastSelectedItem));};
M.prototype._getExternalItem=function(i){var a=this.byId("select").indexOfItem(i);if(a>=0){return this.getItems()[a];}return null;};
M.prototype._getInternalItem=function(i){var a=this.indexOfItem(i);if(a>=0){return this.byId("select").getItems()[a];}return null;};
M.prototype._getInternalDomRef=function(){var s=this.byId("select");return s&&s.getDomRef();};
M.prototype._getInternalUIArea=function(){return this.byId("select").getUIArea();};
return M;});
sap.ui.predefine('sap/m/MultiInput',['./Input','./Tokenizer','./Token','./library','sap/ui/core/EnabledPropagator','sap/ui/base/ManagedObjectMetadata','sap/ui/base/ManagedObjectObserver','sap/ui/Device','./Popover','./List','./Title','./Bar','./Toolbar','./StandardListItem','sap/ui/core/ResizeHandler','sap/ui/core/IconPool','./MultiInputRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes",'sap/ui/core/InvisibleText',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos","sap/ui/dom/jquery/control"],function(I,T,a,l,E,M,b,D,P,L,c,B,d,S,R,f,g,h,K,j,q){"use strict";var k=l.TokenizerRenderMode;
var m=I.extend("sap.m.MultiInput",{metadata:{library:"sap.m",designtime:"sap/m/designtime/MultiInput.designtime",properties:{enableMultiLineMode:{type:"boolean",group:"Behavior",defaultValue:false},maxTokens:{type:"int",group:"Behavior"}},aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},tokenizer:{type:"sap.m.Tokenizer",multiple:false,visibility:"hidden"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{allowPreventDefault:true,parameters:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}},dnd:{draggable:false,droppable:true}}});
E.apply(m.prototype,[true]);var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
m.prototype.init=function(){var t=this;this._bShowListWithTokens=false;I.prototype.init.call(this);this._bIsValidating=false;var o=new T({renderMode:k.Narrow});this.setAggregation("tokenizer",o);o.attachTokenChange(this._onTokenChange,this);o.attachTokenUpdate(this._onTokenUpdate,this);this._oTokenizerObserver=new b(this.invalidate.bind(this));this._oTokenizerObserver.observe(o,{aggregations:["tokens"]});o.getTokensPopup().setInitialFocus(this).attachBeforeOpen(this._onBeforeOpenTokensPicker.bind(this));o.addEventDelegate({onThemeChanged:this._handleInnerVisibility.bind(this),onAfterRendering:function(){if(this.isMobileDevice()&&this.getEditable()){o.addStyleClass("sapMTokenizerIndicatorDisabled");}else{o.removeStyleClass("sapMTokenizerIndicatorDisabled");}this._syncInputWidth(o);this._handleInnerVisibility();this._handleNMoreAccessibility();this._registerTokenizerResizeHandler();}.bind(this)},this);this._aTokenValidators=[];this.setShowValueHelp(true);this.setShowSuggestion(true);this._getSuggestionsPopoverInstance()._oPopover.attachBeforeOpen(function(){if(t.isMobileDevice()!==true){return;}var e=o._getTokensList();o._fillTokensList(e);this.addContent(e);t._manageListsVisibility(!!o.getTokens().length);});this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);this.attachValueHelpRequest(this._onValueHelpRequested,this);this._getValueHelpIcon().setProperty("visible",true,true);this._onResize=this._onResize.bind(this);};
m.prototype.exit=function(){this._deregisterResizeHandler();this._deregisterTokenizerResizeHandler();this._oTokenizerObserver.disconnect();this._oTokenizerObserver.destroy();this._oTokenizerObserver=null;I.prototype.exit.call(this);};
m.prototype.onAfterRendering=function(){var t=this.getAggregation("tokenizer");this._bTokenIsValidated=false;t.setMaxWidth(this._calculateSpaceForTokenizer());t.scrollToEnd();this._registerResizeHandler();I.prototype.onAfterRendering.apply(this,arguments);};
m.prototype._handleInnerVisibility=function(){var H=!!this.getAggregation("tokenizer").getHiddenTokensCount();this._setValueVisible(!H);};
m.prototype.oninput=function(e){this.setProperty("selectedKey",'',true);I.prototype.oninput.call(this,e);if(e.isMarked("invalid")||!this.getEditable()){return;}this._setValueVisible(true);this._manageListsVisibility(false);this.getAggregation("tokenizer").getTokensPopup().close();};
m.prototype._registerResizeHandler=function(){if(!this._iResizeHandlerId){this._iResizeHandlerId=R.register(this,this._onResize);}};
m.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
m.prototype._registerTokenizerResizeHandler=function(){if(!this._iTokenizerResizeHandler){this._iTokenizerResizeHandler=R.register(this.getAggregation("tokenizer"),this._onResize);}};
m.prototype._deregisterTokenizerResizeHandler=function(){if(this._iTokenizerResizeHandler){R.deregister(this._iTokenizerResizeHandler);this._iTokenizerResizeHandler=null;}};
m.prototype._onResize=function(){this.getAggregation("tokenizer").setMaxWidth(this._calculateSpaceForTokenizer());};
m.prototype._onTokenChange=function(e){this.fireTokenChange(e.getParameters());this.invalidate();if(e.getParameter("type")==="removed"){this.getAggregation("tokenizer").setRenderMode(k.Loose);}if(this.isMobileDevice()){this._manageListsVisibility(true);}};
m.prototype._onTokenUpdate=function(e){var i=this.fireTokenUpdate(e.getParameters());if(!this.getTokens().length){this.$().find("input").trigger("focus");}if(!i){e.preventDefault();}else{this.invalidate();}};
m.prototype._onSuggestionItemSelected=function(e){var t=this.getAggregation("tokenizer"),i=null,n=null,o=t.getTokens().length;if(this.getMaxTokens()&&o>=this.getMaxTokens()||this._bValueHelpOpen){return;}if(this._hasTabularSuggestions()){i=e.getParameter("selectedRow");}else{i=e.getParameter("selectedItem");if(i){n=new a({text:i.getText(),key:i.getKey()});}}if(i&&!this._bTokenIsAdded){var p=this.getValue();this.addValidateToken({text:p,token:n,suggestionObject:i,validationCallback:this._validationCallback.bind(this,o)});}if(this.isMobileDevice()){var N=t.getTokens().length;if(o<N){this.setValue("");}if(this._getSuggestionsList()instanceof sap.m.Table){this._getSuggestionsList().addStyleClass("sapMInputSuggestionTableHidden");}else{this._getSuggestionsList().destroyItems();}var s=this.getAggregation("tokenizer").getScrollDelegate();if(s){s.scrollTo(0,0,0);}this._getSuggestionsPopoverInstance()._oPopupInput.focus();}this._bTokenIsAdded=false;};
m.prototype._onValueHelpRequested=function(){this._bValueHelpOpen=true;};
m.prototype._onLiveChange=function(e){this.getAggregation("tokenizer")._removeSelectedTokens();};
m.prototype._setValueVisible=function(v){var V=v?"1":"0";this.$("inner").css("opacity",V);};
m.prototype.onmousedown=function(e){if(e.target==this.getDomRef('content')){e.preventDefault();e.stopPropagation();}};
m.prototype.openMultiLine=function(){};
m.prototype.closeMultiLine=function(){};
m.prototype.showItems=function(){I.prototype.showItems.apply(this,arguments);this._manageListsVisibility(false);};
m.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.apply(this,arguments);this.getAggregation("tokenizer").setEnabled(this.getEnabled());};
m.prototype.onsapnext=function(e){var t=this.getAggregation("tokenizer");if(e.isMarked()){return;}var F=q(document.activeElement).control()[0];if(!F){return;}if(t===F||t.$().find(F.$()).length>0){t.scrollToEnd();this.$().find("input").trigger("focus");}};
m.prototype.onsapbackspace=function(e){if(this._$input.cursorPos()>0||!this.getEditable()||this.getValue().length>0){return;}if(!e.isMarked()){T.prototype.onsapbackspace.apply(this.getAggregation("tokenizer"),arguments);}if(e.isMarked("forwardFocusToParent")){this.focus();}e.preventDefault();e.stopPropagation();};
m.prototype.onsapdelete=function(e){if(!this.getEditable()){return;}if(this.getValue()&&!this._completeTextIsSelected()){return;}if(e.isMarked("forwardFocusToParent")){this.focus();}};
m.prototype.onkeydown=function(e){var t=this.getAggregation("tokenizer");if(!this.getEnabled()){return;}if(e.which===K.TAB){t.selectAllTokens(false);}if((e.ctrlKey||e.metaKey)&&e.which===K.A&&t.getTokens().length>0){t.focus();t.selectAllTokens(true);e.preventDefault();}if((e.ctrlKey||e.metaKey)&&e.which===K.I&&t.getTokens().length){t._togglePopup(t.getTokensPopup());e.preventDefault();}};
m.prototype.onpaste=function(e){var o,i,s,A=[];if(this.getValueHelpOnly()){return;}if(window.clipboardData){o=window.clipboardData.getData("Text");}else{o=e.originalEvent.clipboardData.getData('text/plain');}s=o.split(/\r\n|\r|\n/g);if(s.length<=1){return;}setTimeout(function(){if(s){if(this.fireEvent("_validateOnPaste",{texts:s},true)){var n="";for(i=0;i<s.length;i++){if(s[i]){var t=this._convertTextToToken(s[i],true);if(this._addUniqueToken(t)){A.push(t);}else{n=s[i];}}}this.updateDomValue(n);if(A.length>0){this.fireTokenUpdate({addedTokens:A,removedTokens:[],type:T.TokenUpdateType.Added});this.fireTokenChange({addedTokens:A,removedTokens:[],type:T.TokenChangeType.TokensChanged});}}if(A.length){this.cancelPendingSuggest();}}}.bind(this),0);};
m.prototype._validationCallback=function(o,v){var n=this.getAggregation("tokenizer").getTokens().length;var s=this._getSuggestionsPopoverInstance();this._bIsValidating=false;if(v){this.setValue("");this._bTokenIsValidated=true;if(this.isMobileDevice()&&s&&s._oPopupInput&&(o<n)){s._oPopupInput.setValue("");}}};
m.prototype.onsapprevious=function(e){if(this._getIsSuggestionPopupOpen()){return;}if(this._$input.cursorPos()===0){if(e.srcControl===this){T.prototype.onsapprevious.apply(this.getAggregation("tokenizer"),arguments);}}if(e.keyCode===K.ARROW_UP){e.preventDefault();}};
m.prototype.onsaphome=function(e){if(!this.getFocusDomRef().selectionStart){T.prototype.onsaphome.apply(this.getAggregation("tokenizer"),arguments);}};
m.prototype.onsapend=function(e){if(e.isMarked("forwardFocusToParent")){this.focus();}};
m.prototype.onsapenter=function(e){if(I.prototype.onsapenter){I.prototype.onsapenter.apply(this,arguments);}var v=true,t=this.getAggregation("tokenizer");if(this._getIsSuggestionPopupOpen()){if(this._hasTabularSuggestions()){v=!this._oSuggestionTable.getSelectedItem();}else{v=!this._getSuggestionsList().getSelectedItem();}}if(v){this._validateCurrentText();}if(e&&e.setMarked&&this._bTokenIsValidated){e.setMarked();}if(!this.getEditable()&&t.getHiddenTokensCount()&&e.target===this.getFocusDomRef()){t._togglePopup(t.getTokensPopup());}this.focus();};
m.prototype.onsapfocusleave=function(e){var p=this._getSuggestionsPopoverPopup(),t=this.getAggregation("tokenizer"),s=t.getTokensPopup(),n=false,N=false,i=this.getDomRef()&&h(this.getDomRef(),document.activeElement),o,F;if(p&&p.isA("sap.m.Popover")){if(e.relatedControlId){o=sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef();n=h(p.getFocusDomRef(),o);N=h(t.getFocusDomRef(),o);if(s){F=h(s.getFocusDomRef(),o);}}}I.prototype.onsapfocusleave.apply(this,arguments);if(this._bIsValidating||this._bValueHelpOpen){return;}if(!this.isMobileDevice()&&!n&&e.relatedControlId!==this.getId()&&!N){this._validateCurrentText(true);}if(!this.isMobileDevice()&&this.getEditable()){if(i||n){return;}}if(!F&&!N){s.isOpen()&&!this.isMobileDevice()&&t._togglePopup(s);t.setRenderMode(k.Narrow);}this._handleInnerVisibility();};
m.prototype.ontap=function(e){var t=this.getAggregation("tokenizer");if(document.activeElement===this._$input[0]||document.activeElement===t.getDomRef()){t.selectAllTokens(false);}if(e&&e.isMarked("tokenDeletePress")){return;}I.prototype.ontap.apply(this,arguments);};
m.prototype.onfocusin=function(e){var t=this.getAggregation("tokenizer");this._deregisterTokenizerResizeHandler();this._bValueHelpOpen=false;if(e.target===this.getFocusDomRef()){I.prototype.onfocusin.apply(this,arguments);if(t.hasOneTruncatedToken()){t.getTokens()[0].setSelected(false);!this.isMobileDevice()&&t.setFirstTokenTruncated(false);}}if(!this.isMobileDevice()&&this.getEditable()&&e.target===this.getDomRef("inner")&&!(this._getIsSuggestionPopupOpen())){t.setRenderMode(k.Loose);this._setValueVisible(true);}this._registerResizeHandler();};
m.prototype.onsapescape=function(e){var t=this.getAggregation("tokenizer"),p=t.getTokensPopup();this.getAggregation("tokenizer").selectAllTokens(false);this.selectText(0,0);if(p.isOpen()){t._togglePopup(p);}I.prototype.onsapescape.apply(this,arguments);};
m.prototype._completeTextIsSelected=function(){var i=this._$input[0];if(i.selectionStart!==0){return false;}if(i.selectionEnd!==this.getValue().length){return false;}return true;};
m.prototype._getIsSuggestionPopupOpen=function(){var s=this._getSuggestionsPopoverInstance(),o=this._getSuggestionsPopoverPopup();return s&&o&&o.isOpen();};
m.prototype.setEditable=function(e){var t=this.getAggregation("tokenizer");e=this.validateProperty("editable",e);if(e===this.getEditable()){return this;}if(I.prototype.setEditable){I.prototype.setEditable.apply(this,arguments);}t.setEditable(e);return this;};
m.prototype._findItem=function(t,e,n,G){if(!t){return;}if(!(e&&e.length)){return;}t=t.toLowerCase();var o=e.length;for(var i=0;i<o;i++){var p=e[i];var s=G(p);if(!s){continue;}s=s.toLowerCase();if(s===t){return p;}if(!n&&s.indexOf(t)===0){return p;}}};
m.prototype._getSuggestionItem=function(t,e){var n=null;var o=null;if(this._hasTabularSuggestions()){n=this.getSuggestionRows();o=this._findItem(t,n,e,function(p){var s=p.getCells();var u=null;if(s){var i;for(i=0;i<s.length;i++){if(s[i].getText){u=s[i].getText();break;}}}return u;});}else{n=this.getSuggestionItems();o=this._findItem(t,n,e,function(o){return o.getText();});}return o;};
m.prototype.clone=function(){var C,t=this.getAggregation("tokenizer");this.detachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.detachLiveChange(this._onLiveChange,this);t.detachTokenChange(this._onTokenChange,this);t.detachTokenUpdate(this._onTokenUpdate,this);this.detachValueHelpRequest(this._onValueHelpRequested,this);C=I.prototype.clone.apply(this,arguments);this.attachSuggestionItemSelected(this._onSuggestionItemSelected,this);this.attachLiveChange(this._onLiveChange,this);t.attachTokenChange(this._onTokenChange,this);t.attachTokenUpdate(this._onTokenUpdate,this);this.attachValueHelpRequest(this._onValueHelpRequested,this);return C;};
m.getMetadata().forwardAggregation("tokens",{getter:function(){return this.getAggregation("tokenizer");},aggregation:"tokens",forwardBinding:true});
m.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("content");};
m.prototype.setTokens=function(t){var v,V=[],i;if(Array.isArray(t)){for(i=0;i<t.length;i++){v=this.validateAggregation("tokens",t[i],true);M.addAPIParentInfoBegin(t[i],this,"tokens");V.push(v);}this.getAggregation("tokenizer").setTokens(V);for(i=0;i<t.length;i++){M.addAPIParentInfoEnd(t[i]);}}else{throw new Error("\""+t+"\" is of type "+typeof t+", expected array for aggregation tokens of "+this);}return this;};
m.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};m.WaitForAsyncValidation="sap.m.MultiInput.WaitForAsyncValidation";m.prototype.getDomRefForValueStateMessage=m.prototype.getPopupAnchorDomRef;
m.prototype.updateInputField=function(n){I.prototype.updateInputField.call(this,n);var s=this._getSuggestionsPopoverInstance();this.setDOMValue('');if(s._oPopupInput){s._oPopupInput.setDOMValue('');}};
m.prototype.onChange=function(e,p,n){p=p||this.getChangeEventParams();if(!this.getEditable()||!this.getEnabled()){return;}var v=this._getInputValue(n);if(v===this.getLastValue()){this._bCheckDomValue=false;return;}if(!this._bTokenIsValidated){this.setValue(v);v=this.getValue();this.setLastValue(v);}this.fireChangeEvent(v,p);return true;};
m.prototype.getAccessibilityInfo=function(){var t=this.getTokens().map(function(o){return o.getText();}).join(" ");var i=I.prototype.getAccessibilityInfo.apply(this,arguments);i.type=r.getText("ACC_CTR_TYPE_MULTIINPUT");i.description=((i.description||"")+" "+t).trim();return i;};
m.prototype._modifyPopupInput=function(p){var t=this;p.addEventDelegate({oninput:t._manageListsVisibility.bind(t,false),onsapenter:function(e){if(p.getValue()){t._closeSuggestionPopup();}t._validateCurrentText();t._setValueVisible(false);t.onChange(e,null,p.getValue());}});return p;};
m.prototype._hasShowSelectedButton=function(){return true;};
m.prototype.forwardEventHandlersToSuggPopover=function(s){I.prototype.forwardEventHandlersToSuggPopover.apply(this,arguments);s.setShowSelectedPressHandler(this._handleShowSelectedPress.bind(this));};
m.prototype._handleShowSelectedPress=function(e){this._bShowListWithTokens=e.getSource().getPressed();this._manageListsVisibility(this._bShowListWithTokens);};
m.prototype._onBeforeOpenTokensPicker=function(){var t=this.getAggregation("tokenizer"),p=t.getTokensPopup(),o=this.getDomRef(),e=this.getEditable(),w;this._setValueVisible(false);this._manageListsVisibility(true);if(o&&p){w=(t.getTokens().length===1)?"auto":(o.offsetWidth/parseFloat(l.BaseFontSize))+"rem";p.setContentWidth(e?w:"auto");}};
m.prototype.getDialogTitle=function(){var p=this._getSuggestionsPopoverPopup(),H=p&&p.getCustomHeader();if(H){return H.getContentMiddle()[0];}return null;};
m.prototype._updatePickerHeaderTitle=function(){var o,e;e=this.getLabels();if(e.length){o=e[0];if(o&&(typeof o.getText==="function")){this.getDialogTitle().setText(o.getText());}}else{this.getDialogTitle().setText(r.getText("COMBOBOX_PICKER_TITLE"));}};
m.prototype._getSuggestionsList=function(){var s=this._getSuggestionsPopoverInstance();return s&&s._oList;};
m.prototype._getSuggestionsPopoverInstance=function(){return this._oSuggPopover;};
m.prototype._getSuggestionsPopoverPopup=function(){return this._oSuggestionPopup;};
m.prototype._manageListsVisibility=function(s){if(!this.isMobileDevice()){return;}this.getAggregation("tokenizer")._getTokensList().setVisible(s);this._getSuggestionsList()&&this._getSuggestionsList().setVisible(!s);this._getSuggestionsPopover().getFilterSelectedButton().setPressed(s);};
m.prototype._handleNMoreAccessibility=function(){var i=j.getStaticId("sap.m","MULTICOMBOBOX_OPEN_NMORE_POPOVER"),F=this.getFocusDomRef(),A=(F&&F.getAttribute("aria-labelledby")),e=A?A.split(" "):[],n=e.indexOf(i),o=this.getEnabled(),N=!this.getEditable()&&this.getAggregation("tokenizer").getHiddenTokensCount();if(N&&n===-1){e.push(i);o&&this.getFocusDomRef().setAttribute("aria-keyshortcuts","Enter");}else if(n!==-1&&!N){e.splice(n,1);this.getFocusDomRef().removeAttribute("aria-keyshortcuts");}if(F&&e.length){F.setAttribute("aria-labelledby",e.join(" ").trim());}};
m.prototype._calculateSpaceForTokenizer=function(){var o=this.getDomRef();if(o){var s,e=this.$().find(".sapMInputDescriptionWrapper"),i=this.$().find(".sapMInputBaseInner"),C=o.offsetWidth||0,n=e.width()||0,p=this._calculateIconsSpace(),t=["min-width","padding-right","padding-left"],u=t.reduce(function(A,v){return A+(parseInt(i.css(v))||0);},0);s=C-(p+u+n);s=s<0?0:s;return s+"px";}else{return null;}};
m.prototype._syncInputWidth=function(t){var F=this.getDomRef('inner'),s,i;if(!F||(t&&!t.getDomRef())){return;}s=this._calculateIconsSpace();i=Math.ceil(t.getDomRef().getBoundingClientRect().width);F.style.width='calc(100% - '+Math.floor(s+i)+"px";};
m.prototype.isValueHelpOnlyOpener=function(t){return[this._$input[0],this._getValueHelpIcon().getDomRef()].indexOf(t)>-1;};
m.prototype._shouldTriggerSuggest=function(){var s=I.prototype._shouldTriggerSuggest.apply(this,arguments);return s&&!this._bShowListWithTokens;};
m.prototype.addValidator=function(v){if(typeof(v)==="function"){this._aTokenValidators.push(v);}};
m.prototype.removeValidator=function(v){var i=this._aTokenValidators.indexOf(v);if(i!==-1){this._aTokenValidators.splice(i,1);}};
m.prototype.removeAllValidators=function(){this._aTokenValidators=[];};
m.prototype.getValidators=function(){return this._aTokenValidators;};
m.prototype.addValidateToken=function(p,v){var t=this._validateToken(p,v),A=this._addUniqueToken(t,p.validationCallback);if(A){this.fireTokenUpdate({addedTokens:[t],removedTokens:[],type:T.TokenUpdateType.Added});this.fireTokenChange({addedTokens:[t],removedTokens:[],type:T.TokenChangeType.TokensChanged});}};
m.prototype._validateToken=function(p,v){var t=p.token,V=p.validationCallback,s=p.suggestionObject,e=t&&t.getText(),n=e?e:p.text,o;v=v?v:this._aTokenValidators;o=v.length;if(!o){if(!t&&V){V(false);}return t;}for(var i=0;i<o;i++){t=v[i]({text:n,suggestedToken:t,suggestionObject:s,asyncCallback:this._getAsyncValidationCallback(v,i,n,s,V)});if(!t){if(V){V(false);}return null;}if(t===m.WaitForAsyncValidation){return null;}}return t;};
m.prototype._addUniqueToken=function(t,v){if(!t){return false;}var e=!this._tokenExists(t);e&&this.addToken(t);if(v){v(e);}return e;};
m.prototype._tokenExists=function(t){var o=this.getTokens(),e=o.length,s=t&&t.getKey();if(!s){return false;}for(var i=0;i<e;i++){if(o[i].getKey()===s){return true;}}return false;};
m.prototype._convertTextToToken=function(t,C){var o=this.getAggregation("tokenizer"),O=o.getTokens().length,e=this._configureTokenOptions(t,false,C),v=e.text,i=e.item,n=e.token;if(!v){return null;}return this._validateToken({text:v,token:n,suggestionObject:i,validationCallback:this._validationCallback.bind(this,O)});};
m.prototype._validateCurrentText=function(e){var t=this.getAggregation("tokenizer"),o=t.getTokens().length,O=this._configureTokenOptions(this.getValue(),e),v=O.text,i=O.item,n=O.token;if(!v){return null;}if(i){this._bTokenIsAdded=true;}if(!this.getMaxTokens()||this.getTokens().length<this.getMaxTokens()){this._bIsValidating=true;this.addValidateToken({text:v,token:n,suggestionObject:i,validationCallback:this._validationCallback.bind(this,o)});}};
m.prototype._configureTokenOptions=function(v,e,p){var i,t;if(v&&this.getEditable()){v=v.trim();}if(v&&(e||p||this._getIsSuggestionPopupOpen())){if(this._hasTabularSuggestions()){i=this._oSuggestionTable.getSelectedItem();}else{i=this._getSuggestionItem(v,e);}}if(i&&i.getText&&i.getKey){t=new a({text:i.getText(),key:i.getKey()});}return{text:v,item:i,token:t};};
m.prototype._getAsyncValidationCallback=function(v,V,i,s,e){var t=this;return function(o){if(o){o=t.addValidateToken({text:i,token:o,suggestionObject:s,validationCallback:e},v.slice(V+1));}else{e&&e(false);}};};
return m;});
sap.ui.predefine('sap/m/MultiInputRenderer',['./InputRenderer','sap/ui/core/Renderer',"sap/ui/core/Core"],function(I,R,C){"use strict";var M=R.extend(I);M.apiVersion=2;
M.prependInnerContent=function(r,c){r.renderControl(c.getAggregation("tokenizer"));};
M.addOuterClasses=function(r,c){I.addOuterClasses.apply(this,arguments);r.class("sapMMultiInput");if(c.getTokens().length>0){r.class("sapMMultiInputHasTokens");}};
M.getAriaDescribedBy=function(c){var a=I.getAriaDescribedBy.apply(this,arguments),i=c.getAggregation("tokenizer")&&c.getAggregation("tokenizer").getTokensInfoId();if(a){a=a+" "+i;}else{a=i;}return a;};
M.getAccessibilityState=function(c){var a=I.getAccessibilityState.apply(this,arguments),r=C.getLibraryResourceBundle("sap.m");a.roledescription=r.getText("MULTIINPUT_ARIA_ROLE_DESCRIPTION");return a;};
return M;},true);
sap.ui.predefine('sap/m/NavContainer',['./library','sap/ui/core/Control','sap/ui/core/RenderManager','sap/ui/Device','./NavContainerRenderer',"sap/ui/thirdparty/jquery","sap/base/Log","sap/ui/dom/jquery/Focusable"],function(a,C,R,D,N,q,L){"use strict";
var b=C.extend("sap.m.NavContainer",{metadata:{library:"sap.m",properties:{autoFocus:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},visible:{type:"boolean",group:"Appearance",defaultValue:true},defaultTransitionName:{type:"string",group:"Appearance",defaultValue:"slide"}},defaultAggregation:"pages",aggregations:{pages:{type:"sap.ui.core.Control",multiple:true,singularName:"page"}},associations:{initialPage:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}}}});
var u=sap.ui.getCore().getConfiguration().getAnimation(),g=function(d){return u?d:0;},h=function(c){return!!(c&&c.getParent());},s=function(p,d){if(h(p)){p.$().css({'-webkit-animation-direction':d,'animation-direction':d});}};b.TransitionDirection={BACK:"back",TO:"to"};
b.prototype.init=function(){this._pageStack=[];this._aQueue=[];this._mVisitedPages={};this._mFocusObject={};this._iTransitionsCompleted=0;this._bNeverRendered=true;this._bNavigating=false;this._bRenderingInProgress=false;};
b.prototype.exit=function(){this._mFocusObject=null;};
b.prototype.onBeforeRendering=function(){var p=this.getCurrentPage();if(this._bNeverRendered&&p){var c=p.getId();if(!this._mVisitedPages[c]){this._mVisitedPages[c]=true;var n={from:null,fromId:null,to:p,toId:c,firstTime:true,isTo:false,isBack:false,isBackToPage:false,isBackToTop:false,direction:"initial"};var e=q.Event("BeforeFirstShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);e=q.Event("BeforeShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);}}};
b.prototype.onAfterRendering=function(){var p=this.getCurrentPage(),f,n,c,e;if(this._bNeverRendered&&p){this._bNeverRendered=false;delete this._bNeverRendered;c=p.getId();if(!this._isInsideAPopup()&&this.getAutoFocus()){f=b._applyAutoFocusTo(c);if(f){this._mFocusObject[c]=f;}}n={from:null,fromId:null,to:p,toId:c,firstTime:true,isTo:false,isBack:false,isBackToTop:false,isBackToPage:false,direction:"initial"};e=q.Event("AfterShow",n);e.srcControl=this;e.data=this._oToDataBeforeRendering||{};e.backData={};p._handleEvent(e);}};
b.prototype._getActualInitialPage=function(){var p=this.getInitialPage();if(p){var c=sap.ui.getCore().byId(p);if(c){return c;}else{L.error("NavContainer: control with ID '"+p+"' was set as 'initialPage' but was not found as a DIRECT child of this NavContainer (number of current children: "+this.getPages().length+").");}}var d=this.getPages();return(d.length>0?d[0]:null);};
b.prototype.getPage=function(p){var P=this.getPages();for(var i=0;i<P.length;i++){if(P[i]&&(P[i].getId()==p)){return P[i];}}return null;};
b.prototype._ensurePageStackInitialized=function(d){if(this._pageStack.length===0){var p=this._getActualInitialPage();if(p){this._pageStack.push({id:p.getId(),isInitial:true,data:d||{}});}}return this._pageStack;};
b.prototype.getCurrentPage=function(){var c=this._ensurePageStackInitialized();if(c.length>=1){return this.getPage(c[c.length-1].id);}else{L.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");return undefined;}};
b.prototype.getPreviousPage=function(){var c=this._ensurePageStackInitialized();if(c.length>1){return this.getPage(c[c.length-2].id);}else if(c.length==1){return undefined;}else{L.warning(this+": page stack is empty but should have been initialized - application failed to provide a page to display");}};
b.prototype.currentPageIsTopPage=function(){var c=this._ensurePageStackInitialized();return(c.length===1);};
b.prototype.insertPreviousPage=function(p,t,d){var c=this._ensurePageStackInitialized();if(this._pageStack.length>0){var i=c.length-1;var e={id:p,transition:t,data:d};if(i===0){e.isInitial=true;delete c[c.length-1].isInitial;}c.splice(i,0,e);}else{L.warning(this+": insertPreviousPage called with empty page stack; ignoring");}return this;};
b._applyAutoFocusTo=function(i){var f=q(document.getElementById(i)).firstFocusableDomRef();if(f){f.focus();}return f;};
b.prototype._applyAutoFocus=function(n){var p=n.toId,d,c=n.isBack||n.isBackToPage||n.isBackToTop;if(!n.bFocusInsideFromPage){return;}if(c){d=this._mFocusObject!=null?this._mFocusObject[p]:null;if(d){d.focus();}else{b._applyAutoFocusTo(p);}}else if(n.isTo){b._applyAutoFocusTo(p);}};
b.prototype._afterTransitionCallback=function(n,d,B){var e=q.Event("AfterShow",n);e.data=d||{};e.backData=B||{};e.srcControl=this;n.to._handleEvent(e);e=q.Event("AfterHide",n);e.srcControl=this;n.from._handleEvent(e);this._iTransitionsCompleted++;this._bNavigating=false;if(this.getAutoFocus()){this._applyAutoFocus(n);}this.fireAfterNavigate(n);L.info(this+": _afterTransitionCallback called, to: "+n.toId);if(n.to.hasStyleClass("sapMNavItemHidden")){L.warning(this.toString()+": target page '"+n.toId+"' still has CSS class 'sapMNavItemHidden' after transition. This should not be the case, please check the preceding log statements.");n.to.removeStyleClass("sapMNavItemHidden");}this._dequeueNavigation();};
b.prototype._dequeueNavigation=function(){var n=this._aQueue.shift();if(typeof n==="function"){n();}};
b.prototype._isInPageStack=function(p){return this._pageStack.some(function(P){return P.id===p;});};
b.prototype._safeBackToPage=function(p,t,d,T){var c;if(!this.getPage(p)){return this;}c=this.getCurrentPage();if(c&&c.getId()===p){return this;}if(this._isInPageStack(p)){return this.backToPage(p,d,T);}else{d=d||{};d.safeBackToPage=true;return this.to(p,t,d,T);}};
b.prototype._isFocusInControl=function(c){return q(document.activeElement).closest(c.$()).length>0;};
b.prototype.to=function(p,t,d,T,f){if(p instanceof C){p=p.getId();}if(typeof(t)!=="string"){T=d;d=t;}t=t||this.getDefaultTransitionName();T=T||{};d=d||{};var F={id:p,transition:t,data:d};this._ensurePageStackInitialized(d);if(this._bNavigating){L.info(this.toString()+": Cannot navigate to page "+p+" because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this.to(p,t,d,T,true);},this));return this;}if(this._bNeverRendered){this._oToDataBeforeRendering=d;}var o=this.getCurrentPage();if(o&&(o.getId()===p)){L.warning(this.toString()+": Cannot navigate to page "+p+" because this is the current page.");if(f){this._dequeueNavigation();}if(this._pageStack.length===1){this._pageStack[0].transition=F.transition;}return this;}var c=this.getPage(p);if(c){if(!o){L.warning("Navigation triggered to page with ID '"+p+"', but the current page is not known/aggregated by "+this);return this;}var n={from:o,fromId:o.getId(),to:c,toId:p,firstTime:!this._mVisitedPages[p],isTo:true,isBack:false,isBackToTop:false,isBackToPage:false,direction:"to",bFocusInsideFromPage:this._isFocusInControl(o)};if(n.bFocusInsideFromPage){this._mFocusObject[o.getId()]=document.activeElement;}var e=this.fireNavigate(n);if(e){a.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;o._handleEvent(E);if(!this._mVisitedPages[p]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.data=d||{};E.backData={};c._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.data=d||{};E.backData={};c._handleEvent(E);this._pageStack.push(F);L.info(this.toString()+": navigating to page '"+p+"': "+c.toString());this._mVisitedPages[p]=true;if(!this.getDomRef()){L.info("'Hidden' 'to' navigation in not-rendered NavContainer "+this.toString());if(this._bRenderingInProgress){setTimeout(this.invalidate.bind(this),0);}return this;}var i;if(!(i=c.getDomRef())||i.parentNode!=this.getDomRef()||R.isPreservedContent(i)){c.addStyleClass("sapMNavItemRendering");L.debug("Rendering 'to' page '"+c.toString()+"' for 'to' navigation");var r=sap.ui.getCore().createRenderManager();r.render(c,this.getDomRef());r.destroy();c.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}var j=b.transitions[t]||b.transitions["slide"];var k=this._iTransitionsCompleted;var l=this;window.setTimeout(function(){if(l&&(l._iTransitionsCompleted<k+1)){L.warning("Transition '"+t+"' 'to' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var m=(d.safeBackToPage||T.safeBackToPage)?"back":"to";this._cacheTransitionInfo(t,m);j[m].call(this,o,c,q.proxy(function(){this._afterTransitionCallback(n,d);},this),T);}else{L.info("Navigation to page with ID '"+p+"' has been aborted by the application");}}else{L.warning("Navigation triggered to page with ID '"+p+"', but this page is not known/aggregated by "+this);}return this;};
b.prototype.back=function(c,t){this._backTo("back",c,t);return this;};
b.prototype.backToPage=function(p,c,t){this._backTo("backToPage",c,t,p);return this;};
b.prototype.backToTop=function(c,t){this._backTo("backToTop",c,t);return this;};
b.prototype._backTo=function(t,c,T,r){if(this._bNavigating){L.warning(this.toString()+": Cannot navigate back because another navigation is already in progress. - navigation will be executed after the previous one");this._aQueue.push(q.proxy(function(){this._backTo(t,c,T,r);},this));return this;}if(this._pageStack.length<=1){if(this._pageStack.length===1&&!this._pageStack[0].isInitial){throw new Error("Initial page not found on the stack. How did this happen?");}this._aQueue=[];return this;}else{if(r instanceof C){r=r.getId();}var f=this._pageStack[this._pageStack.length-1];var d=f.transition;var F=this.getPage(f.id);var o;var e;if(t==="backToTop"){o=this._getActualInitialPage();e=null;}else if(t==="backToPage"){var i=this._findClosestPreviousPageInfo(r);if(!i){L.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page was not found among the previous pages.");return this;}o=sap.ui.getCore().byId(i.id);if(!o){L.error(this.toString()+": Cannot navigate backToPage('"+r+"') because target page does not exist anymore.");return this;}e=i.data;}else{o=this.getPreviousPage();e=this._pageStack[this._pageStack.length-2].data;}if(!o){L.error("NavContainer back navigation: target page is not defined or not aggregated by this NavContainer. Aborting navigation.");return;}var j=o.getId();c=c||{};T=T||{};var n={from:F,fromId:F.getId(),to:o,toId:j,firstTime:!this._mVisitedPages[j],isTo:false,isBack:(t==="back"),isBackToPage:(t==="backToPage"),isBackToTop:(t==="backToTop"),direction:t,bFocusInsideFromPage:this._isFocusInControl(F)};var k=this.fireNavigate(n);if(k){a.closeKeyboard();var E=q.Event("BeforeHide",n);E.srcControl=this;F._handleEvent(E);if(!this._mVisitedPages[j]){E=q.Event("BeforeFirstShow",n);E.srcControl=this;E.backData=c||{};E.data={};o._handleEvent(E);}E=q.Event("BeforeShow",n);E.srcControl=this;E.backData=c||{};E.data=e||{};o._handleEvent(E);this._pageStack.pop();L.info(this.toString()+": navigating back to page "+o.toString());this._mVisitedPages[j]=true;if(t==="backToTop"){this._pageStack=[];L.info(this.toString()+": navigating back to top");this.getCurrentPage();}else if(t==="backToPage"){var p=[],l;while(this._pageStack[this._pageStack.length-1].id!==r){l=this._pageStack.pop();p.push(l.id);}L.info(this.toString()+": navigating back to specific page "+o.toString()+" across the pages: "+p.join(", "));}if(!this.getDomRef()){L.info("'Hidden' back navigation in not-rendered NavContainer "+this.toString());return this;}var m=b.transitions[d]||b.transitions["slide"];var v=this._iTransitionsCompleted;var w=this;window.setTimeout(function(){if(w&&(w._iTransitionsCompleted<v+1)){L.warning("Transition '"+d+"' 'back' was triggered five seconds ago, but has not yet invoked the end-of-transition callback.");}},g(5000));this._bNavigating=true;var x;if(!(x=o.getDomRef())||x.parentNode!=this.getDomRef()||R.isPreservedContent(x)){o.addStyleClass("sapMNavItemRendering");L.debug("Rendering 'to' page '"+o.toString()+"' for back navigation");var y=sap.ui.getCore().createRenderManager();var z=this.$().children().index(F.getDomRef());y.renderControl(o);y.flush(this.getDomRef(),false,z);y.destroy();o.addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemRendering");}if(F.getId()===o.getId()){L.info("Transition is skipped when navigating back to the same page instance"+o.toString());this._afterTransitionCallback(n,e,c);return this;}this._cacheTransitionInfo(d,b.TransitionDirection.BACK);m.back.call(this,F,o,q.proxy(function(){this._afterTransitionCallback(n,e,c);},this),T);}}return this;};
b.prototype._findClosestPreviousPageInfo=function(r){for(var i=this._pageStack.length-2;i>=0;i--){var c=this._pageStack[i];if(c.id===r){return c;}}return null;};
b.prototype._cacheTransitionInfo=function(t,T){this._sTransitionName=t;this._sTransitionDirection=T;};
b.prototype._fadeTransition=function(f,t,c){this.oFromPage=f;this.oToPage=t;this.fCallback=c;this._fadeOutAnimation();};
b.prototype._fadeOutAnimation=function(){var t=this,f=this.oFromPage,T=this.oToPage;T.addStyleClass("sapMNavItemTransparent");if(this._sTransitionName==="slide"){if(this._sTransitionDirection===b.TransitionDirection.TO){T.addStyleClass("sapMNavItemSlideLeft");f.addStyleClass("sapMNavItemSlideRight");}else{T.addStyleClass("sapMNavItemSlideRight");f.addStyleClass("sapMNavItemSlideLeft");}}T.removeStyleClass("sapMNavItemHidden");f.addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){f.$().on("webkitTransitionEnd transitionend",t._fadeOutAnimationEnd.bind(t));t.bTransition1EndPending=true;f.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque").addStyleClass("sapMNavItemTransparent");window.setTimeout(function(){if(t.bTransition1EndPending){t._fadeOutAnimationEnd();}},g(150));},g(10));};
b.prototype._fadeOutAnimationEnd=function(e){var f=this.oFromPage;this.bTransition1EndPending=false;if(e&&e.originalEvent&&e.originalEvent.propertyName!=="opacity"){return;}q(f.$()).off("webkitTransitionEnd transitionend");f.removeStyleClass("sapMNavItemSlideLeft").removeStyleClass("sapMNavItemSlideRight");this._fadeInAnimation();};
b.prototype._fadeInAnimation=function(){var t=this,T=this.oToPage;window.setTimeout(function(){T.$().on("webkitTransitionEnd transitionend",t._fadeInAnimationEnd.bind(t));t.bTransition2EndPending=true;T.addStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent").addStyleClass("sapMNavItemOpaque");window.setTimeout(function(){if(t.bTransition2EndPending){t._fadeInAnimationEnd();}},g(150));},g(10));};
b.prototype._fadeInAnimationEnd=function(e){var t=this.oToPage,f=this.oFromPage;this.bTransition2EndPending=false;if(e&&e.originalEvent&&e.originalEvent.propertyName!=="opacity"){return;}if(h(f)){f.addStyleClass("sapMNavItemHidden");f.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemTransparent");}q(t.$()).off("webkitTransitionEnd transitionend");if(h(t)){t.removeStyleClass("sapMNavItemFading").removeStyleClass("sapMNavItemOpaque").removeStyleClass("sapMNavItemSlideLeft").removeStyleClass("sapMNavItemSlideRight");}this.fCallback();};
b.prototype._baseSlideAnimation=function(f,t,c){var F=false,T=true,i=this._sTransitionDirection===b.TransitionDirection.BACK,A=i?"reverse":"normal",d=i?"sapMNavItemSlideCenterToLeft":"sapMNavItemSlideRightToCenter",e=!i?"sapMNavItemSlideCenterToLeft":"sapMNavItemSlideRightToCenter",j=function(){q(this).off("webkitAnimationEnd animationend");if(!F){return(F=true);}T=false;s(t,"");s(f,"");if(h(t)){t.removeStyleClass(d);}if(h(f)){f.removeStyleClass(e).addStyleClass("sapMNavItemHidden");}c();};f.$().on("webkitAnimationEnd animationend",j);t.$().on("webkitAnimationEnd animationend",j);s(t,A);s(f,A);f.addStyleClass(e);t.addStyleClass(d).removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){if(T){F=true;j.apply(f.$().add(t.$()));}},g(400));};
b.transitions=b.transitions||{};b.transitions["show"]={to:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();},back:function(f,t,c){t.removeStyleClass("sapMNavItemHidden");f&&f.addStyleClass("sapMNavItemHidden");c();}};b.transitions["baseSlide"]={to:b.prototype._baseSlideAnimation,back:b.prototype._baseSlideAnimation};b.transitions["slide"]={to:b.prototype._fadeTransition,back:b.prototype._fadeTransition};b.transitions["fade"]={to:b.prototype._fadeTransition,back:b.prototype._fadeTransition};b.transitions["flip"]={to:function(f,t,c){var d=this;window.setTimeout(function(){d.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemFlipping");}if(h(f)){f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipPrevious");}d.$().removeClass("sapMNavFlip");c();}};f.$().on("webkitTransitionEnd transitionend",A);t.$().on("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipNext");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));},0);},back:function(f,t,c){var d=this;d.$().addClass("sapMNavFlip");t.addStyleClass("sapMNavItemFlipPrevious");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitTransitionEnd transitionend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemFlipping");}if(h(f)){f.removeStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemFlipNext");}d.$().removeClass("sapMNavFlip");c();}};f.$().on("webkitTransitionEnd transitionend",A);t.$().on("webkitTransitionEnd transitionend",A);t.addStyleClass("sapMNavItemFlipping").removeStyleClass("sapMNavItemFlipPrevious");f.addStyleClass("sapMNavItemFlipping").addStyleClass("sapMNavItemFlipNext");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(600));},g(60));}};b.transitions["door"]={to:function(f,t,c){var d=this;window.setTimeout(function(){d.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorInNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorInNext");}if(h(f)){f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorInPrevious");}d.$().removeClass("sapMNavDoor");c();}};f.$().on("webkitAnimationEnd animationend",A);t.$().on("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorInPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));},0);},back:function(f,t,c){var d=this;d.$().addClass("sapMNavDoor");t.addStyleClass("sapMNavItemDoorOutNext");t.removeStyleClass("sapMNavItemHidden");window.setTimeout(function(){var o=false;var T=true;var A=null;A=function(){q(this).off("webkitAnimationEnd animationend");if(!o){o=true;}else{T=false;if(h(t)){t.removeStyleClass("sapMNavItemDooring").removeStyleClass("sapMNavItemDoorOutNext");}if(h(f)){f.removeStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemHidden").removeStyleClass("sapMNavItemDoorOutPrevious");}d.$().removeClass("sapMNavDoor");c();}};f.$().on("webkitAnimationEnd animationend",A);t.$().on("webkitAnimationEnd animationend",A);t.addStyleClass("sapMNavItemDooring");f.addStyleClass("sapMNavItemDooring").addStyleClass("sapMNavItemDoorOutPrevious");window.setTimeout(function(){if(T){o=true;A.apply(f.$().add(t.$()));}},g(1000));},g(60));}};
b.prototype.addCustomTransition=function(n,t,B){if(b.transitions[n]){L.warning("Transition with name "+n+" already exists in "+this+". It is now being replaced by custom transition.");}b.transitions[n]={to:t,back:B};return this;};
b.addCustomTransition=b.prototype.addCustomTransition;b.prototype.forceInvalidation=b.prototype.invalidate;
b.prototype.invalidate=function(S){if(S==this){}else if(!S){this.forceInvalidation();}else if(S instanceof C){var I=false,p=this.getPages(),l=p.length;for(var i=0;i<l;i++){if(p[i]===S){I=true;break;}}if((!I||S===this.getCurrentPage())&&!this._isInsideAPopup()){this.forceInvalidation();}}else{this.forceInvalidation();}};
b.prototype._isInsideAPopup=function(){var S;S=function(c){if(!c){return false;}if(c.getMetadata().isInstanceOf("sap.ui.core.PopupInterface")){return true;}return S(c.getParent());};return S(this);};
b.prototype.removePage=function(p){var P;if(typeof(p)=="number"){P=this.getPages()[p];}else if(typeof(p)=="string"){P=sap.ui.getCore().byId(p);}else{P=p;}P=this.removeAggregation("pages",P,P!==this.getCurrentPage());this._onPageRemoved(P);return P;};
b.prototype._onPageRemoved=function(p){if(!p){return;}p.$().remove();p.removeStyleClass("sapMNavItemHidden");p.removeStyleClass("sapMNavItem");var S=this._ensurePageStackInitialized();this._pageStack=S.filter(function(P){return p.getId()!==P.id;});};
b.prototype.removeAllPages=function(){var p=this.removeAllAggregation("pages");for(var i=0;i<p.length;i++){this._onPageRemoved(p[i]);}return p;};
b.prototype.addPage=function(p){var P=this.getPages();if(P.indexOf(p)>-1){return this;}this.addAggregation("pages",p,true);p.addStyleClass("sapMNavItem");var i=P.length;if(i===0&&this.getPages().length===1){this._fireAdaptableContentChange(p);if(this.getDomRef()){this._ensurePageStackInitialized();this.rerender();}}return this;};
b.prototype.insertPage=function(p,i){var P=this.getPages().length;this.insertAggregation("pages",p,i,true);p.addStyleClass("sapMNavItem");if(P===0&&this.getPages().length===1){this._fireAdaptableContentChange(p);if(this.getDomRef()){this._ensurePageStackInitialized();this.rerender();}}return this;};
b.prototype._getAdaptableContent=function(){return this.getCurrentPage();};
b.prototype._fireAdaptableContentChange=function(p){if(p&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":p});}};
return b;});
sap.ui.predefine('sap/m/NavContainerRenderer',["sap/ui/core/InvisibleRenderer"],function(I){"use strict";var N={apiVersion:2};
N.render=function(r,c){c._bRenderingInProgress=true;if(!c.getVisible()){I.render(r,c,"div");return false;}var h=c.getHeight(),t=c.getTooltip_AsString(),C=c.getCurrentPage();r.openStart("div",c);r.class("sapMNav");r.style("width",c.getWidth());if(h&&h!="100%"){r.style("height",h);}if(this.renderAttributes){this.renderAttributes(r,c);}if(t){r.attr("title",t);}r.openEnd();if(this.renderBeforeContent){this.renderBeforeContent(r,c);}c.getPages().forEach(function(p){if(p===C){C.removeStyleClass("sapMNavItemHidden");r.renderControl(C);}else{r.cleanupControlWithoutRendering(p);}});r.close("div");c._bRenderingInProgress=false;};
return N;},true);
sap.ui.predefine('sap/m/NewsContent',['./library','sap/ui/core/Control','sap/m/Text','sap/ui/Device','./NewsContentRenderer',"sap/ui/events/KeyCodes"],function(l,C,T,D,N,K){"use strict";
var a=C.extend("sap.m.NewsContent",{metadata:{library:"sap.m",designtime:"sap/m/designtime/NewsContent.designtime",properties:{"size":{type:"sap.m.Size",group:"Misc",defaultValue:"Auto"},"contentText":{type:"string",group:"Misc",defaultValue:null},"subheader":{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"_contentText",aggregations:{"_contentText":{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{"press":{}}}});
a.prototype.init=function(){this._oContentText=new T(this.getId()+"-content-text",{maxLines:2});this._oContentText.cacheLineHeight=false;this.setAggregation("_contentText",this._oContentText,true);this.setTooltip("{AltText}");};
a.prototype.onBeforeRendering=function(){this._setPointerOnContentText();this.$().off("mouseenter");this.$().off("mouseleave");};
a.prototype.onAfterRendering=function(){this.$().on("mouseenter",this._addTooltip.bind(this));this.$().on("mouseleave",this._removeTooltip.bind(this));};
a.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
a.prototype._removeTooltip=function(){this.$().attr("title",null);};
a.prototype._setPointerOnContentText=function(){var t=this.getAggregation("_contentText");if(t&&this.hasListeners("press")){t.addStyleClass("sapMPointer");}else if(t&&t.hasStyleClass("sapMPointer")){t.removeStyleClass("sapMPointer");}};
a.prototype.getAltText=function(){var A="";var i=true;if(this.getAggregation("_contentText").getText()){A+=this.getAggregation("_contentText").getText();i=false;}if(this.getSubheader()){if(i){A+=""+this.getSubheader();}else{A+="\n"+this.getSubheader();}}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var s=this.getAltText();if(typeof t==="string"||t instanceof String){s=t.split("{AltText}").join(s).split("((AltText))").join(s);return s;}if(t){return t;}else{return"";}};
a.prototype.setContentText=function(t){this._oContentText.setText(t);return this.setProperty("contentText",t,true);};
a.prototype.ontap=function(e){if(D.browser.msie){this.$().trigger("focus");}this.firePress();};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
a.prototype.attachEvent=function(e,d,f,b){C.prototype.attachEvent.call(this,e,d,f,b);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnContentText();}return this;};
a.prototype.detachEvent=function(e,f,b){C.prototype.detachEvent.call(this,e,f,b);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnContentText();}return this;};
return a;});
sap.ui.predefine('sap/m/NewsContentRenderer',[],function(){"use strict";var N={};
N.render=function(r,c){var s=c.getSubheader();var t=c.getTooltip_AsString();if(typeof t!=="string"){t="";}r.write("<div");r.writeControlData(c);r.writeAttribute("role","presentation");r.writeAttributeEscaped("aria-label",t);r.addClass("sapMNwC");if(c.hasListeners("press")){r.addClass("sapMPointer");r.writeAttribute("tabindex","0");}r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMNwCCTxt");r.writeClasses();r.write(">");r.renderControl(c._oContentText);r.write("</div>");r.write("<div");r.writeAttribute("id",c.getId()+"-subheader");r.addClass("sapMNwCSbh");r.writeClasses();r.write(">");r.writeEscaped(s);r.write("</div>");r.write("</div>");};
return N;},true);
sap.ui.predefine('sap/m/NotificationListBase',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/Element','sap/ui/Device','./ListItemBase','./Button','./ToolbarSeparator','sap/m/OverflowToolbar','sap/m/OverflowToolbarLayoutData','sap/ui/core/IconPool','sap/ui/core/Icon','sap/ui/core/library'],function(l,C,a,E,D,L,B,T,O,b,I,c,d){'use strict';var P=d.Priority;var e=l.ButtonType;var f=l.OverflowToolbarPriority;var r=C.getLibraryResourceBundle('sap.m'),g=r.getText('NOTIFICATION_LIST_ITEM_CLOSE'),h=r.getText('NOTIFICATION_LIST_GROUP_CLOSE');
var N=L.extend('sap.m.NotificationListBase',{
metadata:{library:'sap.m',"abstract":true,properties:{priority:{type:'sap.ui.core.Priority',group:'Appearance',defaultValue:P.None},title:{type:'string',group:'Appearance',defaultValue:''},datetime:{type:'string',group:'Appearance',defaultValue:''},showButtons:{type:'boolean',group:'Behavior',defaultValue:true},showCloseButton:{type:'boolean',group:'Behavior',defaultValue:true},authorName:{type:'string',group:'Appearance',defaultValue:''},authorPicture:{type:'sap.ui.core.URI'}},aggregations:{buttons:{type:'sap.m.Button',multiple:true},_closeButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"},_overflowToolbar:{type:'sap.m.OverflowToolbar',multiple:false,visibility:"hidden"},_priorityIcon:{type:'sap.ui.core.Icon',multiple:false,visibility:"hidden"}},events:{close:{}}},
renderer:null
});
N.prototype._activeHandling=function(){};
N.prototype.updateSelectedDOM=function(){};
N.prototype.getAccessibilityText=function(){return'';};
N.prototype.getButtons=function(){var i=this._getCloseButton(),t=this._getToolbarSeparator();return this._getOverflowToolbar().getContent().filter(function(j){return j!==i&&j!==t;},this);};
N.prototype.addButton=function(o){var i=this._getOverflowToolbar(),j=i.getContent().length;if(D.system.phone){j-=2;}i.insertContent(o,j);this.invalidate();return this;};
N.prototype.insertButton=function(o,i){this._getOverflowToolbar().insertContent(o,i);this.invalidate();return this;};
N.prototype.removeButton=function(o){var i=this._getOverflowToolbar().removeContent(o.getId());this.invalidate();return i;};
N.prototype.removeAllButtons=function(){var o=this._getOverflowToolbar(),i=this.getButtons();i.forEach(function(j){o.removeContent(j.getId());});this.invalidate();return this;};
N.prototype.destroyButtons=function(){var i=this.getButtons();i.forEach(function(j){j.destroy();});this.invalidate();return this;};
N.prototype.clone=function(){var i=L.prototype.clone.apply(this,arguments);i.destroyAggregation('_overflowToolbar');var o=this.getAggregation('_overflowToolbar');if(o){i.setAggregation("_overflowToolbar",o.clone(),true);}return i;};
N.prototype._getOverflowToolbar=function(){var o=this.getAggregation('_overflowToolbar'),t,i;if(!o){o=new O(this.getId()+'-overflowToolbar',{});this.setAggregation("_overflowToolbar",o,true);if(D.system.phone){i=this._getCloseButton();i.setLayoutData(new b({priority:f.AlwaysOverflow}));t=new T();t.setLayoutData(new b({priority:f.AlwaysOverflow}));o.addContent(t);o.addContent(i);}}return o;};
N.prototype._getCloseButton=function(){var i,o,j,k;if(D.system.phone){o=this._getOverflowToolbar();j=o.getContent();if(o&&j.length){k=j.length-1;i=j[k];}}else{i=this.getAggregation("_closeButton");}if(!i){if(D.system.phone){i=new B(this.getId()+'-closeButtonOverflow',{text:this.isA("sap.m.NotificationListItem")?g:h,type:e.Default,press:function(){this.close();}.bind(this)});}else{i=new B(this.getId()+'-closeButtonX',{icon:I.getIconURI('decline'),type:e.Transparent,tooltip:this.isA("sap.m.NotificationListItem")?g:h,press:function(){this.close();}.bind(this)});this.setAggregation("_closeButton",i);}}return i;};
N.prototype._getToolbarSeparator=function(){if(!D.system.phone){return null;}var t,o=this._getOverflowToolbar(),i=o.getContent(),j;if(o&&i.length){j=i.length-2;t=i[j];}return t;};
N.prototype.exit=function(){};
N.prototype._hasActionButtons=function(){return this.getShowButtons()&&this.getButtons().length;};
N.prototype._shouldRenderCloseButton=function(){return!D.system.phone&&this.getShowCloseButton();};
N.prototype._shouldRenderOverflowToolbar=function(){var i=this._hasActionButtons();if(D.system.phone){return i||this.getShowCloseButton();}return i;};
N.prototype.onBeforeRendering=function(){var j=this.getButtons(),k,m;if(D.system.phone){this._updatePhoneButtons();return;}k=j.length>1?f.AlwaysOverflow:f.NeverOverflow;for(var i=0;i<j.length;i++){m=j[i];m.setLayoutData(new b({priority:i===0?k:f.AlwaysOverflow}));}};
N.prototype._updatePhoneButtons=function(){var i=this._getCloseButton(),j=this.isA("sap.m.NotificationListGroup"),k=j?h:g,m=j&&this.getCollapsed(),n=!m&&this._hasActionButtons(),s=this.getShowCloseButton(),t=this._getToolbarSeparator(),p;this.getButtons().forEach(function(o){if(n){p=f.AlwaysOverflow;o.removeStyleClass('sapMNLIBHiddenButton');}else{p=f.NeverOverflow;o.addStyleClass('sapMNLIBHiddenButton');}o.setLayoutData(new b({priority:p}));});if(!s){i.setVisible(false);t.setVisible(false);return;}i.setVisible(true);if(n){i.setText(k);i.setTooltip('');i.setType(e.Default);i.setIcon('');i.setLayoutData(new b({priority:f.AlwaysOverflow}));t.setVisible(true);}else{i.setText('');i.setTooltip(k);i.setType(e.Transparent);i.setIcon(I.getIconURI('decline'));i.setLayoutData(new b({priority:f.NeverOverflow}));t.setVisible(false);}};
N.prototype.close=function(){var p=this.getParent();this.fireClose();var H=!!this.getParent();if(!H&&p&&p instanceof E){var i={onAfterRendering:function(){p.focus();p.removeEventDelegate(i);}};p.addEventDelegate(i);}};
N.prototype._getPriorityIcon=function(){var p=this.getAggregation('_priorityIcon');if(!p){p=new c({src:'sap-icon://message-error',useIconTooltip:false});this.setAggregation("_priorityIcon",p,true);}return p;};
return N;});
sap.ui.predefine('sap/m/NotificationListGroup',['./library','sap/ui/core/Core','./NotificationListBase','sap/ui/core/InvisibleText','./ListItemBase','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/m/Button','./NotificationListGroupRenderer',"sap/ui/events/KeyCodes"],function(l,C,N,I,L,a,c,D,B,b,K){'use strict';var P=c.Priority;var d=l.ButtonType;var R=C.getLibraryResourceBundle('sap.m'),E=R.getText('NOTIFICATION_LIST_GROUP_EXPAND'),e=R.getText('NOTIFICATION_LIST_GROUP_COLLAPSE'),f=R.getText('NOTIFICATION_LIST_GROUP_READ'),U=R.getText('NOTIFICATION_LIST_GROUP_UNREAD'),g='sap-icon://slim-arrow-right',h='sap-icon://slim-arrow-down';var m=D.system.desktop?400:100;
var i=N.extend('sap.m.NotificationListGroup',{metadata:{library:'sap.m',properties:{collapsed:{type:'boolean',group:'Behavior',defaultValue:false},autoPriority:{type:'boolean',group:'Behavior',defaultValue:true},showEmptyGroup:{type:'boolean',group:'Behavior',defaultValue:false},enableCollapseButtonWhenEmpty:{type:'boolean',group:'Behavior',defaultValue:false},showItemsCounter:{type:'boolean',group:'Behavior',defaultValue:true},authorName:{type:'string',group:'Appearance',defaultValue:'',deprecated:true},authorPicture:{type:'sap.ui.core.URI',multiple:false,deprecated:true},datetime:{type:'string',group:'Appearance',defaultValue:'',deprecated:true}},defaultAggregation:'items',aggregations:{items:{type:'sap.m.NotificationListItem',multiple:true,singularName:'item'},_collapseButton:{type:'sap.m.Button',multiple:false,visibility:"hidden"}},events:{onCollapse:{parameters:{collapsed:{type:'boolean'}}}}}});
i.prototype._getCollapseButton=function(){var k=this.getAggregation('_collapseButton'),n=this.getCollapsed();if(!k){k=new B(this.getId()+'-collapseButton',{type:d.Transparent,press:function(){var o=!this.getCollapsed();this.setCollapsed(o);this.fireOnCollapse({collapsed:o});}.bind(this)});this.setAggregation("_collapseButton",k,true);}k.setIcon(n?g:h);k.setTooltip(n?E:e);return k;};
i.prototype.init=function(){this._groupTitleInvisibleText=new I({id:this.getId()+"-invisibleGroupTitleText"});};
i.prototype.exit=function(){N.prototype.exit.apply(this,arguments);if(this._groupTitleInvisibleText){this._groupTitleInvisibleText.destroy();this._groupTitleInvisibleText=null;}};
i.prototype.getVisibleItems=function(){var v=this.getItems().filter(function(k){return k.getVisible();});return v;};
i.prototype._getVisibleItemsCount=function(){return this.getVisibleItems().length;};
i.prototype._getGroupTitleInvisibleText=function(){var r=this.getUnread()?U:f,p,k=this.getPriority(),n,o=[r];if(k!==P.None){p=R.getText('NOTIFICATION_LIST_GROUP_PRIORITY',k);o.push(p);}if(this.getShowItemsCounter()){n=R.getText("LIST_ITEM_COUNTER",[this._getVisibleItemsCount()]);o.push(n);}return this._groupTitleInvisibleText.setText(o.join(' '));};
i.prototype.getPriority=function(){if(!this.getAutoPriority()){return this.getProperty('priority');}var n=this.getAggregation('items');var p=P.None;if(n){n.forEach(function(k){p=j(p,k.getPriority());});}else{p=this.getProperty('priority');}return p;};
function j(k,s){if(k==s){return k;}if((k=='None')){return s;}if((k=='Low')&&(s!='None')){return s;}if((k=='Medium')&&(s!='None'&&s!='Low')){return s;}return k;}
i.prototype.onBeforeRendering=function(){N.prototype.onBeforeRendering.apply(this,arguments);this._getCollapseButton().setVisible(this.getEnableCollapseButtonWhenEmpty()||this._getVisibleItemsCount()>0);};
i.prototype._isMaxNumberReached=function(){return this.getItems().length>m;};
i.prototype._getMaxNumberReachedMsg=function(){return{title:R.getText('NOTIFICATION_LIST_GROUP_MAX_NOTIFICATIONS_TITLE',this.getItems().length-m),description:R.getText('NOTIFICATION_LIST_GROUP_MAX_NOTIFICATIONS_BODY')};};
return i;});
sap.ui.predefine('sap/m/NotificationListGroupRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer","sap/ui/Device"],function(c,I,D){'use strict';var N={apiVersion:2};var P=c.Priority;
N.render=function(r,a){if(!a.getVisible()){I.render(r,a,a.TagName);return false;}if(!a.getItems().length&&!a.getShowEmptyGroup()){return false;}var i=a.getCollapsed(),p=a.getPriority(),s=a.getShowItemsCounter(),b=a.getUnread(),v=a._getVisibleItemsCount(),m,C=a.getId(),g=C+'-groupTitle',d=C+'-invisibleGroupTitleText',A=g+' '+d;r.openStart('li',a).class('sapMLIB').class('sapMNLIB').class('sapMNLGroup');if(i){r.class('sapMNLGroupCollapsed');}if(b){r.class('sapMNLGroupUnread');}r.attr('tabindex','0');r.accessibilityState(a,{role:"option",expanded:!a.getCollapsed(),labelledby:{value:A}});r.openEnd();r.openStart('div').class('sapMNLGroupHeader').openEnd();r.openStart('div').class('sapMNLIItem').class('sapMNLGroupCollapseButton').openEnd();r.renderControl(a._getCollapseButton());r.close('div');if(p!==P.None){r.openStart('div').class('sapMNLIBPriority').class('sapMNLIBPriority'+p).openEnd();r.renderControl(a._getPriorityIcon());r.close('div');}r.openStart('div',C+'-groupTitle').class('sapMNLIItem').class('sapMNLGroupTitle').openEnd();r.text(a.getTitle());r.close('div');if(s){r.openStart('div').class('sapMNLGroupCount').openEnd();r.text('('+v+')');r.close('div');}r.openStart('div').class('sapMNLGroupHeaderSpacer').openEnd().close('div');r.openStart('div').class('sapMNLIItem').class('sapMNLIActions');if(!a._shouldRenderOverflowToolbar()||(i&&!D.system.phone)){r.style('display','none');}r.openEnd();if(a._shouldRenderOverflowToolbar()){r.renderControl(a._getOverflowToolbar());}r.close('div');if(a._shouldRenderCloseButton()){r.openStart('div').class('sapMNLIItem').class('sapMNLICloseBtn').openEnd();r.renderControl(a._getCloseButton());r.close('div');}r.renderControl(a._getGroupTitleInvisibleText());r.close('div');r.openStart('ul').class('sapMNLGroupChildren').attr('role','listbox').openEnd();a.getItems().forEach(function(e){r.renderControl(e);});if(a._isMaxNumberReached()){m=a._getMaxNumberReachedMsg();r.openStart('div').class('sapMNLGroupMaxNotifications').openEnd();r.openStart('div').class('sapMNLGroupMNTitle').openEnd();r.text(m.title);r.close('div');r.openStart('div').class('sapMNLGroupMNDescription').openEnd();r.text(m.description);r.close('div');r.close('div');}r.close('ul');r.close('li');};
return N;},true);
sap.ui.predefine('sap/m/NotificationListItem',['./library','sap/ui/core/Core','sap/ui/Device','./NotificationListBase','sap/ui/core/InvisibleText','sap/ui/core/IconPool','sap/ui/core/Icon','sap/ui/core/ResizeHandler','sap/ui/core/library','sap/m/Link','sap/m/Avatar',"sap/ui/events/KeyCodes",'./NotificationListItemRenderer'],function(l,C,D,N,I,a,b,R,c,L,A,K,d){'use strict';var e=C.getLibraryResourceBundle('sap.m'),E=e.getText('NOTIFICATION_LIST_ITEM_SHOW_MORE'),f=e.getText('NOTIFICATION_LIST_ITEM_SHOW_LESS'),g=e.getText('NOTIFICATION_LIST_ITEM_READ'),U=e.getText('NOTIFICATION_LIST_ITEM_UNREAD');var m=44;var h=l.AvatarSize;var i=l.AvatarColor;var P=c.Priority;
var j=N.extend('sap.m.NotificationListItem',{metadata:{library:'sap.m',properties:{description:{type:'string',group:'Appearance',defaultValue:''},authorInitials:{type:"string",group:"Data",defaultValue:null},truncate:{type:'boolean',group:'Appearance',defaultValue:true},hideShowMoreButton:{type:'boolean',group:'Appearance',defaultValue:false},authorAvatarColor:{type:"sap.m.AvatarColor",group:"Appearance",defaultValue:i.Accent6}},aggregations:{processingMessage:{type:'sap.m.MessageStrip',multiple:false},_showMoreButton:{type:'sap.m.Link',multiple:false,visibility:"hidden"}}}});
j.prototype.init=function(){this.setType('Active');this._footerIvisibleText=new I({id:this.getId()+"-invisibleFooterText"});};
j.prototype._getAuthorAvatar=function(){if(this.getAuthorInitials()||this.getAuthorPicture()){if(!this._avatar){this._avatar=new A({displaySize:h.XS});}this._avatar.setInitials(this.getAuthorInitials());this._avatar.setSrc(this.getAuthorPicture());this._avatar.setBackgroundColor(this.getAuthorAvatarColor());return this._avatar;}};
j.prototype.onBeforeRendering=function(){N.prototype.onBeforeRendering.call(this);if(this._resizeListenerId){R.deregister(this._resizeListenerId);this._resizeListenerId=null;}};
j.prototype.onAfterRendering=function(){if(this.getHideShowMoreButton()){return;}this._updateShowMoreButtonVisibility();if(this.getDomRef()){this._resizeListenerId=R.register(this.getDomRef(),this._onResize.bind(this));}};
j.prototype.onfocusin=function(k){N.prototype.onfocusin.apply(this,arguments);if(!D.browser.msie){return;}var t=k.target;if(t!==this.getDomRef()&&!t.classList.contains('sapMBtn')&&!t.classList.contains('sapMLnk')){k.preventDefault();k.stopImmediatePropagation();this.focus();}};
j.prototype.onkeydown=function(k){if(k.target!==this.getDomRef()){return;}var n=this.getParent(),v,o;if(!n||!n.isA('sap.m.NotificationListGroup')){return;}v=n.getVisibleItems();o=v.indexOf(this);switch(k.which){case K.ARROW_UP:if(o===0){return;}var p=o-1;v[p].focus();break;case K.ARROW_DOWN:var q=o+1;if(q===v.length){return;}v[q].focus();break;}};
j.prototype.exit=function(){N.prototype.exit.apply(this,arguments);if(this._resizeListenerId){R.deregister(this._resizeListenerId);this._resizeListenerId=null;}if(this._footerIvisibleText){this._footerIvisibleText.destroy();this._footerIvisibleText=null;}if(this._avatar){this._avatar.destroy();this._avatar=null;}};
j.prototype._onResize=function(){this._updateShowMoreButtonVisibility();};
j.prototype._updateShowMoreButtonVisibility=function(){var $=this.$(),t=$.find('.sapMNLITitleText')[0],k=$.find('.sapMNLIDescription')[0],n;if($.length>0){n=t.scrollHeight>m||k.scrollHeight>m;}this._getShowMoreButton().setVisible(n);};
j.prototype._getShowMoreButton=function(){var s=this.getAggregation('_showMoreButton');if(!s){s=new L(this.getId()+'-showMoreButton',{text:this.getTruncate()?E:f,press:function(){var t=!this.getTruncate();this._getShowMoreButton().setText(t?E:f);this.setTruncate(t);}.bind(this)});this.setAggregation("_showMoreButton",s,true);}return s;};
j.prototype._getFooterInvisibleText=function(){var r=this.getUnread()?U:g,k=this.getAuthorName(),n=this.getDatetime(),p=this.getPriority(),o=[r];if(k){k=e.getText('NOTIFICATION_LIST_ITEM_CREATED_BY');o.push(k);o.push(this.getAuthorName());}if(n){o.push(e.getText('NOTIFICATION_LIST_ITEM_DATETIME',[n]));}if(p!==P.None){o.push(e.getText('NOTIFICATION_LIST_ITEM_PRIORITY',[p]));}return this._footerIvisibleText.setText(o.join(' '));};
return j;});
sap.ui.predefine('sap/m/NotificationListItemRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer","sap/ui/Device"],function(c,I,D){'use strict';var P=c.Priority;var N={apiVersion:2};
N.render=function(r,a){if(!a.getVisible()){I.render(r,a,a.TagName);return false;}var t=a.getTruncate(),b=a.getAuthorName(),d=a.getDatetime(),e=a._getAuthorAvatar(),p=a.getPriority(),i=a.getUnread(),C=a.getId(),f=C+'-invisibleFooterText',A='';if(a.getTitle()){A+=' '+C+'-title';}if(a.getDescription()){A+=' '+C+'-descr';}A+=' '+f;r.openStart('li',a).class('sapMLIB').class('sapMNLIB').class('sapMNLI');if(i){r.class('sapMNLIUnread');}if(!e){r.class('sapMNLINoAvatar');}r.attr('tabindex','0');r.accessibilityState(a,{role:"option",labelledby:{value:A}});r.openEnd();r.renderControl(a.getProcessingMessage());r.openStart('div').class('sapMNLIMain').openEnd();r.openStart('div').attr('aria-hidden','true').class('sapMNLIItem').class('sapMNLIItemAC').openEnd();if(a._shouldRenderOverflowToolbar()){r.openStart('div').class('sapMNLIItem').class('sapMNLIActions').openEnd();r.renderControl(a._getOverflowToolbar());r.close('div');}if(a._shouldRenderCloseButton()){r.openStart('div').class('sapMNLIItem').class('sapMNLICloseBtn').openEnd();r.renderControl(a._getCloseButton());r.close('div');}r.close('div');r.openStart('div').class('sapMNLIContent').openEnd();r.openStart('div').class('sapMNLITitle').openEnd();if(p!==P.None){r.openStart('div').class('sapMNLIBPriority').class('sapMNLIBPriority'+p).openEnd();r.renderControl(a._getPriorityIcon());r.close('div');}r.openStart('div',C+'-title').class('sapMNLITitleText');if(t){r.class('sapMNLIItemTextLineClamp');}r.openEnd();r.text(a.getTitle());r.close('div');r.close('div');r.openStart('div',C+'-descr').class('sapMNLIDescription');if(!a.getDescription()){r.class('sapMNLIDescriptionNoText');}if(t){r.class('sapMNLIItemTextLineClamp');}r.openEnd();r.text(a.getDescription());r.close('div');r.openStart('div').class('sapMNLIFooter').openEnd();r.openStart('div').class('sapMNLIFooterItem').openEnd();r.text(b);r.close('div');if(b&&d){r.openStart('div').class('sapMNLIFooterItem').class('sapMNLIFooterBullet').openEnd();r.text('·');r.close('div');}r.openStart('div').class('sapMNLIFooterItem').openEnd();r.text(d);r.close('div');if(!a.getHideShowMoreButton()){r.openStart('div').class('sapMNLIShowMore').attr('aria-hidden','true').openEnd();r.renderControl(a._getShowMoreButton());r.close('div');}r.renderControl(a._getFooterInvisibleText());r.close('div');r.close('div');r.openStart('div').class('sapMNLIImage').openEnd();if(e){r.renderControl(e);}r.close('div');r.close('div');r.close('li');};
return N;},true);
sap.ui.predefine('sap/m/NumericContent',["./library","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/ResizeHandler","sap/m/Image","./NumericContentRenderer","sap/ui/events/KeyCodes","sap/base/util/deepEqual"],function(l,C,I,R,a,N,K,d){"use strict";var L={"ar":4,"ar_eg":4,"ar_sa":4,"bg":4,"ca":6,"cs":4,"da":4,"de":8,"de_at":8,"de_ch":8,"el":4,"el_cy":4,"en":4,"en_au":4,"en_gb":4,"en_hk":4,"en_ie":4,"en_in":4,"en_nz":4,"en_pg":4,"en_sg":4,"en_us":4,"en_za":4,"es":6,"es_ar":4,"es_bo":4,"es_cl":4,"es_co":4,"es_mx":6,"es_pe":4,"es_uy":4,"es_ve":4,"et":4,"fa":4,"fi":4,"fr":4,"fr_be":4,"fr_ca":4,"fr_ch":4,"fr_lu":4,"he":4,"hi":4,"hr":4,"hu":4,"id":4,"it":8,"it_ch":8,"ja":6,"kk":4,"ko":6,"lt":4,"lv":4,"ms":4,"nb":4,"nl":4,"nl_be":4,"pl":4,"pt":4,"pt_pt":4,"ro":4,"ru":4,"ru_ua":4,"sk":4,"sl":4,"sr":4,"sv":4,"th":4,"tr":4,"uk":4,"vi":4,"zh_cn":6,"zh_hk":6,"zh_sg":6,"zh_tw":6};
var b=C.extend("sap.m.NumericContent",{metadata:{library:"sap.m",properties:{"animateTextChange":{type:"boolean",group:"Behavior",defaultValue:true},"formatterValue":{type:"boolean",group:"Data",defaultValue:false},"icon":{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},"iconDescription":{type:"string",group:"Accessibility",defaultValue:null},"indicator":{type:"sap.m.DeviationIndicator",group:"Appearance",defaultValue:"None"},"nullifyValue":{type:"boolean",group:"Behavior",defaultValue:true},"scale":{type:"string",group:"Appearance",defaultValue:null},"size":{type:"sap.m.Size",group:"Appearance",defaultValue:"Auto"},"truncateValueTo":{type:"int",group:"Appearance"},"value":{type:"string",group:"Data",defaultValue:null},"valueColor":{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},"width":{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},"withMargin":{type:"boolean",group:"Appearance",defaultValue:true},"state":{type:"sap.m.LoadState",group:"Behavior",defaultValue:"Loaded"},"adaptiveFontSize":{type:"boolean",group:"Appearance",defaultValue:true}},events:{"press":{}}}});
b.prototype.init=function(){this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setTooltip("{AltText}");sap.ui.getCore().attachInit(this._registerResizeHandler.bind(this));};
b.prototype._getParentTile=function(){var p=this.getParent();while(p){if(p.isA("sap.m.GenericTile")){return p;}p=p.getParent();}return null;};
b.prototype._getMaxDigitsData=function(){var f=null,s=sap.ui.getCore().getConfiguration().getLanguage().toLowerCase(),m=L[s]||4;if(this.getAdaptiveFontSize()){switch(m){case 6:f="sapMNCMediumFontSize";break;case 8:f="sapMNCSmallFontSize";break;default:f="sapMNCLargeFontSize";break;}}else{f="sapMNCLargeFontSize";m=4;}return{fontClass:f,maxLength:m};};
b.prototype._registerResizeHandler=function(){R.register(this,this.invalidate.bind(this));};
b.prototype.onBeforeRendering=function(){this.$().off("mouseenter");this.$().off("mouseleave");this._iMaxLength=null;};
b.prototype.onAfterRendering=function(){this.$().on("mouseenter",this._addTooltip.bind(this));this.$().on("mouseleave",this._removeTooltip.bind(this));if(!sap.ui.getCore().isThemeApplied()){sap.ui.getCore().attachThemeChanged(this._checkIfIconFits,this);}else{this._checkIfIconFits();}};
b.prototype._addTooltip=function(){this.$().attr("title",this.getTooltip_AsString());};
b.prototype._checkIfIconFits=function(){var p=this._getParentTile();if(p&&(p.isA("sap.m.GenericTile")||p.isA("sap.m.SlideTile"))){p._setupResizeClassHandler();}var i=this.getDomRef("icon-image");if(i){var v=this.getDomRef("value-inner"),o=this.getDomRef("indicator"),w=this.getDomRef("value");var f=i?i.getBoundingClientRect().width:0,V=v?v.getBoundingClientRect().width:0,c=o?o.getBoundingClientRect().width:0,W=w.getBoundingClientRect().width;i.style.display=(f+V+c)>W?"none":"";}};
b.prototype._removeTooltip=function(){this.$().attr("title",null);};
b.prototype.exit=function(){if(this._oIcon){this._oIcon.destroy();}if(this._oIndicatorIcon){this._oIndicatorIcon.destroy();}};
b.prototype.getAltText=function(){var v=this.getValue();var s=this.getScale();var e;var m=this._rb.getText(("SEMANTIC_COLOR_"+this.getValueColor()).toUpperCase());var A="";if(this.getNullifyValue()){e="0";}else{e="";}if(this.getIconDescription()){A=A.concat(this.getIconDescription());A=A.concat("\n");}if(v){A=A.concat(v+s);}else{A=A.concat(e);}A=A.concat("\n");if(this.getIndicator()&&this.getIndicator()!==l.DeviationIndicator.None){A=A.concat(this._rb.getText(("NUMERICCONTENT_DEVIATION_"+this.getIndicator()).toUpperCase()));A=A.concat("\n");}A=A.concat(m);return A;};
b.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var T=this.getAltText();if(typeof t==="string"||t instanceof String){T=t.split("{AltText}").join(T).split("((AltText))").join(T);return T;}if(t){return t;}else{return"";}};
b.prototype.setIcon=function(u){var v=!d(this.getIcon(),u);if(v){if(this._oIcon){this._oIcon.destroy();this._oIcon=undefined;}if(u){this._oIcon=I.createControlByURI({id:this.getId()+"-icon-image",src:u},a);}}this._setPointerOnIcon();return this.setProperty("icon",u);};
b.prototype.setIndicator=function(D){var s="sap-icon://"+(D?D.toLowerCase():"none");if(this._oIndicatorIcon){this._oIndicatorIcon.setSrc(s);}else{this._oIndicatorIcon=I.createControlByURI({id:this.getId()+"-icon-indicator",size:"0.875rem",src:s},a);this._oIndicatorIcon.addStyleClass("sapMNCIndIcon");}return this.setProperty("indicator",D);};
b.prototype._setPointerOnIcon=function(){if(this._oIcon&&this.hasListeners("press")){this._oIcon.addStyleClass("sapMPointer");}else if(this._oIcon&&this._oIcon.hasStyleClass("sapMPointer")){this._oIcon.removeStyleClass("sapMPointer");}};
b.prototype.ontap=function(e){this.$().trigger("focus");this.firePress();e.preventDefault();};
b.prototype.onkeyup=function(e){if(e.which===K.ENTER||e.which===K.SPACE){this.firePress();e.preventDefault();}};
b.prototype.onkeydown=function(e){if(e.which===K.SPACE){e.preventDefault();}};
b.prototype.attachEvent=function(e,c,f,g){C.prototype.attachEvent.call(this,e,c,f,g);if(this.hasListeners("press")){this.$().attr("tabindex",0).addClass("sapMPointer");this._setPointerOnIcon();}return this;};
b.prototype.detachEvent=function(e,f,c){C.prototype.detachEvent.call(this,e,f,c);if(!this.hasListeners("press")){this.$().removeAttr("tabindex").removeClass("sapMPointer");this._setPointerOnIcon();}return this;};
b.prototype._parseFormattedValue=function(v){var t=v.replace(String.fromCharCode(8206),"").replace(String.fromCharCode(8207),"");return{scale:t.replace(/[+-., \d]*(.*)$/g,"$1").trim().replace(/\.$/,""),value:t.replace(/([+-., \d]*).*$/g,"$1").trim()};};
return b;});
sap.ui.predefine('sap/m/ObjectAttribute',['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Text','sap/ui/events/KeyCodes','./ObjectAttributeRenderer',"sap/base/Log"],function(l,C,c,T,K,O,L){"use strict";var a=c.TextDirection;
var b=C.extend("sap.m.ObjectAttribute",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectAttribute.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:a.Inherit}},aggregations:{customContent:{type:"sap.ui.core.Control",multiple:false},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{parameters:{domRef:{type:"string"}}}},dnd:{draggable:true,droppable:false}}});
b.prototype.init=function(){this.setAggregation('_textControl',new T());};
b.prototype._getUpdatedTextControl=function(){var A=this.getAggregation('customContent')||this.getAggregation('_textControl'),t=this.getTitle(),s=this.getAggregation('customContent')?this.getAggregation('customContent').getText():this.getText(),d=this.getTextDirection(),p=this.getParent(),P=sap.ui.getCore().getConfiguration().getRTL(),m,w=true,o='';if(d===a.LTR&&P){o='\u200e';}if(d===a.RTL&&!P){o='\u200f';}s=o+s+o;if(t){s=t+": "+s;}A.setProperty('text',s,true);if(p instanceof sap.m.ObjectListItem){w=false;m=O.MAX_LINES.SINGLE_LINE;}this._setControlWrapping(A,w,m);return A;};
b.prototype._setControlWrapping=function(A,w,m){if(A.isA("sap.m.Link")){A.setProperty('wrapping',w,true);}if(A.isA("sap.m.Text")){A.setProperty('maxLines',m,true);}};
b.prototype.ontap=function(e){if(this._isSimulatedLink()&&(e.target.id===this.getId()+"-text")){this.firePress({domRef:this.getDomRef()});}};
b.prototype.onsapenter=function(e){if(this._isSimulatedLink()){this.firePress({domRef:this.getDomRef()});e.setMarked();}};
b.prototype.onsapspace=function(e){e.preventDefault();};
b.prototype.onkeyup=function(e){if(e.which===K.SPACE){this.onsapenter(e);}};
b.prototype._isEmpty=function(){if(this.getAggregation('customContent')&&!(this.getAggregation('customContent').isA("sap.m.Link")||this.getAggregation('customContent').isA("sap.m.Text"))){L.warning("Only sap.m.Link or sap.m.Text are allowed in \"sap.m.ObjectAttribute.customContent\" aggregation");return true;}return!(this.getText().trim()||this.getTitle().trim());};
b.prototype.ontouchstart=function(e){if(this._isSimulatedLink()){e.originalEvent._sapui_handledByControl=true;}};
b.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("text");};
b.prototype._isSimulatedLink=function(){return(this.getActive()&&this.getText()!=="")&&!this.getAggregation('customContent');};
b.prototype.setCustomContent=function(o){if(o&&o.isA('sap.m.Link')){o._getTabindex=function(){return"-1";};}return this.setAggregation('customContent',o);};
b.prototype._isClickable=function(){return(this.getActive()&&this.getText()!=="")||(this.getAggregation('customContent')&&this.getAggregation('customContent').isA('sap.m.Link'));};
return b;});
sap.ui.predefine('sap/m/ObjectAttributeRenderer',["sap/ui/core/library"],function(c){"use strict";var T=c.TextDirection;var O={apiVersion:2,MAX_LINES:{SINGLE_LINE:1}};
O.render=function(r,o){var p=o.getParent(),t=o.getTooltip_AsString();r.openStart("div",o);if(o._isEmpty()){r.class("sapMObjectAttributeDiv");r.class("sapUiHidden");r.openEnd();r.close("div");return;}r.class("sapMObjectAttributeDiv");if(o._isClickable()){r.class("sapMObjectAttributeActive");r.attr("tabindex","0");r.accessibilityState(o,{role:"link"});if(!o.getTitle()&&o.getText()){r.class("sapMObjectAttributeTextOnly");}}if(t){r.attr("title",t);}r.openEnd();if(o._isClickable()||p instanceof sap.m.ObjectHeader){this.renderActiveTitle(r,o);this.renderActiveText(r,o,p);}else{r.renderControl(o._getUpdatedTextControl());}r.close("div");};
O.renderActiveTitle=function(r,o){if(!o.getProperty("title")){return;}r.openStart("span",o.getId()+"-title");r.class("sapMObjectAttributeTitle");r.openEnd();r.text(o.getProperty("title"));r.close("span");r.openStart("span",o.getId()+"-colon");r.class("sapMObjectAttributeColon");r.openEnd();r.unsafeHtml(":&nbsp;");r.close("span");};
O.renderActiveText=function(r,o,p){var t=o.getTextDirection(),a=o.getAggregation("customContent");r.openStart("span",o.getId()+"-text");r.class("sapMObjectAttributeText");if(t&&t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(a&&p){if((p instanceof sap.m.ObjectHeader)&&!o.getParent().getResponsive()){o._setControlWrapping(a,true);}else{o._setControlWrapping(a,false,O.MAX_LINES.SINGLE_LINE);}r.renderControl(a);}else{r.text(o.getProperty("text"));}r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectHeader',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/core/util/ResponsivePaddingsEnablement','sap/ui/Device','sap/m/Text','sap/ui/events/KeyCodes','./ObjectHeaderRenderer','./ObjectMarker','./ObjectNumber',"sap/ui/thirdparty/jquery"],function(l,C,I,c,R,D,T,K,O,a,b,q){"use strict";var B=l.BackgroundDesign;var d=c.TextAlign;var e=l.ImageHelper;var f=l.ObjectMarkerType;var g=c.TitleLevel;var h=c.TextDirection;var V=c.ValueState;var j=l.ObjectHeaderPictureShape;
var k=C.extend("sap.m.ObjectHeader",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectHeader.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},introActive:{type:"boolean",group:"Misc",defaultValue:null},titleActive:{type:"boolean",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconActive:{type:"boolean",group:"Misc",defaultValue:null},iconAlt:{type:"string",group:"Accessibility",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},imageShape:{type:"sap.m.ObjectHeaderPictureShape",group:"Appearance",defaultValue:j.Square},markFavorite:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true},showTitleSelector:{type:"boolean",group:"Misc",defaultValue:false},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},condensed:{type:"boolean",group:"Appearance",defaultValue:false},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance"},responsive:{type:"boolean",group:"Behavior",defaultValue:false},fullScreenOptimized:{type:"boolean",group:"Appearance",defaultValue:false},titleHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},titleTarget:{type:"string",group:"Behavior",defaultValue:null},introHref:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},introTarget:{type:"string",group:"Behavior",defaultValue:null},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:h.Inherit},titleSelectorTooltip:{type:"string",group:"Misc",defaultValue:"Options"},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:g.H1}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},secondStatus:{type:"sap.m.ObjectStatus",multiple:false,deprecated:true},statuses:{type:"sap.ui.core.Control",multiple:true,singularName:"status"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"},additionalNumbers:{type:"sap.m.ObjectNumber",multiple:true,singularName:"additionalNumber"},headerContainer:{type:"sap.m.ObjectHeaderContainer",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{titlePress:{parameters:{domRef:{type:"object"}}},introPress:{parameters:{domRef:{type:"object"}}},iconPress:{parameters:{domRef:{type:"object"}}},titleSelectorPress:{parameters:{domRef:{type:"object"}}}},dnd:{draggable:false,droppable:true}}});
k._getResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
R.call(k.prototype,{header:{selector:".sapMOH, .sapMOHR"}});
k.prototype.init=function(){this._oTitleArrowIcon=I.createControlByURI({id:this.getId()+"-titleArrow",src:I.getIconURI("arrow-down"),decorative:false,visible:false,tooltip:k._getResourceBundle().getText("OH_SELECT_ARROW_TOOLTIP"),size:"1.375rem",press:function(E){}});this._fNumberWidth=undefined;this._titleText=new T(this.getId()+"-titleText");this._titleText.setMaxLines(3);this._initResponsivePaddingsEnablement();};
k.prototype.insertAttribute=function(A,i){var r=this.insertAggregation("attributes",A,i);this._registerControlListener(A);return r;};
k.prototype.addAttribute=function(A){var r=this.addAggregation("attributes",A);this._registerControlListener(A);return r;};
k.prototype.removeAttribute=function(A){var r=this.removeAggregation("attributes",A);this._deregisterControlListener(r);return r;};
k.prototype.removeAllAttributes=function(){var A=this.removeAllAggregation("attributes");A.forEach(this._deregisterControlListener,this);return A;};
k.prototype.destroyAttributes=function(){var A=this.getAggregation("attributes");if(A!==null){A.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("attributes");};
k.prototype.insertStatus=function(s,i){var r=this.insertAggregation("statuses",s,i);this._registerControlListener(s);return r;};
k.prototype.addStatus=function(s){var r=this.addAggregation("statuses",s);this._registerControlListener(s);return r;};
k.prototype.removeStatus=function(s){var r=this.removeAggregation("statuses",s);this._deregisterControlListener(r);return r;};
k.prototype.removeAllStatuses=function(){var s=this.removeAllAggregation("statuses");s.forEach(this._deregisterControlListener,this);return s;};
k.prototype.destroyStatuses=function(){var s=this.getAggregation("statuses");if(s!==null){s.forEach(this._deregisterControlListener,this);}return this.destroyAggregation("statuses");};
k.prototype._registerControlListener=function(o){if(o){o.attachEvent("_change",this.invalidate,this);}};
k.prototype._deregisterControlListener=function(o){if(o){o.detachEvent("_change",this.invalidate,this);}};
k.prototype.setCondensed=function(i){this.setProperty("condensed",i);if(this.getCondensed()){this._oTitleArrowIcon.setSize("1rem");}else{this._oTitleArrowIcon.setSize("1.375rem");}return this;};
k.prototype.setNumber=function(n){this.setProperty("number",n);this._getObjectNumber().setNumber(n);return this;};
k.prototype.setNumberUnit=function(u){this.setProperty("numberUnit",u);this._getObjectNumber().setUnit(u);return this;};
k.prototype.setNumberState=function(s){this.setProperty("numberState",s);this._getObjectNumber().setState(s);return this;};
k.prototype.setTitleSelectorTooltip=function(t){this.setProperty("titleSelectorTooltip",t);this._oTitleArrowIcon.setTooltip(t);return this;};
k.prototype.setMarkFavorite=function(m){return this._setOldMarkers(f.Favorite,m);};
k.prototype.setMarkFlagged=function(m){return this._setOldMarkers(f.Flagged,m);};
k.prototype.setShowMarkers=function(m){var M,A=this.getMarkers(),i;this.setProperty("showMarkers",m);for(i=0;i<A.length;i++){M=A[i].getType();if((M===f.Flagged&&this.getMarkFlagged())||(M===f.Favorite&&this.getMarkFavorite())){A[i].setVisible(m);}}return this;};
k.prototype._setOldMarkers=function(m,M){var A=this.getMarkers(),H=false,i,o={Flagged:"-flag",Favorite:"-favorite"};this.setProperty("mark"+m,M,false);if(!this.getShowMarkers()){M=false;}for(i=0;i<A.length;i++){if(A[i].getType()===m){H=true;A[i].setVisible(M);break;}}if(!H){this.insertAggregation("markers",new a({id:this.getId()+o[m],type:m,visible:M}));}return this;};
k.prototype._getVisibleMarkers=function(){var A=this.getMarkers(),v=[],i;for(i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
k.prototype._getObjectNumber=function(){var o=this.getAggregation("_objectNumber");if(!o){o=new b(this.getId()+"-number",{emphasized:false});this.setAggregation("_objectNumber",o,true);}return o;};
k.prototype.getFocusDomRef=function(){if(this.getResponsive()){return this.$("txt")[0];}else{return this.$("title")[0];}};
k.prototype.ontap=function(E){var s=E.target.id;if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:window.document.getElementById(s)});}}else if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(E.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){if(!this.getTitleHref()){E.preventDefault();s=this.getId()+"-title";this.fireTitlePress({domRef:window.document.getElementById(s)});}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(E.target).parent().attr('id')===this.getId()+"-txt")){if(!this.getTitleHref()){E.preventDefault();s=this.getId()+"-txt";this.fireTitlePress({domRef:window.document.getElementById(s)});}}else if(s===this.getId()+"-titleArrow"){this.fireTitleSelectorPress({domRef:window.document.getElementById(s)});}else if(s.indexOf(this.getId())!==-1){E.setMarked();E.preventDefault();}};
k.prototype._handleSpaceOrEnter=function(E){var s=E.target.id;E.setMarked();if(!this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-title"||q(E.target).parent().attr('id')===this.getId()+"-title"||s===this.getId()+"-titleText-inner")){s=this.getId()+"-title";if(!this.getTitleHref()){E.preventDefault();this.fireTitlePress({domRef:(s?window.document.getElementById(s):null)});}else{if(E.type==="sapspace"){this._linkClick(E,s);}}}else if(this.getResponsive()&&this.getTitleActive()&&(s===this.getId()+"-txt"||q(E.target).parent().attr('id')===this.getId()+"-txt")){s=this.getId()+"-txt";if(!this.getTitleHref()){E.preventDefault();this.fireTitlePress({domRef:(s?window.document.getElementById(s):null)});}else{if(E.type==="sapspace"){this._linkClick(E,s);}}}else if(this.getIntroActive()&&s===this.getId()+"-intro"){if(!this.getIntroHref()){this.fireIntroPress({domRef:(s?window.document.getElementById(s):null)});}}else if(s===this.getId()+"-titleArrow"){this.fireTitleSelectorPress({domRef:(s?window.document.getElementById(s):null)});}};
k.prototype.onkeyup=function(E){if(E.which===K.SPACE){this._handleSpaceOrEnter(E);}};
k.prototype.onsapenter=k.prototype._handleSpaceOrEnter;
k.prototype._linkClick=function(E,s){E.setMarked();var o=document.createEvent('MouseEvents');o.initEvent('click',false,true);((s?window.document.getElementById(s):null)).dispatchEvent(o);};
k.prototype._onOrientationChange=function(){var i=this.getId();if(D.system.tablet&&this.getFullScreenOptimized()&&(this._hasAttributes()||this._hasStatus())){this._rerenderStates();}if(D.system.phone){if(D.orientation.portrait){if(this.getTitle().length>50){this._rerenderTitle(50);}if(this.getIcon()){q(document.getElementById(i+"-titlediv")).removeClass("sapMOHRTitleIcon");q(document.getElementById(i+"-titleIcon")).addClass("sapMOHRHideIcon");}}else{if(D.orientation.landscape){if(this.getTitle().length>80){this._rerenderTitle(80);}if(this.getIcon()){q(document.getElementById(i+"-titlediv")).addClass("sapMOHRTitleIcon");q(document.getElementById(i+"-titleIcon")).removeClass("sapMOHRHideIcon");}}}this._adjustNumberDiv();}this._adjustIntroDiv();};
k.prototype._rerenderTitle=function(n){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderTitle(r,this,n);r.destroy();};
k.prototype._rerenderStates=function(){var r=sap.ui.getCore().createRenderManager();this.getRenderer()._rerenderResponsiveStates(r,this);r.destroy();};
k.prototype.exit=function(){if(!D.system.phone){this._detachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._onOrientationChange,this);}if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=undefined;}if(this._oTitleArrowIcon){this._oTitleArrowIcon.destroy();this._oTitleArrowIcon=undefined;}if(this._titleText){this._titleText.destroy();this._titleText=undefined;}if(this._introText){this._introText.destroy();this._introText=undefined;}};
k.prototype._getImageControl=function(){var i=this.getId()+"-img";var s="2.5rem";var p=q.extend({src:this.getIcon(),tooltip:this.getIconTooltip(),alt:this.getIconAlt()||k._getResourceBundle().getText("OH_ARIA_ICON"),useIconTooltip:false,densityAware:this.getIconDensityAware(),decorative:false},I.isIconURI(this.getIcon())?{size:s}:{});if(this.getIconActive()){p.press=function(E){this.fireIconPress({domRef:E.getSource().getDomRef()});}.bind(this);p.decorative=false;}this._oImageControl=e.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
k.prototype.onBeforeRendering=function(){if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._onOrientationChange,this);}if(!D.system.phone){this._detachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}if(this._introText){this._introText.destroy();this._introText=undefined;}};
k.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();var $=this.$("titleArrow");$.attr("role","button");if(this.getResponsive()){this._adjustIntroDiv();if(o&&o.getNumber()){if(D.system.desktop&&q('html').hasClass("sapUiMedia-Std-Desktop")&&this.getFullScreenOptimized()&&this._iCountVisAttrStat>=1&&this._iCountVisAttrStat<=3){o.setTextAlign(p?d.Right:d.Left);}else{o.setTextAlign(p?d.Left:d.Right);}}this._adjustNumberDiv();if(D.system.tablet||D.system.phone){D.orientation.attachHandler(this._onOrientationChange,this);}if(!D.system.phone){this._attachMediaContainerWidthChange(this._rerenderOHR,this,D.media.RANGESETS.SAP_STANDARD);}}else{var t=p?d.Left:d.Right;if(o&&o.getNumber()){o.setTextAlign(t);}if(this.getAdditionalNumbers()){this._setTextAlignANum(t);}}};
k.prototype._rerenderOHR=function(){this.invalidate();};
k.prototype._adjustNumberDiv=function(){var i=this.getId();var o=this.getAggregation("_objectNumber");var p=sap.ui.getCore().getConfiguration().getRTL();if(o&&o.getNumber()){var $=q(document.getElementById(i+"-number"));var m=q(document.getElementById(i+"-titlediv"));if(this._isMediaSize("Phone")){if($.hasClass("sapMObjectNumberBelowTitle")){o.setTextAlign(p?d.Left:d.Right);$.removeClass("sapMObjectNumberBelowTitle");m.removeClass("sapMOHRTitleDivFull");}var n=$.parent().width()*0.4;if($.outerWidth()>n){o.setTextAlign(p?d.Right:d.Left);$.addClass("sapMObjectNumberBelowTitle");m.addClass("sapMOHRTitleDivFull");}}}};
k.prototype._adjustIntroDiv=function(){var i=this.getId();var $=q(document.getElementById(i+"-txt"));var m=q(document.getElementById(i+"-titleArrow"));var n=q(document.getElementById(i+"-intro"));if(n.parent().hasClass("sapMOHRIntroMargin")){n.parent().removeClass("sapMOHRIntroMargin");}if(m.height()!==null&&($.height()<m.height())){n.parent().addClass("sapMOHRIntroMargin");}};
k._escapeId=function(i){return i?"#"+i.replace(/(:|\.)/g,'\\$1'):"";};
k.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this._hasMarkers());};
k.prototype._hasIcon=function(){return!!this.getIcon().trim();};
k.prototype._hasAttributes=function(){var m=this.getAttributes();if(m&&m.length>0){for(var i=0;i<m.length;i++){if(!m[i]._isEmpty()){return true;}}}return false;};
k.prototype._hasStatus=function(){var H=((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));if(!H&&this.getStatuses()&&this.getStatuses().length>0){var s=this.getStatuses();for(var i=0;i<s.length;i++){if(s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty()){H=true;break;}else if(s[i]instanceof sap.m.ProgressIndicator){H=true;break;}}}return H;};
k.prototype._hasMarkers=function(){var m=this.getMarkers(),H=this.getShowMarkers()&&(this.getMarkFavorite()||this.getMarkFlagged()),i=m&&m.length;return(H||i);};
k.prototype._getDefaultBackgroundDesign=function(){if(this.getCondensed()){return B.Solid;}else{if(this.getResponsive()){return B.Translucent;}else{return B.Transparent;}}};
k.prototype._getBackground=function(){if(this.getBackgroundDesign()===undefined){return this._getDefaultBackgroundDesign();}else{return this.getBackgroundDesign();}};
k.prototype._setTextAlignANum=function(t){var n=this.getAdditionalNumbers();for(var i=0;i<n.length;i++){n[i].setTextAlign(t);}};
k.prototype._isMediaSize=function(r){return this._getCurrentMediaContainerRange(D.media.RANGESETS.SAP_STANDARD).name===r;};
return k;});
sap.ui.predefine('sap/m/ObjectHeaderRenderer',['sap/ui/core/Control','sap/ui/core/library','sap/m/library','sap/ui/Device',"sap/base/Log",'sap/m/Link','sap/m/Text',"sap/ui/thirdparty/jquery"],function(C,c,l,D,L,a,T,q){"use strict";var b=c.TextDirection;var B=l.BackgroundDesign;var d=c.TitleLevel;var O={apiVersion:2};
O._isEmptyObject=function(o){if(!o){return true;}if((!o._isEmpty||!o._isEmpty())&&(!o.getVisible||o.getVisible())){return false;}return true;};
O._isEmptyArray=function(A){if(A){for(var i=0;i<A.length;i++){if(!O._isEmptyObject(A[i])){return false;}}}return true;};
O._isEmptyRow=function(o,r){return O._isEmptyObject(o)&&O._isEmptyArray(r);};
O._renderObjects=function(r,o,e){for(var i=0;i<o.length;i++){if(o[i]instanceof C){this._renderChildControl(r,e,o[i]);}}};
O._computeChildControlsToBeRendered=function(o){o.__controlsToBeRendered={};var e=o.getAttributes();for(var i=0;i<e.length;i++){o.__controlsToBeRendered[e[i].getId()]=e[i];}e=o.getStatuses();for(var i=0;i<e.length;i++){o.__controlsToBeRendered[e[i].getId()]=e[i];}var f=o.getFirstStatus();if(f){o.__controlsToBeRendered[f.getId()]=f;}f=o.getSecondStatus();if(f){o.__controlsToBeRendered[f.getId()]=f;}f=o.getAggregation("_objectNumber");if(f){o.__controlsToBeRendered[f.getId()]=f;}};
O._cleanupNotRenderedChildControls=function(r,o){for(var i in o.__controlsToBeRendered){r.cleanupControlWithoutRendering(o.__controlsToBeRendered[i]);}delete o.__controlsToBeRendered;};
O._getMarkers=function(o){return o._getVisibleMarkers();};
O._renderIntro=function(r,o,i,I){if(o.getIntroActive()){o._introText=new a(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setHref(o.getIntroHref());o._introText.setTarget(o.getIntroTarget());o._introText.press=o.introPress;}else{o._introText=new T(o.getId()+"-intro");o._introText.setText(o.getIntro());o._introText.setMaxLines(3);}o._introText.setTextDirection(o.getIntroTextDirection());r.openStart("div");r.class(i);if(o.getIntroActive()){r.class(I);}r.openEnd();this._renderChildControl(r,o,o._introText);r.close("div");};
O._renderAttribute=function(r,o,A,f){r.openStart("div");r.class("sapMOHAttr");if(f){r.style("width","100%");}r.openEnd();this._renderChildControl(r,o,A);r.close("div");};
O._getVisibleStatuses=function(o){var v=[];if(o.getFirstStatus()&&o.getFirstStatus().getVisible()){v.push([o.getFirstStatus()]);}if(o.getSecondStatus()&&o.getSecondStatus().getVisible()){v.push([o.getSecondStatus()]);}if(o.getStatuses()){var s=o.getStatuses();for(var i=0;i<s.length;i++){if(!s[i].getVisible||s[i].getVisible()){if((s[i]instanceof sap.m.ObjectStatus&&!s[i]._isEmpty())||s[i]instanceof sap.m.ProgressIndicator){v.push([s[i]]);}else{L.warning("Only sap.m.ObjectStatus or sap.m.ProgressIndicator are allowed in \"sap.m.ObjectHeader.statuses\" aggregation."+" Current object is "+s[i].constructor.getMetadata().getName()+" with id \""+s[i].getId()+"\"");}}}}return v;};
O._getVisibleAttribsAndStatuses=function(o){var r=[],A=o.getAttributes(),v=[];for(var j=0;j<A.length;j++){if(A[j].getVisible()&&!A[j]._isEmpty()){v.push(A[j]);}}var V=this._getVisibleStatuses(o);r[0]=v;r[1]=V;return r;};
O._renderRow=function(r,o,e,R){if(O._isEmptyRow(e,R)){return;}r.openStart("div");r.class("sapMOHAttrRow");r.openEnd();if(!O._isEmptyObject(e)){this._renderAttribute(r,o,e,O._isEmptyArray(R));}else if(O._isEmptyObject(e)&&!O._isEmptyArray(R)){if(R[0]instanceof sap.m.ProgressIndicator){r.openStart("div");r.class("sapMOHAttr");r.openEnd();r.close("div");}}if(!O._isEmptyArray(R)){r.openStart("div");if(R[0]instanceof sap.m.ProgressIndicator){r.class("sapMOHStatusFixedWidth");}else if(R[0]instanceof sap.m.ObjectMarker){r.class("sapMOHStatusFixedWidth");r.class("sapMObjStatusMarker");}else{r.class("sapMOHStatus");}r.openEnd();O._renderObjects(r,R,o);r.close("div");}r.close("div");};
O._renderAttributesAndStatuses=function(r,o){var A=o.getAttributes();var v=[];for(var j=0;j<A.length;j++){if(A[j].getVisible()){v.push(A[j]);}}var i=v.length;var m=[];var M=O._getMarkers(o);if(!o.getResponsive()&&!O._isEmptyArray(M)){m.push(M);}var V=this._getVisibleStatuses(o);m=m.concat(V);var e=m.length;var n=i>e?i:e;if(!o.getResponsive()){for(var f=0;f<n;f++){this._renderRow(r,o,v[f],m[f]);}}};
O._renderNumber=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){return;}r.openStart("div",o.getId()+"-numberdiv");r.class("sapMOHNumberDiv");r.openEnd();var e=o.getAggregation("_objectNumber");if(e&&e.getNumber()){e.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,e);}r.close("div");if(!o.getCondensed()){this._renderAdditionalNumbers(r,o);}};
O._renderAdditionalNumbers=function(r,o){var n=o.getAdditionalNumbers();if(n&&!n.length){return;}if(n.length===1){r.openStart("div");r.class("additionalOHNumberSeparatorDiv");r.openEnd();r.close("div");}for(var i=0;i<n.length;i++){r.openStart("div",o.getId()+"-additionalNumber"+i);r.class("sapMOHNumberDiv");r.class("additionalOHNumberDiv");if(n.length===1){r.class("sapMOHOnlyANumber");}r.openEnd();n[i].setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,n[i]);r.close("div");}};
O._renderTitle=function(r,o){o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.openStart("div");r.class("sapMOHTitleAndArrow");r.openEnd();}if(o.getTitle()){var t=(o.getTitleLevel()===d.Auto)?d.H1:o.getTitleLevel();t=t.toLowerCase();o._titleText.setText(o.getTitle());o._titleText.setTextDirection(o.getTitleTextDirection());if(o.getTitleActive()){r.openStart("a",o.getId()+"-title");if(o.getTitleHref()){r.attr("href",o.getTitleHref());if(o.getTitleTarget()){r.attr("target",o.getTitleTarget());}}r.accessibilityState({role:"link",haspopup:!o.getTitleHref()});}else{r.openStart("div",o.getId()+"-title");}r.class("sapMOHTitle");if(o.getTitleActive()){r.attr("tabindex","0");r.class("sapMOHTitleActive");}if(o.getShowTitleSelector()){r.class("sapMOHTitleFollowArrow");}r.openEnd();r.openStart(t);r.openEnd();this._renderChildControl(r,o,o._titleText);r.close(t);if(o.getTitleActive()){r.close("a");}else{r.close("div");}}if(o.getShowTitleSelector()){r.openStart("span");r.class("sapMOHTitleArrow");r.openEnd();this._renderChildControl(r,o,o._oTitleArrowIcon);r.close("span");}if(o.getShowTitleSelector()&&o._oTitleArrowIcon.getVisible()){r.close("div");}};
O._renderFullTitle=function(r,o){var n=o.getAdditionalNumbers();if(!o.getNumber()&&(n&&!n.length)){r.class("sapMOHTitleDivFull");}};
O._renderFullOH=function(r,o){if(o.getIntro()){this._renderIntro(r,o,"sapMOHIntro","sapMOHIntroActive");}r.openStart("div");r.class("sapMOHTopRow");r.openEnd();r.openStart("div",o.getId()+"-titlediv");r.class("sapMOHTitleDiv");if(o._hasIcon()){r.class("sapMOHTitleIcon");}this._renderFullTitle(r,o);r.openEnd();if(o._hasIcon()){r.openStart("div");r.class("sapMOHIcon");r.class('sapMOHIcon'+o.getImageShape());if(o.getIconActive()){r.class("sapMPointer");}r.openEnd();this._renderChildControl(r,o,o._getImageControl());r.close("div");}this._renderTitle(r,o);r.close("div");this._renderNumber(r,o);r.openStart("div");r.class("sapMOHDivider");r.openEnd();r.close("div");r.close("div");if(o._hasBottomContent()){r.openStart("div");r.class("sapMOHBottomRow");r.openEnd();this._renderAttributesAndStatuses(r,o);r.openStart("div");r.class("sapMOHDivider");r.openEnd();r.close("div");r.close("div");}};
O._renderCondensedOH=function(r,o){r.openStart("div",o.getId()+"-titlediv");r.class("sapMOHTitleDiv");this._renderFullTitle(r,o);r.openEnd();this._renderTitle(r,o);r.close("div");this._renderNumber(r,o);var f=o.getAttributes()[0];if(f&&!f._isEmpty()){this._renderAttribute(r,o,f);}};
O.render=function(r,o){if(o.getResponsive()){this._renderResponsive(r,o);return;}this._computeChildControlsToBeRendered(o);var e=o.getCondensed();r.openStart("div",o);r.openEnd();r.openStart("div");r.class("sapMOH");if(o._getBackground()!==B.Transparent){r.class("sapContrastPlus");}if(e){r.class("sapMOHC");}r.class("sapMOHBg"+o._getBackground());var t=o.getTooltip_AsString();if(t){r.attr("title",t);}r.accessibilityState({role:"region",labelledby:{value:o.getId()+"-titleText-inner",append:true}});r.openEnd();if(e){this._renderCondensedOH(r,o);}else{this._renderFullOH(r,o);}r.openStart("div");r.class("sapMOHLastDivider");r.openEnd();r.close("div");r.close("div");r.close("div");this._cleanupNotRenderedChildControls(r,o);};
O._renderChildControl=function(r,o,e){r.renderControl(e);if(!o.getResponsive()&&o.__controlsToBeRendered){o.__controlsToBeRendered[e.getId()]=undefined;}};
O._renderResponsive=function(r,o){var s=this._hasResponsiveStates(o),t=this._hasResponsiveTabs(o),h=o.getHeaderContainer();r.openStart("div",o);r.class("sapMOHROuter");var e=o.getTooltip_AsString();if(e){r.attr("title",e);}r.accessibilityState({role:"region",labelledby:{value:o.getId()+"-txt",append:true}});r.openEnd();r.openStart("div");r.class("sapMOHR");if(o._getBackground()!==B.Transparent){r.class("sapContrastPlus");}if(t){r.class("sapMOHRNoBorder");}r.class("sapMOHRBg"+o._getBackground());r.openEnd();r.openStart("div");if(D.system.desktop&&o._isMediaSize("Desktop")&&o.getFullScreenOptimized()&&o._iCountVisAttrStat>=1&&o._iCountVisAttrStat<=3){r.class("sapMOHRStatesOneOrThree");}r.openEnd();this._renderResponsiveTitleBlock(r,o);if(s){this._renderResponsiveStates(r,o);}r.close("div");if(t){this._renderResponsiveTabs(r,o);}r.close("div");if(h&&h instanceof sap.m.IconTabBar){this._renderChildControl(r,o,h);}r.close("div");if(!o.getTitle()){if(!o.getBinding("title")){L.warning("The title shouldn't be empty!");}}};
O._renderResponsiveTitleBlock=function(r,o){r.openStart("div",o.getId()+"-titlenumdiv");r.class("sapMOHRTitleNumberDiv");r.openEnd();r.openStart("div",o.getId()+"-titlediv");r.class("sapMOHRTitleDiv");if(o._hasIcon()){if(D.system.phone||o._isMediaSize("Phone")){if(D.orientation.landscape||(o._isMediaSize("Phone")&&!D.system.phone)){r.class("sapMOHRTitleIcon");}}else{r.class("sapMOHRTitleIcon");}}if(!o.getNumber()){r.class("sapMOHRTitleDivFull");}r.openEnd();this._renderResponsiveTitle(r,o);if(o._hasIcon()){r.openStart("div",o.getId()+"-titleIcon");r.class("sapMOHRIcon");r.class('sapMOHRIcon'+o.getImageShape());if((D.system.phone&&D.orientation.portrait)){r.class("sapMOHRHideIcon");}if(o.getIconActive()){r.class("sapMPointer");}r.openEnd();this._renderChildControl(r,o,o._getImageControl());r.close("div");}r.close("div");this._renderResponsiveNumber(r,o);r.close("div");};
O._renderResponsiveStates=function(r,o){r.openStart("div",o.getId()+"-states");r.class("sapMOHRStates");r.openEnd();this._renderResponsiveRow(r,o);r.close("div");};
O._renderResponsiveRow=function(r,o){var v=[];v=this._getVisibleAttribsAndStatuses(o);var V=v[0].concat(v[1]),i=v[0].length,e=V.length,R=1,s='';if(e===0){return;}if(D.system.desktop){if(!o.getFullScreenOptimized()){if(e>=1&&e<=4){R=2;s='sapMOHRTwoCols';}if(e>=5){R=3;s='sapMOHRThreeCols';}}else{if(e>=1&&e<=3){R=1;s='sapMOHROneCols';}if(e>=4){R=4;s='sapMOHRFourCols';}}}if((D.system.tablet&&!D.system.desktop)||(D.system.desktop&&o._isMediaSize("Tablet"))){if(!o.getFullScreenOptimized()||(D.orientation.portrait&&o.getFullScreenOptimized())){R=2;s='sapMOHRTwoCols';}else{if(o.getFullScreenOptimized()&&(D.orientation.landscape||(D.system.desktop&&o._isMediaSize("Tablet")))){if(e>=1&&e<=2){R=2;s='sapMOHRTwoCols';}if(e>=3){R=3;s='sapMOHRThreeCols';}}}}if(D.system.phone||(D.system.desktop&&o._isMediaSize("Phone"))){R=1;s='sapMOHROneCols';}this._renderResponsiveStatesColumn(r,o,R,V,i,s);};
O._renderResponsiveStatesColumn=function(r,o,R,v,e,s){var f=Math.floor(v.length/R);var g=v.length%R;var h=0;var j=1;for(var i=0;i<v.length;i++){if(h==0){r.openStart("div");r.class("sapMOHRStatesCont"+j);r.class(s);r.openEnd();}if(i<e){this._renderResponsiveAttribute(r,o,v[i]);}else{this._renderResponsiveStatus(r,o,v[i]);}h++;if((h==f&&j>g)||(h==(f+1)&&j<=g)||i==v.length-1){r.close("div");h=0;j++;}}};
O._renderResponsiveAttribute=function(r,o,A){r.openStart("div");r.class("sapMOHRAttr");r.openEnd();this._renderChildControl(r,o,A);r.close("div");};
O._renderResponsiveStatus=function(r,o,s){r.openStart("div");r.class("sapMOHRStatus");r.openEnd();this._renderChildControl(r,o,s[0]);r.close("div");};
O._renderResponsiveMarkers=function(r,o){var m=[],t=o.getTitleTextDirection(),p=sap.ui.getCore().getConfiguration().getRTL();m=o._getVisibleMarkers();r.openStart("span",o.getId()+"-markers");r.class("sapMObjStatusMarker");if((t===b.LTR&&p)||(t===b.RTL&&!p)){r.class("sapMObjStatusMarkerOpposite");}r.openEnd();for(var i=0;i<m.length;i++){this._renderChildControl(r,o,m[i]);}r.close("span");};
O._renderResponsiveNumber=function(r,o){var e=o.getAggregation("_objectNumber");if(e&&e.getNumber()){e.setTextDirection(o.getNumberTextDirection());this._renderChildControl(r,o,e);}};
O._hasResponsiveStates=function(o){var A=o.getAttributes(),v=[];if(!(o._hasAttributes()||o._hasStatus())){o._iCountVisAttrStat=0;return false;}for(var j=0;j<A.length;j++){if(A[j].getVisible()){v.push(A[j]);}}var V=this._getVisibleStatuses(o);o._iCountVisAttrStat=v.length+V.length;return!!(v.length+V.length);};
O._hasResponsiveTabs=function(o){var h=o.getHeaderContainer(),i;if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();if(i.getVisible()){o._iCountVisTabs=i.getItems().length;return!!i.getItems().length;}}else if(h.getMetadata().getName()==="sap.m.HeaderContainer"){return!!h.getContent().length;}else if(h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){return!!h.getItems().length;}}return false;};
O._renderResponsiveTabs=function(r,o){var h=o.getHeaderContainer(),i;r.openStart("div");r.class("sapMOHRTabs");if(h instanceof sap.m.IconTabBar){r.class("sapMOHRTabsITB");}r.openEnd();if(h){if(h instanceof sap.m.IconTabBar){i=h._getIconTabHeader();this._renderChildControl(r,o,i);h._bHideHeader=true;}else if(h.getMetadata().getName()==="sap.m.HeaderContainer"||h.getMetadata().getName()==="sap.suite.ui.commons.HeaderContainer"){this._renderChildControl(r,o,h);}else{L.warning("The control "+h+" is not supported for aggregation \"headerContainer\"");}}r.close("div");};
O._renderResponsiveTitle=function(r,o){var n;o._oTitleArrowIcon.setVisible(o.getShowTitleSelector());r.openStart("div",o.getId()+"-title");r.class("sapMOHRTitle");if(o.getTitle().length&&o.getTitleActive()){r.class("sapMOHRTitleActive");}if(o.getShowTitleSelector()){r.class("sapMOHRTitleFollowArrow");}r.openEnd();if((D.system.phone&&D.orientation.portrait)){n=50;}else{n=80;}r.openStart("div",o.getId()+"-title-arrow");r.style("display","inline-block");r.openEnd();this._renderResponsiveTitleAndArrow(r,o,n);r.close("div");if(o.getIntro()){this._renderIntro(r,o,"sapMOHRIntro","sapMOHRIntroActive");}r.close("div");};
O._rerenderTitle=function(r,o,n){var i=o.getId();this._renderResponsiveTitleAndArrow(r,o,n);r.flush(q(document.getElementById(i+"-title-arrow")));};
O._renderResponsiveTitleAndArrow=function(r,o,n){var s,e='',t=o.getTitleTextDirection();var m=!!o._getVisibleMarkers().length;var f=(o.getTitleLevel()===d.Auto)?d.H1:o.getTitleLevel();f=f.toLowerCase();r.openStart(f);r.openEnd();r.openStart("span");r.class("sapMOHRTitleTextContainer");if(t!=b.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(o.getTitle().length&&o.getTitleActive()){r.openStart("a",o.getId()+"-txt");if(o.getTitleHref()){r.attr("href",o.getTitleHref());if(o.getTitleTarget()){r.attr("target",o.getTitleTarget());}}r.attr("tabindex","0");r.accessibilityState({role:"link",haspopup:!o.getTitleHref()});}else{r.openStart("span",o.getId()+"-txt");}r.class("sapMOHRTitleText");r.openEnd();r.openStart("span",o.getId()+"-titletxtwrap");r.class("sapMOHRTitleTextWrappable");r.openEnd();if(o.getTitle().length>n){s=o.getTitle().substr(0,n).trim();e='...';}else{s=o.getTitle();}if(m){var g=s.substr(s.lastIndexOf(" ")+1);var h=s.substr(0,s.lastIndexOf(" ")+1);if(g.length===1){g=s;h='';}r.text(h);r.close("span");r.text(g);r.text(e);if(o.getTitleActive()){r.close("a");}else{r.close("span");}this._renderResponsiveMarkers(r,o);r.close("span");}else{if(!e){r.text(s);}else{r.text(s+e);}if(o.getTitleActive()){r.close("span");r.close("a");r.close("span");}else{r.close("span");r.close("span");r.close("span");}}if(o.getShowTitleSelector()){r.openStart("span");r.class("sapMOHRTitleArrow");r.openEnd();this._renderChildControl(r,o,o._oTitleArrowIcon);r.close("span");}r.close(f);};
O._rerenderResponsiveStates=function(r,o){var i=o.getId(),v=this._getVisibleAttribsAndStatuses(o),V=v[0].concat(v[1]),e=v[0].length,f=V.length,R=1,s='';if(f===0){return;}if(D.orientation.portrait){R=2;s='sapMOHRTwoCols';}else{if(f>=1&&f<=2){R=2;s='sapMOHRTwoCols';}if(f>=3){R=3;s='sapMOHRThreeCols';}}this._renderResponsiveStatesColumn(r,o,R,V,e,s);r.flush(q(document.getElementById(i+"-states"))[0]);};
return O;},true);
sap.ui.predefine('sap/m/ObjectIdentifier',['./library','./Link','./Text','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/Device','sap/ui/base/ManagedObject','./ObjectIdentifierRenderer'],function(l,L,T,C,I,a,c,D,M,O){"use strict";var b=c.TextDirection;
var d=C.extend("sap.m.ObjectIdentifier",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectIdentifier.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},badgeNotes:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgePeople:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},badgeAttachments:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},titleActive:{type:"boolean",group:"Misc",defaultValue:false},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit}},aggregations:{_titleControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{titlePress:{parameters:{domRef:{type:"object"}}}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},dnd:{draggable:true,droppable:false}}});
d.prototype.init=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(sap.ui.getCore().getConfiguration().getAccessibility()){d.OI_ARIA_ROLE=o.getText("OI_ARIA_ROLE");}};
d.prototype.exit=function(){if(this._attachmentsIcon){this._attachmentsIcon.destroy();this._attachmentsIcon=null;}if(this._peopleIcon){this._peopleIcon.destroy();this._peopleIcon=null;}if(this._notesIcon){this._notesIcon.destroy();this._notesIcon=null;}};
d.prototype._getAttachmentsIcon=function(){if(!this._attachmentsIcon){this._attachmentsIcon=this._getIcon(I.getIconURI("attachment"),this.getId()+"-attachments");}return this._attachmentsIcon;};
d.prototype._getPeopleIcon=function(){if(!this._peopleIcon){this._peopleIcon=this._getIcon(I.getIconURI("group"),this.getId()+"-people");}return this._peopleIcon;};
d.prototype._getNotesIcon=function(){if(!this._notesIcon){this._notesIcon=this._getIcon(I.getIconURI("notes"),this.getId()+"-notes");}return this._notesIcon;};
d.prototype._getIcon=function(u,i){var s=D.system.phone?"1em":"1em";var o;o=this._icon||I.createControlByURI({src:u,id:i+"-icon",size:s,useIconTooltip:false},sap.m.Image);o.setSrc(u);return o;};
d.prototype._getTitleControl=function(){var t=this.getAggregation("_titleControl"),i=this.getId(),s=M.escapeSettingsValue(this.getProperty("title"));if(!t){if(this.getProperty("titleActive")){t=new L({id:i+"-link",text:s,ariaLabelledBy:a.getStaticId("sap.m","OI_ARIA_ROLE")});t.addAssociation("ariaLabelledBy",i+"-text",true);}else{t=new T({id:i+"-txt",text:s});}this.setAggregation("_titleControl",t,true);}return t;};
d.prototype._getTextControl=function(){var t=this.getAggregation("_textControl");if(!t){t=new T({text:M.escapeSettingsValue(this.getProperty("text"))});this.setAggregation("_textControl",t,true);}t.setTextDirection(this.getTextDirection());return t;};
d.prototype.setTitle=function(t){if(t){this._getTitleControl().setProperty("text",t);}return this.setProperty("title",t);};
d.prototype.setText=function(t){if(t){this._getTextControl().setProperty("text",t);}return this.setProperty("text",t);};
d.prototype.setTitleActive=function(v){var p=this.getTitleActive();this.setProperty("titleActive",v);if(p!=v){this.destroyAggregation("_titleControl");this._getTitleControl();}return this;};
d.prototype._handlePress=function(e){var o=e.target;if(this.getTitleActive()&&this.$("title")[0].firstChild==o){this.fireTitlePress({domRef:o});e.setMarked();}};
d.prototype.onsapenter=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.onsapspace=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.ontap=function(e){d.prototype._handlePress.apply(this,arguments);};
d.prototype.addAssociation=function(A,i,s){var t=this.getAggregation("_titleControl");if(A==="ariaLabelledBy"){if(this.getTitleActive()&&t instanceof sap.m.Link){t.addAssociation("ariaLabelledBy",i,true);}}return C.prototype.addAssociation.apply(this,arguments);};
d.prototype.removeAssociation=function(A,o,s){var t=this.getAggregation("_titleControl");if(A==="ariaLabelledBy"){if(this.getTitleActive()&&t instanceof sap.m.Link){t.removeAssociation("ariaLabelledBy",o,true);}}return C.prototype.removeAssociation.apply(this,arguments);};
d.prototype.getAccessibilityInfo=function(){var t=this.getAggregation("_titleControl")?this.getAggregation("_titleControl").getAccessibilityInfo():{type:"",description:""},o=(d.OI_ARIA_ROLE+" "+(t.type||"")).trim();t.type=o;t.description=t.description+" "+this.getText();return t;};
d.prototype._hasTopRow=function(){return this.getTitle()||this.getBadgeNotes()||this.getBadgePeople()||this.getBadgeAttachments();};
return d;});
sap.ui.predefine('sap/m/ObjectIdentifierRenderer',[],function(){"use strict";var O={apiVersion:2};
O.render=function(r,o){var t;if(!o.getVisible()){return;}r.openStart("div",o);r.class("sapMObjectIdentifier");t=o.getTooltip_AsString();if(t){r.attr("title",t);}r.openEnd();r.openStart("div");r.class("sapMObjectIdentifierTopRow");if(!o._hasTopRow()){r.style("display","none");}r.openEnd();r.openStart("div",o.getId()+"-title");r.class("sapMObjectIdentifierTitle");r.openEnd();if(o.getTitle()){r.renderControl(o._getTitleControl());}r.close("div");r.openStart("div");r.class("sapMObjectIdentifierIcons");r.openEnd();if(o.getBadgeAttachments()){r.openStart("span");r.class("sapMObjectIdentifierIconSpan");r.openEnd();r.renderControl(o._getAttachmentsIcon());r.close("span");}if(o.getBadgeNotes()){r.openStart("span");r.class("sapMObjectIdentifierIconSpan");r.openEnd();r.renderControl(o._getNotesIcon());r.close("span");}if(o.getBadgePeople()){r.openStart("span");r.class("sapMObjectIdentifierIconSpan");r.openEnd();r.renderControl(o._getPeopleIcon());r.close("span");}r.close("div");r.close("div");r.openStart("div",o.getId()+"-text");r.class("sapMObjectIdentifierText");if(!!o.getProperty("text")&&!!o.getProperty("title")){r.class("sapMObjectIdentifierTextBellow");}r.openEnd();if(o.getText()){r.renderControl(o._getTextControl());}r.close("div");r.close("div");};
return O;},true);
sap.ui.predefine('sap/m/ObjectListItem',['sap/ui/core/Control','sap/ui/base/ManagedObjectObserver','./ListItemBase','./library','sap/ui/core/IconPool','sap/m/ObjectNumber','sap/ui/core/library','./ObjectMarker','./Text','./ObjectListItemRenderer'],function(C,M,L,l,I,O,c,a,T,b){"use strict";var d=l.ObjectMarkerType;var e=l.ImageHelper;var f=c.TextAlign;var g=c.TextDirection;var V=c.ValueState;
var h=L.extend("sap.m.ObjectListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},intro:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},markFavorite:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},markFlagged:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},showMarkers:{type:"boolean",group:"Misc",defaultValue:null,deprecated:true},numberState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},introTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},numberTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:g.Inherit},markLocked:{type:"boolean",group:"Misc",defaultValue:false,deprecated:true}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},firstStatus:{type:"sap.m.ObjectStatus",multiple:false},secondStatus:{type:"sap.m.ObjectStatus",multiple:false},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"},_objectNumber:{type:"sap.m.ObjectNumber",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/ObjectListItem.designtime",dnd:{draggable:true,droppable:true}}});
h.prototype.init=function(E){this._generateObjectNumber();this._observerObjectMarkerChanges=this._observerObjectMarkerChanges.bind(this);this._oMarkersObservers={};};
h.prototype.exit=function(E){if(this._oImageControl){this._oImageControl.destroy();}if(this._oTitleText){this._oTitleText.destroy();this._oTitleText=undefined;}L.prototype.exit.apply(this);};
h.prototype.onAfterRendering=function(){var o=this.getAggregation("_objectNumber"),p=sap.ui.getCore().getConfiguration().getRTL(),t=p?f.Left:f.Right;if(o&&o.getNumber()){o.setTextAlign(t);}};
h.prototype._generateObjectNumber=function(){var n=this.getNumber(),N=this.getNumberUnit(),s=this.getNumberState(),t=this.getNumberTextDirection();this.setAggregation("_objectNumber",new O(this.getId()+"-ObjectNumber",{number:n,unit:N,state:s,textDirection:t}),true);};
h.prototype._hasAttributes=function(){var j=this.getAttributes();if(j.length>0){for(var i=0;i<j.length;i++){if(!j[i]._isEmpty()){return true;}}}return false;};
h.prototype._hasStatus=function(){return((this.getFirstStatus()&&!this.getFirstStatus()._isEmpty())||(this.getSecondStatus()&&!this.getSecondStatus()._isEmpty()));};
h.prototype._hasBottomContent=function(){return(this._hasAttributes()||this._hasStatus()||this.getShowMarkers()||this.getMarkLocked()||this._getVisibleMarkers().length>0);};
h.prototype._getVisibleAttributes=function(){var A=this.getAttributes();var v=[];for(var i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
h.prototype._getVisibleMarkers=function(){var A=this.getMarkers();var v=[];for(var i=0;i<A.length;i++){if(A[i].getVisible()){v.push(A[i]);}}return v;};
h.prototype._getImageControl=function(){var i=this.getId()+'-img';var s="2.5rem";var p;if(I.isIconURI(this.getIcon())){p={src:this.getIcon(),height:s,width:s,size:s,useIconTooltip:false,densityAware:this.getIconDensityAware()};}else{p={src:this.getIcon(),useIconTooltip:false,densityAware:this.getIconDensityAware()};}var j=['sapMObjLIcon'];this._oImageControl=e.getImageControl(i,this._oImageControl,this,p,j);return this._oImageControl;};
h.prototype._activeHandlingInheritor=function(){var A=this.getActiveIcon();if(!!this._oImageControl&&!!A){this._oImageControl.setSrc(A);}};
h.prototype._inactiveHandlingInheritor=function(){var s=this.getIcon();if(!!this._oImageControl){this._oImageControl.setSrc(s);}};
h.prototype.setNumber=function(n){this.setProperty('number',n,true);this.getAggregation("_objectNumber").setNumber(n);return this;};
h.prototype.setNumberUnit=function(n){this.setProperty('numberUnit',n,true);this.getAggregation('_objectNumber').setUnit(n);return this;};
h.prototype.setNumberTextDirection=function(t){this.setProperty('numberTextDirection',t,true);this.getAggregation("_objectNumber").setTextDirection(t);return this;};
h.prototype.setNumberState=function(v){this.setProperty('numberState',v,true);this.getAggregation("_objectNumber").setState(v);return this;};
h.prototype.setMarkFavorite=function(m){return this._setOldMarkers(d.Favorite,m);};
h.prototype.setMarkFlagged=function(m){return this._setOldMarkers(d.Flagged,m);};
h.prototype.setMarkLocked=function(m){return this._setOldMarkers(d.Locked,m);};
h.prototype.setShowMarkers=function(m){var s;var A=this.getMarkers();this.setProperty("showMarkers",m,false);for(var i=0;i<A.length;i++){s=A[i].getType();if((s===d.Flagged&&this.getMarkFlagged())||(s===d.Favorite&&this.getMarkFavorite())||(s===d.Locked&&this.getMarkLocked())){A[i].setVisible(m);}}return this;};
h.prototype.addMarker=function(o){this._startObservingMarker(o);return C.prototype.addAggregation.call(this,"markers",o);};
h.prototype.insertMarker=function(o,i){this._startObservingMarker(o);return C.prototype.insertAggregation.call(this,"markers",o,i);};
h.prototype.removeMarker=function(o){var i=C.prototype.removeAggregation.call(this,"markers",o);this._stopObservingMarker(i);return i;};
h.prototype.removeAllMarkers=function(){var j=C.prototype.removeAllAggregation.call(this,"markers");for(var i=0;i<j.length;i++){this._stopObservingMarker(j[i]);}return j;};
h.prototype.destroyMarkers=function(){this.getMarkers().forEach(function(m){this._stopObservingMarker(m);},this);return C.prototype.destroyAggregation.call(this,"markers");};
h.prototype._observerObjectMarkerChanges=function(o){if(o.current!==o.old){this.invalidate();}};
h.prototype._startObservingMarker=function(m){var o=new M(this._observerObjectMarkerChanges);this._oMarkersObservers[m.getId()]=o;o.observe(m,{properties:true});return this;};
h.prototype._stopObservingMarker=function(m){var s=m.getId();this._oMarkersObservers[s].disconnect();delete this._oMarkersObservers[s];return this;};
h.prototype._setOldMarkers=function(m,j){var A=this.getMarkers();var H=false;var o={Flagged:"-flag",Favorite:"-favorite",Locked:"-lock"};this.setProperty("mark"+m,j,false);if(!this.getShowMarkers()){j=false;}for(var i=0;i<A.length;i++){if(A[i].getType()===m){H=true;A[i].setVisible(j);break;}}if(!H){this.insertAggregation("markers",new a({id:this.getId()+o[m],type:m,visible:j}));}return this;};
h.prototype._getTitleText=function(){if(!this._oTitleText){this._oTitleText=new T(this.getId()+"-titleText",{maxLines:2});this._oTitleText.setParent(this,null,true);}return this._oTitleText;};
return h;});
sap.ui.predefine('sap/m/ObjectListItemRenderer',['./ListItemBaseRenderer','sap/ui/core/Renderer','sap/ui/core/library','sap/ui/Device'],function(L,R,c,D){"use strict";var T=c.TextDirection;var O=R.extend(L);O.apiVersion=2;
O.renderAttributeStatus=function(r,l,a,s){if(!a&&!s||(a&&a._isEmpty()&&s&&s._isEmpty())){return;}r.openStart("div");r.class("sapMObjLAttrRow");r.openEnd();if(a&&!a._isEmpty()){r.openStart("div");r.class("sapMObjLAttrDiv");if(s&&(!s._isEmpty())){if(s instanceof Array){r.class("sapMObjAttrWithMarker");}}if(!s||s._isEmpty()){r.style("width","100%");}r.openEnd();r.renderControl(a);r.close("div");}if(s&&!s._isEmpty()){r.openStart("div");r.class("sapMObjLStatusDiv");if(s instanceof Array&&s.length>0){r.class("sapMObjStatusMarker");}if(!a||a._isEmpty()){r.style("width","100%");}r.openEnd();if(s instanceof Array){while(s.length>0){r.renderControl(s.shift());}}else{r.renderControl(s);}r.close("div");}r.close("div");};
O.renderLIAttributes=function(r,l){r.class("sapMObjLItem");r.class("sapMObjLListModeDiv");};
O.renderLIContent=function(r,l){var o=l.getAggregation("_objectNumber"),t=l.getTitleTextDirection(),i=l.getIntroTextDirection();if(l.getIntro()){r.openStart("div",l.getId()+"-intro");r.class("sapMObjLIntro");r.openEnd();r.openStart("span");if(i!==T.Inherit){r.attr("dir",i.toLowerCase());}r.openEnd();r.text(l.getIntro());r.close("span");r.close("div");}r.openStart("div");r.class("sapMObjLTopRow");r.openEnd();if(!!l.getIcon()){r.openStart("div");r.class("sapMObjLIconDiv");r.openEnd();r.renderControl(l._getImageControl());r.close("div");}r.openStart("div");r.class("sapMObjLNumberDiv");r.openEnd();if(o&&o.getNumber()){o.setTextDirection(l.getNumberTextDirection());r.renderControl(o);}r.close("div");r.openStart("div");r.style("display","-webkit-box");r.style("overflow","hidden");r.openEnd();var a=l._getTitleText();if(a){a.setTextDirection(t);a.setText(l.getTitle());a.addStyleClass("sapMObjLTitle");r.renderControl(a);}r.close("div");r.close("div");r.openStart("div");r.style("clear","both;");r.openEnd();r.close("div");if(l._hasBottomContent()){r.openStart("div");r.class("sapMObjLBottomRow");r.openEnd();var A=l._getVisibleAttributes();var s=[];var m=l._getVisibleMarkers();m._isEmpty=function(){return!(m.length);};if(!m._isEmpty()){s.push(m);}s.push(l.getFirstStatus());s.push(l.getSecondStatus());while(A.length>0){this.renderAttributeStatus(r,l,A.shift(),s.shift());}while(s.length>0){this.renderAttributeStatus(r,l,null,s.shift());}r.close("div");}};
O.getAriaLabelledBy=function(l){var a=[],f=l.getFirstStatus(),s=l.getSecondStatus();if(l.getIntro()){a.push(l.getId()+"-intro");}if(l.getTitle()){a.push(l.getId()+"-titleText");}if(l.getNumber()){a.push(l.getId()+"-ObjectNumber");}if(l.getAttributes()){l.getAttributes().forEach(function(b){if(!b._isEmpty()){a.push(b.getId());}});}if(f&&!f._isEmpty()){a.push(f.getId());}if(s&&!s._isEmpty()){a.push(s.getId());}if(l.getMarkers()){l.getMarkers().forEach(function(m){a.push(m.getId()+"-text");});}return a.join(" ");};
return O;},true);
sap.ui.predefine('sap/m/ObjectMarker',["sap/ui/core/Control","sap/ui/core/Renderer","sap/ui/Device","sap/m/library","sap/ui/core/library","sap/ui/core/Icon","sap/m/TextRenderer","sap/m/Text","sap/m/LinkRenderer","sap/m/Link","./ObjectMarkerRenderer"],function(C,R,D,l,c,I,T,a,L,b,O){"use strict";var d=c.TextAlign;var e=l.ObjectMarkerVisibility;
var f=C.extend("sap.m.ObjectMarker",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectMarker.designtime",properties:{type:{type:"sap.m.ObjectMarkerType",group:"Misc"},visibility:{type:"sap.m.ObjectMarkerVisibility",group:"Misc"},additionalInfo:{type:"string",group:"Misc",defaultValue:""}},aggregations:{_innerControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{type:{type:"sap.m.ObjectMarkerType"}}},dnd:{draggable:true,droppable:false}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");f.M_PREDEFINED_TYPES={Flagged:{icon:{src:"sap-icon://flag",visibility:{small:true,large:true}},text:{value:r.getText("OM_FLAG"),visibility:{small:false,large:false}}},Favorite:{icon:{src:"sap-icon://favorite",visibility:{small:true,large:true}},text:{value:r.getText("OM_FAVORITE"),visibility:{small:false,large:false}}},Draft:{icon:{src:"sap-icon://request",visibility:{small:false,large:false}},text:{value:r.getText("OM_DRAFT"),visibility:{small:true,large:true}}},Locked:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:r.getText("OM_LOCKED"),visibility:{small:false,large:true}}},Unsaved:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:r.getText("OM_UNSAVED"),visibility:{small:false,large:true}}},LockedBy:{icon:{src:"sap-icon://private",visibility:{small:true,large:true}},text:{value:r.getText("OM_LOCKED_BY"),visibility:{small:false,large:true}}},UnsavedBy:{icon:{src:"sap-icon://user-edit",visibility:{small:true,large:true}},text:{value:r.getText("OM_UNSAVED_BY"),visibility:{small:false,large:true}}}};
f.prototype.init=function(){D.media.initRangeSet("DeviceSet",[600],"px",["small","large"]);};
f.prototype.onAfterRendering=function(){this._attachMediaContainerWidthChange(this._handleMediaChange,this,"DeviceSet");};
f.prototype.onBeforeRendering=function(){this._cleanup();this._adjustControl(true);};
f.prototype.exit=function(){this._cleanup();};
f.prototype.attachPress=function(){var o=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.attachEvent.apply(this,arguments);if(this.hasListeners("press")&&o&&o instanceof h){o.destroy();this.setAggregation("_innerControl",this._createCustomLink(),true);this._adjustControl();}return this;};
f.prototype.detachPress=function(){var o=this._getInnerControl();Array.prototype.unshift.apply(arguments,["press"]);C.prototype.detachEvent.apply(this,arguments);if(!this.hasListeners("press")&&o&&o instanceof j){o.destroy();this.setAggregation("_innerControl",this._createCustomText(),true);this._adjustControl();}return this;};
f.prototype._cleanup=function(){this._detachMediaContainerWidthChange(this._handleMediaChange,this,"DeviceSet");};
f.prototype._handleMediaChange=function(){this._adjustControl();};
f.prototype._adjustControl=function(s){var t=f.M_PREDEFINED_TYPES[this.getType()],o=this._getInnerControl(),A=this.getAdditionalInfo(),k=this._isIconVisible(),m=this._isTextVisible(),n=k&&!m,p=this.getType(),q;if(!o){return false;}if(t){q=this._getMarkerText(t,p,A);}if(k){o.setIcon(t.icon.src,s);o._getIconAggregation().setDecorative(!n);this.addStyleClass("sapMObjectMarkerIcon");}else{o.setIcon(null,s);this.removeStyleClass("sapMObjectMarkerIcon");}if(m){o.setAggregation("tooltip",null,s);o.setText(q,s);this.addStyleClass("sapMObjectMarkerText");}else{if(o.getIcon()){o.setAggregation("tooltip",q,s);}o.setText(null,s);this.removeStyleClass("sapMObjectMarkerText");}return true;};
f.prototype._getMarkerText=function(t,s,A){switch(s){case"LockedBy":return(A==="")?r.getText('OM_LOCKED_BY_ANOTHER_USER'):r.getText('OM_LOCKED_BY',[A]);case"UnsavedBy":return(A==="")?r.getText('OM_UNSAVED_BY_ANOTHER_USER'):r.getText('OM_UNSAVED_BY',[A]);default:return(A==="")?t.text.value:t.text.value+" "+A;}};
f.prototype._isIconVisible=function(){var t=f.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),s=this._getDeviceType(),k=t&&t.icon.visibility[s]||false;return v===e.IconOnly||v===e.IconAndText||(v!==e.TextOnly&&k);};
f.prototype._isTextVisible=function(){var t=f.M_PREDEFINED_TYPES[this.getType()],v=this.getVisibility(),s=this._getDeviceType(),k=t&&t.text.visibility[s]||false;return v===e.TextOnly||v===e.IconAndText||(v!==e.IconOnly&&k);};
f.prototype._getDeviceType=function(){return this._getCurrentMediaContainerRange("DeviceSet").name.toLowerCase();};
f.prototype._getInnerControl=function(){var o=this.getAggregation("_innerControl");if(!o&&this.getType()){o=this._createInnerControl();this.setAggregation("_innerControl",o,true);this._adjustControl(true);}return o;};
f.prototype._createInnerControl=function(){if(this.hasListeners("press")){return this._createCustomLink();}else{return this._createCustomText();}};
f.prototype._createCustomLink=function(){var o=new j(this.getId()+"-link",{wrapping:true});o.attachPress(function(E){this.firePress({type:this.getType()});},this);return o;};
f.prototype._createCustomText=function(){return new h(this.getId()+"-text",{textAlign:d.Initial});};
["getAriaLabelledBy","addAriaLabelledBy","removeAriaLabelledBy","removeAllAriaLabelledBy","getAriaDescribedBy","addAriaDescribedBy","removeAriaDescribedBy","removeAllAriaDescribedBy","getAccessibilityInfo"].map(function(F){var k=/^add/.test(F);f.prototype[F]=function(){var o=this._getInnerControl(),m;if(o&&o[F]){m=o[F].apply(o,arguments);}return k?this:m;};});var g=R.extend(T);g.apiVersion=2;
g.renderText=function(o,k){o.renderControl(k._getIconAggregation());T.renderText(o,k);};
var h=a.extend("sap.m.internal.ObjectMarkerCustomText",{
metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:g
});
h.prototype.setIcon=function(s,S){var o=this._getIconAggregation();this.setProperty("icon",s,S);o.setSrc(s);return this;};
h.prototype._getIconAggregation=function(){var o=this.getAggregation("_iconControl");if(!o){o=new I();this.setAggregation("_iconControl",o,true);}return o;};
var i=R.extend(L);i.apiVersion=2;
i.renderText=function(o,k){o.renderControl(k._getIconAggregation());L.renderText(o,k);};
var j=b.extend("sap.m.internal.ObjectMarkerCustomLink",{
metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null}},aggregations:{_iconControl:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}}},
renderer:i
});
j.prototype.setIcon=function(s,S){var o=this._getIconAggregation();this.setProperty("icon",s,S);o.setSrc(s);return this;};
j.prototype._getTabindex=function(){return"0";};
j.prototype._getIconAggregation=function(){var o=this.getAggregation("_iconControl");if(!o){o=new I();this.setAggregation("_iconControl",o,true);}return o;};
return f;});
sap.ui.predefine('sap/m/ObjectMarkerRenderer',[],function(){"use strict";var O={apiVersion:2};
O.render=function(r,c){r.openStart("span",c);r.class("sapMObjectMarker");r.openEnd();r.renderControl(c._getInnerControl());r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectNumber',['./library','sap/ui/core/Control','sap/ui/core/Renderer','sap/ui/core/library','./ObjectNumberRenderer'],function(l,C,R,c,O){"use strict";var T=c.TextAlign;var a=c.TextDirection;var V=c.ValueState;
var b=C.extend("sap.m.ObjectNumber",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/ObjectNumber.designtime",properties:{number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null,deprecated:true},emphasized:{type:"boolean",group:"Appearance",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},unit:{type:"string",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:a.Inherit},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},dnd:{draggable:true,droppable:false}}});
b.prototype._getStateText=function(){var s=this.getState(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return r.getText("OBJECTNUMBER_ARIA_VALUE_STATE_"+s.toUpperCase(),[],true);};
return b;});
sap.ui.predefine('sap/m/ObjectNumberRenderer',['sap/ui/core/Renderer','sap/ui/core/library'],function(R,c){"use strict";var V=c.ValueState;var T=c.TextDirection;var _='sapMObjectNumberStatus';var O={apiVersion:2};
O.render=function(r,o){var t=o.getTooltip_AsString(),s=o.getTextDirection(),a=o.getTextAlign();r.openStart("div",o);r.class("sapMObjectNumber");r.class(_+o.getState());if(o.getEmphasized()){r.class("sapMObjectNumberEmph");}if(t){r.attr("title",t);}if(s!==T.Inherit){r.attr("dir",s.toLowerCase());}a=R.getTextAlign(a,s);if(a){r.style("text-align",a);}r.accessibilityState(o);r.openEnd();this.renderText(r,o);r.text("  ");this.renderUnit(r,o);this.renderHiddenARIAElement(r,o);r.close("div");};
O.renderText=function(r,o){r.openStart("span");r.class("sapMObjectNumberText");r.openEnd();r.text(o.getNumber());r.close("span");};
O.renderUnit=function(r,o){var u=o.getUnit()||o.getNumberUnit();if(u!==""){r.openStart("span");r.class("sapMObjectNumberUnit");r.openEnd();r.text(u);r.close("span");}};
O.renderHiddenARIAElement=function(r,o){if(o.getState()==V.None){return;}r.openStart("span",o.getId()+"-state");r.class("sapUiPseudoInvisibleText");r.openEnd();r.text(o._getStateText());r.close("span");};
return O;},true);
sap.ui.predefine('sap/m/ObjectStatus',['./library','sap/ui/core/Control','sap/ui/core/ValueStateSupport','sap/ui/core/IndicationColorSupport','sap/ui/core/library','sap/ui/base/DataType','./ObjectStatusRenderer'],function(l,C,V,I,c,D,O){"use strict";var a=l.ImageHelper;var T=c.TextDirection;var b=c.ValueState;
var d=C.extend("sap.m.ObjectStatus",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/ObjectStatus.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:false},state:{type:"string",group:"Misc",defaultValue:b.None},inverted:{type:"boolean",group:"Misc",defaultValue:false},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{press:{}},dnd:{draggable:true,droppable:false}}});
d.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
d.prototype._getImageControl=function(){var i=this.getId()+'-icon',e=!this.getText()&&!this.getTitle(),p={src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};if(e){p.decorative=false;p.alt=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS_ICON");}this._oImageControl=a.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
d.prototype.setState=function(v){if(v==null){v=b.None;}else if(!D.getType("sap.ui.core.ValueState").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error('"'+v+'" is not a value of the enums sap.ui.core.ValueState or sap.ui.core.IndicationColor for property "state" of '+this);}return this.setProperty("state",v);};
d.prototype.ontap=function(e){if(this._isClickable(e)){this.firePress();}};
d.prototype.onsapenter=function(e){if(this._isActive()){this.firePress();e.setMarked();}};
d.prototype.onsapspace=function(e){this.onsapenter(e);};
d.prototype._isActive=function(){return this.getActive()&&(this.getText().trim()||this.getIcon().trim());};
d.prototype._isEmpty=function(){return!(this.getText().trim()||this.getIcon().trim()||this.getTitle().trim());};
d.prototype.ontouchstart=function(e){if(this._isClickable(e)){e.setMarked();}};
d.prototype.getAccessibilityInfo=function(){var s=V.getAdditionalText(this.getState());if(this.getState()!=b.None){s=(s!==null)?s:I.getAdditionalText(this.getState());}return{description:((this.getTitle()||"")+" "+(this.getText()||"")+" "+(s!==null?s:"")+" "+(this.getTooltip()||"")+" "+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS")).trim()};};
d.prototype._isClickable=function(e){var s=e.target.id;return this._isActive()&&(s===this.getId()+"-link"||s===this.getId()+"-text"||s===this.getId()+"-statusIcon"||s===this.getId()+"-icon");};
return d;});
sap.ui.predefine('sap/m/ObjectStatusRenderer',['sap/ui/core/ValueStateSupport','sap/ui/core/IndicationColorSupport','sap/ui/core/InvisibleText','sap/ui/core/library'],function(V,I,a,c){"use strict";var T=c.TextDirection;var b=c.ValueState;var O={apiVersion:2};
O.render=function(r,o){r.openStart("div",o);if(o._isEmpty()){r.style("display","none");r.openEnd();}else{var s=o.getState();var i=o.getInverted();var t=o.getTextDirection();var C=sap.ui.getCore();var p=C.getConfiguration().getRTL();var A={roledescription:C.getLibraryResourceBundle("sap.m").getText("OBJECT_STATUS")};var v;var d;if(t===T.Inherit){t=p?T.RTL:T.LTR;}var e=o.getTooltip_AsString();if(e){r.attr("title",e);}r.class("sapMObjStatus");r.class("sapMObjStatus"+s);if(i){r.class("sapMObjStatusInverted");}if(o._isActive()){r.class("sapMObjStatusActive");r.attr("tabindex","0");A.role="button";}else{A.role="group";}r.accessibilityState(o,A);r.openEnd();if(o.getTitle()){r.openStart("span",o.getId()+"-title");r.class("sapMObjStatusTitle");if(t){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(o.getTitle()+":");r.close("span");}if(o._isActive()){r.openStart("span",o.getId()+"-link");r.class("sapMObjStatusLink");r.openEnd();}if(o.getIcon()){r.openStart("span",o.getId()+"-statusIcon");r.class("sapMObjStatusIcon");if(!o.getText()){r.class("sapMObjStatusIconOnly");}r.openEnd();r.renderControl(o._getImageControl());r.close("span");}if(o.getText()){r.openStart("span",o.getId()+"-text");r.class("sapMObjStatusText");if(t){r.attr("dir",t.toLowerCase());}r.openEnd();r.text(o.getText());r.close("span");}if(o._isActive()){r.close("span");}if(s!=b.None){v=V.getAdditionalText(s);if(v){d=v;}else{d=I.getAdditionalText(s);}if(d){r.openStart("span",o.getId()+"sapSRH");r.class("sapUiPseudoInvisibleText");r.openEnd();r.text(d);r.close("span");}}}r.close("div");};
return O;},true);
sap.ui.predefine('sap/m/OverflowToolbar',["./library","sap/ui/core/Control","sap/m/ToggleButton","sap/ui/core/InvisibleText","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData","sap/m/OverflowToolbarAssociativePopover","sap/m/OverflowToolbarAssociativePopoverControls",'sap/ui/core/ResizeHandler',"sap/ui/core/IconPool",'sap/ui/core/theming/Parameters','sap/ui/dom/units/Rem',"sap/ui/Device","./OverflowToolbarRenderer","sap/base/Log","sap/ui/dom/jquery/Focusable"],function(l,C,T,I,a,b,O,c,d,R,e,P,D,f,g,L){"use strict";var h=l.PlacementType;var B=l.ButtonType;var j=l.OverflowToolbarPriority;
var k=a.extend("sap.m.OverflowToolbar",{metadata:{properties:{asyncMode:{type:"boolean",group:"Behavior",defaultValue:false}},aggregations:{_overflowButton:{type:"sap.m.ToggleButton",multiple:false,visibility:"hidden"},_popover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/OverflowToolbar.designtime"}});
k.ARIA_ROLE_DESCRIPTION="OVERFLOW_TOOLBAR_ROLE_DESCRIPTION";
k.prototype._callToolbarMethod=function(F,A){return a.prototype[F].apply(this,A);};
k.prototype.init=function(){this._callToolbarMethod("init",arguments);this._iPreviousToolbarWidth=null;this._bOverflowButtonNeeded=false;this._bNestedInAPopover=null;this._bListenForControlPropertyChanges=false;this._bListenForInvalidationEvents=false;this._bControlsInfoCached=false;this._bSkipOptimization=false;this._aControlSizes={};this._iFrameRequest=null;this._iOverflowToolbarButtonSize=0;this._oOverflowToolbarButtonClone=null;this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aPopoverOnlyControls=[];this._aAllCollections=[this._aMovableControls,this._aToolbarOnlyControls,this._aPopoverOnlyControls];this.addStyleClass("sapMOTB");this._sAriaRoleDescription=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText(k.ARIA_ROLE_DESCRIPTION);};
k.prototype.exit=function(){var p=this.getAggregation("_popover");if(p){p.destroy();}if(this._oOverflowToolbarButtonClone){this._oOverflowToolbarButtonClone.destroy();}if(this._iFrameRequest){window.cancelAnimationFrame(this._iFrameRequest);this._iFrameRequest=null;}};
k.prototype.setAsyncMode=function(v){return this.setProperty("asyncMode",v,true);};
k.prototype.onAfterRendering=function(){this._bInvalidatedAndNotRendered=false;this._getOverflowButton().$().attr("aria-haspopup","menu");if(this._bContentVisibilityChanged){this._bControlsInfoCached=false;this._bContentVisibilityChanged=false;}if(this.getAsyncMode()){this._doLayoutAsync().then(this._applyFocus.bind(this));}else{this._doLayout();this._applyFocus();}};
k.prototype.onsapfocusleave=function(){this._resetChildControlFocusInfo();};
k.prototype._doLayout=function(){var o=sap.ui.getCore(),w;if(!o.isThemeApplied()){L.debug("OverflowToolbar: theme not applied yet, skipping calculations",this);return;}this._recalculateOverflowButtonSize();w=this.$().is(":visible")?this.$().width():0;this._bListenForControlPropertyChanges=false;this._bListenForInvalidationEvents=false;this._deregisterToolbarResize();if(w>0){if(!this._isControlsInfoCached()){this._cacheControlsInfo();}if(this._iPreviousToolbarWidth!==w){this._iPreviousToolbarWidth=w;this._setControlsOverflowAndShrinking(w);this.fireEvent("_controlWidthChanged");}}this._registerToolbarResize();this._bListenForControlPropertyChanges=true;this._bListenForInvalidationEvents=true;};
k.prototype._doLayoutAsync=function(){return new Promise(function(r,i){this._iFrameRequest=window.requestAnimationFrame(function(){this._doLayout();r();}.bind(this));}.bind(this));};
k.prototype._applyFocus=function(){var F,$,i=this.$().lastFocusableDomRef();if(this.sFocusedChildControlId){F=sap.ui.getCore().byId(this.sFocusedChildControlId);$=F&&F.$();}if($&&$.length){$.trigger("focus");}else if(this._bControlWasFocused){this._getOverflowButton().focus();this._bControlWasFocused=false;this._bOverflowButtonWasFocused=true;}else if(this._bOverflowButtonWasFocused&&!this._getOverflowButtonNeeded()){i&&i.focus();this._bOverflowButtonWasFocused=false;}};
k.prototype._preserveChildControlFocusInfo=function(){var A=sap.ui.getCore().getCurrentFocusedControlId();if(this._getControlsIds().indexOf(A)!==-1){this._bControlWasFocused=true;this.sFocusedChildControlId=A;}else if(A===this._getOverflowButton().getId()){this._bOverflowButtonWasFocused=true;this.sFocusedChildControlId="";}};
k.prototype._resetChildControlFocusInfo=function(){this._bControlWasFocused=false;this._bOverflowButtonWasFocused=false;this.sFocusedChildControlId="";};
k.prototype._registerToolbarResize=function(){if(a.isRelativeWidth(this.getWidth())){var r=this._handleResize.bind(this);this._sResizeListenerId=R.register(this,r);}};
k.prototype._deregisterToolbarResize=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId="";}};
k.prototype._handleResize=function(){if(this._bInvalidatedAndNotRendered){return;}if(this.getAsyncMode()){this._doLayoutAsync();}else{this._doLayout();}};
k.prototype._cacheControlsInfo=function(){var v,H,i=parseInt(this.$().css("padding-right"))||0,r=parseInt(this.$().css("padding-left"))||0;this._iOldContentSize=this._iContentSize;this._iContentSize=0;this.getContent().forEach(this._updateControlsCachedSizes,this);if(f.system.phone){this._iContentSize-=1;}if(this._aPopoverOnlyControls.length){v=this._aPopoverOnlyControls.filter(function(o){return o.getVisible();});H=(v.length>0);if(H){this._iContentSize+=this._getOverflowButtonSize();}}this._bControlsInfoCached=true;if(this._iOldContentSize!==this._iContentSize){this.fireEvent("_contentSizeChange",{contentSize:this._iContentSize+i+r+1});}};
k.prototype._updateControlsCachedSizes=function(o){var p,i;p=this._getControlPriority(o);i=this._calculateControlSize(o);this._aControlSizes[o.getId()]=i;if(p!==j.AlwaysOverflow){this._iContentSize+=i;}};
k.prototype._calculateControlSize=function(o){return this._getOptimalControlWidth(o,this._aControlSizes[o.getId()]);};
k.prototype._isControlsInfoCached=function(){return this._bControlsInfoCached;};
k.prototype._flushButtonsToPopover=function(){this._aButtonsToMoveToPopover.forEach(this._moveButtonToPopover,this);};
k.prototype._invalidateIfHashChanged=function(H){if(typeof H==="undefined"||this._getPopover()._getContentIdsHash()!==H){this._preserveChildControlFocusInfo();this.invalidate();}};
k.prototype._addOverflowButton=function(){if(!this._getOverflowButtonNeeded()){this._iCurrentContentSize+=this._getOverflowButtonSize();this._setOverflowButtonNeeded(true);}};
k.prototype._aggregateMovableControls=function(){var G={},A=[],i,p,s,m,n;this._aMovableControls.forEach(function(o){i=k._getControlGroup(o);p=k._oPriorityOrder;if(i){s=this._getControlPriority(o);m=this._getControlIndex(o);G[i]=G[i]||[];n=G[i];n.unshift(o);if(!n._priority||p[n._priority]<p[s]){n._priority=s;}if(!n._index||n._index<m){n._index=m;}}else{A.push(o);}},this);Object.keys(G).forEach(function(o){A.push(G[o]);});return A;};
k.prototype._extractControlsToMoveToOverflow=function(A,t){var i,m;for(i=0;i<A.length;i++){m=A[i];if(m.length){m.forEach(this._addToPopoverArrAndUpdateContentSize,this);}else{this._addToPopoverArrAndUpdateContentSize(m);}if(this._getControlPriority(m)!==j.Disappear){this._addOverflowButton();}if(this._iCurrentContentSize<=t){break;}}};
k.prototype._addToPopoverArrAndUpdateContentSize=function(o){this._aButtonsToMoveToPopover.unshift(o);this._iCurrentContentSize-=this._aControlSizes[o.getId()];};
k.prototype._sortByPriorityAndIndex=function(v,i){var p=k._oPriorityOrder,s=this._getControlPriority(v),m=this._getControlPriority(i),n=p[s]-p[m];if(n!==0){return n;}else{return this._getControlIndex(i)-this._getControlIndex(v);}};
k.prototype._setControlsOverflowAndShrinking=function(t){var i;this._iCurrentContentSize=this._iContentSize;this._aButtonsToMoveToPopover=[];if(this._bSkipOptimization){this._bSkipOptimization=false;}else{i=this._getPopover()._getContentIdsHash();}this._resetToolbar();this._collectPopoverOnlyControls();this._markControlsWithShrinkableLayoutData();if(this._iCurrentContentSize<=t){this._flushButtonsToPopover();this._invalidateIfHashChanged(i);return;}this._moveControlsToPopover(t);this._flushButtonsToPopover();if(this._iCurrentContentSize>t){this._checkContents();}this._invalidateIfHashChanged(i);};
k.prototype._markControlsWithShrinkableLayoutData=function(){this.getContent().forEach(this._markControlWithShrinkableLayoutData,this);};
k.prototype._collectPopoverOnlyControls=function(){var p=this._aPopoverOnlyControls.length,i,o;if(p){for(i=p-1;i>=0;i--){o=this._aPopoverOnlyControls[i];if(o.getVisible()){this._aButtonsToMoveToPopover.unshift(o);}}if(this._aButtonsToMoveToPopover.length>0){this._setOverflowButtonNeeded(true);}}};
k.prototype._moveControlsToPopover=function(t){var A=[];if(this._aMovableControls.length){A=this._aggregateMovableControls();A.sort(this._sortByPriorityAndIndex.bind(this));this._extractControlsToMoveToOverflow(A,t);}};
k.prototype._markControlWithShrinkableLayoutData=function(o){var w,i;o.removeStyleClass(a.shrinkClass);w=a.getOrigWidth(o.getId());if(!a.isRelativeWidth(w)){return;}i=o.getLayoutData();if(i&&i.isA("sap.m.ToolbarLayoutData")&&i.getShrinkable()){o.addStyleClass(a.shrinkClass);}};
k.prototype._resetToolbar=function(){this._getPopover().close();this._getPopover()._getAllContent().forEach(this._restoreButtonInToolbar,this);this._setOverflowButtonNeeded(false);this.getContent().forEach(this._removeShrinkingClass);};
k.prototype._removeShrinkingClass=function(o){o.removeStyleClass(a.shrinkClass);};
k.prototype._moveButtonToPopover=function(o){this._getPopover().addAssociatedContent(o);};
k.prototype._restoreButtonInToolbar=function(v){if(typeof v==="object"){v=v.getId();}this._getPopover().removeAssociatedContent(v);};
k.prototype._resetAndInvalidateToolbar=function(H){if(this._bIsBeingDestroyed){return;}this._resetToolbar();this._bControlsInfoCached=false;this._bNestedInAPopover=null;this._iPreviousToolbarWidth=null;if(H){this._bSkipOptimization=true;}if(this.$().length){this._preserveChildControlFocusInfo();this.invalidate();}};
k.prototype.invalidate=function(){this._bInvalidatedAndNotRendered=true;C.prototype.invalidate.apply(this,arguments);};
k.prototype._getVisibleContent=function(){var t=this.getContent(),p=this._getPopover()._getAllContent();return t.filter(function(o){return p.indexOf(o)===-1;});};
k.prototype._getVisibleAndNonOverflowContent=function(){return this._getVisibleContent().filter(function(o){return o.getVisible();});};
k.prototype._getToggleButton=function(i){return new T({id:this.getId()+i,icon:e.getIconURI("overflow"),press:this._overflowButtonPressed.bind(this),ariaLabelledBy:I.getStaticId("sap.ui.core","Icon.overflow"),type:B.Transparent});};
k.prototype._getOverflowButton=function(){var o;if(!this.getAggregation("_overflowButton")){o=this._getToggleButton("-overflowButton");this.setAggregation("_overflowButton",o,true);}return this.getAggregation("_overflowButton");};
k.prototype._getOverflowButtonClone=function(){if(!this._oOverflowToolbarButtonClone){this._oOverflowToolbarButtonClone=this._getToggleButton("-overflowButtonClone").addStyleClass("sapMTBHiddenElement");}return this._oOverflowToolbarButtonClone;};
k.prototype._overflowButtonPressed=function(E){var p=this._getPopover(),s=this._getBestPopoverPlacement();if(p.getPlacement()!==s){p.setPlacement(s);}if(p.isOpen()){p.close();}else{p.openBy(E.getSource());}};
k.prototype._getPopover=function(){var p;if(!this.getAggregation("_popover")){p=new c(this.getId()+"-popover",{showHeader:false,showArrow:false,modal:false,horizontalScrolling:f.system.phone?false:true,contentWidth:f.system.phone?"100%":"auto",offsetY:this._detireminePopoverVerticalOffset(),ariaLabelledBy:I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES")});p._adaptPositionParams=function(){c.prototype._adaptPositionParams.call(this);this._myPositions=["end top","begin center","end bottom","end center"];this._atPositions=["end bottom","end center","end top","begin center"];};if(f.system.phone){p.attachBeforeOpen(this._shiftPopupShadow,this);}p.attachAfterClose(this._popOverClosedHandler,this);this.setAggregation("_popover",p,true);}return this.getAggregation("_popover");};
k.prototype._shiftPopupShadow=function(){var p=this._getPopover(),s=p.getCurrentPosition();if(s===h.Bottom){p.addStyleClass("sapMOTAPopoverNoShadowTop");p.removeStyleClass("sapMOTAPopoverNoShadowBottom");}else if(s===h.Top){p.addStyleClass("sapMOTAPopoverNoShadowBottom");p.removeStyleClass("sapMOTAPopoverNoShadowTop");}};
k.prototype._popOverClosedHandler=function(){var w=f.os.windows_phone||f.browser.edge&&f.browser.mobile;this._getOverflowButton().setPressed(false);this._getOverflowButton().$().trigger("focus");if(this._isNestedInsideAPopup()||w){return;}this._getOverflowButton().setEnabled(false);setTimeout(function(){this._getOverflowButton().setEnabled(true);setTimeout(function(){this._getOverflowButton().$().trigger("focus");}.bind(this),0);}.bind(this),0);};
k.prototype._isNestedInsideAPopup=function(){var s;if(this._bNestedInAPopover!==null){return this._bNestedInAPopover;}s=function(o){if(!o){return false;}if(o.getMetadata().isInstanceOf("sap.ui.core.PopupInterface")){return true;}return s(o.getParent());};this._bNestedInAPopover=s(this);return this._bNestedInAPopover;};
k.prototype._getOverflowButtonNeeded=function(){return this._bOverflowButtonNeeded;};
k.prototype._setOverflowButtonNeeded=function(v){if(this._bOverflowButtonNeeded!==v){this._bOverflowButtonNeeded=v;}return this;};
k.prototype._updateContentInfoInControlsCollections=function(){this.getContent().forEach(function(o){if(o){this._removeContentFromControlsCollections(o);this._moveControlInSuitableCollection(o,this._getControlPriority(o));}},this);};
k.prototype._moveControlInSuitableCollection=function(o,p){var i=p!==j.NeverOverflow,A=p===j.AlwaysOverflow;if(d.supportsControl(o)&&A){this._aPopoverOnlyControls.push(o);}else{if(d.supportsControl(o)&&i&&o.getVisible()){this._aMovableControls.push(o);}else{this._aToolbarOnlyControls.push(o);}}};
k.prototype._removeContentFromControlsCollections=function(o){var i,m,n;for(i=0;i<this._aAllCollections.length;i++){m=this._aAllCollections[i];n=m.indexOf(o);if(n!==-1){m.splice(n,1);}}};
k.prototype._clearAllControlsCollections=function(){this._aMovableControls=[];this._aToolbarOnlyControls=[];this._aPopoverOnlyControls=[];this._aAllCollections=[this._aMovableControls,this._aToolbarOnlyControls,this._aPopoverOnlyControls];};
k.prototype.onLayoutDataChange=function(E){this._resetAndInvalidateToolbar(true);E&&this._updateContentInfoInControlsCollections();};
k.prototype.addContent=function(o){this._registerControlListener(o);this._resetAndInvalidateToolbar(false);if(o){this._moveControlInSuitableCollection(o,this._getControlPriority(o));}this._informNewFlexibleContentAdded(o);return this._callToolbarMethod("addContent",arguments);};
k.prototype.insertContent=function(o,i){this._registerControlListener(o);this._resetAndInvalidateToolbar(false);if(o){this._moveControlInSuitableCollection(o,this._getControlPriority(o));}this._informNewFlexibleContentAdded(o);return this._callToolbarMethod("insertContent",arguments);};
k.prototype.removeContent=function(){var v=this._callToolbarMethod("removeContent",arguments);if(v){this._getPopover().removeAssociatedContent(v.getId());}this._resetAndInvalidateToolbar(false);this._deregisterControlListener(v);this._removeContentFromControlsCollections(v);return v;};
k.prototype.removeAllContent=function(){var i=this._callToolbarMethod("removeAllContent",arguments);i.forEach(this._deregisterControlListener,this);i.forEach(this._removeContentFromControlsCollections,this);this._resetAndInvalidateToolbar(false);this._clearAllControlsCollections();return i;};
k.prototype.destroyContent=function(){this._resetAndInvalidateToolbar(false);setTimeout(function(){this._resetAndInvalidateToolbar(false);}.bind(this),0);this._clearAllControlsCollections();return this._callToolbarMethod("destroyContent",arguments);};
k.prototype._informNewFlexibleContentAdded=function(o){if(o&&o.isA("sap.m.IOverflowToolbarFlexibleContent")){this.fireEvent("_contentSizeChange",{contentSize:null});}};
k.prototype._registerControlListener=function(o){var i;if(o){o.attachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1){i=o.getOverflowToolbarConfig().invalidationEvents;if(i&&Array.isArray(i)){i.forEach(function(E){o.attachEvent(E,this._onInvalidationEventFired,this);},this);}}}};
k.prototype._deregisterControlListener=function(o){var i;if(o){o.detachEvent("_change",this._onContentPropertyChangedOverflowToolbar,this);if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1){i=o.getOverflowToolbarConfig().invalidationEvents;if(i&&Array.isArray(i)){i.forEach(function(E){o.detachEvent(E,this._onInvalidationEventFired,this);},this);}}}};
k.prototype._onContentPropertyChangedOverflowToolbar=function(E){var s=E.getSource(),o,p;this._updateContentInfoInControlsCollections();if(!this._bListenForControlPropertyChanges){return;}o=d.getControlConfig(s);p=E.getParameter("name");if(p!=='visible'&&!s.getVisible()){return;}if(typeof o!=="undefined"&&o.noInvalidationProps.indexOf(p)!==-1){return;}if(p==="visible"){this._bContentVisibilityChanged=true;}if(s.isA("sap.m.IOverflowToolbarFlexibleContent")&&s.getVisible()){this.fireEvent("_contentSizeChange",{contentSize:null});}this._resetAndInvalidateToolbar(true);};
k.prototype._onInvalidationEventFired=function(E){var s=E.getSource();if(!this._bListenForInvalidationEvents){return;}if(s.isA("sap.m.IOverflowToolbarFlexibleContent")){this.fireEvent("_contentSizeChange",{contentSize:null});}this._resetAndInvalidateToolbar(true);};
k.prototype._getOverflowButtonSize=function(){return this._iOverflowToolbarButtonSize;};
k.prototype._getBestPopoverPlacement=function(){var H=this.getHTMLTag();if(H==="Footer"){return h.Top;}else if(H==="Header"){return h.Bottom;}return h.Vertical;};
k.prototype._getControlsIds=function(){return this.getContent().map(function(i){return i.getId();});};
k.prototype._getControlIndex=function(v){return v.length?v._index:this.indexOfContent(v);};
k.prototype._getOptimalControlWidth=function(o,i){var m,n=o.getLayoutData(),s=n&&n.isA("sap.m.ToolbarLayoutData")?n.getShrinkable():false,M=s?this._getMinWidthOfShrinkableControl(o):0,v=o.getVisible(),S;if(o.isA("sap.m.ToolbarSpacer")){S=parseInt(o.$().css('width'));M=(o.getWidth()&&S)?S:0;m=k._getOptimalWidthOfShrinkableControl(o,M);}else if(s&&M>0&&v){m=k._getOptimalWidthOfShrinkableControl(o,M);}else{m=v?k._getControlWidth(o):0;}if(m===null){m=typeof i!=="undefined"?i:0;}return m;};
k.prototype._getMinWidthOfShrinkableControl=function(o){var m=o.$().css("min-width"),M=parseInt(m),r=a.isRelativeWidth(m);if(r){return(M*this.$().width())/100;}else{return M;}};
k.prototype._getControlPriority=function(v){var i,o,p,G;if(v.length){return v._priority;}i=v.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")>-1;G=i&&v.getOverflowToolbarConfig().getCustomImportance;if(i&&typeof G==="function"){return G();}o=v.getLayoutData&&v.getLayoutData();if(o&&o instanceof O){if(o.getMoveToOverflow()===false){return j.NeverOverflow;}if(o.getStayInOverflow()===true){return j.AlwaysOverflow;}p=o.getPriority();if(p===j.Never){return j.NeverOverflow;}if(p===j.Always){return j.AlwaysOverflow;}return p;}return j.High;};
k._getControlMargins=function(o){return o.$().outerWidth(true)-o.$().outerWidth();};
k._getOptimalWidthOfShrinkableControl=function(o,m){return m+k._getControlMargins(o);};
k._getControlWidth=function(o){var i=o&&o.getDomRef();if(i){return Math.round(i.getBoundingClientRect().width+k._getControlMargins(o));}return null;};
k._getControlGroup=function(o){var i=o.getLayoutData();if(i instanceof O){return i.getGroup();}};
k._oPriorityOrder=(function(){var p={};p[j.Disappear]=1;p[j.Low]=2;p["Medium"]=3;p[j.High]=4;return p;})();
k.prototype._detireminePopoverVerticalOffset=function(){return this.$().parents().hasClass('sapUiSizeCompact')?2:3;};
k.prototype._recalculateOverflowButtonSize=function(){var o=this._getOverflowButtonClone().$(),i;if(!this._getOverflowButtonSize()&&o.width()>0){i=o.outerWidth(true);this._iOverflowToolbarButtonSize=i?i:0;}};
k.prototype.onThemeChanged=function(){this._resetAndInvalidateToolbar();this._iOverflowToolbarButtonSize=0;this._recalculateOverflowButtonSize();for(var i in this._aControlSizes){if(this._aControlSizes.hasOwnProperty(i)){this._aControlSizes[i]=0;}}};
k.prototype.closeOverflow=function(){this._getPopover().close();};
return k;});
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopover',['./Popover','./PopoverRenderer','./OverflowToolbarAssociativePopoverControls','./OverflowToolbarLayoutData','sap/m/library'],function(P,a,O,b,l){"use strict";var c=l.PlacementType;var d=l.OverflowToolbarPriority;
var e=P.extend("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopover",{
metadata:{associations:{associatedContent:{type:"sap.ui.core.Control",multiple:true}}},
renderer:a.render
});
e.prototype.init=function(){P.prototype.init.apply(this,arguments);this.oControlsManager=new O();};
e.prototype.onBeforeRendering=function(){P.prototype.onBeforeRendering.apply(this,arguments);this.addStyleClass("sapMOTAPopover");this.addStyleClass("sapMOverflowToolbarMenu-CTX");};
e.prototype.addAssociatedContent=function(o){this.addAssociation("associatedContent",o,true);this._preProcessControl(o);return this;};
e.prototype.removeAssociatedContent=function(o){var r=this.removeAssociation("associatedContent",o,true),f;if(r){f=sap.ui.getCore().byId(r);if(f){this._postProcessControl(f);}}return r;};
e.prototype._preProcessControl=function(o){var f=O.getControlConfig(o),A;f.listenForEvents.forEach(function(E){A="attach"+C(E);if(o[A]){o[A](this._closeOnInteraction.bind(this,o));}else{o.attachEvent(E,this._closeOnInteraction.bind(this,o));}},this);if(typeof f.preProcess==="function"){f.preProcess.call(this.oControlsManager,o);}var L=o.getLayoutData();if(L instanceof b&&L.getPriority()===d.Disappear){o.addStyleClass("sapMOTAPHidden");}return this;};
e.prototype._postProcessControl=function(o){var f=O.getControlConfig(o),D;f.listenForEvents.forEach(function(E){D="detach"+C(E);if(o[D]){o[D](this._closeOnInteraction,this);}else{o.detachEvent(E,this._closeOnInteraction,this);}},this);if(typeof f.postProcess==="function"){f.postProcess.call(this.oControlsManager,o);}o.removeStyleClass("sapMOTAPHidden");o.$().remove();return this;};
e.prototype._closeOnInteraction=function(o){var L=o.getLayoutData();if(!L||!(L instanceof b)||L.getCloseOverflowOnInteraction()){this.close();}};
e.prototype._getContentIdsHash=function(){return this._getAllContent().join(".");};
e.prototype._recalculateMargins=function(s,p){if(s!==c.Top){return P.prototype._recalculateMargins.apply(this,arguments);}p._fMarginBottom=p._fDocumentHeight-p._$parent.offset().top+this._arrowOffset+p._fOffsetY;};
e.prototype._getAllContent=function(){var A=this.getAssociatedContent().map(function(i){return sap.ui.getCore().byId(i);});if(this.getPlacement()===c.Top){A.reverse();}return this.getContent().concat(A);};
e.prototype.getCurrentPosition=function(){if(!this._oCalcedPos){this._calcPlacement();}return this._oCalcedPos;};
function C(n){return n.substring(0,1).toUpperCase()+n.substring(1);}
return e;});
sap.ui.predefine('sap/m/OverflowToolbarAssociativePopoverControls',['sap/ui/base/Object','./OverflowToolbarButton','./OverflowToolbarToggleButton','./ToggleButton','./Button','sap/m/library',"sap/base/Log"],function(B,O,a,T,b,l,L){"use strict";var c=l.ButtonType;
var d=B.extend("sap.m._overflowToolbarHelpers.OverflowToolbarAssociativePopoverControls",{
constructor:function(){this._mControlsCache={};},
getInterface:function(){return this;}
});
d.prototype._preProcessSapMButton=function(o){var e=o.getType();this._mControlsCache[o.getId()]={buttonType:e};if(e===c.Default){o.setProperty("type",c.Transparent,true);}o.attachEvent("_change",this._onSapMButtonUpdated,this);};
d.prototype._postProcessSapMButton=function(o){var p=this._mControlsCache[o.getId()];if(o.getType()!==p.buttonType){o.setProperty("type",p.buttonType,true);}o.detachEvent("_change",this._onSapMButtonUpdated,this);};
d.prototype._onSapMButtonUpdated=function(e){var p=e.getParameter("name"),o=e.getSource(),s=o.getId();if(typeof this._mControlsCache[s]==="undefined"){return;}if(p==="type"){this._mControlsCache[s]["buttonType"]=o.getType();}};
d.prototype._preProcessSapMOverflowToolbarButton=function(o){this._preProcessSapMButton(o);o._bInOverflow=true;};
d.prototype._postProcessSapMOverflowToolbarButton=function(o){delete o._bInOverflow;this._postProcessSapMButton(o);};
d.prototype._preProcessSapMToggleButton=function(o){this._preProcessSapMButton(o);};
d.prototype._postProcessSapMToggleButton=function(o){this._postProcessSapMButton(o);};
d.prototype._preProcessSapMOverflowToolbarToggleButton=function(o){this._preProcessSapMToggleButton(o);o._bInOverflow=true;};
d.prototype._postProcessSapMOverflowToolbarToggleButton=function(o){delete o._bInOverflow;this._postProcessSapMToggleButton(o);};
d._mSupportedControls={"sap.m.Button":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.MenuButton":{canOverflow:true,listenForEvents:["defaultAction","_menuItemSelected"],noInvalidationProps:["enabled","text","icon"]},"sap.m.OverflowToolbarButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type"]},"sap.m.OverflowToolbarToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","type","pressed"]},"sap.m.CheckBox":{canOverflow:true,listenForEvents:["select"],noInvalidationProps:["enabled","selected"]},"sap.m.ToggleButton":{canOverflow:true,listenForEvents:["press"],noInvalidationProps:["enabled","pressed"]},"sap.m.ComboBox":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value","selectedItemId","selectedKey"]},"sap.m.SearchField":{canOverflow:true,listenForEvents:["search"],noInvalidationProps:["enabled","value","selectOnFocus"]},"sap.m.Input":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.DateTimeInput":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue"]},"sap.m.DatePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.DateTimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat","displayFormatType","secondaryCalendarType","minDate","maxDate"]},"sap.m.TimePicker":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","dateValue","displayFormat","valueFormat"]},"sap.m.RadioButton":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","selected"]},"sap.m.Slider":{canOverflow:false,listenForEvents:[],noInvalidationProps:["enabled","value"]},"sap.m.IconTabHeader":{canOverflow:false,listenForEvents:[],noInvalidationProps:["selectedKey"]},"sap.ui.comp.smartfield.SmartField":{canOverflow:true,listenForEvents:["change"],noInvalidationProps:["enabled","value","valueState","showValueHelp","contextEditable","clientSideMandatoryCheck","mandatory","name","placeholder","showSuggestion","tooltipLabel"]},"sap.ui.comp.smartfield.SmartLabel":{canOverflow:true,listenForEvents:[],noInvalidationProps:["enabled"]}};
d.getControlConfig=function(o){var e;if(o.getMetadata().getInterfaces().indexOf("sap.m.IOverflowToolbarContent")!==-1){if(typeof o.getOverflowToolbarConfig!=="function"){L.error("Required method getOverflowToolbarConfig not implemented by: "+o.getMetadata().getName());return;}e=o.getOverflowToolbarConfig();if(typeof e!=="object"){L.error("Method getOverflowToolbarConfig implemented, but does not return an object in: "+o.getMetadata().getName());return;}return{canOverflow:!!e.canOverflow,listenForEvents:Array.isArray(e.autoCloseEvents)?e.autoCloseEvents:[],noInvalidationProps:Array.isArray(e.propsUnrelatedToSize)?e.propsUnrelatedToSize:[],preProcess:e.onBeforeEnterOverflow,postProcess:e.onAfterExitOverflow};}var s=d.getControlClass(o);e=d._mSupportedControls[s];if(e===undefined){return;}var p="_preProcess"+s.split(".").map(C).join("");if(typeof d.prototype[p]==="function"){e.preProcess=d.prototype[p];}var P="_postProcess"+s.split(".").map(C).join("");if(typeof d.prototype[P]==="function"){e.postProcess=d.prototype[P];}return e;};
d.supportsControl=function(o){var e=d.getControlConfig(o);return typeof e!=="undefined"&&e.canOverflow;};
d.getControlClass=function(o){if(o instanceof O){return"sap.m.OverflowToolbarButton";}else if(o instanceof a){return"sap.m.OverflowToolbarToggleButton";}else if(o instanceof T){return"sap.m.ToggleButton";}else if(o instanceof b){return"sap.m.Button";}return o.getMetadata().getName();};
function C(n){return n.substring(0,1).toUpperCase()+n.substr(1);}
return d;});
sap.ui.predefine('sap/m/OverflowToolbarButton',['sap/m/Button','sap/m/ButtonRenderer'],function(B,a){"use strict";
var O=B.extend("sap.m.OverflowToolbarButton",{
metadata:{interfaces:["sap.f.IShellBar"]},
renderer:a.render
});
O.prototype._getText=function(){if(this._bInOverflow){return B.prototype._getText.call(this);}return"";};
return O;});
sap.ui.predefine('sap/m/OverflowToolbarLayoutData',['sap/m/ToolbarLayoutData','sap/m/library',"sap/base/Log"],function(T,l,L){"use strict";var O=l.OverflowToolbarPriority;
var a=T.extend("sap.m.OverflowToolbarLayoutData",{metadata:{properties:{moveToOverflow:{type:"boolean",defaultValue:true,deprecated:true},stayInOverflow:{type:"boolean",defaultValue:false,deprecated:true},priority:{type:"sap.m.OverflowToolbarPriority",group:"Behavior",defaultValue:O.High},group:{type:"int",group:"Behavior",defaultValue:0},closeOverflowOnInteraction:{type:"boolean",group:"Behavior",defaultValue:true}}}});
a.prototype.invalidate=function(){var c=this.getPriority(),i=c===O.AlwaysOverflow||c===O.NeverOverflow;if(this.getGroup()&&i){L.error("It is not allowed to set AlwaysOverflow or NeverOverflow to a group items.");}return T.prototype.invalidate.call(this);};
return a;});
sap.ui.predefine('sap/m/OverflowToolbarRenderer',["./library",'sap/ui/core/Renderer','./ToolbarRenderer',"sap/m/BarInPageEnabler"],function(l,R,T,B){"use strict";var O=l.OverflowToolbarPriority;var a=R.extend(T);a.apiVersion=2;
a.renderBarContent=function(r,t){var h=false,H;t._getVisibleContent().forEach(function(c){B.addChildClassTo(c,t);if(t._getControlPriority(c)!==O.AlwaysOverflow){r.renderControl(c);}else{h=h||c.getVisible();}});if(h||t._getOverflowButtonNeeded()){a.renderOverflowButton(r,t);}H=t.getContent().some(function(c){return c.getVisible();});if(H){a.renderOverflowButtonClone(r,t);}};
a.renderOverflowButton=function(r,t){var o=t._getOverflowButton();B.addChildClassTo(o,t);r.renderControl(o);};
a.renderOverflowButtonClone=function(r,t){var o=t._getOverflowButtonClone();B.addChildClassTo(o,t);r.renderControl(o);};
return a;},true);
sap.ui.predefine('sap/m/OverflowToolbarToggleButton',['sap/m/ToggleButton','sap/m/ToggleButtonRenderer'],function(T,a){"use strict";
var O=T.extend("sap.m.OverflowToolbarToggleButton",{renderer:a.render});
O.prototype._getText=function(){return this._bInOverflow?T.prototype._getText.call(this):"";};
return O;});
sap.ui.predefine('sap/m/PDFViewer',["./library","sap/ui/core/Control","sap/ui/Device","sap/m/PDFViewerRenderManager","sap/m/MessageBox","sap/m/PDFViewerRenderer","sap/base/Log","sap/base/assert","sap/base/security/URLWhitelist","sap/ui/thirdparty/jquery"],function(l,C,D,P,M,a,L,b,U,q){"use strict";var c=l.PDFViewerDisplayType;
var d=C.extend("sap.m.PDFViewer",{metadata:{library:"sap.m",properties:{height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},source:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},errorMessage:{type:"string",group:"Misc",defaultValue:null,deprecated:true},errorPlaceholderMessage:{type:"string",group:"Misc",defaultValue:null},popupHeaderTitle:{type:"string",group:"Misc",defaultValue:null,deprecated:true},title:{type:"string",group:"Misc",defaultValue:null},showDownloadButton:{type:"boolean",group:"Misc",defaultValue:true},displayType:{type:"sap.m.PDFViewerDisplayType",group:"Misc",defaultValue:c.Auto}},aggregations:{errorPlaceholder:{type:"sap.ui.core.Control",multiple:false},popupButtons:{type:"sap.m.Button",multiple:true,singularName:"popupButton"}},events:{loaded:{},error:{},sourceValidationFailed:{}}}});
d.prototype.init=function(){this._objectsRegister={};this._bIsPopupOpen=false;this._initPopupControl();this._initPopupDownloadButtonControl();this._initPlaceholderMessagePageControl();this._initToolbarDownloadButtonControl();this._initOverflowToolbarControl();this._initControlState();};
d.prototype._initControlState=function(){this._bRenderPdfContent=true;this._bOnBeforeUnloadFired=false;};
d.prototype.setWidth=function(w){this.setProperty("width",w,true);var o=this.$();if(o===null){return this;}o.css("width",this._getRenderWidth());return this;};
d.prototype.setHeight=function(h){this.setProperty("height",h,true);var o=this.$();if(o===null){return this;}o.css("height",this._getRenderHeight());return this;};
d.prototype.onBeforeRendering=function(){this._bOnBeforeUnloadFired=false;};
d.prototype.onAfterRendering=function(){var i=function(){var I=this._getIframeDOMElement();var o=q(I.get(0).contentWindow);if(D.browser.internet_explorer){o.on("beforeunload",this._onBeforeUnloadListener.bind(this));o.on("readystatechange",this._onReadyStateChangeListener.bind(this));I.on("load",this._onLoadIEListener.bind(this));}else{I.on("load",this._onLoadListener.bind(this));}I.on("error",this._onErrorListener.bind(this));var p=this.getSource();var f=this.getSource().indexOf("#");if(f>-1){p=p.substr(0,f);}p+="#view=FitH";if(!U.validate(p)){p=encodeURI(p);}if(U.validate(p)){I.attr("src",p);}else{this._fireErrorEvent();}}.bind(this);try{this.setBusy(true);i();}catch(e){this.setBusy(false);}};
d.prototype._fireErrorEvent=function(){this._renderErrorState();this.fireEvent("error",{},true);};
d.prototype._renderErrorState=function(){var o=this._objectsRegister.getToolbarDownloadButtonControl();o.setEnabled(false);var o=this._objectsRegister.getPopupDownloadButtonControl();o.setEnabled(false);this.setBusy(false);this._bRenderPdfContent=false;C.prototype.invalidate.call(this);};
d.prototype._fireLoadedEvent=function(){this._bRenderPdfContent=true;this.setBusy(false);try{this._getIframeDOMElement().removeClass("sapMPDFViewerLoading");}catch(e){q.log.fatal("Iframe not founded in loaded event");q.log.fatal(e);}this.fireEvent("loaded");};
d.prototype._onLoadListener=function(e){try{var t=q(e.target),f=true;var s="application/pdf";try{var E=t[0].contentWindow.document.embeds;f=!!E&&E.length===1;if(f){s=E[0].attributes.getNamedItem("type").value;}}catch(g){if(!D.browser.firefox&&this.fireEvent("sourceValidationFailed",{},true)){this._showMessageBox();return;}}if(f&&a._isSupportedMimeType(s)&&a._isPdfPluginEnabled()){this._fireLoadedEvent();}else{this._fireErrorEvent();}}catch(g){L.fatal(false,"Fatal error during the handling of load event happened.");L.fatal(false,g.message);}};
d.prototype._onErrorListener=function(){this._fireErrorEvent();};
d.prototype._onReadyStateChangeListener=function(e){var I="interactive";var f="complete";switch(e.target.readyState){case I:case f:this._fireLoadedEvent();break;}};
d.prototype._onBeforeUnloadListener=function(){if(this._bOnBeforeUnloadFired){this._fireErrorEvent();return;}this._bOnBeforeUnloadFired=true;};
d.prototype._onLoadIEListener=function(e){try{var s=e.currentTarget.contentWindow.document.mimeType;}catch(f){return;}if(!a._isSupportedMimeType(s)){this._fireErrorEvent();}};
d.prototype.downloadPDF=function(){var w=window.open(this.getSource());w.focus();};
d.prototype._onSourceValidationErrorMessageBoxCloseListener=function(o){if(o===M.Action.CANCEL){this._renderErrorState();}else{this._fireLoadedEvent();}};
d.prototype._onAfterPopupClose=function(e){var p=this._objectsRegister.getPopup();p.removeAllContent();this._bIsPopupOpen=false;};
d.prototype._shouldRenderPdfContent=function(){return a._isPdfPluginEnabled()&&this._bRenderPdfContent&&this._isSourceValidToDisplay();};
d.prototype._isSourceValidToDisplay=function(){var s=this.getSource();return s!==null&&s!==""&&typeof s!=="undefined";};
d.prototype.invalidate=function(o){this._initControlState();C.prototype.invalidate.call(this,o);};
d.prototype.open=function(){if(!this._isSourceValidToDisplay()){b(false,"The PDF file cannot be opened with the given source. Given source: "+this.getSource());return;}else if(!a._isPdfPluginEnabled()){L.warning("The PDF plug-in is not available on this device.");}if(this._isEmbeddedModeAllowed()){this._openOnDesktop();}else{this._openOnMobile();}};
d.prototype._openOnDesktop=function(){var p=this._objectsRegister.getPopup();if(this._bIsPopupOpen){return;}this._initControlState();this._preparePopup(p);p.addContent(this);this._bIsPopupOpen=true;p.open();};
d.prototype._openOnMobile=function(){var w=window.open(this.getSource());w.focus();};
d.prototype._getIframeDOMElement=function(){var i=this.$().find("iframe");if(i.length===0){throw Error("Underlying iframe was not found in DOM.");}if(i.length>1){L.fatal("Initialization of iframe fails. Reason: the control somehow renders multiple iframes");}return i;};
d.prototype._isEmbeddedModeAllowed=function(){return this._isDisplayTypeAuto()?D.system.desktop:this._isDisplayTypeEmbedded();};
d.prototype._isDisplayTypeAuto=function(){return this.getDisplayType()===c.Auto;};
d.prototype._isDisplayTypeEmbedded=function(){return this.getDisplayType()===c.Embedded;};
d.prototype._isDisplayTypeLink=function(){return this.getDisplayType()===c.Link;};
d.prototype._isDisplayDownloadButton=function(){return this.getShowDownloadButton()||this._isDisplayTypeLink()||(this._isDisplayTypeAuto()&&!this._isEmbeddedModeAllowed());};
d.prototype._getLibraryResourceBundle=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
d.prototype._getMessagePageErrorMessage=function(){return this.getErrorPlaceholderMessage()?this.getErrorPlaceholderMessage():this._getLibraryResourceBundle().getText("PDF_VIEWER_PLACEHOLDER_ERROR_TEXT");};
d.prototype._getRenderWidth=function(){return this._bIsPopupOpen?'100%':this.getWidth();};
d.prototype._getRenderHeight=function(){if(this._bIsPopupOpen){return'100%';}if(!this._isEmbeddedModeAllowed()){return'auto';}return this.getHeight();};
d.prototype._showMessageBox=function(){M.show(this._getLibraryResourceBundle().getText("PDF_VIEWER_SOURCE_VALIDATION_MESSAGE_TEXT"),{icon:M.Icon.WARNING,title:this._getLibraryResourceBundle().getText("PDF_VIEWER_SOURCE_VALIDATION_MESSAGE_HEADER"),actions:[M.Action.OK,M.Action.CANCEL],defaultAction:M.Action.CANCEL,id:this.getId()+"-validationErrorSourceMessageBox",styleClass:"sapUiSizeCompact",contentWidth:'100px',onClose:this._onSourceValidationErrorMessageBoxCloseListener.bind(this)});};
d.prototype.exit=function(){q.each(this._objectsRegister,function(i,g){var o=g(true);if(o){o.destroy();}});};
P.extendPdfViewer(d);return d;});
sap.ui.predefine('sap/m/PDFViewerRenderManager',["sap/m/library","sap/m/Dialog","sap/m/Button","sap/m/MessagePage","sap/m/OverflowToolbar","sap/m/OverflowToolbarButton","sap/m/Title","sap/m/ToolbarSpacer","sap/m/OverflowToolbarLayoutData"],function(l,D,B,M,O,a,T,b,c){"use strict";var d=l.OverflowToolbarPriority;var e=l.ButtonType;var p={extendPdfViewer:function(P){P.prototype._initPopupControl=function(){var t=this;var o={contentHeight:"100%",contentWidth:"100%",horizontalScrolling:false,verticalScrolling:false,showHeader:true,buttons:[],afterClose:t._onAfterPopupClose.bind(t)},s=t.getId()+"-popup",f=s+"-popupCloseButton",C="getPopupCloseButton",g="getPopup";this._objectsRegister[C]=function(){var h=new B(f,{text:'',press:function(){t._objectsRegister.getPopup().close();}});t._objectsRegister[C]=function(){return h;};return h;};this._objectsRegister[g]=function(i){if(i===true){return null;}var h=new D(s,o);h.addStyleClass("sapUiPopupWithPadding");t._objectsRegister[g]=function(){return h;};return h;};};P.prototype._preparePopup=function(o){var f=this.getPopupButtons().slice(),C=this._objectsRegister.getPopupCloseButton(),g=this._objectsRegister.getPopupDownloadButtonControl();C.setText(this._getLibraryResourceBundle().getText("PDF_VIEWER_POPUP_CLOSE_BUTTON"));if(this.getShowDownloadButton()){f.push(g);}f.push(C);o.removeAllButtons();f.forEach(function(h){o.addButton(h);});o.setShowHeader(true);if(!!this.getPopupHeaderTitle()){o.setTitle(this.getPopupHeaderTitle());}if(!!this.getTitle()){o.setTitle(this.getTitle());}};P.prototype._initPlaceholderMessagePageControl=function(){var t=this,s="getPlaceholderMessagePageControl";this._objectsRegister[s]=function(){var m=new M({showHeader:false,text:t._getMessagePageErrorMessage(),description:""});t._objectsRegister[s]=function(){m.setText(t._getMessagePageErrorMessage());return m;};return m;};};P.prototype._initOverflowToolbarControl=function(){var t=this,o=this.getId()+"-overflowToolbar",s=o+"-title",f="getOverflowToolbarControl";this._objectsRegister[f]=function(i){if(i===true){return null;}var g=new O(o,{}),h=new T(s,{text:t.getTitle()}),j=t._objectsRegister.getToolbarDownloadButtonControl();function k(){if(t._isDisplayDownloadButton()){g.addContent(j);}else{g.removeContent(j);}j.setEnabled(t._bRenderPdfContent);h.setText(t.getTitle());}g.addStyleClass("sapUiTinyMarginBottom");g.addContent(h);g.addContent(new b());k();j.setLayoutData(new c({priority:d.NeverOverflow}));t._objectsRegister[f]=function(i){if(!i){k();}return g;};return g;};};P.prototype._initToolbarDownloadButtonControl=function(){var t=this,s=this.getId()+"-toolbarDownloadButton",f="getToolbarDownloadButtonControl";this._objectsRegister[f]=function(i){if(i){return null;}var o=new a(s,{type:e.Transparent,icon:"sap-icon://download"});o.attachPress(t.downloadPDF.bind(t));o.setEnabled(t._bRenderPdfContent);t._objectsRegister[f]=function(){o.setEnabled(t._bRenderPdfContent);return o;};return o;};};P.prototype._initPopupDownloadButtonControl=function(){var t=this,s=this.getId()+"-popupDownloadButton",f="getPopupDownloadButtonControl";this._objectsRegister[f]=function(){var o=new B(s,{text:t._getLibraryResourceBundle().getText("PDF_VIEWER_DOWNLOAD_TEXT"),type:e.Emphasized});o.attachPress(t.downloadPDF.bind(t));o.setEnabled(t._bRenderPdfContent);t._objectsRegister[f]=function(){o.setEnabled(t._bRenderPdfContent);return o;};return o;};};}};return p;},true);
sap.ui.predefine('sap/m/PDFViewerRenderer',['sap/ui/Device',"sap/base/Log"],function(D,L){"use strict";
function s(c){return(!!c.getTitle()||c._isDisplayDownloadButton())&&!c._bIsPopupOpen;}
var a=Object.freeze(["application/pdf","application/x-google-chrome-pdf"]);var P={};
P._isSupportedMimeType=function(m){var f=a.indexOf(m);return f>-1;};
P._isPdfPluginEnabled=function(){var i=true;if(D.browser.firefox){return i;}if(D.browser.internet_explorer){try{new ActiveXObject("AcroPDF.PDF");}catch(e){i=false;}return i;}var m=navigator.mimeTypes;i=a.some(function(A){var M=m.namedItem(A);return M!==null;});return i;};
P.render=function(r,c){r.write("<div");r.writeControlData(c);r.addStyle("width",c._getRenderWidth());r.addStyle("height",c._getRenderHeight());r.writeStyles();r.writeClasses();this._writeAccessibilityTags(r,c);r.write(">");if(s(c)){r.renderControl(c._objectsRegister.getOverflowToolbarControl());}if(c._isEmbeddedModeAllowed()){this.renderPdfContent(r,c);}r.write("</div>");};
P._writeAccessibilityTags=function(r,c){r.writeAttribute("role","document");r.writeAttribute("aria-label",c._getLibraryResourceBundle().getText("PDF_VIEWER_ACCESSIBILITY_LABEL"));};
P.renderPdfContent=function(r,c){if(c._shouldRenderPdfContent()){r.write("<iframe");r.addClass("sapMPDFViewerContent");r.addClass("sapMPDFViewerLoading");if(s(c)){r.addClass("sapMPDFViewerReducedContent");}r.writeClasses();r.write(">");r.write("</iframe>");}else{this.renderErrorContent(r,c);if(!P._isPdfPluginEnabled()){L.warning("The PDF plug-in is not available on this device.");c.fireEvent("error",{},true);}}};
P.renderErrorContent=function(r,c){var e=c.getErrorPlaceholder()?c.getErrorPlaceholder():c._objectsRegister.getPlaceholderMessagePageControl();r.write("<div");r.addClass("sapMPDFViewerError");if(!c._bIsPopupOpen){r.addClass("sapMPDFViewerEmbeddedContent");}r.writeClasses();r.write(">");r.renderControl(e);r.write("</div>");};
return P;},true);
sap.ui.predefine('sap/m/Page',["./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/m/Title","sap/m/Button","sap/m/Bar",'sap/m/TitleAlignmentMixin',"sap/ui/core/ContextMenuSupport","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/core/library","sap/ui/Device","sap/ui/core/Element","./TitlePropagationSupport","./PageRenderer","sap/ui/thirdparty/jquery"],function(l,C,S,T,B,a,b,c,R,d,D,E,e,P,q){"use strict";var A=d.AccessibleLandmarkRole;var f=l.ButtonType;var g=l.PageBackgroundDesign;var h=d.TitleLevel;var i=l.TitleAlignment;var j="div";var H="header";var F="footer";
var k=C.extend("sap.m.Page",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:h.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},navButtonText:{type:"string",group:"Misc",defaultValue:null,deprecated:true},navButtonTooltip:{type:"string",group:"Misc",defaultValue:null},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null,deprecated:true},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:g.Standard},navButtonType:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:f.Back,deprecated:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},contentOnlyBusy:{type:"boolean",group:"Appearance",defaultValue:false},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:i.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},footer:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent",forwarding:{getter:"_getInternalHeader",aggregation:"contentRight"}},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false},_internalHeader:{type:"sap.m.IBar",multiple:false,visibility:"hidden"}},events:{navButtonTap:{deprecated:true},navButtonPress:{}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/Page.designtime"}});
c.apply(k.prototype);R.call(k.prototype,{header:{suffix:"intHeader"},subHeader:{selector:".sapMPageSubHeader .sapMIBar"},content:{suffix:"cont"},footer:{selector:".sapMPageFooter:not(.sapMPageFloatingFooter) .sapMIBar"},floatingFooter:{selector:".sapMPageFloatingFooter.sapMPageFooter"}});e.call(k.prototype,"content",function(){return this._headerTitle?this._headerTitle.getId():false;});k.FOOTER_ANIMATION_DURATION=350;
k.prototype.init=function(){this._initTitlePropagationSupport();this._initResponsivePaddingsEnablement();};
k.prototype._hasScrolling=function(){return this.getEnableScrolling();};
k.prototype.onBeforeRendering=function(){if(this._oScroller&&!this._hasScrolling()){this._oScroller.destroy();this._oScroller=null;}else if(this._hasScrolling()&&!this._oScroller){this._oScroller=new S(this,null,{scrollContainerId:this.getId()+"-cont",horizontal:false,vertical:true});}if(this._headerTitle){this._headerTitle.setLevel(this.getTitleLevel());}this._ensureNavButton();};
k.prototype.onAfterRendering=function(){this.$().toggleClass("sapMPageBusyCoversAll",!this.getContentOnlyBusy());this._sBusySection=this.getContentOnlyBusy()?'cont':null;};
k.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}if(this._navBtn){this._navBtn.destroy();this._navBtn=null;}if(this._appIcon){this._appIcon.destroy();this._appIcon=null;}};
k.prototype.setBackgroundDesign=function(s){var m=this.getBackgroundDesign();this.setProperty("backgroundDesign",s,true);this.$().removeClass("sapMPageBg"+m).addClass("sapMPageBg"+this.getBackgroundDesign());return this;};
k.prototype.setTitle=function(t){var w=!this._headerTitle;this._headerTitle=this._headerTitle||new T(this.getId()+"-title",{level:this.getTitleLevel()});this._headerTitle.setText(t);if(w){this._updateHeaderContent(this._headerTitle,"middle",0);}this.setProperty("title",t,true);return this;};
k.prototype._ensureNavButton=function(){if(!this.getShowNavButton()){return;}var s=this.getNavButtonTooltip()||sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT");if(!this._navBtn){this._navBtn=new B(this.getId()+"-navButton",{press:function(){this.fireNavButtonPress();this.fireNavButtonTap();}.bind(this)});}this._navBtn.setType(this.getNavButtonType());this._navBtn.setTooltip(s);};
k.prototype.setShowNavButton=function(s){var o=!!this.getShowNavButton();if(s===o){return this;}this.setProperty("showNavButton",s,true);if(s){this._ensureNavButton();if(this._appIcon){this._updateHeaderContent(this._appIcon,"left",-1);}this._updateHeaderContent(this._navBtn,"left",0);}else if(this._navBtn){this._updateHeaderContent(this._navBtn,"left",-1);}return this;};
k.prototype.setShowFooter=function(s){if(this.getDomRef()){(s)?this.$().addClass("sapMPageWithFooter"):this.$().removeClass("sapMPageWithFooter");}var $=q(this.getDomRef()).find(".sapMPageFooter").last(),u=sap.ui.getCore().getConfiguration().getAnimation();if(!this.getFloatingFooter()){this.setProperty("showFooter",s);return this;}this.setProperty("showFooter",s,true);$.removeClass("sapUiHidden");$.toggleClass("sapMPageFooterControlShow",s);$.toggleClass("sapMPageFooterControlHide",!s);if(s){return this;}if(u){setTimeout(function(){$.toggleClass("sapUiHidden",!s);},k.FOOTER_ANIMATION_DURATION);}else{$.toggleClass("sapUiHidden",!s);}return this;};
k.prototype._updateHeaderContent=function(o,s,m){var I=this._getInternalHeader();if(I){switch(s){case"left":if(m==-1){if(I.getContentLeft()){I.removeContentLeft(o);}}else{if(I.indexOfContentLeft(o)!=m){I.insertContentLeft(o,m);I.invalidate();}}break;case"middle":if(m==-1){if(I.getContentMiddle()){I.removeContentMiddle(o);}}else{if(I.indexOfContentMiddle(o)!=m){I.insertContentMiddle(o,m);I.invalidate();}}break;case"right":if(m==-1){if(I.getContentRight()){I.removeContentRight(o);}}else{if(I.indexOfContentRight(o)!=m){I.insertContentRight(o,m);I.invalidate();}}break;default:break;}}};
k.prototype._getInternalHeader=function(){var I=this.getAggregation("_internalHeader");if(!I){this.setAggregation("_internalHeader",new a(this.getId()+"-intHeader"),true);I=this.getAggregation("_internalHeader");this._setupBarTitleAlignment(I,this.getId()+"_internalHeader");if(this.getShowNavButton()&&this._navBtn){this._updateHeaderContent(this._navBtn,"left",0);}if(this.getTitle()&&this._headerTitle){this._updateHeaderContent(this._headerTitle,"middle",0);}}return I;};
k.prototype._getAnyHeader=function(){var o=this.getCustomHeader();if(o){return o.addStyleClass("sapMPageHeader");}return this._getInternalHeader().addStyleClass("sapMPageHeader");};
k.prototype.getScrollDelegate=function(){return this._oScroller;};
k.prototype._formatLandmarkInfo=function(L,p){if(L){var r=L["get"+p+"Role"]()||"",s=L["get"+p+"Label"]()||"";if(r===A.None){r='';}return{role:r.toLowerCase(),label:s};}return{};};
k.prototype._getHeaderTag=function(L){if(L&&L.getHeaderRole()!==A.None){return j;}return H;};
k.prototype._getSubHeaderTag=function(L){if(L&&L.getSubHeaderRole()!==A.None){return j;}return H;};
k.prototype._getFooterTag=function(L){if(L&&L.getFooterRole()!==A.None){return j;}return F;};
k.prototype.scrollTo=function(y,t){if(this._oScroller){this._oScroller.scrollTo(0,y,t);}return this;};
k.prototype.scrollToElement=function(o,t,O){if(o instanceof E){o=o.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(o,t,O);}return this;};
k.prototype.setCustomHeader=function(o){this.setAggregation("customHeader",o);this.toggleStyleClass("sapFShellBar-CTX",o&&o.isA("sap.f.ShellBar"));if(o&&this.mEventRegistry["_adaptableContentChange"]){this.fireEvent("_adaptableContentChange",{"parent":this,"adaptableContent":o});}return this;};
k.prototype._getAdaptableContent=function(){return this._getAnyHeader();};
b.mixInto(k.prototype);return k;});
sap.ui.predefine('sap/m/PageAccessibleLandmarkInfo',['sap/ui/core/Element','./library'],function(E,l){"use strict";
var P=E.extend("sap.m.PageAccessibleLandmarkInfo",{metadata:{library:"sap.m",properties:{rootRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},rootLabel:{type:"string",defaultValue:null},contentRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Main"},contentLabel:{type:"string",defaultValue:null},headerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},headerLabel:{type:"string",defaultValue:null},subHeaderRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"None"},subHeaderLabel:{type:"string",defaultValue:null},footerRole:{type:"sap.ui.core.AccessibleLandmarkRole",defaultValue:"Region"},footerLabel:{type:"string",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/m/PageRenderer',["sap/m/library"],function(a){"use strict";var P={apiVersion:2};
P.render=function(r,p){var h=null,f=p.getFooter(),s=p.getShowFooter(),S=null,l=this._isLightHeader(p),L=p.getLandmarkInfo();if(p.getShowHeader()){h=p._getAnyHeader();}if(p.getShowSubHeader()){S=p.getSubHeader();}r.openStart("div",p).class("sapMPage").class("sapMPageBg"+p.getBackgroundDesign());if(h){r.class("sapMPageWithHeader");}if(S){r.class("sapMPageWithSubHeader");}if(f&&s){r.class("sapMPageWithFooter");}if(!p.getContentOnlyBusy()){r.class("sapMPageBusyCoversAll");}if(p.getFloatingFooter()){r.class("sapMPageWithFloatingFooter");}r.accessibilityState(p,p._formatLandmarkInfo(L,"Root"));r.openEnd();if(h){this.renderHeader(r,p,h,L,l);}if(S){this.renderSubHeader(r,p,S,L,l);}this.renderChildControls(r,p,L);if(f){this.renderFooter(r,p,f,L);}r.close("div");};
P.renderBarControl=function(r,p,b,o){if(!b){return;}b._applyContextClassFor(o.context.toLowerCase());b.addStyleClass(o.styleClass||"");r.renderControl(b);};
P.renderHeader=function(r,p,h,l,L){var H=p._getHeaderTag(l);r.openStart(H).class("sapMPageHeader").accessibilityState(p,p._formatLandmarkInfo(l,"Header")).openEnd();this.renderBarControl(r,p,h,{context:"header",styleClass:L?"":"sapContrastPlus"});r.close(H);};
P.renderSubHeader=function(r,p,s,l,L){var S=p._getSubHeaderTag(l);r.openStart(S).class("sapMPageSubHeader").accessibilityState(p,p._formatLandmarkInfo(l,"SubHeader"));if(s.getDesign()==a.ToolbarDesign.Info){r.class("sapMPageSubHeaderInfoBar");}r.openEnd();this.renderBarControl(r,p,s,{context:"subHeader",styleClass:L?"":"sapContrastPlus"});r.close(S);};
P.renderChildControls=function(r,p,L){r.openStart("section",p.getId()+"-cont");r.accessibilityState(p,p._formatLandmarkInfo(L,"Content"));if(sap.ui.Device.browser.firefox){r.attr("tabindex","-1");}if(p.getEnableScrolling()){r.class("sapMPageEnableScrolling");}r.openEnd();var c=p.getContent();var l=c.length;for(var i=0;i<l;i++){r.renderControl(c[i]);}r.close("section");};
P.renderFooter=function(r,p,f,l){var F=p._getFooterTag(l);r.openStart(F).class("sapMPageFooter");if(!p.getShowFooter()){r.class("sapUiHidden");}if(p.getFloatingFooter()){r.class("sapMPageFloatingFooter");}r.accessibilityState(p,p._formatLandmarkInfo(l,"Footer")).openEnd();this.renderBarControl(r,p,f,{context:"footer"});r.close(F);};
P._isLightHeader=function(p){var c=p,o=p.getParent(),s,C;while(o){s=(o&&o.getMetadata().getName())||"";C=c.getMetadata().getName();if(((s==="sap.m.Popover"||s==="sap.m.Dialog")&&C==="sap.m.NavContainer")||((s==="sap.ui.comp.smartvariants.SmartVariantManagement"||s==="sap.ui.comp.smartvariants.SmartVariantManagementUi2"||s==="sap.ui.comp.variants.VariantManagement"||s==="sap.ui.fl.variants.VariantManagement")&&C==="sap.m.ResponsivePopover")){return true;}if(o&&["sap.m.SplitApp","sap.m.SplitContainer"].indexOf(s)>-1&&C==="sap.m.NavContainer"&&/\-Master$/.test(c.getId())){return true;}c=o;o=c.getParent();}return false;};
return P;},true);
sap.ui.predefine('sap/m/PagingButton',['./Button','sap/ui/core/Control','sap/ui/core/IconPool','./PagingButtonRenderer',"sap/base/Log"],function(B,C,I,P,L){"use strict";
var a=C.extend("sap.m.PagingButton",{metadata:{library:"sap.m",properties:{count:{type:"int",group:"Data",defaultValue:1},position:{type:"int",group:"Data",defaultValue:1},nextButtonTooltip:{type:"string",group:"Appearance",defaultValue:""},previousButtonTooltip:{type:"string",group:"Appearance",defaultValue:""}},aggregations:{previousButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{positionChange:{parameters:{newPosition:{type:"int"},oldPosition:{type:"int"}}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
a.prototype.init=function(){this._attachPressEvents();};
a.prototype.onBeforeRendering=function(){this._enforceValidPosition(this.getPosition());this._updateButtonState();};
a.prototype._getNextButton=function(){if(!this.getAggregation("nextButton")){this.setAggregation("nextButton",new B({tooltip:this.getNextButtonTooltip()||r.getText("PAGINGBUTTON_NEXT"),icon:I.getIconURI("slim-arrow-down"),enabled:false,id:this.getId()+"-nextButton"}));}return this.getAggregation("nextButton");};
a.prototype._getPreviousButton=function(){if(!this.getAggregation("previousButton")){this.setAggregation("previousButton",new B({tooltip:this.getPreviousButtonTooltip()||r.getText("PAGINGBUTTON_PREVIOUS"),icon:I.getIconURI("slim-arrow-up"),enabled:false,id:this.getId()+"-previousButton"}));}return this.getAggregation("previousButton");};
a.prototype._attachPressEvents=function(){this._getPreviousButton().attachPress(this._handlePositionChange.bind(this,false));this._getNextButton().attachPress(this._handlePositionChange.bind(this,true));};
a.prototype._handlePositionChange=function(i){var o=this.getPosition(),n=i?o+1:o-1;this.setPosition(n);this.firePositionChange({newPosition:n,oldPosition:o});this._updateButtonState();return this;};
a.prototype._updateButtonState=function(){var t=this.getCount(),c=this.getPosition();this._getPreviousButton().setEnabled(c>1);this._getNextButton().setEnabled(c<t);return this;};
a.prototype.setPosition=function(p){return this._validateProperty("position",p);};
a.prototype.setCount=function(c){return this._validateProperty("count",c);};
a.prototype.setPreviousButtonTooltip=function(t){this._getPreviousButton().setTooltip(t);return this.setProperty("previousButtonTooltip",t,true);};
a.prototype.setNextButtonTooltip=function(t){this._getNextButton().setTooltip(t);return this.setProperty("nextButtonTooltip",t,true);};
a.prototype._validateProperty=function(p,v){if(v<1){L.warning("Property '"+p+"' must be greater or equal to 1",this);return this;}return this.setProperty(p,v);};
a.prototype._enforceValidPosition=function(p){var c=this.getCount();if(p>c){L.warning("Property position must be less or equal to the total count");this.setPosition(c);}return this;};
return a;});
sap.ui.predefine('sap/m/PagingButtonRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,c){var n=c._getNextButton(),p=c._getPreviousButton();r.openStart("div",c);r.class("sapMPagingButton");r.openEnd();r.renderControl(p);r.renderControl(n);r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/Panel',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','./PanelRenderer','sap/m/Button'],function(l,C,I,D,P,B){"use strict";var a=l.PanelAccessibleRole;var b=l.BackgroundDesign;var c=l.ButtonType;
var d=C.extend("sap.m.Panel",{metadata:{library:"sap.m",properties:{headerText:{type:"string",group:"Data",defaultValue:""},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},expandable:{type:"boolean",group:"Appearance",defaultValue:false},expanded:{type:"boolean",group:"Appearance",defaultValue:false},expandAnimation:{type:"boolean",group:"Behavior",defaultValue:true},backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:b.Translucent},accessibleRole:{type:"sap.m.PanelAccessibleRole",group:"Accessibility",defaultValue:a.Form}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},headerToolbar:{type:"sap.m.Toolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false}},events:{expand:{parameters:{expand:{type:"boolean"},triggeredByInteraction:{type:"boolean"}}}},dnd:{draggable:true,droppable:true},designtime:"sap/m/designtime/Panel.designtime"}});
d.prototype.init=function(){this._bInteractiveExpand=false;this.data("sap-ui-fastnavgroup","true",true);};
d.prototype.onThemeChanged=function(){this._setContentHeight();};
d.prototype.setExpanded=function(e){var t=this;if(e===this.getExpanded()){return this;}this.setProperty("expanded",e,true);if(!this.getExpandable()){return this;}this._toggleExpandCollapse(function(){t.invalidate();});this._toggleButtonIcon(e);this.fireExpand({expand:e,triggeredByInteraction:this._bInteractiveExpand});this._bInteractiveExpand=false;return this;};
d.prototype.onBeforeRendering=function(){if(this.getExpandable()&&!this._oExpandButton){this._oExpandButton=this._createExpandButton();}if(D.browser.msie||D.browser.edge){this._updateButtonAriaLabelledBy();}if(sap.ui.getCore().getConfiguration().getAccessibility()){this.$().attr("role",this.getAccessibleRole().toLowerCase());}};
d.prototype.onAfterRendering=function(){var $=this.$(),p=this.getDomRef("content"),h,o=this.getDomRef();if(o){o.style.width=this.getWidth();h=this.getHeight();o.style.height=h;if(parseFloat(h)!=0){o.querySelector(".sapMPanelContent").style.height=h;}}this._setContentHeight();if(this.getExpandable()){this.getHeaderToolbar()&&p&&this._oExpandButton.$().attr("aria-controls",p.id);if(!this.getExpanded()){$.children(".sapMPanelExpandablePart").css("display","none");}}};
d.prototype.ontap=function(e){var o=this.getDomRef(),w=o&&o.querySelector(".sapMPanelWrappingDiv");if(!this.getExpandable()||this.getHeaderToolbar()||!w){return;}if(w.contains(e.target)){this._bInteractiveExpand=true;this.setExpanded(!this.getExpanded());}};
d.prototype.onsapspace=function(e){this.ontap(e);};
d.prototype.onsapenter=function(e){this.ontap(e);};
d.prototype.exit=function(){if(this._oExpandButton){this._oExpandButton.destroy();this._oExpandButton=null;}};
d.prototype._createExpandButton=function(){var t=this,i=this.getExpanded()?I.getIconURI("slim-arrow-down"):I.getIconURI("slim-arrow-right"),T=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PANEL_ICON"),o;if(!this.getHeaderToolbar()){return I.createControlByURI({src:i,tooltip:T});}o=new B(this.getId()+"-expandButton",{icon:i,tooltip:T,type:c.Transparent,press:function(){t._bInteractiveExpand=true;t.setExpanded(!t.getExpanded());}}).addEventDelegate({onAfterRendering:function(){o.$().attr("aria-expanded",this.getExpanded());}.bind(this)},this);this.addDependent(o);return o;};
d.prototype._toggleButtonIcon=function(i){var s=i?I.getIconURI("slim-arrow-down"):I.getIconURI("slim-arrow-right");if(!this._oExpandButton){return;}if(this.getHeaderToolbar()){this._oExpandButton.setIcon(s);}else{this._oExpandButton.setSrc(s);}};
d.prototype._setContentHeight=function(){var A,t=this.getDomRef(),p=t&&t.querySelector(".sapMPanelContent");if(this.getHeight()==="auto"||!p){return;}A='calc('+"100%"+' - '+p.offsetTop+'px)';p.style.height=A;};
d.prototype._toggleExpandCollapse=function(A){var o={complete:A};if(!this.getExpandAnimation()){o.duration=0;}this.$().children(".sapMPanelExpandablePart").slideToggle(o);};
d.prototype._updateButtonAriaLabelledBy=function(){var L,A,f;if(!this._oExpandButton||!this.getHeaderToolbar()){return;}if(this.getAccessibleRole()===a.Form){f=true;}L=this._getLabellingElementId();A=this._oExpandButton.getAriaLabelledBy();if(L&&A.indexOf(L)===-1){this._oExpandButton.removeAllAssociation("ariaLabelledBy");!f&&this._oExpandButton.addAriaLabelledBy(L);}};
d.prototype._getLabellingElementId=function(){var h=this.getHeaderToolbar(),H=this.getHeaderText(),i=null;if(h){i=h.getTitleId();}else if(H){i=this.getId()+"-header";}return i;};
return d;});
sap.ui.predefine('sap/m/PanelRenderer',["sap/m/library","sap/ui/Device"],function(l,D){"use strict";var T=l.ToolbarDesign;var P={apiVersion:2};
P.render=function(r,c){this.startPanel(r,c);this.renderHeader(r,c);this.renderContent(r,c);this.endPanel(r);};
P.startPanel=function(r,c){var i=c.getExpandable(),a={role:c.getAccessibleRole().toLowerCase()};r.openStart("div",c);r.class("sapMPanel");if(i){r.class("sapMPanelExpandable");}r.style("width",c.getWidth());r.style("height",c.getHeight());if(c.getHeaderToolbar()||!i){a.labelledby=c._getLabellingElementId();}r.accessibilityState(c,a);r.openEnd();};
P.renderHeader=function(r,c){var i=c.getExpandable(),I=c.getExpanded(),h=c.getHeaderToolbar(),H,s=h?"header":"div";if(i){r.openStart(s);if(h){H="sapMPanelWrappingDivTb";}else{H="sapMPanelWrappingDiv";this.writeHeaderAccessibility(r,c);}r.class(H);if(I){r.class(H+"Expanded");}r.openEnd();if(i){r.renderControl(c._oExpandButton);}}var a=c.getHeaderText();if(h){h.setDesign(T.Transparent,true);h.addStyleClass("sapMPanelHeaderTB");r.renderControl(h);}else if(a||i){r.openStart("h2",c.getId()+"-header");r.class("sapMPanelHdr");r.openEnd();r.text(a);r.close("h2");}if(i){r.close(s);}var o=c.getInfoToolbar();if(o){o.setDesign(T.Info,true);o.addStyleClass("sapMPanelInfoTB");if(i){r.openStart("div");r.class("sapMPanelExpandablePart");r.openEnd();r.renderControl(o);r.close("div");}else{r.renderControl(o);}}};
P.writeHeaderAccessibility=function(r,c){r.attr('tabindex',0);r.attr('role','button');r.attr('aria-expanded',c.getExpanded());r.attr('aria-controls',c.getId()+"-content");};
P.renderContent=function(r,c){this.startContent(r,c);this.renderChildren(r,c.getContent());this.endContent(r);};
P.startContent=function(r,c){r.openStart("div",c.getId()+"-content");r.class("sapMPanelContent");r.class("sapMPanelBG"+c.getBackgroundDesign());if(c.getExpandable()){r.class("sapMPanelExpandablePart");}if(D.browser.firefox){r.attr('tabindex','-1');}r.openEnd();};
P.renderChildren=function(r,c){c.forEach(r.renderControl,r);};
P.endContent=function(r){r.close("div");};
P.endPanel=function(r){r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarHeaderRenderer',[],function(){"use strict";var P={apiVersion:2};
P.render=function(r,h){var a=h.getAggregation("_actionsToolbar"),n=h.getAggregation("_navigationToolbar");r.openStart("div",h);r.class("sapMPCHead");r.openEnd();if(a){r.renderControl(a);}if(n){r.renderControl(n);}r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRenderer',["sap/ui/core/InvisibleText",'sap/ui/unified/library'],function(I,l){"use strict";var C=l.CalendarAppointmentRoundWidth;var P={apiVersion:2};
P.render=function(r,p){var i=p.getId();var t=p.getTooltip_AsString();var h=p._getHeader();r.openStart("div",p);r.class("sapMPlanCal");r.accessibilityState({role:"region",labelledby:I.getStaticId("sap.m","PLANNINGCALENDAR")});this.addAdditionalClasses(r,p);if(p._iSize!==undefined&&p._iSize!==null){r.class("sapMSize"+p._iSize);}switch(p.getAppointmentRoundWidth()){case C.HalfColumn:r.class("sapUiCalendarAppHalfColumnRounding");break;}if(!p.getSingleSelection()){r.class("sapMPlanCalMultiSel");}if(!p.getShowRowHeaders()){r.class("sapMPlanCalNoHead");}if(p.getShowWeekNumbers()&&p._viewAllowsWeekNumbers(p.getViewKey())){r.class("sapMPlanCalWithWeekNumbers");}if(p.getShowDayNamesLine()&&p._viewAllowsDayNamesLine(p.getViewKey())){r.class("sapMPlanCalWithDayNamesLine");}if(t){r.attr('title',t);}var w=p.getWidth();if(w){r.style("width",w);}var H=p.getHeight();if(H){r.style("height",H);}r.accessibilityState(p);r.openEnd();r.renderControl(h);var T=p.getAggregation("table");r.renderControl(T);var a=p._oRB.getText("PLANNINGCALENDAR");r.openStart("span",i+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(a);r.close("span");a=p._oRB.getText("PLANNINGCALENDAR_VIEW");r.openStart("span",i+"-SelDescr");r.class("sapUiInvisibleText");r.openEnd();r.text(a);r.close("span");r.close("div");};
P.addAdditionalClasses=function(){};
return P;},true);
sap.ui.predefine('sap/m/PlanningCalendarRow',['sap/ui/core/Element','sap/m/CustomListItem','sap/ui/unified/DateTypeRange','sap/ui/unified/library'],function(E,C,D,u){"use strict";
var P=E.extend("sap.m.PlanningCalendarRow",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Data"},text:{type:"string",group:"Data"},icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},nonWorkingDays:{type:"int[]",group:"Misc",defaultValue:null},nonWorkingHours:{type:"int[]",group:"Misc",defaultValue:null},selected:{type:"boolean",group:"Data",defaultValue:false},key:{type:"string",group:"Data",defaultValue:null},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false},noAppointmentsText:{type:"string",group:"Misc",defaultValue:null}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"intervalHeader"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},headerContent:{type:"sap.ui.core.Control",multiple:true,singularName:"headerContent",forwarding:{getter:"_getPlanningCalendarCustomRowHeader",aggregation:"content"},forwardBinding:true}},events:{appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"},copy:{type:"boolean"}}},appointmentDragEnter:{allowPreventDefault:true,parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"},calendarRow:{type:"sap.m.PlanningCalendarRow"}}}}}});
P.prototype.exit=function(){if(this.oRowHeader){this.oRowHeader.destroy();}};
P.prototype._getPlanningCalendarCustomRowHeader=function(){if(!this.oRowHeader){this.oRowHeader=new C(this.getId()+"-CustomHead");}return this.oRowHeader;};
P.prototype._getSpecialDates=function(){var s=this.getSpecialDates();for(var i=0;i<s.length;i++){var n=s[i].getSecondaryType()===u.CalendarDayType.NonWorking&&s[i].getType()!==u.CalendarDayType.NonWorking;if(n){var a=new D();a.setType(u.CalendarDayType.NonWorking);a.setStartDate(s[i].getStartDate());if(s[i].getEndDate()){a.setEndDate(s[i].getEndDate());}s.push(a);}}return s;};
return P;});
sap.ui.predefine('sap/m/Popover',['./Bar','./Button','./InstanceManager','./library','./Title','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/Popup','sap/ui/core/delegate/ScrollEnablement','sap/ui/core/theming/Parameters','sap/ui/Device','sap/ui/base/ManagedObject',"sap/ui/core/util/ResponsivePaddingsEnablement",'sap/ui/core/library','sap/ui/core/Element','sap/ui/core/ResizeHandler','./PopoverRenderer',"sap/ui/dom/containsOrEquals","sap/ui/thirdparty/jquery","sap/ui/dom/getScrollbarSize","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/dom/jquery/Focusable","sap/ui/dom/jquery/rect","sap/ui/dom/jquery/control"],function(B,a,I,l,T,b,C,P,S,c,D,M,R,d,E,f,g,h,q,i,K,L){"use strict";var j=l.PopupHelper;var O=d.OpenState;var k=l.PlacementType;var m=l.TitleAlignment;
var n=C.extend("sap.m.Popover",{metadata:{interfaces:["sap.ui.core.PopupInterface"],library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Behavior",defaultValue:k.Right},showHeader:{type:"boolean",group:"Appearance",defaultValue:true},title:{type:"string",group:"Appearance",defaultValue:null},modal:{type:"boolean",group:"Behavior",defaultValue:false},offsetX:{type:"int",group:"Appearance",defaultValue:0},offsetY:{type:"int",group:"Appearance",defaultValue:0},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentMinWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:""},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},enableScrolling:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},bounce:{type:"boolean",group:"Behavior",defaultValue:null},resizable:{type:"boolean",group:"Dimension",defaultValue:false},ariaModal:{type:"boolean",group:"Misc",defaultValue:true,visibility:"hidden"},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:m.Auto},ariaRoleApplication:{type:"boolean",group:"Misc",defaultValue:false,visibility:"hidden"}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.ui.core.Control",multiple:false},subHeader:{type:"sap.ui.core.Control",multiple:false},footer:{type:"sap.ui.core.Control",multiple:false},_internalHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},beginButton:{type:"sap.ui.core.Control",multiple:false},endButton:{type:"sap.ui.core.Control",multiple:false}},associations:{leftButton:{type:"sap.m.Button",multiple:false,deprecated:true},rightButton:{type:"sap.m.Button",multiple:false,deprecated:true},initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"}}}},designtime:"sap/m/designtime/Popover.designtime"}});
n._bIOS7=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";R.call(n.prototype,{header:{suffix:"intHeader"},subHeader:{selector:".sapMPopoverSubHeader .sapMIBar"},content:{suffix:"cont"},footer:{selector:".sapMPopoverFooter .sapMIBar"}});
n.prototype.init=function(){this._arrowOffsetThreshold=4;this._marginTopInit=false;this._marginTop=48;this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._minDimensions={width:100,height:32};this._$window=q(window);this._initialWindowDimensions={};this.oPopup=new P();this.oPopup.setShadow(true);this.oPopup.setAutoClose(true);this.oPopup.setAnimations(q.proxy(this._openAnimation,this),q.proxy(this._closeAnimation,this));this._placements=[k.Top,k.Right,k.Bottom,k.Left,k.Vertical,k.Horizontal,k.Auto,k.VerticalPreferedTop,k.VerticalPreferedBottom,k.HorizontalPreferedLeft,k.HorizontalPreferedRight,k.VerticalPreferredTop,k.VerticalPreferredBottom,k.HorizontalPreferredLeft,k.HorizontalPreferredRight,k.PreferredRightOrFlip,k.PreferredLeftOrFlip,k.PreferredTopOrFlip,k.PreferredBottomOrFlip];this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];this._offsets=["0 -18","18 0","0 18","-18 0"];this._arrowOffset=18;this._followOfTolerance=32;this._scrollContentList=["sap.m.NavContainer","sap.m.Page","sap.m.ScrollContainer"];this._fnAdjustPositionAndArrow=q.proxy(this._adjustPositionAndArrow,this);this._fnOrientationChange=q.proxy(this._onOrientationChange,this);this._fnFollowOf=q.proxy(function(e){var o=e.lastOfRect,r=e.currentOfRect;if(!D.system.desktop||(Math.abs(o.top-r.top)<=this._followOfTolerance&&Math.abs(o.left-r.left)<=this._followOfTolerance)||(Math.abs(o.top+o.height-r.top-r.height)<=this._followOfTolerance&&Math.abs(o.left+o.width-r.left-r.width)<=this._followOfTolerance)){this.oPopup._applyPosition(this.oPopup._oLastPosition,true);}else{this.close();}},this);this.setFollowOf(true);this._initResponsivePaddingsEnablement();this._oRestoreFocusDelegate={onBeforeRendering:function(){var A=q(document.activeElement),o=A.control(0);this._sFocusControlId=o&&o.getId();},onAfterRendering:function(){if(this._sFocusControlId&&!h(this.getDomRef(),document.activeElement)){sap.ui.getCore().byId(this._sFocusControlId).focus();}}};var t=this;this.oPopup._applyPosition=function(p,F){var e=this.getOpenState(),o;if(e===O.CLOSING||e===O.CLOSED){return;}if(F){t._storeScrollPosition();}t._clearCSSStyles();var r=t._placements.indexOf(t.getPlacement());if(r>3&&!t._bPosCalced){t._calcPlacement();return;}t._bPosCalced=false;if(t._oOpenBy instanceof E){p.of=t._getOpenByDomRef();}if(!p.of){L.warning("sap.m.Popover: in function applyPosition, the openBy element doesn't have any DOM output. "+t);return;}if(!h(document.documentElement,p.of)&&p.of.id){o=q(document.getElementById(p.of.id));if(o){p.of=o;}else{L.warning("sap.m.Popover: in function applyPosition, the openBy element's DOM is already detached from DOM tree and can't be found again by the same id. "+t);return;}}var s=q(p.of).rect();if(F&&t._$window.height()==t._initialWindowDimensions.height&&(s.top+s.height<=0||s.top>=t._$window.height()||s.left+s.width<=0||s.left>=t._$window.width())){t.close();return;}var u=t.getDomRef("scroll");if(!D.system.desktop){q(window).scrollLeft(0);}t._deregisterContentResizeHandler();P.prototype._applyPosition.call(this,p);t._fnAdjustPositionAndArrow();t._restoreScrollPosition();t._registerContentResizeHandler(u);};this.oPopup.close=function(e){var o=typeof e==="boolean";var p=t.oPopup.getOpenState();var r=t._oOpenBy&&t._oOpenBy.getDomRef&&!!t._oOpenBy.getDomRef();if(e!==true&&(this.touchEnabled||!(this._isFocusInsidePopup()&&r))&&this.isOpen()&&!(p===O.CLOSED||p===O.CLOSING)){t.fireBeforeClose({openBy:t._oOpenBy});}t._deregisterContentResizeHandler();P.prototype.close.apply(this,o?[]:arguments);t.removeDelegate(t._oRestoreFocusDelegate);};};
n.prototype.onBeforeRendering=function(){var N,p,H=this.getHorizontalScrolling(),v=this.getVerticalScrolling(),e=!H||this.isPropertyInitial("horizontalScrolling"),V=!v||this.isPropertyInitial("verticalScrolling");if(!this._initialWindowDimensions.width||!this._initialWindowDimensions.height){this._initialWindowDimensions={width:this._$window.width(),height:this._$window.height()};}this._hasSingleScrollableContent();if(!H&&!v){this._forceDisableScrolling=true;}else if(e&&V&&this._singleScrollableContent){this._forceDisableScrolling=true;L.info("VerticalScrolling and horizontalScrolling in sap.m.Popover with ID "+this.getId()+" has been disabled because there's scrollable content inside");}else{this._forceDisableScrolling=false;}if(!this._forceDisableScrolling){if(!this._oScroller){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:H,vertical:v});}else{this._oScroller.setHorizontal(H);this._oScroller.setVertical(v);}}if(this._bContentChanged){this._bContentChanged=false;N=this._getSingleNavContent();p=this._getSinglePageContent();if(N&&!this.getModal()&&!D.system.phone&&!q.sap.simulateMobileOnDesktop){N.attachEvent("afterNavigate",function(o){var r=this.getDomRef();if(r){var F=this.$().firstFocusableDomRef()||r;F.focus();}},this);}if(N||p){p=p||N.getCurrentPage();if(p&&p._getAnyHeader){this.addStyleClass("sapMPopoverWithHeaderCont");}if(N){N.attachEvent("navigate",function(o){var r=o.getParameter("to");if(r instanceof C&&r.isA("sap.m.Page")){this.$().toggleClass("sapMPopoverWithHeaderCont",!!r._getAnyHeader());}},this);}}}if(!this.isPropertyInitial("title")){this._setHeaderTitle();}if(!D.system.desktop){this.setResizable(false);}};
n.prototype.onAfterRendering=function(){var $,e,o;if(!this._marginTopInit&&this.getShowArrow()){this._marginTop=2;if(this._oOpenBy){$=q(this._getOpenByDomRef());if(!($.closest("header.sapMIBar").length>0)){e=$.closest(".sapMPage");if(e.length>0){o=e.children("header.sapMIBar");if(o.length>0){this._marginTop+=o.outerHeight();}}}this._marginTopInit=true;}}this._repositionOffset();};
n.prototype.exit=function(){this._deregisterContentResizeHandler();D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);this.removeDelegate(this._oRestoreFocusDelegate);this._oRestoreFocusDelegate=null;if(this.oPopup){this.oPopup.detachClosed(this._handleClosed,this);this.oPopup.destroy();this.oPopup=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._internalHeader){this._internalHeader.destroy();this._internalHeader=null;}if(this._headerTitle){this._headerTitle.destroy();this._headerTitle=null;}};
n.prototype.openBy=function(o,s){var p=this.oPopup,e=this.oPopup.getOpenState(),F=this._getInitialFocusId(),r,t,u,v;r=(o.getDomRef&&o.getDomRef())||o;v=q(r).closest(".sapUiSizeCompact");u=c.get("_sap_m_Popover_ForceCompactArrowOffset")==="true";this._bSizeCompact=l._bSizeCompact||!!v.length||this.hasStyleClass("sapUiSizeCompact");this._bUseCompactArrow=this._bSizeCompact||u;this._adaptPositionParams();if(e===O.OPEN||e===O.OPENING){if(this._oOpenBy===o){return this;}else{var w=function(){p.detachClosed(w,this);this.openBy(o);};p.attachClosed(w,this);this.close();return this;}}if(!o){return this;}if(D.support.touch){D.resize.attachHandler(this._fnOrientationChange);}if(!this._oOpenBy||o!==this._oOpenBy){this._oOpenBy=o;}this.fireBeforeOpen({openBy:this._oOpenBy});p.attachOpened(this._handleOpened,this);p.attachClosed(this._handleClosed,this);p.setInitialFocusId(F);t=this._placements.indexOf(this.getPlacement());if(t>-1){r=this._getOpenByDomRef();if(!r){L.error("sap.m.Popover id = "+this.getId()+": is opened by a control which isn't rendered yet.");return this;}p.setAutoCloseAreas([o]);p.setContent(this);if(t<=3){p.setPosition(this._myPositions[t],this._atPositions[t],r,this._calcOffset(this._offsets[t]),"fit");}else{p._oPosition.of=r;}var x=this;var y=function(){if(p.bIsDestroyed){return;}if(p.getOpenState()===O.CLOSING){if(x._sOpenTimeout){clearTimeout(x._sOpenTimeout);x._sOpenTimeout=null;}x._sOpenTimeout=setTimeout(y,150);}else{x._oPreviousFocus=P.getCurrentFocusInfo();p.open();x.addDelegate(x._oRestoreFocusDelegate,x);if(!s){I.addPopoverInstance(x);}}};y();}else{L.error(this.getPlacement()+"is not a valid value! It can only be top, right, bottom or left");}return this;};
n.prototype.close=function(){var e=this.oPopup.getOpenState(),s,A;if(e===O.CLOSED||e===O.CLOSING){return this;}this.fireBeforeClose({openBy:this._oOpenBy});this.oPopup.close(true);if(this._oPreviousFocus){A=document.activeElement||{};s=(this._oPreviousFocus.sFocusId===sap.ui.getCore().getCurrentFocusedControlId())||(this._oPreviousFocus.sFocusId===A.id);if(!s){P.applyFocusInfo(this._oPreviousFocus);this._oPreviousFocus=null;}}return this;};
n.prototype.isOpen=function(){return this.oPopup&&this.oPopup.isOpen();};
n.prototype.setFollowOf=function(v){if(v){this.oPopup.setFollowOf(this._fnFollowOf);}else{this.oPopup.setFollowOf(false);}return this;};
n.prototype._clearCSSStyles=function(){if(!this.getDomRef()){return;}var s=this.getDomRef().style,$=this.$("cont"),e=$.children(".sapMPopoverScroll"),o=$[0].style,p=e[0].style,r=this.getContentWidth(),t=this.getContentHeight(),u=this.$("arrow"),w,W;if(r.indexOf("%")>0){w=this._$window.width();r=j.calcPercentageSize(r,w);}if(t.indexOf("%")>0){W=this._$window.height();t=j.calcPercentageSize(t,W);}o.width=r||"";o.height=t||"";o.maxWidth="";o.maxHeight="";s.left="";s.right="";s.top="";s.bottom="";s.width="";s.height="";s.overflow="";p.width="";p.display="";u.removeClass("sapMPopoverArrRight sapMPopoverArrLeft sapMPopoverArrDown sapMPopoverArrUp sapMPopoverCrossArr sapMPopoverFooterAlignArr sapMPopoverHeaderAlignArr sapContrast sapContrastPlus");u.css({left:"",top:""});};
n.prototype._onOrientationChange=function(){var e=(this.oPopup&&this.oPopup.getOpenState())||{};if(e!==O.OPEN&&e!==O.OPENING){return;}this.oPopup._applyPosition(this.oPopup._oLastPosition,true);this._includeScrollWidth();};
n.prototype._includeScrollWidth=function(){var s=this.getContentWidth(),$=this.$(),e=Math.floor(window.innerWidth*0.9),o=this.$('cont');if(!o[0]){return;}if(D.system.desktop&&!D.browser.chrome){var H=o[0].clientHeight<o[0].scrollHeight;if(H&&(!s||s==='auto')&&o.width()<e){$.addClass("sapMPopoverVerticalScrollIncluded");}else{$.removeClass("sapMPopoverVerticalScrollIncluded");}}};
n.prototype._handleOpened=function(){var t=this;this.oPopup.detachOpened(this._handleOpened,this);if(!D.support.touch){setTimeout(function(){!t.bIsDestroyed&&D.resize.attachHandler(t._fnOrientationChange);},0);}var F=this._getInitialFocusId(),o=sap.ui.getCore().byId(F),e=(F?window.document.getElementById(F):null);if(o&&o.getFocusDomRef()){o.getFocusDomRef().focus();}else if(!o&&e){e.focus();}this.fireAfterOpen({openBy:this._oOpenBy});};
n.prototype._handleClosed=function(){this.oPopup.detachClosed(this._handleClosed,this);D.resize.detachHandler(this._fnOrientationChange);I.removePopoverInstance(this);if(!this.oPopup._bModal&&!D.system.desktop&&document.activeElement&&!q(document.activeElement).is(":visible")){document.activeElement.blur();}this.fireAfterClose({openBy:this._oOpenBy});};
n.prototype.onfocusin=function(e){var s=e.target,$=this.$(),F=this.getId()+"-firstfe",o=this.getId()+"-middlefe",p=this.getId()+"-lastfe";if(s.id===F){var r=$.lastFocusableDomRef();if(r){r.focus();}else{document.getElementById(o).focus();}}else if(s.id===p){var t=$.firstFocusableDomRef();if(t){t.focus();}else{document.getElementById(o).focus();}}};
n.prototype.onkeyup=function(e){var o=K,p=e.which||e.keyCode,A=e.altKey;if((!this._isSpacePressed&&p===o.ESCAPE)||(A&&p===o.F4)){if(e.originalEvent&&e.originalEvent._sapui_handledByControl){return;}this.close();e.stopPropagation();e.preventDefault();}if(o.SPACE===p){this._isSpacePressed=false;}};
n.prototype.onkeydown=function(e){var o=K,p=e.which||e.keyCode;this._isSpacePressed=this._isSpacePressed||o.SPACE===p;};
n.prototype.onmousedown=function(o){var r=sap.ui.getCore().getConfiguration().getRTL();if(!o.target.classList||!o.target.classList.contains("sapMPopoverResizeHandle")){return;}var $=q(document);var p=this.$();var t=this;p.addClass('sapMPopoverResizing');o.preventDefault();o.stopPropagation();var s={x:o.pageX,y:o.pageY,width:p.width(),height:p.height()};$.on("mousemove.sapMPopover",function(e){var w,u;if(r){w=s.width+s.x-e.pageX;u=s.height+(s.y-e.pageY);}else{w=s.width+e.pageX-s.x;u=s.height+(s.y-e.pageY);}t.setContentWidth(Math.max(w,t._minDimensions.width)+'px');t.setContentHeight(Math.max(u,t._minDimensions.height)+'px');});$.on("mouseup.sapMPopover",function(){p.removeClass("sapMPopoverResizing");$.off("mouseup.sapMPopover, mousemove.sapMPopover");});};
n.prototype._hasSingleNavContent=function(){return!!this._getSingleNavContent();};
n.prototype._getSingleNavContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.NavContainer")){return e[0];}else{return null;}};
n.prototype._getSinglePageContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.Page")){return e[0];}else{return null;}};
n.prototype._hasSinglePageContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA("sap.m.Page")){return true;}else{return false;}};
n.prototype._hasSingleScrollableContent=function(){var e=this._getAllContent();while(e.length===1&&e[0]instanceof C&&e[0].isA("sap.ui.core.mvc.View")){e=e[0].getContent();}if(e.length===1&&e[0]instanceof C&&e[0].isA(this._scrollContentList)){this._singleScrollableContent=true;}else{this._singleScrollableContent=false;}};
n.prototype._getOffsetX=function(){var F=this.getPlacement(),e=0;if(this._bHorizontalFlip){var p=this._getOpenByDomRef();var H=p!==undefined;var o=H?p.getBoundingClientRect().width:0;e=F===k.PreferredRightOrFlip?Math.abs(o):-Math.abs(o);}var r=sap.ui.getCore().getConfiguration().getRTL();var s=e*(r?-1:1)+this.getOffsetX()*(r?-1:1);return s;};
n.prototype._getOffsetY=function(){var F=this.getPlacement(),e=0;if(this._bVerticalFlip){var p=this._getOpenByDomRef();var H=p!==undefined;var o=H?p.getBoundingClientRect().height:0;e=F==="PreferredTopOrFlip"?-Math.abs(o):Math.abs(o);}return e+this.getOffsetY();};
n.prototype._calcOffset=function(o){var e=this._getOffsetX(),p=this._getOffsetY();var r=o.split(" ");var o=(parseInt(r[0])+e)+" "+(parseInt(r[1])+p);return o;};
n.prototype._calcPlacement=function(){var p=this.getPlacement();var o=this._getOpenByDomRef();switch(p){case k.Auto:this._calcAuto();break;case k.Vertical:case k.VerticalPreferedTop:case k.VerticalPreferredTop:case k.VerticalPreferedBottom:case k.VerticalPreferredBottom:case k.PreferredTopOrFlip:case k.PreferredBottomOrFlip:this._calcVertical();break;case k.Horizontal:case k.HorizontalPreferedLeft:case k.HorizontalPreferredLeft:case k.HorizontalPreferedRight:case k.HorizontalPreferredRight:case k.PreferredRightOrFlip:case k.PreferredLeftOrFlip:this._calcHorizontal();break;}this._bPosCalced=true;var e=this._placements.indexOf(this._oCalcedPos);this.oPopup.setPosition(this._myPositions[e],this._atPositions[e],o,this._calcOffset(this._offsets[e]),"fit");};
n.prototype._getDocHeight=function(){var e=document.body,o=document.documentElement;return Math.max(e.scrollHeight,e.offsetHeight,o.clientHeight,o.offsetHeight);};
n.prototype._calcVertical=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=this.getPlacement()===k.VerticalPreferedTop||this.getPlacement()===k.VerticalPreferredTop;var e=this.getPlacement()===k.VerticalPreferedBottom||this.getPlacement()===k.VerticalPreferredBottom;var o=this.getPlacement()===k.PreferredTopOrFlip;var r=this.getPlacement()===k.PreferredBottomOrFlip;var s=H?$[0].getBoundingClientRect().top:0;var t=H?$[0].getBoundingClientRect().height:0;var u=this._getOffsetY();var v=s-this._marginTop+u;var w=this.$().outerHeight();var x=this._getDocHeight()-($.offset().top+t+this._marginBottom+u);if(p&&v>w+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=k.Top;}else if(o){if(v>w+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=k.Top;}else{this._bVerticalFlip=true;this._oCalcedPos=k.Bottom;}}else if(e&&x>w+this._arrowOffset){this._oCalcedPos=k.Bottom;this._bVerticalFlip=false;}else if(r){if(x>w+this._arrowOffset){this._bVerticalFlip=false;this._oCalcedPos=k.Bottom;}else{this._bVerticalFlip=true;this._oCalcedPos=k.Top;}}else if(v>x){this._oCalcedPos=k.Top;}else{this._oCalcedPos=k.Bottom;}};
n.prototype._calcHorizontal=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=this.getPlacement()===k.HorizontalPreferedLeft||this.getPlacement()===k.HorizontalPreferredLeft;var e=this.getPlacement()===k.HorizontalPreferedRight||this.getPlacement()===k.HorizontalPreferredRight;var o=H?$[0].getBoundingClientRect().left:0;var r=H?$[0].getBoundingClientRect().width:0;var s=this._getOffsetX();var t=o-this._marginLeft+s;var u=o+r;var v=this._$window.width()-u-this._marginRight-s;var w=this.$().outerWidth();var x=this.getPlacement()===k.PreferredLeftOrFlip;var y=this.getPlacement()===k.PreferredRightOrFlip;var z=sap.ui.getCore().getConfiguration().getRTL();if(p&&t>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?k.Right:k.Left;}else if(x){if(t>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?k.Right:k.Left;}else{this._bHorizontalFlip=true;this._oCalcedPos=z?k.Left:k.Right;}}else if(e&&v>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?k.Left:k.Right;}else if(y){if(v>w+this._arrowOffset){this._bHorizontalFlip=false;this._oCalcedPos=z?k.Left:k.Right;}else{this._bHorizontalFlip=true;this._oCalcedPos=z?k.Right:k.Left;}}else if(t>v){this._oCalcedPos=z?k.Right:k.Left;}else{this._oCalcedPos=z?k.Left:k.Right;}};
n.prototype._calcAuto=function(){if(this._$window.width()>this._$window.height()){if(this._checkHorizontal()){this._calcHorizontal();}else if(this._checkVertical()){this._calcVertical();}else{this._calcBestPos();}}else{if(this._checkVertical()){this._calcVertical();}else if(this._checkHorizontal()){this._calcHorizontal();}else{this._calcBestPos();}}};
n.prototype._checkHorizontal=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=H?$[0].getBoundingClientRect().left:0;var e=H?$[0].getBoundingClientRect().width:0;var o=this._getOffsetX();var r=p-this._marginLeft+o;var s=p+e;var t=this._$window.width()-s-this._marginRight-o;var u=this.$();var w=u.outerWidth()+this._arrowOffset;if((w<=r)||(w<=t)){return true;}};
n.prototype._checkVertical=function(){var $=q(this._getOpenByDomRef());var H=$[0]!==undefined;var p=H?$[0].getBoundingClientRect().top:0;var e=H?$[0].getBoundingClientRect().height:0;var o=this._getOffsetY();var t=p-this._marginTop+o;var r=this._getDocHeight()-$.offset().top-e-this._marginBottom-o;var s=this.$();var u=s.outerHeight()+this._arrowOffset;if((u<=t)||(u<=r)){return true;}};
n.prototype._calcBestPos=function(){var $=this.$();var H=$.outerHeight();var w=$.outerWidth();var r=sap.ui.getCore().getConfiguration().getRTL();var e=q(this._getOpenByDomRef());var o=e[0]!==undefined;var p=o?e[0].getBoundingClientRect().left:0;var s=o?e[0].getBoundingClientRect().top:0;var t=o?e[0].getBoundingClientRect().width:0;var u=o?e[0].getBoundingClientRect().height:0;var v=this._getOffsetX();var x=this._getOffsetY();var y=s-this._marginTop+x;var z=this._getDocHeight()-e.offset().top-u-this._marginBottom-x;var A=p-this._marginLeft+v;var F=p+t;var G=this._$window.width()-F-this._marginRight-v;var J=H*w;var N;var Q;if((this._$window.height()-this._marginTop-this._marginBottom)>=H){N=H;}else{N=this._$window.height()-this._marginTop-this._marginBottom;}if((this._$window.width()-this._marginLeft-this._marginRight)>=w){Q=w;}else{Q=this._$window.width()-this._marginLeft-this._marginRight;}var U=(N*(A))/J;var V=(N*(G))/J;var W=(Q*(y))/J;var X=(Q*(z))/J;var Y=Math.max(U,V);var Z=Math.max(W,X);if(Y>Z){if(Y===U){this._oCalcedPos=r?k.Right:k.Left;}else if(Y===V){this._oCalcedPos=r?k.Left:k.Right;}}else if(Z>Y){if(Z===W){this._oCalcedPos=k.Top;}else if(Z===X){this._oCalcedPos=k.Bottom;}}else if(Z===Y){if(this._$window.height()>this._$window.width()){if(Z===W){this._oCalcedPos=k.Top;}else if(Z===X){this._oCalcedPos=k.Bottom;}}else{if(Y===U){this._oCalcedPos=r?k.Right:k.Left;}else if(Y===V){this._oCalcedPos=r?k.Left:k.Right;}}}};
n.outerWidth=function(e,o){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().width;}return q(e).outerWidth(!!o);};
n.outerHeight=function(e,o){if(typeof window.SVGElement!=="undefined"&&e instanceof window.SVGElement){return e.getBoundingClientRect().height;}return q(e).outerHeight(!!o);};
n.prototype._getPositionParams=function($,e,o,p){var r=window.getComputedStyle($[0]),s=window.getComputedStyle(o[0]),t=this.getDomRef().clientHeight!=this.getDomRef().scrollHeight?i().width:0,u={};u._$popover=$;u._$parent=q(this._getOpenByDomRef());u._$arrow=e;u._$content=o;u._$scrollArea=p;u._$header=$.children(".sapMPopoverHeader");u._$subHeader=$.children(".sapMPopoverSubHeader");u._$footer=$.children(".sapMPopoverFooter");u._fWindowTop=this._$window.scrollTop();u._fWindowRight=this._$window.width();u._fWindowBottom=(n._bIOS7&&D.orientation.landscape&&window.innerHeight)?window.innerHeight:this._$window.height();u._fWindowLeft=this._$window.scrollLeft();u._fDocumentWidth=u._fWindowLeft+u._fWindowRight;u._fDocumentHeight=u._fWindowTop+u._fWindowBottom;u._fArrowHeight=e.outerHeight(true);u._fWidth=n.outerWidth($[0]);u._fWidthInner=u._$scrollArea?(u._$scrollArea.width()+t):0;u._fHeight=n.outerHeight($[0]);u._fHeaderHeight=u._$header.length>0?u._$header.outerHeight(true):0;u._fSubHeaderHeight=u._$subHeader.length>0?u._$subHeader.outerHeight(true):0;u._fFooterHeight=u._$footer.length>0?u._$footer.outerHeight(true):0;u._fOffset=$.offset();u._fOffsetX=this._getOffsetX();u._fOffsetY=this._getOffsetY();u._fMarginTop=u._fWindowTop+this._marginTop;u._fMarginRight=this._marginRight;u._fMarginBottom=this._marginBottom;u._fMarginLeft=u._fWindowLeft+this._marginLeft;u._fPopoverBorderTop=parseFloat(r.borderTopWidth);u._fPopoverBorderRight=parseFloat(r.borderRightWidth);u._fPopoverBorderBottom=parseFloat(r.borderBottomWidth);u._fPopoverBorderLeft=parseFloat(r.borderLeftWidth);u._fContentMarginTop=parseFloat(s.marginTop);u._fContentMarginBottom=parseFloat(s.marginBottom);return u;};
n.prototype._recalculateMargins=function(s,p){var r=sap.ui.getCore().getConfiguration().getRTL();switch(s){case k.Left:if(r){p._fMarginLeft=p._$parent.offset().left+n.outerWidth(p._$parent[0],false)+this._arrowOffset-p._fOffsetX;}else{p._fMarginRight=p._fDocumentWidth-p._$parent.offset().left+this._arrowOffset-p._fOffsetX;}break;case k.Right:if(r){p._fMarginRight=p._fDocumentWidth-n.outerWidth(p._$parent[0],false)-p._$parent.offset().left+this._arrowOffset;}else{p._fMarginLeft=p._$parent.offset().left+n.outerWidth(p._$parent[0],false)+this._arrowOffset+p._fOffsetX;}break;case k.Top:p._fMarginBottom=p._fDocumentHeight-p._$parent.offset().top+this._arrowOffset-p._fOffsetY;break;case k.Bottom:p._fMarginTop=p._$parent.offset().top+n.outerHeight(p._$parent[0],false)+this._arrowOffset+p._fOffsetY;break;}};
n.prototype._getPopoverPositionCss=function(p){var e,r,t,o,s=p._fDocumentWidth-p._fOffset.left-p._fWidth,u=p._fDocumentHeight-p._fOffset.top-p._fHeight,v=(p._fDocumentWidth-p._fMarginRight-p._fMarginLeft)<p._fWidth,w=(p._fDocumentHeight-p._fMarginTop-p._fMarginBottom)<p._fHeight,x=p._fOffset.left<p._fMarginLeft,y=this.getVerticalScrolling()&&(p._fWidth!==p._fWidthInner)?i().width:0,z=s<(p._fMarginRight+y),A=p._fOffset.top<p._fMarginTop,F=u<p._fMarginBottom,G=sap.ui.getCore().getConfiguration().getRTL();if(v){e=p._fMarginLeft;r=p._fMarginRight;}else{if(x){e=p._fMarginLeft;if(G){r="";}}else if(z){r=p._fMarginRight;e="";}}if(w){t=p._fMarginTop;o=p._fMarginBottom;}else{if(A){t=p._fMarginTop;}else if(F){o=p._fMarginBottom;t="";}}var H={top:t,bottom:o-p._fWindowTop,left:e,right:typeof r==="number"?r-p._fWindowLeft:r};return H;};
n.prototype._getContentDimensionsCss=function(p){var o={},A=p._$content.height(),e=this._getMaxContentWidth(p),r=this._getMaxContentHeight(p);r=Math.max(r,0);o["max-width"]=e+"px";if(this.getContentHeight()||(A>r)){o["height"]=Math.min(r,A)+"px";}else{o["height"]="";o["max-height"]=r+"px";}return o;};
n.prototype._getMaxContentWidth=function(p){return p._fDocumentWidth-p._fMarginLeft-p._fMarginRight-p._fPopoverBorderLeft-p._fPopoverBorderRight;};
n.prototype._getMaxContentHeight=function(p){return p._fDocumentHeight-p._fMarginTop-p._fMarginBottom-p._fHeaderHeight-p._fSubHeaderHeight-p._fFooterHeight-p._fContentMarginTop-p._fContentMarginBottom-p._fPopoverBorderTop-p._fPopoverBorderBottom;};
n.prototype._isHorizontalScrollbarNeeded=function(p){return this.getHorizontalScrolling()&&(p._$scrollArea.outerWidth(true)<=p._$content.width());};
n.prototype._getArrowOffsetCss=function(s,p){var e,r=sap.ui.getCore().getConfiguration().getRTL();p._fWidth=p._$popover.outerWidth();p._fHeight=p._$popover.outerHeight();if(s===k.Left||s===k.Right){e=p._$parent.offset().top-p._$popover.offset().top-p._fPopoverBorderTop+p._fOffsetY+0.5*(n.outerHeight(p._$parent[0],false)-p._$arrow.outerHeight(false));e=Math.max(e,this._arrowOffsetThreshold);e=Math.min(e,p._fHeight-this._arrowOffsetThreshold-p._$arrow.outerHeight());return{"top":e};}else if(s===k.Top||s===k.Bottom){if(r){e=p._$popover.offset().left+n.outerWidth(p._$popover[0],false)-(p._$parent.offset().left+n.outerWidth(p._$parent[0],false))+p._fPopoverBorderRight+p._fOffsetX+0.5*(n.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));e=Math.max(e,this._arrowOffsetThreshold);e=Math.min(e,p._fWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"right":e};}else{e=p._$parent.offset().left-p._$popover.offset().left-p._fPopoverBorderLeft+p._fOffsetX+0.5*(n.outerWidth(p._$parent[0],false)-p._$arrow.outerWidth(false));e=Math.max(e,this._arrowOffsetThreshold);e=Math.min(e,p._fWidth-this._arrowOffsetThreshold-p._$arrow.outerWidth(false));return{"left":e};}}};
n.prototype._getArrowPositionCssClass=function(s){switch(s){case k.Left:return"sapMPopoverArrRight";case k.Right:return"sapMPopoverArrLeft";case k.Top:return"sapMPopoverArrDown";case k.Bottom:return"sapMPopoverArrUp";}};
n.prototype._getArrowStyleCssClass=function(p){var A=p._$arrow.position(),F=p._$footer.position(),N=this._getSingleNavContent(),o=this._getSinglePageContent(),e=0;if(N||o){o=o||N.getCurrentPage();if(o){e=o._getAnyHeader().$().outerHeight();}}if((A.top+p._fArrowHeight)<(p._fHeaderHeight+p._fSubHeaderHeight)||((A.top+p._fArrowHeight)<e)){return"sapMPopoverHeaderAlignArr";}else if((A.top<(p._fHeaderHeight+p._fSubHeaderHeight))||(A.top<e)||(p._$footer.length&&((A.top+p._fArrowHeight)>F.top)&&(A.top<F.top))){return"sapMPopoverCrossArr";}else if(p._$footer.length&&(A.top>F.top)){return"sapMPopoverFooterAlignArr";}};
n.prototype._getCalculatedPlacement=function(){return this._oCalcedPos||this.getPlacement();};
n.prototype._adjustPositionAndArrow=function(){var e=this.oPopup.getOpenState();if(!(e===O.OPEN||e===O.OPENING)){return;}this._beforeAdjustPositionAndArrowHook();var $=this.$(),o=this.$("arrow"),p=this.$("cont"),r=this.$("scroll"),s=this._getCalculatedPlacement(),t=this._getPositionParams($,o,p,r);this._recalculateMargins(s,t);var u=this._getPopoverPositionCss(t),v=this._getContentDimensionsCss(t),H=this._isHorizontalScrollbarNeeded(t);$.css(u);p.css(v);if(H){r.css("display","block");}if(this.getShowArrow()){var A=this._getArrowOffsetCss(s,t),w=this._getArrowPositionCssClass(s),x,U;o.removeAttr("style");o.css(A);o.addClass(w);if(s===k.Top&&t._$footer&&t._$footer.length){U=true;}if(s===k.Left||s===k.Right){x=this._getArrowStyleCssClass(t);if(x){o.addClass(x);if(x==="sapMPopoverFooterAlignArr"){U=true;}}}if(U){o.addClass("sapContrast sapContrastPlus");}$.css("overflow","visible");}this._afterAdjustPositionAndArrowHook();};
n.prototype._adaptPositionParams=function(){if(this.getShowArrow()){this._marginLeft=10;this._marginRight=10;this._marginBottom=10;this._arrowOffset=18;this._offsets=["0 -18","18 0","0 18","-18 0"];if(this._bUseCompactArrow){this._arrowOffset=9;this._offsets=["0 -9","9 0","0 9","-9 0"];}this._myPositions=["center bottom","begin center","center top","end center"];this._atPositions=["center top","end center","center bottom","begin center"];}else{this._marginTop=0;this._marginLeft=0;this._marginRight=0;this._marginBottom=0;this._arrowOffset=0;this._offsets=["0 0","0 0","0 0","0 0"];this._myPositions=["begin bottom","begin center","begin top","end center"];this._atPositions=["begin top","end center","begin bottom","begin center"];}};
n.prototype._afterAdjustPositionAndArrowHook=function(){};
n.prototype._beforeAdjustPositionAndArrowHook=function(){};
n.prototype._isPopupElement=function(o){var p=this._getOpenByDomRef();return!!(q(o).closest(sap.ui.getCore().getStaticAreaRef()).length)||!!(q(o).closest(p).length);};
n.prototype._getAnyHeader=function(){if(this.getCustomHeader()){return this.getCustomHeader();}else{if(this.getShowHeader()){this._createInternalHeader();return this._internalHeader;}}};
n.prototype._createInternalHeader=function(){if(!this._internalHeader){var t=this;this._internalHeader=new B(this.getId()+"-intHeader");this._setupBarTitleAlignment(this._internalHeader,this.getId()+"_internalHeader");this.setAggregation("_internalHeader",this._internalHeader);this._internalHeader.addEventDelegate({onAfterRendering:function(){t._restoreFocus();}});return true;}else{return false;}};
n.prototype._animation=function(A,r){var t=null;var e=function(){r.off("webkitTransitionEnd transitionend");clearTimeout(t);setTimeout(function(){A();});};r.on("webkitTransitionEnd transitionend",e);t=setTimeout(e,this._getAnimationDuration());};
n.prototype._getAnimationDuration=function(){return 300;};
n.prototype._openAnimation=function(r,e,o){var t=this;setTimeout(function(){r.css("display","block");t._includeScrollWidth();t._animation(function(){if(!t.oPopup||t.oPopup.getOpenState()!==O.OPENING){return;}o();},r);},D.browser.firefox?50:0);};
n.prototype._closeAnimation=function(r,e,o){r.addClass("sapMPopoverTransparent");this._animation(function(){o();r.removeClass("sapMPopoverTransparent");},r);};
n.prototype._getInitialFocusId=function(){return this.getInitialFocus()||this._getFirstVisibleButtonId()||this._getFirstFocusableContentElementId()||this.getId();};
n.prototype._getFirstVisibleButtonId=function(){var o=this.getBeginButton(),e=this.getEndButton(),s="";if(o&&o.getVisible()){s=o.getId();}else if(e&&e.getVisible()){s=e.getId();}return s;};
n.prototype._getFirstFocusableContentElementId=function(){var r="";var $=this.$("cont");var F=$.firstFocusableDomRef();if(F){r=F.id;}return r;};
n.prototype._restoreFocus=function(){if(this.isOpen()){var F=this._getInitialFocusId(),o=sap.ui.getCore().byId(F),e=(F?window.document.getElementById(F):null);if(o&&o.getFocusDomRef()){o.getFocusDomRef().focus();}else if(!o&&e){e.focus();}}};
n.prototype._registerContentResizeHandler=function(s){if(!this._sResizeListenerId){this._sResizeListenerId=f.register(s||this.getDomRef("scroll"),this._fnOrientationChange);}};
n.prototype._deregisterContentResizeHandler=function(){if(this._sResizeListenerId){f.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
n.prototype._storeScrollPosition=function(){var $=this.$("cont");if($.length>0){this._oScrollPosDesktop={x:$.scrollLeft(),y:$.scrollTop()};}};
n.prototype._restoreScrollPosition=function(){if(!this._oScrollPosDesktop){return;}var $=this.$("cont");if($.length>0){$.scrollLeft(this._oScrollPosDesktop.x).scrollTop(this._oScrollPosDesktop.y);this._oScrollPosDesktop=null;}};
n.prototype._repositionOffset=function(){var e=this.oPopup.getOpenState(),o,p;if(!(e===O.OPEN)){return this;}o=this.oPopup._oLastPosition;p=this._placements.indexOf(this.getPlacement());if(p===-1){return this;}if(p<4){o.offset=this._calcOffset(this._offsets[p]);this.oPopup._applyPosition(o);}else{this._calcPlacement();}return this;};
n.prototype._getOpenByDomRef=function(){if(!this._oOpenBy){return null;}if(this._oOpenBy instanceof E){return(this._oOpenBy.getPopupAnchorDomRef&&this._oOpenBy.getPopupAnchorDomRef())||this._oOpenBy.getFocusDomRef();}else{return this._oOpenBy;}};
n.prototype._getAccessibilityOptions=function(){var A,e={},H=this._getAnyHeader();e.role="dialog";e.modal=this.getProperty("ariaModal");if(this.getShowHeader()&&H&&H.getVisible()){A=Array.prototype.concat(H.getId(),this.getAssociation("ariaLabelledBy",[]));e.labelledby=A.join(' ');}return e;};
n.prototype._setHeaderTitle=function(){if(this._headerTitle){this._headerTitle.setText(this.getTitle());}else{this._headerTitle=new T(this.getId()+"-title",{text:this.getTitle(),level:"H2"});this._createInternalHeader();this._internalHeader.addContentMiddle(this._headerTitle);}};
n.prototype.setPlacement=function(p){this.setProperty("placement",p,true);this._bVerticalFlip=false;this._bHorizontalFlip=false;var e=this._placements.indexOf(p);if(e<=3){this._oCalcedPos=p;}return this;};
n.prototype.setBeginButton=function(o){var e=this.getBeginButton();if(e===o){return this;}this._createInternalHeader();this._beginButton=o;if(o){if(e){this._internalHeader.removeAggregation("contentLeft",e,true);}this._internalHeader.addAggregation("contentLeft",o);}else{this._internalHeader.removeContentLeft(e);}return this;};
n.prototype.setEndButton=function(o){var e=this.getEndButton();if(e===o){return this;}this._createInternalHeader();this._endButton=o;if(o){if(e){this._internalHeader.removeAggregation("contentRight",e,true);}this._internalHeader.insertAggregation("contentRight",o,1,true);this._internalHeader.invalidate();}else{this._internalHeader.removeContentRight(e);}return this;};
n.prototype.setLeftButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setBeginButton(v);return this.setAssociation("leftButton",v);};
n.prototype.setRightButton=function(v){if(!(v instanceof a)){v=sap.ui.getCore().byId(v);}this.setEndButton(v);return this.setAssociation("rightButton",v);};
n.prototype.setModal=function(e,s){if(e===this.getModal()){return this;}this.oPopup.setModal(e,("sapMPopoverBLayer "+(s||"")).trim());this.setProperty("modal",e,true);return this;};
n.prototype.setEnableScrolling=function(v){this.setHorizontalScrolling(v);this.setVerticalScrolling(v);this.setProperty("enableScrolling",v);return this;};
n.prototype._setAriaModal=function(v){return this.setProperty("ariaModal",v);};
n.prototype.getScrollDelegate=function(){return this._oScroller;};
n.prototype._setAriaRoleApplication=function(v){return this.setProperty("ariaRoleApplication",v);};
n.prototype.setAggregation=function(A,o,s){if(A==="beginButton"||A==="endButton"){var F="set"+A.charAt(0).toUpperCase()+A.slice(1);return this[F](o);}else{return C.prototype.setAggregation.apply(this,arguments);}};
n.prototype.getAggregation=function(A,o){if(A==="beginButton"||A==="endButton"){var s=this["_"+A];return s||o||null;}else{return C.prototype.getAggregation.apply(this,arguments);}};
n.prototype.destroyAggregation=function(A,s){var o=q(document.activeElement).control(0);if(A==="beginButton"||A==="endButton"){var e=this["_"+A];if(e){e.destroy();this["_"+A]=null;}}else{C.prototype.destroyAggregation.apply(this,arguments);}o&&o.getDomRef()?o.focus():this.focus();return this;};
n.prototype.invalidate=function(o){if(this.isOpen()){C.prototype.invalidate.apply(this,arguments);}return this;};
n.prototype.addAggregation=function(A,o,s){if(A==="content"){this._bContentChanged=true;}C.prototype.addAggregation.apply(this,arguments);};
n.prototype._getAllContent=function(){return this.getContent();};
n.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
b.mixInto(n.prototype);return n;});
sap.ui.predefine('sap/m/PopoverRenderer',['sap/ui/Device','sap/m/library',"sap/ui/dom/getScrollbarSize"],function(D,l,g){"use strict";var P=l.PlacementType;var a={apiVersion:2};
a.render=function(r,c){r.openStart("div",c);var C=this.generateRootClasses(c);C.forEach(function(s){r.class(s);});if(!c.getHorizontalScrolling()){r.class("sapMPopoverHorScrollDisabled");}if(!c.getVerticalScrolling()){r.class("sapMPopoverVerScrollDisabled");}var t=c.getTooltip_AsString();if(t){r.attr("title",t);}r.attr("tabindex","-1").accessibilityState(c,c._getAccessibilityOptions()).openEnd();if(c.getResizable()){r.icon("sap-icon://resize-corner",["sapMPopoverResizeHandle"],{"title":""});}this.renderContent(r,c);r.close("div");};
a.isButtonFooter=function(f){if(f instanceof sap.m.Bar){var c=f.getContentLeft(),C=f.getContentRight(),b=f.getContentMiddle(),L=(!c||c.length===0),r=(!C||C.length===0),m=false;if(b&&b.length===2){if((b[0]instanceof sap.m.Button)&&(b[1]instanceof sap.m.Button)){m=true;}}return L&&r&&m;}else{return false;}};
a.renderContent=function(r,c){var h=c._getAnyHeader(),I=c.getId(),i=0,b=c._getAllContent(),f=c.getFooter(),s=c.getSubHeader(),C=c.getContentWidth(),d=c.getContentMinWidth(),e=c.getContentHeight();if(D.system.desktop){r.openStart("span",c.getId()+"-firstfe").class("sapMPopoverHiddenFocusable").attr("tabindex","0").openEnd().close("span");}if(h){r.openStart("header").class("sapMPopoverHeader").openEnd();if(h._applyContextClassFor){h._applyContextClassFor("header");}r.renderControl(h);r.close("header");}if(s){r.openStart("header").class("sapMPopoverSubHeader").openEnd();if(s._applyContextClassFor){s._applyContextClassFor("subheader");}r.renderControl(s);r.close("header");}r.openStart("div",I+"-cont");if(C){r.style("width",C);}if(d){r.style("min-width",d);}if(e){r.style("height",e);}r.class("sapMPopoverCont");if(sap.ui.getCore().getConfiguration().getAccessibility()&&c.getProperty("ariaRoleApplication")){r.attr("role","application");}r.openEnd();r.openStart("div",c.getId()+"-scroll").class("sapMPopoverScroll");if(!c.getHorizontalScrolling()){r.style(sap.ui.getCore().getConfiguration().getRTL()?"margin-left":"margin-right",g().width+"px");}r.openEnd();for(i=0;i<b.length;i++){r.renderControl(b[i]);}r.close("div");r.close("div");if(f){r.openStart("footer").class("sapMPopoverFooter");if(this.isButtonFooter(f)){r.class("sapMPopoverSpecialFooter");}r.openEnd();if(f._applyContextClassFor){f._applyContextClassFor("footer");f.addStyleClass("sapMTBNoBorders");}r.renderControl(f);r.close("footer");}if(c.getShowArrow()){r.openStart("span",I+"-arrow").class("sapMPopoverArr").openEnd().close("span");}if(D.system.desktop){r.openStart("span",c.getId()+"-middlefe").class("sapMPopoverHiddenFocusable").attr("tabindex","-1").openEnd().close("span");r.openStart("span",c.getId()+"-lastfe").class("sapMPopoverHiddenFocusable").attr("tabindex","0").openEnd().close("span");}};
a.generateRootClasses=function(c){var C=["sapMPopover"],s=c.getSubHeader(),f=c.getFooter(),v=c.getVerticalScrolling()&&!c._forceDisableScrolling,h=c.getHorizontalScrolling()&&!c._forceDisableScrolling,H=c._getAnyHeader();if(H){C.push("sapMPopoverWithBar");}else{C.push("sapMPopoverWithoutBar");}if(s){C.push("sapMPopoverWithSubHeader");}else{C.push("sapMPopoverWithoutSubHeader");}if(c._hasSingleNavContent()){C.push("sapMPopoverNav");}if(c._hasSinglePageContent()){C.push("sapMPopoverPage");}if(f){C.push("sapMPopoverWithFooter");}else{C.push("sapMPopoverWithoutFooter");}if(c.getPlacement()===P.Top){C.push("sapMPopoverPlacedTop");}if(!v){C.push("sapMPopoverVerScrollDisabled");}if(!h){C.push("sapMPopoverHorScrollDisabled");}C.push("sapMPopup-CTX");if(c._bSizeCompact){C.push("sapUiSizeCompact");}return C.concat(c.aCustomStyleClasses);};
return a;},true);
sap.ui.predefine('sap/m/ProgressIndicator',['./library','sap/ui/core/Control','sap/ui/core/ValueStateSupport','sap/ui/core/library','./ProgressIndicatorRenderer',"sap/base/Log"],function(l,C,V,c,P,L){"use strict";var T=c.TextDirection;var a=c.ValueState;
var b=C.extend("sap.m.ProgressIndicator",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},state:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:a.None},displayValue:{type:"string",group:"Appearance",defaultValue:null},percentValue:{type:"float",group:"Data",defaultValue:0},showValue:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},displayAnimation:{type:"boolean",group:"Behavior",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},designtime:"sap/m/designtime/ProgressIndicator.designtime"}});
var u=sap.ui.getCore().getConfiguration().getAnimation();
b.prototype.setPercentValue=function(p){var t=this,$,f,d=this.$(),A,o=p;p=parseFloat(p);if(!i(p)){if(p>100){p=100;}else if(p<0){p=0;}else{L.warning(this+": percentValue ("+o+") is not a valid number! The provided value will not be set!");return this;}L.warning(this+": percentValue ("+o+") is not correct! Setting the percentValue to "+p);}if(this.getPercentValue()!==p){f=this.getPercentValue()-p;this.setProperty("percentValue",p,true);if(!d.length){return this;}["sapMPIValueMax","sapMPIValueMin","sapMPIValueNormal","sapMPIValueGreaterHalf"].forEach(function(s){d.removeClass(s);});d.addClass(this._getCSSClassByPercentValue(p).join(" "));d.addClass("sapMPIAnimate").attr("aria-valuenow",p).attr("aria-valuetext",this._getAriaValueText({fPercent:p}));A=u&&this.getDisplayAnimation()?Math.abs(f)*20:0;$=this.$("bar");$.stop();$.animate({"flex-basis":p+"%"},A,"linear",function(){t._setText.apply(t);t.$().removeClass("sapMPIAnimate");});}return this;};
b.prototype._setText=function(){this.$().toggleClass("sapMPIValueGreaterHalf",this.getPercentValue()>50);return this;};
b.prototype._getCSSClassByPercentValue=function(p){if(p===100){return["sapMPIValueMax","sapMPIValueGreaterHalf"];}if(p===0){return["sapMPIValueMin"];}if(p<=50){return["sapMPIValueNormal"];}return["sapMPIValueNormal","sapMPIValueGreaterHalf"];};
b.prototype._getAriaValueText=function(p){p.sText=p.sText||this.getDisplayValue();p.fPercent=p.fPercent||this.getPercentValue();p.sStateText=p.sStateText||this._getStateText();var A=p.sText||p.fPercent+"%";if(p.sStateText){A+=" "+p.sStateText;}return A;};
b.prototype._getStateText=function(){return V.getAdditionalText(this.getState());};
b.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),d=this.getDisplayValue(),D=d?d:B.getText("ACC_CTR_STATE_PROGRESS",[this.getPercentValue()]);return{role:"progressbar",type:B.getText("ACC_CTR_TYPE_PROGRESS"),description:D,focusable:this.getEnabled(),enabled:this.getEnabled()};};
function i(v){return!isNaN(v)&&v>=0&&v<=100;}
return b;});
sap.ui.predefine('sap/m/ProgressIndicatorRenderer',["sap/ui/core/library"],function(c){"use strict";var V=c.ValueState;var P={apiVersion:2};
P.render=function(r,C){var p=C.getPercentValue(),w=C.getWidth(),h=C.getHeight(),a=C._getCSSClassByPercentValue(p),t=C.getDisplayValue(),s=C.getShowValue(),S=C.getState(),T=C.getTextDirection().toLowerCase(),b=C.getId();r.openStart("div",C);r.class("sapMPI");r.style("width",w);a.forEach(function(d){r.class(d);});r.style("height",h);if(C.getEnabled()){r.attr('tabindex','-1');}else{r.class("sapMPIBarDisabled");}if(C.getDisplayOnly()){r.class("sapMPIDisplayOnly");}r.accessibilityState(C,{role:"progressbar",valuemin:0,valuenow:p,valuemax:100,valuetext:C._getAriaValueText({sText:t,fPercent:p})});if(C.getTooltip_AsString()){r.attr("title",C.getTooltip_AsString());}r.openEnd();r.openStart("div",b+"-bar");r.class("sapMPIBar");switch(S){case V.Warning:r.class("sapMPIBarCritical");break;case V.Error:r.class("sapMPIBarNegative");break;case V.Success:r.class("sapMPIBarPositive");break;case V.Information:r.class("sapMPIBarInformation");break;default:r.class("sapMPIBarNeutral");break;}r.style("flex-basis",p+"%");r.openEnd();P._renderDisplayText(r,T,"Left",b);if(s){r.text(t);}r.close("span");r.close("div");r.openStart("div",b+"-remainingBar");r.class("sapMPIBarRemaining");r.openEnd();P._renderDisplayText(r,T,"Right",b);if(s){r.text(t);}r.close("span");r.close("div");r.close("div");};
P._renderDisplayText=function(r,t,T,C){r.openStart("span",C+"-text"+T);r.class("sapMPIText");r.class("sapMPIText"+T);if(t!=="inherit"){r.attr("dir",t);}r.openEnd();};
return P;},true);
sap.ui.predefine('sap/m/PullToRefresh',["sap/ui/thirdparty/jquery",'./library','sap/ui/core/Control','sap/ui/Device','./PullToRefreshRenderer',"sap/ui/events/KeyCodes","sap/base/security/encodeXML","sap/ui/core/InvisibleText"],function(q,l,C,D,P,K,e,I){"use strict";var a=l.ImageHelper;
var b=C.extend("sap.m.PullToRefresh",{metadata:{library:"sap.m",properties:{description:{type:"string",group:"Misc",defaultValue:null},showIcon:{type:"boolean",group:"Appearance",defaultValue:false},customIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},events:{refresh:{}}}});
b.ARIA_F5_REFRESH="PULL_TO_REFRESH_ARIA_F5";
b.prototype.init=function(){this._bTouchMode=D.support.touch&&!D.system.combi||q.sap.simulateMobileOnDesktop;this._iState=0;this._sAriaF5Text=I.getStaticId("sap.m",b.ARIA_F5_REFRESH);};
b.prototype._loadBI=function(){if(this.getVisible()&&!this._oBusyIndicator){var B=sap.ui.requireSync("sap/m/BusyIndicator");this._oBusyIndicator=new B({size:"1.7rem",design:"auto"});this._oBusyIndicator.setParent(this);}};
b.prototype._getAriaDescribedByReferences=function(){var t=this.getTooltip_AsString(),d=this._sAriaF5Text,T;if(t){T=I.getStaticId("sap.m",t);d+=' '+T;}return d;};
b.prototype.onBeforeRendering=function(){this._loadBI();if(this._bTouchMode){q(window).off("resize.sapMP2R",this.calculateTopTrigger);var p=this.getParent();this._oScroller=p&&p.getScrollDelegate?p.getScrollDelegate():null;if(this._oScroller){this._oScroller.setBounce(true);this._oScroller.setPullDown(this.getVisible()?this:null);}}};
b.prototype.calculateTopTrigger=function(){this._iTopTrigger=1;if(this._oDomRef&&this._oDomRef.parentNode&&this._oDomRef.parentNode.parentNode&&this._oDomRef.parentNode.parentNode.offsetHeight<this._oDomRef.offsetHeight*1.5){this._iTopTrigger=this.getDomRef("T").offsetTop;}};
b.prototype.onAfterRendering=function(){this._oDomRef=this.getDomRef();if(this._bTouchMode){if(this._oScroller){this._oScroller.refresh();}if(this.getVisible()&&this._oScroller&&this._oScroller._bIScroll){q(window).on("resize.sapMP2R",q.proxy(this.calculateTopTrigger,this));this.calculateTopTrigger();}}};
b.prototype.exit=function(){if(this._bTouchMode&&this._oScroller&&this._oScroller._bIScroll){q(window).off("resize.sapMP2R",this.calculateTopTrigger);}if(this._oScroller){this._oScroller.setPullDown(null);this._oScroller=null;}if(this._oCustomImage){this._oCustomImage.destroy();this._oCustomImage=null;}if(this._oBusyIndicator){this._oBusyIndicator.destroy();this._oBusyIndicator=null;}};
b.prototype.doScrollMove=function(){if(!this._oScroller){return;}var d=this._oDomRef;var _=this._oScroller._scroller;if(_.y>-this._iTopTrigger&&this._iState<1){this.setState(1);_.minScrollY=0;}else if(_.y<-this._iTopTrigger&&this._iState===1){this.setState(0);_.minScrollY=-d.offsetHeight;}};
b.prototype.doPull=function(p){if(this._bTouchMode&&this._iState<2){this.setState(p>=-1?1:0);}};
b.prototype.doRefresh=function(){this.setState(0);};
b.prototype.doScrollEnd=function(){if(this._iState===1){this.setState(2);this.fireRefresh();}};
b.prototype.setState=function(s){if(this._iState===s){return;}this._iState=s;if(!this._oDomRef){return;}var $=this.$();var c=$.find(".sapMPullDownText");var r=this._getRB();switch(s){case 0:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",false);c.html(r.getText(this._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));$.removeAttr("aria-live");$.find(".sapMPullDownInfo").html(e(this.getDescription()));break;case 1:$.toggleClass("sapMFlip",true);c.html(r.getText("PULL2REFRESH_RELEASE"));$.removeAttr("aria-live");break;case 2:$.toggleClass("sapMFlip",false).toggleClass("sapMLoading",true);this._oBusyIndicator.setVisible(true);c.html(r.getText("PULL2REFRESH_LOADING"));$.attr("aria-live","assertive");$.find(".sapMPullDownInfo").html(this._bTouchMode?r.getText("PULL2REFRESH_LOADING_LONG"):"");break;}};
b.prototype.getCustomIconImage=function(){var p={src:this.getCustomIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false};var c=['sapMPullDownCIImg'];this._oCustomImage=a.getImageControl(null,this._oCustomImage,this,p,c);return this._oCustomImage;};
b.prototype.onclick=function(){if(!this._bTouchMode){this.setState(2);this.fireRefresh();}};
b.prototype.onkeydown=function(c){if(c.which===K.F5){this.onclick();c.stopPropagation();c.preventDefault();}};
b.prototype.onsapenter=function(E){if(this._iState<1){this.setState(2);this.fireRefresh();}};
b.prototype.onsapspace=function(E){E.preventDefault();if(this._iState<1){this.setState(2);this.fireRefresh();}};
b.prototype.hide=function(){this.setState(0);if(this._oScroller){this._oScroller.refresh();}};
b.prototype.setVisible=function(v){if(this.getVisible()===v){return this;}if(this._oDomRef&&this._oScroller&&this._oScroller._oControl){this._oScroller._oControl.invalidate();}return this.setProperty("visible",v);};
b.prototype._getRB=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m");};
return b;});
sap.ui.predefine('sap/m/PullToRefreshRenderer',['sap/ui/core/IconPool'],function(I){"use strict";I.insertFontFaceStyle();var P={apiVersion:2};
P.writeAccessibilityState=function(r,c){var a={role:"button",controls:c.getParent().sId+"-cont",keyshortcuts:"F5",describedby:c._getAriaDescribedByReferences()};r.accessibilityState(c,a);};
P.render=function(r,c){var s=c.getShowIcon();var C=c.getCustomIcon();var t=c.getTooltip_AsString();var R=c._getRB();r.openStart("div",c);r.class("sapMPullDown");r.class(!c._bTouchMode?"sapMPullDownNontouch":"sapMPullDownTouch");if(s&&!C){r.class("sapMPullDownLogo");}if(t){r.attr("title",t);}r.attr("tabindex",0);this.writeAccessibilityState(r,c);r.openEnd();if(s&&C){var o=c.getCustomIconImage();if(o){r.openStart("div").class("sapMPullDownCI").openEnd();r.renderControl(o);r.close("div");}}r.openStart("span").class("sapMPullDownIcon").openEnd().close("span");r.openStart("span").class("sapMPullDownBusy").openEnd();r.renderControl(c._oBusyIndicator);r.close("span");r.openStart("span",c.getId()+"-T");r.class("sapMPullDownText");r.attr("aria-live","assertive");r.openEnd();r.text(R.getText(c._bTouchMode?"PULL2REFRESH_PULLDOWN":"PULL2REFRESH_REFRESH"));r.close("span");r.openStart("span",c.getId()+"-I");r.class("sapMPullDownInfo");r.openEnd();r.text(c.getDescription());r.close("span");r.close("div");};
return P;},true);
sap.ui.predefine('sap/m/QuickViewCardRenderer',["sap/ui/core/Core"],function(C){"use strict";var Q={apiVersion:2};
Q.render=function(r,q){r.openStart("div",q).class("sapMQuickViewCard").accessibilityState({label:{value:C.getLibraryResourceBundle("sap.m").getText("ARIA_ROLEDESCRIPTION_CARD"),append:true}});if(!q.getShowVerticalScrollBar()){r.class("sapMQuickViewCardNoScroll");}r.openEnd();r.renderControl(q.getNavContainer());r.close("div");};
return Q;},true);
sap.ui.predefine('sap/m/QuickViewGroup',["./library","sap/ui/core/Element"],function(l,E){"use strict";
var G=E.extend("sap.m.QuickViewGroup",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true},heading:{type:"string",group:"Misc",defaultValue:""}},defaultAggregation:"elements",aggregations:{elements:{type:"sap.m.QuickViewGroupElement",multiple:true,singularName:"element",bindable:"bindable"}}}});
["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(f){G.prototype["_"+f+"Old"]=G.prototype[f];G.prototype[f]=function(){var r=G.prototype["_"+f+"Old"].apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}if(["removeAggregation","removeAllAggregation"].indexOf(f)!==-1){return r;}return this;};});
G.prototype.setProperty=function(){E.prototype.setProperty.apply(this,arguments);var p=this.getParent();if(p){p._updatePage();}return this;};
G.prototype.getQuickViewBase=function(){var p=this.getParent();if(p&&p.getQuickViewBase){return p.getQuickViewBase();}return null;};
return G;});
sap.ui.predefine('sap/m/QuickViewPageRenderer',[],function(){"use strict";var Q={apiVersion:2};
Q.render=function(r,q){var p=q.getPageContent();r.openStart("div",q).class("sapMQuickViewPage").openEnd();if(p.header){r.renderControl(p.header);}r.renderControl(p.form);r.close("div");};
return Q;},true);
sap.ui.predefine('sap/m/RadioButton',['./library','sap/ui/core/Control','sap/ui/core/Core','sap/ui/core/EnabledPropagator','sap/ui/core/message/MessageMixin','sap/m/RadioButtonGroup','sap/m/Label','sap/ui/core/library','sap/base/strings/capitalize','./RadioButtonRenderer'],function(l,C,a,E,M,R,L,c,b,d){"use strict";var T=c.TextAlign;var V=c.ValueState;var e=c.TextDirection;
var f=C.extend("sap.m.RadioButton",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selected:{type:"boolean",group:"Data",defaultValue:false},groupName:{type:"string",group:"Behavior",defaultValue:'sapMRbDefaultGroup'},text:{type:"string",group:"Appearance",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:e.Inherit},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:''},useEntireWidth:{type:"boolean",group:"Appearance",defaultValue:false},activeHandling:{type:"boolean",group:"Appearance",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.Begin},editableParent:{type:"boolean",group:"Behavior",defaultValue:true,visibility:"hidden"},valueStateText:{type:"string",group:"Misc",defaultValue:null,visibility:"hidden"}},events:{select:{parameters:{selected:{type:"boolean"}}}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},dnd:{draggable:true,droppable:false},designtime:"sap/m/designtime/RadioButton.designtime"}});
E.call(f.prototype);M.call(f.prototype);f.prototype._groupNames={};var K={HOME:"first",END:"last",NEXT:"next",PREV:"prev"};
f.prototype.onBeforeRendering=function(){this._updateGroupName();this._updateLabelProperties();var g=this.getGroupName(),h=this._groupNames[g],j=h&&h.length;if(!!this.getSelected()&&g&&g!==""){for(var i=0;i<j;i++){var o=h[i];if(o instanceof f&&o!==this&&o.getSelected()){o.fireSelect({selected:false});o.setSelected(false);}}}};
f.prototype.exit=function(){var g=this.getGroupName(),h=this._groupNames[g],G=h&&h.indexOf(this);this._iTabIndex=null;if(this._oLabel){this._oLabel.destroy();this._oLabel=null;}if(G>=-1){h.splice(G,1);}};
f.prototype.ontap=function(o){if(!this.getEnabled()||!this.getEditable()){return;}var p=this.getParent();if(p instanceof R&&(!p.getEnabled()||!p.getEditable())){return;}o&&o.setMarked();this.applyFocusInfo();if(!this.getSelected()){this.setSelected(true);var t=this;setTimeout(function(){t.fireSelect({selected:true});},0);}};
f.prototype.ontouchstart=function(o){o.setMarked();if(this.getEnabled()&&this.getActiveHandling()){this.addStyleClass("sapMRbBTouched");}};
f.prototype.ontouchend=function(){this.removeStyleClass("sapMRbBTouched");};
f.prototype.onsapnext=function(o){this._keyboardHandler(K.NEXT,true);o.setMarked();return this;};
f.prototype.onsapnextmodifiers=function(o){this._keyboardHandler(K.NEXT,!o.ctrlKey);o.setMarked();return this;};
f.prototype.onsapprevious=function(o){this._keyboardHandler(K.PREV,true);o.setMarked();return this;};
f.prototype.onsappreviousmodifiers=function(o){this._keyboardHandler(K.PREV,!o.ctrlKey);o.setMarked();return this;};
f.prototype.onsaphome=function(o){this._keyboardHandler(K.HOME,true);o.setMarked();return this;};
f.prototype.onsaphomemodifiers=function(o){this._keyboardHandler(K.HOME,!o.ctrlKey);o.setMarked();return this;};
f.prototype.onsapend=function(o){this._keyboardHandler(K.END,true);o.setMarked();return this;};
f.prototype.onsapendmodifiers=function(o){this._keyboardHandler(K.END,!o.ctrlKey);o.setMarked();return this;};
f.prototype._keyboardHandler=function(p,s){if(this.getParent()instanceof R){return;}var n=this._getNextFocusItem(p);n.focus();if(s&&!n.getSelected()&&n.getEditable()&&n.getEnabled()){n.setSelected(true);setTimeout(function(){n.fireSelect({selected:true});},0);}};
f.prototype.getAccessibilityInfo=function(){var B=a.getLibraryResourceBundle("sap.m");return{role:"radio",type:B.getText("ACC_CTR_TYPE_RADIO"),description:(this.getText()||"")+(this.getSelected()?(" "+B.getText("ACC_CTR_STATE_CHECKED")):""),enabled:this.getEnabled(),editable:this.getEditable()};};
f.prototype.getFormDoNotAdjustWidth=function(){return this.getText()?false:true;};
f.prototype._getNextFocusItem=function(n){var v=this._groupNames[this.getGroupName()].filter(function(r){return(r.getDomRef()&&r.getEnabled());});var B=v.indexOf(this),i=B,g=v.length;switch(n){case K.NEXT:i=B===g-1?B:B+1;break;case K.PREV:i=B===0?0:i-1;break;case K.HOME:i=0;break;case K.END:i=g-1;break;}return v[i]||this;};
f.prototype.onsapselect=function(o){o.preventDefault();this.ontap(o);};
f.prototype.setTabIndex=function(t){var F=this.getFocusDomRef();this._iTabIndex=t;if(F){F.setAttribute("tabindex",t);}return this;};
f.prototype.setValueStateText=function(t){return this.setProperty("valueStateText",t);};
f.prototype._updateLabelProperties=function(){var o=this._getLabel();var t=this.getText();var u=this.getUseEntireWidth();this.toggleStyleClass("sapMRbHasLabel",!!t);o.setText(t).setWidth(!u?this.getWidth():"auto").setTextDirection(this.getTextDirection()).setTextAlign(this.getTextAlign());};
f.prototype._getLabel=function(){if(!this._oLabel){this._oLabel=new L(this.getId()+"-label");this._oLabel.addStyleClass("sapMRbBLabel").setParent(this,null,true);}return this._oLabel;};
f.prototype._updateGroupName=function(){var s=this.getGroupName();for(var g in this._groupNames){var G=this._groupNames[g];if(g!==s&&G.indexOf(this)!==-1){G.splice(G.indexOf(this),1);}}var n=this._groupNames[s];if(!n){n=this._groupNames[s]=[];}if(n.indexOf(this)===-1){n.push(this);}};
["editableParent"].forEach(function(p){f.prototype["_set"+b(p)]=function(v){return this.setProperty(p,v,true);};});return f;});
sap.ui.predefine('sap/m/RadioButtonGroup',['./library','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/library','./RadioButtonGroupRenderer',"sap/base/Log"],function(l,C,I,c,R,L){"use strict";var T=c.TextDirection;var V=c.ValueState;
var a=C.extend("sap.m.RadioButtonGroup",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/RadioButtonGroup.designtime",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},columns:{type:"int",group:"Appearance",defaultValue:1},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:V.None},selectedIndex:{type:"int",group:"Data",defaultValue:0},enabled:{type:"boolean",group:"Behavior",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.RadioButton",multiple:true,singularName:"button",bindable:"bindable"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{parameters:{selectedIndex:{type:"int"}}}}}});
a.prototype.exit=function(){this.destroyButtons();if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
a.prototype.onBeforeRendering=function(){var b=this.getButtons();var B=b.length;var e=this.getEditable();b.forEach(function(r){r._setEditableParent(e);});if(this.getSelectedIndex()>B){L.warning("Invalid index, set to 0");this.setSelectedIndex(0);}if(this.aRBs){var v=this.getValueState();this.aRBs.forEach(function(r){r.setValueState(v);});}};
a.prototype.onAfterRendering=function(){this._initItemNavigation();};
a.prototype._initItemNavigation=function(){var d=[];var h=false;var r=this.getEnabled();for(var i=0;i<this.aRBs.length;i++){d.push(this.aRBs[i].getDomRef());h=h||this.aRBs[i].getEnabled();}if(!h||!r){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}return;}if(!this._oItemNavigation){this._oItemNavigation=new I();this._oItemNavigation.attachEvent(I.Events.AfterFocus,this._handleAfterFocus,this);this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(this.getDomRef());this._oItemNavigation.setItemDomRefs(d);this._oItemNavigation.setCycling(true);this._oItemNavigation.setColumns(this.getColumns());this._oItemNavigation.setSelectedIndex(this.getSelectedIndex());this._oItemNavigation.setFocusedIndex(this.getSelectedIndex());this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});};
a.prototype.setSelectedIndex=function(s){var i=this.getSelectedIndex();var h=document.activeElement&&document.activeElement.parentNode&&document.activeElement.parentNode.parentNode===this.getDomRef();var b=!!(this.aRBs&&this.aRBs[s]);if(s<-1){L.warning("Invalid index, will not be changed");return this;}this.setProperty("selectedIndex",s,true);if(!isNaN(i)&&this.aRBs&&this.aRBs[i]){this.aRBs[i].setSelected(false);}if(this.aRBs&&this.aRBs[s]){this.aRBs[s].setSelected(true);}if(this._oItemNavigation){this._oItemNavigation.setSelectedIndex(s);this._oItemNavigation.setFocusedIndex(s);}if(b&&h){this.aRBs[s].getDomRef().focus();}return this;};
a.prototype.setSelectedButton=function(s){if(!s){return this.setSelectedIndex(-1);}var b=this.getButtons();for(var i=0;i<b.length;i++){if(s.getId()==b[i].getId()){return this.setSelectedIndex(i);}}return this;};
a.prototype.getSelectedButton=function(){return this.getButtons()[this.getSelectedIndex()];};
a.prototype.addButton=function(b){if(!this._bUpdateButtons&&this.getSelectedIndex()===undefined){this.setSelectedIndex(0);}if(!this.aRBs){this.aRBs=[];}var i=this.aRBs.length;this.aRBs[i]=this._createRadioButton(b,i);this.addAggregation("buttons",this.aRBs[i]);return this;};
a.prototype.insertButton=function(b,d){if(!this.aRBs){this.aRBs=[];}var e=this.aRBs.length,m=this.getButtons().length;d=Math.max(Math.min(d,m),0);if(!this._bUpdateButtons){if(this.getSelectedIndex()===undefined||e==0){this.setSelectedIndex(0);}else if(this.getSelectedIndex()>=d){this.setProperty("selectedIndex",this.getSelectedIndex()+1,true);}}if(d>=e){this.aRBs[d]=this._createRadioButton(b,d);}else{for(var i=(e);i>d;i--){this.aRBs[i]=this.aRBs[i-1];if((i-1)==d){this.aRBs[i-1]=this._createRadioButton(b,d);}}}this.insertAggregation("buttons",b,d);return this;};
a.prototype._createRadioButton=function(b,i){if(this.iIDCount==undefined){this.iIDCount=0;}else{this.iIDCount++;}b.setValueState(this.getValueState());b.setGroupName(this.getId());if(i==this.getSelectedIndex()){b.setSelected(true);}b.attachEvent("select",this._handleRBSelect,this);return b;};
a.prototype.removeButton=function(e){var i=e;if(typeof(e)=="string"){e=sap.ui.getCore().byId(e);}if(typeof(e)=="object"){i=this.indexOfButton(e);}var b=this.removeAggregation("buttons",i);if(!this.aRBs){this.aRBs=[];}if(!this.aRBs[i]){return null;}this.aRBs.splice(i,1);if(!this._bUpdateButtons){if(this.aRBs.length==0){this.setSelectedIndex(-1);}else if(this.getSelectedIndex()==i){this.setSelectedIndex(0);}else{if(this.getSelectedIndex()>i){this.setProperty("selectedIndex",this.getSelectedIndex()-1,true);}}}return b;};
a.prototype.removeAllButtons=function(){if(!this._bUpdateButtons){this.setSelectedIndex(-1);}this.aRBs=[];return this.removeAllAggregation("buttons");};
a.prototype.destroyButtons=function(){this.destroyAggregation("buttons");if(!this._bUpdateButtons){this.setSelectedIndex(-1);}if(this.aRBs){while(this.aRBs.length>0){this.aRBs[0].destroy();this.aRBs.splice(0,1);}}return this;};
a.prototype.updateButtons=function(){this._bUpdateButtons=true;this.updateAggregation("buttons");this._bUpdateButtons=undefined;};
a.prototype.clone=function(){var b=this.getButtons();var i=0;for(i=0;i<b.length;i++){b[i].detachEvent("select",this._handleRBSelect,this);}var o=C.prototype.clone.apply(this,arguments);for(i=0;i<b.length;i++){b[i].attachEvent("select",this._handleRBSelect,this);}return o;};
a.prototype._handleRBSelect=function(o){for(var i=0;i<this.aRBs.length;i++){if(this.aRBs[i].getId()==o.getParameter("id")&&o.getParameter("selected")){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});break;}}};
a.prototype._handleAfterFocus=function(o){var i=o.getParameter("index");var e=o.getParameter("event");if(e.keyCode===undefined){return;}if(i!=this.getSelectedIndex()&&!(e.ctrlKey||e.metaKey)&&this.aRBs[i].getEditable()&&this.aRBs[i].getEnabled()&&this.getEditable()&&this.getEnabled()){this.setSelectedIndex(i);this.fireSelect({selectedIndex:i});}};
return a;});
sap.ui.predefine('sap/m/RadioButtonGroupRenderer',["sap/ui/core/library","sap/ui/core/Core"],function(a,C){"use strict";var T=a.TextDirection;var R={apiVersion:2};
R.render=function(r,o){if(!o.aRBs){return;}var v=o.aRBs.filter(function(B){return B.getVisible();});var b=o.getColumns();var s=o.getTextDirection();var g=C.getConfiguration().getRTL();r.openStart("div",o).class("sapMRbG");if(!o.getEditable()){r.class("sapMRbGRo");}if(b>1){if(b==v.length){r.class("sapMRbG1Row");}else{r.class("sapMRbGTab");}}if(o.getWidth()){r.style("width",o.getWidth());}if(o.getTooltip_AsString()){r.attr("title",o.getTooltip_AsString());}if(!g&&s!=T.Inherit){r.attr("dir",s.toLowerCase());}r.accessibilityState(o,{role:"radiogroup"});r.openEnd();for(var c=0;c<b;c++){if(b>1&&b!=v.length){r.openStart("div").class("sapMRbGCol").openEnd();}for(var i=c;i<v.length;i=i+b){r.renderControl(v[i]);}if(b>1&&b!=v.length){r.close("div");}}if(b>1&&b!=v.length){r.openStart("div").class("sapMRbGDummy").openEnd().close("div");}r.close("div");};
return R;},true);
sap.ui.predefine('sap/m/RadioButtonRenderer',["sap/ui/core/Core","sap/ui/core/ValueStateSupport","sap/ui/core/library","sap/ui/Device"],function(C,V,c,D){"use strict";var a=c.ValueState;var R={apiVersion:2};
R.render=function(r,o){this.addWOuterDivStyles(r,o);this.addInnerDivStyles(r,o);this.renderSvg(r,o);this.renderInput(r,o);this.closeDiv(r);r.renderControl(o._oLabel);this.renderTooltip(r,o);this.closeDiv(r);};
R.addWOuterDivStyles=function(r,o){var i=o.getId(),e=o.getEnabled(),n=!o.getProperty("editableParent"),N=!o.getEditable()||n,v=o.getValueState();r.openStart("div",o).class("sapMRb");if(o.getUseEntireWidth()){r.style("width",o.getWidth());}var t=this.getTooltipText(o);if(t){r.attr("title",t);}r.accessibilityState(o,{role:"radio",readonly:null,selected:null,checked:o.getSelected(),disabled:N?true:undefined,invalid:v===a.Error?true:null,labelledby:{value:i+"-label",append:true},describedby:{value:(t?i+"-Descr":undefined),append:true}});if(o.getSelected()){r.class("sapMRbSel");}if(!e){r.class("sapMRbDis");}if(N){r.class("sapMRbRo");}if(v===a.Error){r.class("sapMRbErr");}if(v===a.Warning){r.class("sapMRbWarn");}if(v===a.Success){r.class("sapMRbSucc");}if(v===a.Information){r.class("sapMRbInfo");}if(e){r.attr("tabindex",o.hasOwnProperty("_iTabIndex")?o._iTabIndex:0);}r.openEnd();};
R.addInnerDivStyles=function(r,o){r.openStart("div").class("sapMRbB");if(!this.isButtonReadOnly(o)&&D.system.desktop){r.class("sapMRbHoverable");}r.openEnd();};
R.renderSvg=function(r,o){r.openStart("svg").attr("xmlns","http://www.w3.org/2000/svg").attr("version","1.0").accessibilityState({role:"presentation"}).class("sapMRbSvg").openEnd();r.openStart("circle",o.getId()+"-Button").attr("stroke","black").attr("r","50%").attr("stroke-width","2").attr("fill","none").class("sapMRbBOut").openEnd().close("circle");r.openStart("circle").attr("r","22%").attr("stroke-width","10").class("sapMRbBInn").openEnd().close("circle");r.close("svg");};
R.renderInput=function(r,o){r.voidStart("input",o.getId()+"-RB").attr("type","radio").attr("tabindex","-1").attr("name",o.getGroupName());if(o.getSelected()){r.attr("checked","checked");}if(this.isButtonReadOnly(o)){r.attr("readonly","readonly");r.attr("disabled","disabled");}r.voidEnd();};
R.renderTooltip=function(r,o){var t=this.getTooltipText(o);if(t&&C.getConfiguration().getAccessibility()){r.openStart("span",o.getId()+"-Descr").style("display","none").openEnd().text(t).close("span");}};
R.isButtonReadOnly=function(r){var e=r.getEnabled(),n=!r.getProperty("editableParent"),N=!r.getEditable()||n;return!e||N;};
R.closeDiv=function(r){r.close("div");};
R.getTooltipText=function(r){var v=r.getProperty("valueStateText"),t=r.getTooltip_AsString();if(v){return(t?t+" - ":"")+v;}else{return V.enrichTooltip(r,t);}};
return R;},true);
sap.ui.predefine('sap/m/RangeSlider',["sap/ui/core/InvisibleText","sap/base/Log","./Slider","./SliderTooltip","./SliderUtilities","./RangeSliderRenderer","sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes"],function(I,l,S,a,b,R,q,K){"use strict";
var c=S.extend("sap.m.RangeSlider",{metadata:{library:"sap.m",properties:{value2:{type:"float",group:"Data",defaultValue:100},range:{type:"float[]",group:"Data",defaultValue:[0,100]}},designtime:"sap/m/designtime/RangeSlider.designtime"}});
c.prototype.init=function(){var s,e,r;S.prototype.init.call(this,arguments);this._bInitialRangeChecks=true;this._aInitialFocusRange=this.getRange();this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');this._ariaUpdateDelay=[];s=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_LEFT_HANDLE")});e=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_RIGHT_HANDLE")});r=new I({text:this._oResourceBundle.getText("RANGE_SLIDER_RANGE_HANDLE")});this.destroyAggregation("_handlesLabels",true);this.addAggregation("_handlesLabels",s);this.addAggregation("_handlesLabels",e);this.addAggregation("_handlesLabels",r);this._mHandleTooltip={start:{handle:null,tooltip:null,label:s},end:{handle:null,tooltip:null,label:e}};};
c.prototype.exit=function(){S.prototype.exit.apply(this,arguments);this._oResourceBundle=null;this._aInitialFocusRange=null;this._liveChangeLastValue=null;this._mHandleTooltip.start.handle=null;this._mHandleTooltip.start.tooltip=null;this._mHandleTooltip.start.label=null;this._mHandleTooltip.end.handle=null;this._mHandleTooltip.end.tooltip=null;this._mHandleTooltip.end.label=null;this._ariaUpdateDelay=null;};
c.prototype.onBeforeRendering=function(){this._bRTL=sap.ui.getCore().getConfiguration().getRTL();var r=this.getRange();if(this.getShowAdvancedTooltip()){this.initAndSyncTooltips(["leftTooltip","rightTooltip"]);this._storeTooltipsMetadata();}this._bInitialRangeChecks=false;this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(this.getStep());this.setRange(r);this._validateProperties();this._syncScaleUsage();};
c.prototype.onAfterRendering=function(){S.prototype.onAfterRendering.apply(this,arguments);var r=this.getRange();this._mHandleTooltip.start.handle=this.getDomRef("handle1");this._mHandleTooltip.end.handle=this.getDomRef("handle2");this._recalculateStyles();this._updateHandle(this._mHandleTooltip.start.handle,r[0]);this._updateHandle(this._mHandleTooltip.end.handle,r[1]);if(this.getShowAdvancedTooltip()&&(r[0]>r[1])){this._swapTooltips(r);}};
c.prototype._storeTooltipsMetadata=function(){var t=this.getUsedTooltips();if(!this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.tooltip=t[0];}if(!this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.tooltip=t[1];}this._mHandleTooltip.bTooltipsSwapped=false;};
c.prototype._recalculateRange=function(){var h,s,e,p,d=this._bRTL?"right":"left";h=[parseFloat(this._mHandleTooltip.start.handle.style[d]),parseFloat(this._mHandleTooltip.end.handle.style[d])];s=Math.min.apply(Math,h)+"%";e=(100-Math.max.apply(Math,h))+"%";p=this.getDomRef("progress");if(this._bRTL){p.style.left=e;p.style.right=s;}else{p.style.left=s;p.style.right=e;}};
c.prototype.getClosestHandleDomRef=function(e){var h=this._mHandleTooltip.start.handle,H=this._mHandleTooltip.end.handle,p=Math.abs(e.pageX-h.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft),C=Math.abs(e.clientX-H.offsetLeft-this._fSliderPaddingLeft-this._fSliderOffsetLeft);return p>C?H:h;};
c.prototype._getIndexOfHandle=function(h){if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="start"){return 0;}else if(h&&h.getAttribute&&h.getAttribute("data-range-val")==="end"){return 1;}else{return-1;}};
c.prototype._getHandleForTooltip=function(t){var h=t===this._mHandleTooltip.start.tooltip?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;return h;};
c.prototype._updateHandle=function(h,v){var t=(this._mHandleTooltip.start.handle===h)?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip,r=this.getRange(),i=this._getIndexOfHandle(h),p=this._getPercentOfValue(v);r[i]=v;this._updateRangePropertyDependencies(r);this._updateHandleDom(h,r,i,v,p);if(this.getShowAdvancedTooltip()){this._updateTooltipContent(t,v);this._adjustTooltipsContainer();}this._recalculateRange();};
c.prototype._updateHandleDom=function(h,r,i,v,p){var m,C=this.getRenderer().CSS_CLASS,f=this.getDomRef("input");if(!!this.getName()){f.setAttribute(h.getAttribute("data-range-val"),this.toFixed(r[i],this._iDecimalPrecision));f.setAttribute("value",this.getValue());}if(this._bRTL){h.style.right=p+"%";}else{h.style.left=p+"%";}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=this._formatValueByCustomElement(v);}m=r[0]===r[1];this.$("handle1").toggleClass(C+"HandleOverlap",m);this.$("handle2").toggleClass(C+"HandleOverlap",m);clearTimeout(this._ariaUpdateDelay[i]);this._ariaUpdateDelay[i]=setTimeout(this["_updateHandleAria"].bind(this,h,v),100);};
c.prototype._updateHandleAria=function(h,v){var r=this.getRange(),p=this.getDomRef("progress"),n=this.toFixed(v,this._iDecimalPrecision),s=this._formatValueByCustomElement(n);r[0]=this.toFixed(r[0],this._iDecimalPrecision);r[1]=this.toFixed(r[1],this._iDecimalPrecision);this._updateHandlesAriaLabels();this._updateHandleAriaAttributeValues(h,v,s);if(p){p.setAttribute("aria-valuetext",this._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',r.map(this._formatValueByCustomElement,this)));}};
c.prototype._updateHandlesAriaLabels=function(){var r=this.getRange(),t=this._mHandleTooltip.start.label;if((r[0]>r[1]&&!this._mHandleTooltip.bAriaHandlesSwapped)||(r[0]<r[1]&&this._mHandleTooltip.bAriaHandlesSwapped)){this._mHandleTooltip.start.label=this._mHandleTooltip.end.label;this._mHandleTooltip.end.label=t;if(this._mHandleTooltip.start.handle){this._mHandleTooltip.start.handle.setAttribute("aria-labelledby",this._mHandleTooltip.start.label.getId());}if(this._mHandleTooltip.end.handle){this._mHandleTooltip.end.handle.setAttribute("aria-labelledby",this._mHandleTooltip.end.label.getId());}this._mHandleTooltip.bAriaHandlesSwapped=!this._mHandleTooltip.bAriaHandlesSwapped;}};
c.prototype._setAriaControls=function(){if(!this.getShowAdvancedTooltip()){return;}if(!this._mHandleTooltip.start.handle.getAttribute('aria-controls')&&this._mHandleTooltip.start.tooltip){this._mHandleTooltip.start.handle.setAttribute('aria-controls',this._mHandleTooltip.start.tooltip.getId());}if(!this._mHandleTooltip.end.handle.getAttribute('aria-controls')&&this._mHandleTooltip.end.tooltip){this._mHandleTooltip.end.handle.setAttribute('aria-controls',this._mHandleTooltip.end.tooltip.getId());}};
c.prototype._updateTooltipContent=function(t,n){var N=this.toFixed(n,this._iDecimalPrecision);t.setValue(parseFloat(N));};
c.prototype._swapTooltips=function(r){var t=this._mHandleTooltip.start.tooltip;if((r[0]>=r[1]&&!this._mHandleTooltip.bTooltipsSwapped)||(r[0]<=r[1]&&this._mHandleTooltip.bTooltipsSwapped)){this._mHandleTooltip.start.tooltip=this._mHandleTooltip.end.tooltip;this._mHandleTooltip.end.tooltip=t;this._updateTooltipContent(this._mHandleTooltip.start.tooltip,r[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,r[1]);if(this.getInputsAsTooltips()){this._mHandleTooltip.start.handle.setAttribute("aria-controls",this._mHandleTooltip.start.tooltip.getId());this._mHandleTooltip.end.handle.setAttribute("aria-controls",this._mHandleTooltip.end.tooltip.getId());}this._mHandleTooltip.bTooltipsSwapped=!this._mHandleTooltip.bTooltipsSwapped;}};
c.prototype._adjustTooltipsContainer=function(){var t=this.getAggregation("_tooltipContainer");if(!t.getDomRef()){return;}t.repositionTooltips(this.getMin(),this.getMax());this._swapTooltips(this.getRange());};
c.prototype.getUsedTooltips=function(){var C=this.getCustomTooltips(),d=this.getAggregation("_defaultTooltips")||[];return C.length>1?C:d;};
c.prototype.handleTooltipChange=function(e){this.updateTooltipsPositionAndState(e.getSource(),Number(e.getParameter("value")));};
c.prototype.updateTooltipsPositionAndState=function(t,v){var h,A,T=this._mHandleTooltip.bTooltipsSwapped;v=this._adjustRangeValue(v);h=this._mHandleTooltip.start.tooltip===t?this._mHandleTooltip.start.handle:this._mHandleTooltip.end.handle;this._updateHandle(h,v);if(T!==this._mHandleTooltip.bTooltipsSwapped){A=this._mHandleTooltip.start.tooltip!==t?this._mHandleTooltip.start.tooltip:this._mHandleTooltip.end.tooltip;A.focus();}this._fireChangeAndLiveChange({range:this.getRange()});this.updateAdvancedTooltipDom();};
c.prototype._updateDOMAfterSetters=function(v,r,h){var p,H;if(this.getDomRef()){p=this._getPercentOfValue(v);H=h===1?this._mHandleTooltip.end:this._mHandleTooltip.start;this._updateHandleDom(H.handle,r,h,v,p);if(this.getShowAdvancedTooltip()){this._updateTooltipContent(H.tooltip,v);}return true;}return false;};
c.prototype.setRange=function(r){r=r.map(this._adjustRangeValue,this);this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)&&this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
c.prototype.setStep=function(s){this._validateProperties();this._iDecimalPrecision=this.getDecimalPrecisionOfNumber(s);return this.setProperty("step",s);};
c.prototype.setValue=function(v){var r=this.getRange();if(typeof v!=="number"||!isFinite(v)){return this;}v=this._adjustRangeValue(v);r[0]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[0],r,0)){this._recalculateRange();}return this;};
c.prototype.setValue2=function(v){var r=this.getRange();v=this._adjustRangeValue(v);r[1]=v;this._updateRangePropertyDependencies(r);if(this._updateDOMAfterSetters(r[1],r,1)){this._recalculateRange();}return this;};
c.prototype._updateRangePropertyDependencies=function(r){var d=Array.isArray(r)?r.slice():[],D=this._iDecimalPrecision?this._iDecimalPrecision:0,n=Number(d[0].toFixed(D)),N=Number(d[1].toFixed(D));if(this.getProperty("value")!==n){this.setProperty("value",n,true);d[0]=n;}if(this.getProperty("value2")!==N){this.setProperty("value2",N,true);d[1]=N;}this.setProperty("range",d,true);};
c.prototype._calculateHandlePosition=function(v){var m=this.getMax(),M=this.getMin(),n;n=((v-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(m-M)+M;if(this._bRTL){n=this._convertValueToRtlMode(n);}return this._adjustRangeValue(n);};
c.prototype._adjustRangeValue=function(v){var m=this.getMax(),M=this.getMin(),s=this.getStep(),f;if(this._bInitialRangeChecks){return v;}f=Math.abs((v-M)%s);if(f!==0){v=f*2>=s?v+s-f:v-f;}if(v<M){l.warning("Warning: "+"Min value ("+v+") not in the range: ["+M+","+m+"]",this);v=M;}else if(v>m){l.warning("Warning: "+"Max value ("+v+") not in the range: ["+M+","+m+"]",this);v=m;}return v;};
c.prototype.ontouchstart=function(e){var t=e.targetTouches[0],C=this.getRenderer().CSS_CLASS,E="."+C,m,M,v,h,r,H,f,F,T,p,d,g;if(!this.getEnabled()){return;}e.setMarked();if(e.target.className.indexOf("sapMInput")===-1){e.preventDefault();}this._recalculateStyles();if(["number","text"].indexOf(e.target.type)>-1){return;}v=this._calculateHandlePosition(t.pageX);r=this.getRange();h=[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];H=this._getIndexOfHandle(e.target);f=h.reduce(function(A,o){return Math.abs(A-o.offsetLeft);},0);m=Math.min.apply(Math,r);M=Math.max.apply(Math,r);g=this.$("handle1").outerWidth()/2;T=Math.abs(this.getMin())+Math.abs(this.getMax());p=((g*100)/this.$("inner").outerWidth());d=(p/100)*T;if(v<m||v<m+d||v>M||v>(M-d)||f<=b.CONSTANTS.RANGE_MOVEMENT_THRESHOLD){h=[this.getClosestHandleDomRef(t)];this._updateHandle(h[0],v);this.fireLiveChange({range:r});}else if(H!==-1){h=[this.getDomRef(H===0?"handle1":"handle2")];}q(document).on("touchend"+E+" touchcancel"+E+" mouseup"+E,this._ontouchend.bind(this,h)).on("touchmove"+E+(e.originalEvent.type!=="touchstart"?" mousemove"+E:""),this._ontouchmove.bind(this,v,this.getRange(),h));h.map(function(o){if(o.className.indexOf(C+"HandlePressed")===-1){o.className+=" "+C+"HandlePressed";}});F=h.length===1?h[0]:this.getDomRef("progress");setTimeout(F["focus"].bind(F),0);};
c.prototype._ontouchmove=function(f,d,h,e){var o,r,g,j,p=e.targetTouches?e.targetTouches[0].pageX:e.pageX,m=this.getMax(),M=this.getMin(),k=[],n=[];e.preventDefault();e.setMarked();if(e.isMarked("delayedMouseEvent")||!this.getEnabled()||e.button){return;}o=this._calculateHandlePosition(p)-f;for(var i=0;i<d.length;i++){k[i]=d[i]+o;}n=this._getNormalizedRange(this.getRange(),d,h);r=k.every(function(v,s){return v===n[s];});g=k.every(function(v){return(v>=M&&v<=m);});j=n.indexOf(M)>-1||n.indexOf(m)>-1;if(!r){if((h.length===1)||g||!j){h.map(function(H){this._updateHandle(H,d[this._getIndexOfHandle(H)]+o);},this);}this.getShowAdvancedTooltip()&&this._adjustTooltipsContainer();n=this._getNormalizedRange(this.getRange(),d,h);}this._triggerLiveChange();this.setRange(n);};
c.prototype.updateAdvancedTooltipDom=function(){this.getAggregation("_tooltipContainer").repositionTooltips(this.getMin(),this.getMax());};
c.prototype._triggerLiveChange=function(){var f,r=this.getRange();this._liveChangeLastValue=this._liveChangeLastValue||[];f=r.some(function(v,i){return v!==this._liveChangeLastValue[i];},this);if(f){this._liveChangeLastValue=r.slice();this.fireLiveChange({range:r});}};
c.prototype._getNormalizedRange=function(r,d,h){var m=this.getMax(),M=this.getMin(),s=Math.abs(d[0]-d[1]),e=[],i,o;for(i=0;i<r.length;i++){e[i]=(r[i]<M?M:r[i]);e[i]=(r[i]>m?m:e[i]);if(h.length===2){if(e[0]==M){e[1]=e[0]+s;}else{o=Math.abs(i-1);e[o]=(e[i]<=M?e[i]+s:e[o]);e[o]=(e[i]>=m?e[i]-s:e[o]);}}}return e;};
c.prototype._ontouchend=function(h,e){var n=this.getRange(),C=this.getRenderer().CSS_CLASS;e.setMarked();h&&h.map(function(H){H.className=H.className.replace(new RegExp(" ?"+C+"HandlePressed","gi"),"");});q(document).off("."+C);this._recalculateRange();if(this._aInitialFocusRange[0]!==n[0]||this._aInitialFocusRange[1]!==n[1]){this._aInitialFocusRange=Array.prototype.slice.call(n);this.fireChange({range:n});}if(this.getShowAdvancedTooltip()){this._updateTooltipContent(this._mHandleTooltip.start.tooltip,n[0]);this._updateTooltipContent(this._mHandleTooltip.end.tooltip,n[1]);}};
c.prototype.onfocusin=function(e){var t=this.getAggregation("_tooltipContainer");if(this.getShowAdvancedTooltip()){t.show(this);this._adjustTooltipsContainer();this._setAriaControls();}if(document.activeElement!==this.getFocusDomRef()){this._aInitialFocusRange=this.getRange();}};
c.prototype.getFocusDomRef=function(){return this.getDomRef("progress");};
c.prototype._updateSliderValues=function(o,h){var r=this.getRange(),m=this.getMax(),M=this.getMin(),f=Math.max.apply(null,r),d=Math.min.apply(null,r),i=this._getIndexOfHandle(h),O=o<0?-1:1,H=i>-1?[h]:[this._mHandleTooltip.start.handle,this._mHandleTooltip.end.handle];if(H.length===1){d=f=r[i];}if(f+o>m){o=O*(Math.abs(m)-Math.abs(f));}else if(d+o<M){o=Math.abs(d)-Math.abs(M);o=o<0?o:O*o;}H.map(function(C){this._updateHandle(C,r[this._getIndexOfHandle(C)]+o);},this);};
c.prototype.onkeydown=function(e){var f=this.getInputsAsTooltips(),s=this.getShowAdvancedTooltip(),F=e.keyCode===b.CONSTANTS.F2_KEYCODE,d=(e.target===this._mHandleTooltip.start.handle),t=q(e.target).hasClass(b.CONSTANTS.HANDLE_CLASS);if(F&&s&&f&&t){this._mHandleTooltip[d?"start":"end"].tooltip.focus();}if(e.keyCode===K.SPACE){e.preventDefault();}};
c.prototype.onsapincrease=function(e){e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapplus=c.prototype.onsapincrease;
c.prototype.onsapincreasemodifiers=function(e){if(e.altKey){return;}e.preventDefault();e.stopPropagation();e.setMarked();if(this.getEnabled()){this._updateSliderValues(this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsappageup=c.prototype.onsapincreasemodifiers;
c.prototype.onsapdecrease=function(e){e.preventDefault();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this.getStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapminus=c.prototype.onsapdecrease;
c.prototype.onsapdecreasemodifiers=function(e){if(e.altKey){return;}e.preventDefault();e.stopPropagation();e.setMarked();if(this.getEnabled()){this._updateSliderValues(-1*this._getLongStep(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsappagedown=c.prototype.onsapdecreasemodifiers;
c.prototype.onsaphome=function(e){var h=0,r,H,m;e.setMarked();e.preventDefault();h=this._getIndexOfHandle(e.target);r=this.getRange()[h];m=this.getMin();if(this.getEnabled()&&(r!==m)){H=(h===1?this._mHandleTooltip.end:this._mHandleTooltip.start);this._updateHandle(H.handle,m);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapend=function(e){e.setMarked();e.preventDefault();if(this.getEnabled()){this._updateSliderValues(this.getMax(),e.target);this._fireChangeAndLiveChange({range:this.getRange()});}};
c.prototype.onsapescape=function(){this.setRange(this._aInitialFocusRange);this._fireChangeAndLiveChange({range:this.getRange()});};
return c;});
sap.ui.predefine('sap/m/RangeSliderRenderer',["sap/ui/core/Renderer","./SliderRenderer","sap/ui/core/InvisibleText"],function(R,S,I){"use strict";var a=R.extend(S);a.apiVersion=2;
a.renderHandles=function(r,c,s){this.renderHandle(r,c,{id:c.getId()+"-handle1",position:"start",forwardedLabels:s});this.renderHandle(r,c,{id:c.getId()+"-handle2",position:"end",forwardedLabels:s});r.renderControl(c._mHandleTooltip.start.label);r.renderControl(c._mHandleTooltip.end.label);r.renderControl(c.getAggregation("_handlesLabels")[2]);};
a.renderHandle=function(r,c,o){var v,b=c.getRange(),e=c.getEnabled(),d=sap.ui.getCore().getConfiguration().getRTL();r.openStart("span",o&&o.id);if(o&&(o.position!==undefined)){v=b[o.position==="start"?0:1];r.attr("data-range-val",o.position);r.attr("aria-labelledby",(o.forwardedLabels+" "+c._mHandleTooltip[o.position].label.getId()).trim());if(c.getInputsAsTooltips()){r.attr("aria-describedby",I.getStaticId("sap.m","SLIDER_INPUT_TOOLTIP"));e&&r.attr("aria-keyshortcuts","F2");}}if(c.getShowHandleTooltip()&&!c.getShowAdvancedTooltip()){this.writeHandleTooltip(r,c);}r.class(S.CSS_CLASS+"Handle");if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle1")){r.style(d?"right":"left",b[0]);}if(o&&(o.id!==undefined)&&o.id===(c.getId()+"-handle2")){r.style(d?"right":"left",b[1]);}this.writeAccessibilityState(r,c,v);if(e){r.attr("tabindex","0");}r.openEnd().close("span");};
a.writeAccessibilityState=function(r,s,v){var n=s._isElementsFormatterNotNumerical(v),b=s._formatValueByCustomElement(v),V;if(s._getUsedScale()&&!n){V=b;}else{V=s.toFixed(v);}r.accessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:V});if(n){r.accessibilityState(s,{valuetext:b});}};
a.renderStartLabel=function(r,c){r.openStart("div").class(S.CSS_CLASS+"RangeLabel").openEnd().text(c.getMin()).close("div");};
a.renderEndLabel=function(r,c){r.openStart("div").class(S.CSS_CLASS+"RangeLabel").style("width",c._getMaxTooltipWidth()+"px").openEnd().text(c.getMax()).close("div");};
a.renderLabels=function(r,c){if(!c.getEnableTickmarks()){r.openStart("div").class(S.CSS_CLASS+"Labels").openEnd();this.renderStartLabel(r,c);this.renderEndLabel(r,c);r.close("div");}};
a.renderProgressIndicator=function(r,s,f){var b=s.getRange();b[0]=s.toFixed(b[0],s._iDecimalPrecision);b[1]=s.toFixed(b[1],s._iDecimalPrecision);r.openStart("div",s.getId()+"-progress");if(s.getEnabled()){r.attr("tabindex","0");}this.addProgressIndicatorClass(r,s);r.style("width",s._sProgressValue);r.accessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuetext:s._oResourceBundle.getText('RANGE_SLIDER_RANGE_ANNOUNCEMENT',b.map(s._formatValueByCustomElement,s)),labelledby:(f+" "+s.getAggregation("_handlesLabels")[2].getId()).trim()}).openEnd().close("div");};
a.addClass=function(r,s){S.addClass(r,s);r.class("sapMRangeSlider");};
return a;},true);
sap.ui.predefine('sap/m/RatingIndicator',['./library','sap/ui/core/Control','sap/ui/core/theming/Parameters','./RatingIndicatorRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,C,P,R,K,L,q){"use strict";var a=l.RatingIndicatorVisualMode;
var b=C.extend("sap.m.RatingIndicator",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},maxValue:{type:"int",group:"Behavior",defaultValue:5},value:{type:"float",group:"Behavior",defaultValue:0,bindable:"bindable"},iconSize:{type:"sap.ui.core.CSSSize",group:"Behavior",defaultValue:null},iconSelected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconUnselected:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},iconHovered:{type:"sap.ui.core.URI",group:"Behavior",defaultValue:null},visualMode:{type:"sap.m.RatingIndicatorVisualMode",group:"Behavior",defaultValue:a.Half},displayOnly:{type:"boolean",group:"Behavior",defaultValue:false},editable:{type:"boolean",group:"Behavior",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"int"}}},liveChange:{parameters:{value:{type:"float"}}}},designtime:"sap/m/designtime/RatingIndicator.designtime"}});
b.sizeMapppings={};b.iconPaddingMappings={};b.paddingValueMappping={};
b.prototype.init=function(){this.allowTextSelection(false);this._iIconCounter=0;this._fHoverValue=0;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle('sap.m');};
b.prototype.setValue=function(v){v=this.validateProperty("value",v);if(v<0){return this;}if(isNaN(v)){L.warning('Ignored new rating value "'+v+'" because it is NAN');}else if(this.$().length&&(v>this.getMaxValue())){L.warning('Ignored new rating value "'+v+'" because it is out  of range (0-'+this.getMaxValue()+')');}else{v=this._roundValueToVisualMode(v);this.setProperty("value",v);this._fHoverValue=v;}return this;};
b.prototype.onThemeChanged=function(e){this.invalidate();};
b.prototype.onBeforeRendering=function(){var v=this.getValue();var m=this.getMaxValue();var s={};if(v>m){this.setValue(m);L.warning("Set value to maxValue because value is > maxValue ("+v+" > "+m+").");}else if(v<0){this.setValue(0);L.warning("Set value to 0 because value is < 0 ("+v+" < 0).");}var i=this.getIconSize();if(i){s=this._getRegularSizes(i);}else if(this.getDisplayOnly()){s=this._getDisplayOnlySizes();}else{s=this._getContentDensitySizes();}this._iPxIconSize=s.icon;this._iPxPaddingSize=s.padding;};
b.prototype._getDisplayOnlySizes=function(){b.sizeMapppings["displayOnly"]=b.sizeMapppings["displayOnly"]||this._toPx(P.get("sapUiRIIconSizeDisplayOnly"));b.paddingValueMappping["displayOnlyPadding"]=b.paddingValueMappping["displayOnlyPadding"]||this._toPx(P.get("sapUiRIIconPaddingDisplayOnly"));return{icon:b.sizeMapppings["displayOnly"],padding:b.paddingValueMappping["displayOnlyPadding"]};};
b.prototype._getContentDensitySizes=function(){var d=this._getDensityMode();var s="sapUiRIIconSize"+d;var p="sapUiRIIconPadding"+d;b.sizeMapppings[s]=b.sizeMapppings[s]||this._toPx(P.get(s));b.paddingValueMappping[p]=b.paddingValueMappping[p]||this._toPx(P.get(p));return{icon:b.sizeMapppings[s],padding:b.paddingValueMappping[p]};};
b.prototype._getRegularSizes=function(i){b.sizeMapppings[i]=b.sizeMapppings[i]||this._toPx(i);var p=b.sizeMapppings[i];b.iconPaddingMappings[p]=b.iconPaddingMappings[p]||"sapUiRIIconPadding"+this._getIconSizeLabel(p);var c=b.iconPaddingMappings[p];b.paddingValueMappping[c]=b.paddingValueMappping[c]||this._toPx(P.get(c));return{icon:b.sizeMapppings[i],padding:b.paddingValueMappping[c]};};
b.prototype.onAfterRendering=function(){this._updateAriaValues();};
b.prototype.exit=function(){this._iIconCounter=null;this._fStartValue=null;this._iPxIconSize=null;this._iPxPaddingSize=null;this._fHoverValue=null;this._oResourceBundle=null;};
b.prototype._getDensityMode=function(){var d=[{name:"Cozy",style:"sapUiSizeCozy"},{name:"Compact",style:"sapUiSizeCompact"},{name:"Condensed",style:"sapUiSizeCondensed"}],D,s,i;for(i in d){D=d[i].style;if(q("html").hasClass(D)||q("."+D).length>0){s=d[i].name;}}return s||d[0].name;};
b.prototype._getIconSizeLabel=function(p){switch(true){case(p>=32):return"L";case(p>=22):return"M";case(p>=16):return"S";case(p>=12):return"XS";default:return"M";}};
b.prototype._toPx=function(c){var s=Math.round(c),d;if(isNaN(s)){if(RegExp("^(auto|0)$|^[+-\.]?[0-9].?([0-9]+)?(px|em|rem|ex|%|in|cm|mm|pt|pc)$").test(c)){d=q('<div style="display: none; width: '+c+'; margin: 0; padding:0; height: auto; line-height: 1; font-size: 1; border:0; overflow: hidden">&nbsp;</div>').appendTo(sap.ui.getCore().getStaticAreaRef());s=d.width();d.remove();}else{return false;}}return Math.round(s);};
b.prototype._updateUI=function(v,h){var s=this.$("sel"),u=this.$("unsel-wrapper"),H=this.$("hov"),i=this._iPxIconSize,I=this._iPxPaddingSize,c="px",S=this.getMaxValue(),d=v*i+(Math.round(v)-1)*I,w=S*(i+I)-I;this._fHoverValue=v;if(d<0){d=0;}this._updateAriaValues(v);u.width((w-d)+c);if(h){H.width(d+c);s.hide();H.show();}else{s.width(d+c);H.hide();s.show();}L.debug("Updated rating UI with value "+v+" and hover mode "+h);};
b.prototype._updateAriaValues=function(n){var $=this.$();var v;if(n===undefined){v=this.getValue();}else{v=n;}var m=this.getMaxValue();$.attr("aria-valuenow",v);$.attr("aria-valuemax",m);var V=this._oResourceBundle.getText("RATING_VALUEARIATEXT",[v,m]);$.attr("aria-valuetext",V);};
b.prototype._calculateSelectedValue=function(e){var s=-1.0,p=0.0,c=this.$(),f=(c.innerWidth()-c.width())/2,E,r=sap.ui.getCore().getConfiguration().getRTL();if(e.targetTouches){E=e.targetTouches[0];}else{E=e;}if(!E||!E.pageX){E=e;if((!E||!E.pageX)&&e.changedTouches){E=e.changedTouches[0];}}if(!E.pageX){return parseFloat(s);}if(E.pageX<c.offset().left){s=0;}else if((E.pageX-c.offset().left)>c.innerWidth()-f){s=this.getMaxValue();}else{p=(E.pageX-c.offset().left-f)/c.width();s=p*this.getMaxValue();}if(r){s=this.getMaxValue()-s;}return this._roundValueToVisualMode(s,true);};
b.prototype._roundValueToVisualMode=function(v,i){if(i){if(v<0.25){v=0;}else if(v<this.getMaxValue()-0.4){v+=0.4;}v=Math.round(v);}else{if(this.getVisualMode()===a.Full){v=Math.round(v);}else if(this.getVisualMode()===a.Half){v=Math.round(v*2)/2;}}return parseFloat(v);};
b.prototype._getIncreasedValue=function(){var m=this.getMaxValue(),v=this.getValue()+this._getValueChangeStep();if(v>m){v=m;}return v;};
b.prototype._getDecreasedValue=function(){var v=this.getValue()-this._getValueChangeStep();if(v<0){v=0;}return v;};
b.prototype._getValueChangeStep=function(){var v=this.getVisualMode(),s;switch(v){case a.Full:s=1;break;case a.Half:if(this.getValue()%1===0.5){s=0.5;}else{s=1;}break;default:L.warning("VisualMode not supported",v);}return s;};
b.prototype.ontouchstart=function(e){if(e.which==2||e.which==3||!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return;}e.setMarked();if(!this._touchEndProxy){this._touchEndProxy=q.proxy(this._ontouchend,this);}if(!this._touchMoveProxy){this._touchMoveProxy=q.proxy(this._ontouchmove,this);}q(document).on("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).on("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);this._fStartValue=this.getValue();var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}};
b.prototype._ontouchmove=function(e){if(e.isMarked("delayedMouseEvent")){return;}e.preventDefault();if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(v>=0&&v<=this.getMaxValue()){this._updateUI(v,true);if(this._fStartValue!==v){this.fireLiveChange({value:v});}}}};
b.prototype._ontouchend=function(e){if(e.isMarked("delayedMouseEvent")){return;}if(this.getEnabled()){var v=this._calculateSelectedValue(e);if(this.getValue()===1&&v===1){v=0;}this.setProperty("value",v,true);this._updateUI(v,false);if(this._fStartValue!==v){this.fireLiveChange({value:v});this.fireChange({value:v});}q(document).off("touchend.sapMRI touchcancel.sapMRI mouseup.sapMRI",this._touchEndProxy);q(document).off("touchmove.sapMRI mousemove.sapMRI",this._touchMoveProxy);delete this._fStartValue;}};
b.prototype.ontouchcancel=b.prototype.ontouchend;
b.prototype.onsapincrease=function(e){var v=this._getIncreasedValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsapdecrease=function(e){var v=this._getDecreasedValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsaphome=function(e){var v=0;this._handleKeyboardValueChange(e,v);};
b.prototype.onsapend=function(e){var v=this.getMaxValue();this._handleKeyboardValueChange(e,v);};
b.prototype.onsapselect=function(e){var v;if(this.getValue()===this.getMaxValue()){v=0;}else{v=this._getIncreasedValue();}this._handleKeyboardValueChange(e,v);};
b.prototype.onkeyup=function(e){var m=this.getMaxValue();if(!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return false;}switch(e.which){case K.DIGIT_0:case K.NUMPAD_0:this.setValue(0);break;case K.DIGIT_1:case K.NUMPAD_1:this.setValue(1);break;case K.DIGIT_2:case K.NUMPAD_2:this.setValue(Math.min(2,m));break;case K.DIGIT_3:case K.NUMPAD_3:this.setValue(Math.min(3,m));break;case K.DIGIT_4:case K.NUMPAD_4:this.setValue(Math.min(4,m));break;case K.DIGIT_5:case K.NUMPAD_5:this.setValue(Math.min(5,m));break;case K.DIGIT_6:case K.NUMPAD_6:this.setValue(Math.min(6,m));break;case K.DIGIT_7:case K.NUMPAD_7:this.setValue(Math.min(7,m));break;case K.DIGIT_8:case K.NUMPAD_8:this.setValue(Math.min(8,m));break;case K.DIGIT_9:case K.NUMPAD_9:this.setValue(Math.min(9,m));break;}};
b.prototype._handleKeyboardValueChange=function(e,v){if(!this.getEnabled()||this.getDisplayOnly()||!this.getEditable()){return;}if(v!==this.getValue()){this.setValue(v);this.fireLiveChange({value:v});this.fireChange({value:v});}if(e){e.preventDefault();e.stopPropagation();}};
b.prototype.getAccessibilityInfo=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m");return{role:"slider",type:B.getText("ACC_CTR_TYPE_RATING"),description:B.getText("ACC_CTR_STATE_RATING",[this.getValue(),this.getMaxValue()]),focusable:this.getEnabled()&&!this.getDisplayOnly(),enabled:this.getEnabled(),editable:this.getEditable()};};
return b;});
sap.ui.predefine('sap/m/RatingIndicatorRenderer',["sap/ui/core/IconPool","sap/ui/Device","sap/ui/core/Core"],function(I,D,C){"use strict";var R={apiVersion:2},s="px";
R.render=function(r,c){var t=this;this.initSharedState(c);this.renderControlContainer(r,c,function(){t.renderSelectedItems(r,c);t.renderUnselectedItems(r,c);t.renderHoverItems(r,c);t.renderSelectorDiv(r,c);});};
R.renderControlContainer=function(r,c,i){var e=c.getEnabled(),E=c.getEditable(),d=c.getDisplayOnly();r.openStart("div",c);r.style("width",this._iWidth+"px");r.style("height",this._iHeight+"px");if(e&&!d){r.attr("tabindex","0");r.class("sapMPointer");if(!E){r.class("sapMRIReadOnly");}}else{r.attr("tabindex","-1");e?r.class("sapMRIDisplayOnly"):r.class("sapMRIDisabled");}r.class("sapMRI");r.class("sapUiRatingIndicator"+c._getIconSizeLabel(this._fIconSize));this.writeTooltip(r,c);this.writeAccessibility(r,c);r.openEnd();i();r.close("div");};
R.initSharedState=function(c){var r=c._roundValueToVisualMode(c.getValue()),i=c._iPxIconSize,f=c._iPxPaddingSize,S=r*i+(Math.round(r)-1)*f;if(S<0){S=0;}this._bUseGradient=D.browser.chrome||D.browser.safari;this._sLabelID=c.getId()+"-ariaLabel";this._iSymbolCount=c.getMaxValue();this._iWidth=this._iSymbolCount*(i+f)-f;this._iHeight=i;this._iSelectedWidth=S;this._fIconSize=i;};
R.writeTooltip=function(r,c){var t=c.getTooltip_AsString();if(t){r.attr("title",t);}};
R.writeAccessibility=function(r,c){var o=C.getLibraryResourceBundle("sap.m");r.accessibilityState(c,{role:"slider",orientation:"horizontal",valuemin:0,disabled:!c.getEnabled()||c.getDisplayOnly(),roledescription:o.getText("RATING_INDICATOR_ARIA_ROLEDESCRIPTION")});};
R.renderSelectedItems=function(r,c){r.openStart("div",c.getId()+"-sel");r.class("sapMRISel");if(this._bUseGradient){r.class("sapMRIGrd");}r.style("width",this._iSelectedWidth+s);r.openEnd();for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("SELECTED",r,c);}r.close("div");};
R.renderUnselectedItems=function(r,c){r.openStart("div",c.getId()+"-unsel-wrapper");r.class("sapMRIUnselWrapper");r.style("width",this._iWidth-this._iSelectedWidth+s);r.openEnd();r.openStart("div",c.getId()+"-unsel");r.class("sapMRIUnsel");if(this._bUseGradient&&(c.getEnabled()||!c.getDisplayOnly())){r.class("sapMRIGrd");}r.openEnd();for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("UNSELECTED",r,c);}r.close("div");r.close("div");};
R.renderHoverItems=function(r,c){if(c.getEnabled()||!c.getDisplayOnly()){r.openStart("div",c.getId()+"-hov");r.class("sapMRIHov");r.openEnd();for(var i=0;i<this._iSymbolCount;i++){this.renderIcon("HOVERED",r,c);}r.close("div");}};
R.renderSelectorDiv=function(r,c){r.openStart("div",c.getId()+"-selector");r.class("sapMRISelector");r.openEnd();r.close("div");};
R.renderIcon=function(i,r,c){var a=this.getIconURI(i,c),t=this.getIconTag(a),b=I.isIconURI(a),S=this._fIconSize+s;if(t==="img"){r.voidStart(t);}else{r.openStart(t);}if(i==="UNSELECTED"&&!c.getEditable()){i="READONLY";}r.class("sapUiIcon");r.class(this.getIconClass(i));r.style("width",S);r.style("height",S);r.style("line-height",S);r.style("font-size",S);if(!b){r.attr("src",a);}if(t==="img"){r.voidEnd();}else{r.openEnd();if(b){r.text(I.getIconInfo(a).content);}r.close(t);}};
R.getIconClass=function(i){switch(i){case"SELECTED":return"sapMRIIconSel";case"UNSELECTED":return"sapMRIIconUnsel";case"HOVERED":return"sapMRIIconHov";case"READONLY":return"sapMRIIconReadOnly";}};
R.getIconURI=function(S,c){if(sap.ui.getCore().getConfiguration().getTheme()==="sap_hcb"){if(S==="UNSELECTED"&&(c.getEnabled()&&!c.getDisplayOnly())){return I.getIconURI("unfavorite");}return I.getIconURI("favorite");}switch(S){case"SELECTED":return c.getIconSelected()||I.getIconURI("favorite");case"UNSELECTED":if(c.getEditable()&&!c.getDisplayOnly()){return c.getIconUnselected()||I.getIconURI("unfavorite");}else{return c.getIconUnselected()||I.getIconURI("favorite");}break;case"HOVERED":return c.getIconHovered()||I.getIconURI("favorite");}};
R.getIconTag=function(i){if(I.isIconURI(i)){return"span";}return"img";};
return R;},true);
sap.ui.predefine('sap/m/ResponsivePopover',['./Dialog','./Popover','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/base/ManagedObject','sap/ui/Device','./ResponsivePopoverRenderer','./Toolbar','./ToolbarSpacer','./Button',"sap/ui/thirdparty/jquery"],function(D,P,l,T,C,I,M,a,R,b,c,B,q){"use strict";var d=l.DialogType;var e=l.PlacementType;var f=l.TitleAlignment;
var g=C.extend("sap.m.ResponsivePopover",{metadata:{library:"sap.m",properties:{placement:{type:"sap.m.PlacementType",group:"Misc",defaultValue:e.Right},showHeader:{type:"boolean",group:"Misc",defaultValue:true},title:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},modal:{type:"boolean",group:"Misc",defaultValue:null},offsetX:{type:"int",group:"Misc",defaultValue:null},offsetY:{type:"int",group:"Misc",defaultValue:null},showArrow:{type:"boolean",group:"Appearance",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},contentHeight:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},horizontalScrolling:{type:"boolean",group:"Misc",defaultValue:true},verticalScrolling:{type:"boolean",group:"Misc",defaultValue:true},showCloseButton:{type:"boolean",group:"Misc",defaultValue:true},resizable:{type:"boolean",group:"Dimension",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:f.Auto}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},customHeader:{type:"sap.m.IBar",multiple:false},subHeader:{type:"sap.m.IBar",multiple:false},beginButton:{type:"sap.m.Button",multiple:false},endButton:{type:"sap.m.Button",multiple:false},_popup:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{initialFocus:{type:"sap.ui.core.Control",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{beforeOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},afterOpen:{parameters:{openBy:{type:"sap.ui.core.Control"}}},beforeClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}},afterClose:{parameters:{openBy:{type:"sap.ui.core.Control"},origin:{type:"sap.m.Button"}}}}}});
g.prototype.init=function(){var t=this;this._bAppendedToUIArea=false;var s={resizable:t.getResizable(),titleAlignment:t.getTitleAlignment(),beforeOpen:function(E){t.fireBeforeOpen({openBy:E.getParameter('openBy')});},afterOpen:function(E){t.fireAfterOpen({openBy:E.getParameter('openBy')});},beforeClose:function(E){t.fireBeforeClose({openBy:E.getParameter('openBy'),origin:E.getParameter('origin')});},afterClose:function(E){t.fireAfterClose({openBy:E.getParameter('openBy'),origin:E.getParameter('origin')});}};if(a.system.phone){this._aNotSupportedProperties=["placement","modal","offsetX","offsetY","showCloseButton"];s.stretch=true;s.type=d.Standard;this._oControl=new D(this.getId()+"-dialog",s);}else{this._aNotSupportedProperties=["icon","showCloseButton"];this._oControl=new P(this.getId()+"-popover",s);}this.setAggregation("_popup",this._oControl);this._oControl.addStyleClass("sapMResponsivePopover");this._oDelegate={onBeforeRendering:function(){var S=this.getShowCloseButton(),h=this._oControl._getAnyHeader(),n,p,r;if(!S||!a.system.phone){this._removeCloseButton(h);return;}if(!this._bContentChanged){return;}this._bContentChanged=false;if(h){this._insertCloseButton(h);}else{n=this._getSingleNavContent();if(!n){return;}p=n.getCurrentPage();r=this._getRealPage(p);if(r&&(h=r._getAnyHeader())){this._insertCloseButton(h);}n.attachEvent("navigate",this._fnOnNavigate,this);}}};this._oPageDelegate={onAfterShow:function(){var r=t._getRealPage(this),h;if(r&&(h=r._getAnyHeader())){t._insertCloseButton(h);}}};this._fnOnNavigate=function(E){var p=E.getParameter("to");if(p){p.addEventDelegate(this._oPageDelegate,p);}};this._oControl.addEventDelegate(this._oDelegate,this);this._oControl._removeChild=function(o,A,S){var p,i;if((A==="content")&&(o instanceof sap.m.NavContainer)){p=o.getPages();for(i=0;i<p.length;i++){p[i].removeEventDelegate(t._oPageDelegate);}o.detachEvent("navigate",t._fnOnNavigate,t);}C.prototype._removeChild.apply(this,arguments);};};
g.prototype.openBy=function(p){if(!this._bAppendedToUIArea&&!this.getParent()){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.addContent(this,true);this._bAppendedToUIArea=true;}if(a.system.phone){return this._oControl.open();}else{return this._oControl.openBy(p);}};
g.prototype.exit=function(){if(this._oCloseButton){this._oCloseButton.destroy();this._oCloseButton=null;}if(this._oControl){this._oControl.removeEventDelegate(this._oDelegate);this._oControl.destroy();this._oControl=null;}};
g.prototype._getCloseButton=function(){if(!this._oCloseButton){var t=this;this._oCloseButton=new B(this.getId()+"-closeButton",{icon:I.getIconURI("decline"),press:function(){t._oControl._oCloseTrigger=this;t.close();}});}return this._oCloseButton;};
g.prototype.addContent=function(o){this._bContentChanged=true;this.addAggregation("content",o);return this;};
g.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments),h=this.getAggregation('_popup').getContent();for(var i=0;i<h.length;i++){o.addContent(h[i].clone());}return o;};
g.prototype._getSingleNavContent=function(){var h=this.getContent();while(h.length===1&&h[0]instanceof sap.ui.core.mvc.View){h=h[0].getContent();}if(h.length===1&&h[0]instanceof sap.m.NavContainer){return h[0];}else{return null;}};
g.prototype._getRealPage=function(p){var r=p,h;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.ui.core.mvc.View){h=r.getContent();if(h.length===1){r=h[0];continue;}}r=null;}return r;};
g.prototype._insertCloseButton=function(h){var o=this._getCloseButton(),i;if(h&&h.addContentRight){i=h.getAggregation("contentRight",[]).length;h.insertAggregation("contentRight",o,i);}};
g.prototype._removeCloseButton=function(h){var o=this._getCloseButton();if(h){h.removeAggregation("contentRight",o);}};
g.prototype._firstLetterUpperCase=function(v){return v.charAt(0).toUpperCase()+v.slice(1);};
g.prototype._lastIndexOfUpperCaseLetter=function(v){var i,s;for(i=v.length-1;i>=0;i--){s=v.charAt(i);if(s===s.toUpperCase()){return i;}}return-1;};
g.prototype._oldSetProperty=g.prototype.setProperty;
g.prototype.setProperty=function(p,v,s){this._oldSetProperty(p,v,true);var S="set"+this._firstLetterUpperCase(p);if(this._aNotSupportedProperties.indexOf(p)===-1&&S in this._oControl){this._oControl[S](v);}return this;};
g.prototype._oldSetModel=g.prototype.setModel;
g.prototype.setModel=function(m,n){this._oControl.setModel(m,n);return this._oldSetModel(m,n);};
g.prototype._createButtonFooter=function(){if(this._oFooter){return this._oFooter;}this._oFooter=new b(this.getId()+"-footer",{content:[new c()]});return this._oFooter;};
g.prototype._getButtonFooter=function(){return a.system.phone?this._oControl._getToolbar():this._oControl.getFooter();};
g.prototype._getPopup=function(){return this._oControl.oPopup;};
g.prototype._setButton=function(p,o){if(this._oControl instanceof P){var G="get"+this._firstLetterUpperCase(p)+"Button",O=this[G](),F=this._createButtonFooter(),s="_o"+this._firstLetterUpperCase(p)+"Button",i=(p.toLowerCase()==="begin"?0:1),h=(p.toLowerCase()==="begin"?"getEndButton":"getBeginButton");if(O){F.removeContent(O);}if(o){if(!F.getParent()){this._oControl.setFooter(F);}F.insertContent(o,i+1);}else{var j=this[h]();if(!j){F.destroy();this._oFooter=null;}}this[s]=o;return this;}else{var A=p.toLowerCase()+"Button";return this.setAggregation(A,o);}};
g.prototype._getButton=function(p){if(this._oControl instanceof P){var s="_o"+this._firstLetterUpperCase(p)+"Button";return this[s];}else{var G="get"+this._firstLetterUpperCase(p)+"Button";return this._oControl[G]();}};
g.prototype.setBeginButton=function(o){this._oControl.setBeginButton(o);return this._setButton("begin",o);};
g.prototype.setEndButton=function(o){this._oControl.setEndButton(o);return this._setButton("end",o);};
g.prototype.setShowCloseButton=function(s){var h=this._oControl._getAnyHeader();if(s){this._insertCloseButton(h);}else{this._removeCloseButton(h);}this.setProperty("showCloseButton",s,true);return this;};
g.prototype.getBeginButton=function(){return this._getButton("begin");};
g.prototype.getEndButton=function(){return this._getButton("end");};
["bindAggregation","validateAggregation","setAggregation","getAggregation","indexOfAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation","setAssociation","getAssociation","addAssociation","removeAssociation","removeAllAssociation"].forEach(function(n){g.prototype[n]=function(){var L=this._lastIndexOfUpperCaseLetter(n),m,r;if(typeof arguments[0]==="string"){if(L!==-1){m=n.substring(0,L)+this._firstLetterUpperCase(arguments[0]);if(this._oControl&&this._oControl[m]){r=this._oControl[m].apply(this._oControl,Array.prototype.slice.call(arguments,1));return r===this._oControl?this:r;}else{return C.prototype[n].apply(this,arguments);}}}r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;};});["invalidate","close","isOpen","addStyleClass","removeStyleClass","toggleStyleClass","hasStyleClass","getDomRef","setBusy","getBusy","setBusyIndicatorDelay","getBusyIndicatorDelay","addEventDelegate","_setAriaModal","_setAriaRoleApplication"].forEach(function(n){g.prototype[n]=function(){if(this._oControl&&this._oControl[n]){if(n==="invalidate"&&arguments[0]===this._oControl){return C.prototype.invalidate.apply(this,arguments);}var r=this._oControl[n].apply(this._oControl,arguments);return r===this._oControl?this:r;}};});
g.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
return g;});
sap.ui.predefine('sap/m/ResponsivePopoverRenderer',[],function(){"use strict";var R={apiVersion:2};
R.render=function(r,c){};
return R;},true);
sap.ui.predefine('sap/m/ResponsiveScale',['./library','./SliderUtilities','sap/ui/core/Element'],function(l,S,E){"use strict";
var a=E.extend("sap.m.ResponsiveScale",{metadata:{interfaces:["sap.m.IScale"],library:"sap.m",properties:{tickmarksBetweenLabels:{type:"int",group:"Appearance",defaultValue:0}}}});
a.prototype.calcNumberOfTickmarks=function(s,f,t){var m=Math.floor(s/f)+1;m=t&&(m>t)?this._runStepsOptimization(t,m-1):m;return Math.floor(m);};
a.prototype._runStepsOptimization=function(t,m){var s=m/t;while((t>1)&&(s%1!==0)){t--;s=m/t;}return t;};
a.prototype.getHiddenTickmarksLabels=function(s,t,o,L){var j,c,h=new Array(t),i=Math.ceil(1/(o/L)),C=function(p){return p<<1;};if(i===1){return h;}i--;i|=i>>1;i|=i>>2;i|=i>>4;i|=i>>8;i|=i>>16;i++;i=i>>1;j=C(i);while(i){c=i;while(c<((t/2)+j)){h[c]=true;h[t-c-1]=true;c+=j;}i=i>>1;j=C(i);}return h;};
a.prototype.handleResize=function(e){var L,o,O,h,s,$=e.control.$(),t=$.find(".sapMSliderTick"),i=$.find(".sapMSliderTickmarks").width(),b=(i/t.length)>=S.CONSTANTS.TICKMARKS.MIN_SIZE.SMALL;t.css("visibility",b?'':'hidden');L=$.find(".sapMSliderTickLabel");o=parseFloat(L[1].style.left);O=i*o/100;h=this.getHiddenTickmarksLabels(i,L.length,O,S.CONSTANTS.TICKMARKS.MIN_SIZE.WITH_LABEL);L.each(function(I,c){s=c.nextSibling||c.previousSibling||{style:{visibility:null}};if(h[I]&&!b){c.style.display="none";s.style.visibility='hidden';}else{c.style.display="";s.style.visibility='';}});};
return a;});
sap.ui.predefine('sap/m/ScrollBar',['sap/ui/core/Control',"./ScrollBarRenderer"],function(C,S){"use strict";
var a=C.extend("sap.m.ScrollBar",{metadata:{library:"sap.m",properties:{scrollPosition:{type:"int",group:"Behavior",defaultValue:0},contentSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{scroll:{}}}});
a.prototype.init=function(){this._onScrollHandler=this._onscroll.bind(this);};
a.prototype.onBeforeRendering=function(){if(this._$ScrollRef&&this._$ScrollRef.length){this._$ScrollRef.off("scroll",this._onScrollHandler);this._$ScrollRef=null;}};
a.prototype.onAfterRendering=function(){this._$ScrollRef=this.$("sb");this._$ScrollRef.on("scroll",this._onScrollHandler);this._setScrollPosition(this.getScrollPosition());};
a.prototype.onThemeChanged=function(){this.invalidate();};
a.prototype.setScrollPosition=function(s){var p=Math.round(Math.max(s,0));this._setScrollPosition(p);return this.setProperty("scrollPosition",p,true);};
a.prototype.setContentSize=function(c){var s=this.$("sbcnt");if(s.length){s.height(c);}return this.setProperty("contentSize",c);};
a.prototype._onscroll=function(e){var s=Math.abs(Math.round(this._$ScrollRef.scrollTop()));this.setProperty("scrollPosition",s,true);this.fireScroll({pos:s});e.preventDefault();e.stopPropagation();return false;};
a.prototype._setScrollPosition=function(s){if(this._$ScrollRef&&this._$ScrollRef.length){this._$ScrollRef.scrollTop(s);}};
return a;});
sap.ui.predefine('sap/m/ScrollBarRenderer',['sap/ui/Device',"sap/ui/dom/getScrollbarSize"],function(D,g){"use strict";var S={apiVersion:2};
S.render=function(r,c){var s="sapMScrollBarTouch",C=c.getContentSize(),a=c.getId(),d=D.support.touch;r.openStart("div",c);r.class("sapMScrollBarOuterDiv");if(d){r.class(s);}r.openEnd();r.openStart("div",a+"-sb");r.class("sapMScrollBarInnerDiv");r.openEnd();r.openStart("div",a+"-sbcnt");r.style("width","0.75rem");r.style("height",C);r.openEnd();r.close("div");r.close("div");r.openStart("div");r.openEnd();r.openStart("span",a+"-ffsize");r.class("sapMScrollBarDistantSpan");r.openEnd();r.close("span");r.close("div");r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/ScrollContainer',["./library","sap/ui/core/Control","sap/ui/core/delegate/ScrollEnablement","sap/ui/core/Element","./ScrollContainerRenderer","sap/ui/dom/denormalizeScrollBeginRTL"],function(l,C,S,E,a,d){"use strict";
var b=C.extend("sap.m.ScrollContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},horizontal:{type:"boolean",group:"Behavior",defaultValue:true},vertical:{type:"boolean",group:"Behavior",defaultValue:false},focusable:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/ScrollContainer.designtime"}});
b.prototype.init=function(){this._oScroller=new S(this,this.getId()+"-scroll",{horizontal:true,vertical:false});};
b.prototype.onBeforeRendering=function(){this._oScroller.setHorizontal(this.getHorizontal());this._oScroller.setVertical(this.getVertical());};
b.prototype.exit=function(){if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}};
b.prototype.getScrollDelegate=function(){return this._oScroller;};
b.prototype.scrollTo=function(x,y,t){if(this._oScroller){var D=this.getDomRef();if(D){if(sap.ui.getCore().getConfiguration().getRTL()){x=d(x,D);}this._oScroller.scrollTo(x,y,t);}else{this._oScroller._scrollX=x;this._oScroller._scrollY=y;}}return this;};
b.prototype.scrollToElement=function(e,t){if(e instanceof E){e=e.getDomRef();}if(this._oScroller){this._oScroller.scrollToElement(e,t);}return this;};
return b;});
sap.ui.predefine('sap/m/ScrollContainerRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){r.openStart("div",c).style("width",c.getWidth()).style("height",c.getHeight());if(c.getVertical()){if(!c.getHorizontal()){r.class("sapMScrollContV");}else{r.class("sapMScrollContVH");}}else{r.class("sapMScrollContH");}r.class("sapMScrollCont");var t=c.getTooltip_AsString();if(t){r.attr("title",t);}if(c.getFocusable()){r.attr("tabindex","0");}r.openEnd();r.openStart("div",c.getId()+"-scroll").class("sapMScrollContScroll").openEnd();var C=c.getContent(),l=C.length;for(var i=0;i<l;i++){r.renderControl(C[i]);}r.close("div");r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SearchField',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./Suggest','sap/ui/Device','./SearchFieldRenderer',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/cursorPos"],function(l,C,E,I,S,D,a,K,q){"use strict";var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");a.oSearchFieldToolTips={SEARCH_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_SEARCH_BUTTON_TOOLTIP"),RESET_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_RESET_BUTTON_TOOLTIP"),REFRESH_BUTTON_TOOLTIP:r.getText("SEARCHFIELD_REFRESH_BUTTON_TOOLTIP")};
var b=C.extend("sap.m.SearchField",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.f.IShellBar"],library:"sap.m",properties:{value:{type:"string",group:"Data",defaultValue:null,bindable:"bindable"},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},visible:{type:"boolean",group:"Appearance",defaultValue:true},maxLength:{type:"int",group:"Behavior",defaultValue:0},placeholder:{type:"string",group:"Misc",defaultValue:null},showMagnifier:{type:"boolean",group:"Misc",defaultValue:true,deprecated:true},showRefreshButton:{type:"boolean",group:"Behavior",defaultValue:false},refreshButtonTooltip:{type:"string",group:"Misc",defaultValue:null},showSearchButton:{type:"boolean",group:"Behavior",defaultValue:true},enableSuggestions:{type:"boolean",group:"Behavior",defaultValue:false},selectOnFocus:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},defaultAggregation:"suggestionItems",designtime:"sap/m/designtime/SearchField.designtime",aggregations:{suggestionItems:{type:"sap.m.SuggestionItem",multiple:true,singularName:"suggestionItem"}},events:{search:{parameters:{query:{type:"string"},suggestionItem:{type:"sap.m.SuggestionItem"},refreshButtonPressed:{type:"boolean"},clearButtonPressed:{type:"boolean"}}},change:{parameters:{value:{type:"string"}}},liveChange:{parameters:{newValue:{type:"string"}}},suggest:{parameters:{suggestValue:{type:"string"}}}}}});
E.call(b.prototype);I.insertFontFaceStyle();
b.prototype.init=function(){this._lastValue="";this.setProperty("placeholder",r.getText("FACETFILTER_SEARCH"),true);};
b.prototype.getFocusDomRef=function(){return this.getInputElement();};
b.prototype.getFocusInfo=function(){var f=C.prototype.getFocusInfo.call(this),i=this.getDomRef("I");if(i){q.extend(f,{cursorPos:q(i).cursorPos()});}return f;};
b.prototype.applyFocusInfo=function(f){C.prototype.applyFocusInfo.call(this,f);if("cursorPos"in f){this.$("I").cursorPos(f.cursorPos);}return this;};
b.prototype.getWidth=function(){return this.getProperty("width")||"100%";};
b.prototype._hasPlaceholder=(function(){return"placeholder"in document.createElement("input");}());
b.prototype.getInputElement=function(){return this.getDomRef("I");};
b.prototype.onBeforeRendering=function(){this._unregisterEventListeners();};
b.prototype.onAfterRendering=function(){this._lastValue=this.getValue();this._setToolTips();var i=this.getInputElement();this._resetElement=this.getDomRef("reset");q(i).on("input",this.onInput.bind(this)).on("search",this.onSearch.bind(this)).on("change",this.onChange.bind(this)).on("focus",this.onFocus.bind(this)).on("blur",this.onBlur.bind(this));q(this.getDomRef("F")).on("click",this.onFormClick.bind(this));if(D.system.desktop||D.system.combi){this.$().on("touchstart mousedown",this.onButtonPress.bind(this));if(D.browser.firefox){this.$().find(".sapMSFB").on("mouseup mouseout",function(g){q(g.target).removeClass("sapMSFBA");});}}else if(window.PointerEvent){q(this._resetElement).on("touchstart",function(){this._active=document.activeElement;}.bind(this));}var f=sap.ui.getCore();if(!f.isThemeApplied()){f.attachThemeChanged(this._handleThemeLoad,this);}};
b.prototype._handleThemeLoad=function(){if(this._oSuggest){this._oSuggest.setPopoverMinWidth();}var f=sap.ui.getCore();f.detachThemeChanged(this._handleThemeLoad,this);};
b.prototype.clear=function(O){var v=O&&O.value||"";if(!this.getInputElement()||this.getValue()===v){return;}this._updateValue(v);u(this);this.fireLiveChange({newValue:v});this._fireChangeEvent();this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:!!(O&&O.clearButton)});};
b.prototype.exit=function(){this._unregisterEventListeners();if(this._oSuggest){this._oSuggest.destroy(true);this._oSuggest=null;}};
b.prototype.onButtonPress=function(f){if(f.originalEvent.button===2){return;}var i=this.getInputElement();if(document.activeElement===i&&f.target!==i){f.preventDefault();}if(D.browser.firefox){var g=q(f.target);if(g.hasClass("sapMSFB")){g.addClass("sapMSFBA");}}};
b.prototype.ontouchstart=function(f){this._oTouchStartTarget=f.target;};
b.prototype.ontouchend=function(f){if(f.originalEvent.button===2){return;}var g=f.target,v=true,i=this.getInputElement();if(this._oTouchStartTarget){v=this._oTouchStartTarget===g;this._oTouchStartTarget=null;}if(g.id==this.getId()+"-reset"&&v){c(this);this._bSuggestionSuppressed=true;var h=!this.getValue();var j=document.activeElement;if(((D.system.desktop||h||/(INPUT|TEXTAREA)/i.test(j.tagName)||j===this._resetElement&&this._active===i))&&(j!==i)){i.focus();}this.clear({clearButton:true});}else if(g.id==this.getId()+"-search"&&v){c(this);if(D.system.desktop&&!this.getShowRefreshButton()&&(document.activeElement!==i)){i.focus();}this._fireChangeEvent();this.fireSearch({query:this.getValue(),refreshButtonPressed:!!(this.getShowRefreshButton()&&!this.$().hasClass("sapMFocus")),clearButtonPressed:false});}else{this.onmouseup(f);}};
b.prototype.onmouseup=function(f){if(D.system.phone&&this.getEnabled()&&f.target.tagName=="INPUT"&&document.activeElement===f.target&&!d(this)){this.onFocus(f);}};
b.prototype.onFormClick=function(f){if(this.getEnabled()&&f.target.tagName=="FORM"){this.getInputElement().focus();}};
b.prototype.onSearch=function(f){var v=this.getInputElement().value;this._updateValue(v);this._fireChangeEvent();this.fireSearch({query:v,refreshButtonPressed:false,clearButtonPressed:false});if(!D.system.desktop){this._blur();}};
b.prototype._blur=function(){var t=this;window.setTimeout(function(){var i=t.getInputElement();if(i){i.blur();}},13);};
b.prototype.onChange=function(f){this._fireChangeEvent();};
b.prototype._fireChangeEvent=function(){var v=this.getInputElement().value;if(this._lastValue===v){return;}this._lastValue=v;this.fireChange({value:v});};
b.prototype.onInput=function(f){var v=this.getInputElement().value;if(v!=this.getValue()){this._updateValue(v);this.fireLiveChange({newValue:v});if(this.getEnableSuggestions()){if(this._iSuggestDelay){clearTimeout(this._iSuggestDelay);}this._iSuggestDelay=setTimeout(function(){this.fireSuggest({suggestValue:v});u(this);this._iSuggestDelay=null;}.bind(this),400);}}};
b.prototype.onkeydown=function(f){var g;var h;var v;switch(f.which){case K.F5:case K.ENTER:this.$("search").toggleClass("sapMSFBA",true);f.stopPropagation();f.preventDefault();if(d(this)){c(this);if((g=this._oSuggest.getSelected())>=0){h=this.getSuggestionItems()[g];this._updateValue(h.getSuggestionText());}}this._fireChangeEvent();this.fireSearch({query:this.getValue(),suggestionItem:h,refreshButtonPressed:this.getShowRefreshButton()&&f.which===K.F5,clearButtonPressed:false});break;case K.ESCAPE:if(d(this)){c(this);f.setMarked();}else{v=this.getValue();if(v===this._sOriginalValue){this._sOriginalValue="";}this.clear({value:this._sOriginalValue});if(v!==this.getValue()){f.setMarked();}}f.preventDefault();break;}};
b.prototype.onkeyup=function(f){if(f.which===K.F5||f.which===K.ENTER){this.$("search").toggleClass("sapMSFBA",false);}};
b.prototype.onFocus=function(f){if(D.browser.internet_explorer&&!document.hasFocus()){return;}this.$().toggleClass("sapMFocus",true);this._sOriginalValue=this.getValue();if(this.getEnableSuggestions()){if(!this._bSuggestionSuppressed){this.fireSuggest({suggestValue:this.getValue()});}else{this._bSuggestionSuppressed=false;}}this._setToolTips(f.type);};
b.prototype.onBlur=function(f){this.$().toggleClass("sapMFocus",false);if(this._bSuggestionSuppressed){this._bSuggestionSuppressed=false;}this._setToolTips(f.type);};
b.prototype._setToolTips=function(t){var $=this.$("search"),f=this.$("reset");if(this.getShowRefreshButton()){if(t==="focus"){$.attr("title",a.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP);}else if(t==="blur"){var R=this.getRefreshButtonTooltip(),T=R===""?a.oSearchFieldToolTips.REFRESH_BUTTON_TOOLTIP:R;if(T){$.attr("title",T);}}}if(this.getValue()===""){f.attr("title",a.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP);}else{f.attr("title",a.oSearchFieldToolTips.RESET_BUTTON_TOOLTIP);}};
b.prototype._updateValue=function(v){v=v||"";var i=this.getInputElement();if(i){if(i.value!==v){i.value=v;}var $=this.$();if($.hasClass("sapMSFVal")==!v){$.toggleClass("sapMSFVal",!!v);}}this.setProperty("value",v,true);this._setToolTips();return this;};
b.prototype._unregisterEventListeners=function(){var i=this.getInputElement();if(i){this.$().find(".sapMSFB").off();this.$().off();q(this.getDomRef("F")).off();q(i).off();}};
b.prototype.onsapshow=function(f){if(this.getEnableSuggestions()){if(d(this)){c(this);}else{this.fireSuggest({suggestValue:this.getValue()});}}};
b.prototype.onsaphide=function(f){this.suggest(false);};
function s(f,g,i,R){var h;if(d(f)){h=f._oSuggest.setSelected(i,R);if(h>=0){f._updateValue(f.getSuggestionItems()[h].getSuggestionText());}g.preventDefault();}}
b.prototype.onsapdown=function(f){s(this,f,1,true);};
b.prototype.onsapup=function(f){s(this,f,-1,true);};
b.prototype.onsaphome=function(f){s(this,f,0,false);};
b.prototype.onsapend=function(f){var L=this.getSuggestionItems().length-1;s(this,f,L,false);};
b.prototype.onsappagedown=function(f){s(this,f,10,true);};
b.prototype.onsappageup=function(f){s(this,f,-10,true);};
b.prototype._applySuggestionAcc=function(){var A="",n=this.getSuggestionItems().length;if(n===1){A=r.getText("INPUT_SUGGESTIONS_ONE_HIT");}else if(n>1){A=r.getText("INPUT_SUGGESTIONS_MORE_HITS",n);}else{A=r.getText("INPUT_SUGGESTIONS_NO_HIT");}this.$("SuggDescr").text(A);};
b.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("F");};
function c(f){f._oSuggest&&f._oSuggest.close();}
function o(f){if(f.getEnableSuggestions()){if(!f._oSuggest){f._oSuggest=new S(f);}f._oSuggest.open();}}
function d(f){return f._oSuggest&&f._oSuggest.isOpen();}
b.prototype.suggest=function(f){if(this.getEnableSuggestions()){f=f===undefined||!!f;if(f&&(this.getSuggestionItems().length||D.system.phone)){o(this);}else{c(this);}}return this;};
function u(f){f._oSuggest&&f._oSuggest.update();}
var e="suggestionItems";
b.prototype.insertSuggestionItem=function(O,i,f){u(this);return C.prototype.insertAggregation.call(this,e,O,i,true);};
b.prototype.addSuggestionItem=function(O,f){u(this);return C.prototype.addAggregation.call(this,e,O,true);};
b.prototype.removeSuggestionItem=function(O,f){u(this);return C.prototype.removeAggregation.call(this,e,O,true);};
b.prototype.removeAllSuggestionItems=function(f){u(this);return C.prototype.removeAllAggregation.call(this,e,true);};
return b;});
sap.ui.predefine('sap/m/SearchFieldRenderer',["sap/ui/Device","sap/ui/core/InvisibleText"],function(D,I){"use strict";var S={apiVersion:2};
S.render=function(r,s){if(!s.getVisible()){return;}var p=s.getPlaceholder(),v=s.getValue(),w=s.getProperty("width"),i=s.getId(),b=s.getShowRefreshButton(),a=s.getShowSearchButton(),A={},t,R=s.getRefreshButtonTooltip(),c;r.openStart("div",s).class("sapMSF");if(w){r.style("width",w);}if(v){r.class("sapMSFVal");}if(!s.getEnabled()){r.class("sapMSFDisabled");}r.openEnd();r.openStart('form',i+"-F").class('sapMSFF');if(!a){r.class("sapMSFNS");}else if(b){r.class('sapMSFReload');}r.openEnd();if(!s._hasPlaceholder&&p){r.openStart("label",i+"-P").class("sapMSFPlaceholder").attr("for",i+"-I").openEnd().text(p).close("label");}r.voidStart('input',s.getId()+"-I").class("sapMSFI").attr("type","search").attr("autocomplete","off");if(D.browser.safari){r.attr("autocorrect","off");}var T=s.getTooltip_AsString();if(T){r.attr("title",T);}if(D.os.android&&D.os.version>=4&&D.os.version<4.1){r.class("sapMSFIA4");}if(s.getEnableSuggestions()&&D.system.phone){r.attr("readonly","readonly");}if(!s.getEnabled()){r.attr("disabled","disabled");}if(p){r.attr("placeholder",p);}if(s.getMaxLength()){r.attr("maxLength",s.getMaxLength());}r.attr("value",v);if(s.getEnabled()&&b){var d=I.getStaticId("sap.m","SEARCHFIELD_ARIA_F5");if(d){A.describedby={value:d,append:true};}}A.disabled=null;r.accessibilityState(s,A);r.voidEnd();if(s.getEnabled()){r.openStart("div",s.getId()+"-reset").class("sapMSFR").class("sapMSFB").attr("aria-hidden",true);c=v===""?this.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP:this.oSearchFieldToolTips.RESET_BUTTON_TOOLTIP;r.attr("title",c);if(D.browser.firefox){r.class("sapMSFBF");}if(!a){r.class("sapMSFNS");}r.openEnd().close("div");if(a){r.openStart("div",s.getId()+"-search").class("sapMSFS").class("sapMSFB").attr("aria-hidden",true);if(D.browser.firefox){r.class("sapMSFBF");}if(b){t=R===""?this.oSearchFieldToolTips.REFRESH_BUTTON_TOOLTIP:R;}else{t=this.oSearchFieldToolTips.SEARCH_BUTTON_TOOLTIP;}r.attr("title",t).openEnd().close("div");}}r.close("form");if(s.getEnableSuggestions()){r.openStart("span",s.getId()+"-SuggDescr").class("sapUiPseudoInvisibleText").attr("role","status").attr("aria-live","polite").openEnd().close("span");}r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SegmentedButton',['./library','./Button','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/delegate/ItemNavigation','sap/ui/core/ResizeHandler','sap/ui/core/ListItem','sap/ui/core/IconPool','./SegmentedButtonRenderer'],function(l,B,C,E,I,R,L,a,S){"use strict";
var c=C.extend("sap.m.SegmentedButton",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent"],library:"sap.m",designtime:"sap/m/designtime/SegmentedButton.designtime",publicMethods:["createButton"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:"",bindable:"bindable"}},defaultAggregation:"buttons",aggregations:{buttons:{type:"sap.m.Button",multiple:true,singularName:"button"},items:{type:"sap.m.SegmentedButtonItem",multiple:true,singularName:"item",bindable:"bindable"},_select:{type:"sap.m.Select",multiple:false,visibility:"hidden"}},associations:{selectedButton:{deprecated:true,type:"sap.m.Button",multiple:false},selectedItem:{type:"sap.m.SegmentedButtonItem",multiple:false},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{select:{deprecated:true,parameters:{button:{type:"sap.m.Button"},id:{type:"string"},key:{type:"string"}}},selectionChange:{parameters:{item:{type:"sap.m.SegmentedButtonItem"}}}},dnd:{draggable:true,droppable:false}}});
E.call(c.prototype);
c.prototype.init=function(){this._aWidths=[];this._oItemNavigation=new I();this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this.addDelegate(this._oItemNavigation);this.removeButton=function(b){var r=c.prototype.removeButton.call(this,b);this.setSelectedButton(this.getButtons()[0]);this._fireChangeEvent();return r;};};
c.prototype.onBeforeRendering=function(){var b=this._getVisibleButtons();this._bCustomButtonWidth=b.some(function(o){return o.getWidth();});if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this.setSelectedKey(this.getProperty("selectedKey"));if(!this.getSelectedButton()){this._selectDefaultButton();}};
c.prototype.onAfterRendering=function(){var b=this._getVisibleButtons(),p;if(!this._sResizeListenerId){p=this.getDomRef().parentNode;if(p){this._sResizeListenerId=R.register(p,this._handleContainerResize.bind(this));}}this._setItemNavigation();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
c.prototype._handleContainerResize=function(){var b=this._getVisibleButtons();this._clearAutoWidthAppliedToControl();this._aWidths=this._getRenderedButtonWidths(b);this._updateWidth();};
c.prototype._clearAutoWidthAppliedToControl=function(){var b=this._getVisibleButtons(),d=b.length,o,i=0;if(!this.getWidth()){this.$().css("width","");}while(i<d){o=b[i];if(!o.getWidth()){o.$().css("width","");}i++;}};
c.prototype._getRenderedButtonWidths=function(b){return b.map(function(o){var d=o.getDomRef();return d&&d.getBoundingClientRect?d.getBoundingClientRect().width:o.$().outerWidth();});};
c.prototype._getButtonWidth=function(b){var d=b.length,w,n=0,s=0,e=0,p,P,i=0;if(this._bCustomButtonWidth){while(i<d){w=b[i].getWidth();if(w){if(w.indexOf("%")!==-1){s+=parseInt(w.slice(0,-1));}else{e+=parseInt(w.slice(0,-2));}}else{n++;}i++;}if(n===0){return false;}p=(100-s)/n;P=(e/n);if(p<0){p=0;}if(P<0){P=0;}if(P>0){return"calc("+p+"% - "+P+"px)";}else{return p+"%";}}else{return(100/d)+"%";}};
c.prototype._updateWidth=function(){if(this.$().length===0||this.hasStyleClass("sapMSegmentedButtonNoAutoWidth")){return;}var s=this.getWidth(),b=this._getVisibleButtons(),d=b.length,m=(this._aWidths.length>0)?Math.max.apply(Math,this._aWidths):0,e=(100/d),p=this.$().parent().innerWidth(),w=this._getButtonWidth(b),f,o,i;if(!s){if((m*d)>p){this.addStyleClass("sapMSegBFit");}else if(m>0){this.$().width((m*d)+1);this.removeStyleClass("sapMSegBFit");}i=0;while(i<d){o=b[i];o.$().css("width",o.getWidth()?o.getWidth():w);i++;}}else if(s&&!this._bCustomButtonWidth){i=0;while(i<d){b[i].$().css("width",e+"%");i++;}}f=this.$().width();if(this._previousWidth!==undefined&&f!==this._previousWidth&&!this._bInOverflow){this.fireEvent("_containerWidthChanged");}this._previousWidth=f;};
c.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}this._bCustomButtonWidth=null;this._aWidths=null;};
c.prototype._setItemNavigation=function(){var b,d=this.getDomRef();if(d){this._oItemNavigation.setRootDomRef(d);b=this.$().find(".sapMSegBBtn:not(.sapMSegBBtnDis)");this._oItemNavigation.setItemDomRefs(b);this._focusSelectedButton();}};
c.prototype.getOverflowToolbarConfig=function(){return{canOverflow:true,listenForEvents:["select"],autoCloseEvents:["select"],propsUnrelatedToSize:["enabled","selectedKey"],invalidationEvents:["_containerWidthChanged"],onBeforeEnterOverflow:this._onBeforeEnterOverflow,onAfterExitOverflow:this._onAfterExitOverflow};};
c.prototype._onBeforeEnterOverflow=function(o){o._toSelectMode();};
c.prototype._onAfterExitOverflow=function(o){if(o._bForcedSelectMode){o._toSelectMode();}else{o._toNormalMode();}};
c.prototype.getFormDoNotAdjustWidth=function(){return true;};
c.prototype.createButton=function(t,u,e,T){var b=new B();if(t!==null){b.setText(t);}if(u!==null){b.setIcon(u);}if(e||e===undefined){b.setEnabled(true);}else{b.setEnabled(false);}if(T){b.setTextDirection(T);}this.addButton(b);return b;};
(function(){
c.prototype.addButton=function(b){if(b){p(b,this);this.addAggregation('buttons',b);this._syncSelect();this._fireChangeEvent();}return this;};
c.prototype.insertButton=function(b,i){if(b){p(b,this);this.insertAggregation('buttons',b,i);this._syncSelect();this._fireChangeEvent();}return this;};
function p(b,P){b.attachPress(function(e){P._buttonPressed(e);});b.attachEvent("_change",P._syncSelect,P);b.attachEvent("_change",P._fireChangeEvent,P);var o=B.prototype.setEnabled;b.setEnabled=function(e){b.$().toggleClass("sapMSegBBtnDis",!e).toggleClass("sapMFocusable",e);o.apply(b,arguments);};b.setVisible=function(v){B.prototype.setVisible.apply(this,arguments);P.invalidate();};}
})();
c.prototype.getSelectedKey=function(){var b=this.getButtons(),d=this.getItems(),s=this.getSelectedButton(),i=0;if(d.length>0){for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this.setProperty("selectedKey",d[i].getKey(),true);return d[i].getKey();}}}return"";};
c.prototype.setSelectedKey=function(k){var b=this.getButtons(),d=this.getItems(),i=0;if(!k){this.setProperty("selectedKey",k,true);return this;}if(d.length>0&&b.length>0){for(;i<d.length;i++){if(d[i]&&d[i].getKey()===k){this.setSelectedItem(d[i]);break;}}}this.setProperty("selectedKey",k,true);return this;};
c.prototype.removeButton=function(b){var r=this.removeAggregation("buttons",b);if(r){delete r.setEnabled;r.detachEvent("_change",this._syncSelect,this);r.detachEvent("_change",this._fireChangeEvent,this);this._syncSelect();}return r;};
c.prototype.removeAllButtons=function(){var b=this.getButtons();if(b){for(var i=0;i<b.length;i++){var o=b[i];if(o){delete o.setEnabled;this.removeAggregation("buttons",o);o.detachEvent("_change",this._syncSelect,this);o.detachEvent("_change",this._fireChangeEvent,this);}}this._syncSelect();}return b;};
c.prototype.addItem=function(i){this.addAggregation("items",i);this.addButton(i.oButton);return this;};
c.prototype.removeItem=function(i){var r;if(i!==null&&i!==undefined){r=this.removeAggregation("items",i);this.removeButton(i.oButton);}if(i&&i instanceof sap.m.SegmentedButtonItem&&this.getSelectedButton()===i.oButton.getId()){this.setSelectedKey("");this.setSelectedButton("");this.setSelectedItem("");}this.setSelectedItem(this.getItems()[0]);return r;};
c.prototype.insertItem=function(i,b){this.insertAggregation("items",i,b);this.insertButton(i.oButton,b);return this;};
c.prototype.removeAllItems=function(s){var r=this.removeAllAggregation("items",s);this.removeAllButtons();this.setSelectedKey("");this.setSelectedButton("");this.setSelectedItem("");return r;};
c.prototype._buttonPressed=function(e){var b=e.getSource(),i;if(this.getSelectedButton()!==b.getId()){this.getButtons().forEach(function(o){o.$().removeClass("sapMSegBBtnSel");o.$().attr("aria-checked",false);});i=this.getItems().filter(function(o){return o.oButton===b;})[0];b.$().addClass("sapMSegBBtnSel");b.$().attr("aria-checked",true);this.setAssociation('selectedButton',b,true);this.setProperty("selectedKey",this.getSelectedKey(),true);this.setAssociation('selectedItem',i,true);this.fireSelectionChange({item:i});this.fireSelect({button:b,id:b.getId(),key:this.getSelectedKey()});}};
c.prototype._selectDefaultButton=function(){var b=this._getVisibleButtons();if(b.length>0){this.setAssociation('selectedButton',b[0],true);if(this.getItems().length>0){this.setAssociation('selectedItem',this.getItems()[0],true);}}};
c.prototype.setSelectedButton=function(b){var s=this.getSelectedButton(),d=this.getButtons();this.setAssociation("selectedButton",b);if(s!==this.getSelectedButton()){if(!this.getSelectedButton()&&d.length>1){this._selectDefaultButton();}this._focusSelectedButton();}this._syncSelect();return this;};
c.prototype.setSelectedItem=function(i){var o=typeof i==="string"&&i!==""?sap.ui.getCore().byId(i):i,b=o instanceof sap.m.SegmentedButtonItem,v=b?o.oButton:i;this.setAssociation("selectedItem",i,true);this.setSelectedButton(v);return this;};
c.prototype._focusSelectedButton=function(){var b=this.getButtons(),s=this.getSelectedButton(),i=0;for(;i<b.length;i++){if(b[i]&&b[i].getId()===s){this._oItemNavigation&&this._oItemNavigation.setFocusedIndex(i);break;}}};
c.prototype.onsappagedown=function(e){this._oItemNavigation.onsapend(e);};
c.prototype.onsappageup=function(e){this._oItemNavigation.onsaphome(e);};
c.prototype.onsapspace=function(e){e.preventDefault();};
c.prototype._lazyLoadSelectForm=function(){var s=this.getAggregation("_select");if(!s){jQuery.sap.require("sap.m.Select");var b=sap.ui.require("sap/m/Select");s=new b(this.getId()+"-select");s.attachChange(this._selectChangeHandler,this);s.addStyleClass("sapMSegBSelectWrapper");this.setAggregation("_select",s,true);}};
c.prototype._selectChangeHandler=function(e){var s=e.getParameter("selectedItem"),n=parseInt(s.getKey()),b=this.getButtons()[n],d=b.getId();b.firePress();this.setSelectedButton(d);};
c.prototype._fireChangeEvent=function(){this.fireEvent("_change");};
c.prototype._syncSelect=function(){var k=0,s=0,b,d,o=this.getAggregation("_select");if(!o){return;}o.destroyItems();this._getVisibleButtons().forEach(function(e){b=e.getText();d=e.getIcon();o.addItem(new L({key:k.toString(),icon:d?d:"",text:b?b:e.getTooltip_AsString(),enabled:e.getEnabled()}));if(e.getId()===this.getSelectedButton()){s=k;}k++;},this);o.setSelectedKey(s.toString());};
c.prototype._toSelectMode=function(){this._bInOverflow=true;this.addStyleClass("sapMSegBSelectWrapper");this._lazyLoadSelectForm();this._syncSelect();this._syncAriaAssociations();};
c.prototype._toNormalMode=function(){delete this._bInOverflow;this.removeStyleClass("sapMSegBSelectWrapper");};
c.prototype._syncAriaAssociations=function(){var s=this.getAggregation("_select");this.getAriaLabelledBy().forEach(function(o){if(s.getAriaLabelledBy().indexOf(o)===-1){s.addAriaLabelledBy(o);}});this.getAriaDescribedBy().forEach(function(d){if(s.getAriaLabelledBy().indexOf(d)===-1){s.addAriaLabelledBy(d);}});};
c.prototype._overwriteImageOnload=function(i){var t=this;if(i.onload===sap.m.Image.prototype.onload){i.onload=function(){if(sap.m.Image.prototype.onload){sap.m.Image.prototype.onload.apply(this,arguments);}window.setTimeout(function(){t._updateWidth();},20);};}};
c.prototype._getIconAriaLabel=function(i){var o=a.getIconInfo(i.getSrc()),r="";if(o&&o.name){r=o.name;}return r;};
c.prototype._getVisibleButtons=function(){return this.getButtons().filter(function(b){return b.getVisible();});};
c.prototype.clone=function(){var s=this.getSelectedButton(),d=this.removeAllAggregation("buttons"),o=C.prototype.clone.apply(this,arguments),e=d.map(function(b){return b.getId();}).indexOf(s),i;if(e>-1){o.setSelectedButton(o.getButtons()[e]);}for(i=0;i<d.length;i++){this.addAggregation("buttons",d[i]);}return o;};
return c;});
sap.ui.predefine('sap/m/SegmentedButtonItem',['./library','sap/ui/core/Item','sap/m/Button','sap/ui/core/CustomStyleClassSupport'],function(l,I,B,C){"use strict";
var S=I.extend("sap.m.SegmentedButtonItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},visible:{type:"boolean",group:"Appearance",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},events:{press:{}}}});
C.apply(S.prototype);
S.prototype.init=function(){var b=new B(this.getId()+"-button");this.aCustomStyleClasses;this.mCustomStyleClassMap;b.aCustomStyleClasses=this.aCustomStyleClasses;b.mCustomStyleClassMap=this.mCustomStyleClassMap;b.getCustomData=this.getCustomData.bind(this);b.getLayoutData=this.getLayoutData.bind(this);b.firePress=function(){this.firePress();B.prototype.firePress.call(b);}.bind(this);this.getDomRef=b.getDomRef.bind(b);this.oButton=b;};
S.prototype.exit=function(){if(this.oButton){this.oButton.destroy();this.oButton=null;}};
S.prototype.setText=function(v){this.setProperty("text",v,true);if(this.oButton){this.oButton.setText(this.getText());}return this;};
S.prototype.setIcon=function(v){this.setProperty("icon",v,true);if(this.oButton){this.oButton.setIcon(this.getIcon());}return this;};
S.prototype.setEnabled=function(v){this.setProperty("enabled",v,true);if(this.oButton){this.oButton.setEnabled(this.getEnabled());}return this;};
S.prototype.setTextDirection=function(v){this.setProperty("textDirection",v,true);if(this.oButton){this.oButton.setTextDirection(this.getTextDirection());}return this;};
S.prototype.setVisible=function(v){this.setProperty("visible",v,true);if(this.oButton){this.oButton.setVisible(v);}return this;};
S.prototype.setWidth=function(v){this.setProperty("width",v,true);if(this.oButton){this.oButton.setWidth(this.getWidth());}return this;};
S.prototype.setTooltip=function(v){this.setAggregation("tooltip",v,true);if(this.oButton){this.oButton.setTooltip(v);}return this;};
return S;});
sap.ui.predefine('sap/m/SegmentedButtonRenderer',["sap/ui/core/library","sap/ui/core/InvisibleRenderer"],function(c,I){"use strict";var T=c.TextDirection;var S={apiVersion:2};
S.render=function(r,C){var b=C.getButtons(),v=b.filter(function(B){return B.getVisible();}),V=0,s=C.getSelectedButton(),B,t,a,d;if(C._bInOverflow){r.openStart("div",C);r.openEnd();r.renderControl(C.getAggregation("_select"));r.close("div");return;}r.openStart("ul",C);if(S._addAllIconsClass(b)){r.class("sapMSegBIcons");}r.class("sapMSegB");r.style('width',C.getWidth());t=C.getTooltip_AsString();if(t){r.attr("title",t);}r.accessibilityState(C,{role:"radiogroup"});r.openEnd();for(var i=0;i<b.length;i++){B=b[i];if(B.getVisible()){var e=B.getText(),o=B.getIcon(),f="",g;++V;if(o){g=B._getImage((B.getId()+"-img"),o);if(g instanceof sap.m.Image){C._overwriteImageOnload(g);}else if(!B.getTooltip()){f=C._getIconAriaLabel(g);}}r.openStart("li",B);r.attr("aria-posinset",V);r.attr("aria-setsize",v.length);r.class("sapMSegBBtn");if(B.getId()===v[v.length-1].getId()){r.class("sapMSegBtnLastVisibleButton");}if(B.aCustomStyleClasses!==undefined&&B.aCustomStyleClasses instanceof Array){for(var j=0;j<B.aCustomStyleClasses.length;j++){r.class(B.aCustomStyleClasses[j]);}}if(B.getEnabled()){r.class("sapMSegBBtnFocusable");}else{r.class("sapMSegBBtnDis");}if(s===B.getId()){r.class("sapMSegBBtnSel");}if(o&&e!==''){r.class("sapMSegBBtnMixed");}a=B.getWidth();r.style('width',a);t=B.getTooltip_AsString();if(t){r.attr("title",t);}r.attr("tabindex",B.getEnabled()?"0":"-1");d=B.getTextDirection();if(d!==T.Inherit){r.attr("dir",d.toLowerCase());}r.accessibilityState(B,{role:"radio",checked:s===B.getId()});if(g&&f!==""){if(e!==""){f+=" "+e;}else{r.attr("title",f);}r.attr("aria-label",f);}r.openEnd();r.openStart("div");r.class("sapMSegBBtnInner");r.openEnd();if(o&&g){r.renderControl(g);}if(e!==''){r.text(e);}r.close("div");r.close("li");}else{I.render(r,B,"li");}}r.close("ul");};
S._addAllIconsClass=function(b){for(var i=0;i<b.length;i++){if(!b[i].getIcon()){return false;}}return true;};
return S;},true);
sap.ui.predefine('sap/m/Select',['./Dialog','./Popover','./SelectList','./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/Icon','sap/ui/core/IconPool','./Button','./Bar','./Title','./delegate/ValueStateMessage','sap/ui/core/message/MessageMixin','sap/ui/core/library','sap/ui/core/Item','sap/ui/Device','sap/ui/core/InvisibleText','./SelectRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes",'./Text','sap/m/SimpleFixFlex','sap/base/Log'],function(D,P,S,l,C,a,E,I,b,B,c,T,V,M,d,f,g,h,j,k,K,m,n,L){"use strict";var o=l.SelectListKeyboardNavigationMode;var p=l.PlacementType;var q=d.ValueState;var r=d.TextDirection;var s=d.TextAlign;var t=l.SelectType;
var u=a.extend("sap.m.Select",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent","sap.f.IShellBar"],library:"sap.m",properties:{name:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},type:{type:"sap.m.SelectType",group:"Appearance",defaultValue:t.Default},autoAdjustWidth:{type:"boolean",group:"Appearance",defaultValue:false},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:s.Initial},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:r.Inherit},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:q.None},valueStateText:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},resetOnMissingKey:{type:"boolean",group:"Behavior",defaultValue:false},forceSelection:{type:"boolean",group:"Behavior",defaultValue:true},wrapItemsText:{type:"boolean",group:"Behavior",defaultValue:false},required:{type:"boolean",group:"Misc",defaultValue:false}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable",forwarding:{getter:"getList",aggregation:"items"}},picker:{type:"sap.ui.core.PopupInterface",multiple:false,visibility:"hidden"},_valueIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_pickerHeader:{type:"sap.m.Bar",multiple:false,visibility:"hidden"},_pickerValueStateContent:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}},designtime:"sap/m/designtime/Select.designtime"}});
b.insertFontFaceStyle();E.apply(u.prototype,[true]);M.call(u.prototype);
function H(i){if(i){this.setSelection(i);this.setValue(i.getText());this.scrollToItem(i);}}
u.prototype._attachHiddenSelectHandlers=function(){var e=this._getHiddenSelect();e.on("focusin",this._addFocusClass.bind(this));e.on("focusout",this._removeFocusClass.bind(this));};
u.prototype._addFocusClass=function(){this.$().addClass("sapMSltFocused");};
u.prototype._removeFocusClass=function(){this.$().removeClass("sapMSltFocused");};
u.prototype._detachHiddenSelectHandlers=function(){var e=this._getHiddenSelect();if(e){e.off("focusin");e.off("focusout");}};
u.prototype._getHiddenSelect=function(){return this.$("hiddenSelect");};
u.prototype._handleFocusout=function(e){this._bFocusoutDueRendering=this.bRenderingPhase;if(this._bFocusoutDueRendering){this._bProcessChange=false;return;}if(this._bProcessChange){if(!this.isOpen()||e.target===this.getAggregation("picker")){this._checkSelectionChange();}else{this._revertSelection();}this._bProcessChange=false;}else{this._bProcessChange=true;}};
u.prototype._checkSelectionChange=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.fireChange({selectedItem:i});}};
u.prototype._revertSelection=function(){var i=this.getSelectedItem();if(this._oSelectionOnFocus!==i){this.setSelection(this._oSelectionOnFocus);this.setValue(this._getSelectedItemText());}};
u.prototype._getSelectedItemText=function(i){i=i||this.getSelectedItem();if(!i){i=this.getDefaultSelectedItem();}if(i){return i.getText();}return"";};
u.prototype.getOverflowToolbarConfig=function(){var e=["enabled","selectedKey"];if(!this.getAutoAdjustWidth()||this._bIsInOverflow){e.push("selectedItemId");}var i={canOverflow:true,autoCloseEvents:["change"],invalidationEvents:["_itemTextChange"],propsUnrelatedToSize:e};i.onBeforeEnterOverflow=function(v){var w=v.getParent();if(!w.isA("sap.m.OverflowToolbar")){return;}v._prevSelectType=v.getType();v._bIsInOverflow=true;if(v.getType()!==t.Default){v.setProperty("type",t.Default,true);}};i.onAfterExitOverflow=function(v){var w=v.getParent();if(!w.isA("sap.m.OverflowToolbar")){return;}v._bIsInOverflow=false;if(v.getType()!==v._prevSelectType){v.setProperty("type",v._prevSelectType,true);}};return i;};
u.prototype.getList=function(){if(this.bIsDestroyed){return null;}return this._oList;};
u.prototype.findFirstEnabledItem=function(i){var e=this.getList();return e?e.findFirstEnabledItem(i):null;};
u.prototype.findLastEnabledItem=function(i){var e=this.getList();return e?e.findLastEnabledItem(i):null;};
u.prototype.setSelectedIndex=function(i,_){var e;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);e=_[i];if(e){this.setSelection(e);}};
u.prototype.scrollToItem=function(i){var e=this.getPicker().getDomRef(),v=i&&i.getDomRef();if(!e||!v){return;}var w=e.querySelector('.sapUiSimpleFixFlexFlexContent'),x=e.querySelector('.sapMSltPickerValueState'),y=x?x.clientHeight:0,z=w.scrollTop,A=v.offsetTop-y,F=w.clientHeight,G=v.offsetHeight;if(z>A){w.scrollTop=A;}else if((A+G)>(z+F)){w.scrollTop=Math.ceil(A+G-F);}};
u.prototype.setValue=function(v){var e=this.getDomRef(),i=e&&e.querySelector(".sapMSelectListItemText");if(i){i.textContent=v;}this._setHiddenSelectValue();this._getValueIcon();};
u.prototype._setHiddenSelectValue=function(){var e=this._getHiddenSelect(),i=this.getSelectedItem(),v;if(i){v=i.getText();e.attr("value",this.getSelectedKey());e.val(v);}};
u.prototype._getValueIcon=function(){if(this.bIsDestroyed){return null;}var v=this.getAggregation("_valueIcon"),e=this.getSelectedItem(),i=!!(e&&e.getIcon&&e.getIcon()),w=i?e.getIcon():"sap-icon://pull-down";if(!v){v=new I(this.getId()+"-labelIcon",{src:w,visible:false});this.setAggregation("_valueIcon",v,true);}if(v.getVisible()!==i){v.setVisible(i);v.toggleStyleClass("sapMSelectListItemIcon",i);}if(i&&e.getIcon()!==v.getSrc()){v.setSrc(w);}return v;};
u.prototype._isShadowListRequired=function(){if(this.getAutoAdjustWidth()){return false;}else if(this.getWidth()==="auto"){return true;}return false;};
u.prototype._handleAriaActiveDescendant=function(i){var e=this.getFocusDomRef(),v=i&&i.getDomRef(),A="aria-activedescendant";if(!e){return;}if(v&&this.isOpen()){e.setAttribute(A,i.getId());}else{e.removeAttribute(A);}};
u.prototype.updateItems=function(R){S.prototype.updateItems.apply(this,arguments);this._oSelectionOnFocus=this.getSelectedItem();};
u.prototype.refreshItems=function(){S.prototype.refreshItems.apply(this,arguments);};
u.prototype.onBeforeOpen=function(e){var i=this["_onBeforeOpen"+this.getPickerType()],v=this.getRenderer().CSS_CLASS;this.addStyleClass(v+"Pressed");this.addStyleClass(v+"Expanded");this.closeValueStateMessage();this.addContent();this.addContentToFlex();i&&i.call(this);};
u.prototype.onAfterOpen=function(e){var i=this.getFocusDomRef(),v=null;if(!i){return;}v=this.getSelectedItem();i.setAttribute("aria-expanded","true");i.setAttribute("aria-controls",this.getList().getId());if(v){i.setAttribute("aria-activedescendant",v.getId());this.scrollToItem(v);}};
u.prototype.onBeforeClose=function(e){var i=this.getFocusDomRef(),v=this.getRenderer().CSS_CLASS;if(i){i.removeAttribute("aria-controls");i.removeAttribute("aria-activedescendant");if(this.shouldValueStateMessageBeOpened()&&(document.activeElement===i)){this.openValueStateMessage();}}this.removeStyleClass(v+"Expanded");};
u.prototype.onAfterClose=function(e){var i=this.getFocusDomRef(),v=this.getRenderer().CSS_CLASS,w=v+"Pressed";if(i){i.setAttribute("aria-expanded","false");i.removeAttribute("aria-activedescendant");}this.removeStyleClass(w);};
u.prototype.getPicker=function(){if(this.bIsDestroyed){return null;}return this.createPicker(this.getPickerType());};
u.prototype.getSimpleFixFlex=function(){if(this.bIsDestroyed){return null;}else if(this.oSimpleFixFlex){return this.oSimpleFixFlex;}this.oSimpleFixFlex=new n({id:this.getPickerValueStateContentId(),fixContent:this._getPickerValueStateContent().addStyleClass(this.getRenderer().CSS_CLASS+"PickerValueState"),flexContent:this.createList()});return this.oSimpleFixFlex;};
u.prototype.setPickerType=function(e){this._sPickerType=e;};
u.prototype.getPickerType=function(){return this._sPickerType;};
u.prototype._getPickerValueStateContent=function(){if(!this.getAggregation("_pickerValueStateContent")){this.setAggregation("_pickerValueStateContent",new m({wrapping:true,text:this._getTextForPickerValueStateContent()}));}return this.getAggregation("_pickerValueStateContent");};
u.prototype._updatePickerValueStateContentText=function(){var e=this.getPicker().getContent()[0].getFixContent(),i;if(e){i=this._getTextForPickerValueStateContent();e.setText(i);}};
u.prototype._getTextForPickerValueStateContent=function(){var v=this.getValueStateText(),e;if(v){e=v;}else{e=this._getDefaultTextForPickerValueStateContent();}return e;};
u.prototype._getDefaultTextForPickerValueStateContent=function(){var v=this.getValueState(),R,e;if(v===q.None){e="";}else{R=C.getLibraryResourceBundle("sap.ui.core");e=R.getText("VALUE_STATE_"+v.toUpperCase());}return e;};
u.prototype._updatePickerValueStateContentStyles=function(){var v=this.getValueState(),e=q,i=this.getRenderer().CSS_CLASS,w=i+"Picker",x=w+v+"State",y=w+"WithSubHeader",z=this.getPicker(),A=z.getContent()[0].getFixContent();if(A){this._removeValueStateClassesForPickerValueStateContent(z);A.addStyleClass(x);if(v!==e.None){z.addStyleClass(y);}else{z.removeStyleClass(y);}}};
u.prototype._removeValueStateClassesForPickerValueStateContent=function(e){var v=q,i=this.getRenderer().CSS_CLASS,w=i+"Picker",x=e.getContent()[0].getFixContent();Object.keys(v).forEach(function(y){var O=w+y+"State";x.removeStyleClass(O);});};
u.prototype._createPopover=function(){var e=this;var i=new P({showArrow:false,showHeader:false,placement:p.VerticalPreferredBottom,offsetX:0,offsetY:0,initialFocus:this,bounce:false,ariaLabelledBy:this._getPickerHiddenLabelId()});i.addEventDelegate({ontouchstart:function(v){var w=this.getDomRef("cont");if((v.target===w)||(v.srcControl instanceof f)){e._bProcessChange=false;}}},i);this._decoratePopover(i);return i;};
u.prototype._decoratePopover=function(e){var i=this;e.open=function(){return this.openBy(i);};};
u.prototype._onBeforeRenderingPopover=function(){var e=this.getPicker(),w=this.$().outerWidth()+"px";if(e){e.setContentMinWidth(w);}};
u.prototype._createDialog=function(){var e=this,i=this._getPickerHeader(),v=new D({stretch:true,ariaLabelledBy:this._getPickerHiddenLabelId(),customHeader:i,beforeOpen:function(){e.updatePickerHeaderTitle();}});v._setupBarTitleAlignment(i,this.getId()+"_pickerHeader");return v;};
u.prototype._getPickerTitle=function(){var e=this.getPicker(),i=e&&e.getCustomHeader();if(i){return i.getContentMiddle()[0];}return null;};
u.prototype._getPickerHeader=function(){var i=b.getIconURI("decline"),R;if(!this.getAggregation("_pickerHeader")){R=C.getLibraryResourceBundle("sap.m");this.setAggregation("_pickerHeader",new c({contentMiddle:new T({text:R.getText("SELECT_PICKER_TITLE_TEXT")}),contentRight:new B({icon:i,press:this.close.bind(this)})}));}return this.getAggregation("_pickerHeader");};
u.prototype._getPickerHiddenLabelId=function(){return h.getStaticId("sap.m","INPUT_AVALIABLE_VALUES");};
u.prototype.getPickerValueStateContentId=function(){return this.getId()+"-valueStateText";};
u.prototype.updatePickerHeaderTitle=function(){var e=this.getPicker();if(!e){return;}var i=this.getLabels();if(i.length){var v=i[0],w=this._getPickerTitle();if(v&&(typeof v.getText==="function")){w&&w.setText(v.getText());}}};
u.prototype._onBeforeOpenDialog=function(){};
u.prototype.init=function(){this.setPickerType(g.system.phone?"Dialog":"Popover");this.createPicker(this.getPickerType());this._oSelectionOnFocus=null;this.bRenderingPhase=false;this._bFocusoutDueRendering=false;this._bProcessChange=false;this.sTypedChars="";this.iTypingTimeoutID=-1;this._oValueStateMessage=new V(this);this._bValueStateMessageOpened=false;this._sAriaRoleDescription=C.getLibraryResourceBundle("sap.m").getText("SELECT_ROLE_DESCRIPTION");};
u.prototype.onBeforeRendering=function(){this.bRenderingPhase=true;this.synchronizeSelection({forceSelection:this.getForceSelection()});this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();this._detachHiddenSelectHandlers();};
u.prototype.onAfterRendering=function(){this.bRenderingPhase=false;this._setHiddenSelectValue();this._attachHiddenSelectHandlers();};
u.prototype.exit=function(){var v=this.getValueStateMessage(),e=this._getValueIcon();this._oSelectionOnFocus=null;if(v){this.closeValueStateMessage();v.destroy();}if(e){e.destroy();}this._oValueStateMessage=null;this._bValueStateMessageOpened=false;};
u.prototype.ontouchstart=function(e){e.setMarked();if(this.getEnabled()&&this.getEditable()&&this.isOpenArea(e.target)){this.addStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
u.prototype.ontouchend=function(e){e.setMarked();if(this.getEnabled()&&this.getEditable()&&!this.isOpen()&&this.isOpenArea(e.target)){this.removeStyleClass(this.getRenderer().CSS_CLASS+"Pressed");}};
u.prototype.ontap=function(e){var i=this.getRenderer().CSS_CLASS;e.setMarked();if(!this.getEnabled()||!this.getEditable()){return;}if(this.isOpenArea(e.target)){if(this.isOpen()){this.close();this.removeStyleClass(i+"Pressed");return;}if(g.system.phone){this.focus();}this.open();}if(this.isOpen()){this.addStyleClass(i+"Pressed");}};
u.prototype.onSelectionChange=function(e){var i=e.getParameter("selectedItem");this.close();this.setSelection(i);this.fireChange({selectedItem:i});this.setValue(this._getSelectedItemText());};
u.prototype.onkeypress=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();var i=String.fromCharCode(e.which),v;this.sTypedChars+=i;v=(/^(.)\1+$/i).test(this.sTypedChars)?i:this.sTypedChars;clearTimeout(this.iTypingTimeoutID);this.iTypingTimeoutID=setTimeout(function(){this.sTypedChars="";this.iTypingTimeoutID=-1;}.bind(this),1000);H.call(this,this.searchNextItemByText(v));};
u.prototype.onsapshow=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();if(e.which===K.F4){e.preventDefault();}this.toggleOpenState();};
u.prototype.onsaphide=u.prototype.onsapshow;
u.prototype.onmousedown=function(e){e.preventDefault();};
u.prototype.onsapescape=function(e){if(!this.getEnabled()||!this.getEditable()||this._bSpaceDown){return;}if(this.isOpen()){e.setMarked();this.close();this._revertSelection();}};
u.prototype.onsapenter=function(e){if(!this.getEnabled()||!this.getEditable()){return;}if(this.isOpen()){e.setMarked();}this.close();this._checkSelectionChange();};
u.prototype.onkeydown=function(e){if(e.which===K.SPACE){this._bSpaceDown=true;}if([K.ARROW_DOWN,K.ARROW_UP,K.SPACE].indexOf(e.which)>-1){e.preventDefault();}if(e.which===K.SHIFT||e.which===K.ESCAPE){this._bSupressNextAction=this._bSpaceDown;}};
u.prototype.onkeyup=function(e){if(!this.getEnabled()||!this.getEditable()){return;}if(e.which===K.SPACE){if(!e.shiftKey&&!this._bSupressNextAction){e.setMarked();if(this.isOpen()){this._checkSelectionChange();}this.toggleOpenState();}this._bSpaceDown=false;this._bSupressNextAction=false;}};
u.prototype.onsapdown=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();e.preventDefault();var N,i=this.getSelectableItems();N=i[i.indexOf(this.getSelectedItem())+1];H.call(this,N);};
u.prototype.onsapup=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();e.preventDefault();var i,v=this.getSelectableItems();i=v[v.indexOf(this.getSelectedItem())-1];H.call(this,i);};
u.prototype.onsaphome=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();e.preventDefault();var F=this.getSelectableItems()[0];H.call(this,F);};
u.prototype.onsapend=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();e.preventDefault();var i=this.findLastEnabledItem(this.getSelectableItems());H.call(this,i);};
u.prototype.onsappagedown=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();e.preventDefault();var i=this.getSelectableItems(),v=this.getSelectedItem();this.setSelectedIndex(i.indexOf(v)+10,i);v=this.getSelectedItem();if(v){this.setValue(v.getText());}this.scrollToItem(v);};
u.prototype.onsappageup=function(e){if(!this.getEnabled()||!this.getEditable()){return;}e.setMarked();e.preventDefault();var i=this.getSelectableItems(),v=this.getSelectedItem();this.setSelectedIndex(i.indexOf(v)-10,i);v=this.getSelectedItem();if(v){this.setValue(v.getText());}this.scrollToItem(v);};
u.prototype.onsaptabnext=function(e){if(!this.getEnabled()){return;}if(this.isOpen()){this.close();this._checkSelectionChange();}};
u.prototype.onsaptabprevious=u.prototype.onsaptabnext;
u.prototype.onfocusin=function(e){if(!this._bFocusoutDueRendering&&!this._bProcessChange){this._oSelectionOnFocus=this.getSelectedItem();}this._bProcessChange=true;setTimeout(function(){if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&(document.activeElement===this.getFocusDomRef())){this.openValueStateMessage();}}.bind(this),100);if(g.browser.msie&&(e.target!==this.getFocusDomRef())){this.focus();}};
u.prototype.onfocusout=function(e){this._handleFocusout(e);if(this.bRenderingPhase){return;}this.closeValueStateMessage();};
u.prototype.onsapfocusleave=function(e){var i=this.getAggregation("picker");if(!e.relatedControlId||!i){return;}var v=C.byId(e.relatedControlId),F=v&&v.getFocusDomRef();if(g.system.desktop&&k(i.getFocusDomRef(),F)){this.focus();}};
u.prototype.getFocusDomRef=function(){return this._getHiddenSelect()[0];};
u.prototype.getPopupAnchorDomRef=function(){return this.getDomRef();};
u.prototype.setSelection=function(i){var e=this.getList(),v;if(e){e.setSelection(i);}this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof f)?i.getId():i,true);if(typeof i==="string"){i=C.byId(i);}v=i?i.getKey():"";this.setProperty("selectedKey",v,true);this._handleAriaActiveDescendant(i);};
u.prototype.isSelectionSynchronized=function(){return S.prototype.isSelectionSynchronized.apply(this,arguments);};
u.prototype.synchronizeSelection=function(){S.prototype.synchronizeSelection.apply(this,arguments);};
u.prototype.addContent=function(e){};
u.prototype.addContentToFlex=function(){};
u.prototype.createPicker=function(e){var i=this.getAggregation("picker"),v=this.getRenderer().CSS_CLASS;if(i){return i;}i=this["_create"+e]();this.setAggregation("picker",i,true);i.setHorizontalScrolling(false).setVerticalScrolling(false).addStyleClass(v+"Picker").addStyleClass(v+"Picker-CTX").addStyleClass("sapUiNoContentPadding").attachBeforeOpen(this.onBeforeOpen,this).attachAfterOpen(this.onAfterOpen,this).attachBeforeClose(this.onBeforeClose,this).attachAfterClose(this.onAfterClose,this).addEventDelegate({onBeforeRendering:this.onBeforeRenderingPicker,onAfterRendering:this.onAfterRenderingPicker},this).addContent(this.getSimpleFixFlex());return i;};
u.prototype.searchNextItemByText=function(e){var v=this.getItems(),w=this.getSelectedIndex(),x=v.splice(w+1,v.length-w),y=v.splice(0,v.length-1);v=x.concat(y);for(var i=0,z;i<v.length;i++){z=v[i];var A=typeof e==="string"&&e!=="";if(z.getEnabled()&&!(z instanceof sap.ui.core.SeparatorItem)&&z.getText().toLowerCase().startsWith(e.toLowerCase())&&A){return z;}}return null;};
u.prototype.createList=function(){var e=o,i=g.system.phone?e.Delimited:e.None;this._oList=new S({width:"100%",keyboardNavigationMode:i}).addStyleClass(this.getRenderer().CSS_CLASS+"List-CTX").addEventDelegate({ontap:function(v){this._checkSelectionChange();this.close();}},this).attachSelectionChange(this.onSelectionChange,this);this._oList.toggleStyleClass("sapMSelectListWrappedItems",this.getWrapItemsText());return this._oList;};
u.prototype.setWrapItemsText=function(w){var e=this.getPicker();if(this._oList){this._oList.toggleStyleClass("sapMSelectListWrappedItems",w);}if(e&&this.getPickerType()==="Popover"){e.toggleStyleClass("sapMPickerWrappedItems",w);}return this.setProperty("wrapItemsText",w,true);};
u.prototype.hasContent=function(){return this.getItems().length>0;};
u.prototype.onBeforeRenderingPicker=function(){var O=this["_onBeforeRendering"+this.getPickerType()];O&&O.call(this);};
u.prototype.onAfterRenderingPicker=function(){var O=this["_onAfterRendering"+this.getPickerType()];O&&O.call(this);};
u.prototype.open=function(){var e=this.getPicker();if(e){e.open();}return this;};
u.prototype.toggleOpenState=function(){if(this.isOpen()){this.close();}else{this.open();}return this;};
u.prototype.getVisibleItems=function(){var e=this.getList();return e?e.getVisibleItems():[];};
u.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
u.prototype.getSelectedIndex=function(){var e=this.getSelectedItem();return e?this.indexOfItem(this.getSelectedItem()):-1;};
u.prototype.getDefaultSelectedItem=function(i){return this.getForceSelection()?this.findFirstEnabledItem():null;};
u.prototype.getSelectableItems=function(){var e=this.getList();return e?e.getSelectableItems():[];};
u.prototype.getOpenArea=function(){return this.getDomRef();};
u.prototype.isOpenArea=function(e){var O=this.getOpenArea();return O&&O.contains(e);};
u.prototype.findItem=function(e,v){var i=this.getList();return i?i.findItem(e,v):null;};
u.prototype.clearSelection=function(){this.setSelection(null);};
u.prototype.onItemChange=function(e){var i=this.getAssociation("selectedItem"),v=e.getParameter("id"),w=e.getParameter("name"),N=e.getParameter("newValue"),O,x,F,y;if(w==="key"&&!this.isBound("selectedKey")){x=this.getSelectedKey();F=this.getItemByKey(N);if(N===x&&i!==v&&F&&v===F.getId()){this.setSelection(F);return;}O=e.getParameter("oldValue");if(i===v&&x===O&&!this.getItemByKey(O)){this.setSelectedKey(N);return;}y=this.getItemByKey(x);if(i===v&&N!==x&&y){this.setSelection(y);return;}}if(w==="text"&&i===v){this.fireEvent("_itemTextChange");this.setValue(N);}};
u.prototype.fireChange=function(e){this._oSelectionOnFocus=e.selectedItem;return this.fireEvent("change",e);};
u.prototype.addAggregation=function(A,O,e){if(A==="items"&&!e&&!this.isInvalidateSuppressed()){this.invalidate(O);}return a.prototype.addAggregation.apply(this,arguments);};
u.prototype.destroyAggregation=function(A,e){if(A==="items"&&!e&&!this.isInvalidateSuppressed()){this.invalidate();}return a.prototype.destroyAggregation.apply(this,arguments);};
u.prototype.setAssociation=function(A,i,e){var v=this.getList();if(v&&(A==="selectedItem")){S.prototype.setAssociation.apply(v,arguments);}return a.prototype.setAssociation.apply(this,arguments);};
u.prototype.setProperty=function(i,v,w){var x=this.getList();if((i==="selectedKey")||(i==="selectedItemId")){x&&S.prototype.setProperty.apply(x,arguments);}try{a.prototype.setProperty.apply(this,arguments);}catch(e){L.warning('Update failed due to exception. Loggable in support mode log',null,null,function(){return{exception:e};});}return this;};
u.prototype.removeAllAssociation=function(A,e){var i=this.getList();if(i&&(A==="selectedItem")){S.prototype.removeAllAssociation.apply(i,arguments);}return a.prototype.removeAllAssociation.apply(this,arguments);};
u.prototype.clone=function(){var e=a.prototype.clone.apply(this,arguments),i=this.getSelectedItem(),v=this.getSelectedKey();if(!this.isBound("selectedKey")&&!e.isSelectionSynchronized()){if(i&&(v==="")){e.setSelectedIndex(this.indexOfItem(i));}else{e.setSelectedKey(v);}}return e;};
u.prototype.updateValueStateClasses=function(v,O){var $=this.$(),e=this.$("label"),A=this.$("arrow"),i=q,w=this.getRenderer().CSS_CLASS;if(O!==i.None){$.removeClass(w+"State");$.removeClass(w+O);e.removeClass(w+"LabelState");e.removeClass(w+"Label"+O);A.removeClass(w+"ArrowState");}if(v!==i.None){$.addClass(w+"State");$.addClass(w+v);e.addClass(w+"LabelState");e.addClass(w+"Label"+v);A.addClass(w+"ArrowState");}};
u.prototype._updatePickerAriaLabelledBy=function(v){var e=this.getPicker(),i=this.getPickerValueStateContentId();if(v===q.None){e.removeAriaLabelledBy(i);}else{e.addAriaLabelledBy(i);}};
u.prototype.updateAriaLabelledBy=function(v,O){var $=this._getHiddenSelect(),A=$.attr("aria-labelledby"),i=A?A.split(" "):[],e,N;if(O!==q.None&&O!==q.Error){e=i.indexOf(h.getStaticId("sap.ui.core","VALUE_STATE_"+O.toUpperCase()));i.splice(e,1);}if(v!==q.None&&v!==q.Error){i.push(h.getStaticId("sap.ui.core","VALUE_STATE_"+v.toUpperCase()));}N=i.join(" ");$.attr("aria-labelledby",N);};
u.prototype.getLabels=function(){var e=this.getAriaLabelledBy().map(function(v){return C.byId(v);});var i=sap.ui.require("sap/ui/core/LabelEnablement");if(i){e=e.concat(i.getReferencingLabels(this).map(function(v){return C.byId(v);}));}return e;};
u.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
u.prototype.getValueStateMessageId=function(){return this.getId()+"-message";};
u.prototype.getValueStateMessage=function(){return this._oValueStateMessage;};
u.prototype.openValueStateMessage=function(){var v=this.getValueStateMessage();if(v&&!this._bValueStateMessageOpened){this._bValueStateMessageOpened=true;v.open();}};
u.prototype.closeValueStateMessage=function(){var v=this.getValueStateMessage();if(v&&this._bValueStateMessageOpened){this._bValueStateMessageOpened=false;v.close();}};
u.prototype.shouldValueStateMessageBeOpened=function(){return(this.getValueState()!==q.None)&&this.getEnabled()&&this.getEditable()&&!this._bValueStateMessageOpened;};
u.prototype.setShowSecondaryValues=function(A){var e=!this._isShadowListRequired();this.setProperty("showSecondaryValues",A,e);var i=this.getList();if(i){i.setShowSecondaryValues(A);}return this;};
u.prototype.addItem=function(i){this.addAggregation("items",i);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
u.prototype.insertItem=function(i,e){this.insertAggregation("items",i,e);if(i){i.attachEvent("_change",this.onItemChange,this);}return this;};
u.prototype.findAggregatedObjects=function(){var e=this.getList();if(e){return S.prototype.findAggregatedObjects.apply(e,arguments);}return[];};
u.prototype.getItems=function(){var e=this.getList();return e?e.getItems():[];};
u.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=C.byId(i);}if(!(i instanceof f)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText(i));this._oSelectionOnFocus=i;return this;};
u.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);this.setValue(this._getSelectedItemText());this._oSelectionOnFocus=this.getSelectedItem();return this;};
u.prototype._isKeyAvailable=function(e){var A=this._oList.getItems().map(function(i){return i.getKey();});return A.indexOf(e)>-1;};
u.prototype.setSelectedKey=function(e){e=this.validateProperty("selectedKey",e);var i=(e==="");if(!i&&!this._isKeyAvailable(e)&&this.getResetOnMissingKey()){i=true;}if(!this.getForceSelection()&&i){this.setSelection(null);this.setValue("");return this.setProperty("selectedKey",e);}var v=this.getItemByKey(e);if(v||i){if(!v&&i){v=this.getDefaultSelectedItem();}this.setSelection(v);this.setValue(this._getSelectedItemText(v));this._oSelectionOnFocus=v;return this;}return this.setProperty("selectedKey",e);};
u.prototype.setValueState=function(v){var O=this.getValueState();this.setProperty("valueState",v,true);v=this.getValueState();if(v===O){return this;}this._updatePickerAriaLabelledBy(v);var e=this.getDomRefForValueState();if(!e){return this;}var i=q;if(v===i.Error){e.setAttribute("aria-invalid",true);}else{e.removeAttribute("aria-invalid");}if(!this.isOpen()&&this.shouldValueStateMessageBeOpened()&&document.activeElement===e){this.openValueStateMessage();}else{this.closeValueStateMessage();}this.updateValueStateClasses(v,O);this.updateAriaLabelledBy(v,O);this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();return this;};
u.prototype.setValueStateText=function(v){this.setProperty("valueStateText",v,true);if(this.getDomRefForValueState()){this._updatePickerValueStateContentText();this._updatePickerValueStateContentStyles();}return this;};
u.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
u.prototype.getSelectedItem=function(){var v=this.getAssociation("selectedItem");return(v===null)?null:C.byId(v)||null;};
u.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
u.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
u.prototype.getEnabledItems=function(i){var e=this.getList();return e?e.getEnabledItems(i):[];};
u.prototype.getItemByKey=function(e){var i=this.getList();return i?i.getItemByKey(e):null;};
u.prototype.removeItem=function(i){var e;i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){e=this.findFirstEnabledItem();if(e){this.setSelection(e);}}this.setValue(this._getSelectedItemText());if(i){i.detachEvent("_change",this.onItemChange,this);}return i;};
u.prototype.removeAllItems=function(){var e=this.removeAllAggregation("items");this.setValue("");if(this._isShadowListRequired()){this.$().find(".sapMSelectListItemBase").remove();}for(var i=0;i<e.length;i++){e[i].detachEvent("_change",this.onItemChange,this);}return e;};
u.prototype.destroyItems=function(){this.destroyAggregation("items");this.setValue("");if(this._isShadowListRequired()){this.$().find(".sapMSelectListItemBase").remove();}return this;};
u.prototype.isOpen=function(){var e=this.getAggregation("picker");return!!(e&&e.isOpen());};
u.prototype.close=function(){var e=this.getAggregation("picker");if(e){e.close();}return this;};
u.prototype.getDomRefForValueState=function(){return this.getDomRef();};
u.prototype.getAccessibilityInfo=function(){var i=this.getType()==="IconOnly",e={role:this.getRenderer().getAriaRole(this),focusable:this.getEnabled(),enabled:this.getEnabled(),readonly:i?undefined:this.getEnabled()&&!this.getEditable()};if(i){var v=this.getTooltip_AsString();if(!v){var w=b.getIconInfo(this.getIcon());v=w&&w.text?w.text:"";}e.type=C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_BUTTON");e.description=v;}else if(this.getType()==="Default"){e.type=C.getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_COMBO");e.description=this._getSelectedItemText();}return e;};
u.prototype.getIdForLabel=function(){return this.getId()+"-hiddenSelect";};
return u;});
sap.ui.predefine('sap/m/SelectDialog',['./Button','./Dialog','./List','./SearchField','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/Device','sap/m/Toolbar','sap/m/Label','sap/m/BusyIndicator','sap/m/Bar','sap/m/Title','sap/ui/core/theming/Parameters',"sap/base/Log"],function(B,D,L,S,l,T,C,a,b,c,d,e,f,P,g){"use strict";var h=l.ListMode;var i=l.ButtonType;var j=l.TitleAlignment;
var k=C.extend("sap.m.SelectDialog",{
metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growingThreshold:{type:"int",group:"Misc",defaultValue:null},growing:{type:"boolean",group:"Behavior",defaultValue:true},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showClearButton:{type:"boolean",group:"Behavior",defaultValue:false},confirmButtonText:{type:"string",group:"Appearance"},draggable:{type:"boolean",group:"Behavior",defaultValue:false},resizable:{type:"boolean",group:"Behavior",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:j.Auto}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ListItemBase",multiple:true,singularName:"item",forwarding:{idSuffix:"-list",aggregation:"items",forwardBinding:true}},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"object[]"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}},
renderer:{apiVersion:2,render:function(){}}
});
k.prototype.init=function(){var t=this,m=0;this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._bAfterCloseAttached=false;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=new L(this.getId()+"-list",{growing:t.getGrowing(),growingScrollToLoad:t.getGrowing(),mode:h.SingleSelectMaster,sticky:[l.Sticky.InfoToolbar],infoToolbar:new b({visible:false,active:false,content:[new c({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:this._selectionChange.bind(this)});this._oList.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oList.getInfoToolbar().$().attr('aria-live','polite');}});this._list=this._oList;this._oList.attachUpdateStarted(this._updateStarted,this);this._oList.attachUpdateFinished(this._updateFinished,this);this._oBusyIndicator=new d(this.getId()+"-busyIndicator").addStyleClass("sapMSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),n=(v?300:0);clearTimeout(m);if(n){m=setTimeout(function(){t._executeSearch(v,false,"liveChange");},n);}else{t._executeSearch(v,false,"liveChange");}},search:function(E){var v=E.getSource().getValue(),n=E.getParameters().clearButtonPressed;t._executeSearch(v,n,"search");}});this._searchField=this._oSearchField;this._oSubHeader=new e(this.getId()+"-subHeader",{contentMiddle:[this._oSearchField]});var o=new e(this.getId()+"-dialog-header",{contentMiddle:[new f(this.getId()+"-dialog-title",{level:"H2"})]});this._setupBarTitleAlignment(o,this.getId()+"_customHeader");this._oDialog=new D(this.getId()+"-dialog",{customHeader:o,stretch:a.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oList],leftButton:this._getCancelButton(),initialFocus:(a.system.desktop?this._oSearchField:null),draggable:this.getDraggable()&&a.system.desktop,resizable:this.getResizable()&&a.system.desktop,escapeHandler:function(p){t._onCancel();p.resolve();}}).addStyleClass("sapMSelectDialog");this._oDialog.addAriaLabelledBy(this._oList.getInfoToolbar());this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);this._oDialog._iVMargin=8*(parseInt(P.get("sapUiFontSize"))||16);this._sSearchFieldValue="";this._bFirstRequest=true;this._bLiveChange=false;this._iListUpdateRequested=0;};
k.prototype.setGrowing=function(v){this._oList.setGrowing(v);this._oList.setGrowingScrollToLoad(v);this.setProperty("growing",v,true);return this;};
k.prototype.setDraggable=function(v){this._setInteractionProperty(v,"draggable",this._oDialog.setDraggable);return this;};
k.prototype.setResizable=function(v){this._setInteractionProperty(v,"resizable",this._oDialog.setResizable);return this;};
k.prototype._setInteractionProperty=function(v,p,m){this.setProperty(p,v,true);if(!a.system.desktop&&v){g.warning(p+" property works only on desktop devices!");return;}if(a.system.desktop&&this._oDialog){m.call(this._oDialog,v);}};
k.prototype.setBusy=function(){this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
k.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
k.prototype.setBusyIndicatorDelay=function(v){this._oList.setBusyIndicatorDelay(v);this._oDialog.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
k.prototype.exit=function(){this._oList=null;this._oSearchField=null;this._oSubHeader=null;this._oClearButton=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iListUpdateRequested=0;this._bFirstRequest=false;this._bInitBusy=false;this._bFirstRender=false;this._bFirstRequest=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._list=null;this._searchField=null;this._dialog=null;};
k.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;}return this;};
k.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}return this;};
k.prototype.open=function(s){if((!this.getParent()||!this.getUIArea())&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._bFirstRequest=true;this._oSearchField.setValue(s);this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._updateSelectionIndicator();this._aInitiallySelectedContextPaths=this._oList.getSelectedContextPaths();return this;};
k.prototype.setGrowingThreshold=function(v){this._oList.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
k.prototype.setMultiSelect=function(m){this.setProperty("multiSelect",m,true);if(m){this._oList.setMode(h.MultiSelect);this._oList.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oList.setMode(h.SingleSelectMaster);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.destroyBeginButton();delete this._oOkButton;}return this;};
k.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.getCustomHeader().getAggregation("contentMiddle")[0].setText(t);return this;};
k.prototype.setConfirmButtonText=function(t){this.setProperty("confirmButtonText",t,true);this._oOkButton&&this._oOkButton.setText(t||this._oRb.getText("SELECT_CONFIRM_BUTTON"));return this;};
k.prototype.setNoDataText=function(n){this._oList.setNoDataText(n);return this;};
k.prototype.getNoDataText=function(){return this._oList.getNoDataText();};
k.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
k.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
k.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
k.prototype.setShowClearButton=function(v){this.setProperty("showClearButton",v,true);if(v){var o=this._oDialog.getCustomHeader();o.addContentRight(this._getClearButton());}if(this._oClearButton){this._oClearButton.setVisible(v);}return this;};
k.prototype.setContentHeight=function(H){this._oDialog.setContentHeight(H);return this;};
k.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
k.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
k.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
k.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
k.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
k.prototype.clearSelection=function(){this._removeSelection();this._updateSelectionIndicator();this._oDialog.focus();return this;};
k.prototype._setModel=k.prototype.setModel;
k.prototype.setModel=function(m,M){var A=Array.prototype.slice.call(arguments);this._setBusy(false);this._bInitBusy=false;this._iListUpdateRequested+=1;this._oList.setModel(m,M);k.prototype._setModel.apply(this,A);this._updateSelectionIndicator();return this;};
k.prototype._setBindingContext=k.prototype.setBindingContext;
k.prototype.setBindingContext=function(o,m){var n=Array.prototype.slice.call(arguments);this._oList.setBindingContext(o,m);k.prototype._setBindingContext.apply(this,n);return this;};
k.prototype._executeSearch=function(v,m,E){var o=this._oList,n=(o?o.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(E==="liveChange"){this._bLiveChange=true;}if(this._oDialog.isOpen()&&((s&&E==="liveChange")||E==="search")){this._sSearchFieldValue=v;if(n){this._iListUpdateRequested+=1;if(E==="search"){this.fireSearch({value:v,itemsBinding:n,clearButtonPressed:m});}else if(E==="liveChange"){this.fireLiveChange({value:v,itemsBinding:n});}}else{if(E==="search"){this.fireSearch({value:v,clearButtonPressed:m});}else if(E==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
k.prototype._setBusy=function(m){if(this._iListUpdateRequested){if(m){this._oList.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oList.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
k.prototype._updateStarted=function(E){if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iListUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
k.prototype._updateFinished=function(E){this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}if(a.system.desktop){if(this._oList.getItems()[0]){this._oDialog.setInitialFocus(this._oList.getItems()[0]);}else{this._oDialog.setInitialFocus(this._oSearchField);}if(this._bFirstRequest&&!this._bLiveChange){var F=this._oList.getItems()[0];if(!F){F=this._oSearchField;}if(F.getFocusDomRef()){F.getFocusDomRef().focus();}}}this._bFirstRequest=false;this._iListUpdateRequested=0;this._oList.getItems().forEach(function(I){I.addEventDelegate(this._getListItemsEventDelegates());},this);};
k.prototype._getOkButton=function(){var t=this,o=null;o=function(){var m=t._oList.getBinding("items");if(m&&m.aFilters&&m.aFilters.length){t._oList.setGrowing(false);m.filter([]);t._oList.setGrowing(t.getGrowing());}t._oSelectedItem=t._oList.getSelectedItem();t._aSelectedItems=t._oList.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{type:i.Emphasized,text:this.getConfirmButtonText()||this._oRb.getText("SELECT_CONFIRM_BUTTON"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
k.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(E){t._onCancel();}});}return this._oCancelButton;};
k.prototype._getClearButton=function(){if(!this._oClearButton){this._oClearButton=new B(this.getId()+"-clear",{text:this._oRb.getText("SELECTDIALOG_CLEARBUTTON"),press:this.clearSelection.bind(this)});}return this._oClearButton;};
k.prototype._onCancel=function(E){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t._resetSelection();t.fireCancel();};this._oDialog.attachAfterClose(A);this._oDialog.close();};
k.prototype._updateSelectionIndicator=function(){var s=this._oList.getSelectedContextPaths(true).length,I=this._oList.getInfoToolbar(),v=!!s&&this.getMultiSelect();if(this.getShowClearButton()&&this._oClearButton){this._oClearButton.setEnabled(s>0);}if(I.getVisible()!==v){I.setVisible(v);if(v){I.rerender();}}I.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
k.prototype._fireConfirmAndUpdateSelection=function(){var p={selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems};Object.defineProperty(p,"selectedContexts",{get:this._oList.getSelectedContexts.bind(this._oList,true)});this.fireConfirm(p);this._updateSelection();};
k.prototype._selectionChange=function(){if(!this._oDialog){return;}if(this.getMultiSelect()){this._updateSelectionIndicator();return;}if(!this._bAfterCloseAttached){this._oDialog.attachEventOnce("afterClose",this._resetAfterClose,this);this._bAfterCloseAttached=true;}this._oDialog.close();};
k.prototype._resetAfterClose=function(){this._oSelectedItem=this._oList.getSelectedItem();this._aSelectedItems=this._oList.getSelectedItems();this._bAfterCloseAttached=false;this._fireConfirmAndUpdateSelection();};
k.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._removeSelection();}};
k.prototype._removeSelection=function(){this._oList.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;};
k.prototype._resetSelection=function(){if(!this.bIsDestroyed){this._oList.removeSelections(true);this._oList.setSelectedContextPaths(this._aInitiallySelectedContextPaths);this._oList.getItems().forEach(function(I){var p=I.getBindingContextPath();if(p&&this._aInitiallySelectedContextPaths.indexOf(p)>-1){I.setSelected(true);}},this);}};
k.prototype._getListItemsEventDelegates=function(){var E=function(o){if(o&&o.isDefaultPrevented&&o.isMarked&&(o.isDefaultPrevented()||o.isMarked("preventSelectionChange"))){return;}if(o&&o.srcControl.isA("sap.m.GroupHeaderListItem")){return;}this._selectionChange(o);}.bind(this);return{ontap:E,onsapselect:E};};
T.mixInto(k.prototype);return k;});
sap.ui.predefine('sap/m/SelectList',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/delegate/ItemNavigation','sap/ui/core/Item','./SelectListRenderer','sap/base/Log',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(l,C,a,I,b,S,L,q){"use strict";var t=l.touch;var c=l.SelectListKeyboardNavigationMode;
var d=a.extend("sap.m.SelectList",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},selectedKey:{type:"string",group:"Data",defaultValue:""},selectedItemId:{type:"string",group:"Misc",defaultValue:""},showSecondaryValues:{type:"boolean",group:"Misc",defaultValue:false},keyboardNavigationMode:{type:"sap.m.SelectListKeyboardNavigationMode",group:"Behavior",defaultValue:c.Delimited}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{selectionChange:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}},itemPress:{parameters:{item:{type:"sap.ui.core.Item"}}}}}});
d.prototype._setSelectedIndex=function(i,_){var o;_=_||this.getItems();i=(i>_.length-1)?_.length-1:Math.max(0,i);o=_[i];if(o){this.setSelection(o);}};
d.prototype.updateItems=function(r){this.bItemsUpdated=false;this.destroyItems();this.updateAggregation("items");this.bItemsUpdated=true;this.synchronizeSelection({forceSelection:false});setTimeout(this.synchronizeSelection.bind(this),0);};
d.prototype.refreshItems=function(){this.bItemsUpdated=false;this.refreshAggregation("items");};
d.prototype._activateItem=function(i){if(i instanceof b&&i&&i.getEnabled()){this.fireItemPress({item:i});if(this.getSelectedItem()!==i){this.setSelection(i);this.fireSelectionChange({selectedItem:i});}}};
d.prototype._queryEnabledItemsDomRefs=function(D){var e="."+this.getRenderer().CSS_CLASS+"ItemBase";D=D||this.getDomRef();return D?Array.prototype.slice.call(D.querySelectorAll(e+":not("+e+"Disabled)")):[];};
d.prototype._handleARIAActivedescendant=function(){var A=q(document.activeElement).control(0),D=this.getDomRef();if(A&&D){D.setAttribute("aria-activedescendant",A.getId());}};
d.prototype.init=function(){this._iStartTimeout=0;this._iActiveTouchId=0;this._fStartX=0;this._fStartY=0;this._oItemNavigation=null;this._$ItemPressed=null;};
d.prototype.onBeforeRendering=function(){this.synchronizeSelection({forceSelection:false});};
d.prototype.onAfterRendering=function(){if(this.getKeyboardNavigationMode()===c.None){this.destroyItemNavigation();}else{this.createItemNavigation();}};
d.prototype.exit=function(){this.destroyItemNavigation();this._$ItemPressed=null;};
d.prototype.ontouchstart=function(e){if(t.countContained(e.touches,this.getId())>1||!this.getEnabled()){return;}e.setMarked();var T=e.targetTouches[0];this._iActiveTouchId=T.identifier;this._fStartX=T.pageX;this._fStartY=T.pageY;this._iStartTimeout=setTimeout(function(){var i=e.srcControl.$();if(i){i.addClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=i;}}.bind(this),100);};
d.prototype.ontouchmove=function(e){var T=null;if(!this.getEnabled()){return;}T=t.find(e.changedTouches,this._iActiveTouchId);if(T&&((Math.abs(T.pageX-this._fStartX)>10)||(Math.abs(T.pageY-this._fStartY)>10))){clearTimeout(this._iStartTimeout);if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}}};
d.prototype.ontouchend=function(e){var T=null;if(!this.getEnabled()){return;}e.setMarked();T=t.find(e.changedTouches,this._iActiveTouchId);if(T){setTimeout(function(){if(this._$ItemPressed){this._$ItemPressed.removeClass(this.getRenderer().CSS_CLASS+"ItemBasePressed");this._$ItemPressed=null;}this._iStartTimeout=null;}.bind(this),100);}};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype.ontap=function(e){if(this.getEnabled()){e.setMarked();this._activateItem(e.srcControl);}};
d.prototype.onsapselect=function(e){if(this.getEnabled()){e.setMarked();e.preventDefault();this._activateItem(e.srcControl);}};
d.prototype.onAfterFocus=function(o){this._handleARIAActivedescendant();};
d.prototype.findFirstEnabledItem=function(e){e=e||this.getItems();for(var i=0;i<e.length;i++){if(e[i].getEnabled()){return e[i];}}return null;};
d.prototype.setSelection=function(i){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",(i instanceof b)?i.getId():i);if(typeof i==="string"){i=C.byId(i);}this.setProperty("selectedKey",i?i.getKey():"",true);return this;};
d.prototype.synchronizeSelection=function(o){var k=this.getSelectedKey(),i=this.getItemByKey(""+k),f=true;if(o){f=!!o.forceSelection;}if(this.isSelectionSynchronized({selectedKey:k,firstItemWithKey:i,forceSelection:f})){return;}if(i&&(k!=="")){this.setAssociation("selectedItem",i,true);this.setProperty("selectedItemId",i.getId(),true);}else if(f&&this.getDefaultSelectedItem()&&(!this.isBound("items")||this.bItemsUpdated)){try{this.setSelection(this.getDefaultSelectedItem());}catch(e){L.warning('Update failed due to exception. Loggable in support mode log',null,null,function(){return{exception:e};});}}};
d.prototype.isSelectionSynchronized=function(o){var s=this.getSelectedItem(),e,f,F;if(o){e=o.selectedKey;f=o.firstItemWithKey;F=o.forceSelection;}else{e=this.getSelectedKey();f=this.getItemByKey(e);F=this.getForceSelection();}if(F){if(!s){return false;}if(e===""&&s.getKey()===""){return true;}return e===s.getKey()&&s===f;}else{if(s===null&&e===""){return true;}if(e===""){return false;}return e===(s&&s.getKey())&&s===f;}};
d.prototype.getForceSelection=function(){return false;};
d.prototype.findLastEnabledItem=function(i){i=i||this.getItems();return this.findFirstEnabledItem(i.reverse());};
d.prototype.getVisibleItems=function(){for(var i=0,o,e=this.getItems(),v=[];i<e.length;i++){o=e[i];if(o.bVisible||(o.bVisible===undefined)){v.push(o);}}return v;};
d.prototype.getSelectableItems=function(){return this.getEnabledItems(this.getVisibleItems());};
d.prototype.findItem=function(p,v){var m="get"+p.charAt(0).toUpperCase()+p.slice(1);for(var i=0,e=this.getItems();i<e.length;i++){if(e[i][m]()===v){return e[i];}}return null;};
d.prototype.getItemByText=function(T){return this.findItem("text",T);};
d.prototype.isItemSelected=function(i){return i&&(i.getId()===this.getAssociation("selectedItem"));};
d.prototype._getNonSeparatorItemsCount=function(){return this.getItems().filter(function(i){return!(i instanceof sap.ui.core.SeparatorItem);}).length;};
d.prototype.getDefaultSelectedItem=function(i){return null;};
d.prototype.clearSelection=function(){this.setSelection(null);};
d.prototype.createItemNavigation=function(){var D;if(!this._oItemNavigation){this._oItemNavigation=new I(null,null,!this.getEnabled());this._oItemNavigation.attachEvent(I.Events.AfterFocus,this.onAfterFocus,this);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"]});this.addEventDelegate(this._oItemNavigation);}D=this.getDomRef();this._oItemNavigation.setRootDomRef(D);this._oItemNavigation.setItemDomRefs(this._queryEnabledItemsDomRefs(D));this._oItemNavigation.setCycling(false);this._oItemNavigation.setSelectedIndex(this.indexOfItem(this.getSelectedItem()));this._oItemNavigation.setPageSize(10);};
d.prototype.destroyItemNavigation=function(){if(this._oItemNavigation){this.removeEventDelegate(this._oItemNavigation);this._oItemNavigation.destroy();this._oItemNavigation=null;}};
d.prototype.getItemNavigation=function(){return this._oItemNavigation;};
d.prototype.setSelectedItem=function(i){if(typeof i==="string"){this.setAssociation("selectedItem",i,true);i=C.byId(i);}if(!(i instanceof b)&&i!==null){return this;}if(!i){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;};
d.prototype.setSelectedItemId=function(i){i=this.validateProperty("selectedItemId",i);this.setSelection(i);return this;};
d.prototype.setSelectedKey=function(k){k=this.validateProperty("selectedKey",k);var i=this.getItemByKey(k);if(i||(k==="")){if(!i&&k===""){i=this.getDefaultSelectedItem();}this.setSelection(i);return this;}return this.setProperty("selectedKey",k);};
d.prototype.getSelectedItem=function(){var s=this.getAssociation("selectedItem");return(s===null)?null:C.byId(s)||null;};
d.prototype.getItemAt=function(i){return this.getItems()[+i]||null;};
d.prototype.getFirstItem=function(){return this.getItems()[0]||null;};
d.prototype.getLastItem=function(){var i=this.getItems();return i[i.length-1]||null;};
d.prototype.getEnabledItems=function(i){i=i||this.getItems();return i.filter(function(o){return o.getEnabled();});};
d.prototype.getItemByKey=function(k){return this.findItem("key",k);};
d.prototype.removeItem=function(i){i=this.removeAggregation("items",i);if(this.getItems().length===0){this.clearSelection();}else if(this.isItemSelected(i)){this.setSelection(this.getDefaultSelectedItem());}return i;};
d.prototype.removeAllItems=function(){var i=this.removeAllAggregation("items",true);this.$().children("li").remove();return i;};
d.prototype.destroyItems=function(){this.destroyAggregation("items",true);return this;};
d.prototype.setNoDataText=function(){};
return d;});
sap.ui.predefine('sap/m/SelectListRenderer',["sap/ui/core/Element","sap/ui/core/Icon","sap/ui/core/IconPool","sap/ui/Device"],function(E,I,a,D){"use strict";var S={apiVersion:2};S.CSS_CLASS="sapMSelectList";
S.render=function(r,l){this.writeOpenListTag(r,l,{elementData:true});this.renderItems(r,l);this.writeCloseListTag(r,l);};
S.writeOpenListTag=function(r,l,s){var C=S.CSS_CLASS;if(s.elementData){r.openStart("ul",l);}else{r.openStart("ul");}r.class(C);if(l.getShowSecondaryValues()){r.class(C+"TableLayout");}if(!l.getEnabled()){r.class(C+"Disabled");}r.style("width",l.getWidth());this.writeAccessibilityState(r,l);r.openEnd();};
S.writeCloseListTag=function(r,l){r.close("ul");};
S.renderItems=function(r,l){var s=l._getNonSeparatorItemsCount(),b=l.getItems(),o=l.getSelectedItem(),c=1,d,f;for(var i=0;i<b.length;i++){f=i===0&&!o;d={selected:o===b[i],setsize:s,elementData:true};if(!(b[i]instanceof sap.ui.core.SeparatorItem)){d.posinset=c++;}this.renderItem(r,l,b[i],d,f);}};
S.renderItem=function(r,l,i,s,f){if(!(i instanceof E)){return;}var e=i.getEnabled(),o=l.getSelectedItem(),C=S.CSS_CLASS,t=i.getTooltip_AsString(),b=l.getShowSecondaryValues();r.openStart("li",s.elementData?i:null);if(i.getIcon&&i.getIcon()){r.class("sapMSelectListItemWithIcon");}if(i instanceof sap.ui.core.SeparatorItem){r.class(C+"SeparatorItem");if(b){r.class(C+"Row");}}else{r.class(C+"ItemBase");if(b){r.class(C+"Row");}else{r.class(C+"Item");}if(i.bVisible===false){r.class(C+"ItemBaseInvisible");}if(!e){r.class(C+"ItemBaseDisabled");}if(e&&D.system.desktop){r.class(C+"ItemBaseHoverable");}if(i===o||f){r.class(C+"ItemBaseSelected");}if(e){r.attr("tabindex","0");}}if(t){r.attr("title",t);}this.writeItemAccessibilityState.apply(this,arguments);r.openEnd();if(b){r.openStart("span");r.class(C+"Cell");r.class(C+"FirstCell");r.attr("disabled","disabled");r.openEnd();this._renderIcon(r,i);r.text(i.getText());r.close("span");r.openStart("span");r.class(C+"Cell");r.class(C+"LastCell");r.attr("disabled","disabled");r.openEnd();if(typeof i.getAdditionalText==="function"){r.text(i.getAdditionalText());}r.close("span");}else{this._renderIcon(r,i);r.text(i.getText());}r.close("li");};
S.writeAccessibilityState=function(r,l){r.accessibilityState(l,{role:"listbox"});};
S.writeItemAccessibilityState=function(r,l,i,s){var R=(i.isA("sap.ui.core.SeparatorItem"))?"separator":"option";var d;if(!i.getText()&&i.getIcon&&i.getIcon()){var o=a.getIconInfo(i.getIcon());if(o){d=o.text||o.name;}}r.accessibilityState(i,{role:R,selected:s.selected,setsize:s.setsize,posinset:s.posinset,label:d});};
S._renderIcon=function(r,i){if(i.getIcon&&i.getIcon()){r.icon(i.getIcon(),S.CSS_CLASS+"ItemIcon",{id:i.getId()+"-icon"});}};
return S;},true);
sap.ui.predefine('sap/m/SelectRenderer',['sap/ui/core/Renderer','sap/ui/core/IconPool','sap/m/library','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/library'],function(R,I,l,D,a,c){"use strict";var T=c.TextDirection;var V=c.ValueState;var S=l.SelectType;var b={apiVersion:2};b.CSS_CLASS="sapMSlt";
b.render=function(r,s){var t=s.getTooltip_AsString(),d=s.getType(),A=s.getAutoAdjustWidth(),e=s.getEditable(),E=s.getEnabled(),C=s.getWidth(),w=C.indexOf("%")>-1,f=A||C==="auto"||w,g=b.CSS_CLASS;r.openStart("div",s);this.addClass(r,s);r.class(g);r.class(g+s.getType());if(!E){r.class(g+"Disabled");}else if(!e){r.class(g+"Readonly");}if(f&&(d===S.Default)){r.class(g+"MinWidth");}if(A){r.class(g+"AutoAdjustedWidth");}else{r.style("width",C);}if(s.getIcon()){r.class(g+"WithIcon");}if(E&&e&&D.system.desktop){r.class(g+"Hoverable");}r.class(g+"WithArrow");if(s.getValueState()!==V.None){this.addValueStateClasses(r,s);}r.style("max-width",s.getMaxWidth());if(t){r.attr("title",t);}else if(d===S.IconOnly){var i=I.getIconInfo(s.getIcon());if(i){r.attr("title",i.text);}}r.openEnd();this.renderHiddenSelect(r,s);this.renderLabel(r,s);switch(d){case S.Default:this.renderArrow(r,s);break;case S.IconOnly:this.renderIcon(r,s);break;}var L=s.getList();if(s._isShadowListRequired()&&L){this.renderShadowList(r,L);}r.close("div");};
b.renderHiddenSelect=function(r,s){var L=s.getList(),d,i;r.openStart("select",s.getId()+"-hiddenSelect");this.writeAccessibilityState(r,s);if(s.getRequired()){r.attr("required","required");}if(!s.getEnabled()){r.attr("disabled","disabled");}r.attr("name",s.getName());r.attr("value",s.getSelectedKey());r.class("sapUiPseudoInvisibleText");r.class(b.CSS_CLASS+"HiddenSelect");r.openEnd();for(i=0,d=L.getItems();i<d.length;i++){r.openStart("option");r.attr("value",d[i].getText());r.attr("hidden",true);r.openEnd();r.text(d[i].getText());r.close("option");}r.close('select');};
b.renderLabel=function(r,s){var o=s.getSelectedItem(),t=s.getTextDirection(),d=R.getTextAlign(s.getTextAlign(),t),C=b.CSS_CLASS;r.openStart("span",s.getId()+"-label");r.class(C+"Label");if(s.getValueState()!==V.None){r.class(C+"LabelState");r.class(C+"Label"+s.getValueState());}if(s.getType()===S.IconOnly){r.class("sapUiPseudoInvisibleText");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.style("text-align",d);r.openEnd();if(s.getType()!==S.IconOnly){r.renderControl(s._getValueIcon());r.openStart("span",s.getId()+"-labelText");r.class("sapMSelectListItemText");r.openEnd();r.text(o&&o.getParent()?o.getText():null);r.close("span");}r.close("span");};
b.renderArrow=function(r,s){var C=b.CSS_CLASS;r.openStart("span",s.getId()+"-arrow");r.class(C+"Arrow");if(s.getValueState()!==V.None){r.class(C+"ArrowState");}r.openEnd().close("span");};
b.renderIcon=function(r,s){var t=s.getTooltip_AsString();r.icon(s.getIcon(),b.CSS_CLASS+"Icon",{id:s.getId()+"-icon",title:t||null});};
b.renderShadowList=function(r,L){var o=L.getRenderer();o.writeOpenListTag(r,L,{elementData:false});this.renderShadowItems(r,L);o.writeCloseListTag(r,L);};
b.renderShadowItems=function(r,L){var o=L.getRenderer(),s=L.getItems().length,d=L.getSelectedItem();for(var i=0,e=L.getItems();i<e.length;i++){o.renderItem(r,L,e[i],{selected:d===e[i],setsize:s,posinset:i+1,elementData:false});}};
b.addClass=function(r,s){};
b.addValueStateClasses=function(r,s){r.class(b.CSS_CLASS+"State");r.class(b.CSS_CLASS+s.getValueState());};
b.getAriaRole=function(s){switch(s.getType()){case S.Default:return"combobox";case S.IconOnly:return"button";}};
b._getValueStateString=function(s){var C="sap.ui.core";switch(s.getValueState()){case V.Success:return a.getStaticId(C,"VALUE_STATE_SUCCESS");case V.Warning:return a.getStaticId(C,"VALUE_STATE_WARNING");case V.Information:return a.getStaticId(C,"VALUE_STATE_INFORMATION");}return"";};
b.writeAccessibilityState=function(r,s){var v=this._getValueStateString(s),o=s.getSelectedItem(),i=s.getType()===S.IconOnly,d=s._getValueIcon(),L=[],A=[],e,f,g;s.getLabels().forEach(function(j){if(j&&j.getId){L.push(j.getId());}});if(s.isOpen()&&o&&o.getDomRef()){f=o.getId();}if(o&&!o.getText()&&o.getIcon&&o.getIcon()){var h=I.getIconInfo(o.getIcon());if(h){g=h.text||h.name;}}if(g&&d){v=d.getId();}if(v){A.push(v);}if(L.length){A=A.concat(L);}e={value:A.join(" "),append:true};r.accessibilityState(null,{role:this.getAriaRole(s),roledescription:s._sAriaRoleDescription,readonly:i?undefined:s.getEnabled()&&!s.getEditable(),expanded:s.isOpen(),invalid:(s.getValueState()===V.Error)?true:undefined,labelledby:(i||e.value==="")?undefined:e,activedescendant:f,haspopup:"listbox"});};
return b;},true);
sap.ui.predefine('sap/m/SelectionDetails',['./library','sap/ui/core/Control','sap/m/Button','sap/ui/base/Interface','sap/ui/Device','sap/ui/core/library','./SelectionDetailsRenderer',"sap/base/util/uid","sap/ui/thirdparty/jquery"],function(l,C,B,I,D,a,S,u,q){"use strict";
var b=C.extend("sap.m.SelectionDetails",{metadata:{library:"sap.m",defaultAggregation:"items",aggregations:{"items":{type:"sap.m.SelectionDetailsItem",multiple:true,bindable:"bindable"},"actions":{type:"sap.ui.core.Item",multiple:true},"actionGroups":{type:"sap.ui.core.Item",multiple:true},"_popover":{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"},"_button":{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{beforeOpen:{},beforeClose:{},navigate:{parameters:{item:{type:"sap.m.SelectionDetailsItem"},direction:{type:"string"},content:{type:"sap.ui.core.Control"}}},actionPress:{parameters:{action:{type:"sap.ui.core.Item"},items:{type:"sap.m.SelectionDetailsItem"},level:{type:"sap.m.SelectionDetailsActionLevel"}}}}}});
b._MAX_ACTIONGROUPS=5;b._POPOVER_MAX_HEIGHT=500;
b.prototype.init=function(){this._bWrapLabels=false;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_button",new B({id:this.getId()+"-button",type:l.ButtonType.Transparent,press:[this._onToolbarButtonPress,this]}),true);this._oItemFactory=null;};
b.prototype.onBeforeRendering=function(){this._updateButton();};
b.prototype.exit=function(){this.detachSelectionHandler();this._oItemFactory=null;this._oChangeHandler=null;};
b.prototype.isOpen=function(){var p=this.getAggregation("_popover");return p?p.isOpen():false;};
b.prototype.isEnabled=function(){return this.getItems().length>0;};
b.prototype.close=function(){var p=this.getAggregation("_popover");if(p){p.close();}return this;};
b.prototype.navTo=function(t,c){if(this.isOpen()){sap.ui.require(["sap/m/Page","sap/m/Toolbar","sap/m/ToolbarSpacer","sap/m/Title"],this._handleNavLazy.bind(this,t,c));}return this;};
b.prototype.getWrapLabels=function(){return this._bWrapLabels;};
b.prototype.setWrapLabels=function(w){var p=this.getAggregation("_popover");this._bWrapLabels=w;if(p&&p.isOpen()){p.invalidate();}return this;};
b.prototype.setPopoverModal=function(m){this._getPopover().setModal(m);return this;};
b.prototype._handleNavLazy=function(p,c,P,T,d,e,B){var s=this.getId()+"-page-for-"+c.getId()+"-uid-"+u();this._setPopoverHeight(b._POPOVER_MAX_HEIGHT);var o=new P(s,{customHeader:this._getPageToolbar(T,d,e,true,p),content:[c]});this._oNavContainer.addPage(o);this._oNavContainer.to(s);};
b.prototype._getPageToolbar=function(T,c,d,s,p){var t=new T({design:l.ToolbarDesign.Transparent}).addStyleClass("sapMSDPageHeader");if(s){var o=new B({icon:"sap-icon://nav-back",press:this._onBackButtonPress.bind(this)});t.addAggregation("content",o,true);}var e=new c();var f=new d({text:p,titleStyle:a.TitleLevel.H5});t.addAggregation("content",e,true);t.addAggregation("content",f,true);t.addAggregation("content",e.clone(),true);if(D.system.phone){t.addAggregation("content",this._getCloseButton(),true);}return t;};
b.prototype._setPopoverHeight=function(h){if(!D.system.phone){var p=this._getPopover(),P=p.$("cont"),m=this._getMaxPopoverHeight();h=Math.min(b._POPOVER_MAX_HEIGHT,h);p._oControl._deregisterContentResizeHandler();P.animate({"height":Math.min(h,m)},sap.ui.getCore().getConfiguration().getAnimation()?100:0,function(){p.setProperty("contentHeight",h+"px",true);p._oControl._registerContentResizeHandler();});}};
b.prototype._getMaxPopoverHeight=function(){var r=this._getPopover(),R=r.$(),o,v,p;if(!R.length){return 0;}o=R.offset().top;v=D.resize.height;p=r._oControl;p._adaptPositionParams();return v-o-p._marginBottom;};
b.prototype._onBackButtonPress=function(){var c=this._oNavContainer.getCurrentPage().getContent()[0];this._oNavContainer.attachEventOnce("afterNavigate",function(){this.fireNavigate({item:this._oItemForNavigation,direction:"back",content:c});},this);this._oNavContainer.back();if(this._oNavContainer.getCurrentPage()===this._oInitialPage){this._setPopoverHeight(this._getInitialPageHeight());}};
b.prototype._getCloseButton=function(){return new B({icon:"sap-icon://decline",press:this.close.bind(this)});};
b.prototype._aFacadeMethods=["addCustomData","getCustomData","indexOfCustomData","insertCustomData","removeCustomData","removeAllCustomData","destroyCustomData","data","addEventDelegate","removeEventDelegate","close","isOpen","isEnabled","attachBeforeOpen","detachBeforeOpen","attachBeforeClose","detachBeforeClose","attachNavigate","detachNavigate","attachActionPress","detachActionPress","addAction","removeAction","removeAllActions","addActionGroup","removeActionGroup","removeAllActionGroups","navTo","getWrapLabels","setWrapLabels"];
b.prototype.getFacade=function(){var f=new I(this,b.prototype._aFacadeMethods,true);f.getItems=this._getItemFacades.bind(this);this.getFacade=function(){return f;};return f;};
b.prototype._getItemFacades=function(){var c=this.getItems();var d=[];for(var i=0;i<c.length;i++){d.push(c[i].getFacade());}return d;};
b.prototype._updateButton=function(){var t,c,o=this.getAggregation("_button");if(this._oSelectionData&&this._oSelectionData.length>=0){c=this._oSelectionData.length;}else{c=this.getItems().length;}if(c>0){t=this._oRb.getText("SELECTIONDETAILS_BUTTON_TEXT_WITH_NUMBER",[c]);o.setProperty("text",t,true);o.setProperty("enabled",true,true);o.setAggregation("tooltip",t,true);}else{t=this._oRb.getText("SELECTIONDETAILS_BUTTON_TEXT");o.setProperty("text",t,true);o.setProperty("enabled",false,true);o.setAggregation("tooltip",t,true);}};
b.prototype._onToolbarButtonPress=function(){sap.ui.require(['sap/m/NavContainer','sap/m/ResponsivePopover','sap/m/Page',"sap/m/Toolbar",'sap/m/OverflowToolbar','sap/m/ToolbarSpacer','sap/m/Button','sap/m/List','sap/m/StandardListItem','sap/ui/layout/FixFlex','sap/m/ScrollContainer',"sap/m/Title"],this._handlePressLazy.bind(this));};
b.prototype._handlePressLazy=function(N,R,P,T,O,c,B,L,d,F,e,f){var p=this._getPopover(N,R,T,c,P,L,F,e,f);if(this._oItemFactory){this._callFactory();}this.fireBeforeOpen();this._addMainListItems();this._addActionGroupListItems(d);this._addListActions(O,c,B);this._oNavContainer.setProperty("defaultTransitionName","show",true);this._oNavContainer.to(this._oInitialPage);this._oNavContainer.setProperty("defaultTransitionName","slide",true);p.openBy(this.getAggregation("_button"));p.invalidate();};
b.prototype._callFactory=function(){var f=this._oItemFactory.factory,d=this._oItemFactory.data,s=this._oSelectionData,r;this.fireEvent("beforeUpdate",{items:this.getItems()});this.destroyAggregation("items",true);for(var i=0;i<s.length;i++){r=f(s[i].displayData,s[i].data,s[i].context,d,s[i].shapeString);if(r){r._sMarkerShapeString=s[i].shapeString;this.addAggregation("items",r,true);}}this.fireEvent("afterUpdate",{items:this.getItems()});};
b.prototype._getInitialPage=function(P,T,c,d){if(!this._oInitialPage){this._oInitialPage=new P(this.getId()+"-page",{showHeader:false,enableScrolling:false});if(D.system.phone){this._oInitialPage.setProperty("showHeader",true,true);this._oInitialPage.setAggregation("customHeader",this._getPageToolbar(T,c,d),true);}}return this._oInitialPage;};
b.prototype._getNavContainer=function(N){return this._oNavContainer||(this._oNavContainer=new N(this.getId()+"-nav-container"));};
b.prototype._getPopover=function(N,R,T,c,P,L,F,d,e){var p=this.getAggregation("_popover"),n,o,m,A,M;if(!p){p=new R({id:this.getId()+"-popover",placement:l.PlacementType.Bottom,showHeader:false,contentWidth:"25rem",contentHeight:"500px",beforeClose:this.fireBeforeClose.bind(this)}).addStyleClass("sapMSD");p.setProperty=this._setPopoverProperty;o=this._getInitialPage(P,T,c,e);A=this._getActionGroupList(L);n=this._getNavContainer(N);M=this._getMainList(L);m=this._createMainContainer(F);m.setAggregation("flexContent",M,true);m.addAggregation("fixContent",A,true);o.addAggregation("content",m,true);n.addPage(o);p.addAggregation("content",n,true);if(!D.system.phone){p.addEventDelegate({onAfterRendering:this._updatePopoverContentHeight.bind(this)});}p.addEventDelegate({onBeforeRendering:function(){this.getWrapLabels()?p.addStyleClass("sapMSDWrapLabels"):p.removeStyleClass("sapMSDWrapLabels");}.bind(this)});this.setAggregation("_popover",p,true);}return p;};
b.prototype._setPopoverProperty=function(p,v){var P=this._oControl.getMetadata().getProperty(p);if(P&&p==="modal"&&this._oControl.setModal){this._oControl.setModal(v);}else{this._oControl.setProperty.apply(this._oControl,arguments);}return C.prototype.setProperty.apply(this,arguments);};
b.prototype._updatePopoverContentHeight=function(){var c=this._getInitialPageHeight(),p=this._getPopover();if(D.browser.edge&&this._oMainList.getDomRef()&&this._oMainList.getDomRef().getBoundingClientRect().height===0){p.setContentHeight(b._POPOVER_MAX_HEIGHT+"px");return;}if(this._oNavContainer.getCurrentPage()===this._oInitialPage&&c<b._POPOVER_MAX_HEIGHT){p.setProperty("contentHeight",c+"px",true);}else{p.setProperty("contentHeight",b._POPOVER_MAX_HEIGHT+"px",true);}};
b.prototype._getInitialPageHeight=function(){var f=this._oInitialPage&&this._oInitialPage.getFooter(),L=this._oMainList.$().outerHeight(),A=this._oActionGroupList.$().outerHeight(),t=f&&f.$().outerHeight()||0;return L+A+t;};
b.prototype._createMainContainer=function(F){return new F(this.getId()+"-mainContainer",{fixFirst:false,minFlexSize:-1});};
b.prototype._getMainList=function(L){if(!this._oMainList){this._oMainList=new L(this.getId()+"-list");}return this._oMainList;};
b.prototype._addMainListItems=function(){var i,c,L;this._oMainList.removeAllAggregation("items",true);c=this.getItems();for(i=0;i<c.length;i++){if(!c[i].hasListeners("_navigate")){c[i].attachEvent("_navigate",this._onNavigate,this);}if(!c[i].hasListeners("_actionPress")){c[i].attachEvent("_actionPress",this._onActionPress,this);}L=c[i]._getListItem();this._oMainList.addAggregation("items",L,true);}};
b.prototype._getActionGroupList=function(L){if(!this._oActionGroupList){this._oActionGroupList=new L(this.getId()+"-actionGroupList",{showNoData:false});}return this._oActionGroupList;};
b.prototype._addActionGroupListItems=function(c){this._oActionGroupList.destroyAggregation("items",true);var A=this.getActionGroups(),s,i,d=Math.min(b._MAX_ACTIONGROUPS,A.length);for(i=0;i<d;i++){s=new c(this.getId()+"-actionGroup-"+i,{title:A[i].getText(),type:l.ListType.Navigation,press:[{action:A[i],level:l.SelectionDetailsActionLevel.Group},this._onActionPress,this]});if(i===0){s.addStyleClass("sapMSDFirstActionGroup");}this._oActionGroupList.addAggregation("items",s,true);}};
b.prototype._addListActions=function(O,T,B){var o,i,A,c,t;this._oInitialPage.destroyAggregation("footer",true);if(!this.getActions().length){return;}t=new O(this.getId()+"-action-toolbar").addStyleClass("sapContrast sapContrastPlus");this._oInitialPage.setAggregation("footer",t,true);t.addAggregation("content",new T(),true);A=this.getActions();for(i=0;i<A.length;i++){c=A[i];o=new B(this.getId()+"-action-"+i,{text:c.getText(),enabled:c.getEnabled(),press:[{action:c,level:l.SelectionDetailsActionLevel.List},this._onActionPress,this]});t.addAggregation("content",o,true);}};
b.prototype._onActionPress=function(e,d){this.fireActionPress({action:d&&d.action||e.getParameter("action"),items:e.getParameter("items")||this.getItems(),level:d&&d.level||e.getParameter("level")});};
b.prototype._onNavigate=function(e){this._oItemForNavigation=e.getSource();this.fireNavigate({item:e.getSource(),direction:"to"});};
b.prototype._handleSelectionChange=function(e){var E=e.getParameter("data");if(Array.isArray(E)){this._oSelectionData=E;this._updateButton();this.getAggregation("_button").rerender();}};
b.prototype.registerSelectionDetailsItemFactory=function(d,f){if(typeof(d)==="function"){f=d;d=undefined;}if(typeof f==="function"){this._oItemFactory={factory:f,data:d};}return this;};
b.prototype.attachSelectionHandler=function(e,c){if(!this._oChangeHandler&&typeof e==="string"&&c&&typeof c.attachEvent==="function"){this._oChangeHandler={eventId:e,listener:c};c.attachEvent(e,this._handleSelectionChange,this);}return this;};
b.prototype.detachSelectionHandler=function(){if(this._oChangeHandler){this._oChangeHandler.listener.detachEvent(this._oChangeHandler.eventId,this._handleSelectionChange,this);this._oChangeHandler=null;}return this;};
return b;});
sap.ui.predefine('sap/m/SelectionDetailsItem',["sap/ui/core/Element","sap/m/ListItemBase","./library","sap/m/Button","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/ui/base/Interface"],function(E,L,l,B,O,T,I){"use strict";
var S=L.extend("sap.m.SelectionDetailsListItem");
S.prototype.onBeforeRendering=function(){var t;if(this._getParentElement().getEnableNav()){t=l.ListType.Navigation;}else{t=l.ListType.Inactive;}this.setProperty("type",t,true);};
var a=E.extend("sap.m.SelectionDetailsItem",{metadata:{library:"sap.m",properties:{enableNav:{type:"boolean",defaultValue:false,group:"Behavior"}},aggregations:{lines:{type:"sap.m.SelectionDetailsItemLine",multiple:true,bindable:"bindable"},actions:{type:"sap.ui.core.Item",multiple:true},_overflowToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"}}}});
a.prototype.exit=function(){if(this._oListItem){this._oListItem.destroy();this._oListItem=null;}};
a.prototype._aFacadeMethods=["addCustomData","getCustomData","indexOfCustomData","insertCustomData","removeCustomData","removeAllCustomData","destroyCustomData","data","addEventDelegate","removeEventDelegate","setEnableNav","getEnableNav","addAction","removeAction"];
a.prototype.getFacade=function(){var f=new I(this,a.prototype._aFacadeMethods);this.getFacade=function(){return f;};return f;};
a.prototype._getListItem=function(){if(!this._oListItem){this._oListItem=new S({press:[this._onSelectionDetailsListItemPress,this]});this._oListItem._getParentElement=function(){return this;}.bind(this);this._addOverflowToolbar();}return this._oListItem;};
a.prototype._onSelectionDetailsListItemPress=function(){this.fireEvent("_navigate");};
a.prototype._addOverflowToolbar=function(){var b=this.getActions(),i,o;this.destroyAggregation("_overflowToolbar");if(b.length===0){return;}var t=new O(this.getId()+"-action-toolbar");this.setAggregation("_overflowToolbar",t,true);t.addAggregation("content",new T(),true);for(i=0;i<b.length;i++){o=new B(this.getId()+"-action-"+i,{text:b[i].getText(),type:l.ButtonType.Transparent,enabled:b[i].getEnabled(),press:[b[i],this._onActionPress,this]});t.addAggregation("content",o,true);}};
a.prototype._onActionPress=function(e,A){this.fireEvent("_actionPress",{action:A,items:[this],level:l.SelectionDetailsActionLevel.Item});};
return a;});
sap.ui.predefine('sap/m/SelectionDetailsItemLine',["sap/ui/core/Element","sap/base/Log","sap/base/util/isPlainObject","sap/ui/thirdparty/jquery"],function(E,L,i,q){"use strict";
var S=E.extend("sap.m.SelectionDetailsItemLine",{metadata:{library:"sap.m",properties:{label:{type:"string",group:"Data"},value:{type:"any",group:"Data"},displayValue:{type:"string",defaultValue:null,group:"Data"},unit:{type:"string",defaultValue:null,group:"Data"},lineMarker:{type:"string",defaultValue:null,group:"Data"}}}});
S.prototype._getValueToRender=function(){var v="",V=this.getValue();if(typeof V==="string"||V instanceof String){v=V;}else if(typeof V==="number"){v=V.toString();}else if(i(V)){if(V.day&&V.day.length>0){v=V.day;}if(V.time&&V.time.length>0){v=(v.length>0)?V.time+" "+v:V.time;}}else{L.warning("Value '"+V+"' is not supported. Expected type is a string, number or a plain object, including date and time properties of type string.");}return v;};
return S;});
sap.ui.predefine('sap/m/SelectionDetailsListItemRenderer',["sap/ui/core/Renderer","sap/m/ListItemBaseRenderer"],function(R,L){"use strict";var T={"svg":{attributes:["width","height","focusable","preserveAspectRatio"]},"path":{attributes:["d","fill","transform","stroke","stroke-width"]},"line":{attributes:["x1","x2","y1","y2","stroke-width","stroke","stroke-dasharray","stroke-linecap"]}},I;try{var p=new DOMParser();I=p.parseFromString("<svg/>","text/html")!==null;}catch(e){I=false;}var P;if(I){P=function(s){var p=new DOMParser(),d=p.parseFromString(s,"text/html");return d.body.childNodes;};}else{P=function(s){var d=document.implementation.createHTMLDocument("");d.body.innerHTML=s;return d.body.childNodes;};}
function a(d,c){var i;if(!d){return true;}for(i=0;i<d.length;i++){if(!c(d[i])){return false;}}return true;}
function b(n){if(n.nodeType!==window.Node.ELEMENT_NODE){return true;}var t=n.tagName.toLowerCase(),o=T[t],c;if(!o){return false;}c=a(n.attributes,function(d){if(d.value===""){return true;}var A=d.name.toLowerCase();return o.attributes.indexOf(A)>=0;});if(!c){return false;}if(!o.allowTextContenet&&n.textContent.trim().length>0){return false;}return a(n.childNodes,b);}
var S=R.extend(L);
S.renderLIAttributes=function(r,c){r.addClass("sapMSDItem");r.writeClasses();};
S.renderLIContent=function(r,c){var l=c._getParentElement().getLines();r.write("<div");r.addClass("sapMSDItemLines");r.writeClasses();r.write(">");for(var i=0;i<l.length;i++){this.renderLine(r,c,l[i]);}r.write("</div>");L.renderType(r,c);};
S._isValidSvg=function(d){try{var n=P(d);if(n.length===0){return false;}return a(n,b);}catch(e){return false;}};
S.renderLine=function(r,c,l){var u=l.getUnit().trim(),v=l._getValueToRender(),d=l.getDisplayValue(),s=l.getLineMarker();r.write("<div");r.addClass("sapMSDItemLine");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMSDItemLineMarkerContainer");r.writeClasses();r.write(">");if(s&&S._isValidSvg(s)){r.write(s);}r.write("</div>");r.write("<div");r.addClass("sapMSDItemLineLabel");r.writeClasses();r.write(">");r.writeEscaped(l.getLabel());r.write("</div>");r.write("<div");r.addClass("sapMSDItemLineValue");if(u){r.addClass("sapMSDItemLineBold");}r.writeClasses();r.write(">");if(d){r.writeEscaped(d);}else{r.writeEscaped(v);}if(u){r.write("<span");r.addClass("sapMSDItemLineUnit");r.writeClasses();r.write(">");r.write("&nbsp;");r.writeEscaped(u);r.write("</span>");}r.write("</div>");r.write("</div>");};
S.renderType=function(r,c){var t=c._getParentElement().getAggregation("_overflowToolbar");if(t){r.write("<div");r.addClass("sapMSDItemActions");r.writeClasses();r.write(">");r.renderControl(t);r.write("</div>");}};
return S;},true);
sap.ui.predefine('sap/m/SelectionDetailsRenderer',['sap/ui/core/Renderer','sap/m/ButtonRenderer'],function(R,B){"use strict";var S=R.extend(B);
S.render=function(r,c){var b=c.getAggregation("_button");r.write("<div");r.writeControlData(c);r.write(">");r.renderControl(b);r.write("</div>");};
return S;},true);
sap.ui.predefine('sap/m/Shell',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/library','sap/m/ShellRenderer',"sap/ui/util/Mobile","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,C,a,c,S,M,L,q){"use strict";var T=c.TitleLevel;
var b=a.extend("sap.m.Shell",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},logo:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},showLogout:{type:"boolean",group:"Behavior",defaultValue:true},headerRightText:{type:"string",group:"Data",defaultValue:null},appWidthLimited:{type:"boolean",group:"Appearance",defaultValue:true},backgroundColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1},homeIcon:{type:"object",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:T.H1}},defaultAggregation:"app",aggregations:{app:{type:"sap.ui.core.Control",multiple:false}},events:{logout:{}}}});
b.prototype.init=function(){C.attachThemeChanged(q.proxy(function(){var $=this.$("hdr");if($.length){$.find(".sapMShellLogo").remove();var r=C.createRenderManager();var h=S.getLogoImageHtml(r,this);$.prepend(q(h));}},this));M.init({statusBar:"default",hideBrowser:true});};
b.prototype.onAfterRendering=function(){var r=this.getDomRef().parentNode,$;if(r&&!r._sapui5_heightFixed){r._sapui5_heightFixed=true;while(r&&r!==document.documentElement){$=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}}this.$("content").css("height","");};
b.prototype.ontap=function(e){if(e.target.className&&e.target.className.indexOf&&e.target.className.indexOf("sapMShellHeaderLogout")>-1){this.fireLogout();}};
b.prototype.setTitle=function(t){this.$("hdrTxt").text(t);this.setProperty("title",t,true);return this;};
b.prototype.setHeaderRightText=function(t){this.setProperty("headerRightText",t,true);if(!t){t="";}this.$("hdrRightTxt").text(t).css("display",(!!t?"inline":"none"));return this;};
b.prototype.setAppWidthLimited=function(d){this.$().toggleClass("sapMShellAppWidthLimited",d);this.setProperty("appWidthLimited",d,true);return this;};
b.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for Shell.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}this.$("BG").css("opacity",o);return this.setProperty("backgroundOpacity",o,true);};
b.prototype.setHomeIcon=function(i){this.setProperty("homeIcon",i,true);M.setIcons(i);return this;};
return b;});
sap.ui.predefine('sap/m/ShellRenderer',['sap/ui/core/library','sap/m/library','sap/ui/Device'],function(c,l,D){"use strict";var B=l.BackgroundHelper;var T=c.TitleLevel;var S={apiVersion:2};
S.render=function(r,C){var t=(C.getTitleLevel()===T.Auto)?T.H1:C.getTitleLevel();t=t.toLowerCase();r.openStart("div",C);r.class("sapMShell");if(C.getAppWidthLimited()){r.class("sapMShellAppWidthLimited");}B.addBackgroundColorStyles(r,C.getBackgroundColor(),C.getBackgroundImage(),"sapMShellGlobalOuterBackground");var s=C.getTooltip_AsString();if(s){r.attr("title",s);}r.openEnd();B.renderBackgroundImageTag(r,C,["sapContrastPlus","sapMShellBG","sapUiGlobalBackgroundImageForce"],C.getBackgroundImage(),C.getBackgroundRepeat(),C.getBackgroundOpacity());r.openStart("div");r.class("sapMShellBrandingBar");r.openEnd();r.close("div");r.openStart("div");r.class("sapMShellCentralBox");r.openEnd();var e="",a="";if(!C.getBackgroundImage()){e="sapMShellBackgroundColorOnlyIfDefault";a="sapUiGlobalBackgroundImageOnlyIfDefault";}r.openStart("header",C.getId()+"-hdr");r.class("sapMShellHeader");r.class(e);r.openEnd();r.openStart("div");r.class(a);r.openEnd();r.close("div");S.getLogoImageHtml(r,C);if(C.getTitle()){r.openStart(t,C.getId()+"-hdrTxt");r.class("sapMShellHeaderText");r.openEnd();r.text(C.getTitle());r.close(t);}r.openStart("span");r.class("sapMShellHeaderRight");r.openEnd();r.openStart("span",C.getId()+"-hdrRightTxt");if(!C.getHeaderRightText()){r.style("display","none");}r.class("sapMShellHeaderRightText");r.openEnd();r.text(C.getHeaderRightText());r.close("span");if(C.getShowLogout()){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.openStart("a",C.getId()+"-logout");r.attr("tabindex","0");r.attr("role","button");r.class("sapMShellHeaderLogout");r.openEnd();r.text(b.getText("SHELL_LOGOUT"));r.close("a");}r.close("span");r.close("header");r.openStart("div",C.getId()+"-content");r.attr("data-sap-ui-root-content","true");r.class("sapMShellContent");r.class("sapMShellGlobalInnerBackground");r.openEnd();r.renderControl(C.getApp());r.close("div");r.close("div");r.close("div");};
S.getLogoImageHtml=function(r,C){var i=C.getLogo();if(!i){jQuery.sap.require("sap.ui.core.theming.Parameters");i=sap.ui.core.theming.Parameters._getThemeImage();}if(i){var R=sap.ui.getCore().getLibraryResourceBundle("sap.m");r.openStart("div");r.class("sapMShellLogo");r.openEnd();if(D.browser.msie){r.openStart("span");r.class("sapMShellLogoImgAligner");r.openEnd();r.close("span");}r.voidStart("img",C.getId()+"-logo");r.class("sapMShellLogoImg");r.attr("src",i);r.attr("alt",R.getText("SHELL_ARIA_LOGO"));r.voidEnd();r.close("div");}};
return S;},true);
sap.ui.predefine('sap/m/SimpleFixFlex',['sap/ui/core/Control','sap/ui/core/ResizeHandler','sap/base/Log','./SimpleFixFlexRenderer'],function(C,R,L){"use strict";
var S=C.extend("sap.m.SimpleFixFlex",{metadata:{library:"sap.m",aggregations:{fixContent:{type:"sap.ui.core.Control",multiple:false},flexContent:{type:"sap.ui.core.Control",multiple:true}},properties:{fitParent:{type:"boolean",group:"Appearance",defaultValue:true}}}});
S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION=200;S.FIX_AREA_CHARACTERS_ABOVE_RECOMMENDED_WARNING="It is recommended to use less than "+S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION+" characters as a value state text.";
S.prototype.onBeforeRendering=function(){this._deregisterFixContentResizeHandler();var f=this.getFixContent();if(f&&f.isA("sap.m.Text")&&f.getText().length>S.FIX_AREA_CHARACTER_COUNT_RECOMMENDATION){L.warning(S.FIX_AREA_CHARACTERS_ABOVE_RECOMMENDED_WARNING,"",this.getId());}};
S.prototype.onAfterRendering=function(){if(this.getFitParent()){this._registerFixContentResizeHandler();}};
S.prototype._registerFixContentResizeHandler=function(){var f=this.getFixContent();if(!this._sResizeListenerId&&f&&f.getDomRef()){this._sResizeListenerId=R.register(f.getDomRef(),this._onFixContentResize.bind(this));this._onFixContentResize();}};
S.prototype._deregisterFixContentResizeHandler=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
S.prototype._onFixContentResize=function(){var $=this.$(),a=this.getFixContent().$(),f=a.get(0);if(!f||!f.clientHeight){return null;}$.css("padding-top",f.clientHeight);a.addClass("sapUiSimpleFixFlexFixedWrap");};
S.prototype.exit=function(){this._deregisterFixContentResizeHandler();};
return S;});
sap.ui.predefine('sap/m/SimpleFixFlexRenderer',[],function(){"use strict";var S={};
S.render=function(r,c){var f=c.getFixContent();r.write('<div');r.addClass('sapUiSimpleFixFlex');r.writeControlData(c);r.writeClasses();r.write('>');if(f){r.renderControl(f.addStyleClass('sapUiSimpleFixFlexFixed'));}this.renderFlexContentContainer(r,c);r.write('</div>');};
S.renderFlexContentContainer=function(r,c){var f=c.getFlexContent();r.write('<div');r.writeAttribute("id",c.getId()+"-flexContentContainer");r.addClass('sapUiSimpleFixFlexFlexContentContainer');r.writeClasses();r.write('>');if(f){r.write('<div');r.addClass('sapUiSimpleFixFlexFlexContent');r.writeClasses();r.write('>');f.forEach(function(c){r.renderControl(c);});r.write('</div>');}r.write('</div>');};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarDayView',['./library','./SinglePlanningCalendarView'],function(l,S){"use strict";
var a=S.extend("sap.m.SinglePlanningCalendarDayView",{metadata:{library:"sap.m"}});
a.prototype.getEntityCount=function(){return 1;};
a.prototype.getScrollEntityCount=function(){return 1;};
a.prototype.calculateStartDate=function(s){return s;};
return a;});
sap.ui.predefine('sap/m/SinglePlanningCalendarRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var h=c._getHeader(),g=c._getCurrentGrid();r.openStart("div",c);r.accessibilityState({role:"region",roledescription:c._oRB.getText("SPC_CONTROL_NAME"),labelledby:{value:h.getId()+"-Title "+g.getId()+"-nowMarkerText",append:true}});r.class("sapMSinglePC");r.openEnd();r.renderControl(h);r.renderControl(g);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/SinglePlanningCalendarUtilities',[],function(){'use strict';
function A(d){this.data=d;this.level=0;this.width=1;this.prev=null;this.next=null;}
A.prototype.hasNext=function(){return this.next!==null;};
A.prototype.hasPrev=function(){return this.prev!==null;};
A.prototype.getData=function(){return this.data;};
function a(){this.head=null;this.tail=null;this.size=0;this.iterator=new b(this);}
a.prototype.getHeadNode=function(){return this.head;};
a.prototype.getTailNode=function(){return this.tail;};
a.prototype.getSize=function(){return this.size;};
a.prototype.isEmpty=function(){return this.getSize()===0;};
a.prototype.createNewNode=function(d){return new A(d);};
a.prototype.getIterator=function(){return this.iterator;};
a.prototype.indexOf=function(n,c){this.iterator.reset();var C,i=0;while(this.iterator.hasNext()){C=this.iterator.next();if(c(C)){return i;}i++;}return-1;};
a.prototype.add=function(d){var n=d;if(!(d instanceof A)){n=this.createNewNode(d);}if(this.isEmpty()){this.head=this.tail=n;}else{this.tail.next=n;n.prev=this.tail;this.tail=n;}this.size++;return true;};
a.prototype.insertFirst=function(d){if(this.isEmpty()){this.add(d);}else{var n=d;if(!(d instanceof A)){n=this.createNewNode(d);}n.next=this.head;this.head.prev=n;this.head=n;this.size++;return true;}};
a.prototype.insertAt=function(i,d){var c=this.getHeadNode(),p=0,n=d;if(!(d instanceof A)){n=this.createNewNode(d);}if(i<0){return false;}if(i===0){return this.insertFirst(d);}if(i>this.getSize()-1){return this.add(d);}while(p<i){c=c.next;p++;}c.prev.next=n;n.prev=c.prev;c.prev=n;n.next=c;this.size++;return true;};
a.prototype.insertAfterLevel=function(l,n){var i=this.indexOf(n,function(c){var L=c.level===l;if(c.next&&c.next.level===l){L=false;}return L;}),s=this.getSize();if(i+1===s||i===-1){return this.add(n);}else{return this.insertAt(i+1,n);}};
function b(l){this.list=l;this.stopIterationFlag=false;this.currentNode=null;}
b.prototype.next=function(){var c=this.currentNode;if(this.currentNode!==null){this.currentNode=this.currentNode.next;}return c;};
b.prototype.hasNext=function(){return this.currentNode!==null;};
b.prototype.reset=function(){this.currentNode=this.list.getHeadNode();return this;};
b.prototype.forEach=function(c,t){var C;t=t||this;this.reset();while(this.hasNext()&&!this.stopIterationFlag){C=this.next();c.call(t,C);}this.stopIterationFlag=false;};
b.prototype.interrupt=function(){this.stopIterationFlag=true;return this;};
return{iterator:b,node:A,list:a};});
sap.ui.predefine('sap/m/SinglePlanningCalendarView',['./library','sap/base/Log','sap/ui/core/Element'],function(l,L,E){"use strict";
var S=E.extend("sap.m.SinglePlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data"},title:{type:"string",group:"Appereance"}}}});
S.prototype.getEntityCount=function(){L.warning("This method should be implemented in one of the inherited classes.",this);};
S.prototype.getScrollEntityCount=function(){L.warning("This method should be implemented in one of the inherited classes.",this);};
S.prototype.calculateStartDate=function(d){L.warning("This method should be implemented in one of the inherited classes.",this);};
return S;});
sap.ui.predefine('sap/m/SlideTile',['./library','sap/ui/core/Control','sap/m/GenericTile','sap/ui/Device','sap/ui/core/Icon','./SlideTileRenderer',"sap/ui/events/KeyCodes","sap/ui/events/PseudoEvents","sap/ui/thirdparty/jquery"],function(l,C,G,D,I,S,K,P,q){"use strict";var T=l.TileSizeBehavior;
var a=C.extend("sap.m.SlideTile",{metadata:{library:"sap.m",properties:{displayTime:{type:"int",group:"Appearance",defaultValue:5000},transitionTime:{type:"int",group:"Appearance",defaultValue:500},scope:{type:"sap.m.GenericTileScope",group:"Misc",defaultValue:"Display"},sizeBehavior:{type:"sap.m.TileSizeBehavior",defaultValue:T.Responsive},width:{type:"sap.ui.core.CSSSize",group:"Appearance"}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.GenericTile",multiple:true,singularName:"tile",bindable:"bindable"},_pausePlayIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},events:{press:{parameters:{scope:{type:"sap.m.GenericTileScope"},action:{type:"string"},domRef:{type:"any"}}}}}});
a.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this.setAggregation("_pausePlayIcon",new I({id:this.getId()+"-pause-play-icon",src:"sap-icon://media-pause",color:"#ffffff",size:"1rem",noTabStop:true}),true);};
a.prototype.onBeforeRendering=function(){G.prototype._initScopeContent.call(this,"sapMST");var A=this.getScope()===l.GenericTileScope.Actions;for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].showActionsView(A);}if(this._iCurrentTile>=0){this._iLastTile=this._iCurrentTile;}this._bNeedInvalidate=false;this._stopAnimation();this._sWidth=this._sHeight=undefined;this._iCurrentTile=this._iPreviousTile=undefined;};
a.prototype.onAfterRendering=function(){this._setupResizeClassHandler();var c=this.getTiles().length,s=this.getScope();this._removeGTFocus();this._iCurrAnimationTime=0;this._bAnimationPause=false;if(this._iLastTile>=0&&c>1){this._scrollToTile(this._iLastTile);}else{this._scrollToNextTile();}if(c>1&&s===l.GenericTileScope.Display){this._startAnimation();}if(s===l.GenericTileScope.Actions&&this._iCurrentTile>=0&&this._hasNewsContent(this._iCurrentTile)){this.addStyleClass("sapMSTDarkBackground");}};
a.prototype.exit=function(){this._stopAnimation();if(this._oMoreIcon){this._oMoreIcon.destroy();}if(this._oRemoveButton){this._oRemoveButton.destroy();}};
a.prototype.ontap=function(e){var s=this.getScope();this.$().trigger("focus");if(s===l.GenericTileScope.Actions){var p=this._getEventParams(e);this.firePress(p);e.preventDefault();}};
a.prototype.ontouchstart=function(e){if(this.getScope()===l.GenericTileScope.Display){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}else{this.addStyleClass("sapMSTHvr");}}};
a.prototype.ontouchend=function(e){this.removeStyleClass("sapMSTHvr");};
a.prototype.ontouchcancel=function(e){if(this.hasStyleClass("sapMSTIconPressed")){this.removeStyleClass("sapMSTIconPressed");}else{this.removeStyleClass("sapMSTHvr");}};
a.prototype.onkeydown=function(e){if(this.getScope()===l.GenericTileScope.Display){if(P.events.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeydown(e);}}};
a.prototype.onkeyup=function(e){var p;if(this.getScope()===l.GenericTileScope.Display){if(P.events.sapenter.fnCheck(e)){var g=this.getTiles()[this._iCurrentTile];g.onkeyup(e);return;}if(P.events.sapspace.fnCheck(e)){this._toggleAnimation();}if(e.which===K.B&&this._bAnimationPause){this._scrollToNextTile(true,true);}if(e.which===K.F&&this._bAnimationPause){this._scrollToNextTile(true,false);}}else if(this.getScope()===l.GenericTileScope.Actions){if(P.events.sapselect.fnCheck(e)){this.firePress(this._getEventParams(e));e.preventDefault();}else if(P.events.sapdelete.fnCheck(e)||P.events.sapbackspace.fnCheck(e)){p={scope:this.getScope(),action:G._Action.Remove,domRef:this._oRemoveButton.getPopupAnchorDomRef()};this.firePress(p);e.preventDefault();}}};
a.prototype.onsapspace=function(e){e.preventDefault();};
a.prototype.onmouseup=function(e){if(this.getScope()===l.GenericTileScope.Display){if(this.hasStyleClass("sapMSTIconPressed")){this._toggleAnimation();this.removeStyleClass("sapMSTIconPressed");}}};
a.prototype.onmousedown=function(e){if(q(e.target).hasClass("sapMSTIconClickTapArea")){this.addStyleClass("sapMSTIconPressed");}};
a.prototype.setScope=function(v){if(this.getScope()!==v){if(v===l.GenericTileScope.Actions){this.setProperty("scope",v,true);this._bNeedInvalidate=true;this._stopAnimation(this._bNeedInvalidate);}else{this.setProperty("scope",v);}this._setTilePressState();}return this;};
a.prototype._setupResizeClassHandler=function(){var c=function(){if(this.getSizeBehavior()===T.Small||window.matchMedia("(max-width: 374px)").matches){this.$().addClass("sapMTileSmallPhone");}else{this.$().removeClass("sapMTileSmallPhone");}}.bind(this);q(window).on("resize",c);c();};
a.prototype._isFocusInsideST=function(){return this.$()[0]===document.activeElement||this.$().find(document.activeElement).length;};
a.prototype._removeGTFocus=function(){for(var i=0;i<this.getTiles().length;i++){this.getTiles()[i].$().removeAttr("tabindex");}};
a.prototype._toggleAnimation=function(){if(this.getTiles().length>1){if(this._bAnimationPause){this._startAnimation();}else{this._stopAnimation();}}this._updatePausePlayIcon();};
a.prototype._stopAnimation=function(n){this._iCurrAnimationTime+=Date.now()-this._iStartTime;clearTimeout(this._sTimerId);if(this._iCurrentTile!=undefined){var w=this.$("wrapper-"+this._iCurrentTile);w.stop();}if(this._iPreviousTile!=undefined){var W=this.$("wrapper-"+this._iPreviousTile);W.stop();}this._bAnimationPause=true;if(this._iCurrAnimationTime>this.getDisplayTime()){this._scrollToNextTile(true);}else{if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}if(n){this.invalidate();}}};
a.prototype._startAnimation=function(){var d=this.getDisplayTime()-this._iCurrAnimationTime;clearTimeout(this._sTimerId);this._sTimerId=setTimeout(function(){this._scrollToNextTile();}.bind(this),d);this._iStartTime=Date.now();this._bAnimationPause=false;};
a.prototype._scrollToTile=function(t){if(t>=0){var w=this.$("wrapper-"+t);var d=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";this._changeSizeTo(t);w.css(d,"0rem");this._iCurrentTile=t;if(this.getTiles()[t]){this._setAriaDescriptor();}this._updateTilesIndicator();}};
a.prototype._scrollToNextTile=function(p,b){var t=this._iCurrAnimationTime-this.getDisplayTime(),f,n,w,W,s,c,d,e,g,o;t=this.getTransitionTime()-(t>0?t:0);f=t===this.getTransitionTime();if(f){if(b){n=this._getPreviousTileIndex(this._iCurrentTile);}else{n=this._getNextTileIndex(this._iCurrentTile);}this._iPreviousTile=this._iCurrentTile;this._iCurrentTile=n;}W=this.$("wrapper-"+this._iCurrentTile);g=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";if(q.isNumeric(this._iPreviousTile)){w=this.$("wrapper-"+this._iPreviousTile);s=w.css("width");c=parseFloat(W.css("width"));d=parseFloat(s);e=d<c;if(e){this._changeSizeTo(this._iCurrentTile);}if(f){W.css(g,s);}o={};if(b){o[g]=s;}else{o[g]="-"+s;}w.animate(o,{duration:t,done:function(){if(!e){this._changeSizeTo(this._iCurrentTile);}w.css(g,"");}.bind(this)});if(b){o[g]="-"+s;W.animate(o,0);}o[g]="0rem";W.animate(o,{duration:t,done:function(){this._iCurrAnimationTime=0;if(this._bNeedInvalidate){this.invalidate();}if(!p){this._startAnimation();}}.bind(this)});}else{this._changeSizeTo(this._iCurrentTile);W.css(g,"0rem");}if(this.getTiles()[this._iCurrentTile]){this._setAriaDescriptor();}this._updateTilesIndicator();};
a.prototype._setAriaDescriptor=function(){var t,s,b,c;s=this.getScope();b=this.getTiles();c=b[this._iCurrentTile];t=c._getAriaText().replace(/\s/g," ");if(s===l.GenericTileScope.Actions){t=this._oRb.getText("GENERICTILE_ACTIONS_ARIA_TEXT")+"\n"+t;}else if(b.length>1&&s===l.GenericTileScope.Display){t+="\n"+this._oRb.getText("SLIDETILE_MULTIPLE_CONTENT")+"\n"+this._oRb.getText("SLIDETILE_TOGGLE_SLIDING");if(this._bAnimationPause){t+="\n"+this._oRb.getText("SLIDETILE_SCROLL_BACK")+"\n"+this._oRb.getText("SLIDETILE_SCROLL_FORWARD");}}t+="\n"+this._oRb.getText("SLIDETILE_ACTIVATE");this.$().attr("aria-label",t);};
a.prototype._changeSizeTo=function(t){var o=this.getTiles()[t];if(!o){return;}if(this._sFrameType){this.$().removeClass(this._sFrameType);}if(this._sSize){this.$().removeClass(this._sSize);}this.$().addClass(o.getFrameType()).addClass(o.getSize());this._sFrameType=o.getFrameType();this._sSize=o.getSize();};
a.prototype._getPreviousTileIndex=function(t){if(t>0){return t-1;}else{return this.getTiles().length-1;}};
a.prototype._getNextTileIndex=function(t){if(t+1<this.getTiles().length){return t+1;}else{return 0;}};
a.prototype._updateTilesIndicator=function(){var $;for(var i=0;i<this.getTiles().length;i++){$=this.$("tileIndicator-"+i);if(i===this._iCurrentTile){$.addClass("sapMSTActive");}else{$.removeClass("sapMSTActive");}}};
a.prototype._updatePausePlayIcon=function(){if(this._bAnimationPause){this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-play");this.$().removeClass("sapMSTPauseIcon");}else{this.getAggregation("_pausePlayIcon").setSrc("sap-icon://media-pause");this.$().addClass("sapMSTPauseIcon");}};
a.prototype._setTilePressState=function(){var t=this.getTiles(),b=this.getScope()===l.GenericTileScope.Display;for(var i=0;i<t.length;i++){t[i].setPressEnabled(b);}};
a.prototype._hasNewsContent=function(t){var b=this.getTiles()[t].getTileContent();for(var i=0;i<b.length;i++){if(b[i]._getContentType()==="News"){return true;}}return false;};
a.prototype._getEventParams=G.prototype._getEventParams;return a;});
sap.ui.predefine('sap/m/SlideTileRenderer',['./library',"sap/base/security/encodeCSS"],function(l,e){"use strict";var G=l.GenericTileScope;var S={};
S.render=function(r,c){var t=c.getTooltip_AsString(),s=c.getScope(),a=e("sapMSTScope"+s),L;r.write("<div");r.writeControlData(c);r.addClass("sapMST");r.addClass(a);if(!this._bAnimationPause){r.addClass("sapMSTPauseIcon");}r.writeClasses();if(t){r.writeAttributeEscaped("title",t);}r.writeAttribute("tabindex","0");r.writeAttribute("role","presentation");r.write(">");L=c.getTiles().length;if(L>1&&s===G.Display){this._renderPausePlayIcon(r,c);this._renderTilesIndicator(r,c);}this._renderTiles(r,c,L);if(s===G.Actions){this._renderActionsScope(r,c);}r.write("<div");r.addClass("sapMSTFocusDiv");r.writeClasses();r.writeAttribute("id",c.getId()+"-focus");r.write(">");r.write("</div>");r.write("</div>");};
S._renderTiles=function(r,c,L){r.write("<div");r.addClass("sapMSTOverflowHidden");r.writeClasses();r.write(">");for(var i=0;i<L;i++){r.write("<div");r.writeAttribute("id",c.getId()+"-wrapper-"+i);r.addClass("sapMSTWrapper");r.writeClasses();r.write(">");r.renderControl(c.getTiles()[i]);r.write("</div>");}r.write("</div>");};
S._renderTilesIndicator=function(r,c){var p=c.getTiles().length;r.write("<div");r.writeAttribute("id",c.getId()+"-tilesIndicator");r.addClass("sapMSTBulleted");r.writeClasses();r.write(">");for(var i=0;i<p;i++){r.write("<span");r.writeAttribute("id",c.getId()+"-tileIndicator-"+i);r.write(">");r.write("</span>");}r.write("</div>");};
S._renderPausePlayIcon=function(r,c){if(c.getTiles().length>1){r.write("<div");r.addClass("sapMSTIconClickTapArea");r.writeClasses();r.write(">");r.write("</div>");r.write("<div");r.addClass("sapMSTIconDisplayArea");r.writeClasses();r.write(">");r.write("</div>");r.write("<div");r.addClass("sapMSTIconNestedArea");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_pausePlayIcon"));r.write("</div>");}};
S._renderActionsScope=function(r,c){r.renderControl(c._oRemoveButton);r.renderControl(c._oMoreIcon);};
return S;},true);
sap.ui.predefine('sap/m/Slider',['sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/InvisibleText','sap/ui/core/library','sap/ui/core/ResizeHandler','sap/base/Log','./library','./SliderTooltipContainer','./SliderTooltip','./SliderUtilities','./SliderRenderer','./ResponsiveScale',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes"],function(C,E,I,c,R,l,a,S,b,d,e,f,q,K){"use strict";var t=a.touch;
var g=C.extend("sap.m.Slider",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},enabled:{type:"boolean",group:"Behavior",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},step:{type:"float",group:"Data",defaultValue:1},progress:{type:"boolean",group:"Misc",defaultValue:true},value:{type:"float",group:"Data",defaultValue:0},showHandleTooltip:{type:"boolean",group:"Appearance",defaultValue:true},showAdvancedTooltip:{type:"boolean",group:"Appearance",defaultValue:false},inputsAsTooltips:{type:"boolean",group:"Appearance",defaultValue:false},enableTickmarks:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"scale",aggregations:{_tooltipContainer:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},scale:{type:"sap.m.IScale",multiple:false,singularName:"scale"},_defaultScale:{type:"sap.m.ResponsiveScale",multiple:false,visibility:"hidden"},_defaultTooltips:{type:"sap.m.SliderTooltipBase",multiple:true,visibility:"hidden"},customTooltips:{type:"sap.m.SliderTooltipBase",multiple:true},_handlesLabels:{type:"sap.ui.core.InvisibleText",multiple:true,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}},liveChange:{parameters:{value:{type:"float"}}}},designtime:"sap/m/designtime/Slider.designtime"}});
E.apply(g.prototype,[true]);
g.prototype._getUsedScale=function(){if(!this.getEnableTickmarks()){return;}return this.getAggregation('scale')||this.getAggregation('_defaultScale');};
g.prototype._syncScaleUsage=function(){var h=this.getEnableTickmarks(),u=this.getAggregation('scale'),D=this.getAggregation("_defaultScale");if((D&&!h)||(u&&D)){this.destroyAggregation("_defaultScale",true);}if(h&&!u&&!D){this.setAggregation("_defaultScale",new f(),true);}};
g.prototype._showTooltipsIfNeeded=function(){if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype._convertValueToRtlMode=function(v){return this.getMax()-v+this.getMin();};
g.prototype._recalculateStyles=function(){var s=this.$();this._fSliderWidth=s.width();this._fSliderPaddingLeft=parseFloat(s.css("padding-left"));this._fSliderOffsetLeft=s.offset().left;this._fHandleWidth=this.$("handle").width();};
g.prototype._validateProperties=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),h=false,i=false;if(m>=M){h=true;i=true;l.warning("Warning: "+"Property wrong min: "+m+" >= max: "+M+" on ",this);}if(s<=0){l.warning("Warning: "+"The step could not be negative on ",this);}if(s>(M-m)&&!h){i=true;l.warning("Warning: "+"Property wrong step: "+s+" > max: "+M+" - "+"min: "+m+" on ",this);}return i;};
g.prototype._getPercentOfValue=function(v){return d.getPercentOfValue(v,this.getMin(),this.getMax());};
g.prototype._getValueOfPercent=function(p){var m=this.getMin(),v=(p*(this.getMax()-m)/100)+m,n=this.toFixed(v,this.getDecimalPrecisionOfNumber(this.getStep()));return Number(n);};
g.prototype._validateStep=function(s){if(typeof s==="undefined"){return 1;}if(typeof s!=="number"){l.warning('Warning: "iStep" needs to be a number',this);return 0;}if((Math.floor(s)===s)&&isFinite(s)){return s;}l.warning('Warning: "iStep" needs to be a finite interger',this);return 0;};
g.prototype._handleSliderResize=function(o){var s=this._getUsedScale();if(this.getEnableTickmarks()&&s&&s.handleResize){s.handleResize(o);}if(this.getShowAdvancedTooltip()){this._handleTooltipContainerResponsiveness();}};
g.prototype._handleTooltipContainerResponsiveness=function(){this.getAggregation("_tooltipContainer").setWidth(this.$().width()+"px");};
g.prototype.getDecimalPrecisionOfNumber=function(v){if(Math.floor(v)===v){return 0;}var V=v.toString(),i=V.indexOf("."),h=V.indexOf("e-"),j=h!==-1,k=i!==-1;if(j){var m=+V.slice(h+2);if(k){return m+V.slice(i+1,h).length;}return m;}if(k){return V.length-i-1;}return 0;};
g.prototype.toFixed=function(n,D){if(D===undefined){D=this.getDecimalPrecisionOfNumber(n);}if(D>20){D=20;}else if(D<0){D=0;}return n.toFixed(D)+"";};
g.prototype.setDomValue=function(n){var D=this.getDomRef(),s=this._formatValueByCustomElement(n),T=this.getAggregation("_tooltipContainer");if(!D){return;}var p=Math.max(this._getPercentOfValue(+n),0)+"%",h=this.getDomRef("handle");if(!!this.getName()){this.getDomRef("input").setAttribute("value",s);}if(this.getProgress()){this.getDomRef("progress").style.width=p;}h.style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=p;if(this.getShowAdvancedTooltip()&&T.getDomRef()){this.updateAdvancedTooltipDom(n);}if(this.getShowHandleTooltip()&&!this.getShowAdvancedTooltip()){h.title=s;}this._updateHandleAriaAttributeValues(h,n,s);};
g.prototype._updateHandleAriaAttributeValues=function(h,v,s){if(this._isElementsFormatterNotNumerical(v)){h.setAttribute("aria-valuenow",v);h.setAttribute("aria-valuetext",s);}else{h.setAttribute("aria-valuenow",s);h.removeAttribute("aria-valuetext");}};
g.prototype._formatValueByCustomElement=function(v,p){var s=this._getUsedScale(),T=this.getUsedTooltips()[0],F=""+v;if(p==='slider'){return F;}if(this.getEnableTickmarks()&&s&&s.getLabel){F=""+s.getLabel(v,this);}if(p==='scale'){return F;}if(this.getShowAdvancedTooltip()&&T&&T.getLabel){F=""+T.getLabel(v,this);}return F;};
g.prototype._isElementsFormatterNotNumerical=function(v){var V=this._formatValueByCustomElement(v);return isNaN(V);};
g.prototype.updateAdvancedTooltipDom=function(n){var T=this.getUsedTooltips();this.updateTooltipsPositionAndState(T[0],parseFloat(n));};
g.prototype.getUsedTooltips=function(){var h=this.getCustomTooltips(),D=this.getAggregation("_defaultTooltips")||[];return h.length?h:D;};
g.prototype.updateTooltipsPositionAndState=function(T,v){var o=this.getAggregation("_tooltipContainer");T.setValue(v);o.repositionTooltips(this.getMin(),this.getMax());};
g.prototype.getClosestHandleDomRef=function(){return this.getDomRef("handle");};
g.prototype._increaseValueBy=function(i){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v+(i||1));n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}};
g.prototype._decreaseValueBy=function(D){var v,n;if(this.getEnabled()){v=this.getValue();this.setValue(v-(D||1));n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}};
g.prototype._getLongStep=function(){var m=this.getMin(),M=this.getMax(),s=this.getStep(),L=(M-m)/10,i=(M-m)/s;return i>10?L:s;};
g.prototype._fireChangeAndLiveChange=function(p){this.fireChange(p);this.fireLiveChange(p);};
g.prototype.handleTooltipChange=function(o){var n=parseFloat(o.getParameter("value"));this.setValue(n);this._fireChangeAndLiveChange({value:n});};
g.prototype._registerResizeHandler=function(){if(!this._parentResizeHandler){this._parentResizeHandler=R.register(this,this._handleSliderResize.bind(this));}};
g.prototype._deregisterResizeHandler=function(){if(this._parentResizeHandler){R.deregister(this._parentResizeHandler);this._parentResizeHandler=null;}};
g.prototype.init=function(){var s;this._iActiveTouchId=-1;this._bSetValueFirstCall=true;this._fValueBeforeFocus=0;this._parentResizeHandler=null;this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTooltipContainer=null;s=new I({text:this._oResourceBundle.getText("SLIDER_HANDLE")});this.addAggregation("_handlesLabels",s);};
g.prototype.exit=function(){if(this._oResourceBundle){this._oResourceBundle=null;}if(this.getAggregation("_defaultTooltips")){this.destroyAggregation("_defaultTooltips");}this._deregisterResizeHandler();};
g.prototype.onBeforeRendering=function(){var h=this._validateProperties();if(!h){this.setValue(this.getValue());this._sProgressValue=Math.max(this._getPercentOfValue(this.getValue()),0)+"%";}if(this.getShowAdvancedTooltip()){this.initAndSyncTooltips(["leftTooltip"]);}this._deregisterResizeHandler();this._syncScaleUsage();};
g.prototype.forwardProperties=function(p,o){p.forEach(function(P){o.setProperty(P,this.getProperty(P),true);},this);};
g.prototype.forwardPropertiesToDefaultTooltips=function(T){var D=this.getAggregation("_defaultTooltips")||[];for(var i=0;i<T;i++){this.forwardProperties(["min","max","step"],D[i]);D[i].setProperty("width",this._getMaxTooltipWidth()+"px",true);D[i].setProperty("editable",this.getInputsAsTooltips(),true);}};
g.prototype.associateCustomTooltips=function(T){this.destroyAggregation("_defaultTooltips",true);this._oTooltipContainer.removeAllAssociation("associatedTooltips",true);for(var i=0;i<T;i++){this._oTooltipContainer.addAssociation("associatedTooltips",this.getCustomTooltips()[i],true);}};
g.prototype.assignDefaultTooltips=function(T){var D=this.getAggregation("_defaultTooltips")||[];if(D.length===0){this._oTooltipContainer.removeAllAssociation("associatedTooltips",true);T.forEach(function(i){this.initDefaultTooltip(i);},this);}this.forwardProperties(["enabled"],this._oTooltipContainer);this.forwardPropertiesToDefaultTooltips(T.length);};
g.prototype.initAndSyncTooltips=function(T){var h=this.getCustomTooltips(),i=h.length,m=T.length;this.initTooltipContainer();if(i<m){this.assignDefaultTooltips(T);}else{if(i>m){l.warning("Warning: More than "+m+" Custom Tooltips are provided. Only the first will be used.");}this.associateCustomTooltips(m);}};
g.prototype.initDefaultTooltip=function(i){var T=new b(this.getId()+"-"+i,{change:this.handleTooltipChange.bind(this)});this.getAggregation("_tooltipContainer").addAssociation("associatedTooltips",T,true);this.addAggregation("_defaultTooltips",T,true);};
g.prototype.initTooltipContainer=function(){if(!this._oTooltipContainer){this._oTooltipContainer=new S();this.setAggregation("_tooltipContainer",this._oTooltipContainer,true);}};
g.prototype._getMaxTooltipWidth=function(){var A=[Math.abs(this.getMin()),Math.abs(this.getMax())],r=A[0]>A[1]?0:1;return((A[r].toString()).length+this.getDecimalPrecisionOfNumber(this.getStep())+1)*d.CONSTANTS.CHARACTER_WIDTH_PX;};
g.prototype.onAfterRendering=function(){if(this.getShowAdvancedTooltip()){this._recalculateStyles();this._handleTooltipContainerResponsiveness();}this._handleSliderResize({control:this});this._registerResizeHandler();};
g.prototype.ontouchstart=function(o){var m=this.getMin(),T=o.targetTouches[0],n,h=this.getRenderer().CSS_CLASS,s="."+h;o.setMarked();if(o.target.className.indexOf("sapMInput")===-1){o.preventDefault();}this.focus();if(t.countContained(o.touches,this.getId())>1||!this.getEnabled()||o.button||(o.srcControl!==this)){return;}this._iActiveTouchId=T.identifier;q(document).on("touchend"+s+" touchcancel"+s+" mouseup"+s,this._ontouchend.bind(this)).on(o.originalEvent.type==="touchstart"?"touchmove"+s:"touchmove"+s+" mousemove"+s,this._ontouchmove.bind(this));var N=this.getClosestHandleDomRef();if(T.target!==N){setTimeout(N["focus"].bind(N),0);}this._recalculateStyles();this._fDiffX=this._fSliderPaddingLeft;this._fInitialValue=this.getValue();this.$("inner").addClass(h+"Pressed");if(T.target===this.getDomRef("handle")){this._fDiffX=(T.pageX-q(N).offset().left)+this._fSliderPaddingLeft-(this._fHandleWidth/2);}else{n=(((T.pageX-this._fSliderPaddingLeft-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(sap.ui.getCore().getConfiguration().getRTL()){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(this._fInitialValue!==n){this.fireLiveChange({value:n});}}};
g.prototype._ontouchmove=function(o){o.setMarked();o.preventDefault();if(o.isMarked("delayedMouseEvent")||!this.getEnabled()||o.button){return;}var m=this.getMin(),v=this.getValue(),T=t.find(o.changedTouches,this._iActiveTouchId),p=T?T.pageX:o.pageX,n=(((p-this._fDiffX-this._fSliderOffsetLeft)/this._fSliderWidth)*(this.getMax()-m))+m;if(sap.ui.getCore().getConfiguration().getRTL()){n=this._convertValueToRtlMode(n);}this.setValue(n);n=this.getValue();if(v!==n){this.fireLiveChange({value:n});}};
g.prototype._ontouchend=function(o){var h=this.getRenderer().CSS_CLASS,s="."+h;o.setMarked();if(o.isMarked("delayedMouseEvent")||!this.getEnabled()||o.button){return;}q(document).off(s);var v=this.getValue();this.$("inner").removeClass(h+"Pressed");if(this._fInitialValue!==v){this.fireChange({value:v});}};
g.prototype.onfocusin=function(o){this._fValueBeforeFocus=this.getValue();if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);this._setAriaControls();this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype._setAriaControls=function(){var T=this.getUsedTooltips()[0],h=this.getFocusDomRef();if(this.getInputsAsTooltips()&&T&&T.getDomRef()){h.setAttribute("aria-controls",T.getId());}};
g.prototype.onfocusout=function(o){if(!this.getShowAdvancedTooltip()){return;}var s=q.contains(this.getDomRef(),o.relatedTarget),T=q.contains(this.getAggregation("_tooltipContainer").getDomRef(),o.relatedTarget);if(s||T){return;}this.getAggregation("_tooltipContainer").hide();};
g.prototype.onmouseover=function(o){var T,h;if(this.getShowAdvancedTooltip()){this.getAggregation("_tooltipContainer").show(this);h=this.getAggregation("_tooltipContainer");T=q.contains(h.getDomRef(),document.activeElement);this._setAriaControls();if(T){return;}this.updateAdvancedTooltipDom(this.getValue());}};
g.prototype.onmouseout=function(o){if(!this.getShowAdvancedTooltip()){return;}var T=this.getAggregation("_tooltipContainer").getDomRef(),s=this.getDomRef(),h=q.contains(s,document.activeElement),i=q.contains(T,document.activeElement);if(!T||h||i){return;}if(q.contains(this.getDomRef(),o.toElement)||(s===o.toElement)){return;}if(q.contains(this.getAggregation("_tooltipContainer").getDomRef(),o.toElement)){return;}this.getAggregation("_tooltipContainer").hide();};
g.prototype.onkeydown=function(o){var T=this.getUsedTooltips();if(o.keyCode===d.CONSTANTS.F2_KEYCODE&&T[0]&&this.getInputsAsTooltips()){T[0].focus();}if(o.keyCode===K.SPACE){o.preventDefault();}};
g.prototype.onsapincrease=function(o){var v,n;o.preventDefault();o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapincreasemodifiers=function(o){if(o.altKey){return;}o.preventDefault();o.stopPropagation();o.setMarked();this._increaseValueBy(this._getLongStep());this._showTooltipsIfNeeded();};
g.prototype.onsapdecrease=function(o){var v,n;o.preventDefault();o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapdecreasemodifiers=function(o){if(o.altKey){return;}o.preventDefault();o.stopPropagation();o.setMarked();this._decreaseValueBy(this._getLongStep());this._showTooltipsIfNeeded();};
g.prototype.onsapplus=function(o){var v,n;o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepUp(1);n=this.getValue();if(v<n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapminus=function(o){var v,n;o.setMarked();if(this.getEnabled()){v=this.getValue();this.stepDown(1);n=this.getValue();if(v>n){this._fireChangeAndLiveChange({value:n});}}this._showTooltipsIfNeeded();};
g.prototype.onsapescape=function(){this.setValue(this._fValueBeforeFocus);};
g.prototype.onsappageup=g.prototype.onsapincreasemodifiers;g.prototype.onsappagedown=g.prototype.onsapdecreasemodifiers;
g.prototype.onsaphome=function(o){o.setMarked();var m=this.getMin();o.preventDefault();if(this.getEnabled()&&this.getValue()>m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}this._showTooltipsIfNeeded();};
g.prototype.onsapend=function(o){o.setMarked();var m=this.getMax();o.preventDefault();if(this.getEnabled()&&this.getValue()<m){this.setValue(m);this._fireChangeAndLiveChange({value:m});}this._showTooltipsIfNeeded();};
g.prototype.getFocusDomRef=function(){return this.getDomRef("handle");};
g.prototype.stepUp=function(s){return this.setValue(this.getValue()+(this._validateStep(s)*this.getStep()),{snapValue:false});};
g.prototype.stepDown=function(s){return this.setValue(this.getValue()-(this._validateStep(s)*this.getStep()),{snapValue:false});};
g.prototype.setValue=function(n,o){if(this._bSetValueFirstCall){this._bSetValueFirstCall=false;return this.setProperty("value",n,true);}var m=this.getMin(),M=this.getMax(),s=this.getStep(),v=this.getValue(),N,h=true,i;if(o){h=!!o.snapValue;}if(typeof n!=="number"||!isFinite(n)){return this;}i=Math.abs((n-m)%s);if(h&&(i!==0)){n=i*2>=s?n+s-i:n-i;}if(n<m){n=m;}else if(n>M){n=M;}N=this.toFixed(n,this.getDecimalPrecisionOfNumber(s));n=Number(N);this.setProperty("value",n,true);if(v!==this.getValue()){this.setDomValue(N);}return this;};
return g;});
sap.ui.predefine('sap/m/SliderRenderer',['./SliderUtilities',"sap/ui/core/InvisibleText"],function(S,I){"use strict";var a={apiVersion:2};a.CSS_CLASS="sapMSlider";
a.render=function(r,s){var e=s.getEnabled(),t=s.getTooltip_AsString(),C=a.CSS_CLASS,b=s.getAriaLabelledBy().reduce(function(A,i){return A+" "+i;},"");r.openStart("div",s);this.addClass(r,s);if(!e){r.class(C+"Disabled");}r.style("width",s.getWidth());if(t&&s.getShowHandleTooltip()){r.attr("title",s._formatValueByCustomElement(t));}r.openEnd();r.openStart('div',s.getId()+"-inner");this.addInnerClass(r,s);if(!e){r.class(C+"InnerDisabled");}r.openEnd();if(s.getProgress()){this.renderProgressIndicator(r,s,b);}this.renderHandles(r,s,b);r.close("div");if(s.getEnableTickmarks()){this.renderTickmarks(r,s);}this.renderLabels(r,s);if(s.getName()){this.renderInput(r,s);}r.close("div");};
a.renderProgressIndicator=function(r,s){r.openStart("div",s.getId()+"-progress");this.addProgressIndicatorClass(r,s);r.style("width",s._sProgressValue);r.attr("aria-hidden","true");r.openEnd().close("div");};
a.renderHandles=function(r,s,f){this.renderHandle(r,s,{id:s.getId()+"-handle",forwardedLabels:f});};
a.renderHandle=function(r,s,o){var e=s.getEnabled();r.openStart("span",o&&o.id);if(s.getShowHandleTooltip()&&!s.getShowAdvancedTooltip()){this.writeHandleTooltip(r,s);}if(s.getInputsAsTooltips()){r.attr("aria-describedby",I.getStaticId("sap.m","SLIDER_INPUT_TOOLTIP"));e&&r.attr("aria-keyshortcuts","F2");}this.addHandleClass(r,s);r.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",s._sProgressValue);this.writeAccessibilityState(r,s,o);if(e){r.attr("tabindex","0");}r.openEnd().close("span");};
a.writeHandleTooltip=function(r,s){r.attr("title",s._formatValueByCustomElement(s.toFixed(s.getValue())));};
a.renderInput=function(r,s){r.voidStart("input",s.getId()+"-input").attr("type","text");r.class(a.CSS_CLASS+"Input");if(!s.getEnabled()){r.attr("disabled");}r.attr("name",s.getName());r.attr("value",s._formatValueByCustomElement(s.toFixed(s.getValue())));r.voidEnd();};
a.writeAccessibilityState=function(r,s,o){var f=s.getValue(),n=s._isElementsFormatterNotNumerical(f),b=s._formatValueByCustomElement(f),v;if(s._getUsedScale()&&!n){v=b;}else{v=s.toFixed(f);}r.accessibilityState(s,{role:"slider",orientation:"horizontal",valuemin:s.toFixed(s.getMin()),valuemax:s.toFixed(s.getMax()),valuenow:v,labelledby:{value:(o.forwardedLabels+" "+s.getAggregation("_handlesLabels")[0].getId()).trim()}});if(n){r.accessibilityState(s,{valuetext:b});}};
a.renderTickmarks=function(r,s){var i,t,T,l,f,b,c,d,o=s._getUsedScale();if(!s.getEnableTickmarks()||!o){return;}b=Math.abs(s.getMin()-s.getMax());c=s.getStep();l=o.getTickmarksBetweenLabels();t=o.calcNumberOfTickmarks(b,c,S.CONSTANTS.TICKMARKS.MAX_POSSIBLE);T=s._getPercentOfValue(this._calcTickmarksDistance(t,s.getMin(),s.getMax(),c));r.openStart("ul").class(a.CSS_CLASS+"Tickmarks").openEnd();this.renderTickmarksLabel(r,s,s.getMin());r.openStart("li").class(a.CSS_CLASS+"Tick").style("width",T+"%;").openEnd().close("li");for(i=1;i<t-1;i++){d=false;if(l&&(i%l===0)){d=true;f=i*T;this.renderTickmarksLabel(r,s,s._getValueOfPercent(f));}r.openStart("li").class(a.CSS_CLASS+"Tick").style("width",T+"%"+(d?" opacity: 0;":"")).openEnd().close("li");}this.renderTickmarksLabel(r,s,s.getMax());r.openStart("li").class(a.CSS_CLASS+"Tick").style("width","0").openEnd().close("li");r.close("ul");};
a.renderTickmarksLabel=function(r,s,v){var o=s._getPercentOfValue(v);var l=sap.ui.getCore().getConfiguration().getRTL()?"right":"left";var V;v=s.toFixed(v,s.getDecimalPrecisionOfNumber(s.getStep()));V=s._formatValueByCustomElement(v,'scale');r.openStart("li").class(a.CSS_CLASS+"TickLabel").style(l,(o+"%")).openEnd();r.openStart("div").class(a.CSS_CLASS+"Label").openEnd().text(V).close("div");r.close("li");};
a._calcTickmarksDistance=function(t,s,e,f){var b=Math.abs(s-e),m=Math.floor(b/f),i=Math.ceil(m/t);return s+(i*f);};
a.addClass=function(r,s){r.class(a.CSS_CLASS);};
a.addInnerClass=function(r,s){r.class(a.CSS_CLASS+"Inner");};
a.addProgressIndicatorClass=function(r,s){r.class(a.CSS_CLASS+"Progress");};
a.addHandleClass=function(r,s){r.class(a.CSS_CLASS+"Handle");};
a.renderLabels=function(r,s){s.getAggregation("_handlesLabels").forEach(r.renderControl,r);};
return a;},true);
sap.ui.predefine('sap/m/SliderTooltip',['./library','./SliderUtilities','./SliderTooltipBase','sap/ui/core/Control','sap/ui/core/library','./delegate/ValueStateMessage','./SliderTooltipRenderer'],function(L,S,a,C,c,V,b){"use strict";var d=c.ValueState;
var e=a.extend("sap.m.SliderTooltip",{metadata:{library:"sap.m",properties:{value:{type:"float",group:"Data",defaultValue:0,bindable:"bindable"},min:{type:"float",group:"Data",defaultValue:0},max:{type:"float",group:"Data",defaultValue:100},editable:{type:"boolean",defaultValue:false},step:{type:"float",group:"Data",defaultValue:1},valueState:{type:"sap.ui.core.ValueState",group:"Appearance",defaultValue:d.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{value:{type:"float"}}}}}});
e.prototype.init=function(){this._oValueStateMessage=new V(this);this._fLastValidValue=0;};
e.prototype.onBeforeRendering=function(){a.prototype.setValue.call(this,this.getValue());};
e.prototype.onAfterRendering=function(){if(this.getDomRef()){this.getFocusDomRef().toggleClass(S.CONSTANTS.TOOLTIP_CLASS+"NotEditable",!this.getEditable());}};
e.prototype.getValueStateText=function(){return"";};
e.prototype.getFocusDomRef=function(){return this.$("input");};
e.prototype.getDomRefForValueStateMessage=function(){return this.getDomRef();};
e.prototype.sliderValueChanged=function(v){if(this.getDomRef()){this.getFocusDomRef().val(v);}this._fLastValidValue=v;this.setValueState(d.None);};
e.prototype.setValueState=function(v){var E,o;v=this.validateProperty("valueState",v);this.setProperty("valueState",v,true);E=(v===d.Error);o=this.getDomRef()&&E;this._oValueStateMessage[o?"open":"close"]();this.$().toggleClass(S.CONSTANTS.TOOLTIP_CLASS+"ErrorState",E);return this;};
e.prototype.onfocusout=function(E){var v=parseFloat(this.getFocusDomRef().val());this._validateValue(v);};
e.prototype.onsapenter=function(E){var v=parseFloat(this.getFocusDomRef().val());this._validateValue(v);};
e.prototype.onsapescape=function(E){this.sliderValueChanged(this._fLastValidValue);this.setValueState(d.None);};
e.prototype._validateValue=function(v){if(this._isValueValid(v)){this.sliderValueChanged(v);this.fireChange({value:v});}else{this.setValueState(d.Error);}};
e.prototype._isValueValid=function(v){return!(isNaN(v)||v<this.getMin()||v>this.getMax());};
return e;});
sap.ui.predefine('sap/m/SliderTooltipBase',['sap/ui/core/Control','./library','./SliderTooltipBaseRenderer'],function(C,L,S){"use strict";
var a=C.extend("sap.m.SliderTooltipBase",{metadata:{library:"sap.m"}});
a.prototype.init=function(){this.fValue=0;};
a.prototype.setValue=function(v){this.fValue=v;this.sliderValueChanged(v);};
a.prototype.getValue=function(){return this.fValue;};
a.prototype.sliderValueChanged=function(v){};
return a;});
sap.ui.predefine('sap/m/SliderTooltipBaseRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={apiVersion:2};S.CSS_CLASS="sapMSliderTooltip";
S.render=function(r,c){r.openStart("div",c).openEnd();this.renderTooltipContent(r,c);r.close("div");};
S.renderTooltipContent=function(r,c){};
return S;},true);
sap.ui.predefine('sap/m/SliderTooltipContainer',['./library','./SliderUtilities','sap/ui/core/Control','sap/ui/core/Popup','./SliderTooltipContainerRenderer',"sap/ui/thirdparty/jquery"],function(L,S,C,P,a,q){"use strict";
var b=C.extend("sap.m.SliderTooltipContainer",{metadata:{library:"sap.m",properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"0px"}},associations:{associatedTooltips:{type:"sap.m.SliderTooltipBase",multiple:true}}}});
b.prototype.init=function(){this.oPopup=new P();this.oPopup.setShadow(false);this.oPopup.setAutoClose(false);this._scrollListener=this._getScrollListener();this._bClosedFromOverflow=false;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype._handleTabNavigation=function(e){var p=this._oParentSlider instanceof sap.m.RangeSlider;e.preventDefault();this[p?"_handleRangeSliderF2":"_handleSliderF2"].apply(this,arguments);};
b.prototype._handleSliderF2=function(){this._oParentSlider.focus();};
b.prototype._handleRangeSliderF2=function(e){var h=this._oParentSlider._getHandleForTooltip(e.srcControl);q(h).trigger("focus");};
b.prototype.onsaptabnext=b.prototype._handleTabNavigation;b.prototype.onsaptabprevious=b.prototype._handleTabNavigation;
b.prototype.onkeydown=function(e){if(e.keyCode===S.CONSTANTS.F2_KEYCODE){this._handleTabNavigation(e);}};
b.prototype.show=function(c){this.oPopup.setContent(this);this._$ParentSlider=c.$();this._oParentSlider=c;this.oPopup.open(0,P.Dock.BeginTop,P.Dock.BeginTop,this._$ParentSlider,'0 -24','flip');document.addEventListener("scroll",this._scrollListener,true);};
b.prototype._getScrollListener=function(){return function(){clearTimeout(this._scrollDebounce);this._scrollDebounce=setTimeout(this.repositionTooltips.bind(this),0);}.bind(this);};
b.prototype.hide=function(){this.oPopup.close();document.removeEventListener("scroll",this._scrollListener,true);};
b.prototype.repositionTooltips=function(){var p=this._oParentSlider instanceof sap.m.RangeSlider,t=this._oParentSlider.getUsedTooltips(),T=this.getAssociatedTooltipsAsControls()[0].$().outerHeight(true);if(this.getDomRef()){this[p?"_positionRangeTooltips":"_positionTooltip"].call(this,t,arguments[0],arguments[1]);this.getDomRef().style["top"]=(this._$ParentSlider.offset().top-T)+"px";this._handleOverflow();}};
b.prototype._positionTooltip=function(t,m,M){var T=this._getTooltipPosition(t[0].getValue(),m,M),A=this._bRtl?"right":"left";if(T){this.getDomRef().children[0].style[A]=T;}};
b.prototype._handleOverflow=function(){var p=this.getDomRef(),s,c;if(p){s=S.getElementScrollableParent(this._$ParentSlider[0].parentNode);c=S.isScrolledIntoView(this._$ParentSlider[0],s);if(!c){this._bClosedFromOverflow=true;this.hide();}}};
b.prototype._positionRangeTooltips=function(t,m,M){var r=this._bRtl,A=r?"right":"left",s=r?"left":"right",R=this._oParentSlider.getRange(),f=S.getPercentOfValue(R[0]>R[1]?R[1]:R[0],m,M),e=S.getPercentOfValue(R[0]>R[1]?R[0]:R[1],m,M),T=this.getAssociatedTooltipsAsControls()[0].$().outerWidth(),i=S.getPercentOfValue(+(t[0].getValue()),m,M),E=S.getPercentOfValue(+(t[1].getValue()),m,M),p=this._oParentSlider.$("progress"),c=this.$("container"),d=this._$ParentSlider.width(),o=false,g=T-S.CONSTANTS.TOOLTIP_SIDE_PADDING,h=(((g+S.CONSTANTS.CHARACTER_WIDTH_PX)/2)/d)*100,j=f-(h)-(h*2-(e-f))/2,k={"min-width":(2*T)+(S.CONSTANTS.TOOLTIP_BORDER*2)+"px"},l;k[A]="calc("+i+"%"+" - "+((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";k[s]="calc("+(100-E)+"% "+"- "+(T-((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH-S.CONSTANTS.TOOLTIP_BORDER))+"px)";if(p.outerWidth()<=(T/2)+(T-S.CONSTANTS.HANDLE_HALF_WIDTH)){k[A]="calc("+j+"%"+" + "+S.CONSTANTS.HANDLE_HALF_WIDTH+"px)";o=true;}c.css(k);l=this._$ParentSlider.offset();if((c.offset().left+c.outerWidth())>(l.left+this._$ParentSlider.outerWidth())){k=this[r?"_getStickedToStart":"_getStickedToEnd"].call(this,k,A,s,o);}if((c.offset().left<=l.left)){k=this[r?"_getStickedToEnd":"_getStickedToStart"].call(this,k,A,s,o);}c.css(k);};
b.prototype._getStickedToStart=function(c,A){c[A]="0";return c;};
b.prototype._getStickedToEnd=function(c,A,s,o){var t=this.getAssociatedTooltipsAsControls()[0].$().outerWidth();c[s]="calc(0% - "+(2*S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";if(o){c[A]="calc(100% - "+(t+(t-2*S.CONSTANTS.HANDLE_HALF_WIDTH))+"px)";}return c;};
b.prototype._getTooltipPosition=function(t,m,M){var p=S.getPercentOfValue(+(t),m,M),T=this.getAssociatedTooltipsAsControls()[0].$().outerWidth(),s=this._$ParentSlider.outerWidth(),f=(100*S.CONSTANTS.SLIDER_SIDE_PADDING)/s,c=((100*T)/s);if(p+f<(c/2)){return"0";}else if(p-f>100-(c/2)){return"calc(100% - "+(T-(S.CONSTANTS.HANDLE_HALF_WIDTH*2))+"px)";}else{return"calc("+p+"% - "+((T/2)-S.CONSTANTS.HANDLE_HALF_WIDTH)+"px)";}};
b.prototype.setWidth=function(w){if(this.getDomRef()){this.$().width(w);}return this.setProperty("width",w,true);};
b.prototype.getAssociatedTooltipsAsControls=function(){var A=this.getAssociation("associatedTooltips")||[];return A.map(function(t){return sap.ui.getCore().byId(t);});};
b.prototype.onmouseout=function(e){var s=q.contains(this._oParentSlider.getDomRef(),document.activeElement),c=q.contains(this.getDomRef(),document.activeElement),t=q.contains(this._oParentSlider.getDomRef(),e.toElement),T=q.contains(this.getDomRef(),e.toElement);if(s||c||t||T){return;}this.hide();};
b.prototype.onfocusout=function(e){if(q.contains(this._$ParentSlider[0],e.relatedTarget)||q.contains(this.getDomRef(),e.relatedTarget)){return;}if(this._bClosedFromOverflow){this._oParentSlider.focus();this._bClosedFromOverflow=false;}this.hide();};
b.prototype.onBeforeRendering=function(){this._bRtl=sap.ui.getCore().getConfiguration().getRTL();};
b.prototype.exit=function(){this._oParentSlider=null;this._$ParentSlider=null;document.removeEventListener("scroll",this._scrollListener,true);};
return b;});
sap.ui.predefine('sap/m/SliderTooltipContainerRenderer',['sap/ui/core/Renderer'],function(R){"use strict";var S={apiVersion:2},C={MAIN_CLASS:"sapMSliderTooltipContainer"};
S.render=function(r,c){var t=c.getAssociatedTooltipsAsControls();r.openStart("div",c).style("width",c.getWidth()).openEnd();r.openStart("div",c.getId()+"-container").style("left","0%").style("right","0%").class(C.MAIN_CLASS);if(!c.getEnabled()){r.class(C.MAIN_CLASS+"Disabled");}r.openEnd();if(t&&t.length){t.forEach(function(T){r.renderControl(T);});}r.close("div").close("div");};
return S;},true);
sap.ui.predefine('sap/m/SliderTooltipRenderer',['sap/ui/core/Renderer',"sap/ui/core/Core"],function(R,C){"use strict";var S={apiVersion:2};S.CSS_CLASS="sapMSliderTooltip";
S.render=function(r,c){r.openStart("div",c).class(S.CSS_CLASS);if(!c.getEditable()){r.class(S.CSS_CLASS+"NonEditableWrapper");}if(c.getWidth()){r.style("width",c.getWidth());}r.openEnd();this.renderTooltipElement(r,c);r.close("div");};
S.renderTooltipElement=function(r,c){var o=C.getLibraryResourceBundle("sap.m");r.voidStart("input",c.getId()+"-input").class(S.CSS_CLASS+"Input");if(!c.getEditable()){r.class(S.CSS_CLASS+"NonEditable");}else{r.attr("aria-label",o.getText("SLIDER_INPUT_LABEL"));}r.accessibilityState(c).attr("tabindex","-1").attr("value",c.getValue()).attr("type","number").attr("step",c.getStep()).voidEnd();};
return S;},true);
sap.ui.predefine('sap/m/SliderUtilities',function(){"use strict";var S={};S.CONSTANTS={CHARACTER_WIDTH_PX:8,F2_KEYCODE:113,RANGE_MOVEMENT_THRESHOLD:32,HANDLE_CLASS:"sapMSliderHandle",RANGE_SLIDER_NAME:"sap.m.RangeSlider",TOOLTIP_CLASS:"sapMSliderTooltip",SLIDER_SIDE_PADDING:17,TOOLTIP_SIDE_PADDING:8,HANDLE_HALF_WIDTH:16,TOOLTIP_BORDER:1,FOLLOW_OF_TOLERANCE:24,TICKMARKS:{MAX_POSSIBLE:101,MIN_SIZE:{SMALL:8,WITH_LABEL:80}}};
S.getPercentOfValue=function(v,m,M){return((v-m)/(M-m))*100;};
S.getElementScrollableParent=function(d){if(!d){return document.body;}if(d.scrollHeight>=d.clientHeight){return d;}return this.getElementScrollableParent(d.parentNode);};
S.isScrolledIntoView=function(e,c){if(!(e||e.getBoundingClientRect)||!(c||c.getBoundingClientRect)){return false;}var C=c.getBoundingClientRect(),o=C.top,E=e.getBoundingClientRect().top,b=(o-this.CONSTANTS.FOLLOW_OF_TOLERANCE)>E,a=(o+C.height-this.CONSTANTS.FOLLOW_OF_TOLERANCE)<E;if(b||a){return false;}return true;};
return S;});
sap.ui.predefine('sap/m/SplitApp',['./SplitContainer','./library','sap/ui/Device','./SplitAppRenderer',"sap/ui/util/Mobile","sap/ui/thirdparty/jquery"],function(S,l,D,a,M,q){"use strict";
var b=S.extend("sap.m.SplitApp",{metadata:{library:"sap.m",properties:{homeIcon:{type:"any",group:"Misc",defaultValue:null}},events:{orientationChange:{parameters:{landscape:{type:"boolean"}}}},designtime:"sap/m/designtime/SplitApp.designtime"}});
b.prototype.init=function(){if(S.prototype.init){S.prototype.init.apply(this,arguments);}this.addStyleClass("sapMSplitApp");M.init({viewport:!this._debugZoomAndScroll,statusBar:"default",hideBrowser:true,preventScroll:!this._debugZoomAndScroll,rootId:this.getId()});};
b.prototype.onBeforeRendering=function(){if(S.prototype.onBeforeRendering){S.prototype.onBeforeRendering.apply(this,arguments);}M.init({homeIcon:this.getHomeIcon()});};
b.prototype.onAfterRendering=function(){if(S.prototype.onAfterRendering){S.prototype.onAfterRendering.apply(this,arguments);}var r=this.getDomRef().parentNode;while(r&&r!==document.documentElement){var $=q(r);if($.attr("data-sap-ui-root-content")){break;}if(!r.style.height){r.style.height="100%";}r=r.parentNode;}};
b.prototype._onOrientationChange=function(){this.fireOrientationChange({landscape:D.orientation.landscape});};
return b;});
sap.ui.predefine('sap/m/SplitAppRenderer',['./SplitContainerRenderer','sap/ui/core/Renderer','sap/m/library'],function(S,R,l){"use strict";var B=l.BackgroundHelper;var a=R.extend(S);a.apiVersion=2;
a.renderAttributes=function(r,c){B.addBackgroundColorStyles(r,c.getBackgroundColor(),c.getBackgroundImage());};
a.renderBeforeContent=function(r,c){B.renderBackgroundImageTag(r,c,"sapMSplitContainerBG",c.getBackgroundImage(),c.getBackgroundRepeat(),c.getBackgroundOpacity());};
return a;},true);
sap.ui.predefine('sap/m/SplitButton',['./library','sap/ui/core/Control','./Button','./ButtonRenderer','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','sap/ui/core/InvisibleText','./SplitButtonRenderer',"sap/ui/events/KeyCodes"],function(l,C,B,a,E,I,c,D,b,S,K){"use strict";var T=c.TextDirection;var d=l.ButtonType;
var e=C.extend("sap.m.SplitButton",{metadata:{interfaces:["sap.m.IOverflowToolbarContent"],library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null},type:{type:"sap.m.ButtonType",group:"Appearance",defaultValue:d.Default},width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:T.Inherit}},aggregations:{_textButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{},arrowPress:{}}}});
E.call(e.prototype);
e.prototype.onAfterRendering=function(){var $=this._getTextButton().$(),f=this._getArrowButton().$();$.attr("tabindex","-1");f.attr("tabindex","-1");$.removeAttr("title");f.removeAttr("title");$.removeAttr("aria-describedby");f.removeAttr("aria-describedby");};
e.prototype._handleAction=function(i){if(i){this.fireArrowPress();}else{this.firePress();}};
e.prototype.setArrowState=function(i){var A=this.getAggregation("_arrowButton");if(!A){return;}if(i){A.$().addClass('sapMSBActive');}else{A.$().removeClass('sapMSBActive');}};
e.prototype._getTextButton=function(){var o=this.getAggregation("_textButton");if(!o){o=new B({width:'100%',icon:this.getIcon(),text:this.getText(),press:this._handleAction.bind(this,false)}).addStyleClass('sapMSBText');if(D.browser.msie){o.addStyleClass('sapMSBTextIE');}this.setAggregation("_textButton",o);}return o;};
e.prototype._getArrowButton=function(){var o=this.getAggregation("_arrowButton");if(!o){o=new B({icon:"sap-icon://slim-arrow-down",press:this._handleAction.bind(this,true)}).addStyleClass("sapMSBArrow");this.setAggregation("_arrowButton",o);}return o;};
e.prototype.setProperty=function(p,v,s){if(p==="type"&&(v===d.Up||v===d.Back||v===d.Unstyled)){return this;}var r=C.prototype.setProperty.apply(this,arguments);if(p==="activeIcon"||p==="iconDensityAware"||p==="textDirection"){B.prototype.setProperty.apply(this._getTextButton(),arguments);}else if(p==="text"||p==="type"||p==="icon"){var f="set"+_(p);B.prototype[f].call(this._getTextButton(),v);if(p==="type"){B.prototype[f].call(this._getArrowButton(),v);}}return r;};
function _(t){return t.charAt(0).toUpperCase()+t.slice(1);}
e.prototype.onkeydown=function(o){if(o.which===K.SPACE){o.preventDefault();}if(o.which===K.ENTER){this._getTextButton().firePress({});}};
e.prototype.onkeyup=function(o){if(o.which===K.SPACE){this._getTextButton().firePress({});}};
e.prototype.onsapup=function(o){this._getArrowButton().firePress();};
e.prototype.onsapdown=function(o){this._getArrowButton().firePress();};
e.prototype.onsapupmodifiers=function(o){this._getArrowButton().firePress();};
e.prototype.onsapdownmodifiers=function(o){this._getArrowButton().firePress();};
e.prototype.onsapshow=function(o){this._getArrowButton().firePress();o.preventDefault();};
e.prototype.getButtonTypeAriaLabelId=function(){var s=this._getTextButton().getType();return a.getButtonTypeAriaLabelId(s);};
e.prototype.getTitleAttributeValue=function(){var t=this.getTooltip_AsString(),i=I.getIconInfo(this.getIcon()),r;if(t||(i&&i.text&&!this.getText())){r=t||i.text;}return r;};
e.prototype.getOverflowToolbarConfig=function(){var o={canOverflow:true,propsUnrelatedToSize:["enabled","type","icon","activeIcon"],autoCloseEvents:["press"]};return o;};
return e;});
sap.ui.predefine('sap/m/SplitButtonRenderer',["sap/m/library","sap/ui/core/InvisibleText","sap/ui/core/ShortcutHintsMixin"],function(l,I,S){"use strict";var B=l.ButtonType;var a={apiVersion:2};a.CSS_CLASS="sapMSB";
a.render=function(r,b){var w=b.getWidth(),t=b.getType(),e=b.getEnabled(),T=b.getTitleAttributeValue(),s;r.openStart("div",b).class(a.CSS_CLASS);if(b.getIcon()){r.class(a.CSS_CLASS+"HasIcon");}if(t===B.Accept||t===B.Reject||t===B.Emphasized||t===B.Transparent||t===B.Attention){r.class(a.CSS_CLASS+t);}this.writeAriaAttributes(r,b);r.attr("tabindex",e?"0":"-1");if(T&&!S.isDOMIDRegistered(b.getId())){r.attr("title",T);}if(w!=""||w.toLowerCase()==="auto"){r.style("width",w);}r.openEnd();r.openStart("div").class("sapMSBInner");if(!e){r.class("sapMSBInnerDisabled");}r.openEnd();r.renderControl(b._getTextButton());r.renderControl(b._getArrowButton());r.close("div");if(T){s=b.getId()+"-tooltip";r.openStart("span",s);r.class("sapUiInvisibleText");r.openEnd();r.text(T);r.close("span");}r.close("div");};
a.writeAriaAttributes=function(r,b){var A={};this.writeAriaRole(b,A);this.writeAriaLabelledBy(b,A);r.accessibilityState(b,A);};
a.writeAriaRole=function(b,A){A["role"]="group";};
a.writeAriaLabelledBy=function(b,A){var s="",o=b.getButtonTypeAriaLabelId(),t=b.getTitleAttributeValue(),T;if(b.getText()){s+=b._getTextButton().getId()+"-content";s+=" ";}if(o){s+=o;s+=" ";}if(t){T=b.getId()+"-tooltip";s+=T+" ";}s+=I.getStaticId("sap.m","SPLIT_BUTTON_DESCRIPTION")+" ";s+=I.getStaticId("sap.m","SPLIT_BUTTON_KEYBOARD_HINT");A["labelledby"]={value:s,append:true};};
return a;},true);
sap.ui.predefine('sap/m/SplitContainer',['./library','sap/ui/base/DataType','sap/ui/core/Control','sap/ui/core/IconPool','sap/m/semantic/SemanticPage','sap/ui/core/InvisibleText','sap/ui/Device','sap/ui/base/ManagedObject','sap/m/NavContainer','sap/m/Popover','sap/m/Button','./SplitContainerRenderer',"sap/ui/dom/containsOrEquals","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,D,C,I,S,a,b,M,N,P,B,c,d,L,q){"use strict";var e=l.ButtonType;var f=l.PlacementType;var g=l.SplitAppMode;
var h=C.extend("sap.m.SplitContainer",{metadata:{library:"sap.m",properties:{defaultTransitionNameDetail:{type:"string",group:"Appearance",defaultValue:"slide"},defaultTransitionNameMaster:{type:"string",group:"Appearance",defaultValue:"slide"},mode:{type:"sap.m.SplitAppMode",group:"Appearance",defaultValue:g.ShowHideMode},masterButtonText:{type:"string",group:"Appearance",defaultValue:null},masterButtonTooltip:{type:"string",group:"Appearance",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},backgroundImage:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},backgroundRepeat:{type:"boolean",group:"Appearance",defaultValue:false},backgroundOpacity:{type:"float",group:"Appearance",defaultValue:1}},aggregations:{masterPages:{type:"sap.ui.core.Control",multiple:true,singularName:"masterPage"},detailPages:{type:"sap.ui.core.Control",multiple:true,singularName:"detailPage"},_navMaster:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navDetail:{type:"sap.m.NavContainer",multiple:false,visibility:"hidden"},_navPopover:{type:"sap.m.Popover",multiple:false,visibility:"hidden"}},associations:{initialDetail:{type:"sap.ui.core.Control",multiple:false},initialMaster:{type:"sap.ui.core.Control",multiple:false}},events:{masterNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterMasterNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},masterButton:{},beforeMasterOpen:{},afterMasterOpen:{},beforeMasterClose:{},afterMasterClose:{},detailNavigate:{allowPreventDefault:true,parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}},afterDetailNavigate:{parameters:{from:{type:"sap.ui.core.Control"},fromId:{type:"string"},to:{type:"sap.ui.core.Control"},toId:{type:"string"},firstTime:{type:"boolean"},isTo:{type:"boolean"},isBack:{type:"boolean"},isBackToTop:{type:"boolean"},isBackToPage:{type:"boolean"},direction:{type:"string"}}}},designtime:"sap/m/designtime/SplitContainer.designtime"}});
h.prototype.init=function(){var t=this;if(sap.ui.getCore().getConfiguration().getAccessibility()&&!h._sAriaPopupLabelId){h._sAriaPopupLabelId=new a({text:''}).toStatic().getId();}this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._aMasterPages=[];this._aDetailPages=[];if(!b.system.phone){this._oMasterNav=new N(this.getId()+"-Master",{width:"",navigate:function(E){t._handleNavigationEvent(E,false,true);},afterNavigate:function(E){t._handleNavigationEvent(E,true,true);t._updateMasterButtonTooltip();}});this._oDetailNav=new N(this.getId()+"-Detail",{width:"",navigate:function(E){t._handleNavigationEvent(E,false,false);},afterNavigate:function(E){t._handleNavigationEvent(E,true,false);}});this.setAggregation("_navMaster",this._oMasterNav,true);this.setAggregation("_navDetail",this._oDetailNav,true);this._createShowMasterButton();this._oPopOver=new P(this.getId()+"-Popover",{placement:f.Bottom,showHeader:false,contentWidth:"320px",contentHeight:"600px",beforeOpen:function(){t.fireBeforeMasterOpen();},beforeClose:function(){t.fireBeforeMasterClose();},afterOpen:function(){t.fireAfterMasterOpen();t._bMasterisOpen=true;},afterClose:function(){t._afterHideMasterAnimation();}}).addStyleClass("sapMSplitContainerPopover");if(h._sAriaPopupLabelId){this._oPopOver.addAriaLabelledBy(h._sAriaPopupLabelId);}this.setAggregation("_navPopover",this._oPopOver,true);}else{this._oMasterNav=this._oDetailNav=new N({width:"",navigate:function(E){t._handleNavigationEvent(E,false,true);},afterNavigate:function(E){t._handleNavigationEvent(E,true,true);}});this.setAggregation("_navMaster",this._oMasterNav,true);}this._oldIsLandscape=b.orientation.landscape;this._bMasterisOpen=false;var t=this;var p=function(r,n,s){return function(o,A,j){r.apply(t[n],arguments);if(A==="pages"&&t[s]&&t[s].indexOf(o)!==-1){t._removePageFromArray(t[s],o);}};};var m=this._oMasterNav._removeChild;this._oMasterNav._removeChild=p(m,"_oMasterNav","_aMasterPages");if(this._oDetailNav){var i=this._oDetailNav._removeChild;this._oDetailNav._removeChild=p(i,"_oDetailNav","_aDetailPages");}};
h.prototype.onBeforeRendering=function(){if(this._fnResize){b.resize.detachHandler(this._fnResize);}if(this._bMasterisOpen&&(this._portraitHide()||this._hideMode())){this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._bMasterisOpen=false;}this._updateMasterButtonTooltip();this._oMasterNav.setInitialPage(sap.ui.getCore().byId(this.getInitialMaster()));this._oMasterNav.setDefaultTransitionName(this.getDefaultTransitionNameMaster());if(!b.system.phone){this._oDetailNav.setInitialPage(sap.ui.getCore().byId(this.getInitialDetail()));this._oShowMasterBtn.setText(this.getMasterButtonText()||this._rb.getText("SPLITCONTAINER_NAVBUTTON_TEXT"));}this._oDetailNav.setDefaultTransitionName(this.getDefaultTransitionNameDetail());};
h.prototype.exit=function(){if(this._fnResize){b.resize.detachHandler(this._fnResize);}delete this._aMasterPages;delete this._aDetailPages;if(this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn=null;}};
h.prototype.onAfterRendering=function(){if(!b.system.phone&&this._oPopOver&&this._oPopOver.isOpen()){this._oPopOver.close();}if(!this._fnResize){this._fnResize=q.proxy(this._handleResize,this);}b.resize.attachHandler(this._fnResize);if(b.os.windows&&b.browser.internet_explorer){this._oMasterNav.$().append('<iframe class="sapMSplitContainerMasterBlindLayer" src="about:blank"></iframe>');}setTimeout(function(){this._oMasterNav.removeStyleClass("sapMSplitContainerNoTransition");}.bind(this),0);};
h.prototype.applySettings=function(s,o){C.prototype.applySettings.call(this,s,o);this._updateMasterInitialPage();};
h.prototype.ontouchstart=function(E){if(!b.system.phone){this._bIgnoreSwipe=(E.originalEvent&&E.originalEvent._sapui_handledByControl);}};
h.prototype.onswiperight=function(E){if(b.support.touch===false){return;}if((b.system.tablet||(b.os.windows&&b.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe&&!this._bDetailNavButton){this.showMaster();}};
h.prototype.ontap=function(E){if(b.system.phone){return;}var i=true,$=q(E.target).closest(".sapMSplitContainerDetail, .sapMSplitContainerMaster"),m=E.srcControl.getMetadata();if($.length>0&&$.hasClass("sapMSplitContainerDetail")){i=false;}if(((!this._oldIsLandscape&&this.getMode()=="ShowHideMode")||this.getMode()=="HideMode")&&!i&&!d(this._oShowMasterBtn.getDomRef(),E.target)&&(!m.getEvent("tap")||!m.getEvent("press"))){this.hideMaster();}};
h.prototype.onswipeleft=function(E){if((b.system.tablet||(b.os.windows&&b.os.version>=8))&&(this._portraitHide()||this._hideMode())&&!this._bIgnoreSwipe){this.hideMaster();}};
h.prototype._onMasterButtonTap=function(E){if(b.system.phone){return;}if(!this._oldIsLandscape){if(this.getMode()=="PopoverMode"){if(!this._oPopOver.isOpen()){this._oPopOver.openBy(this._oShowMasterBtn,true);}else{this._oPopOver.close();}}else{this.showMaster();}}else{if(this.getMode()==="HideMode"){this.showMaster();}}};
h.prototype.to=function(p,t,i,T){if(this._oMasterNav.getPage(p)){this._oMasterNav.to(p,t,i,T);}else{this._oDetailNav.to(p,t,i,T);}};
h.prototype.backToPage=function(p,i,t){if(this._oMasterNav.getPage(p)){this._oMasterNav.backToPage(p,i,t);}else{this._oDetailNav.backToPage(p,i,t);}};
h.prototype.insertPreviousPage=function(p,t,i){if(this._oMasterNav.getPage(p)){this._oMasterNav.insertPreviousPage(p,t,i);}else{this._oDetailNav.insertPreviousPage(p,t,i);}return this;};
h.prototype.toMaster=function(p,t,i,T){this._oMasterNav.to(p,t,i,T);};
h.prototype.backMaster=function(i,t){this._oMasterNav.back(i,t);};
h.prototype.backMasterToPage=function(p,i,t){this._oMasterNav.backToPage(p,i,t);};
h.prototype.toDetail=function(p,t,i,T){this._oDetailNav.to(p,t,i,T);};
h.prototype.backDetail=function(i,t){this._oDetailNav.back(i,t);};
h.prototype.backDetailToPage=function(p,i,t){this._oDetailNav.backToPage(p,i,t);};
h.prototype.backToTopMaster=function(i,t){this._oMasterNav.backToTop(i,t);};
h.prototype.backToTopDetail=function(i,t){this._oDetailNav.backToTop(i,t);};
h.prototype.addMasterPage=function(p){if(this._hasPageInArray(this._aMasterPages,p)){return;}if(this._oMasterNav===this._oDetailNav&&this._oDetailNav.getPages()&&this._oDetailNav.getPages().indexOf(p)!==-1){this._removePageFromArray(this._aDetailPages,p);}this._oMasterNav.insertPage(p,this._aMasterPages.length);this._aMasterPages.push(p);return this;};
h.prototype.addDetailPage=function(p){var t=this,r=this._getRealPage(p);if(this._hasPageInArray(this._aDetailPages,p)){return;}p.addDelegate({onBeforeShow:function(){if(r){if(!b.system.phone){if(t._needShowMasterButton()){t._setMasterButton(r);}}}}});if(r){r.addDelegate({onBeforeRendering:function(){if(!b.system.phone&&(t._oDetailNav.getCurrentPage()===r)){if(!r.getShowNavButton()&&t._needShowMasterButton()){t._setMasterButton(r,true);}else{t._removeMasterButton(r);}}}});if(!b.system.phone){if(!r._setCustomHeaderInSC){r._setCustomHeaderInSC=r.setCustomHeader;}r.setCustomHeader=function(H){this._setCustomHeaderInSC.apply(this,arguments);if(H&&t._needShowMasterButton()){t._setMasterButton(r);}return this;};if(!r._setShowNavButtonInSC){r._setShowNavButtonInSC=r.setShowNavButton;}r.setShowNavButton=function(s){this._setShowNavButtonInSC.apply(this,arguments);if(!s&&t._needShowMasterButton()){t._setMasterButton(r);}else{t._removeMasterButton(r,true);}return this;};}}if(this._oMasterNav===this._oDetailNav&&this._oMasterNav.getPages()&&this._oMasterNav.getPages().indexOf(p)!==-1){this._removePageFromArray(this._aMasterPages,p);}this._oDetailNav.addPage(p);this._aDetailPages.push(p);return this;};
h.prototype.getMasterPages=function(){return this._aMasterPages.slice();};
h.prototype.getDetailPages=function(){return this._aDetailPages.slice();};
h.prototype.indexOfMasterPage=function(p){return this._indexOfMasterPage(p);};
h.prototype.indexOfDetailPage=function(p){return this._indexOfDetailPage(p);};
h.prototype.insertMasterPage=function(p,i,s){return this._insertPage(this._aMasterPages,"masterPages",p,i,s);};
h.prototype.removeMasterPage=function(p,s){return this._removePage(this._aMasterPages,"masterPages",p,s);};
h.prototype.removeAllMasterPages=function(s){this._aMasterPages=[];return this.removeAllAggregation("masterPages",s);};
h.prototype.insertDetailPage=function(p,i,s){return this._insertPage(this._aDetailPages,"detailPages",p,i,s);};
h.prototype._restoreMethodsInPage=function(p){if(b.system.phone){return;}var r=this._getRealPage(p);if(r){if(r._setCustomHeaderInSC){r.setCustomHeader=r._setCustomHeaderInSC;delete r._setCustomHeaderInSC;}if(r._setShowNavButtonInSC){r.setShowNavButton=r._setShowNavButtonInSC;delete r._setShowNavButtonInSC;}}};
h.prototype.removeDetailPage=function(p,s){this._restoreMethodsInPage(p);return this._removePage(this._aDetailPages,"detailPages",p,s);};
h.prototype.removeAllDetailPages=function(s){var p=this.getDetailPages();for(var i=0;i<p.length;i++){this._restoreMethodsInPage(p[i]);}this._aDetailPages=[];return this.removeAllAggregation("detailPages",s);};
h.prototype.addPage=function(p,m){if(m){return this.addMasterPage(p);}else{return this.addDetailPage(p);}};
h.prototype.showMaster=function(){var t=this,_=this._getRealPage(this._oDetailNav.getCurrentPage());function i(){this._oPopOver.detachAfterOpen(i,this);this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}if(this._portraitPopover()){if(!this._oPopOver.isOpen()){this._oPopOver.attachAfterOpen(i,this);this.fireBeforeMasterOpen();this._oPopOver.openBy(this._oShowMasterBtn,true);this._bMasterOpening=true;}}else if((this._portraitHide()||this._hideMode())&&(!this._bMasterisOpen||this._bMasterClosing)){this._oMasterNav.$().one("webkitTransitionEnd transitionend",q.proxy(this._afterShowMasterAnimation,this));this.fireBeforeMasterOpen();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",true);this._oMasterNav.getDomRef()&&this._oMasterNav.getDomRef().offsetHeight;this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",false);this._bMasterOpening=true;t._removeMasterButton(_);if(b.browser.webkit){var m=this._oMasterNav;window.setTimeout(function(){m.$().css("box-shadow","none");window.setTimeout(function(){m.$().css("box-shadow","");},50);},0);}}return this;};
h.prototype.hideMaster=function(){if(this._portraitPopover()){if(this._oPopOver.isOpen()){this._oPopOver.close();this._bMasterClosing=true;}}else if((this._portraitHide()||this._hideMode())&&(this._bMasterisOpen||this._oMasterNav.$().hasClass("sapMSplitContainerMasterVisible"))){this._oMasterNav.$().one("webkitTransitionEnd transitionend",q.proxy(this._afterHideMasterAnimation,this));this.fireBeforeMasterClose();this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.getDomRef()&&this._oMasterNav.getDomRef().offsetHeight;this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterClosing=true;}return this;};
h.prototype._afterShowMasterAnimation=function(){if(this._portraitHide()||this._hideMode()){this._bMasterOpening=false;this._bMasterisOpen=true;this.fireAfterMasterOpen();}};
h.prototype._afterHideMasterAnimation=function(){var o=this._getRealPage(this._oDetailNav.getCurrentPage());this._setMasterButton(o);this._bMasterClosing=false;this._bMasterisOpen=false;if(d(this._oMasterNav.getDomRef(),document.activeElement)){document.activeElement.blur();}this.fireAfterMasterClose();};
h.prototype.getCurrentMasterPage=function(){return this._oMasterNav.getCurrentPage();};
h.prototype.getCurrentDetailPage=function(){return this._oDetailNav.getCurrentPage();};
h.prototype.getCurrentPage=function(m){if(m){return this.getCurrentMasterPage();}else{return this.getCurrentDetailPage();}};
h.prototype.getPreviousPage=function(m){if(m){return this._oMasterNav.getPreviousPage();}else{return this._oDetailNav.getPreviousPage();}};
h.prototype.getMasterPage=function(p){return this._oMasterNav.getPage(p);};
h.prototype.getDetailPage=function(p){return this._oDetailNav.getPage(p);};
h.prototype.getPage=function(p,m){if(m){return this.getMasterPage(p);}else{return this.getDetailPage(p);}};
h.prototype.isMasterShown=function(){if(b.system.phone){var o=this._oMasterNav.getCurrentPage();return this._indexOfMasterPage(o)!==-1;}else{var m=this.getMode();switch(m){case g.StretchCompressMode:return true;case g.HideMode:return this._bMasterisOpen;case g.PopoverMode:case g.ShowHideMode:return b.orientation.landscape||this._bMasterisOpen;default:return false;}}};
h.prototype.setBackgroundOpacity=function(o){if(o>1||o<0){L.warning("Invalid value "+o+" for SplitContainer.setBackgroundOpacity() ignored. Valid values are: floats between 0 and 1.");return this;}return this.setProperty("backgroundOpacity",o);};
h.prototype.setMode=function(m){var o=this.getMode();if(o===m){return this;}this.setProperty("mode",m,true);if(b.system.phone||!this.getDomRef()){return this;}if(o==="HideMode"&&this._oldIsLandscape){this._removeMasterButton(this._oDetailNav.getCurrentPage());}var i=this.getDomRef();if(m!=="PopoverMode"&&this._oPopOver.getContent().length>0){this._updateMasterPosition("landscape");}else if(m=="PopoverMode"){if(!this._oldIsLandscape){if(this._oPopOver.getContent().length===0){this._updateMasterPosition("popover");}this._setMasterButton(this._oDetailNav.getCurrentPage());}i.classList.remove("sapMSplitContainerShowHide");i.classList.remove("sapMSplitContainerStretchCompress");i.classList.remove("sapMSplitContainerHideMode");i.classList.add("sapMSplitContainerPopover");}if(m=="StretchCompressMode"){i.classList.remove("sapMSplitContainerShowHide");i.classList.remove("sapMSplitContainerPopover");i.classList.remove("sapMSplitContainerHideMode");i.classList.add("sapMSplitContainerStretchCompress");this._removeMasterButton(this._oDetailNav.getCurrentPage());}if(m=="ShowHideMode"){i.classList.remove("sapMSplitContainerPopover");i.classList.remove("sapMSplitContainerStretchCompress");i.classList.remove("sapMSplitContainerHideMode");i.classList.add("sapMSplitContainerShowHide");if(!b.orientation.landscape){this._setMasterButton(this._oDetailNav.getCurrentPage());}}if(m==="HideMode"){i.classList.remove("sapMSplitContainerPopover");i.classList.remove("sapMSplitContainerStretchCompress");i.classList.remove("sapMSplitContainerShowHide");i.classList.add("sapMSplitContainerHideMode");this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",false);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",true);this._bMasterisOpen=false;this._setMasterButton(this._oDetailNav.getCurrentPage());}return this;};
h.prototype._updateMasterInitialPage=function(){if(this.getMode()==="HideMode"&&b.system.phone&&this._aDetailPages){this._oMasterNav.setInitialPage(this.getInitialDetail()?this.getInitialDetail():(this.getInitialMaster()||this._aDetailPages[0]));}};
h.prototype._indexOfMasterPage=function(p){return this._aMasterPages.indexOf(p);};
h.prototype._indexOfDetailPage=function(p){return this._aDetailPages.indexOf(p);};
h.prototype._insertPage=function(p,A,o,j,s){this.insertAggregation(A,o,j,s);var i;if(j<0){i=0;}else if(j>p.length){i=p.length;}else{i=j;}var O=(p?Array.prototype.indexOf.call(p,o):-1);p.splice(i,0,o);if(O!=-1){this._removePageFromArray(p,o);}return this;};
h.prototype._removePage=function(p,A,o,s){var r=this.removeAggregation(A,o,s);if(r){this._removePageFromArray(p,r);}return r;};
h.prototype._removePageFromArray=function(p,o){var i=(p?Array.prototype.indexOf.call(p,o):-1);if(i!=-1){p.splice(i,1);if(p===this._aDetailPages){this._restoreMethodsInPage(o);}}};
h.prototype._handleNavigationEvent=function(E,A,m){var s=(A?"After":"")+(m?"Master":"Detail")+"Navigate",i;s=s.charAt(0).toLowerCase()+s.slice(1);i=this.fireEvent(s,E.mParameters,true);if(!i){E.preventDefault();}};
h.prototype._handleResize=function(){var i=b.orientation.landscape,_=this._oDetailNav.getCurrentPage(),m=this.getMode();if(this._oldIsLandscape!==i){this._oldIsLandscape=i;if(!b.system.phone){this.$().toggleClass("sapMSplitContainerPortrait",!i);if(m==="HideMode"){return;}if(m==="ShowHideMode"){if(i){this.fireBeforeMasterOpen();}else{this.fireBeforeMasterClose();}}if(m==="ShowHideMode"||m==="PopoverMode"){this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterVisible",i);this._oMasterNav.toggleStyleClass("sapMSplitContainerMasterHidden",!i);}if(m==="ShowHideMode"){if(i){this._bMasterisOpen=true;this.fireAfterMasterOpen();}else{this._bMasterisOpen=false;this.fireAfterMasterClose();}}if(m=="PopoverMode"){if(this._oPopOver.isOpen()){this._oPopOver.attachAfterClose(this._handlePopClose,this);this._oPopOver.close();}else{this._handlePopClose();}}_=this._getRealPage(_);if(!this._oldIsLandscape&&m!="StretchCompressMode"){this._setMasterButton(_);}else{this._removeMasterButton(_);}}if(this._onOrientationChange){this._onOrientationChange();}}};
h.prototype._handlePopClose=function(E){this._oPopOver.detachAfterClose(this._handlePopClose,this);if(this._oldIsLandscape){this._updateMasterPosition("landscape");}else{this._updateMasterPosition("popover");}};
h.prototype._getRealPage=function(p){var r=p,i;while(r){if(r instanceof sap.m.Page){return r;}if(r instanceof sap.m.MessagePage){return r;}if(r instanceof S){return r;}if(r instanceof sap.ui.core.mvc.View){i=r.getContent();if(i.length===1){r=i[0];continue;}}else if(r instanceof N){r=r.getCurrentPage();continue;}r=null;}return r;};
h.prototype._updateMasterPosition=function(p){var t=this;if(p=="popover"){this.removeAggregation("_navMaster",this._oMasterNav,true);this._oMasterNav.$().remove();this._oPopOver.addContent(this._oMasterNav);this._bMasterisOpen=false;}if(p=="landscape"){var r=function(){t._oPopOver.removeAggregation("content",t._oMasterNav,false);t.setAggregation("_navMaster",t._oMasterNav,true);var $=t.$();if($[0]){var i=sap.ui.getCore().createRenderManager();i.renderControl(t._oMasterNav.addStyleClass("sapMSplitContainerMaster"));i.flush($[0],false,(t.$("BG")[0])?1:0);i.destroy();}};if(this._oPopOver.isOpen()){var A=function(){this._oPopOver.detachAfterClose(A,this);this._bMasterisOpen=false;r();};this._oPopOver.attachAfterClose(A,this);this._oPopOver.close();}else{r();}}};
h.prototype._portraitHide=function(){if(!this._oldIsLandscape&&!b.system.phone&&this.getMode()==="ShowHideMode"){return true;}else{return false;}};
h.prototype._portraitPopover=function(){if(!this._oldIsLandscape&&!b.system.phone&&this.getMode()==="PopoverMode"){return true;}else{return false;}};
h.prototype._hideMode=function(){return this.getMode()==="HideMode"&&!b.system.phone;};
h.prototype._needShowMasterButton=function(){return(this._portraitHide()||this._hideMode()||this._portraitPopover())&&(!this._bMasterisOpen||this._bMasterClosing);};
h.prototype._updateMasterButtonTooltip=function(){if(!this._oShowMasterBtn){return;}var t=this.getMasterButtonTooltip();if(t){this._oShowMasterBtn.setTooltip(t);return;}var p=this._oMasterNav.getCurrentPage();if(p&&p.getTitle){var T=p.getTitle();if(T){T=T.replace(/[_0-9]+$/,'');t=this._rb.getText('SPLITCONTAINER_NAVBUTTON_TOOLTIP',T);}}if(!t){t=this._rb.getText('SPLITCONTAINER_NAVBUTTON_DEFAULT_TOOLTIP');}this._oShowMasterBtn.setTooltip(t);};
h.prototype._createShowMasterButton=function(){if(this._oShowMasterBtn&&!this._oShowMasterBtn.bIsDestroyed){return;}this._oShowMasterBtn=new B(this.getId()+"-MasterBtn",{icon:I.getIconURI("menu2"),tooltip:this.getMasterButtonTooltip(),type:e.Default,press:q.proxy(this._onMasterButtonTap,this)}).addStyleClass("sapMSplitContainerMasterBtn");};
h.prototype._setMasterButton=function(p,j,s){if(!p){return;}if(typeof j==='boolean'){s=j;j=undefined;}p=this._getRealPage(p);if(!p){return;}var H=h._getHeaderButtonAggregation(p),k=H.sAggregationName,m=H.aAggregationContent;for(var i=0;i<m.length;i++){if(m[i]instanceof sap.m.Button&&m[i].getVisible()&&(m[i].getType()==e.Back||(m[i].getType()==e.Up&&m[i]!==this._oShowMasterBtn))){this._bDetailNavButton=true;return;}}this._bDetailNavButton=false;var o=p._getAnyHeader();var n=false;for(var i=0;i<m.length;i++){if(m[i]===this._oShowMasterBtn){n=true;}}if(!n){this._createShowMasterButton();this._updateMasterButtonTooltip();this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");if(o){o.insertAggregation(k,this._oShowMasterBtn,0,s);}}else{this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnHide",false);this._oShowMasterBtn.removeStyleClass("sapMSplitContainerMasterBtnHidden");this._oShowMasterBtn.$().parent().toggleClass("sapMSplitContainerMasterBtnShow",true);}if(j){j(p);}this.fireMasterButton({show:true});};
h._getHeaderButtonAggregation=function(p){var H=p._getAnyHeader(),A,s;if(!H){return;}if(H.getContentLeft){A=H.getContentLeft();s="contentLeft";}if(H.getContent){A=H.getContent();s="content";}return{aAggregationContent:A,sAggregationName:s};};
h.prototype._removeMasterButton=function(p,j,n){if(!p){return;}var t=this,H=this._oShowMasterBtn.$().is(":hidden"),o;if(typeof j==="boolean"){n=j;j=undefined;}if(!H&&!n){p=this._getRealPage(p);if(!p){return;}o=p._getAnyHeader();if(o){var k=h._getHeaderButtonAggregation(p).aAggregationContent;for(var i=0;i<k.length;i++){if(k[i]===this._oShowMasterBtn){this._oShowMasterBtn.destroy();this._oShowMasterBtn.$().parent().on("webkitAnimationEnd animationend",function(){q(this).off("webkitAnimationEnd animationend");t._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(j){j(p);}});break;}}}this.fireMasterButton({show:false});}else{this._oShowMasterBtn.addStyleClass("sapMSplitContainerMasterBtnHidden");if(j){j(p);}if(!H){this.fireMasterButton({show:false});}}};
h.prototype._callMethodInManagedObject=function(F,A){var i=Array.prototype.slice.call(arguments);if(A==="masterPages"){if(F==="indexOfAggregation"){return this._indexOfMasterPage.apply(this,i.slice(2));}else{return this._callNavContainerMethod(F,this._oMasterNav,i);}}else if(A==="detailPages"){if(F==="indexOfAggregation"){return this._indexOfDetailPage.apply(this,i.slice(2));}else{return this._callNavContainerMethod(F,this._oDetailNav,i);}}else{return M.prototype[F].apply(this,i.slice(1));}};
h.prototype._callNavContainerMethod=function(F,n,A){A[1]="pages";A=A.slice(1);var r=h._mFunctionMapping[F];if(r){A.shift();F=r;}return n[F].apply(n,A);};
h.prototype._hasPageInArray=function(i,p){return i.some(function(A){return p&&(p===A);});};
h.prototype.validateAggregation=function(A,o,m){return this._callMethodInManagedObject("validateAggregation",A,o,m);};
h.prototype.setAggregation=function(A,o,s){this._callMethodInManagedObject("setAggregation",A,o,s);return this;};
h.prototype.getAggregation=function(A,o){return this._callMethodInManagedObject("getAggregation",A,o);};
h.prototype.indexOfAggregation=function(A,o){return this._callMethodInManagedObject("indexOfAggregation",A,o);};
h.prototype.insertAggregation=function(A,o,i,s){this._callMethodInManagedObject("insertAggregation",A,o,i,s);return this;};
h.prototype.addAggregation=function(A,o,s){this._callMethodInManagedObject("addAggregation",A,o,s);return this;};
h.prototype.removeAggregation=function(A,o,s){return this._callMethodInManagedObject("removeAggregation",A,o,s);};
h.prototype.removeAllAggregation=function(A,s){return this._callMethodInManagedObject("removeAllAggregation",A,s);};
h.prototype.destroyAggregation=function(A,s){this._callMethodInManagedObject("destroyAggregation",A,s);return this;};
h._mFunctionMapping={"getAggregation":"getPage","addAggregation":"addPage","insertAggregation":"insertPage","removeAggregation":"removePage","removeAllAggregation":"removeAllPages"};return h;});
sap.ui.predefine('sap/m/SplitContainerRenderer',["./library","sap/ui/Device"],function(l,D){"use strict";var S=l.SplitAppMode;var a={apiVersion:2};
a.render=function(r,s){var m=s.getMode(),t=s.getTooltip_AsString();r.openStart("div",s).class("sapMSplitContainer");if(this.renderAttributes){this.renderAttributes(r,s);}if(!D.system.phone){if(D.orientation.portrait){r.class("sapMSplitContainerPortrait");}switch(m){case S.ShowHideMode:r.class("sapMSplitContainerShowHide");break;case S.StretchCompressMode:r.class("sapMSplitContainerStretchCompress");break;case S.PopoverMode:r.class("sapMSplitContainerPopover");break;case S.HideMode:r.class("sapMSplitContainerHideMode");break;default:break;}}if(t){r.attr("title",t);}r.openEnd();if(this.renderBeforeContent){this.renderBeforeContent(r,s);}this.renderMasterAndDetail(r,s,m);r.close("div");};
a.renderMasterAndDetail=function(r,s,m){if(D.system.phone){s._oMasterNav.addStyleClass("sapMSplitContainerMobile");r.renderControl(s._oMasterNav);return;}s._bMasterisOpen=false;if((D.orientation.landscape&&(m!==S.HideMode))||D.orientation.portrait&&(m===S.StretchCompress)){s._oMasterNav.addStyleClass("sapMSplitContainerMasterVisible").removeStyleClass("sapMSplitContainerMasterHidden").removeStyleClass("sapMSplitContainerNoTransition");s._bMasterisOpen=true;}else{s._oMasterNav.addStyleClass("sapMSplitContainerMasterHidden").addStyleClass("sapMSplitContainerNoTransition").removeStyleClass("sapMSplitContainerMasterVisible");}if(m===S.PopoverMode&&D.orientation.portrait){s._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(s._oDetailNav);if(s._oPopOver.getContent().length===0){s._oPopOver.addAggregation("content",s._oMasterNav,true);}}else{s._oMasterNav.addStyleClass("sapMSplitContainerMaster");r.renderControl(s._oMasterNav);s._oDetailNav.addStyleClass("sapMSplitContainerDetail");r.renderControl(s._oDetailNav);}};
return a;},true);
sap.ui.predefine('sap/m/StandardListItem',["sap/ui/core/library","sap/ui/core/IconPool","sap/ui/core/theming/Parameters","sap/ui/Device","./library","./ListItemBase","./Image","./StandardListItemRenderer"],function(c,I,T,D,l,L,a,S){"use strict";var b=c.TextDirection;var V=c.ValueState;
var d=L.extend("sap.m.StandardListItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},description:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},iconInset:{type:"boolean",group:"Appearance",defaultValue:true},iconDensityAware:{type:"boolean",group:"Misc",defaultValue:true},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},adaptTitleSize:{type:"boolean",group:"Appearance",defaultValue:true},titleTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit},infoTextDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit},wrapping:{type:"boolean",group:"Behavior",defaultValue:false},infoStateInverted:{type:"boolean",group:"Appearance",defaultValue:false}},designtime:"sap/m/designtime/StandardListItem.designtime"}});
d.prototype.exit=function(){if(this._oImage){this._oImage.destroy("KeepDom");}L.prototype.exit.apply(this,arguments);};
d.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oImage&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oImage.destroy("KeepDom");this._oImage=undefined;}return this;};
d.prototype._getImage=function(){var i=this._oImage;if(i){i.setSrc(this.getIcon());if(i.setDensityAware){i.setDensityAware(this.getIconDensityAware());}}else{i=I.createControlByURI({id:this.getId()+"-img",src:this.getIcon(),densityAware:this.getIconDensityAware(),useIconTooltip:false},a).setParent(this,null,true);}var s=this.getIconInset()?"sapMSLIImg":"sapMSLIImgNoInset";i.addStyleClass(i instanceof a?s:s+"Icon",true);this._oImage=i;return this._oImage;};
d.prototype._activeHandlingInheritor=function(){if(this._oImage){var A=this.getActiveIcon();A&&this._oImage.setSrc(A);}};
d.prototype._inactiveHandlingInheritor=function(){if(this._oImage){this._oImage.setSrc(this.getIcon());}};
d.prototype.getContentAnnouncement=function(B){var A="",i=this.getInfoState(),t,s="",e,f="",o,g;if(this.getWrapping()){o=this.getDomRef("titleButton");g=this.getDomRef("descriptionButton");t=this._bTitleTextExpanded?this.getTitle():this._getCollapsedText(this.getTitle());e=this._bDescriptionTextExpanded?this.getDescription():this._getCollapsedText(this.getDescription());if(o){s=o.textContent+" "+B.getText("ACC_CTR_TYPE_BUTTON");}if(g){f=g.textContent+" "+B.getText("ACC_CTR_TYPE_BUTTON");}A+=t+" "+s+" "+e+" "+f+" ";}else{A+=this.getTitle()+" "+this.getDescription()+" ";}A+=this.getInfo()+" ";if(i!="None"&&i!=this.getHighlight()){A+=B.getText("LIST_ITEM_STATE_"+i.toUpperCase());}return A;};
d.prototype._measureInfoTextWidth=function(t){if(!d._themeInfo){d._themeInfo={};}if(!d._themeInfo.sFontFamily||t){d._themeInfo.sFontFamily=T.get("sapUiFontFamily");}if(!d._themeInfo.sFontStyleInfoStateInverted||t){d._themeInfo.sFontStyleInfoStateInverted="bold "+parseFloat(T.get("sapMFontSmallSize"))*16+"px"+" "+d._themeInfo.sFontFamily;}if(!d._themeInfo.sFontStyle||t){d._themeInfo.sFontStyle=parseFloat(T.get("sapMFontMediumSize"))*16+"px"+" "+d._themeInfo.sFontFamily;}if(!d._themeInfo.iBaseFontSize||t){d._themeInfo.iBaseFontSize=parseInt(l.BaseFontSize)||16;}if(!d._oCanvas){d._oCanvas=document.createElement("canvas");d._oCtx=d._oCanvas.getContext("2d");}if(this.getInfoStateInverted()){d._oCtx.font=d._themeInfo.sFontStyleInfoStateInverted||"";}else{d._oCtx.font=d._themeInfo.sFontStyle||"";}return Math.ceil(d._oCtx.measureText(this.getInfo()).width)/d._themeInfo.iBaseFontSize;};
d.prototype._getInfoTextMinWidth=function(w){if(this.getInfoStateInverted()&&w<=7.5){return w+0.625+"rem";}if(w<=7.5){return w+"rem";}return"7.5rem";};
d.prototype.ontap=function(e){this._checkExpandCollapse(e);if(!e.isMarked()){return L.prototype.ontap.apply(this,arguments);}};
d.prototype.onsapspace=function(e){this._checkExpandCollapse(e,true);if(!e.isMarked()){return L.prototype.onsapspace.apply(this,arguments);}};
d.prototype._checkExpandCollapse=function(e,p){var t=e.target,i=t&&t.id;if(i&&i===this.getId()+"-titleButton"){if(p){e.preventDefault();}e.setMarked();return this._toggleExpandCollapse("title",this._bTitleTextExpanded);}if(i&&i===this.getId()+"-descriptionButton"){if(p){e.preventDefault();}e.setMarked();return this._toggleExpandCollapse("description",this._bDescriptionTextExpanded);}};
d.prototype._toggleExpandCollapse=function(w,t){var o=this.getDomRef(w+"Text"),e=this.getDomRef(w+"ThreeDots"),B=this.getDomRef(w+"Button"),s=w==="title"?this.getTitle():this.getDescription(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!t){o.textContent=s;e.textContent=" ";B.textContent=r.getText("TEXT_SHOW_LESS");t=true;}else{o.textContent=this._getCollapsedText(s);e.textContent=" ... ";B.textContent=r.getText("TEXT_SHOW_MORE");t=false;}if(w==="title"){this._bTitleTextExpanded=t;}else{this._bDescriptionTextExpanded=t;}};
d.prototype._getCollapsedText=function(t){var m=D.system.phone?100:300;return t.substr(0,m);};
d.prototype.onThemeChanged=function(e){L.prototype.onThemeChanged.apply(this,arguments);var t=e.theme;if(!this._initialRender){this._initialRender=true;if(!d._themeInfo){d._themeInfo={};}if(!d._themeInfo.sCurrentTheme){d._themeInfo.sCurrentTheme=t;}return;}var i=this.getDomRef("info");if(i){var w;if(d._themeInfo.sCurrentTheme!==t){d._themeInfo.sCurrentTheme=t;w=this._measureInfoTextWidth(true);}else{w=this._measureInfoTextWidth();}i.style.minWidth=this._getInfoTextMinWidth(w);}};
return d;});
sap.ui.predefine('sap/m/StandardListItemRenderer',["sap/ui/core/library","sap/ui/core/Core","sap/ui/core/Renderer","sap/ui/core/IconPool","sap/ui/Device","./library","./ListItemBaseRenderer"],function(c,C,R,I,D,l,L){"use strict";var T=c.TextDirection;var S=R.extend(L);S.apiVersion=2;
S.renderLIAttributes=function(r,o){var i=o.getIcon(),t=o.getTitle();r.class("sapMSLI");if(i&&!I.isIconURI(i)){r.class("sapMSLIThumbnail");}if(!o.getIconInset()){r.class("sapMSLINoIconInset");}if(t&&o.getDescription()){r.class("sapMSLIWithDescription");}if(t&&!o.getAdaptTitleSize()){r.class("sapMSLINoTitleAdapt");}if(t&&o.getWrapping()){r.class("sapMSLIWrapping");}};
S.renderLIContent=function(r,o){var i=o.getInfo(),t=o.getTitle(),d=o.getDescription(),a=o.getAdaptTitleSize(),s=!t&&i;if(o.getIcon()){r.renderControl(o._getImage());}r.openStart("div").class("sapMSLIDiv");if((!d&&a&&i)||s){r.class("sapMSLIInfoMiddle");}r.openEnd();this.renderTitleWrapper(r,o);if(t&&d){this.renderDescription(r,o);}if(s&&!o.getWrapping()){this.renderInfo(r,o);}r.close("div");};
S.renderTitleWrapper=function(r,o){var t=o.getTitleTextDirection(),s=o.getTitle(),d=o.getDescription(),i=o.getInfo(),w=o.getWrapping(),b=!s&&i;r.openStart("div");if(!b&&d){r.class("sapMSLITitle");}else{r.class("sapMSLITitleOnly");}if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();if(w){this.renderWrapping(r,o,"title");if(s&&i&&!d){this.renderInfo(r,o);}}else{this.renderTitle(r,o);}r.close("div");if(i&&!d&&!w&&!b){this.renderInfo(r,o);}};
S.renderTitle=function(r,o){r.text(o.getTitle());};
S.renderDescription=function(r,o){var w=o.getWrapping(),d=o.getDescription(),i=o.getInfo();r.openStart("div").class("sapMSLIDescription");if(i){r.class("sapMSLIDescriptionAndInfo");}r.openEnd();if(i){r.openStart("div").class("sapMSLIDescriptionText").openEnd();if(w){this.renderWrapping(r,o,"description");this.renderInfo(r,o);}else{r.text(d);}r.close("div");if(!w){this.renderInfo(r,o);}}else if(w){this.renderWrapping(r,o,"description");}else{r.text(d);}r.close("div");};
S.renderInfo=function(r,o){var i=o.getInfoTextDirection(),b=o.getInfoStateInverted();r.openStart("div",o.getId()+"-info");if(i!==T.Inherit){r.attr("dir",i.toLowerCase());}r.class("sapMSLIInfo");r.class("sapMSLIInfo"+o.getInfoState());if(b){r.class("sapMSLIInfoStateInverted");}var w=o._measureInfoTextWidth();r.style("min-width",o._getInfoTextMinWidth(w));r.openEnd();r.text(o.getInfo());r.close("div");};
S.renderExpandCollapse=function(r,o,w){var i=o.getId(),t=w=="title"?true:false,b=t?o._bTitleTextExpanded:o._bDescriptionTextExpanded,a=C.getLibraryResourceBundle("sap.m");r.openStart("span",i+"-"+w+"ThreeDots").openEnd();r.text(b?" ":" ... ");r.close("span");r.openStart("span",t?i+"-titleButton":i+"-descriptionButton").class("sapMSLIExpandCollapse");r.attr("tabindex","0").attr("role","button").attr("aria-live","polite");r.openEnd();r.text(a.getText(b?"TEXT_SHOW_LESS":"TEXT_SHOW_MORE"));r.close("span");};
S.renderWrapping=function(r,o,w){var i=o.getId(),t=w=="title"?true:false,s=t?o.getTitle():o.getDescription(),b=t?o._bTitleTextExpanded:o._bDescriptionTextExpanded,m=D.system.phone?100:300;r.openStart("span",i+"-"+w+"Text").attr("aria-live","polite").openEnd();if(!b){var a=o._getCollapsedText(s);r.text(a);}else if(t){this.renderTitle(r,o);}else{r.text(o.getDescription());}r.close("span");if(s.length>m){this.renderExpandCollapse(r,o,w);}};
return S;},true);
sap.ui.predefine('sap/m/StandardTile',['./Tile','./library','sap/ui/core/IconPool','sap/ui/core/library','sap/ui/Device','./StandardTileRenderer'],function(T,l,I,c,D,S){"use strict";var a=l.ImageHelper;var b=l.StandardTileType;var V=c.ValueState;
var d=T.extend("sap.m.StandardTile",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},info:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},activeIcon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},number:{type:"string",group:"Misc",defaultValue:null},numberUnit:{type:"string",group:"Misc",defaultValue:null},infoState:{type:"sap.ui.core.ValueState",group:"Misc",defaultValue:V.None},type:{type:"sap.m.StandardTileType",group:"Misc",defaultValue:b.None},iconDensityAware:{type:"boolean",group:"Appearance",defaultValue:true}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}}}});
d.prototype.exit=function(){if(this._oImageControl){this._oImageControl.destroy();this._oImageControl=null;}};
d.prototype.ontap=function(){if(D.browser.msie){this.focus();}T.prototype.ontap.apply(this,arguments);};
d.prototype.getIcon=function(){if(!this.getProperty("icon")&&this.getType()==="Create"){return I.getIconURI("add");}else{return this.getProperty("icon");}};
d.prototype._getImage=function(){var i=this.getId()+"-img";var s=D.system.phone?"1.3rem":"2rem";var p={src:this.getIcon(),height:s,width:s,size:s,densityAware:this.getIconDensityAware(),useIconTooltip:false};this._oImageControl=a.getImageControl(i,this._oImageControl,this,p);return this._oImageControl;};
return d;});
sap.ui.predefine('sap/m/StandardTileRenderer',['./TileRenderer','sap/ui/core/ValueStateSupport','sap/ui/core/Renderer','sap/m/library','sap/ui/core/library'],function(T,V,R,l,c){"use strict";var a=c.ValueState;var S=l.StandardTileType;var b=R.extend(T);
b._renderContent=function(r,t){var i=t.getInfoState();r.write("<div");r.addClass("sapMStdTileTopRow");r.writeClasses();r.write(">");if(t.getIcon()){r.write("<div");r.addClass("sapMStdTileIconDiv");switch(t.getType()){case S.Monitor:r.addClass("sapMStdIconMonitor");break;case S.Create:r.addClass("sapMStdIconCreate");break;}r.writeClasses();r.write(">");r.renderControl(t._getImage());r.write("</div>");}if(t.getNumber()){r.write("<div");r.addClass("sapMStdTileNumDiv");r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",t.getId()+"-number");var n=t.getNumber().length;if(n<5){r.addClass("sapMStdTileNum");}else if(n<8){r.addClass("sapMStdTileNumM");}else{r.addClass("sapMStdTileNumS");}r.writeClasses();r.write(">");r.writeEscaped(t.getNumber());r.write("</div>");if(t.getNumberUnit()){r.write("<div");r.writeAttribute("id",t.getId()+"-numberUnit");r.addClass("sapMStdTileNumUnit");r.writeClasses();r.write(">");r.writeEscaped(t.getNumberUnit());r.write("</div>");}r.write("</div>");}r.write("</div>");r.write("<div");r.addClass("sapMStdTileBottomRow");if(t.getType()===S.Monitor){r.addClass("sapMStdTileMonitorType");}r.writeClasses();r.write(">");r.write("<div");r.writeAttribute("id",t.getId()+"-title");r.addClass("sapMStdTileTitle");r.writeClasses();r.write(">");if(t.getTitle()){r.writeEscaped(t.getTitle());}r.write("</div>");if(t.getInfo()){r.write("<div");r.writeAttribute("id",t.getId()+"-info");r.addClass("sapMStdTileInfo");r.addClass("sapMStdTileInfo"+i);r.writeClasses();if(i!=a.None){r.writeAccessibilityState(t,{ariaDescribedBy:{value:t.getId()+"-sapSRH",append:true}});}r.write(">");if(t.getInfo()){r.writeEscaped(t.getInfo());}r.write("</div>");}if(i!=a.None){r.write("<span");r.writeAttributeEscaped("id",t.getId()+"-sapSRH");r.addClass("sapUiInvisibleText");r.writeClasses();r.writeAccessibilityState({hidden:false});r.write(">");r.writeEscaped(V.getAdditionalText(i));r.write("</span>");}r.write("</div>");};
return b;},true);
sap.ui.predefine('sap/m/StandardTreeItem',['./TreeItemBase','./library','sap/ui/core/IconPool','./Image','./StandardTreeItemRenderer'],function(T,l,I,a,S){"use strict";
var b=T.extend("sap.m.StandardTreeItem",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null}}}});
b.prototype._getIconControl=function(){var u=this.getIcon();if(this._oIconControl){this._oIconControl.setSrc(u);return this._oIconControl;}this._oIconControl=I.createControlByURI({id:this.getId()+"-icon",src:u,useIconTooltip:false,noTabStop:true},a).setParent(this,null,true).addStyleClass("sapMSTIIcon");return this._oIconControl;};
b.prototype.getContentAnnouncement=function(){return this.getTitle();};
b.prototype.exit=function(){T.prototype.exit.apply(this,arguments);this.destroyControls(["Icon"]);};
b.prototype.setIcon=function(i){var o=this.getIcon();this.setProperty("icon",i);if(this._oIconControl&&(!i||I.isIconURI(i)!=I.isIconURI(o))){this._oIconControl.destroy("KeepDom");this._oIconControl=undefined;}return this;};
return b;});
sap.ui.predefine('sap/m/StandardTreeItemRenderer',["./TreeItemBaseRenderer","sap/ui/core/Renderer"],function(T,R){"use strict";var S=R.extend(T);S.apiVersion=2;
S.renderLIContent=function(r,l){if(l.getIcon()){r.renderControl(l._getIconControl());}r.text(l.getTitle());};
S.renderLIAttributes=function(r,l){T.renderLIAttributes.apply(this,arguments);r.class("sapMSTI");};
return S;},true);
sap.ui.predefine('sap/m/StepInput',["sap/ui/core/Icon","./Input","./InputBase","./InputRenderer","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/core/LabelEnablement","sap/ui/core/message/MessageMixin","sap/ui/model/ValidateException","sap/ui/Device","sap/ui/core/library","sap/ui/core/Renderer","sap/m/library","./StepInputRenderer","sap/ui/events/KeyCodes","sap/base/Log"],function(I,a,b,c,C,d,L,M,V,D,f,R,l,S,K,g){"use strict";var h=l.InputType;var T=f.TextAlign;var j=f.ValueState;var k=l.StepInputValidationMode;var m=l.StepInputStepModeType;
var n=C.extend("sap.m.StepInput",{
metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.m",designtime:"sap/m/designtime/StepInput.designtime",properties:{min:{type:"float",group:"Data"},max:{type:"float",group:"Data"},step:{type:"float",group:"Data",defaultValue:1},stepMode:{type:"sap.m.StepInputStepModeType",group:"Data",defaultValue:m.AdditionAndSubtraction},largerStep:{type:"float",group:"Data",defaultValue:2},value:{type:"float",group:"Data",defaultValue:0},name:{type:"string",group:"Misc",defaultValue:null},placeholder:{type:"string",group:"Misc",defaultValue:null},required:{type:"boolean",group:"Misc",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Dimension"},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:j.None},valueStateText:{type:"string",group:"Misc",defaultValue:null},editable:{type:"boolean",group:"Behavior",defaultValue:true},enabled:{type:"boolean",group:"Behavior",defaultValue:true},displayValuePrecision:{type:"int",group:"Data",defaultValue:0},description:{type:"string",group:"Misc",defaultValue:null},fieldWidth:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:'50%'},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:T.End},validationMode:{type:"sap.m.StepInputValidationMode",group:"Misc",defaultValue:k.FocusOut}},aggregations:{_input:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"}},events:{change:{parameters:{value:{type:"string"}}}},dnd:{draggable:false,droppable:true}},
constructor:function(i,s){C.prototype.constructor.apply(this,arguments);if(this.getEditable()){this._getOrCreateDecrementButton();this._getOrCreateIncrementButton();}if(typeof i!=="string"){s=i;}if(s&&s.value===undefined){this.setValue(this._getDefaultValue(undefined,s.max,s.min));}}
});
var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");n.STEP_INPUT_INCREASE_BTN_TOOLTIP=o.getText("STEP_INPUT_INCREASE_BTN");n.STEP_INPUT_DECREASE_BTN_TOOLTIP=o.getText("STEP_INPUT_DECREASE_BTN");n.INITIAL_WAIT_TIMEOUT=500;n.ACCELLERATION=0.8;n.MIN_WAIT_TIMEOUT=50;n.INITIAL_SPEED=120;n._TOLERANCE=10;var F=["enabled","editable","name","placeholder","required","valueStateText","description","fieldWidth","textAlign"];var N=R.extend(c);N.apiVersion=2;
N.writeInnerAttributes=function(r,e){var s=e.getParent(),A=this.getAccessibilityState(e);r.attr("type",e.getType().toLowerCase());if(sap.ui.getCore().getConfiguration().getRTL()){r.attr("dir","ltr");}A.disabled=null;r.accessibilityState(s,A);};
N.getAccessibilityState=function(e){var A=c.getAccessibilityState(e),s=e.getParent(),i=s._getMin(),r=s._getMax(),t=s.getValue(),u=s.getDescription(),v=s.getAriaLabelledBy(),w=L.getReferencingLabels(s),x=s.getAriaDescribedBy().join(" "),y;A.valuenow=t;if(u){v.push(s._getInput().getId()+"-descr");}y=w.concat(v).join(" ");if(typeof i==="number"){A.valuemin=i;}if(typeof r==="number"){A.valuemax=r;}if(!s.getEditable()){A.readonly=true;}if(x){A.describedby=x;}if(y){A.labelledby=y;}return A;};
var p=a.extend("sap.m.internal.NumericInput",{
metadata:{library:"sap.m"},
constructor:function(i,s){return a.apply(this,arguments);},
renderer:N
});
p.prototype.onBeforeRendering=function(){b.prototype.onBeforeRendering.call(this);this.setWidth("100%");this._deregisterEvents();};
p.prototype.setValue=function(v){a.prototype.setValue.apply(this,arguments);if(this.getDomRef()){document.getElementById(this.getId()+"-inner").setAttribute("aria-valuenow",v);}return this;};
M.call(n.prototype);
n.prototype.init=function(){this._iRealPrecision=0;this._attachChange();this._bPaste=false;this._bNeedsVerification=false;this._bValueStatePreset=true;this._onmousewheel=this._onmousewheel.bind(this);window.addEventListener("contextmenu",function(e){if(this._btndown===false&&e.target.className.indexOf("sapMInputBaseIconContainer")!==-1){e.preventDefault();}}.bind(this));};
n.prototype.onBeforeRendering=function(){var e=this._getMin(),i=this._getMax(),v=this._getInput()._$input.val()||this.getValue(),E=this.getEditable();this._iRealPrecision=this._getRealValuePrecision();this._getInput().setValue(this._getFormattedValue(v));this._getInput().setValueState(this.getValueState());this._getInput().setTooltip(this.getTooltip());this._getOrCreateDecrementButton().setVisible(E);this._getOrCreateIncrementButton().setVisible(E);this._disableButtons(v,i,e);this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);if(this._bNeedsVerification&&!this._bValueStatePreset){this._verifyValue();this._bNeedsVerification=false;}};
n.prototype.onAfterRendering=function(){this.$().on(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);};
n.prototype.exit=function(){this.$().off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);};
n.prototype.setProperty=function(P,v,s){C.prototype.setProperty.call(this,P,v,s);if(F.indexOf(P)>-1){this._getInput().setProperty(P,this.getProperty(P),s);}return this;};
n.prototype.setValidationMode=function(v){if(this.getValidationMode()!==v){switch(v){case k.FocusOut:this._detachLiveChange();break;case k.LiveChange:this._attachLiveChange();break;}this.setProperty("validationMode",v);}return this;};
n.prototype.setMin=function(e){if(e!==undefined&&!this._validateOptionalNumberProperty("min",e)){return this;}return this.setProperty("min",e);};
n.prototype.setMax=function(e){if(e!==undefined&&!this._validateOptionalNumberProperty("max",e)){return this;}return this.setProperty("max",e);};
n.prototype._validateOptionalNumberProperty=function(e,v){if(this._isNumericLike(v)){return true;}g.error("The value of property '"+e+"' must be a number");return false;};
n.prototype.setDisplayValuePrecision=function(e){var v;if(q(e)){v=parseInt(e);}else{v=0;g.warning(this+": ValuePrecision ("+e+") is not correct. It should be a number between 0 and 20! Setting the default ValuePrecision:0.");}return this.setProperty("displayValuePrecision",v);};
n.prototype._getIncrementButton=function(){var e=this._getInput().getAggregation("_endIcon");return e?e[0]:null;};
n.prototype._getDecrementButton=function(){var e=this._getInput().getAggregation("_beginIcon");return e?e[0]:null;};
n.prototype._createIncrementButton=function(){var i=this._getInput().addEndIcon({src:d.getIconURI("add"),id:this.getId()+"-incrementBtn",noTabStop:true,press:this._handleButtonPress.bind(this,1),tooltip:n.STEP_INPUT_INCREASE_BTN_TOOLTIP});i.getEnabled=function(){return!this._shouldDisableIncrementButton(Number(this._getInput().getValue()),this._getMax());}.bind(this);i.$().attr("tabindex","-1");this._attachEvents(i,true);i.addEventDelegate({onAfterRendering:function(){i.$().attr("tabindex","-1");}});return i;};
n.prototype._createDecrementButton=function(){var i=this._getInput().addBeginIcon({src:d.getIconURI("less"),id:this.getId()+"-decrementBtn",noTabStop:true,press:this._handleButtonPress.bind(this,-1),tooltip:n.STEP_INPUT_DECREASE_BTN_TOOLTIP});i.getEnabled=function(){return!this._shouldDisableDecrementButton(Number(this._getInput().getValue()),this._getMin());}.bind(this);i.$().attr("tabindex","-1");this._attachEvents(i,false);i.addEventDelegate({onAfterRendering:function(){i.$().attr("tabindex","-1");}});return i;};
n.prototype._getInput=function(){if(!this.getAggregation("_input")){var e=new p({id:this.getId()+"-input",textAlign:this.getTextAlign(),type:h.Number,editable:this.getEditable(),enabled:this.getEnabled(),description:this.getDescription(),fieldWidth:this.getFieldWidth(),liveChange:this._inputLiveChangeHandler});this.setAggregation("_input",e);}return this.getAggregation("_input");};
n.prototype._changeValue=function(e){if((this._fTempValue!=this._fOldValue)||e){this.setValue(this._fTempValue);this.fireChange({value:this._fTempValue});}else{this._applyValue(this._fTempValue);this._disableButtons(Number(this._getInput().getValue()),this._getMax(),this._getMin());}return this;};
n.prototype._handleButtonPress=function(e){if(!this._bSpinStarted){this._bDelayedEventFire=false;this._changeValueWithStep(e);this._btndown=false;this._changeValue();}else{this._bSpinStarted=false;}this._bNeedsVerification=true;return this;};
n.prototype._changeValueWithStep=function(e){var i,r;if(isNaN(this._fTempValue)||this._fTempValue===undefined){this._fTempValue=this.getValue();}r=this._checkInputValue();this._fTempValue+=r;i=e!==0?this._calculateNewValue(e):this._fTempValue;if(e!==0||r!==0||this._bDelayedEventFire){this._fTempValue=i;}if(this._bDelayedEventFire){this._applyValue(i);this._disableButtons(Number(this._getFormattedValue(i)),this._getMax(),this._getMin());this._bNeedsVerification=true;}return this;};
n.prototype._disableButtons=function(v,i,e){if(!this._isNumericLike(v)){return;}var r=this._getIncrementButton(),s=this._getDecrementButton(),t=this._shouldDisableDecrementButton(v,e),u=this._shouldDisableIncrementButton(v,i);s&&s.toggleStyleClass("sapMStepInputIconDisabled",t);r&&r.toggleStyleClass("sapMStepInputIconDisabled",u);return this;};
n.prototype._shouldDisableDecrementButton=function(v,i){var e=this._isNumericLike(i),E=this.getEnabled(),r=e&&i>=v;return E?r:true;};
n.prototype._shouldDisableIncrementButton=function(v,i){var e=this._isNumericLike(i),E=this.getEnabled(),r=e&&i<=v;return E?r:true;};
n.prototype._verifyValue=function(){var e=this._getMin(),i=this._getMax(),v=parseFloat(this._getInput().getValue()),r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core"),B=this.getBinding("value"),s=B&&B.getType&&B.getType(),t=s&&s.oConstraints&&s.oConstraints.maximum,u=s&&s.oConstraints&&s.oConstraints.minimum,w,x=[],H=false,E;if(!this._isNumericLike(v)){return;}E=this;do{H=E.hasListeners("validationError");E=E.getEventingParent();}while(E&&!H);if(this._isNumericLike(i)&&v>i){if(H&&t){return;}w=r.getText("EnterNumberMax",[i]);x.push("maximum");}else if(this._isNumericLike(e)&&v<e){if(H&&u){return;}w=r.getText("EnterNumberMin",[e]);x.push("minimum");}else if(this._areFoldChangeRequirementsFulfilled()&&(v%this.getStep()!==0)){w=r.getText("Float.Invalid");}if(w){this.setProperty("valueState",j.Error,true);this._getInput().setValueState(j.Error);this._getInput().setValueStateText(w);if(H){this.fireValidationError({element:this,exception:new V(w,x),id:this.getId(),message:w,property:"value"});}}else{this.setProperty("valueState",j.None,true);this._getInput().setValueState(j.None);}};
n.prototype.setValueState=function(v){this._bValueStatePreset=true;this.setProperty("valueState",v);this._getInput().setValueState(v);return this;};
n.prototype.setValue=function(v){var r;if(isNaN(v)||v===null){v=this._getDefaultValue(undefined,this._getMax(),this._getMin());}else{v=Number(v);}if(!this._validateOptionalNumberProperty("value",v)){return this;}this._applyValue(v);this._disableButtons(Number(this._getInput().getValue()),this._getMax(),this._getMin());if(v!==this._fOldValue){this._fOldValue=v;r=this.setProperty("value",v);}else{r=this;}this._iRealPrecision=this._getRealValuePrecision();this._fTempValue=v;this._bValueStatePreset=false;return r;};
n.prototype._getFormattedValue=function(v){var P=this.getDisplayValuePrecision(),i,s;if(v==undefined){v=this.getValue();}if(P<=0){return parseFloat(v).toFixed(0);}s=v.toString().split(".");if(s.length===2){i=s[1].length;if(i>P){return parseFloat(v).toFixed(P);}return s[0]+"."+this._padZeroesRight(s[1],P);}else{return v.toString()+"."+this._padZeroesRight("0",P);}};
n.prototype._padZeroesRight=function(v,e){var r="",s=v.length;for(var i=s;i<e;i++){r=r+"0";}r=v+r;return r;};
n.prototype._checkInputValue=function(){var i=this._getInput().getValue(),e=0;if(i===""){i=this._getDefaultValue(i,this._getMax(),this._getMin()).toString();}if(this.getDisplayValuePrecision()===0){i=Math.round(Number(i.toLowerCase().split('e')[0])).toString();}if(this._getFormattedValue(this._fTempValue)!==i){e=Number(i)-this._fTempValue;}return e;};
n.prototype.onsappageup=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(this.getLargerStep());}};
n.prototype.onsappagedown=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(-this.getLargerStep());}};
n.prototype.onsappageupmodifiers=function(e){if(this.getEditable()&&this._isNumericLike(this._getMax())&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){this._bDelayedEventFire=true;this._fTempValue=Number(this._getInput().getValue());this._changeValueWithStep(this._getMax()-this._fTempValue);}};
n.prototype.onsappagedownmodifiers=function(e){if(this.getEditable()&&this._isNumericLike(this._getMin())&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){this._bDelayedEventFire=true;this._fTempValue=Number(this._getInput().getValue());this._changeValueWithStep(-(this._fTempValue-this._getMin()));}};
n.prototype.onsapup=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(1);e.setMarked();}};
n.prototype.onsapdown=function(e){e.preventDefault();if(this.getEditable()){this._bDelayedEventFire=true;this._changeValueWithStep(-1);e.setMarked();}};
n.prototype._onmousewheel=function(e){var i=this.getDomRef().contains(document.activeElement);if(i&&this.getEditable()&&this.getEnabled()){e.preventDefault();var O=e.originalEvent,r=O.detail?(-O.detail>0):(O.wheelDelta>0);this._bDelayedEventFire=true;this._changeValueWithStep((r?1:-1));}};
n.prototype.onkeydown=function(e){var s,i,r;if(!this.getEditable()){return;}if(e.which===K.ENTER&&this._fTempValue!==this.getValue()){e.preventDefault();this._changeValue();return;}this._bPaste=(e.ctrlKey||e.metaKey)&&(e.which===K.V);if(e.which===K.ARROW_UP&&!e.altKey&&e.shiftKey&&(e.ctrlKey||e.metaKey)){i=this._getMax();this._fTempValue=Number(this._getInput().getValue());s=(i!==undefined)?i-this._fTempValue:0;}else if(e.which===K.ARROW_DOWN&&!e.altKey&&e.shiftKey&&(e.ctrlKey||e.metaKey)){r=this._getMin();this._fTempValue=Number(this._getInput().getValue());s=(r!==undefined)?-(this._fTempValue-r):0;}else if(e.which===K.ARROW_UP&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){s=this.getLargerStep();}else if(e.which===K.ARROW_DOWN&&!(e.ctrlKey||e.metaKey||e.altKey)&&e.shiftKey){s=-this.getLargerStep();}else if(e.which===K.ARROW_UP&&(e.ctrlKey||e.metaKey)){s=1;}else if(e.which===K.ARROW_DOWN&&(e.ctrlKey||e.metaKey)){s=-1;}else if(e.which===K.ARROW_UP&&e.altKey){s=1;}else if(e.which===K.ARROW_DOWN&&e.altKey){s=-1;}if(s!==undefined){e.preventDefault();if(s!==0){this._bDelayedEventFire=true;this._changeValueWithStep(s);}}};
n.prototype.onsapescape=function(e){if(this._fOldValue!==this._fTempValue){this._applyValue(this._fOldValue);this._bNeedsVerification=true;}};
n.prototype._attachLiveChange=function(){this._getInput().attachLiveChange(this._liveChange,this);};
n.prototype._detachLiveChange=function(){this._getInput().detachLiveChange(this._liveChange,this);};
n.prototype._attachChange=function(){this._getInput().attachChange(this._change,this);};
n.prototype._liveChange=function(){this._disableButtons(Number(this._getInput().getValue()),this._getMax(),this._getMin());this._verifyValue();};
n.prototype._change=function(e){var O;if(!this._isButtonFocused()){if(!this._btndown){O=Number(this._getFormattedValue());if(this._fOldValue===undefined){this._fOldValue=O;}this._bDelayedEventFire=false;this._changeValueWithStep(0);this._changeValue();this._bNeedsVerification=true;}else{this._fTempValue=Number(this._getInput().getValue());}}};
n.prototype._applyValue=function(e){this._getInput().setValue(this._getFormattedValue(e));};
n.prototype._calculateNewValue=function(s,i){if(i===undefined){i=s<0?false:true;}var e=this.getStep(),r=this._getMax(),t=this._getMin(),u=parseFloat(this._getDefaultValue(this._getInput().getValue(),r,t)),v=i?1:-1,w=Math.abs(e)*Math.abs(s),x=u+v*w,y;if(this._areFoldChangeRequirementsFulfilled()){x=y=this._calculateClosestFoldValue(u,w,v);}else{y=this._sumValues(this._fTempValue,w,v,this._iRealPrecision);}if(this._isNumericLike(r)&&x>=r){y=r;}if(this._isNumericLike(t)&&x<=t){y=t;}return y;};
n.prototype._getRealValuePrecision=function(){var s=this.getValue().toString().split("."),e=this.getStep().toString().split("."),i,r;i=(!s[1])?0:s[1].length;r=(!e[1])?0:e[1].length;return(i>r)?i:r;};
n.prototype._getOrCreateDecrementButton=function(){return this._getDecrementButton()||this._createDecrementButton();};
n.prototype._getOrCreateIncrementButton=function(){return this._getIncrementButton()||this._createIncrementButton();};
n.prototype._inputLiveChangeHandler=function(e){var v=this.getParent()._restrictCharsWhenDecimal(e);this.setProperty("value",v?v:e.getParameter("newValue"),true);};
n.prototype._restrictCharsWhenDecimal=function(e){var i=e.getParameter("value").indexOf("."),r=this.getDisplayValuePrecision(),E=e.getParameter("value"),v;if(i>0&&r>=0){var s=E.split('.')[1],t=s?s.length:0,u=E.split('.')[0],w=r>0?E.substring(E.indexOf('.')+1,E.length):'';if(!this._bPaste){if(t>r){v=u+(r>0?"."+w.substr(0,r):'');this._showWrongValueVisualEffect();}}else{if(E.indexOf(".")){v=E.split('.')[0]+(r>0?"."+s.substring(0,r):'');}this._bPaste=false;}}else{v=E;}this._getInput().updateDomValue(v);return v;};
n.prototype._showWrongValueVisualEffect=function(){var O=this.getValueState(),i=this._getInput();if(O===j.Error){return;}i.setValueState(j.Error);setTimeout(i["setValueState"].bind(i,O),1000);};
n.prototype._getDefaultValue=function(v,e,i){if(v!==""&&v!==undefined){return Number(this._getInput().getValue());}if(this._isNumericLike(i)&&i>0){return i;}else if(this._isNumericLike(e)&&e<0){return e;}else{return 0;}};
n.prototype._isNumericLike=function(v){return!isNaN(v)&&v!==null&&v!=="";};
n.prototype._isInteger=function(v){return v===parseInt(v);};
n.prototype._isButtonFocused=function(){return document.activeElement===this._getIncrementButton().getDomRef()||document.activeElement===this._getDecrementButton().getDomRef();};
n.prototype._sumValues=function(v,e,s,P){var i=Math.pow(10,P),r=parseInt((v*i).toFixed(1)),t=parseInt((e*i).toFixed(1));return(r+(s*t))/i;};
n.prototype._areFoldChangeRequirementsFulfilled=function(){return this.getStepMode()===m.Multiple&&this.getDisplayValuePrecision()===0&&this._isInteger(this.getStep())&&this._isInteger(this.getLargerStep());};
n.prototype._calculateClosestFoldValue=function(v,s,i){var r=Math.floor(v),e=s;do{r+=i;e--;}while(r%s!==0&&e);if(r%s!==0){g.error("Wrong next/previous value "+r+" for "+v+", step: "+s+" and sign: "+i,this);}return r;};
function q(v){return(typeof(v)==='number')&&!isNaN(v)&&v>=0&&v<=20;}
n.prototype._calcWaitTimeout=function(){this._speed*=n.ACCELLERATION;this._waitTimeout=((this._waitTimeout-this._speed)<n.MIN_WAIT_TIMEOUT?n.MIN_WAIT_TIMEOUT:(this._waitTimeout-this._speed));return this._waitTimeout;};
n.prototype._spinValues=function(i){this._spinTimeoutId=setTimeout(function(){if(this._btndown){this._bSpinStarted=true;this._bDelayedEventFire=true;this._changeValueWithStep(i?1:-1);this._disableButtons(Number(this._getInput().getValue()),this._getMax(),this._getMin());if((this._getIncrementButton().getEnabled()&&i)||(this._getDecrementButton().getEnabled()&&!i)){this._spinValues(i);}}}.bind(this),this._calcWaitTimeout());};
n.prototype._attachEvents=function(B,i){var e={onmousedown:function(E){if(E.button===0&&!this._btndown){this._btndown=true;this._waitTimeout=n.INITIAL_WAIT_TIMEOUT;this._speed=n.INITIAL_SPEED;this._spinValues(i);}}.bind(this),onmouseup:function(E){if(E.button===0){this._bDelayedEventFire=undefined;this._btndown=false;this._resetSpinValues();if(this._bSpinStarted){this._changeValue();}}}.bind(this),onmouseout:function(E){if(this._btndown){this._bDelayedEventFire=undefined;this._resetSpinValues();if(this._bSpinStarted){this._changeValue();}}}.bind(this),oncontextmenu:function(E){if(!sap.ui.Device.os.android){E.stopImmediatePropagation(true);if(E.originalEvent&&E.originalEvent.cancelable){E.preventDefault();}E.stopPropagation();}}};B.addDelegate(e,true);};
n.prototype._getMin=function(){var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),s=e&&e.oConstraints&&e.oConstraints.minimum;return s?parseFloat(s):this.getMin();};
n.prototype._getMax=function(){var B=this.getBinding("value"),e=B&&B.getType&&B.getType(),s=e&&e.oConstraints&&e.oConstraints.maximum;return s?parseFloat(s):this.getMax();};
n.prototype.getIdForLabel=function(){return this._getInput().getIdForLabel();};
n.prototype.onfocusout=function(e){if(!this._btndown){this._changeValueWithStep(0);if(this._bDelayedEventFire&&(this._fTempValue)!==this._fOldValue){this._bDelayedEventFire=undefined;this._changeValue();}}};
n.prototype._resetSpinValues=function(){clearTimeout(this._spinTimeoutId);this._waitTimeout=500;this._speed=120;};
n.prototype.getAccessibilityInfo=function(){return{type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_STEPINPUT"),description:this.getValue()||"",focusable:this.getEnabled(),enabled:this.getEnabled(),editable:this.getEnabled()&&this.getEditable()};};
return n;});
sap.ui.predefine('sap/m/StepInputRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,c){var i=c._getInput(),w=c.getWidth(),e=c.getEnabled(),E=c.getEditable(),v=c.getValueState();r.openStart("div",c);if(e&&E){r.attr("tabindex","-1");}r.style("width",w);r.class("sapMStepInput");r.class("sapMStepInput-CTX");!e&&r.class("sapMStepInputReadOnly");!E&&r.class("sapMStepInputNotEditable");if(v==="Error"||v==="Warning"){r.class("sapMStepInput"+v);}r.openEnd();r.renderControl(i);r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/Suggest',['jquery.sap.global','./Toolbar','./Button','./SuggestionsList','./SuggestionItem','sap/ui/Device','sap/m/library','sap/ui/core/Core'],function(q,T,B,S,a,D,l,C){"use strict";var P=l.PlacementType;
function b(i){var p=i,c,d,e,u=D.system.phone,s=this;q.sap.require(u?"sap.m.Dialog":"sap.m.Popover");function o(E){var k=E.srcControl;var v;if(k instanceof a){v=k.getSuggestionText();s._suggestionItemTapped=true;c.close();window.setTimeout(function(){i._updateValue(v);i._fireChangeEvent();i.fireSearch({query:v,suggestionItem:k,refreshButtonPressed:false,clearButtonPressed:false});},0);}}function f(){var k,m,n,r,t,v;n=new(sap.ui.require('sap/m/SearchField'))({liveChange:function(E){var w=E.getParameter("newValue");i._updateValue(w);i.fireLiveChange({newValue:w});i.fireSuggest({suggestValue:w});s.update();},search:function(E){if(!E.getParameter("clearButtonPressed")){k.close();}}});v=new B({icon:"sap-icon://decline",press:function(){s._cancelButtonTapped=true;k._oCloseTrigger=true;k.close();i._updateValue(m);}});r=new T({content:[n,v]});t=new B({text:C.getLibraryResourceBundle("sap.m").getText("MSGBOX_OK"),press:function(){k.close();}});k=new(sap.ui.require('sap/m/Dialog'))({stretch:true,customHeader:r,content:h(),beginButton:t,beforeClose:function(){i._bSuggestionSuppressed=true;},beforeOpen:function(){m=i.getValue();n._updateValue(m);},afterClose:function(E){if(!s._cancelButtonTapped&&!s._suggestionItemTapped){i._fireChangeEvent();i.fireSearch({query:i.getValue(),refreshButtonPressed:false,clearButtonPressed:false});}}});k.addEventDelegate({ontap:o},i);return k;}function g(){var k=s._oPopover=new(sap.ui.require('sap/m/Popover'))({showArrow:false,showHeader:false,horizontalScrolling:false,placement:P.Vertical,offsetX:0,offsetY:0,initialFocus:p,bounce:false,afterOpen:function(){i.$("I").attr("aria-haspopup","true");i._applySuggestionAcc();},beforeClose:function(){i.$("I").attr("aria-haspopup","false").removeAttr("aria-activedescendant");i.$("SuggDescr").text("");},content:h()}).addStyleClass("sapMSltPicker").addStyleClass("sapMSltPicker-CTX");k.open=function(){return this.openBy(p);};k.addEventDelegate({onAfterRendering:s.setPopoverMinWidth.bind(s),ontap:o},i);return k;}function h(){if(!d){d=new S({parentInput:p});}return d;}function j(){if(c===undefined){c=u?f():g();}return c;}this.setPopoverMinWidth=function(){var k=s._oPopover.getDomRef();if(k){var w=(i.$().outerWidth()/parseFloat(l.BaseFontSize))+"rem";k.style.minWidth=w;}};this.destroy=function(){if(c){c.close();c.destroy();c=null;}if(d){d.destroy();d=null;}};this.close=function(){if(!u&&this.isOpen()){c.close();}};this.open=function(){if(!this.isOpen()){this.setSelected(-1);this._suggestionItemTapped=false;this._cancelButtonTapped=false;j().open();}};this.update=function(){var d=h();window.clearTimeout(e);if(this.isOpen()){e=window.setTimeout(d.update.bind(d),50);i._applySuggestionAcc();}};this.isOpen=function(){return!!c&&c.isOpen();};this.getSelected=function(){return h().getSelectedItemIndex();};this.setSelected=function(k,r){return h().selectByIndex(k,r);};}
return b;},true);
sap.ui.predefine('sap/m/SuggestionItem',['./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(l,I,a){"use strict";
var S=I.extend("sap.m.SuggestionItem",{metadata:{library:"sap.m",properties:{icon:{type:"string",group:"Appearance",defaultValue:""},description:{type:"string",group:"Data",defaultValue:""}}}});
a.insertFontFaceStyle();
function r(R,t,s){var i;if(t){i=t.toUpperCase().indexOf(s.toUpperCase());if(i>-1){R.writeEscaped(t.slice(0,i));R.write("<b>");R.writeEscaped(t.slice(i,i+s.length));R.write("</b>");t=t.substring(i+s.length);}R.writeEscaped(t);}}
S.prototype.render=function(R,i,s,b){var c=R;var t=i.getText();var d=i.getIcon();var e="";var f=i.getDescription();var p=i.getParent();var g=p&&p.getSuggestionItems&&p.getSuggestionItems()||[];var h=g.indexOf(i);s=s||"";c.write("<li");c.writeElementData(i);c.addClass("sapMSuLI");c.addClass("sapMSelectListItem");c.addClass("sapMSelectListItemBase");c.addClass("sapMSelectListItemBaseHoverable");c.writeAttribute("role","option");c.writeAttribute("aria-posinset",h+1);c.writeAttribute("aria-setsize",g.length);if(b){c.addClass("sapMSelectListItemBaseSelected");c.writeAttribute("aria-selected","true");if(p){p.$("I").attr("aria-activedescendant",i.getId());}}else{c.writeAttribute("aria-selected","false");}c.writeClasses();c.write(">");if(d){c.writeIcon(d,"sapMSuggestionItemIcon",{});}if(t){r(c,t,s);e=" ";}if(f){c.write(e+"<i>");r(c,f,s);c.write("</i>");}c.write("</li>");};
S.prototype.getSuggestionText=function(){return this.getText();};
S.prototype.invalidate=function(){return undefined;};
return S;});
sap.ui.predefine('sap/m/SuggestionsList',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var S=C.extend("sap.m.SuggestionsList",{
metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"auto"},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"}},associations:{parentInput:{type:"sap.ui.core.Control",multiple:false,singularName:"parentInput"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}}},
renderer:{render:function(r,L){r.write("<ul");r.writeControlData(L);r.addClass("sapMSuL");r.addClass("sapMSelectList");r.writeClasses();r.writeAccessibilityState({role:"listbox","multiselectable":"false"});r.addStyle("width",L.getWidth());r.addStyle("max-width",L.getMaxWidth());r.writeStyles();r.write(">");this.renderItems(r,L);r.write("</ul>");},renderItems:function(r,L){var s;var a=L.getSelectedItemIndex();try{s=sap.ui.getCore().byId(L.getParentInput()).getValue();}catch(e){s="";}L.getItems().forEach(function(i,b){i.render(r,i,s,b===a);});}}
});
S.prototype.init=function(){this._iSelectedItem=-1;};
S.prototype.onBeforeRendering=function(){this.$().off();};
S.prototype.onAfterRendering=function(){this.$().on("mousedown",function(e){e.preventDefault();});};
S.prototype.getItems=function(){try{return sap.ui.getCore().byId(this.getParentInput()).getSuggestionItems();}catch(e){return[];}};
S.prototype.update=function(){var r;var d=this.getDomRef();if(d){r=sap.ui.getCore().createRenderManager();this.getRenderer().renderItems(r,this);r.flush(d);r.destroy();}return this;};
S.prototype.selectByIndex=function(i,r){var a=this.getItems();var b;var c;var d;var p=sap.ui.getCore().byId(this.getParentInput());var e="aria-activedescendant";if(isNaN(parseInt(i))){i=-1;r=false;}if((!a.length)||(r&&i===0)||(!r&&i<0)){b=-1;}else{if(r){if(this._iSelectedItem<0){b=(i<0?a.length:-1)+i;}else{b=this._iSelectedItem+i;}}else{b=i;}b=Math.min(Math.max(b,0),a.length-1);}this._iSelectedItem=b;if(a.length){this.$().children("li").removeClass("sapMSelectListItemBaseSelected").attr("aria-selected","false").eq(b).addClass("sapMSelectListItemBaseSelected").attr("aria-selected","true");}if(p){if(b>=0){c=p.getSuggestionItems()[b];if(c){d=c.getId();this._scrollToItem(c);}}if(d){p.$("I").attr(e,d);}else{p.$("I").removeAttr(e);p.$("SuggDescr").text("");}}return this._iSelectedItem;};
S.prototype._scrollToItem=function(i){var p=this.getParent().$().find(".sapMPopoverCont")[0],P,I,t,b;if(!i||!i.getDomRef()||!p){return;}I=i.getDomRef().getBoundingClientRect();P=p.getBoundingClientRect();t=P.top-I.top;b=I.bottom-P.bottom;if(t>0){p.scrollTop=Math.max(p.scrollTop-t,0);}else if(b>0){p.scrollTop=p.scrollTop+b;}};
S.prototype.getSelectedItemIndex=function(){return this._iSelectedItem;};
return S;});
sap.ui.predefine('sap/m/SuggestionsPopover',['sap/ui/Device','sap/ui/base/EventProvider','sap/ui/core/InvisibleText','sap/ui/core/ListItem','sap/ui/core/ResizeHandler','sap/ui/core/ValueStateSupport','sap/m/library','sap/ui/core/library','sap/m/Bar','sap/m/Toolbar','sap/m/Button','sap/m/ToggleButton','sap/m/ColumnListItem','sap/m/GroupHeaderListItem','sap/ui/core/SeparatorItem','sap/m/Dialog','sap/m/DisplayListItem','sap/m/List','sap/m/Popover','sap/m/StandardListItem','sap/m/Table','sap/m/Title','sap/ui/core/IconPool',"sap/base/security/encodeXML","sap/ui/events/KeyCodes","sap/m/ValueStateHeader"],function(D,E,I,L,R,V,l,c,B,T,a,b,C,G,S,d,e,f,P,g,h,j,k,m,K,n){"use strict";var o=l.ListMode;var p=l.PlacementType;var q=l.ListType;var r=l.ListSeparators;var s="sapMSuggestionsPopover",t="sapUiNoContentPadding";var u=c.ValueState;
var v=E.extend("sap.m.SuggestionsPopover",{
constructor:function(i){E.apply(this,arguments);this._oInput=i;this._bHasTabularSuggestions=false;this._bUseDialog=D.system.phone;this._iPopupListSelectedIndex=-1;this._sPopoverContentWidth=null;this._bEnableHighlighting=true;this._bIsInputIncrementalType=false;this._bAutocompleteEnabled=false;this._sTypedInValue='';this._sOldValueState=u.None;this._oInput.addEventDelegate({onsapup:function(w){if(!this._oInput.isComposingCharacter()){this._onsaparrowkey(w,"up",1);}},onsapdown:function(w){if(!this._oInput.isComposingCharacter()){this._onsaparrowkey(w,"down",1);}},onsappageup:function(w){this._onsaparrowkey(w,"up",5);},onsappagedown:function(w){this._onsaparrowkey(w,"down",5);},onsaphome:function(w){var x;if(this._oList){x=this._oList.getItems().length?this._oList.getItems().length-1:0;this._onsaparrowkey(w,"up",x);}},onsapend:function(w){if(this._oList){this._onsaparrowkey(w,"down",this._oList.getItems().length);}},onsapright:this._onsapright,onsaptabnext:this._handleValueStateLinkNav,onsaptabprevious:this._handleValueStateLinkNav},this);},
destroy:function(){if(this._oPopover){this._oPopover.destroy();this._oPopover=null;}if(this._oList){this._oList.destroy();this._oList=null;}this._oProposedItem=null;this._oInputDelegate=null;this._oValueStateHeader=null;if(this._oPickerValueStateText){this._oPickerValueStateText.destroy();this._oPickerValueStateText=null;}}
});
v.M_EVENTS={SELECTION_CHANGE:"selectionChange"};
v._wordStartsWithValue=function(i,w){var x;if(!i||!w||typeof i!=="string"||typeof w!=="string"){return false;}while(i){if(typeof w==="string"&&w!==""&&i.toLowerCase().indexOf(w.toLowerCase())===0){return true;}x=i.indexOf(' ');if(x===-1){break;}i=i.substring(x+1);}return false;};
v._DEFAULTFILTER=function(i,w){if(w instanceof L&&v._wordStartsWithValue(w.getAdditionalText(),i)){return true;}return v._wordStartsWithValue(w.getText(),i);};
v.prototype.isOpen=function(){return this._oPopover&&this._oPopover.isOpen();};
v.prototype.setInputLabels=function(i){this._fnInputLabels=i;};
v.prototype._getInputLabels=function(){return this._fnInputLabels();};
v.prototype._getScrollableContent=function(){return this._oPopover&&this._oPopover.getDomRef("scroll");};
v.prototype.updatePickerHeaderTitle=function(){var i=sap.ui.getCore().getLibraryResourceBundle("sap.m"),w=this.getPickerTitle(),x,y;if(!w){return;}y=this._getInputLabels();if(y.length){x=y[0];if(x&&(typeof x.getText==="function")){w.setText(x.getText());}}else{w.setText(i.getText("COMBOBOX_PICKER_TITLE"));}return w;};
v.prototype.getPickerTitle=function(){return this._oPopover.getCustomHeader().getContentMiddle()[0];};
v.prototype.getOkButton=function(){var i=this._oPopover&&this._oPopover.getBeginButton();return i||null;};
v.prototype.getCancelButton=function(){var i=this._oPopover&&this._oPopover.getCustomHeader()&&this._oPopover.getCustomHeader().getContentRight&&this._oPopover.getCustomHeader().getContentRight()[0];return i||null;};
v.prototype.getFilterSelectedButton=function(){var i=this._oPopover&&this._oPopover.getSubHeader()&&this._oPopover.getSubHeader().getContent()[1];return i||null;};
v.prototype._createFilterSelectedButton=function(){var i=k.getIconURI("multiselect-all");return new b({icon:i});};
v.prototype._createSuggestionPopup=function(O){O=O||[];var i=this._oInput,w=this,M=i._oRb;this._oPopover=!this._bUseDialog?(new P(i.getId()+"-popup",{showArrow:false,placement:p.VerticalPreferredBottom,showHeader:true,initialFocus:i,horizontalScrolling:true,beforeClose:function(){if(w.bMessageValueStateActive){w._getValueStateHeader().removeStyleClass("sapMPseudoFocus");this.bMessageValueStateActive=false;}}})):(new d(i.getId()+"-popup",{beginButton:new a(i.getId()+"-popup-closeButton",{text:M.getText("SUGGESTIONSPOPOVER_CLOSE_BUTTON")}),stretch:true,customHeader:new B(i.getId()+"-popup-header",{contentMiddle:new j(),contentRight:new a({icon:k.getIconURI("decline")})}),subHeader:this.createSubHeaderContent(O),horizontalScrolling:false,initialFocus:this._oPopupInput,beforeOpen:function(){w.updatePickerHeaderTitle();},afterClose:function(){i.focus();l.closeKeyboard();}}));this._registerAutocomplete();this._oPopover.addStyleClass(s);this._oPopover.addStyleClass(t);this._oPopover.addAriaLabelledBy(I.getStaticId("sap.m","INPUT_AVALIABLE_VALUES"));if(!this._bUseDialog){this._overwritePopover();}if(this._oList){this._oPopover.addContent(this._oList);}};
v.prototype.createSubHeaderContent=function(O){var i=[this._oPopupInput];if(O.showSelectedButton){i.push(this._createFilterSelectedButton());}return new T({content:i});};
v.prototype._createSuggestionPopupContent=function(i){var w=this._oInput;this._bHasTabularSuggestions=i;if(!i){this._oList=new f(w.getId()+"-popup-list",{showNoData:false,mode:o.SingleSelectMaster,rememberSelections:false,width:"100%",showSeparators:r.None,busyIndicatorDelay:0});this._oList.addEventDelegate({onAfterRendering:function(){var z,A;if(!this._bEnableHighlighting){return;}z=this._oList.$().find('.sapMDLILabel, .sapMSLITitleOnly, .sapMDLIValue');A=(this._sTypedInValue||this._oInput.getValue()).toLowerCase();this.highlightSuggestionItems(z,A);}.bind(this)});}else{this._oList=this._oInput._getSuggestionsTable();}if(this._oPopover){if(this._bUseDialog){this._oPopover.addAggregation("content",this._oList,true);var x=this._oPopover.$("scrollCont")[0];if(x){var y=sap.ui.getCore().createRenderManager();y.renderControl(this._oList);y.flush(x);y.destroy();}}else{this._oPopover.addContent(this._oList);}}};
v.prototype._getValueStateHeader=function(){if(!this._oValueStateHeader){this._oValueStateHeader=new n();if(this._oPopover.isA("sap.m.Popover")){this._oPopover.setCustomHeader(this._oValueStateHeader);}else{this._oPopover.insertContent(this._oValueStateHeader,0);}this._oValueStateHeader.setPopup(this._oPopover);}return this._oValueStateHeader;};
v.prototype._destroySuggestionPopup=function(){if(this._oPopover){if(this._oList instanceof h){this._oPopover.removeAllContent();}this._oPopover.destroy();this._oPopover=null;}if(this._oList instanceof f){this._oList.destroy();this._oList=null;}if(this._oPickerValueStateText){this._oPickerValueStateText.destroy();this._oPickerValueStateText=null;}if(this._oValueStateHeader){this._oValueStateHeader.destroy();this._oValueStateHeader=null;}this._getInput().removeEventDelegate(this._oInputDelegate,this);};
v.prototype._overwritePopover=function(){var i=this._oInput;this._oPopover.open=function(){this.openBy(i,false,true);};this._oPopover.oPopup.setAnimations(function($,w,O){O();},function($,w,x){x();});};
v.prototype._resizePopup=function(){var i=this._oInput;if(this._oList&&this._oPopover){if(this._sPopoverContentWidth){this._oPopover.setContentWidth(this._sPopoverContentWidth);}else{this._oPopover.setContentWidth((i.$().outerWidth())+"px");}setTimeout(function(){if(this._oPopover&&this._oPopover.isOpen()&&this._oPopover.$().outerWidth()<i.$().outerWidth()){this._oPopover.setContentWidth((i.$().outerWidth())+"px");}}.bind(this),0);}};
v.prototype._registerResize=function(){if(!this._bUseDialog){this._sPopupResizeHandler=R.register(this._oInput,this._resizePopup.bind(this));}};
v.prototype._deregisterResize=function(){if(this._sPopupResizeHandler){this._sPopupResizeHandler=R.deregister(this._sPopupResizeHandler);}};
v.prototype._closePopoverDelegate={onsaptabnext:function(i){this.bMessageValueStateActive=false;this._oInput.onsapfocusleave(i);this._oPopover.close();setTimeout(function(){this._oInput.closeValueStateMessage();}.bind(this),0);}};v.prototype._focusValueStateHeader={onsaptabprevious:function(i){i.preventDefault();this._oInput.getFocusDomRef().focus();this._getValueStateHeader().addStyleClass("sapMPseudoFocus");this._oInput.removeStyleClass("sapMFocus");}};v.prototype._valueStateLinkArrowNav={onsapup:function(i){this._oInput.getFocusDomRef().focus();this._onsaparrowkey(i,"up",1);},onsapdown:function(i){this._oInput.getFocusDomRef().focus();this._onsaparrowkey(i,"down",1);}};
v.prototype._handleValueStateLinkNav=function(i){this.bMessageValueStateActive=this._oInput.getFormattedTextFocused?this._oInput.getFormattedTextFocused():this.bMessageValueStateActive;if((!this.bMessageValueStateActive||!this.getValueStateLinks().length)||(this.bMessageValueStateActive&&document.activeElement.tagName==="A")){return;}var w=this.getValueStateLinks(),x=w[w.length-1];i.preventDefault();this._iPopupListSelectedIndex=-1;w[0].focus();this._getValueStateHeader().removeStyleClass("sapMPseudoFocus");w.forEach(function(y){y.addDelegate(this._valueStateLinkArrowNav,this);},this);x.addDelegate(this._closePopoverDelegate,this);w[0].addDelegate(this._focusValueStateHeader,this);};
v.prototype._onsaparrowkey=function(i,w,x){var y=this._oInput,z,A=y.$("inner");if(i.isMarked()){return;}if(!y.getEnabled()||!y.getEditable()){return;}if(w!=="up"&&w!=="down"){return;}if(this._bIsInputIncrementalType){i.setMarked();}if(!this._oPopover||!this._oPopover.isOpen()){return;}i.preventDefault();i.stopPropagation();var F=false,H=this._oList,J=H.getItems(),M=H.getSelectedItem(),N=this._iPopupListSelectedIndex,O,Q=this._getValueStateHeader(),U=Q.getFormattedText(),W=D.browser.msie?U:Q,X=N;if(w=="down"&&N===J.length-1){return;}if(this.getValueStateLinks().length&&this.bMessageValueStateActive&&i.type==="sapend"){W.removeStyleClass("sapMPseudoFocus");this._oList.addStyleClass("sapMListFocus");X=0;N=J.length-1;J[N].addStyleClass("sapMLIBFocused");this.bMessageValueStateActive=false;}var Y;if(x>1){if(w=="down"&&N+x>=J.length){w="up";x=1;J[N].setSelected(false);J[N].removeStyleClass("sapMLIBFocused");Y=N;N=J.length-1;F=true;}else if(w=="up"&&N-x<0&&N>=0){w="down";x=1;J[N].setSelected(false);J[N].removeStyleClass("sapMLIBFocused");Y=N;N=0;F=true;}}y.removeStyleClass("sapMFocus");this._oList.addStyleClass("sapMListFocus");if(N===-1){N=0;if(this._isSuggestionItemSelectable(J[N])){X=N;F=true;}else{w="down";}}if(w==="down"){while(N<J.length-1&&(!F||!this._isSuggestionItemSelectable(J[N]))){J[N].setSelected(false);J[N].removeStyleClass("sapMLIBFocused");N=N+x;F=true;x=1;if(Y===N){break;}}}else{while(N>0&&(!F||!J[N].getVisible()||!this._isSuggestionItemSelectable(J[N]))){J[N].setSelected(false);J[N].removeStyleClass("sapMLIBFocused");N=N-x;F=true;x=1;if(Y===N){break;}}}if((this.getValueStateLinks().length&&!this.bMessageValueStateActive&&i.type!=="sapend")&&((w==="up"&&(!this._isSuggestionItemSelectable(J[N])||X===0))||i.type==="saphome")){W.addStyleClass(("sapMPseudoFocus"));this._oList.removeStyleClass("sapMListFocus");A.attr("aria-activedescendant",U.getId());this.bMessageValueStateActive=true;this._iPopupListSelectedIndex=-1;this._scrollToItem(0);return;}if((this.getValueStateLinks().length&&this.bMessageValueStateActive)&&(w==="up"&&N===0||w==="down")){W.removeStyleClass("sapMPseudoFocus");this._oList.addStyleClass("sapMListFocus");this.bMessageValueStateActive=false;}if(!this._isSuggestionItemSelectable(J[N])){if(X>=0){J[X].setSelected(true).updateAccessibilityState();A.attr("aria-activedescendant",J[X].getId());J[X].addStyleClass("sapMLIBFocused");}return;}else{z=J[N];z.setSelected(true).updateAccessibilityState();z.addStyleClass("sapMLIBFocused");A.attr("aria-activedescendant",J[N].getId());}if(D.system.desktop){this._scrollToItem(N);}this._oLastSelectedHeader&&this._oLastSelectedHeader.removeStyleClass("sapMInputFocusedHeaderGroup");if(C&&J[N]instanceof C){O=y._getInputValue(y._fnRowResultFilter(J[N]));}else{if(J[N].isA("sap.m.GroupHeaderListItem")){O="";J[N].addStyleClass("sapMInputFocusedHeaderGroup");M&&M.setSelected(false);this._oLastSelectedHeader=J[N];}else if(J[N]instanceof e){O=y._getInputValue(J[N].getLabel());}else{O=y._getInputValue(J[N].getTitle());}}this._iPopupListSelectedIndex=N;this._bSuggestionItemChanged=true;this.fireEvent(v.M_EVENTS.SELECTION_CHANGE,{newValue:O});};
v.prototype.getValueStateLinks=function(){var H=this._getValueStateHeader(),F=H&&typeof H.getFormattedText==="function"&&H.getFormattedText(),i=F&&typeof F.getControls==="function"&&F.getControls();return i||[];};
v.prototype._isSuggestionItemSelectable=function(i){var w=this._bHasTabularSuggestions||i.getType()!==q.Inactive||i.isA("sap.m.GroupHeaderListItem");return i.getVisible()&&w;};
v.prototype.setOkPressHandler=function(H){var O=this.getOkButton();O&&O.attachPress(H);return O;};
v.prototype.setCancelPressHandler=function(H){var i=this.getCancelButton();i&&i.attachPress(H);};
v.prototype.setShowSelectedPressHandler=function(H){var F=this.getFilterSelectedButton();F&&F.attachPress(H);return F;};
v.prototype._scrollToItem=function(i){var w=this._oPopover,x=this._oList,y,z,A,F,H;if(!(w instanceof P)||!x){return;}y=w.getScrollDelegate();if(!y){return;}var J=x.getItems()[i],M=J&&J.getDomRef();if(!M){return;}z=w.getDomRef("cont").getBoundingClientRect();A=M.getBoundingClientRect();F=z.top-A.top;H=A.bottom-z.bottom;if(F>0){y.scrollTo(y._scrollX,Math.max(y._scrollY-F,0));}else if(H>0){y.scrollTo(y._scrollX,y._scrollY+H);}};
v.prototype._createHighlightedText=function(i,w,W){var x,y,z,N,A,F=i?i.textContent:"",H="";if(!v._wordStartsWithValue(F,w)){return m(F);}w=w.toLowerCase();z=w.length;while(v._wordStartsWithValue(F,w)){x=F.toLowerCase();y=x.indexOf(w);y=(y>0)?x.indexOf(' '+w)+1:y;A=F.substring(0,y);F=F.substring(y);H+=m(A);A=F.substring(0,z);F=F.substring(z);H+='<span class="sapMInputHighlight">'+m(A)+'</span>';N=F.indexOf(" ");N=N===-1?F.length:N;A=F.substring(0,N);F=F.substring(N);H+=m(A);if(!W){break;}}if(F){H+=m(F);}return H;};
v.prototype.highlightSuggestionItems=function(w,x,W){var i;if(!this._bEnableHighlighting||(!w&&!w.length)){return;}var y=[];for(i=0;i<w.length;i++){y.push(this._createHighlightedText(w[i],x,W));}for(i=0;i<w.length;i++){w[i].innerHTML=y[i];}};
v.prototype._registerAutocomplete=function(){var i=this._oPopover,U=this._getInput(),w=this._bUseDialog;if(w){i.addEventDelegate({ontap:function(){if(!this._bSuggestionItemTapped&&this._sProposedItemText){U.setValue(this._sProposedItemText);this._sProposedItemText=null;}}},this);}else{i.attachAfterOpen(this._handleTypeAhead,this);}i.attachAfterOpen(this._setSelectedSuggestionItem,this);i.attachAfterClose(this._finalizeAutocomplete,this);this._oInputDelegate={onkeydown:function(x){this._bDoTypeAhead=!D.os.android&&this._bAutocompleteEnabled&&(x.which!==K.BACKSPACE)&&(x.which!==K.DELETE);},oninput:this._handleTypeAhead};U.addEventDelegate(this._oInputDelegate,this);};
v.prototype._handleTypeAhead=function(){var w=this._getInput(),x=w.getValue();this._oProposedItem=null;this._sProposedItemText=null;this._sTypedInValue=x;if(!this._bDoTypeAhead||x===""){return;}if(!this._oPopover.isOpen()||x.length<this._oInput.getStartSuggestion()){return;}if(document.activeElement!==w.getFocusDomRef()){return;}var y=x.toLowerCase(),z=this._bHasTabularSuggestions?this._oInput.getSuggestionRows():this._oInput.getSuggestionItems(),A,N,F,i;z=z.filter(function(H){return!(H.isA("sap.ui.core.SeparatorItem")||H.isA("sap.m.GroupHeaderListItem"));});A=z.length;for(i=0;i<A;i++){F=this._bHasTabularSuggestions?this._oInput._fnRowResultFilter(z[i]):z[i].getText();if(F.toLowerCase().indexOf(y)===0){this._oProposedItem=z[i];N=F;break;}}this._sProposedItemText=N;if(N){N=this._formatTypedAheadValue(N);if(!w.isComposingCharacter()){w.updateDomValue(N);}if(D.system.desktop){w.selectText(x.length,N.length);}else{setTimeout(function(){w.selectText(x.length,N.length);},0);}}};
v.prototype._setSelectedSuggestionItem=function(){var F;if(this._oList){F=this._oList.getItems();for(var i=0;i<F.length;i++){if((F[i]._oItem||F[i])===this._oProposedItem){F[i].setSelected(true);break;}}}};
v.prototype._getInput=function(){return this._bUseDialog?this._oPopupInput:this._oInput;};
v.prototype._finalizeAutocomplete=function(){if(this._oInput.isComposingCharacter()){return;}if(!this._bAutocompleteEnabled){return;}if(!this._bSuggestionItemTapped&&!this._bSuggestionItemChanged&&this._oProposedItem){if(this._bHasTabularSuggestions){this._oInput.setSelectionRow(this._oProposedItem,true);}else{this._oInput.setSelectionItem(this._oProposedItem,true);}}if(this._oProposedItem&&document.activeElement===this._oInput.getFocusDomRef()){var i=this._oInput.getValue().length;this._oInput.selectText(i,i);}this._resetTypeAhead();};
v.prototype._resetTypeAhead=function(){this._oProposedItem=null;this._sProposedItemText=null;this._sTypedInValue='';this._bSuggestionItemTapped=false;this._bSuggestionItemChanged=false;};
v.prototype._formatTypedAheadValue=function(N){return this._sTypedInValue.concat(N.substring(this._sTypedInValue.length,N.length));};
v.prototype._onsapright=function(){var i=this._oInput,w=i.getValue();if(!this._bAutocompleteEnabled){return;}if(this._sTypedInValue!==w){this._sTypedInValue=w;i.fireLiveChange({value:w,newValue:w});}};
v.prototype.updateValueState=function(i,w,x){var y=x&&i!==u.None;w=w||V.getAdditionalText(i);if(!this._oPopover){return this;}if(this._oPopupInput){this._oPopupInput.setValueState(i);}this._getValueStateHeader().setValueState(i);this._setValueStateHeaderText(w);this._showValueStateHeader(y);this._alignValueStateStyles(i);return this;};
v.prototype._showValueStateHeader=function(i){if(this._oValueStateHeader){this._oValueStateHeader.setVisible(i);}};
v.prototype._setValueStateHeaderText=function(i){if(this._oValueStateHeader&&typeof i==="string"){this._oValueStateHeader.setText(i);}else if(this._oValueStateHeader&&typeof i==="object"){this._oValueStateHeader.setFormattedText(i);}};
v.prototype._alignValueStateStyles=function(i){var w=s+"ValueState",O=s+this._sOldValueState+"State",x=s+i+"State";this._oPopover.addStyleClass(w);this._oPopover.removeStyleClass(O);this._oPopover.addStyleClass(x);this._sOldValueState=i;};
v.prototype.addContent=function(i){this._oPopover.addContent(i);};
return v;});
sap.ui.predefine('sap/m/Support',['sap/ui/thirdparty/jquery','sap/ui/Device',"sap/base/security/encodeXML","sap/base/util/isPlainObject"],function(q,D,e,a){"use strict";var S=(function($,d){var b,s,c,l,t=0,m=3000,h=2,f=3,r=1,o={},g={btnStart:"startE2ETrace",selLevel:"logLevelE2ETrace",taContent:"outputE2ETrace",infoText:"Ent-to-End trace is running in the background."+" Navigate to the URL that you would like to trace."+" The result of the trace will be shown in dialog after the trace is terminated.",infoDuration:5000},j={dvLoadedLibs:"LoadedLibs",dvLoadedModules:"LoadedModules"},w;function k(i,v,E,F,G){i.push("<tr class='sapUiSelectable'><td class='sapUiSupportTechInfoBorder sapUiSelectable'><label class='sapUiSupportLabel sapUiSelectable'>",e(F),"</label><br>");var H=G;if(q.isFunction(G)){H=G(i)||"";}i.push(e(H));i.push("</td></tr>");}function n(E,F,G,H,I){k(E,F,G,H,function(E){E.push("<table class='sapMSupportTable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody>");q.each(I,function(i,v){var J="";if(v!==undefined&&v!==null){if(typeof(v)=="string"||typeof(v)=="boolean"||(Array.isArray(v)&&v.length==1)){J=v;}else if((Array.isArray(v)||a(v))&&window.JSON){J=window.JSON.stringify(v);}}k(E,false,false,i,""+J);});E.push("</tbody></table>");});}function p(F){o={version:F.commonInformation.version,build:F.commonInformation.buildTime,change:F.commonInformation.lastChange,useragent:F.commonInformation.userAgent,docmode:F.commonInformation.documentMode,debug:F.commonInformation.debugMode,bootconfig:F.configurationBootstrap,config:F.configurationComputed,loadedlibs:F.loadedLibraries,modules:F.loadedModules,uriparams:F.URLParameters,appurl:F.commonInformation.applicationHREF};var E=["<table class='sapUiSelectable' border='0' cellspacing='5' cellpadding='5' width='100%'><tbody class='sapUiSelectable'>"];k(E,true,true,"SAPUI5 Version",function(i){i.push(o.version," (built at ",o.build,", last change ",o.change,")");});k(E,true,true,"User Agent",function(i){i.push(o.useragent,(o.docmode?", Document Mode '"+o.docmode+"'":""));});k(E,true,true,"Debug Sources",function(i){i.push((o.debug?"ON":"OFF"));});k(E,true,true,"Application",o.appurl);n(E,true,true,"Configuration (bootstrap)",o.bootconfig);n(E,true,true,"Configuration (computed)",o.config);n(E,true,true,"URI Parameters",o.uriparams);k(E,true,true,"End-to-End Trace",function(i){i.push("<label class='sapUiSupportLabel'>Trace Level:</label>","<select id='"+u(g.selLevel)+"' class='sapUiSupportTxtFld' >","<option value='low'>LOW</option>","<option value='medium' selected>MEDIUM</option>","<option value='high'>HIGH</option>","</select>");i.push("<button id='"+u(g.btnStart)+"' class='sapUiSupportBtn'>Start</button>");i.push("<div class='sapUiSupportDiv'>");i.push("<label class='sapUiSupportLabel'>XML Output:</label>");i.push("<textarea id='"+u(g.taContent)+"' class='sapUiSupportTxtArea sapUiSelectable' readonly ></textarea>");i.push("</div>");});k(E,true,true,"Loaded Libraries",function(G){G.push("<ul class='sapUiSelectable'>");q.each(o.loadedlibs,function(i,v){if(v&&(typeof(v)==="string"||typeof(v)==="boolean")){G.push("<li class='sapUiSelectable'>",i+" "+v,"</li>");}});G.push("</ul>");});k(E,true,true,"Loaded Modules",function(i){i.push("<div class='sapUiSupportDiv sapUiSelectable' id='"+u(j.dvLoadedModules)+"'></div>");});E.push("</tbody></table>");return new sap.ui.core.HTML({content:E.join("").replace(/\{/g,"&#123;").replace(/\}/g,"&#125;")});}function u(i){return b.getId()+"-"+i;}function x(v,E){var F="Modules";var G=0,H=[];G=E.length;q.each(E.sort(),function(i,J){H.push(new sap.m.Label({text:" - "+J}).addStyleClass("sapUiSupportPnlLbl"));});var I=new sap.m.Panel({expandable:true,expanded:false,headerToolbar:new sap.m.Toolbar({design:sap.m.ToolbarDesign.Transparent,content:[new sap.m.Label({text:F+" ("+G+")",design:sap.m.LabelDesign.Bold})]}),content:H});I.placeAt(u(v),"only");}function y(){if(b.traceXml){b.$(g.taContent).text(b.traceXml);}if(b.e2eLogLevel){b.$(g.selLevel).val(b.e2eLogLevel);}x(j.dvLoadedModules,o.modules);b.$(g.btnStart).one("tap",function(){b.e2eLogLevel=b.$(g.selLevel).val();b.$(g.btnStart).addClass("sapUiSupportRunningTrace").text("Running...");b.traceXml="";b.$(g.taContent).text("");sap.ui.core.support.trace.E2eTraceLib.start(b.e2eLogLevel,function(i){b.traceXml=i;});sap.m.MessageToast.show(g.infoText,{duration:g.infoDuration});b.close();});}function z(){if(b){return b;}var i=sap.ui.requireSync("sap/m/Dialog");var v=sap.ui.requireSync("sap/m/Button");sap.ui.requireSync("sap/ui/core/HTML");sap.ui.requireSync("sap/m/MessageToast");sap.ui.requireSync("sap/ui/core/support/trace/E2eTraceLib");b=new i({title:"Technical Information",horizontalScrolling:true,verticalScrolling:true,stretch:D.system.phone,buttons:[new v({text:"Close",press:function(){b.close();}})],afterOpen:function(){S.off();},afterClose:function(){S.on();}}).addStyleClass("sapMSupport");return b;}function A(E){if(E.touches){var i=E.touches.length;if(D.browser.mobile&&(D.browser.name===D.browser.BROWSER.INTERNET_EXPLORER||D.browser.name===D.browser.BROWSER.EDGE)){w=i;}if(i>f){d.removeEventListener('touchend',B);return;}switch(i){case h:s=Date.now();d.addEventListener('touchend',B);break;case f:if(s){t=Date.now()-s;l=E.touches[i-1].identifier;}break;}}}function B(E){var i=D.browser.mobile&&(D.browser.name===D.browser.BROWSER.INTERNET_EXPLORER||D.browser.name===D.browser.BROWSER.EDGE)&&w==f;d.removeEventListener('touchend',B);if(t>m&&(E.touches.length===h||i)&&E.changedTouches.length===r&&E.changedTouches[0].identifier===l){t=0;s=0;C();}}function C(){sap.ui.require(['sap/ui/core/support/ToolsAPI'],function(T){var i=z();i.removeAllAggregation("content");i.addAggregation("content",p(T.getFrameworkInformation()));b.open();y();});}return({on:function(){if(!c&&"ontouchstart"in d){c=true;d.addEventListener("touchstart",A);}return this;},off:function(){if(c){c=false;d.removeEventListener("touchstart",A);}return this;},open:function(){C();},isEventRegistered:function(){return c;}}).on();}(q,document));return S;},true);
sap.ui.predefine('sap/m/Switch',['./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','sap/ui/core/theming/Parameters','sap/ui/events/KeyCodes','./SwitchRenderer',"sap/base/assert"],function(l,C,E,I,P,K,S,a){"use strict";var t=l.touch;var c=l.SwitchType;
var d=C.extend("sap.m.Switch",{metadata:{interfaces:["sap.ui.core.IFormContent","sap.m.IOverflowToolbarContent"],library:"sap.m",properties:{state:{type:"boolean",group:"Misc",defaultValue:false},customTextOn:{type:"string",group:"Misc",defaultValue:""},customTextOff:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Data",defaultValue:true},name:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.m.SwitchType",group:"Appearance",defaultValue:c.Default}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{change:{parameters:{state:{type:"boolean"}}}},designtime:"sap/m/designtime/Switch.designtime"}});
I.insertFontFaceStyle();E.apply(d.prototype,[true]);
d.prototype._slide=function(p){if(p>d._OFFPOSITION){p=d._OFFPOSITION;}else if(p<d._ONPOSITION){p=d._ONPOSITION;}if(this._iCurrentPosition===p){return;}this._iCurrentPosition=p;this.getDomRef("inner").style[sap.ui.getCore().getConfiguration().getRTL()?"right":"left"]=p+"px";this._setTempState(Math.abs(p)<d._SWAPPOINT);};
d.prototype._resetSlide=function(){this.getDomRef("inner").style.cssText="";};
d.prototype._setTempState=function(b){if(this._bTempState===b){return;}this._bTempState=b;this.getDomRef("handle").setAttribute("data-sap-ui-swt",b?this._sOn:this._sOff);};
d.prototype._getInvisibleElement=function(){return this.$("invisible");};
d.prototype.getInvisibleElementId=function(){return this.getId()+"-invisible";};
d.prototype.getInvisibleElementText=function(s){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");var T="";switch(this.getType()){case c.Default:if(s){T=this.getCustomTextOn().trim()||b.getText("SWITCH_ON");}else{T=this.getCustomTextOff().trim()||b.getText("SWITCH_OFF");}break;case c.AcceptReject:if(s){T=b.getText("SWITCH_ARIA_ACCEPT");}else{T=b.getText("SWITCH_ARIA_REJECT");}break;}return T;};
d._ONPOSITION=Number(P.get("_sap_m_Switch_OnPosition"));d._OFFPOSITION=Number(P.get("_sap_m_Switch_OffPosition"));d._SWAPPOINT=Math.abs((d._ONPOSITION-d._OFFPOSITION)/2);
d.prototype.onBeforeRendering=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sOn=this.getCustomTextOn()||r.getText("SWITCH_ON");this._sOff=this.getCustomTextOff()||r.getText("SWITCH_OFF");};
d.prototype.ontouchstart=function(e){var T=e.targetTouches[0],b=this.getRenderer().CSS_CLASS,s=this.$("inner");e.setMarked();if(t.countContained(e.touches,this.getId())>1||!this.getEnabled()||e.button){return;}this._iActiveTouchId=T.identifier;this._bTempState=this.getState();this._iStartPressPosX=T.pageX;this._iPosition=s.position().left;this._bDragging=false;setTimeout(this["focus"].bind(this),0);this.$("switch").addClass(b+"Pressed");};
d.prototype.ontouchmove=function(e){e.setMarked();e.preventDefault();var T,p,f=t;if(!this.getEnabled()||e.button){return;}a(f.find(e.touches,this._iActiveTouchId),"missing touchend");T=f.find(e.changedTouches,this._iActiveTouchId);if(!T||Math.abs(T.pageX-this._iStartPressPosX)<6){return;}this._bDragging=true;p=((this._iStartPressPosX-T.pageX)*-1)+this._iPosition;if(sap.ui.getCore().getConfiguration().getRTL()){p=-p;}this._slide(p);};
d.prototype.ontouchend=function(e){e.setMarked();var T,f=t;if(!this.getEnabled()||e.button){return;}a(this._iActiveTouchId!==undefined,"expect to already be touching");T=f.find(e.changedTouches,this._iActiveTouchId);if(T){a(!f.find(e.touches,this._iActiveTouchId),"touchend still active");if(!this._updateStateAndNotify()){this.$("switch").removeClass(this.getRenderer().CSS_CLASS+"Pressed");this._resetSlide();}}};
d.prototype.ontouchcancel=d.prototype.ontouchend;
d.prototype._handleSpaceOrEnter=function(e){if(this.getEnabled()){e.setMarked();if(!this._bDragging){this._updateStateAndNotify();}}};
d.prototype.onsapspace=function(e){e.preventDefault();};
d.prototype.onkeyup=function(e){if(e.which===K.SPACE){this._handleSpaceOrEnter(e);}};
d.prototype.onsapenter=d.prototype._handleSpaceOrEnter;
d.prototype._updateStateAndNotify=function(){var s=this.getState(),b;this.setState(this._bDragging?this._bTempState:!s);b=s!==this.getState();if(b){this.fireChange({state:this.getState()});}this._bDragging=false;return b;};
d.prototype.getAccessibilityInfo=function(){var b=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s=this.getState(),D=this.getInvisibleElementText(s);return{role:"switch",type:b.getText("ACC_CTR_TYPE_SWITCH"),description:D,focusable:this.getEnabled(),enabled:this.getEnabled()};};
d.prototype.getOverflowToolbarConfig=function(){return{propsUnrelatedToSize:["enabled","state"]};};
return d;});
sap.ui.predefine('sap/m/SwitchRenderer',["sap/ui/Device","sap/m/library"],function(D,l){"use strict";var S=l.SwitchType;var a={apiVersion:2};a.CSS_CLASS="sapMSwt";
a.render=function(r,s){var b=s.getState(),c=b?s._sOn:s._sOff,t=s.getTooltip_AsString(),e=s.getEnabled(),n=s.getName(),A=sap.ui.getCore().getConfiguration().getAccessibility(),d=sap.ui.getCore().getConfiguration().getAnimation(),C=a.CSS_CLASS;r.openStart("div",s);r.class(C+"Cont");if(!e){r.class(C+"ContDisabled");}if(e){r.attr("tabindex","0");}if(t){r.attr("title",t);}if(A){this.writeAccessibilityState(r,s);}r.openEnd();r.openStart("div",s.getId()+"-switch");r.attr("aria-hidden","true");r.class(C);if(d){r.class(C+"Trans");}r.class(b?C+"On":C+"Off");r.class(C+s.getType());if(D.system.desktop&&e){r.class(C+"Hoverable");}if(!e){r.class(C+"Disabled");}if(s._sOn===" "&&s._sOff===" "){r.class(C+"NoLabel");}r.openEnd();r.openStart("div",s.getId()+"-inner");r.class(C+"Inner");r.openEnd();this.renderText(r,s);this.renderHandle(r,s,c);r.close("div");r.close("div");if(n){this.renderCheckbox(r,s,c);}if(A){this.renderInvisibleElement(r,s,{id:s.getInvisibleElementId(),text:s.getInvisibleElementText(b)});}r.close("div");};
a.renderText=function(r,s){var C=a.CSS_CLASS,d=s.getType()===S.Default;r.openStart("div",s.getId()+"-texton");r.class(C+"Text");r.class(C+"TextOn");r.openEnd();r.openStart("span");r.class(C+"Label");r.class(C+"LabelOn");r.openEnd();if(d){r.text(s._sOn);}r.close("span");r.close("div");r.openStart("div",s.getId()+"-textoff");r.class(C+"Text");r.class(C+"TextOff");r.openEnd();r.openStart("span");r.class(C+"Label");r.class(C+"LabelOff");r.openEnd();if(d){r.text(s._sOff);}r.close("span");r.close("div");};
a.renderHandle=function(r,s,b){var C=a.CSS_CLASS;r.openStart("div",s.getId()+"-handle");r.attr("data-sap-ui-swt",b);r.class(C+"Handle");r.openEnd();r.close("div");};
a.renderCheckbox=function(r,s,b){r.voidStart("input",s.getId()+"-input");r.attr("type","checkbox");r.attr("name",s.getName());r.attr("value",b);if(s.getState()){r.attr("checked","checked");}if(!s.getEnabled()){r.attr("disabled","disabled");}r.voidEnd();};
a.writeAccessibilityState=function(r,s){var A=s.getAriaLabelledBy(),m;if(A){A={value:s.getInvisibleElementId(),append:true};}m={role:"switch",checked:s.getState(),labelledby:A};r.accessibilityState(s,m);};
a.renderInvisibleElement=function(r,s,o){r.openStart("span",o.id);r.attr("aria-hidden","true");r.class("sapUiInvisibleText");r.openEnd();r.text(o.text);r.close("span");};
return a;},true);
sap.ui.predefine('sap/m/TabContainer',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/util/ResponsivePaddingsEnablement','./TabContainerRenderer','./TabStrip','./TabStripItem','./Button','sap/ui/Device'],function(l,C,I,R,T,a,b,B,D){"use strict";var c=l.ButtonType;var P=l.PageBackgroundDesign;
var d=C.extend("sap.m.TabContainer",{
metadata:{library:"sap.m",properties:{showAddNewButton:{type:"boolean",group:"Misc",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:P.List}},aggregations:{items:{type:"sap.m.TabContainerItem",multiple:true,singularName:"item",bindable:"bindable"},_addNewButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_tabStrip:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:"sap.m.TabContainerItem",multiple:false}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}},addNewButtonPress:{}},designtime:"sap/m/designtime/TabContainer.designtime",dnd:{draggable:false,droppable:true}},
constructor:function(i,s){var S=[];if(!s&&typeof i==='object'){s=i;}if(s&&Array.isArray(s['items'])){S=s['items'];delete s['items'];}C.prototype.constructor.apply(this,arguments);var o=new a(this.getId()+"--tabstrip",{hasSelect:true,itemSelect:function(e){var f=e.getParameter("item"),g=this._fromTabStripItem(f);this.setSelectedItem(g,e);}.bind(this),itemClose:function(e){var f=e.getParameter("item"),r=this._fromTabStripItem(f);e.preventDefault();if(this.fireItemClose({item:r})){if(!this.getBinding("items")){this.removeItem(r);}}}.bind(this)});this.setAggregation("_tabStrip",o,true);if(s&&s['showAddNewButton']){this.setShowAddNewButton(true);}S.forEach(function(e){this.addItem(e);},this);this.data("sap-ui-fastnavgroup","true",true);}
});
var t={"name":"text","additionalText":"additionalText","icon":"icon","iconTooltip":"iconTooltip","modified":"modified"};R.call(d.prototype,{header:{selector:".sapMTabStripContainer"}});
d.prototype.init=function(){this._initResponsivePaddingsEnablement();};
d.prototype.onBeforeRendering=function(){if(this.getSelectedItem()){return;}this._setDefaultTab();};
d.prototype._getAddNewTabButton=function(){var o=this.getAggregation("_addNewButton");var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");if(!o){o=new B({type:c.Transparent,tooltip:r.getText("TABCONTAINER_ADD_NEW_TAB"),icon:I.getIconURI("add"),press:function(){this.getParent().getParent().fireAddNewButtonPress();}});o.addStyleClass("sapMTSAddNewTabBtn");this.setAggregation("_addNewButton",o,true);}return o;};
d.prototype._getTabStrip=function(){return this.getAggregation("_tabStrip");};
d.prototype._fromTabStripItem=function(i){var e=this.getItems()||[],f=e.length,g=0;for(;g<f;g++){if(e[g].getId()===i.getKey()){return e[g];}}return null;};
d.prototype._toTabStripItem=function(i){var e=0,k=i,o,f,g=this._getTabStrip();if(!g){return null;}o=g.getItems();f=o.length;if(typeof i==="object"){k=i.getId();}for(;e<f;e++){if(o[e].getKey()===k){return o[e];}}return null;};
d.prototype._getSelectedItemContent=function(){var o=this._getTabStrip(),s=this.getSelectedItem(),S=sap.ui.getCore().byId(s),e=this._toTabStripItem(S);if(o){o.setSelectedItem(e);}return S?S.getContent():null;};
d.prototype._moveToNextItem=function(s){if(!this._getTabStrip()._oItemNavigation){return;}var i=this.getItems().length,e=this._getTabStrip()._oItemNavigation.getFocusedIndex(),n=i===e?--e:e,N=this.getItems()[n],f=function(){if(this._getTabStrip()._oItemNavigation){this._getTabStrip()._oItemNavigation.focusItem(n);}};if(s){this.setSelectedItem(N);this.fireItemSelect({item:N});}if(document.activeElement.classList.contains('sapMTabStripSelectListItemCloseBtn')){setTimeout(f.bind(this),0);}};
d.prototype._attachItemPropertyChanged=function(o){o.attachItemPropertyChanged(function(e){var p=e['mParameters'].propertyKey;if(t[p]){p=t[p];var f=this._toTabStripItem(e.getSource());var m="set"+p.substr(0,1).toUpperCase()+p.substr(1);f&&f[m](e['mParameters'].propertyValue);}}.bind(this));};
d.prototype.removeItem=function(i){var o=this._getTabStrip(),e,f;if(typeof i==="undefined"||i===null){return null;}i=this.removeAggregation("items",i);e=i.getId()===this.getSelectedItem();f=this._toTabStripItem(i);if(f.getId()===o.getSelectedItem()){o.removeAllAssociation("selectedItem",true);}o.removeItem(f);this._moveToNextItem(e);return i;};
d.prototype.addAggregation=function(A,o,s){if(A==='items'){this._attachItemPropertyChanged(o);}return C.prototype.addAggregation.call(this,A,o,s);};
d.prototype.insertAggregation=function(A,o,i,s){if(A==='items'){this._attachItemPropertyChanged(o);}return C.prototype.insertAggregation.call(this,A,o,i,s);};
d.prototype.addItem=function(i){this.addAggregation("items",i,false);this._getTabStrip().addItem(new b({key:i.getId(),text:i.getName(),additionalText:i.getAdditionalText(),icon:i.getIcon(),iconTooltip:i.getIconTooltip(),modified:i.getModified(),tooltip:i.getTooltip(),customData:i.getCustomData()}));return this;};
d.prototype.destroyItems=function(){this._getTabStrip().destroyItems();this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
d.prototype.insertItem=function(i,e){this._getTabStrip().insertItem(new b({key:i.getId(),text:i.getName(),additionalText:i.getAdditionalText(),icon:i.getIcon(),iconTooltip:i.getIconTooltip(),modified:i.getModified(),tooltip:i.getTooltip(),customData:i.getCustomData()}),e);return this.insertAggregation("items",i,e);};
d.prototype.removeAllItems=function(){this._getTabStrip().removeAllItems();this.setSelectedItem(null);return this.removeAllAggregation("items");};
d.prototype.setAddButton=function(o){return this._getTabStrip().setAddButton(o);};
d.prototype.getAddButton=function(){return this._getTabStrip().getAddButton();};
d.prototype.setShowAddNewButton=function(s){this.setProperty("showAddNewButton",s,true);if(D.system.phone){s?this.addStyleClass("sapUiShowAddNewButton"):this.removeStyleClass("sapUiShowAddNewButton");}var o=this._getTabStrip();if(o){o.setAddButton(s?this._getAddNewTabButton():null);}return this;};
d.prototype.setSelectedItem=function(s,e){if(this.fireItemSelect({item:s})){var o=this._getTabStrip();if(s&&o){o.setSelectedItem(this._toTabStripItem(s));this._rerenderContent(s.getContent());}d.prototype.setAssociation.call(this,"selectedItem",s,true);return this;}if(e){e.preventDefault();}return this;};
d.prototype._rerenderContent=function(o){var $=this.$("content"),r;if(!o||($.length<=0)){return;}r=sap.ui.getCore().createRenderManager();for(var i=0;i<o.length;i++){r.renderControl(o[i]);}r.flush($[0]);r.destroy();};
d.prototype._setDefaultTab=function(){var f=this.getItems()[0]||null;this.setSelectedItem(f);return f;};
return d;});
sap.ui.predefine('sap/m/TabContainerItem',['sap/ui/core/Element','sap/ui/core/IconPool','./TabStripItem','./library'],function(E,I,T,l){"use strict";
var a=E.extend("sap.m.TabContainerItem",{metadata:{library:"sap.ui.core",properties:{name:{type:"string",group:"Misc",defaultValue:""},additionalText:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},key:{type:"string",group:"Data",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,defaultValue:null},_image:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{itemPropertyChanged:{parameters:{itemChanged:{type:"sap.m.TabContainerItem"},propertyKey:{type:"string"},propertyValue:{type:"any"}}}},dnd:{draggable:true,droppable:false}}});
a.prototype.setProperty=function(n,v,s){this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return E.prototype.setProperty.call(this,n,v,s);};
a.prototype.setIcon=function(i){return T.prototype._setIcon.call(this,i,true);};
a.prototype._getImage=function(){return this.getAggregation("_image");};
return a;});
sap.ui.predefine('sap/m/TabContainerRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){var t=c._getTabStrip(),s=c._getSelectedItemContent();r.openStart("div",c);r.class("sapMTabContainer");r.openEnd();if(t){r.renderControl(t);}r.openStart("div",c.getId()+"-containerContent");r.class("sapMTabContainerContent");if(c.getBackgroundDesign()){r.class("sapMTabContainerContent"+c.getBackgroundDesign());}r.openEnd();r.openStart("div",this.getContentDomId(c));r.class("sapMTabContainerInnerContent");r.accessibilityState(c,this.getTabContentAccAttributes(c));r.openEnd();if(s){s.forEach(function(C){r.renderControl(C);});}r.close("div");r.close("div");r.close("div");};
T.getTabContentAccAttributes=function(c){var s=c.getSelectedItem(),t,a={role:"tabpanel"};if(s){t=c._toTabStripItem(s);if(t){a["aria-labelledby"]=t.getId();}}return a;};
T.getContentDomId=function(c){return c.getId()+"-content";};
return T;},true);
sap.ui.predefine('sap/m/TabStrip',['sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/core/delegate/ItemNavigation','sap/ui/base/ManagedObject','sap/ui/core/delegate/ScrollEnablement','./AccButton','./TabStripItem','sap/m/Select','sap/m/SelectList','sap/ui/Device','sap/ui/core/Renderer','sap/ui/core/ResizeHandler','sap/m/library','sap/ui/core/Icon','sap/m/Image','sap/m/SelectRenderer','sap/m/SelectListRenderer','./TabStripRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/scrollLeftRTL"],function(C,I,a,M,S,A,T,b,c,D,R,d,l,e,f,g,h,i,L,q){"use strict";var j=l.SelectType;var B=l.ButtonType;
var k=C.extend("sap.m.TabStrip",{
metadata:{library:"sap.m",properties:{hasSelect:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{items:{type:"sap.m.TabStripItem",multiple:true,singularName:"item"},addButton:{type:"sap.m.Button",multiple:false,singularName:"addButton"},_select:{type:'sap.m.Select',multiple:false,visibility:"hidden"},_rightArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"},_leftArrowButton:{type:'sap.m.AccButton',multiple:false,visibility:"hidden"}},associations:{selectedItem:{type:'sap.m.TabStripItem',group:"Misc"}},events:{itemClose:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPress:{parameters:{item:{type:"sap.m.TabStripItem"}}},itemSelect:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabContainerItem"}}}}},
constructor:function(v,s){var H=false;if(!s&&typeof v==='object'){s=v;}if(s){H=s['hasSelect'];delete s['hasSelect'];}M.prototype.constructor.apply(this,arguments);this.setProperty('hasSelect',H,true);}
});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");k.ICON_BUTTONS={LeftArrowButton:"slim-arrow-left",RightArrowButton:"slim-arrow-right",DownArrowButton:D.system.phone?"navigation-down-arrow":"slim-arrow-down",AddButton:"add"};k.SELECT_ITEMS_ID_SUFFIX='-SelectItem';k.SCROLL_SIZE=320;k.MIN_DRAG_OFFSET=D.support.touch?15:5;k.SCROLL_ANIMATION_DURATION=sap.ui.getCore().getConfiguration().getAnimation()?500:0;
k.prototype.init=function(){this._bDoScroll=!D.system.phone;this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._iCurrentScrollLeft=0;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(!D.system.phone){this._oScroller=new S(this,this.getId()+"-tabs",{horizontal:true,vertical:false,nonTouchScrolling:true});}};
k.prototype.exit=function(){this._bRtl=null;this._iCurrentScrollLeft=null;this._iMaxOffsetLeft=null;this._scrollable=null;this._oTouchStartX=null;if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._removeItemNavigation();};
k.prototype.onBeforeRendering=function(){if(this._sResizeListenerId){d.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
k.prototype.onAfterRendering=function(){if(this._oScroller){this._oScroller.setIconTabBar(this,q.proxy(this._handleOverflowButtons,this),null);}this._addItemNavigation();if(!D.system.phone){this._oScroller._$Container=this.$("tabsContainer");this._adjustScrolling();if(this.getSelectedItem()){if(!sap.ui.getCore().isThemeApplied()){sap.ui.getCore().attachThemeChanged(this._handleInititalScrollToItem,this);}else{this._handleInititalScrollToItem();}}this._sResizeListenerId=d.register(this.getDomRef(),q.proxy(this._adjustScrolling,this));}else{this.$().toggleClass("sapUiSelectable",this.getItems().length>1);}};
k.prototype._handleInititalScrollToItem=function(){var s=sap.ui.getCore().byId(this.getSelectedItem());if(s&&s.$().length>0){this._scrollIntoView(s,500);}sap.ui.getCore().detachThemeChanged(this._handleInititalScrollToItem,this);};
k.prototype.getFocusDomRef=function(){var t=sap.ui.getCore().byId(this.getSelectedItem());if(!t){return null;}return t.getDomRef();};
k.prototype.applyFocusInfo=function(F){if(F.focusDomRef){q(F.focusDomRef).trigger("focus");}};
k.prototype._addItemNavigation=function(){var H=this.getDomRef("tabsContainer"),s=this.getItems(),t=[];s.forEach(function(u){var v=u.getDomRef();q(v).attr("tabindex","-1");t.push(v);});if(!this._oItemNavigation){this._oItemNavigation=new a();}this._oItemNavigation.setRootDomRef(H);this._oItemNavigation.setItemDomRefs(t);this._oItemNavigation.setCycling(false);this._oItemNavigation.setPageSize(5);this._oItemNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this.addDelegate(this._oItemNavigation);};
k.prototype._checkScrolling=function(){var t=this.getDomRef("tabs"),s=t&&(t.scrollWidth>this.getDomRef("tabsContainer").offsetWidth);this.$().toggleClass("sapMTSScrollable",s);return s;};
k.prototype._handleOverflowButtons=function(){var t=this.getDomRef("tabs"),s=this.getDomRef("tabsContainer"),u,v,w,x=false,y=false,z=this._checkScrolling();if(z&&!this.getAggregation("_rightArrowButton")&&!this.getAggregation("_leftArrowButton")){this._getLeftArrowButton();this._getRightArrowButton();var E=sap.ui.getCore().createRenderManager();this.getRenderer().renderRightOverflowButtons(E,this,true);this.getRenderer().renderLeftOverflowButtons(E,this,true);E.destroy();}if(z&&t&&s){if(this._bRtl){u=q(s).scrollLeftRTL();}else{u=s.scrollLeft;}v=t.scrollWidth;w=s.clientWidth;if(Math.abs(v-w)===1){v=w;}if(u>0){if(this._bRtl){y=true;}else{x=true;}}if((v>w)&&(u+w<v)){if(this._bRtl){x=true;}else{y=true;}}this.$().toggleClass("sapMTSScrollBack",x).toggleClass("sapMTSScrollForward",y);}else{this.$().toggleClass("sapMTSScrollBack",false).toggleClass("sapMTSScrollForward",false);}};
k.prototype._adjustScrolling=function(){this._iMaxOffsetLeft=Math.abs(this.$("tabsContainer").width()-this.$("tabs").width());this._handleOverflowButtons();};
k.prototype._getLeftArrowButton=function(){return this._getArrowButton("_leftArrowButton",r.getText("TABSTRIP_SCROLL_BACK"),k.ICON_BUTTONS.LeftArrowButton,-k.SCROLL_SIZE);};
k.prototype._getRightArrowButton=function(){return this._getArrowButton("_rightArrowButton",r.getText("TABSTRIP_SCROLL_FORWARD"),k.ICON_BUTTONS.RightArrowButton,k.SCROLL_SIZE);};
k.prototype._getArrowButton=function(s,t,u,v){var w=this.getAggregation(s),x=this;if(!w){w=new A({type:B.Transparent,icon:I.getIconURI(u),tooltip:t,tabIndex:"-1",ariaHidden:"true",press:function(E){x._scroll(v,k.SCROLL_ANIMATION_DURATION);}});this.setAggregation(s,w,true);}return w;};
k.prototype._removeItemNavigation=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
k.prototype._scroll=function(s,t){var u=this.getDomRef("tabsContainer").scrollLeft,v=D.browser.internet_explorer||D.browser.edge,w;if(this._bRtl&&!v){w=u-s;if(D.browser.firefox){if(w<-this._iMaxOffsetLeft){w=-this._iMaxOffsetLeft;}if(w>0){w=0;}}}else{w=u+s;if(w<0){w=0;}if(w>this._iMaxOffsetLeft){w=this._iMaxOffsetLeft;}}this._oScroller.scrollTo(w,0,t);this._iCurrentScrollLeft=w;};
k.prototype._scrollIntoView=function(s,t){var $=this.$("tabs"),u=s.$(),v=$.innerWidth()-$.width(),w=u.outerWidth(true),x=u.position().left-v/2,y=this.getDomRef("tabsContainer"),z=y.scrollLeft,E=this.$("tabsContainer").width(),N=z,F=D.browser.internet_explorer||D.browser.edge;if(x<0||x>E-w){if(this._bRtl&&D.browser.firefox){if(x<0){N+=x+w-E;}else{N+=x;}}else if(this._bRtl&&F){if(x<0){N-=x;}else{N-=x+w-E;}}else{if(x<0){N+=x;}else{N+=x+w-E;}}this._iCurrentScrollLeft=N;this._oScroller.scrollTo(N,0,t);}};
k.prototype._createSelect=function(t){var s,u,v,w={type:j.IconOnly,autoAdjustWidth:true,maxWidth:"2.5rem",icon:I.getIconURI(k.ICON_BUTTONS.DownArrowButton),tooltip:r.getText("TABSTRIP_OPENED_TABS"),change:function(E){u=E.getParameters()['selectedItem'];v=this._findTabStripItemFromSelectItem(u);if(v instanceof T){this._activateItem(v,E);}}.bind(this)};s=new n(w).addStyleClass("sapMTSOverflowSelect");this._addItemsToSelect(s,t);return s;};
k.prototype.onsapselect=function(E){E.setMarked();E.preventDefault();if(E.srcControl instanceof T){this._activateItem(E.srcControl,E);}};
k.prototype.onsapdelete=function(E){var s=q("#"+E.target.id).control(0),t=s.getId()===this.getSelectedItem(),u=function(){this._moveToNextItem(t);};this._removeItem(s,u);};
k.prototype._moveToNextItem=function(s){if(!this._oItemNavigation){return;}var t=this.getItems().length,u=this._oItemNavigation.getFocusedIndex(),N=t===u?--u:u,v=this.getItems()[N],F=function(){if(this._oItemNavigation){this._oItemNavigation.focusItem(N);}};if(s){this.setSelectedItem(v);this.fireItemPress({item:v});}setTimeout(F.bind(this),0);};
k.prototype._activateItem=function(s,E){if(this.fireItemSelect({item:s})){if(!this.getSelectedItem()||this.getSelectedItem()!==s.getId()){this.setSelectedItem(s);}this.fireItemPress({item:s});}else if(E&&!E.isDefaultPrevented()){E.preventDefault();}};
k.prototype.addAggregation=function(s,O,t){if(s==='items'){this._handleItemsAggregation(['addAggregation',O,t],true);}return C.prototype.addAggregation.call(this,s,O,t);};
k.prototype.insertAggregation=function(s,O,t,u){if(s==='items'){this._handleItemsAggregation(['insertAggregation',O,t,u],true);}return C.prototype.insertAggregation.call(this,s,O,t,u);};
k.prototype.removeAggregation=function(s,O,t){if(s==='items'){this._handleItemsAggregation(['removeAggregation',O,t]);}return C.prototype.removeAggregation.call(this,s,O,t);};
k.prototype.removeAllAggregation=function(s,t){if(s==='items'){this._handleItemsAggregation(['removeAllAggregation',null,t]);}return C.prototype.removeAllAggregation.call(this,s,t);};
k.prototype.destroyAggregation=function(s,t){if(s==='items'){this._handleItemsAggregation(['destroyAggregation',t]);}return C.prototype.destroyAggregation.call(this,s,t);};
k.prototype.setSelectedItem=function(s){var N=!D.system.phone;if(!s){return this;}if(s.$().length>0&&N){this._scrollIntoView(s,500);}if(N){this._updateAriaSelectedAttributes(this.getItems(),s);this._updateSelectedItemClasses(s.getId());}if(this.getHasSelect()){var t=this._findSelectItemFromTabStripItem(s);this.getAggregation('_select').setSelectedItem(t);}return this.setAssociation("selectedItem",s,N);};
k.prototype.setProperty=function(P,v,s){var t;t=C.prototype.setProperty.call(this,P,v,s);if(P==='hasSelect'){if(v){if(!this.getAggregation('_select')){t=this.setAggregation('_select',this._createSelect(this.getItems()));}}else{t=this.destroyAggregation('_select');}}return t;};
k.prototype._attachItemEventListeners=function(O){if(O instanceof T){var E=['itemClosePressed','itemPropertyChanged'];E.forEach(function(s){s=s.charAt(0).toUpperCase()+s.slice(1);O['detach'+s](this['_handle'+s]);O['attach'+s](this['_handle'+s].bind(this));},this);}};
k.prototype._detachItemEventListeners=function(O){if(!O||typeof O!=='object'||!(O instanceof T)){var s=this.getItems();s.forEach(function(t){if(typeof t!=='object'||!(t instanceof T)){return;}return this._detachItemEventListeners(t);}.bind(this));}};
k.prototype._handleItemPropertyChanged=function(E){var s=this._findSelectItemFromTabStripItem(E.getSource());var P=E['mParameters'].propertyKey;var t="set"+P.substr(0,1).toUpperCase()+P.substr(1);s[t](E['mParameters'].propertyValue);};
k.prototype._handleItemClosePressed=function(E){this._removeItem(E.getSource());};
k.prototype._removeItem=function(s,t){var u;if(!(s instanceof T)){L.error('Expecting instance of a TabStripSelectItem, given: ',s);}if(s.getId().indexOf(k.SELECT_ITEMS_ID_SUFFIX)!==-1){u=this._findTabStripItemFromSelectItem(s);}else{u=s;}if(this.fireItemClose({item:u})){this.removeAggregation('items',u);this._moveToNextItem(s.getId()===this.getSelectedItem());if(t){t.call(this);}}};
k.prototype._handleItemsAggregation=function(s,t){var u='items',F=s[0],O=s[1],N=[u];s.forEach(function(v,w){if(w>0){N.push(v);}});if(t){this._attachItemEventListeners(O);}else{this._detachItemEventListeners(O);}if(u!=="items"){return this;}if(this.getHasSelect()){this._handleSelectItemsAggregation(N,t,F,O);}return this;};
k.prototype._handleSelectItemsAggregation=function(s,t,F,O){var u=this.getAggregation('_select'),v;if(F==='destroyAggregation'&&!u){return;}if(O===null||typeof O!=='object'){return u[F]['apply'](u,s);}if(t){v=this._createSelectItemFromTabStripItem(O);}else{v=this._findSelectItemFromTabStripItem(O);}s.forEach(function(w,x){if(typeof w==='object'){s[x]=v;}});return u[F]['apply'](u,s);};
k.prototype._addItemsToSelect=function(s,t){t.forEach(function(u){var v=this._createSelectItemFromTabStripItem(u);s.addAggregation('items',v);if(u.getId()===this.getSelectedItem()){s.setSelectedItem(v);}},this);};
k.prototype._createSelectItemFromTabStripItem=function(t){var s;if(!t&&!(t instanceof sap.m.TabContainerItem)){L.error('Expecting instance of "sap.m.TabContainerItem": instead of '+t+' given.');return;}s=new T({id:t.getId()+k.SELECT_ITEMS_ID_SUFFIX,text:t.getText(),additionalText:t.getAdditionalText(),icon:t.getIcon(),iconTooltip:t.getIconTooltip(),modified:t.getModified(),itemClosePressed:function(E){this._handleItemClosePressed(E);}.bind(this)});s.addEventDelegate({ontap:function(E){var u=E.srcControl;if(E.target.id===u.getParent().getId()+"-img"){E.srcControl=u=u.getParent();}if((u instanceof A||u instanceof e)){this.fireItemClosePressed({item:this});}}},s);return s;};
k.prototype._findTabStripItemFromSelectItem=function(t){var s,u=t.getId().replace(k.SELECT_ITEMS_ID_SUFFIX,''),v=this.getItems();for(s=0;s<v.length;s++){if(v[s].getId()===u){return v[s];}}};
k.prototype._findSelectItemFromTabStripItem=function(t){var s,u,v=t.getId()+k.SELECT_ITEMS_ID_SUFFIX;if(this.getHasSelect()){u=this.getAggregation('_select').getItems();for(s=0;s<u.length;s++){if(u[s].getId()===v){return u[s];}}}};
k.prototype._updateAriaSelectedAttributes=function(s,t){var u;s.forEach(function(v){u="false";if(v.$()){if(t&&t.getId()===v.getId()){u="true";}v.$().attr("aria-selected",u);}});};
k.prototype._updateSelectedItemClasses=function(s){if(this.$("tabs")){this.$("tabs").children(".sapMTabStripItemSelected").removeClass("sapMTabStripItemSelected");q("#"+s).addClass("sapMTabStripItemSelected");}};
k.prototype.changeItemState=function(v,s){var $;var t=this.getItems();t.forEach(function(u){if(v===u.getId()){$=q(u.$());if(s===true&&!$.hasClass(T.CSS_CLASS_MODIFIED)){$.addClass(T.CSS_CLASS_MODIFIED);}else{$.removeClass(T.CSS_CLASS_MODIFIED);}}});};
k.prototype.ontouchstart=function(E){var t=q(E.target).control(0);if(t instanceof T||t instanceof A||t instanceof e||t instanceof f||t instanceof n){this._oTouchStartX=E.changedTouches[0].pageX;}};
k.prototype.ontouchend=function(E){var t,s;if(!this._oTouchStartX){return;}t=q(E.target).control(0);if(E.target.id===t.getParent().getId()+"-img"){t=t.getParent();}s=Math.abs(E.changedTouches[0].pageX-this._oTouchStartX);if(s<k.MIN_DRAG_OFFSET){if(t instanceof T){this._activateItem(t,E);}else if(t instanceof A){if(t&&t.getParent&&t.getParent()instanceof T){t=t.getParent();this._removeItem(t);}}else if(t instanceof e){if(t&&t.getParent&&t.getParent().getParent&&t.getParent().getParent()instanceof T){t=t.getParent().getParent();this._removeItem(t);}}this._oTouchStartX=null;}};
k.prototype.destroyItems=function(){this.setAssociation("selectedItem",null);return this.destroyAggregation("items");};
var m=R.extend(g);m.apiVersion=2;
var n=b.extend("sap.m.internal.TabStripSelect",{
metadata:{library:"sap.m"},
renderer:m
});
n.prototype.onAfterRendering=function(){b.prototype.onAfterRendering.apply(this,arguments);this.$().attr("tabindex","-1");};
n.prototype.onAfterRenderingPicker=function(){var P=this.getPicker();b.prototype.onAfterRenderingPicker.call(this);if(D.system.phone){return;}P.setOffsetX(Math.round(sap.ui.getCore().getConfiguration().getRTL()?this.getPicker().$().width()-this.$().width():this.$().width()-this.getPicker().$().width()));P.setOffsetY(this.$().parents().hasClass('sapUiSizeCompact')?2:3);P._calcPlacement();};
n.prototype.createList=function(){this._oList=new p({width:"100%"}).attachSelectionChange(this.onSelectionChange,this).addEventDelegate({ontap:function(E){this.close();}},this);return this._oList;};
n.prototype.setValue=function(v){b.prototype.setValue.apply(this,arguments);this.$("label").toggleClass("sapMTSOverflowSelectLabelModified",this.getSelectedItem()&&this.getSelectedItem().getProperty("modified"));return this;};
n.prototype._getValueIcon=function(){return null;};
var o=R.extend(h);o.apiVersion=2;
o.renderItem=function(s,t,u,v){s.openStart("li",u);s.class(h.CSS_CLASS+"ItemBase");s.class(h.CSS_CLASS+"Item");s.class("sapMTSOverflowSelectListItem");if(u.getProperty("modified")){s.class("sapMTSOverflowSelectListItemModified");}if(D.system.desktop){s.class(h.CSS_CLASS+"ItemBaseHoverable");}if(u===t.getSelectedItem()){s.class(h.CSS_CLASS+"ItemBaseSelected");}s.attr("tabindex",0);this.writeItemAccessibilityState.apply(this,arguments);s.openEnd();s.openStart("div");s.class("sapMSelectListItemText");s.openEnd();if(u.getIcon()){s.renderControl(u._getImage());}s.openStart("div");s.class("sapMTSTexts");s.openEnd();this.renderItemText(s,u.getAdditionalText(),T.CSS_CLASS_TEXT);this.renderItemText(s,u.getText(),T.CSS_CLASS_LABEL);s.close("div");s.close("div");s.renderControl(u.getAggregation('_closeButton'));s.close("li");};
o.renderItemText=function(s,t,u){s.openStart("div");s.class(u);s.openEnd();s.text(t.slice(0,(D.system.phone?t.length:T.DISPLAY_TEXT_MAX_LENGTH)));if(!D.system.phone&&t.length>T.DISPLAY_TEXT_MAX_LENGTH){s.text('...');}s.close("div");};
var p=c.extend("sap.m.internal.TabStripSelectList",{
metadata:{library:"sap.m"},
renderer:o
});
return k;});
sap.ui.predefine('sap/m/TabStripItem',["./library","sap/ui/core/Item","sap/ui/base/ManagedObject","sap/ui/core/IconPool","./AccButton"],function(l,I,M,a,A){"use strict";var B=l.ButtonType;var b=l.ImageHelper;
var T=I.extend("sap.m.TabStripItem",{metadata:{library:"sap.m",properties:{additionalText:{type:"string",group:"Misc",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},iconTooltip:{type:"string",group:"Accessibility",defaultValue:null},modified:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_closeButton:{type:"sap.m.Button",multiple:false},_image:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{itemClosePressed:{allowPreventDefault:true,parameters:{item:{type:"sap.m.TabStripItem"}}},itemPropertyChanged:{parameters:{itemChanged:{type:'sap.m.TabStripItem'},propertyKey:{type:"string"},propertyValue:{type:"any"}}}}}});
T.DISPLAY_TEXT_MAX_LENGTH=25;T.CSS_CLASS="sapMTabStripItem";T.CSS_CLASS_LABEL="sapMTabStripItemLabel";T.CSS_CLASS_MODIFIED_SYMBOL="sapMTabStripItemModifiedSymbol";T.CSS_CLASS_TEXT="sapMTabStripItemAddText";T.CSS_CLASS_BUTTON="sapMTabStripItemButton";T.CSS_CLASS_MODIFIED="sapMTabStripItemModified";T.CSS_CLASS_SELECTED="sapMTabStripItemSelected";T.CSS_CLASS_STATE="sapMTabStripSelectListItemModified";T.CSS_CLASS_STATE_INVISIBLE="sapMTabStripSelectListItemModifiedInvisible";T.CSS_CLASS_CLOSE_BUTTON='sapMTabStripSelectListItemCloseBtn';T.CSS_CLASS_CLOSE_BUTTON_INVISIBLE='sapMTabStripSelectListItemCloseBtnInvisible';
T.prototype.init=function(){var o=new A({type:B.Transparent,icon:a.getIconURI("decline"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("TABSTRIP_ITEM_CLOSE_BTN"),tabIndex:"-1",ariaHidden:"true"}).addStyleClass(T.CSS_CLASS_CLOSE_BUTTON);this.setAggregation('_closeButton',o);};
T.prototype.setProperty=function(n,v,s){if(n==='modified'){s=true;}M.prototype.setProperty.call(this,n,v,s);if(this.getParent()&&this.getParent().changeItemState){this.getParent().changeItemState(this.getId(),v);}this.fireItemPropertyChanged({itemChanged:this,propertyKey:n,propertyValue:v});return this;};
T.prototype.setIcon=function(i){return this._setIcon(i);};
T.prototype._setIcon=function(i,s){var p,c=['sapMTabContIcon'],o=this.getAggregation("_image"),d=this.getId()+"-img";if(!i){this.setProperty("icon",i,s);if(o){this.destroyAggregation("_image");}return this;}if(this.getIcon()!==i){this.setProperty("icon",i,s);p={src:i,id:d,tooltip:this.getIconTooltip()};o=b.getImageControl(d,o,undefined,p,c);this.setAggregation("_image",o,s);}return this;};
T.prototype._getImage=function(){return this.getAggregation("_image");};
return T;});
sap.ui.predefine('sap/m/TabStripRenderer',['./TabStripItem','sap/ui/Device','sap/ui/core/InvisibleText',"sap/ui/core/Element"],function(T,D,I,E){"use strict";var a={apiVersion:2};a.LEFT_OVERRFLOW_BTN_CLASS_NAME="sapMTSLeftOverflowButtons";a.RIGHT_OVERRFLOW_BTN_CLASS_NAME="sapMTSRightOverflowButtons";
a.render=function(r,c){if(!c.getVisible()){return;}this.beginTabStrip(r,c);if(!D.system.phone){r.openStart("div",c.getId()+"-leftOverflowButtons");r.class(this.LEFT_OVERRFLOW_BTN_CLASS_NAME);r.openEnd();if(c.getAggregation("_leftArrowButton")){this.renderLeftOverflowButtons(r,c,false);}r.close("div");}this.beginTabsContainer(r,c);this.renderItems(r,c);this.endTabsContainer(r);if(!D.system.phone){r.openStart("div",c.getId()+"-rightOverflowButtons");r.class(this.RIGHT_OVERRFLOW_BTN_CLASS_NAME);r.openEnd();if(c.getAggregation("_rightArrowButton")){this.renderRightOverflowButtons(r,c,false);}r.close("div");}this.renderTouchArea(r,c);this.endTabStrip(r);};
a.renderItems=function(r,c){var i=c.getItems(),s=c.getSelectedItem(),d,S;if(D.system.phone){S=E.registry.get(s);S&&this.renderItem(r,c,S,true);}else{i.forEach(function(o){d=s&&s===o.getId();this.renderItem(r,c,o,d);},this);}};
a.renderItem=function(r,c,i,s){var t=i.getTooltip(),d=g(i),m=i.getModified();r.openStart("div",i);r.class(T.CSS_CLASS);if(m){r.class(T.CSS_CLASS_MODIFIED);}if(s){r.class(T.CSS_CLASS_SELECTED);}if(t){r.attr("title",t);}r.accessibilityState(i,b(i,c,sap.ui.getCore().byId(c.getSelectedItem())));r.openEnd();if(i.getIcon()){r.renderControl(i._getImage());}r.openStart("div");r.class("sapMTSTexts");r.openEnd();r.openStart("div",d+"-addText");r.class(T.CSS_CLASS_TEXT);r.openEnd();this.renderItemText(r,i.getAdditionalText());r.close("div");r.openStart("div",d+"-text");r.class(T.CSS_CLASS_LABEL);r.openEnd();this.renderItemText(r,i.getText());if(m){r.openStart("span",d+"-symbol");r.class(T.CSS_CLASS_MODIFIED_SYMBOL);r.attr("role","presentation");r.attr("aria-hidden","true");r.openEnd();r.close("span");}r.close("div");r.close("div");this.renderItemCloseButton(r,i);r.close("div");};
a.renderItemText=function(r,i){if(i.length>T.DISPLAY_TEXT_MAX_LENGTH){r.text(i.slice(0,T.DISPLAY_TEXT_MAX_LENGTH));r.text('...');}else{r.text(i);}};
a.renderItemCloseButton=function(r,i){r.openStart("div");r.class("sapMTSItemCloseBtnCnt");r.openEnd();r.renderControl(i.getAggregation("_closeButton"));r.close("div");};
a.beginTabStrip=function(r,c){r.openStart("div");r.class("sapMTabStripContainer");r.openEnd();r.openStart("div",c);r.class("sapMTabStrip");r.class("sapContrastPlus");r.openEnd();};
a.endTabStrip=function(r){r.close("div");r.close("div");};
a.beginTabsContainer=function(r,c){r.openStart("div",c.getId()+"-tabsContainer");r.class("sapMTSTabsContainer");r.openEnd();r.openStart("div",c.getId()+"-tabs");r.class("sapMTSTabs");r.accessibilityState(c,{role:"tablist"});r.openEnd();};
a.endTabsContainer=function(r){r.close("div");r.close("div");};
a.renderLeftOverflowButtons=function(r,c,f){r.renderControl(c.getAggregation("_leftArrowButton"));if(f){r.flush(c.$("leftOverflowButtons")[0]);}};
a.renderRightOverflowButtons=function(r,c,f){r.renderControl(c.getAggregation("_rightArrowButton"));if(f){r.flush(c.$("rightOverflowButtons")[0]);}};
a.renderTouchArea=function(r,c){r.openStart("div",c.getId()+"-touchArea");r.class("sapMTSTouchArea");r.openEnd();r.renderControl(c.getAggregation('_select'));r.renderControl(c.getAddButton());r.close("div");};
function g(i){return i.getId()+"-label";}
function b(i,t,s){var c=t.getItems(),d=c.indexOf(i),o=t.getParent(),A={role:"tab"},e=I.getStaticId("sap.m","TABSTRIP_ITEM_CLOSABLE")+" ";e+=I.getStaticId("sap.m",i.getModified()?"TABSTRIP_ITEM_MODIFIED":"TABSTRIP_ITEM_NOT_MODIFIED");A["describedby"]=e;A["posinset"]=d+1;A["setsize"]=c.length;A["labelledby"]=g(i)+"-addText "+g(i)+"-text";if(o&&o.getRenderer&&o.getRenderer().getContentDomId){A["controls"]=o.getRenderer().getContentDomId(o);}if(s&&s.getId()===i.getId()){A["selected"]="true";}else{A["selected"]="false";}return A;}
return a;},true);
sap.ui.predefine('sap/m/Table',["sap/ui/Device","./library","./ListBase","./ListItemBase","./CheckBox","./TableRenderer","sap/base/Log","sap/ui/core/ResizeHandler","sap/ui/core/util/PasteHelper","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/m/ListBaseRenderer","sap/ui/dom/jquery/Selectors"],function(D,l,L,a,C,T,b,R,P,K,q,c){"use strict";var d=l.ListKeyboardMode;var e=l.ListGrowingDirection;var B=l.BackgroundDesign;var f=l.PopinLayout;var S=l.ScreenSizes;
var g=L.extend("sap.m.Table",{metadata:{library:"sap.m",properties:{backgroundDesign:{type:"sap.m.BackgroundDesign",group:"Appearance",defaultValue:B.Translucent},fixedLayout:{type:"boolean",group:"Behavior",defaultValue:true},showOverlay:{type:"boolean",group:"Appearance",defaultValue:false},alternateRowColors:{type:"boolean",group:"Appearance",defaultValue:false},popinLayout:{type:"sap.m.PopinLayout",group:"Appearance",defaultValue:f.Block},contextualWidth:{type:"string",group:"Behavior",defaultValue:"Inherit"},autoPopinMode:{type:"boolean",group:"Behavior",defaultValue:false},hiddenInPopin:{type:"sap.ui.core.Priority[]",group:"Behavior"}},aggregations:{columns:{type:"sap.m.Column",multiple:true,singularName:"column",dnd:{draggable:true,droppable:true,layout:"Horizontal"}}},events:{beforeOpenContextMenu:{allowPreventDefault:true,parameters:{listItem:{type:"sap.m.ColumnListItem"},column:{type:"sap.m.Column"}}},paste:{allowPreventDefault:true,parameters:{data:{type:"string[][]"}}},popinChanged:{parameters:{hasPopin:{type:"boolean"},hiddenInPopin:{type:"sap.m.Column[]"}}}},designtime:"sap/m/designtime/Table.designtime"}});
g.prototype.sNavItemClass="sapMListTblRow";
g.prototype.init=function(){this._iItemNeedsColumn=0;L.prototype.init.call(this);};
g.prototype.setContextualWidth=function(w){var o=this.getContextualWidth();if(w==o){return this;}if(typeof w==="number"){this._sContextualWidth=w+"px";this._sContextualWidth=this._sContextualWidth.toLowerCase();}else{var h=w.toLowerCase(),W=S[h];if(W){this._sContextualWidth=W+"px";}else{this._sContextualWidth=w;}}var i=this._validateContextualWidth(this._sContextualWidth);this._iLastContextualWidth=o;if(i){this.setProperty("contextualWidth",w,true);}else{return this;}if(this._iLastContextualWidth.toLowerCase()==="auto"){this._deregisterResizeHandler();}if(this._sContextualWidth.toLowerCase()==="auto"){this._registerResizeHandler();this._applyContextualWidth(this.$().width());}else{this._applyContextualWidth(this._sContextualWidth);}return this;};
g.prototype._validateContextualWidth=function(w){if(!w){return;}if(typeof w!="string"){throw new Error('expected string for property "contextualWidth" of '+this);}if(w.toLowerCase()==="auto"||w.toLowerCase()==="inherit"){return true;}if(!/^\d+(\.\d+)?(px)$/i.test(w)){throw new Error('invalid CSS size("px", "Auto", "auto", Inherit", "inherit" required) or sap.m.ScreenSize enumeration for property "contextualWidth" of '+this);}return true;};
g.prototype._applyContextualWidth=function(w){w=parseFloat(w)||0;if(w){this._applyContextualSettings({contextualWidth:w});}};
g.prototype._onResize=function(p){this._applyContextualWidth(p.size.width);};
g.prototype._registerResizeHandler=function(){if(!this._iResizeHandlerId){var t=this;window.requestAnimationFrame(function(){t._iResizeHandlerId=R.register(t,t._onResize.bind(t));});}};
g.prototype._deregisterResizeHandler=function(){if(this._iResizeHandlerId){R.deregister(this._iResizeHandlerId);this._iResizeHandlerId=null;}};
g.prototype.onBeforeRendering=function(){L.prototype.onBeforeRendering.call(this);if(this.getFixedLayout()){this._bHasDynamicWidthCol=this._hasDynamicWidthColumn();}if(this.getAutoPopinMode()){this._configureAutoPopin();this._bAutoPopinMode=true;}else{this._bAutoPopinMode=false;}this._applyContextualWidth(this._sContextualWidth);this._ensureColumnsMedia();this._notifyColumns("ItemsRemoved");};
g.prototype._hasDynamicWidthColumn=function(o,s){if(!this.bRenderDummyColumn||!this.getFixedLayout()){return true;}return this.getColumns().some(function(h){if(h.getVisible()){var w=o&&o.getId()===h.getId()?s:h.getWidth();return!w||w==="auto";}});};
g.prototype._ensureColumnsMedia=function(){this.getColumns().forEach(function(o){if(o._bShouldAddMedia){o._addMedia();}});};
g.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.call(this);this.updateSelectAllCheckbox();if(this.getFixedLayout()){this._forceStyleChange();}this._renderOverlay();if(this._bPopinChanged){setTimeout(function(){this._firePopinChangedEvent();}.bind(this),0);this._bPopinChanged=false;}};
g.prototype._renderOverlay=function(){var $=this.$(),h=$.find(".sapMTableOverlay"),s=this.getShowOverlay();if(s&&h.length===0){h=q("<div>").addClass("sapUiOverlay sapMTableOverlay").css("z-index","1");$.append(h);}else if(!s){h.remove();}};
g.prototype.setShowOverlay=function(s){this.setProperty("showOverlay",s,true);this._renderOverlay();return this;};
g.prototype.exit=function(){L.prototype.exit.call(this);if(this._selectAllCheckBox){this._selectAllCheckBox.destroy();this._selectAllCheckBox=null;}};
g.prototype.destroyItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.destroyItems.apply(this,arguments);};
g.prototype.removeAllItems=function(){this._notifyColumns("ItemsRemoved");return L.prototype.removeAllItems.apply(this,arguments);};
g.prototype.removeSelections=function(){L.prototype.removeSelections.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
g.prototype.selectAll=function(){L.prototype.selectAll.apply(this,arguments);this.updateSelectAllCheckbox();return this;};
g.prototype.getColumns=function(s){var h=this.getAggregation("columns",[]);if(s){h.sort(function(i,j){return i.getOrder()-j.getOrder();});}return h;};
g.prototype.onAfterPageLoaded=function(){this.updateSelectAllCheckbox();if(this.getAlternateRowColors()){var $=this.$("tblBody").removeClass();$.addClass(this._getAlternateRowColorsClass());}L.prototype.onAfterPageLoaded.apply(this,arguments);};
g.prototype.shouldRenderItems=function(){return this.getColumns().some(function(o){return o.getVisible();});};
g.prototype.onItemTypeColumnChange=function(i,n){this._iItemNeedsColumn+=(n?1:-1);if(this._iItemNeedsColumn==1&&n){this._setTypeColumnVisibility(true);}else if(this._iItemNeedsColumn==0){this._setTypeColumnVisibility(false);}};
g.prototype.onItemSelectedChange=function(i,s){L.prototype.onItemSelectedChange.apply(this,arguments);setTimeout(function(){this.updateSelectAllCheckbox();}.bind(this),0);};
g.prototype.getTableDomRef=function(){return this.getDomRef("listUl");};
g.prototype.getItemsContainerDomRef=function(){return this.getDomRef("tblBody");};
g.prototype.setNavigationItems=function(i){var h=this.$("tblHeader");var F=this.$("tblFooter");var r=this.$("tblBody").children(".sapMLIB");var I=h.add(r).add(F).get();i.setItemDomRefs(I);if(i.getFocusedIndex()==-1){if(this.getGrowing()&&this.getGrowingDirection()==e.Upwards){i.setFocusedIndex(I.length-1);}else{i.setFocusedIndex(h[0]?1:0);}}};
g.prototype.checkGrowingFromScratch=function(){if(this.hasPopin()){return false;}return this.getColumns().some(function(o){return o.getVisible()&&o.getMergeDuplicates();});};
g.prototype.onColumnPress=function(o){this.bActiveHeaders&&this.fireEvent("columnPress",{column:o});};
g.prototype.onColumnResize=function(o){if(!this.hasPopin()&&!this._mutex){var h=this.getColumns().some(function(j){return j.isPopin();});if(!h){o.setDisplay(this.getTableDomRef(),!o.isHidden());setTimeout(function(){var H=this.getHiddenInPopin()||[];var j=H.some(function(I){return!!I;});if(j){this._firePopinChangedEvent();}}.bind(this),100);return;}}this._dirty=this._getMediaContainerWidth()||window.innerWidth;if(!this._mutex){var i=this._getMediaContainerWidth()||window.innerWidth;this._mutex=true;this.rerender();setTimeout(function(){if(this._dirty!=i){this._dirty=0;this.rerender();}this._mutex=false;}.bind(this),200);}};
g.prototype.setTableHeaderVisibility=function(h){if(!this.getDomRef()){return;}if(!this.shouldRenderItems()){return this.invalidate();}var $=this.$("tblHeader"),H=!$.hasClass("sapMListTblHeaderNone"),v=$.find(".sapMListTblCell:visible"),i=v.eq(0);if(v.length==1){i.width("");}else{v.each(function(){this.style.width=this.getAttribute("data-sap-width")||"";});}this._colCount=v.length+3+!!c.ModeOrder[this.getMode()];this.$("tblBody").find(".sapMGHLICell").attr("colspan",this.getColSpan());this.$("nodata-text").attr("colspan",this.getColCount());if(this.getFixedLayout()){this._forceStyleChange();}if(!h&&H){$[0].className="sapMListTblRow sapMLIBFocusable sapMListTblHeader";this._headerHidden=false;}else if(h&&!H&&!v.length){$[0].className="sapMListTblHeaderNone";this._headerHidden=true;}};
g.prototype._forceStyleChange=function(){if(D.browser.msie||D.browser.edge){var t=this.getTableDomRef().style;t.listStyleType="circle";window.setTimeout(function(){t.listStyleType="none";},0);}};
g.prototype._setTypeColumnVisibility=function(v){q(this.getTableDomRef()).toggleClass("sapMListTblHasNav",v);if(this.getAutoPopinMode()){this._configureAutoPopin(true);}};
g.prototype._notifyColumns=function(A,p,v){this.getColumns().forEach(function(o){o["on"+A](p,v);});};
g.prototype._getSelectAllCheckbox=function(){if(this.bPreventMassSelection){return;}if(!this._selectAllCheckBox){this._selectAllCheckBox=new C({id:this.getId("sa"),activeHandling:false}).addStyleClass("sapMLIBSelectM").setParent(this,null,true).attachSelect(function(){if(this._selectAllCheckBox.getSelected()){this.selectAll(true);}else{this.removeSelections(false,true);}},this).setTabIndex(-1);}this._selectAllCheckBox.getEnabled=function(){return true;};return this._selectAllCheckBox;};
g.prototype.updateSelectAllCheckbox=function(){if(this._selectAllCheckBox&&this.getMode()==="MultiSelect"){var i=this.getItems(),s=this.getSelectedItems().length,h=i.filter(function(I){return I.isSelectable();}).length;this._selectAllCheckBox.setSelected(i.length>0&&s==h);}};
g.prototype.enhanceAccessibilityState=function(E,A){if(E==this._selectAllCheckBox){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m");A.label=o.getText("TABLE_CHECKBOX_SELECT_ALL");}};
g.prototype.getColSpan=function(){var i=this.shouldRenderDummyColumn()?3:2;return(this._colCount||1)-i;};
g.prototype.getColCount=function(){return(this._colCount||0);};
g.prototype.shouldRenderDummyColumn=function(){return this.bRenderDummyColumn&&this.getFixedLayout()&&!this._bHasDynamicWidthCol;};
g.prototype.hasPopin=function(){return!!this._hasPopin;};
g.prototype.isHeaderRowEvent=function(E){var h=this.$("tblHeader");return!!q(E.target).closest(h,this.getTableDomRef()).length;};
g.prototype.isFooterRowEvent=function(E){var F=this.$("tblFooter");return!!q(E.target).closest(F,this.getTableDomRef()).length;};
g.prototype.getAccessibilityType=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TABLE");};
g.prototype._setHeaderAnnouncement=function(){var o=sap.ui.getCore().getLibraryResourceBundle("sap.m"),A=o.getText("ACC_CTR_TYPE_HEADER_ROW")+" ";if(this.isAllSelectableSelected()){A+=o.getText("LIST_ALL_SELECTED");}this.getColumns(true).forEach(function(h,i){if(!h.getVisible()){return;}var H=h.getHeader();if(H&&H.getVisible()){A+=a.getAccessibilityText(H)+" ";}});this.updateInvisibleText(A);};
g.prototype._setFooterAnnouncement=function(){var A=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_FOOTER_ROW")+" ";this.getColumns(true).forEach(function(o,i){if(!o.getVisible()){return;}var F=o.getFooter();if(F&&F.getVisible()){var h=o.getHeader();if(h&&h.getVisible()){A+=a.getAccessibilityText(h)+" ";}A+=a.getAccessibilityText(F)+" ";}});this.updateInvisibleText(A);};
g.prototype.onsapspace=function(E){if(E.isMarked()){return;}if(E.target.id==this.getId("tblHeader")){E.preventDefault();if(this._selectAllCheckBox){this._selectAllCheckBox.setSelected(!this._selectAllCheckBox.getSelected()).fireSelect();E.setMarked();}}};
g.prototype.onsaptabnext=function(E){if(E.isMarked()||this.getKeyboardMode()==d.Edit){return;}var r=q();if(E.target.id==this.getId("nodata")){r=this.$("nodata");}else if(this.isHeaderRowEvent(E)){r=this.$("tblHeader");}else if(this.isFooterRowEvent(E)){r=this.$("tblFooter");}var o=r.find(":sapTabbable").get(-1)||r[0];if(E.target===o){this.forwardTab(true);E.setMarked();}};
g.prototype.onsaptabprevious=function(E){if(E.isMarked()||this.getKeyboardMode()==d.Edit){return;}var t=E.target.id;if(t==this.getId("nodata")||t==this.getId("tblHeader")||t==this.getId("tblFooter")){this.forwardTab(false);}else if(t==this.getId("trigger")){this.focusPrevious();E.preventDefault();}};
g.prototype.onfocusin=function(E){var t=E.target;if(t.id===this.getId("tblHeader")){this._setHeaderAnnouncement();}else if(t.id===this.getId("tblFooter")){this._setFooterAnnouncement();}if(this._bThemeChanged){this._bThemeChanged=false;this._forceStyleChange();}L.prototype.onfocusin.call(this,E);};
g.prototype.onThemeChanged=function(){L.prototype.onThemeChanged.call(this);this._bThemeChanged=true;};
g.prototype._getAlternateRowColorsClass=function(){if(this.isGrouped()){return"sapMListTblAlternateRowColorsGrouped";}if(this.hasPopin()){return"sapMListTblAlternateRowColorsPopin";}return"sapMListTblAlternateRowColors";};
g.prototype.onpaste=function(E){if(E.isMarked()||(/^(input|textarea)$/i.test(E.target.tagName))){return;}var h=P.getPastedDataAs2DArray(E.originalEvent);if(!h||h.length===0||h[0].length===0){return;}this.firePaste({data:h});};
g.prototype.onkeydown=function(E){L.prototype.onkeydown.apply(this,arguments);if(D.browser.msie&&E.ctrlKey&&E.which===K.V){this.onpaste(E);}};
g.prototype.ondragenter=function(E){var o=E.dragSession;if(!o||!o.getDropControl()||!o.getDropControl().isA("sap.m.Column")){return;}o.setIndicatorConfig({height:this.getTableDomRef().clientHeight});};
g.prototype.onColumnWidthChanged=function(o,w){this._bHasDynamicWidthCol=this._hasDynamicWidthColumn(o,w);};
g.prototype.onColumnRecalculateAutoPopin=function(o,r){if(this.getAutoPopinMode()){this._configureAutoPopin(r);}};
g.prototype._requireAutoPopinRecalculation=function(v){var A=this.getAutoPopinMode();if(this._bAutoPopinMode!==A){this._bAutoPopinMode=A;return true;}if(v.length!==this._aVisibleColumns.length){return true;}for(var i=0;i<v.length;i++){if(v[i]!==this._aVisibleColumns[i]){return true;}}return this.shouldRenderDummyColumn();};
g.prototype._configureAutoPopin=function(r){var v=this.getColumns(true).filter(function(o){return o.getVisible();});if(!v.length){return;}if(!this._aVisibleColumns||!r&&this._requireAutoPopinRecalculation(v)){this._aVisibleColumns=v;if(!r){r=true;}}if(r){var I=this.getItems();var h=[];var m=[];var j=[];for(var i=0;i<v.length;i++){var s=v[i].getImportance();if(s==="Medium"||s==="None"){m.push(v[i]);}else if(s==="High"){h.push(v[i]);}else{j.push(v[i]);}}var A=this._getInitialAccumulatedWidth(I)||6.5;A+=this.shouldRenderDummyColumn()?1:0;A=g._updateAccumulatedWidth(h,h.length>0,A);A=g._updateAccumulatedWidth(m,h.length===0&&m.length>0,A);g._updateAccumulatedWidth(j,h.length===0&&m.length===0&&j.length>0,A);}};
g.prototype._getInitialAccumulatedWidth=function(i){var I=i.find(function(k){return k.getHighlight()!=="None";});var h=I?0.375:0;var m=this.getMode(),s=m==="MultiSelect"||m==="Delete"||m==="SingleSelect"||m==="SingleSelectLeft"?3:0;var o=i.find(function(k){var t=k.getType();return t==="Detail"||t==="DetailAndActive"||k.getType()==="Navigation";});var A=o?3:0;var j=i.find(function(k){return k.getNavigated();});var n=j?0.1875:0;return h+s+A+n;};
g._updateAccumulatedWidth=function(h,s,A){var j=A;for(var i=0;i<h.length;i++){h[i].setDemandPopin(!(s&&i===0));var w=h[i].getWidth();var u=w.replace(/[^a-z]/ig,"");var k=parseFloat(l.BaseFontSize)||16;if(u===""||u==="auto"){j=j+h[i].getAutoPopinWidth();}else if(u==="px"){j=j+parseFloat((parseFloat(w).toFixed(2)/k).toFixed(2));}else if(u==="em"||u==="rem"){j=j+parseFloat(w);}if(h[i].getDemandPopin()){h[i].setMinScreenWidth(j+"rem");}else{h[i].setMinScreenWidth();}}return j;};
g.prototype._getHiddenInPopin=function(){var v=this.getColumns().filter(function(o){return o.getVisible()&&o.getDemandPopin();});var h=v.filter(function(V){return V._media&&!V._media.matches&&!V.isPopin();});this._iHiddenPopinColumns=h.length;return h;};
g.prototype._firePopinChangedEvent=function(){this.fireEvent("popinChanged",{hasPopin:this.hasPopin(),hiddenInPopin:this._getHiddenInPopin()});};
return g;});
sap.ui.predefine('sap/m/TablePersoController',['./TablePersoDialog','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectRegistry',"sap/ui/core/syncStyleClass","sap/base/Log","sap/ui/thirdparty/jquery"],function(T,M,d,s,L,q){"use strict";
var e=M.extend("sap.m.TablePersoController",{
constructor:function(i,S){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",since:"1.22"},"componentName":{type:"string",since:"1.20.2"},"hasGrouping":{type:"boolean",defaultValue:false,since:"1.22"},"showSelectAll":{type:"boolean",defaultValue:true,since:"1.22"},"showResetAll":{type:"boolean",defaultValue:true,since:"1.22"}},aggregations:{"_tablePersoDialog":{type:"sap.m.TablePersoDialog",multiple:false,visibility:"hidden"},"persoService":{type:"Object",multiple:false}},associations:{"table":{type:"sap.m.Table",multiple:false},"tables":{type:"sap.m.Table",multiple:true}},events:{personalizationsDone:{}},library:"sap.m"}
});
d.apply(e,{onDuplicate:function(i,o,n){if(o._sapui_candidateForDestroy){L.debug("destroying dangling template "+o+" when creating new object with same ID");o.destroy();}else{var m="adding TablePersoController with duplicate id '"+i+"'";if(sap.ui.getCore().getConfiguration().getNoDuplicateIds()){L.error(m);throw new Error("Error: "+m);}else{L.warning(m);}}}});
e.prototype.init=function(){this._schemaProperty="_persoSchemaVersion";this._schemaVersion="1.0";this._oPersonalizations=null;this._mDelegateMap={};this._mTablePersMap={};this._mInitialTableStateMap={};this._triggersPersDoneEvent=true;};
e.prototype.exit=function(){this._callFunctionForAllTables(q.proxy(function(t){t.removeDelegate(this._mDelegateMap[t]);t._hasTablePersoController=function(){return false;};},this));delete this._mDelegateMap;delete this._mTablePersMap;delete this._mInitialTableStateMap;};
e.prototype.activate=function(){this._callFunctionForAllTables(this._rememberInitialTableStates);this._callFunctionForAllTables(this._createAndAddDelegateForTable);return this;};
e.prototype.getTablePersoDialog=function(){return this.getAggregation("_tablePersoDialog");};
e.prototype.applyPersonalizations=function(t){var r=this.getPersoService().getPersData();var a=this;r.done(function(p){if(p){a._adjustTable(p,t);}});r.fail(function(){L.error("Problem reading persisted personalization data.");});};
e.prototype._createAndAddDelegateForTable=function(t){if(!this._mDelegateMap[t]){var o={onBeforeRendering:function(){this.applyPersonalizations(t);if(!this.getAggregation("_tablePersoDialog")){this._createTablePersoDialog(t);}}.bind(this)};t.addDelegate(o);o.onBeforeRendering();this._mDelegateMap[t]=o;var a=this;t._hasTablePersoController=function(){return!!a._mDelegateMap[this];};}};
e.prototype._createTablePersoDialog=function(t){var o=new T(t.getId()+"-PersoDialog",{persoDialogFor:t,persoMap:this._getPersoColumnMap(t),columnInfoCallback:this._tableColumnInfo.bind(this),initialColumnState:this._mInitialTableStateMap[t],contentWidth:this.getContentWidth(),contentHeight:this.getContentHeight(),hasGrouping:this.getHasGrouping(),showSelectAll:this.getShowSelectAll(),showResetAll:this.getShowResetAll()});this.setAggregation("_tablePersoDialog",o);o.attachConfirm(q.proxy(function(){this._oPersonalizations=o.retrievePersonalizations();this._callFunctionForAllTables(this._personalizeTable);this.savePersonalizations();this.firePersonalizationsDone();},this));};
e.prototype._adjustTable=function(D,t){if(D&&D.hasOwnProperty(this._schemaProperty)&&D[this._schemaProperty]===this._schemaVersion){this._oPersonalizations=D;if(t){this._personalizeTable(t);}else{this._callFunctionForAllTables(this._personalizeTable);}}};
e.prototype._personalizeTable=function(t){var p=this._getPersoColumnMap(t);if(!!p&&!!this._oPersonalizations){var D=false;for(var c=0,a=this._oPersonalizations.aColumns.length;c<a;c++){var n=this._oPersonalizations.aColumns[c];var o=p[n.id];if(!o){o=sap.ui.getCore().byId(n.id);if(o){L.info("Migrating personalization persistence id of column "+n.id);n.id=p[o];D=true;}}if(o){o.setVisible(n.visible);o.setOrder(n.order);}else{L.warning("Personalization could not be applied to column "+n.id+" - not found!");}}if(D){this.savePersonalizations();}t.invalidate();}};
e.prototype.savePersonalizations=function(){var b=this._oPersonalizations;b[this._schemaProperty]=this._schemaVersion;var w=this.getPersoService().setPersData(b);w.done(function(){});w.fail(function(){L.error("Problem persisting personalization data.");});};
e.prototype.refresh=function(){var r=function(o){this._mTablePersMap={};o.invalidate();};this._callFunctionForAllTables(r);var t=this.getAggregation("_tablePersoDialog");if(t){t.setPersoMap(this._getPersoColumnMap(sap.ui.getCore().byId(t.getPersoDialogFor())));}};
e.prototype.openDialog=function(){var t=this.getAggregation("_tablePersoDialog");if(t){s("sapUiSizeCompact",t.getPersoDialogFor(),t._oDialog);t.open();}else{L.warning("sap.m.TablePersoController: trying to open TablePersoDialog before TablePersoService has been activated.");}};
e.prototype.setContentWidth=function(w){this.setProperty("contentWidth",w,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setContentWidth(w);}return this;};
e.prototype.setContentHeight=function(h){this.setProperty("contentHeight",h,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setContentHeight(h);}return this;};
e.prototype.setHasGrouping=function(h){this.setProperty("hasGrouping",h,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setHasGrouping(h);}return this;};
e.prototype.setShowSelectAll=function(S){this.setProperty("showSelectAll",S,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setShowSelectAll(S);}return this;};
e.prototype.setShowResetAll=function(S){this.setProperty("showResetAll",S,true);var t=this.getAggregation("_tablePersoDialog");if(t){t.setShowResetAll(S);}return this;};
e.prototype.setComponentName=function(c){this.setProperty("componentName",c,true);return this;};
e.prototype._getMyComponentName=function(c){if(this.getComponentName()){return this.getComponentName();}if(c===null){return"empty_component";}var m=c.getMetadata();if(c.getMetadata().getStereotype()==="component"){return m._sComponentName;}return this._getMyComponentName(c.getParent());};
e.prototype._callFunctionForAllTables=function(t){var o=sap.ui.getCore().byId(this.getAssociation("table"));if(o){t.call(this,o);}var a=this.getAssociation("tables");if(a){for(var i=0,l=this.getAssociation("tables").length;i<l;i++){o=sap.ui.getCore().byId(this.getAssociation("tables")[i]);t.call(this,o);}}};
e.prototype._isStatic=function(i){var u=sap.ui.getCore().getConfiguration().getUIDPrefix();var r=new RegExp("^"+u);return!r.test(i);};
e.prototype._getPersoColumnMap=function(t){var r=this._mTablePersMap[t];if(!r){r={};var E=function(i){var l=i.lastIndexOf("-");return i.substring(l+1);};var a=E.call(this,t.getId());if(!this._isStatic(a)){L.error("Table "+t.getId()+" must have a static id suffix. Otherwise personalization can not be persisted.");r=null;return null;}var n;var c=this._getMyComponentName(t);var b=this;t.getColumns().forEach(function(N){if(r){var f=N.getId();var g=E.call(b,f);if(!b._isStatic(g)){L.error("Suffix "+g+" of table column "+f+" must be static. Otherwise personalization can not be persisted for its table.");r=null;return null;}n=c+"-"+a+"-"+g;r[N]=n;r[n]=N;}});this._mTablePersMap[t]=r;}return r;};
e.prototype._rememberInitialTableStates=function(t){this._mInitialTableStateMap[t]=this._tableColumnInfo(t,this._getPersoColumnMap(t));};
e.prototype._tableColumnInfo=function(t,p){if(p){var c=t.getColumns(),C=[],P=this.getPersoService();c.forEach(function(o){var a=null;if(P.getCaption){a=P.getCaption(o);}var g=null;if(P.getGroup){g=P.getGroup(o);}if(!a){var b=o.getHeader();if(b.getText&&b.getText()){a=b.getText();}else if(b.getTitle&&b.getTitle()){a=b.getTitle();}if(!a){a=o.getId();L.warning("Please 'getCaption' callback implentation in your TablePersoProvider for column "+o+". Table personalization uses column id as fallback value.");}}C.push({text:a,order:o.getOrder(),visible:o.getVisible(),id:p[o],group:g});});C.sort(function(a,b){return a.order-b.order;});return C;}return null;};
return e;});
sap.ui.predefine('sap/m/TablePersoDialog',['./Text','./Title','./Label','./Column','./Button','./Dialog','./ColumnListItem','./Table','./Toolbar','./Bar','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectRegistry','sap/base/Log','sap/m/library','sap/ui/Device','sap/ui/model/Sorter','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/json/JSONModel','sap/m/CheckBox','sap/m/SearchField','sap/m/ScrollContainer',"sap/ui/thirdparty/jquery"],function(T,a,L,C,B,D,b,c,d,e,M,f,g,l,h,S,F,i,J,j,k,m,q){"use strict";var n=l.ButtonType;var o=l.ListMode;
var p=M.extend("sap.m.TablePersoDialog",{
constructor:function(I,s){M.apply(this,arguments);},
metadata:{properties:{"contentWidth":{type:"sap.ui.core.CSSSize"},"contentHeight":{type:"sap.ui.core.CSSSize",since:"1.22"},"persoMap":{type:"object"},"columnInfoCallback":{type:"object",since:"1.22"},"initialColumnState":{type:"object",since:"1.22"},"hasGrouping":{type:"boolean",since:"1.22"},"showSelectAll":{type:"boolean",since:"1.22"},"showResetAll":{type:"boolean",since:"1.22"}},aggregations:{"persoService":{type:"Object",multiple:false,deprecated:true}},associations:{"persoDialogFor":"sap.m.Table"},events:{confirm:{},cancel:{}},library:"sap.m"}
});
f.apply(p,{onDuplicate:function(I,r,s){if(r._sapui_candidateForDestroy){g.debug("destroying dangling template "+r+" when creating new object with same ID");r.destroy();}else{var t="adding TablePersoDialog with duplicate id '"+I+"'";if(sap.ui.getCore().getConfiguration().getNoDuplicateIds()){g.error(t);throw new Error("Error: "+t);}else{g.warning(t);}}}});
p.prototype.init=function(){var t=this,r=0;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oP13nModel=new J();this._oP13nModel.setSizeLimit(Number.MAX_VALUE);this._oColumnItemTemplate=new b(this.getId()+"-cli",{selected:"{Personalization>visible}",type:"Active",cells:[new L({text:"{Personalization>text}"})],press:function(E){this._oSelectedItem=E.oSource;this._fnUpdateArrowButtons.call(this);}.bind(this)}).addStyleClass("sapMPersoDialogLI");this._oButtonUp=new B(this.getId()+"-buttonUp",{icon:"sap-icon://navigation-up-arrow",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_UP'),press:function(){t._moveItem(-1);}});this._oButtonDown=new B(this.getId()+"-buttonDown",{icon:"sap-icon://navigation-down-arrow",enabled:false,tooltip:t._oRb.getText('PERSODIALOG_DOWN'),press:function(){t._moveItem(1);}});this._fnUpdateArrowButtons=function(){if(this.getHasGrouping()){return;}var u=this._oInnerTable.getModel("Personalization").getProperty("/aColumns");var v,w;if(!this._oSelectedItem){v=false;w=false;}else{var I=u.indexOf(this._oSelectedItem.getBindingContext("Personalization").getObject());v=I>0?true:false;w=I<u.length-1?true:false;}this._updateMarkedItem();t._oButtonUp.setEnabled(v);t._oButtonDown.setEnabled(w);}.bind(this);this._fnAfterDialogOpen=function(){t._fnUpdateArrowButtons.call(t);};this._fnAfterScrollContainerRendering=function(){t._oScrollContainer.$().attr('tabindex','-1');};this._oInnerTable=new c(this.getId()+"-colTable",{noDataText:this._oRb.getText('PERSODIALOG_NO_DATA'),mode:o.MultiSelect,width:"100%",sticky:["ColumnHeaders"],columns:[new C({header:new T({text:this._oRb.getText("PERSODIALOG_SELECT_ALL")})})]});this._oSearchField=new k(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),u=(v?300:0);clearTimeout(r);if(u){r=setTimeout(function(){t._executeSearch();},u);}else{t._executeSearch();}},search:function(){t._executeSearch();}});this._resetAllButton=new B(this.getId()+"-buttonUndo",{text:this._oRb.getText("VIEWSETTINGS_RESET"),tooltip:this._oRb.getText('PERSODIALOG_UNDO'),press:function(){this._resetAll();}.bind(this)}).addStyleClass("sapMPersoDialogResetBtn");var H=new e({contentLeft:new a(this.getId()+"-Dialog-title",{text:this._oRb.getText("PERSODIALOG_COLUMNS_TITLE")}),contentRight:this._resetAllButton});var s=new d(this.getId()+"-toolbar",{active:false,content:[this._oSearchField,this._oButtonUp,this._oButtonDown]});this._oDialog=new D(this.getId()+"-Dialog",{title:this._oRb.getText("PERSODIALOG_COLUMNS_TITLE"),customHeader:H,draggable:true,resizable:true,stretch:h.system.phone,horizontalScrolling:false,verticalScrolling:true,initialFocus:(h.system.desktop?this._oInnerTable:null),content:[this._oInnerTable],subHeader:s,leftButton:new B(this.getId()+"-buttonOk",{text:this._oRb.getText("PERSODIALOG_OK"),press:function(){t._oDialog.close();t._oSelectedItem=null;t._oSearchField.setValue("");t.fireConfirm();},type:n.Emphasized}),rightButton:new B(this.getId()+"-buttonCancel",{text:this._oRb.getText("PERSODIALOG_CANCEL"),press:function(){t._oDialog.close();t._oSelectedItem=null;t._oSearchField.setValue("");t.fireCancel();}}),afterOpen:this._fnAfterDialogOpen}).addStyleClass("sapMPersoDialog");this._oDialog.setTitle=function(u){this.setProperty("title",u);this.getCustomHeader().getContentLeft()[0].setText(u);};};
p.prototype._updateMarkedItem=function(){if(!this._oSelectedItem){this._oSelectedItem=this._oInnerTable&&this._oInnerTable.getItems().length>0?this._oInnerTable.getItems()[0]:null;}if(this._oSelectedItem){this._oInnerTable.getItems().forEach(function(I){if(I.hasStyleClass("sapMPersoDialogItemSelected")){I.removeStyleClass("sapMPersoDialogItemSelected");}});this._oSelectedItem.addStyleClass("sapMPersoDialogItemSelected");}};
p.prototype.retrievePersonalizations=function(){return this._oP13nModel.getData();};
p.prototype.open=function(){var s=null;if(this.getHasGrouping()){s=[new S('group',false,true)];}this._readCurrentSettingsFromTable();this._oDialog.setModel(this._oP13nModel,"Personalization");this._oInnerTable.bindAggregation("items",{path:"Personalization>/aColumns",key:"text",sorter:s,template:this._oColumnItemTemplate});if(!this._oInnerTable.getSelectedItem()){var I=this._oInnerTable.getItems();if(this.getHasGrouping()){I=I.filter(function(r){return r.getMetadata().getName()!="sap.m.GroupHeaderListItem";});}if(I.length>0){this._sLastSelectedItemId=I[0].getBindingContext('Personalization').getProperty('id');}}this._fnUpdateArrowButtons.call(this);this._oDialog.open();};
p.prototype.setContentHeight=function(H){H=H?H:"28rem";this.setProperty("contentHeight",H,true);this._oDialog.setContentHeight(H);return this;};
p.prototype.setContentWidth=function(w){w=w?w:"25rem";this.setProperty("contentWidth",w,true);this._oDialog.setContentWidth(w);return this;};
p.prototype.exit=function(){this._oRb=null;this._oP13nModel=null;this._oSelectedItem=null;if(this._oColumnItemTemplate){this._oColumnItemTemplate.destroy();this._oColumnItemTemplate=null;}if(this._oInnerTable){this._oInnerTable.destroy();this._oInnerTable=null;}if(this._oSearchField){this._oSearchField.destroy();this._oSearchField=null;}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oButtonDown){this._oButtonDown.destroy();this._oButtonDown=null;}if(this._oButtonUp){this._oButtonUp.destroy();this._oButtonUp=null;}};
p.prototype._resetAll=function(){if(this.getInitialColumnState()){var I=q.extend(true,[],this.getInitialColumnState()),t=this;var r=this._oInnerTable.getSelectedItem();this._sLastSelectedItemId=r&&r.getBindingContext('Personalization')&&r.getBindingContext('Personalization').getProperty('id');if(this._mColumnCaptions){I.forEach(function(s){s.text=t._mColumnCaptions[s.id];});}this._oP13nModel.getData().aColumns=I;this._oP13nModel.updateBindings();sap.ui.getCore().applyChanges();}};
p.prototype._moveItem=function(r){var s=this._oSelectedItem;if(!s){return;}var I=this._oInnerTable.getItems();var t=this._oInnerTable.getModel("Personalization").getProperty("/aColumns");var O=t.indexOf(s.getBindingContext("Personalization").getObject());var N=O+r;N=t.indexOf(I[N].getBindingContext("Personalization").getObject());if(N==O){return;}t.splice(N,0,t.splice(O,1)[0]);t.forEach(function(u,v){u.order=v;});this._oInnerTable.getModel("Personalization").setProperty("/aColumns",t);this._oSelectedItem=I[N];this._scrollToItem(this._oSelectedItem);this._fnUpdateArrowButtons.call(this);};
p.prototype._scrollToItem=function(I){sap.ui.getCore().applyChanges();if(I.getDomRef()){var N=this._oInnerTable.getItems().indexOf(I);var r=I.getDomRef().getBoundingClientRect();var s=this._oDialog.getDomRef("cont").getBoundingClientRect();var v=s.top;var V=s.bottom;var E=r.top;if(E<v+18){this._oInnerTable.scrollToIndex(N);}else if(E>V-18){this._oInnerTable.scrollToIndex(N);}}};
p.prototype._readCurrentSettingsFromTable=function(){var t=sap.ui.getCore().byId(this.getPersoDialogFor()),r=this,s=this.getColumnInfoCallback().call(this,t,this.getPersoMap());this._oP13nModel.setData({aColumns:s});this._mColumnCaptions={};s.forEach(function(u){r._mColumnCaptions[u.id]=u.text;});};
p.prototype._executeSearch=function(){var v=this._oSearchField.getValue(),r=new F("text",i.Contains,v),s=this._oInnerTable.getBinding("items");s.filter([r]);this._fnUpdateArrowButtons.call(this);return this;};
p.prototype.setHasGrouping=function(H){this.setProperty("hasGrouping",H,true);var r=this._oDialog.getSubHeader();if(!H){if(r.getContent().length===1){r.addContent(this._oButtonDown);r.addContent(this._oButtonUp);}}else{r.removeContent(this._oButtonUp);r.removeContent(this._oButtonDown);}return this;};
p.prototype.setShowSelectAll=function(s){this.setProperty("showSelectAll",s,true);var t=s?this._oRb.getText("PERSODIALOG_SELECT_ALL"):this._oRb.getText("PERSODIALOG_COLUMNS_TITLE");this._oInnerTable.getColumns()[0].setHeader(new T({text:t}));this._oInnerTable.bPreventMassSelection=!s;return this;};
p.prototype.setShowResetAll=function(s){this.setProperty("showResetAll",s,true);this._resetAllButton.setVisible(s);return this;};
return p;});
sap.ui.predefine('sap/m/TablePersoProvider',['sap/ui/base/ManagedObject',"sap/base/Log"],function(M,L){"use strict";
var T=M.extend("sap.m.TablePersoProvider",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{"abstract":true,library:"sap.m"}
});
T.prototype.init=function(){L.warning("This is the abstract base class for a TablePersoProvider. Do not create instances of this class, but use a concrete sub class instead.");L.debug("TablePersoProvider init");};
T.prototype.getPersData=function(){L.debug("TablePersoProvider getPersData");};
T.prototype.setPersData=function(b){L.debug("TablePersoProvider setPersData");};
T.prototype.delPersData=function(){L.debug("TablePersoProvider delPersData");};
T.prototype.getCaption=function(c){return null;};
T.prototype.getGroup=function(c){return null;};
T.prototype.resetPersData=function(){L.debug("TablePersoProvider resetPersData");};
return T;});
sap.ui.predefine('sap/m/TableRenderer',["sap/ui/core/Renderer","sap/ui/core/Core","./library","./ListBaseRenderer","./ColumnListItemRenderer"],function(R,C,l,L,a){"use strict";var b=l.ListKeyboardMode;var T=R.extend(L);T.apiVersion=2;var r=C.getConfiguration().getRTL();T.columnAlign={left:r?"flex-end":"flex-start",center:"center",right:r?"flex-start":"flex-end"};
T.renderColumns=function(c,t,d){var i=0,h=0,e=false,f=false,m=t.getMode(),M=L.ModeOrder[m],g="sapMListTbl",j=t.getId("tbl"),k=(d=="Head")?"th":"td",n="t"+d.toLowerCase(),o=t.getColumns(),s=t.shouldRenderDummyColumn(),H,p=function(u,v,A){c.openStart(k,v&&j+v);if(k==="th"){c.class("sapMTableTH");c.attr("role",A?"presentation":"columnheader");c.attr("scope","col");}else if(A){c.attr("role","presentation");}A&&c.attr("aria-hidden","true");c.class(g+u);if(d==="Foot"){if(u==="HighlightCol"){c.class("sapMTableHighlightFooterCell");}else if(u==="NavigatedCol"){c.class("sapMTableNavigatedFooterCell");}}c.openEnd();c.close(k);i++;};if(d=="Head"){var F=o.reduce(function(u,v,O){v.setIndex(-1);v.setInitialOrder(O);v.setForcedColumn(false);return(v.getCalculatedMinScreenWidth()<u.getCalculatedMinScreenWidth())?v:u;},o[0]);var q=o.filter(function(u){return u.getVisible()&&!u.isPopin()&&!u.isHidden();}).length;if(!q&&F){F.setForcedColumn(true);q=1;}H=o.every(function(u){return!u.getHeader()||!u.getHeader().getVisible()||!u.getVisible()||u.isPopin()||u.isHidden();});}c.openStart(n);if(t._hasFooter&&d==="Foot"){c.class("sapMTableTFoot");if(t.hasPopin()){c.class("sapMListTblHasPopin");}}c.openEnd();c.openStart("tr",t.addNavSection(j+d+"er"));if(d!=="Head"&&s){c.class("sapMListTblRowHasDummyCell");}c.attr("tabindex",-1);if(H){c.class("sapMListTblHeaderNone");}else{c.class("sapMListTblRow").class("sapMLIBFocusable").class("sapMListTbl"+d+"er");a.addLegacyOutlineClass.call(a,c);}c.openEnd();p("HighlightCol",d+"Highlight",true);if(M==-1){if(m=="MultiSelect"&&d=="Head"&&!H){c.openStart("th");c.class("sapMTableTH");c.attr("scope","col");c.attr("aria-hidden","true");c.class(g+"SelCol");c.attr("role","presentation");c.openEnd();c.renderControl(t._getSelectAllCheckbox());c.close("th");i++;}else{p("SelCol","",true);}}t.getColumns(true).forEach(function(u,v){if(!u.getVisible()){return;}if(u.isPopin()){e=true;return;}var w=u.isHidden();if(w){h++;}var x=u["get"+d+"er"](),y=(q==1)?"":u.getWidth(),z=u.getStyleClass(true),A=u.getCssAlign();if(d=="Head"){c.openStart(k,u);c.class("sapMTableTH");c.attr("role","columnheader");c.attr("scope","col");var S=u.getSortIndicator().toLowerCase();S!=="none"&&c.attr("aria-sort",S);}else{c.openStart(k);}z&&c.class(z);c.class(g+"Cell");c.class(g+d+"erCell");c.attr("data-sap-width",u.getWidth());c.style("width",y);if(A&&d!=="Head"){c.style("text-align",A);}if(w){c.style("display","none");c.attr("aria-hidden","true");}c.openEnd();if(x){if(d==="Head"){c.openStart("div");c.class("sapMColumnHeader");if(t.bActiveHeaders&&!x.isA("sap.ui.core.InvisibleText")){c.attr("tabindex",0);c.attr("role","button");c.attr("aria-haspopup","dialog");c.class("sapMColumnHeaderActive");}if(A){c.style("justify-content",T.columnAlign[A]);c.style("text-align",A);}c.openEnd();c.renderControl(x.addStyleClass("sapMColumnHeaderContent"));c.close("div");}else{c.renderControl(x);}}if(d=="Head"&&!f){f=!!u.getFooter();}c.close(k);u.setIndex(i++);});if(e&&s){p("DummyCol",d+"DummyCol",true);}p("NavCol",d+"Nav",!t._iItemNeedsColumn);if(M==1){p("SelCol","",true);}p("NavigatedCol",d+"Navigated",true);if(!e&&s){p("DummyCol",d+"DummyCol",true);}c.close("tr");c.close(n);if(d==="Head"){t._bPopinChanged=t._hasPopin!==e||t._iHiddenPopinColumns!==t._getHiddenInPopin().length||e;t._hasPopin=e;t._colCount=i-h;t._hasFooter=f;t._headerHidden=H;}};
T.renderContainerAttributes=function(c,o){c.attr("role","application");c.class("sapMListTblCnt");c.accessibilityState(o,this.getAccessibilityState(o));};
T.renderListStartAttributes=function(c,o){c.openStart("table",o.getId("listUl"));c.class("sapMListTbl");if(o.getFixedLayout()===false){c.style("table-layout","auto");}if(o._iItemNeedsColumn){c.class("sapMListTblHasNav");}};
T.getAriaRole=function(c){return"";};
T.getAriaLabelledBy=function(c){var p=L.getAriaLabelledBy.call(this,c);var s=this.getAriaAnnouncement("TABLE_ROLE_DESCRIPTION");if(p&&s){return p+" "+s;}return s||p;};
T.renderListHeadAttributes=function(c,o){this.renderColumns(c,o,"Head");c.openStart("tbody",o.addNavSection(o.getId("tblBody")));c.class("sapMListItems");c.class("sapMTableTBody");if(o.getAlternateRowColors()){c.class(o._getAlternateRowColorsClass());}if(o.hasPopin()){c.class("sapMListTblHasPopin");}c.openEnd();};
T.renderListEndAttributes=function(c,o){c.close("tbody");o._hasFooter&&this.renderColumns(c,o,"Foot");c.close("table");};
T.renderNoData=function(c,o){c.openStart("tr",o.getId("nodata"));c.attr("tabindex",o.getKeyboardMode()==b.Navigation?-1:0);c.class("sapMLIB").class("sapMListTblRow").class("sapMLIBTypeInactive");a.addFocusableClasses.call(a,c);if(!o._headerHidden||(!o.getHeaderText()&&!o.getHeaderToolbar())){c.class("sapMLIBShowSeparator");}c.openEnd();c.openStart("td",o.getId("nodata-text"));c.attr("colspan",o.getColCount());c.class("sapMListTblCell").class("sapMListTblCellNoData");c.openEnd();if(!o.shouldRenderItems()){c.text(C.getLibraryResourceBundle("sap.m").getText("TABLE_NO_COLUMNS"));}else{c.text(o.getNoDataText(true));}c.close("td");c.close("tr");};
return T;},true);
sap.ui.predefine('sap/m/TableSelectDialog',['./Button','./Dialog','./SearchField','./Table','./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/Device','sap/m/Toolbar','sap/m/Text','sap/m/BusyIndicator','sap/m/Bar','sap/ui/core/theming/Parameters','sap/m/Title','sap/base/Log'],function(B,D,S,T,l,a,C,b,c,d,e,f,P,g,L){"use strict";var h=l.ListMode;var j=l.ButtonType;var k=l.TitleAlignment;
var m=C.extend("sap.m.TableSelectDialog",{
metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:null},noDataText:{type:"string",group:"Appearance",defaultValue:null},multiSelect:{type:"boolean",group:"Dimension",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:true},growingThreshold:{type:"int",group:"Misc",defaultValue:null},contentWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},rememberSelections:{type:"boolean",group:"Behavior",defaultValue:false},contentHeight:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showClearButton:{type:"boolean",group:"Behavior",defaultValue:false},confirmButtonText:{type:"string",group:"Appearance"},draggable:{type:"boolean",group:"Behavior",defaultValue:false},resizable:{type:"boolean",group:"Behavior",defaultValue:false},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:k.Auto}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.ColumnListItem",multiple:true,singularName:"item",bindable:"bindable",forwarding:{idSuffix:"-table",aggregation:"items",forwardBinding:true}},_dialog:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},columns:{type:"sap.m.Column",multiple:true,singularName:"column",bindable:"bindable",forwarding:{idSuffix:"-table",aggregation:"columns",forwardBinding:true}}},events:{confirm:{parameters:{selectedItem:{type:"sap.m.StandardListItem"},selectedItems:{type:"sap.m.StandardListItem[]"},selectedContexts:{type:"string"}}},search:{parameters:{value:{type:"string"},itemsBinding:{type:"any"},clearButtonPressed:{type:"boolean"}}},liveChange:{parameters:{value:{type:"string"},itemsBinding:{type:"any"}}},cancel:{}}},
renderer:{apiVersion:2,render:function(){}}
});
m.prototype.init=function(){var t=this,i=0,r=null;r=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(r);t._fireConfirmAndUpdateSelection();};this._bAppendedToUIArea=false;this._bInitBusy=false;this._bFirstRender=true;this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oTable=new T(this.getId()+"-table",{growing:t.getGrowing(),growingScrollToLoad:t.getGrowing(),mode:h.SingleSelectMaster,modeAnimationOn:false,sticky:[l.Sticky.InfoToolbar,l.Sticky.ColumnHeaders],infoToolbar:new c({visible:false,active:false,content:[new d({text:this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[0])})]}),selectionChange:function(E){if(t._oDialog){if(!t.getMultiSelect()){t._oDialog.attachAfterClose(r);t._oDialog.close();}else{t._updateSelectionIndicator();}}}});this._oTable.getInfoToolbar().addEventDelegate({onAfterRendering:function(){t._oTable.getInfoToolbar().$().attr('aria-live','polite');}});this._table=this._oTable;this._oBusyIndicator=new e(this.getId()+"-busyIndicator").addStyleClass("sapMTableSelectDialogBusyIndicator",true);this._oSearchField=new S(this.getId()+"-searchField",{width:"100%",liveChange:function(E){var v=E.getSource().getValue(),n=(v?300:0);clearTimeout(i);if(n){i=setTimeout(function(){t._executeSearch(v,false,"liveChange");},n);}else{t._executeSearch(v,false,"liveChange");}},search:function(E){var v=E.getSource().getValue(),n=E.getParameter("clearButtonPressed");t._executeSearch(v,n,"search");}});this._searchField=this._oSearchField;this._oSubHeader=new f(this.getId()+"-subHeader",{contentMiddle:[this._searchField]});var o=new f(this.getId()+"-dialog-header",{contentMiddle:[new g(this.getId()+"-dialog-title",{level:"H2"})]});this._setupBarTitleAlignment(o,this.getId()+"_customHeader");this._oDialog=new D(this.getId()+"-dialog",{customHeader:o,stretch:b.system.phone,contentHeight:"2000px",subHeader:this._oSubHeader,content:[this._oBusyIndicator,this._oTable],endButton:this._getCancelButton(),initialFocus:((b.system.desktop&&this._oSearchField)?this._oSearchField:null),draggable:this.getDraggable()&&b.system.desktop,resizable:this.getResizable()&&b.system.desktop,escapeHandler:function(p){t._onCancel();p.resolve();}}).addStyleClass("sapMTableSelectDialog");this._dialog=this._oDialog;this.setAggregation("_dialog",this._oDialog);this._oDialog._iVMargin=8*(parseInt(P.get("sapUiFontSize"))||16);this._sSearchFieldValue="";this._bFirstRequest=true;this._iTableUpdateRequested=0;this._oDialog.getProperty=function(n){if(n!=="title"){return C.prototype.getProperty.call(this,n);}return this.getCustomHeader().getAggregation("contentMiddle")[0].getText();}.bind(this._oDialog);};
m.prototype.exit=function(){this._oTable=null;this._oSearchField=null;this._oSubHeader=null;this._oClearButton=null;this._oBusyIndicator=null;this._sSearchFieldValue=null;this._iTableUpdateRequested=null;this._bFirstRequest=false;this._bInitBusy=false;this._bFirstRender=false;if(this._bAppendedToUIArea){var s=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(s);s.removeContent(this,true);}if(this._oDialog){this._oDialog.destroy();this._oDialog=null;}if(this._oOkButton){this._oOkButton.destroy();this._oOkButton=null;}this._oSelectedItem=null;this._aSelectedItems=null;this._aInitiallySelectedItems=null;this._table=null;this._searchField=null;this._dialog=null;};
m.prototype.onAfterRendering=function(){if(this._bInitBusy&&this._bFirstRender){this._setBusy(true);this._bInitBusy=false;this._bFirstRender=false;}return this;};
m.prototype.invalidate=function(){if(this._oDialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._oDialog.invalidate(arguments);}else{C.prototype.invalidate.apply(this,arguments);}return this;};
m.prototype.open=function(s){if(!this.getParent()&&!this._bAppendedToUIArea){var o=sap.ui.getCore().getStaticAreaRef();o=sap.ui.getCore().getUIArea(o);o.addContent(this,true);this._bAppendedToUIArea=true;}this._bFirstRequest=true;this._sSearchFieldValue="";this._oSearchField.setValue(s);this._oDialog.open();if(this._bInitBusy){this._setBusy(true);}this._aInitiallySelectedItems=this._oTable.getSelectedItems();this._updateSelectionIndicator();return this;};
m.prototype.setGrowing=function(v){this._oTable.setGrowing(v);this._oTable.setGrowingScrollToLoad(v);this.setProperty("growing",v,true);return this;};
m.prototype.setGrowingThreshold=function(v){this._oTable.setGrowingThreshold(v);this.setProperty("growingThreshold",v,true);return this;};
m.prototype.setDraggable=function(v){this._setInteractionProperty(v,"draggable",this._oDialog.setDraggable);return this;};
m.prototype.setResizable=function(v){this._setInteractionProperty(v,"resizable",this._oDialog.setResizable);return this;};
m.prototype._setInteractionProperty=function(v,p,i){this.setProperty(p,v,true);if(!b.system.desktop&&v){L.warning(p+" property works only on desktop devices!");return;}if(b.system.desktop&&this._oDialog){i.call(this._oDialog,v);}};
m.prototype.setBusy=function(i){this._oSearchField.setEnabled(!i);this._oDialog.setBusy.apply(this._oDialog,arguments);return this;};
m.prototype.getBusy=function(){return this._oDialog.getBusy.apply(this._oDialog,arguments);};
m.prototype.setBusyIndicatorDelay=function(v){this._oTable.setBusyIndicatorDelay(v);this._oDialog.setBusyIndicatorDelay(v);this.setProperty("busyIndicatorDelay",v,true);return this;};
m.prototype.setMultiSelect=function(M){this.setProperty("multiSelect",M,true);if(M){this._oTable.setMode(h.MultiSelect);this._oTable.setIncludeItemInSelection(true);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.setBeginButton(this._getOkButton());}else{this._oTable.setMode(h.SingleSelectMaster);this._oDialog.setEndButton(this._getCancelButton());this._oDialog.destroyBeginButton();delete this._oOkButton;}return this;};
m.prototype.setTitle=function(t){this.setProperty("title",t,true);this._oDialog.getCustomHeader().getAggregation("contentMiddle")[0].setText(t);return this;};
m.prototype.setConfirmButtonText=function(t){this.setProperty("confirmButtonText",t,true);this._oOkButton&&this._oOkButton.setText(t||this._oRb.getText("SELECT_CONFIRM_BUTTON"));return this;};
m.prototype.setNoDataText=function(n){this._oTable.setNoDataText(n);return this;};
m.prototype.getNoDataText=function(){return this._oTable.getNoDataText();};
m.prototype.getContentWidth=function(){return this._oDialog.getContentWidth();};
m.prototype.setContentWidth=function(w){this._oDialog.setContentWidth(w);return this;};
m.prototype.getContentHeight=function(){return this._oDialog.getContentHeight();};
m.prototype.setContentHeight=function(H){this._oDialog.setContentHeight(H);return this;};
m.prototype.addStyleClass=function(){this._oDialog.addStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.removeStyleClass=function(){this._oDialog.removeStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.toggleStyleClass=function(){this._oDialog.toggleStyleClass.apply(this._oDialog,arguments);return this;};
m.prototype.hasStyleClass=function(){return this._oDialog.hasStyleClass.apply(this._oDialog,arguments);};
m.prototype.getDomRef=function(){if(this._oDialog){return this._oDialog.getDomRef.apply(this._oDialog,arguments);}else{return null;}};
m.prototype.setShowClearButton=function(v){this.setProperty("showClearButton",v,true);if(v){var o=this._oDialog.getCustomHeader();o.addContentRight(this._getClearButton());this._oClearButton.setVisible(v);}else if(this._oClearButton){this._oClearButton.setVisible(v);}return this;};
m.prototype._setModel=m.prototype.setModel;
m.prototype.setModel=function(M,s){var A=Array.prototype.slice.call(arguments);this._setBusy(false);this._bInitBusy=false;this._iTableUpdateRequested+=1;this._oTable.attachUpdateStarted(this._updateStarted,this);this._oTable.attachUpdateFinished(this._updateFinished,this);this._oTable.setModel(M,s);m.prototype._setModel.apply(this,A);this._updateSelectionIndicator();return this;};
m.prototype._setBindingContext=m.prototype.setBindingContext;
m.prototype.setBindingContext=function(o,M){var i=Array.prototype.slice.call(arguments);this._oTable.setBindingContext(o,M);m.prototype._setBindingContext.apply(this,i);return this;};
m.prototype._executeSearch=function(v,i,E){var t=this._oTable,o=(t?t.getBinding("items"):undefined),s=(this._sSearchFieldValue!==v);if(this._oDialog.isOpen()&&((s&&E==="liveChange")||E==="search")){this._sSearchFieldValue=v;if(o){this._iTableUpdateRequested+=1;if(E==="search"){this.fireSearch({value:v,itemsBinding:o,clearButtonPressed:i});}else if(E==="liveChange"){this.fireLiveChange({value:v,itemsBinding:o});}}else{if(E==="search"){this.fireSearch({value:v,clearButtonPressed:i});}else if(E==="liveChange"){this.fireLiveChange({value:v});}}}return this;};
m.prototype._setBusy=function(i){if(this._iTableUpdateRequested){if(i){this._oSearchField.setEnabled(false);this._oTable.addStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','inline-block');}else{this._oSearchField.setEnabled(true);this._oTable.removeStyleClass('sapMSelectDialogListHide');this._oBusyIndicator.$().css('display','none');}}};
m.prototype._updateStarted=function(E){if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){if(this._oDialog.isOpen()&&this._iTableUpdateRequested){this._setBusy(true);}else{this._bInitBusy=true;}}};
m.prototype._updateFinished=function(E){this._updateSelectionIndicator();if(this.getModel()&&this.getModel()instanceof sap.ui.model.odata.ODataModel){this._setBusy(false);this._bInitBusy=false;}if(b.system.desktop){if(this._oTable.getItems()[0]){this._oDialog.setInitialFocus(this._oTable.getItems()[0]);}else{this._oDialog.setInitialFocus(this._oSearchField);}if(this._bFirstRequest){var F=this._oTable.getItems()[0];if(!F){F=this._oSearchField;}if(F.getFocusDomRef()){F.getFocusDomRef().focus();}}}this._bFirstRequest=false;this._iTableUpdateRequested=0;};
m.prototype._getOkButton=function(){var t=this,o=null;o=function(){t._oSelectedItem=t._oTable.getSelectedItem();t._aSelectedItems=t._oTable.getSelectedItems();t._oDialog.detachAfterClose(o);t._fireConfirmAndUpdateSelection();};if(!this._oOkButton){this._oOkButton=new B(this.getId()+"-ok",{type:j.Emphasized,text:this.getConfirmButtonText()||this._oRb.getText("SELECT_CONFIRM_BUTTON"),press:function(){t._oDialog.attachAfterClose(o);t._oDialog.close();}});}return this._oOkButton;};
m.prototype._getCancelButton=function(){var t=this;if(!this._oCancelButton){this._oCancelButton=new B(this.getId()+"-cancel",{text:this._oRb.getText("MSGBOX_CANCEL"),press:function(){t._onCancel();}});}return this._oCancelButton;};
m.prototype._getClearButton=function(){if(!this._oClearButton){this._oClearButton=new B(this.getId()+"-clear",{text:this._oRb.getText("TABLESELECTDIALOG_CLEARBUTTON"),press:function(){this._removeSelection();this._updateSelectionIndicator();this._oDialog.focus();}.bind(this)});}return this._oClearButton;};
m.prototype._onCancel=function(E){var t=this,A=null;A=function(){t._oSelectedItem=null;t._aSelectedItems=[];t._sSearchFieldValue=null;t._oDialog.detachAfterClose(A);t.fireCancel();};t._resetSelection();this._oDialog.attachAfterClose(A);this._oDialog.close();};
m.prototype._updateSelectionIndicator=function(){var s=this._oTable.getSelectedContextPaths(true).length,i=this._oTable.getInfoToolbar();if(this.getShowClearButton()&&this._oClearButton){this._oClearButton.setEnabled(s>0);}i.setVisible(!!s);i.getContent()[0].setText(this._oRb.getText("TABLESELECTDIALOG_SELECTEDITEMS",[s]));};
m.prototype._fireConfirmAndUpdateSelection=function(){var p={selectedItem:this._oSelectedItem,selectedItems:this._aSelectedItems};Object.defineProperty(p,"selectedContexts",{get:this._oTable.getSelectedContexts.bind(this._oTable,true)});this.fireConfirm(p);this._updateSelection();};
m.prototype._updateSelection=function(){if(!this.getRememberSelections()&&!this.bIsDestroyed){this._removeSelection();}};
m.prototype._removeSelection=function(){this._oTable.removeSelections(true);delete this._oSelectedItem;delete this._aSelectedItems;};
m.prototype._resetSelection=function(){var i=0;if(!this.bIsDestroyed){var o=this._oTable.getBinding("items");if(o&&o.aFilters&&o.aFilters.length){o.filter([]);}this._oTable.removeSelections();for(;i<this._aInitiallySelectedItems.length;i++){this._oTable.setSelectedItem(this._aInitiallySelectedItems[i]);}}};
a.mixInto(m.prototype);return m;});
sap.ui.predefine('sap/m/Text',['./library','sap/ui/core/Core','sap/ui/core/Control','sap/ui/core/library','sap/ui/Device','sap/m/HyphenationSupport',"./TextRenderer"],function(l,C,a,c,D,H,T){"use strict";var b=c.TextAlign;var d=c.TextDirection;var W=l.WrappingType;
var e=a.extend("sap.m.Text",{metadata:{interfaces:["sap.ui.core.IShrinkable","sap.ui.core.IFormContent","sap.m.IHyphenation"],library:"sap.m",properties:{text:{type:"string",defaultValue:'',bindable:"bindable"},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},wrapping:{type:"boolean",group:"Appearance",defaultValue:true},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:b.Begin},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxLines:{type:"int",group:"Appearance",defaultValue:null},renderWhitespace:{type:"boolean",group:"Appearance",defaultValue:false}},designtime:"sap/m/designtime/Text.designtime"}});
e.prototype.normalLineHeight=1.2;e.prototype.cacheLineHeight=true;e.prototype.ellipsis='...';e.hasNativeLineClamp=("webkitLineClamp"in document.documentElement.style);
e.setNodeValue=function(o,n){n=n||"";var f=o.childNodes;if(f.length===1&&f[0].nodeType===window.Node.TEXT_NODE){f[0].nodeValue=n;}else{o.textContent=n;}};
e.prototype.getText=function(n){var t=this.getProperty("text");if(n){return t.replace(/\r\n|\n\r|\r/g,"\n");}return t;};
e.prototype.onAfterRendering=function(){if(this.getVisible()&&this.hasMaxLines()&&!this.canUseNativeLineClamp()){if(C.isThemeApplied()){this.clampHeight();}else{C.attachThemeChanged(this._handleThemeLoad,this);}}};
e.prototype._handleThemeLoad=function(){this.clampHeight();C.detachThemeChanged(this._handleThemeLoad,this);};
e.prototype.hasMaxLines=function(){return(this.getWrapping()&&this.getMaxLines()>1);};
e.prototype.getTextDomRef=function(){if(!this.getVisible()){return null;}if(this.hasMaxLines()){return this.getDomRef("inner");}return this.getDomRef();};
e.prototype.canUseNativeLineClamp=function(){if(!e.hasNativeLineClamp){return false;}if(this.getTextDirection()==d.RTL){return false;}if(this.getTextDirection()==d.Inherit&&C.getConfiguration().getRTL()){return false;}return true;};
e.prototype.getLineHeight=function(o){if(this.cacheLineHeight&&this._fLineHeight){return this._fLineHeight;}o=o||this.getTextDomRef();if(!o){return 0;}var s=window.getComputedStyle(o),L=s.lineHeight,f;if(/px$/i.test(L)){f=parseFloat(L);}else if(/^normal$/i.test(L)){f=parseFloat(s.fontSize)*this.normalLineHeight;}else{f=parseFloat(s.fontSize)*parseFloat(L);}if(!D.browser.firefox){f=Math.floor(f);}if(this.cacheLineHeight&&f){this._fLineHeight=f;}return f;};
e.prototype.getClampHeight=function(o){o=o||this.getTextDomRef();return this.getMaxLines()*this.getLineHeight(o);};
e.prototype.clampHeight=function(o){o=o||this.getTextDomRef();if(!o){return 0;}var m=this.getClampHeight(o);if(m){o.style.maxHeight=m+"px";}return m;};
e.prototype.clampText=function(o,s,E){o=o||this.getTextDomRef();if(!o){return;}var i;var t=this.getText(true);var m=this.getClampHeight(o);s=s||0;E=E||t.length;e.setNodeValue(o,t.slice(0,E));if(o.scrollHeight>m){var S=o.style,h=S.height,f=this.ellipsis,g=f.length;S.height=m+"px";while((E-s)>g){i=(s+E)>>1;e.setNodeValue(o,t.slice(0,i-g)+f);if(o.scrollHeight>m){E=i;}else{s=i;}}if(o.scrollHeight>m&&s>0){i=s;o.textContent=t.slice(0,i-g)+f;}S.height=h;}return i;};
e.prototype.getAccessibilityInfo=function(){return{description:this.getText()};};
e.prototype.getTextsToBeHyphenated=function(){return{"main":this.getText(true)};};
e.prototype.getDomRefsForHyphenatedTexts=function(){return{"main":this.getTextDomRef()};};
H.mixInto(e.prototype);return e;});
sap.ui.predefine('sap/m/TextArea',['./InputBase','./Text','sap/ui/core/ResizeHandler','./library','sap/ui/core/library','sap/ui/events/KeyCodes','sap/ui/Device',"sap/base/security/encodeXML",'./TextAreaRenderer',"sap/ui/thirdparty/jquery"],function(I,T,R,l,c,K,D,a,b,q){"use strict";var W=c.Wrapping;
var d=I.extend("sap.m.TextArea",{metadata:{library:"sap.m",designtime:"sap/m/designtime/TextArea.designtime",properties:{rows:{type:"int",group:"Appearance",defaultValue:2},cols:{type:"int",group:"Appearance",defaultValue:20},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},maxLength:{type:"int",group:"Behavior",defaultValue:0},showExceededText:{type:"boolean",group:"Behavior",defaultValue:false},wrapping:{type:"sap.ui.core.Wrapping",group:"Behavior",defaultValue:W.None},valueLiveUpdate:{type:"boolean",group:"Behavior",defaultValue:false},growing:{type:"boolean",group:"Behavior",defaultValue:false},growingMaxLines:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{_counter:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{liveChange:{parameters:{value:{type:"string"}}}},dnd:{draggable:false,droppable:true}}});
d.prototype.init=function(){var C;I.prototype.init.call(this);this.sResizeListenerId=null;this._bPasteIsTriggered=false;C=new T(this.getId()+'-counter',{}).addStyleClass("sapMTextAreaCounter").setVisible(false);this.setAggregation("_counter",C);};
d.prototype.setShowExceededText=function(v){var C=this.getAggregation("_counter"),V;if(v){if(this.getAriaLabelledBy().indexOf(C.getId())<0){this.addAriaLabelledBy(C.getId());}}else{C=this.getAggregation("_counter");C&&this.removeAriaLabelledBy(C.getId());V=this.getValue();if(this.getMaxLength()){V=V.substring(0,this.getMaxLength());this.setValue(V);}}C.setVisible(v);this.setProperty("showExceededText",v);this._updateMaxLengthAttribute();return this;};
d.prototype.exit=function(){I.prototype.exit.call(this);q(window).off("resize.sapMTextAreaGrowing");this._detachResizeHandler();this._deregisterEvents();};
d.prototype.onBeforeRendering=function(){I.prototype.onBeforeRendering.call(this);var C=this.getAggregation("_counter");if((this.getMaxLength()<=0||!this.getShowExceededText())&&C.getVisible()){C.setVisible(false);}this._detachResizeHandler();if(this.getGrowing()){q(window).on("resize.sapMTextAreaGrowing",this._updateOverflow.bind(this));}else{q(window).off("resize.sapMTextAreaGrowing");}};
d.prototype.onAfterRendering=function(){I.prototype.onAfterRendering.call(this);if(this.getGrowing()){this._sResizeListenerId=R.register(this,this._resizeHandler.bind(this));if(this.getGrowingMaxLines()>0){this._setGrowingMaxHeight();}this._adjustContainerDimensions();}this._updateMaxLengthAttribute();if(!D.support.touch){return;}var t=this.$("inner");if(this._behaviour.INSIDE_SCROLLABLE_WITHOUT_FOCUS){t.on("touchstart",q.proxy(this._onTouchStart,this));t.on("touchmove",q.proxy(this._onTouchMove,this));}else if(this._behaviour.PAGE_NON_SCROLLABLE_AFTER_FOCUS){t.on("touchmove",function(e){if(t.is(":focus")){e.stopPropagation();}});}};
d.prototype._deregisterEvents=function(){this.$("inner").off("touchstart").off("touchmove");};
d.prototype._setGrowingMaxHeight=function(){var h=this.getDomRef('hidden'),C=sap.ui.getCore(),L=C.getLoadedLibraries(),f,m,s;if(!L||!L['sap.m']){C.attachThemeChanged(this._setGrowingMaxHeight.bind(this));return;}C.detachThemeChanged(this._setGrowingMaxHeight);s=window.getComputedStyle(h);f=this._getLineHeight();m=(f*this.getGrowingMaxLines())+parseFloat(s.getPropertyValue("padding-top"))+parseFloat(s.getPropertyValue("border-top-width"))+parseFloat(s.getPropertyValue("border-bottom-width"));if(D.browser.firefox){m+=parseFloat(s.getPropertyValue("padding-bottom"));}h.style.maxHeight=m+"px";};
d.prototype._getLineHeight=function(){var t=this.getFocusDomRef(),s;if(!t){return;}s=window.getComputedStyle(t);return isNaN(parseFloat(s.getPropertyValue("line-height")))?1.4*parseFloat(s.getPropertyValue("font-size")):parseFloat(s.getPropertyValue("line-height"));};
d.prototype._resizeHandler=function(e){this._adjustContainerDimensions();};
d.prototype._detachResizeHandler=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}};
d.prototype.onsapenter=function(e){e.setMarked();};
d.prototype.onValueRevertedByEscape=function(v){if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this.fireLiveChange({value:v,newValue:v});};
d.prototype.getValue=function(){var t=this.getFocusDomRef();return t?t.value:this.getProperty("value");};
d.prototype.setValue=function(v){I.prototype.setValue.call(this,v);this._handleShowExceededText();if(this.getGrowing()){this._adjustContainerDimensions();}return this;};
d.prototype.onsapnext=function(e){e.setMarked();};
d.prototype.onsapprevious=function(e){e.setMarked();};
d.prototype.oninput=function(e){I.prototype.oninput.call(this,e);if(this._bPasteIsTriggered){this._bPasteIsTriggered=false;this._selectExceededText();}if(e.isMarked("invalid")){return;}var t=this.getFocusDomRef(),v=t.value,s=this.getShowExceededText(),m=this.getMaxLength();if(!s&&m&&v.length>m){v=v.substring(0,m);t.value=v;}if(this.getValueLiveUpdate()){this.setProperty("value",v,true);v=this.getValue();}this._handleShowExceededText();if(this.getGrowing()){this._adjustContainerDimensions();}this.fireLiveChange({value:v,newValue:v});};
d.prototype.onpaste=function(e){if(this.getShowExceededText()){this._bPasteIsTriggered=true;}};
d.prototype._adjustContainerDimensions=function(){var t=this.getFocusDomRef(),h=this.getDomRef("hidden"),H,n;if(!t||!h){return;}h.style.width="";if(this.getGrowing()&&!this.getWidth()&&this.getCols()!==20){h.style.width=(this.getCols()*0.5)+"rem";}H=h.style["min-height"];n=this.getRows()*this._getLineHeight()+"px";if(!H||n!==H){h.style["min-height"]=n;}h.innerHTML=a(t.value)+'&nbsp;';this._updateOverflow();};
d.prototype._updateOverflow=function(){var t=this.getFocusDomRef(),h=this.getDomRef("hidden"),m;if(t){m=parseFloat(window.getComputedStyle(h)["max-height"]);t.style.overflowY=(h.scrollHeight>m)?"auto":"";}};
d.prototype._getInputValue=function(v){v=(v===undefined)?this.$("inner").val()||"":v.toString();if(this.getMaxLength()>0&&!this.getShowExceededText()){v=v.substring(0,this.getMaxLength());}return v.replace(/\r\n/g,"\n");};
d.prototype._selectExceededText=function(){var v=this.getValue().length;if(v>this.getMaxLength()){this.selectText(this.getMaxLength(),v);}};
d.prototype._updateMaxLengthAttribute=function(){var t=this.getFocusDomRef();if(!t){return;}if(this.getShowExceededText()){t.removeAttribute("maxlength");this._handleShowExceededText();}else{this.getMaxLength()&&t.setAttribute("maxlength",this.getMaxLength());}};
d.prototype._handleShowExceededText=function(){var C=this.getAggregation("_counter"),m=this.getMaxLength(),s;if(!this.getDomRef()||!this.getShowExceededText()||!m){return;}s=this._getCounterValue();C.setText(s);};
d.prototype._maxLengthIsExceeded=function(v){var r=false;if(this.getMaxLength()>0&&this.getShowExceededText()&&this.getValue().length>this.getMaxLength()){r=true;}return r;};
d.prototype._getCounterValue=function(){var B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),C=this.getMaxLength()-this.getValue().length,e=(C<0?true:false),m="TEXTAREA_CHARACTER"+(Math.abs(C)===1?"":"S")+"_"+(e?"EXCEEDED":"LEFT");return B.getText(m,[Math.abs(C)]);};
d.prototype._behaviour=(function(o){return{INSIDE_SCROLLABLE_WITHOUT_FOCUS:o.os.ios||o.os.blackberry||o.browser.chrome,PAGE_NON_SCROLLABLE_AFTER_FOCUS:o.os.android&&o.os.version>=4.1};}(D));
d.prototype._onTouchStart=function(e){var t=e.touches[0];this._iStartY=t.pageY;this._iStartX=t.pageX;this._bHorizontalScroll=undefined;e.setMarked("swipestartHandled");};
d.prototype._onTouchMove=function(e){var t=this.getFocusDomRef(),p=e.touches[0].pageY,s=t.scrollTop,f=s<=0,B=s+t.clientHeight>=t.scrollHeight,g=this._iStartY>p,G=this._iStartY<p,o=f&&G||B&&g;if(this._bHorizontalScroll===undefined){this._bHorizontalScroll=Math.abs(this._iStartY-p)<Math.abs(this._iStartX-e.touches[0].pageX);}if(this._bHorizontalScroll||!o){e.setMarked();}};
var _=D.os.windows_phone&&(/MSAppHost/i).test(navigator.appVersion);
d.prototype.onfocusin=function(e){var s,$=this.$();I.prototype.onfocusin.apply(this,arguments);function f(){q(window).scrollTop(0);s.scrollTop($.offset().top-s.offset().top+s.scrollTop());}if(_&&$.height()+$.offset().top>260){for(s=$.parent();s[0];s=s.parent()){if(s.css("overflow-y")=="auto"){s.children().last().css("padding-bottom",q(window).height()+"px");window.setTimeout(f,100);return;}}}};
d.prototype.onkeyup=function(e){if(e.keyCode===K.ENTER){e.setMarked("enterKeyConsumedAsContent");}};
return d;});
sap.ui.predefine('sap/m/TextAreaRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/Device','sap/ui/core/library'],function(R,I,D,c){"use strict";var W=c.Wrapping;var T=R.extend(I);T.apiVersion=2;
T.addOuterClasses=function(r,C){r.class("sapMTextArea");if(C.getShowExceededText()){r.class("sapMTextAreaWithCounter");}if(C.getHeight()){r.class("sapMTextAreaWithHeight");}};
T.addOuterStyles=function(r,C){C.getHeight()&&r.style("height",C.getHeight());};
T.writeDecorations=function(r,C){var o=C.getAggregation("_counter");r.renderControl(o);};
T.openInputTag=function(r,C){r.openStart("textarea",C.getId()+"-"+this.getInnerSuffix());};
T.endInputTag=function(r,C){r.openEnd();};
T.closeInputTag=function(r,C){r.close("textarea");};
T.prependInnerContent=function(r,C){if(C.getGrowing()){r.openStart("div",C.getId()+'-hidden');r.class("sapMTextAreaMirror");r.openEnd().close("div");}};
T.writeInnerValue=function(){};
T.writeInnerContent=function(r,C){var v=C.getValue();r.text(v);};
T.addInnerClasses=function(r,C){r.class("sapMTextAreaInner");if(C.getGrowing()){r.class("sapMTextAreaGrow");}};
T.getAriaRole=function(C){return"";};
T.writeInnerAttributes=function(r,C){if(C.getWrapping()!=W.None){r.attr("wrap",C.getWrapping());}r.attr("rows",C.getRows());r.attr("cols",C.getCols());};
return T;},true);
sap.ui.predefine('sap/m/TextRenderer',['sap/ui/core/Renderer','sap/ui/core/library','sap/m/HyphenationSupport','./library'],function(R,c,H,m){"use strict";var T=c.TextDirection;var W=m.WrappingType;var a={apiVersion:2};
a.render=function(r,t){var w=t.getWidth(),s=t.getText(true),b=t.getTextDirection(),d=t.getTooltip_AsString(),n=t.getMaxLines(),e=t.getWrapping(),f=t.getWrappingType(),g=t.getTextAlign(),h=t.getRenderWhitespace();r.openStart("span",t);r.class("sapMText");r.class("sapUiSelectable");if(t.hasMaxLines()){r.class("sapMTextMaxLineWrapper");}if(!e||n==1){r.class("sapMTextNoWrap");}else if(e&&f!==W.Hyphenated){if(s&&s.length>0&&!/\s/.test(s)){r.class("sapMTextBreakWord");}}w?r.style("width",w):r.class("sapMTextMaxWidth");if(b!==T.Inherit){r.attr("dir",b.toLowerCase());}d&&r.attr("title",d);if(g){g=R.getTextAlign(g,b);if(g){r.style("text-align",g);}}if(h){var i=e?"sapMTextRenderWhitespaceWrap":"sapMTextRenderWhitespace";r.class(i);}H.writeHyphenationClass(r,t);r.openEnd();if(t.hasMaxLines()){this.renderMaxLines(r,t);}else{this.renderText(r,t);}r.close("span");};
a.renderMaxLines=function(r,t){r.openStart("span",t.getId()+"-inner");r.class("sapMTextMaxLine");if(t.canUseNativeLineClamp()){r.class("sapMTextLineClamp");r.style("-webkit-line-clamp",t.getMaxLines());}r.openEnd();this.renderText(r,t);r.close("span");};
a.renderText=function(r,t){var s=H.getTextForRender(t,"main");r.text(s);};
return a;},true);
sap.ui.predefine('sap/m/Tile',['./library','sap/ui/core/InvisibleText','sap/ui/core/Control','sap/ui/Device','./TileRenderer',"sap/ui/thirdparty/jquery"],function(l,I,C,D,T,q){"use strict";
var a=C.extend("sap.m.Tile",{metadata:{library:"sap.m",properties:{removable:{type:"boolean",group:"Misc",defaultValue:true}},events:{press:{}}}});
a.prototype.init=function(){if(D.system.desktop){var o=q.proxy(function(e){if(e.srcControl===this&&!e.isMarked()){this.ontap();e.stopPropagation();}},this);this.onsapspace=o;this.onsapenter=o;}};
a.prototype.onAfterRendering=function(){if(this._rendered&&!this._bIsDragged&&this.getParent()instanceof sap.m.TileContainer){this.setPos(this._posX,this._posY);}this._rendered=true;};
a.prototype.setPos=function(x,y){this._posX=x=Math.floor(x);this._posY=y=Math.floor(y);if(!this._rendered){return;}var o=this.getDomRef();if(!o){return;}if("webkitTransform"in o.style){this.$().css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("transform"in o.style){this.$().css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){this.$().css('msTransform','translate('+x+'px,'+y+'px)');}else if("MozTransform"in o.style){this.$().css('-moz-transform','translate3d('+x+'px,'+y+'px,0)');}if(this._invisible){this.$().css("visibility","");delete this._invisible;}};
a.prototype.setSize=function(w,h){this._width=w;this._height=h;};
a.prototype.isEditable=function(i){var o=this._bIsEditable;if(i===true||i===false){this._bIsEditable=i;}if(o!=i&&this.$()){this.$().attr("aria-describedBy",i?I.getStaticId("sap.m","TILE_REMOVE_BY_DEL_KEY"):null);}return this._bIsEditable;};
a.prototype.isDragged=function(i){if(!this._bIsEditable){return;}if(i===true||i===false){var o=this.$();o.toggleClass("sapMTileDrag",i);this._bIsDragged=i;}return this._bIsDragged;};
a.prototype.ontouchstart=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",true);this._clientX=e.clientX;this._clientY=e.clientY;}};
a.prototype.ontouchend=function(){if(!this.isEditable()){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}};
Object.defineProperty(a.prototype,"_parentPreventsTapEvent",{get:function(){var p=this.getParent();while(p){if(p._bAvoidChildTapEvent||(p instanceof a&&p.isEditable())){return true;}p=p.getParent();}return false;}});
a.prototype.ontouchmove=function(e){if(!this.isEditable()&&!this._parentPreventsTapEvent){if(Math.abs(e.clientX-this._clientX)>30||Math.abs(e.clientY-this._clientY)>10){this.$().toggleClass("sapMTileActive sapMTileActive-CTX",false);}}};
a.prototype.ontap=function(){if(!this.isEditable()&&!this._parentPreventsTapEvent){this.firePress({});}};
a.prototype.setVisible=function(v){this.setProperty("visible",v);if(!v){this._rendered=false;}if(this.getParent()&&this.getParent()instanceof sap.m.TileContainer){this.getParent().invalidate();}return this;};
a.prototype._setVisible=function(v){this._invisible=!v;return this;};
return a;});
sap.ui.predefine('sap/m/TileContainer',['./library','sap/ui/core/Control','sap/ui/core/IconPool','sap/ui/Device','sap/ui/core/ResizeHandler','./TileContainerRenderer',"sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Selectors"],function(l,C,I,D,R,T,L,q){"use strict";
var a=C.extend("sap.m.TileContainer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},editable:{type:"boolean",group:"Misc",defaultValue:null},allowAdd:{type:"boolean",group:"Misc",defaultValue:null}},defaultAggregation:"tiles",aggregations:{tiles:{type:"sap.m.Tile",multiple:true,singularName:"tile"}},events:{tileMove:{parameters:{tile:{type:"sap.m.Tile"},newIndex:{type:"int"}}},tileDelete:{parameters:{tile:{type:"sap.m.Tile"}}},tileAdd:{}}}});
I.insertFontFaceStyle();a.prototype._bRtl=sap.ui.getCore().getConfiguration().getRTL();
a.prototype.init=function(){this._iCurrentTileStartIndex=0;this._oDim=null;this._iScrollLeft=0;this._iScrollGap=0;if(!D.system.desktop){this._iScrollGap=0;}this.bAllowTextSelection=false;this._oDragSession=null;this._oTouchSession=null;this._bAvoidChildTapEvent=false;this._iEdgeShowStart=D.system.phone?10:20;if(D.system.phone){this._iTriggerScrollOffset=10;}else if(D.system.desktop){this._iTriggerScrollOffset=-40;}else{this._iTriggerScrollOffset=20;}this._iCurrentFocusIndex=-1;if(D.system.desktop||D.system.combi){var o=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var F=this._iCurrentTileStartIndex===this._iCurrentFocusIndex?0:this._iCurrentTileStartIndex;var t=E.ctrlKey?F:r;var m=this._getVisibleTiles()[t];if(!!m){this._findTile(m.$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),O=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var r=this._iCurrentFocusIndex-this._iCurrentFocusIndex%this._iMaxTilesX;var m=r+this._iMaxTilesX<t.length?r+this._iMaxTilesX-1:t.length-1;var n=this._iCurrentTileStartIndex+this._iMaxTiles<t.length?this._iCurrentTileStartIndex+this._iMaxTiles-1:t.length-1;var p=n===this._iCurrentFocusIndex?t.length-1:n;var s=E.ctrlKey?p:m;if(t.length>0){this._findTile(t[s].$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),f=q.proxy(function(E){var t=this._getVisibleTiles();if(t.length>0){var n=this._iCurrentFocusIndex-this._iMaxTiles>=0?this._iCurrentFocusIndex-this._iMaxTiles:0;var N=t[n];if(!!N){this._renderTilesInTheSamePage(n,t);this._findTile(N.$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),d=q.proxy(function(E){var t=this._getVisibleTiles(),m=t.length;if(m>0){var n=this._iCurrentFocusIndex+this._iMaxTiles<m?this._iCurrentFocusIndex+this._iMaxTiles:m-1;var N=t[n];if(!!N){this._renderTilesInTheSamePage(n,t);this._findTile(N.$()).trigger("focus");E.stopPropagation();}this._handleAriaActiveDescendant();}},this),e=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex+1<t.length?this._iCurrentFocusIndex+1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(!!N){if(n<this._iCurrentTileStartIndex+this._iMaxTiles){this._findTile(N.$()).trigger("focus");}else{this._renderTilesInTheSamePage(n,t);this.scrollIntoView(N,true,t);var m=this;setTimeout(function(){m._findTile(N.$()).trigger("focus");},400);}}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),g=q.proxy(function(E){if(this._iCurrentFocusIndex>=0){var t=this._getVisibleTiles();var n=this._iCurrentFocusIndex-1>=0?this._iCurrentFocusIndex-1:this._iCurrentFocusIndex;if(!E.ctrlKey){var N=t[n];if(!!N){if(n>=this._iCurrentTileStartIndex){this._findTile(N.$()).trigger("focus");}else{this._renderTilesInTheSamePage(n,t);this.scrollIntoView(N,true,t);var m=this;setTimeout(function(){m._findTile(N.$()).trigger("focus");},400);}}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),i=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex+this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M>m)&&!!N){this._findTile(N.$()).trigger("focus");}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),j=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0){var m=this._iCurrentFocusIndex%this._iMaxTiles,n=this._iCurrentFocusIndex-this._iMaxTilesX,M=n%this._iMaxTiles;if(!E.ctrlKey){var N=t[n];if((M<m)&&!!N){this._findTile(N.$()).trigger("focus");}}else if(this.getEditable()){var p=t[this._iCurrentFocusIndex];this.moveTile(p,n);p.$().trigger("focus");}this._handleAriaActiveDescendant();E.stopPropagation();}},this),k=q.proxy(function(E){var t=this._getVisibleTiles();if(this._iCurrentFocusIndex>=0&&this.getEditable()){var m=t[this._iCurrentFocusIndex];if(m.getRemovable()){this.deleteTile(m);t=this._getVisibleTiles();if(this._iCurrentFocusIndex===t.length){if(t.length!==0){t[this._iCurrentFocusIndex-1].$().trigger("focus");}else{this._findNextTabbable().trigger("focus");}}else{t[this._iCurrentFocusIndex].$().trigger("focus");}this._handleAriaActiveDescendant();}E.stopPropagation();}},this);this.onsaphome=o;this.onsaphomemodifiers=o;this.onsapend=O;this.onsapendmodifiers=O;this.onsapright=this._bRtl?g:e;this.onsaprightmodifiers=this._bRtl?g:e;this.onsapleft=this._bRtl?e:g;this.onsapleftmodifiers=this._bRtl?e:g;this.onsapup=j;this.onsapupmodifiers=j;this.onsapdown=i;this.onsapdownmodifiers=i;this.onsappageup=f;this.onsappagedown=d;this.onsapdelete=k;this.data("sap-ui-fastnavgroup","true",true);}if(D.system.tablet||D.system.phone){this._fnOrientationChange=function(E){if(this.getDomRef()){this._oTileDimensionCalculator.calc();}}.bind(this);}this._oTileDimensionCalculator=new b(this);this._bRtl=sap.ui.getCore().getConfiguration().getRTL();this._oPagesInfo=(function(r){var m,n,p,s,P=false,t=r;return{setCurrentPage:function(u){p=m;m=u;},setCount:function(u){s=n;n=u;},setPagerCreated:function(u){P=u;},syncOldToCurrentValues:function(){s=n;p=m;},reset:function(){s=undefined;p=undefined;n=undefined;m=undefined;P=false;},getCurrentPage:function(){return m;},getCount:function(){return n;},getOldCurrentPage:function(){return p;},getOldCount:function(){return s;},isPagerCreated:function(){return P;},currentPageIsLast:function(){return t?(m===0):(m===n-1);},currentPageIsFirst:function(){return t?(m===n-1):(m===0);},oldCurrentPageIsLast:function(){if(isNaN(p)){return false;}return t?(p===0):(p===s-1);},oldCurrentPageIsFirst:function(){if(isNaN(p)){return false;}return t?(p===s-1):(p===0);},currentPageIsLastChanged:function(){return this.currentPageIsLast()!==this.oldCurrentPageIsLast();},currentPageIsFirstChanged:function(){return this.currentPageIsFirst()!==this.oldCurrentPageIsFirst();},currentPageRelativePositionChanged:function(){return this.currentPageIsFirstChanged()||this.currentPageIsLastChanged();},pageCountChanged:function(){return n!==s;},currentPageChanged:function(){return m!==p;}};}(this._bRtl));this._iMaxTiles=1;};
a.prototype._findNextTabbable=function(){var r=this.$();var t=q.merge(q.merge(r.nextAll(),r.parents().nextAll()).find(':sapTabbable').addBack(':sapTabbable'),q.merge(r.parents().prevAll(),r.prevAll()).find(':sapTabbable').addBack(':sapTabbable'));return t.first();};
a.prototype.onBeforeRendering=function(){var t=this.getTiles(),d=t.length;if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._oPagesInfo.reset();for(var i=0;i<d;i++){t[i]._rendered=false;}};
a.prototype.onAfterRendering=function(){var v=[];this._sResizeListenerId=R.register(this.getDomRef().parentElement,q.proxy(this._resize,this));this._oDim=this._calculateDimension();this._applyDimension();this.$().toggleClass("sapMTCEditable",this.getEditable()===true);if(this._bRenderFirstPage){this._bRenderFirstPage=false;v=this._getVisibleTiles();this._updateTileDimensionInfoAndPageSize(v);if(this.getTiles().length===1){this._update(false,v);}else if(this._iMaxTiles!==Infinity&&this._iMaxTiles){this._renderTiles(v,0,this._iMaxTiles-1);}}else{this._update(true);}if(D.system.desktop||D.system.combi){var t=v||this._getVisibleTiles();if(t.length>0&&this._mFocusables&&this._mFocusables[t[0].getId()]){this._mFocusables[t[0].getId()].eq(0).attr('tabindex','0');}}if(D.system.tablet||D.system.phone){D.orientation.attachHandler(this._fnOrientationChange,this);}};
a.prototype.setEditable=function(v){var t=this._getVisibleTiles();this.setProperty("editable",v,true);var e=this.getEditable();this.$().toggleClass("sapMTCEditable",e);for(var i=0;i<t.length;i++){var o=t[i];if(o instanceof sap.m.Tile){o.isEditable(e);}}return this;};
a.prototype.updateTiles=function(){this.destroyTiles();this.updateAggregation('tiles');};
a.prototype._applyDimension=function(){var d=this._getDimension(),$=this.$(),t,o=10,e=this.$("scrl"),s,f,p=this.$("pager").outerHeight();e.css({width:d.outerwidth+"px",height:(d.outerheight-p)+"px"});t=$.position();s=e.position();f=e.outerHeight();if(D.system.phone){o=2;}else if(D.system.desktop){o=0;}this.$("blind").css({top:(s.top+o)+"px",left:(s.left+o)+"px",right:"auto",width:(e.outerWidth()-o)+"px",height:(f-o)+"px"});this.$("rightedge").css({top:(t.top+o)+"px",right:o+"px",left:"auto",height:(f-o)+"px"});this.$("leftedge").css({top:(t.top+o)+"px",left:(t.left+o)+"px",right:"auto",height:(f-o)+"px"});};
a.prototype._resize=function(){if(this._oDragSession){return;}setTimeout(q.proxy(function(){var v=this._getVisibleTiles(),t=v.length,d=this._iCurrentTileStartIndex,o=this._oDim,n,N,e;this._oPagesInfo.reset();this._oDim=this._calculateDimension();this._updateTileDimensionInfoAndPageSize(v);if(o.width!==this._oDim.width||o.height!==this._oDim.height){for(var i=0;i<t;i++){if(v[i]._rendered){v[i]._rendered=false;v[i].$().remove();}}n=this._getPageNumberForTile(d);N=n*this._iMaxTiles;e=N+this._iMaxTiles-1;this._renderTiles(v,N,e);}},this),0);};
a.prototype.exit=function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}if(D.system.tablet||D.system.phone){D.orientation.detachHandler(this._fnOrientationChange,this);}delete this._oPagesInfo;};
a.prototype._update=function(A,v){if(!this.getDomRef()){return;}if(!this.getVisible()){return;}v=v||this._getVisibleTiles();this._oTileDimensionCalculator.calc(v);this._updateTilePositions(v);if(!this._oDragSession){this.scrollIntoView(this._iCurrentTileStartIndex||0,A,v);}};
a.prototype.getPageFirstTileIndex=function(){return this._iCurrentTileStartIndex||0;};
a.prototype.moveTile=function(t,n){if(!isNaN(t)){t=this._getVisibleTiles()[t];}if(!t){L.info("No Tile to move");return this;}this.deleteTile(t);this.insertTile(t,n);return this;};
a.prototype.addTile=function(t){this.insertTile(t,this.getTiles().length);return this;};
a.prototype.insertTile=function(t,i){var d=this,v;t.isEditable(this.getEditable());if(D.system.desktop||D.system.combi){t.addEventDelegate({"onAfterRendering":function(){if(!d._mFocusables){d._mFocusables={};}d._mFocusables[this.getId()]=this.$().find("[tabindex!='-1']").addBack().filter(d._isFocusable);d._mFocusables[this.getId()].attr('tabindex','-1');}},t);var o=function(e){var i=d._getVisibleTiles().indexOf(this),E=Math.floor(i/d._iMaxTiles),p=E-d._oPagesInfo.getCurrentPage();var P=d._iCurrentFocusIndex>=0?d._iCurrentFocusIndex:0;var V=d._getVisibleTiles();var f=V[P];if(f){d._mFocusables[f.getId()].attr("tabindex","-1");d._mFocusables[this.getId()].attr("tabindex","0");}if(p!=0){d.scrollIntoView(i,null,V);}d._handleAriaActiveDescendant();d._iCurrentFocusIndex=i;};t.addEventDelegate({"onfocusin":o},t);}if(this.getDomRef()){this.insertAggregation("tiles",t,i,true);v=this._getVisibleTiles();if(!this._oDragSession){if(t.getVisible()&&(v.length===1||this._getPageNumberForTile(i)<=this._oPagesInfo.getCurrentPage())){this._renderTile(t,i);this._update(false,v);}else{this._oPagesInfo.setCount(Math.ceil(v.length/this._iMaxTiles));this._updatePager();}}else{this._update(false,v);}if(D.system.desktop||D.system.combi){this._updateTilesTabIndex(v);}}else{this.insertAggregation("tiles",t,i);v=this._getVisibleTiles();}if(t.getVisible()){c.call(this,i,v.length,v);h.call(this,v);}return this;};
a.prototype._updateTilesTabIndex=function(v){v=v||this._getVisibleTiles();if(v.length&&v.length>0){for(var i=0;i<v.length;i++){if(v[i].$().attr("tabindex")==="0"){return;}}}v[0].$().attr("tabindex","0");};
a.prototype._isFocusable=function(i,e){var d=!isNaN(q(e).attr("tabindex"));var n=e.nodeName.toLowerCase();if(n==="area"){var m=e.parentNode,f=m.name,g;if(!e.href||!f||m.nodeName.toLowerCase()!=="map"){return false;}g=q("img[usemap='#"+f+"']")[0];return!!g;}return(/input|select|textarea|button|object/.test(n)?!e.disabled:n=="a"?e.href||d:d);};
a.prototype.deleteTile=function(t){var v=this._getVisibleTiles(),d=this._indexOfVisibleTile(t,v);if(this.getDomRef()){v.splice(d,1);this.removeAggregation("tiles",t,true);if(!this._oDragSession){if(t.getDomRef()){t.getDomRef().parentNode.removeChild(t.getDomRef());}if(D.system.desktop||D.system.combi){if(this._mFocusables&&this._mFocusables[t.getId()]){delete this._mFocusables[t.getId()];}}}if(v.length===0){this._oPagesInfo.reset();}else if(t.getVisible()&&d>=0&&this._getPageNumberForTile(d)<=this._oPagesInfo.getCurrentPage()){this._renderTilesInTheSamePage(this._oPagesInfo.getCurrentPage()*this._iMaxTiles,v);}this._update(false);}else{this.removeAggregation("tiles",t,false);v=this._getVisibleTiles();}c.call(this,d,v.length);h.call(this,v);return this;};
a.prototype.removeTile=a.prototype.deleteTile;
a.prototype.removeAllTiles=function(){var t=this.getTiles().length-1;for(var i=t;i>=0;i--){var o=this.getTiles()[i];this.deleteTile(o);}return this;};
a.prototype.destroyTiles=function(){if(this.getDomRef()){var t=this.getTiles();this.removeAllAggregation("tiles",true);this._oPagesInfo.reset();this._update();for(var i=0;i<t.length;i++){var d=t[i];d.destroy();}}else{this.destroyAggregation("tiles",false);}return this;};
a.prototype.rerender=function(){if(!this._oDragSession||this._oDragSession.bDropped){C.prototype.rerender.apply(this);}};
a.prototype.scrollLeft=function(){var s=0,v=this._getVisibleTiles();if(this._bRtl){s=this._iCurrentTileStartIndex+this._iMaxTiles;}else{s=this._iCurrentTileStartIndex-this._iMaxTiles;}this._renderTiles(v,s,s+this._iMaxTiles-1);this.scrollIntoView(s,null,v);};
a.prototype.scrollRight=function(){var s=0,v=this._getVisibleTiles();if(this._bRtl){s=this._iCurrentTileStartIndex-this._iMaxTiles;}else{s=this._iCurrentTileStartIndex+this._iMaxTiles;}this._renderTiles(v,s,s+this._iMaxTiles-1);this.scrollIntoView(s,null,v);};
a.prototype._renderTilesInTheSamePage=function(t,d){var i=this._getPageNumberForTile(t),f=i*this._iMaxTiles,e=f+this._iMaxTiles-1;this._renderTiles(d,f,e);};
a.prototype._renderTiles=function(t,s,e){var n=false,i;for(i=s;i<=e;i++){if(t[i]&&!t[i]._rendered){this._renderTile(t[i],i);n=true;}}if(n){this._update(false,t);if(D.system.desktop||D.system.combi){this._updateTilesTabIndex();}}};
a.prototype.scrollIntoView=function(t,A,v){var i=this._getContentDimension().outerwidth,d=t,e=this.getTiles();if(isNaN(t)){d=this.indexOfAggregation("tiles",t);}if(!e[d]||!e[d].getVisible()){return;}v=v||this._getVisibleTiles();d=this._indexOfVisibleTile(e[d]);if(d>-1){this._renderTilesInTheSamePage(d,v);}this._applyPageStartIndex(d,v);this._oPagesInfo.setCurrentPage(Math.floor(this._iCurrentTileStartIndex/this._iMaxTiles));if(this._bRtl){this._scrollTo((this._oPagesInfo.getCount()-this._oPagesInfo.getCurrentPage())*i,A);}else{this._scrollTo(this._oPagesInfo.getCurrentPage()*i,A);}this._updatePager();};
a.prototype._updateTilePositions=function(v){var d=this._getDimension();if(d.height===0){return;}v=v||this._getVisibleTiles();if(v.length===0){this._oPagesInfo.setCount(0);this._updatePager();return;}this._applyPageStartIndex(this._iCurrentTileStartIndex,v);this._applyDimension();var o=this._getContentDimension();this._oPagesInfo.setCount(Math.ceil(v.length/this._iMaxTiles));var t=this._oTileDimensionCalculator.getLastCalculatedDimension();for(var i=0;i<v.length;i++){if(!v[i]._rendered||v[i].isDragged()){continue;}var p=Math.floor(i/this._iMaxTiles),e=v[i],f=(p*o.outerwidth)+this._iOffsetX+i%this._iMaxTilesX*t.width,g=this._iOffsetY+Math.floor(i/this._iMaxTilesX)*t.height-(p*this._iMaxTilesY*t.height);if(this._bRtl){f=(this._oPagesInfo.getCount()-p)*o.outerwidth-this._iOffsetX-(i%this._iMaxTilesX+1)*t.width;}e.setPos(f,g);e.setSize(t.width,t.height);}};
a.prototype._findTile=function($){if($.hasClass('sapMTile')||$.hasClass('sapMCustomTile')){return $;}else{return $.find('.sapMTile')||$.find('.sapMCustomTile');}};
a.prototype._updatePager=function(){var p,s,S,H,P=false;if(!this._oPagesInfo.pageCountChanged()&&!this._oPagesInfo.currentPageChanged()){return;}p=this.$("pager")[0];s=this.$("leftscroller")[0];S=this.$("rightscroller")[0];if(this._oPagesInfo.getCount()==undefined||this._oPagesInfo.getCount()<=1){p.innerHTML="";S.style.right="-100px";s.style.left="-100px";s.style.display="none";S.style.display="none";this._oPagesInfo.setPagerCreated(false);return;}if(!this._oPagesInfo.isPagerCreated()){H=[""];for(var i=0;i<this._oPagesInfo.getCount();i++){H.push("");}p.innerHTML=H.join("<span></span>");p.style.display="block";p.childNodes[0].className="sapMTCActive";this._oPagesInfo.setPagerCreated(true);P=true;}else if(this._oPagesInfo.pageCountChanged()){if(this._oPagesInfo.getCount()-this._oPagesInfo.getOldCount()<0){p.removeChild(p.lastChild);}else{p.appendChild(document.createElement("span"));}}if(this._oPagesInfo.currentPageChanged()){p.childNodes[this._oPagesInfo.getCurrentPage()].className="sapMTCActive";if(p.childNodes[this._oPagesInfo.getOldCurrentPage()]){p.childNodes[this._oPagesInfo.getOldCurrentPage()].className="";}if(this._oPagesInfo.getCurrentPage()>=1){p.childNodes[0].className="";}}if(D.system.desktop&&(P||this._oPagesInfo.currentPageRelativePositionChanged())){if(this._bRtl){S.style.left="auto";s.style.right="auto";}S.style.right=this._oPagesInfo.currentPageIsLast()?"-100px":"1rem";s.style.left=this._oPagesInfo.currentPageIsFirst()?"-100px":"1rem";S.style.display=this._oPagesInfo.currentPageIsLast()?"none":"block";s.style.display=this._oPagesInfo.currentPageIsFirst()?"none":"block";}this._oPagesInfo.syncOldToCurrentValues();};
a.prototype._getContentDimension=function(){if(!this.getDomRef()){return;}var s=this.$("scrl");return{width:s.width(),height:s.height()-20,outerheight:s.outerHeight()-20,outerwidth:s.outerWidth()};};
a.prototype._getDimension=function(){if(!this._oDim){this._oDim=this._calculateDimension();}return this._oDim;};
a.prototype._calculatePageSize=function(v){var d,t;v=v||this._getVisibleTiles();t=v.length;if(t===0){return;}d=q.extend({},this._getDimension());if(d.height===0){return;}if(D.system.desktop){d.width-=45*2;}var o=this._oTileDimensionCalculator.getLastCalculatedDimension(),p=this.$("pager")[0].offsetHeight,m=Math.max(Math.floor(d.width/o.width),1),M=Math.max(Math.floor((d.height-p)/o.height),1),n=(t<m)?t:m,N=(t/n<M)?Math.ceil(t/n):M;this._iMaxTiles=m*M;this._iMaxTilesX=m;this._iMaxTilesY=M;this._iOffsetX=Math.floor((d.width-(o.width*n))/2);if(D.system.desktop){this._iOffsetX+=45;}this._iOffsetY=Math.floor((d.height-p-(o.height*N))/2);};
a.prototype._getTilesFromPosition=function(x,y){if(!this._getVisibleTiles().length){return[];}x=x+this._iScrollLeft;var t=this._getVisibleTiles(),r=[];for(var i=0;i<t.length;i++){var o=t[i],d={top:o._posY,left:o._posX,width:o._width,height:o._height};if(!t[i].isDragged()&&y>d.top&&y<d.top+d.height&&x>d.left&&x<d.left+d.width){r.push(t[i]);}}return r;};
a.prototype._applyPageStartIndex=function(i,v){var o=this._getDimension();if(o.height===0){return;}v=v||this._getVisibleTiles();this._calculatePageSize(v);var d=v.length;if(i<0){i=0;}else if(i>d-1){i=d-1;}var e=Math.floor(i/this._iMaxTiles||0);this._iCurrentTileStartIndex=e*(this._iMaxTiles||0);L.info("current index "+this._iCurrentTileStartIndex);};
a.prototype._scrollTo=function(s,A){if(A!==false){A=true;}this._applyTranslate(this.$("cnt"),-s,0,A);if(this._bRtl){this._iScrollLeft=s-this._getContentDimension().outerwidth;}else{this._iScrollLeft=s;}};
a.prototype._applyTranslate=function(d,x,y,A){var o=d[0];this.$("cnt").toggleClass("sapMTCAnim",A);if("webkitTransform"in o.style){d.css('-webkit-transform','translate3d('+x+'px,'+y+'px,0)');}else if("MozTransform"in o.style){d.css('-moz-transform','translate('+x+'px,'+y+'px)');}else if("transform"in o.style){d.css('transform','translate3d('+x+'px,'+y+'px,0)');}else if("msTransform"in o.style){d.css('-ms-transform','translate('+x+'px,'+y+'px)');}};
a.prototype._initTouchSession=function(e){if(e.type=="touchstart"){var t=e.targetTouches[0];this._oTouchSession={dStartTime:new Date(),fStartX:t.pageX,fStartY:t.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:t.pageX-e.target.offsetLeft};}else{this._oTouchSession={dStartTime:new Date(),fStartX:e.pageX,fStartY:e.pageY,fDiffX:0,fDiffY:0,oControl:e.srcControl,iOffsetX:e.pageX-e.target.offsetLeft};}};
a.prototype._initDragSession=function(e){while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}var i=this.indexOfAggregation("tiles",e.srcControl);if(e.type=="touchstart"){this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.targetTouches[0].pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.targetTouches[0].pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.targetTouches[0].pageX,iDiffY:e.targetTouches[0].pageY};}else{this._oDragSession={oTile:e.srcControl,oTileElement:e.srcControl.$()[0],iOffsetLeft:e.pageX-e.srcControl._posX+this._iScrollLeft,iOffsetTop:e.pageY-e.srcControl._posY,iIndex:i,iOldIndex:i,iDiffX:e.pageX,iDiffY:e.pageY};}};
a.prototype.onclick=function(e){var p=this.$("pager")[0];if(e.target.id==this.getId()+"-leftscroller"||e.target.parentNode.id==this.getId()+"-leftscroller"){this.scrollLeft();}else if(e.target.id==this.getId()+"-rightscroller"||e.target.parentNode.id==this.getId()+"-rightscroller"){this.scrollRight();}else if(e.target==p&&D.system.desktop){if(e.offsetX<p.offsetWidth/2){this.scrollLeft();}else{this.scrollRight();}}};
a.prototype.ontouchstart=function(e){e.setMarked();if(e.targetTouches.length>1||this._oTouchSession){return;}while(e.srcControl&&e.srcControl.getParent()!=this){e.srcControl=e.srcControl.getParent();}if(e.srcControl instanceof sap.m.Tile&&this.getEditable()){if(e.target.className!="sapMTCRemove"){this._initDragSession(e);this._initTouchSession(e);this._oDragSession.oTile.isDragged(true);}else{this._initTouchSession(e);}this._bAvoidChildTapEvent=true;}else{this._initTouchSession(e);}q(document).on("touchmove mousemove",q.proxy(this._onmove,this));q(document).on("touchend touchcancel mouseup",q.proxy(this._onend,this));};
a.prototype._onmove=function(e){if(document.selection&&document.selection.clear){document.selection.clear();}if(e.isMarked("delayedMouseEvent")){return;}if(e.targetTouches&&e.targetTouches.length>1){return;}if(!e.targetTouches){e.targetTouches=[{pageX:e.pageX,pageY:e.pageY}];}var t=this._oTouchSession;t.fDiffX=t.fStartX-e.targetTouches[0].pageX;t.fDiffY=t.fStartY-e.targetTouches[0].pageY;if(this._oDragSession){if(Math.abs(t.fDiffX)>5){if(!this._oDragSession.bStarted){this._oDragSession.bStarted=true;this._onDragStart(e);}else{this._onDrag(e);}this._bAvoidChildTapEvent=true;}}else if(t){var d=this._getContentDimension().outerwidth;var n=-this._iScrollLeft-t.fDiffX;if(n>this._iScrollGap){return;}else if(n<-(((this._oPagesInfo.getCount()-1)*d)+this._iScrollGap)){return;}if(this._bRtl){n=n-d;}var v=this._getVisibleTiles();var i=t.fDiffX>0?1:-1;var g=this._iCurrentTileStartIndex+i*this._iMaxTiles;var G=g+this._iMaxTiles-1;this._renderTiles(v,g,G);this._applyTranslate(this.$("cnt"),n,0,false);}};
a.prototype._onend=function(e){if(e.isMarked("delayedMouseEvent")){return;}q(document).off("touchend touchcancel mouseup",this._onend);q(document).off("touchmove mousemove",this._onmove);if(this._oDragSession){this._onDrop(e);delete this._oTouchSession;return;}if(!this._oTouchSession){return;}var t=this._oTouchSession,d=new Date(),f=(d-t.dStartTime<600),r=this._bRtl?-1:1;if(f){var p=this.$("pager")[0];if(Math.abs(t.fDiffX)>30){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}else if(e.target==p&&!D.system.desktop){if((t.iOffsetX-p.offsetWidth/2)*r<0){this.scrollLeft();}else{this.scrollRight();}this._bAvoidChildTapEvent=true;}else if(e.target.className=="sapMTCRemove"){if(e.type==="touchend"||(e.type==="mouseup"&&e.button===0)){this.fireTileDelete({tile:t.oControl});}}}else{var o=this._getContentDimension();if(Math.abs(t.fDiffX)>o.outerwidth/2){this._applyPageStartIndex(this._iCurrentTileStartIndex+((t.fDiffX*r>0?1:-1)*this._iMaxTiles));this._bAvoidChildTapEvent=true;}}this._update();delete this._oDragSession;delete this._oTouchSession;var g=this;setTimeout(function(){g._bAvoidChildTapEvent=false;},100);};
a.prototype._onDragStart=function(e){this.$().append(this._oDragSession.oTileElement);this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;this._oDragSession.oTile.setPos(this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,this._oDragSession.iDiffY-this._oDragSession.iOffsetTop);this.$("blind").css("display","block");};
a.prototype._onDrag=function(e){if(!this._oTouchSession){clearTimeout(this.iScrollTimer);this._oDragSession=null;this.iScrollTimer=null;this._bTriggerScroll=false;return;}this._oDragSession.iDiffX=this._oTouchSession.fStartX-this._oTouchSession.fDiffX;this._oDragSession.iDiffY=this._oTouchSession.fStartY-this._oTouchSession.fDiffY;var o=this._getContentDimension(),t=this._oDragSession.iDiffY-this._oDragSession.iOffsetTop,i=this._oDragSession.iDiffX-this._oDragSession.iOffsetLeft,m=t+(this._oDragSession.oTileElement.offsetHeight/2),d=i+(this._oDragSession.oTileElement.offsetWidth/2),s=i+this._oDragSession.oTileElement.offsetWidth-this._iTriggerScrollOffset>o.width,S=i<-this._iTriggerScrollOffset,n=o.width-(i+this._oDragSession.oTileElement.offsetWidth),N=i;this._oDragSession.oTile.setPos(i,t);this._oDragSession.oTile.$().css("clip","auto");var r=this.$("rightedge")[0];if(i+this._oDragSession.oTile._width>r.offsetLeft+r.offsetWidth&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1){var f=r.offsetLeft+r.offsetWidth-i-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)-2;this._oDragSession.oTile.$().css("clip","rect(-25px,"+f+"px,"+(this._oDragSession.oTile._height+20)+"px,-25px)");}var g=this.$("leftedge")[0];if(i<g.offsetLeft+2+((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2)&&this._oPagesInfo.getCurrentPage()>0){var j=g.offsetLeft+4-i-((this._oDragSession.oTile._width-this._oDragSession.oTile.$().outerWidth(false))/2);this._oDragSession.oTile.$().css("clip","rect(-25px,"+this._oDragSession.oTile._width+"px,"+(this._oDragSession.oTile._height+20)+"px,"+j+"px)");}if(n<this._iEdgeShowStart&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1){var O=(this._iEdgeShowStart-n)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("rightedge").css("opacity",""+O);}else{this.$("rightedge").css("opacity","0.01");}if(N<this._iEdgeShowStart&&this._oPagesInfo.getCurrentPage()>0){var O=(this._iEdgeShowStart-N)/(this._iEdgeShowStart+this._iTriggerScrollOffset);this.$("leftedge").css("opacity",""+O);}else{this.$("leftedge").css("opacity","0.01");}var k;if(this._bRtl){k=s&&this._oPagesInfo.getCurrentPage()>0||S&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1;}else{k=S&&this._oPagesInfo.getCurrentPage()>0||s&&this._oPagesInfo.getCurrentPage()<this._oPagesInfo.getCount()-1;}if(k){if(this._bTriggerScroll){S?this.scrollLeft():this.scrollRight();}else{var p=this;if(!this.iScrollTimer){this.iScrollTimer=setInterval(function(){p._bTriggerScroll=true;p._onDrag(e);p._bTriggerScroll=false;},1000);}}return;}else{if(this.iScrollTimer){clearTimeout(this.iScrollTimer);this._bTriggerScroll=false;this.iScrollTimer=null;}}var H=this._getTilesFromPosition(d,m);if(H&&H.length>0){var u=H[0],v={top:u._posY,left:u._posX,width:u._width,height:u._height};var w=this.indexOfAggregation("tiles",u);if(d+this._iScrollLeft<((v.left+v.width)/2)&&(w%this._iMaxTilesX)!=0){w--;}this._oDragSession.iIndex=w;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}else if(this._oPagesInfo.getCurrentPage()==this._oPagesInfo.getCount()-1){var x=this._getVisibleTiles(),y=x[x.length-1];if(y&&d>y._posX-this._iScrollLeft&&m>y._posY){this._oDragSession.iIndex=x.length-1;this.moveTile(this._oDragSession.oTile,this._oDragSession.iIndex);}}};
a.prototype._onDrop=function(e){if(this._oDragSession){var t=this._oDragSession.oTile,i=this._oDragSession.iIndex;this._oDragSession.oTile.isDragged(false);if(this._oDragSession.iOldIndex!=this._oDragSession.iIndex){this.fireTileMove({tile:t,newIndex:i});}this.$("blind").css("display","block");if(this._oDragSession.bStarted){this._oDragSession.oTile.setPos(this._oDragSession.oTile._posX+this._iScrollLeft,this._oDragSession.oTile._posY);}this._oDragSession.oTile.$().css("clip","auto");this.$("rightedge").css("opacity","0.01");this.$("leftedge").css("opacity","0.01");this.$("cnt").append(this._oDragSession.oTileElement);delete this._oDragSession;this.moveTile(t,i);this.scrollIntoView(t,false);if(D.system.desktop||D.system.combi){this._findTile(t.$()).trigger("focus");}this._handleAriaActiveDescendant();this.$("blind").css("display","none");}};
a.prototype._handleAriaActiveDescendant=function(){var A=q(document.activeElement).control(0);if(A instanceof sap.m.Tile&&A.getParent()===this){this.getDomRef().setAttribute("aria-activedescendant",A.getId());}};
a.prototype._renderTile=function(t,i){var r=sap.ui.getCore().createRenderManager(),o=this.$("cnt")[0];r.renderControl(t);r.flush(o,false,i);r.destroy();};
a.prototype.onThemeChanged=function(){if(this.getDomRef()){this.invalidate();}};
a.prototype._calculateDimension=function(){var d=this.$();if(!d){return;}return{width:d.width(),height:d.height(),outerheight:d.outerHeight(),outerwidth:d.outerWidth()};};
a.prototype._getVisibleTiles=function(){var r=[],t=this.getTiles();for(var i=0,d=t.length;i<d;i++){if(t[i].mProperties["visible"]){r.push(t[i]);}}return r;};
a.prototype._indexOfVisibleTile=function(t,d){var i,e;d=d||this._getVisibleTiles();e=d.length;for(i=0;i<e;i++){if(d[i]===t){return i;}}return-1;};
a.prototype._updateTileDimensionInfoAndPageSize=function(v){v=v||this._getVisibleTiles();this._oTileDimensionCalculator.calc(v);this._calculatePageSize(v);};
a.prototype._getPageNumberForTile=function(t){return Math.floor((t/this._iMaxTiles)||0);};
var b=function(t){this._oDim=null;this._oTileContainer=t;};
b.prototype.calc=function(v){var V,t;if(!this._oTileContainer.getDomRef()){return;}V=v||this._oTileContainer._getVisibleTiles();if(V.length){t=V[0];for(var i=0,d=V.length;i<d;i++){if(V[i]._rendered){t=V[i];break;}}this._oDim={width:Math.round(t.$().outerWidth(true)),height:Math.round(t.$().outerHeight(true))};}return this._oDim;};
b.prototype.getLastCalculatedDimension=function(){return this._oDim;};
function h(v){var t,i,o;v=v||this._getVisibleTiles();t=v.length;for(i=0;i<t;i++){o=v[i];if(o._rendered&&o.getDomRef()){o.getDomRef().setAttribute("aria-setsize",t);}}}
function c(s,e,v){var i,t=null;v=v||this._getVisibleTiles();for(i=s;i<e;i++){t=v[i];if(t){t.$().attr('aria-posinset',this._indexOfVisibleTile(t,v)+1);}}}
return a;});
sap.ui.predefine('sap/m/TileContainerRenderer',[],function(){"use strict";var T={};T.DEFAULT_TILES_TO_RENDER=1;
T.render=function(r,c){var i=c.getId();r.write("<div tabindex=\"-1\"");r.writeControlData(c);r.addStyle("height",c.getHeight());r.addStyle("width",c.getWidth());r.writeStyles();r.addClass("sapMTC");r.writeClasses();r.writeAccessibilityState(c,{role:"listbox",multiSelectable:false,activeDescendant:c.getTiles().length>0?c.getTiles()[0].getId():""});r.write(" >");r.write("<div id=\""+i+"-scrl\" class=\"sapMTCScrl\" style=\"height:0px;");if(!c.bRtl){r.write(" overflow: hidden;");}r.write("\">");r.write("<div id=\""+i+"-blind\" class=\"sapMTCBlind\"></div>");r.write("<div id=\""+i+"-cnt\" class=\"sapMTCCnt sapMTCAnim\" style=\"height:0px; width:0px;\" role=\"group\">");this.renderTiles(c,r);r.write("</div>");r.write("</div>");r.write("<div id=\""+i+"-pager\" class=\"sapMTCPager\">");r.write("</div>");r.write("<div id=\""+i+"-leftedge\" class=\"sapMTCEdgeLeft\"></div>");r.write("<div id=\""+i+"-rightedge\" class=\"sapMTCEdgeRight\"></div>");r.write("<div id=\""+i+"-leftscroller\" class=\"sapMTCScroller sapMTCLeft\" tabindex=\"-1\"><div class=\"sapMTCInner\" ></div></div>");r.write("<div id=\""+i+"-rightscroller\" class=\"sapMTCScroller sapMTCRight\" tabindex=\"-1\"><div class=\"sapMTCInner\" ></div></div>");r.write("</div>");};
T.renderTiles=function(t,r){var a=t.getTiles(),i=0,R=0,m;if(!a.length){return;}m=this._getCountOfTilesToRender(t,a);if(m===T.DEFAULT_TILES_TO_RENDER){t._bRenderFirstPage=true;}do{if(a[i]&&a[i].getVisible()){a[i]._setVisible(false);r.renderControl(a[i]);R++;}i++;}while(R!==m&&(i<a.length));};
T._getCountOfTilesToRender=function(t,a){if(t._iMaxTiles){return t._iMaxTiles;}if(a.length>T.DEFAULT_TILES_TO_RENDER){return T.DEFAULT_TILES_TO_RENDER;}return a.length;};
return T;},true);
sap.ui.predefine('sap/m/TileContent',['./library','sap/ui/core/Control','./TileContentRenderer'],function(l,C,T){"use strict";
var a=C.extend("sap.m.TileContent",{metadata:{library:"sap.m",properties:{"footer":{type:"string",group:"Appearance",defaultValue:null},"footerColor":{type:"sap.m.ValueColor",group:"Appearance",defaultValue:"Neutral"},"size":{type:"sap.m.Size",group:"Appearance",defaultValue:"Auto"},"unit":{type:"string",group:"Data",defaultValue:null},"disabled":{type:"boolean",group:"Behavior",defaultValue:false},"frameType":{type:"sap.m.FrameType",group:"Appearance",defaultValue:"Auto"}},defaultAggregation:"content",aggregations:{"content":{type:"sap.ui.core.Control",multiple:false,bindable:"bindable"}}}});
a.prototype.init=function(){this._bRenderFooter=true;this._bRenderContent=true;};
a.prototype.onBeforeRendering=function(){if(this.getContent()&&this._oDelegate){if(this.getDisabled()){this.getContent().addDelegate(this._oDelegate);}else{this.getContent().removeDelegate(this._oDelegate);}}};
a.prototype.onAfterRendering=function(){var c=this.getContent();if(c){var t=this.$();if(!t.attr("title")){var s=c.getTooltip_AsString();var b=t.find("*");b.removeAttr("title");if(s&&s.trim().length!==0){if(this._getFooterText().trim()!==0){s=s+"\n"+this._getFooterText();}t.attr("title",s);}}}};
a.prototype._getContentType=function(){if(this.getContent()){var c=this.getContent().getMetadata().getName();if(c==="sap.m.NewsContent"||c==="sap.suite.ui.commons.NewsContent"){return"News";}}};
a.prototype._getFooterText=function(){var r=sap.ui.getCore().getLibraryResourceBundle('sap.m');var f=this.getFooter();var u=this.getUnit();if(u){if(f){if(sap.ui.getCore().getConfiguration().getRTL()){return r.getText('TILECONTENT_FOOTER_TEXT',[f,u]);}else{return r.getText('TILECONTENT_FOOTER_TEXT',[u,f]);}}else{return u;}}else{return f;}};
a.prototype.getAltText=function(){var A="";var i=true;var c=this.getContent();if(c){if(c.getAltText){A+=c.getAltText();i=false;}else if(c.getTooltip_AsString()){A+=c.getTooltip_AsString();i=false;}}if(this.getUnit()){A+=(i?"":"\n")+this.getUnit();i=false;}if(this.getFooter()){A+=(i?"":"\n")+this.getFooter();}return A;};
a.prototype.getTooltip_AsString=function(){var t=this.getTooltip();var A="";if(typeof t==="string"||t instanceof String){return t;}A=this.getAltText();return A?A:"";};
a.prototype.setRenderFooter=function(v){this._bRenderFooter=v;return this;};
a.prototype.setRenderContent=function(v){this._bRenderContent=v;return this;};
return a;});
sap.ui.predefine('sap/m/TileContentRenderer',["sap/base/security/encodeCSS"],function(e){"use strict";var T={};
T.render=function(r,c){var t=c.getTooltip_AsString();var C=c._getContentType();if(C){C=e(C);}var f=e("sapMFrameType"+c.getFrameType());r.write("<div");r.writeControlData(c);r.addClass("sapMTileCnt");r.addClass(C);r.addClass(f);if(t.trim()){r.writeAttributeEscaped("title",t);}r.writeClasses();r.write(">");this._renderContent(r,c);this._renderFooter(r,c);r.write("</div>");};
T._renderContent=function(r,c){if(!c._bRenderContent){return;}var C=c.getContent();if(C){r.write("<div");r.addClass("sapMTileCntContent");r.writeClasses();r.writeAttribute("id",c.getId()+"-content");r.write(">");if(!C.hasStyleClass("sapMTcInnerMarker")){C.addStyleClass("sapMTcInnerMarker");}r.renderControl(C);r.write("</div>");}};
T._renderFooter=function(r,c){if(!c._bRenderFooter){return;}var C="sapMTileCntFooterTextColor"+c.getFooterColor();var t=c.getTooltip_AsString();var f=c._getFooterText(r,c);r.write("<div");r.addClass("sapMTileCntFtrTxt");r.addClass(e(C));r.writeClasses();r.writeAttribute("id",c.getId()+"-footer-text");if(t.trim()){r.writeAttributeEscaped("title",t);}r.write(">");r.writeEscaped(f);r.write("</div>");};
return T;},true);
sap.ui.predefine('sap/m/TileRenderer',[],function(){"use strict";var T={};
T.render=function(r,c){var t,v;r.write("<div tabindex=\"0\"");r.writeControlData(c);r.addClass("sapMTile");r.addClass("sapMPointer");r.writeClasses();if(c._invisible){r.addStyle("visibility","hidden");r.writeStyles();}var s=c.getTooltip_AsString();if(s){r.writeAttributeEscaped("title",s);}if(c.getParent()instanceof sap.m.TileContainer){t=c.getParent();v=t._getVisibleTiles();r.writeAccessibilityState(c,{role:"option",posinset:t._indexOfVisibleTile(c,v)+1,setsize:v.length});}r.write(">");if(c.getRemovable()){r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCRemove\"></div>");}else{r.write("<div id=\""+c.getId()+"-remove\" class=\"sapMTCNoRemove\"></div>");}r.write("<div class=\"sapMTileContent\">");this._renderContent(r,c);r.write("</div></div>");};
T._renderContent=function(r,c){};
return T;},true);
sap.ui.predefine('sap/m/TimePicker',['./InputBase','./DateTimeField','./MaskInputRule','./ResponsivePopover','sap/ui/core/EnabledPropagator','sap/ui/core/IconPool','./TimePickerSliders','./MaskEnabler','sap/ui/Device','sap/ui/core/format/DateFormat','sap/ui/core/Locale','sap/m/library','sap/ui/core/LocaleData','./TimePickerRenderer',"sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/InvisibleText",'./Button',"sap/ui/thirdparty/jquery"],function(I,D,M,R,E,a,T,b,c,d,L,l,e,f,K,g,h,B,q){"use strict";var P=l.PlacementType,j=l.TimePickerMaskMode,k=l.ButtonType,m=1;
var n=D.extend("sap.m.TimePicker",{metadata:{library:"sap.m",designtime:"sap/m/designtime/TimePicker.designtime",properties:{localeId:{type:"string",group:"Data"},title:{type:"string",group:"Misc",defaultValue:null},minutesStep:{type:"int",group:"Misc",defaultValue:m},secondsStep:{type:"int",group:"Misc",defaultValue:m},placeholderSymbol:{type:"string",group:"Misc",defaultValue:"_"},mask:{type:"string",group:"Misc",defaultValue:null},maskMode:{type:"sap.m.TimePickerMaskMode",group:"Misc",defaultValue:j.On},support2400:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{rules:{type:"sap.m.MaskInputRule",multiple:true,singularName:"rule"},_picker:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},dnd:{draggable:false,droppable:true}}});
a.insertFontFaceStyle();E.call(n.prototype,true);b.call(n.prototype);var o={Short:"short",Medium:"medium",Long:"long"},p={Hour:"hour",Minute:"minute",Second:"second"},r='-';
n.prototype.init=function(){D.prototype.init.apply(this,arguments);b.init.apply(this,arguments);this.setDisplayFormat(t());this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._bValid=false;this._sUsedDisplayPattern=null;this._sUsedValuePattern=null;this._oDisplayFormat=null;this._sValueFormat=null;this._oPopoverKeydownEventDelegate=null;this._rPlaceholderRegEx=new RegExp(r,'g');this._sLastChangeValue=null;var i=this.addEndIcon({id:this.getId()+"-icon",src:this.getIconSrc(),noTabStop:true,title:"",tooltip:this._oResourceBundle.getText("OPEN_PICKER_TEXT")});this._bShouldClosePicker=false;i.addEventDelegate({onmousedown:function(u){this._bShouldClosePicker=this.isOpen();}},this);i.attachPress(function(){this.toggleOpen(this._bShouldClosePicker);},this);};
n.prototype.onBeforeRendering=function(){D.prototype.onBeforeRendering.apply(this,arguments);var v=this._getValueHelpIcon();if(v){v.setProperty("visible",this.getEditable(),true);}};
n.prototype.exit=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}b.exit.apply(this,arguments);this._removePickerEvents();this._oResourceBundle=null;this._bValid=false;this._sUsedDisplayPattern=null;this._oDisplayFormat=null;this._oPopoverKeydownEventDelegate=null;this._sUsedValuePattern=null;this._sValueFormat=null;this._sLastChangeValue=null;};
n.prototype.getIconSrc=function(){return a.getIconURI("time-entry-request");};
n.prototype.isOpen=function(){return this._getPicker()&&this._getPicker().isOpen();};
n.prototype.toggleOpen=function(O){if(this.getEditable()&&this.getEnabled()){this[O?"_closePicker":"_openPicker"]();}};
n.prototype.onfocusin=function(i){var u=this._getPicker();var v=this._isIconClicked(i);b.onfocusin.apply(this,arguments);if(u&&u.isOpen()&&!v){this._closePicker();}};
n.prototype._isIconClicked=function(i){return q(i.target).hasClass("sapUiIcon")||q(i.target).hasClass("sapMInputBaseIconContainer");};
n.prototype.onBeforeOpen=function(){var S=this._getSliders(),i=this.getDateValue(),u=this._$input.val(),F=this.getValueFormat(),v=F.indexOf("HH"),w=F.indexOf("H");S.setValue(u);if(this._shouldSetInitialFocusedDateValue()){i=this.getInitialFocusedDateValue();}S._setTimeValues(i,T._isHoursValue24(u,v,w));S.collapseAll();this.$().addClass(I.ICON_PRESSED_CSS_CLASS);};
n.prototype.onAfterOpen=function(){var S=this._getSliders();if(S){S.openFirstSlider();this._handleAriaOnExpandCollapse();}};
n.prototype.onAfterClose=function(){this.$().removeClass(I.ICON_PRESSED_CSS_CLASS);this._handleAriaOnExpandCollapse();};
n.prototype._getValueHelpIcon=function(){var v=this.getAggregation("_endIcon");return v&&v[0];};
n.prototype._handleInputChange=function(v){var i,u,w,F=this.getValueFormat(),x=F.indexOf("HH"),y=F.indexOf("H");v=v||this._$input.val();u=v;w=T._isHoursValue24(u,x,y);this._bValid=true;if(v!==""){i=this._parseValue(w?T._replace24HoursWithZero(v,x,y):v,true);if(!i){this._bValid=false;}else{v=this._formatValue(i);if(this.getMask()){this._setupMaskVariables();}}}u=this.getSupport2400()&&w?"24:"+v.replace(/[0-9]/g,"0").slice(0,-3):v;this.updateDomValue(u);if(i){u=v=this._formatValue(i,true);}this.setProperty("value",u,true);this.setLastValue(v);if(this._bValid){this.setProperty("dateValue",i,true);}this.fireChangeEvent(u,{valid:this._bValid});return true;};
n.prototype.onChange=function(i){var v=i?i.value:null;if(this.getEditable()&&this.getEnabled()){return this._handleInputChange(v);}return false;};
n.prototype.setMinutesStep=function(i){var S=this._getSliders();i=Math.max(m,i||m);if(S){S.setMinutesStep(i);}return this.setProperty("minutesStep",i,true);};
n.prototype.setSecondsStep=function(i){var S=this._getSliders();i=Math.max(m,i||m);if(S){S.setSecondsStep(i);}return this.setProperty("secondsStep",i,true);};
n.prototype.setTitle=function(i){var S=this._getSliders();if(S){S.setLabelText(i);}this.setProperty("title",i,true);return this;};
n.prototype._handleDateValidation=function(i){if(!i){this._bValid=false;g.warning("Value can not be converted to a valid date",this);}else{this._bValid=true;this.setProperty("dateValue",i,true);var v=this._formatValue(i);if(this.isActive()){this.updateDomValue(v);}else{this.setProperty("value",v,true);this.setLastValue(v);this._sLastChangeValue=v;}}};
n.prototype.setSupport2400=function(S){var i=this._getSliders();this.setProperty("support2400",S,true);if(i){i.setSupport2400(S);}this._initMask();return this;};
n.prototype.setDisplayFormat=function(i){var S=this._getSliders();this.setProperty("displayFormat",i,true);this._initMask();if(S){S.setDisplayFormat(i);}var u=this.getDateValue();if(!u){return this;}var O=this._formatValue(u);this.updateDomValue(O);this.setLastValue(O);return this;};
n.prototype.setValue=function(v){var i,O,F=this.getValueFormat(),u=F.indexOf("HH"),w=F.indexOf("H"),S=this._getSliders();v=this.validateProperty("value",v);this._initMask();b.setValue.call(this,v);if(this.getMask()){this._setupMaskVariables();}this._sLastChangeValue=v;this._bValid=true;if(v){i=this._parseValue(T._isHoursValue24(v,u,w)?T._replace24HoursWithZero(v,u,w):v);if(!i){this._bValid=false;g.warning("Value can not be converted to a valid date",this);}}if(this._bValid){this.setProperty("dateValue",i,true);}if(i&&!this.getSupport2400()){O=this._formatValue(i);}else{O=v;}if(S){S.setValue(v);}this.updateDomValue(O);this.setLastValue(O);return this;};
n.prototype.setDateValue=function(v){this._initMask();return D.prototype.setDateValue.apply(this,arguments);};
n.prototype.setTooltip=function(v){var i=this.getDomRef(),u;this._refreshTooltipBaseDelegate(v);this.setAggregation("tooltip",v,true);if(!i){return this;}u=this.getTooltip_AsString();if(u){i.setAttribute("title",u);}else{i.removeAttribute("title");}return this;};
n.prototype.setLocaleId=function(i){var C=this.getValue(),S=this._getSliders();this.setProperty("localeId",i,true);this._initMask();this._oDisplayFormat=null;this._sValueFormat=null;if(C){this.setValue(C);}if(S){S.setLocaleId(i);}return this;};
n.prototype._getDefaultDisplayStyle=function(){return o.Medium;};
n.prototype._getDefaultValueStyle=function(){return o.Medium;};
n.prototype._getLocale=function(){var i=this.getLocaleId();return i?new L(i):sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();};
n.prototype._getFormatterInstance=function(F,i,u,C,v){var w=this._getLocale();if(i===o.Short||i===o.Medium||i===o.Long){F=d.getTimeInstance({style:i,strictParsing:true,relative:u},w);}else{F=d.getTimeInstance({pattern:i,strictParsing:true,relative:u},w);}if(v){this._sUsedDisplayPattern=i;this._oDisplayFormat=F;}else{this._sUsedValuePattern=i;this._sValueFormat=F;}return F;};
n.prototype._getFormat=function(){var F=this._getDisplayFormatPattern();if(!F){F=o.Medium;}if(Object.keys(o).indexOf(F)!==-1){F=t();}return F;};
n.prototype.onsappageup=function(i){this._increaseTime(1,p.Hour);i.preventDefault();};
n.prototype.onsappageupmodifiers=function(i){if(!(i.ctrlKey||i.metaKey||i.altKey)&&i.shiftKey){this._increaseTime(1,p.Minute);}if(!i.altKey&&i.shiftKey&&(i.ctrlKey||i.metaKey)){this._increaseTime(1,p.Second);}i.preventDefault();};
n.prototype.onsappagedown=function(i){this._increaseTime(-1,p.Hour);i.preventDefault();};
n.prototype.onsappagedownmodifiers=function(i){if(!(i.ctrlKey||i.metaKey||i.altKey)&&i.shiftKey){this._increaseTime(-1,p.Minute);}if(!i.altKey&&i.shiftKey&&(i.ctrlKey||i.metaKey)){this._increaseTime(-1,p.Second);}i.preventDefault();};
n.prototype.onkeydown=function(i){var u=K,v=i.which||i.keyCode,A=i.altKey,w;if(v===u.F4||(A&&(v===u.ARROW_UP||v===u.ARROW_DOWN))){w=this._getPicker()&&this._getPicker().isOpen();if(!w){this._openPicker();}else{this._closePicker();}i.preventDefault();}else{b.onkeydown.call(this,i);}};
n.prototype._getPicker=function(){return this.getAggregation("_picker");};
n.prototype._removePickerEvents=function(){var i,u=this._getPicker();if(u){i=u.getAggregation("_popup");if(typeof this._oPopoverKeydownEventDelegate==='function'){i.removeEventDelegate(this._oPopoverKeydownEventDelegate);}}};
n.prototype._openPicker=function(){var i=this._getPicker(),S;if(!i){i=this._createPicker(this._getDisplayFormatPattern());}i.open();S=this._getSliders();setTimeout(S._updateSlidersValues.bind(S),0);return i;};
n.prototype._closePicker=function(){var i=this._getPicker();if(i){i.close();}else{g.warning("There is no picker to close.");}return i;};
n.prototype._createPicker=function(F){var i=this,u,v,w,O,C,x,y=this.getAggregation("_endIcon")[0],z=this._getLocale().getLanguage(),A,G,H;w=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=w.getText("TIMEPICKER_SET");C=w.getText("TIMEPICKER_CANCEL");x=this.getTitle();v=new R(i.getId()+"-RP",{showCloseButton:false,showHeader:false,horizontalScrolling:false,verticalScrolling:false,placement:P.VerticalPreferedBottom,beginButton:new B({text:O,type:k.Emphasized,press:this._handleOkPress.bind(this)}),content:[new T(this.getId()+"-sliders",{support2400:this.getSupport2400(),displayFormat:F,valueFormat:this.getValueFormat(),labelText:x?x:"",localeId:z,minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep()})._setShouldOpenSliderAfterRendering(true)],contentHeight:n._PICKER_CONTENT_HEIGHT,ariaLabelledBy:h.getStaticId("sap.m","TIMEPICKER_SET_TIME"),beforeOpen:this.onBeforeOpen.bind(this),afterOpen:this.onAfterOpen.bind(this),afterClose:this.onAfterClose.bind(this)});u=v.getAggregation("_popup");if(u.setShowArrow){u.setShowArrow(false);}u.oPopup.setAutoCloseAreas([y]);if(c.system.phone){A=this.$("inner").attr("aria-labelledby");G=A&&A.split(" ")[0];H=G?document.getElementById(G).getAttribute("aria-label"):"";v.setTitle(H);v.setShowHeader(true);v.setShowCloseButton(true);}else{v.setEndButton(new B(this.getId()+"-Cancel",{text:C,press:this._handleCancelPress.bind(this)}));this._oPopoverKeydownEventDelegate={onkeydown:function(J){var N=K,Q=J.which||J.keyCode,S=J.altKey;if((S&&(Q===N.ARROW_UP||Q===N.ARROW_DOWN))||Q===N.F4){this._handleOkPress(J);this.focus();J.preventDefault();}}};u.addEventDelegate(this._oPopoverKeydownEventDelegate,this);u._afterAdjustPositionAndArrowHook=function(){i._getSliders()._onOrientationChanged();};}v.addStyleClass(this.getRenderer().CSS_CLASS+"DropDown");v.open=function(){return this.openBy(i);};this.setAggregation("_picker",v,true);return v;};
n.prototype._getSliders=function(){var i=this._getPicker();if(!i){return null;}return i.getContent()[0];};
n.prototype._handleOkPress=function(i){var u=this._getSliders().getTimeValues(),v=this._formatValue(u);this.updateDomValue(v);this._handleInputChange();this._closePicker();};
n.prototype._handleCancelPress=function(i){this._closePicker();};
n.prototype._getLocaleBasedPattern=function(i){return e.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(i);};
n.prototype._parseValue=function(v,i){if(i){v=this._oTimeSemanticMaskHelper.stripValueOfLeadingSpaces(v);v=v.replace(this._rPlaceholderRegEx,'');}return D.prototype._parseValue.call(this,v,i);};
n.prototype._formatValue=function(i,v){var V=D.prototype._formatValue.apply(this,arguments),F=this.getValueFormat(),u=F.indexOf("HH"),w=F.indexOf("H");if(i){if(!v&&this._oTimeSemanticMaskHelper){V=this._oTimeSemanticMaskHelper.formatValueWithLeadingTrailingSpaces(V);}}if(this.getSupport2400()&&this._getSliders()&&this._getSliders()._getHoursSlider().getSelectedValue()==="24"){V=T._replaceZeroHoursWith24(V,u,w);}return V;};
n.prototype._handleAriaOnExpandCollapse=function(){this.getFocusDomRef().setAttribute("aria-expanded",this._getPicker().isOpen());};
n.prototype._increaseTime=function(N,u){var O=this.getDateValue(),i,v;if(O&&this.getEditable()&&this.getEnabled()){i=new Date(O.getTime());switch(u){case p.Hour:i.setHours(i.getHours()+N);v=60*60*1000;break;case p.Minute:i.setMinutes(i.getMinutes()+N);v=60*1000;break;case p.Second:v=1000;i.setSeconds(i.getSeconds()+N);}if(N<0&&i.getTime()-O.getTime()!==N*v){i=new Date(O.getTime()+N*v);}this.setDateValue(i);this.fireChangeEvent(this.getValue(),{valid:true});}};
n.prototype._initMask=function(){if(this._oTimeSemanticMaskHelper){this._oTimeSemanticMaskHelper.destroy();}this._oTimeSemanticMaskHelper=new s(this);};
n.prototype._isMaskEnabled=function(){return this.getMaskMode()===j.On;};
n.prototype._shouldSetInitialFocusedDateValue=function(){if(!this._isValidValue()){return true;}return!this.getValue()&&!!this.getInitialFocusedDateValue();};
n.prototype._isValidValue=function(){return this._bValid;};
n.prototype.fireChangeEvent=function(v,i){if(v){v=v.trim();}if(v!==this._sLastChangeValue){this._sLastChangeValue=v;I.prototype.fireChangeEvent.call(this,v,i);}};
var s=function(u){var v=u._getDisplayFormatPattern(),w,A,x=u._getLocale(),i;if(u._checkStyle(v)){w=e.getInstance(x).getTimePattern(v);}else{v=v.replace(/'/g,"");w=v;}this._oTimePicker=u;this.aOriginalAmPmValues=e.getInstance(x).getDayPeriods("abbreviated");this.aAmPmValues=this.aOriginalAmPmValues.slice(0);this.iAmPmValueMaxLength=Math.max(this.aAmPmValues[0].length,this.aAmPmValues[1].length);for(i=0;i<this.aAmPmValues.length;i++){while(this.aAmPmValues[i].length<this.iAmPmValueMaxLength){this.aAmPmValues[i]+=" ";}}this.b24H=v.indexOf("H")!==-1;this.bLeadingZero=v.indexOf("HH")!==-1||v.indexOf("hh")!==-1;this.sLeadingChar=this.bLeadingZero?"0":" ";this.sAlternativeLeadingChar=this.bLeadingZero?" ":"0";this.sLeadingRegexChar=this.bLeadingZero?"0":"\\s";u.setPlaceholderSymbol(r);w=w.replace(/hh/ig,"h").replace(/h/ig,"h9");if(this.b24H){A="["+this.sLeadingRegexChar+"012]";}else{A="["+this.sLeadingRegexChar+"1]";}this._maskRuleHours=new M({maskFormatSymbol:"h",regex:A});u.addRule(this._maskRuleHours);this.iHourNumber1Index=w.indexOf("h9");this.iHourNumber2Index=this.iHourNumber1Index!==-1?this.iHourNumber1Index+1:-1;this.iMinuteNumber1Index=w.indexOf("mm");w=w.replace(/mm/g,"59");this.iSecondNumber1Index=w.indexOf("ss");w=w.replace(/ss/g,"59");this._maskRuleMinSec=new M({maskFormatSymbol:"5",regex:"[0-5]"});u.addRule(this._maskRuleMinSec);this.aAllowedHours=J.call(this,this.b24H,this.sLeadingChar);this.aAllowedMinutesAndSeconds=N.call(this);this.iAmPmChar1Index=w.indexOf("a");this.iAfterAmPmValueIndex=-1;if(this.iAmPmChar1Index!==-1){this.iAfterAmPmValueIndex=this.iAmPmChar1Index+this.iAmPmValueMaxLength;var C=this.iAmPmValueMaxLength-"a".length;this.shiftIndexes(C);var y=65;var z="";var F="";var G="";for(i=0;i<this.iAmPmValueMaxLength;i++){F="[";if(this.aAmPmValues[0][i]){F+=this.aAmPmValues[0][i];}else{F+="\\s";}if(this.aAmPmValues[1][i]!==this.aAmPmValues[0][i]){if(this.aAmPmValues[1][i]){F+=this.aAmPmValues[1][i];}else{F+="\\s";}}F+="]";G=String.fromCharCode(y++);z+=G;this._maskRuleChars=new M({maskFormatSymbol:G,regex:F});u.addRule(this._maskRuleChars);}w=w.replace(/a/g,z);}u.setMask(w);function H(S,O,Q){var U=[],V,i;for(i=S;i<=O;i++){V=i.toString();if(i<10){V=Q+V;}U.push(V);}return U;}function J(O,Q){var S=O?0:1,U=this._oTimePicker.getSupport2400()?24:23,V=O?U:12;return H(S,V,Q);}function N(){return H(0,59,"0");}};
s.prototype.replaceChar=function(C,u,v){var A=u-this.iAmPmChar1Index,w,x,y,S,z,F,i;if(u===this.iHourNumber1Index&&this.sAlternativeLeadingChar===C){if(this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else{return this.sLeadingChar;}}else if(u===this.iHourNumber1Index&&!this._oTimePicker._isCharAllowed(C,u)&&this.aAllowedHours.indexOf(this.sLeadingChar+C)!==-1){return this.sLeadingChar+C;}else if(u===this.iHourNumber2Index&&this.aAllowedHours.indexOf(v[this.iHourNumber1Index]+C)===-1){return"";}else if((u===this.iMinuteNumber1Index||u===this.iSecondNumber1Index)&&!this._oTimePicker._isCharAllowed(C,u)&&this.aAllowedMinutesAndSeconds.indexOf("0"+C)!==-1){return"0"+C;}else if(A>=0&&u<this.iAfterAmPmValueIndex){w=v.slice(this.iAmPmChar1Index,u);x=this.aAmPmValues[0].slice(0,A);y=this.aAmPmValues[1].slice(0,A);z=this.aAmPmValues[0].slice(A,this.iAfterAmPmValueIndex);F=this.aAmPmValues[1].slice(A,this.iAfterAmPmValueIndex);S=(x===y);var G="";for(i=A;i<this.iAmPmValueMaxLength;i++){if(this.aAmPmValues[0][i]===this.aAmPmValues[1][i]){G+=this.aAmPmValues[0][i];}else{break;}}if(i===this.iAmPmValueMaxLength||i!==A){return G;}else{if(!S){if(w===x){return z;}else if(w===y){return F;}else{return C;}}else{if(this.aAmPmValues[0][A].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[0]===w+z){return z;}else if(this.aAmPmValues[1][A].toLowerCase()===C.toLowerCase()&&this.aAmPmValues[1]===w+F){return F;}else{return C;}}}}else{return C;}};
s.prototype.formatValueWithLeadingTrailingSpaces=function(v){var i=this._oTimePicker.getMask().length;if(this.aOriginalAmPmValues[0]!==this.aAmPmValues[0]){v=v.replace(this.aOriginalAmPmValues[0],this.aAmPmValues[0]);}if(this.aOriginalAmPmValues[1]!==this.aAmPmValues[1]){v=v.replace(this.aOriginalAmPmValues[1],this.aAmPmValues[1]);}while(i>v.length){v=[v.slice(0,this.iHourNumber1Index)," ",v.slice(this.iHourNumber1Index)].join('');}return v;};
s.prototype.stripValueOfLeadingSpaces=function(v){if(v[this.iHourNumber1Index]===" "){v=[v.slice(0,this.iHourNumber1Index),v.slice(this.iHourNumber1Index+1)].join('');}return v;};
s.prototype.shiftIndexes=function(i){if(this.iAmPmChar1Index<this.iHourNumber1Index){this.iHourNumber1Index+=i;this.iHourNumber2Index+=i;}if(this.iAmPmChar1Index<this.iMinuteNumber1Index){this.iMinuteNumber1Index+=i;}if(this.iAmPmChar1Index<this.iSecondNumber1Index){this.iSecondNumber1Index+=i;}};
s.prototype.destroy=function(){if(this._maskRuleHours){this._maskRuleHours.destroy();this._maskRuleHours=null;}if(this._maskRuleMinSec){this._maskRuleMinSec.destroy();this._maskRuleMinSec=null;}if(this._maskRuleChars){this._maskRuleChars.destroy();this._maskRuleChars=null;}};
n.prototype._feedReplaceChar=function(C,i,u){return this._oTimeSemanticMaskHelper.replaceChar(C,i,u);};
n.prototype._getAlteredUserInputValue=function(v){return v?this._formatValue(this._parseValue(v),true):v;};
n.prototype.getAccessibilityInfo=function(){var i=this.getRenderer();var u=I.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var w=this.getDateValue();if(w){v=this._formatValue(w);}}q.extend(true,u,{role:i.getAriaRole(this),type:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TIMEINPUT"),description:[v,i.getLabelledByAnnouncement(this),i.getDescribedByAnnouncement(this)].join(" ").trim(),autocomplete:"none",expanded:false,haspopup:true,owns:this.getId()+"-sliders"});return u;};
function t(){var i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),u=e.getInstance(i);return u.getTimePattern(o.Medium);}
n._PICKER_CONTENT_HEIGHT="25rem";return n;});
sap.ui.predefine('sap/m/TimePickerRenderer',['sap/ui/core/Renderer','./InputBaseRenderer','sap/ui/core/library'],function(R,I,c){"use strict";var V=c.ValueState;var T=R.extend(I);T.apiVersion=2;T.CSS_CLASS="sapMTimePicker";
T.addOuterClasses=function(r,C){r.class(T.CSS_CLASS);};
T.writeDecorations=function(r,C){var o=C._oResourceBundle,t=o.getText("TIMEPICKER_SCREENREADER_TAG");r.openStart("span",C.getId()+"-descr");r.style("visibility","hidden");r.style("display","none");r.openEnd();r.text(t);r.close("span");};
T.writeInnerValue=function(r,C){r.attr("value",C._formatValue(C.getDateValue()));};
T.getAriaRole=function(){return"combobox";};
T.getLabelledByAnnouncement=function(C){return C._getPlaceholder()||"";};
T.getAccessibilityState=function(C){var a=this.getAriaLabelledBy(C),A=this.getAriaDescribedBy(C),m=C.getAccessibilityInfo();if(C.getValueState()===V.Error){m.invalid=true;}if(a){m.labelledby={value:a.trim(),append:true};}if(A){m.describedby={value:A.trim(),append:true};}return m;};
T.getAriaDescribedBy=function(C){var o=C.getId()+"-descr ";if(this.getDescribedByAnnouncement(C)){o+=C.getId()+"-describedby";}return o;};
return T;},true);
sap.ui.predefine('sap/m/TimePickerSlider',['sap/ui/core/Control','./TimePickerSliderRenderer','sap/ui/core/IconPool','sap/ui/Device',"sap/ui/events/KeyCodes","sap/m/Button","sap/ui/thirdparty/jquery"],function(C,T,I,D,K,B,q){"use strict";
var a=C.extend("sap.m.TimePickerSlider",{
metadata:{library:"sap.m",properties:{selectedValue:{type:"string",defaultValue:null},isCyclic:{type:"boolean",defaultValue:true},label:{type:"string",defaultValue:null},isExpanded:{type:"boolean",defaultValue:false}},aggregations:{items:{type:"sap.m.VisibleItem",multiple:true,singularName:"item"},_arrowUp:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowDown:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{expanded:{},collapsed:{}}},
renderer:T.render
});
var S=sap.ui.getCore().getConfiguration().getAnimation()?200:0;var M=50;var L=32;var A=32;
a.prototype.init=function(){this._bIsDrag=null;this._selectionOffset=0;this._mousedown=false;this._dragSession=null;this._iSelectedItemIndex=-1;this._animatingSnap=false;this._iSelectedIndex=-1;this._animating=false;this._intervalId=null;this._maxScrollTop=null;this._minScrollTop=null;this._marginTop=null;this._marginBottom=null;this._bOneTimeValueSelectionAnimation=false;this._bEnabled=true;if(D.system.desktop){this._fnHandleTypeValues=t.call(this);}this._initArrows();};
a.prototype.exit=function(){var s=this._getSliderContainerDomRef();if(s){s.stop();}if(this._intervalId){clearInterval(this._intervalId);this._intervalId=null;}};
a.prototype.onAfterRendering=function(){if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}this._attachEvents();};
a.prototype.onThemeChanged=function(e){this.invalidate();};
a.prototype.fireTap=function(e){var s,i,d;if(!this.getIsExpanded()){if(D.system.desktop){this.focus();}else{this.setIsExpanded(true);}}else{s=e.srcElement||e.originalTarget;if(s&&s.tagName.toLowerCase()==="li"){i=q(s).text();d=F.call(this,i);this._iClickedIndex=Array.prototype.slice.call(s.parentElement.children).indexOf(s);this._bOneTimeValueSelectionAnimation=true;this.setSelectedValue(d);this._fireSelectedValueChange(d);}else{this._addSelectionStyle();this.focus();}}};
a.prototype.setSelectedValue=function(v){var i=f(this._getVisibleItems(),function(E){return E.getKey()===v;}),d=this,e,s,g,h;if(i===-1){return this;}if(this.getDomRef()){s=this._getSliderContainerDomRef();g=this._getItemHeightInPx();h=this._getContentRepeat();if(i*g>=this._selectionOffset){e=this._getVisibleItems().length*Math.floor(h/2)+i;}else{e=this._getVisibleItems().length*Math.ceil(h/2)+i;}if(this._bOneTimeValueSelectionAnimation){s.scrollTop((e-this._iClickedIndex+this._iSelectedItemIndex)*g-this._selectionOffset);this._animatingSnap=true;s.animate({scrollTop:e*g-this._selectionOffset},S,'linear',function(){s.clearQueue();d._animatingSnap=false;d._bOneTimeValueSelectionAnimation=false;});}else{s.scrollTop(e*g-this._selectionOffset);}this._removeSelectionStyle();this._iSelectedItemIndex=e;this._addSelectionStyle();}return this.setProperty("selectedValue",v,true);};
a.prototype.setIsExpanded=function(v,s){this.setProperty("isExpanded",v,true);if(!this.getDomRef()){return this;}var $=this.$();if(v){$.addClass("sapMTPSliderExpanded");if(D.system.phone){setTimeout(function(){this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}.bind(this),0);}else{this._updateDynamicLayout(v);if(!s){this.fireExpanded({ctrl:this});}}}else{this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null&&this._animatingTargetIndex!==undefined){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}$.removeClass("sapMTPSliderExpanded");this._updateMargins(v);if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}if(!s){this.fireCollapsed({ctrl:this});}}return this;};
a.prototype.onfocusin=function(e){if(D.system.desktop&&!this.getIsExpanded()){this.setIsExpanded(true);}};
a.prototype.onfocusout=function(e){var s=e.relatedTarget?e.relatedTarget.id:null,d=[this.getAggregation("_arrowUp").getId(),this.getAggregation("_arrowDown").getId()];if(s&&d.indexOf(s)!==-1){return;}if(D.system.desktop&&this.getIsExpanded()){this.setIsExpanded(false);}};
a.prototype._onmousewheel=function(e){var O,d,w;e.preventDefault();e.stopPropagation();if(!this.getIsExpanded()||this._intervalId){return false;}O=e.originalEvent;d=O.detail?(-O.detail>0):(O.wheelDelta>0);w=O.detail?(-O.detail/3):(O.wheelDelta/120);if(!w){return false;}this._handleWheelScroll(d,w);};
a.prototype._handleWheelScroll=function(d,w){var r=d?Math.ceil:Math.floor,R;if(!this._aWheelDeltas){this._aWheelDeltas=[];}this._aWheelDeltas.push(w);if(!this._bWheelScrolling){this._bWheelScrolling=true;this._intervalId=setInterval(function(){if(!this._aWheelDeltas.length){clearInterval(this._intervalId);this._intervalId=null;this._bWheelScrolling=false;}else{R=this._aWheelDeltas[0];this._aWheelDeltas=[];R=r(R);if(R){this._offsetSlider(R);}}}.bind(this),150);}return false;};
a.prototype.onsappageup=function(e){if(this.getIsExpanded()){var i=this._getVisibleItems()[0],v=i.getKey();this.setSelectedValue(v);this._fireSelectedValueChange(v);}};
a.prototype.onsappagedown=function(e){if(this.getIsExpanded()){var l=this._getVisibleItems()[this._getVisibleItems().length-1],v=l.getKey();this.setSelectedValue(v);this._fireSelectedValueChange(v);}};
a.prototype.onsapup=function(e){if(this.getIsExpanded()){this._offsetValue(-1);}};
a.prototype.onsapdown=function(e){if(this.getIsExpanded()){this._offsetValue(1);}};
a.prototype.onkeydown=function(e){var k=e.which||e.keyCode,d=K;if(k>=d.NUMPAD_0&&k<=d.NUMPAD_9){k=this._convertNumPadToNumKeyCode(k);}if((k>=d.A&&k<=d.Z)||(k>=d.DIGIT_0&&k<=d.DIGIT_9)){this._fnHandleTypeValues(e.timeStamp,k);}};
a.prototype._getSliderContainerDomRef=function(){return this.$().find(".sapMTimePickerSlider");};
a.prototype._getContentRepeat=function(){var i;if(this.getIsCyclic()){i=Math.ceil(M/this._getVisibleItems().length);i=Math.max(i,3);}else{i=1;}return i;};
a.prototype._getItemHeightInPx=function(){return this.$("content").find("li:not(.TPSliderItemHidden)")[0].getBoundingClientRect().height;};
a.prototype._updateSelectionFrameLayout=function(){var $,i,d,e,s=this.$().offset(),g=s?s.top:0,h=this.$().parents(".sapMTimePickerContainer").offset(),j=h?h.top:0;if(this.getDomRef()){e=this._getItemHeightInPx();$=this.$().find(".sapMTPPickerSelectionFrame");d=g-j;i=(this.$().height()-e+L)/2+d;$.css("top",i);if(D.system.phone){setTimeout(this._afterExpandCollapse.bind(this),0);}else{this._afterExpandCollapse();}}};
a.prototype._updateStepAndValue=function(n,s){var v=0,$,i;for(i=0;i<this.getItems().length;i++){if(i%s!==0&&i!==n){this.getItems()[i].setVisible(false);}else{this.getItems()[i].setVisible(true);v++;}}if(v>2&&v<13&&this.getDomRef()){$=this.$().find(".sapMTimePickerSlider");$.className="";q($).addClass("sapMTimePickerSlider SliderValues"+v.toString());}this.setIsCyclic(v>2);this.setSelectedValue(n.toString());};
a.prototype._updateMargins=function(i){var d=this._getItemHeightInPx(),$,v,V,e,g,h,m,j;if(this.getDomRef()){d=this._getItemHeightInPx();$=this.$().find(".SliderValues3,.SliderValues4,.SliderValues5,.SliderValues6,.SliderValues7,.SliderValues8,.SliderValues9,.SliderValues10,.SliderValues11,.SliderValues12");if(!$.length){return;}if(i){v=this._getVisibleItems().length;V=d*Math.floor(v/2);e=d*Math.ceil(v/2);h=this.$().parents().hasClass('sapUiSizeCompact')?A:0;g=(this.$().height()-d+L)/2;m=g-V-L-h;j=this.$().height()-g-e-h;m=Math.max(m,0);j=Math.max(j,0);}else{m=0;j=0;}$.css("margin-top",m);$.css("margin-bottom",j);}};
a.prototype._updateDynamicLayout=function(i){this._updateMargins(i);this._updateSelectionFrameLayout();};
a.prototype._getSelectionFrameTopOffset=function(){var $=this._getSliderContainerDomRef().find(".sapMTPPickerSelectionFrame"),d=$.offset();return d.top;};
a.prototype._animateScroll=function(s){var $=this._getSliderContainerDomRef(),p=$.scrollTop(),d=25,e=$.height(),g=this.$("content").height(),i=200,h=e+i,j=this._getContentRepeat(),k=this.getIsCyclic(),l=0.9,m=0.05,n=this;this._intervalId=setInterval(function(){n._animating=true;p=p-s*d;if(k){p=n._getUpdatedCycleScrollTop(e,g,p,h,j);}else{if(p>n._maxScrollTop){p=n._maxScrollTop;s=0;}if(p<n._minScrollTop){p=n._minScrollTop;s=0;}}$.scrollTop(p);s*=l;if(Math.abs(s)<m){var r=n._getItemHeightInPx();var O=n._selectionOffset?(n._selectionOffset%r):0;var u=Math.round((p+O)/r)*r-O;clearInterval(n._intervalId);n._intervalId=null;n._animating=null;n._iSelectedIndex=Math.round((p+n._selectionOffset)/r);n._animatingSnap=true;$.animate({scrollTop:u},S,'linear',function(){$.clearQueue();n._animatingSnap=false;if($.css("visibility")==="visible"){n._scrollerSnapped(n._iSelectedIndex);}});}},d);};
a.prototype._stopAnimation=function(){if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}};
a.prototype._startDrag=function(p){if(!this._dragSession){this._dragSession={};this._dragSession.positions=[];}this._dragSession.pageY=p;this._dragSession.startTop=this._getSliderContainerDomRef().scrollTop();};
a.prototype._doDrag=function(p,d){if(this._dragSession){this._dragSession.offsetY=p-this._dragSession.pageY;this._dragSession.positions.push({pageY:p,timeStamp:d});if(this._dragSession.positions.length>20){this._dragSession.positions.splice(0,10);}if(this._bIsDrag){this._getSliderContainerDomRef().scrollTop(this._dragSession.startTop-this._dragSession.offsetY);}}};
a.prototype._endDrag=function(p,d){if(this._dragSession){var O,e;for(var i=this._dragSession.positions.length-1;i>=0;i--){O=d-this._dragSession.positions[i].timeStamp;e=p-this._dragSession.positions[i].pageY;if(O>100){break;}}var s=(e/O);if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}this._dragSession=null;this._animateScroll(s);}};
a.prototype._afterExpandCollapse=function(){var s=this.getSelectedValue(),d=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset(),i,l,g,h;this._selectionOffset=d-e.top;if(!this.getIsCyclic()){l=this.$("content");h=this._getItemHeightInPx();g=this.$().height();if(this.getIsExpanded()){this._minScrollTop=0;this._marginTop=d-e.top;this._maxScrollTop=h*(this._getVisibleItems().length-1);i=$.height();this._marginBottom=i-this._marginTop-h;if(this._marginBottom<0){this._marginBottom=g-this._marginTop-h;}l.css("margin-top",this._marginTop);l.css("margin-bottom",this._marginBottom);}else{this._marginBottom=g-h;l.css("margin-top",0);l.css("margin-bottom",this._marginBottom);}this._selectionOffset=0;}if(!this.getIsExpanded()){this._selectionOffset=0;}this.$().attr('aria-expanded',this.getIsExpanded());this.setSelectedValue(s);};
a.prototype._getUpdatedCycleScrollTop=function(i,d,e,g,h){var j=d-e-i;while(j<g){e=e-d/h;j=d-e-i;}while(e<g){e=e+d/h;}return e;};
a.prototype._scrollerSnapped=function(i){var s=i,d=this._getVisibleItems().length,n;while(s>=d){s=s-d;}if(!this.getIsCyclic()){s=i;}n=this._getVisibleItems()[s].getKey();this.setSelectedValue(n);this._fireSelectedValueChange(n);};
a.prototype._updateScroll=function(){var s=this.getSelectedValue();if(s!==this._getVisibleItems()[0].getKey()&&this._getSliderContainerDomRef().scrollTop()+(this._selectionOffset?this._selectionOffset:0)===0){this.setSelectedValue(s);this._fireSelectedValueChange(s);}};
a.prototype._addSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)"),s=$.eq(this._iSelectedItemIndex).text(),d,e;if(!s){return;}e=s;if(e&&e.length>1&&e.indexOf('0')===0){e=e.substring(1);}$.eq(this._iSelectedItemIndex).addClass("sapMTimePickerItemSelected");d=document.getElementById(this.getId()+"-valDescription");if(d.innerHTML!==e){d.innerHTML=e;}};
a.prototype._removeSelectionStyle=function(){var $=this.$("content").find("li:not(.TPSliderItemHidden)");$.eq(this._iSelectedItemIndex).removeClass("sapMTimePickerItemSelected");};
a.prototype._attachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(b,this),false);document.addEventListener("touchend",q.proxy(c,this),false);e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(b,this),false);document.addEventListener("mouseup",q.proxy(c,this),false);}else{if(D.system.phone||D.system.tablet){e.addEventListener("touchstart",q.proxy(o,this),false);e.addEventListener("touchmove",q.proxy(b,this),false);document.addEventListener("touchend",q.proxy(c,this),false);}else{e.addEventListener("mousedown",q.proxy(o,this),false);document.addEventListener("mousemove",q.proxy(b,this),false);document.addEventListener("mouseup",q.proxy(c,this),false);}}};
a.prototype._detachEvents=function(){var e=this.getDomRef();if(D.system.combi){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(b,this),false);document.removeEventListener("touchend",q.proxy(c,this),false);e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(b,this),false);document.removeEventListener("mouseup",q.proxy(c,this),false);}else{if(D.system.phone||D.system.tablet){e.removeEventListener("touchstart",q.proxy(o,this),false);e.removeEventListener("touchmove",q.proxy(b,this),false);document.removeEventListener("touchend",q.proxy(c,this),false);}else{e.removeEventListener("mousedown",q.proxy(o,this),false);document.removeEventListener("mousemove",q.proxy(b,this),false);document.removeEventListener("mouseup",q.proxy(c,this),false);}}};
a.prototype._offsetValue=function(i){var s=this._getSliderContainerDomRef(),d,e=this._getItemHeightInPx(),g,h,j=this.getIsCyclic(),k=this;this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}h=this._iSelectedItemIndex+i;d=s.scrollTop();g=d+i*e;if(!j){if(h<0||h>=this._getVisibleItems().length){return;}if(g>this._maxScrollTop){g=this._maxScrollTop;}if(g<this._minScrollTop){g=this._minScrollTop;}}this._animatingSnap=true;this._animatingTargetIndex=h;s.animate({scrollTop:g},S,'linear',function(){s.clearQueue();k._animatingSnap=false;k._animatingTargetIndex=null;if(s.css("visibility")==="visible"){k._scrollerSnapped(h);}});};
a.prototype._offsetSlider=function(O){var s=this._getSliderContainerDomRef().scrollTop(),d=this,$=d._getSliderContainerDomRef().height(),e=d.$("content").height(),i=200,g=$+i,h=d._getContentRepeat(),j=d.getIsCyclic(),k=d._getItemHeightInPx();s=s-O*k;if(j){s=d._getUpdatedCycleScrollTop($,e,s,g,h);}else{if(s>d._maxScrollTop){s=d._maxScrollTop;}if(s<d._minScrollTop){s=d._minScrollTop;}}d._getSliderContainerDomRef().scrollTop(s);d._iSelectedIndex=Math.round((s+d._selectionOffset)/k);d._scrollerSnapped(d._iSelectedIndex);};
a.prototype._initArrows=function(){var d=this,e,g,r=sap.ui.getCore().getLibraryResourceBundle("sap.m");e=new B({icon:I.getIconURI("slim-arrow-up"),press:function(E){d._offsetValue(-1);},tooltip:r.getText("TIMEPICKER_TOOLTIP_UP"),type:'Transparent'});e.addEventDelegate({onAfterRendering:function(){e.$().attr("tabindex",-1);}});this.setAggregation("_arrowUp",e);g=new B({icon:I.getIconURI("slim-arrow-down"),press:function(E){d._offsetValue(1);},tooltip:r.getText("TIMEPICKER_TOOLTIP_DOWN"),type:'Transparent'});g.addStyleClass("sapMTimePickerItemArrowDown");g.addEventDelegate({onAfterRendering:function(){g.$().attr("tabindex",-1);}});this.setAggregation("_arrowDown",g);};
a.prototype._convertNumPadToNumKeyCode=function(k){var d=K;if(k>=d.NUMPAD_0&&k<=d.NUMPAD_9){k-=48;}return k;};
function f(d,p){if(d==null){throw new TypeError('findIndex called with null or undefined array');}if(typeof p!=='function'){throw new TypeError('predicate must be a function');}var l=d.length;var e=arguments[1];var v;for(var i=0;i<l;i++){v=d[i];if(p.call(e,v,i,d)){return i;}}return-1;}
var o=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;this._bIsDrag=false;if(!this.getIsExpanded()){return;}this._stopAnimation();this._startDrag(p);if(!D.system.desktop){e.preventDefault();}this._mousedown=true;};var b=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;if(!this._mousedown||!this.getIsExpanded()){return;}if(!this._bIsDrag&&this._dragSession&&this._dragSession.positions.length){var d=this._dragSession.positions.some(function(g){return Math.abs(g.pageY-p)>5;});if(d){this._bIsDrag=true;}}this._doDrag(p,e.timeStamp);this._mousedown=true;};var c=function(e){var p=e.changedTouches&&e.changedTouches.length?e.changedTouches[0].pageY:e.pageY;if(this._bIsDrag===false){this.fireTap(e);this._dragSession=null;}this._bIsDrag=true;if(!this.getIsExpanded()){this._dragSession=null;return;}this._endDrag(p,e.timeStamp);this._mousedown=false;};var F=function(s){var i=this._getVisibleItems();var d=f(i,function(e){return e.getText()===s;});return i[d]?i[d].getKey():'';};var t=function(){var l=-1,i=-1,w=1000,s="",d=function(e,k){var m;if(l+w<e){s="";}else{if(i!==-1){clearTimeout(i);i=-1;}}s+=String.fromCharCode(k).toLowerCase();m=this._getVisibleItems().filter(function(g){return g.getKey().indexOf(s)===0;});if(m.length>1){i=setTimeout(function(){this.setSelectedValue(s);s="";i=-1;}.bind(this),w);}else if(m.length===1){this.setSelectedValue(m[0].getKey());s="";}else{s="";}l=e;};return d;};
a.prototype._getVisibleItems=function(){return this.getItems().filter(function(i){return i.getVisible();});};
a.prototype._setEnabled=function(e){this._bEnabled=e;if(e){this.$().removeClass("sapMTPDisabled");this.$().attr("tabindex",0);}else{this.$().addClass("sapMTPDisabled");this.$().attr("tabindex",-1);}return this;};
a.prototype._getEnabled=function(e){return this._bEnabled;};
a.prototype._fireSelectedValueChange=function(v){this.fireEvent("_selectedValueChange",{value:v});};
return a;});
sap.ui.predefine('sap/m/TimePickerSliderRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){var i,R,n=c._getContentRepeat(),I=c.getItems(),C=c.getLabel();r.openStart("div",c);r.attr("tabindex","0");r.class("sapMTPColumn");if(c.getIsExpanded()){r.class("sapMTPSliderExpanded");}if(!c.getIsCyclic()){r.class("sapMTimePickerSliderShort");}if(!c._getEnabled()){r.class("sapMTPDisabled");}r.accessibilityState(c,{role:"list",labelledby:{value:c.getId()+"-label",append:true},describedby:{value:c.getId()+"-valDescription",append:true}});r.openEnd();r.openStart("div",c.getId()+"-label");r.class("sapMTimePickerLabel");r.openEnd();r.text(C);r.close("div");r.openStart("div",c.getId()+"-valDescription");r.attr('aria-hidden','false');r.attr('aria-live','assertive');r.class("sapUiInvisibleText");r.openEnd();r.close("div");r.openStart("div");r.class("sapMTimePickerItemArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowUp"));r.close("div");r.openStart("div");r.class("sapMTimePickerSlider");T.addItemValuesCssClass(r,c);r.attr("unselectable","on");r.openEnd();r.openStart("div");r.class("sapMTPPickerSelectionFrame");r.openEnd();r.close("div");r.openStart("ul",c.getId()+"-content");r.attr("unselectable","on");r.openEnd();for(R=1;R<=n;R++){for(i=0;i<I.length;i++){r.openStart("li");r.class("sapMTimePickerItem");if(!I[i].getVisible()){r.class("TPSliderItemHidden");}r.accessibilityState(c);r.attr("unselectable","on");r.openEnd();r.text(I[i].getText());r.close("li");}}r.close("ul");r.close("div");r.openStart("div");r.class("sapMTimePickerItemArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowDown"));r.close("div");r.close("div");};
T.addItemValuesCssClass=function(r,c){var v=c.getItems().filter(function(i){return i.getVisible();}).length;if(v>2&&v<13){r.class("SliderValues"+v.toString());}};
return T;});
sap.ui.predefine('sap/m/TimePickerSliders',['sap/ui/core/library','sap/ui/core/Control','sap/ui/model/type/Date','sap/ui/model/odata/type/ODataType','sap/ui/core/format/DateFormat','./TimePickerSlidersRenderer','./TimePickerSlider','./VisibleItem','sap/ui/core/LocaleData','sap/ui/Device','sap/ui/core/Locale','./TimePickerSlidersRenderer',"sap/ui/thirdparty/jquery"],function(c,C,S,O,D,a,T,V,L,b,d,e,q){"use strict";var f=1,g=c.CalendarType;
var h=C.extend("sap.m.TimePickerSliders",{metadata:{library:"sap.m",properties:{localeId:{type:"string",group:"Data"},displayFormat:{name:"displayFormat",type:"string",group:"Appearance"},labelText:{name:"labelText",type:"string"},minutesStep:{type:"int",group:"Misc",defaultValue:f},secondsStep:{type:"int",group:"Misc",defaultValue:f},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"},value:{type:"string",group:"Data",defaultValue:null},valueFormat:{type:"string",group:"Data",defaultValue:null},support2400:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{_columns:{type:"sap.m.TimePickerSlider",multiple:true,visibility:"hidden"}},events:{change:{parameters:{value:{type:"string"}}}}}});
h.prototype.init=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),p=o.getDayPeriods("abbreviated"),i=o.getTimePattern("medium");this._fnLayoutChanged=q.proxy(this._onOrientationChanged,this);b.resize.attachHandler(this._fnLayoutChanged);this._sAM=p[0];this._sPM=p[1];this._onSliderExpanded=this._onSliderExpanded.bind(this);this._onSliderCollapsed=this._onSliderCollapsed.bind(this);this.setDisplayFormat(i);this._setTimeValues();this._iMinutes;this._iSeconds;};
h.prototype.exit=function(){this.$().off(!!b.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);b.resize.detachHandler(this._fnOrientationChanged);};
h.prototype.onAfterRendering=function(){this.$().off(!!b.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this.$().on(!!b.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this._onmousewheel,this));this.$().on('selectstart',F);if(this._getShouldOpenSliderAfterRendering()){if(b.system.desktop){this._getFirstSlider().setIsExpanded(true);}}};
h.prototype.setLocaleId=function(l){var o,p;l=this.validateProperty("localeId",l);this.setProperty("localeId",l,true);if(l){o=new d(l);p=L.getInstance(o).getDayPeriods("abbreviated");this._sAM=p[0];this._sPM=p[1];this._destroyColumns();this._setupLists();}return this;};
h.prototype.setSupport2400=function(i){this.setProperty("support2400",i,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setDisplayFormat=function(i){this.setProperty("displayFormat",i,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setMinutesStep=function(v){v=Math.max(f,v||f);this.setProperty("minutesStep",v,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setSecondsStep=function(v){v=Math.max(f,v||f);this.setProperty("secondsStep",v,true);this._destroyColumns();this._setupLists();return this;};
h.prototype.setValue=function(v){var H=this._getHoursSlider(),i=this._getValueFormatPattern(),I=i.indexOf("HH"),j=i.indexOf("H"),k=H&&H.getSelectedValue()==="24",l=h._isHoursValue24(v,I,j);if(k&&this._isFormatSupport24()&&!l){v=h._replaceZeroHoursWith24(v,I,j);}v=this.validateProperty("value",v);this.setProperty("value",v,true);var o;if(v){o=this._parseValue(l?h._replace24HoursWithZero(v,I,j):v);}if(o){this._setTimeValues(o,l);}return this;};
h.prototype.getTimeValues=function(){var H=this._getHoursSlider(),m=this._getMinutesSlider(),o=this._getSecondsSlider(),i=this._getFormatSlider(),j=null,A=null,k=new Date();if(H){j=parseInt(H.getSelectedValue());}if(i){A=i.getSelectedValue();}if(A==="am"&&j===12){j=0;}else if(A==="pm"&&j!==12){j+=12;}if(j!==null){k.setHours(j.toString());}if(m){k.setMinutes(m.getSelectedValue());}if(o){k.setSeconds(o.getSelectedValue());}return k;};
h.prototype.collapseAll=function(){var i=this.getAggregation("_columns");if(i){for(var I=0;I<i.length;I++){if(i[I].getIsExpanded()){i[I].setIsExpanded(false);}}}return this;};
h.prototype.openFirstSlider=function(){var o=this._getFirstSlider();o.setIsExpanded(true);o.focus();return this;};
h.prototype._setTimeValues=function(o,H){var i=this._getHoursSlider(),m=this._getMinutesSlider(),j=this._getSecondsSlider(),k=this._getFormatSlider(),l,A=null;o=o||new Date();if(Object.prototype.toString.call(o)!=="[object Date]"||isNaN(o)){throw new Error("Date must be a JavaScript date object; "+this);}if(!H){var v=this._formatValue(o,true);this.setProperty("value",v,true);l=o.getHours();}else{l=24;}if(k){A=l>=12?"pm":"am";l=(l>12)?l-12:l;l=(l===0?12:l);}i&&i.setSelectedValue(l.toString());m&&m._updateStepAndValue(o.getMinutes(),this.getMinutesStep());j&&j._updateStepAndValue(o.getSeconds(),this.getSecondsStep());k&&k.setSelectedValue(A);if(H){this._disableSlider(m);m&&m.setSelectedValue("0");this._disableSlider(j);j&&j.setSelectedValue("0");}else{this._enableSlider(m);this._enableSlider(j);}};
h.prototype._updateSlidersValues=function(){var i=this.getAggregation("_columns");if(i){for(var I=0;I<i.length;I++){i[I]._updateScroll();}}};
h.prototype.onsaphome=function(E){var n=this._getFirstSlider(),o=this._getCurrentSlider();if(o&&document.activeElement===o.getDomRef()&&this._isSliderEnabled(n)){n.focus();}};
h.prototype.onsapend=function(E){var n=this._getLastSlider(),o=this._getCurrentSlider();if(o&&document.activeElement===o.getDomRef()&&this._isSliderEnabled(n)){n.focus();}};
h.prototype.onsapleft=function(E){var n,o=this._getCurrentSlider(),i=-1,N=-1,j=this.getAggregation("_columns");if(o&&document.activeElement===o.getDomRef()){i=j.indexOf(o);N=i>0?i-1:j.length-1;n=j[N];if(this._isSliderEnabled(n)){n.focus();}}};
h.prototype.onsapright=function(E){var n,o=this._getCurrentSlider(),i=-1,N=-1,j=this.getAggregation("_columns");if(o&&document.activeElement===o.getDomRef()){i=j.indexOf(o);N=i<j.length-1?i+1:0;n=j[N];if(this._isSliderEnabled(n)){n.focus();}}};
h.prototype._onmousewheel=function(E){var i=this._getCurrentSlider();if(i){i._onmousewheel(E);}};
h.prototype._onOrientationChanged=function(){var j=this.getAggregation("_columns");if(!j){return;}for(var i=0;i<j.length;i++){if(j[i].getIsExpanded()){j[i]._updateSelectionFrameLayout();}}};
h.prototype._generatePickerListValues=function(i,t,j,l){var v=[],k;for(var I=i;I<=t;I+=1){if(I<10&&l){k="0"+I.toString();}else{k=I.toString();}var o=new V({key:I.toString(),text:k});if(I%j!==0){o.setVisible(false);}v.push(o);}return v;};
h.prototype._checkStyle=function(p){return(p==="short"||p==="medium"||p==="long"||p==="full");};
h.prototype._getDisplayFormatPattern=function(){var p=this.getDisplayFormat();if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
h.prototype._getValueFormatPattern=function(){var p=this._getBoundValueTypePattern()||this.getValueFormat()||"medium";if(this._checkStyle(p)){p=this._getLocaleBasedPattern(p);}return p;};
h.prototype._getLocaleBasedPattern=function(p){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getTimePattern(p);};
h.prototype._destroyColumns=function(){var i=this.getAggregation("_columns");if(i){this.destroyAggregation("_columns");}};
h.prototype._setupLists=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),l=r.getText("TIMEPICKER_LBL_HOURS"),i=r.getText("TIMEPICKER_LBL_MINUTES"),j=r.getText("TIMEPICKER_LBL_SECONDS"),k=r.getText("TIMEPICKER_LBL_AMPM"),m=this.getMinutesStep(),n=this.getSecondsStep(),o=this._getDisplayFormatPattern();if(o===undefined){return;}var H=false,p=false,t,u;if(o.indexOf("HH")!==-1){H=true;t=0;u=this.getSupport2400()?24:23;p=true;}else if(o.indexOf("H")!==-1){H=true;t=0;u=this.getSupport2400()?24:23;}else if(o.indexOf("hh")!==-1){H=true;t=1;u=12;p=true;}else if(o.indexOf("h")!==-1){H=true;t=1;u=12;}if(H){this.addAggregation("_columns",new T(this.getId()+"-listHours",{items:this._generatePickerListValues(t,u,1,p),expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:l}).attachEvent("_selectedValueChange",this._handleHoursChange,this));}if(o.indexOf("m")!==-1){var v=this._generatePickerListValues(0,59,m,true);this.addAggregation("_columns",new T(this.getId()+"-listMins",{items:v,expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:i}));}if(o.indexOf("s")!==-1){var v=this._generatePickerListValues(0,59,n,true);this.addAggregation("_columns",new T(this.getId()+"-listSecs",{items:v,expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:j}));}if(o.indexOf("a")!==-1){this.addAggregation("_columns",new T(this.getId()+"-listFormat",{items:[{key:"am",text:this._sAM},{key:"pm",text:this._sPM}],expanded:this._onSliderExpanded,collapsed:this._onSliderCollapsed,label:k,isCyclic:false}).addStyleClass("sapMTimePickerSliderShort"));}var w,x=this.getValue();if(x){w=this._parseValue(x);}if(w){this._setTimeValues(w);}};
h.prototype._getCurrentSlider=function(){var j=this.getAggregation("_columns");if(j){for(var i=0;i<j.length;i++){if(j[i].getIsExpanded()){return j[i];}}}return null;};
h.prototype._getHoursSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listHours")||null;};
h.prototype._getMinutesSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listMins")||null;};
h.prototype._getSecondsSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listSecs")||null;};
h.prototype._getFormatSlider=function(){return sap.ui.getCore().byId(this.getId()+"-listFormat")||null;};
h.prototype._getFirstSlider=function(){return this.getAggregation("_columns")[0]||null;};
h.prototype._getLastSlider=function(){var i=this.getAggregation("_columns");return i[i.length-1]||null;};
h.prototype._parseValue=function(v){return this._getFormatter().parse(v);};
h.prototype._isSliderEnabled=function(o){return o._getEnabled();};
h.prototype._getFormatter=function(){var p=this._getBoundValueTypePattern(),r=false,B=this.getBinding("value"),i;if(B&&B.oType&&B.oType.oOutputFormat){r=!!B.oType.oOutputFormat.oFormatOptions.relative;i=B.oType.oOutputFormat.oFormatOptions.calendarType;}if(!p){p=this.getValueFormat()||"medium";i=g.Gregorian;}if(!i){i=sap.ui.getCore().getConfiguration().getCalendarType();}return this._getFormatterInstance(p,r,i);};
h.prototype._getBoundValueTypePattern=function(){var B=this.getBinding("value"),o=B&&B.getType&&B.getType();if(o instanceof S){return o.getOutputPattern();}if(o instanceof O&&o.oFormat){return o.oFormat.oFormatOptions.pattern;}return undefined;};
h.prototype._getFormatterInstance=function(p,r,i,j){var o;if(this._checkStyle(p)){o=this._getFormatInstance({style:p,strictParsing:true,relative:r,calendarType:i});}else{o=this._getFormatInstance({pattern:p,strictParsing:true,relative:r,calendarType:i});}return o;};
h.prototype._getFormatInstance=function(A,i){return D.getTimeInstance(A);};
h.prototype._formatValue=function(o){if(o){return this._getFormatter().format(o);}return"";};
h.prototype._onSliderExpanded=function(E){var j=this.getAggregation("_columns");for(var i=0;i<j.length;i++){if(j[i]!==E.oSource&&j[i].getIsExpanded()){j[i].setIsExpanded(false);}}};
h.prototype._onSliderCollapsed=function(E){var o=this.getTimeValues();this.setValue(this._formatValue(o,true));this.fireChange({value:this.getValue()});};
h.prototype._getShouldOpenSliderAfterRendering=function(){return this._shouldOpenSliderAfterRendering;};
h.prototype._setShouldOpenSliderAfterRendering=function(i){this._shouldOpenSliderAfterRendering=i;return this;};
h.prototype._isFormatSupport24=function(){var i=this._getDisplayFormatPattern();return i.indexOf("HH")!==-1||i.indexOf("H")!==-1;};
h.prototype._disableSlider=function(o){if(o){o._setEnabled(false);}return this;};
h.prototype._enableSlider=function(o){if(o){o._setEnabled(true);}return this;};
h.prototype._handleHoursChange=function(E){var v=E.getParameter("value"),m=this._getMinutesSlider(),o=this._getSecondsSlider();if(this.getSupport2400()){if(v==="24"){if(m&&m._getEnabled()){this._iMinutes=m.getSelectedValue();this._disableSlider(m);m.setSelectedValue("0");}if(o&&o._getEnabled()){this._iSeconds=o.getSelectedValue();this._disableSlider(o);o.setSelectedValue("0");}}else{if(m&&!m._getEnabled()){this._enableSlider(m);m.setSelectedValue(this._iMinutes);}if(o&&!o._getEnabled()){this._enableSlider(o);o.setSelectedValue(this._iSeconds);}}}};
h._replaceZeroHoursWith24=function(v,i,I){var H=2,j=i;if(i===-1){H=1;j=I;}return v.substr(0,j)+"24"+v.substr(j+H);};
h._replace24HoursWithZero=function(v,i,I){var H=2,j=i;if(i===-1){H=1;j=I;}return v.substr(0,j)+s(0,H)+v.substr(j+2);};
h._isHoursValue24=function(v,i,I){if(i===-1&&I===-1){return false;}var j=i;if(i===-1){j=I;}return v.substr(j,2)==="24";};
function s(j,k){var r="";for(var i=0;i<k;i++){r+=j;}return r;}
function F(){return false;}
return h;});
sap.ui.predefine('sap/m/TimePickerSlidersRenderer',["sap/ui/Device"],function(D){"use strict";var T={apiVersion:2};
T.render=function(r,c){var s=c.getAggregation("_columns"),l=c.getLabelText()||"",R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),S,b=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",c);r.class("sapMTimePickerContainer");r.style("width",c.getWidth());r.style("height",c.getHeight());r.accessibilityState(c,{label:(l+" "+R.getText("TIMEPICKER_SCREENREADER_TAG")).trim()});r.openEnd();if(!D.system.desktop){r.openStart("div",c.getId()+"-label");r.class("sapMTimePickerContainerLabel");r.openEnd();r.style("display","block");r.text(l);r.close("div");}if(b){for(S=s.length-1;S>=0;S--){r.renderControl(s[S]);}}else{for(S=0;S<s.length;S++){r.renderControl(s[S]);}}r.close("div");};
return T;},true);
sap.ui.predefine('sap/m/Title',['sap/ui/core/Control','./library','sap/ui/core/library','./TitleRenderer',"sap/m/HyphenationSupport"],function(C,l,c,T,H){"use strict";var a=c.TextAlign;var b=c.TitleLevel;var W=l.WrappingType;
var d=C.extend("sap.m.Title",{metadata:{library:"sap.m",interfaces:["sap.ui.core.IShrinkable","sap.m.IHyphenation"],properties:{text:{type:"string",group:"Appearance",defaultValue:null},level:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:b.Auto},titleStyle:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:b.Auto},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textAlign:{type:"sap.ui.core.TextAlign",group:"Appearance",defaultValue:a.Initial},wrapping:{type:"boolean",group:"Appearance",defaultValue:false},wrappingType:{type:"sap.m.WrappingType",group:"Appearance",defaultValue:W.Normal}},associations:{title:{type:"sap.ui.core.Title",multiple:false}},designtime:"sap/m/designtime/Title.designtime"}});
d.prototype._getTitle=function(){var t=this.getTitle();if(t){var o=sap.ui.getCore().byId(t);if(o&&o instanceof sap.ui.core.Title){return o;}}return null;};
d.prototype._onTitleChanged=function(){this.invalidate();};
d.prototype.setTitle=function(t){var e=this;var o=this._getTitle();if(o){o.invalidate=o.__sapui5_title_originvalidate;o.exit=o.__sapui5_title_origexit;delete o.__sapui5_title_origexit;delete o.__sapui5_title_originvalidate;}this.setAssociation("title",t);var n=this._getTitle();if(n){n.__sapui5_title_originvalidate=n.invalidate;n.__sapui5_title_origexit=n.exit;n.exit=function(){e._onTitleChanged();if(this.__sapui5_title_origexit){this.__sapui5_title_origexit.apply(this,arguments);}};n.invalidate=function(){e._onTitleChanged();this.__sapui5_title_originvalidate.apply(this,arguments);};}return this;};
d.prototype.getAccessibilityInfo=function(){var t=this._getTitle()||this;return{role:"heading",description:t.getText(),focusable:false};};
d.prototype.getTextsToBeHyphenated=function(){var t=this._getTitle();return{"main":t?t.getText():this.getText()};};
d.prototype.getDomRefsForHyphenatedTexts=function(){var D;if(!this._getTitle()){D={"main":this.getDomRef("inner")};}return D;};
d.prototype._getAriaLevel=function(){var L=2,e=1;if(this.getTitleStyle()!==b.Auto){L=parseInt(this.getTitleStyle()[e]);}return L;};
H.mixInto(d.prototype);return d;});
sap.ui.predefine('sap/m/TitleAlignmentMixin',['sap/ui/core/theming/Parameters','sap/m/library'],function(P,l){"use strict";var T={};var a=l.TitleAlignment;var _=function(B,k){if(!this._oTitleAlignmentBarInstances){this._oTitleAlignmentBarInstances={};}this._oTitleAlignmentBarInstances[k]=B;this._determineTitleAlignment(B);};var b=function(){this._determineTitleAlignment();};var c=function(){this._titleAlignmentThemeChangedDelegate={onThemeChanged:this._titleAlignmentThemeChangedHandler};this.addEventDelegate(this._titleAlignmentThemeChangedDelegate,this);};var d=function(){this.removeEventDelegate(this._titleAlignmentThemeChangedDelegate);};var e=function(B){var t=P.get("sapMTitleAlignment");var C=this.getTitleAlignment();if(C===a.Auto){C=t===undefined?a.Center:t;}if(!B){if(this._oTitleAlignmentBarInstances){for(var k in this._oTitleAlignmentBarInstances){f(this._oTitleAlignmentBarInstances[k]);}}}else{f(B);}function f(B){B.removeStyleClass("sapMBarTitleStart");if(C===a.Start){B.addStyleClass("sapMBarTitleStart");}}};var s=function(A){this.setProperty("titleAlignment",A,true);this._determineTitleAlignment();if(this._oTitleAlignmentBarInstances){for(var k in this._oTitleAlignmentBarInstances){this._oTitleAlignmentBarInstances[k].invalidate();}}return this;};
T.mixInto=function(C){C._setupBarTitleAlignment=_;C._titleAlignmentThemeChangedHandler=b;C._attachTitleAlignmentEventDelegate=c;C._detachTitleAlignmentEventDelegate=d;C._determineTitleAlignment=e;C.setTitleAlignment=s;var i=C.init;C.init=function(I){if(!this._oTitleAlignmentBarInstances){this._oTitleAlignmentBarInstances={};}var r=i.apply(this,arguments);this._attachTitleAlignmentEventDelegate();return r;};var E=C.exit;C.exit=function(I){var r=E.apply(this,arguments);this._detachTitleAlignmentEventDelegate();delete this._oTitleAlignmentBarInstances;return r;};};
return T;});
sap.ui.predefine('sap/m/TitlePropagationSupport',[],function(){"use strict";return function(a,g){if(!this.isA("sap.ui.core.Element")){return;}this._propagateTitleIdToChildControl=function(){var A=this.getMetadata().getAggregation(a),c=A&&A.get(this),t=g&&g.call(this),i;if(!sap.ui.getCore().getConfiguration().getAccessibility()||!t||!c||c.length===0){return false;}i=c[0];if(i&&i._suggestTitleId&&i.isA(["sap.ui.layout.form.SimpleForm","sap.ui.layout.form.Form","sap.ui.comp.smartform.SmartForm"])){i._suggestTitleId(t);return true;}return false;};this._initTitlePropagationSupport=function(){this.addEventDelegate({onBeforeRendering:this._propagateTitleIdToChildControl.bind(this)});};};});
sap.ui.predefine('sap/m/TitleRenderer',["sap/ui/core/library","sap/m/HyphenationSupport"],function(c,H){"use strict";var T=c.TextAlign;var a=c.TitleLevel;var b={apiVersion:2};
b.render=function(r,t){var A=t._getTitle(),l=(A?A.getLevel():t.getLevel())||a.Auto,d=l==a.Auto,s=d?"div":l.toLowerCase(),e=H.getTextForRender(t,"main");r.openStart(s,t);r.class("sapMTitle");r.class("sapMTitleStyle"+t.getTitleStyle());r.class(t.getWrapping()?"sapMTitleWrap":"sapMTitleNoWrap");r.class("sapUiSelectable");var w=t.getWidth();if(!w){r.class("sapMTitleMaxWidth");}else{r.style("width",w);}var f=t.getTextAlign();if(f&&f!=T.Initial){r.class("sapMTitleAlign"+f);}if(t.getParent()instanceof sap.m.Toolbar){r.class("sapMTitleTB");}var g=A?A.getTooltip_AsString():t.getTooltip_AsString();if(g){r.attr("title",g);}if(d){r.attr("role","heading");r.attr("aria-level",t._getAriaLevel());}H.writeHyphenationClass(r,t);r.openEnd();r.openStart("span",t.getId()+"-inner");r.openEnd();r.text(e);r.close("span");r.close(s);};
return b;},true);
sap.ui.predefine('sap/m/ToggleButton',['./Button','./library','sap/ui/core/EnabledPropagator','./ToggleButtonRenderer',"sap/ui/events/KeyCodes"],function(B,l,E,T,K){"use strict";
var a=B.extend("sap.m.ToggleButton",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ToggleButton.designtime",properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}},events:{press:{parameters:{pressed:{type:"boolean"}}}}}});
E.call(a.prototype);
a.prototype.ontap=function(e){e.setMarked();if(this.getEnabled()){this.setPressed(!this.getPressed());this.firePress({pressed:this.getPressed()});}};
a.prototype.setPressed=function(p){p=!!p;if(p!=this.getPressed()){this.setProperty("pressed",p);this.$().attr("aria-pressed",p);this.$("inner").toggleClass("sapMToggleBtnPressed",p&&!this._isUnstyled());}return this;};
a.prototype.onkeydown=function(e){if(e.which===K.ENTER){this.ontap(e);}};
a.prototype.onkeyup=function(e){if(e.which===K.SPACE||e.which===K.ENTER){e.setMarked();}if(e.which===K.SPACE){this.ontap(e);}};
a.prototype.getAccessibilityInfo=function(){var i=B.prototype.getAccessibilityInfo.apply(this,arguments);if(this.getPressed()){i.description=((i.description||"")+" "+sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_STATE_PRESSED")).trim();}return i;};
return a;});
sap.ui.predefine('sap/m/ToggleButtonRenderer',['./ButtonRenderer','sap/ui/core/Renderer'],function(B,R){"use strict";var T=R.extend(B);T.apiVersion=2;
T.renderAccessibilityAttributes=function(r,t,a){a["pressed"]=t.getPressed();};
T.renderButtonAttributes=function(r,t){if(t.getPressed()&&!t._isUnstyled()){r.class("sapMToggleBtnPressed");}};
return T;},true);
sap.ui.predefine('sap/m/Token',['./library','sap/ui/core/Control','sap/ui/core/library','sap/ui/core/Icon','./TokenRenderer','sap/ui/core/InvisibleText','sap/ui/events/KeyCodes','sap/ui/core/theming/Parameters','sap/ui/core/Core'],function(l,C,c,I,T,a,K,P,b){"use strict";var d=c.TextDirection;
var e=C.extend("sap.m.Token",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Misc",defaultValue:false},key:{type:"string",group:"Misc",defaultValue:""},text:{type:"string",group:"Misc",defaultValue:""},editable:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:d.Inherit},editableParent:{type:"boolean",group:"Behavior",defaultValue:true,visibility:"hidden"},truncated:{type:"boolean",group:"Appearance",defaultValue:false,visibility:"hidden"}},aggregations:{deleteIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{"delete":{},press:{},select:{},deselect:{}}}});
e.prototype.init=function(){var D=new I({id:this.getId()+"-icon",src:"sap-icon://decline",noTabStop:true,press:this._fireDeleteToken.bind(this)});D.addStyleClass("sapMTokenIcon");D.setUseIconTooltip(false);this.setAggregation("deleteIcon",D);};
e.prototype.ontouchstart=function(E){if(E.target.id===this.getId()+"-icon"){E.preventDefault();}};
e.prototype._getTooltip=function(o,E){var t=o.getTooltip_AsString(),D=b.getLibraryResourceBundle("sap.m").getText("TOKEN_ARIA_DELETABLE");if(E&&!t){return D;}return t;};
e.prototype._onTokenPress=function(E){var s=this.getSelected(),f=E.ctrlKey||E.metaKey,n=true;if(f||(E.which===K.SPACE)){n=!s;}this.setSelected(n);this.firePress();if(s!==n){if(n){this.fireSelect();}else{this.fireDeselect();}}if(this.getSelected()){this.focus();}};
e.prototype.ontap=function(E){var D=this.getAggregation("deleteIcon");if(D&&E.target.id===D.getId()){E.setMark("tokenDeletePress",true);return;}E.setMark("tokenTap",this);this._onTokenPress(E);};
e.prototype.onsapbackspace=function(E){this._fireDeleteToken(E);};
e.prototype.onsapdelete=function(E){this._fireDeleteToken(E);};
e.prototype._fireDeleteToken=function(E){if(this.getEditable()&&this.getProperty("editableParent")){this.fireDelete({token:this});}E.preventDefault();};
e.prototype.onsapspace=function(E){this._onTokenPress(E);if(E){E.preventDefault();E.stopPropagation();}};
e.prototype.onkeydown=function(E){if((E.ctrlKey||E.metaKey)&&E.which===K.SPACE){this.onsapspace(E);E.preventDefault();}};
e.prototype.getTruncated=function(){return this.getProperty("truncated");};
e.prototype.setTruncated=function(v,s){if(this.getTruncated()===v){return this;}return this.setProperty("truncated",v,s);};
return e;});
sap.ui.predefine('sap/m/TokenRenderer',["sap/ui/core/library","sap/ui/core/InvisibleText"],function(c,I){"use strict";var T=c.TextDirection;var a={apiVersion:2};
a.render=function(r,C){var t=C._getTooltip(C,C.getEditable()&&C.getProperty("editableParent")),d=C.getAggregation("deleteIcon"),A=[],o={role:"option"};r.openStart("div",C).attr("tabindex","-1").class("sapMToken");if(C.getSelected()){r.class("sapMTokenSelected");}if(!C.getEditable()){r.class("sapMTokenReadOnly");}if(C.getTruncated()){r.class("sapMTokenTruncated");}if(t){r.attr("title",t);}A.push(I.getStaticId("sap.m","TOKEN_ARIA_LABEL"));if(C.getEditable()&&C.getProperty("editableParent")){A.push(I.getStaticId("sap.m","TOKEN_ARIA_DELETABLE"));}if(C.getSelected()){A.push(I.getStaticId("sap.m","TOKEN_ARIA_SELECTED"));}o.describedby={value:A.join(" "),append:true};r.accessibilityState(C,o);r.openEnd();a._renderInnerControl(r,C);if(C.getEditable()&&d){r.renderControl(d);}r.close("div");};
a._renderInnerControl=function(r,C){var t=C.getTextDirection();r.openStart("span").class("sapMTokenText");if(t!==T.Inherit){r.attr("dir",t.toLowerCase());}r.openEnd();var b=C.getText();if(b){r.text(b);}r.close("span");};
return a;},true);
sap.ui.predefine('sap/m/Tokenizer',['./library','sap/m/List','sap/m/StandardListItem','sap/m/ResponsivePopover','sap/ui/core/Control','sap/ui/core/delegate/ScrollEnablement','sap/ui/Device','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','./TokenizerRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/core/EnabledPropagator","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(l,L,S,R,C,a,D,I,b,T,c,K,d,E,q){"use strict";var e=l.TokenizerRenderMode,P=l.PlacementType,f=l.ListMode;
var g=C.extend("sap.m.Tokenizer",{metadata:{library:"sap.m",properties:{editable:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:"100%"},renderMode:{type:"string",group:"Misc",defaultValue:e.Loose},hiddenTokensCount:{type:"int",group:"Misc",defaultValue:0,visibility:"hidden"}},defaultAggregation:"tokens",aggregations:{tokens:{type:"sap.m.Token",multiple:true,singularName:"token"},_tokensInfo:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{ariaDescribedBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaDescribedBy"},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{tokenChange:{parameters:{type:{type:"string"},token:{type:"sap.m.Token"},tokens:{type:"sap.m.Token[]"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}},tokenUpdate:{allowPreventDefault:true,parameters:{type:{type:"string"},addedTokens:{type:"sap.m.Token[]"},removedTokens:{type:"sap.m.Token[]"}}}}}});
var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");E.apply(g.prototype,[true]);
g.prototype.init=function(){this.allowTextSelection(false);this._oTokensWidthMap={};this._oIndicator=null;this._oScroller=new a(this,this.getId()+"-scrollContainer",{horizontal:true,vertical:false,nonTouchScrolling:true});if(sap.ui.getCore().getConfiguration().getAccessibility()){var A=new I({text:r.getText("TOKENIZER_ARIA_CONTAIN_TOKEN")});this.setAggregation("_tokensInfo",A);}};
g.prototype._handleNMoreIndicatorPress=function(){this._togglePopup(this.getTokensPopup());};
g.prototype._getTokensList=function(){if(!this._oTokensList){this._oTokensList=new L({width:"auto",mode:f.Delete}).attachDelete(this._handleListItemDelete,this);}return this._oTokensList;};
g.prototype._setPopoverMode=function(m){var s={},p=this.getTokensPopup();switch(m){case f.Delete:s={showArrow:false,placement:P.VerticalPreferredBottom};break;default:s={showArrow:true,placement:P.Auto};break;}p.setShowArrow(s.showArrow);p.setPlacement(s.placement);this._getTokensList().setMode(m);};
g.prototype._fillTokensList=function(o,F){o.destroyItems();F=F?F:function(){return true;};this.getTokens().filter(F).forEach(function(t){o.addItem(this._mapTokenToListItem(t));},this);};
g.prototype._handleListItemDelete=function(o){var h,i,j,k=o.getParameter("listItem"),s=k&&k.data("tokenId"),t;t=this.getTokens().filter(function(m){return(m.getId()===s)&&m.getEditable();})[0];if(t){this.fireTokenUpdate({addedTokens:[],removedTokens:[t],type:g.TokenUpdateType.Removed});h=this._getTokensList().getItems();j=h.indexOf(k);i=(j===h.length-1)?h[h.length-2]:h[j+1];i&&i.focus();this.removeAggregation("tokens",t,true);k.destroy();t.destroy();this._adjustTokensVisibility();}};
g.prototype.getTokensPopup=function(){if(this._oPopup){return this._oPopup;}this._oPopup=new R({showArrow:false,showHeader:false,placement:P.Auto,offsetX:0,offsetY:3,horizontalScrolling:false,content:this._getTokensList()}).attachBeforeOpen(function(){var p=this._oPopup;if(p.getContent&&!p.getContent().length){p.addContent(this._getTokensList());}this._fillTokensList(this._getTokensList());},this);this.addDependent(this._oPopup);if(D.system.phone){this._oPopup.setEndButton(new sap.m.Button({text:r.getText("SUGGESTIONSPOPOVER_CLOSE_BUTTON"),press:function(){this._oPopup.close();}.bind(this)}));}return this._oPopup;};
g.prototype._togglePopup=function(p){var o,h=this.getDomRef(),i=p.isOpen(),j=this.getEditable();this._setPopoverMode(j?f.Delete:f.None);if(i){p.close();}else{o=j||this.hasOneTruncatedToken()?h:this._oIndicator[0];o=o&&o.className.indexOf("sapUiHidden")===-1?o:h;p.openBy(o||h);}};
g.prototype._mapTokenToListItem=function(t){if(!t){return null;}var o=new S({selected:true}).data("tokenId",t.getId());o.setTitle(t.getText());return o;};
g.prototype._getPixelWidth=function(){var m=this.getMaxWidth(),t,o=this.getDomRef(),p;if(!o){return;}p=parseInt(this.$().css("padding-left"));if(m.indexOf("px")===-1){t=o.clientWidth;}else{t=parseInt(this.getMaxWidth());}return t-p;};
g.prototype._adjustTokensVisibility=function(){if(!this.getDomRef()){return;}var t=this._getPixelWidth(),h=this._getVisibleTokens().reverse(),i=h.length,j,F,k,m=-1;h.some(function(o,n){t=t-this._oTokensWidthMap[o.getId()];if(t<0){m=n;return true;}else{F=t;}},this);if(i===1&&m!==-1){this.setFirstTokenTruncated(true);return;}else if(i===1&&h[0].getTruncated()){this.setFirstTokenTruncated(false);}if(m>-1){for(k=0;k<i;k++){if(k>=m){h[k].addStyleClass("sapMHiddenToken");}else{h[k].removeStyleClass("sapMHiddenToken");}}this._handleNMoreIndicator(i-m);j=this._oIndicator.width();if(j>=F){m=m-1;this._handleNMoreIndicator(i-m);h[m].addStyleClass("sapMHiddenToken");}this._setHiddenTokensCount(i-m);}else{this._setHiddenTokensCount(0);this._showAllTokens();}};
g.prototype.setFirstTokenTruncated=function(v){var t=this.getTokens()[0];t&&t.setTruncated(v);if(v){this.addStyleClass("sapMTokenizerOneLongToken");}else{this.removeStyleClass("sapMTokenizerOneLongToken");this.scrollToEnd();}return this;};
g.prototype.hasOneTruncatedToken=function(){return this.getTokens().length===1&&this.getTokens()[0].getTruncated();};
g.prototype._handleNMoreIndicator=function(h){if(!this.getDomRef()){return this;}if(h){var s="MULTIINPUT_SHOW_MORE_TOKENS";if(h===this._getVisibleTokens().length){if(h===1){s="TOKENIZER_SHOW_ALL_ITEM";}else{s="TOKENIZER_SHOW_ALL_ITEMS";}}this._oIndicator.html(r.getText(s,h));}return this;};
g.prototype._getVisibleTokens=function(){return this.getTokens().filter(function(t){return t.getVisible();});};
g.prototype._showAllTokens=function(){this._getVisibleTokens().forEach(function(t){t.removeStyleClass("sapMHiddenToken");});};
g.prototype.getScrollDelegate=function(){return this._oScroller;};
g.prototype.scrollToEnd=function(){var h=this.getDomRef(),s;if(!this.getDomRef()){return;}s=this.$().find(".sapMTokenizerScrollContainer")[0];if(D.browser.msie){setTimeout(function(){h.scrollLeft=s.scrollWidth;});}else{h.scrollLeft=s.scrollWidth;}};
g.prototype._registerResizeHandler=function(){if(!this._sResizeHandlerId){this._sResizeHandlerId=b.register(this.getDomRef(),this._handleResize.bind(this));}};
g.prototype._handleResize=function(){this._useCollapsedMode(this.getRenderMode());this.scrollToEnd();};
g.prototype.setPixelWidth=function(n){if(typeof n!=="number"){d.warning("Tokenizer.setPixelWidth called with invalid parameter. Expected parameter of type number.");return;}this.setWidth(n+"px");if(this._oScroller){this._oScroller.refresh();}};
g.prototype.scrollToStart=function(){var h=this.getDomRef();if(!h){return;}h.scrollLeft=0;};
g.prototype.getScrollWidth=function(){if(!this.getDomRef()){return 0;}return this.$().children(".sapMTokenizerScrollContainer")[0].scrollWidth;};
g.prototype.onBeforeRendering=function(){this._setTokensAria();};
g.prototype.onAfterRendering=function(){var s=this.getRenderMode();this._oIndicator=this.$().find(".sapMTokenizerIndicator");this._updateTokensAriaSetAttributes();this._useCollapsedMode(s);this._registerResizeHandler();if(s===e.Loose){this.scrollToEnd();}};
g.prototype.onThemeChanged=function(){this.getTokens().forEach(function(t){if(t.getDomRef()&&!t.$().hasClass("sapMHiddenToken")&&!t.getTruncated()){this._oTokensWidthMap[t.getId()]=t.$().outerWidth(true);}}.bind(this));this._useCollapsedMode(this.getRenderMode());};
g.prototype._useCollapsedMode=function(s){var t=this._getVisibleTokens();if(!t.length){return;}if(s===e.Narrow){this._adjustTokensVisibility();}else{this._setHiddenTokensCount(0);this._showAllTokens();}};
g.prototype.onsapfocusleave=function(o){if(document.activeElement===this.getDomRef()||!this._checkFocus()){this._changeAllTokensSelection(false);this._oSelectionOrigin=null;}};
g.prototype.onkeydown=function(o){var s;if(!this.getEnabled()){return;}if(o.which===K.TAB){this._changeAllTokensSelection(false);}if((o.ctrlKey||o.metaKey)&&o.which===K.A){s=this.getSelectedTokens().length<this._getVisibleTokens().length;if(this._getVisibleTokens().length>0){this.focus();this._changeAllTokensSelection(s);o.preventDefault();o.stopPropagation();}}if((o.ctrlKey||o.metaKey)&&(o.which===K.C||o.which===K.INSERT)){this._copy();}if(((o.ctrlKey||o.metaKey)&&o.which===K.X)||(o.shiftKey&&o.which===K.DELETE)){if(this.getEditable()){this._cut();}else{this._copy();}}};
g.prototype.onsappreviousmodifiers=function(o){this.onsapprevious(o);};
g.prototype.onsapnextmodifiers=function(o){this.onsapnext(o);};
g.prototype.onsaphomemodifiers=function(o){this._selectRange(false);};
g.prototype.onsapendmodifiers=function(o){this._selectRange(true);};
g.prototype._selectRange=function(F){var o={},t=this._getVisibleTokens(),h=q(document.activeElement).control()[0],j=t.indexOf(h);if(!h||!h.isA("sap.m.Token")){return;}if(F){o.start=j;o.end=t.length-1;}else{o.start=0;o.end=j;}if(o.start<o.end){for(var i=o.start;i<=o.end;i++){t[i].setSelected(true);}}};
g.prototype._copy=function(){var s=this.getSelectedTokens(),h="",t,j=function(o){if(o.clipboardData){o.clipboardData.setData('text/plain',h);}else{o.originalEvent.clipboardData.setData('text/plain',h);}o.preventDefault();};for(var i=0;i<s.length;i++){t=s[i];h+=(i>0?"\r\n":"")+t.getText();}if(!h){return;}if(D.browser.msie&&window.clipboardData){window.clipboardData.setData("text",h);}else{document.addEventListener('copy',j);document.execCommand('copy');document.removeEventListener('copy',j);}};
g.prototype._cut=function(){var s=this,h=s.getSelectedTokens(),j="",k=[],m,t,n=function(o){if(o.clipboardData){o.clipboardData.setData('text/plain',j);}else{o.originalEvent.clipboardData.setData('text/plain',j);}o.preventDefault();};m=s.fireTokenUpdate({addedTokens:[],removedTokens:k,type:g.TokenUpdateType.Removed});for(var i=0;i<h.length;i++){t=h[i];j+=(i>0?"\r\n":"")+t.getText();if(m&&t.getEditable()){s.removeToken(t);k.push(t);t.destroy();}}if(!j){return;}if(D.browser.msie&&window.clipboardData){window.clipboardData.setData("text",j);}else{document.addEventListener('cut',n);document.execCommand('cut');document.removeEventListener('cut',n);}};
g.prototype.onsapbackspace=function(o){var s=this.getSelectedTokens();if(!this.getEnabled()){return;}if(s.length<2){o.preventDefault();this.onsapprevious(o);}else{this._focusUnselectedToken(o);}this._handleKeyboardDelete(o);o.setMarked();};
g.prototype._focusUnselectedToken=function(o){var s=this.getSelectedTokens(),t=this._getVisibleTokens(),i,h;if(o.keyCode===K.DELETE){i=t.indexOf(s[s.length-1]);h=t[i+1];}if(o.keyCode===K.BACKSPACE){i=t.indexOf(s[0]);h=t[i-1];}if(h){h.focus();}else{o.setMarked("forwardFocusToParent");this.focus();}};
g.prototype.onsapdelete=function(o){var s;if(!this.getEnabled()){return;}s=this.getSelectedTokens();if(s.length<2){this.onsapnext(o);}else{this._focusUnselectedToken(o);}this._handleKeyboardDelete(o);o.setMarked();};
g.prototype._handleKeyboardDelete=function(o){var t;if(this.getEditable()){t=q(o.target).control()[0];if(t&&t.isA("sap.m.Token")){this.handleTokenDeletion(t);}this._removeSelectedTokens();if(!this._getVisibleTokens().length){o.setMarked("forwardFocusToParent");}}};
g.prototype._ensureTokenVisible=function(t){if(!t||!t.getDomRef()||!this.getDomRef()){return;}var i=this.$().offset().left,h=this.$().width(),j=t.$().offset().left,k=t.$().width();if(this._getVisibleTokens().indexOf(t)===0){this.$().scrollLeft(0);return;}if(j<i){this.$().scrollLeft(this.$().scrollLeft()-i+j);}if(j-i+k>h){this.$().scrollLeft(this.$().scrollLeft()+(j-i+k-h));}};
g.prototype.ontap=function(o){var s=o.shiftKey,h=(o.ctrlKey||o.metaKey),t=o.getMark("tokenTap"),j=o.getMark("tokenDeletePress"),k=this._getVisibleTokens(),F,m,n,M,p;if(j||!t||(!s&&h)){this._oSelectionOrigin=null;return;}if(!s){this._oSelectionOrigin=t;this._changeAllTokensSelection(false,t,true);}F=t;if(this._oSelectionOrigin){F=this._oSelectionOrigin;}else{this._oSelectionOrigin=F;}m=this.indexOfToken(F);n=this.indexOfToken(t);M=Math.min(m,n);p=Math.max(m,n);k.forEach(function(u,i){if(i>=M&&i<=p){u.setSelected(true);}else if(!h){u.setSelected(false);}});};
g.prototype.onsapprevious=function(o){var t=this._getVisibleTokens(),i=t.length;if(i===0){return;}var F=q(document.activeElement).control()[0];var h=F?t.indexOf(F):-1;if(h===0){o.setMarked("forwardFocusToParent");return;}var j,k;if(h>0){j=t[h-1];j.focus();}else{j=t[t.length-1];j.focus();}if(o.shiftKey){k=t[h];j.setSelected(true);k.setSelected(true);}o.setMarked();o.preventDefault();};
g.prototype.onsapnext=function(o){var t=this._getVisibleTokens(),i=t.length;if(i===0){return;}var F=q(document.activeElement).control()[0];var h=F?t.indexOf(F):-1;if(h<i-1){var n=t[h+1],j=t[h];n.focus();if(o.shiftKey){n.setSelected(true);j.setSelected(true);}this._ensureTokenVisible(n);}else{o.setMarked("forwardFocusToParent");return;}o.setMarked();o.preventDefault();};
g.prototype.addValidator=function(v){d.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
g.prototype.removeValidator=function(v){d.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
g.prototype.removeAllValidators=function(){d.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
g.prototype.addValidateToken=function(p){d.warning("[Warning]:","You are attempting to use deprecated method 'addValidator()', please use MultiInput.prototype.addValidator instead.",this);};
g.prototype._parseString=function(s){return s.split(/\r\n|\r|\n/g);};
g.prototype._checkFocus=function(){return this.getDomRef()&&c(this.getDomRef(),document.activeElement);};
g.prototype.addToken=function(t,s){var p=this.getParent();t.setProperty("editableParent",this.getEditable());if(p instanceof sap.m.MultiInput){if(p.getMaxTokens()!==undefined&&p.getTokens().length>=p.getMaxTokens()){return this;}}this.addAggregation("tokens",t,s);this.fireTokenChange({token:t,type:g.TokenChangeType.Added});t.addEventDelegate({onAfterRendering:function(){if(sap.ui.getCore().isThemeApplied()&&t.getDomRef()&&!t.getTruncated()&&!t.$().hasClass("sapMHiddenToken")){this._oTokensWidthMap[t.getId()]=t.$().outerWidth(true);}}.bind(this)});t.attachSelect(function(){var F=this.hasOneTruncatedToken()?t:this;if(!this.hasOneTruncatedToken()||this.hasStyleClass("sapMTokenizerIndicatorDisabled")){return;}this.getTokensPopup().setInitialFocus(F);this._togglePopup(this.getTokensPopup());}.bind(this));t.getAggregation("deleteIcon").attachPress(function(){if(this.getEnabled()){this.handleTokenDeletion(t);}}.bind(this));return this;};
g.prototype.removeToken=function(t){t=this.removeAggregation("tokens",t);this._updateTokensAriaSetAttributes();!this.getTokens().length&&this.setFirstTokenTruncated(false);this.fireTokenChange({token:t,type:g.TokenChangeType.Removed});if(this.getTokensPopup().isOpen()){this._fillTokensList(this._getTokensList());}return t;};
g.prototype.setTokens=function(t){var o=this.getTokens();this.removeAllTokens(false);var i;for(i=0;i<t.length;i++){this.addToken(t[i],true);}this.invalidate();this.fireTokenChange({addedTokens:t,removedTokens:o,type:g.TokenChangeType.TokensChanged});};
g.prototype.removeAllTokens=function(F){var t=this.getTokens();var h=this.removeAllAggregation("tokens");this.setFirstTokenTruncated(false);if(typeof(F)==="boolean"&&!F){return h;}this.fireTokenChange({addedTokens:[],removedTokens:t,type:g.TokenChangeType.TokensChanged});this.fireTokenChange({tokens:t,type:g.TokenChangeType.RemovedAll});return h;};
g.prototype.updateTokens=function(){this.destroyTokens();this.updateAggregation("tokens");};
g.prototype.destroyTokens=function(){this.setFirstTokenTruncated(false);return this.destroyAggregation("tokens");};
g.prototype._removeSelectedTokens=function(){var t=this.getSelectedTokens();if(t.length===0){return this;}this.handleTokenDeletion(t);this._doSelect();return this;};
g.prototype.handleTokenDeletion=function(t){var o,i,h,j=[];j=j.concat(t);o=this.fireTokenUpdate({addedTokens:[],removedTokens:j,type:g.TokenUpdateType.Removed});if(!o){return;}for(i=0;i<j.length;i++){h=j[i];if(h.getEditable()){h.destroy();}}this.scrollToEnd();if(this.getTokensPopup().isOpen()){this._fillTokensList(this._getTokensList());}this.fireTokenChange({addedTokens:[],removedTokens:j,type:g.TokenChangeType.TokensChanged});};
g.prototype.selectAllTokens=function(s){if(s===undefined){s=true;}this._changeAllTokensSelection(s);return this;};
g.prototype._changeAllTokensSelection=function(s,t,h){var i=this._getVisibleTokens();i.filter(function(o){return o!==t;}).forEach(function(o){o.setSelected(s);});if(!h){this._doSelect();}return this;};
g.prototype.getSelectedTokens=function(){return this._getVisibleTokens().filter(function(t){return t.getSelected();});};
g.prototype.onsaphome=function(o){var A=this.getTokens().filter(function(t){return t.getDomRef()&&!t.getDomRef().classList.contains("sapMHiddenToken");});A.length&&A[0].focus();this.scrollToStart();o.preventDefault();};
g.prototype.onsapend=function(o){var t=this._getVisibleTokens(),h=t[t.length-1];if(h.getDomRef()!==document.activeElement){h.focus();this.scrollToEnd();o.stopPropagation();}else{o.setMarked("forwardFocusToParent");}o.preventDefault();};
g.prototype.onclick=function(o){var F;if(!this.getEnabled()){return;}F=!this.hasStyleClass("sapMTokenizerIndicatorDisabled")&&(o.target===this.getFocusDomRef()||o.target.classList.contains("sapMTokenizerIndicator"));if(F){this._handleNMoreIndicatorPress();}};
g.prototype.ontouchstart=function(o){o.setMarked();if(D.browser.chrome&&window.getSelection()){window.getSelection().removeAllRanges();}};
g.prototype.exit=function(){this._deregisterResizeHandler();if(this._oTokensList){this._oTokensList.destroy();this._oTokensList=null;}if(this._oScroller){this._oScroller.destroy();this._oScroller=null;}if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}this._oTokensWidthMap=null;this._oIndicator=null;this._aTokenValidators=null;};
g.prototype._deregisterResizeHandler=function(){if(this._sResizeHandlerId){b.deregister(this._sResizeHandlerId);delete this._sResizeHandlerId;}};
g.prototype._setTokensAria=function(){var t=this._getVisibleTokens().length,i,s="";if(sap.ui.getCore().getConfiguration().getAccessibility()){i=this.getAggregation("_tokensInfo");switch(t){case 0:s=r.getText("TOKENIZER_ARIA_CONTAIN_TOKEN");break;case 1:s=r.getText("TOKENIZER_ARIA_CONTAIN_ONE_TOKEN");break;default:s=r.getText("TOKENIZER_ARIA_CONTAIN_SEVERAL_TOKENS",t);break;}i.setText(s);}};
g.prototype._updateTokensAriaSetAttributes=function(){var t=this.getTokens(),h=t.length;for(var i=0;i<h;i++){var o=t[i].getDomRef();if(o){o.setAttribute("aria-posinset",i+1);o.setAttribute("aria-setsize",h);}}};
g.prototype._doSelect=function(){if(this._checkFocus()&&this._bCopyToClipboardSupport){var F=document.activeElement;var s=window.getSelection();s.removeAllRanges();if(this.getSelectedTokens().length){var o=document.createRange();o.selectNodeContents(this.getDomRef("clip"));s.addRange(o);}if(window.clipboardData&&F.id===this.getId()+"-clip"&&this.getDomRef()){this.getDomRef().focus();}}};
g.prototype.setEditable=function(h){var t=this.getTokens();t.forEach(function(o){o.setProperty("editableParent",h);});this.setProperty("editable",h);return this;};
g.prototype._setHiddenTokensCount=function(i){i=this.validateProperty("hiddenTokensCount",i);return this.setProperty("hiddenTokensCount",i);};
g.prototype.getHiddenTokensCount=function(){return this.getProperty("hiddenTokensCount");};
g.prototype.getTokensInfoId=function(){return this.getAggregation("_tokensInfo").getId();};
g.TokenChangeType={Added:"added",Removed:"removed",RemovedAll:"removedAll",TokensChanged:"tokensChanged"};g.TokenUpdateType={Added:"added",Removed:"removed"};return g;});
sap.ui.predefine('sap/m/TokenizerRenderer',['sap/ui/Device','sap/ui/core/InvisibleText'],function(D,I){"use strict";var T={apiVersion:2};
T.render=function(r,c){if(c.getParent()&&(c.getParent()instanceof sap.m.MultiInput||c.getParent()instanceof sap.m.MultiComboBox)){r.openStart("div",c);}else{r.openStart("div",c).attr("tabindex","0");}r.class("sapMTokenizer");if(!c.getEditable()){r.class("sapMTokenizerReadonly");}if(!c.getEnabled()){r.class("sapMTokenizerDisabled");}var t=c.getTokens();if(!t.length){r.class("sapMTokenizerEmpty");}r.style("max-width",c.getMaxWidth());var p=c.getWidth();if(p){r.style("width",p);}var a={role:"listbox"};a.labelledby={value:I.getStaticId("sap.m","TOKENIZER_ARIA_LABEL"),append:true};r.accessibilityState(c,a);r.openEnd();r.renderControl(c.getAggregation("_tokensInfo"));c._bCopyToClipboardSupport=false;if((D.system.desktop||D.system.combi)&&t.length){r.openStart("div",c.getId()+"-clip").class("sapMTokenizerClip");if(window.clipboardData){r.attr("contenteditable","true");r.attr("tabindex","-1");}r.openEnd();r.unsafeHtml("&nbsp");r.close("div");c._bCopyToClipboardSupport=true;}r.openStart("div",c.getId()+"-scrollContainer");r.class("sapMTokenizerScrollContainer");r.openEnd();T._renderTokens(r,c);r.close("div");T._renderIndicator(r,c);r.close("div");};
T._renderTokens=function(r,c){var i=0,t=c.getTokens(),l=t.length;for(i=0;i<l;i++){r.renderControl(t[i]);}};
T._renderIndicator=function(r,c){r.openStart("span");r.class("sapMTokenizerIndicator");if(c.getHiddenTokensCount()===0){r.class("sapUiHidden");}r.openEnd().close("span");};
return T;},true);
sap.ui.predefine('sap/m/Toolbar',['./BarInPageEnabler','./ToolbarLayoutData','./ToolbarSpacer','./library','sap/ui/core/Control','sap/ui/core/EnabledPropagator',"sap/ui/events/KeyCodes",'./ToolbarRenderer'],function(B,T,a,l,C,E,K,b){"use strict";var c=l.ToolbarDesign,d=l.ToolbarStyle;
var e=C.extend("sap.m.Toolbar",{metadata:{interfaces:["sap.ui.core.Toolbar","sap.m.IBar"],library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null},active:{type:"boolean",group:"Behavior",defaultValue:false},enabled:{type:"boolean",group:"Behavior",defaultValue:true},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''},design:{type:"sap.m.ToolbarDesign",group:"Appearance",defaultValue:c.Auto},style:{type:"sap.m.ToolbarStyle",group:"Appearance",defaultValue:d.Standard},ariaHasPopup:{type:"string",group:"Accessibility",defaultValue:null}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{parameters:{srcControl:{type:"sap.ui.core.Control"}}}},designtime:"sap/m/designtime/Toolbar.designtime"}});
E.call(e.prototype);e.shrinkClass="sapMTBShrinkItem";
e.isRelativeWidth=function(w){return/^([-+]?\d+%|auto|inherit|)$/i.test(w);};
e.getOrigWidth=function(i){var o=sap.ui.getCore().byId(i);if(!o||!o.getWidth){return"";}return o.getWidth();};
e.checkShrinkable=function(o,s){if(o instanceof a){return this.isRelativeWidth(o.getWidth());}s=s||this.shrinkClass;o.removeStyleClass(s);var w=this.getOrigWidth(o.getId());if(!this.isRelativeWidth(w)){return;}var L=o.getLayoutData();if(L instanceof T){return L.getShrinkable()&&o.addStyleClass(s);}if(w.indexOf("%")>0||o.getMetadata().isInstanceOf("sap.ui.core.IShrinkable")){return o.addStyleClass(s);}var D=o.getDomRef();if(D&&(D.firstChild||{}).nodeType==3){return o.addStyleClass(s);}};
e.prototype._setEnableAccessibilty=function(f){var F=f?"true":"false",r=f?"toolbar":"none";this.data("sap-ui-fastnavgroup",F,f);this._setRootAccessibilityRole(r);return this;};
e.prototype.init=function(){this.data("sap-ui-fastnavgroup","true",true);this._oContentDelegate={onAfterRendering:this._onAfterContentRendering};};
e.prototype.onAfterRendering=function(){this._checkContents();};
e.prototype.onLayoutDataChange=function(){this.rerender();};
e.prototype.addContent=function(o){this.addAggregation("content",o);this._onContentInserted(o);return this;};
e.prototype.insertContent=function(o,i){this.insertAggregation("content",o,i);this._onContentInserted(o);return this;};
e.prototype.removeContent=function(v){v=this.removeAggregation("content",v);this._onContentRemoved(v);return v;};
e.prototype.removeAllContent=function(){var f=this.removeAllAggregation("content")||[];f.forEach(this._onContentRemoved,this);return f;};
e.prototype.ontap=function(o){if(this.getActive()&&!o.isMarked()){o.setMarked();this.firePress({srcControl:o.srcControl});}};
e.prototype.onsapenter=function(o){if(this.getActive()&&o.srcControl===this&&!o.isMarked()){o.setMarked();this.firePress({srcControl:this});}};
e.prototype.onsapspace=function(o){if(o.srcControl===this){o.preventDefault();}};
e.prototype.onkeyup=function(o){if(o.which===K.SPACE){this.onsapenter(o);}};
e.prototype.ontouchstart=function(o){this.getActive()&&o.setMarked();};
e.prototype._checkContents=function(){this.getContent().forEach(function(o){e.checkShrinkable(o);});};
e.prototype._onContentInserted=function(o){if(o){o.attachEvent("_change",this._onContentPropertyChanged,this);o.addEventDelegate(this._oContentDelegate,o);}};
e.prototype._onContentRemoved=function(o){if(o){o.detachEvent("_change",this._onContentPropertyChanged,this);o.removeEventDelegate(this._oContentDelegate,o);}};
e.prototype._onAfterContentRendering=function(){var L=this.getLayoutData();if(L instanceof T){L.applyProperties();}};
e.prototype._onContentPropertyChanged=function(o){if(o.getParameter("name")!="width"){return;}var f=o.getSource();var p=f.getWidth().indexOf("%")>0;f.toggleStyleClass(e.shrinkClass,p);};
e.prototype._getAccessibilityRole=function(){var r=this._getRootAccessibilityRole();if(this.getActive()){r="button";}return r;};
e.prototype.setDesign=function(D,s){if(!s){return this.setProperty("design",D);}this._sAutoDesign=this.validateProperty("design",D);return this;};
e.prototype.getActiveDesign=function(){var D=this.getDesign();if(D!=c.Auto){return D;}return this._sAutoDesign||D;};
e.prototype.getTitleControl=function(){var f=sap.ui.require("sap/m/Title");if(!f){return;}var g=this.getContent();for(var i=0;i<g.length;i++){var o=g[i];if(o instanceof f&&o.getVisible()){return o;}}};
e.prototype.getTitleId=function(){var t=this.getTitleControl();return t?t.getId():"";};
e.prototype.isContextSensitive=B.prototype.isContextSensitive;e.prototype.setHTMLTag=B.prototype.setHTMLTag;e.prototype.getHTMLTag=B.prototype.getHTMLTag;e.prototype.applyTagAndContextClassFor=B.prototype.applyTagAndContextClassFor;e.prototype._applyContextClassFor=B.prototype._applyContextClassFor;e.prototype._applyTag=B.prototype._applyTag;e.prototype._getContextOptions=B.prototype._getContextOptions;e.prototype._setRootAccessibilityRole=B.prototype._setRootAccessibilityRole;e.prototype._getRootAccessibilityRole=B.prototype._getRootAccessibilityRole;e.prototype._setRootAriaLevel=B.prototype._setRootAriaLevel;e.prototype._getRootAriaLevel=B.prototype._getRootAriaLevel;return e;});
sap.ui.predefine('sap/m/ToolbarLayoutData',['./library','sap/ui/core/LayoutData'],function(l,L){"use strict";
var T=L.extend("sap.m.ToolbarLayoutData",{metadata:{library:"sap.m",properties:{shrinkable:{type:"boolean",group:"Behavior",defaultValue:false},minWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},maxWidth:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null}}}});
T.prototype.getParentStyle=function(){var p=this.getParent();if(!p||!p.getDomRef){return{};}var d=p.getDomRef();return d?d.style:{};};
T.prototype.applyProperties=function(){var s=this.getParentStyle();s.minWidth=this.getMinWidth();s.maxWidth=this.getMaxWidth();return this;};
return T;});
sap.ui.predefine('sap/m/ToolbarRenderer',['./BarInPageEnabler'],function(B){"use strict";var T={apiVersion:2};T.render=B.prototype.render;
T.writeAccessibilityState=function(r,t){var a={role:t._getAccessibilityRole()};if(!t.getAriaLabelledBy().length){a.labelledby=t.getTitleId();}if(t.getActive()){a.haspopup=t.getAriaHasPopup();}if(t._sAriaRoleDescription){a.roledescription=t._sAriaRoleDescription;}r.accessibilityState(t,a);};
T.decorateRootElement=function(r,t){this.writeAccessibilityState(r,t);r.class("sapMTB");r.class("sapMTBNewFlex");if(t.getActive()){r.class("sapMTBActive");r.attr("tabindex","0");}else{r.class("sapMTBInactive");}r.class("sapMTB"+t.getStyle());r.class("sapMTB-"+t.getActiveDesign()+"-CTX");r.style("width",t.getWidth());r.style("height",t.getHeight());};
T.renderBarContent=function(r,t){t.getContent().forEach(function(c){B.addChildClassTo(c,t);r.renderControl(c);});};
T.shouldAddIBarContext=function(c){return false;};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSeparator',['./library','sap/ui/core/Control','./ToolbarSeparatorRenderer'],function(l,C,T){"use strict";
var a=C.extend("sap.m.ToolbarSeparator",{metadata:{library:"sap.m",interfaces:["sap.m.IOverflowToolbarContent"]}});
a.CLASSNAME_OVERFLOW_TOOLBAR="sapMTBSeparatorOverflowToolbar";
a.prototype._onBeforeEnterOverflow=function(c){c.addStyleClass(a.CLASSNAME_OVERFLOW_TOOLBAR);};
a.prototype._onAfterExitOverflow=function(c){c.removeStyleClass(a.CLASSNAME_OVERFLOW_TOOLBAR);};
a.prototype.getOverflowToolbarConfig=function(){var c={canOverflow:true};c.onBeforeEnterOverflow=this._onBeforeEnterOverflow;c.onAfterExitOverflow=this._onAfterExitOverflow;return c;};
return a;});
sap.ui.predefine('sap/m/ToolbarSeparatorRenderer',[],function(){"use strict";var T={apiVersion:2};
T.render=function(r,c){r.openStart("div",c);r.class("sapMTBSeparator");r.accessibilityState(c,{role:"separator"});r.openEnd();r.close("div");};
return T;},true);
sap.ui.predefine('sap/m/ToolbarSpacer',['./library','sap/ui/core/Control','./ToolbarSpacerRenderer',"sap/base/Log"],function(l,C,T,L){"use strict";
var a=C.extend("sap.m.ToolbarSpacer",{metadata:{library:"sap.m",properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:''}}}});
a.prototype.setLayoutData=function(o){if(o&&o.isA("sap.m.ToolbarLayoutData")){L.warning("sap.m.ToolbarLayoutData should not be set in the layoutData aggregation of sap.m.ToolbarSpacer");return this;}return this.setAggregation("layoutData",o);};
return a;});
sap.ui.predefine('sap/m/ToolbarSpacerRenderer',[],function(){"use strict";var T={apiVersion:2};T.flexClass="sapMTBSpacerFlex";
T.render=function(r,c){r.openStart("div",c);r.class("sapMTBSpacer");var w=c.getWidth();if(w){r.style("width",w);}else{r.class(T.flexClass);}r.openEnd().close("div");};
return T;},true);
sap.ui.predefine('sap/m/Tree',['./ListBase','./library','sap/ui/model/ClientTreeBindingAdapter','sap/ui/model/TreeBindingCompatibilityAdapter','./TreeRenderer',"sap/base/Log","sap/base/assert"],function(L,l,C,T,a,b,c){"use strict";
var d=L.extend("sap.m.Tree",{metadata:{library:"sap.m",events:{toggleOpenState:{parameters:{itemIndex:{type:"int"},itemContext:{type:"object"},expanded:{type:"boolean"}}}}}});
d.prototype.isTreeBinding=function(n){return(n=="items");};
d.prototype.getBinding=function(n){n=n||"items";var B=L.prototype.getBinding.call(this,n);if(B&&n==="items"&&!B.getLength){if(B.isA("sap.ui.model.odata.v2.ODataTreeBinding")){B.applyAdapterInterface();}else if(B.isA("sap.ui.model.ClientTreeBinding")){C.apply(B);}else if(B.isA("sap.ui.model.odata.ODataTreeBinding")){T(B,this);}else{b.error("TreeBinding is not supported for the "+this);}}return B;};
d.prototype.updateAggregation=function(n){if(n!="items"){return L.prototype.updateAggregation.apply(this,arguments);}var B=this.getBindingInfo("items"),o=this.getBinding("items"),f=B.factory,e;function u(g,e){var h=g.getItems()||[],j,k;if(h.length>e.length){for(var i=e.length;i<h.length;i++){g.removeItem(h[i]);h[i].destroy("KeepDom");}}for(var i=0;i<e.length;i++){j=e[i];k=h[i];if(k){k.setBindingContext(j,B.model);}else{k=f(g.getId()+"-"+i,j);k.setBindingContext(j,B.model);g.addItem(k);}}}e=o.getContexts(0);if(!B.template){this.destroyItems();}u(this,e);};
d.prototype.validateAggregation=function(A,o,m){var r=L.prototype.validateAggregation.apply(this,arguments);if(A==="items"&&!o.isA("sap.m.TreeItemBase")){throw new Error(o+" is not a valid items aggregation of "+this+". Items aggregation in Tree control only supports TreeItemBase-based objects, e.g. StandardTreeItem.");}return r;};
d.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);this._bInvalidated=true;};
d.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.apply(this,arguments);this._bInvalidated=false;};
d.prototype._updateDeepestLevel=function(i){if(i.getLevel()+1>this.getDeepestLevel()){this._iDeepestLevel=i.getLevel()+1;}};
d.prototype.onItemExpanderPressed=function(i,e){var I=this.indexOfItem(i);var B=this.getBindingInfo("items");var o=i&&i.getBindingContext(B.model);if(B&&o){var E=i.getExpanded();var f;this._updateDeepestLevel(i);var g=this.getBinding("items");if(e==undefined){g.toggleIndex(I);}else if(e){g.expand(I);}else{g.collapse(I);}f=g.isExpanded(I);if(E!==f&&!i.isLeaf()){this.fireToggleOpenState({itemIndex:I,itemContext:o,expanded:f});}}};
d.prototype.setGrowing=function(v){b.error("Growing feature of "+this+" is not supported!");return this;};
d.prototype.setGrowingThreshold=function(v){b.error("GrowingThreshold of "+this+" is not supported!");return this;};
d.prototype.setGrowingTriggerText=function(v){b.error("GrowingTriggerText of "+this+" is not supported!");return this;};
d.prototype.setGrowingScrollToLoad=function(v){b.error("GrowingScrollToLoad of "+this+" is not supported!");return this;};
d.prototype.setGrowingDirection=function(v){b.error("GrowingDirection of "+this+" is not supported!");return this;};
d.prototype.expandToLevel=function(i){var B=this.getBinding("items");c(B&&B.expandToLevel,"Tree.expandToLevel is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(B&&B.expandToLevel&&B.getNumberOfExpandedLevels){if(B.getNumberOfExpandedLevels()>i){B.collapseToLevel(0);}B.expandToLevel(i);}return this;};
d.prototype.getNumberOfExpandedLevel=function(){return this.getBinding("items").getNumberOfExpandedLevels();};
d.prototype.getDeepestLevel=function(){if(this._iDeepestLevel===undefined){this._iDeepestLevel=this.getNumberOfExpandedLevel();}return this._iDeepestLevel;};
d.prototype.collapseAll=function(){var B=this.getBinding("items");c(B&&B.expandToLevel,"Tree.collapseAll is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(B){B.collapseToLevel(0);}return this;};
d.prototype._sortHelper=function(p){var i=[];if(typeof p==="number"){i.push(p);}else if(Array.isArray(p)){i=p.sort().reverse();}return i;};
d.prototype._removeLeaf=function(s){var I=null,e,f=[];for(var i=0;i<s.length;i++){e=s[i];I=this.getItems()[e];if(I&&!I.isLeaf()){f.push(e);}}return f;};
d.prototype._preExpand=function(p){var i=this._sortHelper(p);i=this._removeLeaf(i);return i;};
d.prototype.expand=function(p){var B=this.getBinding("items");if(B&&B.expand){var I=this._preExpand(p),o;if(I.length>0){for(var i=0;i<I.length-1;i++){o=this.getItems()[I[i]];this._updateDeepestLevel(o);B.expand(I[i],true);}o=this.getItems()[I[I.length-1]];this._updateDeepestLevel(o);B.expand(I[I.length-1],false);}}return this;};
d.prototype.collapse=function(p){var B=this.getBinding("items");if(B&&B.collapse){var I=this._preExpand(p);for(var i=0;i<I.length-1;i++){B.collapse(I[i],true);}B.collapse(I[I.length-1],false);}return this;};
d.prototype.getAccessibilityType=function(){return sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_TREE");};
d.prototype.getAccessbilityPosition=function(i){var s,p,n=i.getItemNodeContext();if(n.parent){s=n.parent.children.length;}if(n.positionInParent!=undefined){p=n.positionInParent+1;}return{setSize:s,posInset:p};};
d.prototype.onItemLongDragOver=function(i){var I=this.indexOfItem(i),B=this.getBinding("items"),o=this.getBindingInfo("items"),e=i&&i.getBindingContext(o.model);if(i){this._updateDeepestLevel(i);if(!i.isLeaf()){B.expand(I);this.fireToggleOpenState({itemIndex:I,itemContext:e,expanded:B.isExpanded(I)});}}};
d.prototype.isGrouped=function(){return false;};
return d;});
sap.ui.predefine('sap/m/TreeItemBase',['./ListItemBase','./library','sap/ui/core/IconPool','sap/ui/core/Icon','./TreeItemBaseRenderer','sap/ui/events/KeyCodes'],function(L,l,I,a,T,K){"use strict";var b=l.ListMode;
var c=L.extend("sap.m.TreeItemBase",{metadata:{library:"sap.m"}});
c.prototype.ExpandedIconURI=I.getIconURI("navigation-down-arrow");c.prototype.CollapsedIconURI=I.getIconURI("navigation-right-arrow");
c.prototype.getTree=function(){var p=this.getParent();if(p&&p.isA("sap.m.Tree")){return p;}};
c.prototype.getList=c.prototype.getTree;c.prototype.informTree=c.prototype.informList;
c.prototype.getItemNodeContext=function(){var t=this.getTree();var n=null;var B=t?t.getBinding("items"):null;if(t&&B){B=t.getBinding("items");n=B.getNodeByIndex(t.indexOfItem(this));}return n;};
c.prototype.getParentNode=function(){if(this.isTopLevel()){return;}var t=this.getTree(),n=this.getLevel(),p=null,i=t.indexOfItem(this)-1,d=t.getItems(),e;while(i>=0){e=d[i].getLevel();if(e===n-1){p=d[i];break;}i--;}return p;};
c.prototype.getParentNodeContext=function(){return this.getItemNodeContext().parent;};
c.prototype.isLeaf=function(){var t=this.getTree(),n=this.getItemNodeContext();return n?!t.getBinding("items").nodeHasChildren(n):false;};
c.prototype.isTopLevel=function(){return(this.getLevel()===0);};
c.prototype.getLevel=function(){return(this.getItemNodeContext()||{}).level;};
c.prototype.getExpanded=function(){var t=this.getTree();if(!t){return false;}var i=t.indexOfItem(this);var B=t.getBinding("items");return(B&&B.isExpanded(i));};
c.prototype.setSelected=function(s){L.prototype.setSelected.apply(this,arguments);var t=this.getTree();var B=t?t.getBinding("items"):null;var i=-1;if(t&&B){i=t.indexOfItem(this);if(t.getMode()===b.SingleSelect){B.setSelectedIndex(i);}if(t.getMode()===b.MultiSelect){if(s){B.addSelectionInterval(i,i);}else{B.removeSelectionInterval(i,i);}}}return this;};
c.prototype._getExpanderControl=function(){var s=this.CollapsedIconURI,B=sap.ui.getCore().getLibraryResourceBundle("sap.m"),i=B.getText("TREE_ITEM_EXPAND_NODE");if(this.getExpanded()){s=this.ExpandedIconURI;i=B.getText("TREE_ITEM_COLLAPSE_NODE");}if(this._oExpanderControl){this._oExpanderControl.setSrc(s);this._oExpanderControl.setTooltip(i);return this._oExpanderControl;}this._oExpanderControl=new a({id:this.getId()+"-expander",src:s,tooltip:i,noTabStop:true}).setParent(this,null,true).addStyleClass("sapMTreeItemBaseExpander").attachPress(function(e){this.informTree("ExpanderPressed");},this);return this._oExpanderControl;};
c.prototype._updateItem=function(){if(this._bInvalidated){return;}var t=this.getTree();if(t&&t._bInvalidated){return;}if(this._oExpanderControl){var s=this.CollapsedIconURI;if(this.getExpanded()){s=this.ExpandedIconURI;}this._oExpanderControl.setSrc(s);var $=this.$();if(!this.isLeaf()){$.removeClass("sapMTreeItemBaseLeaf");$.attr("aria-expanded",this.getExpanded());}else{$.addClass("sapMTreeItemBaseLeaf");$.removeAttr("aria-expanded");}$.toggleClass("sapMTreeItemBaseChildren",!this.isTopLevel());$.attr("aria-level",this.getLevel()+1);var i=this._getPadding(),S=sap.ui.getCore().getConfiguration().getRTL()?"paddingRight":"paddingLeft";$.css(S,i+"rem");}};
c.prototype.invalidate=function(){L.prototype.invalidate.apply(this,arguments);this._bInvalidated=true;};
c.prototype.onAfterRendering=function(){L.prototype.onAfterRendering.apply(this,arguments);this._bInvalidated=false;};
c.prototype.setBindingContext=function(){L.prototype.setBindingContext.apply(this,arguments);this._updateItem();return this;};
c.prototype._getPadding=function(){var t=this.getTree(),n=this.getLevel(),i=0,d;if(t){d=t.getDeepestLevel();}if(d<n){t._iDeepestLevel=n;d=t._iDeepestLevel;}if(d<2){i=n*1.5;}else if(d===2){i=n*1;}else if(d<6){i=n*0.5;}else{i=n*0.25;}return i;};
c.prototype.onsapplus=function(e){this.informTree("ExpanderPressed",true);};
c.prototype.onsapminus=function(e){this.informTree("ExpanderPressed",false);};
c.prototype.onsapright=function(e){if(e.srcControl!==this||this.isLeaf()){return;}if(!this.getExpanded()){this.informTree("ExpanderPressed",true);}else{e.keyCode=K.ARROW_DOWN;}};
c.prototype.onsapleft=function(e){if(e.srcControl!==this||this.isTopLevel()&&!this.getExpanded()){return;}if(!this.isLeaf()){if(this.getExpanded()){this.informTree("ExpanderPressed",false);}else{this.getParentNode().focus();}}else{this.getParentNode().focus();}};
c.prototype.onsapbackspace=function(e){if(e.srcControl!==this){return;}if(!this.isTopLevel()){this.getParentNode().focus();}};
c.prototype.getAccessibilityType=function(B){return B.getText("ACC_CTR_TYPE_TREEITEM");};
c.prototype.exit=function(){L.prototype.exit.apply(this,arguments);this.destroyControls(["Expander"]);};
c.prototype.onlongdragover=function(e){this.informTree("LongDragOver");};
return c;});
sap.ui.predefine('sap/m/TreeItemBaseRenderer',["./ListItemBaseRenderer","sap/ui/core/Renderer"],function(L,R){"use strict";var T=R.extend(L);T.apiVersion=2;
T.renderLIAttributes=function(r,l){r.class("sapMTreeItemBase");if(!l.isTopLevel()){r.class("sapMTreeItemBaseChildren");}if(l.isLeaf()){r.class("sapMTreeItemBaseLeaf");}else{r.attr("aria-expanded",l.getExpanded());}var i=l._getPadding();if(sap.ui.getCore().getConfiguration().getRTL()){r.style("padding-right",i+"rem");}else{r.style("padding-left",i+"rem");}};
T.renderContentFormer=function(r,l){this.renderHighlight(r,l);this.renderExpander(r,l);this.renderMode(r,l,-1);};
T.renderExpander=function(r,l){var e=l._getExpanderControl();if(e){r.renderControl(e);}};
T.getAriaRole=function(l){return"treeitem";};
T.getAccessibilityState=function(l){var a=L.getAccessibilityState.call(this,l);a.level=l.getLevel()+1;if(!l.isLeaf()){a.expanded=l.getExpanded();}return a;};
return T;},true);
sap.ui.predefine('sap/m/TreeRenderer',['sap/ui/core/Renderer','./ListBaseRenderer'],function(R,L){"use strict";var T=R.extend(L);T.apiVersion=2;
T.getAriaRole=function(c){return"tree";};
return T;},true);
sap.ui.predefine('sap/m/UploadCollectionItem',["./library","sap/ui/core/Element","sap/m/ObjectAttribute","sap/ui/core/util/File","sap/ui/Device","sap/base/Log","sap/base/util/ObjectPath","sap/ui/thirdparty/jquery"],function(l,E,O,F,D,L,a,q){"use strict";
var U=E.extend("sap.m.UploadCollectionItem",{metadata:{library:"sap.m",properties:{contributor:{type:"string",group:"Data",defaultValue:null},documentId:{type:"string",group:"Misc",defaultValue:null},fileName:{type:"string",group:"Misc",defaultValue:null},fileSize:{type:"float",group:"Misc",defaultValue:null},mimeType:{type:"string",group:"Misc",defaultValue:null},thumbnailUrl:{type:"string",group:"Misc",defaultValue:null},uploadedDate:{type:"string",group:"Misc",defaultValue:null},url:{type:"string",group:"Misc",defaultValue:null},enableEdit:{type:"boolean",group:"Behavior",defaultValue:true},enableDelete:{type:"boolean",group:"Behavior",defaultValue:true},visibleEdit:{type:"boolean",group:"Behavior",defaultValue:true},visibleDelete:{type:"boolean",group:"Behavior",defaultValue:true},ariaLabelForPicture:{type:"string",group:"Accessibility",defaultValue:null},selected:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,bindable:"bindable"},_propertyAttributes:{type:"sap.m.ObjectAttribute",multiple:true,visibility:"hidden"},statuses:{type:"sap.m.ObjectStatus",multiple:true,bindable:"bindable"},markers:{type:"sap.m.ObjectMarker",multiple:true,bindable:"bindable"}},associations:{fileUploader:{type:"sap.ui.unified.FileUploader",multiple:false}},events:{press:{},deletePress:{}}}});
U.prototype.init=function(){this._mDeprecatedProperties={};this._aManagedInstances=[];};
U.prototype.exit=function(){for(var i=0;i<this._aManagedInstances.length;i++){this._aManagedInstances[i].destroy();}};
U.prototype.setContributor=function(c){if(this.getContributor()!==c){this.setProperty("contributor",c,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setUploadedDate=function(u){if(this.getUploadedDate()!==u){this.setProperty("uploadedDate",u,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setFileSize=function(f){if(this.getFileSize()!==f){this.setProperty("fileSize",f,true);this._updateDeprecatedProperties();}return this;};
U.prototype.setSelected=function(s){if(this.getSelected()!==s){this.setProperty("selected",s,true);this.fireEvent("selected");}return this;};
U.prototype.download=function(b){if(D.browser.name==="sf"){b=false;}if(!this.getUrl()){L.warning("Items to download do not have a URL.");return false;}else if(b){var f=this.getFileName();var o=this._splitFileName(f,false);var d=null;var x=new window.XMLHttpRequest();x.open("GET",this.getUrl());if(o.extension!=="csv"){x.responseType="blob";}x.onload=function(){var s=o.extension;f=o.name;d=x.response;F.save(d,f,s,this.getMimeType(),'utf-8');}.bind(this);x.send();return true;}else{l.URLHelper.redirect(this.getUrl(),true);return true;}};
U.prototype._splitFileName=function(f,w){var r={};var R=/(?:\.([^.]+))?$/;var b=R.exec(f);r.name=f.slice(0,f.indexOf(b[0]));if(w){r.extension=b[0];}else{r.extension=b[1];}return r;};
U.prototype._updateDeprecatedProperties=function(){var p=["uploadedDate","contributor","fileSize"];this.removeAllAggregation("_propertyAttributes",true);q.each(p,function(i,n){var v=this.getProperty(n),A=this._mDeprecatedProperties[n];if(typeof v==="number"&&!!v||!!v){if(!A){A=new O({active:false});this._mDeprecatedProperties[n]=A;this.addAggregation("_propertyAttributes",A,true);A.setText(v);}else{A.setText(v);this.addAggregation("_propertyAttributes",A,true);}}else if(A){A.destroy();delete this._mDeprecatedProperties[n];}}.bind(this));this.invalidate();};
U.prototype.getAllAttributes=function(){return this.getAggregation("_propertyAttributes",[]).concat(this.getAttributes());};
U.prototype._getControl=function(n,s,g){var c=a.get(n||""),i=new c(s);this._aManagedInstances.push(i);if(g){this["_get"+g]=function(){return i;};}return i;};
U.prototype._getPressEnabled=function(){return this.hasListeners("press")||!!q.trim(this.getUrl());};
return U;});
sap.ui.predefine('sap/m/UploadCollectionParameter',['./library','sap/ui/core/Element'],function(l,E){"use strict";
var U=E.extend("sap.m.UploadCollectionParameter",{metadata:{library:"sap.m",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
return U;});
sap.ui.predefine('sap/m/UploadCollectionRenderer',['./ListItemBaseRenderer'],function(L){"use strict";var U={};
U.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMUC");r.writeClasses();r.write(">");this.renderDragDropOverlay(r,c);this.renderList(r,c);r.write("</div>");};
U.renderNoData=function(r,c){var u=c.getParent();r.write("<li");r.writeAttribute("tabindex",0);r.writeAttribute("id",u._oList.getId("nodata"));r.addClass("sapMLIB sapMUCNoDataPage");L.addFocusableClasses.call(L,r);r.writeClasses();r.write(">");r.renderControl(u.getAggregation("_noDataIcon"));r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-text");r.addClass("sapMUCNoDataText");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataText());r.write("</div>");if(u.getUploadEnabled()){r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-description");r.addClass("sapMUCNoDataDescription");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataDescription());r.write("</div>");}r.write("</li>");};
U.renderDragDropOverlay=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-drag-drop-area");r.addClass("sapMUCDragDropOverlay");r.addClass("sapMUCDragDropOverlayHide");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMUCDragDropIndicator");r.writeClasses();r.write(">");r.renderControl(c.getAggregation("_dragDropIcon"));r.renderControl(c.getAggregation("_dragDropText"));r.write("</div>");r.write("</div>");};
U.renderList=function(r,c){var o=c._oList.getRenderer().renderNoData;c._oList.getRenderer().renderNoData=this.renderNoData;r.renderControl(c._oList);c._oList.getRenderer().renderNoData=o;};
return U;},true);
sap.ui.predefine('sap/m/UploadCollectionToolbarPlaceholder',['./library','sap/ui/core/Control'],function(l,C){"use strict";
var U=C.extend("sap.m.UploadCollectionToolbarPlaceholder",{
metadata:{library:"sap.m",properties:{}},
renderer:null
});
return U;});
sap.ui.predefine('sap/m/VBox',['./FlexBox','./library',"./VBoxRenderer"],function(F,l,V){"use strict";var a=l.FlexDirection;
var b=F.extend("sap.m.VBox",{metadata:{library:"sap.m",designtime:"sap/m/designtime/VBox.designtime"}});
b.prototype.init=function(){this.setDirection(a.Column);F.prototype.init.apply(this,arguments);};
return b;});
sap.ui.predefine('sap/m/VBoxRenderer',['./FlexBoxRenderer'],function(F){"use strict";var V={apiVersion:2};
V.render=function(r,c){F.render.apply(this,[r,c]);};
return V;},true);
sap.ui.predefine('sap/m/ValueStateHeader',["./library","sap/ui/core/library","sap/ui/Device","sap/ui/core/Core","sap/ui/core/Control"],function(l,c,D,C,a){"use strict";var V=c.ValueState;
var b=a.extend("sap.m.ValueStateHeader",{
metadata:{library:"sap.m",properties:{text:{type:"string",defaultValue:""},valueState:{type:"sap.ui.core.ValueState",defaultValue:V.None}},aggregations:{formattedText:{type:"sap.m.FormattedText",multiple:false}},associations:{popup:{type:"sap.ui.core.Popup",multiple:false}}},
renderer:{apiVersion:2,render:function(r,o){var m={None:"",Error:"sapMValueStateHeaderError",Warning:"sapMValueStateHeaderWarning",Success:"sapMValueStateHeaderSuccess",Information:"sapMValueStateHeaderInformation"};r.openStart("div",o).class("sapMValueStateHeaderRoot").class(m[o.getValueState()]).openEnd();r.openStart("span",o.getId()+"-inner").class("sapMValueStateHeaderText").openEnd();if(o.getFormattedText()){r.renderControl(o.getFormattedText());}else{r.text(o.getText());}r.close("span");r.close("div");}}
});
b.prototype._fnOrientationChange=function(){var p=this._getAssociatedPopupObject(),h=this.getDomRef();if(h&&p&&p.isA("sap.m.Dialog")){h.style.width=p.getDomRef().getBoundingClientRect().width+"px";}};
b.prototype.init=function(){D.orientation.attachHandler(this._fnOrientationChange,this);};
b.prototype.exit=function(){D.orientation.detachHandler(this._fnOrientationChange,this);};
b.prototype.setPopup=function(p){var t=this;var r=false;var P=(typeof p==="string")?C.byId(p):p;this.setAssociation("popup",P);if(P.isA("sap.m.Dialog")){return this;}P._afterAdjustPositionAndArrowHook=function(){var d=t.getDomRef();if(!d){return;}d.style.width=P.getDomRef().getBoundingClientRect().width+"px";d.style.height="auto";if(!r){r=true;setTimeout(function(){P._fnOrientationChange();},0);}};return this;};
b.prototype._getAssociatedPopupObject=function(){return C.byId(this.getPopup());};
b.prototype.onAfterRendering=function(){var p=this._getAssociatedPopupObject();if(p){this.getDomRef().style.width=p.getDomRef().getBoundingClientRect().width+"px";if(p.isA("sap.m.Popover")){setTimeout(function(){p._fnOrientationChange();},0);}}};
return b;},true);
sap.ui.predefine('sap/m/ViewSettingsCustomItem',['./ViewSettingsItem','sap/ui/base/ManagedObject','./library'],function(V,M,l){"use strict";
var a=V.extend("sap.m.ViewSettingsCustomItem",{metadata:{library:"sap.m",properties:{filterCount:{type:"int",group:"Behavior",defaultValue:0}},aggregations:{customControl:{type:"sap.ui.core.Control",multiple:false}}}});
a.prototype.init=function(){this.attachEvent("modelContextChange",function(){this._control&&this._control.setModel(this.getModel());}.bind(this));};
a.prototype.exit=function(){if(this._control&&!this._control.getParent()){this._control.destroy();delete this._control;}};
a.prototype.setCustomControl=function(c){this._control=c;return this;};
a.prototype.getCustomControl=function(){return this._control;};
a.prototype.setFilterCount=function(v){this.setProperty("filterCount",v,true);return this;};
a.prototype.setSelected=function(v){this.setProperty("selected",v,true);return this;};
a.prototype.clone=function(i,L,o){var c=M.prototype.clone.apply(this,arguments);c._control=this._control.clone();return c;};
return a;});
sap.ui.predefine('sap/m/ViewSettingsCustomTab',['./library','sap/ui/core/Item','sap/ui/core/IconPool'],function(l,I){"use strict";
var V=I.extend("sap.m.ViewSettingsCustomTab",{metadata:{library:"sap.m",properties:{icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:"sap-icon://competitor"},title:{type:"string",defaultValue:""}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}}}});
V.prototype.init=function(){this._aTabContents=[];};
V.prototype.exit=function(){this._aTabContents.forEach(function(c,i){c.destroy();delete this._aTabContents[i];},this);};
return V;});
sap.ui.predefine('sap/m/ViewSettingsDialog',['./library','./TitleAlignmentMixin','sap/ui/core/Control','sap/ui/core/IconPool','./Toolbar','./CheckBox','./SearchField','./List','./StandardListItem','./Dialog','./Button','./ToggleButton','./Title','./Label','./NavContainer','./Bar','./SegmentedButton','./Page','./ViewSettingsItem','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectObserver','sap/ui/base/EventProvider','sap/ui/Device','sap/ui/core/InvisibleText','./ViewSettingsDialogRenderer',"sap/m/GroupHeaderListItem","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,T,C,I,a,b,S,L,c,D,B,d,e,f,N,g,h,P,V,M,m,E,n,o,p,G,q,Q){"use strict";var r=l.ListMode;var s=l.ListType;var t=l.StringFilterOperator;var u=l.TitleAlignment;var v=l.ButtonType;var w="-list-item";
var x=C.extend("sap.m.ViewSettingsDialog",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Behavior",defaultValue:null},sortDescending:{type:"boolean",group:"Behavior",defaultValue:false},groupDescending:{type:"boolean",group:"Behavior",defaultValue:false},filterSearchOperator:{type:"sap.m.StringFilterOperator",group:"Behavior",defaultValue:t.StartsWith},titleAlignment:{type:"sap.m.TitleAlignment",group:"Misc",defaultValue:u.Auto}},aggregations:{sortItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"sortItem",bindable:"bindable"},groupItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"groupItem",bindable:"bindable"},filterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"filterItem",bindable:"bindable"},presetFilterItems:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"presetFilterItem",bindable:"bindable"},customTabs:{type:"sap.m.ViewSettingsCustomTab",multiple:true,singularName:"customTab",bindable:"bindable"}},associations:{selectedSortItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedGroupItem:{type:"sap.m.ViewSettingsItem",multiple:false},selectedPresetFilterItem:{type:"sap.m.ViewSettingsItem",multiple:false}},events:{confirm:{parameters:{sortItem:{type:"sap.m.ViewSettingsItem"},sortDescending:{type:"boolean"},groupItem:{type:"sap.m.ViewSettingsItem"},groupDescending:{type:"boolean"},presetFilterItem:{type:"sap.m.ViewSettingsItem"},filterItems:{type:"sap.m.ViewSettingsItem[]"},filterKeys:{type:"object",deprecated:true},filterCompoundKeys:{type:"object"},filterString:{type:"string"}}},cancel:{},resetFilters:{},reset:{},filterDetailPageOpened:{parameters:{parentFilterItem:{type:"sap.m.ViewSettingsFilterItem"}}}}}});
x.prototype.init=function(){var j=this.getId();this._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._sDialogWidth="350px";this._sDialogHeight="434px";this._bAppendedToUIArea=false;this._showSubHeader=false;this._filterDetailList=undefined;this._vContentPage=-1;this._oContentItem=null;this._oPreviousState={};this._sCustomTabsButtonsIdPrefix='-custom-button-';this._sTitleLabelId=j+"-title";this._sFilterDetailTitleLabelId=j+"-detailtitle";this._oFiltersSelectedOnly={};this._oKeylessFilters={};this._aggregationToListItems("sortItems",{text:{listProp:"title"},selected:{}},{tooltip:{}},{type:s.Active},{mode:r.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(k){var X=k.getParameter('listItem'),Y=this.getSortItems(),Z=this._getVSItem(X),i;Z.setProperty('selected',k.getParameter('selected'),true,false);this.setAssociation('selectedSortItem',Z,true);for(i=0;i<Y.length;i++){if(Z!==Y[i]){Y[i].setProperty('selected',false,true,false);}}this._checkResetStatus();}.bind(this)});};
x.prototype.exit=function(){this._rb=null;this._sDialogWidth=null;this._sDialogHeight=null;this._bAppendedToUIArea=null;this._showSubHeader=null;this._vContentPage=null;this._oContentItem=null;this._oPreviousState=null;this._sortContent=null;this._groupContent=null;this._filterContent=null;this._sCustomTabsButtonsIdPrefix=null;this._fnFilterSearchCallback=null;this._oKeylessFilters=null;if(this._bAppendedToUIArea&&this._dialog){var i=sap.ui.getCore().getStaticAreaRef();i=sap.ui.getCore().getUIArea(i);i.removeContent(this._dialog,true);}if(this._dialog){this._dialog.destroy();this._dialog=null;}if(this._navContainer){this._navContainer.destroy();this._navContainer=null;}if(this._titleLabel){this._titleLabel.destroy();this._titleLabel=null;}if(this._page1){this._page1.destroy();this._page1=null;}if(this._header){this._header.destroy();this._header=null;}if(this._resetButton){this._resetButton.destroy();this._resetButton=null;}if(this._subHeader){this._subHeader.destroy();this._subHeader=null;}if(this._segmentedButton){this._segmentedButton.destroy();this._segmentedButton=null;}if(this._sortButton){this._sortButton.destroy();this._sortButton=null;}if(this._groupButton){this._groupButton.destroy();this._groupButton=null;}if(this._filterButton){this._filterButton.destroy();this._filterButton=null;}if(this._sortList){this._sortList.destroy();this._sortList=null;}if(this._ariaSortListInvisibleText){this._ariaSortListInvisibleText.destroy();this._ariaSortListInvisibleText=null;}if(this._sortOrderList){this._sortOrderList.destroy();this._sortOrderList=null;this._ariaSortOrderInvisibleText.destroy();this._ariaSortOrderInvisibleText=null;}if(this._oGroupingNoneItem){this._oGroupingNoneItem.destroy();this._oGroupingNoneItem=null;}if(this._groupList){this._groupList.destroy();this._groupList=null;this._ariaGroupListInvisibleText.destroy();this._ariaGroupListInvisibleText=null;}if(this._groupOrderList){this._groupOrderList.destroy();this._groupOrderList=null;this._ariaGroupOrderInvisibleText.destroy();this._ariaGroupOrderInvisibleText=null;}if(this._presetFilterList){this._presetFilterList.destroy();this._presetFilterList=null;}if(this._filterList){this._filterList.destroy();this._filterList=null;}if(this._page2){this._page2.destroy();this._page2=null;}if(this._detailTitleLabel){this._detailTitleLabel.destroy();this._detailTitleLabel=null;}if(this._filterDetailList){this._filterDetailList.destroy();this._filterDetailList=null;}if(this._oStringFilter){this._oStringFilter=null;}if(this._oSelectedFilterKeys){this._oSelectedFilterKeys=null;}};
x.prototype._aggregationToListItems=function(i,j,k,X,Y){var Z=this._getListType(i),$="_"+Z+"List";if(!this.mToList){this.mToList={};}this.mToList[Z]={"itemPropertyMap":j,"itemAggregationMap":k,"listItemOptions":X,"listOptions":Y,"listName":$};};
x.prototype._getListType=function(i){return i.replace('Items','');};
x.prototype._createList=function(i){var j=this.getId()+"-"+i+"list",k=new L(j,this.mToList[i].listOptions),X=this._createGroupHeaderItem(i);k.addItem(X);this[this.mToList[i].listName]=k;return k;};
x.prototype._createGroupHeaderItem=function(i){return new G({title:this._rb.getText("VIEWSETTINGS_"+i.toUpperCase()+"_OBJECT")});};
x.prototype._getList=function(i){if(!this.mToList||!this.mToList[i]){return;}return this[this.mToList[i].listName];};
x.prototype._createListItem=function(i,j){var k=this.mToList[i].listItemOptions,X=this.mToList[i].itemPropertyMap,Y=this.mToList[i].itemAggregationMap,Z,$;for(var _ in X){if(X.hasOwnProperty(_)){Z=X[_].listProp||_;k[Z]=this._createListItemPropertyValue(i,_,j);}}for(var a1 in Y){if(Y.hasOwnProperty(a1)){k[a1]=j.getAggregation(a1);}}$=new c(k).data('item',j);return $;};
x.prototype._createListItemPropertyValue=function(i,j,k){var X=k.getMetadata().getAllProperties()[j].get(k),Y=this.mToList[i].itemPropertyMap[j].fn;return Y?Y(X):X;};
x.prototype._getListItem=function(i,j){var k=this._getList(i).getItems().filter(function(X){return X.data('item')===j;});return k.length?k[0]:null;};
x.prototype._getVSItem=function(i){return i.data('item');};
x.prototype.addCustomTab=function(i){var j=i.getId();if(j==='sort'||j==='filter'||j==='group'){throw'Id "'+j+'" is reserved and cannot be used as custom tab id.';}this.addAggregation('customTabs',i);return this;};
x.prototype.invalidate=function(){if(this._dialog&&(!arguments[0]||arguments[0]&&arguments[0].getId()!==this.getId()+"-dialog")){this._dialog.invalidate(arguments);}};
x.prototype.addStyleClass=function(){var i=this._getDialog();i.addStyleClass.apply(i,arguments);return this;};
x.prototype.removeStyleClass=function(){var i=this._getDialog();i.removeStyleClass.apply(i,arguments);return this;};
x.prototype.toggleStyleClass=function(){var i=this._getDialog();i.toggleStyleClass.apply(i,arguments);return this;};
x.prototype.hasStyleClass=function(){var i=this._getDialog();return i.hasStyleClass.apply(i,arguments);};
x.prototype.getDomRef=function(){if(this._dialog){return this._dialog.getDomRef.apply(this._dialog,arguments);}else{return null;}};
x.prototype.setTitle=function(i){this._getTitleLabel().setText(i);this.setProperty("title",i);return this;};
x.prototype.addAggregation=function(i,j,k){C.prototype.addAggregation.apply(this,arguments);var X=this._getListType(i);if(this.mToList[X]){var Y=this._createListItem(X,j);var Z=this._getList(X);if(!Z){Z=this._createList(X);}else if(!Z.getItems().length){Z.addItem(this._createGroupHeaderItem(X));}Z.addItem(Y);this._attachItemPropertyChange(X,j);}else{this._attachItemEventHandlers(i,j);}if(i==="filterItems"){this._observeItem(j);}return this;};
x.prototype.insertAggregation=function(i,j,k,X){C.prototype.insertAggregation.apply(this,arguments);var Y=this._getListType(i);if(this.mToList[Y]){var Z=this._createListItem(Y,j);var $=this._getList(Y);if(!$){$=this._createList(Y);$.insertItem(Z,k);}else if(!$.getItems().length){$.addItem(this._createGroupHeaderItem(Y));$.insertItem(Z,k+1);}else{$.insertItem(Z,k);}this._attachItemPropertyChange(Y,j);}else{this._attachItemEventHandlers(i,j);}if(i==="filterItems"){this._observeItem(j);}return this;};
x.prototype.removeAggregation=function(i,j,k){H.call(this,i,j);var X=C.prototype.removeAggregation.apply(this,arguments);var Y=this._getListType(i);if(this.mToList[Y]){var Z=this._getListItem(Y,X);var $=this._getList(Y);var _=$.removeItem(Z);_.destroy();this._detachItemPropertyChange(X);}if(i==="filterItems"){this._unobserveItem(X);if(!this.getFilterItems().length){this._disconnectAndDestroyFilterItemsObserver();}}return X;};
x.prototype.removeAllAggregation=function(i,j){H.call(this);var k=C.prototype.removeAllAggregation.apply(this,arguments);var X=this._getListType(i);if(this.mToList[X]){var Y=this._getList(X);if(Y){var Z=Y.removeAllItems();Z.forEach(function($){$.destroy();});}k.forEach(function($){this._detachItemPropertyChange($);},this);}if(i==="filterItems"){this._disconnectAndDestroyFilterItemsObserver();}return k;};
x.prototype.destroyAggregation=function(i,j){H.call(this);C.prototype.destroyAggregation.apply(this,arguments);var k=this._getListType(i);if(this.mToList[k]){var X=this._getList(k);if(X){X.destroyItems();}}if(i==="filterItems"){this._disconnectAndDestroyFilterItemsObserver();}return this;};
x.prototype._detachItemPropertyChange=function(i){delete E.getEventList(i)["itemPropertyChanged"];};
x.prototype._attachItemPropertyChange=function(i,j){j.attachEvent('itemPropertyChanged',function fnHandleItemPropertyChanged(k){var X,Y,Z,$,_,a1;X=this._getListItem(i,j);Y=k.getParameter('propertyKey');if(!this.mToList[i].itemPropertyMap[Y]){return;}Z=this.mToList[i].itemPropertyMap[Y].listProp||Y;$=k.getParameter('propertyValue');_=this.mToList[i].itemPropertyMap[Y].fn;a1=_?_($):$;X.getMetadata().getAllProperties()[Z].set(X,a1);},this);};
x.prototype._getFilterItemsObserver=function(){if(!this._oFilterItemsObserver){this._oFilterItemsObserver=new m(function(){if(this._oSelectedFilterKeys){this.setSelectedFilterCompoundKeys(this._oSelectedFilterKeys);}}.bind(this));}return this._oFilterItemsObserver;};
x.prototype._observeItem=function(i){this._getFilterItemsObserver().observe(i,{aggregations:["items"]});};
x.prototype._unobserveItem=function(i){this._getFilterItemsObserver().unobserve(i,{aggregations:["items"]});};
x.prototype._disconnectAndDestroyFilterItemsObserver=function(){if(this._oFilterItemsObserver){this._oFilterItemsObserver.disconnect();this._oFilterItemsObserver.destroy();this._oFilterItemsObserver=null;}};
x.prototype._attachItemEventHandlers=function(i,j){if(i!=='groupItems'&&i!=='filterItems'){return this;}var k=i.replace('Items','');k=k.charAt(0).toUpperCase()+k.slice(1);j.attachEvent('itemPropertyChanged',function(i,X){if(i==='filterItems'&&X.getParameter('changedItem').getParent().getMetadata().getName()==='sap.m.ViewSettingsFilterItem'){if(X.getParameter('propertyKey')!=='selected'){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}else{if(this._filterDetailList){var Y=this._filterDetailList.getItems();Y.forEach(function(Z){if(Z.data('item').getId()===X.getParameter('changedItem').getId()){Z.setSelected(X.getParameter('propertyValue'));}});this._updateSelectAllCheckBoxState();}}this._updateFilterCounters();}else{if(typeof this['_init'+k+'Content']==='function'){this['_init'+k+'Content']();}if(typeof this['_init'+k+'Items']==='function'){this['_init'+k+'Items']();}}}.bind(this,i));j.attachEvent('filterDetailItemsAggregationChange',function(X){if(this._vContentPage===3&&this._oContentItem){this._setFilterDetailTitle(this._oContentItem);this._initFilterDetailItems(this._oContentItem);}}.bind(this));return this;};
x.prototype._setFilterDetailTitle=function(i){var j=this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")+" "+i.getText();this._getDetailTitleLabel().setText(j);this._toggleDialogTitle(this._sFilterDetailTitleLabelId);};
x.prototype._toggleDialogTitle=function(i){var j=this._getDialog(),k=j.getAriaLabelledBy(),X=[this._sTitleLabelId,this._sFilterDetailTitleLabelId];if(X.indexOf(i)===-1&&k.indexOf(i)>-1){return this;}for(var Y in X){j.removeAriaLabelledBy(X[Y]);}j.addAriaLabelledBy(i);return this;};
x.prototype.updateAggregation=function(i){C.prototype.updateAggregation.apply(this,arguments);if(i!=='groupItems'&&i!=='filterItems'){return this;}var j=i.replace('Items','');j=j.charAt(0).toUpperCase()+j.slice(1);if(typeof this['_init'+j+'Content']==='function'){this['_init'+j+'Content']();}if(typeof this['_init'+j+'Items']==='function'){this['_init'+j+'Items']();}};
x.prototype.addSortItem=function(i){this.addAggregation("sortItems",i);if(i.getSelected()){this.setSelectedSortItem(i);}return this;};
x.prototype.addGroupItem=function(i){this.addAggregation("groupItems",i);if(i.getSelected()){this.setSelectedGroupItem(i);}return this;};
x.prototype.addPresetFilterItem=function(i){this.addAggregation("presetFilterItems",i);if(i.getSelected()){this.setSelectedPresetFilterItem(i);}return this;};
x.prototype.setSelectedSortItem=function(j){var k=this.getSortItems(),i=0,X=A(j,k,"Could not set selected sort item. Item is not found: '"+j+"'");if(F(X)){for(i=0;i<k.length;i++){if(k[i].getId()!==X.getId()){k[i].setProperty('selected',false,true);}}if(X.getProperty('selected')!==true){X.setProperty('selected',true,true);}if(this._getDialog().isOpen()){this._updateListSelection(this._sortList,X);}this.setAssociation("selectedSortItem",X,true);}return this;};
x.prototype.setSelectedGroupItem=function(j){var k=this.getGroupItems(),i=0,X=A(j,k,"Could not set selected group item. Item is not found: '"+j+"'");if(!X&&!j){X=this._oGroupingNoneItem;}if(F(X)){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}X.setProperty('selected',true,true);if(this._getDialog().isOpen()){this._updateListSelection(this._groupList,X);}this.setAssociation("selectedGroupItem",X,true);}return this;};
x.prototype.setSelectedPresetFilterItem=function(j){var k=this.getPresetFilterItems(),i=0,X=A(j,k,"Could not set selected preset filter item. Item is not found: '"+j+"'");if(F(X)||X===null){for(i=0;i<k.length;i++){k[i].setProperty('selected',false,true);}if(X!==null){X.setProperty('selected',true,true);}this._clearSelectedFilters();this.setAssociation("selectedPresetFilterItem",X,true);}return this;};
x.prototype.open=function(i){if(!this.getParent()&&!this._bAppendedToUIArea){var j=sap.ui.getCore().getStaticAreaRef();j=sap.ui.getCore().getUIArea(j);j.addContent(this._getDialog(),true);this._bAppendedToUIArea=true;}if(i&&this._vContentPage===3){setTimeout(this._getNavContainer()["to"].bind(this._getNavContainer(),this._getPage1().getId(),"show"),0);}this._initDialogContent(i);this._oPreviousState={sortItem:sap.ui.getCore().byId(this.getSelectedSortItem()),sortDescending:this.getSortDescending(),groupItem:sap.ui.getCore().byId(this.getSelectedGroupItem()),groupDescending:this.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(this.getSelectedPresetFilterItem()),filterKeys:this.getSelectedFilterKeys(),filterCompoundKeys:this.getSelectedFilterCompoundKeys(),navPage:this._getNavContainer().getCurrentPage(),contentPage:this._vContentPage,contentItem:this._oContentItem};if(!this._oInitialState){this._oInitialState={sortItem:this.getSelectedSortItem(),sortDescending:this.getSortDescending(),groupItem:this.getSelectedGroupItem(),groupDescending:this.getGroupDescending(),presetFilterItem:this.getSelectedPresetFilterItem()};}if(n.system.desktop){this._getDialog().attachEventOnce("afterOpen",function(){var k=this._getNavContainer().getCurrentPage(),$;if(k){$=k.$("cont").firstFocusableDomRef();if($){if(Q($).hasClass('sapMListUl')){var X=Q($).find('.sapMLIB');X.length&&X[0].focus();return;}$.focus();}}},this);}this._checkResetStatus();this._getDialog().open();return this;};
x.prototype.getSelectedFilterItems=function(){var k=[],X=this.getFilterItems(),Y,Z=true,i=0,j;for(;i<X.length;i++){if(X[i]instanceof sap.m.ViewSettingsCustomItem){if(X[i].getSelected()){k.push(X[i]);}}else if(X[i]instanceof sap.m.ViewSettingsFilterItem){Y=X[i].getItems();Z=X[i].getMultiSelect();for(j=0;j<Y.length;j++){if(Y[j].getSelected()){k.push(Y[j]);if(!Z){break;}}}}}return k;};
x.prototype.getSelectedFilterString=function(){var k="",X,Y=this.getSelectedPresetFilterItem(),Z=this.getFilterItems(),$,_=true,i=0,j;if(Y){k=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+sap.ui.getCore().byId(Y).getText());}else{for(;i<Z.length;i++){if(Z[i]instanceof sap.m.ViewSettingsCustomItem){if(Z[i].getSelected()){k+=Z[i].getText()+", ";}}else if(Z[i]instanceof sap.m.ViewSettingsFilterItem){$=Z[i].getItems();_=Z[i].getMultiSelect();X="";for(j=0;j<$.length;j++){if($[j].getSelected()){X+=$[j].getText()+", ";if(!_){break;}}}X=X.substring(0,X.length-2);if(X){X=" ("+X+")";k+=Z[i].getText()+X+", ";}}}k=k.substring(0,k.length-2);if(k){k=this._rb.getText("VIEWSETTINGS_FILTERTEXT").concat(" "+k);}}return k;};
x.prototype.getSelectedFilterKeys=function(){var j={},k=this.getSelectedFilterItems(),i=0;for(;i<k.length;i++){j[k[i].getKey()]=k[i].getSelected();}return j;};
x.prototype.getSelectedFilterCompoundKeys=function(){var j={},k=this.getSelectedFilterItems(),i,X,Y,Z;this._oKeylessFilters={};for(i=0;i<k.length;i++){Z=k[i];if(Z instanceof sap.m.ViewSettingsCustomItem){X=Z.getKey();j[X]=Z.getSelected();}else{X=Z.getKey();Y=Z.getParent().getKey();if(!j[Y]){j[Y]={};}j[Y][X]=Z.getSelected();if(X===""){if(!this._oKeylessFilters[Y]){this._oKeylessFilters[Y]={};}this._oKeylessFilters[Y][Z.getText()]=true;}}}return j;};
x.prototype.setSelectedFilterKeys=function(X){var Y=this.getFilterItems(),Z={},$,_,i,j,k;if(Object.keys(X).length){this._clearPresetFilter();}for(var a1 in X){$=null;if(X.hasOwnProperty(a1)){for(i=0;i<Y.length;i++){if(Y[i]instanceof sap.m.ViewSettingsCustomItem){if(Y[i].getKey()===a1){$=Y[i];Y[i].setProperty('selected',X[a1],true);}}else if(Y[i]instanceof sap.m.ViewSettingsFilterItem){Z=Y[i].getItems();_=Y[i].getMultiSelect();for(j=0;j<Z.length;j++){if(Z[j].getKey()===a1){$=Z[j];if(!_){for(k=0;k<Z.length;k++){Z[k].setProperty('selected',false,true);}}break;}}}if($){break;}}if($===null){q.warning('Cannot set state for key "'+a1+'" because there is no filter with these keys');continue;}$.setProperty('selected',X[a1],true);}}return this;};
x.prototype.setSelectedFilterCompoundKeys=function(i){var j=this.getFilterItems(),k,X,Y,Z,$,_,a1,b1,c1,d1;this._oSelectedFilterKeys=i;if(Object.keys(i).length){this._clearPresetFilter();for(k in i){Z=null;for(d1=0;d1<j.length;d1++){X=j[d1].getKey();if(X===k){Z=j[d1];break;}}if(Z instanceof sap.m.ViewSettingsCustomItem){Z.setProperty('selected',i[k],true);}else if(Z instanceof sap.m.ViewSettingsFilterItem){$=i[k];_=Z.getItems();a1=Z.getMultiSelect();c1=false;for(d1=0;d1<_.length;d1++){X=_[d1].getKey();Y=_[d1].getText();if((X!==""&&$[X])||(X===""&&this._oKeylessFilters[k]&&this._oKeylessFilters[k][Y])){b1=c1?false:$[X];}else{b1=false;}_[d1].setProperty("selected",b1,true);if(b1&&!a1){c1=true;}}}}}return this;};
x.prototype._checkForInnerCustomItems=function(j){for(var i=0;i<j.length;i++){if(j[i].isA("sap.m.ViewSettingsCustomItem")){return true;}}return false;};
x.prototype._checkForCustomItems=function(){var i=this.getSortItems(),j=this.getGroupItems(),k=this.getFilterItems(),X=this.getPresetFilterItems();return this.getAggregation("customTabs").length||i.length&&this._checkForInnerCustomItems(i)||j.length&&this._checkForInnerCustomItems(j)||k.length&&this._checkForInnerCustomItems(k)||X.length&&this._checkForInnerCustomItems(X);};
x.prototype._checkResetStatus=function(){var i=false,j=this.getSelectedFilterItems();if(this._checkForCustomItems()){i=true;}else{if(this._oInitialState){if(j.length>0){i=true;}if((this._oInitialState.sortItem&&this._oInitialState.sortItem!==this.getSelectedSortItem())||this._oInitialState.sortDescending!==this.getSortDescending()){i=true;}if((this._oInitialState.groupItem&&this._oInitialState.groupItem!==this.getSelectedGroupItem())||this._oInitialState.groupDescending!==this.getGroupDescending()){i=true;}if(this._oInitialState.presetFilterItem!==undefined&&this.getSelectedPresetFilterItem()!==null){i=true;}}}if(this._resetButton){this._resetButton.setEnabled(i);}if(this._detailResetButton){this._detailResetButton.setEnabled(i);}};
x.prototype._globalReset=function(){this.clearFilters();this._oInitialState.sortItem!==undefined&&this.setSelectedSortItem(sap.ui.getCore().byId(this._oInitialState.sortItem));this.setSortDescending(this._oInitialState.sortDescending);this._updateListSelection(this._sortOrderList,this._oInitialState.sortDescending);this._oInitialState.groupItem!==undefined&&this.setSelectedGroupItem(sap.ui.getCore().byId(this._oInitialState.groupItem));this.setGroupDescending(this._oInitialState.groupDescending);this._updateListSelection(this._groupOrderList,this._oInitialState.groupDescending);this._checkResetStatus();this.fireReset();};
x.prototype._getDialog=function(){var i=this;if(this._dialog===undefined){this._dialog=new D(this.getId()+"-dialog",{ariaLabelledBy:this._sTitleLabelId,showHeader:false,stretch:n.system.phone,verticalScrolling:true,horizontalScrolling:false,contentWidth:this._sDialogWidth,contentHeight:this._sDialogHeight,content:this._getNavContainer(),titleAlignment:this.getTitleAlignment(),beginButton:new B(this.getId()+"-acceptbutton",{text:this._rb.getText("VIEWSETTINGS_ACCEPT"),type:v.Emphasized}).attachPress(this._onConfirm,this),endButton:new B(this.getId()+"-cancelbutton",{text:this._rb.getText("VIEWSETTINGS_CANCEL")}).attachPress(this._onCancel,this)}).addStyleClass("sapMVSD");this.addDependent(this._dialog);var j=this._dialog.onsapescape;this._dialog.onsapescape=function(k){if(j){j.call(i._dialog,k);}i._onCancel();};this._dialog.onsapentermodifiers=function(k){if(k.shiftKey&&!k.ctrlKey&&!k.altKey){i._pressBackButton();}};}return this._dialog;};
x.prototype._getNavContainer=function(){if(this._navContainer===undefined){this._navContainer=new N(this.getId()+'-navcontainer',{pages:[]});}return this._navContainer;};
x.prototype._getTitleLabel=function(){if(this._titleLabel===undefined){this._titleLabel=new f(this._sTitleLabelId,{text:this._rb.getText("VIEWSETTINGS_TITLE")}).addStyleClass("sapMVSDTitle");}return this._titleLabel;};
x.prototype._getResetButton=function(){if(!this._resetButton){this._resetButton=new B(this.getId()+"-resetbutton",{press:function(){this._globalReset();}.bind(this),text:this._rb.getText("VIEWSETTINGS_RESET")});}return this._resetButton;};
x.prototype._getDetailResetButton=function(){if(this._detailResetButton===undefined){this._detailResetButton=new B(this.getId()+"-detailresetbutton",{press:function(){this._globalReset();}.bind(this),text:this._rb.getText("VIEWSETTINGS_RESET")});}return this._detailResetButton;};
x.prototype._getDetailTitleLabel=function(){if(this._detailTitleLabel===undefined){this._detailTitleLabel=new f(this.getId()+"-detailtitle",{text:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY")}).addStyleClass("sapMVSDTitle");}return this._detailTitleLabel;};
x.prototype._getHeader=function(){if(this._header===undefined){this._header=new g({contentMiddle:[this._getTitleLabel()]}).addStyleClass("sapMVSDBar");}this._setupBarTitleAlignment(this._header,this.getId()+'_header');return this._header;};
x.prototype._getSubHeader=function(){if(this._subHeader===undefined){this._subHeader=new g({contentLeft:[this._getSegmentedButton()]}).addStyleClass("sapMVSDBar");}return this._subHeader;};
x.prototype._getSegmentedButton=function(){var j=this,k=this.getCustomTabs(),X=k.length,i=0;if(this._segmentedButton===undefined){this._segmentedButton=new h({select:function(Y){var Z=Y.getParameter('id');if(Z===j.getId()+"-sortbutton"){j._switchToPage(0);}else if(Z===j.getId()+"-groupbutton"){j._switchToPage(1);}else if(Z===j.getId()+"-filterbutton"){j._switchToPage(2);}else{for(i=0;i<X;i++){var $=k[i],_=j.getId()+j._sCustomTabsButtonsIdPrefix+$.getId();if(!j._isEmptyTab($)&&Z===_){j._switchToPage($.getId());break;}}}q.info('press event segmented: '+Y.getParameter('id'));}}).addStyleClass("sapMVSDSeg");this._segmentedButton._bPreventWidthRecalculationOnAfterRendering=true;}return this._segmentedButton;};
x.prototype._getSortButton=function(){if(this._sortButton===undefined){this._sortButton=new B(this.getId()+"-sortbutton",{icon:I.getIconURI("sort"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});}return this._sortButton;};
x.prototype._getGroupButton=function(){if(this._groupButton===undefined){this._groupButton=new B(this.getId()+"-groupbutton",{icon:I.getIconURI("group-2"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});}return this._groupButton;};
x.prototype._getFilterButton=function(){if(this._filterButton===undefined){this._filterButton=new B(this.getId()+"-filterbutton",{icon:I.getIconURI("filter"),tooltip:this._rb.getText("VIEWSETTINGS_TITLE_FILTER")});}return this._filterButton;};
x.prototype._getPage1=function(i){if(this._page1===undefined&&!i){this._page1=new P(this.getId()+'-page1',{title:this._rb.getText("VIEWSETTINGS_TITLE"),customHeader:this._getHeader()});this._getNavContainer().addPage(this._page1);}return this._page1;};
x.prototype._getPage2=function(){var i,j,k;if(this._page2===undefined){j=new B(this.getId()+"-backbutton",{icon:I.getIconURI("nav-back"),press:[this._pressBackButton,this]});k=this._getDetailResetButton();i=new g({contentLeft:[j],contentMiddle:[this._getDetailTitleLabel()],contentRight:[k]}).addStyleClass("sapMVSDBar");this._setupBarTitleAlignment(i,this.getId()+"_page2_header");this._page2=new P(this.getId()+'-page2',{title:this._rb.getText("VIEWSETTINGS_TITLE_FILTERBY"),customHeader:i});this._getNavContainer().addPage(this._page2);}return this._page2;};
x.prototype._initFilterDetailItems=function(k){if(!(k instanceof sap.m.ViewSettingsFilterItem)){return;}var X;var Y=k.getMultiSelect();var Z=k.getItems();var $=this;if(this._filterDetailList){this._filterDetailList.destroy();}this._getPage2().removeAllAggregation('content');this._filterDetailList=new L({mode:(Y?r.MultiSelect:r.SingleSelectLeft),includeItemInSelection:true,selectionChange:function(_){var a1,b1=_.getParameter("listItems"),c1,i=0,d1;$._clearPresetFilter();if(Y){this._updateSelectAllCheckBoxState();}if(b1.length>1&&Y){c1=k.getItems();for(;i<c1.length;i++){for(var j=0;j<b1.length;j++){if(c1[i].getKey()===b1[j].getCustomData()[0].getValue().getKey()){c1[i].setProperty('selected',b1[j].getSelected(),true);}}}}else{a1=_.getParameter("listItem").data("item");if(!k.getMultiSelect()){c1=k.getItems();for(;i<c1.length;i++){if(c1[i].getId()!==a1.getId()){c1[i].setProperty('selected',false,true);}}}d1=_.getParameter("listItem").getSelected();if(a1.getProperty('selected')!==d1){a1.setProperty('selected',d1,true);}}this._checkResetStatus();}.bind(this)});for(var i=0;i<Z.length;i++){X=new c({title:M.escapeSettingsValue(Z[i].getText()),type:s.Active,selected:Z[i].getSelected(),tooltip:Z[i].getTooltip()}).data("item",Z[i]);this._filterDetailList.addItem(X);}this._filterSearchField=this._getFilterSearchField(this._filterDetailList);this._showOnlySelectedButton=this._getShowOnlySelectedButton();this._searchBar=new a({content:[this._filterSearchField.addStyleClass('sapMVSDFilterSearchField').addStyleClass('sapMTBShrinkItem'),this._showOnlySelectedButton]});this._getPage2().addContent(this._searchBar);this._getPage2().getCustomHeader().addStyleClass('sapMVSDBarWithSearch');if(Y){this._selectAllCheckBox=this._createSelectAllCheckbox(Z,this._filterDetailList);if(this._filterDetailList.getItems().length===0){this._selectAllCheckBox.setEnabled(false);}this._filterDetailList.setHeaderToolbar(new a({content:[this._selectAllCheckBox]}).addStyleClass('sapMVSDFilterHeaderToolbar'));}this._setFilterDetailItemsVisibility(this._filterDetailList,true);this._getPage2().addContent(this._filterDetailList);};
x.prototype._initSortContent=function(){if(this._sortContent){return;}this._vContentPage=-1;this._ariaSortOrderInvisibleText=new o(this.getId()+"-sortOrderLabel",{text:this._rb.getText("VIEWSETTINGS_SORT_DIRECTION")});this._sortOrderList=new L(this.getId()+"-sortorderlist",{mode:r.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(i){this.setProperty('sortDescending',i.getParameter("listItem").data("item"),true);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaSortOrderInvisibleText});this._sortOrderList.addItem(new G({title:this._rb.getText("VIEWSETTINGS_SORT_BY")}));this._sortOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._sortOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaSortListInvisibleText=new o(this.getId()+"-sortListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_SORT")});this._sortList.addAriaLabelledBy(this._ariaSortListInvisibleText);this._sortContent=[this._ariaSortOrderInvisibleText,this._sortOrderList,this._ariaSortListInvisibleText,this._sortList];};
x.prototype._initGroupItems=function(){var i,j,k=this.getGroupItems(),X=this._rb.getText("VIEWSETTINGS_GROUP_OBJECT");this._groupList.destroyItems();if(!!k.length){this._groupList.addItem(new G({title:X}));k.forEach(function(Y){i=new c({id:Y.getId()+w,title:M.escapeSettingsValue(Y.getText()),type:s.Active,selected:Y.getSelected(),tooltip:Y.getTooltip()}).data("item",Y);this._groupList.addItem(i);},this);if(!this._oGroupingNoneItem||this._oGroupingNoneItem.bIsDestroyed){j=!!this.getSelectedGroupItem();this._oGroupingNoneItem=new V({text:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!j,itemPropertyChanged:function(){this._initGroupContent();this._initGroupItems();}.bind(this)});!j&&this.setAssociation("selectedGroupItem",this._oGroupingNoneItem,true);}i=new c({id:this._oGroupingNoneItem.getId()+w,title:this._oGroupingNoneItem.getText(),type:s.Active,selected:this._oGroupingNoneItem.getSelected()}).data("item",this._oGroupingNoneItem);this._groupList.addItem(i);}};
x.prototype._initGroupContent=function(){var i=this._rb.getText("VIEWSETTINGS_GROUP_BY");if(this._groupContent){return;}this._vContentPage=-1;this._ariaGroupOrderInvisibleText=new o(this.getId()+"-groupOrderLabel",{text:this._rb.getText("VIEWSETTINGS_GROUP_DIRECTION")});this._groupOrderList=new L(this.getId()+"-grouporderlist",{mode:r.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(j){this.setProperty('groupDescending',j.getParameter("listItem").data("item"),true);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaGroupOrderInvisibleText});this._groupOrderList.addItem(new G({title:i}));this._groupOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_ASCENDING_ITEM")}).data("item",false).setSelected(true));this._groupOrderList.addItem(new c({title:this._rb.getText("VIEWSETTINGS_DESCENDING_ITEM")}).data("item",true));this._ariaGroupListInvisibleText=new o(this.getId()+"-groupListLabel",{text:this._rb.getText("VIEWSETTINGS_TITLE_GROUP")});this._groupList=new L(this.getId()+"-grouplist",{mode:r.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(j){var k=j.getParameter("listItem").data("item");this.setSelectedGroupItem(k);this._checkResetStatus();}.bind(this),ariaLabelledBy:this._ariaGroupListInvisibleText});this._groupContent=[this._ariaGroupOrderInvisibleText,this._groupOrderList,this._ariaGroupListInvisibleText,this._groupList];};
x.prototype._initFilterItems=function(){var i,j,k,X=this,Y=this._rb.getText("VIEWSETTINGS_FILTER_BY");this._presetFilterList.destroyItems();i=this.getPresetFilterItems();if(i.length){i.forEach(function(Z){k=new c({id:Z.getId()+w,title:M.escapeSettingsValue(Z.getText()),type:s.Active,selected:Z.getSelected(),tooltip:Z.getTooltip()}).data("item",Z);this._presetFilterList.addItem(k);},this);}if(i.length){k=new c({id:this._presetFilterList.getId()+"-none"+w,title:this._rb.getText("VIEWSETTINGS_NONE_ITEM"),selected:!!this.getSelectedPresetFilterItem()});this._presetFilterList.addItem(k);}this._filterList.destroyItems();j=this.getFilterItems();this._filterList.addItem(new G({title:Y}));if(j.length){j.forEach(function(Z){k=new c({id:Z.getId()+w,title:M.escapeSettingsValue(Z.getText()),type:s.Active,tooltip:Z.getTooltip(),press:(function(Z){return function($){if(X._navContainer.getCurrentPage().getId()!==X.getId()+'-page2'){X._switchToPage(3,Z);X._prevSelectedFilterItem=this;setTimeout(X._navContainer["to"].bind(X._navContainer,X.getId()+'-page2',"slide"),0);}if(n.system.desktop&&X._filterDetailList&&X._filterDetailList.getItems()[0]){X._getNavContainer().attachEventOnce("afterNavigate",function(){X._filterDetailList.getItems()[0].focus();});}};}(Z))}).data("item",Z);this._filterList.addItem(k);},this);}};
x.prototype._initFilterContent=function(){if(this._filterContent){return;}this._vContentPage=-1;this._presetFilterList=new L(this.getId()+"-predefinedfilterlist",{mode:r.SingleSelectLeft,includeItemInSelection:true,selectionChange:function(i){var j=i.getParameter("listItem").data("item");if(j){j.setProperty('selected',i.getParameter("listItem").getSelected(),true);}this.setAssociation("selectedPresetFilterItem",j,true);this._clearSelectedFilters();this._checkResetStatus();}.bind(this)});this._filterList=new L(this.getId()+"-filterlist",{});this._filterContent=[this._presetFilterList,this._filterList];};
x.prototype._initDialogContent=function(i){var j=!!this.getSortItems().length,k=!!this.getGroupItems().length,X=!!this.getPresetFilterItems().length,Y=!!this.getFilterItems().length;if(j){this._initSortContent();}if(k){this._initGroupContent();this._initGroupItems();}if(X||Y){this._initFilterContent();this._initFilterItems();}this._updateDialogState(i);this._updateListSelections();};
x.prototype._getTabButton=function(i,j){var k=j+i.getId(),X=sap.ui.getCore().byId(k);if(X){return X;}else{return new B({id:k,icon:i.getIcon(),tooltip:i.getTooltip()});}};
x.prototype._updateDialogState=function(i){var j=!!this.getSortItems().length,k=!!this.getGroupItems().length,X=!!this.getPresetFilterItems().length,Y=!!this.getFilterItems().length,Z=!!this.getCustomTabs().length,$=this._getSegmentedButton(),_=null,a1=false,b1={"sort":0,"group":1,"filter":2};$.removeAllButtons();if(this._filterContent){this._presetFilterList.setVisible(true);this._filterList.setVisible(true);}if(j){$.addButton(this._getSortButton());}if(X||Y){$.addButton(this._getFilterButton());if(!X){this._presetFilterList.setVisible(false);}if(!Y){this._filterList.setVisible(false);}}if(k){$.addButton(this._getGroupButton());}if(Z){this.getCustomTabs().forEach(function(d1){if(!this._isEmptyTab(d1)){var e1=this.getId()+this._sCustomTabsButtonsIdPrefix,f1=this._getTabButton(d1,e1);$.addButton(f1);}}.bind(this));}this._showSubHeader=this._hasSubHeader();if(i===undefined&&this._vContentPage!==-1){i=this._vContentPage;switch(i){case 0:i='sort';break;case 1:i='group';break;case 2:i='filter';break;}}if(i===this._vContentPage&&this._vContentPage===3){this._vContentPage=-1;this._switchToPage(3,this._oContentItem);}else{i=this._determineValidPageId(i);for(var c1 in b1){if(i===c1){a1=true;_=this.getId()+'-'+i+'button';i=b1[c1];break;}}if(!a1){_=this.getId()+this._sCustomTabsButtonsIdPrefix+i;}this._getSegmentedButton().setSelectedButton(_);this._switchToPage(i);if(this._getNavContainer().getCurrentPage()!==this._getPage1()){this._getNavContainer().to(this._getPage1().getId());}}};
x.prototype._determineValidPageId=function(i){var j='sort',k=false,X=[];X=this._fetchValidPagesIds();if(X.length){j=X[0];}else{q.warning('No available pages to load - missing items.');}if(!i){i=j;}else{X.filter(function(Y){if(Y===i){k=true;return false;}return true;});if(!k){i=j;}}return i;};
x.prototype._fetchValidPagesIds=function(){var i,j=this.getCustomTabs(),k=j.length,X=[];var Y=['sort','filter','group'];Y.forEach(function($){if(this._isValidPredefinedPageId($)){X.push($);}},this);for(i=0;i<k;i++){var Z=j[i];if(!this._isEmptyTab(Z)){X.push(Z.getId());}}return X;};
x.prototype._isEmptyTab=function(i){return!(i.getContent().length||this._vContentPage===i.getId()&&this._getPage1().getContent().length);};
x.prototype._isValidPredefinedPageId=function(i){if(!i){q.warning('Missing mandatory parameter.');return false;}var j=false;switch(i){case'sort':j=!!this.getSortItems().length;break;case'filter':j=!!this.getFilterItems().length||!!this.getPresetFilterItems().length;break;case'group':j=!!this.getGroupItems().length;break;}return j;};
x.prototype._pressBackButton=function(){var i=this;if(this._vContentPage===3){this._updateFilterCounters();this._getNavContainer().attachEvent("afterNavigate",function(){if(i._prevSelectedFilterItem){i._prevSelectedFilterItem.focus();}});setTimeout(this._getNavContainer()['back'].bind(this._getNavContainer()),0);this._switchToPage(2);this._segmentedButton.setSelectedButton(this._filterButton);}};
x.prototype.setModel=function(i,j){if(this._vContentPage===3&&this._oContentItem){y.call(this);}return M.prototype.setModel.call(this,i,j);};
x.prototype.removeFilterItem=function(i){var j="";if(this._vContentPage===3&&this._oContentItem){if(typeof(i)==="object"){j=i.getId();}else if(typeof(i)==="string"){j=i;}else if(typeof(i)==="number"){j=this.getFilterItems()[i].getId();}if(this._oContentItem.getId()===j){y.call(this);}}return this.removeAggregation('filterItems',i);};
x.prototype.removeAllFilterItems=function(){if(this._vContentPage===3&&this._oContentItem){y.call(this);}return this.removeAllAggregation('filterItems');};
x.prototype.setFilterSearchCallback=function(i){this._fnFilterSearchCallback=i;return this;};
x.prototype._switchToPage=function(j,k){var i=0,X=this._getTitleLabel(),Y=this._getHeader(),Z=this._getSubHeader();this._checkResetStatus();this._getPage2().getCustomHeader().removeStyleClass('sapMVSDBarWithSearch');if(J.call(this)){H.call(this);}Y.removeAllContentRight();Z.removeAllContentRight();this._vContentPage=j;this._oContentItem=k;if(j!==3){this._getPage1().removeAllAggregation("content",true);this._addResetButtonToPage1();}else if(j===3){this._getPage2().removeAllAggregation("content",true);}if(this.getTitle()){X.setText(this.getTitle());}else{X.setText(this._rb.getText("VIEWSETTINGS_TITLE"));}this._toggleDialogTitle(this._sTitleLabelId);switch(j){case 1:if(!this._showSubHeader&&!this.getTitle()){X.setText(this._rb.getText("VIEWSETTINGS_TITLE_GROUP"));}for(;i<this._groupContent.length;i++){this._getPage1().addContent(this._groupContent[i]);}break;case 2:if(!this._showSubHeader&&!this.getTitle()){X.setText(this._rb.getText("VIEWSETTINGS_TITLE_FILTER"));}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();for(;i<this._filterContent.length;i++){this._getPage1().addContent(this._filterContent[i]);}break;case 3:this._setFilterDetailTitle(k);if(k instanceof sap.m.ViewSettingsCustomItem&&k.getCustomControl()){this._clearPresetFilter();this._getPage2().addContent(k.getCustomControl());}else if(k instanceof sap.m.ViewSettingsFilterItem&&k.getItems()){this._initFilterDetailItems(k);}break;case 0:if(!this._getPage1().getSubHeader()&&!this.getTitle()){X.setText(this._rb.getText("VIEWSETTINGS_TITLE_SORT"));}if(this._sortContent){for(;i<this._sortContent.length;i++){this._getPage1().addContent(this._sortContent[i]);}}break;default:this._getPage1().removeAllAggregation("content",true);var $="VIEWSETTINGS_TITLE";var _=this.getCustomTabs();if(_.length<2){$=_[0].getTitle();}if(!this._getPage1().getSubHeader()&&!this.getTitle()){X.setText($);}_.forEach(function(a1){if(a1.getId()===j){a1.getContent().forEach(function(b1){this._getPage1().addContent(b1);},this);}},this);break;}if(j===3){this.fireFilterDetailPageOpened({parentFilterItem:k});}};
x.prototype._createSelectAllCheckbox=function(i,j){var k=false;if(i&&i.length!==0){k=i.every(function(Y){return Y.getSelected();});}var X=new b({text:this._rb.getText("COLUMNSPANEL_SELECT_ALL"),selected:k,select:function(Y){var Z=Y.getParameter('selected');j.getItems().filter(function($){return $.getVisible();}).forEach(function($){var _=$.data("item");_.setSelected(Z);});this._checkResetStatus();}.bind(this)});return X;};
x.prototype._updateSelectAllCheckBoxState=function(){var i=false,j=this._filterDetailList.getItems(),k=[];if(!this._selectAllCheckBox){return;}if(j&&j.length!==0){k=j.filter(function(X){return X.getVisible();});}if(k.length!==0){this._selectAllCheckBox.setEnabled(true);i=k.every(function(X){return X.getSelected();});}else{this._selectAllCheckBox.setEnabled(false);}this._selectAllCheckBox.setSelected(i);};
x.prototype._visibilityBySearchField=function(i){var j=this._filterSearchField.getValue(),k=this._getStringFilter(),X=k(j,i.getTitle());return X;};
x.prototype._visibilityByToggleButton=function(i){var j=this._showOnlySelectedButton.getPressed()?i.getSelected():true;return j;};
x.prototype._getFilterSearchField=function(i){var j=new S({liveChange:function(){this._setFilterDetailItemsVisibility(i);}.bind(this)});return j;};
x.prototype._setFilterDetailItemsVisibility=function(i,j){i.getItems().forEach(function(k){k.setVisible(this._visibilityByToggleButton(k)&&(j||this._visibilityBySearchField(k)));}.bind(this));this._updateSelectAllCheckBoxState();};
x.prototype._getShowOnlySelectedButton=function(){var i=this._oContentItem&&this._oFiltersSelectedOnly[this._oContentItem.getId()]?true:false,j=new d({icon:I.getIconURI("multi-select"),tooltip:this._rb.getText("SHOW_SELECTED_ONLY"),type:v.Transparent,pressed:i,press:function(){var k=this._showOnlySelectedButton.getPressed(),X=this._oContentItem.getId();if(k){this._oFiltersSelectedOnly[X]=true;}else{delete this._oFiltersSelectedOnly[X];}this._setFilterDetailItemsVisibility(this._filterDetailList);}.bind(this)});return j;};
x.prototype._getStringFilter=function(){if(this._fnFilterSearchCallback){return this._fnFilterSearchCallback;}if(!this._oStringFilter||this._oStringFilter.sOperator!==this.getFilterSearchOperator()){this._oStringFilter=new K(this.getFilterSearchOperator());}return this._oStringFilter.filter.bind(this._oStringFilter);};
x.prototype._updateListSelections=function(){this._updateListSelection(this._sortList,sap.ui.getCore().byId(this.getSelectedSortItem()));this._updateListSelection(this._sortOrderList,this.getSortDescending());this._updateListSelection(this._groupList,sap.ui.getCore().byId(this.getSelectedGroupItem()));this._updateListSelection(this._groupOrderList,this.getGroupDescending());this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));this._updateFilterCounters();};
x.prototype._updateListSelection=function(j,k){var X,i=0,Y;if(!j){return false;}X=j.getItems();j.removeSelections();for(;i<X.length;i++){Y=X[i].isA("sap.m.GroupHeaderListItem");if(!Y&&(X[i].data("item")===k||X[i].data("item")===null)){j.setSelectedItem(X[i],(k&&k.getSelected?k.getSelected():true));return true;}}return false;};
x.prototype._updateFilterCounters=function(){var k=(this._filterList?this._filterList.getItems():[]),X,Y,Z=0,i=0,j;for(;i<k.length;i++){X=k[i].data("item");Z=0;if(X){if(X instanceof sap.m.ViewSettingsCustomItem){Z=X.getFilterCount();}else if(X instanceof sap.m.ViewSettingsFilterItem){Z=0;Y=X.getItems();for(j=0;j<Y.length;j++){if(Y[j].getSelected()){Z++;}}}}k[i].setCounter(Z);}};
x.prototype._clearSelectedFilters=function(){var k=this.getFilterItems(),X,i=0,j;for(;i<k.length;i++){if(k[i]instanceof sap.m.ViewSettingsFilterItem){X=k[i].getItems();for(j=0;j<X.length;j++){X[j].setProperty('selected',false,true);}}k[i].setProperty('selected',false,true);}if(this._vContentPage===2&&this._getDialog().isOpen()){this._updateFilterCounters();}};
x.prototype._clearPresetFilter=function(){if(this.getSelectedPresetFilterItem()){this.setSelectedPresetFilterItem(null);}};
x.prototype._calculateNumberOfPages=function(){var i=0,j=!!this.getSortItems().length,k=!!this.getGroupItems().length,X=!!this.getPresetFilterItems().length,Y=!!this.getFilterItems().length;if(j){i++;}if(X||Y){i++;}if(k){i++;}this.getCustomTabs().forEach(function(Z){if(!this._isEmptyTab(Z)){i++;}},this);return i;};
x.prototype._hasSubHeader=function(){return!(this._calculateNumberOfPages()<2);};
function y(){this._vContentPage=2;this._oContentItem=null;this._navContainer.to(this._getPage1().getId(),"show");}
function z(j,k){var i,X;for(i=0;i<j.length;i++){if(j[i].getKey()===k){X=j[i];break;}}return X;}
function A(i,j,k){var X;if(typeof i==="string"){X=z(j,i);if(!X){q.error(k);}}else{X=i;}return X;}
function F(i){return i&&i instanceof sap.m.ViewSettingsItem;}
x.prototype._onConfirm=function(i){var j=this._getDialog(),k=this,X=function(){var Y,Z,$=k.getSelectedGroupItem();if(!k._oGroupingNoneItem||$!=k._oGroupingNoneItem.getId()){Z=sap.ui.getCore().byId($);}k._toggleDialogTitle(k._sTitleLabelId);Y={sortItem:sap.ui.getCore().byId(k.getSelectedSortItem()),sortDescending:k.getSortDescending(),groupItem:Z,groupDescending:k.getGroupDescending(),presetFilterItem:sap.ui.getCore().byId(k.getSelectedPresetFilterItem()),filterItems:k.getSelectedFilterItems(),filterKeys:k.getSelectedFilterKeys(),filterCompoundKeys:k.getSelectedFilterCompoundKeys(),filterString:k.getSelectedFilterString()};k._dialog.detachAfterClose(X);k.fireConfirm(Y);};j.attachAfterClose(X);j.close();};
x.prototype._onCancel=function(i){var j=this,k=this._getDialog(),X=function(){j._toggleDialogTitle(j._sTitleLabelId);j.setSelectedSortItem(j._oPreviousState.sortItem);j.setSortDescending(j._oPreviousState.sortDescending);j.setSelectedGroupItem(j._oPreviousState.groupItem);j.setGroupDescending(j._oPreviousState.groupDescending);j.setSelectedPresetFilterItem(j._oPreviousState.presetFilterItem);j._clearSelectedFilters();j.setSelectedFilterCompoundKeys(j._oPreviousState.filterCompoundKeys);if(j._navContainer.getCurrentPage()!==j._oPreviousState.navPage){setTimeout(j._navContainer["to"].bind(j._navContainer,j._oPreviousState.navPage.getId(),"show"),0);}j._switchToPage(j._oPreviousState.contentPage,j._oPreviousState.contentItem);j._dialog.detachAfterClose(X);j.fireCancel();};k.attachAfterClose(X);k.close();};
x.prototype.clearFilters=function(){this._clearSelectedFilters();this._clearPresetFilter();this.fireResetFilters();this._updateFilterCounters();if(this._vContentPage===3){setTimeout(this._getNavContainer()['to'].bind(this._getNavContainer(),this._getPage1().getId()),0);this._switchToPage(2);this._getSegmentedButton().setSelectedButton(this._getFilterButton());}this._updateListSelection(this._presetFilterList,sap.ui.getCore().byId(this.getSelectedPresetFilterItem()));return this;};
x.prototype._addResetButtonToPage1=function(){var i=this._getHeader(),j=this._getSubHeader(),k=this._getResetButton();if(this._showSubHeader){if(!this._getPage1().getSubHeader()){this._getPage1().setSubHeader(j);}}else{if(this._getPage1().getSubHeader()){this._getPage1().setSubHeader();}}i.addContentRight(k);};
x.prototype._applyContextualSettings=function(){M.prototype._applyContextualSettings.call(this,M._defaultContextualSettings);};
function H(i,j){if(!this._getPage1(true)){return;}if(i==='customTabs'&&j){if(j.getMetadata().getName()===this.getMetadata().getManagedAggregation(i).type&&this._vContentPage===j.getId()){var k=this._getPage1().getContent();k.forEach(function(X){j.addAggregation('content',X,true);});}}else if(!i&&!j){var k=this._getPage1().getContent();this.getCustomTabs().forEach(function(j){if(this._vContentPage===j.getId()){k.forEach(function(X){j.addAggregation('content',X,true);});}},this);}}
function J(){var i=[-1,0,1,2,3];return(this._getPage1().getContent().length&&i.indexOf(this._vContentPage)===-1);}
x.prototype.setBusy=function(i){this._getDialog().setBusy(i);return this;};
var K=function(i){this.sOperator=i||t.StartsWith;switch(this.sOperator){case t.Equals:this.fnOperator=O;break;case t.Contains:this.fnOperator=R;break;case t.StartsWith:this.fnOperator=U;break;case t.AnyWordStartsWith:this.fnOperator=W;break;default:q.warning("Unknown string compare operator. Use values from sap.m.StringFilterOperator. Default operator should be used.");this.fnOperator=R;break;}};
K.prototype.filter=function(i,j){if(!i){return true;}if(!j){return false;}j=j.toLowerCase();i=i.toLowerCase();return this.fnOperator(i,j);};
function O(i,j){return j===i;}
function R(i,j){return j.indexOf(i)>-1;}
function U(i,j){return j.indexOf(i)===0;}
function W(i,j){var k=new RegExp(".*\\b"+i+".*");return k.test(j);}
T.mixInto(x.prototype);return x;});
sap.ui.predefine('sap/m/ViewSettingsDialogRenderer',[],function(){"use strict";var V={apiVersion:2};
V.render=function(r,c){};
return V;},true);
sap.ui.predefine('sap/m/ViewSettingsFilterItem',['./ViewSettingsItem','./library','sap/ui/base/ManagedObject'],function(V,l,M){"use strict";
var a=V.extend("sap.m.ViewSettingsFilterItem",{metadata:{library:"sap.m",properties:{multiSelect:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{items:{type:"sap.m.ViewSettingsItem",multiple:true,singularName:"item",bindable:"bindable"}},events:{filterDetailItemsAggregationChange:{}}}});
a.prototype._handleNewAggregationEvents=function(o){o.attachEvent('itemPropertyChanged',function(e){this.fireItemPropertyChanged({changedItem:e.getParameter('changedItem'),propertyKey:e.getParameter('propertyKey'),propertyValue:e.getParameter('propertyValue')});}.bind(this));this.fireFilterDetailItemsAggregationChange({item:o});};
a.prototype.addAggregation=function(A,o,s){M.prototype.addAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.insertAggregation=function(A,o,i,s){M.prototype.insertAggregation.apply(this,arguments);this._handleNewAggregationEvents(o);return this;};
a.prototype.removeAggregation=function(A,o,s){M.prototype.removeAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.removeAllAggregation=function(A,s){M.prototype.removeAllAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
a.prototype.destroyAggregation=function(A,s){M.prototype.destroyAggregation.apply(this,arguments);this.fireFilterDetailItemsAggregationChange();return this;};
return a;});
sap.ui.predefine('sap/m/ViewSettingsItem',['./library','sap/ui/core/Item','sap/ui/base/ManagedObject'],function(l,I,M){"use strict";
var V=I.extend("sap.m.ViewSettingsItem",{metadata:{library:"sap.m",properties:{selected:{type:"boolean",group:"Behavior",defaultValue:false}},events:{itemPropertyChanged:{parameters:{changedItem:{type:'sap.m.ViewSettingsItem'},propertyKey:{type:"string"},propertyValue:{type:"any"}}}}}});
V.prototype.setSelected=function(v){V.prototype.setProperty.call(this,"selected",v,true);return this;};
V.prototype.setProperty=function(n,v,s,f){M.prototype.setProperty.apply(this,arguments);f=f===undefined?true:f;if(f){this.fireItemPropertyChanged({changedItem:this,propertyKey:n,propertyValue:v});}};
return V;});
sap.ui.predefine('sap/m/VisibleItem',['./library','sap/ui/core/Item',"sap/ui/thirdparty/jquery"],function(l,I,q){"use strict";
var V=I.extend("sap.m.VisibleItem",{metadata:{library:"sap.m",properties:{visible:{type:"boolean",group:"Behavior",defaultValue:true}}}});
V.prototype._getRefs=function(){var p=this.getParent(),$,t=this;if(p&&p.$("content")){$=p.$("content").find("li").filter(function(){return q(this).html()===t.getText();});}return $;};
V.prototype.setVisible=function(v){if(this.getVisible()===v){return;}var $=this._getRefs();if($){if(v){$.removeClass('TPSliderItemHidden');}else{$.addClass('TPSliderItemHidden');}}return this.setProperty('visible',v,true);};
return V;});
sap.ui.predefine('sap/m/WheelSlider',['sap/ui/core/Control','./WheelSliderRenderer','sap/ui/core/IconPool','sap/ui/Device',"sap/ui/events/KeyCodes","sap/m/Button","sap/ui/thirdparty/jquery"],function(C,W,I,D,K,B,q){"use strict";
var a=C.extend("sap.m.WheelSlider",{
metadata:{library:"sap.m",properties:{selectedKey:{type:"string",defaultValue:null},isCyclic:{type:"boolean",defaultValue:true},label:{type:"string",defaultValue:null},isExpanded:{type:"boolean",defaultValue:false}},aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item"},_arrowUp:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_arrowDown:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{expanded:{},collapsed:{},selectedKeyChange:{parameters:{newKey:{type:"string"}}}}},
renderer:W
});
var S=sap.ui.getCore().getConfiguration().getAnimation()?200:0;var L=32;var A=32;var M=1.0;
a.prototype.init=function(){this._bIsDrag=null;this._selectionOffset=0;this._mousedown=false;this._dragSession=null;this._iSelectedItemIndex=-1;this._animatingSnap=false;this._iSelectedIndex=-1;this._animating=false;this._intervalId=null;this._maxScrollTop=null;this._minScrollTop=null;this._marginTop=null;this._marginBottom=null;this._bOneTimeValueSelectionAnimation=false;this._bEnabled=true;if(D.system.desktop){this._fnHandleTypeValues=t.call(this);}this._onTouchStart=q.proxy(o,this);this._onTouchMove=q.proxy(c,this);this._onTouchEnd=q.proxy(d,this);this._onMouseWheel=this._onMouseWheel.bind(this);this._initArrows();};
a.prototype.exit=function(){var s=this._getSliderContainerDomRef();if(s){s.stop();}this._stopAnimation();if(s[0]){this._detachEvents();}};
a.prototype.onBeforeRendering=function(){if(this._getSliderContainerDomRef()[0]){this._detachEvents();}};
a.prototype.onAfterRendering=function(){if(this._marginTop){this._previousMarginTop=this._marginTop;}if(this._marginBottom){this._previousMarginBottom=this._marginBottom;}if(this.getItems().length){this._updateDynamicLayout(this.getIsExpanded());}this._attachEvents();};
a.prototype.onThemeChanged=function(e){this.invalidate();};
a.prototype._handleTap=function(e){var s,i,g;if(!this.getIsExpanded()){if(D.system.desktop){this.focus();}else{this.setIsExpanded(true);}}else{s=e.srcElement||e.originalTarget;if(s&&s.tagName.toLowerCase()==="li"){i=q(s).text();g=F.call(this,i);this._iClickedIndex=Array.prototype.slice.call(s.parentElement.children).indexOf(s);this._bOneTimeValueSelectionAnimation=true;this.setSelectedKey(g);this.fireSelectedKeyChange({newKey:g});}else{this._addSelectionStyle();this.focus();}}};
a.prototype.setSelectedKey=function(v,r){var s=r!==undefined?!r:true,i=b(this.getItems(),function(E){return E.getKey()===v;}),i,$,e;this.setProperty("selectedKey",v,s);if(!s||i===-1){return this;}i-=this.iMinIndex;if(this.getDomRef()){$=this._getSliderContainerDomRef();e=this._getItemHeightInPx();if(this._bOneTimeValueSelectionAnimation){$.scrollTop((i-this._iClickedIndex+this._iSelectedItemIndex)*e-this._selectionOffset);this._animatingSnap=true;$.animate({scrollTop:i*e-this._selectionOffset},S,'linear',function(){$.clearQueue();this._animatingSnap=false;this._bOneTimeValueSelectionAnimation=false;}.bind(this));}else{$.scrollTop(i*e-this._selectionOffset);}this._removeSelectionStyle();this._iSelectedItemIndex=i;this._addSelectionStyle();}return this;};
a.prototype.setIsExpanded=function(v,s){this.setProperty("isExpanded",v,true);if(!this.getDomRef()){return this;}var T=this.$();if(v){T.addClass("sapMWSExpanded");this._updateDynamicLayout(true);if(!s){this.fireExpanded({ctrl:this});}}else{this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null&&this._animatingTargetIndex!==undefined){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}T.removeClass("sapMWSExpanded");this._updateDynamicLayout(false);if(!s){this.fireCollapsed({ctrl:this});}}return this;};
a.prototype.onfocusin=function(e){if(D.system.desktop&&!this.getIsExpanded()){this.setIsExpanded(true);}};
a.prototype.onfocusout=function(e){var s=e.relatedTarget?e.relatedTarget.id:null,g=[this.getAggregation("_arrowUp").getId(),this.getAggregation("_arrowDown").getId()];if(s&&g.indexOf(s)!==-1){return;}if(D.system.desktop&&this.getIsExpanded()){this.setIsExpanded(false);}};
a.prototype._onMouseWheel=function(e){var O,g,w;e.preventDefault();e.stopPropagation();if(!this.getIsExpanded()){return false;}O=e.originalEvent;g=O.detail?(-O.detail>0):(O.wheelDelta>0);w=O.detail?(-O.detail/3):(O.wheelDelta/120);if(!w){return false;}this._handleWheelScroll(g,w);};
a.prototype._handleWheelScroll=function(e,w){var r=e?Math.ceil:Math.floor,R;if(!this._aWheelDeltas){this._aWheelDeltas=[];}this._aWheelDeltas.push(w);if(!this._bWheelScrolling){this._bWheelScrolling=true;this._stopAnimation();this._animating=true;this._intervalId=setInterval(function(){if(!this._aWheelDeltas.length){this._stopAnimation();this._bWheelScrolling=false;}else{R=this._aWheelDeltas[0];this._aWheelDeltas=[];R=r(R);if(R){this._offsetValue(R);}}}.bind(this),150);}return false;};
a.prototype.onsappageup=function(e){if(this.getIsExpanded()){var i=this.getItems()[0],k=i.getKey();this.setSelectedKey(k,true);this.fireSelectedKeyChange({newKey:k});}};
a.prototype.onsappagedown=function(e){if(this.getIsExpanded()){var l=this.getItems()[this.getItems().length-1],k=l.getKey();this.setSelectedKey(k,true);this.fireSelectedKeyChange({newKey:k});}};
a.prototype.onsapup=function(e){if(this.getIsExpanded()){this._offsetAnimateValue(-1);}};
a.prototype.onsapdown=function(e){if(this.getIsExpanded()){this._offsetAnimateValue(1);}};
a.prototype.onkeydown=function(e){var k=e.which||e.keyCode,g=K;if(k>=g.NUMPAD_0&&k<=g.NUMPAD_9){k=this._convertNumPadToNumKeyCode(k);}if((k>=g.A&&k<=g.Z)||(k>=g.DIGIT_0&&k<=g.DIGIT_9)){this._fnHandleTypeValues(e.timeStamp,k);}};
a.prototype._getSliderContainerDomRef=function(){return this.$().find(".sapMWSInner");};
a.prototype._getItemHeightInPx=function(){return this.$("content").find("li")[0].getBoundingClientRect().height;};
a.prototype._updateSelectionFrameLayout=function(){var $,i,e,g,s=this.$().offset(),h=s?s.top:0,j=this.$().parents(".sapMWSContainer").offset(),k=j?j.top:0;if(this.getDomRef()){g=this._getItemHeightInPx();$=this.$().find(".sapMWSSelectionFrame");e=h-k;i=(this.$().height()-g+L)/2+e;$.css("top",i);}};
a.prototype._updateConstrainedMargins=function(i){var e=this._getItemHeightInPx(),$,v,V,g,h,j,m,k;if(this.getDomRef()){e=this._getItemHeightInPx();$=this.$().find(".SliderValues3,.SliderValues4,.SliderValues5,.SliderValues6,.SliderValues7,.SliderValues8,.SliderValues9,.SliderValues10,.SliderValues11,.SliderValues12");if(!$.length){return;}if(i){v=this.getItems().length;V=e*Math.floor(v/2);g=e*Math.ceil(v/2);j=this.$().parents().hasClass('sapUiSizeCompact')?A:0;h=(this.$().height()-e+L)/2;m=h-V-L-j;k=this.$().height()-h-g-j;m=Math.max(m,0);k=Math.max(k,0);}else{m=0;k=0;}$.css("margin-top",m);$.css("margin-bottom",k);}};
a.prototype._updateDynamicLayout=function(i){if(this.getDomRef()){this._updateConstrainedMargins(i);if(i){this._updateSelectionFrameLayout();}this._updateMargins();this._updateSelectionOffset();this._reselectCurrentItem();this.$().attr('aria-expanded',i);}};
a.prototype._getSelectionFrameTopOffset=function(){var $=this._getSliderContainerDomRef().find(".sapMWSSelectionFrame"),e=$.offset();return e.top;};
a.prototype._animateScroll=function(s){var $=this._getSliderContainerDomRef(),p=$.scrollTop(),e=25,g=this.getIsCyclic(),h=0.9,i=0.05;this._animating=true;this._intervalId=setInterval(function(){p=p-s*e;if(!g){if(p>this._maxScrollTop){p=this._maxScrollTop;s=0;}if(p<this._minScrollTop){p=this._minScrollTop;s=0;}}$.scrollTop(p);s*=h;if(Math.abs(s)<i){this._stopAnimation();var j=this._getItemHeightInPx();var O=this._selectionOffset?(this._selectionOffset%j):0;var k=Math.round((p+O)/j)*j-O;this._iSelectedIndex=Math.round((p+this._selectionOffset)/j);if(this._animatingSnap){return;}this._animatingSnap=true;$.animate({scrollTop:k},S,'linear',function(){$.clearQueue();this._animatingSnap=false;if($.css("visibility")==="visible"&&!this._animating){this._scrollerSnapped(this._iSelectedIndex);}}.bind(this));}}.bind(this),e);};
a.prototype.getSelectedItemIndex=function(){var s=this.getSelectedKey();if(!s){return 0;}return b(this.getItems(),function(e){return e.getKey()===s;});};
a.prototype._reselectCurrentItem=function(){var s=this.getSelectedItemIndex(),e;if(s===-1){return;}e=this.getItems()[s].getKey();this.setSelectedKey(e);};
a.prototype._updateSelectionOffset=function(){var s=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset();if(this.getIsCyclic()&&this.getIsExpanded()){this._selectionOffset=s-e.top;}else{this._selectionOffset=0;}};
a.prototype._stopAnimation=function(){if(this._animating){clearInterval(this._intervalId);this._intervalId=null;this._animating=null;}};
a.prototype._startDrag=function(p){if(!this._dragSession){this._dragSession={};this._dragSession.positions=[];}this._dragSession.pageY=p;this._dragSession.startTop=this._getSliderContainerDomRef().scrollTop();};
a.prototype._doDrag=function(p,T){if(this._dragSession){this._dragSession.offsetY=p-this._dragSession.pageY;this._dragSession.positions.push({pageY:p,timeStamp:T});if(this._dragSession.positions.length>20){this._dragSession.positions.splice(0,10);}if(this._bIsDrag){this._getSliderContainerDomRef().scrollTop(this._dragSession.startTop-this._dragSession.offsetY);}}};
a.prototype._endDrag=function(p,T){if(this._dragSession){var O,e;for(var i=this._dragSession.positions.length-1;i>=0;i--){O=T-this._dragSession.positions[i].timeStamp;e=p-this._dragSession.positions[i].pageY;if(O>100){break;}}var s=(e/O);this._stopAnimation();this._dragSession=null;s=Math.min(s,M);s=Math.max(s,-M);this._animateScroll(s);}};
a.prototype._updateMargins=function(){var s=this._getSelectionFrameTopOffset(),$=this._getSliderContainerDomRef(),e=$.offset(),i,l,g,h;if(!this.getIsCyclic()){l=this.$("content");h=this._getItemHeightInPx();g=this.$().height();if(this.getIsExpanded()){this._minScrollTop=0;this._marginTop=s-e.top;this._maxScrollTop=h*(this.getItems().length-1);i=$.height();this._marginBottom=i-this._marginTop-h;if(this._marginBottom<0){this._marginBottom=g-this._marginTop-h;}}else{this._marginTop=0;this._marginBottom=g-h;}if(this._previousMarginTop!==this._marginTop){l.css("margin-top",this._marginTop);this._previousMarginTop=this._marginTop;}if(this._previousMarginBottom!==this._marginBottom){l.css("margin-bottom",this._marginBottom);this._previousMarginBottom=this._marginBottom;}}};
a.prototype._scrollerSnapped=function(i){var s=i,e=this.getItems().length,n;if(!this.getIsCyclic()){s=i;}var g=s+this.iMinIndex;if(this.getIsCyclic()){while(g<0){g=g+e;}while(g>=e){g=g-e;}}else{g=Math.min(e-1,g);}n=this.getItems()[g].getKey();var r=this.getIsCyclic()||(this.iPreviousMiddle>g&&this.iMinIndex>0)||(this.iPreviousMiddle<g&&this.iMaxIndex<e-1);this.setSelectedKey(n,r);this.fireSelectedKeyChange({newKey:n});};
a.prototype._addSelectionStyle=function(){var $=this.$("content").find("li"),s=$.eq(this._iSelectedItemIndex).text(),e,g;if(!s){return;}g=s;if(g&&g.length>1&&g.indexOf('0')===0){g=g.substring(1);}$.eq(this._iSelectedItemIndex).addClass("sapMWSItemSelected");e=document.getElementById(this.getId()+"-valDescription");if(e.innerText!==g){e.innerText=g;}};
a.prototype._removeSelectionStyle=function(){var $=this.$("content").find("li");$.eq(this._iSelectedItemIndex).removeClass("sapMWSItemSelected");};
a.prototype._attachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.addEventListener("touchstart",this._onTouchStart,false);e.addEventListener("touchmove",this._onTouchMove,false);document.addEventListener("touchend",this._onTouchEnd,false);e.addEventListener("mousedown",this._onTouchStart,false);document.addEventListener("mousemove",this._onTouchMove,false);document.addEventListener("mouseup",this._onTouchEnd,false);}else{if(D.system.phone||D.system.tablet){e.addEventListener("touchstart",this._onTouchStart,false);e.addEventListener("touchmove",this._onTouchMove,false);document.addEventListener("touchend",this._onTouchEnd,false);}else{e.addEventListener("mousedown",this._onTouchStart,false);document.addEventListener("mousemove",this._onTouchMove,false);document.addEventListener("mouseup",this._onTouchEnd,false);}}this.$().on('selectstart',f);this.$().on(!!D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onMouseWheel);};
function f(){return false;}
a.prototype._detachEvents=function(){var e=this._getSliderContainerDomRef()[0];if(D.system.combi){e.removeEventListener("touchstart",this._onTouchStart,false);e.removeEventListener("touchmove",this._onTouchMove,false);document.removeEventListener("touchend",this._onTouchEnd,false);e.removeEventListener("mousedown",this._onTouchStart,false);document.removeEventListener("mousemove",this._onTouchMove,false);document.removeEventListener("mouseup",this._onTouchEnd,false);}else{if(D.system.phone||D.system.tablet){e.removeEventListener("touchstart",this._onTouchStart,false);e.removeEventListener("touchmove",this._onTouchMove,false);document.removeEventListener("touchend",this._onTouchEnd,false);}else{e.removeEventListener("mousedown",this._onTouchStart,false);document.removeEventListener("mousemove",this._onTouchMove,false);document.removeEventListener("mouseup",this._onTouchEnd,false);}}this.$().off('selectstart',f);this.$().off(!!D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onMouseWheel);};
a.prototype._offsetAnimateValue=function(i){var s=this._getSliderContainerDomRef(),e,g=this._getItemHeightInPx(),h,j,k=this.getIsCyclic();this._stopAnimation();if(this._animatingSnap===true){this._animatingSnap=false;this._getSliderContainerDomRef().stop(true);if(this._animatingTargetIndex!==null&&this._animatingTargetIndex!==undefined){this._scrollerSnapped(this._animatingTargetIndex);this._animatingTargetIndex=null;}else if(this._iSelectedIndex!==-1){this._scrollerSnapped(this._iSelectedIndex);}}j=this._iSelectedItemIndex+i;e=s.scrollTop();h=e+i*g;if(!k){if(j<0||j>=this.getItems().length){return;}if(h>this._maxScrollTop){h=this._maxScrollTop;}if(h<this._minScrollTop){h=this._minScrollTop;}}this._animatingSnap=true;this._animatingTargetIndex=j;s.animate({scrollTop:h},S,'linear',function(){s.clearQueue();this._animatingSnap=false;this._animatingTargetIndex=null;if(s.css("visibility")==="visible"){this._scrollerSnapped(j);}}.bind(this));};
a.prototype._offsetValue=function(O){var s=this._getSliderContainerDomRef().scrollTop(),e=this.getIsCyclic(),i=this._getItemHeightInPx();s=s-O*i;if(!e){if(s>this._maxScrollTop){s=this._maxScrollTop;}if(s<this._minScrollTop){s=this._minScrollTop;}}this._getSliderContainerDomRef().scrollTop(s);this._iSelectedIndex=Math.round((s+this._selectionOffset)/i);this._scrollerSnapped(this._iSelectedIndex);};
a.prototype._initArrows=function(){var e,g;e=new B({icon:I.getIconURI("slim-arrow-up"),press:function(E){this._offsetAnimateValue(-1);}.bind(this),type:'Transparent'});e.addEventDelegate({onAfterRendering:function(){e.$().attr("tabindex",-1);}});this.setAggregation("_arrowUp",e);g=new B({icon:I.getIconURI("slim-arrow-down"),press:function(E){this._offsetAnimateValue(1);}.bind(this),type:'Transparent'});g.addEventDelegate({onAfterRendering:function(){g.$().attr("tabindex",-1);}});this.setAggregation("_arrowDown",g);};
a.prototype._convertNumPadToNumKeyCode=function(k){var e=K;if(k>=e.NUMPAD_0&&k<=e.NUMPAD_9){k-=48;}return k;};
function b(e,p){if(e==null){throw new TypeError('findIndex called with null or undefined array');}if(typeof p!=='function'){throw new TypeError('predicate must be a function');}var l=e.length;var T=arguments[1];var v;for(var i=0;i<l;i++){v=e[i];if(p.call(T,v,i,e)){return i;}}return-1;}
var o=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;this._bIsDrag=false;if(!this.getIsExpanded()){return;}this._stopAnimation();this._startDrag(p);if(!D.system.desktop){e.preventDefault();}this._mousedown=true;};var c=function(e){var p=e.touches&&e.touches.length?e.touches[0].pageY:e.pageY;if(!this._mousedown||!this.getIsExpanded()){return;}if(!this._bIsDrag&&this._dragSession&&this._dragSession.positions.length){var g=this._dragSession.positions.some(function(h){return Math.abs(h.pageY-p)>5;});if(g){this._bIsDrag=true;}}this._doDrag(p,e.timeStamp);this._mousedown=true;};var d=function(e){var p=e.changedTouches&&e.changedTouches.length?e.changedTouches[0].pageY:e.pageY;if(this._bIsDrag===false){this._handleTap(e);this._dragSession=null;}this._bIsDrag=true;if(!this.getIsExpanded()){this._dragSession=null;return;}this._endDrag(p,e.timeStamp);this._mousedown=false;};var F=function(T){var i=this.getItems();var e=b(i,function(g){return g.getText()===T;});return i[e].getKey();};var t=function(){var l=-1,i=-1,w=1000,s="",T=function(e,k){var m;if(l+w<e){s="";}else{if(i!==-1){clearTimeout(i);i=-1;}}s+=String.fromCharCode(k).toLowerCase();m=this.getItems().filter(function(g){return g.getText().indexOf(s)===0;});if(m.length>1){i=setTimeout(function(){this.setSelectedKey(m[0].getKey(),true);s="";i=-1;}.bind(this),w);}else if(m.length===1){this.setSelectedKey(m[0].getKey(),true);s="";}else{s="";}l=e;};return T;};return a;});
sap.ui.predefine('sap/m/WheelSliderContainer',['sap/ui/Device','sap/ui/core/Control',"sap/ui/thirdparty/jquery",'./WheelSliderContainerRenderer'],function(D,C,q,W){"use strict";
var a=C.extend("sap.m.WheelSliderContainer",{metadata:{library:"sap.m",properties:{labelText:{type:"string"},width:{type:"sap.ui.core.CSSSize",group:"Appearance"},height:{type:"sap.ui.core.CSSSize",group:"Appearance"}},aggregations:{sliders:{type:"sap.m.WheelSlider",multiple:true}}}});
a.prototype.init=function(){this._fnLayoutChanged=q.proxy(this._onOrientationChanged,this);D.resize.attachHandler(this._fnLayoutChanged);this._onSliderExpanded=this._onSliderExpanded.bind(this);};
a.prototype.exit=function(){this.$().off('selectstart',f);this.$().off(!!D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);D.resize.detachHandler(this._fnOrientationChanged);};
a.prototype.onAfterRendering=function(){this.$().off(!!D.browser.firefox?"DOMMouseScroll":"mousewheel",this._onmousewheel);this.$().on(!!D.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this._onmousewheel,this));this.$().off('selectstart',f);this.$().on('selectstart',f);};
a.prototype.onsaphome=function(e){var n=this._getFirstSlider(),c=this._getCurrentSlider();if(c&&document.activeElement===c.getDomRef()){n.focus();}};
a.prototype.onsapend=function(e){var n=this._getLastSlider(),c=this._getCurrentSlider();if(c&&document.activeElement===c.getDomRef()){n.focus();}};
a.prototype.onsapleft=function(e){var n,c=this._getCurrentSlider(),i=-1,N=-1,s=this.getSliders();if(c&&document.activeElement===c.getDomRef()){i=s.indexOf(c);N=i>0?i-1:s.length-1;n=s[N];n.focus();}};
a.prototype.onsapright=function(e){var n,c=this._getCurrentSlider(),i=-1,N=-1,s=this.getSliders();if(c&&document.activeElement===c.getDomRef()){i=s.indexOf(c);N=i<s.length-1?i+1:0;n=s[N];n.focus();}};
a.prototype._onmousewheel=function(e){var c=this._getCurrentSlider();if(c){c._onMouseWheel(e);}};
a.prototype._onOrientationChanged=function(){var s=this.getSliders();for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){s[i]._updateSelectionFrameLayout();}}};
a.prototype._getCurrentSlider=function(){var s=this.getSliders();if(s){for(var i=0;i<s.length;i++){if(s[i].getIsExpanded()){return s[i];}}}return null;};
a.prototype._getFirstSlider=function(){return this.getSliders()[0]||null;};
a.prototype._getLastSlider=function(){var s=this.getSliders();return s[s.length-1]||null;};
a.prototype._onSliderExpanded=function(e){var s=this.getSliders();for(var i=0;i<s.length;i++){if(s[i]!==e.oSource&&s[i].getIsExpanded()){s[i].setIsExpanded(false);}}};
a.prototype.addSlider=function(s){if(!D.system.desktop&&!sap.ui.base.EventProvider.hasListener(s,"expanded",this._onSliderExpanded,this)){s.attachExpanded(this._onSliderExpanded);}return this.addAggregation("sliders",s);};
function f(){return false;}
return a;});
sap.ui.predefine('sap/m/WheelSliderContainerRenderer',["sap/ui/Device"],function(D){"use strict";var W={apiVersion:2};
W.render=function(r,c){var s=c.getSliders(),l=c.getLabelText()||"",R=sap.ui.getCore().getLibraryResourceBundle("sap.m"),S,b=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",c);r.class("sapMWSContainer");r.style("width",c.getWidth());r.style("height",c.getHeight());r.accessibilityState(c,{label:(l+" "+R.getText("TIMEPICKER_SCREENREADER_TAG")).trim()});r.openEnd();if(!D.system.desktop){r.openStart("div",c.getId()+"-label");r.class("sapMWSContainerLabel");r.openEnd();r.style("display","block");r.text(l);r.close("div");}if(b){for(S=s.length-1;S>=0;S--){r.renderControl(s[S]);}}else{for(S=0;S<s.length;S++){r.renderControl(s[S]);}}r.close("div");};
return W;},true);
sap.ui.predefine('sap/m/WheelSliderRenderer',[],function(){"use strict";var W={apiVersion:2};var i=60;
W.render=function(r,c){var I,a=c.getItems(),C=c.getLabel();r.openStart("div",c);r.attr("tabindex","0");r.class("sapMWS");if(c.getIsExpanded()){r.class("sapMWSExpanded");}if(!c.getIsCyclic()){r.class("sapMWSShort");}r.accessibilityState(c,{role:"list",labelledby:{value:c.getId()+"-label",append:true},describedby:{value:c.getId()+"-valDescription",append:true}});r.openEnd();r.openStart("div",c.getId()+"-label");r.class("sapMWSLabel");r.openEnd();r.text(C);r.close("div");r.openStart("div",c.getId()+"-valDescription");r.attr('aria-hidden','false');r.attr('aria-live','assertive');r.class("sapUiInvisibleText");r.openEnd();r.close("div");r.openStart("div");r.class("sapMWSArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowUp"));r.close("div");r.openStart("div");r.class("sapMWSInner");W.addItemValuesCssClass(r,c);r.attr("unselectable","on");r.openEnd();r.openStart("div");r.class("sapMWSSelectionFrame");r.openEnd();r.close("div");r.openStart("ul",c.getId()+"-content");r.attr("unselectable","on");if(c._marginTop){r.style("margin-top",c._marginTop+"px");}if(c._marginBottom){r.style("margin-bottom",c._marginBottom+"px");}r.openEnd();if(a.length){var s=c.getSelectedItemIndex();var m=c.getIsCyclic()?s-i:Math.max(s-i,0);var M=c.getIsCyclic()?s+i:Math.min(s+i,a.length-1);c.iPreviousMiddle=s;c.iMinIndex=m;c.iMaxIndex=M;for(I=m;I<=M;I++){var b=I;while(b<0){b+=a.length;}while(b>=a.length){b-=a.length;}r.openStart("li");r.attr("data-sap-ui-index",b);r.class("sapMWSItem");r.accessibilityState(c);r.attr("unselectable","on");r.openEnd();r.text(a[b].getText());r.close("li");}}r.close("ul");r.close("div");r.openStart("div");r.class("sapMWSArrows");r.openEnd();r.renderControl(c.getAggregation("_arrowDown"));r.close("div");r.close("div");};
W.addItemValuesCssClass=function(r,c){var v=c.getItems().length;if(v>2&&v<13){r.class("SliderValues"+v.toString());}};
return W;});
sap.ui.predefine('sap/m/WizardProgressNavigator',["./library","sap/ui/core/Control","sap/ui/core/ResizeHandler","sap/ui/core/delegate/ItemNavigation","sap/ui/Device","sap/m/ActionSheet","./WizardProgressNavigatorRenderer","./Button","sap/ui/thirdparty/jquery"],function(l,C,R,I,D,A,W,B,q){"use strict";
var a=C.extend("sap.m.WizardProgressNavigator",{metadata:{properties:{stepCount:{type:"int",group:"Data",defaultValue:3},stepTitles:{type:"string[]",group:"Appearance",defaultValue:[]},stepIcons:{type:"sap.ui.core.URI[]",group:"Appearance",defaultValue:[]},varyingStepCount:{type:"boolean",group:"Appearance",defaultValue:false}},events:{stepChanged:{parameters:{current:{type:"int"}}}}}});
a.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,MIN_STEP_WIDTH_NO_TITLE:64,MIN_STEP_WIDTH_WITH_TITLE:200};a.TEXT={STEP:"WIZARD_PROG_NAV_STEP_TITLE",OPTIONAL_STEP:"WIZARD_STEP_OPTIONAL_STEP_TEXT"};
a.prototype.init=function(){this._iCurrentStep=1;this._iActiveStep=1;this._aCachedSteps=[];this._aStepOptionalIndication=[];this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oActionSheet=new A();this._createStepNavigation();};
a.prototype.onBeforeRendering=function(){if(this.getStepCount()!==this.getStepIcons().filter(String).length){this.setStepIcons([]);}if(this.getStepCount()!==this.getStepTitles().filter(String).length){this.setStepTitles([]);}};
a.prototype.onAfterRendering=function(){var $,z=this._iActiveStep-1,Z=this._iCurrentStep-1;this._cacheDOMElements();this._updateStepZIndex();this._updateStepNavigation(z);this._updateStepActiveAttribute(z);this._removeStepAriaDisabledAttribute(z);this._updateStepCurrentAttribute(Z);this._updateStepAriaLabelAttribute(Z);this._updateOpenSteps();R.register(this.getDomRef(),this._updateOpenSteps.bind(this));if(D.os.name===D.os.OS.IOS){$=this.$().find(".sapMWizardProgressNavStep").css("display","block");setTimeout($["css"].bind($,"display",""),0);}};
a.prototype.ontap=function(e){if(this._isGroupAtStart(e.target)){return this._showActionSheet(e.target,true);}if(this._isGroupAtEnd(e.target)){return this._showActionSheet(e.target,false);}if(!this._isOpenStep(e.target)||!this._isActiveStep(this._getStepNumber(e.target))){return;}this._updateCurrentStep(this._getStepNumber(e.target));this.fireStepChanged({current:this._getStepNumber(e.target)});};
a.prototype.onsapspace=function(e){if(this._onEnter){this._onEnter(e,this._oStepNavigation.getFocusedIndex());}this.ontap(e);};
a.prototype.onsapenter=a.prototype.onsapspace;
a.prototype.exit=function(){R.deregisterAllForControl(this.getId());this.removeDelegate(this._oStepNavigation);this._oStepNavigation.destroy();this._oStepNavigation=null;this._oActionSheet.destroy();this._oActionSheet=null;this._iCurrentStep=null;this._iActiveStep=null;this._aCachedSteps=null;this._aStepOptionalIndication=null;};
a.prototype.getCurrentStep=function(){return this._iCurrentStep;};
a.prototype.getProgress=function(){return this._iActiveStep;};
a.prototype.previousStep=function(){var c=this.getCurrentStep();if(c<2){return this;}return this._moveToStep(c-1);};
a.prototype.nextStep=function(){return this._moveToStep(this.getCurrentStep()+1);};
a.prototype.incrementProgress=function(){return this._moveToStep(this.getProgress()+1);};
a.prototype.discardProgress=function(i){if(i<=0||i>this._iActiveStep){return this;}this._updateCurrentStep(i,this._iCurrentStep);this._updateStepActiveAttribute(i-1,this._iActiveStep-1);this._addStepAriaDisabledAttribute(i-1);this._updateStepNavigation(i-1);this._iCurrentStep=i;this._iActiveStep=i;};
a.prototype._setOnEnter=function(c){this._onEnter=c;};
a.prototype._createStepNavigation=function(){var t=this;this._oStepNavigation=new I();this._oStepNavigation.setCycling(false);this._oStepNavigation.setDisabledModifiers({sapnext:["alt"],sapprevious:["alt"]});this._oStepNavigation.attachEvent("AfterFocus",function(p){var e=p.mParameters.oEvent;if(!e||!e.relatedTarget||q(e.relatedTarget).hasClass(W.CLASSES.STEP)){return;}t._oStepNavigation.focusItem(t._iCurrentStep-1);});this.addDelegate(this._oStepNavigation);};
a.prototype._cacheDOMElements=function(){var d=this.getDomRef();this._aCachedSteps=d.querySelectorAll("."+W.CLASSES.STEP);};
a.prototype._updateStepZIndex=function(){var z=this._iCurrentStep-1,s=this._aCachedSteps.length,Z=a.CONSTANTS.MAXIMUM_STEPS;for(var i=0;i<s;i++){if(i<=z){this._aCachedSteps[i].style.zIndex=0;}else{this._aCachedSteps[i].style.zIndex=Z;Z-=1;}}};
a.prototype._updateStepNavigation=function(b){var n=this.getDomRef(),f=[];for(var i=0;i<=b;i++){if(this._aCachedSteps[i]){f.push(this._aCachedSteps[i]);}}this._oStepNavigation.setRootDomRef(n);this._oStepNavigation.setItemDomRefs(f);this._oStepNavigation.setPageSize(b);this._oStepNavigation.setFocusedIndex(b);};
a.prototype._updateStepActiveAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.ACTIVE_STEP);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.ACTIVE_STEP,true);}};
a.prototype._updateStepCurrentAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.CURRENT_STEP);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.CURRENT_STEP,true);}};
a.prototype._addStepAriaDisabledAttribute=function(b){var s=this._aCachedSteps.length,S;for(var i=b+1;i<s;i++){S=this._aCachedSteps[i];S.setAttribute(W.ATTRIBUTES.ARIA_DISABLED,true);}};
a.prototype._removeStepAriaDisabledAttribute=function(i){if(this._aCachedSteps[i]){this._aCachedSteps[i].removeAttribute(W.ATTRIBUTES.ARIA_DISABLED);}};
a.prototype._updateStepAriaLabelAttribute=function(n,o){if(o!==undefined&&this._aCachedSteps[o]){this._aCachedSteps[o].removeAttribute(W.ATTRIBUTES.ARIA_CURRENT);}if(this._aCachedSteps[n]){this._aCachedSteps[n].setAttribute(W.ATTRIBUTES.ARIA_CURRENT,"step");}};
a.prototype._moveToStep=function(n){var s=this.getStepCount(),o=this.getCurrentStep();if(n>s){return this;}if(n>this._iActiveStep){this._updateActiveStep(n);}return this._updateCurrentStep(n,o);};
a.prototype._updateActiveStep=function(n,o){var z=n-1,Z=(o||this._iActiveStep)-1;this._iActiveStep=n;this._updateStepNavigation(z);this._removeStepAriaDisabledAttribute(z);this._updateStepActiveAttribute(z,Z);};
a.prototype._updateCurrentStep=function(n,o){var z=n-1,Z=(o||this.getCurrentStep())-1;this._iCurrentStep=n;this._updateStepZIndex();this._updateOpenSteps();this._updateStepCurrentAttribute(z,Z);this._updateStepAriaLabelAttribute(z,Z);return this;};
a.prototype._updateOpenSteps=function(){var w=this.$().width(),c=this._iCurrentStep-1,b=0,d=true,s=this.getStepTitles().length?Math.floor(w/a.CONSTANTS.MIN_STEP_WIDTH_WITH_TITLE):Math.floor(w/a.CONSTANTS.MIN_STEP_WIDTH_NO_TITLE);if(!this._aCachedSteps){return;}[].forEach.call(this._aCachedSteps,function(e){e.setAttribute(W.ATTRIBUTES.OPEN_STEP,false);e.setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,false);e.setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,false);});if(this._aCachedSteps[c]){this._aCachedSteps[c].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);}for(var i=1;i<s;i++){if(d){b+=1;}if(d&&this._aCachedSteps[c+b]){this._aCachedSteps[c+b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d=!d;}else if(!d&&this._aCachedSteps[c-b]){this._aCachedSteps[c-b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d=!d;}else if(this._aCachedSteps[c+b+1]){b+=1;this._aCachedSteps[c+b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);d=true;}else if(this._aCachedSteps[c-b]){this._aCachedSteps[c-b].setAttribute(W.ATTRIBUTES.OPEN_STEP,true);b+=1;d=false;}}for(i=0;i<this._aCachedSteps.length;i++){if(this._aCachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"&&this._aCachedSteps[i-1]&&this._aCachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"){this._aCachedSteps[i-1].setAttribute(W.ATTRIBUTES.OPEN_STEP_PREV,true);}if(this._aCachedSteps[i].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="false"&&this._aCachedSteps[i-1]&&this._aCachedSteps[i-1].getAttribute(W.ATTRIBUTES.OPEN_STEP)=="true"){this._aCachedSteps[i].setAttribute(W.ATTRIBUTES.OPEN_STEP_NEXT,true);break;}}};
a.prototype._isGroupAtStart=function(d){var $=q(d).closest("."+W.CLASSES.STEP);var s=this._getStepNumber($);return $.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true"&&s>1;};
a.prototype._isGroupAtEnd=function(d){var $=q(d).closest("."+W.CLASSES.STEP);var s=this._getStepNumber($);return $.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true"&&s<this._aCachedSteps.length;};
a.prototype._showActionSheet=function(d,b){var f=b?0:this._getStepNumber(d)-1;var t=b?this._getStepNumber(d):this._aCachedSteps.length;var s,T;this._oActionSheet.removeAllButtons();for(var i=f;i<t;i++){s=this.getStepIcons()[i];T=this._aCachedSteps[i].getAttribute("aria-roledescription");this._oActionSheet.addButton(new B({width:"200px",text:T,icon:s,enabled:this._iActiveStep>=(i+1),press:function(c){this._moveToStep(c);this.fireStepChanged({current:c});}.bind(this,i+1)}));}this._oActionSheet.openBy(d);};
a.prototype._isOpenStep=function(d){var $=q(d).closest("."+W.CLASSES.STEP);return $.attr(W.ATTRIBUTES.OPEN_STEP)==="true"||($.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&$.attr(W.ATTRIBUTES.OPEN_STEP_PREV)==="true")||($.attr(W.ATTRIBUTES.OPEN_STEP)==="false"&&$.attr(W.ATTRIBUTES.OPEN_STEP_NEXT)==="true");};
a.prototype._isActiveStep=function(s){return s<=this._iActiveStep;};
a.prototype._getStepNumber=function(d){var $=q(d).closest("."+W.CLASSES.STEP).attr(W.ATTRIBUTES.STEP);return parseInt($);};
return a;});
sap.ui.predefine('sap/m/WizardProgressNavigatorRenderer',[],function(){"use strict";var C={NAVIGATION:"sapMWizardProgressNav",LIST:"sapMWizardProgressNavList",LIST_VARYING:"sapMWizardProgressNavListVarying",LIST_NO_TITLES:"sapMWizardProgressNavListNoTitles",STEP:"sapMWizardProgressNavStep",STEP_CIRCLE:"sapMWizardProgressNavStepCircle",STEP_TITLE:"sapMWizardProgressNavStepTitle",STEP_TITLE_OPTIONAL_TITLE:"sapMWizardProgressNavStepTitleOptional",STEP_TITLE_OPTIONAL_LABEL:"sapMWizardProgressNavStepLabelOptional",STEP_ICON:"sapMWizardProgressNavStepIcon",STEP_TITLE_CONTAINER:"sapMWizardProgressNavStepTitleContainer"};var A={STEP:"data-sap-ui-wpn-step",STEP_COUNT:"data-sap-ui-wpn-step-count",CURRENT_STEP:"data-sap-ui-wpn-step-current",ACTIVE_STEP:"data-sap-ui-wpn-step-active",OPEN_STEP:"data-sap-ui-wpn-step-open",OPEN_STEP_PREV:"data-sap-ui-wpn-step-open-prev",OPEN_STEP_NEXT:"data-sap-ui-wpn-step-open-next",ARIA_CURRENT:"aria-current",ARIA_DISABLED:"aria-disabled"};var W={apiVersion:2,CLASSES:C,ATTRIBUTES:A},r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
W.render=function(R,c){this.startNavigator(R,c);this.renderList(R,c);this.endNavigator(R);};
W.startNavigator=function(R,c){var w=r.getText("WIZARD_PROGRESS_NAVIGATOR_ARIA_ROLE_DESCRIPTION");R.openStart("nav",c).class(C.NAVIGATION).class("sapContrastPlus").attr(A.STEP_COUNT,c.getStepCount()).accessibilityState({role:"navigation",roledescription:w}).openEnd();};
W.renderList=function(R,c){this.startList(R,c);this.renderSteps(R,c);this.endList(R);};
W.startList=function(R,c){var s=c.getStepTitles();R.openStart("ul");if(c.getVaryingStepCount()){R.class(C.LIST_VARYING);}else{R.class(C.LIST);}if(!s.length){R.class(C.LIST_NO_TITLES);}R.accessibilityState({role:"list"});R.openEnd();};
W.renderSteps=function(R,c){var s=c.getStepCount(),S=c.getStepTitles(),a=c._aStepOptionalIndication,b=c.getStepIcons(),o=r.getText("WIZARD_STEP_OPTIONAL_STEP_TEXT");for(var i=1;i<=s;i++){var l=a[i-1]?o:"";this.startStep(R,c,i,S[i-1],b[i-1],l);this.endStep(R);}};
W.startStep=function(R,c,s,S,i,o){var a=c._aCachedSteps,b=a[s];R.openStart("li").class(C.STEP).attr(A.STEP,s).attr("tabindex","-1").accessibilityState({role:"listitem",roledescription:this.writeStepRoleDescription(R,S,o,s),label:null});if(!b||!!parseInt(b.style.zIndex)){R.attr("aria-disabled","true");}R.attr("aria-posinset",s);if(!c.getVaryingStepCount()){R.attr("aria-setsize",c.getStepCount());}else{R.attr("aria-setsize","-1");}R.openEnd();R.openStart("div").class("sapMWizardProgressNavStepContainer");R.openEnd();this.renderStepCircle(R,i,s);if(S){this.renderStepTitle(R,S,o);}R.close("div");};
W.renderStepCircle=function(R,i,s){R.openStart("span").class(C.STEP_CIRCLE).openEnd();if(i){R.icon(i,[C.STEP_ICON],{title:null});}else{R.text(s);}R.close("span");};
W.writeStepRoleDescription=function(R,s,o,S){var a=r.getText("WIZARD_PROG_NAV_STEP_TITLE"),t;if(s){t=S+". "+s;}else{t=a+" "+S;}if(o){t+=" ("+o+")";}return t;};
W.renderStepTitle=function(R,s,o){R.openStart("span").class(C.STEP_TITLE_CONTAINER).openEnd();R.openStart("span").class(C.STEP_TITLE);if(o){R.class(C.STEP_TITLE_OPTIONAL_TITLE);}R.openEnd().text(s).close("span");if(o){R.openStart("span").class(C.STEP_TITLE_OPTIONAL_LABEL).openEnd().text("("+o+")").close("span");}R.close("span");};
W.endStep=function(R){R.close("li");};
W.endList=function(R){R.close("ul");};
W.endNavigator=function(R){R.close("nav");};
return W;},true);
sap.ui.predefine('sap/m/WizardRenderer',[],function(){"use strict";var W={apiVersion:2};
W.render=function(r,w){this.startWizard(r,w);this.renderProgressNavigator(r,w);this.renderWizardSteps(r,w);this.endWizard(r);};
W.startWizard=function(r,w){var s=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("WIZARD_LABEL");r.openStart("div",w).class("sapMWizard").class("sapMWizardBg"+w.getBackgroundDesign()).style("width",w.getWidth()).style("height",w.getHeight()).accessibilityState({label:s}).openEnd();};
W.renderProgressNavigator=function(r,w){r.renderControl(w.getAggregation("_progressNavigator"));};
W.renderWizardSteps=function(r,w){r.openStart("section",w.getId()+"-step-container").class("sapMWizardStepContainer").openEnd();var R=this._getStepsRenderingOrder(w);R.forEach(r.renderControl,r);r.close("section");};
W.endWizard=function(r){r.close("div");};
W._getStepsRenderingOrder=function(w){if(!w.getEnableBranching()){return w.getSteps();}var s=w.getSteps().slice(),i,r,j,S;var c=function(a,i,r){var o=sap.ui.getCore().byId(a);if(s.indexOf(o)<s.indexOf(r)){var b=s.indexOf(o),t=s[b];s[b]=r;s[i]=t;i=0;}return i;};for(i=0;i<s.length;i++){r=s[i];S=r.getSubsequentSteps();if(S.length<1&&r.getNextStep()){S=[r.getNextStep()];}for(j=0;j<S.length;j++){i=c(S[j],i,r);}}return s;};
return W;},true);
sap.ui.predefine('sap/m/WizardStep',["./library","sap/ui/core/Control","sap/ui/core/InvisibleText","./WizardStepRenderer","./Button","./TitlePropagationSupport","sap/base/Log"],function(l,C,I,W,B,T,L){"use strict";
var a=C.extend("sap.m.WizardStep",{metadata:{properties:{title:{type:"string",group:"appearance",defaultValue:""},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:""},validated:{type:"boolean",group:"Behavior",defaultValue:true},optional:{type:"boolean",group:"Appearance",defaultValue:false}},events:{complete:{parameters:{}},activate:{parameters:{}}},defaultAggregation:"content",aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{subsequentSteps:{type:"sap.m.WizardStep",multiple:true,singularName:"subsequentStep"},nextStep:{type:"sap.m.WizardStep",multiple:false}}}});
var b=l.ButtonType;T.call(a.prototype,"content",function(){return this.getId()+"-title";});
a.prototype.init=function(){this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oNumberInvisibleText=new I({id:this.getId()+"-NumberedTitle"}).toStatic();this._createNextButton();this._initTitlePropagationSupport();};
a.prototype._createNextButton=function(){this._oNextButton=new B(this.getId()+"-nextButton",{text:this._oResourceBundle.getText("WIZARD_STEP")+2,type:b.Emphasized,press:this._complete.bind(this)}).addStyleClass("sapMWizardNextButtonVisible");this.setAggregation("_nextButton",this._oNextButton);};
a.prototype.setWizardContext=function(s){["bLast","bReviewStep","sButtonText","bParentAllowsButtonShow"].forEach(function(p){if(typeof s[p]!=="undefined"){this[p]=s[p];}}.bind(this));this._oNextButton.setText(this.sButtonText);this.setLast(this.bLast);this.setButtonVisibility();};
a.prototype._getNumberInvisibleText=function(){return this._oNumberInvisibleText;};
a.prototype._setNumberInvisibleText=function(n){return this._oNumberInvisibleText.setText(this._oResourceBundle.getText("WIZARD_STEP")+n+" "+this.getTitle());};
a.prototype.setValidated=function(v){this.setProperty("validated",v,true);this.setButtonVisibility();return this;};
a.prototype.setNextStep=function(v){this.setAssociation("nextStep",v,true);var p=this._getWizardParent();if(p!==null){p._checkCircularReference(this._getNextStepReference());p._updateProgressNavigator();}return this;};
a.prototype.setVisible=function(v){this.setProperty("visible",v,true);L.warning("Don't use the set visible method for wizard steps. If you need to show/hide steps based on some condition - use the branching property of the Wizard instead.");return this;};
a.prototype._isLeaf=function(){if(this.getNextStep()===null&&this.getSubsequentSteps().length===0){return true;}return false;};
a.prototype._isBranched=function(){return this.getSubsequentSteps().length>1;};
a.prototype._getNextStepReference=function(){if(this.getNextStep()!==null){return sap.ui.getCore().byId(this.getNextStep());}if(this.getSubsequentSteps().length===1){return sap.ui.getCore().byId(this.getSubsequentSteps()[0]);}return null;};
a.prototype._containsSubsequentStep=function(s){return this.getSubsequentSteps().some(function(S){return S===s;});};
a.prototype._getWizardParent=function(){var p=this.getParent();while(!(p instanceof sap.m.Wizard)){if(p===null){return null;}p=p.getParent();}return p;};
a.prototype.setLast=function(c){this.bLast=c;this.toggleStyleClass("sapMWizardLastActivatedStep",c);this.setButtonVisibility();};
a.prototype.setButtonVisibility=function(){var s=this.getValidated()&&this.bParentAllowsButtonShow&&this.bLast;if(typeof s==='undefined'){return;}this.displayButton(s);};
a.prototype.displayButton=function(s){this._oNextButton.toggleStyleClass("sapMWizardNextButtonHidden",!s);this._oNextButton.toggleStyleClass("sapMWizardNextButtonVisible",s);this._oNextButton.setVisible(s);};
a.prototype._activate=function(){this.setLast(true);this.addStyleClass("sapMWizardStepActivated");this.fireActivate();};
a.prototype._deactivate=function(){this.removeStyleClass("sapMWizardStepActivated");};
a.prototype._complete=function(){var w=this._getWizardParent();this.setLast(this.bReviewStep||false);this.fireComplete();if(w!==null){w._handleNextButtonPress();}};
a.prototype.exit=function(){this._oNumberInvisibleText.destroy();this._oNumberInvisibleText=null;};
return a;});
sap.ui.predefine('sap/m/WizardStepRenderer',function(){"use strict";var W={apiVersion:2};
W.render=function(r,s){this.startWizardStep(r,s);this.renderWizardStepTitle(r,s);this.renderContent(r,s);this.endWizardStep(r);};
W.startWizardStep=function(r,s){r.openStart("div",s).accessibilityState(s,{labelledby:s._getNumberInvisibleText().getId(),role:"region"}).class("sapMWizardStep").openEnd();};
W.renderWizardStepTitle=function(r,s){r.openStart("h3",s.getId()+"-Title").class("sapMWizardStepTitle").openEnd().text(s.getTitle()).close("h3");};
W.renderContent=function(r,s){s.getContent().forEach(r.renderControl,r);r.renderControl(s.getAggregation("_nextButton"));};
W.endWizardStep=function(r){r.close("div");};
return W;},true);
sap.ui.predefine('sap/m/changeHandler/AddTableColumn',["sap/ui/fl/changeHandler/BaseAddViaDelegate","sap/base/util/ObjectPath"],function(B,O){"use strict";var C="columns";var a="cells";var I="items";
function g(c,i,m,v,o){var e=O.get("oDataInformation.entityType",c);if(e){var b=c.content;return m.createControl('sap.m.Text',o,v,b.newFieldSelector.id+'--column',{text:"{/#"+e+"/"+b.bindingPath+"/@sap:label}"});}return i.label;}
var A=B.createAddViaDelegateChangeHandler({addProperty:function(p){var i=p.innerControls;if(i.valueHelp){throw Error("Adding properties with value helps is not yet supported by addTableColumn change handler");}var t=p.control;var m=p.modifier;var v=p.view;var o=p.appComponent;var c=p.change;var r=c.getRevertData();var b=c.getDefinition();var d=b.content;var e=d.newFieldIndex;var f=d.newFieldSelector;var T=m.getBindingTemplate(t,I,v);if(T){var s=i.control;m.insertAggregation(T,a,s,e,v);m.updateAggregation(t,I);r.newCellSelector={id:f.id+'--field',idIsLocal:true};}var h=m.createControl('sap.m.Column',o,v,f);var l=g(b,i,m,v,o);m.insertAggregation(h,'header',l,0,v);m.insertAggregation(t,C,h,e,v);},revertAdditionalControls:function(p){var t=p.control;var c=p.change;var m=p.modifier;var o=p.appComponent;var T=m.getBindingTemplate(t,I);if(T){var n=m.bySelector(c.getRevertData().newCellSelector,o);m.removeAggregation(T,a,n);m.destroy(n);m.updateAggregation(t,I);}},aggregationName:C,parentAlias:"targetTable",fieldSuffix:"--field",skipCreateLabel:function(p){return!!O.get("changeDefinition.oDataInformation.entityType",p);},skipCreateLayout:true,supportsDefault:true});return A;},true);
sap.ui.predefine('sap/m/changeHandler/ChangeLinkTarget',function(){"use strict";var C={};
C.applyChange=function(c,o,p){var m=p.modifier,a=c.getDefinition(),t=a.content,r={target:m.getProperty(o,"target")};m.setProperty(o,"target",t);c.setRevertData(r);return true;};
C.revertChange=function(c,o,p){var m=p.modifier,r=c.getRevertData(),t=r.target;m.setProperty(o,"target",t);return true;};
C.completeChangeContent=function(c,s,p){return true;};
return C;});
sap.ui.predefine('sap/m/changeHandler/CombineButtons',["sap/base/util/uid","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(u,J,C){"use strict";var a={};
a.applyChange=function(c,o,p){if(p.modifier.targets!=="jsControlTree"){throw new Error("Combine buttons change can't be applied on XML tree");}var b=c.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var s=m.bySelector(b.content.combineButtonSelectors[0],A,v);var P=m.getParent(s);var i;var d;var B;var I=sap.ui.getCore().getConfiguration().getRTL();var M;var e;var f=[];var g="";var h="";var O="";var r={parentAggregation:"",insertIndexes:[]};var j=[];B=b.content.combineButtonSelectors.map(function(k){return m.bySelector(k,A,v);});d=m.getParentAggregationName(B[0],P);r.parentAggregation=d;i=m.findIndexInParentAggregation(s);M=m.createControl("sap.m.Menu",A,v,b.content.menuIdSelector);B.forEach(function(k,l){var n;var q;var S=b.content.buttonsIdForSave[l];var t=m.getProperty(k,"text");q=m.createControl("sap.m.MenuItem",A,v,S);r.insertIndexes[l]=m.findIndexInParentAggregation(k);m.attachEvent(q,"press","sap.m.changeHandler.CombineButtons.pressHandler",{selector:m.getSelector(k,A),appComponentId:A.getId()});var w="$sap.m.flexibility.CombineButtonsModel";var x=m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModel'}),{object:k,name:w});m.insertAggregation(q,"dependents",x,0,v);m.bindProperty(q,"text",w+">/text");m.bindProperty(q,"icon",w+">/icon");m.bindProperty(q,"enabled",w+">/enabled");m.bindProperty(q,"visible",w+">/visible");m.bindAggregation(q,"customData",{path:w+">/customData",template:m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},S,{id:S.id+'-customData'}),{key:"{ path: '"+w+">key' }",value:"{ path: '"+w+">value' }"}),templateShareable:false},v);if(t){I?f.unshift(t):f.push(t);}S.id=S.id+"-originalButtonId";n=m.createControl("sap.ui.core.CustomData",A,v,S);m.setProperty(n,"key","originalButtonId");m.setProperty(n,"value",m.getId(k));m.removeAggregation(P,d,k);m.insertAggregation(P,"dependents",k,0,v);m.insertAggregation(k,"customData",n,0,v);m.insertAggregation(M,"items",q,l,v);var w="$sap.m.flexibility.MenuButtonModel"+l;j[l]=m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},S,{id:S.id+'-managedObjectModelMenuItem'}),{object:q,name:w});g=g+O+"${"+w+">/enabled}";h=h+O+"${"+w+">/visible}";O=" || ";});e=m.createControl("sap.m.MenuButton",A,v,b.content.menuButtonIdSelector,{visible:"{= "+h+"}",enabled:"{= "+g+"}"});j.forEach(function(k){m.insertAggregation(e,"dependents",k,0,v);});m.setProperty(e,"text",f.join("/"));m.insertAggregation(e,"menu",M,0,v);m.insertAggregation(P,d,e,i,v);c.setRevertData(r);return true;};
a.revertChange=function(c,o,p){var m=p.modifier;var v=p.view;var r=c.getRevertData();var b=c.getDefinition();var P=r.parentAggregation;var M=m.bySelector(b.content.menuButtonIdSelector,p.appComponent,v);var d=m.getParent(M);var B=b.content.combineButtonSelectors.slice().reverse();var e;m.removeAggregation(d,P,M);m.destroy(M);for(var i=0,l=B.length;i<l;i++){e=m.bySelector(B[i],p.appComponent,v);m.getAggregation(e,"customData").some(function(f){if(m.getProperty(f,"key")==="originalButtonId"){m.destroy(f);return true;}});m.insertAggregation(d,P,e,r.insertIndexes[l-i-1],v);}c.resetRevertData();return true;};
a.completeChangeContent=function(c,s,p){var m=p.modifier;var A=p.appComponent;var o=c.getDefinition();var b=s.combineElementIds;if(b&&b.length>1){c.addDependentControl(b,"combinedButtons",p);o.content.combineButtonSelectors=b.map(function(d){return m.getSelector(d,A);});o.content.menuButtonIdSelector=m.getSelector(A.createId(u()),A);o.content.menuIdSelector=m.getSelector(A.createId(u()),A);o.content.buttonsIdForSave=b.map(function(){return m.getSelector(A.createId(u()),A);});}else{throw new Error("Combine buttons action cannot be completed: oSpecificChangeInfo.combineElementIds attribute required");}};
a.pressHandler=function(e,p){var b=J.bySelector(p.selector,C.get(p.appComponentId));b.firePress();};
return a;},true);
sap.ui.predefine('sap/m/changeHandler/MoveTableColumns',["sap/base/Log","sap/ui/thirdparty/jquery"],function(L,q){"use strict";var M={};var S="source";var T="target";var a="movedElements";var C="columns";var b="cells";var I="items";
function _(c,r,p,i){var m=p.modifier,v=p.view,A=p.appComponent,o=c.getContent(),t=c.getDependentControl(S,p),d=c.getDependentControl(T,p),e=m.getAggregation(d,C),s=function(R,g,h){var j=m.getAggregation(R,b);if(!j){L.warning("Aggregation cells to move not found");return;}if(g<0||g>=j.length){L.warning("Move cells in table item called with invalid index: "+g);return;}var k=j[g];m.removeAggregation(R,b,k);m.insertAggregation(R,b,k,h,v);},f=function(g,h){m.getAggregation(d,I).forEach(function(j){if(m.getControlType(j)==="sap.m.GroupHeaderListItem"){return;}s(j,g,h);});};if(t!==d){L.warning("Moving columns between different tables is not yet supported.");return false;}o.movedElements.forEach(function(g){var h=m.bySelector(g.selector,A,v),j,k,l,n,u;if(!h){u=g.selector&&g.selector.id;L.warning("The table column with id: '"+u+"' stored in the change is not found and the move operation cannot be applied");return;}l=e.indexOf(h);n=g.sourceIndex;k=q.isFunction(i)&&i(l);k=q.isNumeric(k)?k:g.targetIndex;if(l!==k){j=l;}else{j=n;}m.removeAggregation(d,C,h);m.insertAggregation(d,C,h,k,v);var w=m.getBindingTemplate(d,I);if(w){s(w,j,k);m.updateAggregation(d,I);}else{f(j,k);}},this);return true;}
M.applyChange=function(c,r,p){var R=[];_(c,r,p,function(i){R.unshift({index:i});});c.setRevertData(R);};
M.revertChange=function(c,r,p){var R=c.getRevertData();_(c,r,p,function(){var i=R.shift();return i&&i.index;});c.resetRevertData();};
M.completeChangeContent=function(c,s,p){var m=p.modifier,A=p.appComponent,d=c.getDefinition(),o=m.bySelector(s.source.id,A),t=m.bySelector(s.target.id,A),e={aggregation:s.source.aggregation,type:m.getControlType(o)},f={aggregation:s.target.aggregation,type:m.getControlType(t)};d.content={movedElements:[]};s.movedElements.forEach(function(E){var g=E.element||m.bySelector(E.id,A);d.content.movedElements.push({selector:m.getSelector(g,A),sourceIndex:E.sourceIndex,targetIndex:E.targetIndex});});c.addDependentControl(s.source.id,S,p,e);c.addDependentControl(s.target.id,T,p,f);c.addDependentControl(s.movedElements.map(function(g){return g.id;}),a,p);};
return M;},true);
sap.ui.predefine('sap/m/changeHandler/SplitMenuButton',["sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/core/Component","sap/ui/fl/util/ManagedObjectModel"],function(J,C){"use strict";var S={};var a="sourceControl";
S.applyChange=function(c,o,p){if(p.modifier.targets!=="jsControlTree"){throw new Error("Split change can't be applied on XML tree");}var b=c.getDefinition();var m=p.modifier;var v=p.view;var A=p.appComponent;var s=c.getDependentControl(a,p);var M=m.getAggregation(s,"menu");var d=m.getAggregation(M,"items");var P=m.getParent(s);var e=m.getParentAggregationName(s,P);var i=m.findIndexInParentAggregation(s);var n=b.content.newElementIds;var r={parentAggregation:e,insertIndex:i,insertedButtons:[]};d.forEach(function(f,g){var h=n[g];var B=m.createControl("sap.m.Button",A,v,h);r.insertedButtons.push(h);var j="$sap.m.flexibility.SplitButtonsModel";var k=m.createControl("sap.ui.fl.util.ManagedObjectModel",A,v,Object.assign({},h,{id:h.id+'-managedObjectModel'}),{object:f,name:j});m.insertAggregation(B,"dependents",k,0,v);m.bindProperty(B,"text",j+">/text");m.bindProperty(B,"icon",j+">/icon");m.bindProperty(B,"enabled",j+">/enabled");m.bindProperty(B,"visible",j+">/visible");m.bindAggregation(B,"customData",{path:j+">/customData",template:m.createControl("sap.ui.core.CustomData",A,v,Object.assign({},h,{id:h.id+'-customData'}),{key:{path:j+">key"},value:{path:j+">value"}}),templateShareable:false});m.attachEvent(B,"press","sap.m.changeHandler.SplitMenuButton.pressHandler",{selector:m.getSelector(f,A),appComponentId:A.getId()});m.insertAggregation(P,e,B,i+g,v);});m.removeAggregation(P,e,s);m.insertAggregation(P,"dependents",s,0,v);c.setRevertData(r);return true;};
S.revertChange=function(c,o,p){var m=p.modifier;var r=c.getRevertData();var s=c.getDependentControl(a,p);var A=p.appComponent;var v=p.view;var P=m.getParent(s);var b=r.parentAggregation;var i=r.insertIndex;var I=r.insertedButtons.map(function(d){return m.bySelector(d,A,v);});I.forEach(function(B){m.removeAggregation(P,b,B);m.destroy(B);});m.insertAggregation(P,b,s,i,v);c.resetRevertData();return true;};
S.completeChangeContent=function(c,s,p){var m=p.modifier;var A=p.appComponent;var o=c.getDefinition();if(!s.newElementIds){throw new Error("Split of MenuButton cannot be applied : oSpecificChangeInfo.newElementIds attribute required");}if(!s.sourceControlId){throw new Error("Split of MenuButton cannot be applied : oSpecificChangeInfo.sourceControlId attribute required");}c.addDependentControl(s.sourceControlId,a,p);o.content.sourceSelector=m.getSelector(s.sourceControlId,A);o.content.newElementIds=s.newElementIds.map(function(e){return m.getSelector(e,A);});};
S.pressHandler=function(e,p){var m=J.bySelector(p.selector,C.get(p.appComponentId));m.firePress();};
return S;},true);
sap.ui.predefine('sap/m/delegate/ValueStateMessage',['sap/ui/Device','sap/ui/base/Object','sap/ui/core/Core','sap/ui/core/ValueStateSupport','sap/ui/core/Popup','sap/ui/core/library',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Aria"],function(D,B,C,V,P,c,q){"use strict";var a=c.ValueState;
var b=B.extend("sap.m.delegate.ValueState",{constructor:function(o){B.apply(this,arguments);this._oControl=o;this._oPopup=null;}});
b.prototype.open=function(){var o=this._oControl,p=this.getPopup(),m=this.createDom(),d=P.Dock,$;if(!o||!o.getDomRef()||!p||!m){return;}$=q(o.getDomRefForValueStateMessage());p.setContent(m);p.close(0);if(p.getContent()){p.getContent().style.maxWidth=o.getDomRef().offsetWidth+"px";}else{p.getContent().style.maxWidth="";}p.open(this.getOpenDuration(),d.BeginTop,d.BeginBottom,o.getDomRefForValueStateMessage(),null,null,D.system.phone?true:P.CLOSE_ON_SCROLL);var e=q(m);if($.offset().top<e.offset().top){e.addClass("sapMValueStateMessageBottom");}else{e.addClass("sapMValueStateMessageTop");}q(o.getFocusDomRef()).addAriaDescribedBy(this.getId());};
b.prototype.close=function(){var o=this._oControl,p=this._oPopup;if(p){p.close(0);}if(o){q(o.getFocusDomRef()).removeAriaDescribedBy(this.getId());}};
b.prototype.getId=function(){var o=this._oControl;if(!o){return"";}return(typeof o.getValueStateMessageId==="function")?o.getValueStateMessageId():o.getId()+"-message";};
b.prototype.getOpenDuration=function(){var o=this._oControl;if(!o){return 0;}return(o.iOpenMessagePopupDuration===undefined)?0:o.iOpenMessagePopupDuration;};
b.prototype.createPopup=function(i){i=i||this.getId();if(this._oPopup){return this._oPopup;}this._oPopup=new P(document.createElement("span"),false,false,false);this._oPopup.attachClosed(function(){q(document.getElementById(i)).remove();});this._oPopup.attachOpened(function(){var d=this._oPopup.getContent(),e=D.browser.msie&&this._oControl&&this._oControl.getFormattedValueStateText&&!!this._oControl.getFormattedValueStateText();if(d&&!e){d.style.zIndex=this._getCorrectZIndex();}}.bind(this));return this._oPopup;};
b.prototype.getPopup=function(){if(!this._oControl){return null;}return this.createPopup();};
b.prototype.createDom=function(){var o=this._oControl;if(!o){return null;}var i=this.getId(),m=document.createElement("div"),s=o.getValueState(),I=D.browser.msie,f=o.getFormattedValueStateText?o.getFormattedValueStateText():null,t,r,A,T;m.id=i;m.setAttribute("role","tooltip");m.setAttribute("aria-live","assertive");if(s===a.Success||s===a.None){m.className="sapUiInvisibleText";}else{m.className="sapMValueStateMessage sapMValueStateMessage"+s;}r=C.getLibraryResourceBundle("sap.m");A=document.createElement("span");A.id=i+"-hidden";if(I){A.className="sapUiHidden";A.setAttribute("aria-hidden","true");}else{A.className="sapUiPseudoInvisibleText";}if(s!==a.None){A.appendChild(document.createTextNode(r.getText("INPUTBASE_VALUE_STATE_"+s.toUpperCase())));}m.appendChild(A);if(!f||!f.getHtmlText()){T=s===a.Success||s===a.None?"":o.getValueStateText()||V.getAdditionalText(o);t=document.createElement("span");t.id=i+"-text";t.appendChild(document.createTextNode(T));m.appendChild(t);}else if(s!==a.Success&&s!==a.None){C.getRenderManager().render(f,m);m.lastElementChild.setAttribute("id",i+"-text");}if(!o.isA('sap.m.Select')&&I){if(!t){m.lastElementChild.setAttribute("id",i+"-text");}else{t.setAttribute("aria-hidden","true");}}return m;};
b.prototype.destroy=function(){if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}this._oControl=null;};
b.prototype._getCorrectZIndex=function(){var p=this._oControl.$().parents().filter(function(){var z=q(this).css('z-index');return z&&z!=='auto'&&z!=='0';});if(!p.length){return 1;}var h=0;p.each(function(){var z=parseInt(q(this).css('z-index'));if(z>h){h=z;}});return h+1;};
return b;});
sap.ui.predefine('sap/m/flexibility/Avatar.flexibility',[],function(){"use strict";return{"hideControl":"default","unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Bar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/flexibility/Button.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/CheckBox.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XCKL"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/Dialog.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"})};});
sap.ui.predefine('sap/m/flexibility/IconTabFilter.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTBS"})};});
sap.ui.predefine('sap/m/flexibility/InputListItem.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"label",translationTextType:"XBLI"}),"unhideControl":"default","moveControls":"default"};});
sap.ui.predefine('sap/m/flexibility/Label.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XFLD"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/Link.flexibility',["sap/m/changeHandler/ChangeLinkTarget","sap/ui/fl/changeHandler/BaseRename"],function(C,B){"use strict";return{"hideControl":"default","unhideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"changeLinkTarget":{"changeHandler":C,"layers":{"CUSTOMER":false}}};});
sap.ui.predefine('sap/m/flexibility/MenuButton.flexibility',["sap/m/changeHandler/SplitMenuButton","sap/ui/fl/changeHandler/BaseRename"],function(S,B){"use strict";return{"splitMenuButton":S,"rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XFLD"})};},true);
sap.ui.predefine('sap/m/flexibility/OverflowToolbar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/flexibility/OverflowToolbarButton.flexibility',[],function(){"use strict";return{"hideControl":"default","unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Page.flexibility',["sap/ui/fl/changeHandler/BaseRename","sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(B,C,S){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};});
sap.ui.predefine('sap/m/flexibility/Panel.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"headerText",translationTextType:"XGRP"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Popover.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"moveControls":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"})};});
sap.ui.predefine('sap/m/flexibility/RadioButton.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XBUT"}),"unhideControl":"default"};});
sap.ui.predefine('sap/m/flexibility/StandardListItem.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"title",translationTextType:"XTIT"}),"unhideControl":"default","moveControls":"default"};});
sap.ui.predefine('sap/m/flexibility/Table.flexibility',["sap/m/changeHandler/MoveTableColumns","sap/m/changeHandler/AddTableColumn"],function(M,A){"use strict";return{"hideControl":"default","unhideControl":"default","moveTableColumns":M,"addTableColumn":A};},true);
sap.ui.predefine('sap/m/flexibility/Text.flexibility',['sap/ui/fl/changeHandler/BaseRename'],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTXT"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Title.flexibility',["sap/ui/fl/changeHandler/BaseRename"],function(B){"use strict";return{"hideControl":"default","rename":B.createRenameChangeHandler({propertyName:"text",translationTextType:"XTIT"}),"unhideControl":"default"};},true);
sap.ui.predefine('sap/m/flexibility/Toolbar.flexibility',["sap/m/changeHandler/CombineButtons","sap/m/changeHandler/SplitMenuButton"],function(C,S){"use strict";return{"moveControls":"default","combineButtons":{"changeHandler":C,"layers":{"CUSTOMER":false}},"splitMenuButton":{"changeHandler":S,"layers":{"CUSTOMER":false}}};},true);
sap.ui.predefine('sap/m/ios7',["sap/ui/core/IntervalTrigger","sap/ui/thirdparty/jquery","sap/ui/base/EventProvider","sap/ui/Device"],function(I,q,E,D){"use strict";
var _=E.extend("sap.m._Ios7",{constructor:function(){var b=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";E.apply(this);if(!b){return;}this._bIntervallAttached=false;this._bInputIsOpen=false;this._bNavigationBarEventFired=false;var a=window.orientation===90||window.orientation===-90;if(a){this._attachNavigationBarPolling();}D.orientation.attachHandler(this._onOrientationChange,this);this._onFocusin=q.proxy(this._onFocusin,this);document.addEventListener("focusin",this._onFocusin,true);this._onFocusout=q.proxy(this._onFocusout,this);document.addEventListener("focusout",this._onFocusout,true);}});
_.prototype.getNavigationBarHeight=function(){if(!this._bNavigationBarEventFired){return 0;}return this._iNavigationBarHeight;};
_.prototype._attachNavigationBarPolling=function(){if(!D.system.phone||this._bIntervallAttached){return;}I.addListener(this._detectNavigationBar,this);this._bIntervallAttached=true;};
_.prototype._detachNavigationBarPolling=function(){if(!D.system.phone||!this._bIntervallAttached){return;}I.removeListener(this._detectNavigationBar,this);this._bIntervallAttached=false;};
_.prototype._detectNavigationBar=function(){var h=window.outerHeight-window.innerHeight;if(h===0||this._bInputIsOpen||this._bNavigationBarEventFired){this._iPreviousHeight=null;return;}if(this._iPreviousHeight===window.innerHeight){window.scrollTo(0,0);var n=window.outerHeight-window.innerHeight;if(h!==n){return;}this._iNavigationBarHeight=h;this._bNavigationBarEventFired=true;this.fireEvent("navigationBarShownInLandscape",{barHeight:h});this._detachNavigationBarPolling();this._iPreviousHeight=null;}else{this._iPreviousHeight=window.innerHeight;}};
_.prototype.destroy=function(){E.prototype.destroy.apply(this,arguments);document.removeEventListener("focusin",this._onFocusin,true);document.removeEventListener("focusout",this._onFocusout,true);};
_.prototype._onFocusin=function(e){var t=e.target.tagName;if(!_._rTagRegex.test(t)){return;}this._inputTarget=e.target;this._detachNavigationBarPolling();this._bInputIsOpen=true;this.fireEvent("inputOpened");};
_._rTagRegex=/INPUT|TEXTAREA|SELECT/;
_.prototype._onFocusout=function(e){var t=e.srcElement.tagName,r=e.relatedTarget,R=(r&&(r.getAttribute("readonly")===null)&&(r.getAttribute("disabled")===null))?r.tagName:"";if(_._rTagRegex.test(t)&&!_._rTagRegex.test(R)){window.scrollTo(0,0);if(window.orientation===90||window.orientation===-90){this._attachNavigationBarPolling();}this._bInputIsOpen=false;this.fireEvent("inputClosed");}};
_.prototype._onOrientationChange=function(e){var b=e.landscape;window.scrollTo(0,0);this._bNavigationBarEventFired=false;if(this._bInputIsOpen&&this._inputTarget&&this._inputTarget.blur){this._inputTarget.blur();}else if(b){this._attachNavigationBarPolling();}else if(!b){this._detachNavigationBarPolling();}};
var i=new _();return i;},true);
sap.ui.predefine('sap/m/library',["sap/ui/Device","sap/ui/base/DataType","sap/ui/base/EventProvider","sap/ui/core/Control","sap/base/util/ObjectPath","sap/ui/core/library","sap/base/strings/capitalize","sap/ui/thirdparty/jquery","sap/base/assert","sap/base/Log","sap/base/util/defineLazyProperty","sap/base/security/encodeCSS","./AvatarShape","./AvatarSize","./AvatarType","./AvatarColor","./AvatarImageFitType","./Support"],function(D,a,E,C,O,b,d,q,e,L,f,g,A,h,n,o,p){"use strict";sap.ui.getCore().initLibrary({name:"sap.m",version:"1.82.2",dependencies:["sap.ui.core"],designtime:"sap/m/designtime/library.designtime",types:["sap.m.AvatarImageFitType","sap.m.AvatarShape","sap.m.AvatarSize","sap.m.AvatarType","sap.m.AvatarColor","sap.m.BackgroundDesign","sap.m.BadgeState","sap.m.BarDesign","sap.m.BreadcrumbsSeparatorStyle","sap.m.ButtonType","sap.m.CarouselArrowsPlacement","sap.m.DateTimeInputType","sap.m.DeviationIndicator","sap.m.DialogRoleType","sap.m.DialogType","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignContent","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FlexWrap","sap.m.FrameType","sap.m.GenericTagDesign","sap.m.GenericTagValueState","sap.m.GenericTileMode","sap.m.GenericTileScope","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabDensityMode","sap.m.IconTabFilterDesign","sap.m.IconTabHeaderMode","sap.m.ImageMode","sap.m.InputTextFormatMode","sap.m.InputType","sap.m.LabelDesign","sap.m.LightBoxLoadingStates","sap.m.LinkConversion","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.ObjectHeaderPictureShape","sap.m.ObjectMarkerType","sap.m.ObjectMarkerVisibility","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.P13nConditionOperation","sap.m.PageBackgroundDesign","sap.m.PanelAccessibleRole","sap.m.PDFViewerDisplayType","sap.m.PlacementType","sap.m.PlanningCalendarBuiltInView","sap.m.PlanningCalendarStickyMode","sap.m.PopinDisplay","sap.m.PopinLayout","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectionDetailsActionLevel","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.Size","sap.m.SplitAppMode","sap.m.StandardTileType","sap.m.StepInputStepModeType","sap.m.StepInputValidationMode","sap.m.Sticky","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.TileSizeBehavior","sap.m.TimePickerMaskMode","sap.m.TitleAlignment","sap.m.TokenizerRenderMode","sap.m.ToolbarDesign","sap.m.ToolbarStyle","sap.m.UploadState","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.VerticalPlacementType","sap.m.WrappingType","sap.m.semantic.SemanticRuleSetType"],interfaces:["sap.m.IBar","sap.m.IBadge","sap.m.IBreadcrumbs","sap.m.IconTab","sap.m.IScale","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer","sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent","sap.m.IHyphenation"],controls:["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Avatar","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnHeaderPopover","sap.m.ColumnListItem","sap.m.ColorPalette","sap.m.ColorPalettePopover","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.CustomTreeItem","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeField","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTag","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.HeaderContainer","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabHeader","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageView","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiEditField","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.PlanningCalendarLegend","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.OverflowToolbarToggleButton","sap.m.P13nColumnsPanel","sap.m.P13nGroupPanel","sap.m.P13nSelectionPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PDFViewer","sap.m.PlanningCalendar","sap.m.PlanningCalendarHeader","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewBase","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectList","sap.m.SelectionDetails","sap.m.Shell","sap.m.SimpleFixFlex","sap.m.SinglePlanningCalendar","sap.m.SinglePlanningCalendarGrid","sap.m.SinglePlanningCalendarMonthGrid","sap.m.Slider","sap.m.SliderTooltip","sap.m.SliderTooltipBase","sap.m.SliderTooltipContainer","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.TimePickerSliders","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.upload.UploadSet","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.WheelSlider","sap.m.WheelSliderContainer","sap.m.Wizard","sap.m.WizardStep","sap.m.semantic.DetailPage","sap.m.semantic.SemanticPage","sap.m.semantic.ShareMenuPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage"],elements:["sap.m.BadgeCustomData","sap.m.Column","sap.m.ColumnPopoverActionItem","sap.m.ColumnPopoverCustomItem","sap.m.ColumnPopoverItem","sap.m.ColumnPopoverSortItem","sap.m.FlexItemData","sap.m.FeedListItemAction","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessageItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nGroupItem","sap.m.P13nSortItem","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.ResponsiveScale","sap.m.SegmentedButtonItem","sap.m.SelectionDetailsItem","sap.m.SelectionDetailsItemLine","sap.m.SinglePlanningCalendarDayView","sap.m.SinglePlanningCalendarMonthView","sap.m.SinglePlanningCalendarWeekView","sap.m.SinglePlanningCalendarWorkWeekView","sap.m.SinglePlanningCalendarView","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.TabStripItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.upload.Uploader","sap.m.upload.UploadSetItem","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.plugins.DataStateIndicator","sap.m.plugins.PluginBase","sap.m.semantic.AddAction","sap.m.semantic.CancelAction","sap.m.semantic.DeleteAction","sap.m.semantic.DiscussInJamAction","sap.m.semantic.EditAction","sap.m.semantic.FavoriteAction","sap.m.semantic.FilterAction","sap.m.semantic.FilterSelect","sap.m.semantic.FlagAction","sap.m.semantic.ForwardAction","sap.m.semantic.GroupAction","sap.m.semantic.GroupSelect","sap.m.semantic.MainAction","sap.m.semantic.MessagesIndicator","sap.m.semantic.MultiSelectAction","sap.m.semantic.NegativeAction","sap.m.semantic.OpenInAction","sap.m.semantic.PositiveAction","sap.m.semantic.PrintAction","sap.m.semantic.SaveAction","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticControl","sap.m.semantic.SemanticSelect","sap.m.semantic.SemanticToggleButton","sap.m.semantic.SendEmailAction","sap.m.semantic.SendMessageAction","sap.m.semantic.ShareInJamAction","sap.m.semantic.SortAction","sap.m.semantic.SortSelect"],extensions:{flChangeHandlers:{"sap.m.ActionSheet":{"moveControls":"default"},"sap.m.Avatar":"sap/m/flexibility/Avatar","sap.m.Bar":"sap/m/flexibility/Bar","sap.m.Button":"sap/m/flexibility/Button","sap.m.CheckBox":"sap/m/flexibility/CheckBox","sap.m.ColumnListItem":{"hideControl":"default","unhideControl":"default"},"sap.m.CustomListItem":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.DatePicker":{"hideControl":"default","unhideControl":"default"},"sap.m.Dialog":"sap/m/flexibility/Dialog","sap.m.FlexBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.HBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.IconTabBar":{"moveControls":"default"},"sap.m.IconTabFilter":"sap/m/flexibility/IconTabFilter","sap.m.Image":{"hideControl":"default","unhideControl":"default"},"sap.m.Input":{"hideControl":"default","unhideControl":"default"},"sap.m.InputBase":{"hideControl":"default","unhideControl":"default"},"sap.m.InputListItem":"sap/m/flexibility/InputListItem","sap.m.Label":"sap/m/flexibility/Label","sap.m.MultiInput":{"hideControl":"default","unhideControl":"default"},"sap.m.ListItemBase":{"hideControl":"default","unhideControl":"default"},"sap.m.Link":"sap/m/flexibility/Link","sap.m.List":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.ListBase":{"hideControl":"default","unhideControl":"default","moveControls":"default"},"sap.m.MaskInput":{"hideControl":"default","unhideControl":"default"},"sap.m.MenuButton":"sap/m/flexibility/MenuButton","sap.m.OverflowToolbar":"sap/m/flexibility/OverflowToolbar","sap.m.OverflowToolbarButton":"sap/m/flexibility/OverflowToolbarButton","sap.m.Page":"sap/m/flexibility/Page","sap.m.Panel":"sap/m/flexibility/Panel","sap.m.Popover":"sap/m/flexibility/Popover","sap.m.RadioButton":"sap/m/flexibility/RadioButton","sap.m.RatingIndicator":{"hideControl":"default","unhideControl":"default"},"sap.m.RangeSlider":{"hideControl":"default","unhideControl":"default"},"sap.m.ScrollContainer":{"hideControl":"default","moveControls":"default","unhideControl":"default"},"sap.m.Slider":{"hideControl":"default","unhideControl":"default"},"sap.m.StandardListItem":"sap/m/flexibility/StandardListItem","sap.m.Table":"sap/m/flexibility/Table","sap.m.Column":{"hideControl":"default","unhideControl":"default"},"sap.m.Text":"sap/m/flexibility/Text","sap.m.Title":"sap/m/flexibility/Title","sap.m.Toolbar":"sap/m/flexibility/Toolbar","sap.m.VBox":{"hideControl":"default","unhideControl":"default","moveControls":"default"}},"sap.ui.support":{publicRules:true,internalRules:true}}});var t=sap.m;t.BackgroundDesign={Solid:"Solid",Transparent:"Transparent",Translucent:"Translucent"};t.BadgeState={Updated:"Updated",Appear:"Appear",Disappear:"Disappear"};t.BadgeStyle={Default:"Default",Attention:"Attention"};t.BarDesign={Auto:"Auto",Header:"Header",SubHeader:"SubHeader",Footer:"Footer"};t.BreadcrumbsSeparatorStyle={Slash:"Slash",BackSlash:"BackSlash",DoubleSlash:"DoubleSlash",DoubleBackSlash:"DoubleBackSlash",GreaterThan:"GreaterThan",DoubleGreaterThan:"DoubleGreaterThan"};t.ButtonType={Default:"Default",Back:"Back",Accept:"Accept",Reject:"Reject",Transparent:"Transparent",Ghost:"Ghost",Up:"Up",Unstyled:"Unstyled",Emphasized:"Emphasized",Critical:"Critical",Negative:"Negative",Success:"Success",Neutral:"Neutral",Attention:"Attention"};t.ButtonAccessibilityType={Default:"Default",Labelled:"Labelled",Described:"Described",Combined:"Combined"};t.CarouselArrowsPlacement={Content:"Content",PageIndicator:"PageIndicator"};t.PlanningCalendarBuiltInView={Hour:"Hour",Day:"Day",Month:"Month",Week:"Week",OneMonth:"One Month"};t.DateTimeInputType={Date:"Date",DateTime:"DateTime",Time:"Time"};t.DialogType={Standard:"Standard",Message:"Message"};t.DialogRoleType={Dialog:"dialog",AlertDialog:"alertdialog"};t.DeviationIndicator={Up:"Up",Down:"Down",None:"None"};t.DraftIndicatorState={Clear:"Clear",Saving:"Saving",Saved:"Saved"};t.FacetFilterListDataType={Date:"Date",DateTime:"DateTime",Time:"Time",Integer:"Integer",Float:"Float",String:"String",Boolean:"Boolean"};t.FacetFilterType={Simple:"Simple",Light:"Light"};t.FlexAlignItems={Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};t.FlexAlignSelf={Auto:"Auto",Start:"Start",End:"End",Center:"Center",Baseline:"Baseline",Stretch:"Stretch",Inherit:"Inherit"};t.FlexDirection={Row:"Row",Column:"Column",RowReverse:"RowReverse",ColumnReverse:"ColumnReverse",Inherit:"Inherit"};t.FlexJustifyContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Inherit:"Inherit"};t.FlexWrap={NoWrap:"NoWrap",Wrap:"Wrap",WrapReverse:"WrapReverse"};t.FlexAlignContent={Start:"Start",End:"End",Center:"Center",SpaceBetween:"SpaceBetween",SpaceAround:"SpaceAround",Stretch:"Stretch",Inherit:"Inherit"};t.FlexRendertype={Div:"Div",List:"List",Bare:"Bare"};t.FrameType={OneByOne:"OneByOne",TwoByOne:"TwoByOne",TwoThirds:"TwoThirds",Auto:"Auto"};t.LinkConversion={None:"None",ProtocolOnly:"ProtocolOnly",All:"All"};t.InputTextFormatMode={Value:"Value",Key:"Key",ValueKey:"ValueKey",KeyValue:"KeyValue"};t.GenericTagDesign={Full:"Full",StatusIconHidden:"StatusIconHidden"};t.GenericTagValueState={None:"None",Error:"Error"};t.GenericTileMode={ContentMode:"ContentMode",HeaderMode:"HeaderMode",LineMode:"LineMode"};t.GenericTileScope={Display:"Display",Actions:"Actions",ActionMore:"ActionMore",ActionRemove:"ActionRemove"};t.TileSizeBehavior={Responsive:"Responsive",Small:"Small"};t.HeaderLevel={H1:"H1",H2:"H2",H3:"H3",H4:"H4",H5:"H5",H6:"H6"};t.IBarHTMLTag={Div:"Div",Header:"Header",Footer:"Footer"};t.IconTabHeaderMode={Standard:"Standard",Inline:"Inline"};t.IconTabDensityMode={Inherit:"Inherit",Compact:"Compact",Cozy:"Cozy"};t.IconTabFilterDesign={Horizontal:"Horizontal",Vertical:"Vertical"};t.ImageMode={Image:"Image",Background:"Background"};t.Size={XS:"XS",S:"S",M:"M",L:"L",Auto:"Auto",Responsive:"Responsive"};t.ValueColor={Neutral:"Neutral",Good:"Good",Critical:"Critical",Error:"Error"};t.ValueCSSColor=a.createType("sap.m.ValueCSSColor",{isValid:function(v){var r=t.ValueColor.hasOwnProperty(v);if(r){return r;}else{r=b.CSSColor.isValid(v);if(r){return r;}else{var P=sap.ui.requireSync("sap/ui/core/theming/Parameters");return b.CSSColor.isValid(P.get(v));}}}},a.getType("string"));t.InputType={Text:"Text",Date:"Date",Datetime:"Datetime",DatetimeLocale:"DatetimeLocale",Email:"Email",Month:"Month",Number:"Number",Tel:"Tel",Time:"Time",Url:"Url",Week:"Week",Password:"Password"};t.LabelDesign={Bold:"Bold",Standard:"Standard"};t.ListHeaderDesign={Standard:"Standard",Plain:"Plain"};t.ListMode={None:"None",SingleSelect:"SingleSelect",SingleSelectLeft:"SingleSelectLeft",SingleSelectMaster:"SingleSelectMaster",MultiSelect:"MultiSelect",Delete:"Delete"};t.ListKeyboardMode={Navigation:"Navigation",Edit:"Edit"};t.ListGrowingDirection={Downwards:"Downwards",Upwards:"Upwards"};t.ListSeparators={All:"All",Inner:"Inner",None:"None"};t.ListType={Inactive:"Inactive",Detail:"Detail",Navigation:"Navigation",Active:"Active",DetailAndActive:"DetailAndActive"};t.SelectListKeyboardNavigationMode={None:"None",Delimited:"Delimited"};t.LoadState={Loading:"Loading",Loaded:"Loaded",Failed:"Failed",Disabled:"Disabled"};t.MenuButtonMode={Regular:"Regular",Split:"Split"};t.OverflowToolbarPriority={NeverOverflow:"NeverOverflow",Never:"Never",High:"High",Low:"Low",Disappear:"Disappear",AlwaysOverflow:"AlwaysOverflow",Always:"Always"};t.ObjectHeaderPictureShape={Circle:"Circle",Square:"Square"};t.P13nPanelType={sort:"sort",filter:"filter",group:"group",columns:"columns",dimeasure:"dimeasure",selection:"selection"};t.P13nConditionOperation={BT:"BT",EQ:"EQ",Contains:"Contains",StartsWith:"StartsWith",EndsWith:"EndsWith",LT:"LT",LE:"LE",GT:"GT",GE:"GE",Initial:"Initial",Empty:"Empty",NotEmpty:"NotEmpty",Ascending:"Ascending",Descending:"Descending",GroupAscending:"GroupAscending",GroupDescending:"GroupDescending",Total:"Total",Average:"Average",Minimum:"Minimum",Maximum:"Maximum"};t.PageBackgroundDesign={Standard:"Standard",List:"List",Solid:"Solid",Transparent:"Transparent"};t.PanelAccessibleRole={Complementary:"Complementary",Form:"Form",Region:"Region"};t.PDFViewerDisplayType={Auto:"Auto",Embedded:"Embedded",Link:"Link"};t.PlacementType={Left:"Left",Right:"Right",Top:"Top",Bottom:"Bottom",Vertical:"Vertical",VerticalPreferedTop:"VerticalPreferedTop",VerticalPreferredTop:"VerticalPreferredTop",VerticalPreferedBottom:"VerticalPreferedBottom",VerticalPreferredBottom:"VerticalPreferredBottom",Horizontal:"Horizontal",HorizontalPreferedRight:"HorizontalPreferedRight",HorizontalPreferredRight:"HorizontalPreferredRight",HorizontalPreferedLeft:"HorizontalPreferedLeft",HorizontalPreferredLeft:"HorizontalPreferredLeft",PreferredLeftOrFlip:"PreferredLeftOrFlip",PreferredRightOrFlip:"PreferredRightOrFlip",PreferredTopOrFlip:"PreferredTopOrFlip",PreferredBottomOrFlip:"PreferredBottomOrFlip",Auto:"Auto"};t.QuickViewGroupElementType={phone:"phone",mobile:"mobile",email:"email",link:"link",text:"text",pageLink:"pageLink"};t.VerticalPlacementType={Top:"Top",Bottom:"Bottom",Vertical:"Vertical"};t.PopinDisplay={Block:"Block",Inline:"Inline",WithoutHeader:"WithoutHeader"};t.PopinLayout={Block:"Block",GridSmall:"GridSmall",GridLarge:"GridLarge"};t.Sticky={ColumnHeaders:"ColumnHeaders",HeaderToolbar:"HeaderToolbar",InfoToolbar:"InfoToolbar"};t.RatingIndicatorVisualMode={Full:"Full",Half:"Half"};t.ScreenSize={Phone:"Phone",Tablet:"Tablet",Desktop:"Desktop",XXSmall:"XXSmall",XSmall:"XSmall",Small:"Small",Medium:"Medium",Large:"Large",XLarge:"XLarge",XXLarge:"XXLarge"};t.SelectionDetailsActionLevel={Item:"Item",List:"List",Group:"Group"};t.SelectType={Default:"Default",IconOnly:"IconOnly"};t.SplitAppMode={ShowHideMode:"ShowHideMode",StretchCompressMode:"StretchCompressMode",PopoverMode:"PopoverMode",HideMode:"HideMode"};t.StandardTileType={Create:"Create",Monitor:"Monitor",None:"None"};t.semantic=t.semantic||{};t.semantic.SemanticRuleSetType={Classic:"Classic",Optimized:"Optimized"};t.ObjectMarkerType={Flagged:"Flagged",Favorite:"Favorite",Draft:"Draft",Locked:"Locked",Unsaved:"Unsaved",LockedBy:"LockedBy",UnsavedBy:"UnsavedBy"};t.ObjectMarkerVisibility={IconOnly:"IconOnly",TextOnly:"TextOnly",IconAndText:"IconAndText"};t.SwipeDirection={LeftToRight:"LeftToRight",RightToLeft:"RightToLeft",BeginToEnd:"BeginToEnd",EndToBegin:"EndToBegin",Both:"Both"};t.SwitchType={Default:"Default",AcceptReject:"AcceptReject"};t.TokenizerRenderMode={Loose:"Loose",Narrow:"Narrow"};t.ToolbarDesign={Auto:"Auto",Transparent:"Transparent",Info:"Info",Solid:"Solid"};t.ToolbarStyle={Standard:"Standard",Clear:"Clear"};t.TimePickerMaskMode={On:"On",Off:"Off"};t.StringFilterOperator={Equals:"Equals",Contains:"Contains",StartsWith:"StartsWith",AnyWordStartsWith:"AnyWordStartsWith"};t.LightBoxLoadingStates={Loading:"LOADING",Loaded:"LOADED",TimeOutError:"TIME_OUT_ERROR",Error:"ERROR"};t.StepInputValidationMode={FocusOut:"FocusOut",LiveChange:"LiveChange"};t.StepInputStepModeType={AdditionAndSubtraction:"AdditionAndSubtraction",Multiple:"Multiple"};t.UploadState={Complete:"Complete",Error:"Error",Ready:"Ready",Uploading:"Uploading"};t.WrappingType={Normal:"Normal",Hyphenated:"Hyphenated"};t.PlanningCalendarStickyMode={None:"None",All:"All",NavBarAndColHeaders:"NavBarAndColHeaders"};t.TitleAlignment={Auto:"Auto",Start:"Start",Center:"Center"};t.AvatarShape=A;t.AvatarSize=h;t.AvatarType=n;t.AvatarColor=o;t.AvatarImageFitType=p;sap.ui.lazyRequire("sap.m.MessageToast","show");sap.ui.lazyRequire("sap.m.routing.RouteMatchedHandler");sap.ui.lazyRequire("sap.m.routing.Router");sap.ui.lazyRequire("sap.m.routing.Target");sap.ui.lazyRequire("sap.m.routing.TargetHandler");sap.ui.lazyRequire("sap.m.routing.Targets");if(D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf"){sap.ui.requireSync("sap/m/ios7");}if(/sap-ui-xx-formfactor=compact/.test(location.search)){q("html").addClass("sapUiSizeCompact");t._bSizeCompact=true;}if(/sap-ui-xx-formfactor=condensed/.test(location.search)){q("html").addClass("sapUiSizeCondensed");t._bSizeCondensed=true;}
t.getInvalidDate=function(){return null;};
t.getLocale=function(){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();t.getLocale=function(){return l;};return l;};
t.getLocaleData=function(){var l=sap.ui.requireSync("sap/ui/core/LocaleData").getInstance(t.getLocale());t.getLocaleData=function(){return l;};return l;};
t.isDate=function(v){return v&&Object.prototype.toString.call(v)=="[object Date]"&&!isNaN(v);};
t.getIScroll=function(c){if(typeof window.iScroll!="function"||!(c instanceof C)){return;}var i,s;for(i=c;i=i.oParent;){s=i.getScrollDelegate?i.getScrollDelegate()._scroller:null;if(s&&s instanceof window.iScroll){return s;}}};
t.getScrollDelegate=function(i,G){if(!(i instanceof C)){return;}var U=sap.ui.require("sap/ui/core/UIComponent");function j(c){if(!c){return;}return G&&U&&(c instanceof U)?c.oContainer:c.oParent;}for(var k=i;k=j(k);){if(k&&typeof k.getScrollDelegate=="function"){return k.getScrollDelegate(i);}}};
t.ScreenSizes={phone:240,tablet:600,desktop:1024,xxsmall:240,xsmall:320,small:480,medium:560,large:768,xlarge:960,xxlarge:1120};f(t,"BaseFontSize",function(){t.BaseFontSize=q(document.documentElement).css("font-size")||"16px";return t.BaseFontSize;});
t.closeKeyboard=function(){var c=document.activeElement;if(!D.system.desktop&&c&&/(INPUT|TEXTAREA)/i.test(c.tagName)){c.blur();}};
t.touch=t.touch||{};
t.touch.find=function(T,c){var i,j;if(!T){return;}if(c&&typeof c.identifier!=="undefined"){c=c.identifier;}else if(typeof c!=="number"){e(false,"sap.m.touch.find(): oTouch must be a touch object or a number");return;}j=T.length;for(i=0;i<j;i++){if(T[i].identifier===c){return T[i];}}};
t.touch.countContained=function(T,v){var i,c=0,j,k,$;if(!T){return 0;}if(v instanceof Element){v=q(v);}else if(typeof v==="string"){v=q(document.getElementById(v));}else if(!(v instanceof q)){e(false,"sap.m.touch.countContained(): vElement must be a jQuery object or Element reference or a string");return 0;}k=v.children().length;j=T.length;for(i=0;i<j;i++){$=q(T[i].target);if((k===0&&$.is(v))||(v[0].contains($[0]))){c++;}}return c;};
t.URLHelper=(function(){function i(v){return v&&Object.prototype.toString.call(v)=="[object String]";}function c(T){if(!i(T)){return"";}return T.replace(/[^0-9\+\*#]/g,"");}function j(T){if(!i(T)){return"";}T=T.split(/\r\n|\r|\n/g).join("\r\n");return encodeURIComponent(T);}return q.extend(new E(),{normalizeTel:function(T){return"tel:"+c(T);},normalizeSms:function(T){return"sms:"+c(T);},normalizeEmail:function(s,S,B,k,l){var P=[],u="mailto:",m=encodeURIComponent;i(s)&&(u+=m(q.trim(s)));i(S)&&P.push("subject="+m(S));i(B)&&P.push("body="+j(B));i(l)&&P.push("bcc="+m(q.trim(l)));i(k)&&P.push("cc="+m(q.trim(k)));if(P.length){u+="?"+P.join("&");}return u;},redirect:function(u,N){e(i(u),this+"#redirect: URL must be a string");this.fireEvent("redirect",u);if(!N){window.location.href=u;}else{var w=window.open(u,"_blank");if(!w){L.error(this+"#redirect: Could not open "+u);if(D.os.windows_phone||(D.browser.edge&&D.browser.mobile)){L.warning("URL will be enforced to open in the same window as a fallback from a known Windows Phone system restriction. Check the documentation for more information.");window.location.href=u;}}}},attachRedirect:function(F,l){return this.attachEvent("redirect",F,l);},detachRedirect:function(F,l){return this.detachEvent("redirect",F,l);},triggerTel:function(T){this.redirect(this.normalizeTel(T));},triggerSms:function(T){this.redirect(this.normalizeSms(T));},triggerEmail:function(s,S,B,k,l){this.redirect(this.normalizeEmail.apply(0,arguments));},toString:function(){return"sap.m.URLHelper";}});}());t.BackgroundHelper={addBackgroundColorStyles:function(r,B,s,c){r.class(c||"sapUiGlobalBackgroundColor");if(B&&!a.getType("sap.ui.core.CSSColor").isValid(B)){L.warning(B+" is not a valid sap.ui.core.CSSColor type");B="";}if(B||s){r.style("background-image","none");r.style("filter","none");}if(B){r.style("background-color",B);}},renderBackgroundImageTag:function(r,c,v,B,R,j){r.openStart("div",c.getId()+"-BG");if(Array.isArray(v)){for(var i=0;i<v.length;i++){r.class(v[i]);}}else{r.class(v);}r.class("sapUiGlobalBackgroundImage");if(B){r.style("display","block");r.style("background-image","url("+g(B)+")");r.style("background-repeat",R?"repeat":"no-repeat");if(!R){r.style("background-size","cover");r.style("background-position","center");}else{r.style("background-position","left top");}}if(j!==1){if(j>1){j=1;}r.style("opacity",j);}r.openEnd();r.close("div");}};t.ImageHelper=(function(){function c(j,k,v){if(v!==undefined){var s=j["set"+d(k)];if(typeof(s)==="function"){s.call(j,v);return true;}}return false;}var i={getImageControl:function(I,j,P,m,r,s){e(m.src,"sap.m.ImageHelper.getImageControl: mProperties do not contain 'src'");if(j&&(j.getSrc()!=m.src)){j.destroy();j=undefined;}if(j&&(j instanceof sap.m.Image||j instanceof sap.ui.core.Icon)){for(var u in m){c(j,u,m[u]);}}else{var v=sap.ui.require("sap/m/Image")||sap.ui.requireSync("sap/m/Image");var S=Object.assign({},m,{id:I});j=sap.ui.core.IconPool.createControlByURI(S,v);j.setParent(P,null,true);}if(s){for(var l=0,w=s.length;l!==w;l++){j.removeStyleClass(s[l]);}}if(r){for(var k=0,x=r.length;k!==x;k++){j.addStyleClass(r[k]);}}return j;}};return i;}());t.PopupHelper={calcPercentageSize:function(P,B){if(typeof P!=="string"){L.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+P+"isn't with type string");return null;}if(P.indexOf("%")<=0){L.warning("sap.m.PopupHelper: calcPercentageSize, the first parameter"+P+"is not a percentage string (for example '25%')");return null;}var c=parseFloat(P)/100,i=parseFloat(B);return Math.floor(c*i)+"px";}};t.InputODataSuggestProvider=(function(){var _=function(i){var j=i.getSource();var v=j.data(j.getId()+"-#valueListAnnotation");var m=j.getModel();var k=j.getBinding("value");var s=m.resolve(k.getPath(),k.getContext());if(!v){return;}var r=i.getParameter("selectedRow");q.each(r.getCells(),function(l,u){var w=u.getBinding("text");q.each(v.outParameters,function(K,x){if(!x.displayOnly&&x.value==w.getPath()){var V=w.getValue();var y=m.resolve(K,k.getContext());if(V&&y!==s){m.setProperty(y,V);}}});});return true;};var c=function(l,r){var M=l.getModel();var s=M.oMetadata;var P=M.resolve(l.getBindingPath("value"),l.getBindingContext());var v={};v.searchSupported=false;v.collectionPath="";v.outParameters={};v.inParameters={};v.selection=[];var u=M.getProperty(P+"/#com.sap.vocabularies.Common.v1.ValueList");if(!u){return false;}var w=P.substr(P.lastIndexOf("/")+1);v.inProperty=w;q.each(u.record,function(i,x){q.each(x,function(j,y){if(y.property==="SearchSupported"&&y.bool){v.searchSupported=true;}if(y.property==="CollectionPath"){v.collectionPath=y.string;}if(y.property==="Parameters"){q.each(y.collection.record,function(k,R){if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterIn"){var z;q.each(R.propertyValue,function(m,B){if(B.property==="LocalDataProperty"){z=B.propertyPath;}});q.each(R.propertyValue,function(m,B){if(B.property==="ValueListProperty"){v.inParameters[z]={value:B.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterInOut"){var z;q.each(R.propertyValue,function(m,B){if(B.property==="LocalDataProperty"){z=B.propertyPath;}});q.each(R.propertyValue,function(m,B){if(B.property==="ValueListProperty"){v.outParameters[z]={value:B.string};v.inParameters[z]={value:B.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterOut"){var z;q.each(R.propertyValue,function(m,B){if(B.property==="LocalDataProperty"){z=B.propertyPath;}});q.each(R.propertyValue,function(m,B){if(B.property==="ValueListProperty"){v.outParameters[z]={value:B.string};}});}else if(R.type==="com.sap.vocabularies.Common.v1.ValueListParameterDisplayOnly"){var z;q.each(R.propertyValue,function(m,B){if(B.property==="ValueListProperty"){v.outParameters[B.string]={value:B.string,displayOnly:true};}});}});}});});v.resultEntity=s._getEntityTypeByPath("/"+v.collectionPath);v.listItem=new sap.m.ColumnListItem();q.each(v.outParameters,function(k,i){v.listItem.addCell(new sap.m.Text({text:"{"+i.value+"}",wrapping:false}));l.addSuggestionColumn(new sap.m.Column({header:new sap.m.Text({text:"{/#"+v.resultEntity.name+"/"+i.value+"/@sap:label}",wrapping:false})}));v.selection.push(i.value);});l.data(l.getId()+"-#valueListAnnotation",v);if(r){l.attachSuggestionItemSelected(_);}};var I={suggest:function(i,r,R,l){var v,j=i.getSource();r=r===undefined?true:r;R=R===undefined?true:R;if(!j.data(j.getId()+"-#valueListAnnotation")){c(j,R);}v=j.data(j.getId()+"-#valueListAnnotation");if(!v){return;}var k=function(i){var B=this.getLength();if(B&&B<=l){j.setShowTableSuggestionValueHelp(false);}else{j.setShowTableSuggestionValueHelp(true);}};if(v.searchSupported){var F=[];var s,m={};if(r){q.each(v.inParameters,function(K,u){if(K==v.inProperty){s=u.value;}else if(r){var V=j.getModel().getProperty(K,j.getBinding("value").getContext());if(V){F.push(new sap.ui.model.Filter(u.value,sap.ui.model.FilterOperator.StartsWith,V));}}});}m.search=i.getParameter("suggestValue");if(v.inParameters.length){if(s){m["search-focus"]=s;}else{e(false,"no search-focus defined");}}j.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,length:l,filters:F,parameters:{select:v.selection.join(","),custom:m},events:{dataReceived:k},template:v.listItem});}else{var F=[];q.each(v.inParameters,function(K,u){if(K==v.inProperty){F.push(new sap.ui.model.Filter(u.value,sap.ui.model.FilterOperator.StartsWith,i.getParameter("suggestValue")));}else if(r){var V=j.getModel().getProperty(K,j.getBinding("value").getContext());if(V){F.push(new sap.ui.model.Filter(u.value,sap.ui.model.FilterOperator.StartsWith,V));}}});j.bindAggregation("suggestionRows",{path:"/"+v.collectionPath,filters:F,template:v.listItem,length:l,parameters:{select:v.selection.join(",")},events:{dataReceived:k}});}}};return I;}());O.set("sap.ui.layout.form.FormHelper",{createLabel:function(T,i){return new sap.m.Label(i,{text:T});},createButton:function(i,P,c){var j=this;var _=function(k){var l=new k(i,{type:t.ButtonType.Transparent});l.attachEvent("press",P,j);c.call(j,l);};var B=sap.ui.require("sap/m/Button");if(B){_(B);}else{sap.ui.require(["sap/m/Button"],_);}},setButtonContent:function(B,T,s,i,I){B.setText(T);B.setTooltip(s);B.setIcon(i);B.setActiveIcon(I);},addFormClass:function(){return"sapUiFormM";},setToolbar:function(T){var c=this.getToolbar();if(c&&c.setDesign){c.setDesign(c.getDesign(),true);}if(T&&T.setDesign){T.setDesign(sap.m.ToolbarDesign.Transparent,true);}return T;},getToolbarTitle:function(T){if(T){var c=T.getContent();for(var i=0;i<c.length;i++){var j=c[i];if(j.isA("sap.m.Title")){return j.getId();}}return T.getId();}},bArrowKeySupport:false,bFinal:true});O.set("sap.ui.unified.FileUploaderHelper",{createTextField:function(i){var T=new sap.m.Input(i);return T;},setTextFieldContent:function(T,w){T.setWidth(w);},createButton:function(i){var B=new sap.m.Button(i);return B;},addFormClass:function(){return"sapUiFUM";},bFinal:true});O.set("sap.ui.unified.ColorPickerHelper",{isResponsive:function(){return true;},factory:{createLabel:function(c){return new sap.m.Label(c);},createInput:function(i,c){return new sap.m.InputBase(i,c);},createSlider:function(i,c){return new sap.m.Slider(i,c);},createRadioButtonGroup:function(c){return new sap.m.RadioButtonGroup(c);},createRadioButtonItem:function(c){return new sap.m.RadioButton(c);},createButton:function(i,c){return new sap.m.Button(i,c);}},bFinal:true});O.set("sap.ui.table.TableHelper",{createLabel:function(c){return new sap.m.Label(c);},createTextView:function(c){return new sap.m.Label(c);},addTableClass:function(){return"sapUiTableM";},bFinal:true});O.set("sap.ui.layout.GridHelper",{getLibrarySpecificClass:function(){return"";},bFinal:true});if(D.os.blackberry||D.os.android&&D.os.version>=4){q(window).on("resize",function(){var c=document.activeElement;var T=c?c.tagName:"";if(T=="INPUT"||T=="TEXTAREA"){setTimeout(function(){c.scrollIntoViewIfNeeded();},0);}});}if(!Number.MAX_SAFE_INTEGER){Number.MAX_SAFE_INTEGER=Math.pow(2,53)-1;}return t;});
sap.ui.predefine('sap/m/plugins/DataStateIndicator',["./PluginBase","sap/ui/core/Core","sap/ui/base/ManagedObjectObserver"],function(P,C,M){"use strict";
var D=P.extend("sap.m.plugins.DataStateIndicator",{metadata:{library:"sap.m",properties:{filter:{type:"function",invalidate:false},messageLinkText:{type:"string",visibility:"hidden"},messageLinkVisible:{type:"boolean",defaultValue:true,visibility:"hidden"}},events:{dataStateChange:{allowPreventDefault:true,parameters:{dataState:{type:"sap.ui.model.DataState"},filteredMessages:{type:"any[]"}}}}}});
D.prototype.setMessageLinkText=function(l){this.setProperty("messageLinkText",l,true);this._updateMessageLinkControl();return this;};
D.prototype.getMessageLinkText=function(){return this.getProperty("messageLinkText");};
D.prototype.setMessageLinkVisible=function(v){this.setProperty("messageLinkVisible",v,true);if(this._oLink){this._oLink.setVisible(v);}return this;};
D.prototype.getMessageLinkVisible=function(){return this.getProperty("messageLinkVisible");};
D.prototype.isApplicable=function(c){if(!c.addAriaLabelledBy||!P.prototype.isApplicable.apply(this,arguments)||!c.getMetadata().getAllPrivateAggregations()["_messageStrip"]||!this._getBindingName()){return false;}return true;};
D.prototype.onActivate=function(c){var b=this._getBindingName();var B=c.getBinding(b);if(B){B.attachAggregatedDataStateChange(this._onAggregatedDataStateChange,this);this._processDataState(B.getDataState());}this._oObserver=new M(this._observeChanges.bind(this));this._oObserver.observe(c,{bindings:[b]});};
D.prototype.onDeactivate=function(c){var b=this._getBindingName();var B=c.getBinding(b);if(B){B.detachAggregatedDataStateChange(this._onAggregatedDataStateChange,this);B.getDataState().getMessages().forEach(function(m){m.removeControlId(c.getId());});}if(this._oMessageStrip){this._oMessageStrip.destroy();this._oMessageStrip=null;}if(this._oLink){this._oLink.destroy();this._oLink=null;}this._oObserver.unobserve(c,{bindings:[b]});this._oObserver.destroy();this._oObserver=null;};
D.prototype.showMessage=function(t,T){if(!this.getEnabled()||!this.getControl()||(!t&&!this._oMessageStrip)){return;}if(this._oMessageStrip){this._oMessageStrip.setText(t).setType(T).setVisible(!!t);return;}sap.ui.require(["sap/m/MessageStrip"],function(a){var c=this.getControl();this._oMessageStrip=new a({showCloseButton:true,showIcon:true}).addStyleClass("sapUiTinyMargin");this._updateMessageLinkControl();c.setAggregation("_messageStrip",this._oMessageStrip);c.addAriaLabelledBy(this._oMessageStrip);this.showMessage(t,T);}.bind(this));};
D.prototype._updateMessageLinkControl=function(){if(!this._oMessageStrip){return;}var m=this.getMessageLinkText();if(!m){this._oMessageStrip.setLink(null);return;}else if(this._oLink){this._oLink.setText(m);this._oMessageStrip.setLink(this._oLink);}if(!this._oLink){sap.ui.require(["sap/m/Link"],function(L){this._oLink=new L({text:m,visible:this.getMessageLinkVisible(),press:[function(){this.fireEvent("messageLinkPressed");},this]});this._oMessageStrip.setLink(this._oLink);}.bind(this));}};
D.prototype.refresh=function(){if(this.isActive()){var b=this._getBindingName();var B=this.getControl().getBinding(b);if(B){this._processDataState(B.getDataState());}}};
D.prototype._getBindingName=function(){return this.getControlPluginConfig("defaultBindingName");};
D.prototype._translate=function(b){var B="DATASTATE_"+b;var m=this.getControl().getMetadata();var l=m.getLibraryName();var c=m.getName().split(".").pop().toUpperCase();var r=C.getLibraryResourceBundle(l);var s=c+"_"+B;if(r.hasText(s)){return r.getText(s);}if(l=="sap.m"){return r.getText(B);}return C.getLibraryResourceBundle("sap.m").getText(B);};
D.prototype._getCombinedType=function(m){if(m&&m.length){var t={None:0,Information:1,Success:2,Warning:4,Error:8};var s=0;m.forEach(function(o){s|=t[o.getType()];});if(s&t.Error&&s&t.Warning){return"Issue";}else if(s&t.Error){return"Error";}else if(s&t.Warning){return"Warning";}else if(s&t.Success||s&t.Information){return"Notification";}}return"";};
D.prototype._processDataState=function(d){if(!d||!d.getChanges().messages){return;}var m=d.getMessages();var c=this.getControl();var f=this.getFilter();if(f){m=m.filter(function(o){return f(o,c);});}if(!this.fireDataStateChange({dataState:d,filteredMessages:m})){return;}if(m.length){var F=m[0];var b=this._getBindingName();var B=c.getBinding(b).getPath();var u=false;var s="";var a="";m.forEach(function(o){if(o.getControlIds().indexOf(c.getId())==-1){o.addControlId(c.getId());u=true;}});if(m.length==1&&F.getTarget()&&F.getTarget().endsWith(B)){a=F.getMessage();}else{s=this._getCombinedType(m);if(s){a=this._translate(s.toUpperCase());}}this.showMessage(a,F.getType());if(u){C.getMessageManager().getMessageModel().checkUpdate(false,true);}}else{this.showMessage("");}};
D.prototype._onAggregatedDataStateChange=function(e){this._processDataState(e.getParameter("dataState"));};
D.prototype._observeChanges=function(c){var b=c.bindingInfo.binding;if(b){var o=(c.mutation=="ready")?"attach":"detach";b[o+"AggregatedDataStateChange"](this._onAggregatedDataStateChange,this);}};
P.setConfig({"sap.m.ListBase":{defaultBindingName:"items"},"sap.ui.table.Table":{defaultBindingName:"rows"}},D);return D;});
sap.ui.predefine('sap/m/plugins/PluginBase',["sap/ui/core/Element"],function(E){"use strict";
var P=E.extend("sap.m.plugins.PluginBase",{metadata:{"abstract":true,library:"sap.m",properties:{enabled:{type:"boolean",defaultValue:true}}}});
var p={};
P.setConfig=function(c,v){var s=(typeof v=="function")?v.getMetadata().getName():P.getMetadata().getName();Object.assign(p[s]=p[s]||{},c);};
P.prototype.init=function(){this._bIsActive=false;};
P.prototype.isActive=function(){return this._bIsActive;};
P.prototype.getControl=function(){return this.getParent();};
P.prototype.getControlPluginConfig=function(k,d){var c=this.getControl();if(!c){return d;}var s=this.getMetadata().getName();var C=c.getMetadata().getName();var m=p[s]||{};var a=m[C]||{};if(k in a){return a[k];}for(var b in m){if(c.isA(b)&&k in m[b]){return m[b][k];}}var e=P.getMetadata().getName();var g=p[e]||{};var G=g[C]||{};if(k in G){return G[k];}for(var b in g){if(c.isA(b)&&k in g[b]){return g[b][k];}}return d;};
P.prototype.isApplicable=function(c){return c.isA("sap.ui.core.Control");};
P.prototype.onActivate=function(c){};
P.prototype.onDeactivate=function(c){};
P.prototype.setParent=function(o){var e=this.getEnabled();if(e&&this.getControl()){this._deactivate();}E.prototype.setParent.apply(this,arguments);if(o&&e){if(!this.isApplicable(o)){throw new Error(this+" is not applicable to "+o);}else{this._activate();}}return this;};
P.prototype.setEnabled=function(e){var o=this.getEnabled();this.setProperty("enabled",e,true);var n=this.getEnabled();if(n!=o&&this.getControl()){if(n){this._activate();}else{this._deactivate();}}return this;};
P.prototype.setProperty=function(s,v,S){S=S||(this.getMetadata().getProperty(s).appData||{}).invalidate===false;return E.prototype.setProperty.call(this,s,v,S);};
P.prototype._activate=function(){if(!this.isActive()){this.onActivate(this.getControl());this._bIsActive=true;}};
P.prototype._deactivate=function(){if(this.isActive()){this.onDeactivate(this.getControl());this._bIsActive=false;}};
return P;});
sap.ui.predefine('sap/m/routing/RouteMatchedHandler',['sap/ui/base/Object','./TargetHandler','./Router',"sap/base/Log"],function(B,T,M,L){"use strict";
var R=B.extend("sap.m.routing.RouteMatchedHandler",{constructor:function(r,c){if(r instanceof M){L.warning("A sap.m.routing.Router is used together with an sap.m.routing.RouteMatchedHandler (deprecated)."+"The RoutematchedHandler is not taking over triggering the navigations, the Router will do it.",this);return;}this._oTargetHandler=new T(c);r._oTargetHandler=this._oTargetHandler;r.attachRouteMatched(this._onHandleRouteMatched,this);r.attachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oTargets=r.getTargets();if(this._oTargets){this._oTargets.attachDisplay(this._onHandleDisplay,this);}this._oRouter=r;}});
R.prototype.destroy=function(){if(this._oRouter){this._oRouter.detachRouteMatched(this._onHandleRouteMatched,this);this._oRouter.detachRoutePatternMatched(this._handleRoutePatternMatched,this);this._oRouter=null;}if(this._oTargets){this._oTargets.detachDisplay(this._onHandleRouteMatched,this);this._oTargets=null;}return this;};
R.prototype.setCloseDialogs=function(c){this._oTargetHandler.setCloseDialogs(c);return this;};
R.prototype.getCloseDialogs=function(){return this._oTargetHandler.getCloseDialogs();};
R.prototype._handleRoutePatternMatched=function(e){var t=+e.getParameter("config").viewLevel;this._oTargetHandler.navigate({viewLevel:t,navigationIdentifier:e.getParameter("name"),askHistory:true});};
R.prototype._onHandleRouteMatched=function(e){var p=e.getParameters(),c=p.config;if(!this._oRouter.getRoute(p.name)._oTarget){return;}this._oTargetHandler.addNavigation({targetControl:p.targetControl,eventData:p.arguments,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
R.prototype._onHandleDisplay=function(e){var p=e.getParameters(),c=p.config;this._oTargetHandler.addNavigation({targetControl:p.control,eventData:p.data,view:p.view,navigationIdentifier:p.name,transition:c.transition,transitionParameters:c.transitionParameters,preservePageInSplitContainer:c.preservePageInSplitContainer});};
return R;});
sap.ui.predefine('sap/m/routing/Router',['sap/ui/core/routing/Router','./TargetHandler','./Targets'],function(R,T,a){"use strict";
var M=R.extend("sap.m.routing.Router",{
constructor:function(){this._oTargetHandler=new T();R.prototype.constructor.apply(this,arguments);},
destroy:function(){R.prototype.destroy.apply(this,arguments);this._oTargetHandler.destroy();this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_createTargets:function(c,t){return new a({views:this._oViews,config:c,targets:t,targetHandler:this._oTargetHandler});},
fireRouteMatched:function(A){var r=this.getRoute(A.name),t;if(r._oTarget){t=r._oTarget._oOptions;this._oTargetHandler.addNavigation({navigationIdentifier:A.name,transition:t.transition,transitionParameters:t.transitionParameters,eventData:A.arguments,targetControl:A.targetControl,view:A.view,preservePageInSplitContainer:t.preservePageInSplitContainer});}return R.prototype.fireRouteMatched.apply(this,arguments);},
fireRoutePatternMatched:function(A){var r=A.name,o=this.getRoute(r),v;if(o._oTarget){if(this._oTargets&&this._oTargets._oLastDisplayedTarget){v=this._oTargets._getViewLevel(this._oTargets._oLastDisplayedTarget);}this._oTargetHandler.navigate({navigationIdentifier:r,viewLevel:v,askHistory:true});}return R.prototype.fireRoutePatternMatched.apply(this,arguments);}
});
return M;});
sap.ui.predefine('sap/m/routing/Target',['sap/ui/core/routing/Target','./async/Target','./sync/Target',"sap/base/Log","sap/base/util/UriParameters"],function(T,a,s,L,U){"use strict";
var M=T.extend("sap.m.routing.Target",{constructor:function(o,v,p,t){this._oTargetHandler=t;function c(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTarget");return true;}return false;}if(o._async===undefined){o._async=c();}T.prototype.constructor.apply(this,arguments);var b=o._async?a:s;this._super={};for(var f in b){this._super[f]=this[f];this[f]=b[f];}}});
return M;});
sap.ui.predefine('sap/m/routing/TargetHandler',['sap/m/InstanceManager','sap/m/NavContainer','sap/m/SplitContainer','sap/ui/base/Object','sap/ui/core/routing/History','sap/ui/Device',"sap/base/Log"],function(I,N,S,B,H,D,L){"use strict";
var T=B.extend("sap.m.routing.TargetHandler",{constructor:function(c){this._aQueue=[];this._oNavigationOrderPromise=Promise.resolve();if(c===undefined){this._bCloseDialogs=true;}else{this._bCloseDialogs=!!c;}}});
T.prototype.setCloseDialogs=function(c){this._bCloseDialogs=!!c;return this;};
T.prototype.getCloseDialogs=function(){return this._bCloseDialogs;};
T.prototype.addNavigation=function(p){this._aQueue.push(p);};
T.prototype.navigate=function(d){var r=this._createResultingNavigations(d.navigationIdentifier),c=false,b=this._getDirection(d),n;while(r.length){n=this._applyNavigationResult(r.shift().oParams,b);c=c||n;}if(c){this._closeDialogs();}};
T.prototype._chainNavigation=function(n){this._oNavigationOrderPromise=this._oNavigationOrderPromise.then(n);return this._oNavigationOrderPromise;};
T.prototype._getDirection=function(d){var t=d.viewLevel,h=H.getInstance(),b=false;if(d.direction==="Backwards"){b=true;}else if(isNaN(t)||isNaN(this._iCurrentViewLevel)||t===this._iCurrentViewLevel){if(d.askHistory){b=h.getDirection()==="Backwards";}}else{b=t<this._iCurrentViewLevel;}this._iCurrentViewLevel=t;return b;};
T.prototype._createResultingNavigations=function(n){var i,f,c,C,o,r=[],v,b,a,p,R;while(this._aQueue.length){f=false;c=this._aQueue.shift();C=c.targetControl;b=C instanceof S;a=C instanceof N;v=c.view;o={oContainer:C,oParams:c,bIsMasterPage:(b&&!!C.getMasterPage(v.getId()))};p=b&&c.preservePageInSplitContainer&&C.getCurrentPage(o.bIsMasterPage)&&n!==c.navigationIdentifier;if(!(a||b)||!v){continue;}for(i=0;i<r.length;i++){R=r[i];if(R.oContainer!==C){continue;}if(a||D.system.phone){r.splice(i,1);r.push(o);f=true;break;}if(R.bIsMasterPage===o.bIsMasterPage){if(p){break;}r.splice(i,1);r.push(o);f=true;break;}}if(C instanceof S&&!D.system.phone){o.bIsMasterPage=!!C.getMasterPage(v.getId());}if(!f){if(!!C.getCurrentPage(o.bIsMasterPage)&&p){continue;}r.push(o);}}return r;};
T.prototype._applyNavigationResult=function(p,b){var t=p.targetControl,P,a=p.eventData,s=p.transition||"",o=p.transitionParameters,v=p.view.getId(),n=t instanceof S&&!!t.getMasterPage(v);if(t.getDomRef()&&t.getCurrentPage(n).getId()===v){L.info("navigation to view with id: "+v+" is skipped since it already is displayed by its targetControl","sap.m.routing.TargetHandler");return false;}L.info("navigation to view with id: "+v+" the targetControl is "+t.getId()+" backwards is "+b);if(b){P=t.getPreviousPage(n);if(!P||P.getId()!==v){t.insertPreviousPage(v,s,a);}t.backToPage(v,a,o);}else{t.to(v,s,a,o);}return true;};
T.prototype._closeDialogs=function(){if(!this._bCloseDialogs){return;}if(I.hasOpenPopover()){I.closeAllPopovers();}if(I.hasOpenDialog()){I.closeAllDialogs();}if(I.hasOpenLightBox()){I.closeAllLightBoxes();}};
return T;});
sap.ui.predefine('sap/m/routing/Targets',['sap/ui/core/routing/Targets','./TargetHandler','./Target','./async/Targets','./sync/Targets',"sap/base/Log","sap/base/util/UriParameters"],function(T,a,b,c,s,L,U){"use strict";
var M=T.extend("sap.m.routing.Targets",{
constructor:function(o){if(!o.config){o.config={_async:false};}function d(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","MobileTargets");return true;}return false;}if(o.config._async===undefined){o.config._async=(o.config.async===undefined)?d():o.config.async;}if(o.targetHandler){this._oTargetHandler=o.targetHandler;}else{this._oTargetHandler=new a();this._bHasOwnTargetHandler=true;}T.prototype.constructor.apply(this,arguments);var e=o.config._async?c:s;this._super={};for(var f in e){this._super[f]=this[f];this[f]=e[f];}},
destroy:function(){T.prototype.destroy.apply(this,arguments);if(this._bHasOwnTargetHandler){this._oTargetHandler.destroy();}this._oTargetHandler=null;},
getTargetHandler:function(){return this._oTargetHandler;},
_constructTarget:function(o,p){return new b(o,this.getViews(),p,this._oTargetHandler);},
_getViewLevel:function(t){var v;do{v=t._oOptions.viewLevel;if(v!==undefined){return v;}t=t._oParent;}while(t);return v;}
});
return M;});
sap.ui.predefine('sap/m/routing/async/Target',[],function(){"use strict";return{_place:function(d){var p=this._super._place.apply(this,arguments),t=this;return this._oTargetHandler._chainNavigation(function(){return p.then(function(v){t._oTargetHandler.addNavigation({navigationIdentifier:t._oOptions._name,transition:t._oOptions.transition,transitionParameters:t._oOptions.transitionParameters,eventData:d,targetControl:v.control,view:v.view,preservePageInSplitContainer:t._oOptions.preservePageInSplitContainer});if(d){delete d.routeConfig;}return v;});});}};},true);
sap.ui.predefine('sap/m/routing/async/Targets',[],function(){"use strict";return{_display:function(){var v,n;this._oLastDisplayedTarget=null;var p=this._super._display.apply(this,arguments);return p.then(function(V){if(this._oLastDisplayedTarget){v=this._getViewLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({viewLevel:v,navigationIdentifier:n,askHistory:true});return V;}.bind(this));},_displaySingleTarget:function(t){var T=this.getTarget(t.name);return this._super._displaySingleTarget.apply(this,arguments).then(function(v){if(T){this._oLastDisplayedTarget=T;}return v;}.bind(this));}};},true);
sap.ui.predefine('sap/m/routing/sync/Target',[],function(){"use strict";return{_place:function(p,d){var r=this._super._place.apply(this,arguments);this._oTargetHandler.addNavigation({navigationIdentifier:this._oOptions._name,transition:this._oOptions.transition,transitionParameters:this._oOptions.transitionParameters,eventData:d,targetControl:r.oTargetControl,view:r.oTargetParent,preservePageInSplitContainer:this._oOptions.preservePageInSplitContainer});if(d){delete d.routeConfig;}return r;}};},true);
sap.ui.predefine('sap/m/routing/sync/Targets',[],function(){"use strict";return{_display:function(){var v,n;this._oLastDisplayedTarget=null;var r=this._super._display.apply(this,arguments);if(this._oLastDisplayedTarget){v=this._getViewLevel(this._oLastDisplayedTarget);n=this._oLastDisplayedTarget._oOptions._name;}this._oTargetHandler.navigate({viewLevel:v,navigationIdentifier:n,askHistory:true});return r;},_displaySingleTarget:function(n){var t=this.getTarget(n);if(t){this._oLastDisplayedTarget=t;}return this._super._displaySingleTarget.apply(this,arguments);}};},true);
sap.ui.predefine('sap/m/semantic/AddAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var A=S.extend("sap.m.semantic.AddAction",{metadata:{library:"sap.m"}});
return A;});
sap.ui.predefine('sap/m/semantic/CancelAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var C=S.extend("sap.m.semantic.CancelAction",{metadata:{library:"sap.m"}});
return C;});
sap.ui.predefine('sap/m/semantic/DeleteAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DeleteAction",{metadata:{library:"sap.m"}});
return D;});
sap.ui.predefine('sap/m/semantic/DetailPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/library"],function(S,a,b,l){"use strict";var c=l.semantic.SemanticRuleSetType;
var D=S.extend("sap.m.semantic.DetailPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/semantic/DetailPage.designtime"},
renderer:b
});
D.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_DETAIL_PAGE_TITLE"));};
D.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return this;}return S.prototype.setAggregation.call(this,A,o,s);};
D.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
D.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
D.prototype.getSemanticRuleSet=function(){return c.Classic;};
return D;});
sap.ui.predefine('sap/m/semantic/DiscussInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var D=S.extend("sap.m.semantic.DiscussInJamAction",{metadata:{library:"sap.m"}});
return D;});
sap.ui.predefine('sap/m/semantic/EditAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var E=S.extend("sap.m.semantic.EditAction",{metadata:{library:"sap.m"}});
return E;});
sap.ui.predefine('sap/m/semantic/FavoriteAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FavoriteAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/FilterAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;});
sap.ui.predefine('sap/m/semantic/FilterSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FilterSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IFilter"]}});
return F;});
sap.ui.predefine('sap/m/semantic/FlagAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.FlagAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/ForwardAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var F=S.extend("sap.m.semantic.ForwardAction",{metadata:{library:"sap.m"}});
return F;});
sap.ui.predefine('sap/m/semantic/FullscreenPage',["sap/m/semantic/ShareMenuPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer"],function(S,a,b){"use strict";
var F=S.extend("sap.m.semantic.FullscreenPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},flagAction:{type:"sap.m.semantic.FlagAction",multiple:false},favoriteAction:{type:"sap.m.semantic.FavoriteAction",multiple:false},openInAction:{type:"sap.m.semantic.OpenInAction",multiple:false},discussInJamAction:{type:"sap.m.semantic.DiscussInJamAction",multiple:false},shareInJamAction:{type:"sap.m.semantic.ShareInJamAction",multiple:false},sendEmailAction:{type:"sap.m.semantic.SendEmailAction",multiple:false},sendMessageAction:{type:"sap.m.semantic.SendMessageAction",multiple:false},printAction:{type:"sap.m.semantic.PrintAction",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false},saveAsTileAction:{type:"sap.m.Button",multiple:false},pagingAction:{type:"sap.m.PagingButton",multiple:false},draftIndicator:{type:"sap.m.DraftIndicator",multiple:false}}},
renderer:b
});
F.prototype.setAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(o){this._addToInnerAggregation(o,a.getPositionInPage(A),a.getSequenceOrderIndex(A),s);this[p]=o;}else{if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p]=null;}}return;}S.prototype.setAggregation.call(this,A,o,s);};
F.prototype.getAggregation=function(A,o,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){return this['_'+A];}return S.prototype.getAggregation.call(this,A,o,s);};
F.prototype.destroyAggregation=function(A,s){if((A==="saveAsTileAction")||(A==="pagingAction")||(A==="draftIndicator")){var p='_'+A;if(this[p]){this._removeFromInnerAggregation(this[p],a.getPositionInPage(A),s);this[p].destroy();this[p]=null;}return this;}return S.prototype.destroyAggregation.call(this,A,s);};
return F;});
sap.ui.predefine('sap/m/semantic/GroupAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;});
sap.ui.predefine('sap/m/semantic/GroupSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var G=S.extend("sap.m.semantic.GroupSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.IGroup"]}});
return G;});
sap.ui.predefine('sap/m/semantic/MainAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MainAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return M;});
sap.ui.predefine('sap/m/semantic/MasterPage',["sap/m/semantic/SemanticPage","sap/m/semantic/SemanticPageRenderer","sap/m/library"],function(S,a,l){"use strict";var b=l.semantic.SemanticRuleSetType;
var M=S.extend("sap.m.semantic.MasterPage",{
metadata:{library:"sap.m",aggregations:{addAction:{type:"sap.m.semantic.AddAction",multiple:false},mainAction:{type:"sap.m.semantic.MainAction",multiple:false},positiveAction:{type:"sap.m.semantic.PositiveAction",multiple:false},negativeAction:{type:"sap.m.semantic.NegativeAction",multiple:false},multiSelectAction:{type:"sap.m.semantic.MultiSelectAction",multiple:false},forwardAction:{type:"sap.m.semantic.ForwardAction",multiple:false},editAction:{type:"sap.m.semantic.EditAction",multiple:false},saveAction:{type:"sap.m.semantic.SaveAction",multiple:false},deleteAction:{type:"sap.m.semantic.DeleteAction",multiple:false},cancelAction:{type:"sap.m.semantic.CancelAction",multiple:false},sort:{type:"sap.m.semantic.ISort",multiple:false},filter:{type:"sap.m.semantic.IFilter",multiple:false},group:{type:"sap.m.semantic.IGroup",multiple:false},messagesIndicator:{type:"sap.m.semantic.MessagesIndicator",multiple:false}}},
renderer:a
});
M.prototype.init=function(){S.prototype.init.call(this);this._getPage().getLandmarkInfo().setRootLabel(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_MASTER_PAGE_TITLE"));};
M.prototype.getSemanticRuleSet=function(){return b.Classic;};
return M;});
sap.ui.predefine('sap/m/semantic/MessagesIndicator',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MessagesIndicator",{metadata:{library:"sap.m"}});
return M;});
sap.ui.predefine('sap/m/semantic/MultiSelectAction',['sap/m/semantic/SemanticToggleButton'],function(S){"use strict";
var M=S.extend("sap.m.semantic.MultiSelectAction",{metadata:{library:"sap.m"}});
var b=sap.ui.getCore().getLibraryResourceBundle("sap.m");M._PRESSED_STATE_TO_ICON_MAP={"true":"sap-icon://sys-cancel","false":"sap-icon://multi-select"};M._ACC_TOOLTIP_TO_ICON_MAP={"true":b.getText("SEMANTIC_CONTROL_MULTI_SELECT_CANCEL"),"false":b.getText("SEMANTIC_CONTROL_MULTI_SELECT")};
M.prototype._setPressed=function(p,s){var i=M._PRESSED_STATE_TO_ICON_MAP[p];var I=M._ACC_TOOLTIP_TO_ICON_MAP[p];this._getControl().setIcon(i);this._getControl().setTooltip(I);};
return M;});
sap.ui.predefine('sap/m/semantic/NegativeAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var N=S.extend("sap.m.semantic.NegativeAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return N;});
sap.ui.predefine('sap/m/semantic/OpenInAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var O=S.extend("sap.m.semantic.OpenInAction",{metadata:{library:"sap.m"}});
return O;});
sap.ui.predefine('sap/m/semantic/PositiveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PositiveAction",{metadata:{library:"sap.m",properties:{text:{type:"string",group:"Misc",defaultValue:null}}}});
return P;});
sap.ui.predefine('sap/m/semantic/PrintAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var P=S.extend("sap.m.semantic.PrintAction",{metadata:{library:"sap.m"}});
return P;});
sap.ui.predefine('sap/m/semantic/SaveAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SaveAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/Segment',['sap/ui/base/Object',"sap/base/Log"],function(B,L){"use strict";
var S=B.extend("sap.m.semantic.Segment",{
constructor:function(C,o,s,f){if(!o){L.error("missing argumment: constructor expects a container reference",this);return;}C||(C=[]);this._aContent=C;this._oContainer=o;this._sContainerAggregationName=s;this._fnSortFunction=f;},
getInterface:function(){return this;}
});
S.prototype.getStartIndex=function(){return 0;};
S.prototype.getEndIndex=function(){return this.getStartIndex()+this._aContent.length;};
S.prototype.getContent=function(){return this._aContent.slice();};
S.prototype.indexOfContent=function(C){return this._aContent.indexOf(C);};
S.prototype.addContent=function(C,s){if(this._fnSortFunction){var i=this._matchSortToInsertIndex(C);if(typeof i!=='undefined'){this._insertContent(C,i,s);return C;}}var a=this.getEndIndex(),l=this._aContent.length,A="insert"+c(this._sContainerAggregationName);this._oContainer[A](C,a,s);this._aContent.splice(l,0,C);return C;};
S.prototype.insertContent=function(C,i,s){if(this._fnSortFunction){var I=this._matchSortToInsertIndex(C);if(typeof I!=='undefined'){this._insertContent(C,I,s);return C;}}return this._insertContent(C,i,s);};
S.prototype.removeContent=function(C,s){var l=this._aContent.indexOf(C),a="remove"+c(this._sContainerAggregationName);if(l>-1){this._aContent.splice(l,1);return this._oContainer[a](C,s);}};
S.prototype.removeAllContent=function(s){var r=[],g=this._oContainer.getAggregation(this._sContainerAggregationName),a=this.getStartIndex(),e=this.getEndIndex(),A="remove"+c(this._sContainerAggregationName);for(var i=a;i<e;i++){var I=this._oContainer[A](g[i],s);if(I){r.push(I);}}this._aContent=[];return r;};
S.prototype.destroy=function(s){var r=this.removeAllContent(s);for(var i=0;i<r.length;i++){r[i].destroy(s);}};
S.prototype._insertContent=function(C,i,s){var I=Math.min(this.getStartIndex()+i,this.getEndIndex()),a="insert"+c(this._sContainerAggregationName);I=Math.max(I,0);this._oContainer[a](C,I,s);this._aContent.splice(i,0,C);return C;};
S.prototype._matchSortToInsertIndex=function(C){for(var i=0;i<this._aContent.length;i++){if(this._fnSortFunction(C,this._aContent[i])<=0){return i;}}};
function c(n){return n.charAt(0).toUpperCase()+n.substring(1);}
return S;});
sap.ui.predefine('sap/m/semantic/SegmentedContainer',['sap/m/semantic/Segment','sap/ui/base/Object',"sap/base/Log"],function(S,B,L){"use strict";
var a=B.extend("sap.m.semantic.SegmentedContainer",{
constructor:function(c,C){if(!c){L.error("missing argumment: constructor expects a container reference",this);return;}this._oContainer=c;C||(C="content");this._sContainerAggregationName=C;this._aSegments=[];},
getInterface:function(){return this;}
});
a.prototype.addSection=function(o){if(!o||!o.sTag){L.error("missing argumment: section options expected",this);return;}if(o.aContent){var c=o.aContent;var l=c.length;for(var i=0;i<l;i++){this._oContainer.addAggregation(this._sContainerAggregationName,c[i]);}}var s=new S(c,this._oContainer,this._sContainerAggregationName,o.fnSortFunction);s.sTag=o.sTag;var b=this._aSegments;s.getStartIndex=function(){var d=0;var e=b.indexOf(this);if(e>0){var p=e-1;while(p>=0){d+=b[p].getContent().length;p--;}}return d;};this._aSegments.push(s);};
a.prototype.getSection=function(t){var s;this._aSegments.forEach(function(b){if(b.sTag===t){s=b;}});return s;};
a.prototype.destroy=function(s){this._oContainer.destroy(s);this.aSegments=null;};
a.prototype.getContainer=function(){return this._oContainer;};
return a;});
sap.ui.predefine('sap/m/semantic/SemanticButton',['sap/m/semantic/SemanticControl','sap/m/Button','sap/m/semantic/SemanticOverflowToolbarButton',"sap/ui/thirdparty/jquery"],function(S,B,a,q){"use strict";
var b=S.extend("sap.m.semantic.SemanticButton",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true}},events:{press:{}}}});
b.prototype._getControl=function(){var c,C,n,o=this._getConfiguration();if(!o){return null;}c=this.getAggregation('_control');if(!c){C=this._getClass(o);n=this._createInstance(C);n.applySettings(o.getSettings());if(typeof o.getEventDelegates==="function"){n.addEventDelegate(o.getEventDelegates(n));}this.setAggregation('_control',n,true);c=this.getAggregation('_control');}return c;};
b.prototype._getClass=function(c){return c&&c.constraints==="IconOnly"?a:B;};
b.prototype._createInstance=function(c){return new c({id:this.getId()+"-button",press:q.proxy(this.firePress,this)});};
return b;});
sap.ui.predefine('sap/m/semantic/SemanticConfiguration',["sap/ui/base/Object","sap/m/library","sap/m/OverflowToolbarLayoutData","sap/ui/core/IconPool","sap/ui/core/InvisibleText"],function(B,l,O,I,a){"use strict";var b=l.ButtonType;var P=l.PlacementType;var S=l.semantic.SemanticRuleSetType;var c=l.OverflowToolbarPriority;
var d=B.extend("sap.m.semantic.SemanticConfiguration",{getInterface:function(){return this;}});
d.prototype._PositionInPage={headerLeft:"headerLeft",headerRight:"headerRight",headerMiddle:"headerMiddle",footerLeft:"footerLeft",footerRight_IconOnly:"footerRight_IconOnly",footerRight_TextOnly:"footerRight_TextOnly",shareMenu:"shareMenu"};d._PageMode={display:"display",edit:"edit",multimode:"multimode"};
d.isKnownSemanticType=function(t){return d.getConfiguration(t)!=undefined;};
d.getConfiguration=function(t){return d._oTypeConfigs[t];};
d.getSettings=function(t){return d._oTypeConfigs[t].getSettings();};
d.getPositionInPage=function(t){return d._oTypeConfigs[t].position;};
d.getSequenceOrderIndex=function(t){return d._oTypeConfigs[t].order;};
d.getAriaId=function(t){return d._oTypeConfigs[t].getSettings().ariaLabelledBy;};
d.getShareMenuConfig=function(r){switch(r){case S.Classic:return{baseButtonPlacement:P.Bottom,actionSheetPlacement:P.Top};case S.Optimized:return{baseButtonPlacement:P.Top,actionSheetPlacement:P.Bottom};}};
d._oTypeConfigs=(function(){var t={},o=sap.ui.getCore().getLibraryResourceBundle("sap.m");t["sap.m.semantic.MultiSelectAction"]={position:d.prototype._PositionInPage.headerRight,getSettings:function(){return{icon:I.getIconURI("multi-select"),tooltip:o.getText("SEMANTIC_CONTROL_MULTI_SELECT")};}};t["sap.m.semantic.MainAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:b.Emphasized,layoutData:new O({priority:c.NeverOverflow})};},order:0};t["sap.m.semantic.EditAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.edit,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_EDIT"),type:b.Emphasized,layoutData:new O({priority:c.NeverOverflow})};},order:1};t["sap.m.semantic.SaveAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_SAVE"),type:b.Emphasized,layoutData:new O({priority:c.NeverOverflow})};},order:3};t["sap.m.semantic.DeleteAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_DELETE"),layoutData:new O({priority:c.NeverOverflow})};},order:4};t["sap.m.semantic.PositiveAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:b.Accept,layoutData:new O({priority:c.NeverOverflow})};},order:5};t["sap.m.semantic.NegativeAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{type:b.Reject,layoutData:new O({priority:c.NeverOverflow})};},order:6};t["sap.m.semantic.CancelAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,triggers:d._PageMode.display,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_CANCEL")};},order:7};t["sap.m.semantic.ForwardAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_FORWARD")};},order:8};t["sap.m.semantic.OpenInAction"]={position:d.prototype._PositionInPage.footerRight_TextOnly,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_OPEN_IN")};},order:9};t["sap.m.semantic.AddAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,triggers:d._PageMode.edit,getSettings:function(){return{icon:I.getIconURI("add"),text:o.getText("SEMANTIC_CONTROL_ADD"),tooltip:o.getText("SEMANTIC_CONTROL_ADD")};},order:0,constraints:"IconOnly"};t["sap.m.semantic.FavoriteAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("favorite"),text:o.getText("SEMANTIC_CONTROL_FAVORITE"),tooltip:o.getText("SEMANTIC_CONTROL_FAVORITE")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.FlagAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("flag"),text:o.getText("SEMANTIC_CONTROL_FLAG"),tooltip:o.getText("SEMANTIC_CONTROL_FLAG")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.ISort"]={position:d.prototype._PositionInPage.footerRight_IconOnly,order:3};t["sap.m.semantic.IFilter"]={position:d.prototype._PositionInPage.footerRight_IconOnly,order:4};t["sap.m.semantic.IGroup"]={position:d.prototype._PositionInPage.footerRight_IconOnly,order:5};t["sap.m.semantic.SortAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("sort"),text:o.getText("SEMANTIC_CONTROL_SORT"),tooltip:o.getText("SEMANTIC_CONTROL_SORT")};},constraints:"IconOnly"};t["sap.m.semantic.SortSelect"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("sort"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_SORT")};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":"listbox"});}.bind(C)};},constraints:"IconOnly"};t["sap.m.semantic.FilterAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("filter"),text:o.getText("SEMANTIC_CONTROL_FILTER"),tooltip:o.getText("SEMANTIC_CONTROL_FILTER")};},constraints:"IconOnly"};t["sap.m.semantic.FilterSelect"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("filter"),type:"IconOnly",autoAdjustWidth:true,tooltip:o.getText("SEMANTIC_CONTROL_FILTER")};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":"listbox"});}.bind(C)};},constraints:"IconOnly"};t["sap.m.semantic.GroupAction"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("group-2"),text:o.getText("SEMANTIC_CONTROL_GROUP"),tooltip:o.getText("SEMANTIC_CONTROL_GROUP")};},constraints:"IconOnly"};t["sap.m.semantic.GroupSelect"]={position:d.prototype._PositionInPage.footerRight_IconOnly,getSettings:function(){return{icon:I.getIconURI("group-2"),type:"IconOnly",autoAdjustWidth:true};},getEventDelegates:function(C){return{onAfterRendering:function(){this.$().attr({"aria-haspopup":"listbox"});}.bind(C)};},constraints:"IconOnly"};t["saveAsTileAction"]={position:d.prototype._PositionInPage.shareMenu,order:0,constraints:"IconOnly"};t["pagingAction"]={position:d.prototype._PositionInPage.headerRight};t["sap.m.semantic.DiscussInJamAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("discussion-2"),text:o.getText("SEMANTIC_CONTROL_DISCUSS_IN_JAM")};},order:1,constraints:"IconOnly"};t["sap.m.semantic.ShareInJamAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("share-2"),text:o.getText("SEMANTIC_CONTROL_SHARE_IN_JAM")};},order:2,constraints:"IconOnly"};t["sap.m.semantic.SendMessageAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("discussion"),text:o.getText("SEMANTIC_CONTROL_SEND_MESSAGE")};},order:3,constraints:"IconOnly"};t["sap.m.semantic.SendEmailAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("email"),text:o.getText("SEMANTIC_CONTROL_SEND_EMAIL")};},order:4,constraints:"IconOnly"};t["sap.m.semantic.PrintAction"]={position:d.prototype._PositionInPage.shareMenu,getSettings:function(){return{icon:I.getIconURI("print"),text:o.getText("SEMANTIC_CONTROL_PRINT")};},order:5,constraints:"IconOnly"};t["sap.m.semantic.MessagesIndicator"]={position:d.prototype._PositionInPage.footerLeft,getSettings:function(){var T=a.getStaticId("sap.m","SEMANTIC_CONTROL_MESSAGES_INDICATOR");return{icon:I.getIconURI("message-popup"),text:{path:"message>/",formatter:function(m){return m.length||0;}},tooltip:o.getText("SEMANTIC_CONTROL_MESSAGES_INDICATOR"),ariaLabelledBy:T,type:b.Emphasized,visible:{path:"message>/",formatter:function(m){return m&&m.length>0;}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new O({priority:c.NeverOverflow})};}};t["draftIndicator"]={position:d.prototype._PositionInPage.footerLeft,getSettings:function(){return{layoutData:new O({shrinkable:false})};},order:1};return t;})();return d;});
sap.ui.predefine('sap/m/semantic/SemanticControl',["sap/m/semantic/SemanticConfiguration","sap/ui/base/ManagedObject","sap/ui/core/Element","sap/ui/thirdparty/jquery"],function(S,M,E,q){"use strict";
var a=E.extend("sap.m.semantic.SemanticControl",{metadata:{library:"sap.m","abstract":true,properties:{visible:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{_control:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});
a.prototype.setProperty=function(k,v,s){M.prototype.setProperty.call(this,k,v,true);this._applyProperty(k,v,s);return this;};
a.prototype.updateAggregation=function(n){this._getControl().updateAggregation(n);};
a.prototype.refreshAggregation=function(n){this._getControl().refreshAggregation(n);};
a.prototype.setAggregation=function(A,o,s){if(A==='_control'){return M.prototype.setAggregation.call(this,A,o,s);}return this._getControl().setAggregation(A,o,s);};
a.prototype.getAggregation=function(A,d){if(A==='_control'){return M.prototype.getAggregation.call(this,A,d);}return this._getControl().getAggregation(A,d);};
a.prototype.indexOfAggregation=function(A,o){return this._getControl().indexOfAggregation(A,o);};
a.prototype.insertAggregation=function(A,o,i,s){return this._getControl().insertAggregation(A,o,i,s);};
a.prototype.addAggregation=function(A,o,s){return this._getControl().addAggregation(A,o,s);};
a.prototype.removeAggregation=function(A,o,s){return this._getControl().removeAggregation(A,o,s);};
a.prototype.removeAllAggregation=function(A,s){return this._getControl().removeAllAggregation(A,s);};
a.prototype.destroyAggregation=function(A,s){return this._getControl().destroyAggregation(A,s);};
a.prototype.bindAggregation=function(n,b){return this._getControl().bindAggregation(n,b);};
a.prototype.unbindAggregation=function(n,s){return this._getControl().unbindAggregation(n,s);};
a.prototype.clone=function(i,l){var c=E.prototype.clone.apply(this,arguments);var p=this._getControl().clone(i,l);c.setAggregation('_control',p);return c;};
a.prototype.destroy=function(){var r=E.prototype.destroy.apply(this,arguments);if(this.getAggregation("_control")){this.getAggregation("_control").destroy();}return r;};
a.prototype.getPopupAnchorDomRef=function(){return this._getControl().getDomRef();};
a.prototype.getDomRef=function(s){return this._getControl().getDomRef(s);};
a.prototype.addEventDelegate=function(d,t){q.each(d,function(e,c){if(typeof c==='function'){var p=function(o){o.srcControl=this;c.call(t,o);}.bind(this);d[e]=p;}}.bind(this));this._getControl().addEventDelegate(d,t);return this;};
a.prototype.removeEventDelegate=function(d){this._getControl().removeEventDelegate(d);return this;};
a.prototype._getConfiguration=function(){return S.getConfiguration(this.getMetadata().getName());};
a.prototype._onPageStateChanged=function(e){this._updateState(e.sId);};
a.prototype._updateState=function(s){if(this._getConfiguration()&&this._getControl()){var o=this._getConfiguration().states[s];if(o){this._getControl().applySettings(o);}}};
a.prototype._applyProperty=function(k,v,s){var b="set"+this._capitalize(k);this._getControl()[b](v,s);};
a.prototype._capitalize=function(n){return n.charAt(0).toUpperCase()+n.slice(1);};
return a;});
sap.ui.predefine('sap/m/semantic/SemanticOverflowToolbarButton',['sap/m/OverflowToolbarButton','sap/m/ButtonRenderer'],function(O,B){"use strict";
var S=O.extend("sap.m.semantic.SemanticOverflowToolbarButton",{
metadata:{library:"sap.m"},
renderer:B.render
});
S.prototype._getTooltip=function(){var t=O.prototype._getTooltip.call(this);if(!t&&!this._bInOverflow&&this.getText()){t=this.getText();}return t;};
return S;});
sap.ui.predefine('sap/m/semantic/SemanticOverflowToolbarToggleButton',["sap/m/OverflowToolbarToggleButton","sap/m/ToggleButtonRenderer"],function(O,T){"use strict";
var S=O.extend("sap.m.semantic.SemanticOverflowToolbarButton",{
metadata:{library:"sap.m"},
renderer:T.render
});
S.prototype._getTooltip=function(){var t=O.prototype._getTooltip.call(this);if(!t&&!this._bInOverflow&&this.getText()){t=this.getText();}return t;};
return S;});
sap.ui.predefine('sap/m/semantic/SemanticPage',['sap/m/semantic/SegmentedContainer','sap/m/semantic/SemanticConfiguration','sap/m/Button','sap/m/Title','sap/m/Page','sap/m/OverflowToolbar','sap/m/ToolbarSpacer','sap/m/Bar','sap/ui/core/CustomData','sap/ui/base/ManagedObject','sap/m/PageAccessibleLandmarkInfo','sap/ui/base/ManagedObjectObserver','sap/ui/core/Control','sap/ui/core/library','sap/m/library',"./SemanticPageRenderer","sap/base/Log","sap/ui/thirdparty/jquery"],function(S,a,B,T,P,O,b,c,C,M,d,e,f,g,l,h,L,q){"use strict";var i=l.ButtonType;var j=l.PageBackgroundDesign;var k=l.semantic.SemanticRuleSetType;var m=g.TitleLevel;
var n=f.extend("sap.m.semantic.SemanticPage",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null},titleLevel:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:m.Auto},showNavButton:{type:"boolean",group:"Appearance",defaultValue:false},showSubHeader:{type:"boolean",group:"Appearance",defaultValue:true},enableScrolling:{type:"boolean",group:"Behavior",defaultValue:true},showFooter:{type:"boolean",group:"Appearance",defaultValue:true},floatingFooter:{type:"boolean",group:"Appearance",defaultValue:false},semanticRuleSet:{type:"sap.m.semantic.SemanticRuleSetType",group:"Misc",defaultValue:k.Classic},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:j.Standard}},defaultAggregation:"content",aggregations:{subHeader:{type:"sap.m.IBar",multiple:false},content:{type:"sap.ui.core.Control",multiple:true,singularName:"content",forwarding:{getter:"_getPage",aggregation:"content"}},customHeaderContent:{type:"sap.m.Button",multiple:true,singularName:"customHeaderContent"},customFooterContent:{type:"sap.m.Button",multiple:true,singularName:"customFooterContent"},landmarkInfo:{type:"sap.m.PageAccessibleLandmarkInfo",multiple:false,forwarding:{getter:"_getPage",aggregation:"landmarkInfo"}},_page:{type:"sap.m.Page",multiple:false,visibility:"hidden"}},events:{navButtonPress:{}},dnd:{draggable:false,droppable:true},designtime:"sap/m/designtime/semantic/SemanticPage.designtime"}});
n.prototype.init=function(){this._oHeaderObserver=new e(n.prototype._updateHeaderVisibility.bind(this));this._currentMode=a._PageMode.display;this._getPage().setCustomHeader(this._getInternalHeader());this._getPage().setFooter(new O(this.getId()+"-footer"));this.setLandmarkInfo(new d());this._getPage().setShowHeader(false);};
n.prototype.exit=function(){if(this._oInternalHeader){this._oInternalHeader.destroy();this._oInternalHeader=null;}if(this._oWrappedFooter){this._oWrappedFooter.destroy();this._oWrappedFooter=null;}if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oNavButton){this._oNavButton.destroy();this._oNavButton=null;}if(this._oHeaderObserver){this._oHeaderObserver.disconnect();this._oHeaderObserver=null;}this._oPositionsMap=null;};
n.prototype.setSubHeader=function(p,r){this._getPage().setSubHeader(p,r);return this;};
n.prototype.getSubHeader=function(){return this._getPage().getSubHeader();};
n.prototype.destroySubHeader=function(p){this._getPage().destroySubHeader(p);return this;};
n.prototype.getShowSubHeader=function(){return this._getPage().getShowSubHeader();};
n.prototype.setShowSubHeader=function(p,r){this._getPage().setShowSubHeader(p,r);this.setProperty("showSubHeader",p,true);return this;};
n.prototype.getShowFooter=function(){return this._getPage().getShowFooter();};
n.prototype.setShowFooter=function(p,r){this._getPage().setShowFooter(p,r);this.setProperty("showFooter",p,true);return this;};
n.prototype.setFloatingFooter=function(F,p){this._getPage().setFloatingFooter(F,p);this.setProperty("floatingFooter",F,true);return this;};
n.prototype.setTitle=function(t){var p=this._getTitle();if(p){p.setText(t);if(!p.getParent()){this._getInternalHeader().addContentMiddle(p);}}this.setProperty("title",t,true);return this;};
n.prototype.setTitleLevel=function(t){this.setProperty("titleLevel",t,true);this._getTitle().setLevel(t);return this;};
n.prototype.setShowNavButton=function(p){var r=this._getNavButton();if(r){r.setVisible(p);if(!r.getParent()){this._getInternalHeader().addContentLeft(r);}}this.setProperty("showNavButton",p,true);return this;};
n.prototype.setEnableScrolling=function(E){this._getPage().setEnableScrolling(E);this.setProperty("enableScrolling",E,true);return this;};
n.prototype.setBackgroundDesign=function(p){this.setProperty("backgroundDesign",p,true);this._getPage().setBackgroundDesign(p);return this;};
n.prototype.getCustomFooterContent=function(){return this._getSegmentedFooter().getSection("customRight").getContent();};
n.prototype.addCustomFooterContent=function(p,r){this._getSegmentedFooter().getSection("customRight").addContent(p,r);return this;};
n.prototype.indexOfCustomFooterContent=function(p){return this._getSegmentedFooter().getSection("customRight").indexOfContent(p);};
n.prototype.insertCustomFooterContent=function(p,I,r){this._getSegmentedFooter().getSection("customRight").insertContent(p,I,r);return this;};
n.prototype.removeCustomFooterContent=function(p,r){return this._getSegmentedFooter().getSection("customRight").removeContent(p,r);};
n.prototype.removeAllCustomFooterContent=function(p){return this._getSegmentedFooter().getSection("customRight").removeAllContent(p);};
n.prototype.destroyCustomFooterContent=function(p){var r=this.getCustomFooterContent();if(!r){return this;}if(p){this.iSuppressInvalidate++;}this._getSegmentedFooter().getSection("customRight").destroy(p);if(!this.isInvalidateSuppressed()){this.invalidate();}if(p){this.iSuppressInvalidate--;}return this;};
n.prototype.getCustomHeaderContent=function(){return this._getSegmentedHeader().getSection("customRight").getContent();};
n.prototype.addCustomHeaderContent=function(p,r){this._getSegmentedHeader().getSection("customRight").addContent(p,r);return this;};
n.prototype.indexOfCustomHeaderContent=function(p){return this._getSegmentedHeader().getSection("customRight").indexOfContent(p);};
n.prototype.insertCustomHeaderContent=function(p,I,r){this._getSegmentedHeader().getSection("customRight").insertContent(p,I,r);return this;};
n.prototype.removeCustomHeaderContent=function(p,r){return this._getSegmentedHeader().getSection("customRight").removeContent(p,r);};
n.prototype.removeAllCustomHeaderContent=function(p){return this._getSegmentedHeader().getSection("customRight").removeAllContent(p);};
n.prototype.destroyCustomHeaderContent=function(p){var r=this.getCustomHeaderContent();if(!r){return this;}if(p){this.iSuppressInvalidate++;}this._getSegmentedHeader().getSection("customRight").destroy(p);if(!this.isInvalidateSuppressed()){this.invalidate();}if(p){this.iSuppressInvalidate--;}return this;};
n.prototype.setAggregation=function(A,p,r){var t=this.mAggregations[A];if(t===p){return this;}p=this.validateAggregation(A,p,false);var u=this.getMetadata().getManagedAggregation(A).type;if(a.isKnownSemanticType(u)){if(t){this._stopMonitor(t);this._removeFromInnerAggregation(t._getControl(),a.getPositionInPage(u),r);}if(p){this._initMonitor(p);this._addToInnerAggregation(p._getControl(),a.getPositionInPage(u),a.getSequenceOrderIndex(u),r);}return M.prototype.setAggregation.call(this,A,p,true);}return M.prototype.setAggregation.call(this,A,p,r);};
n.prototype.destroyAggregation=function(A,p){var r=this.getMetadata().getAggregations()[A];if(r&&a.isKnownSemanticType(r.type)){var t=M.prototype.getAggregation.call(this,A);if(t){this._stopMonitor(t);if(!t._getControl().bIsDestroyed){this._removeFromInnerAggregation(t._getControl(),a.getPositionInPage(r.type),p);}}}return M.prototype.destroyAggregation.call(this,A,t,p);};
n.prototype._updateHeaderVisibility=function(){var H=this._getInternalHeader();var E=(H.getContentLeft().length===0)&&(H.getContentMiddle().length===0)&&(H.getContentRight().length===0);this._getPage().setShowHeader(!E);};
n.prototype._getTitle=function(){if(!this._oTitle){this._oTitle=new T(this.getId()+"-title",{text:this.getTitle()});}return this._oTitle;};
n.prototype._getNavButton=function(){if(!this._oNavButton){this._oNavButton=new B(this.getId()+"-navButton",{type:i.Up,tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("PAGE_NAVBUTTON_TEXT"),press:q.proxy(this.fireNavButtonPress,this)});}return this._oNavButton;};
n.prototype._initMonitor=function(p){var r=p._getConfiguration();if(r.triggers){p.attachEvent("press",this._updateCurrentMode,this);}var t=r.states,u=this;if(t){q.each(a._PageMode,function(v,w){if(t[v]){u.attachEvent(v,p._onPageStateChanged,p);}});}};
n.prototype._stopMonitor=function(p){p.detachEvent("press",this._updateCurrentMode,this);var r=p._getConfiguration();var t=r.states,u=this;if(t){q.each(a._PageMode,function(v,w){if(t[v]){u.detachEvent(v,p._onPageStateChanged,p);}});}};
n.prototype._updateCurrentMode=function(E){var p=E.oSource._getConfiguration();if(typeof p.triggers==='string'){this._currentMode=p.triggers;}else{var r=p.triggers.length;if(r&&r>0){for(var I=0;I<r;I++){var t=p.triggers[I];if(t&&(t.inState===this._currentMode)){this._currentMode=t.triggers;break;}}}}this.fireEvent(this._currentMode);};
n.prototype._removeFromInnerAggregation=function(p,r,t){var u=this._getSemanticPositionsMap()[r];if(u&&u.oContainer&&u.sAggregation){u.oContainer["remove"+o(u.sAggregation)](p,t);}};
n.prototype._addToInnerAggregation=function(p,r,t,u){if(!p||!r){return;}var v=this._getSemanticPositionsMap()[r];if(!v||!v.oContainer||!v.sAggregation){return;}if(typeof t!=='undefined'){p.addCustomData(new C({key:"sortIndex",value:t}));}return v.oContainer["add"+o(v.sAggregation)](p,u);};
n.prototype._getSemanticPositionsMap=function(p,r){if(!this._oPositionsMap){this._oPositionsMap={};this._oPositionsMap[a.prototype._PositionInPage.headerLeft]={oContainer:this._getInternalHeader(),sAggregation:"contentLeft"};this._oPositionsMap[a.prototype._PositionInPage.headerRight]={oContainer:this._getSegmentedHeader().getSection("semanticRight"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.headerMiddle]={oContainer:this._getInternalHeader(),sAggregation:"contentMiddle"};this._oPositionsMap[a.prototype._PositionInPage.footerLeft]={oContainer:this._getSegmentedFooter().getSection("semanticLeft"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_IconOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_IconOnly"),sAggregation:"content"};this._oPositionsMap[a.prototype._PositionInPage.footerRight_TextOnly]={oContainer:this._getSegmentedFooter().getSection("semanticRight_TextOnly"),sAggregation:"content"};}return this._oPositionsMap;};
n.prototype._getPage=function(){var p=this.getAggregation("_page");if(!p){this.setAggregation("_page",new P(this.getId()+"-page"));p=this.getAggregation("_page");}return p;};
n.prototype._getInternalHeader=function(){if(!this._oInternalHeader){this._oInternalHeader=new c(this.getId()+"-intHeader");if(this._oHeaderObserver){this._oHeaderObserver.observe(this._oInternalHeader,{aggregations:["contentLeft","contentMiddle","contentRight"]});}}return this._oInternalHeader;};
n.prototype._getAnyHeader=function(){return this._getInternalHeader();};
n.prototype._getSegmentedHeader=function(){if(!this._oWrappedHeader){var H=this._getInternalHeader();if(!H){L.error("missing page header",this);return null;}this._oWrappedHeader=new S(H,"contentRight");this._oWrappedHeader.addSection({sTag:"customRight"});this._oWrappedHeader.addSection({sTag:"semanticRight"});}return this._oWrappedHeader;};
n.prototype._getSegmentedFooter=function(){if(!this._oWrappedFooter){var F=this._getPage().getFooter();if(!F){L.error("missing page footer",this);return null;}this._oWrappedFooter=new S(F);this._oWrappedFooter.addSection({sTag:"semanticLeft"});this._oWrappedFooter.addSection({sTag:"spacer",aContent:[new b()]});this._oWrappedFooter.addSection({sTag:"semanticRight_TextOnly",fnSortFunction:s});this._oWrappedFooter.addSection({sTag:"customRight"});this._oWrappedFooter.addSection({sTag:"semanticRight_IconOnly",fnSortFunction:s});}return this._oWrappedFooter;};
function o(N){return N.substring(0,1).toUpperCase()+N.substring(1);}
function s(p,r){var t=p.data("sortIndex");var u=r.data("sortIndex");if((typeof t==='undefined')||(typeof u==='undefined')){L.warning("sortIndex missing",this);return null;}return(t-u);}
return n;});
sap.ui.predefine('sap/m/semantic/SemanticPageRenderer',[],function(){"use strict";var S={apiVersion:2};
S.render=function(r,o){r.openStart("div",o);r.class("sapMSemanticPage");r.openEnd();r.renderControl(o._getPage());r.close("div");};
return S;},true);
sap.ui.predefine('sap/m/semantic/SemanticSelect',['sap/m/semantic/SemanticControl','sap/m/Select',"sap/base/Log"],function(S,a,L){"use strict";
var b=S.extend("sap.m.semantic.SemanticSelect",{metadata:{library:"sap.m","abstract":true,properties:{enabled:{type:"boolean",group:"Behavior",defaultValue:true},selectedKey:{type:"string",group:"Data",defaultValue:""}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.core.Item",multiple:true,singularName:"item",bindable:"bindable"}},associations:{selectedItem:{type:"sap.ui.core.Item",multiple:false}},events:{change:{parameters:{selectedItem:{type:"sap.ui.core.Item"}}}}}});
b.prototype.setProperty=function(p,v,s){if(!this.getMetadata().getProperties()[p]&&!b.getMetadata().getProperties()[p]&&!S.getMetadata().getProperties()[p]){L.error("unknown property: "+p,this);return this;}S.prototype.setProperty.call(this,p,v,s);};
b.prototype.getSelectedItem=function(){return this._getControl().getSelectedItem();};
b.prototype.setSelectedItem=function(i){this._getControl().setSelectedItem(i);this.setSelectedKey(this._getControl().getSelectedKey());return this;};
b.prototype.getItemAt=function(i){return this._getControl().getItemAt(i);};
b.prototype._getControl=function(){var c=this.getAggregation('_control');if(!c){this.setAggregation('_control',new a({id:this.getId()+"-select",change:this._onInnerSelectChange.bind(this)}),true);c=this.getAggregation('_control');c.applySettings(this._getConfiguration().getSettings());if(typeof this._getConfiguration().getEventDelegates==="function"){c.addEventDelegate(this._getConfiguration().getEventDelegates(c));}}return c;};
b.prototype._onInnerSelectChange=function(e){var s=e.getSource().getSelectedItem();this.setSelectedItem(s);this.fireChange({selectedItem:s});};
return b;});
sap.ui.predefine('sap/m/semantic/SemanticToggleButton',["sap/m/semantic/SemanticButton","sap/ui/events/KeyCodes","sap/m/ToggleButton","sap/m/semantic/SemanticOverflowToolbarToggleButton"],function(S,K,T,a){"use strict";
var b=S.extend("sap.m.semantic.SemanticToggleButton",{metadata:{library:"sap.m","abstract":true,properties:{pressed:{type:"boolean",group:"Data",defaultValue:false}}}});
b.prototype._getClass=function(c){return c&&c.constraints==="IconOnly"?a:T;};
b.prototype._onPress=function(e){var p;if(this.getEnabled()){p=e.getParameter('pressed');this.setPressed(p);this.firePress({pressed:p});}};
b.prototype._applyProperty=function(p,v,s){if(p==='pressed'){this._setPressed(v,s);}else{S.prototype._applyProperty.apply(this,arguments);}};
b.prototype._setPressed=function(v,s){var t=this._getControl(),p=Boolean(v);if(t.getPressed()!==p){this._getControl().setPressed(p,s);}};
b.prototype._createInstance=function(c){var i=new c({id:this.getId()+"-toggleButton"});i.attachEvent("press",this._onPress,this);return i;};
return b;});
sap.ui.predefine('sap/m/semantic/SendEmailAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendEmailAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/SendMessageAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SendMessageAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/ShareInJamAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.ShareInJamAction",{metadata:{library:"sap.m"}});
return a;});
sap.ui.predefine('sap/m/semantic/ShareMenu',['sap/ui/base/Object','sap/ui/base/ManagedObjectObserver','sap/m/library','sap/m/Button','sap/m/OverflowToolbarLayoutData','sap/ui/core/IconPool','sap/m/OverflowToolbarButton',"sap/base/Log"],function(B,M,l,a,O,I,b,L){"use strict";var c=l.OverflowToolbarPriority;
var S=B.extend("sap.m.semantic.ShareMenu",{
constructor:function(A){if(!A){L.error("missing argumment: constructor expects an actionsheet reference",this);return;}this._oActionSheet=A;this._oContentObserver=new M(this._updateShareBtnVisibility.bind(this));this._setMode(S._Mode.initial);},
getInterface:function(){return this;}
});
S._Mode={initial:"initial",button:"button",actionSheet:"actionSheet"};
S.prototype.getBaseButton=function(){return this._oBaseButton;};
S.prototype.getAggregation=function(n){if(n==="content"){return this.getContent();}};
S.prototype.addAggregation=function(n,o,s){if(n==="content"){return this.addContent(o,s);}};
S.prototype.insertAggregation=function(n,o,i,s){if(n==="content"){return this.insertContent(o,i,s);}};
S.prototype.indexOfAggregation=function(n,o){if(n==="content"){return this.indexOfContent(o);}};
S.prototype.removeAggregation=function(n,o,s){if(n==="content"){return this.removeContent(o,s);}};
S.prototype.removeAllAggregation=function(n,s){if(n==="content"){return this.removeAllContent(s);}};
S.prototype.getContent=function(){var m=this._getMode();if(m===S._Mode.initial){return[];}else if(m===S._Mode.button){return[this._oBaseButton];}else{return this._oActionSheet.getAggregation("buttons")||[];}};
S.prototype.addContent=function(o,s){var m=this._getMode();this._observeButton(o);if(m===S._Mode.initial){this._setMode(S._Mode.button,s,o);return this;}if(m===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(o);this._oActionSheet.addButton(o,s);this._updateShareBtnVisibility();return this;};
S.prototype.insertContent=function(o,i,s){var m=this._getMode();this._observeButton(o);if(m===S._Mode.initial){this._setMode(S._Mode.button,s,o);return this;}if(m===S._Mode.button){this._setMode(S._Mode.actionSheet,s);}this._preProcessOverflowToolbarButton(o);this._oActionSheet.insertButton(o,i,s);this._updateShareBtnVisibility();return this;};
S.prototype.indexOfContent=function(o){if((this._getMode()===S._Mode.button)&&(o===this._oBaseButton)){return 0;}if(this._getMode()===S._Mode.actionSheet){return this._oActionSheet.indexOfAggregation("buttons",o);}return-1;};
S.prototype.removeContent=function(o,s){var r,m=this._getMode();if(m===S._Mode.actionSheet){r=this._oActionSheet.removeButton(o,s);this._postProcessOverflowToolbarButton(o);this._unobserveButton(o);if(r){if(this._oActionSheet.getAggregation("buttons").length===1){this._setMode(S._Mode.button,s);}}this._updateShareBtnVisibility();return r;}if(m===S._Mode.button){var d=this._oBaseButton;this._setMode(S._Mode.initial,s);return d;}return r;};
S.prototype.removeAllContent=function(s){var r;if(this._getMode()===S._Mode.actionSheet){r=this._oActionSheet.removeAllButtons(s);r.forEach(function(o){this._postProcessOverflowToolbarButton(o);this._unobserveButton(o);},this);this._updateShareBtnVisibility();}else if(this._getMode()===S._Mode.button){r=[this._oBaseButton];}this._setMode(S._Mode.initial,s);return r;};
S.prototype.destroy=function(s){this._oActionSheet.destroy(s);if(this._oShareMenuBtn){this._oShareMenuBtn.destroy(s);this._oShareMenuBtn=null;}if(this._oContentObserver){this._oContentObserver.disconnect();this._oContentObserver=null;}};
S.prototype._setBaseButton=function(o,s){if(this._oBaseButton===o){return this;}var d=this._oBaseButton;this._oBaseButton=o;if(d){var p=d.getParent(),P=d.sParentAggregationName;if(p){p.removeAggregation(P,d,s);p.addAggregation(P,this._oBaseButton,s);}}return this;};
S.prototype._getMode=function(){return this._mode;};
S.prototype._setMode=function(m,s,o){if(!S._Mode[m]){L.error("unknown shareMenu mode "+m,this);return this;}if(this._mode===m){return this;}if(S._Mode.initial===m){this._setBaseButton(this._getShareMenuButton().applySettings({visible:false}));this._mode=S._Mode.initial;return this;}if(m===S._Mode.button){if(this._mode===S._Mode.initial){this._setBaseButton(o);}else if(this._mode===S._Mode.actionSheet){var d=this._oActionSheet.getAggregation("buttons")[0];this._oActionSheet.removeButton(d,s);this._postProcessOverflowToolbarButton(d);this._setBaseButton(d);}this._mode=S._Mode.button;return this;}if(m===S._Mode.actionSheet){var e=this._oBaseButton;this._setBaseButton(this._getShareMenuButton().applySettings({visible:true}));if(e){this._preProcessOverflowToolbarButton(e);this._oActionSheet.addButton(e,s);}this._mode=S._Mode.actionSheet;}return this;};
S.prototype._getShareMenuButton=function(){if(!this._oShareMenuBtn){var t=this;this._oShareMenuBtn=new a(this._oActionSheet.getParent().getId()+"-shareButton",{icon:I.getIconURI("action"),tooltip:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("SEMANTIC_CONTROL_ACTION_SHARE"),layoutData:new O({priority:c.NeverOverflow}),press:function(){t._oActionSheet.openBy(t._oShareMenuBtn);}});this._oShareMenuBtn.addEventDelegate({onAfterRendering:function(){t._oShareMenuBtn.$().attr("aria-haspopup","menu");}});}return this._oShareMenuBtn;};
S.prototype._getVisibleContent=function(){return this.getContent().filter(function(o){return o.getVisible();});};
S.prototype._updateShareBtnVisibility=function(){var v=this._getVisibleContent(),t=v.length>0;this._getShareMenuButton().setVisible(t);};
S.prototype._preProcessOverflowToolbarButton=function(o){if(o instanceof b){o._bInOverflow=true;}};
S.prototype._postProcessOverflowToolbarButton=function(o){if(o instanceof b){delete o._bInOverflow;}};
S.prototype._observeButton=function(o){this._oContentObserver.observe(o,{properties:["visible"]});};
S.prototype._unobserveButton=function(o){this._oContentObserver.unobserve(o,{properties:["visible"]});};
return S;});
sap.ui.predefine('sap/m/semantic/ShareMenuPage',["sap/m/semantic/SemanticPage","sap/m/semantic/SemanticConfiguration","sap/m/semantic/SemanticPageRenderer","sap/m/semantic/SegmentedContainer","sap/m/semantic/ShareMenu","sap/m/ActionSheet","sap/m/library"],function(S,a,b,c,d,A,l){"use strict";var P=l.PlacementType;
var e=S.extend("sap.m.semantic.ShareMenuPage",{
metadata:{library:"sap.m",aggregations:{customShareMenuContent:{type:"sap.m.Button",multiple:true,singularName:"customShareMenuContent"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"}},designtime:"sap/m/designtime/semantic/ShareMenuPage.designtime"},
renderer:b
});
e.prototype._getSemanticPositionsMap=function(C,o){if(!this._oPositionsMap){this._oPositionsMap=S.prototype._getSemanticPositionsMap.apply(this,arguments);this._oPositionsMap[a.prototype._PositionInPage.shareMenu]={oContainer:this._getSegmentedShareMenu().getSection("semantic"),sAggregation:"content"};}return this._oPositionsMap;};
e.prototype.exit=function(){S.prototype.exit.apply(this,arguments);if(this._oSegmentedShareMenu){this._oSegmentedShareMenu.destroy();this._oSegmentedShareMenu=null;}};
e.prototype.getCustomShareMenuContent=function(){return this._getSegmentedShareMenu().getSection("custom").getContent();};
e.prototype.addCustomShareMenuContent=function(B,s){this._getSegmentedShareMenu().getSection("custom").addContent(B,s);return this;};
e.prototype.indexOfCustomShareMenuContent=function(B){return this._getSegmentedShareMenu().getSection("custom").indexOfContent(B);};
e.prototype.insertCustomShareMenuContent=function(B,i,s){this._getSegmentedShareMenu().getSection("custom").insertContent(B,i,s);return this;};
e.prototype.removeCustomShareMenuContent=function(B,s){return this._getSegmentedShareMenu().getSection("custom").removeContent(B,s);};
e.prototype.removeAllCustomShareMenuContent=function(s){return this._getSegmentedShareMenu().getSection("custom").removeAllContent(s);};
e.prototype.destroyCustomShareMenuContent=function(s){var C=this.getCustomShareMenuContent();if(!C){return this;}if(s){this.iSuppressInvalidate++;}this._getSegmentedShareMenu().getSection("custom").destroy();if(!this.isInvalidateSuppressed()){this.invalidate();}if(s){this.iSuppressInvalidate--;}return this;};
e.prototype.setSemanticRuleSet=function(n){var o=this.getSemanticRuleSet();if(o===n){return this;}this.setProperty("semanticRuleSet",n,true);var O=a.getShareMenuConfig(o),s=this._getShareBaseButtonContainer(O.baseButtonPlacement).getSection("shareMenu");if(s){this._moveShareMenu(O,a.getShareMenuConfig(this.getSemanticRuleSet()));}return this;};
e.prototype._moveShareMenu=function(o,n){var O=this._getShareBaseButtonContainer(o.baseButtonPlacement).getSection("shareMenu"),f=O&&O.removeAllContent(),g=f.length&&f[0];this._placeShareMenu(g,n);};
e.prototype._getActionSheet=function(){var o=this.getAggregation("_actionSheet");if(!o){this.setAggregation("_actionSheet",new A(),true);o=this.getAggregation("_actionSheet");}return o;};
e.prototype._getSegmentedShareMenu=function(){if(!this._oSegmentedShareMenu){var s=new d(this._getActionSheet());var o=s.getBaseButton();if(s&&o){this._oSegmentedShareMenu=new c(s);this._oSegmentedShareMenu.addSection({sTag:"custom"});this._oSegmentedShareMenu.addSection({sTag:"semantic"});this._placeShareMenu(o,a.getShareMenuConfig(this.getSemanticRuleSet()));}}return this._oSegmentedShareMenu;};
e.prototype._placeShareMenu=function(s,o){var f=o.baseButtonPlacement,v=o.actionSheetPlacement;var D=this._getShareBaseButtonContainer(f),g=D.getSection("shareMenu");if(!g){D.addSection({sTag:"shareMenu"});g=D.getSection("shareMenu");}if(s){g.addContent(s);}this._getActionSheet().setPlacement(v);};
e.prototype._getShareBaseButtonContainer=function(B){return(B===P.Bottom)?this._getSegmentedFooter():this._getSegmentedHeader();};
return e;});
sap.ui.predefine('sap/m/semantic/SortAction',['sap/m/semantic/SemanticButton'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortAction",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;});
sap.ui.predefine('sap/m/semantic/SortSelect',['sap/m/semantic/SemanticSelect'],function(S){"use strict";
var a=S.extend("sap.m.semantic.SortSelect",{metadata:{library:"sap.m",interfaces:["sap.m.semantic.ISort"]}});
return a;});
sap.ui.predefine('sap/m/upload/UploadSetItem',["sap/base/Log","sap/ui/core/library","sap/ui/core/Element","sap/ui/core/Icon","sap/ui/core/IconPool","sap/ui/core/HTML","sap/ui/core/util/File","sap/m/library","sap/m/BusyIndicator","sap/m/Button","sap/m/CustomListItem","sap/m/Image","sap/m/Input","sap/m/Label","sap/m/Link","sap/m/ProgressIndicator","sap/m/VBox","sap/m/HBox"],function(L,C,E,I,a,H,F,M,B,b,c,d,e,f,g,P,V,h){"use strict";
var U=E.extend("sap.m.upload.UploadSetItem",{metadata:{library:"sap.m",properties:{enabledRemove:{type:"boolean",defaultValue:true},enabledEdit:{type:"boolean",defaultValue:true},fileName:{type:"string",defaultValue:null},mediaType:{type:"string",defaultValue:null},thumbnailUrl:{type:"string",defaultValue:null},uploadState:{type:"sap.m.UploadState",defaultValue:null},url:{type:"string",defaultValue:null},visibleRemove:{type:"boolean",defaultValue:true},visibleEdit:{type:"boolean",defaultValue:true}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.m.ObjectAttribute",multiple:true,singularName:"attribute"},markers:{type:"sap.m.ObjectMarker",multiple:true,singularName:"marker"},statuses:{type:"sap.m.ObjectStatus",multiple:true,singularName:"status"}},events:{openPressed:{item:{type:"sap.m.upload.UploadSetItem"},allowPreventDefault:true},removePressed:{item:{type:"sap.m.upload.UploadSetItem"},allowPreventDefault:true}}}});
var j=M.UploadState,k=M.FlexJustifyContent,l=C.ValueState;
var D=H.extend("sap.m.upload.DynamicItemContent",{
metadata:{library:"sap.m",properties:{item:{type:"sap.m.upload.UploadSetItem"}}},
renderer:{render:function(r,o){var i=o.getItem();r.write("<div class=\"sapMUCTextContainer ");if(this._bInEditMode){r.write("sapMUCEditMode ");}r.write("\" >");r.write("<div style=\"display:flex;\">");r.renderControl(i._bInEditMode?i._getFileNameEdit():i._getFileNameLink());i._renderMarkers(r);r.write("</div>");i._renderAttributes(r);i._renderStatuses(r);r.write("</div>");i._renderStateAndProgress(r);i._renderButtons(r);}}
});
U.DYNAMIC_CONTENT_SEPARATOR="<div class=\"sapMUCSeparator\">&nbsp&#x00B7&#160</div>";U.MEGABYTE=1048576;U.IMAGE_FILE_ICON="sap-icon://card";
U.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oListItem=null;this._oIcon=null;this._oFileNameLink=null;this._oFileNameEdit=null;this._oDynamicContent=null;this._oRestartButton=null;this._oEditButton=null;this._oDeleteButton=null;this._oTerminateButton=null;this._oConfirmRenameButton=null;this._oCancelRenameButton=null;this._oProgressBox=null;this._oProgressIndicator=null;this._oStateLabel=null;this._oProgressLabel=null;this._oFileObject=null;this._fFileSize=null;this._bInEditMode=false;this._bContainsError=false;this._bFileTypeRestricted=false;this._bNameLengthRestricted=false;this._bSizeRestricted=false;this._bMediaTypeRestricted=false;};
U.prototype.setFileName=function(s){var o;if(this.getFileName()!==s){this.setProperty("fileName",s,true);if(this.getParent()){this._getFileNameLink().setText(s);o=U._splitFileName(s);this._getFileNameEdit().setValue(o.name);this._checkNameLengthRestriction(this.getParent().getMaxFileNameLength());this._checkTypeRestriction(this.getParent().getFileTypes());}}return this;};
U.prototype.setUploadState=function(u){var i=this._getProgressIndicator(),s=this._getStateLabel(),m=(u!==j.Complete),n=(u===j.Uploading);this.setProperty("uploadState",u,true);i.setVisible(m);s.setVisible(m);this._getProgressLabel().setVisible(m);switch(u){case j.Complete:i.setState(l.None);s.setText("");break;case j.Error:i.setState(l.Error);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_ERROR_STATE"));break;case j.Ready:i.setState(l.None);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_READY_STATE"));break;case j.Uploading:i.setState(l.Information);s.setText(this._oRb.getText("UPLOAD_SET_ITEM_UPLOADING_STATE"));break;}if(this.getParent()){this._getRestartButton().setVisible(u===j.Error);if(this.getVisibleEdit()){this._getEditButton().setVisible(!n);}if(this.getVisibleRemove()){this._getDeleteButton().setVisible(!n);}this._getTerminateButton().setVisible(this.getParent().getTerminationEnabled()&&n);}return this;};
U.prototype.setEnabledRemove=function(i){if(this.getEnabledRemove()!==i){this.setProperty("enabledRemove",i,true);if(this.getParent()){this._getDeleteButton().setEnabled(i);}}return this;};
U.prototype.setVisibleRemove=function(v){if(this.getVisibleRemove()!==v){this.setProperty("visibleRemove",v,true);if(this.getParent()){this._getDeleteButton().setVisible(v);}}return this;};
U.prototype.setEnabledEdit=function(i){if(this.getEnabledEdit()!==i){this.setProperty("enabledEdit",i,true);if(this.getParent()){this._getEditButton().setEnabled(i);}}return this;};
U.prototype.setVisibleEdit=function(v){if(this.getVisibleEdit()!==v){this.setProperty("visibleEdit",v,true);if(this.getParent()){this._getEditButton().setVisible(v);}}return this;};
U.prototype.setThumbnailUrl=function(u){if(this.getThumbnailUrl()!=u){this.setProperty("thumbnailUrl",u,true);if(this._oListItem){for(var i=0;i<this._oListItem.getContent().length;i++){if(this._oListItem.getContent()[i]instanceof sap.ui.core.Icon||this._oListItem.getContent()[i]instanceof sap.m.Image){var o=this._oListItem.getContent()[i];this._oListItem.removeContent(o);if(this._oIcon){this._oIcon.destroy();this._oIcon=null;}this._oIcon=a.createControlByURI({id:this.getId()+"-thumbnail",src:u,decorative:false},d);this._oIcon.addStyleClass("sapMUCItemImage sapMUCItemIcon");this._oListItem.insertContent(this._oIcon,0);}}}}return this;};
U.prototype.getFileObject=function(){return this._oFileObject;};
U.prototype.getListItem=function(){return this._getListItem();};
U.prototype.setProgress=function(p){var $;this._getProgressLabel().setText(p+"%");$=this.$("-busyIndicator");if(p===100){$.attr("aria-label",this._oRb.getText("UPLOAD_SET_UPLOAD_COMPLETED"));}else{$.attr("aria-valuenow",p);}this._getProgressIndicator().setPercentValue(p);return this;};
U.prototype.download=function(A){var p=this.getParent();if(!p){L.warning("Download cannot proceed without a parent association.");return false;}return p._getActiveUploader().downloadItem(this,[],A);};
U.prototype._handleFileNamePressed=function(){if(this.fireOpenPressed({item:this})){M.URLHelper.redirect(this.getUrl(),true);}};
U.prototype._getListItem=function(){if(!this._oListItem){this._oListItem=new c(this.getId()+"-listItem",{content:[this._getIcon(),this._getDynamicContent()]});this._oListItem.addStyleClass("sapMUCItem");}return this._oListItem;};
U.prototype._setFileObject=function(o){this._oFileObject=o;if(o){this._fFileSize=o.size/U.MEGABYTE;this.setMediaType(o.type);}else{this._fFileSize=null;this.setMediaType(null);}if(this.getParent()){this._checkSizeRestriction(this.getParent().getMaxFileSize());this._checkMediaTypeRestriction(this.getParent().getMediaTypes());}};
U.prototype._getIcon=function(){if(!this._oIcon){if(this.getThumbnailUrl()){this._oIcon=a.createControlByURI({id:this.getId()+"-thumbnail",src:this.getThumbnailUrl(),decorative:false},d);this._oIcon.addStyleClass("sapMUCItemImage sapMUCItemIcon");}else{this._oIcon=new I(this.getId()+"-icon",{src:this._getIconByFileType()});this._oIcon.addStyleClass("sapMUCItemIcon");}this.addDependent(this._oIcon);}return this._oIcon;};
U.prototype._getIconByFileType=function(){var s=U._splitFileName(this.getFileName()).extension;if(!s){return"";}switch(s.toLowerCase()){case"bmp":case"jpg":case"jpeg":case"png":return U.IMAGE_FILE_ICON;case"csv":case"xls":case"xlsx":return"sap-icon://excel-attachment";case"doc":case"docx":case"odt":return"sap-icon://doc-attachment";case"pdf":return"sap-icon://pdf-attachment";case"ppt":case"pptx":return"sap-icon://ppt-attachment";case"txt":return"sap-icon://document-text";default:return"sap-icon://document";}};
U.prototype._getFileNameLink=function(){if(!this._oFileNameLink){this._oFileNameLink=new g({id:this.getId()+"-fileNameLink",press:[this,this._handleFileNamePressed,this]});this._oFileNameLink.setText(this.getFileName());this._oFileNameLink.addStyleClass("sapMUCFileName");this._oFileNameLink.addStyleClass("sapMUSFileName");this.addDependent(this._oFileNameLink);}this._oFileNameLink.setEnabled(!!this.getUrl());return this._oFileNameLink;};
U.prototype._getDynamicContent=function(){if(!this._oDynamicContent){this._oDynamicContent=new D({item:this});this.addDependent(this._oDynamicContent);}return this._oDynamicContent;};
U.prototype._getRestartButton=function(){var p=this.getParent();if(!this._oRestartButton){this._oRestartButton=new b({id:this.getId()+"-restartButton",icon:"sap-icon://refresh",type:M.ButtonType.Standard,visible:this.getUploadState()===j.Error,tooltip:this._oRb.getText("UPLOAD_SET_RESTART_BUTTON_TEXT"),press:[this,p._handleItemRestart,p]});this.addDependent(this._oRestartButton);}return this._oRestartButton;};
U.prototype._getEditButton=function(){var p=this.getParent();if(!this._oEditButton){this._oEditButton=new b({id:this.getId()+"-editButton",icon:"sap-icon://edit",type:M.ButtonType.Standard,enabled:this.getEnabledEdit(),visible:this.getVisibleEdit(),tooltip:this._oRb.getText("UPLOAD_SET_EDIT_BUTTON_TEXT"),press:[this,p._handleItemEdit,p]});this._oEditButton.addStyleClass("sapMUCEditBtn");this.addDependent(this._oEditButton);}return this._oEditButton;};
U.prototype._getFileNameEdit=function(){var s;if(!this._oFileNameEdit){s=U._splitFileName(this.getFileName());this._oFileNameEdit=new e({id:this.getId()+"-fileNameEdit",type:M.InputType.Text});this._oFileNameEdit.addStyleClass("sapMUCEditBox");this._oFileNameEdit.setFieldWidth("75%");this._oFileNameEdit.setDescription(s.extension);this._updateFileNameEdit();this.addDependent(this._oFileNameEdit);}return this._oFileNameEdit;};
U.prototype._updateFileNameEdit=function(){var o=this._getFileNameEdit();if(this._bContainsError){o.setValueState(l.Error);o.setValueStateText("");o.setShowValueStateMessage(true);}else{o.setValueState(l.None);if(o.getValue().length===0){o.setValueStateText(this._oRb.getText("UPLOAD_SET_TYPE_FILE_NAME"));}else{o.setValueStateText(this._oRb.getText("UPLOAD_SET_FILE_NAME_EXISTS"));}o.setShowValueStateMessage(false);}};
U.prototype._setInEditMode=function(i){if(i&&!this._bInEditMode){var s=U._splitFileName(this.getFileName());this._getFileNameEdit().setValue(s.name);}this._bInEditMode=i;this._setContainsError(false);this.invalidate();};
U.prototype._getContainsError=function(){return this._bContainsError;};
U.prototype._setContainsError=function(i){this._bContainsError=i;this._updateFileNameEdit();};
U._splitFileName=function(s,w){var r={};var R=/(?:\.([^.]+))?$/;var i=R.exec(s);r.name=s.slice(0,s.indexOf(i[0]));if(w){r.extension=i[0];}else{r.extension=i[1];}return r;};
U.prototype._getDeleteButton=function(){var p=this.getParent();if(!this._oDeleteButton){this._oDeleteButton=new b({id:this.getId()+"-deleteButton",icon:"sap-icon://decline",type:M.ButtonType.Standard,enabled:this.getEnabledRemove(),visible:this.getVisibleRemove(),tooltip:this._oRb.getText("UPLOAD_SET_DELETE_BUTTON_TEXT"),press:[this,p._handleItemDelete,p]});this._oDeleteButton.addStyleClass("sapMUCDeleteBtn");this.addDependent(this._oDeleteButton);}return this._oDeleteButton;};
U.prototype._getTerminateButton=function(){var p=this.getParent();if(!this._oTerminateButton){this._oTerminateButton=new b({id:this.getId()+"-terminateButton",icon:"sap-icon://stop",type:M.ButtonType.Standard,visible:p.getTerminationEnabled()&&this.getUploadState()===j.Uploading,tooltip:this._oRb.getText("UPLOAD_SET_TERMINATE_BUTTON_TEXT"),press:[this,p._handleTerminateRequest,p]});this._oTerminateButton.addStyleClass("sapMUCDeleteBtn");this.addDependent(this._oTerminateButton);}return this._oTerminateButton;};
U.prototype._getConfirmRenameButton=function(){var p=this.getParent();if(!this._oConfirmRenameButton){this._oConfirmRenameButton=new b({id:this.getId()+"-okButton",text:this._oRb.getText("UPLOAD_SET_RENAME_BUTTON_TEXT"),type:M.ButtonType.Transparent,press:[this,p._handleItemEditConfirmation,p]});this._oConfirmRenameButton.addStyleClass("sapMUCOkBtn");this.addDependent(this._oConfirmRenameButton);}return this._oConfirmRenameButton;};
U.prototype._getCancelRenameButton=function(){var p=this.getParent();if(!this._oCancelRenameButton){this._oCancelRenameButton=new b({id:this.getId()+"-cancelButton",text:this._oRb.getText("UPLOAD_SET_CANCEL_BUTTON_TEXT"),type:M.ButtonType.Transparent,press:[this,p._handleItemEditCancelation,p]});this._oCancelRenameButton.addStyleClass("sapMUCCancelBtn");this.addDependent(this._oCancelRenameButton);}return this._oCancelRenameButton;};
U.prototype._getProgressBox=function(){if(!this._oProgressBox){this._oProgressBox=new V({id:this.getId()+"-progressBox",items:[this._getProgressIndicator(),new h({justifyContent:k.SpaceBetween,items:[this._getStateLabel(),this._getProgressLabel()]})],width:"20%"});this._oProgressBox.addStyleClass("sapMUSProgressBox");this.addDependent(this._oProgressBox);}return this._oProgressBox;};
U.prototype._getProgressIndicator=function(){if(!this._oProgressIndicator){this._oProgressIndicator=new P({id:this.getId()+"-progressIndicator",percentValue:0,state:l.Information,visible:this.getUploadState()!==j.Complete});this._oProgressIndicator.addStyleClass("sapMUSProgressIndicator");}return this._oProgressIndicator;};
U.prototype._getStateLabel=function(){if(!this._oStateLabel){this._oStateLabel=new f({id:this.getId()+"-stateLabel",text:"Pending",visible:this.getUploadState()!==j.Complete});}return this._oStateLabel;};
U.prototype._getProgressLabel=function(){if(!this._oProgressLabel){this._oProgressLabel=new f({id:this.getId()+"-progressLabel",visible:this.getUploadState()!==j.Complete});this.setProgress(0);this.addDependent(this._oProgressLabel);}return this._oProgressLabel;};
U.prototype._renderAttributes=function(r){var i=this.getAttributes().length-1;if(this.getAttributes().length>0){r.write("<div class=\"sapMUCAttrContainer\">");this.getAttributes().forEach(function(A,m){r.renderControl(A.addStyleClass("sapMUCAttr"));if(m<i){r.write(U.DYNAMIC_CONTENT_SEPARATOR);}});r.write("</div>");}};
U.prototype._renderMarkers=function(r){if(this.getMarkers().length>0){r.write("<div class=\"sapMUSObjectMarkerContainer\">");this.getMarkers().forEach(function(m){r.renderControl(m.addStyleClass("sapMUCObjectMarker"));});r.write("</div>");}};
U.prototype._renderStatuses=function(r){var i=this.getStatuses().length-1;if(this.getStatuses().length>0){r.write("<div class=\"sapMUCStatusContainer\">");this.getStatuses().forEach(function(s,m){r.renderControl(s);if(m<i){r.write(U.DYNAMIC_CONTENT_SEPARATOR);}});r.write("</div>");}};
U.prototype._renderStateAndProgress=function(r){r.renderControl(this._getProgressBox());};
U.prototype._renderButtons=function(r){var i;if(this._bInEditMode){i=[this._getConfirmRenameButton(),this._getCancelRenameButton()];}else{i=[this._getRestartButton(),this._getEditButton(),this._getDeleteButton(),this._getTerminateButton()];}if(i.length>0){r.write("<div class=\"sapMUCButtonContainer\">");i.forEach(function(o,m){if(m<(i.length-1)){o.addStyleClass("sapMUCFirstButton");}r.renderControl(o);});r.write("</div>");}};
U.prototype._checkTypeRestriction=function(t){var o=U._splitFileName(this.getFileName()),r=(!!this.getFileName()&&!!t&&(t.length>0)&&o.extension&&t.indexOf(o.extension.toLowerCase())===-1);if(r!==this._bFileTypeRestricted){this._bFileTypeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileTypeMismatch({item:this});}}};
U.prototype._checkNameLengthRestriction=function(m){var r=(m&&!!this.getFileName()&&this.getFileName().length>m);if(r!==this._bNameLengthRestricted){this._bNameLengthRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileNameLengthExceeded({item:this});}}};
U.prototype._checkSizeRestriction=function(m){var r=(m&&this._fFileSize>m);if(r!==this._bSizeRestricted){this._bSizeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireFileSizeExceeded({item:this});}}};
U.prototype._checkMediaTypeRestriction=function(t){var r=(!!t&&(t.length>0)&&!!this.getMediaType()&&t.indexOf(this.getMediaType())===-1);if(r!==this._bMediaTypeRestricted){this._bMediaTypeRestricted=r;this.invalidate();if(r&&this.getParent()){this.getParent().fireMediaTypeMismatch({item:this});}}};
U.prototype._isRestricted=function(){return this._bFileTypeRestricted||this._bNameLengthRestricted||this._bSizeRestricted||this._bMediaTypeRestricted;};
return U;});
sap.ui.predefine('sap/m/upload/UploadSetRenderer',['sap/m/ListItemBaseRenderer'],function(L){"use strict";var U={};
U.render=function(r,c){r.write("<div");r.writeControlData(c);r.addClass("sapMUC");r.writeClasses();r.write(">");this.renderDragDropOverlay(r,c);this.renderList(r,c);r.write("</div>");};
U.renderDragDropOverlay=function(r,c){r.write("<div");r.writeAttribute("id",c.getId()+"-drag-drop-area");r.addClass("sapMUCDragDropOverlay");r.addClass("sapMUCDragDropOverlayHide");r.writeClasses();r.write(">");r.write("<div");r.addClass("sapMUCDragDropIndicator");r.writeClasses();r.write(">");r.write("</div>");r.write("</div>");};
U.renderList=function(r,c){var o=c.getList().getRenderer().renderNoData;c.getList().getRenderer().renderNoData=this.renderNoData;r.renderControl(c.getList());c.getList().getRenderer().renderNoData=o;};
U.renderNoData=function(r,c){var u=c.getParent();r.write("<li");r.writeAttribute("tabindex",0);r.writeAttribute("id",u.getList().getId("nodata"));r.addClass("sapMLIB sapMUCNoDataPage");L.addFocusableClasses.call(L,r);r.writeClasses();r.write(">");r.renderControl(u._oNoDataIcon);r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-text");r.addClass("sapMUCNoDataText");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataText());r.write("</div>");if(u.getUploadEnabled()){r.write("<div");r.writeAttribute("id",u.getId()+"-no-data-description");r.addClass("sapMUCNoDataDescription");r.writeClasses();r.write(">");r.writeEscaped(u.getNoDataDescription());r.write("</div>");}r.write("</li>");};
return U;});
sap.ui.predefine('sap/m/upload/Uploader',["sap/base/Log","sap/m/library","sap/ui/core/Element","sap/ui/core/util/File","sap/ui/Device","sap/ui/core/Item","sap/m/upload/UploadSetItem"],function(L,M,E,F,D,H,U){"use strict";
var a=E.extend("sap.m.upload.Uploader",{metadata:{library:"sap.m",publicMethods:["uploadItem","terminateItem","downloadItem"],properties:{uploadUrl:{type:"string",defaultValue:null},downloadUrl:{type:"string",defaultValue:null}},events:{uploadStarted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},uploadProgressed:{parameters:{item:{type:"sap.m.upload.UploadSetItem"},loaded:{type:"long"},total:{type:"long"}}},uploadCompleted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},uploadAborted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}}}}});
a.prototype.init=function(){this._mRequestHandlers={};};
a.uploadFile=function(f,u,h){var x=new window.XMLHttpRequest();return new Promise(function(r,b){x.open("POST",u,true);if((D.browser.edge||D.browser.internet_explorer)&&f.type&&x.readyState===1){x.setRequestHeader("Content-Type",f.type);}if(h){h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});}x.onreadystatechange=function(){if(this.readyState===window.XMLHttpRequest.DONE){if(this.status===200){r(this);}else{b(this);}}};x.send(f);});};
a.prototype.uploadItem=function(i,h){var x=new window.XMLHttpRequest(),f=i.getFileObject(),t=this,r={xhr:x,item:i};x.open("POST",this.getUploadUrl(),true);if((D.browser.edge||D.browser.internet_explorer)&&f.type&&x.readyState===1){x.setRequestHeader("Content-Type",f.type);}if(h){h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});}x.upload.addEventListener("progress",function(e){t.fireUploadProgressed({item:i,loaded:e.loaded,total:e.total,aborted:false});});x.onreadystatechange=function(){var o=t._mRequestHandlers[i.getId()];if(this.readyState===window.XMLHttpRequest.DONE&&!o.aborted){t.fireUploadCompleted({item:i});}};this._mRequestHandlers[i.getId()]=r;x.send(i.getFileObject());this.fireUploadStarted({item:i});};
a.prototype.terminateItem=function(i){var h=this._mRequestHandlers[i.getId()],t=this;h.xhr.onabort=function(){h.aborted=false;t.fireUploadAborted({item:i});};h.aborted=true;h.xhr.abort();};
a.prototype.downloadItem=function(i,h,A){var u=this.getDownloadUrl()||i.getUrl();if(D.browser.name==="sf"){A=false;}if(!i.getUrl()){L.warning("Items to download do not have a URL.");return false;}else if(A){var b=null,x=new window.XMLHttpRequest();x.open("GET",u);h.forEach(function(o){x.setRequestHeader(o.getKey(),o.getText());});x.responseType="blob";x.onload=function(){var f=i.getFileName(),s=U._splitFileName(f,false);b=x.response;F.save(b,s.name,s.extension,i.getMediaType(),"utf-8");};x.send();return true;}else{M.URLHelper.redirect(u,true);return true;}};
return a;});
sap.ui.predefine('sap/m/Wizard',["sap/m/library","sap/ui/core/Control","sap/ui/core/Core","sap/ui/core/delegate/ScrollEnablement","./WizardProgressNavigator","sap/ui/core/util/ResponsivePaddingsEnablement","sap/ui/Device","./WizardRenderer","sap/ui/dom/containsOrEquals","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Focusable"],function(l,C,a,S,W,R,D,b,c,L,q){"use strict";var d=l.PageBackgroundDesign;
var e=C.extend("sap.m.Wizard",{metadata:{library:"sap.m",designtime:"sap/m/designtime/Wizard.designtime",interfaces:["sap.f.IDynamicPageStickyContent"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"auto"},height:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:"100%"},showNextButton:{type:"boolean",group:"Behavior",defaultValue:true},finishButtonText:{type:"string",group:"Appearance",defaultValue:"Review"},enableBranching:{type:"boolean",group:"Behavior",defaultValue:false},backgroundDesign:{type:"sap.m.PageBackgroundDesign",group:"Appearance",defaultValue:d.Standard}},defaultAggregation:"steps",aggregations:{steps:{type:"sap.m.WizardStep",multiple:true,singularName:"step"},_progressNavigator:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_nextButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},associations:{
/**
					 * This association controls the current activated step of the wizard (meaning the last step)
					 * For example if we have A->B->C->D steps, we are on step A and we setCurrentStep(C) A,B and C are going to be activated. D will still remain unvisited.
					 * The parameter needs to be a Wizard step that is part of the current Wizard
					 * @since 1.50
					 */
currentStep:{type:"sap.m.WizardStep",multiple:false}},events:{stepActivate:{parameters:{index:{type:"int"}}},complete:{parameters:{}}},dnd:{draggable:false,droppable:true}}});
e.CONSTANTS={MINIMUM_STEPS:3,MAXIMUM_STEPS:8,ANIMATION_TIME:300,SCROLL_OFFSET:16};R.call(e.prototype,{header:{suffix:"progressNavigator"},content:{suffix:"step-container"}});
e.prototype.init=function(){this._iStepCount=0;this._aStepPath=[];this._bScrollLocked=false;this._oScroller=this._initScrollEnablement();this._oResourceBundle=a.getLibraryResourceBundle("sap.m");this._initProgressNavigator();this._initResponsivePaddingsEnablement();};
e.prototype.onBeforeRendering=function(){var s=this._getStartingStep();if(!this._isMinStepCountReached()||this._isMaxStepCountExceeded()){L.error("The Wizard is supposed to handle from 3 to 8 steps.");}this._saveInitialValidatedState();if(s&&this._aStepPath.indexOf(s)<0){this._activateStep(s);s._setNumberInvisibleText(1);}};
e.prototype.onAfterRendering=function(){if(!this.getCurrentStep()){this.setAssociation("currentStep",this._getStartingStep(),true);}var s=this._getCurrentStepInstance();if(s){this._activateAllPreceedingSteps(s);}this._attachScrollHandler();};
e.prototype.exit=function(){var o=this.getDomRef("step-container");if(o){o.onscroll=null;}this._oScroller.destroy();this._oScroller=null;this._aStepPath=null;this._iStepCount=null;this._bScrollLocked=null;this._oResourceBundle=null;};
e.prototype.validateStep=function(s){if(!this._containsStep(s)){L.error("The wizard does not contain this step");return this;}s.setValidated(true);return this;};
e.prototype.invalidateStep=function(s){if(!this._containsStep(s)){L.error("The wizard does not contain this step");return this;}s.setValidated(false);return this;};
e.prototype.nextStep=function(){var i=this._getProgressNavigator().getProgress()-1;var o=this._aStepPath[i];this.validateStep(o);o._complete();return this;};
e.prototype.previousStep=function(){var p=this._getProgressNavigator().getProgress()-2;if(p>=0){this.discardProgress(this._aStepPath[p]);}return this;};
e.prototype.getProgress=function(){return this._getProgressNavigator().getProgress();};
e.prototype.getProgressStep=function(){return this._aStepPath[this.getProgress()-1];};
e.prototype.goToStep=function(s,f){if(!this.getVisible()||this._aStepPath.indexOf(s)<0){return this;}s._setNumberInvisibleText(this.getProgress());var t=this,m={scrollTop:this._getStepScrollOffset(s)},A={queue:false,duration:e.CONSTANTS.ANIMATION_TIME,start:function(){t._bScrollLocked=true;},complete:function(){t._bScrollLocked=false;var p=t._getProgressNavigator();if(!p){return;}p._updateCurrentStep(t._aStepPath.indexOf(s)+1);if(f||f===undefined){t._focusFirstStepElement(s);}}};q(this.getDomRef("step-container")).animate(m,A);return this;};
e.prototype.discardProgress=function(s,p){var P=this.getProgress(),f=this._aStepPath,I=this._aStepPath.indexOf(s),o=this._aStepPath[I],g=I+1;if(g>P||g<=0){L.warning("The given step is either not yet reached, or is not present in the wizard control.");return this;}this._getProgressNavigator().discardProgress(g,true);this._updateProgressNavigator();this._restoreInitialValidatedState(g);for(var i=g;i<f.length;i++){f[i]._deactivate();if(f[i].getSubsequentSteps().length>1){f[i].setNextStep(null);}}this.setAssociation("currentStep",s);o.setWizardContext({sButtonText:this._getNextButtonText(),bLast:true});if(s.getSubsequentSteps().length>1&&!p){s.setNextStep(null);}f.splice(g);return this;};
e.prototype.setCurrentStep=function(s){var o=(typeof s==="string")?a.byId(s):s;if(!this.getEnableBranching()){this.setAssociation("currentStep",s,true);}if(o&&this._isStepReachable(o)){this._activateAllPreceedingSteps(o);}else{L.error("The given step could not be set as current step.");}return this;};
e.prototype.setShowNextButton=function(v){this.setProperty("showNextButton",v,true);this.getSteps().forEach(function(s){s.setWizardContext({bParentAllowsButtonShow:v});});return this;};
e.prototype.getFinishButtonText=function(){if(this.getProperty("finishButtonText")==="Review"){return this._oResourceBundle.getText("WIZARD_FINISH");}else{return this.getProperty("finishButtonText");}};
e.prototype.addStep=function(w){if(this._isMaxStepCountExceeded()){L.error("The Wizard is supposed to handle up to 8 steps.");return this;}w.setWizardContext({bParentAllowsButtonShow:this.getShowNextButton()});this._incrementStepCount();return this.addAggregation("steps",w);};
e.prototype.setBackgroundDesign=function(B){var s=this.getBackgroundDesign();this.setProperty("backgroundDesign",B,true);this.$().removeClass("sapMWizardBg"+s).addClass("sapMWizardBg"+this.getBackgroundDesign());return this;};
e.prototype.insertStep=function(w,i){throw new Error("Dynamic step insertion is not yet supported.");};
e.prototype.removeStep=function(w){throw new Error("Dynamic step removal is not yet supported.");};
e.prototype.removeAllSteps=function(){this._resetStepCount();return this.removeAllAggregation("steps").map(function(s){return s;},this);};
e.prototype.destroySteps=function(){this._resetStepCount();return this.destroyAggregation("steps");};
e.prototype._getStickyContent=function(){return this._getProgressNavigator();};
e.prototype._returnStickyContent=function(){if(this.bIsDestroyed){return;}this._getStickyContent().$().prependTo(this.$());};
e.prototype._setStickySubheaderSticked=function(i){this._bStickyContentSticked=i;};
e.prototype._getStickySubheaderSticked=function(){return this._bStickyContentSticked;};
e.prototype._activateAllPreceedingSteps=function(s){if(this._aStepPath.indexOf(s)>=0){this.discardProgress(s,true);return;}while(this.getProgressStep()!==s){this.nextStep();}};
e.prototype._isNextStepDetermined=function(s,p){if(!this.getEnableBranching()){return true;}s=s||this._getCurrentStepInstance();return this._getNextStep(s,p)!==null;};
e.prototype._isStepReachable=function(s){if(this.getEnableBranching()){var o=this._getStartingStep();while(o!==s){o=o._getNextStepReference();if(o==null){return false;}}this.setAssociation("currentStep",s);return true;}else{return this.getSteps().indexOf(s)>=0;}};
e.prototype._initScrollEnablement=function(){return new S(this,null,{scrollContainerId:this.getId()+"-step-container",horizontal:false,vertical:true});};
e.prototype._initProgressNavigator=function(){var t=this,p=new W(this.getId()+"-progressNavigator",{stepChanged:this._handleStepChanged.bind(this)});p._setOnEnter(function(E,s){var o=t._aStepPath[s];setTimeout(function(){this._focusFirstStepElement(o);}.bind(t),e.CONSTANTS.ANIMATION_TIME);});this.setAggregation("_progressNavigator",p);};
e.prototype._handleNextButtonPress=function(){var p=this._getProgressNavigator(),P=p.getProgress(),s=this.isStepFinal();if(s){this.fireComplete();}else{var o=this.getProgressStep();if(!this._isNextStepDetermined(o,P)){throw new Error("The wizard is in branching mode, and the nextStep association is not set.");}p.incrementProgress();this._handleStepActivated(p.getProgress());this._handleStepChanged(p.getProgress());}};
e.prototype._getStepScrollOffset=function(s){var i=this._oScroller.getScrollTop(),p=this._getCurrentStepInstance(),n=this._getNextButton(),A=0,f=0;if(s&&s.$()&&s.$().position()){f=s.$().position().top||0;}if(!D.system.phone&&p&&n&&!c(p.getDomRef(),n.getDomRef())){A=n.$().outerHeight();}return(i+f)-(e.CONSTANTS.SCROLL_OFFSET+A);};
e.prototype._focusFirstStepElement=function(s){var $=s.$();if($&&$.firstFocusableDomRef()){$.firstFocusableDomRef().focus();}};
e.prototype._handleStepChanged=function(E){var p=((typeof E==="number")?E:E.getParameter("current"))-2,P=this._aStepPath[p],s=this._getNextStep(P,p),f=D.system.desktop?true:false;this.goToStep(s,f);};
e.prototype._handleStepActivated=function(i){var p=i-2,P=this._aStepPath[p],n=this._getNextStep(P,p);this._activateStep(n);this._updateProgressNavigator();this.fireStepActivate({index:i});this.setAssociation("currentStep",this.getProgressStep(),true);this.getProgressStep().setWizardContext({bLast:true,bReviewStep:this.isStepFinal(),sButtonText:this._getNextButtonText()});};
e.prototype._isMaxStepCountExceeded=function(){var s=this._getStepCount();if(this.getEnableBranching()){return false;}return s>=e.CONSTANTS.MAXIMUM_STEPS;};
e.prototype._isMinStepCountReached=function(){var s=this._getStepCount();return s>=e.CONSTANTS.MINIMUM_STEPS;};
e.prototype._getStepCount=function(){return this._iStepCount;};
e.prototype._incrementStepCount=function(){this._iStepCount+=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
e.prototype._decrementStepCount=function(){this._iStepCount-=1;this._getProgressNavigator().setStepCount(this._getStepCount());};
e.prototype._resetStepCount=function(){this._iStepCount=0;this._getProgressNavigator().setStepCount(this._getStepCount());};
e.prototype._getProgressNavigator=function(){return this.getAggregation("_progressNavigator");};
e.prototype._saveInitialValidatedState=function(){if(this._aInitialValidatedState){return;}this._aInitialValidatedState=this.getSteps().map(function(s){return s.getValidated();});};
e.prototype._restoreInitialValidatedState=function(I){var s=this._aStepPath,A=this.getSteps();for(var i=I;i<s.length;i++){var o=s[i],f=A.indexOf(o),g=this._aInitialValidatedState[f];o.setValidated(g);}};
e.prototype._getNextStep=function(s,p){if(!this.getEnableBranching()){return this.getSteps()[p+1];}if(p<0){return this._getStartingStep();}var n=s._getNextStepReference();if(n===null){throw new Error("The wizard is in branching mode, and no next step is defined for "+"the current step, please set one.");}if(!this._containsStep(n)){throw new Error("The next step that you have defined is not part of the wizard steps aggregation."+"Please add it to the wizard control.");}var f=s.getSubsequentSteps();if(f.length>0&&!s._containsSubsequentStep(n.getId())){throw new Error("The next step that you have defined is not contained inside the subsequentSteps"+" association of the current step.");}return n;};
e.prototype.isStepFinal=function(){var s,i=this._getStepCount(),p=this.getProgress();if(this.getEnableBranching()){s=this._aStepPath[this._aStepPath.length-1]._isLeaf();}else{s=p===i;}return s;};
e.prototype._getNextButtonText=function(){if(this.isStepFinal()){return this.getFinishButtonText();}else{return this._oResourceBundle.getText("WIZARD_STEP")+" "+(this.getProgress()+1);}};
e.prototype._getNextButton=function(){var s=this._getCurrentStepInstance();if(s){return s.getAggregation("_nextButton");}else{return null;}};
e.prototype._updateProgressNavigator=function(){var p=this._getProgressNavigator(),o=this._getStartingStep(),A=this.getSteps(),s=[o.getTitle()],f=[o.getIcon()],g=[o.getOptional()],i=1;if(this.getEnableBranching()){while(!o._isLeaf()&&o._getNextStepReference()!==null){i++;o=o._getNextStepReference();s.push(o.getTitle());g.push(o.getOptional());f.push(o.getIcon());}p.setVaryingStepCount(o._isBranched());p.setStepCount(i);}else{s=A.map(function(h){return h.getTitle();});g=A.map(function(h){return h.getOptional();});f=A.map(function(h){return h.getIcon();});}p.setStepTitles(s);p._aStepOptionalIndication=g;p.setStepIcons(f);};
e.prototype._getStartingStep=function(){return this.getSteps()[0];};
e.prototype._attachScrollHandler=function(){var o=this.getDomRef("step-container");o.onscroll=this._scrollHandler.bind(this);};
e.prototype._scrollHandler=function(E){if(this._bScrollLocked){return;}var s=E.target.scrollTop,p=this._getProgressNavigator(),o=this._aStepPath[p.getCurrentStep()-1].getDomRef();if(!o){return;}var i=o.clientHeight,f=o.offsetTop,g=100;if(s+g>=f+i&&p._isActiveStep(p._iCurrentStep+1)){p.nextStep();}var h=this.getSteps();for(var j=0;j<h.length;j++){if(s+g<=f){p.previousStep();o=this._aStepPath[p.getCurrentStep()-1].getDomRef();if(!o){break;}f=o.offsetTop;}}};
e.prototype._getCurrentStepInstance=function(){return a.byId(this.getCurrentStep());};
e.prototype._containsStep=function(s){return this.getSteps().some(function(o){return o===s;});};
e.prototype._checkCircularReference=function(s){if(this._aStepPath.indexOf(s)>=0){throw new Error("The step that you are trying to activate has already been visited. You are creating "+"a loop inside the wizard.");}};
e.prototype._activateStep=function(s){this._checkCircularReference(s);this._aStepPath.push(s);s._activate();};
return e;});
sap.ui.require.preload({
	"sap/m/MultiEditField.control.xml":'<core:FragmentDefinition xmlns:m="sap.m" xmlns:core="sap.ui.core" type="XML"><m:Select id="select" width="100%" items="{$this&gt;items}" change="_handleSelectionChange"><m:items><core:Item text="{$this&gt;text}" key="{$this&gt;key}" id="itemTemplate"/></m:items></m:Select></core:FragmentDefinition>',
	"sap/m/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.m","type":"library","embeds":[],"applicationVersion":{"version":"1.82.2"},"title":"The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.","description":"The main UI5 control library, with responsive controls that can be used in touch devices as well as desktop browsers.","ach":"CA-UI5-CTR","resources":"resources.json","offline":true},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.82","libs":{"sap.ui.core":{"minVersion":"1.82.2"},"sap.ui.layout":{"minVersion":"1.82.2","lazy":true},"sap.ui.unified":{"minVersion":"1.82.2","lazy":true}}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","da","de","el","en","en-US-sappsd","en-US-saptrc","es","et","fi","fr","hi","hr","hu","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","rigi","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.m.ActionListItem","sap.m.ActionSelect","sap.m.ActionSheet","sap.m.App","sap.m.Avatar","sap.m.Bar","sap.m.BusyDialog","sap.m.BusyIndicator","sap.m.Button","sap.m.Breadcrumbs","sap.m.Carousel","sap.m.CheckBox","sap.m.ColumnHeaderPopover","sap.m.ColumnListItem","sap.m.ColorPalette","sap.m.ColorPalettePopover","sap.m.ComboBox","sap.m.ComboBoxTextField","sap.m.ComboBoxBase","sap.m.CustomListItem","sap.m.CustomTile","sap.m.CustomTreeItem","sap.m.DatePicker","sap.m.DateRangeSelection","sap.m.DateTimeField","sap.m.DateTimeInput","sap.m.DateTimePicker","sap.m.Dialog","sap.m.DisplayListItem","sap.m.DraftIndicator","sap.m.FacetFilter","sap.m.FacetFilterItem","sap.m.FacetFilterList","sap.m.FeedContent","sap.m.FeedInput","sap.m.FeedListItem","sap.m.FlexBox","sap.m.FormattedText","sap.m.GenericTag","sap.m.GenericTile","sap.m.GroupHeaderListItem","sap.m.GrowingList","sap.m.HBox","sap.m.HeaderContainer","sap.m.IconTabBar","sap.m.IconTabBarSelectList","sap.m.IconTabHeader","sap.m.Image","sap.m.ImageContent","sap.m.Input","sap.m.InputBase","sap.m.InputListItem","sap.m.Label","sap.m.LightBox","sap.m.Link","sap.m.List","sap.m.ListBase","sap.m.ListItemBase","sap.m.MaskInput","sap.m.Menu","sap.m.MenuButton","sap.m.MessagePage","sap.m.MessagePopover","sap.m.MessageView","sap.m.MessageStrip","sap.m.MultiComboBox","sap.m.MultiEditField","sap.m.MultiInput","sap.m.NavContainer","sap.m.NewsContent","sap.m.NumericContent","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.NotificationListGroup","sap.m.PagingButton","sap.m.PlanningCalendarLegend","sap.m.ObjectAttribute","sap.m.ObjectHeader","sap.m.ObjectIdentifier","sap.m.ObjectListItem","sap.m.ObjectMarker","sap.m.ObjectNumber","sap.m.ObjectStatus","sap.m.OverflowToolbar","sap.m.OverflowToolbarButton","sap.m.OverflowToolbarToggleButton","sap.m.P13nColumnsPanel","sap.m.P13nGroupPanel","sap.m.P13nSelectionPanel","sap.m.P13nDimMeasurePanel","sap.m.P13nConditionPanel","sap.m.P13nDialog","sap.m.P13nFilterPanel","sap.m.P13nPanel","sap.m.P13nSortPanel","sap.m.Page","sap.m.Panel","sap.m.PDFViewer","sap.m.PlanningCalendar","sap.m.PlanningCalendarHeader","sap.m.Popover","sap.m.ProgressIndicator","sap.m.PullToRefresh","sap.m.QuickView","sap.m.QuickViewBase","sap.m.QuickViewCard","sap.m.QuickViewPage","sap.m.RadioButton","sap.m.RadioButtonGroup","sap.m.RangeSlider","sap.m.RatingIndicator","sap.m.ResponsivePopover","sap.m.ScrollContainer","sap.m.SearchField","sap.m.SegmentedButton","sap.m.Select","sap.m.SelectDialog","sap.m.SelectList","sap.m.SelectionDetails","sap.m.Shell","sap.m.SimpleFixFlex","sap.m.SinglePlanningCalendar","sap.m.SinglePlanningCalendarGrid","sap.m.SinglePlanningCalendarMonthGrid","sap.m.Slider","sap.m.SliderTooltip","sap.m.SliderTooltipBase","sap.m.SliderTooltipContainer","sap.m.SlideTile","sap.m.StepInput","sap.m.SplitApp","sap.m.SplitContainer","sap.m.StandardListItem","sap.m.StandardTreeItem","sap.m.StandardTile","sap.m.Switch","sap.m.Table","sap.m.TableSelectDialog","sap.m.TabContainer","sap.m.TabStrip","sap.m.Text","sap.m.TextArea","sap.m.Tile","sap.m.TileContainer","sap.m.TileContent","sap.m.TimePicker","sap.m.TimePickerSliders","sap.m.Title","sap.m.ToggleButton","sap.m.Token","sap.m.Tokenizer","sap.m.Toolbar","sap.m.ToolbarSpacer","sap.m.ToolbarSeparator","sap.m.Tree","sap.m.TreeItemBase","sap.m.UploadCollection","sap.m.UploadCollectionToolbarPlaceholder","sap.m.upload.UploadSet","sap.m.VBox","sap.m.ViewSettingsDialog","sap.m.WheelSlider","sap.m.WheelSliderContainer","sap.m.Wizard","sap.m.WizardStep","sap.m.semantic.DetailPage","sap.m.semantic.SemanticPage","sap.m.semantic.ShareMenuPage","sap.m.semantic.FullscreenPage","sap.m.semantic.MasterPage"],"elements":["sap.m.BadgeCustomData","sap.m.Column","sap.m.ColumnPopoverActionItem","sap.m.ColumnPopoverCustomItem","sap.m.ColumnPopoverItem","sap.m.ColumnPopoverSortItem","sap.m.FlexItemData","sap.m.FeedListItemAction","sap.m.IconTabFilter","sap.m.IconTabSeparator","sap.m.LightBoxItem","sap.m.OverflowToolbarLayoutData","sap.m.MaskInputRule","sap.m.MenuItem","sap.m.MessageItem","sap.m.MessagePopoverItem","sap.m.PageAccessibleLandmarkInfo","sap.m.P13nFilterItem","sap.m.P13nItem","sap.m.PlanningCalendarRow","sap.m.PlanningCalendarView","sap.m.P13nColumnsItem","sap.m.P13nDimMeasureItem","sap.m.P13nGroupItem","sap.m.P13nSortItem","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.ResponsiveScale","sap.m.SegmentedButtonItem","sap.m.SelectionDetailsItem","sap.m.SelectionDetailsItemLine","sap.m.SinglePlanningCalendarDayView","sap.m.SinglePlanningCalendarMonthView","sap.m.SinglePlanningCalendarWeekView","sap.m.SinglePlanningCalendarWorkWeekView","sap.m.SinglePlanningCalendarView","sap.m.SuggestionItem","sap.m.TabContainerItem","sap.m.TabStripItem","sap.m.ToolbarLayoutData","sap.m.UploadCollectionItem","sap.m.UploadCollectionParameter","sap.m.upload.Uploader","sap.m.upload.UploadSetItem","sap.m.ViewSettingsCustomItem","sap.m.ViewSettingsCustomTab","sap.m.ViewSettingsFilterItem","sap.m.ViewSettingsItem","sap.m.plugins.DataStateIndicator","sap.m.plugins.PluginBase","sap.m.semantic.AddAction","sap.m.semantic.CancelAction","sap.m.semantic.DeleteAction","sap.m.semantic.DiscussInJamAction","sap.m.semantic.EditAction","sap.m.semantic.FavoriteAction","sap.m.semantic.FilterAction","sap.m.semantic.FilterSelect","sap.m.semantic.FlagAction","sap.m.semantic.ForwardAction","sap.m.semantic.GroupAction","sap.m.semantic.GroupSelect","sap.m.semantic.MainAction","sap.m.semantic.MessagesIndicator","sap.m.semantic.MultiSelectAction","sap.m.semantic.NegativeAction","sap.m.semantic.OpenInAction","sap.m.semantic.PositiveAction","sap.m.semantic.PrintAction","sap.m.semantic.SaveAction","sap.m.semantic.SemanticButton","sap.m.semantic.SemanticControl","sap.m.semantic.SemanticSelect","sap.m.semantic.SemanticToggleButton","sap.m.semantic.SendEmailAction","sap.m.semantic.SendMessageAction","sap.m.semantic.ShareInJamAction","sap.m.semantic.SortAction","sap.m.semantic.SortSelect"],"types":["sap.m.AvatarImageFitType","sap.m.AvatarShape","sap.m.AvatarSize","sap.m.AvatarType","sap.m.AvatarColor","sap.m.BackgroundDesign","sap.m.BadgeState","sap.m.BarDesign","sap.m.BreadcrumbsSeparatorStyle","sap.m.ButtonType","sap.m.CarouselArrowsPlacement","sap.m.DateTimeInputType","sap.m.DeviationIndicator","sap.m.DialogRoleType","sap.m.DialogType","sap.m.DraftIndicatorState","sap.m.FacetFilterListDataType","sap.m.FacetFilterType","sap.m.FlexAlignContent","sap.m.FlexAlignItems","sap.m.FlexAlignSelf","sap.m.FlexDirection","sap.m.FlexJustifyContent","sap.m.FlexRendertype","sap.m.FlexWrap","sap.m.FrameType","sap.m.GenericTagDesign","sap.m.GenericTagValueState","sap.m.GenericTileMode","sap.m.GenericTileScope","sap.m.HeaderLevel","sap.m.IBarHTMLTag","sap.m.IconTabDensityMode","sap.m.IconTabFilterDesign","sap.m.IconTabHeaderMode","sap.m.ImageMode","sap.m.InputTextFormatMode","sap.m.InputType","sap.m.LabelDesign","sap.m.LightBoxLoadingStates","sap.m.LinkConversion","sap.m.ListGrowingDirection","sap.m.ListHeaderDesign","sap.m.ListKeyboardMode","sap.m.ListMode","sap.m.ListSeparators","sap.m.ListType","sap.m.LoadState","sap.m.MenuButtonMode","sap.m.ObjectHeaderPictureShape","sap.m.ObjectMarkerType","sap.m.ObjectMarkerVisibility","sap.m.OverflowToolbarPriority","sap.m.P13nPanelType","sap.m.P13nConditionOperation","sap.m.PageBackgroundDesign","sap.m.PanelAccessibleRole","sap.m.PDFViewerDisplayType","sap.m.PlacementType","sap.m.PlanningCalendarBuiltInView","sap.m.PlanningCalendarStickyMode","sap.m.PopinDisplay","sap.m.PopinLayout","sap.m.QuickViewGroupElementType","sap.m.RatingIndicatorVisualMode","sap.m.ScreenSize","sap.m.SelectionDetailsActionLevel","sap.m.SelectListKeyboardNavigationMode","sap.m.SelectType","sap.m.Size","sap.m.SplitAppMode","sap.m.StandardTileType","sap.m.StepInputStepModeType","sap.m.StepInputValidationMode","sap.m.Sticky","sap.m.StringFilterOperator","sap.m.SwipeDirection","sap.m.SwitchType","sap.m.TileSizeBehavior","sap.m.TimePickerMaskMode","sap.m.TitleAlignment","sap.m.TokenizerRenderMode","sap.m.ToolbarDesign","sap.m.ToolbarStyle","sap.m.UploadState","sap.m.ValueColor","sap.m.ValueCSSColor","sap.m.VerticalPlacementType","sap.m.WrappingType","sap.m.semantic.SemanticRuleSetType"],"interfaces":["sap.m.IBar","sap.m.IBadge","sap.m.IBreadcrumbs","sap.m.IconTab","sap.m.IScale","sap.m.semantic.IGroup","sap.m.semantic.IFilter","sap.m.semantic.ISort","sap.m.ObjectHeaderContainer","sap.m.IOverflowToolbarContent","sap.m.IOverflowToolbarFlexibleContent","sap.m.IHyphenation"]}}}}',
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
	"sap/m/ColorPalette.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/core/Control','sap/ui/Device','sap/ui/base/DataType','sap/ui/core/library','sap/ui/core/delegate/ItemNavigation','./Button','./Dialog','./library','./ColorPaletteRenderer',"sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/unified/ColorPickerDisplayMode"],function(C,D,a,c,I,B,b,l,d,e,K,q,f){"use strict";var g=c.CSSColor;var h;var i;var j=l.ButtonType;var k=a.getType("boolean");var m="sapMColorPaletteSquare";var S=5;var M=2;var n=15;var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var o=C.extend("sap.m.ColorPalette",{metadata:{library:"sap.m",properties:{colors:{type:"sap.ui.core.CSSColor[]",group:"Appearance",defaultValue:["gold","darkorange","indianred","darkmagenta","cornflowerblue","deepskyblue","darkcyan","olivedrab","darkslategray","azure","white","lightgray","darkgray","dimgray","black"]}},aggregations:{_defaultColorButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"},_moreColorsButton:{type:"sap.m.Button",multiple:false,visibility:"hidden"}},events:{colorSelect:{parameters:{"value":{type:"sap.ui.core.CSSColor"},"defaultAction":{type:"boolean"}}}}}});
o.prototype.init=function(){this._oDefaultColor=null;this._bShowDefaultColorButton=false;this._bShowMoreColorsButton=false;this._bShowRecentColorsSection=false;this._oDisplayMode=f.Default;this._oMoreColorsDialog=null;this._oPaletteColorItemNavigation=null;this._oRecentColorItemNavigation=null;this._recentColors=[];};
o.prototype.exit=function(){if(this._oMoreColorsDialog){this._oMoreColorsDialog.destroy();delete this._oMoreColorsDialog;}if(this._oPaletteColorItemNavigation){this.removeDelegate(this._oPaletteColorItemNavigation);this._oPaletteColorItemNavigation.destroy();delete this._oPaletteColorItemNavigation;}if(this._oRecentColorItemNavigation){this.removeDelegate(this._oRecentColorItemNavigation);this._oRecentColorItemNavigation.destroy();delete this._oRecentColorItemNavigation;}};
o.prototype.setColors=function(r){r=this.validateProperty("colors",r);if(r.length<M||r.length>n){throw new Error("Cannot set property 'colors' - array must has minimum 2 and maximum 15 elements");}return this.setProperty("colors",r);};
o.prototype._setDisplayMode=function(r){var s=this._getColorPicker();s.setDisplayMode(r);this._oDisplayMode=r;return this;};
o.prototype._getDisplayMode=function(){return this._oDisplayMode;};
o.prototype._getColorPicker=function(){return this._ensureMoreColorsDialog()._oColorPicker;};
o.prototype.ontap=function(E){var t=q(E.target),s,$;$=t.closest("."+m);if(!$.length){return;}s=$.attr("data-sap-ui-color");this._fireColorSelect(s,false,E);};
o.prototype.onsaptabnext=o.prototype.onsaptabprevious=function(E){var r=this._getElementInfo(E.target);if(r.bIsMoreColorsButton){this.fireEvent("_colorNotSelected",{_originalEvent:E});return;}if(r.bIsDefaultColorButton){this._fireColorSelect(this._getDefaultColor(),true,E);return;}o.prototype.ontap.apply(this,arguments);};o.prototype.onsapenter=o.prototype.ontap;
o.prototype.onsapspace=function(E){E.preventDefault();};
o.prototype.onkeyup=function(E){if(E.which===K.SPACE){E.preventDefault();o.prototype.ontap.apply(this,arguments);}};
o.prototype.onAfterRendering=function(){this._ensureItemNavigation();};
o.prototype.pushToRecentColors=function(s){var r=this._recentColors.indexOf(s);if(r>-1){this._recentColors.splice(r,1);}else if(this._recentColors.length===5){this._recentColors.pop();}this._recentColors.unshift(s);this.invalidate();};
o.prototype.setColorPickerSelectedColor=function(r){if(!g.isValid(r)){throw new Error("Cannot set the selected color - invalid value: "+r);}this._getColorPicker().setColorString(r);return this;};
o.prototype._createDefaultColorButton=function(){return new B(this.getId()+"-btnDefaultColor",{width:"100%",type:j.Transparent,text:L.getText("COLOR_PALETTE_DEFAULT_COLOR"),visible:this._getShowDefaultColorButton(),press:function(E){this._fireColorSelect(this._getDefaultColor(),true,E);}.bind(this)});};
o.prototype._getDefaultColor=function(){return this._oDefaultColor;};
o.prototype._setDefaultColor=function(r){if(!g.isValid(r)){throw new Error("Cannot set internal property '_defaultColor' - invalid value: "+r);}this._oDefaultColor=r;return this;};
o.prototype._getShowDefaultColorButton=function(){return this._bShowDefaultColorButton;};
o.prototype._setShowDefaultColorButton=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showDefaultColorButton' - invalid value: "+v);}this._bShowDefaultColorButton=v;if(v&&!this._getDefaultColorButton()){this.setAggregation("_defaultColorButton",this._createDefaultColorButton());}if(this._getDefaultColorButton()){this._getDefaultColorButton().setVisible(v);}return this;};
o.prototype._getDefaultColorButton=function(){return this.getAggregation("_defaultColorButton");};
o.prototype._createMoreColorsButton=function(){return new B(this.getId()+"-btnMoreColors",{width:"100%",type:j.Transparent,text:L.getText("COLOR_PALETTE_MORE_COLORS"),visible:this._getShowMoreColorsButton(),press:this._openColorPicker.bind(this)});};
o.prototype._getShowMoreColorsButton=function(){return this._bShowMoreColorsButton;};
o.prototype._getShowRecentColorsSection=function(){return this._bShowRecentColorsSection;};
o.prototype._getRecentColors=function(){return this._recentColors;};
o.prototype._setShowRecentColorsSection=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showRecentColorsSection' - invalid value: "+v);}this._bShowRecentColorsSection=v;return this;};
o.prototype._setShowMoreColorsButton=function(v){if(!k.isValid(v)){throw new Error("Cannot set internal property 'showMoreColorsButton' - invalid value: "+v);}this._bShowMoreColorsButton=v;if(v&&!this._getMoreColorsButton()){this.setAggregation("_moreColorsButton",this._createMoreColorsButton());}if(this._getMoreColorsButton()){this._getMoreColorsButton().setVisible(v);}return this;};
o.prototype._getMoreColorsButton=function(){return this.getAggregation("_moreColorsButton");};
o.prototype._openColorPicker=function(){this.fireEvent("_beforeOpenColorPicker");this._ensureMoreColorsDialog().open();};
o.prototype._ensureMoreColorsDialog=function(){if(!this._oMoreColorsDialog){this._oMoreColorsDialog=this._createMoreColorsDialog();}return this._oMoreColorsDialog;};
o.prototype._createMoreColorsDialog=function(){var r=new b(this.getId()+"-moreColorsDialog",{stretch:!!D.system.phone,title:L.getText("COLOR_PALETTE_MORE_COLORS_TITLE")}).addStyleClass("CPDialog");this._ensureUnifiedLibrary();r.addContent(r._oColorPicker=new h({mode:i.HSL,displayMode:this._oDisplayMode}));r.setBeginButton(new B({text:L.getText("COLOR_PALETTE_MORE_COLORS_CONFIRM"),press:function(E){r.close();if(r._oColorPicker.getColorString()){this._fireColorSelect(r._oColorPicker.getColorString(),false,E);}}.bind(this)}));r.setEndButton(new B({text:L.getText("COLOR_PALETTE_MORE_COLORS_CANCEL"),press:function(){r.close();}}));return r;};
o.prototype._ensureUnifiedLibrary=function(){var u;if(!h){sap.ui.getCore().loadLibrary("sap.ui.unified");u=sap.ui.require("sap/ui/unified/library");h=sap.ui.requireSync("sap/ui/unified/ColorPicker");i=u.ColorPickerMode;}};
o.prototype._focusFirstElement=function(){var F=this._getShowDefaultColorButton()?this._getDefaultColorButton().getDomRef():this._getAllPaletteColorSwatches()[0];F.focus();};
o.prototype._fireColorSelect=function(r,s,O){this.fireColorSelect({value:r,defaultAction:s,_originalEvent:O});this.pushToRecentColors(r);};
o.prototype._ensureItemNavigation=function(){var P=[],r=[];if(!this._oPaletteColorItemNavigation){this._oPaletteColorItemNavigation=new p(this);this._oPaletteColorItemNavigation.setColumns(S);this._oPaletteColorItemNavigation.setCycling(false);this.addDelegate(this._oPaletteColorItemNavigation);this._oPaletteColorItemNavigation.attachEvent(I.Events.BorderReached,this._onSwatchContainerBorderReached,this);}if(!this._oRecentColorItemNavigation){this._oRecentColorItemNavigation=new p(this);this._oRecentColorItemNavigation.setColumns(S);this._oRecentColorItemNavigation.setCycling(false);this.addDelegate(this._oRecentColorItemNavigation);this._oRecentColorItemNavigation.attachEvent(I.Events.BorderReached,this._onSwatchContainerBorderReached,this);}P=P.concat(this._getAllPaletteColorSwatches());r=r.concat(this._getAllRecentColorSwatches());r=r.slice(0,this._getRecentColors().length);this._oPaletteColorItemNavigation.setRootDomRef(this.getDomRef("swatchCont-paletteColor"));this._oPaletteColorItemNavigation.setItemDomRefs(P);this._oRecentColorItemNavigation.setRootDomRef(this.getDomRef("swatchCont-recentColors"));this._oRecentColorItemNavigation.setItemDomRefs(r);};
o.prototype._onSwatchContainerBorderReached=function(E){var N,s,H=["saphome","sapend"].indexOf(E.getParameter("event").type)>-1,r=this._getAllRecentColorSwatches()[0]?this._getElementInfo(E.mParameters.event.target).bIsRecentColorSwatch:false;if(E.getParameter(p.BorderReachedDirection)===p.BorderReachedDirectionForward){if(this._getShowMoreColorsButton()&&!r){N=this._getMoreColorsButton();}else if(!H&&this._bShowRecentColorsSection&&!r&&this._getRecentColors().length>0){N=this._getAllRecentColorSwatches()[0];}else if(!H&&this._getShowDefaultColorButton()){N=this._getDefaultColorButton();}else if(!H){N=this._getAllPaletteColorSwatches()[0];}}else{if(this._getShowDefaultColorButton()&&!r){N=this._getDefaultColorButton();}else if(!H&&this._bShowRecentColorsSection&&!r&&this._getRecentColors().length>0){N=this._getAllRecentColorSwatches()[0];}else if(!H&&this._getShowMoreColorsButton()){N=this._getMoreColorsButton();}else if(!H&&!this._getShowDefaultColorButton()){s=this._getAllPaletteColorSwatches();N=s[s.length-1];}else if(!H){s=this._getAllPaletteColorSwatches();N=s[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()];}}if(N){N.focus();}return N;};
o.prototype.onsapnext=function(E){var N,r=this._getElementInfo(E.target);if(!(r.bIsDefaultColorButton||r.bIsMoreColorsButton)){return;}E.preventDefault();E.stopImmediatePropagation(true);if(r.bIsDefaultColorButton){N=this._getAllPaletteColorSwatches()[0];}else if(this._getRecentColors().length>0&&!r.bIsRecentColorSwatch&&this._bShowRecentColorsSection){N=this._getAllRecentColorSwatches()[0];}else{N=this._getShowDefaultColorButton()?this._getDefaultColorButton():this._getAllPaletteColorSwatches()[0];}N.focus();};
o.prototype.onsapprevious=function(E){var N,F=this._getElementInfo(E.target),A;if(!(F.bIsDefaultColorButton||F.bIsMoreColorsButton||E.target===this._getAllRecentColorSwatches()[0])){return;}E.preventDefault();E.stopImmediatePropagation(true);A=this._getAllPaletteColorSwatches();if(F.bIsMoreColorsButton||(!F.bIsMoreColorsButton&&this.bIsRecentColorSwatch)){N=E.keyCode===K.ARROW_UP?A[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()]:A[A.length-1];}else if(F.bIsRecentColorSwatch&&!this._bShowMoreColorsButton&&!this._bShowDefaultColorButton){A=this._getAllPaletteColorSwatches();N=A[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()];}else if(this._getRecentColors().length>0&&!F.bIsRecentColorSwatch&&this._bShowRecentColorsSection){N=this._getAllRecentColorSwatches()[0];}else if(this._getShowMoreColorsButton()){N=this._getMoreColorsButton();}else{N=A[this._oPaletteColorItemNavigation._getIndexOfTheFirstItemInLastRow()];}N.focus();};
o.prototype.onsaphome=function(E){var r=this._getElementInfo(E.target);if(!r.bIsMoreColorsButton){return;}if(this._getShowDefaultColorButton()){this._getDefaultColorButton().focus();}E.preventDefault();E.stopImmediatePropagation(true);};
o.prototype.onsapend=function(E){var r=this._getElementInfo(E.target);if(!r.bIsDefaultColorButton){return;}if(this._getShowMoreColorsButton()){this._getMoreColorsButton().focus();}E.preventDefault();E.stopImmediatePropagation(true);};
o.prototype._getAllPaletteColorSwatches=function(){return this.$().find("."+m).get().slice(0,this.getColors().length);};
o.prototype._getAllRecentColorSwatches=function(){return this.$().find("."+m).get().slice(this.getColors().length);};
o.prototype._getElementInfo=function(E){var r=this._getShowDefaultColorButton()&&e(E,this._getDefaultColorButton().getDomRef()),s=!r&&this._getShowMoreColorsButton()&&e(E,this._getMoreColorsButton().getDomRef()),t=this._getAllRecentColorSwatches().indexOf(E)>-1,u=this._getAllPaletteColorSwatches().indexOf(E)>-1;return{bIsDefaultColorButton:r,bIsMoreColorsButton:s,bIsASwatch:u,bIsRecentColorSwatch:t};};
var p=I.extend("sap.m.ItemNavigationHomeEnd",{constructor:function(){I.apply(this,arguments);this.setHomeEndColumnMode(true);this.fireEvent=function(N,E){var s;if(N===I.Events.BorderReached){s=p.BorderReachedDirectionBackward;if(["sapnext","sapend"].indexOf(E.event.type)>-1){s=p.BorderReachedDirectionForward;}E[p.BorderReachedDirection]=s;}I.prototype.fireEvent.apply(this,arguments);};}});
p.BorderReachedDirection="direction";p.BorderReachedDirectionForward="BorderReachedDirectionForward";p.BorderReachedDirectionBackward="BorderReachedDirectionBackward";
p.prototype.getColumns=function(){return this.iColumns;};
p.prototype.onsapprevious=function(E){var r=e(this.getRootDomRef(),E.target),A=E.keyCode===K.ARROW_UP&&this.getFocusedIndex()===0;if(!r){return;}if(!A){I.prototype.onsapprevious.apply(this,arguments);return;}E.preventDefault();this.fireEvent(I.Events.BorderReached,{index:0,event:E});};
p.prototype.onsapnext=function(E){var r=e(this.getRootDomRef(),E.target),s,t,u;if(!r){return;}if(E.keyCode!==K.ARROW_DOWN){I.prototype.onsapnext.apply(this,arguments);return;}t=this.getFocusedIndex();u=this._getItemInfo(t);if(u.bIsLastItem&&u.bIsInTheLastColumn){E.preventDefault();this.fireEvent(I.Events.BorderReached,{index:t,event:E});return;}if(u.bNextRowExists&&!u.bItemSameColumnNextRowExists){E.preventDefault();s=this.getItemDomRefs();s[s.length-1].focus();return;}I.prototype.onsapnext.apply(this,arguments);};
p.prototype.onsaphome=function(E){var r=e(this.getRootDomRef(),E.target),s;if(!r){return;}s=this._getItemInfo(this.getFocusedIndex());if(!s.bIsInTheFirstColumn){I.prototype.onsaphome.apply(this,arguments);return;}E.preventDefault();if(s.bIsFirstItem){this.fireEvent(I.Events.BorderReached,{index:0,event:E});}else{this.getItemDomRefs()[0].focus();}};
p.prototype.onsapend=function(E){var r=e(this.getRootDomRef(),E.target),s;if(!r){return;}s=this._getItemInfo(this.getFocusedIndex());if(!(s.bIsLastItem||s.bIsInTheLastColumn)){I.prototype.onsapend.apply(this,arguments);return;}E.preventDefault();if(s.bIsLastItem){this.fireEvent(I.Events.BorderReached,{index:this.getItemDomRefs().length-1,event:E});}else{this.getItemDomRefs()[this.getItemDomRefs().length-1].focus();}};
p.prototype._getItemInfo=function(r){var s=this.getItemDomRefs().length,t=r===(s-1),u=s>this.getColumns()?this.getColumns():s,v=r%this.getColumns()===0,w=(r+1)%u===0,x=Math.floor(r/this.getColumns())+1,N,y;N=x*this.getColumns()<s;y=N&&(r+this.getColumns())<s;return{bIsFirstItem:r===0,bIsLastItem:t,bIsInTheLastColumn:w,bIsInTheFirstColumn:v,bNextRowExists:N,bItemSameColumnNextRowExists:y};};
p.prototype._getIndexOfTheFirstItemInLastRow=function(){return Math.floor((this.getItemDomRefs().length-1)/this.getColumns())*this.getColumns();};
o.prototype._ItemNavigation=p;o.prototype._ColorsHelper={RGB_TO_NAMED_COLORS_MAP:{"#FFB200":"gold","#FF8C00":"darkorange","#CD5C5C":"indianred","#8B008B":"darkmagenta","#6495ED":"cornflowerblue","#00BFFF":"deepskyblue","#008B8B":"darkcyan","#6B8E23":"olivedrab","#2F4F4F":"darkslategray","#F0FFFF":"azure","#FFFFFF":"white","#D3D3D3":"lightgray","#A9A9A9":"darkgray","#696969":"dimgray","#000000":"black"},NAME_COLORS_TO_RGB_MAP:{"gold":"#FFB200","darkorange":"#FF8C00","indianred":"#CD5C5C","darkmagenta":"#8B008B","cornflowerblue":"#6495ED","deepskyblue":"#00BFFF","darkcyan":"#008B8B","olivedrab":"#6B8E23","darkslategray":"#2F4F4F","azure":"#F0FFFF","white":"#FFFFFF","lightgray":"#D3D3D3","darkgray":"#A9A9A9","dimgray":"#696969","black":"#000000"},getNamedColor:function(s){var H="";if(!s||s.toLowerCase().indexOf("hsl")!==-1){return undefined;}if(s.indexOf("#")===-1){return this.NAME_COLORS_TO_RGB_MAP[s.toLowerCase()]?s.toLowerCase():undefined;}if(s.length===4){H=["#",s[1],s[1],s[2],s[2],s[3],s[3]].join("");}else{H=s;}H=H.toUpperCase();return this.RGB_TO_NAMED_COLORS_MAP[H];}};return o;});
},
	"sap/m/ColorPalettePopover.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/core/Control','sap/ui/Device','sap/ui/unified/ColorPickerDisplayMode','./Button','./ResponsivePopover','./ColorPalette','./library'],function(C,D,a,B,R,b,l){"use strict";var P=l.PlacementType;
var c=C.extend("sap.m.ColorPalettePopover",{
metadata:{library:"sap.m",publicMethods:["openBy","close"],properties:{defaultColor:{type:"sap.ui.core.CSSColor",group:"Appearance",defaultValue:null},colors:{type:"sap.ui.core.CSSColor[]",group:"Appearance",defaultValue:["gold","darkorange","indianred","darkmagenta","cornflowerblue","deepskyblue","darkcyan","olivedrab","darkslategray","azure","white","lightgray","darkgray","dimgray","black"]},showDefaultColorButton:{type:"boolean",group:"Appearance",defaultValue:true},showMoreColorsButton:{type:"boolean",group:"Appearance",defaultValue:true},showRecentColorsSection:{type:"boolean",group:"Appearance",defaultValue:true},displayMode:{type:"sap.ui.unified.ColorPickerDisplayMode",group:"Appearance",defaultValue:a.Default}},events:{colorSelect:{parameters:{"value":{type:"sap.ui.core.CSSColor"},"defaultAction":{type:"boolean"}}}}},
renderer:{apiVersion:2}
});
var L=sap.ui.getCore().getLibraryResourceBundle("sap.m");var F={COLOR_PALETTE_PROPS:{colors:"setColors",defaultColor:"_setDefaultColor",showDefaultColorButton:"_setShowDefaultColorButton",showMoreColorsButton:"_setShowMoreColorsButton",showRecentColorsSection:"_setShowRecentColorsSection",displayMode:"_setDisplayMode"},POPOVER_METHODS:{getDomRef:"",close:"",openBy:""}};
c.prototype.init=function(){this._oPopover=null;this._bPopoverDestroying=null;};
c.prototype.exit=function(){this._bPopoverDestroying=true;if(this._oPopover){this._oPopover.removeDelegate(this._oPopover._onAfterRenderingDelegate);this._oPopover.destroy();this._oPopover=null;}};
c.prototype.setColorPickerSelectedColor=function(d){this._getPalette().setColorPickerSelectedColor(d);return this;};
c.prototype._getPalette=function(){return this._ensurePopover().getContent()[0];};
c.prototype._ensurePopover=function(){if(!this._oPopover){this._oPopover=this._createPopover();}return this._oPopover;};
c.prototype._createPopover=function(){var p,o=this._createColorPalette(),d;p=new R(this.getId()+"-colorPalettePopover",{showHeader:D.system.phone,placement:P.VerticalPreferredBottom,showArrow:false,showCloseButton:false,title:L.getText("COLOR_PALETTE_TITLE"),content:o,afterOpen:o._focusFirstElement.bind(o)}).addStyleClass("sapMColorPaletteContainer");if(D.system.phone){p.setEndButton(new B({text:L.getText("COLOR_PALETTE_CANCEL"),press:function(){p.close();}}));}o.attachEvent("_beforeOpenColorPicker",function(){p.close();});o.attachEvent("_colorNotSelected",function(e){this._handleNextOrPreviousUponPaletteClose(e);p.close();}.bind(this));o.attachEvent("colorSelect",function(e){this._handleNextOrPreviousUponPaletteClose(e);p.close();this.fireColorSelect({"value":e.getParameter("value"),"defaultAction":e.getParameter("defaultAction")});}.bind(this));d={onAfterRendering:function(){var $=this.$();$.attr("aria-modal","true");$.attr("aria-label",this.getTitle());}};p.addEventDelegate(d,p);p._onAfterRenderingDelegate=d;return p;};
c.prototype._createColorPalette=function(){var o=new b(this.getId()+"-palette");o._setShowDefaultColorButton(this.getShowDefaultColorButton());o._setShowMoreColorsButton(this.getShowMoreColorsButton());o._setShowRecentColorsSection(this.getShowRecentColorsSection());return o;};
c.prototype._handleNextOrPreviousUponPaletteClose=function(e){var o=e.getParameter("_originalEvent");if(!o){return;}if(o.type==="saptabnext"||o.type==="saptabprevious"){o.stopPropagation();o.preventDefault();}};
c.prototype.setProperty=function(p,v,s){var t;if(F.COLOR_PALETTE_PROPS[p]!==undefined){t=F.COLOR_PALETTE_PROPS[p]||p;b.prototype[t].call(this._getPalette(),v);}return C.prototype.setProperty.apply(this,arguments);};
Object.keys(F.POPOVER_METHODS).forEach(function(s){var t=F.COLOR_PALETTE_PROPS[s]||s;c.prototype[s]=function(){if(this._bPopoverDestroying){return null;}var p=this._ensurePopover();return p[t].apply(p,arguments);};});return c;});
},
	"sap/m/DatePicker.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/thirdparty/jquery','sap/ui/Device','./InputBase','./DateTimeField','./Button','./ResponsivePopover','sap/ui/core/date/UniversalDate','./library','sap/ui/core/Control','sap/ui/core/library',"./DatePickerRenderer","sap/base/util/deepEqual","sap/base/assert","sap/base/Log","sap/ui/core/IconPool","./InstanceManager","sap/ui/unified/Calendar","sap/ui/unified/DateRange",'sap/ui/unified/DateTypeRange',"sap/ui/unified/calendar/CustomMonthPicker","sap/ui/unified/calendar/CustomYearPicker","sap/ui/unified/library","sap/ui/dom/jquery/cursorPos"],function(q,D,I,a,B,R,U,l,C,c,b,d,e,L,f,g,h,j,k,m,n,u){"use strict";var o=c.CalendarType;var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");
var p=a.extend("sap.m.DatePicker",{metadata:{library:"sap.m",properties:{displayFormatType:{type:"string",group:"Appearance",defaultValue:""},secondaryCalendarType:{type:"sap.ui.core.CalendarType",group:"Appearance",defaultValue:null},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null},showFooter:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{specialDates:{type:"sap.ui.core.Element",multiple:true,singularName:"specialDate"},_popup:{type:"sap.m.ResponsivePopover",multiple:false,visibility:"hidden"}},associations:{legend:{type:"sap.ui.core.Control",multiple:false}},events:{navigate:{parameters:{dateRange:{type:"sap.ui.unified.DateRange"},afterPopupOpened:{type:"boolean"}}}},designtime:"sap/m/designtime/DatePicker.designtime",dnd:{draggable:false,droppable:true}}});
p.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=false;this._bOnlyCalendar=true;this._bValid=true;this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);this._oMaxDate=new Date(9999,11,31,23,59,59,999);var i=this.addEndIcon({id:this.getId()+"-icon",src:this.getIconSrc(),noTabStop:true,tooltip:r.getText("OPEN_PICKER_TEXT")});this._bShouldClosePicker=false;i.addEventDelegate({onmousedown:function(E){this._bShouldClosePicker=!!this.isOpen();}},this);i.attachPress(function(){this.toggleOpen(this._bShouldClosePicker);},this);};
p.prototype.isValidValue=function(){return this._bValid;};
p.prototype.isOpen=function(){return this._oPopup&&this._oPopup.isOpen();};
p.prototype.toggleOpen=function(O){if(this.getEditable()&&this.getEnabled()){if(O){s.call(this);}else{_.call(this);}}};
p.prototype.getIconSrc=function(){return f.getIconURI("appointment-2");};
p.prototype.exit=function(){I.prototype.exit.apply(this,arguments);if(this._oPopup){if(this._oPopup.isOpen()){this._oPopup.close();}delete this._oPopup;}if(this._getCalendar()){this._getCalendar().destroy();delete this._getCalendar();}if(this._iInvalidateCalendar){clearTimeout(this._iInvalidateCalendar);}this._sUsedDisplayPattern=undefined;this._sUsedDisplayCalendarType=undefined;this._oDisplayFormat=undefined;this._sUsedValuePattern=undefined;this._sUsedValueCalendarType=undefined;this._oValueFormat=undefined;};
p.prototype.invalidate=function(O){if(!O||O!=this._getCalendar()){C.prototype.invalidate.apply(this,arguments);this._iInvalidateCalendar=setTimeout(y.bind(this),0);}};
p.prototype.onBeforeRendering=function(){a.prototype.onBeforeRendering.apply(this,arguments);this._checkMinMaxDate();var V=this._getValueHelpIcon();if(V){V.setProperty("visible",this.getEditable(),true);}};
p.prototype.setWidth=function(W){return I.prototype.setWidth.call(this,W||"100%");};
p.prototype.getWidth=function(W){return this.getProperty("width")||"100%";};
p.prototype.applyFocusInfo=function(F){this._bFocusNoPopup=true;if(!D.support.touch||D.system.desktop){I.prototype.applyFocusInfo.apply(this,arguments);}};
p.prototype.onfocusin=function(E){if(!q(E.target).hasClass("sapUiIcon")){I.prototype.onfocusin.apply(this,arguments);}this._bFocusNoPopup=undefined;};
p.prototype.onsapshow=function(E){this.toggleOpen(this.isOpen());E.preventDefault();};
p.prototype.onsaphide=p.prototype.onsapshow;
p.prototype.onsappageup=function(E){var i=this._getCalendarConstructor().getMetadata().getName();E.preventDefault();if(i!="sap.ui.unified.Calendar"){return;}this._increaseDate(1,"day");};
p.prototype.onsappageupmodifiers=function(E){var i=this._getCalendarConstructor().getMetadata().getName();E.preventDefault();if(!E.ctrlKey&&E.shiftKey){if(i=="sap.ui.unified.internal.CustomYearPicker"){return;}this._increaseDate(1,"month");}else{this._increaseDate(1,"year");}};
p.prototype.onsappagedown=function(E){var i=this._getCalendarConstructor().getMetadata().getName();E.preventDefault();if(i!="sap.ui.unified.Calendar"){return;}this._increaseDate(-1,"day");};
p.prototype.onsappagedownmodifiers=function(E){var i=this._getCalendarConstructor().getMetadata().getName();E.preventDefault();if(!E.ctrlKey&&E.shiftKey){if(i=="sap.ui.unified.internal.CustomYearPicker"){return;}this._increaseDate(-1,"month");}else{this._increaseDate(-1,"year");}};
p.prototype.onkeypress=function(E){if(!E.charCode||E.metaKey||E.ctrlKey){return;}var F=this._getFormatter(true);var i=String.fromCharCode(E.charCode);if(i&&F.sAllowedCharacters&&F.sAllowedCharacters.indexOf(i)<0){E.preventDefault();}};
p.prototype._getValueHelpIcon=function(){var V=this.getAggregation("_endIcon");return V&&V[0];};
p.prototype._dateValidation=function(i){this._bValid=true;if(i&&(i.getTime()<this._oMinDate.getTime()||i.getTime()>this._oMaxDate.getTime())){this._bValid=false;e(this._bValid,"Date must be in valid range");}this.setProperty("dateValue",i);return i;};
p.prototype.setMinDate=function(i){if(!this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getMinDate(),i)){return this;}if(i){var Y=i.getFullYear();if(Y<1||Y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMinDate=new Date(i.getTime());var z=this.getDateValue();if(z&&z.getTime()<i.getTime()){this._bValid=false;L.warning("DateValue not in valid date range",this);}}else{this._oMinDate=new Date(1,0,1);this._oMinDate.setFullYear(1);}this.setProperty("minDate",i);if(this._getCalendar()){this._getCalendar().setMinDate(i);}this._oMinDate.setHours(0,0,0,0);return this;};
p.prototype.setMaxDate=function(i){if(!this._isValidDate(i)){throw new Error("Date must be a JavaScript date object; "+this);}if(d(this.getMaxDate(),i)){return this;}if(i){var Y=i.getFullYear();if(Y<1||Y>9999){throw new Error("Date must be between 0001-01-01 and 9999-12-31; "+this);}this._oMaxDate=new Date(i.getTime());var z=this.getDateValue();if(z&&z.getTime()>i.getTime()){this._bValid=false;L.warning("DateValue not in valid date",this);}}else{this._oMaxDate=new Date(9999,11,31,23,59,59,999);}this.setProperty("maxDate",i);if(this._getCalendar()){this._getCalendar().setMaxDate(i);}this._oMaxDate.setHours(23,59,59,999);return this;};
p.prototype._checkMinMaxDate=function(){if(this._oMinDate.getTime()>this._oMaxDate.getTime()){L.warning("minDate > MaxDate -> dates switched",this);var M=new Date(this._oMinDate.getTime());var i=new Date(this._oMaxDate.getTime());this._oMinDate=new Date(i.getTime());this._oMaxDate=new Date(M.getTime());this.setProperty("minDate",i,true);this.setProperty("maxDate",M,true);if(this._getCalendar()){this._getCalendar().setMinDate(i);this._getCalendar().setMaxDate(M);}}var z=this.getDateValue();if(z&&(z.getTime()<this._oMinDate.getTime()||z.getTime()>this._oMaxDate.getTime())){this._bValid=false;L.error("dateValue "+z.toString()+"(value="+this.getValue()+") does not match "+"min/max date range("+this._oMinDate.toString()+" - "+this._oMaxDate.toString()+"). App. "+"developers should take care to maintain dateValue/value accordingly.",this);}};
p.prototype.getDisplayFormatType=function(){return this.getProperty("displayFormatType");};
p.prototype._handleDateValidation=function(i){this._bValid=true;if(!i||i.getTime()<this._oMinDate.getTime()||i.getTime()>this._oMaxDate.getTime()){this._bValid=false;L.warning("Value can not be converted to a valid date",this);}var V=this._formatValue(i,true);if(V!==this.getValue()){this.setLastValue(V);}this.setProperty("value",V);this.setProperty("dateValue",i);};
p.prototype.setDisplayFormatType=function(i){if(i){var F=false;for(var T in o){if(T==i){F=true;break;}}if(!F){throw new Error(i+" is not a valid calendar type"+this);}}this.setProperty("displayFormatType",i,true);this.setDisplayFormat(this.getDisplayFormat());return this;};
p.prototype.setSecondaryCalendarType=function(i){this._bSecondaryCalendarTypeSet=true;this.setProperty("secondaryCalendarType",i,true);if(this._getCalendar()){this._getCalendar().setSecondaryCalendarType(i);}return this;};
p.prototype.setShowFooter=function(F){var P=this._oPopup,i=this._getCalendar();this.setProperty("showFooter",F);if(!P||!i){return this;}P._getButtonFooter().setVisible(F);return this;};
p.prototype.addSpecialDate=function(S){x.call(this,S);this.addAggregation("specialDates",S,true);y.call(this);return this;};
p.prototype.insertSpecialDate=function(S,i){x.call(this,S);this.insertAggregation("specialDates",S,i,true);y.call(this);return this;};
p.prototype.removeSpecialDate=function(S){var i=this.removeAggregation("specialDates",S,true);y.call(this);return i;};
p.prototype.removeAllSpecialDates=function(){var i=this.removeAllAggregation("specialDates",true);y.call(this);return i;};
p.prototype.destroySpecialDates=function(){this.destroyAggregation("specialDates",true);y.call(this);return this;};
p.prototype.setLegend=function(i){this.setAssociation("legend",i,true);var z=this.getLegend();if(z){var A=sap.ui.require("sap/ui/unified/CalendarLegend");i=sap.ui.getCore().byId(z);if(i&&!(typeof A=="function"&&i instanceof A)){throw new Error(i+" is not an sap.ui.unified.CalendarLegend. "+this);}}if(this._getCalendar()){this._getCalendar().setLegend(z);}return this;};
p.prototype.onChange=function(E){if(!this.getEditable()||!this.getEnabled()){return;}var V=this._$input.val(),O=this._formatValue(this.getDateValue()),i;if(V==O&&this._bValid){return;}if(this.getShowFooter()&&this._oPopup&&!V){this._oPopup.getBeginButton().setEnabled(false);}this._bValid=true;if(V!=""){i=this._parseValue(V,true);if(!i||i.getTime()<this._oMinDate.getTime()||i.getTime()>this._oMaxDate.getTime()){this._bValid=false;i=undefined;}else{V=this._formatValue(i);}}if(this.getDomRef()&&(this._$input.val()!==V)){this._$input.val(V);this._curpos=this._$input.cursorPos();}if(i){V=this._formatValue(i,true);}if(this.getLastValue()!==V||(i&&this.getDateValue()&&i.getFullYear()!==this.getDateValue().getFullYear())){this.setLastValue(V);this.setProperty("value",V,true);var N=this.getValue();if(this._bValid&&V==N){this.setProperty("dateValue",i,true);}V=N;if(this.isOpen()){if(this._bValid){i=this.getDateValue();}this._getCalendar().focusDate(i);var S=this._oDateRange.getStartDate();if((!S&&i)||(S&&i&&S.getTime()!=i.getTime())){this._oDateRange.setStartDate(new Date(i.getTime()));}else if(S&&!i){this._oDateRange.setStartDate(undefined);}}this.fireChangeEvent(V,{valid:this._bValid});}};
p.prototype._getInputValue=function(V){V=(typeof V=="undefined")?this._$input.val():V.toString();var i=this._parseValue(V,true);V=this._formatValue(i,true);return V;};
p.prototype.updateDomValue=function(V){if(this.isActive()&&(this._$input.val()!==V)){this._bCheckDomValue=true;V=(typeof V=="undefined")?this._$input.val():V.toString();this._curpos=this._$input.cursorPos();var i=this._parseValue(V,true);V=this._formatValue(i);this._$input.val(V);if(document.activeElement===this._$input[0]){this._$input.cursorPos(this._curpos);}}return this;};
p.prototype._storeInputSelection=function(i){if((D.browser.msie||D.browser.edge)&&!D.support.touch){this._oInputSelBeforePopupOpen={iStart:i.selectionStart,iEnd:i.selectionEnd};i.selectionStart=0;i.selectionEnd=0;}};
p.prototype._restoreInputSelection=function(i){if((D.browser.msie||D.browser.edge)&&!D.support.touch){i.selectionStart=this._oInputSelBeforePopupOpen.iStart;i.selectionEnd=this._oInputSelBeforePopupOpen.iEnd;}};
function _(){this._createPopup();this._createPopupContent();var i;var z=this.getBinding("value");if(z&&z.oType&&z.oType.oOutputFormat){i=z.oType.oOutputFormat.oFormatOptions.calendarType;}else if(z&&z.oType&&z.oType.oFormat){i=z.oType.oFormat.oFormatOptions.calendarType;}if(!i){i=this.getDisplayFormatType();}if(i){this._getCalendar().setPrimaryCalendarType(i);}var V=this._bValid?this._formatValue(this.getDateValue()):this.getValue();if(V!=this._$input.val()){this.onChange();}this._fillDateRange();this._openPopup();this.fireNavigate({dateRange:this._getVisibleDatesRange(this._getCalendar()),afterPopupOpened:true});}
p.prototype._createPopup=function(){var i,z;if(!this._oPopup){this._oPopup=new R(this.getId()+"-RP",{showCloseButton:false,showArrow:false,showHeader:false,placement:l.PlacementType.VerticalPreferedBottom,beginButton:new B({type:l.ButtonType.Emphasized,text:r.getText("DATEPICKER_SELECTION_CONFIRM"),press:this._handleOKButton.bind(this)}),afterOpen:t.bind(this),afterClose:v.bind(this)}).addStyleClass("sapMRPCalendar");if(this.getShowFooter()){this._oPopup.addStyleClass("sapMLandscapePadding");}this._oPopup._getPopup().setAutoClose(true);if(D.system.phone){i=this.$("inner").attr("aria-labelledby");z=i?document.getElementById(i).getAttribute("aria-label"):"";this._oPopup.setTitle(z);this._oPopup.setShowHeader(true);this._oPopup.setShowCloseButton(true);}else{this._oPopup._getPopup().setDurations(0,0);this._oPopup.setEndButton(new B({text:r.getText("DATEPICKER_SELECTION_CANCEL"),press:this._handleCancelButton.bind(this)}));}this.setAggregation("_popup",this._oPopup,true);}};
p.prototype._openPopup=function(){if(!this._oPopup){return;}this._storeInputSelection(this._$input.get(0));this._oPopup._getPopup().setAutoCloseAreas([this.getDomRef()]);this._oPopup.openBy(this);};
p.prototype._getVisibleDatesRange=function(i){var V=i._getVisibleDays();return new j({startDate:V[0].toLocalJSDate(),endDate:V[V.length-1].toLocalJSDate()});};
p.prototype._createPopupContent=function(){var i=this._getCalendarConstructor();if(!this._getCalendar()){this._oCalendar=new i(this.getId()+"-cal",{intervalSelection:this._bIntervalSelection,minDate:this.getMinDate(),maxDate:this.getMaxDate(),legend:this.getLegend(),startDateChange:function(){this.fireNavigate({dateRange:this._getVisibleDatesRange(this._getCalendar())});}.bind(this)});this._oDateRange=new j();this._getCalendar().addSelectedDate(this._oDateRange);this._getCalendar()._setSpecialDatesControlOrigin(this);this._getCalendar().attachCancel(s,this);this._getCalendar().setPopupMode(true);if(this.$().closest(".sapUiSizeCompact").length>0){this._getCalendar().addStyleClass("sapUiSizeCompact");}if(this._bSecondaryCalendarTypeSet){this._getCalendar().setSecondaryCalendarType(this.getSecondaryCalendarType());}if(this._bOnlyCalendar){this._getCalendar().attachSelect(this._handleCalendarSelect,this);this._getCalendar().attachEvent("_renderMonth",w,this);this._oPopup._getButtonFooter().setVisible(this.getShowFooter());this._getCalendar()._bSkipCancelButtonRendering=true;this._oPopup.addContent(this._getCalendar());if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}}}};
p.prototype._getCalendarConstructor=function(){var P=this._getFormatter(true).aFormatArray.map(function(z){return z.type.toLowerCase();}),i=P.indexOf("day")>=0,M=P.indexOf("month")>=0,Y=P.indexOf("year")>=0;if(i&&M&&Y){return h;}else if(M&&Y){return m;}else if(Y){return n;}else{L.warning("Not valid date pattern! Default Calendar constructor function is returned",this);return h;}};
p.prototype._fillDateRange=function(){var i=this.getDateValue();if(i&&i.getTime()>=this._oMinDate.getTime()&&i.getTime()<=this._oMaxDate.getTime()){this._getCalendar().focusDate(new Date(i.getTime()));if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=i.getTime()){this._oDateRange.setStartDate(new Date(i.getTime()));}}else{var z=this.getInitialFocusedDateValue();var F=z?z:new Date();var M=this._oMaxDate.getTime();if(F.getTime()<this._oMinDate.getTime()||F.getTime()>M){F=this._oMinDate;}this._getCalendar().focusDate(F);if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}};
p.prototype.getAccessibilityInfo=function(){var i=this.getRenderer();var z=I.prototype.getAccessibilityInfo.apply(this,arguments);var V=this.getValue()||"";if(this._bValid){var A=this.getDateValue();if(A){V=this._formatValue(A);}}z.type=r.getText("ACC_CTR_TYPE_DATEINPUT");z.description=[V,i.getLabelledByAnnouncement(this),i.getDescribedByAnnouncement(this)].join(" ").trim();return z;};
p.prototype._selectDate=function(){var i=this.getDateValue(),z=this._getSelectedDate(),V="";if(!d(z,i)){this.setDateValue(new Date(z.getTime()));V=this.getValue();this.fireChangeEvent(V,{valid:true});this._focusInput();}else if(!this._bValid){V=this._formatValue(z);if(V!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(V);this.setLastValue(V);}V=this._formatValue(z,true);this.setProperty("value",V,true);this.fireChangeEvent(V,{valid:true});this._focusInput();}}else if(D.system.desktop||!D.support.touch){this.focus();}this._oPopup.close();};
p.prototype._handleCalendarSelect=function(){if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(true);return;}this._selectDate();};
p.prototype._focusInput=function(){if(this.getDomRef()&&(D.system.desktop||!D.support.touch)){this._curpos=this._$input.val().length;this._$input.cursorPos(this._curpos);}return this;};
p.prototype._getCalendar=function(){return this._oCalendar;};
p.prototype._getSelectedDate=function(){var S=this._getCalendar().getSelectedDates(),i;if(S.length>0){i=S[0].getStartDate();}return i;};
p.prototype._handleOKButton=function(){this._selectDate();};
p.prototype._handleCancelButton=function(){if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}this._oPopup.close();};
function s(E){if(this.isOpen()){this._oPopup.close();if((D.system.desktop||!D.support.touch)){this.focus();}}}
p.prototype._increaseDate=function(N,i){var O=this.getDateValue();var z=this._$input.cursorPos();if(O&&this.getEditable()&&this.getEnabled()){var A;var E=this.getBinding("value");if(E&&E.oType&&E.oType.oOutputFormat){A=E.oType.oOutputFormat.oFormatOptions.calendarType;}else if(E&&E.oType&&E.oType.oFormat){A=E.oType.oFormat.oFormatOptions.calendarType;}if(!A){A=this.getDisplayFormatType();}var F=U.getInstance(new Date(O.getTime()),A);O=U.getInstance(new Date(O.getTime()),A);switch(i){case"day":F.setDate(F.getDate()+N);break;case"month":F.setMonth(F.getMonth()+N);var M=(O.getMonth()+N)%12;if(M<0){M=12+M;}while(F.getMonth()!=M){F.setDate(F.getDate()-1);}break;case"year":F.setFullYear(F.getFullYear()+N);while(F.getMonth()!=O.getMonth()){F.setDate(F.getDate()-1);}break;default:break;}if(F.getTime()<this._oMinDate.getTime()){F=new U(this._oMinDate.getTime());}else if(F.getTime()>this._oMaxDate.getTime()){F=new U(this._oMaxDate.getTime());}if(!d(this.getDateValue(),F.getJSDate())){this.setDateValue(new Date(F.getTime()));this._curpos=z;this._$input.cursorPos(this._curpos);var V=this.getValue();this.fireChangeEvent(V,{valid:true});}}};
p.prototype._getSpecialDates=function(){var z=this.getSpecialDates();for(var i=0;i<z.length;i++){var N=z[i].getSecondaryType()===u.CalendarDayType.NonWorking&&z[i].getType()!==u.CalendarDayType.NonWorking;if(N){var A=new k();A.setType(z[i].getSecondaryType());A.setStartDate(z[i].getStartDate());if(z[i].getEndDate()){A.setEndDate(z[i].getEndDate());}z.push(A);}}return z;};
function t(){this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);this._renderedDays=this._getCalendar().$("-Month0-days").find(".sapUiCalItem").length;this.$("inner").attr("aria-owns",this.getId()+"-cal");this.$("inner").attr("aria-expanded",true);g.addPopoverInstance(this._oPopup);this._getCalendar().focus();}
function v(){if(!this.getDateValue()){this._oPopup.getBeginButton().setEnabled(false);}this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.$("inner").attr("aria-expanded",false);this._restoreInputSelection(this._$input.get(0));this._getCalendar()._closedPickers();g.removePopoverInstance(this._oPopup);}
function w(E){var i=E.getParameter("days"),P=this._oPopup._getPopup();if(i>this._renderedDays){this._renderedDays=i;P._applyPosition(P._oLastPosition);}}
function x(S){var k=sap.ui.require("sap/ui/unified/DateTypeRange");if(S&&!(k&&S instanceof k)){throw new Error(S+"is not valid for aggregation \"specialDates\" of "+this);}}
function y(){if(this.isOpen()){this._getCalendar()._bDateRangeChanged=false;this._getCalendar().invalidate();}}
return p;});
},
	"sap/m/DateRangeSelection.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/Device','./DatePicker','./library','sap/ui/core/LocaleData','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate','./DateRangeSelectionRenderer',"sap/ui/unified/calendar/CustomMonthPicker","sap/ui/unified/calendar/CustomYearPicker","sap/base/util/deepEqual","sap/base/Log","sap/base/assert","sap/ui/dom/jquery/cursorPos"],function(D,a,l,L,b,U,c,C,d,f,g,h){"use strict";
var j=a.extend("sap.m.DateRangeSelection",{metadata:{library:"sap.m",properties:{delimiter:{type:"string",group:"Misc",defaultValue:'-'},secondDateValue:{type:"object",group:"Data",defaultValue:null},from:{type:"object",group:"Misc",defaultValue:null,deprecated:true},to:{type:"object",group:"Misc",defaultValue:null,deprecated:true}},designtime:"sap/m/designtime/DateRangeSelection.designtime",dnd:{draggable:false,droppable:true}}});
var H=String.fromCharCode(45),E=String.fromCharCode(8211),k=String.fromCharCode(8212);
j.prototype.init=function(){a.prototype.init.apply(this,arguments);this._bIntervalSelection=true;};
j.prototype._createPopupContent=function(){a.prototype._createPopupContent.apply(this,arguments);var e=this._getCalendar();if(e instanceof C){e._getMonthPicker().setIntervalSelection(true);}if(e instanceof d){e._getYearPicker().setIntervalSelection(true);}this._getCalendar().attachWeekNumberSelect(this._handleWeekSelect,this);this._getCalendar().getSelectedDates()[0].setStartDate(this._oDateRange.getStartDate());this._getCalendar().getSelectedDates()[0].setEndDate(this._oDateRange.getEndDate());};
j.prototype.onkeypress=function(e){if(!e.charCode||e.metaKey||e.ctrlKey){return;}var F=r.call(this);var i=q.call(this);var A=F.sAllowedCharacters+i+" ";var v=String.fromCharCode(e.charCode);if(v&&F.sAllowedCharacters&&A.indexOf(v)<0){e.preventDefault();}};
j.prototype._getPlaceholder=function(){var P=this.getPlaceholder(),B,e,i,v;if(!P){B=this.getBinding("value");i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();v=L.getInstance(i);if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){e=B.getType();if(e.oFormatOptions&&e.oFormatOptions.format){P=v.getCustomDateTimePattern(e.oFormatOptions.format);}else{P=v.getDatePattern("medium");}}else{P=this.getDisplayFormat();if(!P){P="medium";}if(this._checkStyle(P)){P=v.getDatePattern(P);}}var w=q.call(this);if(w&&w!==""){P=P+" "+w+" "+P;}}return P;};
j.prototype.setValue=function(v){if(v!==this.getValue()){this.setLastValue(v);}else{return this;}this.setProperty("value",v);this._bValid=true;var e=[undefined,undefined];if(v){e=this._parseValue(v);if(!o.call(this,e[0],e[1])[0]){this._bValid=false;g.warning("Value can not be converted to a valid dates",this);}}this.setProperty("dateValue",_(e[0]));this.setProperty("secondDateValue",_(e[1]));if(this.getDomRef()){var O=this._formatValue(e[0],e[1]);if(this._$input.val()!==O){this._$input.val(O);this._curpos=this._$input.cursorPos();}}return this;};
function _(B){return(typeof B==='number')?new Date(B):B;}
function m(B){return(B&&B.getTime)?B.getTime():B;}
j.prototype.setValueFormat=function(v){this.setProperty("valueFormat",v,true);g.warning("Property valueFormat is not supported in sap.m.DateRangeSelection control.",this);return this;};
j.prototype.setDisplayFormat=function(e){this.setProperty("displayFormat",e,true);var O=this._formatValue(this.getDateValue(),this.getSecondDateValue());this.setProperty("value",O,true);if(this.getDomRef()&&(this._$input.val()!==O)){this._$input.val(O);this._curpos=this._$input.cursorPos();}return this;};
j.prototype.setFrom=function(F){this.setDateValue(F);return this;};
j.prototype.getFrom=function(){return this.getDateValue();};
j.prototype.setTo=function(T){this.setSecondDateValue(T);return this;};
j.prototype.getTo=function(){return this.getSecondDateValue();};
j.prototype.setDateValue=function(e){if(!this._isValidDate(e)){throw new Error("Date must be a JavaScript date object; "+this);}if(f(this.getDateValue(),e)){return this;}a.prototype._dateValidation.call(this,e);this._syncDateObjectsToValue(e,this.getSecondDateValue());return this;};
j.prototype.setSecondDateValue=function(S){if(!this._isValidDate(S)){throw new Error("Date must be a JavaScript date object; "+this);}if(f(this.getSecondDateValue(),S)){return this;}this._bValid=true;if(S&&(S.getTime()<this._oMinDate.getTime()||S.getTime()>this._oMaxDate.getTime())){this._bValid=false;h(this._bValid,"Date must be in valid range");}this.setProperty("secondDateValue",S);this._syncDateObjectsToValue(this.getDateValue(),S);return this;};
j.prototype.setMinDate=function(e){a.prototype.setMinDate.apply(this,arguments);if(e){var S=this.getSecondDateValue();if(S&&S.getTime()<this._oMinDate.getTime()){g.warning("SecondDateValue not in valid date range",this);}}return this;};
j.prototype.setMaxDate=function(e){a.prototype.setMaxDate.apply(this,arguments);if(e){var S=this.getSecondDateValue();if(S&&S.getTime()>this._oMaxDate.getTime()){g.warning("SecondDateValue not in valid date range",this);}}return this;};
j.prototype._checkMinMaxDate=function(){a.prototype._checkMinMaxDate.apply(this,arguments);var S=this.getSecondDateValue();if(S&&(S.getTime()<this._oMinDate.getTime()||S.getTime()>this._oMaxDate.getTime())){g.error("secondDateValue "+S.toString()+"(value="+this.getValue()+") does not match "+"min/max date range("+this._oMinDate.toString()+" - "+this._oMaxDate.toString()+"). App. "+"developers should take care to maintain secondDateValue/value accordingly.",this);}};
j.prototype._parseValue=function(v){var F;var i=[];var w,x;var B=this.getBinding("value");if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){try{i=B.getType().parseValue(v,"string");}catch(e){return[undefined,undefined];}if(B.getType().oFormatOptions&&B.getType().oFormatOptions.UTC){i=i.map(function(A){return new Date(A.getUTCFullYear(),A.getUTCMonth(),A.getUTCDate(),A.getUTCHours(),A.getUTCMinutes(),A.getUTCSeconds());});}return i;}var y=q.call(this);if(y&&v){v=v.trim();v=u(v,[y," "]);i=this._splitValueByDelimiter(v,y);if(i.length===2){if(i[0].slice(i[0].length-1,i[0].length)==" "){i[0]=i[0].slice(0,i[0].length-1);}if(i[1].slice(0,1)==" "){i[1]=i[1].slice(1);}}else{i=v.split(" "+y+" ");}if(v.indexOf(y)===-1){var z=v.split(" ");if(z.length===2){i=z;}}}if(v&&i.length<=2){F=r.call(this);if((!y||y==="")||i.length===1){w=F.parse(v);}else if(i.length===2){w=F.parse(i[0]);x=F.parse(i[1]);if(!w||!x){w=undefined;x=undefined;}}}return[w,x];};
j.prototype._splitValueByDelimiter=function(v,e){var w=[H,E,k],i;if(e){if(w.indexOf(e)===-1){return v.split(e);}}for(i=0;i<w.length;i++){if(v.indexOf(w[i])>0){return v.split(w[i]);}}return v?v.split(" "):[];};
j.prototype._formatValue=function(e,S){var v="",i=q.call(this),F,B,w,x;w=e;x=S;if(w){B=this.getBinding("value");if(B&&B.getType()instanceof sap.ui.model.type.DateInterval){if(B.getType().oFormatOptions&&B.getType().oFormatOptions.source&&B.getType().oFormatOptions.source.pattern==="timestamp"){v=B.getType().formatValue([m(e),m(S)],"string");}else{if(B.getType().oFormatOptions&&B.getType().oFormatOptions.UTC){w=new Date(Date.UTC(e.getFullYear(),e.getMonth(),e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()));if(S){x=new Date(Date.UTC(S.getFullYear(),S.getMonth(),S.getDate(),S.getHours(),S.getMinutes(),S.getSeconds()));}}v=B.getType().formatValue([w,x],"string");}}else{F=r.call(this);if(i&&i!==""&&x){v=F.format(w)+" "+i+" "+F.format(x);}else{v=F.format(w);}}}return v;};
j.prototype.onChange=function(){if(!this.getEditable()||!this.getEnabled()){return;}var v=this._$input.val();var e=[undefined,undefined];if(this.getShowFooter()&&this._oPopup&&!v){this._oPopup.getBeginButton().setEnabled(false);}this._bValid=true;if(v!=""){e=this._parseValue(v);e[1]&&e[1].setHours(23,59,59,999);e=o.call(this,e[0],e[1]);if(e[0]){v=this._formatValue(e[0],e[1]);}else{this._bValid=false;}}if(v!==this.getLastValue()){if(this.getDomRef()&&(this._$input.val()!==v)){this._$input.val(v);this._curpos=this._$input.cursorPos();}this.setLastValue(v);this.setProperty("value",v,true);if(this._bValid){this.setProperty("dateValue",_(e[0]),true);this.setProperty("secondDateValue",_(e[1]),true);}if(this._oPopup&&this._oPopup.isOpen()){var S=this.getDateValue();if(S){if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!==S.getTime()){this._oDateRange.setStartDate(new Date(S.getTime()));this._getCalendar().focusDate(S);}}else{if(this._oDateRange.getStartDate()){this._oDateRange.setStartDate(undefined);}}var i=this.getSecondDateValue();if(i){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==i.getTime()){this._oDateRange.setEndDate(new Date(i.getTime()));this._getCalendar().focusDate(i);}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}}n.call(this,this._bValid);}};
j.prototype._getInputValue=function(v){v=(typeof v=="undefined")?this._$input.val():v.toString();if(!v){return"";}var e=this._parseValue(v);v=this._formatValue(e[0],e[1]);return v;};
j.prototype.updateDomValue=function(v){this._bCheckDomValue=true;v=(typeof v=="undefined")?this._$input.val():v.toString();this._curpos=this._$input.cursorPos();var e=this._parseValue(v);v=this._formatValue(e[0],e[1]);if(this.isActive()&&(this._$input.val()!==v)){this._$input.val(v);this._$input.cursorPos(this._curpos);}return this;};
j.prototype._fillDateRange=function(){a.prototype._fillDateRange.apply(this,arguments);var e=this.getSecondDateValue();if(e&&e.getTime()>=this._oMinDate.getTime()&&e.getTime()<=this._oMaxDate.getTime()){if(!this._oDateRange.getEndDate()||this._oDateRange.getEndDate().getTime()!==e.getTime()){this._oDateRange.setEndDate(new Date(e.getTime()));}}else{if(this._oDateRange.getEndDate()){this._oDateRange.setEndDate(undefined);}}};
j.prototype._selectDate=function(){var S=this._getCalendar().getSelectedDates();if(S.length>0){var e=S[0].getStartDate();var i=S[0].getEndDate();if(e&&i){var v=this.getDateValue();var w=this.getSecondDateValue();i.setHours(23,59,59,999);var V;if(!f(e,v)||!f(i,w)){if(f(i,w)){this.setDateValue(e);}else{this.setProperty("dateValue",e,true);this.setSecondDateValue(i);}V=this.getValue();n.call(this,true);if(D.system.desktop||!D.support.touch){this._curpos=V.length;this._$input.cursorPos(this._curpos);}}else if(!this._bValid){V=this._formatValue(e,i);if(V!=this._$input.val()){this._bValid=true;if(this.getDomRef()){this._$input.val(V);}n.call(this,true);}}this._oDateRange.setStartDate(this._getCalendar().getSelectedDates()[0].getStartDate());this._oDateRange.setEndDate(this._getCalendar().getSelectedDates()[0].getEndDate());this._oPopup.close();}}};
j.prototype._handleCalendarSelect=function(){var S=this._getCalendar().getSelectedDates(),e=S[0].getStartDate(),i=S[0].getEndDate();if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(!!(e&&i));return;}this._selectDate();};
j.prototype._handleWeekSelect=function(e){var S=e.getParameter("weekDays"),i=S.getStartDate(),v=S.getEndDate();if(this.getShowFooter()){this._oPopup.getBeginButton().setEnabled(!!(i&&v));return;}this._getCalendar().getSelectedDates()[0].setStartDate(i);this._getCalendar().getSelectedDates()[0].setEndDate(v);this._oDateRange.setStartDate(i);this._oDateRange.setEndDate(v);this._selectDate();};
j.prototype.getAccessibilityInfo=function(){var R=this.getRenderer();var i=a.prototype.getAccessibilityInfo.apply(this,arguments);var v=this.getValue()||"";if(this._bValid){var e=this.getDateValue();if(e){v=this._formatValue(e,this.getSecondDateValue());}}i.description=[v,R.getLabelledByAnnouncement(this),R.getDescribedByAnnouncement(this)].join(" ").trim();return i;};
j.prototype._syncDateObjectsToValue=function(e,S){var v=this._formatValue(e,S);if(v!==this.getValue()){this.setLastValue(v);}this.setProperty("value",v);if(this.getDomRef()){var O=this._formatValue(e,S);if(this._$input.val()!==O){this._$input.val(O);this._curpos=this._$input.cursorPos();}}};
function n(v){this.fireChangeEvent(this.getValue(),{from:this.getDateValue(),to:this.getSecondDateValue(),valid:v});}
function o(e,S){var F,i;if(e&&e.getTime){F=e.getTime();}else if(typeof e==='number'){F=e;}if(S&&S.getTime){i=S.getTime();}else if(typeof S==='number'){i=S;}if(e&&S&&F>i){var T=e;e=S;S=T;}if((e&&(F<this._oMinDate.getTime()||F>this._oMaxDate.getTime()))||(S&&(i<this._oMinDate.getTime()||i>this._oMaxDate.getTime()))){return[undefined,undefined];}else{return[e,S];}}
j.prototype._increaseDate=function(N,e){var v=this._$input.val(),i=this._parseValue(v),F=i[0],S=i[1],w=r.call(this),x=q.call(this),y,z,A,V,B,G,I;if(!F||!this.getEditable()||!this.getEnabled()){return;}if(!o.call(this,F,S)[0]){g.warning("Value can not be converted to a valid dates or dates are outside of the min/max range",this);this._bValid=false;n.call(this,this._bValid);return;}v=u(v,[x," "]);y=this._$input.cursorPos();z=F?w.format(F).length:0;A=S?w.format(S).length:0;V=v.length;B=y<=z+1;G=y>=V-A-1&&y<=V;if(B&&F){I=p.call(this,F,N,e);if(!f(this.getDateValue(),I.getJSDate())){this.setDateValue(new Date(I.getTime()));this._curpos=y;this._$input.cursorPos(this._curpos);this.fireChangeEvent(this.getValue(),{valid:this._bValid});}}else if(G&&S){I=p.call(this,S,N,e);if(!f(this.getSecondDateValue(),I.getJSDate())){this.setSecondDateValue(new Date(I.getTime()));this._curpos=y;this._$input.cursorPos(this._curpos);this.fireChangeEvent(this.getValue(),{valid:this._bValid});}}};
function p(O,N,e){var B=this.getBinding("value"),i,M,v,w;if(B&&B.oType&&B.oType.oOutputFormat){i=B.oType.oOutputFormat.oFormatOptions.calendarType;}else if(B&&B.oType&&B.oType.oFormat){i=B.oType.oFormat.oFormatOptions.calendarType;}if(!i){i=this.getDisplayFormatType();}v=U.getInstance(new Date(O.getTime()),i);w=v.getMonth();switch(e){case"day":v.setDate(v.getDate()+N);break;case"month":v.setMonth(v.getMonth()+N);M=(w+N)%12;if(M<0){M=12+M;}while(v.getMonth()!=M){v.setDate(v.getDate()-1);}break;case"year":v.setFullYear(v.getFullYear()+N);while(v.getMonth()!=w){v.setDate(v.getDate()-1);}break;default:break;}if(v.getTime()<this._oMinDate.getTime()){v=new U(this._oMinDate.getTime());}else if(v.getTime()>this._oMaxDate.getTime()){v=new U(this._oMaxDate.getTime());}return v;}
function q(){var e=this.getDelimiter();if(!e){if(!this._sLocaleDelimiter){var i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var v=L.getInstance(i);var P=v.getIntervalPattern();var I=P.indexOf("{0}")+3;var w=P.indexOf("{1}");e=P.slice(I,w);if(e.length>1){if(e.slice(0,1)==" "){e=e.slice(1);}if(e.slice(e.length-1,e.length)==" "){e=e.slice(0,e.length-1);}}this._sLocaleDelimiter=e;}else{e=this._sLocaleDelimiter;}}return e;}
function r(){var P=(this.getDisplayFormat()||"medium");var F;var e=this.getDisplayFormatType();if(P==this._sUsedDisplayPattern&&e==this._sUsedDisplayCalendarType){F=this._oDisplayFormat;}else{if(this._checkStyle(P)){F=b.getInstance({style:P,strictParsing:true,calendarType:e});}else{F=b.getInstance({pattern:P,strictParsing:true,calendarType:e});}this._sUsedDisplayPattern=P;this._sUsedDisplayCalendarType=e;this._oDisplayFormat=F;}return F;}
function s(v,e){return v&&e&&v.lastIndexOf(e)===v.length-e.length;}
function t(v,S){return v&&S&&v.indexOf(S)===0;}
function u(v,P){var i=0,T=P;if(!T){T=[" "];}while(i<T.length){if(s(v,T[i])){v=v.substring(0,v.length-T[i].length);i=0;continue;}i++;}i=0;while(i<T.length){if(t(v,T[i])){v=v.substring(T[i].length);i=0;continue;}i++;}return v;}
return j;});
},
	"sap/m/DateTimePicker.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(["sap/ui/thirdparty/jquery",'./InputBase','./DatePicker','sap/ui/model/type/Date','sap/ui/unified/DateRange','./library','sap/ui/core/Control','sap/ui/Device','sap/ui/core/format/DateFormat','sap/ui/core/LocaleData','./DateTimePickerRenderer','./TimePickerSliders','./SegmentedButton','./SegmentedButtonItem','./ResponsivePopover','./Button',"sap/ui/events/KeyCodes","sap/ui/core/IconPool"],function(q,I,D,a,b,l,C,c,d,L,e,T,S,f,R,B,K,g){"use strict";var P=l.PlacementType,h=l.ButtonType,k="Phone";
var m=D.extend("sap.m.DateTimePicker",{metadata:{library:"sap.m",properties:{minutesStep:{type:"int",group:"Misc",defaultValue:1},secondsStep:{type:"int",group:"Misc",defaultValue:1}},designtime:"sap/m/designtime/DateTimePicker.designtime",dnd:{draggable:false,droppable:true}}});
var n={Short:"short",Medium:"medium",Long:"long",Full:"full"};
var o=C.extend("sap.m.internal.DateTimePickerPopup",{
metadata:{library:"sap.m",aggregations:{_switcher:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},calendar:{type:"sap.ui.core.Control",multiple:false},timeSliders:{type:"sap.ui.core.Control",multiple:false}}},
renderer:{apiVersion:2,render:function(i,j){i.openStart("div",j);i.class("sapMDateTimePopupCont").class("sapMTimePickerDropDown");i.openEnd();var v=j.getAggregation("_switcher");if(v){i.openStart("div");i.class("sapMTimePickerSwitch");i.openEnd();i.renderControl(v);i.close("div");}var w=j.getCalendar();if(w){i.renderControl(w);}i.openStart("div");i.class("sapMTimePickerSep");i.openEnd();i.close("div");var x=j.getTimeSliders();if(x){i.renderControl(x);}i.close("div");}},
init:function(){},
onBeforeRendering:function(){var i=this.getAggregation("_switcher");if(!i){var j=sap.ui.getCore().getLibraryResourceBundle("sap.m");var v=j.getText("DATETIMEPICKER_DATE");var w=j.getText("DATETIMEPICKER_TIME");i=new S(this.getId()+"-Switch",{selectedKey:"Cal",items:[new f(this.getId()+"-Switch-Cal",{key:"Cal",text:v}),new f(this.getId()+"-Switch-Sli",{key:"Sli",text:w})]});i.attachSelect(this._handleSelect,this);this.setAggregation("_switcher",i,true);}if(c.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){i.setVisible(true);i.setSelectedKey("Cal");}else{i.setVisible(false);}},
onAfterRendering:function(){if(c.system.phone||q('html').hasClass("sapUiMedia-Std-Phone")){var i=this.getAggregation("_switcher");var j=i.getSelectedKey();this._switchVisibility(j);}},
_handleSelect:function(E){this._switchVisibility(E.getParameter("key"));},
_switchVisibility:function(i){var j=this.getCalendar();var v=this.getTimeSliders();if(!j||!v){return;}if(i=="Cal"){j.$().css("display","");v.$().css("display","none");}else{j.$().css("display","none");v.$().css("display","");v._updateSlidersValues();v._onOrientationChanged();v.openFirstSlider();}},
switchToTime:function(){var i=this.getAggregation("_switcher");if(i&&i.getVisible()){i.setSelectedKey("Sli");this._switchVisibility("Sli");}},
getSpecialDates:function(){return this._oDateTimePicker.getSpecialDates();}
});
m.prototype.init=function(){D.prototype.init.apply(this,arguments);this._bOnlyCalendar=false;};
m.prototype.getIconSrc=function(){return g.getIconURI("date-time");};
m.prototype.exit=function(){D.prototype.exit.apply(this,arguments);if(this._oSliders){this._oSliders.destroy();delete this._oSliders;}this._oPopupContent=undefined;c.media.detachHandler(this._handleWindowResize,this);};
m.prototype.setDisplayFormat=function(i){D.prototype.setDisplayFormat.apply(this,arguments);if(this._oSliders){this._oSliders.setDisplayFormat(t.call(this));}return this;};
m.prototype.setMinutesStep=function(M){this.setProperty('minutesStep',M,true);if(this._oSliders){this._oSliders.setMinutesStep(M);}return this;};
m.prototype._getDefaultValueStyle=function(){return n.Medium;};
m.prototype.setMinDate=function(i){D.prototype.setMinDate.call(this,i);if(i){this._oMinDate.setHours(i.getHours(),i.getMinutes(),i.getSeconds());}return this;};
m.prototype.setMaxDate=function(i){D.prototype.setMaxDate.call(this,i);if(i){this._oMaxDate.setHours(i.getHours(),i.getMinutes(),i.getSeconds());}return this;};
m.prototype.setSecondsStep=function(i){this.setProperty('secondsStep',i,true);if(this._oSliders){this._oSliders.setSecondsStep(i);}return this;};
m.prototype._getFormatInstance=function(A,i){var M=q.extend({},A);var j=-1;if(M.style){j=M.style.indexOf("/");}if(i){var v=q.extend({},M);if(j>0){v.style=v.style.substr(0,j);}this._oDisplayFormatDate=d.getInstance(v);}return d.getDateTimeInstance(M);};
m.prototype._checkStyle=function(v){if(D.prototype._checkStyle.apply(this,arguments)){return true;}else if(v.indexOf("/")>0){var w=[n.Short,n.Medium,n.Long,n.Long];var x=false;for(var i=0;i<w.length;i++){var y=w[i];for(var j=0;j<w.length;j++){var z=w[j];if(v==y+"/"+z){x=true;break;}}if(x){break;}}return x;}return false;};
m.prototype._parseValue=function(v,i){var j=D.prototype._parseValue.apply(this,arguments);if(i&&!j){j=this._oDisplayFormatDate.parse(v);if(j){var O=this.getDateValue();if(!O){O=new Date();}j.setHours(O.getHours());j.setMinutes(O.getMinutes());j.setSeconds(O.getSeconds());j.setMilliseconds(O.getMilliseconds());}}return j;};
m.prototype._getLocaleBasedPattern=function(i){var j=L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()),v=i.indexOf("/");if(v>0){return j.getCombinedDateTimePattern(i.substr(0,v),i.substr(v+1));}else{return j.getCombinedDateTimePattern(i,i);}};
m.prototype._createPopup=function(){var i,j,v,O,w,x;if(!this._oPopup){v=sap.ui.getCore().getLibraryResourceBundle("sap.m");O=v.getText("TIMEPICKER_SET");w=v.getText("TIMEPICKER_CANCEL");this._oPopupContent=new o(this.getId()+"-PC");this._oPopupContent._oDateTimePicker=this;this._oOKButton=new B(this.getId()+"-OK",{text:O,type:h.Emphasized,press:_.bind(this)});this._oPopup=new R(this.getId()+"-RP",{showCloseButton:false,showHeader:false,placement:P.VerticalPreferedBottom,beginButton:this._oOKButton,content:this._oPopupContent,afterOpen:r.bind(this),afterClose:s.bind(this)});if(c.system.phone){i=this.$("inner").attr("aria-labelledby");j=i?document.getElementById(i).getAttribute("aria-label"):"";this._oPopup.setTitle(j);this._oPopup.setShowHeader(true);this._oPopup.setShowCloseButton(true);}else{this._oPopup.setEndButton(new B(this.getId()+"-Cancel",{text:w,press:p.bind(this)}));}this._oPopup.addStyleClass("sapMDateTimePopup");x=this._oPopup.getAggregation("_popup");if(x.setShowArrow){x.setShowArrow(false);}this.setAggregation("_popup",this._oPopup,true);}};
m.prototype._openPopup=function(){if(!this._oPopup){return;}this.addStyleClass(I.ICON_PRESSED_CSS_CLASS);this._storeInputSelection(this._$input.get(0));var i=this._oPopup.getAggregation("_popup");i.oPopup.setAutoCloseAreas([this.getDomRef()]);this._oPopup.openBy(this);var j=this._oPopup.getContent()[0]&&this._oPopup.getContent()[0].getTimeSliders();if(j){setTimeout(j._updateSlidersValues.bind(j),0);}};
m.prototype._createPopupContent=function(){var N=!this._oCalendar;D.prototype._createPopupContent.apply(this,arguments);if(N){this._oPopupContent.setCalendar(this._oCalendar);this._oCalendar.attachSelect(u,this);}if(!this._oSliders){this._oSliders=new T(this.getId()+"-Sliders",{minutesStep:this.getMinutesStep(),secondsStep:this.getSecondsStep(),displayFormat:t.call(this),localeId:this.getLocaleId()})._setShouldOpenSliderAfterRendering(true);this._oPopupContent.setTimeSliders(this._oSliders);}};
m.prototype._selectFocusedDateValue=function(i){var j=this._oCalendar;j.removeAllSelectedDates();j.addSelectedDate(i);return this;};
m.prototype._fillDateRange=function(){var i=this.getDateValue(),j=true;if(i){i=new Date(i.getTime());this._oOKButton.setEnabled(true);}else{j=false;i=this.getInitialFocusedDateValue();if(!i){i=new Date();this._oCalendar.removeAllSelectedDates();}var M=this._oMaxDate.getTime();if(i.getTime()<this._oMinDate.getTime()||i.getTime()>M){i=this._oMinDate;}this._oOKButton.setEnabled(false);}this._oCalendar.focusDate(i);if(j){if(!this._oDateRange.getStartDate()||this._oDateRange.getStartDate().getTime()!=i.getTime()){this._oDateRange.setStartDate(i);}}this._oSliders._setTimeValues(i);};
m.prototype._getSelectedDate=function(){var i=D.prototype._getSelectedDate.apply(this,arguments);if(i){var j=this._oSliders.getTimeValues();var v=this._oSliders._getDisplayFormatPattern();if(v.search("h")>=0||v.search("H")>=0){i.setHours(j.getHours());}if(v.search("m")>=0){i.setMinutes(j.getMinutes());}if(v.search("s")>=0){i.setSeconds(j.getSeconds());}if(i.getTime()<this._oMinDate.getTime()){i=new Date(this._oMinDate.getTime());}else if(i.getTime()>this._oMaxDate.getTime()){i=new Date(this._oMaxDate.getTime());}}return i;};
m.prototype.getLocaleId=function(){return sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();};
m.prototype.getAccessibilityInfo=function(){var i=D.prototype.getAccessibilityInfo.apply(this,arguments);i.type=sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("ACC_CTR_TYPE_DATETIMEINPUT");return i;};
function _(E){this._handleCalendarSelect();}
function p(E){this.onsaphide(E);if(!this.getDateValue()){this._oCalendar.removeAllSelectedDates();}}
m.prototype._handleWindowResize=function(i){var j=this.getAggregation("_popup").getContent()[0].getAggregation("_switcher"),v=this.getAggregation("_popup").getContent()[0].getCalendar(),w=this.getAggregation("_popup").getContent()[0].getTimeSliders();if(i.name===k){j.setVisible(true);this.getAggregation("_popup").getContent()[0]._switchVisibility(j.getSelectedKey());}else{j.setVisible(false);w.$().css("display","");v.$().css("display","");}};
function r(E){this.$("inner").attr("aria-expanded",true);this._oCalendar.focus();this._oSliders._onOrientationChanged();c.media.attachHandler(this._handleWindowResize,this);}
function s(){this.removeStyleClass(I.ICON_PRESSED_CSS_CLASS);this.$("inner").attr("aria-expanded",false);this._restoreInputSelection(this._$input.get(0));this._oCalendar._closedPickers();c.media.detachHandler(this._handleWindowResize,this);}
function t(){var i=this.getDisplayFormat();var j;var v=this.getBinding("value");if(v&&v.oType&&(v.oType instanceof a)){i=v.oType.getOutputPattern();}else if(v&&v.oType&&v.oType.oFormat){i=v.oType.oFormat.oFormatOptions.pattern;}else{i=this.getDisplayFormat();}if(!i){i=n.Medium;}var w=i.indexOf("/");if(w>0&&this._checkStyle(i)){i=i.substr(w+1);}if(i==n.Short||i==n.Medium||i==n.Long||i==n.Full){var x=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var y=L.getInstance(x);j=y.getTimePattern(i);}else{j=i;}return j;}
function u(E){this._oOKButton.setEnabled(true);this._oPopupContent.switchToTime();}
return m;});
},
	"sap/m/Menu.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['./library','sap/ui/core/Control','./Button','./Dialog','./NavContainer','./List','./Page','./MenuListItem','sap/ui/unified/Menu','sap/ui/unified/MenuItem','sap/ui/Device','sap/ui/core/EnabledPropagator',"sap/ui/thirdparty/jquery","sap/ui/core/Popup"],function(l,C,B,D,N,L,P,M,U,a,b,E,q,c){"use strict";var d=c.Dock;var e=l.ListType;var f=l.ListMode;
var g=C.extend("sap.m.Menu",{
metadata:{interfaces:["sap.ui.core.IContextMenu"],library:"sap.m",properties:{title:{type:"string",group:"Misc",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.MenuItem",multiple:true,singularName:"item",bindable:"bindable"},_dialog:{type:"sap.m.Dialog",multiple:false,visibility:"hidden"},_menu:{type:"sap.ui.unified.Menu",multiple:false,visibility:"hidden"}},events:{itemSelected:{parameters:{item:{type:"sap.m.MenuItem"}}},closed:{}}},
renderer:null
});
E.call(g.prototype);g.UNIFIED_MENU_ITEMS_ID_SUFFIX='-unifiedmenu';g.UNFIFIED_MENU_ITEMS_PROPS=a.getMetadata().getAllProperties();g.LIST_ITEMS_ID_SUFFIX='-menuinnerlist';g.MENU_LIST_ITEMS_PROPS=M.getMetadata().getAllProperties();
g.prototype.init=function(){if(b.system.phone){this._initDialog();}this._bIsInitialized=false;};
g.prototype.exit=function(){if(this._navContainerId){this._navContainerId=null;}if(this._bIsInitialized){this._bIsInitialized=null;}if(this._getMenu()&&this._getMenu().getPopup()){this._getMenu().getPopup().detachClosed(this._menuClosed,this);}};
g.prototype.invalidate=function(){};
g.prototype.setTitle=function(t){var n=this._getNavContainer();this.setProperty("title",t,true);if(n&&n.getPages().length){n.getPages()[0].setTitle(t);}return this;};
g.prototype.openBy=function(o,w,s,i,O){if(b.system.phone){this._openDialog();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}if(!s){s=d.BeginTop;}if(!i){i=d.BeginBottom;}if(!O){O="0 -2";}this._getMenu().open(w,o,s,i,o,O);}};
g.prototype.close=function(){if(b.system.phone){this._getDialog().close();}else{this._getVisualParent().close();}};
g.prototype._initDialog=function(){var o=new D({showHeader:false,stretch:true,content:this._initNavContainer(),buttons:[this._initCloseButton()]});o.addStyleClass("sapMRespMenuDialog");o.removeStyleClass("sapUiPopupWithPadding");this.setAggregation("_dialog",o,true);o.attachAfterClose(this._menuClosed,this);};
g.prototype._getDialog=function(){return this.getAggregation("_dialog");};
g.prototype._openDialog=function(){if(!this._bIsInitialized){this._initAllPages();this._bIsInitialized=true;}this._getNavContainer().to(this._getNavContainer().getPages()[0]);this._getDialog().open();};
g.prototype._initAllMenuItems=function(){this._initMenuForItems(this.getItems());};
g.prototype._setCustomEnhanceAccStateFunction=function(i){this._fnEnhanceUnifiedMenuAccState=i;};
g.prototype._initMenuForItems=function(i,p){var m=new U();m._setCustomEnhanceAccStateFunction(this._fnEnhanceUnifiedMenuAccState);m.isCozy=this._isMenuCozy.bind(this,m);this.addStyleClass('sapMMenu');m.aCustomStyleClasses=this.aCustomStyleClasses;m.mCustomStyleClassMap=this.mCustomStyleClassMap;i.forEach(function(I){this._addVisualMenuItemFromItem(I,m);}.bind(this));if(p){p.setSubmenu(m);}else{m.getPopup().attachClosed(this._menuClosed,this);this.setAggregation('_menu',m,true);}m.attachItemSelect(this._handleMenuItemSelect,this);};
g.prototype._menuClosed=function(){this.fireClosed();};
g.prototype._getMenu=function(){return this.getAggregation("_menu");};
g.prototype._initCloseButton=function(){var r=sap.ui.getCore().getLibraryResourceBundle("sap.m");return new B({text:r.getText("MENU_CLOSE"),press:h.bind(this)});};
function h(){this._getDialog().close();}
g.prototype._initNavContainer=function(){var n=new N();this._navContainerId=n.getId();return n;};
g.prototype._getNavContainer=function(){return sap.ui.getCore().byId(this._navContainerId);};
g.prototype._initAllPages=function(){this._initPageForParent(this);};
g.prototype._initPageForParent=function(p){var i=p.getItems(),k=p instanceof g,s=k?p.getTitle():p.getText(),o=new L({mode:f.None}),m=new P({title:s,showNavButton:!k,content:o});if(!k){this._setBackButtonTooltipForPageWithParent(p,m);}m.attachNavButtonPress(function(){this._getNavContainer().back();},this);this._getNavContainer().addPage(m);i.forEach(function(I){this._addListItemFromItem(I,m);},this);this._updateListInset(o);o.attachEvent("itemPress",this._handleListItemPress,this);return m;};
g.prototype._handleListItemPress=function(o){var i=o.getParameter("listItem"),m=sap.ui.getCore().byId(i.getMenuItem()),p=m._getVisualChild();if(p){this._getNavContainer().to(p);}else{this._getDialog().close();this.fireItemSelected({item:m});}m.firePress();};
g.prototype._setBackButtonTooltipForPageWithParent=function(p,o){var i=p.getParent(),r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),s;s=i instanceof g?i.getTitle():i.getText();s=r.getText("MENU_PAGE_BACK_BUTTON")+" "+s;o.setNavButtonTooltip(s);};
g.prototype._createMenuListItemFromItem=function(i){return new M({id:this._generateListItemId(i.getId()),type:e.Active,icon:i.getIcon(),title:i.getText(),startsSection:i.getStartsSection(),menuItem:i,tooltip:i.getTooltip(),visible:i.getVisible()});};
g.prototype._createVisualMenuItemFromItem=function(I){var u=new a({id:this._generateUnifiedMenuItemId(I.getId()),icon:I.getIcon(),text:I.getText(),startsSection:I.getStartsSection(),tooltip:I.getTooltip(),visible:I.getVisible(),enabled:I.getEnabled()}),i,k=I.getCustomData();for(i=0;i<k.length;i++){I._addCustomData(u,k[i]);}return u;};
g.prototype._addVisualMenuItemFromItem=function(i,m,I){var o=this._createVisualMenuItemFromItem(i);i._setVisualParent(m);i._setVisualControl(o);var k=['aggregationChanged','propertyChanged'];k.forEach(function(s){var n='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[n],this);},this);if(i.getItems().length!==0){this._initMenuForItems(i.getItems(),o);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){m.addItem(o);}else{m.insertItem(o,I);}};
g.prototype._addListItemFromItem=function(i,p,I){var m=this._createMenuListItemFromItem(i),o=p.getContent()[0];i._setVisualParent(p);i._setVisualControl(m);var k=['aggregationChanged','propertyChanged'];k.forEach(function(s){var n='_on'+s.slice(0,1).toUpperCase()+s.slice(1);i.attachEvent(s,this[n],this);},this);if(i.getItems().length!==0){this._initPageForParent(i);i._setVisualChild(i.getItems()[0]._getVisualParent());}if(I===undefined){o.addItem(m);}else{o.insertItem(m,I);}o.rerender();};
g.prototype._connectVisualItem=function(i,o,I){if(!o||sap.ui.getCore().byId(i._getVisualControl())){return;}if(b.system.phone){this._addListItemFromItem(i,o,I);var k=o.getContent()[0];this._updateListInset(k);}else{this._addVisualMenuItemFromItem(i,o,I);}};
g.prototype._updateListInset=function(o){var H=false,I="sapMListIcons",k=o.getItems();for(var i=0;i<k.length;i++){if(k[i].getIcon()){H=true;break;}}if(H){o.addStyleClass(I);}else{o.removeStyleClass(I);}};
g.prototype._handleMenuItemSelect=function(o){var u=o.getParameter("item"),m;if(!u){return;}m=this._findMenuItemByUnfdMenuItem(u);if(m&&!m.getItems().length){this.fireItemSelected({item:m});}if(m){m.firePress();}};
g.prototype._generateListItemId=function(m){return m+g.LIST_ITEMS_ID_SUFFIX;};
g.prototype._generateUnifiedMenuItemId=function(m){return m+g.UNIFIED_MENU_ITEMS_ID_SUFFIX;};
g.prototype._findMenuItemByUnfdMenuItem=function(u){var k=[],o=u,I,m,i;do{k.push(o.getId());o=o.getParent().getParent();}while(o instanceof a);I=this.getItems();do{m=k.pop();for(i=0;i<I.length;i++){if(I[i]._getVisualControl()===m){if(k.length===0){return I[i];}else{I=I[i].getItems();break;}}}}while(k.length);return null;};
g.prototype._isMenuCozy=function(m){if(!m.bCozySupported){return false;}if(m.hasStyleClass("sapUiSizeCozy")){return true;}if(j(m.oOpenerRef)){return true;}return false;};
function j(r){if(!r){return false;}r=r.$?r.$():q(r);var $=r.closest(".sapUiSizeCompact,.sapUiSizeCondensed,.sapUiSizeCozy");return(!$.hasClass("sapUiSizeCompact")&&!$.hasClass("sapUiSizeCondensed"))||$.hasClass("sapUiSizeCozy");}
g.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.apply(this,arguments);if(A==="items"){this._connectVisualItem(o,this._getVisualParent());}return this;};
g.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.apply(this,arguments);if(A==="items"){this._connectVisualItem(o,this._getVisualParent(),i);}return this;};
g.prototype.removeAggregation=function(A,o,s){var i=C.prototype.removeAggregation.apply(this,arguments);if(A==="items"){this._removeVisualItem(i);}return i;};
g.prototype.removeAllAggregation=function(A,s){var I=C.prototype.removeAllAggregation.apply(this,arguments);if(A==="items"){for(var i=0;i<I.length;i++){this._removeVisualItem(I[i]);}}return I;};
g.prototype._removeVisualItem=function(i,p){var v=sap.ui.getCore().byId(i._getVisualControl()),m;if(v){m=v.getParent();m.removeItem(v);if(b.system.phone){this._removeSubPageForItem(i);if(m.getItems().length===0){if(p){p._setVisualChild(null);sap.ui.getCore().byId(p._getVisualControl()).rerender();}}if(m){m.rerender();}}}};
g.prototype.destroyAggregation=function(A,s){if(A==="items"){for(var i=0;i<this.getItems().length;i++){this._removeVisualItem(this.getItems()[i]);}}return C.prototype.destroyAggregation.apply(this,arguments);};
g.prototype._removeSubPageForItem=function(I,s){var S;if(!s){for(var i=0;i<I.getItems().length;i++){this._removeSubPageForItem(I.getItems()[i]);}}if(I._getVisualChild()){S=sap.ui.getCore().byId(I._getVisualChild());if(this._getNavContainer()&&S){this._getNavContainer().removePage(S);}!!S&&S.destroy();}};
g.prototype._getVisualParent=function(){var n=this._getNavContainer(),m=this._getMenu();if(n&&n.getPages().length){return n.getPages()[0];}else{return m;}};
g.prototype._onPropertyChanged=function(o){var p=o.getParameter("propertyKey"),i=o.getParameter("propertyValue"),t=b.system.phone?g.MENU_LIST_ITEMS_PROPS:g.UNFIFIED_MENU_ITEMS_PROPS,G=b.system.phone?this._generateListItemId:this._generateUnifiedMenuItemId,T;if(b.system.phone&&p==='text'){p='title';}if(!t[p]){return;}T=G(o.getSource().getId());if(T){sap.ui.getCore().byId(T).setProperty(p,i);if(b.system.phone&&this._getDialog().isOpen()){this._getDialog().close();}}};
g.prototype._onAggregationChanged=function(o){var A=o.getParameter("aggregationName");switch(A){case'items':this._onItemsAggregationChanged(o);break;case'tooltip':this._onTooltipAggregationChanged(o);break;}};
g.prototype._onTooltipAggregationChanged=function(o){var v=o.getSource()._getVisualControl(),m=o.getParameter("methodName"),i=o.getParameter("methodParams"),V;if(!v){return;}V=sap.ui.getCore().byId(v);if(m==="set"){V.setTooltip(i.item);}if(m==="destroy"){V.destroyTooltip();}};
g.prototype._onItemsAggregationChanged=function(o){var I=o.getSource(),m=o.getParameter("methodName"),k=o.getParameter("methodParams"),n;if(m==="add"||m==="insert"){if(m==="insert"){n=k.index;}this._addOrInsertItem(I,k.item,n);}if(m==="remove"){this._removeVisualItem(k.item,I);}if(m==="removeall"){for(var i=0;i<k.items.length;i++){this._removeVisualItem(k.items[i],I);}}if(m==="destroy"){this._destroyItem(I);}};
g.prototype._addOrInsertItem=function(p,n,i){var o;if(p._getVisualChild()){this._connectVisualItem(n,sap.ui.getCore().byId(p._getVisualChild()),i);}else{if(b.system.phone){this._initPageForParent(p);p._setVisualChild(p.getItems()[0]._getVisualParent());o=sap.ui.getCore().byId(p._getVisualControl());o.rerender();}else{this._initMenuForItems(p.getItems(),sap.ui.getCore().byId(p._getVisualControl()));p._setVisualChild(p.getItems()[0]._getVisualParent());}}};
g.prototype._destroyItem=function(i){var v=sap.ui.getCore().byId(i._getVisualControl());if(v&&v.setMenuItem){v.setMenuItem(null);}this._removeSubPageForItem(i,true);i._setVisualChild(null);if(v&&v.setMenuItem){v.rerender();v.setMenuItem(i);}};
g.prototype.getDomRefId=function(){if(b.system.phone){return this._getDialog().getId();}else{return this._getMenu().getId();}};
g.prototype.openAsContextMenu=function(o,O){if(b.system.phone){this._openDialog();}else{if(!this._bIsInitialized){this._initAllMenuItems();this._bIsInitialized=true;}this._getMenu().openAsContextMenu(o,O);}};
["addStyleClass","removeStyleClass","toggleStyleClass"].forEach(function(m){g.prototype[m]=function(s,S){var o=this._getDialog();C.prototype[m].apply(this,arguments);if(o){o[m].apply(o,arguments);}return this;};});return g;});
},
	"sap/m/PlanningCalendar.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/m/delegate/DateNavigation','sap/ui/core/Control','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectObserver','sap/ui/unified/library','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/DatesRow','sap/ui/unified/calendar/OneMonthDatesRow','sap/ui/unified/calendar/MonthsRow','sap/ui/unified/calendar/TimesRow','sap/ui/unified/DateRange','sap/ui/unified/DateTypeRange','sap/ui/unified/CalendarAppointment','sap/ui/unified/CalendarRow','sap/ui/unified/CalendarRowRenderer','sap/ui/Device','sap/ui/core/Core','sap/ui/core/Element','sap/ui/core/Renderer','sap/ui/core/ResizeHandler','sap/ui/core/InvisibleText','sap/ui/core/Item','sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo','sap/ui/core/dnd/DragDropInfo','sap/ui/core/format/DateFormat','sap/m/Select','sap/m/Button','sap/m/OverflowToolbar','sap/m/Toolbar','sap/m/Table','sap/m/Column','sap/m/ColumnListItem','sap/m/ColumnListItemRenderer','sap/m/SegmentedButtonItem','sap/m/StandardListItem','sap/m/StandardListItemRenderer','sap/m/PlanningCalendarHeader','sap/m/PlanningCalendarRow','sap/m/PlanningCalendarRenderer','sap/m/PlanningCalendarView','sap/m/CheckBox','sap/m/library',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(D,C,M,a,u,b,c,d,O,e,T,f,g,h,k,l,m,n,E,R,o,I,p,q,r,s,t,S,B,v,w,x,y,z,A,F,G,H,P,J,K,L,N,Q,U,V,W){"use strict";var X=Q.Sticky;var Y=u.CalendarDayType;var Z=Q.ListMode;var $=Q.ToolbarDesign;var _=Q.PlanningCalendarBuiltInView;var a1=Q.ScreenSize;var b1=u.CalendarAppointmentVisualization;var c1=u.GroupAppointmentsMode;var d1=u.CalendarIntervalType;var e1=u.CalendarAppointmentHeight;var f1=u.CalendarAppointmentRoundWidth;var g1="DragDropConfig";var h1="ResizeConfig";var i1="CreateConfig";var j1="-CLI";
var k1=C.extend("sap.m.PlanningCalendar",{
metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},viewKey:{type:"string",group:"Appearance",defaultValue:d1.Hour},singleSelection:{type:"boolean",group:"Misc",defaultValue:true},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},showIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showEmptyIntervalHeaders:{type:"boolean",group:"Appearance",defaultValue:true},showRowHeaders:{type:"boolean",group:"Appearance",defaultValue:true},noDataText:{type:"string",group:"Misc",defaultValue:null},groupAppointmentsMode:{type:"sap.ui.unified.GroupAppointmentsMode",group:"Appearance",defaultValue:c1.Collapsed},appointmentsReducedHeight:{type:"boolean",group:"Appearance",defaultValue:false},appointmentHeight:{type:"sap.ui.unified.CalendarAppointmentHeight",group:"Appearance",defaultValue:e1.Regular},appointmentRoundWidth:{type:"sap.ui.unified.CalendarAppointmentRoundWidth",group:"Appearance",defaultValue:f1.None},appointmentsVisualization:{type:"sap.ui.unified.CalendarAppointmentVisualization",group:"Appearance",defaultValue:b1.Standard},minDate:{type:"object",group:"Misc",defaultValue:null},maxDate:{type:"object",group:"Misc",defaultValue:null},showDayNamesLine:{type:"boolean",group:"Appearance",defaultValue:false},showWeekNumbers:{type:"boolean",group:"Appearance",defaultValue:false},builtInViews:{type:"string[]",group:"Appearance",defaultValue:[]},stickyHeader:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{rows:{type:"sap.m.PlanningCalendarRow",multiple:true,singularName:"row"},views:{type:"sap.m.PlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},toolbarContent:{type:"sap.ui.core.Control",multiple:true,singularName:"toolbarContent",forwarding:{getter:"_getHeader",aggregation:"actions"},forwardBinding:true},table:{type:"sap.m.Table",multiple:false,visibility:"hidden"},header:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.ui.unified.CalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"},multiSelect:{type:"boolean"},domRefId:{type:"string"}}},intervalSelect:{parameters:{startDate:{type:"object"},endDate:{type:"object"},subInterval:{type:"boolean"},row:{type:"sap.m.PlanningCalendarRow"}}},rowSelectionChange:{parameters:{rows:{type:"sap.m.PlanningCalendarRow[]"}}},startDateChange:{},viewChange:{},rowHeaderClick:{parameters:{headerId:{type:"string"},row:{type:"sap.m.PlanningCalendarRow"}}}},designtime:"sap/m/designtime/PlanningCalendar.designtime"},
constructor:function(i,j){C.prototype.constructor.apply(this,arguments);if(typeof i!=="string"){j=i;}if(j&&typeof j.customAppointmentsSorterCallback==="function"){this._fnCustomSortedAppointments=j.customAppointmentsSorterCallback;}}
});
var l1=["_oTimesRow","_oDatesRow","_oMonthsRow","_oWeeksRow","_oOneMonthsRow"],m1={};m1[d1.Day]={sInstanceName:"_oDatesRow",sIdSuffix:"-DatesRow",oClass:d};m1[d1.Week]={sInstanceName:"_oWeeksRow",sIdSuffix:"-WeeksRow",oClass:d};m1[d1.OneMonth]={sInstanceName:"_oOneMonthsRow",sIdSuffix:"-OneMonthsRow",oClass:O};var n1=a1.Desktop;var o1=[_.Hour,_.Day,_.Month,_.Week,_.OneMonth];var p1={PHONE:"600",TABLET:"1024"};var q1=["sap.ui.unified.calendar.TimesRow","sap.ui.unified.calendar.DatesRow","sap.ui.unified.calendar.MonthsRow","sap.ui.unified.calendar.OneMonthDatesRow"];
var r1=C.extend("CalendarHeader",{
metadata:{aggregations:{"toolbar":{type:"sap.m.Toolbar",multiple:false},"allCheckBox":{type:"sap.m.CheckBox",multiple:false}}},
renderer:{apiVersion:2,render:function(i,j){i.openStart("div",j);i.class("sapMPlanCalHead");i.openEnd();var R1=j.getToolbar();if(R1){i.renderControl(R1);}var S1=j.getAllCheckBox();if(S1){i.renderControl(S1);}i.close("div");}}
});
k1.prototype.init=function(){this._dateNav=new D();this._iBreakPointTablet=m.media._predefinedRangeSets[m.media.RANGESETS.SAP_STANDARD_EXTENDED].points[0];this._iBreakPointDesktop=m.media._predefinedRangeSets[m.media.RANGESETS.SAP_STANDARD_EXTENDED].points[1];this._iBreakPointLargeDesktop=m.media._predefinedRangeSets[m.media.RANGESETS.SAP_STANDARD_EXTENDED].points[2];if(m.system.phone||W('html').hasClass("sapUiMedia-Std-Phone")){this._iSize=0;this._iSizeScreen=0;}else if((m.system.tablet||W('html').hasClass("sapUiMedia-Std-Tablet"))&&!(m.system.desktop||W('html').hasClass("sapUiMedia-Std-Desktop"))){this._iSize=1;this._iSizeScreen=1;}else{this._iSize=2;this._iSizeScreen=2;}this.setAggregation("header",this._createHeader());this._attachHeaderEvents();this._oRB=n.getLibraryResourceBundle("sap.m");var i=this.getId();this._oIntervalTypeSelect=this._getHeader()._getOrCreateViewSwitch();this._oIntervalTypeSelect.attachEvent("selectionChange",s1,this);this._oTodayButton=this._getHeader()._getTodayButton();this._oCalendarHeader=new r1(i+"-CalHead",{});this._oInfoToolbar=new w(i+"-InfoToolbar",{height:"auto",design:$.Transparent,content:[this._oCalendarHeader,this._oTimesRow],ariaLabelledBy:I.getStaticId("sap.m","PC_INTERVAL_TOOLBAR")});var j=new x(i+"-Table",{sticky:[],infoToolbar:this._oInfoToolbar,mode:Z.SingleSelectMaster,columns:[new y({styleClass:"sapMPlanCalRowHead"}),new y({width:"80%",styleClass:"sapMPlanCalAppRow",minScreenWidth:n1,demandPopin:true})],ariaLabelledBy:i+"-Descr"});j.attachEvent("selectionChange",I1,this);j.addDelegate({onBeforeRendering:function(){if(this._rowHeaderClickEvent){this._rowHeaderClickEvent.off();}},onAfterRendering:function(){this._rowHeaderClickEvent=j.$().find(".sapMPlanCalRowHead > div.sapMLIB").on("click",function(R1){var S1=W(R1.currentTarget).control(0),T1=E1(S1.getParent()),U1=S1.getId();this.fireRowHeaderClick({headerId:U1,row:T1});}.bind(this));this._adjustColumnHeadersTopOffset();}},false,this);this.setAggregation("table",j,true);this.setStartDate(new Date());this._resizeProxy=W.proxy(w1,this);this._fnCustomSortedAppointments=undefined;this.iWidth=0;};
k1.prototype.exit=function(){if(this._sResizeListener){o.deregister(this._sResizeListener);this._sResizeListener=undefined;}m.orientation.detachHandler(this._updateStickyHeader,this);if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}var i=this.getAggregation("table");i.removeAllItems();l1.forEach(function(R1){if(this[R1]){this[R1]._oPlanningCalendar=undefined;this[R1].destroy();this[R1]=undefined;}},this);if(this._oViews){for(var j in this._oViews){this._oViews[j].destroy();}}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.destroy();}if(this._rowHeaderClickEvent){this._rowHeaderClickEvent.off();this._rowHeaderClickEvent=null;}};
k1.prototype.onBeforeRendering=function(){this._bBeforeRendering=true;if((!this._oTimesRow&&!this._oDatesRow&&!this._oMonthsRow&&!this._oWeeksRow&&!this._oOneMonthsRow)||this._bCheckView){this.setViewKey(this.getViewKey());this._bCheckView=undefined;}L1.call(this);if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}this._updatePickerSelection();this._updateHeaderButtons();m.orientation.detachHandler(this._updateStickyHeader,this);this._bBeforeRendering=undefined;this._toggleStickyClasses();};
k1.prototype.attachEvent=function(i,j,R1,S1){C.prototype.attachEvent.call(this,i,j,R1,S1);if(this.hasListeners("intervalSelect")){l1.forEach(function(T1){if(this[T1]){this[T1]._setAriaRole("button");}},this);}return this;};
k1.prototype.detachEvent=function(i,j,R1){C.prototype.detachEvent.call(this,i,j,R1);if(!this.hasListeners("intervalSelect")){l1.forEach(function(S1){if(this[S1]){this[S1]._setAriaRole("gridcell");}},this);}return this;};
k1.prototype._createHeader=function(){var i=new P(this.getId()+"-Header");i.getAggregation("_actionsToolbar").addAriaLabelledBy(I.getStaticId("sap.m","PC_FUNCTIONS_TOOLBAR"));i.getAggregation("_navigationToolbar").addAriaLabelledBy(I.getStaticId("sap.m","PC_INTERVAL_SELECTION_TOOLBAR"));return i;};
k1.prototype._attachHeaderEvents=function(){var i=this._getHeader();i.attachEvent("pressPrevious",this._handlePressArrow,this);i.attachEvent("pressToday",this._handleTodayPress,this);i.attachEvent("pressNext",this._handlePressArrow,this);i.attachEvent("dateSelect",this._handleDateSelect,this);return this;};
k1.prototype._handlePressArrow=function(i){this._applyArrowsLogic(i.getId()==="pressPrevious");};
k1.prototype._applyArrowsLogic=function(i){if(i){this._dateNav.previous();}else{this._dateNav.next();}if(this.getMinDate()&&this._dateNav.getStart().getTime()<=this.getMinDate().getTime()){this._dateNav.setStart(this.getMinDate());this._dateNav.setCurrent(this.getMinDate());}if(this.getMaxDate()&&this._dateNav.getEnd().getTime()>=this.getMaxDate().getTime()){this._dateNav.setStart(this.getMaxDate());this._dateNav.setCurrent(this.getMaxDate());}var j=this._getRowInstanceByViewKey(this.getViewKey());this.setStartDate(this._dateNav.getStart());j.setDate(this._dateNav.getCurrent());this._updatePickerSelection();this.fireStartDateChange();};
k1.prototype._formatPickerText=function(){var i=this._getFirstAndLastRangeDate(),j=b._createLocalDate(i.oStartDate,true),R1=b._createLocalDate(i.oEndDate,true),S1=this.getViewKey(),T1=d1[S1]?d1[S1]:this._getView(S1).getIntervalType(),U1=n.getConfiguration().getRTL(),V1,W1,X1,Y1;switch(T1){case d1.Hour:V1=t.getDateInstance({format:"yMMMMd"});X1=V1.format(j);if(j.getDate()!==R1.getDate()){Y1=V1.format(R1);}break;case d1.Day:case d1.Week:V1=t.getDateInstance({format:"yMMMMd"});X1=V1.format(j);Y1=V1.format(R1);break;case d1.OneMonth:V1=t.getDateInstance({format:"yMMMM"});X1=V1.format(j);break;case d1.Month:V1=t.getDateInstance({format:"y"});X1=V1.format(j);if(j.getFullYear()!==R1.getFullYear()){Y1=V1.format(R1);}break;default:throw new Error("Unknown IntervalType: "+S1+"; "+this);}if(!U1){W1=X1;if(Y1){W1+=" - "+Y1;}}else{if(Y1){W1=Y1+" - "+X1;}else{W1=X1;}}return W1;};
k1.prototype._getFirstAndLastRangeDate=function(){var i=b._createUniversalUTCDate(this.getStartDate(),"Gregorian",true),j=b._createUniversalUTCDate(this._dateNav.getEnd(),"Gregorian",true);return{oStartDate:i,oEndDate:j};};
k1.prototype._getHeader=function(){return this.getAggregation("header");};
k1.prototype._toggleStickyClasses=function(){this.toggleStyleClass("sapMPCSticky",this.getStickyHeader());return this;};
k1.prototype._adjustColumnHeadersTopOffset=function(){var i=this.getStickyHeader(),j=this.getDomRef().querySelector(".sapMListInfoTBarContainer"),R1;switch(i){case true:R1=this._getHeader().$().outerHeight()+"px";break;default:R1="auto";break;}j.style.top=R1;return this;};
k1.prototype._setAriaRole=function(i){if(this.hasListeners("intervalSelect")){i._setAriaRole("button");}else{i._setAriaRole("gridcell");}};
k1.prototype._updateTodayButtonState=function(){if(this._oTodayButton){this._oTodayButton.setEnabled(!this._dateMatchesVisibleRange(new Date(),this.getViewKey()));}};
k1.prototype._dateMatchesVisibleRange=function(i,j){var R1=this._getView(j,!this._bBeforeRendering);if(!R1){return false;}var S1=R1.getIntervalType(),T1=m1[S1],U1=T1?this[T1.sInstanceName]:null,V1=false;if(U1&&j==="One Month"){return b._isSameMonthAndYear(c.fromLocalJSDate(this.getStartDate()),c.fromLocalJSDate(i));}else if(U1&&j==="Week"){var W1=U1.getDays(),X1=c.fromLocalJSDate(i),Y1=c.fromLocalJSDate(this.getStartDate()),Z1=c.fromLocalJSDate(this.getStartDate());Z1.setDate(Z1.getDate()+W1);return X1.isSameOrAfter(Y1)&&X1.isBefore(Z1);}return V1;};
k1.prototype.onAfterRendering=function(i){i.size={width:this.getDomRef().offsetWidth};w1.call(this,i,true);if(!this._sResizeListener){this._sResizeListener=o.register(this,this._resizeProxy);}if(m.system.phone&&this.getStickyHeader()){m.orientation.attachHandler(this._updateStickyHeader,this);}this._updateCurrentTimeVisualization(false);if(this.getHeight()){var j=this.getDomRef().querySelector("table");if(this.getHeight().indexOf("%")>-1){j.style.height=this.getHeight();return;}var R1=this.$().height()-this._oInfoToolbar.$().height()+"px";j.style.height=R1;}this._adjustColumnHeadersTopOffset();};
k1.prototype.onThemeChanged=function(){if(this.getDomRef()){this._adjustColumnHeadersTopOffset();}};
k1.prototype.addToolbarContent=function(i){if(i&&i.isA("sap.m.Title")){this._observeHeaderTitleText(i);this._getHeader().setTitle(i.getText());i.setVisible(false);}this.addAggregation("toolbarContent",i);return this;};
k1.prototype.insertToolbarContent=function(i,j){if(i&&i.isA("sap.m.Title")){this._observeHeaderTitleText(i);this._getHeader().setTitle(i.getText());i.setVisible(false);}this.insertAggregation("toolbarContent",i,j);return this;};
k1.prototype.removeToolbarContent=function(i){var j;if(i&&i.isA("sap.m.Title")){this._getHeader().setTitle("");this._disconnectAndDestroyHeaderObserver();}else{j=this.removeAggregation("toolbarContent",i);}return j;};
k1.prototype.removeAllToolbarContent=function(){var i=this.removeAllAggregation("toolbarContent");this._getHeader().setTitle("");this._disconnectAndDestroyHeaderObserver();return i;};
k1.prototype.destroyToolbarContent=function(){var i=this.destroyAggregation("toolbarContent");this._getHeader().setTitle("");this._disconnectAndDestroyHeaderObserver();return i;};
k1.prototype._getHeaderObserver=function(){if(!this._oHeaderObserver){this._oHeaderObserver=new a(this._handleTitleTextChange.bind(this));}return this._oHeaderObserver;};
k1.prototype._observeHeaderTitleText=function(i){this._getHeaderObserver().observe(i,{properties:["text"]});};
k1.prototype._handleTitleTextChange=function(i){this._getHeader().setTitle(i.current);};
k1.prototype._disconnectAndDestroyHeaderObserver=function(){if(this._oHeaderObserver){this._oHeaderObserver.disconnect();this._oHeaderObserver.destroy();this._oHeaderObserver=null;}};
k1.prototype.setStartDate=function(i){var j;if(!i){j=new Date();}else{b._checkJSDateObject(i);j=new Date(i.getTime());}j=this._shiftStartDate(j);if(U(j,this.getStartDate())){this._updateTodayButtonState();return this;}var R1=j.getFullYear();b._checkYearInValidRange(R1);var S1=this.getMinDate();if(S1&&S1.getTime()>j.getTime()){V.warning("StartDate < minDate -> StartDate set to minDate",this);j=new Date(S1.getTime());}else{var T1=this.getMaxDate();if(T1&&T1.getTime()<j.getTime()){V.warning("StartDate > maxDate -> StartDate set to minDate",this);if(S1){j=new Date(S1.getTime());}else{j=new Date(1,0,1);j.setFullYear(1);}}}this.setProperty("startDate",j,true);this._dateNav.setStart(j);this._dateNav.setCurrent(j);this._getHeader().setStartDate(j);l1.forEach(function(U1){if(this[U1]){this[U1].setStartDate(new Date(j.getTime()));}},this);if(this.getViewKey()===_.OneMonth&&this._oOneMonthsRow.getMode()<2&&this._oOneMonthsRow.getSelectedDates().length){this._setRowsStartDate(this._oOneMonthsRow.getSelectedDates()[0].getStartDate());}else{this._setRowsStartDate(new Date(j.getTime()));}if(this.getViewKey()===_.Week||this.getViewKey()===_.OneMonth){this._updateTodayButtonState();}if(this.getDomRef()){this._updateCurrentTimeVisualization(false);this._updatePickerSelection();}this._updateHeaderButtons();return this;};
k1.prototype.setMinDate=function(i){if(U(i,this.getMinDate())){return this;}var j=this.getMaxDate(),R1=this._getHeader();if(i){b._checkJSDateObject(i);var S1=i.getFullYear();b._checkYearInValidRange(S1);this.setProperty("minDate",i,true);this._bNoStartDateChange=true;R1.getAggregation("_calendarPicker").setMinDate(new Date(i.getTime()));R1.getAggregation("_monthPicker").setMinDate(new Date(i.getTime()));R1.getAggregation("_yearPicker").setMinDate(new Date(i.getTime()));if(j&&j.getTime()<i.getTime()){V.warning("minDate > maxDate -> maxDate set to end of the month",this);j=new Date(i.getTime());j.setMonth(j.getMonth()+1,0);j.setHours(23);j.setMinutes(59);j.setSeconds(59);j.setMilliseconds(0);this.setMaxDate(j);}this._bNoStartDateChange=undefined;var T1=this.getStartDate();if(T1&&T1.getTime()<i.getTime()){V.warning("StartDate < minDate -> StartDate set to minDate",this);T1=new Date(i.getTime());this.setStartDate(T1);R1.setPickerText(this._formatPickerText());}}else{this.setProperty("minDate",undefined,true);R1.getAggregation("_calendarPicker").setMinDate();R1.getAggregation("_monthPicker").setMinDate();R1.getAggregation("_yearPicker").setMinDate();}var U1=new Date();if(i&&U1.getTime()<i.getTime()){this._oTodayButton.setVisible(false);}else if(!j||U1.getTime()<j.getTime()){this._oTodayButton.setVisible(true);}return this;};
k1.prototype.setMaxDate=function(i){if(U(i,this.getMaxDate())){return this;}var j=this.getMinDate(),R1=this._getHeader();if(i){b._checkJSDateObject(i);var S1=i.getFullYear();b._checkYearInValidRange(S1);this.setProperty("maxDate",i,true);this._bNoStartDateChange=true;R1.getAggregation("_calendarPicker").setMaxDate(new Date(i.getTime()));R1.getAggregation("_monthPicker").setMaxDate(new Date(i.getTime()));R1.getAggregation("_yearPicker").setMaxDate(new Date(i.getTime()));if(j&&j.getTime()>i.getTime()){V.warning("maxDate < minDate -> maxDate set to begin of the month",this);j=new Date(i.getTime());j.setDate(1);j.setHours(0);j.setMinutes(0);j.setSeconds(0);j.setMilliseconds(0);this.setMinDate(j);}this._bNoStartDateChange=undefined;var T1=this.getStartDate();if(T1&&T1.getTime()>i.getTime()){V.warning("StartDate > maxDate -> StartDate set to minDate",this);if(j){T1=new Date(j.getTime());}else{T1=new Date(1,0,1);T1.setFullYear(1);}this.setStartDate(T1);R1.setPickerText(this._formatPickerText());}}else{this.setProperty("maxDate",undefined,true);R1.getAggregation("_calendarPicker").setMaxDate();R1.getAggregation("_monthPicker").setMaxDate();R1.getAggregation("_yearPicker").setMaxDate();}var U1=new Date();if(i&&U1.getTime()>i.getTime()){this._oTodayButton.setVisible(false);}else if(!j||U1.getTime()>j.getTime()){this._oTodayButton.setVisible(true);}return this;};
k1.prototype.removeIntervalInstanceFromInfoToolbar=function(){var i=this._oInfoToolbar.getContent();i.forEach(function(j){if(j.isA(q1)){this._oInfoToolbar.removeContent(j);}}.bind(this));};
k1.prototype.setViewKey=function(j){var R1,S1,T1,U1=this.getViewKey(),V1=this._getHeader(),W1;this.setProperty("viewKey",j,true);this._oIntervalTypeSelect.setSelectedKey(j);this.removeIntervalInstanceFromInfoToolbar();var X1=this.getStartDate();var Y1=this.getMinDate();var Z1=this.getMaxDate();var $1=this._getView(j,!this._bBeforeRendering);if(!$1){this._bCheckView=true;this.invalidate();}else{var _1=$1.getIntervalType();var a2=this._getIntervals($1);this._bCheckView=false;this._dateNav.setUnit(_1);this._dateNav.setStep(a2);this._dateNav.setCurrent(undefined);switch(_1){case d1.Hour:if(!this._oTimesRow){this._oTimesRow=new T(this.getId()+"-TimesRow",{startDate:new Date(X1.getTime()),items:a2,legend:this.getLegend()});this._setAriaRole(this._oTimesRow);this._oTimesRow._setLegendControlOrigin(this);this._oTimesRow.attachEvent("focus",this._handleFocus,this);this._oTimesRow.attachEvent("select",this._handleCalendarSelect,this);this._oTimesRow._oPlanningCalendar=this;this._oTimesRow._getSpecialDates=function(){return this._oPlanningCalendar._getSpecialDates();};this._oTimesRow.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(this._oTimesRow.getItems()!==a2){this._oTimesRow.setItems(a2);this._dateNav.setStep(a2);}this._insertInterval(this._oTimesRow);V1.setAssociation("currentPicker",V1.getAggregation("_calendarPicker"));break;case d1.Day:case d1.Week:case d1.OneMonth:T1=m1[_1];R1=this[T1.sInstanceName];if(!R1){R1=new T1.oClass(this.getId()+T1.sIdSuffix,{startDate:new Date(X1.getTime()),days:a2,showDayNamesLine:this.getShowDayNamesLine(),legend:this.getLegend(),showWeekNumbers:this.getShowWeekNumbers()});this._setAriaRole(R1);R1.attachEvent("select",this._handleCalendarSelect,this);R1.attachEvent("focus",this._handleFocus,this);if(j===_.OneMonth){R1._setRowsStartDate=this._setRowsStartDate.bind(this);}R1._oPlanningCalendar=this;R1._getSpecialDates=function(){return this._oPlanningCalendar._getSpecialDates();};R1.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(R1.getDays()!==a2){R1.setDays(a2);this._dateNav.setStep(a2);}this._insertInterval(R1);this[T1.sInstanceName]=R1;if(_1===d1.OneMonth){V1.setAssociation("currentPicker",V1.getAggregation("_monthPicker"));}else{V1.setAssociation("currentPicker",V1.getAggregation("_calendarPicker"));}break;case d1.Month:if(!this._oMonthsRow){this._oMonthsRow=new e(this.getId()+"-MonthsRow",{startDate:new Date(X1.getTime()),months:a2,legend:this.getLegend()});this._setAriaRole(this._oMonthsRow);this._oMonthsRow._setLegendControlOrigin(this);this._oMonthsRow.attachEvent("focus",this._handleFocus,this);this._oMonthsRow.attachEvent("select",this._handleCalendarSelect,this);this._oMonthsRow._oPlanningCalendar=this;this._oMonthsRow._getSpecialDates=function(){return this._oPlanningCalendar._getSpecialDates();};this._oMonthsRow.getSpecialDates=function(){return this._oPlanningCalendar.getSpecialDates();};}else if(this._oMonthsRow.setMonths()!==a2){this._oMonthsRow.setMonths(a2);this._dateNav.setStep(a2);}this._insertInterval(this._oMonthsRow);V1.setAssociation("currentPicker",V1.getAggregation("_yearPicker"));break;default:throw new Error("Unknown IntervalType: "+_1+"; "+this);}var b2=this.getRows();for(var i=0;i<b2.length;i++){var c2=b2[i];var d2=H1(c2);d2.setIntervalType(_1);d2.setIntervals(a2);d2.setShowSubIntervals($1.getShowSubIntervals());}if(this.getDomRef()){this._updateCurrentTimeVisualization(false);u1.call(this,this.getShowWeekNumbers(),this._viewAllowsWeekNumbers(j));v1.call(this,this.getShowDayNamesLine(),!!R1);}this._updatePickerSelection();}if(j===_.Week||j===_.OneMonth||j===_.Month){S1=this.getStartDate();this.setStartDate(new Date(S1.getTime()));if(S1.getTime()!==this.getStartDate().getTime()){this.fireStartDateChange();}}if(this._oOneMonthsRow&&j===_.OneMonth){this._oOneMonthsRow.setMode(this._iSize);this._oOldStartDate=new Date(this.getStartDate().getTime());this._adjustSelectedDate(c.fromLocalJSDate(S1));if(this._iSize<2){this._setRowsStartDate(S1);}}else if(this._oOneMonthsRow&&U1===_.OneMonth&&this._oOneMonthsRow.getSelectedDates().length){W1=this._oOneMonthsRow.getSelectedDates()[0].getStartDate();W1.setHours(this._oOldStartDate.getHours());W1.setMinutes(this._oOldStartDate.getMinutes());W1.setSeconds(this._oOldStartDate.getSeconds());W1.setMilliseconds(this._oOldStartDate.getMilliseconds());if(W1){this.setStartDate(W1);}}if(Y1){V1.getAggregation("_calendarPicker").setMinDate(new Date(Y1.getTime()));V1.getAggregation("_yearPicker").setMinDate(new Date(Y1.getTime()));V1.getAggregation("_monthPicker").setMinDate(new Date(Y1.getTime()));}if(Z1){V1.getAggregation("_calendarPicker").setMaxDate(new Date(Z1.getTime()));V1.getAggregation("_yearPicker").setMaxDate(new Date(Z1.getTime()));V1.getAggregation("_monthPicker").setMaxDate(new Date(Z1.getTime()));}this._updateTodayButtonState();return this;};
k1.prototype._handleFocus=function(i){var j=i.getParameter("date"),R1=i.getParameter("restoreOldDate");if(R1){return;}this.shiftToDate(j,i.getParameter("otherMonth"));};
k1.prototype.shiftToDate=function(i,j){var R1=this._getRowInstanceByViewKey(this.getViewKey()),S1,T1;this._dateNav.toDate(i);S1=this._dateNav.getStart();T1=this._dateNav.getCurrent();if(this._dateNav.getCurrent()>this._dateNav.getEnd()){S1=new Date(this._dateNav.getStart());S1.setDate(S1.getDate()+1);}if((this.getMaxDate()&&this.getMaxDate()<i)||(this.getMinDate()&&this.getMinDate()>i)){return;}if(j){this.fireStartDateChange();}if(R1&&!(R1.getMode&&R1.getMode()<2&&!j)){this.setStartDate(S1);R1.setStartDate(S1);R1.setDate(T1);}};
k1.prototype._shiftStartDate=function(i){if(this.getViewKey()===_.Week){var j=b.getFirstDateOfWeek(b._createUniversalUTCDate(i,undefined,true));i.setTime(b._createLocalDate(j,true).getTime());}if((this.getViewKey()===_.OneMonth||this.getViewKey()===_.Month)){var R1=b.getFirstDateOfMonth(b._createUniversalUTCDate(i,undefined,true));i.setTime(b._createLocalDate(R1,true).getTime());}return i;};
k1.prototype._updatePickerSelection=function(){var i=this._getFirstAndLastRangeDate(),j=this._getHeader().getAssociation("currentPicker"),R1=n.byId(j),S1;S1=new f({startDate:b._createLocalDate(i.oStartDate,true),endDate:b._createLocalDate(i.oEndDate,true)});R1.destroySelectedDates();R1.addSelectedDate(S1);this._getHeader().setPickerText(this._formatPickerText());this._updateTodayButtonState();};
k1.prototype._adjustSelectedDate=function(i){var j=i.toLocalJSDate();if(this._oOneMonthsRow.getMode&&this._oOneMonthsRow.getMode()<2){this._oOneMonthsRow.removeAllSelectedDates();this._oOneMonthsRow.addSelectedDate(new f({startDate:j}));this._oOneMonthsRow.selectDate(j);}};
k1.prototype._insertInterval=function(i){if(this._iSizeScreen>1){this._oInfoToolbar.addContent(i);}else{this._oInfoToolbar.insertContent(i,1);}};
k1.prototype._viewAllowsWeekNumbers=function(i){var j=this._getView(i).getIntervalType(),R1=m1[j];return!!R1&&!!R1.oClass.prototype.setShowWeekNumbers;};
k1.prototype._viewAllowsDayNamesLine=function(i){var j=this._getView(i).getIntervalType(),R1=m1[j];return!!R1&&!!R1.oClass.prototype.setShowDayNamesLine;};
k1.prototype._getRowInstanceByViewKey=function(i){var j=this._getView(i).getIntervalType(),R1=m1[j],S1;if(R1){S1=this[R1.sInstanceName];}if(j===d1.Month){S1=this._oMonthsRow;}if(j===d1.Hour){S1=this._oTimesRow;}return S1;};
k1.prototype.setShowWeekNumbers=function(i){this.setProperty("showWeekNumbers",i,true);this._getViews().forEach(function(j){var R1=j.getKey(),S1=this._viewAllowsWeekNumbers(R1),T1=this._getRowInstanceByViewKey(R1);if(T1&&S1){T1.setShowWeekNumbers(i);}if(this.getDomRef()&&this.getViewKey()===R1){u1.call(this,i,S1);}},this);return this;};
k1.prototype.setShowIntervalHeaders=function(j){this.setProperty("showIntervalHeaders",j,true);var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setShowIntervalHeaders(j);}return this;};
k1.prototype.setShowEmptyIntervalHeaders=function(j){this.setProperty("showEmptyIntervalHeaders",j,true);var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setShowEmptyIntervalHeaders(j);}return this;};
k1.prototype.setGroupAppointmentsMode=function(j){this.setProperty("groupAppointmentsMode",j,true);var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setGroupAppointmentsMode(j);}return this;};
k1.prototype.setAppointmentsReducedHeight=function(j){this.setProperty("appointmentsReducedHeight",j,true);var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setAppointmentsReducedHeight(j);}return this;};
k1.prototype.setAppointmentHeight=function(j){var R1=this.getRows(),i;this.setProperty("appointmentHeight",j);for(i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setAppointmentHeight(j);}return this;};
k1.prototype.setAppointmentRoundWidth=function(j){var R1=this.getRows(),i;this.setProperty("appointmentRoundWidth",j);for(i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setAppointmentRoundWidth(j);}return this;};
k1.prototype.setAppointmentsVisualization=function(j){this.setProperty("appointmentsVisualization",j,true);var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=R1[i];H1(S1).setAppointmentsVisualization(j);}return this;};
k1.prototype.setShowRowHeaders=function(i){this.setProperty("showRowHeaders",i,true);var j=this.getAggregation("table");j.getColumns()[0].setVisible(i);this._toggleAppointmentsColumnPopinState(i);this.$().toggleClass("sapMPlanCalNoHead",!i);P1.call(this);this._setSelectionMode.call(this);return this;};
k1.prototype.setShowDayNamesLine=function(i){var j,R1,S1,T1=!!this.getDomRef(),U1=this.getViewKey();for(j in m1){R1=m1[j].sInstanceName;if(this[R1]){S1=this[R1];S1.setShowDayNamesLine(i);if(T1&&j===U1){v1.call(this,i,true);}}}return this.setProperty("showDayNamesLine",i,false);};
k1.prototype.setStickyHeader=function(i){if(this.getStickyHeader()===i){return this;}this.setProperty("stickyHeader",i,true);if(m.system.phone){if(i){m.orientation.attachHandler(this._updateStickyHeader,this);}else{m.orientation.detachHandler(this._updateStickyHeader,this);}}this._updateStickyHeader();return this;};
k1.prototype._updateStickyHeader=function(){var i=[],j=this.getStickyHeader(),R1=this.getViewKey()===_.OneMonth&&this._iSize<2,S1=j&&!m.system.phone&&!R1,T1=j&&!(m.system.phone&&m.orientation.landscape)&&!R1;if(S1){i.push(X.HeaderToolbar);}if(this._oInfoToolbar&&T1){i.push(X.InfoToolbar);}this.getAggregation("table").setSticky(i);};
k1.prototype.addRow=function(i){this.addAggregation("rows",i);this.getAggregation("table").addItem(this._createPlanningCalendarListItem(i));return this;};
k1.prototype.insertRow=function(i,j){this.insertAggregation("rows",i,j);this.getAggregation("table").insertItem(this._createPlanningCalendarListItem(i),j,true);return this;};
k1.prototype.removeRow=function(i){var j=this.removeAggregation("rows",i,true),R1=this.getAggregation("table");R1.removeItem(F1(j),true);this._handleRowRemoval(j);O1.call(this);this._setSelectionMode.call(this);return j;};
k1.prototype.removeAllRows=function(){var i=this.removeAllAggregation("rows",true),j=this.getAggregation("table");j.removeAllItems(true);i.forEach(this._handleRowRemoval,this);O1.call(this);this._setSelectionMode.call(this);return i;};
k1.prototype.destroyRows=function(){var i;var j=this.getAggregation("table");j.destroyItems(true);i=this.destroyAggregation("rows");O1.call(this);this._setSelectionMode.call(this);return i;};
k1.prototype.setSingleSelection=function(i){this.setProperty("singleSelection",i,true);P1.call(this);this._setSelectionMode.call(this);if(i){this.selectAllRows(false);}else{O1.call(this);}this.$().toggleClass("sapMPlanCalMultiSel",!i);return this;};
k1.prototype.setNoDataText=function(i){this.setProperty("noDataText",i,true);var j=this.getAggregation("table");j.setNoDataText(i);return this;};
k1.prototype.setLegend=function(j){this.setAssociation("legend",j,true);var R1=this.getRows(),S1=this.getLegend()&&n.byId(this.getLegend()),T1;for(var i=0;i<R1.length;i++){var U1=R1[i];H1(U1).setLegend(j);}l1.forEach(function(V1){if(this[V1]){this[V1].setLegend(j);}},this);if(S1){T1=new a(function(V1){this.invalidate();}.bind(this));T1.observe(S1,{destroy:true});}return this;};
k1.prototype.addAriaLabelledBy=function(i){this.addAssociation("ariaLabelledBy",i,true);var j=this.getAggregation("table");j.addAriaLabelledBy(i);return this;};
k1.prototype.removeAriaLabelledBy=function(i){this.removeAssociation("ariaLabelledBy",i,true);var j=this.getAggregation("table");j.removeAriaLabelledBy(i);return this;};
k1.prototype.removeAllAriaLabelledBy=function(){this.removeAllAssociation("ariaLabelledBy",true);var i=this.getAggregation("table");i.removeAllAriaLabelledBy();i.addAriaLabelledBy(this.getId()+"-Descr");return this;};
k1.prototype.invalidate=function(i){var j=i&&i instanceof f;if(!this._bIsBeingDestroyed&&(this._bDateRangeChanged||j)){if(this.getDomRef()){var R1=this.getViewKey();var S1=this._getView(R1);var T1=S1.getIntervalType();switch(T1){case d1.Hour:if(this._oTimesRow){this._oTimesRow.invalidate(arguments);}break;case d1.Day:if(this._oDatesRow){this._oDatesRow.invalidate(arguments);}break;case d1.Month:if(this._oMonthsRow){this._oMonthsRow.invalidate(arguments);}break;case d1.OneMonth:if(this._oOneMonthsRow){this._oOneMonthsRow.invalidate(arguments);}break;case d1.Week:if(this._oWeeksRow){this._oWeeksRow.invalidate(arguments);}break;default:throw new Error("Unknown IntervalType: "+T1+"; "+this);}}this._bDateRangeChanged=undefined;}else{if(i&&i instanceof sap.m.PlanningCalendarView){this._bCheckView=true;}C.prototype.invalidate.apply(this,arguments);}};
k1.prototype.addSpecialDate=function(i){this._bDateRangeChanged=true;return C.prototype.addAggregation.call(this,"specialDates",i);};
k1.prototype.insertSpecialDate=function(i,j){this._bDateRangeChanged=true;return C.prototype.insertAggregation.call(this,"specialDates",i,j);};
k1.prototype.removeSpecialDate=function(i){this._bDateRangeChanged=true;return C.prototype.removeAggregation.call(this,"specialDates",i);};
k1.prototype.removeAllSpecialDates=function(){this._bDateRangeChanged=true;return this.removeAllAggregation("specialDates");};
k1.prototype.destroySpecialDates=function(){this._bDateRangeChanged=true;return this.destroyAggregation("specialDates");};
k1.prototype.removeAllViews=function(){this._bCheckView=true;var i=this.removeAllAggregation("views"),j=this.getBuiltInViews();if(j.length){this.setViewKey(j[0]);}else{this.setViewKey(o1[0]);}return i;};
k1.prototype.destroyViews=function(){this._bCheckView=true;var i=this.destroyAggregation("views"),j=this.getBuiltInViews();if(j.length){this.setViewKey(j[0]);}else{this.setViewKey(o1[0]);}return i;};
k1.prototype.getSelectedRows=function(){return this.getRows().filter(function(i){return i.getSelected();});};
k1.prototype.selectAllRows=function(j){var R1=this.getRows();if(!(j&&this.getSingleSelection())){for(var i=0;i<R1.length;i++){var S1=R1[i];S1.setSelected(j);}if(this._oSelectAllCheckBox){this._oSelectAllCheckBox.setSelected(j);}}return this;};
k1.prototype.onsaphomemodifiers=function(i){if((i.metaKey||i.ctrlKey)&&!i.altKey&&!i.shiftKey){var j=this.getRows();var R1=j[0];var S1=new W.Event("saphome");S1._bPlanningCalendar=true;H1(R1).onsaphome(S1);i.preventDefault();i.stopPropagation();}};
k1.prototype.onsapendmodifiers=function(i){if((i.metaKey||i.ctrlKey)&&!i.altKey&&!i.shiftKey){var j=this.getRows();var R1=j[j.length-1];var S1=new W.Event("sapend");S1._bPlanningCalendar=true;H1(R1).onsapend(S1);i.preventDefault();i.stopPropagation();}};
k1.prototype.setBuiltInViews=function(i){this.setProperty("builtInViews",i);this.setViewKey(this._getViews()[0].getKey());return this;};
k1.prototype.removeView=function(i){var j=this.removeAggregation("views",i);if(!this.getViews().length){this.setViewKey(this._getViews()[0].getKey());}return j;};
k1.prototype._getIntervals=function(i){var j=0;switch(this._iSize){case 0:j=i.getIntervalsS();break;case 1:j=i.getIntervalsM();break;default:j=i.getIntervalsL();break;}return j;};
k1.prototype._getView=function(j,R1){var S1=this._getViews();var T1;for(var i=0;i<S1.length;i++){T1=S1[i];if(T1.getKey()!=j){T1=undefined;}else{break;}}if(!T1&&!R1){throw new Error("PlanningCalendarView with key "+j+" not assigned "+this);}return T1;};
k1.prototype._changeStartDate=function(i){if(this._bNoStartDateChange){return;}this.setStartDate(new Date(i.getTime()));this._updatePickerSelection();this.fireStartDateChange();};
k1.prototype._updateCurrentTimeVisualization=function(j){if(this._sUpdateCurrentTime){clearTimeout(this._sUpdateCurrentTime);this._sUpdateCurrentTime=undefined;}if(j){var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=R1[i];H1(S1).updateCurrentTimeVisualization();}}var T1=new Date();var U1=this.getStartDate();var V1=this.getViewKey();var W1=this._getView(V1);var X1=W1.getIntervalType();var Y1=this._getIntervals(W1);var Z1=0;var $1=0;var _1=0;switch(X1){case d1.Hour:Z1=60000;$1=U1.getTime()-3600000;_1=U1.getTime()+Y1*3600000;break;case d1.Day:case d1.Week:case d1.OneMonth:Z1=1800000;$1=U1.getTime()-3600000;_1=U1.getTime()+Y1*86400000;break;default:Z1=-1;break;}if(T1.getTime()<=_1&&T1.getTime()>=$1&&Z1>0){this._sUpdateCurrentTime=setTimeout(this['_updateCurrentTimeVisualization'].bind(this,true),Z1);}};
function s1(i){this.setViewKey(i.getParameter("item").getKey());this.fireViewChange();}
k1.prototype._handleTodayPress=function(i){var j=new Date(),R1,S1=this.getViewKey();if(S1===_.OneMonth){R1=b.getFirstDateOfMonth(b._createUniversalUTCDate(j,undefined,true));this._adjustSelectedDate(c.fromLocalJSDate(j));j=b._createLocalDate(R1,true);}if(S1===_.Week){R1=this.getStartDate();j.setHours(R1.getHours());j.setMinutes(R1.getMinutes());j.setSeconds(R1.getSeconds());}this.setStartDate(j);this._dateNav.setCurrent(j);this._updatePickerSelection();this.fireStartDateChange();};
k1.prototype._handleStartDateChange=function(i){var j=i.oSource.getStartDate();if(this._getView(this.getViewKey()).getIntervalType()!==d1.Hour){var R1=this.getStartDate();j.setHours(R1.getHours());j.setMinutes(R1.getMinutes());j.setSeconds(R1.getSeconds());}this._changeStartDate(j);};
k1.prototype._handleDateSelect=function(i){var j=i.oSource.getStartDate();if(this._getView(this.getViewKey()).getIntervalType()===d1.Hour){var R1=this.getStartDate();j.setHours(R1.getHours());j.setMinutes(R1.getMinutes());j.setSeconds(R1.getSeconds());}this._changeStartDate(j);this._dateNav.setCurrent(j);var S1=this.getViewKey(),T1=this._getView(S1),U1=T1.getIntervalType(),V1;if(U1==="Hour"){U1="Time";}else if(U1==="Day"){U1="Date";}else if(U1==="One Month"){U1="OneMonth";}V1="_o"+U1+"sRow";if(this[V1]){this[V1].setDate(j);}};
k1.prototype._handleCalendarSelect=function(i){var j=i.getSource().getSelectedDates();if(!j.length){return;}var R1=new Date(j[0].getStartDate());var S1=b._createUniversalUTCDate(R1,undefined,true);var T1=this.getViewKey();var U1=this._getView(T1);var V1=U1.getIntervalType();if(V1!==d1.OneMonth||this._iSize>1){j[0].setStartDate();}switch(V1){case d1.Hour:S1.setUTCHours(S1.getUTCHours()+1);break;case d1.Day:case d1.Week:S1.setUTCDate(S1.getUTCDate()+1);break;case d1.OneMonth:if(this._iSize<2){var W1=new Date(R1.getTime());if(b.monthsDiffer(this.getStartDate(),R1)){this.setStartDate(R1);this._getHeader().setPickerText(this._formatPickerText());}this._setRowsStartDate(W1);this._oOneMonthsRow._focusDate(c.fromLocalJSDate(W1),true);}else if(b._isNextMonth(R1,this.getStartDate())){this.shiftToDate(R1);return;}S1.setUTCDate(S1.getUTCDate()+1);break;case d1.Month:S1.setUTCMonth(S1.getUTCMonth()+1);break;default:throw new Error("Unknown IntervalType: "+V1+"; "+this);}S1.setUTCMilliseconds(S1.getUTCMilliseconds()-1);S1=b._createLocalDate(S1,true);this._formatPickerText();this.fireIntervalSelect({startDate:R1,endDate:S1,subInterval:false,row:undefined});};
function t1(i){var j=i.getParameter("startDate");var R1=this.getViewKey();var S1=this._getView(R1);var T1=S1.getIntervalType();if(T1===d1.OneMonth&&b._isNextMonth(j,this.getStartDate())){this.shiftToDate(j);return;}var U1=i.getParameter("endDate");var V1=i.getParameter("subInterval");var W1=E1(i.oSource.getParent());this._formatPickerText();this.fireIntervalSelect({startDate:j,endDate:U1,subInterval:V1,row:W1});}
k1.prototype._applyContextualSettings=function(i){return C.prototype._applyContextualSettings.call(this,i||M._defaultContextualSettings);};
function u1(i,j){this.$().toggleClass("sapMPlanCalWithWeekNumbers",i&&j);}
function v1(i,j){this.$().toggleClass("sapMPlanCalWithDayNamesLine",i&&j);}
function w1(j,R1){if(j.size.width<=0){return;}if(Math.abs(this.iWidth-j.size.width)<15){return;}this.iWidth=j.size.width;this._applyContextualSettings({contextualWidth:this.iWidth});var S1=this.getRows();var T1;var i=0;var U1;var V1=this._iSize;J1.call(this,j.size.width);if(V1!=this._iSize){K1.call(this,this._iSize);var W1=this.getViewKey();var X1=this._getView(W1);var Y1=X1.getIntervalType();var Z1=this._getIntervals(X1);for(i=0;i<S1.length;i++){T1=S1[i];var $1=H1(T1);if(Z1!=$1.getIntervals()){$1.setIntervals(Z1);}else{$1.handleResize();}}switch(Y1){case d1.Hour:if(this._oTimesRow&&this._oTimesRow.getItems()!=Z1){this._oTimesRow.setItems(Z1);this._dateNav.setStep(Z1);}break;case d1.Day:if(this._oDatesRow&&this._oDatesRow.getDays()!=Z1){this._oDatesRow.setDays(Z1);this._dateNav.setStep(Z1);}break;case d1.Month:if(this._oMonthsRow&&this._oMonthsRow.getMonths()!=Z1){this._oMonthsRow.setMonths(Z1);this._dateNav.setStep(Z1);}break;case d1.Week:if(this._oWeeksRow&&this._oWeeksRow.getDays()!=Z1){this._oWeeksRow.setDays(Z1);this._dateNav.setStep(Z1);}break;case d1.OneMonth:if(this._oOneMonthsRow&&this._oOneMonthsRow.getDays()!=Z1){this._oOneMonthsRow.setDays(Z1);this._dateNav.setStep(Z1);if(this._iSize>1){this._setRowsStartDate(new Date(this.getStartDate().getTime()));}}break;default:throw new Error("Unknown IntervalType: "+Y1+"; "+this);}P1.call(this);}else if(!R1){for(i=0;i<S1.length;i++){T1=S1[i];H1(T1).handleResize();}}if(this._oOneMonthsRow&&this.getViewKey()===d1.OneMonth){U1=(this._getSelectedDates().length&&this._getSelectedDates()[0].getStartDate())?this._getSelectedDates()[0].getStartDate():this.getStartDate();this._oOneMonthsRow.setMode(this._iSize);this._adjustSelectedDate(c.fromLocalJSDate(U1));}if(this.getStickyHeader()){this._updateStickyHeader();}}
function x1(R1){var S1=R1.getParameter("appointment"),T1=R1.getParameter("multiSelect"),U1=R1.getParameter("appointments"),V1=R1.getParameter("domRefId"),W1,X1,Y1,Z1,$1,i,j;if(!T1){X1=this.getRows();for(i=0;i<X1.length;i++){Y1=X1[i];if(R1.oSource!=H1(Y1)){Z1=Y1.getAppointments();for(j=0;j<Z1.length;j++){$1=Z1[j];$1.setSelected(false);}}}}W1={appointment:S1,appointments:U1,multiSelect:T1,domRefId:V1};this.fireAppointmentSelect(W1);}
k1.prototype._setRowsStartDate=function(j){var R1=this.getRows(),S1,i;for(i=0;i<R1.length;i++){S1=R1[i];H1(S1).setStartDate(j);}};
k1.prototype._toggleAppointmentsColumnPopinState=function(i){var j=this.getAggregation("table"),R1=j.getColumns()[1];R1.setDemandPopin(i);R1.setMinScreenWidth(i?n1:"");};
k1.prototype._getViews=function(){var i=this.getViews(),j=this.getBuiltInViews(),R1,S1=[],T1=_,U1=d1;if(!this._oViews){this._oViews={};}if(j.length){S1=j;}else{S1=i.length?[]:o1;}R1=S1.map(function(W1){switch(W1){case T1.Hour:return this._oViews[T1.Hour]||(this._oViews[T1.Hour]=new L(this.getId()+"-HourView",{key:T1.Hour,intervalType:U1.Hour,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_HOURS"),intervalsS:6,intervalsM:6,intervalsL:12}));case T1.Day:return this._oViews[T1.Day]||(this._oViews[T1.Day]=new L(this.getId()+"-DayView",{key:T1.Day,intervalType:U1.Day,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_DAYS"),intervalsS:7,intervalsM:7,intervalsL:14}));case T1.Month:return this._oViews[T1.Month]||(this._oViews[T1.Month]=new L(this.getId()+"-MonthView",{key:T1.Month,intervalType:U1.Month,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_MONTHS"),intervalsS:3,intervalsM:6,intervalsL:12}));case T1.Week:return this._oViews[T1.Week]||(this._oViews[T1.Week]=new L(this.getId()+"-WeekView",{key:T1.Week,intervalType:U1.Week,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_WEEK"),intervalsS:7,intervalsM:7,intervalsL:7}));case T1.OneMonth:return this._oViews[T1.OneMonth]||(this._oViews[T1.OneMonth]=new L(this.getId()+"-OneMonthView",{key:T1.OneMonth,intervalType:U1.OneMonth,description:this._oRB&&this._oRB.getText("PLANNINGCALENDAR_ONE_MONTH"),intervalsS:1,intervalsM:1,intervalsL:31}));default:V.error("Cannot get PlanningCalendar views. Invalid view key "+W1);break;}},this);for(var V1 in this._oViews){if(S1.indexOf(V1)<0){this._oViews[V1].destroy();delete this._oViews[V1];}}if(i.length){R1=R1.concat(i);}return R1;};
k1.prototype.getSelectedAppointments=function(){var i=[];this.getRows().filter(function(j){i.push.apply(i,H1(j).aSelectedAppointments);});return i;};
k1.prototype.setCustomAppointmentsSorterCallback=function(i){if(typeof i==="function"||i===null||i===undefined){this.getRows().forEach(function(j){H1(j)._setCustomAppointmentsSorterCallback(i);});this._fnCustomSortedAppointments=i;}else{V.warning("Your custom sort function won't be used, but the old one will be preserved.",this);}return this;};
k1.prototype.setWidth=function(i){var j=this.getStartDate();this.getRows().forEach(function(R1){H1(R1).setStartDate(j);});return this.setProperty("width",i);};
k1.prototype.getCustomAppointmentsSorterCallback=function(){return this._fnCustomSortedAppointments;};
k1.prototype._onRowDeselectAppointment=function(){var R1=this.getRows();for(var i=0;i<R1.length;i++){var S1=H1(R1[i]).aSelectedAppointments;for(var j=0;j<S1.length;j++){var T1=n.byId(S1[j]);if(T1){T1.setProperty("selected",false,true);T1.$().removeClass("sapUiCalendarAppSel");}}H1(R1[i]).aSelectedAppointments=[];}};
k1.prototype._updateRowTimeline=function(i){var j=H1(i),R1,S1,T1,U1,V1=this.getViewKey()===_.OneMonth&&this._iSize<2,W1=this.getStartDate();j.setNonWorkingDays(i.getNonWorkingDays());j.setNonWorkingHours(i.getNonWorkingHours());if(V1&&this._oOneMonthsRow&&this._oOneMonthsRow.getSelectedDates().length){W1=this._oOneMonthsRow.getSelectedDates()[0].getStartDate();}j.setStartDate(W1);j.setShowIntervalHeaders(this.getShowIntervalHeaders());j.setShowEmptyIntervalHeaders(this.getShowEmptyIntervalHeaders());j.setGroupAppointmentsMode(this.getGroupAppointmentsMode());j.setAppointmentsReducedHeight(this.getAppointmentsReducedHeight());j.setAppointmentRoundWidth(this.getAppointmentRoundWidth());j.setLegend(this.getLegend());j.setAppointmentsVisualization(this.getAppointmentsVisualization());j.setAppointmentHeight(this.getAppointmentHeight());j.attachEvent("select",x1,this);j.attachEvent("startDateChange",this._handleStartDateChange,this);j.attachEvent("leaveRow",N1,this);j.attachEvent("intervalSelect",t1,this);O1.call(this);if(Q1.call(this)){R1=this.getViewKey();S1=this._getView(R1);T1=S1.getIntervalType();U1=this._getIntervals(S1);j.setIntervalType(T1);j.setIntervals(U1);j.setShowSubIntervals(S1.getShowSubIntervals());}this._setSelectionMode.call(this);if(this._fnCustomSortedAppointments){j._setCustomAppointmentsSorterCallback(this._fnCustomSortedAppointments);}};
k1.prototype._observeRowChanges=function(i){var j=F1(i),R1=G1(i),S1=H1(i);var T1={destroy:function(){j.destroy();},change:{title:function(U1){R1.setProperty(U1.name,U1.current);},icon:function(U1){R1.setProperty(U1.name,U1.current);},text:function(U1){S1.toggleStyleClass("sapMPlanCalRowLarge",!!U1.current);R1.setProperty("description",U1.current);},enableAppointmentsDragAndDrop:function(U1){this._enableAppointmentsDragAndDrop(i);}.bind(this),enableAppointmentsResize:function(U1){this._enableAppointmentsResize(i);}.bind(this),enableAppointmentsCreate:function(U1){this._enableAppointmentsCreate(i);}.bind(this),nonWorkingDays:function(U1){S1.setProperty(U1.name,U1.current);},nonWorkingHours:function(U1){S1.setProperty(U1.name,U1.current);},selected:function(U1){O1.call(this);j.setProperty(U1.name,U1.current);}.bind(this),tooltip:function(U1){if(U1.mutation==="insert"){R1.setTooltip(U1.child);}else if(U1.mutation==="remove"){R1.setTooltip();}},intervalHeaders:function(U1){S1.invalidate();},appointments:function(U1){S1.invalidate();}}};new a(function(U1){if(U1.type==="destroy"){T1.destroy();}else if(T1.change[U1.name]){T1.change[U1.name](U1);}}).observe(i,{properties:["icon","text","title","nonWorkingDays","nonWorkingHours","selected","enableAppointmentsDragAndDrop","enableAppointmentsResize","enableAppointmentsCreate"],aggregations:["tooltip","appointments","intervalHeaders","headerContent"],destroy:true});i.invalidate=function(U1){if(!U1||!(U1 instanceof h)){E.prototype.invalidate.apply(this,arguments);}else if(j){S1.invalidate(U1);}};i.applyFocusInfo=function(U1){S1.applyFocusInfo(U1);return this;};};
k1.prototype._createPlanningCalendarListItem=function(i){var j,R1,S1;if(i.getHeaderContent().length||i.getBindingInfo("headerContent")){R1=i._getPlanningCalendarCustomRowHeader();}else{R1=new y1(i.getId()+"-Head",{icon:i.getIcon(),description:i.getText(),title:i.getTitle(),tooltip:i.getTooltip(),iconDensityAware:false});}S1=new A1(i.getId()+"-CalRow",{checkResize:false,updateCurrentTime:false,ariaLabelledBy:R1.getId()});S1.getAppointments=function(){return i.getAppointments();};S1.getIntervalHeaders=function(){return i.getIntervalHeaders();};S1.setAssociation("row",i.getId());j=new C1(i.getId()+j1,{cells:[R1,S1]});this._updateRowTimeline(i);this._observeRowChanges(i);this._enableAppointmentsDragAndDrop(i);this._enableAppointmentsResize(i);this._enableAppointmentsCreate(i);return j;};
k1.prototype._handleRowRemoval=function(i){var j=H1(i);j.detachEvent("select",x1,this);j.detachEvent("startDateChange",this._handleStartDateChange,this);j.detachEvent("leaveRow",N1,this);j.detachEvent("intervalSelect",t1,this);if(this._fnCustomSortedAppointments){j._fnCustomSortedAppointments=undefined;}F1(i).destroy();};
var y1=G.extend("PlanningCalendarRowHeader",{
renderer:R.extend(H),
TagName:"div"
});
y1.prototype.isSelectable=function(){return false;};
PlanningCalendarRowHeaderRenderer.renderTabIndex=function(i,j){};
PlanningCalendarRowHeaderRenderer.getAriaRole=function(i,j){};
var z1=R.extend(l);z1.apiVersion=2;
z1.getLegendItems=function(i){var j=[],R1,S1=i.getLegend();if(S1){R1=n.byId(S1);if(R1){j=R1.getAppointmentItems?R1.getAppointmentItems():R1.getItems();}else{V.error("PlanningCalendarLegend with id '"+S1+"' does not exist!",i);}}return j;};
z1.renderBeforeAppointments=function(j,R1){var S1=E1(R1.getParent()),T1;if(!S1.getEnableAppointmentsDragAndDrop()&&!S1.getEnableAppointmentsResize()&&!S1.getEnableAppointmentsCreate()||R1._isOneMonthsRowOnSmallSizes()){return;}T1=R1.getAggregation("_intervalPlaceholders");j.openStart("div");j.class("sapUiCalendarRowAppsOverlay");j.openEnd();if(T1){for(var i=0;i<T1.length;i++){var U1=T1[i];U1.setWidth(100/T1.length+"%");j.renderControl(U1);}}j.close("div");};
z1.renderResizeHandle=function(i,j,R1){if(!E1(j.getParent()).getEnableAppointmentsResize()||j._isOneMonthsRowOnSmallSizes()||(R1._aAppointments&&R1._aAppointments.length>0)){return;}i.openStart("span");i.class("sapUiCalendarAppResizeHandle");i.openEnd();i.close("span");};
z1.writeCustomAttributes=function(i,j){if(E1(j.getParent()).getEnableAppointmentsCreate()){i.attr("draggable","true");}};
z1.renderInterval=function(j,R1,S1,T1,U1,V1,W1,X1,Y1,Z1,$1,_1,a2){var b2=R1.getIntervalType(),c2;if(b2===d1.Day||b2===d1.Week||b2===d1.OneMonth){var d2=E1(R1.getParent()),e2=d2.getParent(),f2=function(p2){return p2.getType()===Y.NonWorking;},g2=d2._getSpecialDates().filter(f2),h2=e2._getSpecialDates().filter(f2),i2=R1.getStartDate(),j2,k2,l2,m2;if(h2&&g2){j2=h2.concat(g2);}else if(g2){j2=g2;}if(j2&&j2.length){var n2=function(p2){return p2===k2.getDay();};k2=new Date(i2.getTime());k2.setHours(0,0,0);k2.setDate(i2.getDate()+S1);for(var i=0;i<j2.length;i++){if(j2[i].getStartDate()){l2=new Date(j2[i].getStartDate().getTime());}if(j2[i].getEndDate()){m2=new Date(j2[i].getEndDate().getTime());}else{m2=new Date(j2[i].getStartDate().getTime());m2.setHours(23,59,59);}if(k2.getTime()>=l2.getTime()&&k2.getTime()<=m2.getTime()){var o2=V1.some(n2);if(!o2){c2="sapUiCalendarRowAppsNoWork";}}}}}l.renderInterval(j,R1,S1,T1,U1,V1,W1,X1,Y1,Z1,$1,_1,a2,c2);};
var A1=k.extend("PlanningCalendarRowTimeline",{
metadata:{aggregations:{intervalHeaders:{type:"sap.ui.unified.CalendarAppointment",multiple:true},_intervalPlaceholders:{type:"IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},associations:{row:{type:"sap.m.PlanningCalendarRow",multiple:false}},dnd:true},
renderer:z1
});
A1.prototype._updatePlaceholders=function(){var j=this.getProperty("intervals");if(this.getIntervalType()===d1.Hour){j*=2;}this.removeAllAggregation("_intervalPlaceholders");for(var i=0;i<j;i++){this.addAggregation("_intervalPlaceholders",new B1());}};
A1.prototype.onBeforeRendering=function(){k.prototype.onBeforeRendering.call(this);this._updatePlaceholders();};
A1.prototype.onmousedown=function(i){var j=i.target.classList;this._isResizeHandleMouseDownTarget=j.contains("sapUiCalendarAppResizeHandle");this._isRowAppsIntervalMouseDownTarget=j.contains("sapUiCalendarRowAppsInt");};
A1.prototype._isResizingPerformed=function(){return this._isResizeHandleMouseDownTarget;};
A1.prototype._isDraggingPerformed=function(){return!this._isResizeHandleMouseDownTarget&&!this._isRowAppsIntervalMouseDownTarget;};
A1.prototype._isCreatingPerformed=function(){return this._isRowAppsIntervalMouseDownTarget;};
var B1=C.extend("IntervalPlaceholder",{
metadata:{properties:{width:{type:"sap.ui.core.CSSSize",group:"Appearance",defaultValue:null}}},
renderer:function(i,j){i.openStart("div",j);i.style("width",j.getWidth());i.class("sapUiCalendarRowAppsPlaceholder");i.openEnd();i.close("div");}
});
var C1=z.extend("sap.m.internal.PlanningCalendarRowListItem",{
metadata:{library:"sap.m"},
renderer:A
});
C1.prototype.getHeader=function(){return this.getCells()[0];};
C1.prototype.getTimeline=function(){return this.getCells()[1];};
C1.prototype.getCustomData=function(){return E1(this).getCustomData();};
k1.prototype._getSelectedDates=function(){var i=this.getViewKey(),j=this._getView(i),R1=j.getIntervalType(),S1=m1[R1];return this[S1.sInstanceName].getSelectedDates();};
k1.prototype._enableAppointmentsDragAndDrop=function(i){var j=H1(i),R1;if(i.getEnableAppointmentsDragAndDrop()){R1=i.getDragDropConfig().some(function(S1){return S1.getGroupName()===g1;});if(!R1){this._addDragDropInfo(i,H1(i));}}else{i.getDragDropConfig().forEach(function(S1){if(S1.getGroupName()===g1){i.removeDragDropConfig(S1);}});j.getDragDropConfig().forEach(function(S1){if(S1.getGroupName()===g1){j.removeDragDropConfig(S1);}});}};
k1.prototype._enableAppointmentsResize=function(i){var j=i.getEnableAppointmentsResize(),R1=this._getConfigFromDragDropConfigAggregation(i.getAggregation("dragDropConfig"),h1),S1=this._getResizeConfig(i);if(j&&!R1){i.addAggregation("dragDropConfig",S1,true);}if(!j){i.removeAggregation("dragDropConfig",R1,true);}};
k1.prototype._enableAppointmentsCreate=function(i){var j=i.getEnableAppointmentsCreate(),R1=H1(i),S1=this._getConfigFromDragDropConfigAggregation(R1.getAggregation("dragDropConfig"),i1),T1=this._getAppointmentsCreateConfig(i);if(j&&!S1){R1.addAggregation("dragDropConfig",T1,true);}if(!j){R1.removeAggregation("dragDropConfig",S1,true);}};
k1.prototype._addDragDropInfo=function(i,j){i.addDragDropConfig(new q({groupName:g1,sourceAggregation:"appointments",dragStart:function(R1){var S1=function(){var T1=W(".sapUiCalendarRowAppsOverlay");setTimeout(function(){T1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);W(document).one("dragend",function(){T1.removeClass("sapUiCalendarRowAppsOverlayDragging");});};if(j._isOneMonthsRowOnSmallSizes()||!j._isDraggingPerformed()){R1.preventDefault();return;}S1();}}));j.addDragDropConfig(new r({groupName:g1,targetAggregation:"_intervalPlaceholders",dragEnter:function(R1){var S1=R1.getParameter("dragSession"),T1=S1.getDragControl(),U1=j.getIntervalType(),V1=j.getStartDate(),W1=j.indexOfAggregation("_intervalPlaceholders",S1.getDropControl()),X1=j.getId(),Y1,Z1=function(){var _1=W(S1.getIndicator()),a2=S1.getDropControl().getDomRef().getBoundingClientRect(),b2=n.byId(X1).getDomRef().getBoundingClientRect(),c2=S1.getDragControl().$().outerWidth(),d2=n.getConfiguration().getRTL(),e2=d2?Math.ceil(a2.right)-b2.left:b2.right-Math.ceil(a2.left);_1.css("min-width",(c2<e2)?c2:e2).css(d2?"border-left-width":"border-right-width",(c2>e2)?"0":"").css("margin-left",d2?-(_1.outerWidth()-parseFloat(_1.context.style.width)):"");};if(i.hasListeners("appointmentDragEnter")){if(U1===d1.Hour){Y1=this._calcNewHoursAppPos(V1,T1.getStartDate(),T1.getEndDate(),W1);}else if(U1===d1.Day||U1===d1.Week||(U1===d1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){Y1=this._calcNewDaysAppPos(V1,T1.getStartDate(),T1.getEndDate(),W1);}else if(U1===d1.Month){Y1=this._calcNewMonthsAppPos(V1,T1.getStartDate(),T1.getEndDate(),W1);}var $1=i.fireAppointmentDragEnter({appointment:T1,startDate:Y1.startDate,endDate:Y1.endDate,calendarRow:E1(j.getParent())});if(!$1){R1.preventDefault();return;}}else if(H1(T1.getParent())!==j){R1.preventDefault();return;}if(j.getIntervalType()!==d1.Hour){return;}if(!S1.getIndicator()){setTimeout(Z1,0);}else{Z1();}}.bind(this),drop:function(R1){var S1=R1.getParameter("dragSession"),T1=S1.getDragControl(),U1=j.getIntervalType(),V1=j.getStartDate(),W1=j.indexOfAggregation("_intervalPlaceholders",S1.getDropControl()),X1,Y1=R1.getParameter("browserEvent"),Z1=(Y1.metaKey||Y1.ctrlKey);if(U1===d1.Hour){X1=this._calcNewHoursAppPos(V1,T1.getStartDate(),T1.getEndDate(),W1);}else if(U1===d1.Day||U1===d1.Week||(U1===d1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){X1=this._calcNewDaysAppPos(V1,T1.getStartDate(),T1.getEndDate(),W1);}else if(U1===d1.Month){X1=this._calcNewMonthsAppPos(V1,T1.getStartDate(),T1.getEndDate(),W1);}j.$().find(".sapUiCalendarRowAppsOverlay").removeClass("sapUiCalendarRowAppsOverlayDragging");if(T1.getStartDate().getTime()===X1.startDate.getTime()&&T1.getParent()===E1(j.getParent())){return;}i.fireAppointmentDrop({appointment:T1,startDate:X1.startDate,endDate:X1.endDate,calendarRow:E1(j.getParent()),copy:Z1});}.bind(this)}));};
k1.prototype._calcNewHoursAppPos=function(i,j,R1,S1){var T1=b._createUniversalUTCDate(i,null,true),U1=b._createUniversalUTCDate(j,null,true),V1=b._createUniversalUTCDate(R1,null,true),W1=new Date(T1.setUTCMinutes(0,0,0)+(S1*30*60*1000));return{startDate:b._createLocalDate(W1,true),endDate:b._createLocalDate(new Date(W1.getTime()+V1.getTime()-U1.getTime()),true)};};
k1.prototype._calcNewDaysAppPos=function(i,j,R1,S1){var T1=b._createUniversalUTCDate(i,null,true),U1=b._createUniversalUTCDate(j,null,true),V1=b._createUniversalUTCDate(R1,null,true),W1=V1.getTime()-U1.getTime();U1.setUTCFullYear(T1.getUTCFullYear(),T1.getUTCMonth(),T1.getUTCDate()+S1);V1=new Date(U1.getTime()+W1);return{startDate:b._createLocalDate(U1,true),endDate:b._createLocalDate(V1,true)};};
k1.prototype._calcNewMonthsAppPos=function(i,j,R1,S1){var T1=b._createUniversalUTCDate(i,null,true),U1=b._createUniversalUTCDate(j,null,true),V1=b._createUniversalUTCDate(R1,null,true),W1=V1.getTime()-U1.getTime();U1.setUTCFullYear(T1.getUTCFullYear(),T1.getUTCMonth()+S1);V1=new Date(U1.getTime()+W1);return{startDate:b._createLocalDate(U1,true),endDate:b._createLocalDate(V1,true)};};
k1.prototype._getResizeConfig=function(i){var j=H1(i),R1=new s({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",targetElement:H1(i),dragStart:function(S1){if(!i.getEnableAppointmentsResize()||j._isOneMonthsRowOnSmallSizes()||!j._isResizingPerformed()){S1.preventDefault();return;}var T1=S1.getParameter("dragSession"),U1=j.$().find(".sapUiCalendarRowAppsOverlay"),V1=W(T1.getIndicator()),W1=T1.getDragControl().$();V1.addClass("sapUiDnDIndicatorHide");setTimeout(function(){U1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);W(document).one("dragend",function(){U1.removeClass("sapUiCalendarRowAppsOverlayDragging");V1.removeClass("sapUiDnDIndicatorHide");W1.css({width:"auto","min-width":"auto","z-index":"auto",opacity:1});});if(!m.browser.msie&&!m.browser.edge){S1.getParameter("browserEvent").dataTransfer.setDragImage(D1(),0,0);}},dragEnter:function(S1){var T1=S1.getParameter("dragSession"),U1=this.getTargetElement(),V1=function(){var $1=W(T1.getIndicator());$1.addClass("sapUiDnDIndicatorHide");},W1=T1.getDropControl().getDomRef().getBoundingClientRect(),X1=n.byId(U1).getDomRef().getBoundingClientRect(),Y1={width:W1.left+W1.width-(T1.getDragControl().$().position().left+X1.left),"z-index":1,opacity:0.8},Z1=Y1.width;if(W1.width>0){while(Z1<=0){Z1+=W1.width;}while(Z1>W1.width){Z1-=W1.width;}}Y1["min-width"]=Z1;T1.getDragControl().$().css(Y1);if(!T1.getIndicator()){setTimeout(V1,0);}else{V1();}},drop:function(S1){var j=H1(i),T1=S1.getParameter("dragSession"),U1=T1.getDragControl(),V1=j.getIntervalType(),W1=j.getStartDate(),X1=j.indexOfAggregation("_intervalPlaceholders",T1.getDropControl()),Y1;if(V1===d1.Hour){Y1=this._calcResizeNewHoursAppPos(W1,U1.getStartDate(),U1.getEndDate(),X1);}else if(V1===d1.Day||V1===d1.Week||(V1===d1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){Y1=this._calcResizeNewDaysAppPos(W1,U1.getStartDate(),U1.getEndDate(),X1);}else if(V1===d1.Month){Y1=this._calcResizeNewMonthsAppPos(W1,U1.getStartDate(),U1.getEndDate(),X1);}j.$().find(".sapUiCalendarRowAppsOverlay").removeClass("sapUiCalendarRowAppsOverlayDragging");W(T1.getIndicator()).removeClass("sapUiDnDIndicatorHide");U1.$().css({width:"auto","min-width":"auto","z-index":"auto",opacity:1});if(U1.getEndDate().getTime()===Y1.endDate.getTime()){return;}i.fireAppointmentResize({appointment:U1,startDate:Y1.startDate,endDate:Y1.endDate,calendarRow:i});}.bind(this)});R1.setProperty("groupName",h1);return R1;};
k1.prototype._calcResizeNewHoursAppPos=function(i,j,R1,S1){var T1=b._createUniversalUTCDate(new Date(i.getTime()),null,true),U1=30*60*1000,V1=b._createUniversalUTCDate(j,null,true),W1=new Date(T1.setUTCMinutes(0,0,0)+((S1+1)*U1));if(W1.getTime()<=V1.getTime()){W1=new Date(V1.getTime()+U1);}return{startDate:b._createLocalDate(V1,true),endDate:b._createLocalDate(W1,true)};};
k1.prototype._calcResizeNewDaysAppPos=function(i,j,R1,S1){var T1=b._createUniversalUTCDate(i,null,true),U1=b._createUniversalUTCDate(j,null,true),V1=new Date(T1.setUTCDate(T1.getUTCDate()+S1+1)),W1={};W1.startDate=b._createLocalDate(U1);W1.startDateTime=b._createLocalDate(U1,true);W1.endDate=b._createLocalDate(V1);if(W1.endDate<=W1.startDate){W1.endDate=b._createLocalDate(new Date(V1.setUTCDate(U1.getUTCDate()+1)));}return{startDate:W1.startDateTime,endDate:W1.endDate};};
k1.prototype._calcResizeNewMonthsAppPos=function(i,j,R1,S1){var T1=b._createUniversalUTCDate(i,null,true),U1=b._createUniversalUTCDate(j,null,true),V1=new Date(T1.setUTCMonth(T1.getUTCMonth()+S1+1,1));if(b._monthsBetween(U1,V1,true)<0){V1=new Date(V1.setUTCFullYear(U1.getUTCFullYear(),U1.getUTCMonth()+1,1));}return{startDate:b._createLocalDate(U1,true),endDate:b._createLocalDate(V1)};};
k1.prototype._calcCreateNewAppHours=function(i,j,R1){var S1=b._createUniversalUTCDate(i,null,true),T1=30*60*1000,U1=(j<=R1)?j:R1,V1=(j<=R1)?R1+1:j,W1=new Date(S1.setUTCMinutes(0,0,0)),X1=new Date(W1.getTime()+U1*T1),Y1=new Date(W1.getTime()+V1*T1);return{startDate:b._createLocalDate(X1,true),endDate:b._createLocalDate(Y1,true)};};
k1.prototype._calcCreateNewAppDays=function(i,j,R1){var S1=b._createUniversalUTCDate(i,null,true),T1=(j<=R1)?j:R1,U1=(j<=R1)?R1+1:j,V1=new Date(S1.getTime()),W1=new Date(S1.getTime());return{startDate:b._createLocalDate(new Date(V1.setUTCDate(V1.getUTCDate()+T1))),endDate:b._createLocalDate(new Date(W1.setUTCDate(W1.getUTCDate()+U1)))};};
k1.prototype._calcCreateNewAppMonths=function(i,j,R1){var S1=b._createUniversalUTCDate(i,null,true),T1=(j<=R1)?j:R1,U1=(j<=R1)?R1+1:j,V1=new Date(S1.getTime()),W1=new Date(S1.getTime());return{startDate:b._createLocalDate(new Date(V1.setUTCMonth(V1.getUTCMonth()+T1,1))),endDate:b._createLocalDate(new Date(W1.setUTCMonth(W1.getUTCMonth()+U1,1)))};};
k1.prototype._getConfigFromDragDropConfigAggregation=function(j,R1){var S1=j,T1=S1&&S1.length;for(var i=0;i<T1;i++){if(S1[i].getGroupName()===R1){return S1[i];}}return null;};
k1.prototype._getAppointmentsCreateConfig=function(i){var j=H1(i),R1=new s({targetAggregation:"_intervalPlaceholders",dragStart:function(S1){if(!i.getEnableAppointmentsCreate()||j._isOneMonthsRowOnSmallSizes()||!j._isCreatingPerformed()){S1.preventDefault();return;}var T1=S1.getParameter("dragSession"),U1=j.$().find(".sapUiCalendarRowAppsOverlay"),V1=W(T1.getIndicator());setTimeout(function(){U1.addClass("sapUiCalendarRowAppsOverlayDragging");},0);W(document).one("dragend",function(){U1.removeClass("sapUiCalendarRowAppsOverlayDragging");V1.html("");V1.removeClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");});if(!m.browser.msie&&!m.browser.edge){S1.getParameter("browserEvent").dataTransfer.setDragImage(D1(),0,0);}},dragEnter:function(S1){var T1=S1.getParameter("dragSession"),U1=T1.getDropControl().getDomRef().getBoundingClientRect(),V1=function(){var X1=W(T1.getIndicator());X1.addClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");};var W1=T1.getData("text")?parseFloat(T1.getData("text").split("|")[0]):0;if(W1){if(W1<=U1.left){T1.setIndicatorConfig({left:W1,width:Math.max((U1.left+U1.width-W1),U1.width)});}else{T1.setIndicatorConfig({left:U1.left,width:W1-U1.left});}}else{T1.setData("text",U1.left+"|"+j.indexOfAggregation("_intervalPlaceholders",T1.getDropControl()));}if(!T1.getIndicator()){setTimeout(V1,0);}else{V1();}},drop:function(S1){var T1=S1.getParameter("dragSession"),U1=W(T1.getIndicator()),V1=j.getIntervalType(),W1=H1(i).getStartDate(),X1=parseInt(T1.getData("text").split("|")[1]),Y1=j.indexOfAggregation("_intervalPlaceholders",T1.getDropControl()),Z1;if(V1===d1.Hour){Z1=this._calcCreateNewAppHours(W1,X1,Y1);}else if(V1===d1.Day||V1===d1.Week||(V1===d1.OneMonth&&!j._isOneMonthsRowOnSmallSizes())){Z1=this._calcCreateNewAppDays(W1,X1,Y1);}else if(V1===d1.Month){Z1=this._calcCreateNewAppMonths(W1,X1,Y1);}i.fireAppointmentCreate({startDate:Z1.startDate,endDate:Z1.endDate,calendarRow:i});U1.html("");U1.removeClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");}.bind(this)});R1.setProperty("groupName",i1);return R1;};
k1.prototype._updateHeaderButtons=function(){var i=this.getViewKey(),j=this._getView(i,true),R1=j&&j.getIntervalType(),S1=new Date(this._dateNav.getStart().getTime()),T1=new Date(this._dateNav.getEnd().getTime()),U1=this.getMinDate()?new Date(this.getMinDate().getTime()):undefined,V1=this.getMaxDate()?new Date(this.getMaxDate().getTime()):undefined;if(R1!=="Hour"){U1&&U1.setHours(0,0,0,0);V1&&V1.setHours(23,59,59,999);S1.setHours(0,0,0,0);T1.setHours(23,59,59,999);}this._getHeader()._oPrevBtn.setEnabled(!U1||S1.getTime()>U1.getTime());this._getHeader()._oNextBtn.setEnabled(!V1||T1.getTime()<V1.getTime());};
k1.prototype._getSpecialDates=function(){var j=this.getSpecialDates();for(var i=0;i<j.length;i++){var R1=j[i].getSecondaryType()===u.CalendarDayType.NonWorking&&j[i].getType()!==u.CalendarDayType.NonWorking;if(R1){var S1=new g();S1.setType(u.CalendarDayType.NonWorking);S1.setStartDate(j[i].getStartDate());if(j[i].getEndDate()){S1.setEndDate(j[i].getEndDate());}j.push(S1);}}return j;};
function D1(){var i=W("<span></span>").addClass("sapUiCalAppResizeGhost");i.appendTo(document.body);setTimeout(function(){i.remove();},0);return i.get(0);}
function E1(i){var j=i.getId();return n.byId(j.substring(0,j.indexOf(j1)));}
function F1(i){return n.byId(i.getId()+j1);}
function G1(i){var j=F1(i);return j?j.getHeader():null;}
function H1(i){var j=F1(i);return j?j.getTimeline():null;}
function I1(j){var R1=[];var S1=this.getRows();for(var i=0;i<S1.length;i++){var T1=S1[i];var U1=F1(T1);var V1=U1.getSelected();if(T1.getSelected()!=V1){T1.setProperty("selected",V1,true);R1.push(T1);}}if(!this.getSingleSelection()){O1.call(this);}if(R1.length>0){this.fireRowSelectionChange({rows:R1});}}
function J1(i){if(i<this._iBreakPointTablet){this._iSize=0;}else if(i<this._iBreakPointDesktop){this._iSize=1;}else{this._iSize=2;}if(i<p1.PHONE){this._iSizeScreen=0;}else if(i<p1.TABLET){this._iSizeScreen=1;}else{this._iSizeScreen=2;}}
function K1(j){var R1='sapMSize'+j,i,S1;for(i=0;i<3;i++){S1='sapMSize'+i;if(S1===R1){this.addStyleClass(S1);}else{this.removeStyleClass(S1);}}}
function L1(){var j=this._getViews();this._oIntervalTypeSelect.destroyItems();var i;var R1;for(i=0;i<j.length;i++){var S1=j[i];R1=new F(this.getId()+"-"+i,{key:S1.getKey(),text:S1.getDescription(),tooltip:S1.getTooltip()});this._oIntervalTypeSelect.addItem(R1);}if(this._oIntervalTypeSelect.getItems().length>4){this._getHeader()._convertViewSwitchToSelect();}else{this._getHeader()._convertViewSwitchToSegmentedButton();}this._oIntervalTypeSelect.setVisible(!(j.length===1));}
function M1(i){var j=i.getParameter("selected");var R1=this.getRows();if(j){R1=this.getRows().filter(function(S1){return!S1.getSelected();});}this.selectAllRows(j);this.fireRowSelectionChange({rows:R1});}
function N1(j){var R1=j.oSource;var S1=j.getParameter("type");var T1=this.getRows();var U1;var V1;var W1;var X1;var i=0;var Y1=0;var Z1;for(i=0;i<T1.length;i++){U1=T1[i];if(H1(U1)==R1){Y1=i;break;}}switch(S1){case"sapup":W1=R1.getFocusedAppointment();X1=W1.getStartDate();if(Y1>0){Y1--;}V1=T1[Y1];H1(V1).focusNearestAppointment(X1);break;case"sapdown":W1=R1.getFocusedAppointment();X1=W1.getStartDate();if(Y1<T1.length-1){Y1++;}V1=T1[Y1];H1(V1).focusNearestAppointment(X1);break;case"saphome":if(Y1>0){V1=T1[0];Z1=new W.Event(S1);Z1._bPlanningCalendar=true;H1(V1).onsaphome(Z1);}break;case"sapend":if(Y1<T1.length-1){V1=T1[T1.length-1];Z1=new W.Event(S1);Z1._bPlanningCalendar=true;H1(V1).onsapend(Z1);}break;default:break;}}
function O1(){if(this._oSelectAllCheckBox){var i=this.getRows();var j=this.getSelectedRows();if(i.length==j.length&&j.length>0){this._oSelectAllCheckBox.setSelected(true);}else{this._oSelectAllCheckBox.setSelected(false);}}}
function P1(){if(this.getSingleSelection()){if(this._oCalendarHeader.getAllCheckBox()){this._oCalendarHeader.setAllCheckBox();}else if(this._oInfoToolbar.getContent().length>2){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}}else{if(!this._oSelectAllCheckBox){this._oSelectAllCheckBox=new N(this.getId()+"-All",{text:this._oRB.getText("COLUMNSPANEL_SELECT_ALL")});this._oSelectAllCheckBox.attachEvent("select",M1,this);}if(this._iSizeScreen<2||!this.getShowRowHeaders()){var i=this._oInfoToolbar.indexOfContent(this._oSelectAllCheckBox);if(this._iSizeScreen<2){if(i<this._oInfoToolbar.getContent().length-1){this._oInfoToolbar.addContent(this._oSelectAllCheckBox);}}else if(i<0||i>1){if(i>1){this._oInfoToolbar.removeContent(this._oSelectAllCheckBox);}this._oInfoToolbar.insertContent(this._oSelectAllCheckBox,1);}}else{this._oCalendarHeader.setAllCheckBox(this._oSelectAllCheckBox);}}}
k1.prototype._setSelectionMode=function(){var i=this.getAggregation("table");var j=i.getMode();var R1;if(this.getSingleSelection()){if(!this.getShowRowHeaders()&&this.getRows().length==1){R1=Z.None;}else{R1=Z.SingleSelectMaster;}}else{R1=Z.MultiSelect;}if(j!=R1){i.setMode(R1);}};
function Q1(){return this._oTimesRow||this._oDatesRow||this._oMonthsRow||this._oWeeksRow||this._oOneMonthsRow;}
return k1;});
},
	"sap/m/PlanningCalendarHeader.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/core/Element','sap/ui/core/Control','./library','./Toolbar','./AssociativeOverflowToolbar','./Button','./AccButton','./Title','./ToolbarSpacer','./SegmentedButton','sap/ui/unified/Calendar','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CustomMonthPicker','sap/ui/unified/calendar/CustomYearPicker','sap/ui/core/format/DateFormat','sap/ui/core/Popup','sap/ui/core/IconPool','sap/ui/core/InvisibleText',"./PlanningCalendarHeaderRenderer"],function(E,C,l,T,A,B,a,b,c,S,d,e,f,g,D,P,I,h,j){"use strict";var k=l.ToolbarDesign;
var m=C.extend("sap.m.PlanningCalendarHeader",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:""},startDate:{type:"object",group:"Data"},pickerText:{type:"string",group:"Data"}},aggregations:{actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action"},_actionsToolbar:{type:"sap.m.OverflowToolbar",multiple:false,visibility:"hidden"},_navigationToolbar:{type:"sap.m.Toolbar",multiple:false,visibility:"hidden"},_calendarPicker:{type:"sap.ui.unified.Calendar",multiple:false,visibility:"hidden"},_monthPicker:{type:"sap.ui.unified.internal.CustomMonthPicker",multiple:false,visibility:"hidden"},_yearPicker:{type:"sap.ui.unified.internal.CustomYearPicker",multiple:false,visibility:"hidden"}},events:{pressPrevious:{},pressToday:{},pressNext:{},dateSelect:{},cancel:{},viewChange:{}},associations:{currentPicker:{type:"sap.ui.core.Control",multiple:false}}}});
var R=3;
m.prototype.init=function(){var o=this.getId(),n=o+"-NavToolbar",r=sap.ui.getCore().getLibraryResourceBundle("sap.m"),p,i,M,y;this.setAggregation("_actionsToolbar",new A(o+"-ActionsToolbar",{design:k.Transparent}).addStyleClass("sapMPCHeadActionsToolbar").addContent(this._getOrCreateTitleControl()).addContent(this._getOrCreateToolbarSpacer()).addContent(this._getOrCreateViewSwitch()));this._oPrevBtn=new B(n+"-PrevBtn",{icon:I.getIconURI('slim-arrow-left'),tooltip:r.getText("PCH_NAVIGATE_BACKWARDS"),press:function(){this.firePressPrevious();}.bind(this)});this._oTodayBtn=new B(n+"-TodayBtn",{text:r.getText("PLANNINGCALENDAR_TODAY"),ariaLabelledBy:h.getStaticId("sap.m","PCH_NAVIGATE_TO_TODAY"),press:function(){this.firePressToday();}.bind(this)});this._oNextBtn=new B(n+"-NextBtn",{icon:I.getIconURI('slim-arrow-right'),tooltip:r.getText("PCH_NAVIGATE_FORWARD"),press:function(){this.firePressNext();}.bind(this)});i=new d(o+"-Cal",{ariaLabelledBy:h.getStaticId("sap.m","PCH_RANGE_PICKER")});i.attachEvent("select",this._handlePickerDateSelect,this);i.attachEvent("cancel",this._handlePickerCancelEvent,this);i.setPopupMode(true);this.setAggregation("_calendarPicker",i);this.setAssociation("currentPicker",i);M=new f(o+"-MonthCal",{ariaLabelledBy:h.getStaticId("sap.m","PCH_RANGE_PICKER")});M.attachEvent("select",this._handlePickerDateSelect,this);M.attachEvent("cancel",this._handlePickerCancelEvent,this);M.setPopupMode(true);this.setAggregation("_monthPicker",M);y=new g(o+"-YearCal",{ariaLabelledBy:h.getStaticId("sap.m","PCH_RANGE_PICKER")});y.attachEvent("select",this._handlePickerDateSelect,this);y.attachEvent("cancel",this._handlePickerCancelEvent,this);y.setPopupMode(true);this.setAggregation("_yearPicker",y);this._oPickerBtn=new a(n+"-PickerBtn",{text:this.getPickerText(),ariaHaspopup:"dialog",ariaLabelledBy:h.getStaticId("sap.m","PCH_SELECT_RANGE"),press:function(){if(this.fireEvent("_pickerButtonPress",{},true)){var q=this.getStartDate()||new Date(),s=this.getAssociation("currentPicker");p=E.registry.get(s);p.displayDate(q);this._openCalendarPickerPopup(p);}}.bind(this)});this.setAggregation("_navigationToolbar",new T(n,{design:k.Transparent,content:[this._oPrevBtn,this._oTodayBtn,this._oNextBtn,this._oPickerBtn]}).addStyleClass("sapMPCHeadNavToolbar"));};
m.prototype.exit=function(){this._getActionsToolbar().removeAllContent();if(this._oTitle){this._oTitle.destroy();this._oTitle=null;}if(this._oToolbarSpacer){this._oToolbarSpacer.destroy();this._oToolbarSpacer=null;}if(this._oViewSwitch){this._oViewSwitch.destroy();this._oViewSwitch=null;}if(this._oPopup){this._oPopup.destroy();this._oPopup=null;}if(this._oPrevBtn){this._oPrevBtn.destroy();this._oPrevBtn=null;}if(this._oNextBtn){this._oNextBtn.destroy();this._oNextBtn=null;}};
m.prototype.onBeforeRendering=function(){var v=!!this.getActions().length||!!this.getTitle()||this._getOrCreateViewSwitch().getItems().length>1;this._getActionsToolbar().setProperty("visible",v,true);};
m.prototype.setTitle=function(t){this._getOrCreateTitleControl().setText(t).setVisible(!!t);return this.setProperty("title",t);};
m.prototype.addAction=function(o){if(!o){return this;}this._getActionsToolbar().addContent(o);return this.addAggregation("actions",o);};
m.prototype.insertAction=function(o,i){if(!o){return this;}this._getActionsToolbar().insertContent(o,i+R);return this.insertAggregation("actions",o,i);};
m.prototype.removeAction=function(o){if(!o){return this;}this._getActionsToolbar().removeContent(o);return this.removeAggregation("actions",o);};
m.prototype.removeAllActions=function(){var o=this._getActionsToolbar(),n=o.getContent();for(var i=R;i<n.length;i++){o.removeContent(n[i]);}return this.removeAllAggregation("actions");};
m.prototype.destroyActions=function(){var o=this._getActionsToolbar(),n=o.getContent(),r;for(var i=R;i<n.length;i++){r=o.removeContent(n[i]);r.destroy();}return this;};
m.prototype.setPickerText=function(t){this.setProperty("pickerText",t);this._oPickerBtn.setText(t);return this;};
m.prototype._getOrCreateTitleControl=function(){if(!this._oTitle){this._oTitle=new b(this.getId()+"-Title",{visible:false});}return this._oTitle;};
m.prototype._getOrCreateToolbarSpacer=function(){if(!this._oToolbarSpacer){this._oToolbarSpacer=new c(this.getId()+"-Spacer");}return this._oToolbarSpacer;};
m.prototype._getOrCreateViewSwitch=function(){if(!this._oViewSwitch){this._oViewSwitch=new S(this.getId()+"-ViewSwitch");this._oViewSwitch.attachEvent("selectionChange",this._handleViewSwitchChange,this);this.addDependent(this._oViewSwitch);}return this._oViewSwitch;};
m.prototype._convertViewSwitchToSelect=function(){this._oViewSwitch._bForcedSelectMode=true;this._oViewSwitch._toSelectMode();};
m.prototype._convertViewSwitchToSegmentedButton=function(){this._oViewSwitch._bForcedSelectMode=false;this._oViewSwitch._toNormalMode();};
m.prototype._getTodayButton=function(){return this._oTodayBtn;};
m.prototype._handlePickerDateSelect=function(){var s=this.getAssociation("currentPicker"),p=E.registry.get(s),o=p.getSelectedDates()[0].getStartDate();this.setStartDate(o);this._closeCalendarPickerPopup();this.fireDateSelect();};
m.prototype._handleViewSwitchChange=function(o){this.fireViewChange(o.getParameters());};
m.prototype._openCalendarPickerPopup=function(p){var i;if(!this._oPopup){this._oPopup=this._createPopup();}this._oPopup.setContent(p);i=P.Dock;this._oPopup.open(0,i.CenterTop,i.CenterTop,this._oPickerBtn,null,"flipfit",true);};
m.prototype._createPopup=function(){var p=new P();p.setAutoClose(true);p.setDurations(0,0);p.onsapescape=function(o){this.onsapescape(o);}.bind(this);p.attachEvent("opened",this._handlePopupOpenedEvent,this);p.attachEvent("closed",this._handlePopupClosedEvent,this);return p;};
m.prototype.onsapescape=function(){if(this._oPopup){this._closeCalendarPickerPopup();if(this._oPickerBtn.getDomRef()){this._oPickerBtn.getDomRef().focus();}}};
m.prototype._closeCalendarPickerPopup=function(){if(this._oPopup&&this._oPopup.isOpen()){this._oPopup.close();}};
m.prototype._handlePickerCancelEvent=function(){var p=this._oPickerBtn.getDomRef();this.fireCancel();this._closeCalendarPickerPopup();p&&p.focus();};
m.prototype._handlePopupOpenedEvent=function(){E.registry.get(this.getAssociation("currentPicker")).focus();};
m.prototype._handlePopupClosedEvent=function(){this.getAggregation("_calendarPicker")._closedPickers();};
m.prototype._getActionsToolbar=function(){return this.getAggregation("_actionsToolbar");};
m.prototype._getNavigationToolbar=function(){return this.getAggregation("_navigationToolbar");};
return m;});
},
	"sap/m/PlanningCalendarLegend.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/unified/CalendarLegend','sap/ui/unified/CalendarAppointment','./PlanningCalendarLegendRenderer'],function(C,a,P){"use strict";
var b=C.extend("sap.m.PlanningCalendarLegend",{metadata:{library:"sap.m",properties:{itemsHeader:{type:"string",group:"Appearance",defaultValue:"Calendar"},appointmentItemsHeader:{type:"string",group:"Appearance",defaultValue:"Appointments"}},aggregations:{appointmentItems:{type:"sap.ui.unified.CalendarLegendItem",multiple:true,singularName:"appointmentItem"}},designtime:"sap/m/designtime/PlanningCalendarLegend.designtime"}});
b._COLUMN_WIDTH_DEFAULT="auto";
b.prototype.init=function(){C.prototype.init.call(this);this.setProperty("columnWidth",b._COLUMN_WIDTH_DEFAULT);this.addStyleClass("sapMPlanCalLegend");};
b.prototype.setColumnWidth=function(w){if(w==undefined){w=b._COLUMN_WIDTH_DEFAULT;}return this.setProperty("columnWidth",w);};
b.findLegendItemForItem=function(l,s){var L=l?l.getAppointmentItems():null,c=l?l.getItems():null,A=s instanceof a,I=A?L:c,o=A?s.getType():s.type,d,e,i;if(I&&I.length){for(i=0;i<I.length;i++){d=I[i];if(d.getType()===o){e=d.getText();break;}}}if(!e){e=o;}return e;};
return b;});
},
	"sap/m/PlanningCalendarLegendRenderer.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/unified/CalendarLegendRenderer','sap/ui/core/Renderer'],function(C,R){"use strict";var P=R.extend(C);P.apiVersion=2;
P.renderItemsHeader=function(r,l){var i=l.getItemsHeader();if(i&&(l.getItems().length||l.getStandardItems().length)){this._renderItemsHeader(r,i);}};
P.renderAppointmentsItemsHeader=function(r,l){var a=l.getAppointmentItemsHeader();if(a&&l.getAppointmentItems().length){this._renderItemsHeader(r,a);}else if(l.getAppointmentItems().length&&(l.getItems().length||l.getStandardItems().length)){r.voidStart("hr");r.voidEnd();}};
P._renderItemsHeader=function(r,h){r.openStart("div");r.class("sapMPlanCalLegendHeader");r.openEnd();r.text(h);r.close("div");r.voidStart("hr");r.voidEnd();};
P.renderAdditionalContent=function(r,l){var a=l.getAppointmentItems(),i,c;this.renderAppointmentsItemsHeader(r,l);r.openStart("div");r.class("sapUiUnifiedLegendItems");c=l.getColumnWidth();r.style("column-width",c);r.style("-moz-column-width",c);r.style("-webkit-column-width",c);r.openEnd();for(i=0;i<a.length;i++){this.renderLegendItem(r,"sapUiCalLegDayType"+l._getItemType(a[i],a).slice(4),a[i],["sapUiUnifiedLegendSquareColor","sapMPlanCalLegendAppCircle"]);}r.close("div");};
return P;},true);
},
	"sap/m/PlanningCalendarView.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/core/Element','./library','sap/ui/unified/library'],function(E,l,u){"use strict";var C=u.CalendarIntervalType;var a=u.CalendarAppointmentHeight;
var P=E.extend("sap.m.PlanningCalendarView",{metadata:{library:"sap.m",properties:{key:{type:"string",group:"Data",defaultValue:null},intervalType:{type:"sap.ui.unified.CalendarIntervalType",group:"Appearance",defaultValue:C.Hour},description:{type:"string",group:"Data"},intervalsS:{type:"int",group:"Appearance",defaultValue:6},intervalsM:{type:"int",group:"Appearance",defaultValue:8},intervalsL:{type:"int",group:"Appearance",defaultValue:12},showSubIntervals:{type:"boolean",group:"Appearance",defaultValue:false},appointmentHeight:{type:"sap.ui.unified.CalendarAppointmentHeight",group:"Appearance",defaultValue:a.Regular}}}});
return P;});
},
	"sap/m/SelectionDetailsFacade.js":function(){
},
	"sap/m/SinglePlanningCalendar.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['./library','./PlanningCalendarHeader','./SegmentedButtonItem',"./SinglePlanningCalendarWeekView",'./SinglePlanningCalendarGrid','./SinglePlanningCalendarMonthGrid','./SinglePlanningCalendarRenderer','sap/base/Log','sap/ui/core/Control','sap/ui/core/InvisibleText','sap/ui/core/ResizeHandler','sap/ui/core/format/DateFormat','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/DateRange','sap/ui/unified/DateTypeRange','sap/ui/unified/library','sap/ui/base/ManagedObjectObserver',"sap/ui/thirdparty/jquery"],function(l,P,S,a,b,c,d,L,C,I,R,D,e,f,g,u,M,q){"use strict";var h=l.PlanningCalendarStickyMode;var H="_sHeaderResizeHandlerId";var j=4;var k="--item";
var m=C.extend("sap.m.SinglePlanningCalendar",{metadata:{library:"sap.m",properties:{title:{type:"string",group:"Appearance",defaultValue:""},startDate:{type:"object",group:"Data"},startHour:{type:"int",group:"Data",defaultValue:0},endHour:{type:"int",group:"Data",defaultValue:24},fullDay:{type:"boolean",group:"Data",defaultValue:true},stickyMode:{type:"sap.m.PlanningCalendarStickyMode",group:"Behavior",defaultValue:h.None},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{actions:{type:"sap.ui.core.Control",multiple:true,singularName:"action",forwarding:{getter:"_getHeader",aggregation:"actions"}},appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",forwarding:{getter:"_getCurrentGrid",aggregation:"appointments"}},views:{type:"sap.m.SinglePlanningCalendarView",multiple:true,singularName:"view"},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate",forwarding:{getter:"_getCurrentGrid",aggregation:"specialDates"}},_header:{type:"sap.m.PlanningCalendarHeader",multiple:false,visibility:"hidden"},_grid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_mvgrid:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},associations:{selectedView:{type:"sap.m.SinglePlanningCalendarView",multiple:false},legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},headerDateSelect:{parameters:{date:{type:"object"}}},startDateChange:{parameters:{date:{type:"object"}}},cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},moreLinkPress:{parameters:{date:{type:"object"}}},viewChange:{}}}});
m.prototype.init=function(){var o=this.getId();this._oRB=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oDefaultView=new a({key:"DEFAULT_INNER_WEEK_VIEW_CREATED_FROM_CONTROL",title:""});this.setAssociation("selectedView",this._oDefaultView);this.setAggregation("_header",this._createHeader());this.setAggregation("_grid",new b(o+"-Grid"));this.setAggregation("_mvgrid",new c(o+"-GridMV"));this._attachHeaderEvents();this._attachGridEvents();this._attachDelegates();this.setStartDate(new Date());};
m.prototype.onBeforeRendering=function(){this._toggleStickyClasses();};
m.prototype.onAfterRendering=function(){var o=this._getHeader();this._adjustColumnHeadersTopOffset();this.toggleStyleClass("sapMSinglePCActionsHidden",!o._getActionsToolbar().getVisible());this._registerResizeHandler(H,o,this._onHeaderResize.bind(this));};
m.prototype.exit=function(){if(this._oDefaultView){this._oDefaultView.destroy();this._oDefaultView=null;}if(this._afterRenderFocusCell){this.removeDelegate(this._afterRenderFocusCell);this._afterRenderFocusCell=null;}this._deRegisterResizeHandler(H);};
m.prototype._onHeaderResize=function(E){if(E.oldSize.height===E.size.height){return this;}this.toggleStyleClass("sapMSinglePCActionsHidden",!this._getHeader()._getActionsToolbar().getVisible());this._adjustColumnHeadersTopOffset();return this;};
m.prototype.setTitle=function(t){this._getHeader().setTitle(t);return this.setProperty("title",t);};
m.prototype.setStartDate=function(o){this.setProperty("startDate",o);this._alignColumns();return this;};
m.prototype.setStartHour=function(i){this.getAggregation("_grid").setStartHour(i);this.setProperty("startHour",i);return this;};
m.prototype.setEndHour=function(i){this.getAggregation("_grid").setEndHour(i);this.setProperty("endHour",i);return this;};
m.prototype.setFullDay=function(F){this.getAggregation("_grid").setFullDay(F);this.setProperty("fullDay",F);return this;};
m.prototype.setEnableAppointmentsDragAndDrop=function(E){this.getAggregation("_grid").setEnableAppointmentsDragAndDrop(E);this.getAggregation("_mvgrid").setEnableAppointmentsDragAndDrop(E);return this.setProperty("enableAppointmentsDragAndDrop",E,true);};
m.prototype.setEnableAppointmentsResize=function(E){this.getAggregation("_grid").setEnableAppointmentsResize(E);return this.setProperty("enableAppointmentsResize",E,true);};
m.prototype.setEnableAppointmentsCreate=function(E){this.getAggregation("_grid").setEnableAppointmentsCreate(E);return this.setProperty("enableAppointmentsCreate",E,true);};
m.prototype._toggleStickyClasses=function(){var s=this.getStickyMode();this.toggleStyleClass("sapMSinglePCStickyAll",s===h.All);this.toggleStyleClass("sapMSinglePCStickyNavBarAndColHeaders",s===h.NavBarAndColHeaders);return this;};
m.prototype._adjustColumnHeadersTopOffset=function(){var s=this.getStickyMode(),G=this.getAggregation("_grid"),o=G&&G._getColumnHeaders(),t;if(!o||!o.getDomRef()){return this;}switch(s){case h.All:t=this._getHeader().$().outerHeight();break;case h.NavBarAndColHeaders:t=this._getHeader()._getNavigationToolbar().$().outerHeight();break;default:t="auto";break;}o.$().css("top",t);o._setTopPosition(t);return this;};
m.prototype.addView=function(v){var V,o=this._getHeader(),s=v.getId()+k,i;if(!v){return this;}if(this._isViewKeyExisting(v.getKey())){L.error("There is an existing view with the same key.",this);return this;}this.addAggregation("views",v);V=o._getOrCreateViewSwitch();i=new S(s,{key:v.getKey(),text:v.getTitle()});V.addItem(i);this._observeViewTitle(v);if(this._getSelectedView().getKey()===this._oDefaultView.getKey()){this.setAssociation("selectedView",v);}this._alignView();if(this.getViews().length>j){o._convertViewSwitchToSelect();}return this;};
m.prototype.insertView=function(v,p){var V,o=this._getHeader(),s=v.getId()+k,i;if(!v){return this;}if(this._isViewKeyExisting(v.getKey())){L.error("There is an existing view with the same key.",this);return this;}this.insertAggregation("views",v,p);V=o._getOrCreateViewSwitch();i=new S(s,{key:v.getKey(),text:v.getTitle()});V.insertItem(i,p);this._observeViewTitle(v);if(this._getSelectedView().getKey()===this._oDefaultView.getKey()){this.setAssociation("selectedView",v);}this._alignView();if(this.getViews().length>j){o._convertViewSwitchToSelect();}return this;};
m.prototype.removeView=function(v){if(!v){return this;}var o=this._getHeader(),V=o._getOrCreateViewSwitch(),n=V.getItems(),p=this._getSelectedView(),r=v.getKey(),s,i;if(this.getViews().length===1){this._disconnectAndDestroyViewsObserver();}else{this._oViewsObserver.unobserve(v,{properties:["title"]});}for(i=0;i<n.length;i++){s=n[i];if(s.getKey()===r){V.removeItem(s);break;}}this.removeAggregation("views",v);if(r===p.getKey()){this.setAssociation("selectedView",this.getViews()[0]||this._oDefaultView);}this._alignView();if(this.getViews().length<=j){o._convertViewSwitchToSegmentedButton();}return this;};
m.prototype.removeAllViews=function(){var v=this._getHeader()._getOrCreateViewSwitch();this._disconnectAndDestroyViewsObserver();v.removeAllItems();this.setAssociation("selectedView",this._oDefaultView);this._alignView();return this.removeAllAggregation("views");};
m.prototype.destroyViews=function(){var v=this._getHeader()._getOrCreateViewSwitch();this._disconnectAndDestroyViewsObserver();v.destroyItems();this.setAssociation("selectedView",this._oDefaultView);this._alignView();return this.destroyAggregation("views");};
m.prototype._viewsObserverCallbackFunction=function(o){sap.ui.getCore().byId(o.object.getId()+k).setText(o.current);};
m.prototype._getViewsObserver=function(){if(!this._oViewsObserver){this._oViewsObserver=new M(this._viewsObserverCallbackFunction);}return this._oViewsObserver;};
m.prototype._observeViewTitle=function(v){this._getViewsObserver().observe(v,{properties:["title"]});};
m.prototype._disconnectAndDestroyViewsObserver=function(){if(this._oViewsObserver){this._oViewsObserver.disconnect();this._oViewsObserver.destroy();this._oViewsObserver=null;}};
m.prototype.setSelectedView=function(v){if(typeof v==="string"){v=this._getViewById(v);}else if(v.isA("sap.m.SinglePlanningCalendarView")&&!this._isViewKeyExisting(v.getKey())){v=null;}if(!v){L.error("There is no such view.",this);return this;}this._setupNewView(v);this._getHeader()._getOrCreateViewSwitch().setSelectedKey(v.getKey());return this;};
m.prototype.getSelectedAppointments=function(){return this.getAggregation("_grid").getSelectedAppointments();};
m.prototype.setLegend=function(v){var o,s,i;this.setAssociation("legend",v);this.getAggregation("_grid").setAssociation("legend",v);this.getAggregation("_mvgrid").setAssociation("legend",v);s=this.getLegend();if(s){this.getAggregation("_grid")._sLegendId=s;this.getAggregation("_mvgrid")._sLegendId=s;i=sap.ui.getCore().byId(s);}if(i){o=new M(function(n){this.invalidate();}.bind(this));o.observe(i,{destroy:true});}return this;};
m.prototype._alignView=function(){this._switchViewButtonVisibility();this._alignColumns();return this;};
m.prototype._createHeader=function(){var o=new P(this.getId()+"-Header");o.getAggregation("_actionsToolbar").addAriaLabelledBy(I.getStaticId("sap.m","SPC_ACTIONS_TOOLBAR"));o.getAggregation("_navigationToolbar").addAriaLabelledBy(I.getStaticId("sap.m","SPC_NAVIGATION_TOOLBAR"));return o;};
m.prototype._isViewKeyExisting=function(K){return this.getViews().some(function(v){return v.getKey()===K;});};
m.prototype.getViewByKey=function(K){var v=this.getViews(),i;for(i=0;i<v.length;i++){if(v[i].getKey()===K){return v[i];}}return null;};
m.prototype._getViewById=function(s){var v=this.getViews(),i;for(i=0;i<v.length;i++){if(v[i].getId()===s){return v[i];}}return null;};
m.prototype._getSelectedView=function(){var s,v=this.getViews(),n=sap.ui.getCore().byId(this.getAssociation("selectedView")).getKey();for(var i=0;i<v.length;i++){if(n===v[i].getKey()){s=v[i];break;}}return s||this._oDefaultView;};
m.prototype._switchViewButtonVisibility=function(){var s=this._getHeader()._getOrCreateViewSwitch(),v=s.getItems().length>1;s.setProperty("visible",v);return this;};
m.prototype._attachHeaderEvents=function(){var o=this._getHeader();o.attachEvent("viewChange",this._handleViewChange,this);o.attachEvent("pressPrevious",this._handlePressArrow,this);o.attachEvent("pressToday",this._handlePressToday,this);o.attachEvent("pressNext",this._handlePressArrow,this);o.attachEvent("dateSelect",this._handleCalendarPickerDateSelect,this);return this;};
m.prototype._attachDelegates=function(){this._afterRenderFocusCell={onAfterRendering:function(){if(this._sGridCellFocusSelector){q(this._sGridCellFocusSelector).trigger("focus");this._sGridCellFocusSelector=null;}}.bind(this)};this.getAggregation("_grid").addDelegate(this._afterRenderFocusCell);this.getAggregation("_mvgrid").addDelegate(this._afterRenderFocusCell);};
m.prototype._attachGridEvents=function(){var G=this.getAggregation("_grid"),o=this.getAggregation("_mvgrid");var i=function(E){this.fireHeaderDateSelect({date:E.getSource().getDate()});};var n=function(E){this.fireAppointmentSelect({appointment:E.getParameter("appointment"),appointments:E.getParameter("appointments")});};var p=function(E){this.fireAppointmentDrop({appointment:E.getParameter("appointment"),startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate"),copy:E.getParameter("copy")});};var r=function(E){this.fireAppointmentResize({appointment:E.getParameter("appointment"),startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var s=function(E){this.fireAppointmentCreate({startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var t=function(E){this.fireEvent("cellPress",{startDate:E.getParameter("startDate"),endDate:E.getParameter("endDate")});};var v=function(E){this.fireEvent("moreLinkPress",{date:E.getParameter("date")});};var w=function(E){var G=this.getAggregation("_grid"),F=G._getDateFormatter(),N=this._getSelectedView().getScrollEntityCount()-G._getColumns()+1,y=new Date(E.getParameter("startDate")),z=E.getParameter("fullDay"),A=this.getStartDate();if(E.getParameter("next")){y.setDate(y.getDate()+N);A=new Date(A.setDate(A.getDate()+this._getSelectedView().getScrollEntityCount()));this.setStartDate(A);}else{y.setDate(y.getDate()-N);A=new Date(A.setDate(A.getDate()-this._getSelectedView().getScrollEntityCount()));this.setStartDate(A);}this._sGridCellFocusSelector=z?"[data-sap-start-date='"+F.format(y)+"'].sapMSinglePCBlockersColumn":"[data-sap-start-date='"+F.format(y)+"'].sapMSinglePCRow";};var x=function(E){var y=new Date(E.getParameter("startDate")),z=e.fromLocalJSDate(y),N;z.setDate(z.getDate()+E.getParameter("offset"));N=z.toLocalJSDate();this.setStartDate(N);this._sGridCellFocusSelector="[sap-ui-date='"+z.valueOf()+"'].sapMSPCMonthDay";};G._getColumnHeaders().attachEvent("select",i,this);G.attachEvent("appointmentSelect",n,this);o.attachEvent("appointmentSelect",n,this);G.attachEvent("appointmentDrop",p,this);o.attachEvent("appointmentDrop",p,this);G.attachEvent("appointmentResize",r,this);G.attachEvent("appointmentCreate",s,this);G.attachEvent("cellPress",t,this);o.attachEvent("cellPress",t,this);o.attachEvent("moreLinkPress",v,this);G.attachEvent("borderReached",w,this);o.attachEvent("borderReached",x,this);return this;};
m.prototype._handleViewChange=function(E){var n=E.getParameter("item").getProperty("key"),N=this.getViewByKey(n);this._setupNewView(N);this.fireViewChange();};
m.prototype._handlePressArrow=function(E){this._applyArrowsLogic(E.getId()==="pressPrevious");this._adjustColumnHeadersTopOffset();};
m.prototype._handlePressToday=function(){var s=this._getSelectedView().calculateStartDate(new Date());this.setStartDate(s);this.fireStartDateChange({date:s});this._adjustColumnHeadersTopOffset();};
m.prototype._setupNewView=function(v){var p=this._getCurrentGrid();this.setAssociation("selectedView",v);this._transferAggregations(p);this._alignColumns();this._adjustColumnHeadersTopOffset();};
m.prototype._transferAggregations=function(p){var n=this._getCurrentGrid(),A,s,i;if(p.getId()!==n.getId()){A=p.removeAllAggregation("appointments",true);for(i=0;i<A.length;i++){n.addAggregation("appointments",A[i],true);}s=p.removeAllAggregation("specialDates",true);for(i=0;i<s.length;i++){n.addAggregation("specialDates",s[i],true);}}};
m.prototype._handleCalendarPickerDateSelect=function(){var s=this._getHeader().getStartDate(),o;o=this._getSelectedView().calculateStartDate(new Date(s.getTime()));this.setStartDate(o);if(!this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){this.getAggregation("_grid")._getColumnHeaders().setDate(s);}this.fireStartDateChange({date:o});this._adjustColumnHeadersTopOffset();};
m.prototype._updateCalendarPickerSelection=function(){var r=this._getFirstAndLastRangeDate(),s;s=new f({startDate:r.oStartDate.toLocalJSDate(),endDate:r.oEndDate.toLocalJSDate()});this._getHeader().getAggregation("_calendarPicker").removeAllSelectedDates();this._getHeader().getAggregation("_calendarPicker").addSelectedDate(s);};
m.prototype._formatPickerText=function(){var r=this._getFirstAndLastRangeDate(),s=r.oStartDate.toLocalJSDate(),E=r.oEndDate.toLocalJSDate(),o=D.getDateInstance({format:"yMMMMd"}),i=o.format(s);if(s.getTime()!==E.getTime()){i+=" - "+o.format(E);}return i;};
m.prototype._applyArrowsLogic=function(B){var o=e.fromLocalJSDate(this.getStartDate()||new Date()),O=B?-1:1,n=this._getSelectedView().getScrollEntityCount(this.getStartDate(),O),s;if(B){n*=-1;}o.setDate(o.getDate()+n);s=o.toLocalJSDate();this.setStartDate(s);this.fireStartDateChange({date:s});};
m.prototype._getFirstAndLastRangeDate=function(){var s=this._getSelectedView(),o=this._getHeader().getStartDate()||new Date(),i=s.getEntityCount()-1,n,p;n=e.fromLocalJSDate(s.calculateStartDate(new Date(o.getTime())));p=new e(n);p.setDate(n.getDate()+i);return{oStartDate:n,oEndDate:p};};
m.prototype._alignColumns=function(){var o=this._getHeader(),G=this.getAggregation("_grid"),i=this.getAggregation("_mvgrid"),v=this._getSelectedView(),n=this.getStartDate()||new Date(),V=v.calculateStartDate(new Date(n.getTime())),p=e.fromLocalJSDate(V);o.setStartDate(V);o.setPickerText(this._formatPickerText(p));this._updateCalendarPickerSelection();G.setStartDate(V);i.setStartDate(V);G._setColumns(v.getEntityCount());this._setColumnHeaderVisibility();};
m.prototype._setColumnHeaderVisibility=function(){var v;if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){return;}v=!this._getSelectedView().isA("sap.m.SinglePlanningCalendarDayView");this.getAggregation("_grid")._getColumnHeaders().setVisible(v);this.toggleStyleClass("sapMSinglePCHiddenColHeaders",!v);};
m.prototype._getHeader=function(){return this.getAggregation("_header");};
m.prototype._getCurrentGrid=function(){if(this._getSelectedView().isA("sap.m.SinglePlanningCalendarMonthView")){return this.getAggregation("_mvgrid");}else{return this.getAggregation("_grid");}};
m.prototype._registerResizeHandler=function(s,o,i){if(!this[s]){this[s]=R.register(o,i);}return this;};
m.prototype._deRegisterResizeHandler=function(s){if(this[s]){R.deregister(this[s]);this[s]=null;}return this;};
m.prototype._getSpecialDates=function(){var s=this.getSpecialDates();for(var i=0;i<s.length;i++){var n=s[i].getSecondaryType()===u.CalendarDayType.NonWorking&&s[i].getType()!==u.CalendarDayType.NonWorking;if(n){var o=new g();o.setType(u.CalendarDayType.NonWorking);o.setStartDate(s[i].getStartDate());if(s[i].getEndDate()){o.setEndDate(s[i].getEndDate());}s.push(o);}}return s;};
return m;});
},
	"sap/m/SinglePlanningCalendarGrid.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['./SinglePlanningCalendarUtilities','sap/ui/core/Control','sap/ui/core/LocaleData','sap/ui/core/Locale','sap/ui/core/InvisibleText','sap/ui/core/format/DateFormat','sap/ui/core/date/UniversalDate','sap/ui/core/dnd/DragInfo','sap/ui/core/dnd/DropInfo','sap/ui/core/dnd/DragDropInfo','sap/ui/unified/library','sap/ui/unified/CalendarAppointment','sap/ui/unified/calendar/DatesRow','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/DateTypeRange','sap/ui/events/KeyCodes','./SinglePlanningCalendarGridRenderer','sap/ui/Device','sap/ui/core/delegate/ItemNavigation',"sap/ui/thirdparty/jquery",'./PlanningCalendarLegend'],function(S,C,L,a,I,D,U,b,c,d,u,e,f,g,h,k,K,l,m,n,q,P){"use strict";var R=69,o=48,B=34,p=25,H=3600000/2,O=60*1000,M=86400000,r=7,F=0,s=24;
var t=C.extend("sap.m.SinglePlanningCalendarGrid",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},startHour:{type:"int",group:"Data",defaultValue:0},endHour:{type:"int",group:"Data",defaultValue:24},fullDay:{type:"boolean",group:"Data",defaultValue:true},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsResize:{type:"boolean",group:"Misc",defaultValue:false},enableAppointmentsCreate:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},_columnHeaders:{type:"sap.ui.unified.calendar.DatesRow",multiple:false,visibility:"hidden"},_intervalPlaceholders:{type:"sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}},_blockersPlaceholders:{type:"sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true,associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"},legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentResize:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"}}},appointmentCreate:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}}}}});
t.prototype.init=function(){var i=new Date(),j=new f(this.getId()+"-columnHeaders",{showDayNamesLine:false,showWeekNumbers:false,startDate:i}).addStyleClass("sapMSinglePCColumnHeader"),x=(60-i.getSeconds())*1000,T=this._getCoreLocaleData().getTimePattern("medium");j._setAriaRole("columnheader");this.setAggregation("_columnHeaders",j);this.setStartDate(i);this._setColumns(7);this._configureBlockersDragAndDrop();this._configureAppointmentsDragAndDrop();this._configureAppointmentsResize();this._configureAppointmentsCreate();this._oUnifiedRB=sap.ui.getCore().getLibraryResourceBundle("sap.ui.unified");this._oFormatStartEndInfoAria=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY 'at' "+T});this._oFormatAriaFullDayCell=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY"});this._sLegendId=undefined;setTimeout(this._updateRowHeaderAndNowMarker.bind(this),x);};
t.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}};
t.prototype.onBeforeRendering=function(){var A=this._createAppointmentsMap(this.getAppointments()),i=this.getStartDate(),j=g.fromLocalJSDate(i),x=this._getColumns();this._oVisibleAppointments=this._calculateVisibleAppointments(A.appointments,this.getStartDate(),x);this._oAppointmentsToRender=this._calculateAppointmentsLevelsAndWidth(this._oVisibleAppointments);this._aVisibleBlockers=this._calculateVisibleBlockers(A.blockers,j,x);this._oBlockersToRender=this._calculateBlockersLevelsAndWidth(this._aVisibleBlockers);if(this._iOldColumns!==x||this._oOldStartDate!==i){this._createBlockersDndPlaceholders(i,x);this._createAppointmentsDndPlaceholders(i,x);}};
t.prototype.onmousedown=function(E){var i=E.target.classList;this._isResizeHandleBottomMouseDownTarget=i.contains("sapMSinglePCAppResizeHandleBottom");this._isResizeHandleTopMouseDownTarget=i.contains("sapMSinglePCAppResizeHandleTop");};
t.prototype._isResizingPerformed=function(){return this._isResizeHandleBottomMouseDownTarget||this._isResizeHandleTopMouseDownTarget;};
t.prototype._configureBlockersDragAndDrop=function(){this.addDragDropConfig(new d({sourceAggregation:"appointments",targetAggregation:"_blockersPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()){E.preventDefault();return false;}var i=function(){var $=q(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");});};i();}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),x=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),y=function(){var $=q(i.getIndicator()),z=A.$().outerHeight(),G=A.$().outerWidth(),J=j.$().closest(".sapMSinglePCBlockersColumns").get(0).getBoundingClientRect(),N=j.getDomRef().getBoundingClientRect(),Q=(N.left+G)-(J.left+J.width);if(x){$.css("min-height",z);$.css("min-width",Math.min(G,G-Q));}else{$.css("min-height",i.getDropControl().$().outerHeight());$.css("min-width",i.getDropControl().$().outerWidth());}};if(!i.getIndicator()){setTimeout(y,0);}else{y();}}.bind(this),drop:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),x=j.getDate().getJSDate(),y,z=E.getParameter("browserEvent"),G=(z.metaKey||z.ctrlKey),J=this.isAllDayAppointment(A.getStartDate(),A.getEndDate());y=new Date(x);if(J){y.setMilliseconds(A.getEndDate().getTime()-A.getStartDate().getTime());}this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(J&&A.getStartDate().getTime()===x.getTime()){return;}this.fireAppointmentDrop({appointment:A,startDate:x,endDate:y,copy:G});}.bind(this)}));};
t.prototype._configureAppointmentsDragAndDrop=function(){this.addDragDropConfig(new d({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()||this._isResizingPerformed()){E.preventDefault();return false;}var i=function(){var $=q(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");});};i();}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),x=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),y=function(){var $=q(i.getIndicator()),z=A.$().outerHeight(),G=j.$().closest(".sapMSinglePCColumn").get(0).getBoundingClientRect(),J=i.getDropControl().getDomRef().getBoundingClientRect(),N=(J.top+z)-(G.top+G.height);if(x){$.css("min-height",2*i.getDropControl().$().outerHeight());}else{$.css("min-height",Math.min(z,z-N));}};if(!i.getIndicator()){setTimeout(y,0);}else{y();}}.bind(this),drop:function(E){var i=E.getParameter("dragSession"),A=i.getDragControl(),j=i.getDropControl(),x=j.getDate().getJSDate(),y,z=E.getParameter("browserEvent"),G=(z.metaKey||z.ctrlKey),J=this.isAllDayAppointment(A.getStartDate(),A.getEndDate());y=new Date(x);if(J){y.setHours(y.getHours()+1);}else{y.setMilliseconds(A.getEndDate().getTime()-A.getStartDate().getTime());}this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(!J&&A.getStartDate().getTime()===x.getTime()){return;}this.fireAppointmentDrop({appointment:A,startDate:x,endDate:y,copy:G});}.bind(this)}));};
t.prototype._configureAppointmentsResize=function(){var i=new d({sourceAggregation:"appointments",targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsResize()||!this._isResizingPerformed()){E.preventDefault();return;}var j=E.getParameter("dragSession"),$=this.$().find(".sapMSinglePCOverlay"),x=q(j.getIndicator()),y=j.getDragControl().$();if(this._isResizeHandleBottomMouseDownTarget){j.setComplexData("bottomHandle","true");}if(this._isResizeHandleTopMouseDownTarget){j.setComplexData("topHandle","true");}x.addClass("sapUiDnDIndicatorHide");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");},0);q(document).one("dragend",function(){var A=j.getComplexData("appointmentStartingBoundaries");$.removeClass("sapMSinglePCOverlayDragging");x.removeClass("sapUiDnDIndicatorHide");y.css({top:A.top,height:A.height,"z-index":"auto",opacity:1});});if(!m.browser.msie&&!m.browser.edge){E.getParameter("browserEvent").dataTransfer.setDragImage(v(),0,0);}}.bind(this),dragEnter:function(E){var j=E.getParameter("dragSession"),A=j.getDragControl().$().get(0),x=j.getDropControl().getDomRef(),y=j.getComplexData("appointmentStartingBoundaries"),z=function(){var $=q(j.getIndicator());$.addClass("sapUiDnDIndicatorHide");},T,G,J,V,N;if(!y){y={top:A.offsetTop,bottom:A.offsetTop+A.getBoundingClientRect().height,height:A.getBoundingClientRect().height};j.setComplexData("appointmentStartingBoundaries",y);}V=j.getData("bottomHandle")?y.top:y.bottom;T=Math.min(V,x.offsetTop);G=Math.max(V,x.offsetTop+x.getBoundingClientRect().height);J=G-T;N={top:T,height:J,"z-index":1,opacity:0.8};j.getDragControl().$().css(N);if(!j.getIndicator()){setTimeout(z,0);}else{z();}},drop:function(E){var j=E.getParameter("dragSession"),A=j.getDragControl(),x=this.indexOfAggregation("_intervalPlaceholders",j.getDropControl()),y=j.getComplexData("appointmentStartingBoundaries"),z;z=this._calcResizeNewHoursAppPos(A.getStartDate(),A.getEndDate(),x,j.getComplexData("bottomHandle"));this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");q(j.getIndicator()).removeClass("sapUiDnDIndicatorHide");A.$().css({top:y.top,height:y.height,"z-index":"auto",opacity:1});if(A.getEndDate().getTime()===z.endDate.getTime()&&A.getStartDate().getTime()===z.startDate.getTime()){return;}this.fireAppointmentResize({appointment:A,startDate:z.startDate,endDate:z.endDate});}.bind(this)});this.addDragDropConfig(i);};
t.prototype._configureAppointmentsCreate=function(){this.addDragDropConfig(new d({targetAggregation:"_intervalPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsCreate()){E.preventDefault();return;}var $=this.$().find(".sapMSinglePCOverlay");setTimeout(function(){$.addClass("sapMSinglePCOverlayDragging");});q(document).one("dragend",function(){$.removeClass("sapMSinglePCOverlayDragging");q(".sapUiAppCreate").remove();q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");});if(!m.browser.msie&&!m.browser.edge){E.getParameter("browserEvent").dataTransfer.setDragImage(v(),0,0);}var G=E.getParameter("target"),i=G.getAggregation("_intervalPlaceholders"),j=i[0].getDomRef().getBoundingClientRect(),x=j.height,y=Math.floor((j.top-G.getDomRef().getBoundingClientRect().top)/x),z=Math.floor(E.getParameter("browserEvent").offsetY/x)-y,A=E.getParameter("dragSession");if(z<0){z=0;}A.setComplexData("startingRectsDropArea",{top:Math.ceil(z*x),left:j.left});A.setComplexData("startingDropDate",i[z].getDate());}.bind(this),dragEnter:function(E){var i=E.getParameter("dragSession"),j=i.getDropControl(),x=j.getDomRef(),y=x.offsetHeight,z=x.offsetTop,A=z,G=x.getBoundingClientRect().left,J=G,N=j.$().parents(".sapMSinglePCColumn").get(0),$=q(".sapUiAppCreate");if(!$.get(0)){$=q("<div></div>").addClass("sapUiCalendarApp sapUiCalendarAppType01 sapUiAppCreate");$.appendTo(N);}q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");if(!i.getComplexData("startingRectsDropArea")){i.setComplexData("startingRectsDropArea",{top:z,left:G});i.setComplexData("startingDropDate",j.getDate());}else{A=i.getComplexData("startingRectsDropArea").top;J=i.getComplexData("startingRectsDropArea").left;}if(G!==J){E.preventDefault();return false;}j.$().closest(".sapMSinglePCColumn").find(".sapMSinglePCAppointments").addClass("sapUiDnDDragging");$.css({top:Math.min(A,z)+2,height:Math.abs(A-z)+y-4,left:3,right:3,"z-index":2});i.setIndicatorConfig({display:"none"});},drop:function(E){var i=E.getParameter("dragSession"),j=i.getDropControl(),T=30*60*1000,x=i.getComplexData("startingDropDate").getTime(),y=j.getDate().getJSDate().getTime(),z=Math.min(x,y),A=Math.max(x,y)+T;this.fireAppointmentCreate({startDate:new Date(z),endDate:new Date(A)});q(".sapUiAppCreate").remove();q(".sapUiDnDDragging").removeClass("sapUiDnDDragging");}.bind(this)}));};
t.prototype._calcResizeNewHoursAppPos=function(A,i,j,x){var y=30*60*1000,z=this.getAggregation("_intervalPlaceholders")[j].getDate().getTime(),E=z+y,V=x?A.getTime():i.getTime(),G=Math.min(V,z),J=Math.max(V,E);return{startDate:new Date(G),endDate:new Date(J)};};
t.prototype._adjustAppointmentsHeightforCompact=function(i,j,x){var A,$,y,z,E,G,J,N,Q=this._getRowHeight(),T=this;if(this._oAppointmentsToRender[i]){this._oAppointmentsToRender[i].oAppointmentsList.getIterator().forEach(function(V){A=V.getData();$=q("div[data-sap-day='"+i+"'].sapMSinglePCColumn #"+A.getId());y=A.getStartDate();z=A.getEndDate();J=j.getTime()>y.getTime();N=x.getTime()<z.getTime();E=J?0:T._calculateTopPosition(y);G=N?0:T._calculateBottomPosition(z);$.css("top",E);$.css("bottom",G);$.find(".sapUiCalendarApp").css("min-height",Q/2-3);});}};
t.prototype._adjustBlockersHeightforCompact=function(){var i=this._getBlockersToRender().iMaxlevel,j=(i+1)*this._getBlockerRowHeight(),x=this._getColumns()===1?j+r:j,y=this._getBlockerRowHeight();if(i>0){x=x+3;}this.$().find(".sapMSinglePCBlockersColumns").css("height",x);this._oBlockersToRender.oBlockersList.getIterator().forEach(function(z){z.getData().$().css("top",y*z.level+1);});};
t.prototype._adjustBlockersHeightforCozy=function(){var i=this._getBlockersToRender()&&this._getBlockersToRender().iMaxlevel,j;if(this._getColumns()===1){j=(i+1)*this._getBlockerRowHeight();this.$().find(".sapMSinglePCBlockersColumns").css("height",j+r);}};
t.prototype.onAfterRendering=function(){var j=this._getColumns(),x=this.getStartDate(),y=this._getRowHeight();if(y===o){for(var i=0;i<j;i++){var z=new g(x.getFullYear(),x.getMonth(),x.getDate()+i),A=this._getDateFormatter().format(z.toLocalJSDate()),E=new U(z.getYear(),z.getMonth(),z.getDate(),this._getVisibleStartHour()),G=new U(z.getYear(),z.getMonth(),z.getDate(),this._getVisibleEndHour(),59,59);this._adjustAppointmentsHeightforCompact(A,E,G);}this._adjustBlockersHeightforCompact();}else{this._adjustBlockersHeightforCozy();}this._updateRowHeaderAndNowMarker();_.call(this);};
t.prototype._appFocusHandler=function(E,i){var T=sap.ui.getCore().byId(E.target.id);if(T&&T.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});this._focusCellWithKeyboard(T,i);E.preventDefault();}};
t.prototype._cellFocusHandler=function(E,i){var G=E.target,j=this._getDateFormatter(),x;if(G.classList.contains("sapMSinglePCRow")||G.classList.contains("sapMSinglePCBlockersColumn")){x=j.parse(G.getAttribute("data-sap-start-date"));if(this._isBorderReached(x,i)){this.fireEvent("borderReached",{startDate:x,next:i===K.ARROW_RIGHT,fullDay:G.classList.contains("sapMSinglePCBlockersColumn")});}}};
t.prototype.onsapup=function(E){this._appFocusHandler(E,K.ARROW_UP);};
t.prototype.onsapdown=function(E){this._appFocusHandler(E,K.ARROW_DOWN);};
t.prototype.onsapright=function(E){this._appFocusHandler(E,K.ARROW_RIGHT);this._cellFocusHandler(E,K.ARROW_RIGHT);};
t.prototype.onsapleft=function(E){this._appFocusHandler(E,K.ARROW_LEFT);this._cellFocusHandler(E,K.ARROW_LEFT);};
t.prototype.setStartDate=function(i){this._oOldStartDate=this.getStartDate();this.getAggregation("_columnHeaders").setStartDate(i);return this.setProperty("startDate",i);};
t.prototype.applyFocusInfo=function(x){var V=this._getVisibleBlockers(),y=this._getVisibleAppointments(),z=Object.keys(y),A,i,j;for(i=0;i<V.length;++i){if(V[i].getId()===x.id){V[i].focus();return this;}}for(i=0;i<z.length;++i){A=y[z[i]];for(j=0;j<A.length;++j){if(A[j].getId()===x.id){A[j].focus();return this;}}}return this;};
t.prototype.getSelectedAppointments=function(){return this.getAppointments().filter(function(A){return A.getSelected();});};
t.prototype._toggleAppointmentSelection=function(A,j){var x=[],y,z,i;if(j){y=this.getAppointments();for(i=0,z=y.length;i<z;i++){if((!A||y[i].getId()!==A.getId())&&y[i].getSelected()){y[i].setProperty("selected",false);x.push(y[i]);}}}if(A){A.setProperty("selected",!A.getSelected());x.push(A);}return x;};
t.prototype._isBorderReached=function(i,j){var G=g.fromLocalJSDate(this.getStartDate()),x=new g(G.getYear(),G.getMonth(),G.getDate()+this._getColumns()-1),T=g.fromLocalJSDate(i),y=j===K.ARROW_LEFT&&T.isSame(G),z=j===K.ARROW_RIGHT&&T.isSame(x);return y||z;};
t.prototype._focusCellWithKeyboard=function(A,i){var j=this.isAllDayAppointment(A.getStartDate(),A.getEndDate()),x=this._getDateFormatter(),y=new Date(A.getStartDate().getFullYear(),A.getStartDate().getMonth(),A.getStartDate().getDate(),A.getStartDate().getHours()),G=new Date(this.getStartDate().getFullYear(),this.getStartDate().getMonth(),this.getStartDate().getDate(),this.getStartDate().getHours());if(y<G){y=G;}if(this._isBorderReached(y,i)){this.fireEvent("borderReached",{startDate:y,next:i===K.ARROW_RIGHT,fullDay:j});return;}switch(i){case K.ARROW_UP:if(!j){y.setHours(y.getHours()-1);}break;case K.ARROW_DOWN:if(!j){y.setHours(y.getHours()+1);}break;case K.ARROW_LEFT:y.setDate(y.getDate()-1);break;case K.ARROW_RIGHT:y.setDate(y.getDate()+1);break;default:}if(j&&i!==K.ARROW_DOWN){q("[data-sap-start-date='"+x.format(y)+"'].sapMSinglePCBlockersColumn").trigger("focus");}else{q("[data-sap-start-date='"+x.format(y)+"'].sapMSinglePCRow").trigger("focus");}};
t.prototype.ontap=function(E){this._fireSelectionEvent(E);};
t.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this._fireSelectionEvent(E);E.preventDefault();}};
t.prototype._fireSelectionEvent=function(E){var A=E.srcControl,G=E.target;if(E.target.classList.contains("sapMSinglePCRow")||E.target.classList.contains("sapMSinglePCBlockersColumn")){this.fireEvent("cellPress",{startDate:this._getDateFormatter().parse(G.getAttribute("data-sap-start-date")),endDate:this._getDateFormatter().parse(G.getAttribute("data-sap-end-date"))});this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});}else if(A&&A.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:A,appointments:this._toggleAppointmentSelection(A,!(E.ctrlKey||E.metaKey))});}};
t.prototype._getVisibleStartHour=function(){return(this.getFullDay()||!this.getStartHour())?F:this.getStartHour();};
t.prototype._getVisibleEndHour=function(){return((this.getFullDay()||!this.getEndHour())?s:this.getEndHour())-1;};
t.prototype._isVisibleHour=function(i){var j=this.getStartHour(),E=this.getEndHour();if(!this.getStartHour()){j=F;}if(!this.getEndHour()){E=s;}return j<=i&&i<E;};
t.prototype._shouldHideRowHeader=function(i){var j=new Date().getHours(),x=h._areCurrentMinutesLessThan(15)&&j===i,y=h._areCurrentMinutesMoreThan(45)&&j===i-1;return x||y;};
t.prototype._parseDateStringAndHours=function(i,j){var x=this._getDateFormatter().parse(i);if(j){x.setHours(j);}return x;};
t.prototype._getDateFormatter=function(){if(!(this._oDateFormat instanceof D)){this._oDateFormat=D.getDateTimeInstance({pattern:"YYYYMMdd-HHmm"});}return this._oDateFormat;};
t.prototype._formatTimeAsString=function(i){var j=this._getHoursPattern()+":mm",x=D.getDateTimeInstance({pattern:j},new a(this._getCoreLocaleId()));return x.format(i);};
t.prototype._addAMPM=function(i){var A=this._getAMPMFormat();return" "+A.format(i);};
t.prototype._calculateTopPosition=function(i){var j=i.getHours()-this._getVisibleStartHour(),x=i.getMinutes(),y=this._getRowHeight();return Math.floor((y*j)+(y/60)*x);};
t.prototype._calculateBottomPosition=function(i){var j=this._getVisibleEndHour()+1-i.getHours(),x=i.getMinutes(),y=this._getRowHeight();return Math.floor((y*j)-(y/60)*x);};
t.prototype._updateRowHeaderAndNowMarker=function(){var i=new Date();this._updateNowMarker(i);this._updateRowHeaders(i);setTimeout(this._updateRowHeaderAndNowMarker.bind(this),O);};
t.prototype._updateNowMarker=function(i){var $=this.$("nowMarker"),j=this.$("nowMarkerText"),x=this.$("nowMarkerAMPM"),y=!this._isVisibleHour(i.getHours());$.toggleClass("sapMSinglePCNowMarkerHidden",y);$.css("top",this._calculateTopPosition(i)+"px");j.text(this._formatTimeAsString(i));x.text(this._addAMPM(i));j.append(x);};
t.prototype._updateRowHeaders=function(i){var $=this.$(),j=i.getHours(),N=j+1;$.find(".sapMSinglePCRowHeader").removeClass("sapMSinglePCRowHeaderHidden");if(this._shouldHideRowHeader(j)){$.find(".sapMSinglePCRowHeader"+j).addClass("sapMSinglePCRowHeaderHidden");}else if(this._shouldHideRowHeader(N)){$.find(".sapMSinglePCRowHeader"+N).addClass("sapMSinglePCRowHeaderHidden");}};
t.prototype._createAppointmentsMap=function(A){var i=this;return A.reduce(function(j,x){var y=x.getStartDate(),z=x.getEndDate(),E,G,J;if(!y||!z){return j;}if(!i.isAllDayAppointment(y,z)){E=g.fromLocalJSDate(y);G=g.fromLocalJSDate(z);while(E.isSameOrBefore(G)){J=i._getDateFormatter().format(E.toLocalJSDate());if(!j.appointments[J]){j.appointments[J]=[];}j.appointments[J].push(x);E.setDate(E.getDate()+1);}}else{j.blockers.push(x);}return j;},{appointments:{},blockers:[]});};
t.prototype._calculateVisibleAppointments=function(A,j,x){var V={},y,z,E;for(var i=0;i<x;i++){y=new g(j.getFullYear(),j.getMonth(),j.getDate()+i);z=this._getDateFormatter().format(y.toLocalJSDate());E=this._isAppointmentFitInVisibleHours(y);if(A[z]){V[z]=A[z].filter(E,this).sort(this._sortAppointmentsByStartHourCallBack);}}return V;};
t.prototype._isAppointmentFitInVisibleHours=function(i){return function(A){var j=A.getStartDate().getTime(),x=A.getEndDate().getTime(),y=(new U(i.getYear(),i.getMonth(),i.getDate(),this._getVisibleStartHour())).getTime(),z=(new U(i.getYear(),i.getMonth(),i.getDate(),this._getVisibleEndHour(),59,59)).getTime();var E=j<y&&x>z,G=j>=y&&j<z,J=x>y&&x<=z;return E||G||J;};};
t.prototype._calculateAppointmentsLevelsAndWidth=function(V){var i=this;return Object.keys(V).reduce(function(A,j){var x=0,y=new S.list(),z=V[j];z.forEach(function(E){var G=new S.node(E),J=E.getStartDate().getTime();if(y.getSize()===0){y.add(G);return;}y.getIterator().forEach(function(N){var Q=true,T=N.getData(),W=T.getStartDate().getTime(),X=T.getEndDate().getTime(),Y=X-W;if(Y<H){X=X+(H-Y);}if(J>=W&&J<X){G.level++;x=Math.max(x,G.level);}if(N.next&&N.next.level===G.level){Q=false;}if(J>=X&&Q){this.interrupt();}});y.insertAfterLevel(G.level,G);});A[j]={oAppointmentsList:i._calculateAppointmentsWidth(y),iMaxLevel:x};return A;},{});};
t.prototype._calculateAppointmentsWidth=function(A){A.getIterator().forEach(function(i){var j=i.getData(),x=i.level,y=i.level,z=j.getStartDate().getTime(),E=j.getEndDate().getTime(),G=E-z;if(G<H){E=E+(H-G);}new S.iterator(A).forEach(function(J){var N=J.getData(),Q=J.level,T=N.getStartDate().getTime(),V=N.getEndDate().getTime(),W=V-T;if(W<H){V=V+(H-W);}if(y>=Q){return;}if(z>=T&&z<V||E>T&&E<V||z<=T&&E>=V){i.width=Q-y;this.interrupt();return;}if(x<Q){x=Q;i.width++;}});});return A;};
t.prototype._calculateVisibleBlockers=function(i,j,x){var y=new g(j.getYear(),j.getMonth(),j.getDate()+x-1),z=this._isBlockerVisible(j,y);return i.filter(z).sort(this._sortAppointmentsByStartHourCallBack);};
t.prototype._isBlockerVisible=function(V,i){return function(A){var j=g.fromLocalJSDate(A.getStartDate()),x=g.fromLocalJSDate(A.getEndDate());var y=j.isBefore(V)&&x.isAfter(i),z=h._isBetween(j,V,i,true),E=h._isBetween(x,V,i,true);return y||z||E;};};
t.prototype._calculateBlockersLevelsAndWidth=function(V){var i=0,j=new S.list();V.forEach(function(x){var y=new S.node(x),z=g.fromLocalJSDate(x.getStartDate()),A=g.fromLocalJSDate(x.getEndDate());y.width=h._daysBetween(A,z);if(j.getSize()===0){j.add(y);return;}j.getIterator().forEach(function(E){var G=true,J=E.getData(),N=g.fromLocalJSDate(J.getStartDate()),Q=g.fromLocalJSDate(J.getEndDate());if(z.isSameOrAfter(N)&&z.isSameOrBefore(Q)){y.level++;i=Math.max(i,y.level);}if(E.next&&E.next.level===y.level){G=false;}if(z.isSameOrAfter(Q)&&G){this.interrupt();}});j.insertAfterLevel(y.level,y);},this);return{oBlockersList:j,iMaxlevel:i};};
t.prototype._sortAppointmentsByStartHourCallBack=function(A,i){return A.getStartDate().getTime()-i.getStartDate().getTime()||i.getEndDate().getTime()-A.getEndDate().getTime();};
t.prototype._getVisibleAppointments=function(){return this._oVisibleAppointments;};
t.prototype._getAppointmentsToRender=function(){return this._oAppointmentsToRender;};
t.prototype._getVisibleBlockers=function(){return this._aVisibleBlockers;};
t.prototype._getBlockersToRender=function(){return this._oBlockersToRender;};
t.prototype._setColumns=function(i){this._iOldColumns=this._iColumns;this._iColumns=i;this.getAggregation("_columnHeaders").setDays(i);this.invalidate();return this;};
t.prototype._getColumns=function(){return this._iColumns;};
t.prototype._getRowHeight=function(){return this._isCompact()?o:R;};
t.prototype._getBlockerRowHeight=function(){return this._isCompact()?p:B;};
t.prototype._isCompact=function(){var i=this.getDomRef();while(i&&i.classList){if(i.classList.contains("sapUiSizeCompact")){return true;}i=i.parentNode;}return false;};
t.prototype._getCoreLocaleId=function(){if(!this._sLocale){this._sLocale=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale().toString();}return this._sLocale;};
t.prototype._getCoreLocaleData=function(){var i,j;if(!this._oLocaleData){i=this._getCoreLocaleId();j=new a(i);this._oLocaleData=L.getInstance(j);}return this._oLocaleData;};
t.prototype._hasAMPM=function(){var i=this._getCoreLocaleData();return i.getTimePattern("short").search("a")>=0;};
t.prototype._getHoursFormat=function(){var i=this._getCoreLocaleId();if(!this._oHoursFormat||this._oHoursFormat.oLocale.toString()!==i){var j=new a(i),x=this._getHoursPattern();this._oHoursFormat=D.getTimeInstance({pattern:x},j);}return this._oHoursFormat;};
t.prototype._getHoursPattern=function(){return this._hasAMPM()?"h":"H";};
t.prototype._getAMPMFormat=function(){var i=this._getCoreLocaleId(),j=new a(i);if(!this._oAMPMFormat||this._oAMPMFormat.oLocale.toString()!==i){this._oAMPMFormat=D.getTimeInstance({pattern:"a"},j);}return this._oAMPMFormat;};
t.prototype._getColumnHeaders=function(){return this.getAggregation("_columnHeaders");};
t.prototype._getAppointmentAnnouncementInfo=function(A){var i=this._oUnifiedRB.getText("CALENDAR_START_TIME"),E=this._oUnifiedRB.getText("CALENDAR_END_TIME"),j=this._oFormatStartEndInfoAria.format(A.getStartDate()),x=this._oFormatStartEndInfoAria.format(A.getEndDate()),y=i+": "+j+"; "+E+": "+x;return y+"; "+P.findLegendItemForItem(sap.ui.getCore().byId(this._sLegendId),A);};
t.prototype.enhanceAccessibilityState=function(i,A){if(i.getId()===this._getColumnHeaders().getId()){A.labelledby=I.getStaticId("sap.m","PLANNINGCALENDAR_DAYS");}};
t.prototype._getCellStartEndInfo=function(i,E){var j=this._oUnifiedRB.getText("CALENDAR_START_TIME"),x=this._oUnifiedRB.getText("CALENDAR_END_TIME"),y=!E;if(y){return j+": "+this._oFormatAriaFullDayCell.format(i)+"; ";}return j+": "+this._oFormatStartEndInfoAria.format(i)+"; "+x+": "+this._oFormatStartEndInfoAria.format(E);};
t.prototype.isAllDayAppointment=function(A,i){var j=A.getHours()===0,x=A.getMinutes()===0,y=A.getSeconds()===0,z=A.getMilliseconds()===0,E=j&&x&&y&&z,G=false;if(E){G=this._isEndTime0000(A,i);}return G;};
t.prototype._isEndTime0000=function(A,i){return(i.getTime()-A.getTime())%M===0;};
t.prototype._createBlockersDndPlaceholders=function(j,x){this.destroyAggregation("_blockersPlaceholders");for(var i=0;i<x;i++){var y=new U(j.getFullYear(),j.getMonth(),j.getDate()+i);var z=new w({date:y});this.addAggregation("_blockersPlaceholders",z,true);}};
t.prototype._createAppointmentsDndPlaceholders=function(x,y){var z=this._getVisibleStartHour(),E=this._getVisibleEndHour();this._dndPlaceholdersMap={};this.destroyAggregation("_intervalPlaceholders");for(var i=0;i<y;i++){var A=new g(x.getFullYear(),x.getMonth(),x.getDate()+i);if(!this._dndPlaceholdersMap[A]){this._dndPlaceholdersMap[A]=[];}for(var j=z;j<=E;j++){var G=this._dndPlaceholdersMap[A],Y=A.getYear(),J=A.getMonth(),N=A.getDate();G.push(this._createAppointmentsDndPlaceHolder(new U(Y,J,N,j)));G.push(this._createAppointmentsDndPlaceHolder(new U(Y,J,N,j,30)));}}};
t.prototype._createAppointmentsDndPlaceHolder=function(i){var j=new w({date:i});this.addAggregation("_intervalPlaceholders",j,true);return j;};
t.prototype._getSpecialDates=function(){var j=this.getSpecialDates();for(var i=0;i<j.length;i++){var N=j[i].getSecondaryType()===u.CalendarDayType.NonWorking&&j[i].getType()!==u.CalendarDayType.NonWorking;if(N){var x=new k();x.setType(u.CalendarDayType.NonWorking);x.setStartDate(j[i].getStartDate());if(j[i].getEndDate()){x.setEndDate(j[i].getEndDate());}j.push(x);}}return j;};
function v(){var $=q("<span></span>").addClass("sapUiCalAppResizeGhost");$.appendTo(document.body);setTimeout(function(){$.remove();},0);return $.get(0);}
var w=C.extend("sap.m.SinglePlanningCalendarGrid._internal.IntervalPlaceholder",{
metadata:{properties:{date:{type:"object",group:"Data"}}},
renderer:function(i,j){i.write("<div");i.writeControlData(j);i.addClass("sapMSinglePCPlaceholder");i.writeClasses();i.write("></div>");}
});
function _(){var i=this.getDomRef(),j=this.$().find(".sapMSinglePCBlockersColumn").toArray();this._aGridCells=Array.prototype.concat(j);for(var x=0;x<=this._getVisibleEndHour();++x){j=this.$().find("div[data-sap-hour='"+x+"']").toArray();this._aGridCells=this._aGridCells.concat(j);}if(!this._oItemNavigation){this._oItemNavigation=new n();this.addDelegate(this._oItemNavigation);}this._oItemNavigation.setRootDomRef(i);this._oItemNavigation.setItemDomRefs(this._aGridCells);this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"],saphome:["alt","meta"],sapend:["meta"]});this._oItemNavigation.setTableMode(true,true).setColumns(this._getColumns());this._oItemNavigation.setPageSize(this._aGridCells.length);}
return t;});
},
	"sap/m/SinglePlanningCalendarGridRenderer.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/core/InvisibleText','./PlanningCalendarLegend','sap/ui/unified/library'],function(C,a,U,I,P,u){"use strict";var v=2;var A=2;var b=1;var c=u.CalendarDayType;var S={apiVersion:2};
S.render=function(r,o){r.openStart("div",o);r.class("sapMSinglePCGrid");r.openEnd();r.renderControl(o.getAggregation("_columnHeaders"));this.renderBlockersContainer(r,o);r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCGridContent");r.openEnd();this.renderRowHeaders(r,o);this.renderNowMarker(r,o);this.renderColumns(r,o);r.close("div");r.close("div");};
S.renderBlockersContainer=function(r,o){var d=o._getColumns(),m=o._getBlockersToRender().iMaxlevel,s=o.getStartDate(),e=(m+1)*o._getBlockerRowHeight()+3,f=o._getDateFormatter(),g=o._getSpecialDates(),h=C.fromLocalJSDate(s),D=o._getColumnHeaders()._getDateTypes(h),t,l;r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCBlockersRow");r.openEnd();r.openStart("div");r.attr("role","row");r.class("sapMSinglePCBlockersColumns");if(g&&o._getColumns()===1){if(D&&D[0]){t=D[0];r.class("sapUiCalItem"+t.type);l=P.findLegendItemForItem(sap.ui.getCore().byId(o._sLegendId),t);}r.class("sapMSpecialDaysInDayView");}r.style("height",e+"px");r.openEnd();this.renderDndPlaceholders(r,o,o.getAggregation("_blockersPlaceholders"));for(var i=0;i<d;i++){var j=new C(s.getFullYear(),s.getMonth(),s.getDate()+i);r.openStart("div");r.attr("role","gridcell");r.attr("data-sap-start-date",f.format(j.toLocalJSDate()));r.attr("data-sap-end-date",f.format(j.toLocalJSDate()));r.attr("aria-labelledby",I.getStaticId("sap.m","SPC_BLOCKERS")+" "+"fullDay-"+f.format(j.toLocalJSDate())+"-Descr");r.class("sapMSinglePCBlockersColumn");r.attr("tabindex",-1);if(j.isSame(new C())){r.class("sapMSinglePCBlockersColumnToday");}if(a._isWeekend(j,o._getCoreLocaleData())){r.class("sapMSinglePCBlockersColumnWeekend");}r.openEnd();r.openStart("span","fullDay-"+f.format(j.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(j.toLocalJSDate()));if(o._sLegendId&&l){r.text(l);}r.close("span");r.close("div");}this.renderBlockers(r,o);r.close("div");r.close("div");};
S.renderBlockers=function(r,o){var t=this,B=o._getBlockersToRender().oBlockersList;r.openStart("div");r.attr("role","list");r.attr("aria-labelledby",I.getStaticId("sap.m","SPC_BLOCKERS"));r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.openEnd();B.getIterator().forEach(function(d){t.renderBlockerAppointment(r,o,d);});r.close("div");};
S.renderBlockerAppointment=function(r,o,B){var g=C.fromLocalJSDate(o.getStartDate()),d=B.getData(),e=C.fromLocalJSDate(d.getStartDate()),f=C.fromLocalJSDate(d.getEndDate()),s=a._daysBetween(e,g),E=a._daysBetween(f,g),i=o._getColumns(),R=o._getBlockerRowHeight(),h=B.level,j=B.width,t=d.getTooltip_AsString(),T=d.getType(),k=d.getColor(),l=d.getTitle(),m=d.getText(),n=d.getIcon(),p=d.getId(),q={role:"listitem",labelledby:{value:I.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},w=o.getAriaLabelledBy(),L=s*(100/i),x=(i-E-1)*(100/i),y=sap.ui.getCore().getConfiguration().getRTL(),z;if(w.length>0){q["labelledby"].value=q["labelledby"].value+" "+w.join(" ");}if(l){q["labelledby"].value=q["labelledby"].value+" "+p+"-Title";}q["labelledby"].value=q["labelledby"].value+" "+p+"-Descr";if(m){q["labelledby"].value=q["labelledby"].value+" "+p+"-Text";}if(d.getTentative()){q["labelledby"].value=q["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(d.getSelected()){q["labelledby"].value=q["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",d);r.attr("data-sap-level",h);r.attr("data-sap-width",j);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(d,q);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!k&&T!==c.None){r.class("sapUiCalendarApp"+T);}if(k){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",k);}else{r.style("border-left-color",k);}}r.style("top",R*h+1+"px");r.style(y?"right":"left",Math.max(L,0)+"%");r.style(y?"left":"right",Math.max(x,0)+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(d.getSelected()){r.class("sapUiCalendarAppSel");}if(d.getTentative()){r.class("sapUiCalendarAppTent");}if(n){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(k){r.style("background-color",d._getCSSColorForBackground(k));}r.openEnd();if(L<0){z=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",z,{title:null});}if(n){z=["sapUiCalendarAppIcon"];var D={};D["id"]=p+"-Icon";D["title"]=null;r.icon(n,z,D);}if(l){r.openStart("span",p+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(l,true);r.close("span");}if(x<0){z=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",z,{title:null});}r.openStart("span",p+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(d));r.close("span");r.close("div");r.close("div");r.close("div");};
S.renderRowHeaders=function(r,o){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),d=new Date(),h=o._getHoursFormat(),f=o._getAMPMFormat();r.openStart("div");r.class("sapMSinglePCRowHeaders");r.openEnd();for(var i=s;i<=e;i++){d.setHours(i);r.openStart("span");r.class("sapMSinglePCRowHeader");r.class("sapMSinglePCRowHeader"+i);if(o._shouldHideRowHeader(i)){r.class("sapMSinglePCRowHeaderHidden");}r.openEnd();r.text(h.format(d));if(o._hasAMPM()){r.openStart("span");r.class("sapMSinglePCRowHeaderAMPM");r.openEnd();r.text(" "+f.format(d));r.close("span");}r.close("span");}r.close("div");};
S.renderColumns=function(r,o){var d=o._getColumns(),s=o.getStartDate(),e=o._getAppointmentsToRender();r.openStart("div");r.attr("role","grid");r.attr("aria-labelledby",I.getStaticId("sap.m","SPC_APPOINTMENTS"));r.class("sapMSinglePCColumns");r.openEnd();for(var i=0;i<d;i++){var f=new C(s.getFullYear(),s.getMonth(),s.getDate()+i),F=o._getDateFormatter(),D=F.format(f.toLocalJSDate());r.openStart("div");r.attr("role","row");r.attr("data-sap-day",D);r.class("sapMSinglePCColumn");if(f.isSame(new C())){r.class("sapMSinglePCColumnToday");}if(a._isWeekend(f,o._getCoreLocaleData())){r.class("sapMSinglePCColumnWeekend");}r.openEnd();this.renderDndPlaceholders(r,o,o._dndPlaceholdersMap[f]);this.renderRows(r,o,D);this.renderAppointments(r,o,e[D],f);r.close("div");}r.close("div");};
S.renderDndPlaceholders=function(r,o,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();p.forEach(r.renderControl,r);r.close("div");};
S.renderRows=function(r,o,d){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),f=o._getDateFormatter(),g,h;for(var i=s;i<=e;i++){g=o._parseDateStringAndHours(d,i);h=new Date(g.getFullYear(),g.getMonth(),g.getDate(),g.getHours()+1);r.openStart("div");r.attr("role","gridcell");r.class("sapMSinglePCRow");if(!o._isVisibleHour(i)){r.class("sapMSinglePCNonWorkingRow");}r.attr("data-sap-hour",i);r.attr("data-sap-start-date",f.format(g));r.attr("data-sap-end-date",f.format(h));r.attr("aria-labelledby",f.format(g)+"-Descr");r.attr("tabindex",-1);r.openEnd();r.openStart("span",f.format(g)+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(g,h));r.close("span");r.close("div");}};
S.renderAppointments=function(r,o,d,e){var t=this;if(d){r.openStart("div");r.attr("role","list");r.class("sapMSinglePCAppointments");r.class("sapUiCalendarRowVisFilled");r.openEnd();d.oAppointmentsList.getIterator().forEach(function(f){var m=d.iMaxLevel,l=f.level,w=f.width,g=f.getData();t.renderAppointment(r,o,m,l,w,g,e);});r.close("div");}};
S.renderAppointment=function(r,o,m,i,d,e,f){var g=C.fromLocalJSDate(o.getStartDate()),G=new C(g),R=o._getRowHeight(),h=new U(f.getYear(),f.getMonth(),f.getDate(),o._getVisibleStartHour()),j=new U(f.getYear(),f.getMonth(),f.getDate(),o._getVisibleEndHour(),59,59),k=e.getStartDate(),l=e.getEndDate(),n=C.fromLocalJSDate(k),p=C.fromLocalJSDate(l),t=e.getTooltip_AsString(),T=e.getType(),s=e.getColor(),q=e.getTitle(),w=e.getText(),x=e.getIcon(),y=e.getId(),L=this._getLineClamp(k,l),z={role:"listitem",labelledby:{value:I.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},B=o.getAriaLabelledBy(),D=h.getTime()>k.getTime(),E=j.getTime()<l.getTime(),F=D?0:o._calculateTopPosition(k),H=E?0:o._calculateBottomPosition(l),J=100/(m+1),K,M,N,O,Q;G.setDate(G.getDate()+o._getColumns()-1);K=a._daysBetween(n,g);M=a._daysBetween(G,p);N=f.isSame(g);O=f.isSame(G);if(B.length>0){z["labelledby"].value=z["labelledby"].value+" "+B.join(" ");}if(q){z["labelledby"].value=z["labelledby"].value+" "+y+"-Title";}z["labelledby"].value=z["labelledby"].value+" "+y+"-Descr";if(w){z["labelledby"].value=z["labelledby"].value+" "+y+"-Text";}if(e.getTentative()){z["labelledby"].value=z["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(e.getSelected()){z["labelledby"].value=z["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",e);r.attr("data-sap-level",i);r.attr("data-sap-width",d);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(e,z);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!s&&T!==c.None){r.class("sapUiCalendarApp"+T);}if(s){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",s);}else{r.style("border-left-color",s);}}r.style("top",F+"px");r.style("bottom",H+"px");r.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",J*i+"%");r.style("width",J*d+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");r.style("min-height",(R-(v+A+b))/2+"px");if(e.getSelected()){r.class("sapUiCalendarAppSel");}if(e.getTentative()){r.class("sapUiCalendarAppTent");}if(x){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(s){r.style("background-color",e._getCSSColorForBackground(s));}r.openEnd();if(N&&K<0){Q=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",Q,{title:null});}if(x){Q=["sapUiCalendarAppIcon"];var V={};V["id"]=y+"-Icon";V["title"]=null;r.icon(x,Q,V);}r.openStart("div");r.class("sapUiCalendarAppTitleWrapper");r.class("sapUiSPCAppLineClamp"+L);r.openEnd();if(q){r.openStart("span",y+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(q,true);r.close("span");}if(w){r.openStart("span",y+"-Text");r.class("sapUiCalendarAppText");r.openEnd();r.text(w,true);r.close("span");}r.close("div");if(O&&M<0){Q=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",Q,{title:null});}r.openStart("span",y+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(e));r.close("span");r.close("div");if(o.getEnableAppointmentsResize()&&!D&&!E){this.renderResizeHandles(r);}r.close("div");r.close("div");};
S.renderNowMarker=function(r,o){var d=new Date();r.openStart("div",o.getId()+"-nowMarker");r.style("top",o._calculateTopPosition(d)+"px");r.class("sapMSinglePCNowMarker");if(!o._isVisibleHour(d.getHours())){r.class("sapMSinglePCNowMarkerHidden");}r.openEnd();r.openStart("span",o.getId()+"-nowMarkerText");r.class("sapMSinglePCNowMarkerText");r.openEnd();r.text(o._formatTimeAsString(d));if(o._hasAMPM()){r.openStart("span",o.getId()+"-nowMarkerAMPM");r.class("sapMSinglePCNowMarkerAMPM");r.openEnd();r.text(o._addAMPM(d));r.close("span");}r.close("span");r.close("div");};
S.renderResizeHandles=function(r){r.openStart("span");r.class("sapMSinglePCAppResizeHandleBottom");r.openEnd();r.close("span");r.openStart("span");r.class("sapMSinglePCAppResizeHandleTop");r.openEnd();r.close("span");};
S._getLineClamp=function(o,d){var m=a._minutesBetween(o,d);if(m>=51&&m<69){return"2";}else if(m>=69&&m<90){return"3";}else if(m>=90&&m<110){return"4";}else if(m>=110&&m<130){return"5";}else if(m>=130&&m<150){return"6";}else if(m>=150&&m<170){return"7";}else if(m>=170&&m<190){return"8";}else if(m>=190){return"9";}else{return"1";}};
return S;},true);
},
	"sap/m/SinglePlanningCalendarMonthGrid.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/core/Control','sap/ui/core/format/DateFormat','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/DateTypeRange','sap/ui/unified/library','sap/ui/core/LocaleData','sap/ui/core/Locale','sap/ui/core/delegate/ItemNavigation','sap/ui/core/dnd/DragDropInfo','sap/ui/core/CustomData','sap/ui/events/KeyCodes','sap/base/Log','sap/ui/core/Core','./Link','./PlanningCalendarLegend','./SinglePlanningCalendarMonthGridRenderer'],function(C,D,c,d,e,u,L,f,I,g,h,K,l,m,n,P,S){"use strict";var A=1.5625;var o=1.5;var p=2.125;var q=1.75;
var r=C.extend("sap.m.SinglePlanningCalendarMonthGrid",{metadata:{library:"sap.m",properties:{startDate:{type:"object",group:"Data"},enableAppointmentsDragAndDrop:{type:"boolean",group:"Misc",defaultValue:false}},aggregations:{appointments:{type:"sap.ui.unified.CalendarAppointment",multiple:true,singularName:"appointment",dnd:{draggable:true}},specialDates:{type:"sap.ui.unified.DateTypeRange",multiple:true,singularName:"specialDate"},_appsPlaceholders:{type:"sap.m.SinglePlanningCalendarMonthGrid._internal.IntervalPlaceholder",multiple:true,visibility:"hidden",dnd:{droppable:true}}},dnd:true,associations:{legend:{type:"sap.m.PlanningCalendarLegend",multiple:false}},events:{cellPress:{parameters:{startDate:{type:"object"},endDate:{type:"object"}}},moreLinkPress:{parameters:{date:{type:"object"}}},appointmentDrop:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},startDate:{type:"object"},endDate:{type:"object"},copy:{type:"boolean"}}},appointmentSelect:{parameters:{appointment:{type:"sap.ui.unified.CalendarAppointment"},appointments:{type:"sap.ui.unified.CalendarAppointment[]"}}}}}});
r.prototype.init=function(){this._aLinks=[];this._handleMorePress=this._handleMorePress.bind(this);this._oDateFormat=D.getDateTimeInstance({pattern:"YYYYMMdd"});this._oFormatAriaApp=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY 'at' "+this._getCoreLocaleData().getTimePattern("medium")});this._oFormatAriaFullDayCell=D.getDateTimeInstance({pattern:"EEEE dd/MM/YYYY"});this.setStartDate(new Date());this._configureAppointmentsDragAndDrop();};
r.prototype.exit=function(){if(this._oItemNavigation){this.removeDelegate(this._oItemNavigation);this._oItemNavigation.destroy();delete this._oItemNavigation;}for(var i=0;i<this._aLinks.length;i++){if(this._aLinks[i]){this._aLinks[i].destroy();}}delete this._aLinks;};
r.prototype.onBeforeRendering=function(){var a=this.getStartDate();this._oAppointmentsToRender=this._calculateAppointmentsNodes(a);this._createAppointmentsDndPlaceholders(a);};
r.prototype.onAfterRendering=function(){this._initItemNavigation();};
r.prototype._getColumns=function(){return 7;};
r.prototype._getRows=function(){return 6;};
r.prototype._getDateFormatter=function(){return this._oDateFormat;};
r.prototype._getAppointmetsForADay=function(a){return this._oAppointmentsToRender.filter(function(b){return b.start.valueOf()===a.valueOf();});};
r.prototype._getPreviousAppointmetsForADay=function(a){return this._oAppointmentsToRender.filter(function(b){return b.start.valueOf()<a.valueOf()&&b.end.valueOf()>=a.valueOf();}).map(function(b){var i={data:b.data,start:b.start,end:b.end,len:b.len,level:b.level,width:b.width};i.width-=d._daysBetween(a,b.start);i.hasPrevious=true;return i;},this);};
r.prototype.ontap=function(E){this._fireSelectionEvent(E);};
r.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this._fireSelectionEvent(E);E.preventDefault();}};
r.prototype._fireSelectionEvent=function(E){var a=E.srcControl,t=E.target,i=t&&t.classList.contains("sapMSPCMonthDay"),b=t&&t.classList.contains("sapMLnk"),T,j,k;if(a&&a.isA("sap.m.SinglePlanningCalendarMonthGrid")&&i&&!b){T=parseInt(t.getAttribute("sap-ui-date"));j=new Date(T);j=new Date(j.getFullYear(),j.getMonth(),j.getDate());k=new Date(j);k.setDate(k.getDate()+1);this.fireEvent("cellPress",{startDate:j,endDate:k});this.fireAppointmentSelect({appointment:undefined,appointments:this._toggleAppointmentSelection(undefined,true)});}else if(a&&a.isA("sap.ui.unified.CalendarAppointment")){this.fireAppointmentSelect({appointment:a,appointments:this._toggleAppointmentSelection(a,!(E.ctrlKey||E.metaKey))});}};
r.prototype._toggleAppointmentSelection=function(a,R){var b=[],j,k,i;if(R){j=this.getAppointments();for(i=0,k=j.length;i<k;i++){if((!a||j[i].getId()!==a.getId())&&j[i].getSelected()){j[i].setProperty("selected",false);b.push(j[i]);}}}if(a){a.setProperty("selected",!a.getSelected());b.push(a);}return b;};
r.prototype._getMoreLink=function(a,b,i){var M=m.getLibraryResourceBundle("sap.m").getText("SPC_MORE_LINK",[a.toString()]),j=new n({text:M,press:this._handleMorePress}).addCustomData(new h({key:"date",value:b.valueOf().toString(),writeToDom:true}));if(this._aLinks[i]){this._aLinks[i].destroy();}this._aLinks[i]=j;return j;};
r.prototype._handleMorePress=function(E){var t=parseInt(E.getSource().getCustomData()[0].getValue()),a=new Date(t);a=new Date(a.getFullYear(),a.getMonth(),a.getDate());this.fireEvent("moreLinkPress",{date:a});};
r.prototype._getCoreLocaleData=function(){var a=m.getConfiguration().getFormatSettings().getFormatLocale().toString(),b=new f(a);return L.getInstance(b);};
r.prototype._getCells=function(){return this._getVisibleDays(this.getStartDate());};
r.prototype._getVerticalLabels=function(){var a=this._getVisibleDays(this.getStartDate()),b=this._getColumns(),R=[],j=m.getConfiguration().getFormatLocale().toString(),k=this._getCoreLocaleData();for(var i=0;i<this._getRows();i++){R.push(d.calculateWeekNumber(a[i*b].toUTCJSDate(),a[i*b].getYear(),j,k));}return R;};
r.prototype._getVisibleDays=function(a){var b,j,k,t,F,v,V=[];if(!a){return V;}b=c.fromLocalJSDate(a);v=this._getCoreLocaleData().getFirstDayOfWeek();F=new c(b);F.setDate(1);t=F.getDay()-v;if(t<0){t=7+t;}if(t>0){F.setDate(1-t);}j=new c(F);for(var i=0;i<this._getColumns()*this._getRows();i++){k=new c(j);V.push(k);j.setDate(j.getDate()+1);}return V;};
r.prototype._getAppointmentsToRender=function(){return this._oAppointmentsToRender;};
r.prototype._calculateAppointmentsNodes=function(t){var v=this._getVisibleDays(t),F=v[0],w=v[v.length-1],x=this.getAppointments().filter(function(a){var b=a.getStartDate()&&a.getEndDate();if(!b){l.warning("Appointment "+a.getId()+" has no start or no end date. It is ignored.");}return b;}).map(function(a){var b=c.fromLocalJSDate(a.getStartDate()),G=c.fromLocalJSDate(a.getEndDate());return{data:a,start:b,end:G,len:d._daysBetween(G,b)};}).filter(function(a){return d._isBetween(a.start,F,w,true)||d._isBetween(a.end,F,w,true)||(d._isBetween(F,a.start,w,true)&&d._isBetween(w,F,a.end,true));}).sort(function compare(a,b){return a.start.valueOf()-b.start.valueOf();}),V=[],y,z,E,B,i,j,k;for(i=0;i<v.length;i++){V.push([]);}for(i=0;i<x.length;i++){y=x[i];z=d._daysBetween(y.start,v[0]);E=z+y.len;z=z>0?z:0;E=E<v.length?E:v.length-1;y.width=y.len+1;B=V[z].indexOf(true);if(B===-1){B=V[z].length;}y.level=B;for(j=z;j<=E;j++){V[j][B]=false;for(k=0;k<B;k++){if(V[j][k]===undefined){V[j][k]=true;}}}}this._aAppsLevelsPerDay=V;return x;};
r.prototype._getMoreCountPerCell=function(a){var b=this._aAppsLevelsPerDay[a];var M=this._getMaxAppointments();var j=0;var k=0;if(b.length<=M){return 0;}for(var i=0;i<b.length;i++){if(!b[i]){j++;}if(i<M-1){k++;}}return j-k;};
r.prototype._configureAppointmentsDragAndDrop=function(){this.addDragDropConfig(new g({sourceAggregation:"appointments",targetAggregation:"_appsPlaceholders",dragStart:function(E){if(!this.getEnableAppointmentsDragAndDrop()){E.preventDefault();return false;}var H=function(){var O=jQuery(".sapMSinglePCOverlay");setTimeout(function(){O.addClass("sapMSinglePCOverlayDragging");});jQuery(document).one("dragend",function(){O.removeClass("sapMSinglePCOverlayDragging");});};H();}.bind(this),dragEnter:function(E){var a=E.getParameter("dragSession"),b=function(){var i=jQuery(a.getIndicator());i.css("min-height",a.getDropControl().$().outerHeight());i.css("min-width",a.getDropControl().$().outerWidth());};if(!a.getIndicator()){setTimeout(b,0);}else{b();}},drop:function(E){var a=E.getParameter("dragSession"),b=a.getDragControl(),i=a.getDropControl(),j=i.getDate(),k=c.fromLocalJSDate(b.getStartDate()),t=c.fromLocalJSDate(b.getEndDate()),O=d._daysBetween(j,k),v=new c(k),w=new c(t),B=E.getParameter("browserEvent"),x=(B.metaKey||B.ctrlKey);v.setDate(v.getDate()+O);w.setDate(w.getDate()+O);this.$().find(".sapMSinglePCOverlay").removeClass("sapMSinglePCOverlayDragging");if(k.valueOf()===j.valueOf()){return;}this.fireAppointmentDrop({appointment:b,startDate:v.toLocalJSDate(),endDate:w.toLocalJSDate(),copy:x});}.bind(this)}));};
r.prototype._initItemNavigation=function(){var R=this.getDomRef();this._aGridCells=this.$().find(".sapMSPCMonthDay").toArray();if(!this._oItemNavigation){this._oItemNavigation=new I();this.addDelegate(this._oItemNavigation);this._oItemNavigation.attachEvent(I.Events.BorderReached,this._itemNavigationBorderReached,this);}this._oItemNavigation.setRootDomRef(R);this._oItemNavigation.setItemDomRefs(this._aGridCells);this._oItemNavigation.setCycling(false);this._oItemNavigation.setDisabledModifiers({sapnext:["alt","meta"],sapprevious:["alt","meta"],saphome:["alt","meta"],sapend:["meta"]});this._oItemNavigation.setTableMode(false).setColumns(this._getColumns(),true);this._oItemNavigation.setPageSize(this._aGridCells.length);};
r.prototype._itemNavigationBorderReached=function(E){var G,F,i=E.getParameter("event"),O;if(i.target.classList.contains("sapMSPCMonthDay")){G=i.target;F=parseInt(G.getAttribute("sap-ui-date"));switch(i.keyCode){case K.ARROW_LEFT:O=-1;break;case K.ARROW_UP:O=-this._getColumns();break;case K.ARROW_RIGHT:O=1;break;case K.ARROW_DOWN:O=this._getColumns();break;default:break;}this.fireEvent("borderReached",{startDate:F,offset:O});}};
r.prototype._createAppointmentsDndPlaceholders=function(a){var b=this._getVisibleDays(a);this.destroyAggregation("_appsPlaceholders");for(var i=0;i<b.length;i++){var j=new s({date:b[i]});this.addAggregation("_appsPlaceholders",j,true);}};
var s=C.extend("sap.m.SinglePlanningCalendarMonthGrid._internal.IntervalPlaceholder",{
metadata:{properties:{date:{type:"object",group:"Data"}}},
renderer:function(R,a){R.write("<div");R.writeControlData(a);R.addClass("sapMSinglePCPlaceholder");R.writeClasses();R.write("></div>");}
});
r.prototype._getCellStartInfo=function(a){var b=m.getLibraryResourceBundle("sap.ui.unified").getText("CALENDAR_START_TIME");return b+": "+this._oFormatAriaFullDayCell.format(a)+"; ";};
r.prototype._getAppointmentAnnouncementInfo=function(a){var U=m.getLibraryResourceBundle("sap.ui.unified"),b=U.getText("CALENDAR_START_TIME"),E=U.getText("CALENDAR_END_TIME"),F=this._oFormatAriaApp.format(a.getStartDate()),i=this._oFormatAriaApp.format(a.getEndDate()),j=b+": "+F+"; "+E+": "+i;return j+"; "+P.findLegendItemForItem(m.byId(this._sLegendId),a);};
r.prototype._getMaxAppointments=function(){return this._isCompact()?4:3;};
r.prototype._getDensitySizes=function(){return this._isCompact()?{appHeight:A,cellHeaderHeight:o}:{appHeight:p,cellHeaderHeight:q};};
r.prototype._isCompact=function(){var a=this.getDomRef()||(this.getParent()&&this.getParent().getDomRef&&this.getParent().getDomRef()||(this.getParent()&&this.getParent().getRootNode&&this.getParent().getRootNode()));while(a&&a.classList){if(a.classList.contains("sapUiSizeCompact")){return true;}a=a.parentNode;}return false;};
r.prototype._getSpecialDates=function(){var a=this.getSpecialDates();for(var i=0;i<a.length;i++){var N=a[i].getSecondaryType()===u.CalendarDayType.NonWorking&&a[i].getType()!==u.CalendarDayType.NonWorking;if(N){var b=new e();b.setType(u.CalendarDayType.NonWorking);b.setStartDate(a[i].getStartDate());if(a[i].getEndDate()){b.setEndDate(a[i].getEndDate());}a.push(b);}}return a;};
return r;});
},
	"sap/m/SinglePlanningCalendarMonthGridRenderer.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/Month','sap/ui/core/date/UniversalDate','./PlanningCalendarLegend','sap/ui/core/InvisibleText','sap/ui/core/Core','sap/ui/unified/library'],function(C,a,M,U,P,I,b,u){"use strict";var c=u.CalendarDayType;var S={apiVersion:2};
S.render=function(r,o){var l=o._getCoreLocaleData();var d=o._getDensitySizes();r.openStart("div",o);r.class("sapMSinglePCGrid");r.class("sapMSPCMonthGrid");r.openEnd();this.renderDayNames(r,o,l);r.openStart("div");r.class("sapMSinglePCGridContent");r.openEnd();this.renderCells(r,o,l,d);r.close("div");r.close("div");};
S.renderCells=function(r,o,l,d){var e=o._getCells(),v=o._getVerticalLabels(),f=o._getColumns(),m=[],A=[],g,D,h,p,k=[],n,w,i,j;for(i=0;i<o._getRows();i++){w=0;r.openStart("div");r.attr("role","grid");r.class("sapMSPCMonthWeek");r.openEnd();r.openStart("div");r.class("sapMSPCMonthWeekNumber");r.openEnd();r.text(v[i]);r.close("div");for(j=0;j<f;j++){g=i*f+j;D=e[g];h=o._getAppointmetsForADay(D);p=o._getPreviousAppointmetsForADay(D);k.push(p);n=o._getMoreCountPerCell(g);m.push(n);A.push(h);w=Math.max(w,o._aAppsLevelsPerDay[g].length);}r.openStart("div");r.class("sapMSPCMonthDays");r.class("sapMSPCMonthDaysMax"+w);r.attr("role","row");r.openEnd();for(j=0;j<f;j++){g=i*f+j;D=e[g];this.renderDay(r,o,D,l,m[g],g);}r.openStart("div");r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.attr("role","list");r.openEnd();for(j=0;j<f;j++){g=i*f+j;D=e[g];if(j===0){this.renderAppointments(r,o,k[g],j,m[g],d);}this.renderAppointments(r,o,A[g],j,m[g],d);}r.close("div");r.close("div");r.close("div");}};
S.renderDay=function(r,o,d,l,m,i){var s=o._getSpecialDates(),D=M.prototype._getDateTypes.call(o,d),f=o._getDateFormatter(),t,L;r.openStart("div");r.class("sapMSPCMonthDay");r.attr("role","gridcell");if(a._isWeekend(d,l)){r.class("nonWorkingTimeframe");}if(s){if(D&&D[0]){t=D[0];r.class("sapUiCalendarSpecialDay"+t.type);L=P.findLegendItemForItem(b.byId(o._sLegendId),t);}}r.attr("sap-ui-date",d.valueOf().toString());r.attr("tabindex",-1);r.attr("aria-labelledby",f.format(d.toLocalJSDate())+"-Descr");r.openEnd();this.renderDndPlaceholder(r,o.getAggregation("_appsPlaceholders")[i]);r.openStart("div");r.class("specialDateIndicator");r.openEnd();r.close("div");r.openStart("div");r.class("sapMSPCMonthDayNumber");r.openEnd();r.text(d.getDate());r.close("div");if(m){r.openStart("div");r.class("sapMSPCMonthLnkMore");r.openEnd();r.renderControl(o._getMoreLink(m,d,i));r.close("div");}r.openStart("span",f.format(d.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartInfo(d.toLocalJSDate()));if(o._sLegendId&&L){r.text(L);}r.close("span");r.close("div");};
S.renderAppointments=function(r,o,d,e,m,D){var f=o._getMaxAppointments(),g=m?f-2:f-1;for(var i=0;i<d.length;i++){if(d[i].level<=g){this.renderAppointment(r,o,d[i],e,D);}}};
S.renderAppointment=function(r,o,d,i,D){var A=d.data,w=d.width,l=d.level,e=o._getColumns(),t=A.getTooltip_AsString(),T=A.getType(),s=A.getColor(),f=A.getTitle(),g=A.getText(),h=A.getIcon(),j=A.getId(),m={role:"listitem",labelledby:{value:I.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},R=e-i-w,k=b.getConfiguration().getRTL(),n,B=b.getConfiguration().getTheme().indexOf("_hc")?2:1;R=R<0?0:R;if(f){m["labelledby"].value=m["labelledby"].value+" "+j+"-Title";}m["labelledby"].value=m["labelledby"].value+" "+j+"-Descr";if(g){m["labelledby"].value=m["labelledby"].value+" "+j+"-Text";}if(A.getTentative()){m["labelledby"].value=m["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(A.getSelected()){m["labelledby"].value=m["labelledby"].value+" "+I.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",A);r.attr("data-sap-level",l);r.attr("data-sap-width",w);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(A,m);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!s&&T!==c.None){r.class("sapUiCalendarApp"+T);}if(s){if(b.getConfiguration().getRTL()){r.style("border-right-color",s);}else{r.style("border-left-color",s);}}r.style(k?"right":"left","calc("+(i*100)/e+"% + "+B+"px)");r.style(k?"left":"right","calc("+(R*100)/e+"% + "+B+"px)");r.style("top",(l*D.appHeight+D.cellHeaderHeight)+"rem");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(A.getSelected()){r.class("sapUiCalendarAppSel");}if(A.getTentative()){r.class("sapUiCalendarAppTent");}if(h){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(s){r.style("background-color",A._getCSSColorForBackground(s));}r.openEnd();if(d.hasPrevious<0){n=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",n,{title:null});}if(h){n=["sapUiCalendarAppIcon"];var p={};p["id"]=j+"-Icon";p["title"]=null;r.icon(h,n,p);}if(f){r.openStart("span",j+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(f,true);r.close("span");}if(d.hasNext<0){n=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",n,{title:null});}r.openStart("span",j+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(A));r.close("span");r.close("div");r.close("div");r.close("div");};
S.renderDayNames=function(r,o,l){var f=l.getFirstDayOfWeek(),s=o.getId(),d,e=b.getConfiguration().getCalendarType(),w=l.getDaysStandAlone("abbreviated",e),W=l.getDaysStandAlone("wide",e),D;r.openStart("div",s+"-Names");r.class("sapMSPCMonthDayNames");r.openEnd();for(var i=0;i<7;i++){D=(i+f)%7;d=s+"-WH"+D;r.openStart("div",d);r.class("sapUiCalWH");if(i===0){r.class("sapUiCalFirstWDay");}r.accessibilityState(null,{role:"columnheader",label:W[D]});r.openEnd();r.text(w[D%7]);r.close("div");}r.close("div");};
S.renderDndPlaceholder=function(r,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();r.renderControl(p);r.close("div");};
return S;},true);
},
	"sap/m/SinglePlanningCalendarMonthView.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate'],function(l,S,C,a){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarMonthView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 1;};
b.prototype.getScrollEntityCount=function(s,o){var n=a.fromLocalJSDate(s),m=s.getMonth()+o,i=o>0?1:-1;n.setMonth(m);while((m+12)%12!==n.getMonth()){n.setDate(n.getDate()-i);}return Math.abs(C._daysBetween(n,a.fromLocalJSDate(s)));};
b.prototype.calculateStartDate=function(s){var r=C.getFirstDateOfMonth(C._createUTCDate(s,true)).getJSDate();return C._createLocalDate(r,true);};
return b;});
},
	"sap/m/SinglePlanningCalendarWeekView.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils'],function(l,S,C,a){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarWeekView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 7;};
b.prototype.getScrollEntityCount=function(){return 7;};
b.prototype.calculateStartDate=function(s){var c=C.fromLocalJSDate(s),o=a._getFirstDateOfWeek(c);return o.toLocalJSDate();};
return b;});
},
	"sap/m/SinglePlanningCalendarWorkWeekView.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['./library','./SinglePlanningCalendarView','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/LocaleData'],function(l,S,C,a,L){"use strict";
var b=S.extend("sap.m.SinglePlanningCalendarWorkWeekView",{metadata:{library:"sap.m"}});
b.prototype.getEntityCount=function(){return 5;};
b.prototype.getScrollEntityCount=function(){return 7;};
b.prototype.calculateStartDate=function(s){var c=C.fromLocalJSDate(s),o=a._getFirstDateOfWeek(c),d=this._getFormatSettingsLocaleData();if(o.getDay()===d.getWeekendEnd()){o.setDate(o.getDate()+1);}return o.toLocalJSDate();};
b.prototype._getFormatSettingsLocaleData=function(){return L.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale());};
return b;});
},
	"sap/m/UploadCollection.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(["./library","sap/m/library","sap/m/MessageBox","sap/m/Dialog","sap/ui/core/Control","sap/ui/core/Icon","sap/ui/core/IconPool","sap/m/Image","sap/m/Text","sap/m/Title","sap/m/Button","sap/m/List","sap/m/BusyIndicator","sap/m/StandardListItem","sap/ui/unified/FileUploaderParameter","sap/ui/unified/FileUploader","sap/ui/core/format/FileSizeFormat","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/m/ObjectAttribute","sap/m/UploadCollectionItem","sap/m/UploadCollectionParameter","sap/m/UploadCollectionToolbarPlaceholder","sap/ui/core/HTML","sap/m/CustomListItem","sap/ui/core/ResizeHandler","sap/ui/Device","./UploadCollectionRenderer","sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes","sap/base/Log","sap/ui/dom/jquery/selectText"],function(L,M,a,D,C,I,b,c,T,d,B,f,g,S,F,h,k,O,l,m,U,n,o,H,p,R,q,r,Q,K,s){"use strict";
var t=C.extend("sap.m.UploadCollection",{
constructor:function(i,j){var u;if(j&&j.instantUpload!==undefined){if(j.instantUpload===false){u=j.instantUpload;}delete j.instantUpload;}else if(i&&i.instantUpload!==undefined){if(i.instantUpload===false){u=i.instantUpload;}delete i.instantUpload;}if(j&&j.mode===L.ListMode.MultiSelect&&u===false){j.mode=L.ListMode.None;s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}else if(i&&i.mode===L.ListMode.MultiSelect&&u===false){i.mode=L.ListMode.None;s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Upload Pending scenario. Value has been resetted to 'None'");}try{C.apply(this,arguments);if(u===false){this.bInstantUpload=u;this._oFormatDecimal=k.getInstance({binaryFilesize:true,maxFractionDigits:1,maxIntegerDigits:4});}}catch(e){this.destroy();throw e;}},
metadata:{library:"sap.m",properties:{fileType:{type:"string[]",group:"Data",defaultValue:null},maximumFilenameLength:{type:"int",group:"Data",defaultValue:null},maximumFileSize:{type:"float",group:"Data",defaultValue:null},mimeType:{type:"string[]",group:"Data",defaultValue:null},multiple:{type:"boolean",group:"Behavior",defaultValue:false},noDataText:{type:"string",group:"Appearance",defaultValue:null},noDataDescription:{type:"string",group:"Appearance",defaultValue:null},sameFilenameAllowed:{type:"boolean",group:"Behavior",defaultValue:false},showSeparators:{type:"sap.m.ListSeparators",group:"Appearance",defaultValue:"All"},uploadEnabled:{type:"boolean",group:"Behavior",defaultValue:true},uploadUrl:{type:"string",group:"Data",defaultValue:"../../../upload"},instantUpload:{type:"boolean",group:"Behavior",defaultValue:true},numberOfAttachmentsText:{type:"string",group:"Appearance",defaultValue:null},mode:{type:"sap.m.ListMode",group:"Behavior",defaultValue:"None"},uploadButtonInvisible:{type:"boolean",group:"Appearance",defaultValue:false},terminationEnabled:{type:"boolean",group:"Behavior",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.UploadCollectionItem",multiple:true,singularName:"item",bindable:"bindable"},headerParameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"headerParameter"},parameters:{type:"sap.m.UploadCollectionParameter",multiple:true,singularName:"parameter"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},infoToolbar:{type:"sap.m.Toolbar",multiple:false,forwarding:{idSuffix:"-list",aggregation:"infoToolbar"}},_list:{type:"sap.m.List",multiple:false,visibility:"hidden"},_noDataIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_dragDropIcon:{type:"sap.ui.core.Icon",multiple:false,visibility:"hidden"},_dragDropText:{type:"sap.m.Text",multiple:false,visibility:"hidden"}},events:{change:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileDeleted:{parameters:{documentId:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},filenameLengthExceed:{parameters:{documentId:{type:"string"},files:{type:"object[]"}}},fileRenamed:{parameters:{documentId:{type:"string"},fileName:{type:"string"},item:{type:"sap.m.UploadCollectionItem"}}},fileSizeExceed:{parameters:{documentId:{type:"string"},fileSize:{type:"string"},files:{type:"object[]"}}},typeMissmatch:{parameters:{documentId:{type:"string"},fileType:{type:"string"},mimeType:{type:"string"},files:{type:"object[]"}}},uploadComplete:{parameters:{readyStateXHR:{type:"string"},response:{type:"string"},status:{type:"string"},files:{type:"object[]"}}},uploadTerminated:{parameters:{fileName:{type:"string"},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},beforeUploadStarts:{parameters:{fileName:{type:"string"},addHeaderParameter:{type:"function",parameters:{headerParameter:{type:"sap.m.UploadCollectionParameter"}}},getHeaderParameter:{type:"function",parameters:{headerParameterName:{type:"string"}}}}},selectionChange:{parameters:{selectedItem:{type:"sap.m.UploadCollectionItem"},selectedItems:{type:"sap.m.UploadCollectionItem[]"},selected:{type:"boolean"}}}}}
});
t._uploadingStatus="uploading";t._displayStatus="display";t._toBeDeletedStatus="toBeDeleted";t._pendingUploadStatus="pendingUploadStatus";t._placeholderCamera="sap-icon://card";t._markerMargin=8;if(q.system.phone){t._resizeTimeoutInterval=500;}else{t._resizeTimeoutInterval=100;}
t.prototype.init=function(){t.prototype._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._headerParamConst={requestIdName:"requestId"+Q.now(),fileNameRequestIdName:"fileNameRequestId"+Q.now(),acceptLanguage:"accept-language"};this._requestIdValue=0;this._iFUCounter=0;this._oList=new f(this.getId()+"-list",{selectionChange:[this._handleSelectionChange,this],noDataText:this.getNoDataText()});this.setAggregation("_list",this._oList,true);this._oList.addStyleClass("sapMUCList");this.setAggregation("_noDataIcon",new I(this.getId()+"-no-data-icon",{src:"sap-icon://document",size:"6rem",noTabStop:true}),true);this.setAggregation("_dragDropIcon",new I(this.getId()+"-drag-drop-icon",{src:"sap-icon://upload-to-cloud",size:"4rem",noTabStop:true}),true);this.setAggregation("_dragDropText",new T(this.getId()+"-drag-drop-text",{text:this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR")}),true);this._iUploadStartCallCounter=0;this.aItems=[];this._aDeletedItemForPendingUpload=[];this._aFileUploadersForPendingUpload=[];this._aFilesFromDragAndDropForPendingUpload=[];this._iFileUploaderPH=null;this._oListEventDelegate=null;this._oItemToUpdate=null;this._sReziseHandlerId=null;};
t.prototype.setFileType=function(e){if(!e){return this;}if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change fileType at runtime.");}else{var j=e.length;for(var i=0;i<j;i++){e[i]=e[i].toLowerCase();}if(this.getFileType()!==e){this.setProperty("fileType",e,true);this._getFileUploader().setFileType(e);}}return this;};
t.prototype.setMaximumFilenameLength=function(i){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change maximumFilenameLength at runtime.");}else if(this.getMaximumFilenameLength()!==i){this.setProperty("maximumFilenameLength",i,true);this._getFileUploader().setMaximumFilenameLength(i);}return this;};
t.prototype.setMaximumFileSize=function(i){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change maximumFileSize at runtime.");}else if(this.getMaximumFileSize()!==i){this.setProperty("maximumFileSize",i,true);this._getFileUploader().setMaximumFileSize(i);}return this;};
t.prototype.setMimeType=function(e){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change mimeType at runtime.");}else if(this.getMimeType()!==e){this.setProperty("mimeType",e,true);this._getFileUploader().setMimeType(e);}return this;};
t.prototype.setMultiple=function(e){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change multiple at runtime.");}else if(this.getMultiple()!==e){this.setProperty("multiple",e);this._getFileUploader().setMultiple(e);}return this;};
t.prototype.setShowSeparators=function(e){if(this.getShowSeparators()!==e){this.setProperty("showSeparators",e);this._oList.setShowSeparators(e);}return this;};
t.prototype.setUploadEnabled=function(u){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change uploadEnabled at runtime.");}else if(this.getUploadEnabled()!==u){this.setProperty("uploadEnabled",u);this._getFileUploader().setEnabled(u);}return this;};
t.prototype.setUploadUrl=function(u){if(!this.getInstantUpload()){s.info("As property instantUpload is false it is not allowed to change uploadUrl at runtime.");}else if(this.getUploadUrl()!==u){this.setProperty("uploadUrl",u);this._getFileUploader().setUploadUrl(u);}return this;};
t.prototype.setInstantUpload=function(){s.error("It is not supported to change the behavior at runtime.");return this;};
t.prototype.setMode=function(e){if(e===L.ListMode.Delete){this._oList.setMode(L.ListMode.None);s.info("sap.m.ListMode.Delete is not supported by UploadCollection. Value has been resetted to 'None'");}else if(e===L.ListMode.MultiSelect&&!this.getInstantUpload()){this._oList.setMode(L.ListMode.None);s.info("sap.m.ListMode.MultiSelect is not supported by UploadCollection for Pending Upload. Value has been resetted to 'None'");}else{this._oList.setMode(e);}return this;};
t.prototype.getMode=function(){return this._oList.getMode();};
t.prototype.getToolbar=function(){return this._oHeaderToolbar;};
t.prototype.getNoDataText=function(){var N=this.getProperty("noDataText");N=N||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_TEXT");return N;};
t.prototype.getNoDataDescription=function(){var N=this.getProperty("noDataDescription");N=N||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_DESCRIPTION");return N;};
t.prototype.setNoDataText=function(N){this.setProperty("noDataText",N,true);this.$().find("#"+this.getId()+"-no-data-text").text(N);this._oList.setNoDataText(N);return this;};
t.prototype.setUploadButtonInvisible=function(u){if(this.getUploadButtonInvisible()===u){return this;}this.setProperty("uploadButtonInvisible",u,true);if(this.getInstantUpload()){this._getFileUploader().setVisible(!u);}else{this._setFileUploaderVisibility(u);}if(this._bDragDropEnabled){this._unbindDragEnterLeave();this._bDragDropEnabled=false;}else{this._bindDragEnterLeave();}return this;};
t.prototype.getInternalRequestHeaderNames=function(){return[this._headerParamConst.fileNameRequestIdName,this._headerParamConst.requestIdName];};
t.prototype.upload=function(){if(this.getInstantUpload()){s.error("Not a valid API call. 'instantUpload' should be set to 'false'.");}var e=this._aFileUploadersForPendingUpload.length;for(var i=0;i<e;i++){this._iUploadStartCallCounter=0;if(this._aFileUploadersForPendingUpload[i].getValue()){this._aFileUploadersForPendingUpload[i].upload();}}if(this._aFilesFromDragAndDropForPendingUpload.length>0){this._oFileUploader._sendFilesFromDragAndDrop(this._aFilesFromDragAndDropForPendingUpload);this._aFilesFromDragAndDropForPendingUpload=[];}};
t.prototype.getSelectedItems=function(){var e=this._oList.getSelectedItems();return this._getUploadCollectionItemsByListItems(e);};
t.prototype.getSelectedItem=function(){var e=this._oList.getSelectedItem();if(e){return this._getUploadCollectionItemByListItem(e);}return null;};
t.prototype.setSelectedItemById=function(i,e){this._oList.setSelectedItemById(i+"-cli",e);this._setSelectedForItems([this._getUploadCollectionItemById(i)],e);return this;};
t.prototype.setSelectedItem=function(u,e){return this.setSelectedItemById(u.getId(),e);};
t.prototype.selectAll=function(){var e=this._oList.selectAll();if(e.getItems().length!==this.getItems().length){s.info("Internal 'List' and external 'UploadCollection' are not in sync.");}this._setSelectedForItems(this.getItems(),true);return this;};
t.prototype.downloadItem=function(u,e){if(!this.getInstantUpload()){s.info("Download is not possible on Pending Upload mode");return false;}else{return u.download(e);}};
t.prototype.openFileDialog=function(i){if(this._oFileUploader){if(i){if(!this._oFileUploader.getMultiple()){this._oItemToUpdate=i;this._oFileUploader.$().find("input[type=file]").trigger("click");}else{s.warning("Version Upload cannot be used in multiple upload mode");}}else{this._oFileUploader.$().find("input[type=file]").trigger("click");}}return this;};
t.prototype.removeAggregation=function(A,v,e){var i,j,u;if(!this.getInstantUpload()&&A==="items"&&v){i=v._internalFileIdWithinDragDropArray;if(i){j=this._aFilesFromDragAndDropForPendingUpload.indexOf(i);if(j!==-1){this._aFilesFromDragAndDropForPendingUpload.splice(j,1);}}else if(Q.isNumeric(v)){u=this.getItems();this._aDeletedItemForPendingUpload.push(u[v]);}else{this._aDeletedItemForPendingUpload.push(v);}}return C.prototype.removeAggregation.apply(this,arguments);};
t.prototype.removeAllAggregation=function(A,e){if(!this.getInstantUpload()&&A==="items"){if(this._aFileUploadersForPendingUpload){for(var i=0;i<this._aFileUploadersForPendingUpload.length;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=[];}}return C.prototype.removeAllAggregation.apply(this,arguments);};
t.prototype.onBeforeRendering=function(){this._RenderManager=this._RenderManager||sap.ui.getCore().createRenderManager();var i,e;if(this._oListEventDelegate){this._oList.removeEventDelegate(this._oListEventDelegate);this._oListEventDelegate=null;}this._deregisterSizeHandler();this._unbindDragEnterLeave();j.bind(this)();if(!this.getInstantUpload()){this.aItems=this.getItems();this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setHeaderToolbar(this._oHeaderToolbar);return;}if(this.aItems.length>0){e=this.aItems.length;var u=[];for(i=0;i<e;i++){if(this.aItems[i]&&this.aItems[i]._status===t._uploadingStatus){u.push(this.aItems[i]);}else if(this.aItems[i]&&this.aItems[i]._status!==t._uploadingStatus&&this.aItems[i]._percentUploaded===100&&this.getItems().length===0){u.push(this.aItems[i]);}}if(u.length!==0){this.aItems=[];this.aItems=this.getItems();this.aItems=u.concat(this.aItems);}else{this.aItems=this.getItems();}}else{this.aItems=this.getItems();}this._getListHeader(this.aItems.length);this._clearList();this._fillList(this.aItems);this._oList.setAggregation("headerToolbar",this._oHeaderToolbar,true);if(this.sErrorState!=="Error"){if(this.getUploadEnabled()!==this._oFileUploader.getEnabled()){this._oFileUploader.setEnabled(this.getUploadEnabled());}}else{this._oFileUploader.setEnabled(false);}if(this.sDeletedItemId){Q(document.activeElement).trigger("blur");}function j(){if(this.bInstantUpload===false){this.setProperty("instantUpload",this.bInstantUpload,true);delete this.bInstantUpload;}}};
t.prototype.onAfterRendering=function(){this._bindDragEnterLeave();if(this.getInstantUpload()){if(this.aItems||(this.aItems===this.getItems())){if(this.editModeItem){var $=Q(document.getElementById(this.editModeItem+"-ta_editFileName-inner"));if($){var i=this.editModeItem;if(!q.os.ios){$.on("focus",function(){$.selectText(0,$.val().length);});}$.trigger("focus");this._oListEventDelegate={onclick:function(e){this._handleClick(e,i);}.bind(this)};this._oList.addDelegate(this._oListEventDelegate);}}else if(this.sFocusId){this._setFocusToLineItem(this.sFocusId);this.sFocusId=null;}else if(this.sDeletedItemId){this._setFocusAfterDeletion();}}}else if(this.sFocusId){this._setFocusToLineItem(this.sFocusId);this.sFocusId=null;}};
t.prototype.exit=function(){var i,P,e;this._unbindDragEnterLeave();if(this._$RootNode){this._$RootNode=null;}if(this._oFileUploader){this._oFileUploader.destroy();this._oFileUploader=null;}if(this._oHeaderToolbar){this._oHeaderToolbar.destroy();this._oHeaderToolbar=null;}if(this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle.destroy();this._oNumberOfAttachmentsTitle=null;}if(this._RenderManager){this._RenderManager.destroy();}if(this._aFileUploadersForPendingUpload){P=this._aFileUploadersForPendingUpload.length;for(i=0;i<P;i++){this._aFileUploadersForPendingUpload[i].destroy();this._aFileUploadersForPendingUpload[i]=null;}this._aFileUploadersForPendingUpload=null;}for(i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===t._uploadingStatus){e=this.aItems.splice(i,1)[0];if(e.destroy){e.destroy();}}}this._deregisterSizeHandler();};
t.prototype._bindDragEnterLeave=function(){this._bDragDropEnabled=this._isDragAndDropAllowed();if(!this._bDragDropEnabled){return;}if(!this._oDragDropHandler){this._oDragDropHandler={dragEnterUIArea:this._onDragEnterUIArea.bind(this),dragLeaveUIArea:this._onDragLeaveUIArea.bind(this),dragOverUIArea:this._onDragOverUIArea.bind(this),dropOnUIArea:this._onDropOnUIArea.bind(this),dragEnterUploadCollection:this._onDragEnterUploadCollection.bind(this),dragLeaveUploadCollection:this._onDragLeaveUploadCollection.bind(this),dragOverUploadCollection:this._onDragOverUploadCollection.bind(this),dropOnUploadCollection:this._onDropOnUploadCollection.bind(this)};}this._$RootNode=Q(document.body);this._$RootNode.on("dragenter",this._oDragDropHandler.dragEnterUIArea);this._$RootNode.on("dragleave",this._oDragDropHandler.dragLeaveUIArea);this._$RootNode.on("dragover",this._oDragDropHandler.dragOverUIArea);this._$RootNode.on("drop",this._oDragDropHandler.dropOnUIArea);this._$DragDropArea=this.$("drag-drop-area");this.$().on("dragenter",this._oDragDropHandler.dragEnterUploadCollection);this.$().on("dragleave",this._oDragDropHandler.dragLeaveUploadCollection);this.$().on("dragover",this._oDragDropHandler.dragOverUploadCollection);this.$().on("drop",this._oDragDropHandler.dropOnUploadCollection);};
t.prototype._unbindDragEnterLeave=function(){if(!this._bDragDropEnabled&&!this._oDragDropHandler){return;}if(this._$RootNode){this._$RootNode.off("dragenter",this._oDragDropHandler.dragEnterUIArea);this._$RootNode.off("dragleave",this._oDragDropHandler.dragLeaveUIArea);this._$RootNode.off("dragover",this._oDragDropHandler.dragOverUIArea);this._$RootNode.off("drop",this._oDragDropHandler.dropOnUIArea);}this.$().off("dragenter",this._oDragDropHandler.dragEnterUploadCollection);this.$().off("dragleave",this._oDragDropHandler.dragLeaveUploadCollection);this.$().off("dragover",this._oDragDropHandler.dragOverUploadCollection);this.$().off("drop",this._oDragDropHandler.dropOnUploadCollection);};
t.prototype._onDragEnterUIArea=function(e){if(!this._checkForFiles(e)){return;}this._oLastEnterUIArea=e.target;this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");this._adjustDragDropIcon();};
t.prototype._onDragOverUIArea=function(e){e.preventDefault();if(!this._checkForFiles(e)){return;}this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");};
t.prototype._onDragLeaveUIArea=function(e){if(this._oLastEnterUIArea===e.target){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
t.prototype._onDropOnUIArea=function(e){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");};
t.prototype._onDragEnterUploadCollection=function(e){if(!this._checkForFiles(e)){return;}if(e.target===this._$DragDropArea[0]){this._$DragDropArea.addClass("sapMUCDropIndicator");this._adjustDragDropIcon();this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DROP_FILE_INDICATOR"));}};
t.prototype._onDragOverUploadCollection=function(e){e.preventDefault();e.originalEvent.dataTransfer.dropEffect="copy";};
t.prototype._onDragLeaveUploadCollection=function(e){if(e.target===this._$DragDropArea[0]){this._$DragDropArea.removeClass("sapMUCDropIndicator");this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR"));}};
t.prototype._checkForFiles=function(e){var j=e.originalEvent.dataTransfer.types;if(j){for(var i=0;i<j.length;i++){if(j[i]==="Files"){return true;}}}return false;};
t.prototype._isDragAndDropAllowed=function(){return this.getUploadEnabled()&&!this.getUploadButtonInvisible();};
t.prototype._onDropOnUploadCollection=function(e){if(!this._checkForFiles(e)){e.preventDefault();return;}if(e.target===this._$DragDropArea[0]){e.preventDefault();this._$DragDropArea.removeClass("sapMUCDropIndicator");this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");this.getAggregation("_dragDropText").setText(this._oRb.getText("UPLOADCOLLECTION_DRAG_FILE_INDICATOR"));var j=e.originalEvent.dataTransfer.files;if(j.length>1&&!this.getMultiple()){var u=this._oRb.getText("UPLOADCOLLECTION_MULTIPLE_FALSE");a.error(u);return;}if(!this._oFileUploader._areFilesAllowed(j)){return;}if(!this.getInstantUpload()){for(var i=0;i<j.length;i++){this._oFileUploader.fireChange({files:[j[i]],fromDragDrop:true});this._aFilesFromDragAndDropForPendingUpload.push(j[i]);}}else{this._oFileUploader.fireChange({files:j});this._oFileUploader._sendFilesFromDragAndDrop(j);}}};
t.prototype._adjustDragDropIcon=function(){if(this._$DragDropArea[0].offsetHeight<160){this.getAggregation("_dragDropIcon").$().hide();}};
t.prototype._deregisterSizeHandler=function(){q.orientation.detachHandler(this._onResize,this);R.deregister(this._sReziseHandlerId);};
t.prototype._hideFileUploaders=function(){var e,i;if(!this.getInstantUpload()){e=this._oHeaderToolbar.getContent().length;if(this._aFileUploadersForPendingUpload.length){for(i=0;i<e;i++){if(this._oHeaderToolbar.getContent()[i]instanceof h){if(i===this._iFileUploaderPH&&this._bFocusFileUploader){this._oHeaderToolbar.getContent()[i].$().find("button").trigger("focus");}else{this._oHeaderToolbar.getContent()[i].$().hide();}}}}}};
t.prototype._truncateFileName=function(e){if(!e){return;}if(e._status==="Edit"){e._oListItem.$().find(".sapMUCObjectMarkerContainer").attr("style","display: none");return;}var j=0;var u=e.getMarkers();var v;for(var i=0;i<u.length;i++){j=j+u[i].$().width()+t._markerMargin;}if(j>0){var $=e._oFileNameLink.$();if($){v="max-width: calc(100% - "+j+"px)";if($.attr("style")!==v){$.attr("style",v);}}}};
t.prototype._getListHeader=function(e){var j,i;this._setNumberOfAttachmentsTitle(e);if(!this._oHeaderToolbar){if(!!this._oFileUploader&&!this.getInstantUpload()){this._oFileUploader.destroy();}j=this._getFileUploader();this._oHeaderToolbar=this.getAggregation("toolbar");if(!this._oHeaderToolbar){this._oHeaderToolbar=new O(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new l(),j]}).addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=2;}else{this._oHeaderToolbar.addEventDelegate({onAfterRendering:this._hideFileUploaders},this);this._iFileUploaderPH=this._getFileUploaderPlaceHolderPosition(this._oHeaderToolbar);if(this._oHeaderToolbar&&this._iFileUploaderPH>-1){this._setFileUploaderInToolbar(j);}else{s.info("A place holder of type 'sap.m.UploadCollectionPlaceholder' needs to be provided.");}}}else if(!this.getInstantUpload()){var P=this._aFileUploadersForPendingUpload.length;for(i=P-1;i>=0;i--){if(this._aFileUploadersForPendingUpload[i].getId()===this._oFileUploader.getId()){j=this._getFileUploader();this._oHeaderToolbar.insertAggregation("content",j,this._iFileUploaderPH,true);break;}}}};
t.prototype._getFileUploaderPlaceHolderPosition=function(e){for(var i=0;i<e.getContent().length;i++){if(e.getContent()[i]instanceof o){return i;}}return-1;};
t.prototype._setFileUploaderInToolbar=function(e){this._oHeaderToolbar.getContent()[this._iFileUploaderPH].setVisible(false);this._oHeaderToolbar.insertContent(e,this._iFileUploaderPH);};
t.prototype._mapItemToListItem=function(i){if(!i||(this._oItemToUpdate&&i.getId()===this._oItemToUpdate.getId())){return null;}var e,j,u,v,w,x,$,y,z;e=i.getId();j=i._status;u=i.getFileName();if(j===t._uploadingStatus){v=new g({id:e+"-ia_indicator"});v.addStyleClass("sapMUCloadingIcon");}else{z=this._createIcon(i,e,u);}x=e+"-container";$=Q(document.getElementById(x));if($){$.remove();$=null;}y=new H(x,{content:"<span class='sapMUCTextButtonContainer'></span>",afterRendering:this._renderContent.bind(this,i,x)});w=new p(e+"-cli",{content:[v,z,y],selected:i.getSelected()});w._oUploadCollectionItem=i;w._status=j;w.addStyleClass("sapMUCItem");w.setTooltip(i.getTooltip_Text());i._oListItem=w;return w;};
t.prototype._renderContent=function(e,j){var u,i,A,v,w,P,x,y,z,E,G;P=e._percentUploaded;x=e.getAllAttributes();y=e.getStatuses();G=e.getMarkers();u=e.getId();A=x.length;v=y.length;w=G.length;E=e._status;z=this._RenderManager;z.write("<div class=\"sapMUCTextContainer ");if(E==="Edit"){z.write("sapMUCEditMode ");}z.write("\" >");z.renderControl(this._getFileNameControl(e));if(E===t._uploadingStatus){z.renderControl(this._createProgressLabel(e,P));}else{if(w>0){z.write("<div class=\"sapMUCObjectMarkerContainer\">");for(i=0;i<w;i++){z.renderControl(G[i].addStyleClass("sapMUCObjectMarker"));}z.write("</div>");}if(A>0){z.write("<div class=\"sapMUCAttrContainer\" tabindex=\"0\">");for(i=0;i<A;i++){x[i].addStyleClass("sapMUCAttr");z.renderControl(x[i]);if((i+1)<A){z.write("<div class=\"sapMUCSeparator\">&nbsp&#x00B7&#160</div>");}}z.write("</div>");}if(v>0){z.write("<div class=\"sapMUCStatusContainer\" tabindex=\"0\">");for(i=0;i<v;i++){y[i].detachBrowserEvent("hover");y[i].setTooltip(y[i].getTitle()+":"+y[i].getText());z.renderControl(y[i]);if((i+1)<v){z.write("<div class=\"sapMUCSeparator\">&nbsp&#x00B7&#160</div>");}}z.write("</div>");}}z.write("</div>");this._renderButtons(z,e,E,u);z.flush(Q(document.getElementById(j))[0],true);this._truncateFileName(e);this._sReziseHandlerId=R.register(this,this._onResize.bind(this));q.orientation.attachHandler(this._onResize,this);};
t.prototype._renderButtons=function(e,j,u,v){var w,x;w=this._getButtons(j,u,v);if(w){x=w.length;}if(x>0){e.write("<div class=\"sapMUCButtonContainer\">");for(var i=0;i<x;i++){if((i+1)<x){w[i].addStyleClass("sapMUCFirstButton");}e.renderControl(w[i]);}e.write("</div>");}};
t.prototype._getFileNameControl=function(i){var e,j,u,v,w,x,y,V,z,A,E;v=i.getFileName();w=i.getId();x=i._status;if(x!=="Edit"){e=i._getFileNameLink?i._getFileNameLink():i._getControl("sap.m.Link",{id:w+"-ta_filenameHL",press:[i,this._onItemPressed,this]},"FileNameLink");e.setEnabled(this._getItemPressEnabled(i));e.addStyleClass("sapMUCFileName");e.setModel(i.getModel());e.setText(v);i._oFileNameLink=e;return e;}else{j=t._splitFilename(v);y=this.getMaximumFilenameLength();V="None";z=false;u=j.name;if(i.errorState==="Error"){z=true;V="Error";u=i.changedFileName;if(u.length===0){E=this._oRb.getText("UPLOADCOLLECTION_TYPE_FILENAME");}else{E=this._oRb.getText("UPLOADCOLLECTION_EXISTS");}}A=i._getFileNameEditBox?i._getFileNameEditBox():i._getControl("sap.m.Input",{id:w+"-ta_editFileName",type:L.InputType.Text},"FileNameEditBox");A.addStyleClass("sapMUCEditBox");A.setModel(i.getModel());A.setValue(u);A.setValueState(V);A.setFieldWidth("75%");A.setValueStateText(E);A.setDescription(j.extension);A.setShowValueStateMessage(z);if((y-j.extension.length)>0){A.setProperty("maxLength",y-j.extension.length,true);}return A;}};
t.prototype._getItemPressEnabled=function(i){return i._getPressEnabled()&&this.sErrorState!=="Error";};
t.prototype._onItemPressed=function(e,i){if(i.hasListeners("press")){i.firePress();}else if(this.sErrorState!=="Error"&&Q.trim(i.getProperty("url"))){this._triggerLink(e,i);}};
t.prototype._createProgressLabel=function(i,e){var P,j=i.getId();P=i._getProgressLabel?i._getProgressLabel():i._getControl("sap.m.Label",{id:j+"-ta_progress"},"ProgressLabel").addStyleClass("sapMUCProgress");P.setText(this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[e]));return P;};
t.prototype._createIcon=function(i,e,j){var u,v,w,x;u=i.getThumbnailUrl();if(u){w=b.createControlByURI({id:e+"-ia_imageHL",src:this._getThumbnail(u,j),decorative:false},c).addStyleClass("sapMUCItemImage sapMUCItemIcon");w.setAlt(this._getAriaLabelForPicture(i));}else{v=this._getThumbnail(undefined,j);w=new I(e+"-ia_iconHL",{src:v,decorative:false,useIconTooltip:false});w.setAlt(this._getAriaLabelForPicture(i));if(this.sErrorState!=="Error"&&Q.trim(i.getProperty("url"))){x="sapMUCItemIcon";}else{x="sapMUCItemIconInactive";}if(v===t._placeholderCamera){if(this.sErrorState!=="Error"&&Q.trim(i.getProperty("url"))){x=x+" sapMUCItemPlaceholder";}else{x=x+" sapMUCItemPlaceholderInactive";}}w.addStyleClass(x);}if(this._getItemPressEnabled(i)){w.attachPress(i,this._onItemPressed,this);}return w;};
t.prototype._getButtons=function(i,e,j){var u,v,w,x,y,E,z;u=[];if(!this.getInstantUpload()){x="deleteButton";y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);return u;}if(e==="Edit"){v=i._getOkButton?i._getOkButton():i._getControl("sap.m.Button",{id:j+"-okButton",text:this._oRb.getText("UPLOADCOLLECTION_RENAMEBUTTON_TEXT"),type:L.ButtonType.Transparent},"OkButton").addStyleClass("sapMUCOkBtn");w=i._getCancelButton?i._getCancelButton():i._getControl("sap.m.Button",{id:j+"-cancelButton",text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),type:L.ButtonType.Transparent},"CancelButton").addStyleClass("sapMUCCancelBtn");u.push(v);u.push(w);}else if(e===t._uploadingStatus){x="terminateButton";y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);}else{E=i.getEnableEdit();if(this.sErrorState==="Error"){E=false;}if(i.getVisibleEdit()){z=i._getEditButton?i._getEditButton():i._getControl("sap.m.Button",{id:j+"-editButton",icon:"sap-icon://edit",type:L.ButtonType.Standard,tooltip:this._oRb.getText("UPLOADCOLLECTION_EDITBUTTON_TEXT"),press:[i,this._handleEdit,this]},"EditButton").addStyleClass("sapMUCEditBtn");z.setEnabled(E);z.setVisible(i.getVisibleEdit());u.push(z);}x="deleteButton";if(i.getVisibleDelete()){y=this._createDeleteButton(j,x,i,this.sErrorState);u.push(y);}}return u;};
t.prototype._createDeleteButton=function(i,e,j,u){var E,v,G,w,x,V,P;E=j.getEnableDelete();if(u==="Error"){E=false;}if(e==="deleteButton"){G="DeleteButton";x=j._getDeleteButton;w=this._oRb.getText("UPLOADCOLLECTION_DELETEBUTTON_TEXT");V=j.getVisibleDelete();P=[this,this._handleDelete,this];}else{G="TerminateButton";x=j._getTerminateButton;w=this._oRb.getText("UPLOADCOLLECTION_TERMINATEBUTTON_TEXT");V=this.getTerminationEnabled();P=[j,this._handleTerminate,this];}v=x?x():j._getControl("sap.m.Button",{id:i+"-"+e,icon:"sap-icon://decline",type:L.ButtonType.Standard,press:P},G).addStyleClass("sapMUCDeleteBtn");v.setVisible(V);v.setEnabled(E);v.setTooltip(w);return v;};
t.prototype._fillList=function(i){var e=this,j=i.length-1,u=this.getBinding("items"),G=false,v,w=this.getBindingInfo("items")?this.getBindingInfo("items").model:undefined,x=this.getBindingInfo("items")?this.getBindingInfo("items").groupHeaderFactory:null;var y=function(A){return A.getBindingContext(w)?u.getGroup(A.getBindingContext(w)):null;};var z=function(A){return y(A)&&y(A).key;};Q.each(i,function(A,E){if(u&&u.isGrouped()&&E){if(!G||v!==z(E)){if(x){e._oList.addItemGroup(y(E),x(y(E)),true);}else if(y(E)){e._oList.addItemGroup(y(E),null,true);}G=true;v=z(E);}}if(!E._status||!E.getVisibleEdit()){E._status=t._displayStatus;}else if(e.getInstantUpload()&&e._oItemForDelete&&e._oItemForDelete._status===t._toBeDeletedStatus&&E.getDocumentId()===e._oItemForDelete.documentId){return false;}if(!E._percentUploaded&&E._status===t._uploadingStatus){E._percentUploaded=0;}var J=e._mapItemToListItem(E);if(J){if(A===0&&j===0){J.addStyleClass("sapMUCListSingleItem");}else if(A===0){J.addStyleClass("sapMUCListFirstItem");}else if(A===j){J.addStyleClass("sapMUCListLastItem");}else{J.addStyleClass("sapMUCListItem");}e._oList.addAggregation("items",J,true);E.attachEvent("selected",e._handleItemSetSelected,e);}return true;});};
t.prototype._clearList=function(){if(this._oList){this._oList.destroyAggregation("items",true);}};
t.prototype._setNumberOfAttachmentsTitle=function(e){var i=e||0;var j;if(this._oItemToUpdate){i--;}if(this.getNumberOfAttachmentsText()){j=this.getNumberOfAttachmentsText();}else{j=this._oRb.getText("UPLOADCOLLECTION_ATTACHMENTS",[i]);}if(!this._oNumberOfAttachmentsTitle){this._oNumberOfAttachmentsTitle=new d(this.getId()+"-numberOfAttachmentsTitle",{text:j});}else{this._oNumberOfAttachmentsTitle.setText(j);}};
t.prototype._setFileUploaderVisibility=function(u){var e=this._oHeaderToolbar.getContent();if(e){var P=e[this._iFileUploaderPH];if(P instanceof h){P.setVisible(!u);}}};
t.prototype._handleDelete=function(e){var P=e.getParameters();var j=this.getItems();var u=P.id.split("-deleteButton")[0];var v;var w;var x="";var y;var z;for(var i=0;i<j.length;i++){if(j[i].sId===u){w=i;v={documentId:j[i].getDocumentId(),_iLineNumber:w};break;}}if(j[w].hasListeners("deletePress")){j[w].fireDeletePress();return;}this.sDeletedItemId=u;if(Q(document.getElementById(this.sId)).hasClass("sapUiSizeCompact")){x="sapUiSizeCompact";}if(this.editModeItem){this._handleOk(e,this.editModeItem,true);if(this.sErrorState==="Error"){return;}}if(j[w]&&j[w].getEnableDelete()){y=j[w].getFileName();if(!y){z=this._oRb.getText("UPLOADCOLLECTION_DELETE_WITHOUT_FILENAME_TEXT");}else{z=this._oRb.getText("UPLOADCOLLECTION_DELETE_TEXT",y);}this._oItemForDelete=v;a.show(z,{title:this._oRb.getText("UPLOADCOLLECTION_DELETE_TITLE"),actions:[a.Action.OK,a.Action.CANCEL],onClose:this._onCloseMessageBoxDeleteItem.bind(this),dialogId:"messageBoxDeleteFile",styleClass:x});}};
t.prototype._onCloseMessageBoxDeleteItem=function(e){var j=this.getItems();var u;if(this.getInstantUpload()){for(var i=0;i<j.length;i++){if(j[i].getDocumentId()===this._oItemForDelete.documentId){u=j[i];}}}else{u=j[this._oItemForDelete._iLineNumber];}if(e===a.Action.OK){this._oItemForDelete._status=t._toBeDeletedStatus;if(this.getInstantUpload()){this.fireFileDeleted({documentId:this._oItemForDelete.documentId,item:u});this._oItemForDelete=null;}else{if(this.aItems.length===1){if(!this.getUploadButtonInvisible()){this.sFocusId=this._oFileUploader.$().find(":button")[0].id;}}else if(this._oItemForDelete._iLineNumber<this.aItems.length-1){this.sFocusId=this.aItems[this._oItemForDelete._iLineNumber+1].getId()+"-cli";}else{this.sFocusId=this.aItems[0].getId()+"-cli";}this._aDeletedItemForPendingUpload.push(u);this.aItems.splice(this._oItemForDelete._iLineNumber,1);this.removeAggregation("items",u,false);}}};
t.prototype._handleTerminate=function(e,j){var u,v;u=new f({items:[new S({icon:this._getIconFromFilename(j.getFileName())})]});u.getItems()[0].setTitle(j.getFileName());v=new D({id:this.getId()+"deleteDialog",title:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TITLE"),content:[new T({text:this._oRb.getText("UPLOADCOLLECTION_TERMINATE_TEXT")}),u],buttons:[new B({text:this._oRb.getText("UPLOADCOLLECTION_OKBUTTON_TEXT"),press:[w,this]}),new B({text:this._oRb.getText("UPLOADCOLLECTION_CANCELBUTTON_TEXT"),press:function(){v.close();}})],afterClose:function(){v.destroy();}}).open();function w(){var A=false;for(var i=0;i<this.aItems.length;i++){if(this.aItems[i]._status===t._uploadingStatus&&this.aItems[i]._requestIdName===j._requestIdName){this.aItems[i]._status=t._toBeDeletedStatus;this._oItemForDelete=this.aItems[i];A=true;break;}else if(j.getFileName()===this.aItems[i].getFileName()&&this.aItems[i]._status===t._displayStatus){this.aItems[i]._status=t._toBeDeletedStatus;this._oItemForDelete=this.aItems[i];this.fireFileDeleted({documentId:this.aItems[i].getDocumentId(),item:this.aItems[i]});break;}}if(A){this._getFileUploader().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(j.getFileName())+this._oItemForDelete._requestIdName);}v.close();this.invalidate();}};
t.prototype._handleEdit=function(e,j){var i,u=j.getId(),v=this.aItems.length;if(this.editModeItem){this._handleOk(e,this.editModeItem,false);}if(this.sErrorState!=="Error"){for(i=0;i<v;i++){if(this.aItems[i].getId()===u){this.aItems[i]._status="Edit";break;}}j._status="Edit";this.editModeItem=e.getSource().getId().split("-editButton")[0];this.invalidate();}};
t.prototype._handleClick=function(e,i){var $=Q(e.target).closest("button");var j="";if($.length){j=$.prop("id");}if(j.lastIndexOf("editButton")===-1){if(j.lastIndexOf("cancelButton")!==-1){this._handleCancel(e,i);}else if(e.target.id.lastIndexOf("ia_imageHL")<0&&e.target.id.lastIndexOf("ia_iconHL")<0&&e.target.id.lastIndexOf("deleteButton")<0&&e.target.id.lastIndexOf("ta_editFileName-inner")<0){if(e.target.id.lastIndexOf("cli")>0){this.sFocusId=e.target.id;}this._handleOk(e,i,true);}}};
t.prototype._handleOk=function(e,i,j){var E=document.getElementById(i+"-ta_editFileName-inner");var N;var u=t._findById(i,this.aItems);var v=u.getProperty("fileName");var w=t._splitFilename(v);var x=sap.ui.getCore().byId(i+"-ta_editFileName");var y=u.errorState;var z=u.changedFileName;if(E!==null){N=E.value.replace(/^\s+/,"");}this.sFocusId=i+"-cli";if(!N||N.length===0){if(E!==null){this._setErrorStateOnItem(this,u,N,z,y);}return;}u._status=t._displayStatus;if(w.name===N){this._removeErrorStateFromItem(this,u);if(j){this.invalidate();}return;}if(this.getSameFilenameAllowed()){this._removeErrorStateFromItem(this,u);this._oItemForRename=u;this._onEditItemOk.bind(this)(N+w.extension);return;}if(t._checkDoubleFileName(N+w.extension,this.aItems)){x.setProperty("valueState","Error",true);this._setErrorStateOnItem(this,u,N,z,y);}else{x.setProperty("valueState","None",true);u.changedFileName=null;this._removeErrorStateFromItem(this,u);if(j){this.invalidate();}this._oItemForRename=u;this._onEditItemOk.bind(this)(N+w.extension);}};
t.prototype._setErrorStateOnItem=function(e,i,N,j,E){i._status="Edit";i.errorState="Error";e.sErrorState="Error";i.changedFileName=N;if(E!=="Error"||j!==N){e.invalidate();}};
t.prototype._removeErrorStateFromItem=function(e,i){i.errorState=null;e.sErrorState=null;e.editModeItem=null;};
t.prototype._onEditItemOk=function(N){if(this._oItemForRename){this._oItemForRename.setFileName(N);this.fireFileRenamed({documentId:this._oItemForRename.getProperty("documentId"),fileName:N,item:this._oItemForRename});}delete this._oItemForRename;};
t.prototype._handleCancel=function(e,i){var j=t._findById(i,this.aItems);j._status=t._displayStatus;j.errorState=null;j.changedFileName=j._getFileNameEditBox().getValue();this.sFocusId=this.editModeItem+"-cli";this.sErrorState=null;this.editModeItem=null;this.invalidate();};
t.prototype._onChange=function(e){if(e){var j,u=e.getParameter("files").length,i,v,w,x,A;if(u===0){return;}this._oFileUploader.removeAllAggregation("headerParameters",true);this.removeAllAggregation("headerParameters",true);this._oFileUploader.removeAllAggregation("parameters",true);this.removeAllAggregation("parameters",true);this.fireChange({getParameter:function(z){if(z){return e.getParameter(z);}return null;},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:e.getParameter("files")});var P=this.getAggregation("parameters");if(P){Q.each(P,function(z,E){var G=new F({name:E.getProperty("name"),value:E.getProperty("value")});this._oFileUploader.addParameter(G);}.bind(this));}if(!this.getInstantUpload()){this._bFocusFileUploader=true;w=t._pendingUploadStatus;}else{w=t._uploadingStatus;}this._requestIdValue++;j=this._requestIdValue.toString();var y=this.getAggregation("headerParameters");if(!this.getInstantUpload()){this._aFileUploadersForPendingUpload.push(this._oFileUploader);}for(i=0;i<u;i++){v=new U();v.setFileName(e.getParameter("files")[i].name);if(e.getParameter("fromDragDrop")){v._internalFileIdWithinDragDropArray=e.getParameter("files")[i];}v._status=w;v._internalFileIndexWithinFileUploader=i+1;v._requestIdName=j;if(!this.getInstantUpload()){v.setAssociation("fileUploader",this._oFileUploader,true);x=this._oFormatDecimal.format(e.getParameter("files")[i].size);A=new m({text:x});v.insertAggregation("attributes",A,true);this.insertItem(v);}else{v._percentUploaded=0;}this.aItems.unshift(v);}if(y){Q.each(y,function(z,E){this._oFileUploader.addHeaderParameter(new F({name:E.getProperty("name"),value:E.getProperty("value")}));}.bind(this));}this._oFileUploader.addHeaderParameter(new F({name:this._headerParamConst.requestIdName,value:j}));}};
t.prototype._onFilenameLengthExceed=function(e){var i={name:e.getParameter("fileName")};var j=[i];this.fireFilenameLengthExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:j});};
t.prototype._onFileSizeExceed=function(e){var i={name:e.getParameter("fileName"),fileSize:e.getParameter("fileSize")};this.fireFileSizeExceed({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:[i]});};
t.prototype._onTypeMissmatch=function(e){var i={name:e.getParameter("fileName"),fileType:e.getParameter("fileType"),mimeType:e.getParameter("mimeType")};var j=[i];this.fireTypeMissmatch({getParameter:function(P){if(P){return e.getParameter(P);}},getParameters:function(){return e.getParameters();},mParameters:e.getParameters(),files:j});};
t.prototype._onUploadTerminated=function(e){var i;var j=this._getRequestId(e);var u=e.getParameter("fileName");var v=this.aItems.length;for(i=0;i<v;i++){if(this.aItems[i]&&this.aItems[i].getFileName()===u&&this.aItems[i]._requestIdName===j&&(this.aItems[i]._status===t._uploadingStatus||this.aItems[i]._status===t._toBeDeletedStatus)){if(this.getItems()&&this.getItems()[i]===this.aItems[i]){this.removeItem(i);}this.aItems.splice(i,1);break;}}this.fireUploadTerminated({fileName:u,getHeaderParameter:this._getHeaderParameterWithinEvent.bind(e)});};
t.prototype._onUploadComplete=function(e){if(e){var i,j=this._getRequestId(e),u=e.getParameter("fileName"),v=e.getParameter("id"),w,x,y,z=A();w=this.aItems.length;y=[t._uploadingStatus,t._pendingUploadStatus];for(i=0;i<w;i++){if((!j||this.aItems[i]._requestIdName===j)&&this.aItems[i].getProperty("fileName")===u&&(y.indexOf(this.aItems[i]._status)>=0)){if(z&&this.aItems[i]._status!==t._pendingUploadStatus){this.aItems[i]._percentUploaded=100;this.aItems[i]._status=t._displayStatus;}x=this.aItems.splice(i,1)[0];if(x.destroy){x.destroy();}this._oItemToUpdate=null;break;}}for(i=0;i<this._aFileUploadersForPendingUpload.length;i++){if(this._aFileUploadersForPendingUpload[i].getId()===v){this._aFileUploadersForPendingUpload[i].clear();break;}}this.fireUploadComplete({getParameter:e.getParameter,getParameters:e.getParameters,mParameters:e.getParameters(),files:[{fileName:e.getParameter("fileName")||u,responseRaw:e.getParameter("responseRaw"),reponse:e.getParameter("response"),response:e.getParameter("response"),status:e.getParameter("status"),headers:e.getParameter("headers")}]});}this.invalidate();function A(){var E=e.getParameter("status").toString()||"200";return E[0]==="2"||E[0]==="3";}};
t.prototype._onUploadProgress=function(e){if(!e||!this.getInstantUpload()){return;}var u=e.getParameter("fileName"),P,j=Math.round(e.getParameter("loaded")/e.getParameter("total")*100),v=this._getRequestId(e),w=this.aItems.length,x,$,y;if(j===100){P=this._oRb.getText("UPLOADCOLLECTION_UPLOAD_COMPLETED");}else{P=this._oRb.getText("UPLOADCOLLECTION_UPLOADING",[j]);}for(var i=0;i<w;i++){y=this.aItems[i];if(y.getProperty("fileName")===u&&y._requestIdName===v&&y._status===t._uploadingStatus){x=y._getProgressLabel?y._getProgressLabel():y._getControl("sap.m.Label",{id:y.getId()+"-ta_progress"},"ProgressLabel");if(x){x.setText(P);x.rerender();y._percentUploaded=j;$=Q(document.getElementById(y.getId()+"-ia_indicator"));if(j===100){$.attr("aria-label",P);}else{$.attr("aria-valuenow",j);}break;}}}};
t.prototype._getRequestId=function(e){var i;i=e.getParameter("requestHeaders");if(!i){return null;}for(var j=0;j<i.length;j++){if(i[j].name===this._headerParamConst.requestIdName){return i[j].value;}}return null;};
t.prototype._getFileUploader=function(){var u=this.getInstantUpload();if(!u||!this._oFileUploader){var e=this.getInstantUpload()?this._oRb.getText("UPLOADCOLLECTION_UPLOAD"):this._oRb.getText("UPLOADCOLLECTION_ADD");this._iFUCounter=this._iFUCounter+1;this._oFileUploader=new h(this.getId()+"-"+this._iFUCounter+"-uploader",{buttonOnly:true,buttonText:e,tooltip:e,iconOnly:false,enabled:this.getUploadEnabled(),fileType:this.getFileType(),icon:"",iconFirst:false,style:"Transparent",maximumFilenameLength:this.getMaximumFilenameLength(),maximumFileSize:this.getMaximumFileSize(),mimeType:this.getMimeType(),multiple:this.getMultiple(),name:"uploadCollection",uploadOnChange:u,sameFilenameAllowed:true,uploadUrl:this.getUploadUrl(),useMultipart:false,sendXHR:true,change:[this._onChange,this],filenameLengthExceed:[this._onFilenameLengthExceed,this],fileSizeExceed:[this._onFileSizeExceed,this],typeMissmatch:[this._onTypeMissmatch,this],uploadAborted:[this._onUploadTerminated,this],uploadComplete:[this._onUploadComplete,this],uploadProgress:[this._onUploadProgress,this],uploadStart:[this._onUploadStart,this],visible:!this.getUploadButtonInvisible()});}return this._oFileUploader;};
t.prototype._onUploadStart=function(e){var j,i,u,v,P,w,G;this._iUploadStartCallCounter++;P=e.getParameter("requestHeaders").length;for(i=0;i<P;i++){if(e.getParameter("requestHeaders")[i].name===this._headerParamConst.requestIdName){u=e.getParameter("requestHeaders")[i].value;break;}}w=e.getParameter("fileName");j={name:this._headerParamConst.fileNameRequestIdName,value:this._encodeToAscii(w)+u};e.getParameter("requestHeaders").push(j);v={name:this._headerParamConst.acceptLanguage,value:sap.ui.getCore().getConfiguration().getLanguage()};e.getParameter("requestHeaders").push(v);for(i=0;i<this._aDeletedItemForPendingUpload.length;i++){if(this._aDeletedItemForPendingUpload[i].getAssociation("fileUploader")===e.oSource.sId&&this._aDeletedItemForPendingUpload[i].getFileName()===w&&this._aDeletedItemForPendingUpload[i]._internalFileIndexWithinFileUploader===this._iUploadStartCallCounter){e.getSource().abort(this._headerParamConst.fileNameRequestIdName,this._encodeToAscii(w)+u);return;}}this.fireBeforeUploadStarts({fileName:w,addHeaderParameter:x,getHeaderParameter:y.bind(this)});if(Array.isArray(G)){for(i=0;i<G.length;i++){if(e.getParameter("requestHeaders")[i].name===G[i].getName()){e.getParameter("requestHeaders")[i].value=G[i].getValue();}}}else if(G instanceof n){for(i=0;i<e.getParameter("requestHeaders").length;i++){if(e.getParameter("requestHeaders")[i].name===G.getName()){e.getParameter("requestHeaders")[i].value=G.getValue();break;}}}function x(z){var j={name:z.getName(),value:z.getValue()};e.getParameter("requestHeaders").push(j);}function y(z){G=this._getHeaderParameterWithinEvent.bind(e)(z);return G;}};
t.prototype._getIconFromFilename=function(e){var i=t._splitFilename(e).extension;if(typeof i==="string"){i=i.toLowerCase();}switch(i){case".bmp":case".jpg":case".jpeg":case".png":return t._placeholderCamera;case".csv":case".xls":case".xlsx":return"sap-icon://excel-attachment";case".doc":case".docx":case".odt":return"sap-icon://doc-attachment";case".pdf":return"sap-icon://pdf-attachment";case".ppt":case".pptx":return"sap-icon://ppt-attachment";case".txt":return"sap-icon://document-text";default:return"sap-icon://document";}};
t.prototype._getThumbnail=function(e,i){if(e){return e;}else{return this._getIconFromFilename(i);}};
t.prototype._triggerLink=function(e,i){if(this.editModeItem){this._handleOk(e,this.editModeItem,true);if(this.sErrorState==="Error"){return;}this.sFocusId=e.getParameter("id");}M.URLHelper.redirect(i.getProperty("url"),true);};
t.prototype.onkeydown=function(e){switch(e.keyCode){case K.F2:this._handleF2(e);break;case K.ESCAPE:this._handleESC(e);break;case K.DELETE:this._handleDEL(e);break;case K.ENTER:this._handleENTER(e);break;default:return;}e.setMarked();};
t.prototype._setFocusAfterDeletion=function(){var i=this.aItems.length;var e;if(i===0){this._oFileUploader.focus();}else{var j=this.sDeletedItemId.split("-").pop();if(j<=i-1){e=this.sDeletedItemId+"-cli";}else{e=this.aItems[this.aItems.length-1].sId+"-cli";}this._setFocusToLineItem(e);}this.sDeletedItemId=null;};
t.prototype._setFocusToLineItem=function(i){Q(document.getElementById(i)).trigger("focus");};
t.prototype._handleENTER=function(e){var i,j,u,v;if(this.editModeItem){i=e.target.id.split(this.editModeItem).pop();}else{i=e.target.id.split("-").pop();}switch(i){case"-ta_editFileName-inner":case"-okButton":this._handleOk(e,this.editModeItem,true);break;case"-cancelButton":e.preventDefault();this._handleCancel(e,this.editModeItem);break;case"-ia_iconHL":case"-ia_imageHL":v=this.editModeItem.split("-").pop();M.URLHelper.redirect(this.aItems[v].getProperty("url"),true);break;case"ia_iconHL":case"ia_imageHL":case"cli":j=e.target.id.split(i)[0]+"ta_filenameHL";u=sap.ui.getCore().byId(j);if(u.getEnabled()){v=e.target.id.split("-")[2];M.URLHelper.redirect(this.aItems[v].getProperty("url"),true);}break;default:break;}};
t.prototype._handleDEL=function(e){if(!this.editModeItem){var i=e.target.id.slice(0,-4),j=sap.ui.getCore().byId(i),u=j&&j._getDeleteButton&&j._getDeleteButton();if(u){u.firePress();}}};
t.prototype._handleESC=function(e){if(this.editModeItem){this.sFocusId=this.editModeItem+"-cli";this.aItems[this.editModeItem.split("-").pop()]._status=t._displayStatus;this._handleCancel(e,this.editModeItem);}};
t.prototype._handleF2=function(e){var i=sap.ui.getCore().byId(e.target.id);if(i!==undefined){if(i._status===t._displayStatus){var j=Q(document.getElementById(e.target.id));var u=j.find("[id$='-editButton']");var E=sap.ui.getCore().byId(u[0].id);if(E.getEnabled()){if(this.editModeItem){this._handleClick(e,this.editModeItem);}if(this.sErrorState!=="Error"){E.firePress();}}}else{this._handleClick(e,this.editModeItem);}}else if(e.target.id.search(this.editModeItem)===0){this._handleOk(e,this.editModeItem,true);}};
t._checkDoubleFileName=function(e,j){if(j.length===0||!e){return false;}var u=j.length;e=e.replace(/^\s+/,"");for(var i=0;i<u;i++){if(e===j[i].getProperty("fileName")){return true;}}return false;};
t._splitFilename=function(e){var i={};var N=e.split(".");if(N.length===1){i.extension="";i.name=N.pop();return i;}i.extension="."+N.pop();i.name=N.join(".");return i;};
t.prototype._getAriaLabelForPicture=function(i){var e;e=(i.getAriaLabelForPicture()||i.getFileName());return e;};
t.prototype._getHeaderParameterWithinEvent=function(e){var u=[];var j=this.getParameter("requestHeaders");var P=j.length;var i;if(j&&e){for(i=0;i<P;i++){if(j[i].name===e){return new n({name:j[i].name,value:j[i].value});}}return null;}else if(j){for(i=0;i<P;i++){u.push(new n({name:j[i].name,value:j[i].value}));}return u;}};
t.prototype._encodeToAscii=function(v){var e="";for(var i=0;i<v.length;i++){e=e+v.charCodeAt(i);}return e;};
t.prototype._onResize=function(){var e=this._oList.getItems();for(var i=0;i<e.length;i++){var j=e[i];setTimeout(function(){var u=this._truncateFileName.bind(this);if(typeof u==="string"||u instanceof String){u=this[u];}u.apply(this,[j._oUploadCollectionItem]||[]);}.bind(this),t._resizeTimeoutInterval);}};
t.prototype._getUploadCollectionItemByListItem=function(e){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===e.getId().replace("-cli","")){return A[i];}}return null;};
t.prototype._getUploadCollectionItemById=function(u){var A=this.getItems();for(var i=0;i<A.length;i++){if(A[i].getId()===u){return A[i];}}return null;};
t.prototype._getUploadCollectionItemsByListItems=function(e){var u=[];var v=this.getItems();if(e){for(var i=0;i<e.length;i++){for(var j=0;j<v.length;j++){if(e[i].getId().replace("-cli","")===v[j].getId()){u.push(v[j]);break;}}}return u;}return null;};
t.prototype._setSelectedForItems=function(u,e){if(this.getMode()!==L.ListMode.MultiSelect&&e){var v=this.getItems();for(var j=0;j<v.length;j++){v[j].setSelected(false);}}for(var i=0;i<u.length;i++){u[i].setSelected(e);}};
t.prototype._handleItemSetSelected=function(e){var i=e.getSource();if(i instanceof U){var j=this._getListItemById(i.getId()+"-cli");if(j){j.setSelected(i.getSelected());}}};
t.prototype._handleSelectionChange=function(e){var i=e.getParameter("listItem");var j=e.getParameter("selected");var u=this._getUploadCollectionItemsByListItems(e.getParameter("listItems"));var v=this._getUploadCollectionItemByListItem(i);if(v&&i&&u){this.fireSelectionChange({selectedItem:v,selectedItems:u,selected:j});v.setSelected(i.getSelected());}};
t.prototype._getListItemById=function(e){var i=this._oList.getItems();return t._findById(e,i);};
t._findById=function(e,j){for(var i=0;i<j.length;i++){if(j[i].getId()===e){return j[i];}}return null;};
return t;});
},
	"sap/m/delegate/DateNavigation.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(['sap/ui/base/EventProvider','sap/ui/core/date/UniversalDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/unified/calendar/CalendarDate','sap/ui/unified/library'],function(E,U,C,a,u){"use strict";var P=u.CalendarIntervalType;
var D=E.extend("sap.m.delegate.DateNavigation",{constructor:function(){E.apply(this,arguments);this._unit=P.Day;this._start=new Date();this._step=1;}});
D.HOURS24=1000*3600*24;
D.prototype.setUnit=function(p){this._unit=p;};
D.prototype.setStart=function(d){this._start=d;};
D.prototype.setStep=function(s){this._step=s;};
D.prototype.setCurrent=function(d){this._current=d;};
D.prototype.getUnit=function(){return this._unit;};
D.prototype.getStart=function(){return this._start;};
D.prototype.getStep=function(){return this._step;};
D.prototype.getCurrent=function(){return this._current;};
D.prototype.getEnd=function(){var c=C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Day:case P.Week:case P.OneMonth:c.setUTCDate(c.getUTCDate()+this.getStep()-1);break;case P.Hour:c.setUTCHours(c.getUTCHours()+this.getStep()-1);break;case P.Month:c.setUTCMonth(c.getUTCMonth()+this.getStep()-1);break;default:break;}return C._createLocalDate(c,true);};
D.prototype.next=function(){var n=C._createUniversalUTCDate(this.getStart(),undefined,true);var N=this.getCurrent()?C._createUniversalUTCDate(this.getCurrent(),undefined,true):C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Hour:N.setUTCHours(N.getUTCHours()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCHours(n.getUTCHours()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Week:case P.Day:N.setUTCDate(N.getUTCDate()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCDate(n.getUTCDate()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Month:N.setUTCMonth(N.getUTCMonth()+this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()+this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.OneMonth:N.setUTCMonth(N.getUTCMonth()+1,1);this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()+1,1);this.setStart(C._createLocalDate(n,true));break;default:break;}};
D.prototype.previous=function(){var n=C._createUniversalUTCDate(this.getStart(),undefined,true);var N=this.getCurrent()?C._createUniversalUTCDate(this.getCurrent(),undefined,true):C._createUniversalUTCDate(this.getStart(),undefined,true);switch(this.getUnit()){case P.Hour:N.setUTCHours(N.getUTCHours()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCHours(n.getUTCHours()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Week:case P.Day:N.setUTCDate(N.getUTCDate()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCDate(n.getUTCDate()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.Month:N.setUTCMonth(N.getUTCMonth()-this.getStep());this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()-this.getStep());this.setStart(C._createLocalDate(n,true));break;case P.OneMonth:N.setUTCMonth(N.getUTCMonth()-1,1);this.setCurrent(C._createLocalDate(N,true));n.setUTCMonth(n.getUTCMonth()-1,1);this.setStart(C._createLocalDate(n,true));break;default:break;}};
D.prototype.toDate=function(t){var n,c,h,N=C._createUniversalUTCDate(t,undefined,true),o=C._createUTCDate(t,true);this.setCurrent(t);switch(this.getUnit()){case P.OneMonth:if(C.monthsDiffer(this.getStart(),t)){var f=C.getFirstDateOfMonth(o);this.setStart(C._createLocalDate(f,true));}break;case P.Day:c=C._createUniversalUTCDate(this.getStart(),undefined,true);c.setUTCDate(c.getUTCDate()+this.getStep());if(t.valueOf()>=c.valueOf()){h=1+Math.ceil((t.valueOf()-c.valueOf())/(D.HOURS24));n=C._createUniversalUTCDate(this.getStart(),undefined,true);n.setUTCDate(n.getUTCDate()+h);this.setStart(C._createLocalDate(n,true));}else if(t.valueOf()<this.getStart().valueOf()){n=C._createUniversalUTCDate(t,undefined,true);this.setStart(C._createLocalDate(n,true));}break;case P.Month:c=C._createUniversalUTCDate(this.getStart());c.setUTCMonth(c.getUTCMonth()+this.getStep());if(N.getTime()>=c.valueOf()){h=1+C._monthsBetween(t,C._createLocalDate(c,true));n=C._createUniversalUTCDate(this.getStart(),undefined,true);n.setUTCMonth(n.getUTCMonth()+h);this.setStart(C._createLocalDate(n,true));}else if(t.valueOf()<this.getStart().valueOf()){n=C._createUniversalUTCDate(t,undefined,true);this.setStart(C._createLocalDate(n,true));}break;case P.Week:var T=C.getFirstDateOfWeek(o);if(this.getStart().valueOf()!==T.valueOf()){this.setStart(C._createLocalDate(T,true));}break;case P.Hour:c=this.getEnd(this.getStart());var b=C._createUniversalUTCDate(c,undefined,true);if(N.getTime()<C._createUniversalUTCDate(this.getStart(),undefined,true).getTime()||N.getTime()>b.getTime()){this.setStart(t);}break;default:break;}};
return D;});
},
	"sap/m/upload/UploadSet.js":function(){sap.ui.getCore().loadLibrary("sap.ui.unified");sap.ui.define(["sap/ui/core/Control","sap/ui/core/Icon","sap/ui/events/KeyCodes","sap/base/Log","sap/base/util/deepEqual","sap/m/library","sap/m/Button","sap/m/Dialog","sap/m/List","sap/m/MessageBox","sap/m/OverflowToolbar","sap/m/StandardListItem","sap/m/Text","sap/m/ToolbarSpacer","sap/ui/unified/FileUploader","sap/m/upload/UploadSetItem","sap/m/upload/Uploader","sap/m/upload/UploadSetRenderer"],function(C,I,K,L,d,M,B,D,a,b,O,S,T,c,F,U,e,R){"use strict";
var f=C.extend("sap.m.upload.UploadSet",{metadata:{library:"sap.m",properties:{fileTypes:{type:"string[]",defaultValue:null},maxFileNameLength:{type:"int",defaultValue:null},maxFileSize:{type:"float",defaultValue:null},mediaTypes:{type:"string[]",defaultValue:null},noDataText:{type:"string",defaultValue:null},noDataDescription:{type:"string",defaultValue:null},instantUpload:{type:"boolean",defaultValue:true},showIcons:{type:"boolean",defaultValue:true},terminationEnabled:{type:"boolean",defaultValue:true},uploadEnabled:{type:"boolean",defaultValue:true},uploadUrl:{type:"string",defaultValue:null}},defaultAggregation:"items",aggregations:{items:{type:"sap.m.upload.UploadSetItem",multiple:true,singularName:"item"},incompleteItems:{type:"sap.m.upload.UploadSetItem",multiple:true,singularName:"incompleteItem"},headerFields:{type:"sap.ui.core.Item",multiple:true,singularName:"headerField"},toolbar:{type:"sap.m.OverflowToolbar",multiple:false},uploader:{type:"sap.m.upload.Uploader",multiple:false}},events:{afterItemAdded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},beforeItemAdded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeItemRemoved:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeItemEdited:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},beforeUploadStarts:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},uploadCompleted:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},beforeUploadTermination:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}},allowPreventDefault:true},uploadTerminated:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileTypeMismatch:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileNameLengthExceeded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},fileSizeExceeded:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},mediaTypeMismatch:{parameters:{item:{type:"sap.m.upload.UploadSetItem"}}},selectionChanged:{parameters:{items:{type:"sap.m.upload.UploadSetItem[]"}}}}}});
var g=M.UploadState;
f.prototype.init=function(){this._oRb=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._oList=null;this._oNoDataIcon=new I(this.getId()+"-no-data-icon",{src:"sap-icon://document",size:"6rem",noTabStop:true});this._oEditedItem=null;this._oItemToBeDeleted=null;this._mListItemIdToItemMap={};this._$Body=null;this._$DragDropArea=null;this._oLastEnteredTarget=null;};
f.prototype.exit=function(){this._unbindDragAndDrop();this._oNoDataIcon.destroy();this._oNoDataIcon=null;};
f.prototype.onBeforeRendering=function(){this._unbindDragAndDrop();};
f.prototype.onAfterRendering=function(){var i;if(this._oEditedItem){i=this._oEditedItem._getFileNameEdit().$("inner");if(i){i.on("focus",function(){i.selectText(0,i.val().length);});i.trigger("focus");}}this._bindDragAndDrop();};
f.prototype.onkeydown=function(E){var l,i;if(this._oEditedItem&&this._oEditedItem._getFileNameEdit().$("inner")[0]===E.target){i=this._oEditedItem;}else if(E.target){l=sap.ui.getCore().byId(E.target.id);if(l){i=this._mListItemIdToItemMap[l.getId()];}}if(!i){return;}switch(E.keyCode){case K.F2:if(i._bInEditMode){this._handleItemEditConfirmation(E,i);}else{this._handleItemEdit(E,i);}break;case K.ESCAPE:this._handleItemEditCancelation(E,i);break;case K.DELETE:if(!i.$("fileNameEdit").hasClass("sapMInputFocused")){this._handleItemDelete(E,i);}break;case K.ENTER:if(i===this._oEditedItem){this._handleItemEditConfirmation(E,i);}else{i._handleFileNamePressed();}break;default:return;}};
f.prototype.getToolbar=function(){if(!this._oToolbar){this._oToolbar=this.getAggregation("toolbar");if(!this._oToolbar){this._oToolbar=new O(this.getId()+"-toolbar",{content:[this._oNumberOfAttachmentsTitle,new c(),this.getDefaultFileUploader()]});this.addDependent(this._oToolbar);}else{this._oToolbar.addContent(this.getDefaultFileUploader());}}return this._oToolbar;};
f.prototype.getNoDataText=function(){var n=this.getProperty("noDataText");n=n||this._oRb.getText("UPLOAD_SET_NO_DATA_TEXT");return n;};
f.prototype.getNoDataDescription=function(){var n=this.getProperty("noDataDescription");n=n||this._oRb.getText("UPLOADCOLLECTION_NO_DATA_DESCRIPTION");return n;};
f.prototype.setToolbar=function(t){this.setAggregation("toolbar",t);this.getToolbar();return this;};
f.prototype.addAggregation=function(A,o,s){C.prototype.addAggregation.call(this,A,o,s);if(o&&(A==="items"||A==="incompleteItems")){this._projectToNewListItem(o);this._refreshInnerListStyle();}};
f.prototype.insertAggregation=function(A,o,i,s){C.prototype.insertAggregation.call(this,A,o,i,s);if(o&&(A==="items"||A==="incompleteItems")){this._projectToNewListItem(o,i||0);this._refreshInnerListStyle();}};
f.prototype.removeAggregation=function(A,o,s){var l;C.prototype.removeAggregation.call(this,A,o,s);if(o&&(A==="items"||A==="incompleteItems")){l=o._getListItem();var i=this.getList().removeAggregation("items",l,s);if(i){i.destroy();}this._refreshInnerListStyle();}};
f.prototype.removeAllAggregation=function(A,s){if(A==="items"){this.getItems().forEach(function(i){this.getList().removeAggregation("items",i._getListItem(),s);}.bind(this));}else if(A==="incompleteItems"){this.getIncompleteItems().forEach(function(i){this.getList().removeAggregation("items",i._getListItem(),s);}.bind(this));}C.prototype.removeAllAggregation.call(this,A,s);};
f.prototype.destroyAggregation=function(A,s){if(A==="items"||A==="incompleteItems"){this.removeAllAggregation(A,s);}if(this.getList().getItems().length===0){this.getList().destroyAggregation("items",s);}C.prototype.destroyAggregation.call(this,A,s);};
f.prototype.setFileTypes=function(n){var t=n||null;if(typeof t==="string"){t=t.split(",");}t=(t||[]).map(function(s){return s?s.toLowerCase():"";});if(!d(this.getFileTypes(),t)){this.setProperty("fileTypes",t,true);this._checkRestrictions();}return this;};
f.prototype.setMaxFileNameLength=function(n){if(this.getMaxFileNameLength()!==n){this.setProperty("maxFileNameLength",n,true);this._checkRestrictions();}return this;};
f.prototype.setMaxFileSize=function(n){if(this.getMaxFileSize()!==n){this.setProperty("maxFileSize",n,true);this._checkRestrictions();}return this;};
f.prototype.setMediaTypes=function(n){var t=n||null;if(typeof t==="string"){t=t.split(",");}t=(t||[]).map(function(s){return s?s.toLowerCase():"";});if(!d(this.getMediaTypes(),t)){this.setProperty("mediaTypes",t,true);this._checkRestrictions();}return this;};
f.prototype.setShowIcons=function(s){if(s!==this.getShowIcons()){this._getAllItems().forEach(function(i){i._getIcon().setVisible(s);});this.setProperty("showIcons",s,false);}return this;};
f.prototype.setTerminationEnabled=function(E){if(E!==this.getTerminationEnabled()){this._getAllItems().forEach(function(i){if(i.getUploadState()===g.Uploading){i._getTerminateButton().setVisible(E);}});this.setProperty("terminationEnabled",E,false);}return this;};
f.prototype.setUploadEnabled=function(E){if(E!==this.getUploadEnabled()){this.getDefaultFileUploader().setEnabled(E);this.setProperty("uploadEnabled",E,false);}return this;};
f.prototype.getList=function(){if(!this._oList){this._oList=new a(this.getId()+"-list",{selectionChange:[this._handleSelectionChange,this],headerToolbar:this.getToolbar()});this._oList.addStyleClass("sapMUCList");this.addDependent(this._oList);}return this._oList;};
f.prototype.upload=function(){if(!this.getUploadEnabled()){L.warning("Upload is currently disabled for this upload set.");return;}this.getIncompleteItems().forEach(function(i){this._uploadItemIfGoodToGo(i);}.bind(this));};
f.prototype.uploadItem=function(i){this._uploadItemIfGoodToGo(i);};
f.prototype.getDefaultFileUploader=function(){var t=this._oRb.getText("UPLOADCOLLECTION_UPLOAD");if(!this._oFileUploader){this._oFileUploader=new F(this.getId()+"-uploader",{buttonOnly:true,buttonText:t,tooltip:t,iconOnly:false,enabled:this.getUploadEnabled(),icon:"",iconFirst:false,style:"Transparent",name:"uploadSetFileUploader",sameFilenameAllowed:true,useMultipart:false,sendXHR:true,change:[this._onFileUploaderChange,this],uploadStart:[this._onUploadStarted,this],uploadProgress:[this._onUploadProgressed,this],uploadComplete:[this._onUploadCompleted,this],uploadAborted:[this._onUploadAborted,this]});}return this._oFileUploader;};
f.prototype.registerUploaderEvents=function(u){u.attachUploadStarted(this._onUploadStarted.bind(this));u.attachUploadProgressed(this._onUploadProgressed.bind(this));u.attachUploadCompleted(this._onUploadCompleted.bind(this));u.attachUploadAborted(this._onUploadAborted.bind(this));};
f.prototype._onFileUploaderChange=function(E){var o=E.getParameter("files");this._processNewFileObjects(o);};
f.prototype._onUploadStarted=function(E){var i=E.getParameter("item");i.setUploadState(g.Uploading);};
f.prototype._onUploadProgressed=function(E){var i=E.getParameter("item"),p=Math.round(E.getParameter("loaded")/E.getParameter("total")*100);i.setProgress(p);};
f.prototype._onUploadCompleted=function(E){var i=E.getParameter("item");i.setProgress(100);i.setUploadState(g.Complete);this.fireUploadCompleted({item:i});};
f.prototype._onUploadAborted=function(E){var i=E.getParameter("item");i.setUploadState(g.Error);this.fireUploadTerminated({item:i});};
f.prototype._handleItemEdit=function(E,i){if(this._oEditedItem){this._handleItemEditConfirmation(E,this._oEditedItem);}if(!this._oEditedItem){if(this.fireBeforeItemEdited({item:i})){this._oEditedItem=i;this._oEditedItem._setInEditMode(true);}}};
f.prototype._handleItemRestart=function(E,i){i.setUploadState(g.Ready);this._uploadItemIfGoodToGo(i);};
f.prototype._handleItemEditConfirmation=function(E,i){var o=i._getFileNameEdit(),n,N,s=i.getFileName(),h=U._splitFileName(s);n=o.getValue().trim();if(!n||n.length===0){i._setContainsError(true);return;}if(h.name!==n){N=n+"."+h.extension;i.setFileName(N);}i._setContainsError(false);i._setInEditMode(false);this._oEditedItem=null;};
f.prototype._handleItemEditCancelation=function(E,i){i._setContainsError(false);i._setInEditMode(false);this._oEditedItem=null;};
f.prototype._handleItemDelete=function(E,i){var m;if(this._oEditedItem){this._handleItemEditConfirmation(E,this._oEditedItem);if(this._oEditedItem){return;}}if(!i.fireRemovePressed({item:i})){return;}if(!this.fireBeforeItemRemoved({item:i})){return;}if(!i.getFileName()){m=this._oRb.getText("UPLOAD_SET_DELETE_WITHOUT_FILE_NAME_TEXT");}else{m=this._oRb.getText("UPLOAD_SET_DELETE_TEXT",i.getFileName());}this._oItemToBeDeleted=i;b.show(m,{id:this.getId()+"-deleteDialog",title:this._oRb.getText("UPLOAD_SET_DELETE_TITLE"),actions:[b.Action.OK,b.Action.CANCEL],onClose:this._handleClosedDeleteDialog.bind(this),dialogId:"messageBoxDeleteFile",styleClass:this.hasStyleClass("sapUiSizeCompact")?"sapUiSizeCompact":""});};
f.prototype._handleClosedDeleteDialog=function(A){if(A!==b.Action.OK){return;}this.removeItem(this._oItemToBeDeleted);this.removeIncompleteItem(this._oItemToBeDeleted);this._oItemToBeDeleted=null;};
f.prototype._handleTerminateRequest=function(h,i){var o=new a({items:[new S({title:i.getFileName(),icon:i._getIcon().getSrc()})]}),j=new D({id:this.getId()+"-teminateDialog",title:this._oRb.getText("UPLOAD_SET_TERMINATE_TITLE"),content:[new T({text:this._oRb.getText("UPLOAD_SET_TERMINATE_TEXT")}),o],buttons:[new B({text:this._oRb.getText("UPLOAD_SET_OKBUTTON_TEXT"),press:[k,this]}),new B({text:this._oRb.getText("UPLOAD_SET_CANCEL_BUTTON_TEXT"),press:function(){j.close();}})],afterClose:function(){j.destroy();}});j.open();function k(){if(i.getUploadState()===g.Uploading){if(this.fireBeforeUploadTermination({item:i})){this._handleUploadTermination(i);}}else if(i.getUploadState()===g.Complete){this.removeItem(i);}j.close();this.invalidate();}};
f.prototype._handleUploadTermination=function(i){this._getActiveUploader().terminateItem(i);};
f.prototype._handleSelectionChange=function(E){var l=E.getParameter("listItems"),i=[];l.forEach(function(o){i.push(this._mListItemIdToItemMap[o.getId()]);}.bind(this));this.fireSelectionChanged({items:i});};
f.prototype._onDragEnterSet=function(E){if(E.target===this._$DragDropArea[0]&&this.getUploadEnabled()){this._$DragDropArea.addClass("sapMUCDropIndicator");}};
f.prototype._onDragLeaveSet=function(E){if(E.target===this._$DragDropArea[0]&&this.getUploadEnabled()){this._$DragDropArea.removeClass("sapMUCDropIndicator");}};
f.prototype._onDragOverSet=function(E){E.preventDefault();};
f.prototype._onDropOnSet=function(E){var o;E.preventDefault();if(E.target===this._$DragDropArea[0]&&this.getUploadEnabled()){this._$DragDropArea.removeClass("sapMUCDropIndicator");this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");o=E.originalEvent.dataTransfer.files;this._processNewFileObjects(o);}};
f.prototype._onDragEnterBody=function(E){if(this.getUploadEnabled()){this._oLastEnteredTarget=E.target;this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");}};
f.prototype._onDragLeaveBody=function(E){if(this._oLastEnteredTarget===E.target&&this.getUploadEnabled()){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
f.prototype._onDragOverBody=function(E){E.preventDefault();if(this.getUploadEnabled()){this._$DragDropArea.removeClass("sapMUCDragDropOverlayHide");}};
f.prototype._onDropOnBody=function(E){if(this.getUploadEnabled()){this._$DragDropArea.addClass("sapMUCDragDropOverlayHide");}};
f.prototype._getAllItems=function(){return this.getItems().concat(this.getIncompleteItems());};
f.prototype._refreshInnerListStyle=function(){var m=this.getList().length-1;this._oList.getItems().forEach(function(l,i){l.removeStyleClass("sapMUCListSingleItem").removeStyleClass("sapMUCListFirstItem").removeStyleClass("sapMUCListLastItem").removeStyleClass("sapMUCListItem");if(i===0&&m===0){l.addStyleClass("sapMUCListSingleItem");}else if(i===0){l.addStyleClass("sapMUCListFirstItem");}else if(i===m){l.addStyleClass("sapMUCListLastItem");}else{l.addStyleClass("sapMUCListItem");}});};
f.prototype._processNewFileObjects=function(o){var h=[],j;for(var i=0;i<o.length;i++){h.push(o[i]);}h.forEach(function(k){j=new U({uploadState:g.Ready});j._setFileObject(k);j.setFileName(k.name);if(!this.fireBeforeItemAdded({item:j})){return;}this.insertIncompleteItem(j);this.fireAfterItemAdded({item:j});if(this.getInstantUpload()){this._uploadItemIfGoodToGo(j);}}.bind(this));};
f.prototype._projectToNewListItem=function(i,h){var l=i._getListItem();this._mListItemIdToItemMap[l.getId()]=i;if(h||h===0){this.getList().insertAggregation("items",l,h,true);}else{this.getList().addAggregation("items",l,true);}this._checkRestrictionsForItem(i);};
f.prototype._getImplicitUploader=function(){if(!this._oUploader){this._oUploader=new e();this._oUploader.setUploadUrl(this.getUploadUrl());this.registerUploaderEvents(this._oUploader);this.addDependent(this._oUploader);}return this._oUploader;};
f.prototype._getActiveUploader=function(){return this.getUploader()||this._getImplicitUploader();};
f.prototype._uploadItemIfGoodToGo=function(i){if(i.getUploadState()===g.Ready&&!i._isRestricted()){if(this.fireBeforeUploadStarts({item:i})){this._getActiveUploader().uploadItem(i,this.getHeaderFields());}}};
f.prototype._getDragDropHandlers=function(){if(!this._oDragDropHandlers){this._oDragDropHandlers={body:{"dragenter":this._onDragEnterBody.bind(this),"dragleave":this._onDragLeaveBody.bind(this),"dragover":this._onDragOverBody.bind(this),"drop":this._onDropOnBody.bind(this)},set:{"dragenter":this._onDragEnterSet.bind(this),"dragleave":this._onDragLeaveSet.bind(this),"dragover":this._onDragOverSet.bind(this),"drop":this._onDropOnSet.bind(this)}};}return this._oDragDropHandlers;};
f.prototype._bindDragAndDrop=function(){this._$Body=jQuery(document.body);Object.keys(this._getDragDropHandlers().body).forEach(function(E){this._$Body.on(E,this._getDragDropHandlers().body[E]);}.bind(this));this._$DragDropArea=this.$("drag-drop-area");Object.keys(this._getDragDropHandlers().set).forEach(function(E){this.$().on(E,this._getDragDropHandlers().set[E]);}.bind(this));};
f.prototype._unbindDragAndDrop=function(){if(this._$Body){Object.keys(this._getDragDropHandlers().body).forEach(function(E){this._$Body.off(E,this._getDragDropHandlers().body[E]);}.bind(this));}Object.keys(this._getDragDropHandlers().set).forEach(function(E){this.$().off(E,this._getDragDropHandlers().set[E]);}.bind(this));};
f.prototype._checkRestrictions=function(){this.getItems().forEach(function(i){this._checkRestrictionsForItem(i);}.bind(this));this.getIncompleteItems().forEach(function(i){this._checkRestrictionsForItem(i);}.bind(this));};
f.prototype._checkRestrictionsForItem=function(i){i._checkTypeRestriction(this.getFileTypes());i._checkNameLengthRestriction(this.getMaxFileNameLength());i._checkSizeRestriction(this.getMaxFileSize());i._checkMediaTypeRestriction(this.getMediaTypes());};
return f;});
}
},"sap/m/library-preload"
);
//# sourceMappingURL=library-preload.js.map